// RUN: %parallel-boogie /errorTrace:0 /timeLimit:120 "%s" > "%t"
// RUN: %diff "%s.expect" "%t"

// Stress test that we really don't need ot run multiple times
// UNSUPPORTED: batch_mode

var raiseException : bool;
var errorReached : bool;
var k : int;
var __storm_atomic : bool;
var __storm_init : bool;
var __storm_thread_id : int;
var __storm_thread_done_1 : bool;
var __storm_thread_done_2 : bool;
var __storm_thread_done_3 : bool;
var __storm_thread_done_4 : bool;
var __storm_thread_done_5 : bool;
var __storm_thread_done_6 : bool;

procedure /* dummy comment */ {:inline 1} storm_getThreadID() returns (tid:int)
{
  tid := __storm_thread_id;
  return;
}

procedure storm_context_0();

procedure contextSwitch();
modifies k;
ensures __storm_atomic ==> old(k) == k;
ensures(old(k) <= k);
ensures(k < 1);



// Memory model

// Mutable
var alloc:int;

// Immutable

var Mem_0_T.CancelRoutine__IRP : [int]int;
var Mem_0_T.CurrentLocation__IRP : [int]int;
var Mem_0_T.DeviceExtension__DEVICE_OBJECT : [int]int;
var Mem_0_T.StackCount__IRP : [int]int;


// Field declarations


// Type declarations


// Field offset definitions

function AllocatedResourcesTranslated___unnamed_8_634fb90c(int) returns (int);


//axiom (forall x:int :: {AllocatedResourcesTranslated___unnamed_8_634fb90c(x)} AllocatedResourcesTranslated___unnamed_8_634fb90c(x) == x + 4);
axiom (forall x:int :: {AllocatedResourcesTranslated___unnamed_8_634fb90c(x)} AllocatedResourcesTranslated___unnamed_8_634fb90c(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function AllocatedResources___unnamed_8_634fb90c(int) returns (int);


//axiom (forall x:int :: {AllocatedResources___unnamed_8_634fb90c(x)} AllocatedResources___unnamed_8_634fb90c(x) == x + 0);
axiom (forall x:int :: {AllocatedResources___unnamed_8_634fb90c(x)} AllocatedResources___unnamed_8_634fb90c(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BDDBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {BDDBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x)} BDDBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 1364);
axiom (forall x:int :: {BDDBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x)} BDDBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 1364));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BDDBuildNumber__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {BDDBuildNumber__BDSI_INITIALIZERESOURCES(x)} BDDBuildNumber__BDSI_INITIALIZERESOURCES(x) == x + 544);
axiom (forall x:int :: {BDDBuildNumber__BDSI_INITIALIZERESOURCES(x)} BDDBuildNumber__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 544));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BDDVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {BDDVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x)} BDDVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 1356);
axiom (forall x:int :: {BDDVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x)} BDDVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 1356));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BDDVersionMajor__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {BDDVersionMajor__BDSI_INITIALIZERESOURCES(x)} BDDVersionMajor__BDSI_INITIALIZERESOURCES(x) == x + 536);
axiom (forall x:int :: {BDDVersionMajor__BDSI_INITIALIZERESOURCES(x)} BDDVersionMajor__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 536));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BDDVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {BDDVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x)} BDDVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 1360);
axiom (forall x:int :: {BDDVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x)} BDDVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 1360));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BDDVersionMinor__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {BDDVersionMinor__BDSI_INITIALIZERESOURCES(x)} BDDVersionMinor__BDSI_INITIALIZERESOURCES(x) == x + 540);
axiom (forall x:int :: {BDDVersionMinor__BDSI_INITIALIZERESOURCES(x)} BDDVersionMinor__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 540));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function BdlExtenstion__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {BdlExtenstion__BDL_INTERNAL_DEVICE_EXTENSION(x)} BdlExtenstion__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 0);
axiom (forall x:int :: {BdlExtenstion__BDL_INTERNAL_DEVICE_EXTENSION(x)} BdlExtenstion__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Blink__LIST_ENTRY(int) returns (int);


//axiom (forall x:int :: {Blink__LIST_ENTRY(x)} Blink__LIST_ENTRY(x) == x + 4);
axiom (forall x:int :: {Blink__LIST_ENTRY(x)} Blink__LIST_ENTRY(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Block__BDDI_ITEM_DATA(int) returns (int);


//axiom (forall x:int :: {Block__BDDI_ITEM_DATA(x)} Block__BDDI_ITEM_DATA(x) == x + 0);
axiom (forall x:int :: {Block__BDDI_ITEM_DATA(x)} Block__BDDI_ITEM_DATA(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function CancelIrql__IRP(int) returns (int);


//axiom (forall x:int :: {CancelIrql__IRP(x)} CancelIrql__IRP(x) == x + 37);
axiom (forall x:int :: {CancelIrql__IRP(x)} CancelIrql__IRP(x) == INT_ADD(x, 37));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function CancelRoutine__IRP(int) returns (int);


//axiom (forall x:int :: {CancelRoutine__IRP(x)} CancelRoutine__IRP(x) == x + 56);
axiom (forall x:int :: {CancelRoutine__IRP(x)} CancelRoutine__IRP(x) == INT_ADD(x, 56));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Cancel__IRP(int) returns (int);


//axiom (forall x:int :: {Cancel__IRP(x)} Cancel__IRP(x) == x + 36);
axiom (forall x:int :: {Cancel__IRP(x)} Cancel__IRP(x) == INT_ADD(x, 36));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ChannelId__BDDI_PARAMS_REGISTERNOTIFY(int) returns (int);


//axiom (forall x:int :: {ChannelId__BDDI_PARAMS_REGISTERNOTIFY(x)} ChannelId__BDDI_PARAMS_REGISTERNOTIFY(x) == x + 12);
axiom (forall x:int :: {ChannelId__BDDI_PARAMS_REGISTERNOTIFY(x)} ChannelId__BDDI_PARAMS_REGISTERNOTIFY(x) == INT_ADD(x, 12));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ChannelId__BDL_CONTROL_CHANGE_REGISTRATION(int) returns (int);


//axiom (forall x:int :: {ChannelId__BDL_CONTROL_CHANGE_REGISTRATION(x)} ChannelId__BDL_CONTROL_CHANGE_REGISTRATION(x) == x + 4);
axiom (forall x:int :: {ChannelId__BDL_CONTROL_CHANGE_REGISTRATION(x)} ChannelId__BDL_CONTROL_CHANGE_REGISTRATION(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function CompletionRoutine__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {CompletionRoutine__IO_STACK_LOCATION(x)} CompletionRoutine__IO_STACK_LOCATION(x) == x + 28);
axiom (forall x:int :: {CompletionRoutine__IO_STACK_LOCATION(x)} CompletionRoutine__IO_STACK_LOCATION(x) == INT_ADD(x, 28));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ComponentId__BDDI_PARAMS_REGISTERNOTIFY(int) returns (int);


//axiom (forall x:int :: {ComponentId__BDDI_PARAMS_REGISTERNOTIFY(x)} ComponentId__BDDI_PARAMS_REGISTERNOTIFY(x) == x + 8);
axiom (forall x:int :: {ComponentId__BDDI_PARAMS_REGISTERNOTIFY(x)} ComponentId__BDDI_PARAMS_REGISTERNOTIFY(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ComponentId__BDL_CONTROL_CHANGE_REGISTRATION(int) returns (int);


//axiom (forall x:int :: {ComponentId__BDL_CONTROL_CHANGE_REGISTRATION(x)} ComponentId__BDL_CONTROL_CHANGE_REGISTRATION(x) == x + 0);
axiom (forall x:int :: {ComponentId__BDL_CONTROL_CHANGE_REGISTRATION(x)} ComponentId__BDL_CONTROL_CHANGE_REGISTRATION(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Context__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {Context__IO_STACK_LOCATION(x)} Context__IO_STACK_LOCATION(x) == x + 32);
axiom (forall x:int :: {Context__IO_STACK_LOCATION(x)} Context__IO_STACK_LOCATION(x) == INT_ADD(x, 32));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(int) returns (int);


//axiom (forall x:int :: {ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x)} ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x) == x + 620);
axiom (forall x:int :: {ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x)} ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x) == INT_ADD(x, 620));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(int) returns (int);


//axiom (forall x:int :: {ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(x)} ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(x) == x + 636);
axiom (forall x:int :: {ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(x)} ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(x) == INT_ADD(x, 636));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(x)} ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 160);
axiom (forall x:int :: {ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(x)} ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 160));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ControlId__BDDI_PARAMS_REGISTERNOTIFY(int) returns (int);


//axiom (forall x:int :: {ControlId__BDDI_PARAMS_REGISTERNOTIFY(x)} ControlId__BDDI_PARAMS_REGISTERNOTIFY(x) == x + 16);
axiom (forall x:int :: {ControlId__BDDI_PARAMS_REGISTERNOTIFY(x)} ControlId__BDDI_PARAMS_REGISTERNOTIFY(x) == INT_ADD(x, 16));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ControlId__BDL_CONTROL_CHANGE_REGISTRATION(int) returns (int);


//axiom (forall x:int :: {ControlId__BDL_CONTROL_CHANGE_REGISTRATION(x)} ControlId__BDL_CONTROL_CHANGE_REGISTRATION(x) == x + 8);
axiom (forall x:int :: {ControlId__BDL_CONTROL_CHANGE_REGISTRATION(x)} ControlId__BDL_CONTROL_CHANGE_REGISTRATION(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Control__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {Control__IO_STACK_LOCATION(x)} Control__IO_STACK_LOCATION(x) == x + 3);
axiom (forall x:int :: {Control__IO_STACK_LOCATION(x)} Control__IO_STACK_LOCATION(x) == INT_ADD(x, 3));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function CurrentLocation__IRP(int) returns (int);


//axiom (forall x:int :: {CurrentLocation__IRP(x)} CurrentLocation__IRP(x) == x + 35);
axiom (forall x:int :: {CurrentLocation__IRP(x)} CurrentLocation__IRP(x) == INT_ADD(x, 35));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function CurrentStackLocation___unnamed_12_3a099e68(int) returns (int);


//axiom (forall x:int :: {CurrentStackLocation___unnamed_12_3a099e68(x)} CurrentStackLocation___unnamed_12_3a099e68(x) == x + 8);
axiom (forall x:int :: {CurrentStackLocation___unnamed_12_3a099e68(x)} CurrentStackLocation___unnamed_12_3a099e68(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Data__BDDI_ITEM(int) returns (int);


//axiom (forall x:int :: {Data__BDDI_ITEM(x)} Data__BDDI_ITEM(x) == x + 4);
axiom (forall x:int :: {Data__BDDI_ITEM(x)} Data__BDDI_ITEM(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function DeviceCapabilities__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {DeviceCapabilities__BDL_INTERNAL_DEVICE_EXTENSION(x)} DeviceCapabilities__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 140);
axiom (forall x:int :: {DeviceCapabilities__BDL_INTERNAL_DEVICE_EXTENSION(x)} DeviceCapabilities__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 140));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function DeviceExtension__DEVICE_OBJECT(int) returns (int);


//axiom (forall x:int :: {DeviceExtension__DEVICE_OBJECT(x)} DeviceExtension__DEVICE_OBJECT(x) == x + 40);
axiom (forall x:int :: {DeviceExtension__DEVICE_OBJECT(x)} DeviceExtension__DEVICE_OBJECT(x) == INT_ADD(x, 40));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function DeviceObject__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {DeviceObject__IO_STACK_LOCATION(x)} DeviceObject__IO_STACK_LOCATION(x) == x + 20);
axiom (forall x:int :: {DeviceObject__IO_STACK_LOCATION(x)} DeviceObject__IO_STACK_LOCATION(x) == INT_ADD(x, 20));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function DeviceOpen__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {DeviceOpen__BDL_INTERNAL_DEVICE_EXTENSION(x)} DeviceOpen__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 136);
axiom (forall x:int :: {DeviceOpen__BDL_INTERNAL_DEVICE_EXTENSION(x)} DeviceOpen__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 136));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(x)} DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 28);
axiom (forall x:int :: {DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(x)} DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 28));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function DeviceState__POWER_STATE(int) returns (int);


//axiom (forall x:int :: {DeviceState__POWER_STATE(x)} DeviceState__POWER_STATE(x) == x + 0);
axiom (forall x:int :: {DeviceState__POWER_STATE(x)} DeviceState__POWER_STATE(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Flink__LIST_ENTRY(int) returns (int);


//axiom (forall x:int :: {Flink__LIST_ENTRY(x)} Flink__LIST_ENTRY(x) == x + 0);
axiom (forall x:int :: {Flink__LIST_ENTRY(x)} Flink__LIST_ENTRY(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HWBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {HWBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x)} HWBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 1352);
axiom (forall x:int :: {HWBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x)} HWBuildNumber__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 1352));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HWBuildNumber__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {HWBuildNumber__BDSI_INITIALIZERESOURCES(x)} HWBuildNumber__BDSI_INITIALIZERESOURCES(x) == x + 532);
axiom (forall x:int :: {HWBuildNumber__BDSI_INITIALIZERESOURCES(x)} HWBuildNumber__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 532));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HWVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {HWVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x)} HWVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 1344);
axiom (forall x:int :: {HWVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x)} HWVersionMajor__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 1344));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HWVersionMajor__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {HWVersionMajor__BDSI_INITIALIZERESOURCES(x)} HWVersionMajor__BDSI_INITIALIZERESOURCES(x) == x + 524);
axiom (forall x:int :: {HWVersionMajor__BDSI_INITIALIZERESOURCES(x)} HWVersionMajor__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 524));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HWVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {HWVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x)} HWVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 1348);
axiom (forall x:int :: {HWVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x)} HWVersionMinor__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 1348));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HWVersionMinor__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {HWVersionMinor__BDSI_INITIALIZERESOURCES(x)} HWVersionMinor__BDSI_INITIALIZERESOURCES(x) == x + 528);
axiom (forall x:int :: {HWVersionMinor__BDSI_INITIALIZERESOURCES(x)} HWVersionMinor__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 528));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(x)} HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 816);
axiom (forall x:int :: {HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(x)} HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 816));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function HandleList__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {HandleList__BDL_INTERNAL_DEVICE_EXTENSION(x)} HandleList__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 820);
axiom (forall x:int :: {HandleList__BDL_INTERNAL_DEVICE_EXTENSION(x)} HandleList__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 820));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Handle__BDDI_ITEM_DATA(int) returns (int);


//axiom (forall x:int :: {Handle__BDDI_ITEM_DATA(x)} Handle__BDDI_ITEM_DATA(x) == x + 0);
axiom (forall x:int :: {Handle__BDDI_ITEM_DATA(x)} Handle__BDDI_ITEM_DATA(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(int) returns (int);


//axiom (forall x:int :: {IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x)} IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x) == x + 624);
axiom (forall x:int :: {IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x)} IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x) == INT_ADD(x, 624));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ISRControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(int) returns (int);


//axiom (forall x:int :: {ISRControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x)} ISRControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x) == x + 0);
axiom (forall x:int :: {ISRControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x)} ISRControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(int) returns (int);


//axiom (forall x:int :: {ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x)} ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x) == x + 36);
axiom (forall x:int :: {ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x)} ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(x) == INT_ADD(x, 36));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Information__IO_STATUS_BLOCK(int) returns (int);


//axiom (forall x:int :: {Information__IO_STATUS_BLOCK(x)} Information__IO_STATUS_BLOCK(x) == x + 4);
axiom (forall x:int :: {Information__IO_STATUS_BLOCK(x)} Information__IO_STATUS_BLOCK(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function IoCount__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {IoCount__BDL_INTERNAL_DEVICE_EXTENSION(x)} IoCount__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 44);
axiom (forall x:int :: {IoCount__BDL_INTERNAL_DEVICE_EXTENSION(x)} IoCount__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 44));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function IoStatus__IRP(int) returns (int);


//axiom (forall x:int :: {IoStatus__IRP(x)} IoStatus__IRP(x) == x + 24);
axiom (forall x:int :: {IoStatus__IRP(x)} IoStatus__IRP(x) == INT_ADD(x, 24));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function MajorFunction__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {MajorFunction__IO_STACK_LOCATION(x)} MajorFunction__IO_STACK_LOCATION(x) == x + 0);
axiom (forall x:int :: {MajorFunction__IO_STACK_LOCATION(x)} MajorFunction__IO_STACK_LOCATION(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function MinorFunction__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {MinorFunction__IO_STACK_LOCATION(x)} MinorFunction__IO_STACK_LOCATION(x) == x + 1);
axiom (forall x:int :: {MinorFunction__IO_STACK_LOCATION(x)} MinorFunction__IO_STACK_LOCATION(x) == INT_ADD(x, 1));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function NumChannels__BDL_COMPONENT(int) returns (int);


//axiom (forall x:int :: {NumChannels__BDL_COMPONENT(x)} NumChannels__BDL_COMPONENT(x) == x + 12);
axiom (forall x:int :: {NumChannels__BDL_COMPONENT(x)} NumChannels__BDL_COMPONENT(x) == INT_ADD(x, 12));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function NumComponents__BDL_DEVICE_CAPABILITIES(int) returns (int);


//axiom (forall x:int :: {NumComponents__BDL_DEVICE_CAPABILITIES(x)} NumComponents__BDL_DEVICE_CAPABILITIES(x) == x + 8);
axiom (forall x:int :: {NumComponents__BDL_DEVICE_CAPABILITIES(x)} NumComponents__BDL_DEVICE_CAPABILITIES(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function NumHandles_HANDLELIST_(int) returns (int);


//axiom (forall x:int :: {NumHandles_HANDLELIST_(x)} NumHandles_HANDLELIST_(x) == x + 8);
axiom (forall x:int :: {NumHandles_HANDLELIST_(x)} NumHandles_HANDLELIST_(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Overlay___unnamed_48_7c673e0a(int) returns (int);


//axiom (forall x:int :: {Overlay___unnamed_48_7c673e0a(x)} Overlay___unnamed_48_7c673e0a(x) == x + 0);
axiom (forall x:int :: {Overlay___unnamed_48_7c673e0a(x)} Overlay___unnamed_48_7c673e0a(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Parameters__IO_STACK_LOCATION(int) returns (int);


//axiom (forall x:int :: {Parameters__IO_STACK_LOCATION(x)} Parameters__IO_STACK_LOCATION(x) == x + 4);
axiom (forall x:int :: {Parameters__IO_STACK_LOCATION(x)} Parameters__IO_STACK_LOCATION(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function PendingReturned__IRP(int) returns (int);


//axiom (forall x:int :: {PendingReturned__IRP(x)} PendingReturned__IRP(x) == x + 33);
axiom (forall x:int :: {PendingReturned__IRP(x)} PendingReturned__IRP(x) == INT_ADD(x, 33));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function PowerState__BDSI_SETPOWERSTATE(int) returns (int);


//axiom (forall x:int :: {PowerState__BDSI_SETPOWERSTATE(x)} PowerState__BDSI_SETPOWERSTATE(x) == x + 4);
axiom (forall x:int :: {PowerState__BDSI_SETPOWERSTATE(x)} PowerState__BDSI_SETPOWERSTATE(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Power___unnamed_16_357c4db4(int) returns (int);


//axiom (forall x:int :: {Power___unnamed_16_357c4db4(x)} Power___unnamed_16_357c4db4(x) == x + 0);
axiom (forall x:int :: {Power___unnamed_16_357c4db4(x)} Power___unnamed_16_357c4db4(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(x)} RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 48);
axiom (forall x:int :: {RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(x)} RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 48));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Size__BDDI_PARAMS_CLOSEHANDLE(int) returns (int);


//axiom (forall x:int :: {Size__BDDI_PARAMS_CLOSEHANDLE(x)} Size__BDDI_PARAMS_CLOSEHANDLE(x) == x + 0);
axiom (forall x:int :: {Size__BDDI_PARAMS_CLOSEHANDLE(x)} Size__BDDI_PARAMS_CLOSEHANDLE(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Size__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {Size__BDSI_INITIALIZERESOURCES(x)} Size__BDSI_INITIALIZERESOURCES(x) == x + 0);
axiom (forall x:int :: {Size__BDSI_INITIALIZERESOURCES(x)} Size__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Size__BDSI_SETPOWERSTATE(int) returns (int);


//axiom (forall x:int :: {Size__BDSI_SETPOWERSTATE(x)} Size__BDSI_SETPOWERSTATE(x) == x + 0);
axiom (forall x:int :: {Size__BDSI_SETPOWERSTATE(x)} Size__BDSI_SETPOWERSTATE(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(x)} SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 24);
axiom (forall x:int :: {SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(x)} SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 24));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function StackCount__IRP(int) returns (int);


//axiom (forall x:int :: {StackCount__IRP(x)} StackCount__IRP(x) == x + 34);
axiom (forall x:int :: {StackCount__IRP(x)} StackCount__IRP(x) == INT_ADD(x, 34));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function StartDevice___unnamed_16_357c4db4(int) returns (int);


//axiom (forall x:int :: {StartDevice___unnamed_16_357c4db4(x)} StartDevice___unnamed_16_357c4db4(x) == x + 0);
axiom (forall x:int :: {StartDevice___unnamed_16_357c4db4(x)} StartDevice___unnamed_16_357c4db4(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function State___unnamed_16_72a8bca0(int) returns (int);


//axiom (forall x:int :: {State___unnamed_16_72a8bca0(x)} State___unnamed_16_72a8bca0(x) == x + 8);
axiom (forall x:int :: {State___unnamed_16_72a8bca0(x)} State___unnamed_16_72a8bca0(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Status___unnamed_4_46d45f1c(int) returns (int);


//axiom (forall x:int :: {Status___unnamed_4_46d45f1c(x)} Status___unnamed_4_46d45f1c(x) == x + 0);
axiom (forall x:int :: {Status___unnamed_4_46d45f1c(x)} Status___unnamed_4_46d45f1c(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(x)} SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 16);
axiom (forall x:int :: {SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(x)} SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 16));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function SystemState__POWER_STATE(int) returns (int);


//axiom (forall x:int :: {SystemState__POWER_STATE(x)} SystemState__POWER_STATE(x) == x + 0);
axiom (forall x:int :: {SystemState__POWER_STATE(x)} SystemState__POWER_STATE(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Tail__IRP(int) returns (int);


//axiom (forall x:int :: {Tail__IRP(x)} Tail__IRP(x) == x + 64);
axiom (forall x:int :: {Tail__IRP(x)} Tail__IRP(x) == INT_ADD(x, 64));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function Type__BDDI_ITEM(int) returns (int);


//axiom (forall x:int :: {Type__BDDI_ITEM(x)} Type__BDDI_ITEM(x) == x + 0);
axiom (forall x:int :: {Type__BDDI_ITEM(x)} Type__BDDI_ITEM(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function __unnamed_12_3a099e68___unnamed_40_3fd77f3c(int) returns (int);


//axiom (forall x:int :: {__unnamed_12_3a099e68___unnamed_40_3fd77f3c(x)} __unnamed_12_3a099e68___unnamed_40_3fd77f3c(x) == x + 24);
axiom (forall x:int :: {__unnamed_12_3a099e68___unnamed_40_3fd77f3c(x)} __unnamed_12_3a099e68___unnamed_40_3fd77f3c(x) == INT_ADD(x, 24));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function __unnamed_4_46d45f1c__IO_STATUS_BLOCK(int) returns (int);


//axiom (forall x:int :: {__unnamed_4_46d45f1c__IO_STATUS_BLOCK(x)} __unnamed_4_46d45f1c__IO_STATUS_BLOCK(x) == x + 0);
axiom (forall x:int :: {__unnamed_4_46d45f1c__IO_STATUS_BLOCK(x)} __unnamed_4_46d45f1c__IO_STATUS_BLOCK(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function bddiFunctions__BDL_DRIVER_EXTENSION(int) returns (int);


//axiom (forall x:int :: {bddiFunctions__BDL_DRIVER_EXTENSION(x)} bddiFunctions__BDL_DRIVER_EXTENSION(x) == x + 0);
axiom (forall x:int :: {bddiFunctions__BDL_DRIVER_EXTENSION(x)} bddiFunctions__BDL_DRIVER_EXTENSION(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function bdsiFunctions__BDL_DRIVER_EXTENSION(int) returns (int);


//axiom (forall x:int :: {bdsiFunctions__BDL_DRIVER_EXTENSION(x)} bdsiFunctions__BDL_DRIVER_EXTENSION(x) == x + 32);
axiom (forall x:int :: {bdsiFunctions__BDL_DRIVER_EXTENSION(x)} bdsiFunctions__BDL_DRIVER_EXTENSION(x) == INT_ADD(x, 32));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function fDeviceRemoved__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {fDeviceRemoved__BDL_INTERNAL_DEVICE_EXTENSION(x)} fDeviceRemoved__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 813);
axiom (forall x:int :: {fDeviceRemoved__BDL_INTERNAL_DEVICE_EXTENSION(x)} fDeviceRemoved__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 813));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function fRegister__BDDI_PARAMS_REGISTERNOTIFY(int) returns (int);


//axiom (forall x:int :: {fRegister__BDDI_PARAMS_REGISTERNOTIFY(x)} fRegister__BDDI_PARAMS_REGISTERNOTIFY(x) == x + 4);
axiom (forall x:int :: {fRegister__BDDI_PARAMS_REGISTERNOTIFY(x)} fRegister__BDDI_PARAMS_REGISTERNOTIFY(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function fStartSucceeded__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {fStartSucceeded__BDL_INTERNAL_DEVICE_EXTENSION(x)} fStartSucceeded__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 812);
axiom (forall x:int :: {fStartSucceeded__BDL_INTERNAL_DEVICE_EXTENSION(x)} fStartSucceeded__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 812));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function fUsed__BDL_ISR_CONTROL_CHANGE_ITEM(int) returns (int);


//axiom (forall x:int :: {fUsed__BDL_ISR_CONTROL_CHANGE_ITEM(x)} fUsed__BDL_ISR_CONTROL_CHANGE_ITEM(x) == x + 24);
axiom (forall x:int :: {fUsed__BDL_ISR_CONTROL_CHANGE_ITEM(x)} fUsed__BDL_ISR_CONTROL_CHANGE_ITEM(x) == INT_ADD(x, 24));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function hData__BDDI_PARAMS_CLOSEHANDLE(int) returns (int);


//axiom (forall x:int :: {hData__BDDI_PARAMS_CLOSEHANDLE(x)} hData__BDDI_PARAMS_CLOSEHANDLE(x) == x + 4);
axiom (forall x:int :: {hData__BDDI_PARAMS_CLOSEHANDLE(x)} hData__BDDI_PARAMS_CLOSEHANDLE(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function handle_LIST_NODE_(int) returns (int);


//axiom (forall x:int :: {handle_LIST_NODE_(x)} handle_LIST_NODE_(x) == x + 4);
axiom (forall x:int :: {handle_LIST_NODE_(x)} handle_LIST_NODE_(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pAllocatedResourcesTranslated__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {pAllocatedResourcesTranslated__BDSI_INITIALIZERESOURCES(x)} pAllocatedResourcesTranslated__BDSI_INITIALIZERESOURCES(x) == x + 8);
axiom (forall x:int :: {pAllocatedResourcesTranslated__BDSI_INITIALIZERESOURCES(x)} pAllocatedResourcesTranslated__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pAllocatedResources__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {pAllocatedResources__BDSI_INITIALIZERESOURCES(x)} pAllocatedResources__BDSI_INITIALIZERESOURCES(x) == x + 4);
axiom (forall x:int :: {pAllocatedResources__BDSI_INITIALIZERESOURCES(x)} pAllocatedResources__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pAttachedDeviceObject__BDL_DEVICEEXT(int) returns (int);


//axiom (forall x:int :: {pAttachedDeviceObject__BDL_DEVICEEXT(x)} pAttachedDeviceObject__BDL_DEVICEEXT(x) == x + 4);
axiom (forall x:int :: {pAttachedDeviceObject__BDL_DEVICEEXT(x)} pAttachedDeviceObject__BDL_DEVICEEXT(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pBDLExtension__POWER_IRP_CONTEXT(int) returns (int);


//axiom (forall x:int :: {pBDLExtension__POWER_IRP_CONTEXT(x)} pBDLExtension__POWER_IRP_CONTEXT(x) == x + 0);
axiom (forall x:int :: {pBDLExtension__POWER_IRP_CONTEXT(x)} pBDLExtension__POWER_IRP_CONTEXT(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pBuffer__BDDI_ITEM_DATA_BLOCK(int) returns (int);


//axiom (forall x:int :: {pBuffer__BDDI_ITEM_DATA_BLOCK(x)} pBuffer__BDDI_ITEM_DATA_BLOCK(x) == x + 4);
axiom (forall x:int :: {pBuffer__BDDI_ITEM_DATA_BLOCK(x)} pBuffer__BDDI_ITEM_DATA_BLOCK(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pDriverExtension__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {pDriverExtension__BDL_INTERNAL_DEVICE_EXTENSION(x)} pDriverExtension__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 12);
axiom (forall x:int :: {pDriverExtension__BDL_INTERNAL_DEVICE_EXTENSION(x)} pDriverExtension__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 12));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pHead_HANDLELIST_(int) returns (int);


//axiom (forall x:int :: {pHead_HANDLELIST_(x)} pHead_HANDLELIST_(x) == x + 0);
axiom (forall x:int :: {pHead_HANDLELIST_(x)} pHead_HANDLELIST_(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pIrp__BDL_CONTROL_CHANGE_STRUCT(int) returns (int);


//axiom (forall x:int :: {pIrp__BDL_CONTROL_CHANGE_STRUCT(x)} pIrp__BDL_CONTROL_CHANGE_STRUCT(x) == x + 632);
axiom (forall x:int :: {pIrp__BDL_CONTROL_CHANGE_STRUCT(x)} pIrp__BDL_CONTROL_CHANGE_STRUCT(x) == INT_ADD(x, 632));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pNext_LIST_NODE_(int) returns (int);


//axiom (forall x:int :: {pNext_LIST_NODE_(x)} pNext_LIST_NODE_(x) == x + 0);
axiom (forall x:int :: {pNext_LIST_NODE_(x)} pNext_LIST_NODE_(x) == INT_ADD(x, 0));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pTail_HANDLELIST_(int) returns (int);


//axiom (forall x:int :: {pTail_HANDLELIST_(x)} pTail_HANDLELIST_(x) == x + 4);
axiom (forall x:int :: {pTail_HANDLELIST_(x)} pTail_HANDLELIST_(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pfbddiCloseHandle__BDLI_BDDIFUNCTIONS(int) returns (int);


//axiom (forall x:int :: {pfbddiCloseHandle__BDLI_BDDIFUNCTIONS(x)} pfbddiCloseHandle__BDLI_BDDIFUNCTIONS(x) == x + 24);
axiom (forall x:int :: {pfbddiCloseHandle__BDLI_BDDIFUNCTIONS(x)} pfbddiCloseHandle__BDLI_BDDIFUNCTIONS(x) == INT_ADD(x, 24));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pfbddiRegisterNotify__BDLI_BDDIFUNCTIONS(int) returns (int);


//axiom (forall x:int :: {pfbddiRegisterNotify__BDLI_BDDIFUNCTIONS(x)} pfbddiRegisterNotify__BDLI_BDDIFUNCTIONS(x) == x + 4);
axiom (forall x:int :: {pfbddiRegisterNotify__BDLI_BDDIFUNCTIONS(x)} pfbddiRegisterNotify__BDLI_BDDIFUNCTIONS(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pfbdsiInitializeResources__BDLI_BDSIFUNCTIONS(int) returns (int);


//axiom (forall x:int :: {pfbdsiInitializeResources__BDLI_BDSIFUNCTIONS(x)} pfbdsiInitializeResources__BDLI_BDSIFUNCTIONS(x) == x + 12);
axiom (forall x:int :: {pfbdsiInitializeResources__BDLI_BDSIFUNCTIONS(x)} pfbdsiInitializeResources__BDLI_BDSIFUNCTIONS(x) == INT_ADD(x, 12));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pfbdsiReleaseResources__BDLI_BDSIFUNCTIONS(int) returns (int);


//axiom (forall x:int :: {pfbdsiReleaseResources__BDLI_BDSIFUNCTIONS(x)} pfbdsiReleaseResources__BDLI_BDSIFUNCTIONS(x) == x + 16);
axiom (forall x:int :: {pfbdsiReleaseResources__BDLI_BDSIFUNCTIONS(x)} pfbdsiReleaseResources__BDLI_BDSIFUNCTIONS(x) == INT_ADD(x, 16));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pfbdsiRemoveDevice__BDLI_BDSIFUNCTIONS(int) returns (int);


//axiom (forall x:int :: {pfbdsiRemoveDevice__BDLI_BDSIFUNCTIONS(x)} pfbdsiRemoveDevice__BDLI_BDSIFUNCTIONS(x) == x + 8);
axiom (forall x:int :: {pfbdsiRemoveDevice__BDLI_BDSIFUNCTIONS(x)} pfbdsiRemoveDevice__BDLI_BDSIFUNCTIONS(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function pfbdsiSetPowerState__BDLI_BDSIFUNCTIONS(int) returns (int);


//axiom (forall x:int :: {pfbdsiSetPowerState__BDLI_BDSIFUNCTIONS(x)} pfbdsiSetPowerState__BDLI_BDSIFUNCTIONS(x) == x + 32);
axiom (forall x:int :: {pfbdsiSetPowerState__BDLI_BDSIFUNCTIONS(x)} pfbdsiSetPowerState__BDLI_BDSIFUNCTIONS(x) == INT_ADD(x, 32));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgChannels__BDL_COMPONENT(int) returns (int);


//axiom (forall x:int :: {rgChannels__BDL_COMPONENT(x)} rgChannels__BDL_COMPONENT(x) == x + 16);
axiom (forall x:int :: {rgChannels__BDL_COMPONENT(x)} rgChannels__BDL_COMPONENT(x) == INT_ADD(x, 16));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgComponents__BDL_DEVICE_CAPABILITIES(int) returns (int);


//axiom (forall x:int :: {rgComponents__BDL_DEVICE_CAPABILITIES(x)} rgComponents__BDL_DEVICE_CAPABILITIES(x) == x + 12);
axiom (forall x:int :: {rgComponents__BDL_DEVICE_CAPABILITIES(x)} rgComponents__BDL_DEVICE_CAPABILITIES(x) == INT_ADD(x, 12));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgControls__BDL_CHANNEL(int) returns (int);


//axiom (forall x:int :: {rgControls__BDL_CHANNEL(x)} rgControls__BDL_CHANNEL(x) == x + 8);
axiom (forall x:int :: {rgControls__BDL_CHANNEL(x)} rgControls__BDL_CHANNEL(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgControls__BDL_COMPONENT(int) returns (int);


//axiom (forall x:int :: {rgControls__BDL_COMPONENT(x)} rgControls__BDL_COMPONENT(x) == x + 8);
axiom (forall x:int :: {rgControls__BDL_COMPONENT(x)} rgControls__BDL_COMPONENT(x) == INT_ADD(x, 8));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgControls__BDL_DEVICE_CAPABILITIES(int) returns (int);


//axiom (forall x:int :: {rgControls__BDL_DEVICE_CAPABILITIES(x)} rgControls__BDL_DEVICE_CAPABILITIES(x) == x + 4);
axiom (forall x:int :: {rgControls__BDL_DEVICE_CAPABILITIES(x)} rgControls__BDL_DEVICE_CAPABILITIES(x) == INT_ADD(x, 4));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgProducts__BDL_CHANNEL(int) returns (int);


//axiom (forall x:int :: {rgProducts__BDL_CHANNEL(x)} rgProducts__BDL_CHANNEL(x) == x + 28);
axiom (forall x:int :: {rgProducts__BDL_CHANNEL(x)} rgProducts__BDL_CHANNEL(x) == INT_ADD(x, 28));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function rgSourceLists__BDL_CHANNEL(int) returns (int);


//axiom (forall x:int :: {rgSourceLists__BDL_CHANNEL(x)} rgSourceLists__BDL_CHANNEL(x) == x + 20);
axiom (forall x:int :: {rgSourceLists__BDL_CHANNEL(x)} rgSourceLists__BDL_CHANNEL(x) == INT_ADD(x, 20));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function wszSerialNumber__BDL_INTERNAL_DEVICE_EXTENSION(int) returns (int);


//axiom (forall x:int :: {wszSerialNumber__BDL_INTERNAL_DEVICE_EXTENSION(x)} wszSerialNumber__BDL_INTERNAL_DEVICE_EXTENSION(x) == x + 832);
axiom (forall x:int :: {wszSerialNumber__BDL_INTERNAL_DEVICE_EXTENSION(x)} wszSerialNumber__BDL_INTERNAL_DEVICE_EXTENSION(x) == INT_ADD(x, 832));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS

function wszSerialNumber__BDSI_INITIALIZERESOURCES(int) returns (int);


//axiom (forall x:int :: {wszSerialNumber__BDSI_INITIALIZERESOURCES(x)} wszSerialNumber__BDSI_INITIALIZERESOURCES(x) == x + 12);
axiom (forall x:int :: {wszSerialNumber__BDSI_INITIALIZERESOURCES(x)} wszSerialNumber__BDSI_INITIALIZERESOURCES(x) == INT_ADD(x, 12));
//adding this additional axiom since to show Array(x, 1, n)[f(x)], we need f(x) to be a PLUS


///////////////////////////////////
// will be replaced by:
// "//" when using bv mode
// ""   when using int mode
// main reason is to avoid using bv for constants
// or avoid translating lines that are complex or unsound
//////////////////////////////////

////////////////////////////////////////////
/////// functions for int type /////////////
// Theorem prover does not see INT_ADD etc.
////////////////////////////////////////////
function {:inline true} INT_EQ(x:int, y:int)  returns  (bool)   {x == y}
function {:inline true} INT_NEQ(x:int, y:int)  returns  (bool)   {x != y}

function {:inline true} INT_ADD(x:int, y:int)  returns  (int)   {x + y}
function {:inline true} INT_SUB(x:int, y:int)  returns  (int)   {x - y}
function {:inline true} INT_MULT(x:int, y:int) returns  (int)   {x * y}
function {:inline true} INT_DIV(x:int, y:int)  returns  (int)   {x div y}
function {:inline true} INT_LT(x:int, y:int)   returns  (bool)  {x < y}
function {:inline true} INT_ULT(x:int, y:int)   returns  (bool)  {x < y}
function {:inline true} INT_LEQ(x:int, y:int)  returns  (bool)  {x <= y}
function {:inline true} INT_ULEQ(x:int, y:int)  returns  (bool)  {x <= y}
function {:inline true} INT_GT(x:int, y:int)   returns  (bool)  {x > y}
function {:inline true} INT_UGT(x:int, y:int)   returns  (bool)  {x > y}
function {:inline true} INT_GEQ(x:int, y:int)  returns  (bool)  {x >= y}
function {:inline true} INT_UGEQ(x:int, y:int)  returns  (bool)  {x >= y}


////////////////////////////////////////////
/////// functions for bv32 type /////////////
// Theorem prover does not see INT_ADD etc.
// we are treating unsigned ops now
////////////////////////////////////////////
function {:inline true} BV32_EQ(x:bv32, y:bv32)  returns  (bool)   {x == y}
function {:inline true} BV32_NEQ(x:bv32, y:bv32)  returns  (bool)  {x != y}

function {:bvbuiltin "bvadd"}  BV32_ADD(x:bv32, y:bv32)  returns  (bv32);
function {:bvbuiltin "bvsub"}  BV32_SUB(x:bv32, y:bv32)  returns  (bv32);
function {:bvbuiltin "bvmul"}  BV32_MULT(x:bv32, y:bv32) returns  (bv32);
function {:bvbuiltin "bvudiv"} BV32_DIV(x:bv32, y:bv32)  returns  (bv32);
function {:bvbuiltin "bvult"}  BV32_ULT(x:bv32, y:bv32)   returns  (bool);
function {:bvbuiltin "bvslt"}  BV32_LT(x:bv32, y:bv32)   returns  (bool);
function {:bvbuiltin "bvule"}  BV32_ULEQ(x:bv32, y:bv32)  returns  (bool);
function {:bvbuiltin "bvsle"}  BV32_LEQ(x:bv32, y:bv32)  returns  (bool);
function {:bvbuiltin "bvugt"}  BV32_UGT(x:bv32, y:bv32)   returns  (bool);
function {:bvbuiltin "bvsgt"}  BV32_GT(x:bv32, y:bv32)   returns  (bool);
function {:bvbuiltin "bvuge"}  BV32_UGEQ(x:bv32, y:bv32)  returns  (bool);
function {:bvbuiltin "bvsge"}  BV32_GEQ(x:bv32, y:bv32)  returns  (bool);

//what about bitwise ops {BIT_AND, BIT_OR, BIT_NOT, ..}
//only enabled with bv theory
// function {:bvbuiltin "bvand"} BIT_BAND(a:int, b:int) returns (x:int);
// function {:bvbuiltin "bvor"}  BIT_BOR(a:int, b:int) returns (x:int);
// function {:bvbuiltin "bvxor"} BIT_BXOR(a:int, b:int) returns (x:int);
// function {:bvbuiltin "bvnot"} BIT_BNOT(a:int) returns (x:int);

//////////////////////////////////
// Generic C Arithmetic operations
/////////////////////////////////

//Is this sound for bv32?
function MINUS_BOTH_PTR_OR_BOTH_INT(a:int, b:int, size:int) returns (int);
 axiom  (forall a:int, b:int, size:int :: {MINUS_BOTH_PTR_OR_BOTH_INT(a,b,size)}
//size * MINUS_BOTH_PTR_OR_BOTH_INT(a,b,size) <= a - b && a - b < size * (MINUS_BOTH_PTR_OR_BOTH_INT(a,b,size) + 1));
 INT_LEQ( INT_MULT(size, MINUS_BOTH_PTR_OR_BOTH_INT(a,b,size)),  INT_SUB(a, b)) && INT_LT( INT_SUB(a, b),  INT_MULT(size, (INT_ADD(MINUS_BOTH_PTR_OR_BOTH_INT(a,b,size), 1)))));

//we just keep this axiom for size = 1
axiom  (forall a:int, b:int, size:int :: {MINUS_BOTH_PTR_OR_BOTH_INT(a,b,size)}  MINUS_BOTH_PTR_OR_BOTH_INT(a,b,1) == INT_SUB(a,b));


function MINUS_LEFT_PTR(a:int, a_size:int, b:int) returns (int);
//axiom(forall a:int, a_size:int, b:int :: {MINUS_LEFT_PTR(a,a_size,b)} MINUS_LEFT_PTR(a,a_size,b) == a - a_size * b);
axiom(forall a:int, a_size:int, b:int :: {MINUS_LEFT_PTR(a,a_size,b)} MINUS_LEFT_PTR(a,a_size,b) == INT_SUB(a, INT_MULT(a_size, b)));


function PLUS(a:int, a_size:int, b:int) returns (int);
//axiom (forall a:int, a_size:int, b:int :: {PLUS(a,a_size,b)} PLUS(a,a_size,b) == a + a_size * b);
axiom (forall a:int, a_size:int, b:int :: {PLUS(a,a_size,b)} PLUS(a,a_size,b) == INT_ADD(a, INT_MULT(a_size, b)));

function MULT(a:int, b:int) returns (int); // a*b
//axiom(forall a:int, b:int :: {MULT(a,b)} MULT(a,b) == a * b);
axiom(forall a:int, b:int :: {MULT(a,b)} MULT(a,b) == INT_MULT(a, b));

function DIV(a:int, b:int) returns (int); // a/b

// Not sure if these axioms hold for BV too, just commet them for BV



//uninterpreted binary op
function BINARY_BOTH_INT(a:int, b:int) returns (int);


//////////////////////////////////////////
//// Bitwise ops (uninterpreted, used with int)
//////////////////////////////////////////


 function BIT_BAND(a:int, b:int) returns (x:int);


 function BIT_BOR(a:int, b:int) returns (x:int);
 function BIT_BXOR(a:int, b:int) returns (x:int);
 function BIT_BNOT(a:int) returns (int);




function LIFT(a:bool) returns (int);
axiom(forall a:bool :: {LIFT(a)} a <==> LIFT(a) != 0);

function PTR_NOT(a:int) returns (int);
axiom(forall a:int :: {PTR_NOT(a)} a == 0 ==> PTR_NOT(a) != 0);
axiom(forall a:int :: {PTR_NOT(a)} a != 0 ==> PTR_NOT(a) == 0);

function NULL_CHECK(a:int) returns (int);
axiom(forall a:int :: {NULL_CHECK(a)} a == 0 ==> NULL_CHECK(a) != 0);
axiom(forall a:int :: {NULL_CHECK(a)} a != 0 ==> NULL_CHECK(a) == 0);

procedure havoc_assert(i:int);
requires (i != 0);

procedure havoc_assume(i:int);
ensures (i != 0);

procedure __HAVOC_free(a:int);

function NewAlloc(x:int, y:int) returns (z:int);

//Comments below make HAVOC_malloc deterministic

procedure __HAVOC_malloc(obj_size:int) returns (new:int);
//requires obj_size >= 0;
free requires INT_GEQ(obj_size, 0);
modifies alloc;
ensures new == old(alloc);
//ensures alloc > new + obj_size;
ensures INT_GT(alloc, INT_ADD(new, obj_size));
//ensures alloc == NewAlloc(old(alloc), obj_size);




procedure _strdup(str:int) returns (new:int);

procedure _xstrcasecmp(a0:int, a1:int) returns (ret:int);

procedure _xstrcmp(a0:int, a1:int) returns (ret:int);


/*
//bv functions
function bv8ToInt(bv8)   returns (int);
function bv16ToInt(bv16) returns (int);
function bv32ToInt(bv32) returns (int);
function bv64ToInt(bv64) returns (int);

function intToBv8(int)    returns (bv8);
function intToBv16(int)   returns (bv16);
function intToBv32(int)   returns (bv32);
function intToBv64(int)   returns (bv64);

axiom(forall a:int ::  {intToBv8(a)} bv8ToInt(intToBv8(a)) == a);
axiom(forall a:int ::  {intToBv16(a)} bv16ToInt(intToBv16(a)) == a);
axiom(forall a:int ::  {intToBv32(a)} bv32ToInt(intToBv32(a)) == a);
axiom(forall a:int ::  {intToBv64(a)} bv64ToInt(intToBv64(a)) == a);

axiom(forall b:bv8 ::  {bv8ToInt(b)} intToBv8(bv8ToInt(b)) == b);
axiom(forall b:bv16 ::  {bv16ToInt(b)} intToBv16(bv16ToInt(b)) == b);
axiom(forall b:bv32 ::  {bv32ToInt(b)} intToBv32(bv32ToInt(b)) == b);
axiom(forall b:bv64 ::  {bv64ToInt(b)} intToBv64(bv64ToInt(b)) == b);
*/



var Res_0_COMPLETED : [int]int;
var Res_0_EVENT : [int]int;
var Res_KERNEL_SOURCE:[int]int;
var Res_0_LOCK : [int]int;
var Res_PROBED:[int]int;

//Pointer constants

//Function pointer constants
const unique BDLCallDriverCompletionRoutine : int;
const unique BDLDevicePowerIoCompletion : int;
const unique BDLSystemPowerIoCompletion : int;


axiom(BDLCallDriverCompletionRoutine != 0);
const unique BDLSystemPowerCompleted : int;
axiom(BDLSystemPowerCompleted != 0);
var cancelLockStatus_0 : int;

var created_irp_0 : int;

const unique g_DebugLevel : int;
axiom(g_DebugLevel != 0);
const unique hdevobj : int;
axiom(hdevobj != 0);


procedure DRIVER_CANCEL(a0:int, a1:int);



procedure ExFreePoolWithTag(a0:int, a1:int);



procedure FN_BDDI_CLOSEHANDLE(a0:int, a1:int) returns (ret:int);



procedure FN_BDDI_REGISTERNOTIFY(a0:int, a1:int) returns (ret:int);



procedure FN_BDSI_INITIALIZERESOURCES(a0:int, a1:int) returns (ret:int);



procedure FN_BDSI_RELEASERESOURCES(a0:int) returns (ret:int);



procedure FN_BDSI_REMOVEDEVICE(a0:int) returns (ret:int);



procedure FN_BDSI_SETPOWERSTATE(a0:int, a1:int) returns (ret:int);



procedure IO_COMPLETION_ROUTINE(a0:int, a1:int, a2:int) returns (ret:int);



procedure IoAcquireRemoveLockEx(a0:int, a1:int, a2:int, a3:int, a4:int) returns (ret:int);



procedure IoDeleteDevice(a0:int);



procedure IoDetachDevice(a0:int);



procedure IoReleaseRemoveLockAndWaitEx(a0:int, a1:int, a2:int);



procedure IoReleaseRemoveLockEx(a0:int, a1:int, a2:int);



procedure IoSetDeviceInterfaceState(a0:int, a1:int) returns (ret:int);



procedure KfLowerIrql(a0:int);



procedure KfRaiseIrql(a0:int) returns (ret:int);



procedure PoRequestPowerIrp(a0:int, a1:int, a2:int, a3:int, a4:int, a5:int) returns (ret:int);



procedure PoSetPowerState(a0:int, a1:int, a2:int) returns (ret:int);



procedure PoStartNextPowerIrp(a0:int);



procedure RtlFreeUnicodeString(a0:int);



procedure __storm_assert_dummy();



procedure __storm_atomic_begin_dummy();



procedure __storm_atomic_end_dummy();



procedure __storm_init_begin_dummy();



procedure __storm_init_end_dummy();






procedure storm_nondet() returns (ret:int);



procedure storm_main();
  free requires 0 < alloc;
  requires INT_LT(PLUS(hdevobj, 1, 184), alloc);
  modifies alloc, k, errorReached, raiseException, __storm_atomic, __storm_init, cancelLockStatus_0, created_irp_0, alloc, __storm_thread_id, __storm_thread_done_1, __storm_thread_done_2, __storm_thread_done_3, __storm_thread_done_4, Res_0_COMPLETED, Res_0_EVENT, Res_KERNEL_SOURCE, Res_0_LOCK, Res_PROBED, Mem_0_T.CancelRoutine__IRP, Mem_0_T.CurrentLocation__IRP, Mem_0_T.DeviceExtension__DEVICE_OBJECT, Mem_0_T.StackCount__IRP;



implementation storm_main()
{
  var inline$BDLGetDebugLevel$398$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$407$myNondetVar_0: int, inline$CallCompletionRoutine$10$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$21$: int, inline$BDLGetDebugLevel$681$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$17$$context$2$435.8$CallCompletionRoutine$4: int, inline$CallCompletionRoutine$0$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$25$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$55$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$$result.DbgPrint$3251.0$2$: int, inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$4$: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLSystemPowerIoCompletion$21$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$487$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$57$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$567$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$584$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$7$: int, inline$BDLGetDebugLevel$475$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$375$myNondetVar_0: int, inline$BDLGetDebugLevel$525$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$548$myNondetVar_0: int, inline$BDLGetDebugLevel$49$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$13$$result.memset$1683.8$14$: int, inline$CallCompletionRoutine$18$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$596$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$167$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$601$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$31$myVar_0: int, inline$IoGetCurrentIrpStackLocation$31$myVar_1: int, inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$529$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$6$havoc_stringTemp: int, inline$CallCompletionRoutine$28$myNondetVar_0: int, inline$BDLGetDebugLevel$239$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStop$0$$result.BDLPnPStop$2180.0$1$: int, inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$storm_PoCallDriver$1$$result.storm_IoCallDriver$499.27$2$: int, inline$BDLGetDebugLevel$8$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$71$myVar_0: int, inline$IoGetCurrentIrpStackLocation$71$myVar_1: int, inline$BDLCallDriverCompletionRoutine$22$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$25$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$14$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetNextIrpStackLocation$8$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$10$havoc_stringTemp: int, inline$RemoveHeadList$5$$Entry$3$8126.16$RemoveHeadList$4: int, inline$BDLGetDebugLevel$394$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$4$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$84$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLCallDriverCompletionRoutine$13$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$520$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$702$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$792$myNondetVar_0: int, inline$BDLGetDebugLevel$733$myNondetVar_0: int, inline$BDLGetDebugLevel$317$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$30$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1665.0$4$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$18$$result.memset$1683.8$14$: int, inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$storm_KeAcquireSpinLock$0$$tid$3$128.6$storm_KeAcquireSpinLock$8: int, inline$BDLSystemPowerIoCompletion$10$myNondetVar_0: int, inline$BDLGetDebugLevel$508$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLSystemPowerIoCompletion$28$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$343$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$555$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$79$myVar_0: int, inline$IoGetCurrentIrpStackLocation$79$myVar_1: int, inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$16$: int, inline$IoGetCurrentIrpStackLocation$52$havoc_stringTemp: int, inline$BDLGetDebugLevel$27$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$27$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$341$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$26$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8: int, inline$CallCompletionRoutine$30$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$2$: int, inline$IoGetCurrentIrpStackLocation$53$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1428.0$34$: int, inline$BDLDevicePowerIoCompletion$1$$callresult.$1687.68$15$: int, inline$BDLSystemPowerIoCompletion$0$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$113$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1358.0$15$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$27$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$4$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$737$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16_.1: int, inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLGetDebugLevel$315$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$47$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$284$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$6$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$421$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$49$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$7$$result.memset$1683.8$14$: int, inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$storm_KeReleaseSpinLock$1$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$BDLGetDebugLevel$41$myNondetVar_0: int, inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$125$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$1$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4: int, inline$BDLGetDebugLevel$44$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$29$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$IoGetNextIrpStackLocation$5$myNondetVar_0: int, inline$BDLGetDebugLevel$418$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCleanupDataHandles$1$$result.DbgPrint$3290.0$21$: int, inline$IoSetNextIrpStackLocation$9$havoc_stringTemp: int, inline$storm_IoCompleteRequest$58$$result.storm_nondet$338.2$1$: int, inline$BDLCallDriverCompletionRoutine$24$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$27$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$27$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$28$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$289$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$22$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCallDriver$12$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$519$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp: int, inline$BDLGetDebugLevel$530$myNondetVar_0: int, inline$BDLCallLowerLevelDriverAndWait$5$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLSystemPowerIoCompletion$12$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$650$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$210$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$result.PoSetPowerState$1693.27$16$: int, inline$BDLGetDebugLevel$471$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$2$myVar_0: int, inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1723.0$34$: int, inline$BDLDevicePowerIoCompletion$26$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$28$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$3$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$305$myNondetVar_0: int, inline$BDLGetDebugLevel$506$myNondetVar_0: int, inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$46$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLCallDriverCompletionRoutine$14$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$IoGetCurrentIrpStackLocation$147$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1700.0$23$: int, inline$BDLGetDebugLevel$636$myNondetVar_0: int, inline$BDLGetDebugLevel$493$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$111$myNondetVar_0: int, inline$BDLGetDebugLevel$388$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$26$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$483$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$8$: int, inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$43$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeInitializeEvent$1$$State$3$205.13$storm_KeInitializeEvent$12_.1: int, inline$BDLGetDebugLevel$778$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetNextIrpStackLocation$3$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$28$: int, inline$IoGetCurrentIrpStackLocation$42$myVar_0: int, inline$IoGetCurrentIrpStackLocation$42$myVar_1: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$61$: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$299$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$309$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$24$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$13$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$3$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$22$myNondetVar_0: int, inline$BDLGetDebugLevel$319$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1700.0$18$: int, inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLGetDebugLevel$352$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$0$tempBoogie0: int, inline$BDLGetDebugLevel$120$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$19$$Event$1$213.14$storm_KeSetEvent$12: int, inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPCancelRemove$0$$pIrp$3$2318.40$BDLPnPCancelRemove$12_.1: int, inline$BDLGetDebugLevel$100$myNondetVar_0: int, inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8: int, inline$IoGetNextIrpStackLocation$6$myVar_0: int, inline$IoGetCurrentIrpStackLocation$23$myVar_0: int, inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$143$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$72$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$107$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$IoSetNextIrpStackLocation$14$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$6$$result.memset$1683.8$14$: int, inline$BDLDevicePowerIoCompletion$28$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$35$myNondetVar_0: int, inline$BDLGetDebugLevel$624$myNondetVar_0: int, inline$storm_IoCompleteRequest$39$$result.storm_nondet$338.2$1$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$3$: int, inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$360$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$56$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$38$myVar_1: int, inline$IoGetCurrentIrpStackLocation$38$myVar_0: int, inline$BDLGetDebugLevel$525$myNondetVar_0: int, inline$BDLGetDebugLevel$450$myNondetVar_0: int, inline$BDLGetDebugLevel$363$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$153$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$13$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$771$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$26$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$54$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPQueryStop$0$$result.BDLPnPQueryStop$2074.0$1$: int, inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$BDLGetDebugLevel$578$myNondetVar_0: int, inline$BDLGetDebugLevel$235$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$29$myNondetVar_0: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$7$: int, inline$BDLGetDebugLevel$382$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$581$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$37$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLSystemPowerIoCompletion$16$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$storm_getThreadID$3$tid: int, inline$BDLCallDriverCompletionRoutine$24$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoSetNextIrpStackLocation$12$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$24$: int, inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$670$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$50$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$96$myVar_1: int, inline$IoGetCurrentIrpStackLocation$96$myVar_0: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1700.0$23$: int, inline$BDLPnP$0$$result.BDLPnPQueryStop$916.32$29$: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$22$: int, inline$storm_KeInitializeEvent$0$$State$3$205.13$storm_KeInitializeEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$23$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$799$myNondetVar_0: int, inline$BDLGetDebugLevel$610$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_KeAcquireSpinLock$0$$result.storm_getThreadID$128.29$1$: int, inline$IoGetCurrentIrpStackLocation$47$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$14$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$618$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$303$myNondetVar_0: int, inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLDevicePowerIoCompletion$11$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IsListEmpty$2$$result.IsListEmpty$8096.0$1$: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$6$: int, inline$BDLGetDebugLevel$60$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$640$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp: int, inline$RemoveHeadList$0$$Entry$3$8126.16$RemoveHeadList$4: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$148$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$743$myNondetVar_0: int, inline$BDLGetDebugLevel$770$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$41$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$99$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1700.0$18$: int, inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$4$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$30$$result.memset$1683.8$14$: int, inline$storm_IoCallDriver$5$$result.storm_nondet$465.2$2$: int, inline$BDLCallDriverCompletionRoutine$20$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLGetDebugLevel$561$myNondetVar_0: int, inline$BDLGetDebugLevel$56$myNondetVar_0: int, inline$BDLGetDebugLevel$583$myNondetVar_0: int, inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCleanupNotificationStruct$0$$bddiRegisterNotifyParams$10$3120.36$BDLCleanupNotificationStruct$4: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLHandleRemove$0$$result.DbgPrint$2457.0$41$: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$477$myNondetVar_0: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$24$: int, inline$IoSetNextIrpStackLocation$13$myVar_0: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$681$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1428.0$34$: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLGetDebugLevel$421$myNondetVar_0: int, inline$BDLGetDebugLevel$59$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$47$myNondetVar_0: int, inline$BDLGetDebugLevel$530$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$690$myNondetVar_0: int, inline$BDLGetDebugLevel$426$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3144.23$13$: int, inline$BDLGetDebugLevel$165$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$112$myNondetVar_0: int, inline$BDLGetDebugLevel$458$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$7$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLGetDebugLevel$261$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1358.0$20$: int, inline$IsListEmpty$5$myNondetVar_0: int, inline$BDLGetDebugLevel$324$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$11$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLHandleRemove$1$$result.DbgPrint$2423.0$17$: int, inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1723.0$34$: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1428.0$29$: int, inline$BDLPnPSurpriseRemoval$0$$pIrp$3$2531.40$BDLPnPSurpriseRemoval$12_.1: int, inline$BDLGetDebugLevel$309$myNondetVar_0: int, inline$BDLPnPSurpriseRemoval$0$$pIrp$3$2531.40$BDLPnPSurpriseRemoval$12: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$17$: int, inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$13$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$8$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLCallDriverCompletionRoutine$10$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$22$: int, inline$CallCompletionRoutine$2$$status$5$438.11$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$126$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$395$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$580$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLGetDebugLevel$25$myNondetVar_0: int, inline$BDLGetDebugLevel$527$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLGetDebugLevel$766$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$88$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$8$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$94$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$473$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLHandleRemove$1$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$3$myVar_0: int, inline$IoGetCurrentIrpStackLocation$3$myVar_1: int, inline$CallCompletionRoutine$2$$result.completionRoutine$448.30$3$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$10$$callresult.$1687.68$15$: int, inline$BDLGetDebugLevel$437$myNondetVar_0: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$20$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLPnP$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1358.0$15$: int, inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$8$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$550$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$28$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$576$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$12$myVar_1: int, inline$IoGetCurrentIrpStackLocation$12$myVar_0: int, inline$BDLGetDebugLevel$633$myNondetVar_0: int, inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$144$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$63$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$80$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$13$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$649$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$14$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLCleanupDataHandles$1$$result.DbgPrint$3308.0$27$: int, inline$BDLGetDebugLevel$729$myNondetVar_0: int, inline$BDLGetDebugLevel$274$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$144$myVar_0: int, inline$IoGetCurrentIrpStackLocation$144$myVar_1: int, inline$BDLSystemPowerIoCompletion$22$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLPnP$0$$result.DbgPrint$987.0$42$: int, inline$BDLCallDriverCompletionRoutine$3$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$IoGetCurrentIrpStackLocation$73$myVar_0: int, inline$IoGetCurrentIrpStackLocation$73$myVar_1: int, inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$57$myVar_0: int, inline$RemoveHeadList$0$$result.RemoveHeadList$8121.0$1$: int, inline$BDLGetDebugLevel$657$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.DbgPrint$2037.0$48$: int, inline$BDLDevicePowerIoCompletion$21$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$25$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLGetDebugLevel$465$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$5$tempBoogie0: int, inline$BDLDevicePowerIoCompletion$19$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$storm_KeSetEvent$17$$Event$1$213.14$storm_KeSetEvent$12: int, inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8: int, inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$401$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$644$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$14$: int, inline$IoGetCurrentIrpStackLocation$86$myVar_0: int, inline$IoGetCurrentIrpStackLocation$86$myVar_1: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1344.0$4$: int, inline$CallCompletionRoutine$9$myNondetVar_0: int, inline$storm_KeSetEvent$13$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4: int, inline$BDLGetDebugLevel$803$myNondetVar_0: int, inline$BDLGetDebugLevel$137$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$280$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$326$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoGetCurrentIrpStackLocation$77$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$3$: int, inline$IoGetCurrentIrpStackLocation$108$havoc_stringTemp: int, inline$BDLGetDebugLevel$434$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$18$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$146$havoc_stringTemp: int, inline$BDLCallLowerLevelDriverAndWait$1$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$260$myNondetVar_0: int, inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCleanupNotificationStruct$1$$result.RemoveHeadList$3153.26$14$: int, inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLHandleRemove$0$$result.storm_IoCallDriver$2453.25$39$: int, inline$BDLGetDebugLevel$567$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$241$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$148$myNondetVar_0: int, inline$myInitDriver$0$myVar_0: int, inline$BDLGetDebugLevel$794$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$29$myNondetVar_0: int, inline$BDLPnPRemove$0$$result.DbgPrint$2486.0$3$: int, inline$BDLSystemPowerIoCompletion$7$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$11$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$21$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$630$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$8$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$250$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp: int, inline$storm_IoCallDriver$4$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLGetDebugLevel$283$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$147$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$13$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$725$myNondetVar_0: int, inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4: int, inline$BDLGetDebugLevel$161$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$586$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$177$$result.BDLGetDebugLevel$39.0$1$: int, inline$IsListEmpty$3$$result.IsListEmpty$8096.0$1$: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$32$: int, inline$storm_IoCompleteRequest$16$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$603$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$12$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$25$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$75$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_PoCallDriver$0$$result.storm_IoCallDriver$499.27$2$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLGetDebugLevel$82$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$10$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$511$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$788$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$8$$result.storm_IoCallDriver$456.0$1$: int, inline$IoGetCurrentIrpStackLocation$118$myVar_1: int, inline$IoGetCurrentIrpStackLocation$118$myVar_0: int, inline$BDLGetDebugLevel$633$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1344.0$9$: int, inline$storm_IoCompleteRequest$30$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$7$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4: int, inline$IoGetCurrentIrpStackLocation$112$myVar_1: int, inline$IoGetCurrentIrpStackLocation$112$myVar_0: int, inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$19$myNondetVar_0: int, inline$BDLGetDebugLevel$617$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$80$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$114$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$326$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$416$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$83$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$33$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$CallCompletionRoutine$23$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$12$: int, inline$BDLGetDebugLevel$612$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$289$myNondetVar_0: int, inline$BDLGetDebugLevel$572$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$501$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$8$: int, inline$IoGetCurrentIrpStackLocation$31$havoc_stringTemp: int, inline$BDLGetDebugLevel$16$myNondetVar_0: int, inline$storm_IoCallDriver$2$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLSystemPowerIoCompletion$7$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$151$myVar_0: int, inline$IoGetCurrentIrpStackLocation$151$myVar_1: int, inline$BDLDevicePowerIoCompletion$28$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$665$myNondetVar_0: int, inline$BDLGetDebugLevel$272$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$5$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$6$: int, inline$BDLGetDebugLevel$214$myNondetVar_0: int, inline$BDLGetDebugLevel$77$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$10$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$83$myNondetVar_0: int, inline$BDLGetDebugLevel$80$myNondetVar_0: int, inline$BDLGetDebugLevel$664$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$12$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IsListEmpty$3$$ListHead$1$8097.28$IsListEmpty$4: int, inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeReleaseSpinLock$0$$result.storm_getThreadID$145.0$1$: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$37$: int, inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$601$myNondetVar_0: int, inline$BDLHandleRemove$0$$result.DbgPrint$2441.0$34$: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$61$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$17$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$14$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1: int, inline$IoGetCurrentIrpStackLocation$65$myVar_0: int, inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8: int, inline$BDLGetDebugLevel$205$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$109$myVar_1: int, inline$IoGetCurrentIrpStackLocation$109$myVar_0: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1428.0$34$: int, inline$storm_IoCompleteRequest$9$$result.storm_nondet$338.2$1$: int, inline$BDLHandleRemove$0$$result.DbgPrint$2386.0$8$: int, inline$IoGetCurrentIrpStackLocation$28$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IoGetCurrentIrpStackLocation$50$myVar_1: int, inline$IoGetCurrentIrpStackLocation$50$myVar_0: int, inline$BDLGetDebugLevel$133$myNondetVar_0: int, inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$51$myNondetVar_0: int, inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$storm_IoCallDriver$10$$status$4$462.11$storm_IoCallDriver$8: int, inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_PoCallDriver$4$$result.storm_PoCallDriver$494.0$1$: int, inline$BDLGetDebugLevel$166$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$1$havoc_stringTemp: int, inline$BDLGetDebugLevel$310$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$145$myNondetVar_0: int, inline$BDLGetDebugLevel$128$myNondetVar_0: int, inline$storm_KeSetEvent$23$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$349$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupDataHandles$0$$result.DbgPrint$3290.0$21$: int, inline$BDLGetDebugLevel$72$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLSystemPowerIoCompletion$11$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetNextIrpStackLocation$10$myVar_0: int, inline$BDLGetDebugLevel$160$myNondetVar_0: int, inline$storm_IoCallDriver$1$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$513$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$75$havoc_stringTemp: int, inline$BDLGetDebugLevel$314$myNondetVar_0: int, inline$BDLGetDebugLevel$696$myNondetVar_0: int, inline$CallCompletionRoutine$6$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$14$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$654$myNondetVar_0: int, inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8: int, inline$BDLGetDebugLevel$14$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$635$myNondetVar_0: int, inline$BDLGetDebugLevel$85$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$204$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLSystemPowerIoCompletion$3$myNondetVar_0: int, inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$474$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLLockHandleList$1$$pBDLExtension$1$134.40$BDLLockHandleList$8_.1: int, inline$BDLDevicePowerIoCompletion$23$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$102$myVar_1: int, inline$BDLPnPCancelStop$0$$pBDLExtension$1$2132.40$BDLPnPCancelStop$12: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLDevicePowerIoCompletion$18$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$628$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$12$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$17$: int, inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLCleanupDataHandles$0$$result.BDLGetFirstHandle$3264.27$12$: int, inline$BDLGetDebugLevel$590$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$478$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$123$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$153$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$3$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$142$havoc_stringTemp: int, inline$BDLGetDebugLevel$652$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$643$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$129$myNondetVar_0: int, inline$BDLGetDebugLevel$515$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$21$$result.PoSetPowerState$1693.27$16$: int, inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$9$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLDevicePowerIoCompletion$5$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$2$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$92$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$21$myVar_1: int, inline$storm_IoCallDriver$6$$result.storm_nondet$472.22$4$: int, inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$2$: int, inline$IoGetCurrentIrpStackLocation$48$myVar_0: int, inline$IoGetCurrentIrpStackLocation$48$myVar_1: int, inline$BDLGetDebugLevel$316$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1723.0$29$: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1358.0$20$: int, inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20: int, inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$70$havoc_stringTemp: int, inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1723.0$34$: int, inline$IoGetCurrentIrpStackLocation$56$havoc_stringTemp: int, inline$BDLHandleRemove$0$$callresult.$2437.63$27$: int, inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1723.0$29$: int, inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$8$myNondetVar_0: int, inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3178.0$17$: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$0$myVar_1: int, inline$IoGetCurrentIrpStackLocation$0$myVar_0: int, inline$BDLGetDebugLevel$58$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$25$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$564$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$139$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4: int, inline$RemoveHeadList$3$$Entry$3$8126.16$RemoveHeadList$4: int, inline$BDLGetDebugLevel$491$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$310$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$122$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeInitializeEvent$3$$Event$1$203.14$storm_KeInitializeEvent$12: int, inline$BDLCallDriverCompletionRoutine$12$myNondetVar_0: int, inline$BDLGetDebugLevel$729$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$377$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$0$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPQueryStop$0$$pIrp$3$2078.40$BDLPnPQueryStop$12: int, inline$BDLSystemPowerIoCompletion$21$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1358.0$20$: int, inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeSetEvent$16$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_IoCallDriver$0$$result.storm_IoCallDriver$456.0$1$: int, inline$IoGetCurrentIrpStackLocation$11$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLHandleRemove$1$$result.DbgPrint$2457.0$41$: int, inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1440.0$40$: int, inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1665.0$4$: int, inline$BDLSystemPowerIoCompletion$29$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$11$: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$31$: int, inline$BDLLockHandleList$0$$pBDLExtension$1$134.40$BDLLockHandleList$8: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$169$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$result.PoSetPowerState$1693.27$16$: int, inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$20$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLPnPQueryRemove$0$havoc_stringTemp: int, inline$storm_getThreadID$8$tid: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1358.0$20$: int, inline$IoGetCurrentIrpStackLocation$34$havoc_stringTemp: int, inline$BDLGetDebugLevel$676$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$88$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$11$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1344.0$4$: int, inline$BDLDevicePowerIoCompletion$10$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$14$: int, inline$IoGetCurrentIrpStackLocation$62$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$35$havoc_stringTemp: int, inline$IoGetNextIrpStackLocation$2$myNondetVar_0: int, inline$BDLGetDebugLevel$659$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$740$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$0$myVar_0: int, inline$BDLDevicePowerIoCompletion$4$$result.PoSetPowerState$1693.27$16$: int, inline$IoSetNextIrpStackLocation$9$myVar_0: int, inline$BDLGetDebugLevel$523$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$177$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$21$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLCallDriverCompletionRoutine$8$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$25$$callresult.$1687.68$15$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$38$: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLCallLowerLevelDriverAndWait$0$$result.BDLCallLowerLevelDriverAndWait$71.0$1$: int, inline$BDLDevicePowerIoCompletion$6$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$23$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16: int, inline$IoGetCurrentIrpStackLocation$23$havoc_stringTemp: int, inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$256$myNondetVar_0: int, inline$storm_KeSetEvent$17$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$294$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$24$myNondetVar_0: int, inline$BDLGetDebugLevel$485$myNondetVar_0: int, inline$BDLGetDebugLevel$2$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$13$: int, inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1: int, inline$BDLGetDebugLevel$475$myNondetVar_0: int, inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$97$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLDevicePowerIoCompletion$12$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$196$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$28$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$23$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$9$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$573$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLGetDebugLevel$381$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$24$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$5$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$17$: int, inline$IoSetNextIrpStackLocation$1$havoc_stringTemp: int, inline$BDLGetDebugLevel$87$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$9$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24: int, inline$IoGetCurrentIrpStackLocation$14$myNondetVar_0: int, inline$BDLGetDebugLevel$173$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$283$myNondetVar_0: int, inline$BDLGetDebugLevel$298$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$647$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$myNondetVar_0: int, inline$BDLGetDebugLevel$194$myNondetVar_0: int, inline$BDLGetDebugLevel$610$myNondetVar_0: int, inline$BDLGetDebugLevel$772$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLGetDebugLevel$178$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$622$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$42$: int, inline$IoGetCurrentIrpStackLocation$148$myVar_0: int, inline$IoGetCurrentIrpStackLocation$148$myVar_1: int, inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$536$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$30$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$16$$result.PoSetPowerState$1693.27$16$: int, inline$BDLCallDriverCompletionRoutine$15$myNondetVar_0: int, inline$BDLPnP$0$$result.BDLPnPStop$934.27$31$: int, inline$BDLGetDebugLevel$715$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp: int, inline$BDLPnPCancelRemove$0$$pBDLExtension$1$2316.40$BDLPnPCancelRemove$12_.1: int, inline$IoGetCurrentIrpStackLocation$51$myVar_0: int, inline$IoGetCurrentIrpStackLocation$51$myVar_1: int, inline$BDLDevicePowerIoCompletion$2$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$149$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$30$$callresult.$1687.68$15$: int, inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$549$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$779$myNondetVar_0: int, inline$BDLGetDebugLevel$168$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$311$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$419$myNondetVar_0: int, inline$BDLGetDebugLevel$651$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1358.0$20$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLCleanupDataHandles$1$$irql$6$3249.28$BDLCleanupDataHandles$4: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetNextIrpStackLocation$11$myVar_0: int, inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLGetDebugLevel$433$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLPnPCancelStop$0$$result.DbgPrint$2139.0$8$: int, inline$BDLGetDebugLevel$374$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$524$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$595$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$IoGetCurrentIrpStackLocation$58$myVar_0: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$55$: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$799$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$232$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$30$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1: int, inline$IoGetCurrentIrpStackLocation$28$myVar_1: int, inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$409$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$114$myVar_1: int, inline$IoGetCurrentIrpStackLocation$114$myVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$16$: int, inline$IoGetCurrentIrpStackLocation$58$havoc_stringTemp: int, inline$BDLGetDebugLevel$21$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$15$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$660$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1700.0$23$: int, inline$IoSetNextIrpStackLocation$15$myVar_0: int, inline$BDLGetDebugLevel$683$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$result.PoSetPowerState$1693.27$16$: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$14$: int, inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3178.0$17$: int, inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1700.0$23$: int, inline$storm_IoCallDriver$9$$status$4$462.11$storm_IoCallDriver$8: int, inline$IoSkipCurrentIrpStackLocation$0$myNondetVar_0: int, inline$BDLGetDebugLevel$64$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$13$: int, inline$storm_IoCompleteRequest$27$$result.storm_nondet$338.2$1$: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2323.0$8$: int, inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$storm_KeAcquireSpinLock$2$$result.storm_getThreadID$128.29$1$: int, inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$43$: int, inline$BDLDevicePowerIoCompletion$9$$callresult.$1687.68$15$: int, inline$BDLGetDebugLevel$673$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$282$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$storm_KeSetEvent$10$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$714$myNondetVar_0: int, inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLGetDebugLevel$299$myNondetVar_0: int, inline$BDLGetDebugLevel$380$myNondetVar_0: int, inline$BDLGetDebugLevel$774$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$97$myNondetVar_0: int, inline$storm_IoAllocateIrp$0$$malloc.arg.1$5$: int, inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$storm_KeClearEvent$0$$Event$1$236.14$storm_KeClearEvent$4: int, inline$BDLGetDebugLevel$322$myNondetVar_0: int, inline$BDLGetDebugLevel$202$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPQueryRemove$0$$result.DbgPrint$2263.0$3$: int, inline$BDLGetDebugLevel$197$myNondetVar_0: int, inline$storm_IoCompleteRequest$41$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLDevicePowerIoCompletion$22$$callresult.$1687.68$15$: int, inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1700.0$23$: int, inline$BDLDevicePowerIoCompletion$17$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$607$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$24$: int, inline$storm_IoCallDriver$14$$result.storm_nondet$472.22$4$: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLDevicePowerIoCompletion$9$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$44$: int, inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$531$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$118$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$12$: int, inline$BDLDevicePowerIoCompletion$15$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$2$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1344.0$9$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$50$: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$213$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$IoGetCurrentIrpStackLocation$36$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoSetNextIrpStackLocation$3$tempBoogie0: int, inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_KeWaitForSingleObject$116.38$5$: int, inline$BDLCallDriverCompletionRoutine$0$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$storm_KeReleaseSpinLock$1$$result.storm_getThreadID$145.0$1$: int, inline$BDLDevicePowerIoCompletion$20$$result.PoSetPowerState$1693.27$16$: int, inline$IoSetNextIrpStackLocation$12$tempBoogie0: int, inline$BDLDevicePowerIoCompletion$2$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$28$: int, inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$storm_IoCallDriver$9$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$3$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLReleaseHandleList$1$$pBDLExtension$1$145.40$BDLReleaseHandleList$8: int, inline$IoGetCurrentIrpStackLocation$129$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$20$: int, inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$IoSetNextIrpStackLocation$10$tempBoogie0: int, inline$BDLGetDebugLevel$287$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$22$myNondetVar_0: int, inline$storm_IoCompleteRequest$23$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1428.0$29$: int, inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$28$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLSystemPowerIoCompletion$17$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1358.0$15$: int, inline$BDLCleanupDataHandles$0$$result.DbgPrint$3308.0$32$: int, inline$BDLGetDebugLevel$767$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$604$myNondetVar_0: int, inline$BDLGetDebugLevel$223$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$753$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$780$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$52$myVar_1: int, inline$IoGetCurrentIrpStackLocation$52$myVar_0: int, inline$IoGetCurrentIrpStackLocation$71$myNondetVar_0: int, inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$752$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$22$: int, inline$storm_IoCompleteRequest$45$$result.storm_nondet$338.2$1$: int, inline$CallCompletionRoutine$8$$result.completionRoutine$448.30$3$: int, inline$BDLGetDebugLevel$485$$result.BDLGetDebugLevel$39.0$1$: int, inline$RemoveHeadList$0$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$500$myNondetVar_0: int, inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$24$: int, inline$storm_IoCompleteRequest$24$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$775$myNondetVar_0: int, inline$BDLGetDebugLevel$266$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1344.0$4$: int, inline$BDLCleanupDataHandles$0$$result.DbgPrint$3290.0$16$: int, inline$BDLDevicePowerIoCompletion$15$$result.memset$1683.8$14$: int, inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1358.0$15$: int, inline$IoGetCurrentIrpStackLocation$69$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLDevicePowerIoCompletion$1$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$27$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$652$myNondetVar_0: int, inline$BDLGetDebugLevel$110$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1358.0$20$: int, inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLDevicePowerIoCompletion$2$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$38$: int, inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$76$havoc_stringTemp: int, inline$BDLGetDebugLevel$685$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$61$myVar_1: int, inline$IoGetCurrentIrpStackLocation$61$myVar_0: int, inline$storm_IoCompleteRequest$42$$result.storm_nondet$338.2$1$: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$599$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$308$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$34$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$775$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$11$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$CallCompletionRoutine$17$$result.completionRoutine$448.30$3$: int, inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$25$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$12$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$15$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$417$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$3$: int, inline$IoGetCurrentIrpStackLocation$96$havoc_stringTemp: int, inline$BDLGetDebugLevel$273$myNondetVar_0: int, inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$8$: int, inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$636$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$125$myNondetVar_0: int, inline$CallCompletionRoutine$21$myNondetVar_0: int, inline$BDLGetDebugLevel$28$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$20$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$155$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLCallLowerLevelDriverAndWait$0$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8: int, inline$IoGetNextIrpStackLocation$4$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$13$: int, inline$storm_IoCompleteRequest$34$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$238$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$137$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1723.0$34$: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$138$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$252$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$60$: int, inline$BDLGetDebugLevel$776$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$190$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$803$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$65$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$23$myVar_1: int, inline$BDLGetDebugLevel$712$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$24$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$3$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$446$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$133$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$2$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$29$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$11$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3215.23$29$: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$712$myNondetVar_0: int, inline$BDLGetDebugLevel$717$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$18$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1358.0$20$: int, inline$BDLSystemPowerIoCompletion$4$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$6$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$128$havoc_stringTemp: int, inline$BDLGetDebugLevel$323$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$762$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$24$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$43$myVar_1: int, inline$IoGetCurrentIrpStackLocation$43$myVar_0: int, inline$BDLDevicePowerIoCompletion$12$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$storm_KeInitializeEvent$5$$State$3$205.13$storm_KeInitializeEvent$12_.1: int, inline$BDLGetDebugLevel$428$myNondetVar_0: int, inline$BDLGetDebugLevel$447$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$337$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$737$myNondetVar_0: int, inline$BDLGetDebugLevel$208$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$743$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$320$myNondetVar_0: int, inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$7$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$451$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLPnP$0$$pAttachedDeviceObject$6$862.36$BDLPnP$8: int, inline$storm_KeAcquireSpinLock$2$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1428.0$29$: int, inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$229$myNondetVar_0: int, inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1700.0$23$: int, inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$13$: int, inline$IoGetCurrentIrpStackLocation$100$myVar_0: int, inline$IoGetCurrentIrpStackLocation$100$myVar_1: int, inline$BDLCallDriverCompletionRoutine$2$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLCallDriverCompletionRoutine$15$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8: int, inline$BDLCallDriverCompletionRoutine$5$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$1$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$12$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$759$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLDevicePowerIoCompletion$12$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$591$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$15$: int, inline$BDLGetDebugLevel$505$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLDevicePowerIoCompletion$9$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$IoSkipCurrentIrpStackLocation$1$tempBoogie0: int, inline$BDLGetDebugLevel$716$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3144.23$13$: int, inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$91$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCompleteRequest$51$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$22$: int, inline$storm_KeWaitForSingleObject$5$$result.storm_KeWaitForSingleObject$243.0$1$: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$292$myNondetVar_0: int, inline$BDLGetDebugLevel$749$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$0$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1344.0$4$: int, inline$IoGetCurrentIrpStackLocation$84$myNondetVar_0: int, inline$BDLGetDebugLevel$250$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1440.0$40$: int, inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$66$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$551$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$35$myNondetVar_0: int, inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLSystemPowerIoCompletion$1$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3123.0$2$: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$6$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$103$myVar_1: int, inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$29$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$662$myNondetVar_0: int, inline$BDLGetDebugLevel$726$myNondetVar_0: int, inline$BDLGetDebugLevel$403$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$668$myNondetVar_0: int, inline$storm_PoCallDriver$0$$Irp$2$496.14$storm_PoCallDriver$8: int, inline$BDLSystemPowerIoCompletion$9$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$756$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$256$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$24$: int, inline$IoGetCurrentIrpStackLocation$73$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$24$: int, inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$29$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$122$myVar_0: int, inline$IoGetCurrentIrpStackLocation$122$myVar_1: int, inline$BDLDevicePowerIoCompletion$10$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$38$: int, inline$IoGetCurrentIrpStackLocation$13$myVar_0: int, inline$IoGetCurrentIrpStackLocation$13$myVar_1: int, inline$BDLGetDebugLevel$123$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$20$: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLCallDriverCompletionRoutine$9$myNondetVar_0: int, inline$storm_IoCallDriver$10$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$36$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$230$myNondetVar_0: int, inline$BDLGetDebugLevel$415$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$117$havoc_stringTemp: int, inline$BDLGetDebugLevel$787$myNondetVar_0: int, inline$BDLGetDebugLevel$74$myNondetVar_0: int, inline$BDLGetDebugLevel$672$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2536.0$3$: int, inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4_.1: int, inline$BDLGetDebugLevel$359$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$81$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IsListEmpty$1$$result.IsListEmpty$8096.0$1$: int, inline$BDLGetDebugLevel$502$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4: int, inline$IoGetCurrentIrpStackLocation$13$havoc_stringTemp: int, inline$BDLCallDriverCompletionRoutine$20$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1344.0$4$: int, inline$IoGetCurrentIrpStackLocation$5$myVar_1: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$58$: int, inline$BDLGetDebugLevel$105$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$688$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$109$havoc_stringTemp: int, inline$BDLGetDebugLevel$516$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$380$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$535$myNondetVar_0: int, inline$BDLGetDebugLevel$403$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$4$$status$5$438.11$CallCompletionRoutine$4: int, inline$CallCompletionRoutine$25$$result.completionRoutine$448.30$3$: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$135$myNondetVar_0: int, inline$BDLGetDebugLevel$620$myNondetVar_0: int, inline$BDLGetDebugLevel$247$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLGetDebugLevel$189$myNondetVar_0: int, inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IsListEmpty$4$$ListHead$1$8097.28$IsListEmpty$4: int, inline$BDLDevicePowerIoCompletion$5$$result.PoSetPowerState$1693.27$16$: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$22$: int, inline$BDLDevicePowerIoCompletion$8$$callresult.$1687.68$15$: int, inline$IoGetCurrentIrpStackLocation$148$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2353.0$32$: int, inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1700.0$18$: int, inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$6$: int, inline$BDLGetDebugLevel$399$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoCopyCurrentIrpStackLocationToNext$3$$result.memcpy$25110.4$3$: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$700$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$287$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$9$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1428.0$29$: int, inline$BDLDevicePowerIoCompletion$13$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$0$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$IoSetNextIrpStackLocation$1$tempBoogie0: int, inline$BDLGetDebugLevel$109$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$12$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$193$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$12$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$115$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp: int, inline$storm_IoCompleteRequest$0$$result.storm_nondet$338.2$1$: int, inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLDevicePowerIoCompletion$22$$result.memset$1683.8$14$: int, inline$BDLGetDebugLevel$4$myNondetVar_0: int, inline$BDLGetDebugLevel$664$myNondetVar_0: int, inline$BDLCallLowerLevelDriverAndWait$1$$result.BDLCallLowerLevelDriverAndWait$71.0$1$: int, inline$BDLGetDebugLevel$141$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$495$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$0$myVar_0: int, inline$BDLGetDebugLevel$18$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoCopyCurrentIrpStackLocationToNext$2$$result.memcpy$25110.4$3$: int, inline$BDLHandleRemove$1$$result.DbgPrint$2465.0$52$: int, inline$IoGetCurrentIrpStackLocation$14$myVar_1: int, inline$IoGetCurrentIrpStackLocation$14$myVar_0: int, inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$56$$result.storm_nondet$338.2$1$: int, inline$storm_IoCancelIrp$0$myVar_0: int, inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$26$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$94$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$579$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$callresult.$1687.68$15$: int, inline$BDLGetDebugLevel$499$myNondetVar_0: int, inline$storm_KeSetEvent$15$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$631$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$60$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$1$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$279$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$7$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12: int, inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$139$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLPnPSurpriseRemoval$0$$pBDLExtension$1$2529.40$BDLPnPSurpriseRemoval$12_.1: int, inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$595$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$callresult.$3172.84$15$: int, inline$BDLGetDebugLevel$275$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$2$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$14$: int, inline$storm_IoCallDriver$11$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLPnPStop$0$$result.DbgPrint$2190.0$3$: int, inline$IoGetCurrentIrpStackLocation$10$myVar_1: int, inline$BDLCallDriverCompletionRoutine$24$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$129$myVar_1: int, inline$IoGetCurrentIrpStackLocation$129$myVar_0: int, inline$IoGetCurrentIrpStackLocation$60$havoc_stringTemp: int, inline$BDLGetDebugLevel$227$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.BDLCallLowerLevelDriverAndWait$1975.43$13$: int, inline$IoGetCurrentIrpStackLocation$1$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$16$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$452$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16_.1: int, inline$BDLGetDebugLevel$224$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$347$myNondetVar_0: int, inline$BDLGetDebugLevel$150$myNondetVar_0: int, inline$BDLGetDebugLevel$510$myNondetVar_0: int, inline$BDLGetDebugLevel$369$myNondetVar_0: int, inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$21$$result.memset$1683.8$14$: int, inline$BDLGetDebugLevel$125$myNondetVar_0: int, inline$storm_IoCompleteRequest$28$$result.storm_nondet$338.2$1$: int, inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$74$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$233$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$19$: int, inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$201$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp: int, inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$547$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetNextIrpStackLocation$7$myNondetVar_0: int, inline$storm_IoCompleteRequest$10$$result.storm_nondet$338.2$1$: int, inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$3$: int, inline$IoGetCurrentIrpStackLocation$12$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2336.0$20$: int, inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnP$0$$result.question.16$: int, inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$151$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$5$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$17$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1: int, inline$BDLGetDebugLevel$580$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$6$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$457$myNondetVar_0: int, inline$CallCompletionRoutine$29$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$36$: int, inline$BDLDevicePowerIoCompletion$24$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$747$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$36$$result.storm_nondet$338.2$1$: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLDevicePowerIoCompletion$29$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$24$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$512$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$551$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$3$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$50$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2536.0$8$: int, inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$storm_KeInitializeEvent$5$$Event$1$203.14$storm_KeInitializeEvent$12_.1: int, inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$231$myNondetVar_0: int, inline$BDLGetDebugLevel$619$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$2$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLGetDebugLevel$211$myNondetVar_0: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$19$: int, inline$IoGetCurrentIrpStackLocation$54$myVar_1: int, inline$IoGetCurrentIrpStackLocation$54$myVar_0: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1723.0$29$: int, inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$3$: int, inline$IoGetCurrentIrpStackLocation$64$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$226$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$5$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$146$myNondetVar_0: int, inline$BDLGetDebugLevel$321$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnP$0$$status$3$859.36$BDLPnP$8: int, inline$BDLGetDebugLevel$791$myNondetVar_0: int, inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetNextIrpStackLocation$9$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$1$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$2$$result.BDLCallLowerLevelDriverAndWait$71.0$1$: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$596$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$51$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$111$myVar_0: int, inline$IoGetCurrentIrpStackLocation$111$myVar_1: int, inline$BDLDevicePowerIoCompletion$0$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoSetNextIrpStackLocation$11$tempBoogie0: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1344.0$9$: int, inline$IoGetCurrentIrpStackLocation$52$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$36$: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$1$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$237$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$17$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$CallCompletionRoutine$23$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$107$myVar_1: int, inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$41$: int, inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1700.0$23$: int, inline$CallCompletionRoutine$30$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$2$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$13$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLCallDriverCompletionRoutine$30$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$7$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$8$: int, inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$582$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$5$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$364$myNondetVar_0: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$7$: int, inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$28$: int, inline$BDLGetDebugLevel$371$myNondetVar_0: int, inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$28$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$4$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$storm_KeInitializeEvent$1$$Event$1$203.14$storm_KeInitializeEvent$12: int, inline$storm_IoCallDriver$6$$result.storm_nondet$465.2$2$: int, inline$BDLPnP$0$$result.IoAcquireRemoveLockEx$879.0$14$: int, inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1: int, inline$CallCompletionRoutine$3$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$28$$result.PoSetPowerState$1693.27$16$: int, inline$storm_KeInitializeEvent$2$$Event$1$203.14$storm_KeInitializeEvent$12_.1: int, inline$CallCompletionRoutine$4$$context$2$435.8$CallCompletionRoutine$4: int, inline$IoSetNextIrpStackLocation$15$tempBoogie0: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$39$: int, inline$IoGetCurrentIrpStackLocation$23$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp: int, inline$CallCompletionRoutine$16$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLPnPQueryRemove$0$$result.DbgPrint$2303.0$27$: int, inline$storm_IoSetCompletionRoutine$1$$result.storm_nondet$405.2$1$: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$33$: int, inline$BDLGetDebugLevel$723$myNondetVar_0: int, inline$BDLGetDebugLevel$414$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1723.0$34$: int, inline$IoGetCurrentIrpStackLocation$88$myVar_0: int, inline$IoGetCurrentIrpStackLocation$88$myVar_1: int, inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$174$myNondetVar_0: int, inline$BDLGetDebugLevel$415$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$562$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$533$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$16$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$710$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$27$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$13$: int, inline$IoGetCurrentIrpStackLocation$115$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$50$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$3$: int, inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$17$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$494$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$122$havoc_stringTemp: int, inline$BDLCleanupNotificationStruct$1$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4: int, inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_KeReleaseSpinLock$4$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$CallCompletionRoutine$14$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$19$: int, inline$CallCompletionRoutine$15$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLPnPRemove$0$$pAttachedDeviceObject$3$2480.40$BDLPnPRemove$16_.1: int, inline$BDLGetDebugLevel$436$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$30$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$98$myNondetVar_0: int, inline$BDLGetDebugLevel$634$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoSetNextIrpStackLocation$11$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$15$myVar_0: int, inline$IoGetCurrentIrpStackLocation$15$myVar_1: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLHandleRemove$0$myNondetVar_0: int, inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$28$: int, inline$IoGetCurrentIrpStackLocation$91$havoc_stringTemp: int, inline$BDLGetFirstHandle$0$$result.BDLGetFirstHandle$276.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$41$: int, inline$BDLSystemPowerIoCompletion$1$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$509$myNondetVar_0: int, inline$BDLGetDebugLevel$278$myNondetVar_0: int, inline$BDLGetDebugLevel$489$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$12$$callresult.$1687.68$15$: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$22$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$27$: int, inline$IoGetCurrentIrpStackLocation$146$myVar_1: int, inline$BDLDevicePowerIoCompletion$17$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$110$myNondetVar_0: int, inline$BDLGetDebugLevel$773$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1665.0$9$: int, inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1723.0$29$: int, inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$89$myVar_0: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLDevicePowerIoCompletion$26$myNondetVar_0: int, inline$BDLLockHandleList$0$myNondetVar_0: int, inline$BDLLockHandleList$0$myNondetVar_1: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$140$myNondetVar_0: int, inline$BDLGetDebugLevel$609$myNondetVar_0: int, inline$BDLGetDebugLevel$728$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetCurrentIrpStackLocation$97$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$351$myNondetVar_0: int, inline$CallCompletionRoutine$8$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1665.0$9$: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2336.0$15$: int, inline$BDLGetDebugLevel$18$myNondetVar_0: int, inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$574$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1428.0$29$: int, inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$435$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$126$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$RemoveHeadList$2$$Entry$3$8126.16$RemoveHeadList$4: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$13$: int, inline$IoGetNextIrpStackLocation$11$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$59$myNondetVar_0: int, inline$BDLGetDebugLevel$788$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1358.0$20$: int, inline$BDLSystemPowerIoCompletion$24$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$476$myNondetVar_0: int, inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$8$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$8$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$108$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1700.0$18$: int, inline$IoGetCurrentIrpStackLocation$92$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$682$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$458$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1358.0$20$: int, inline$CallCompletionRoutine$28$$result.completionRoutine$448.30$3$: int, inline$RemoveHeadList$5$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$3$$result.storm_KeWaitForSingleObject$243.0$1$: int, inline$BDLGetDebugLevel$179$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$24$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetNextIrpStackLocation$5$havoc_stringTemp: int, inline$storm_IoCancelIrp$0$$result.storm_nondet$360.4$2$: int, inline$BDLGetDebugLevel$107$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1440.0$45$: int, inline$IoGetCurrentIrpStackLocation$100$myNondetVar_0: int, inline$BDLGetDebugLevel$27$myNondetVar_0: int, inline$BDLGetDebugLevel$609$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLGetDebugLevel$588$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLCallDriverCompletionRoutine$1$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$3$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$7$: int, inline$BDLGetDebugLevel$62$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$127$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$3$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLCleanupNotificationStruct$0$$result.KfRaiseIrql$3141.8$12$: int, inline$BDLDevicePowerIoCompletion$18$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$44$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1723.0$29$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$56$: int, inline$storm_KeInitializeEvent$3$$Event$1$203.14$storm_KeInitializeEvent$12_.1: int, inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$260$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1440.0$45$: int, inline$storm_KeInitializeEvent$4$$State$3$205.13$storm_KeInitializeEvent$12: int, inline$storm_IoCallDriver$0$$result.storm_nondet$465.2$2$: int, inline$IoGetCurrentIrpStackLocation$80$myNondetVar_0: int, inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$516$myNondetVar_0: int, inline$BDLGetDebugLevel$302$myNondetVar_0: int, inline$BDLGetDebugLevel$754$myNondetVar_0: int, inline$storm_KeSetEvent$19$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$12$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$276$myNondetVar_0: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$12$: int, inline$BDLSystemPowerIoCompletion$0$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$storm_IoSetCompletionRoutine$0$$result.storm_nondet$405.2$1$: int, inline$BDLGetDebugLevel$105$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1665.0$4$: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1428.0$29$: int, inline$storm_KeSetEvent$18$$Event$1$213.14$storm_KeSetEvent$12: int, inline$CallCompletionRoutine$19$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$2$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$355$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$190$myNondetVar_0: int, inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$10$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$312$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$697$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$3$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1428.0$29$: int, inline$BDLCleanupNotificationStruct$1$$bddiRegisterNotifyParams$10$3120.36$BDLCleanupNotificationStruct$4: int, inline$IoGetCurrentIrpStackLocation$80$myVar_1: int, inline$BDLDevicePowerIoCompletion$25$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$4$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$142$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$39$: int, inline$storm_KeSetEvent$9$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$IoSetNextIrpStackLocation$11$myVar_0: int, inline$BDLDevicePowerIoCompletion$27$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$425$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$23$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$604$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$510$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$21$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$3$: int, inline$IoGetCurrentIrpStackLocation$141$myVar_1: int, inline$IoGetCurrentIrpStackLocation$141$myVar_0: int, inline$BDLGetDebugLevel$733$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1440.0$40$: int, inline$BDLCallDriverCompletionRoutine$22$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$28$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$48$myNondetVar_0: int, inline$BDLGetDebugLevel$564$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$411$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$142$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$353$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$180$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$CallCompletionRoutine$1$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$374$myNondetVar_0: int, inline$BDLGetDebugLevel$637$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$756$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$440$myNondetVar_0: int, inline$BDLGetDebugLevel$143$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$166$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLCallDriverCompletionRoutine$11$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$782$myNondetVar_0: int, inline$BDLGetDebugLevel$455$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$31$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$124$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$656$myNondetVar_0: int, inline$storm_IoCompleteRequest$21$$result.storm_nondet$338.2$1$: int, inline$BDLPnPCancelStop$0$$result.DbgPrint$2169.0$27$: int, inline$storm_IoCallDriver$11$$result.storm_nondet$472.22$4$: int, inline$BDLPnPQueryStop$0$$status$4$2081.16$BDLPnPQueryStop$12: int, inline$BDLGetDebugLevel$348$myNondetVar_0: int, inline$IoCopyCurrentIrpStackLocationToNext$1$$result.memcpy$25110.4$3$: int, inline$BDLGetDebugLevel$503$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$317$myNondetVar_0: int, inline$storm_IoCallDriver$4$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$494$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnP$0$$result.DbgPrint$886.0$23$: int, inline$IoGetCurrentIrpStackLocation$53$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$11$myNondetVar_0: int, inline$BDLGetDebugLevel$602$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$23$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$116$havoc_stringTemp: int, inline$BDLPnPRemove$0$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp: int, inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$481$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$7$: int, inline$storm_IoCompleteRequest$47$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$255$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$2$: int, inline$BDLGetDebugLevel$669$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$4$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$24$: int, inline$CallCompletionRoutine$3$$context$2$435.8$CallCompletionRoutine$4: int, inline$storm_PoCallDriver$3$$result.storm_PoCallDriver$494.0$1$: int, inline$CallCompletionRoutine$11$myNondetVar_0: int, inline$RemoveHeadList$2$$result.RemoveHeadList$8121.0$1$: int, inline$BDLGetDebugLevel$364$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$11$myNondetVar_0: int, inline$BDLGetDebugLevel$768$myNondetVar_0: int, inline$BDLGetDebugLevel$556$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1723.0$34$: int, inline$BDLDevicePowerIoCompletion$16$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$43$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$26$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$538$myNondetVar_0: int, inline$BDLGetDebugLevel$666$myNondetVar_0: int, inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$IoGetNextIrpStackLocation$3$myNondetVar_0: int, inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_IoCallDriver$108.29$4$: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$33$: int, inline$storm_KeSetEvent$7$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$IoGetNextIrpStackLocation$7$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1700.0$18$: int, inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$BDLPnPQueryRemove$0$$pBDLExtension$1$2256.40$BDLPnPQueryRemove$12: int, inline$IoGetCurrentIrpStackLocation$108$myNondetVar_0: int, inline$BDLGetDebugLevel$17$myNondetVar_0: int, inline$CallCompletionRoutine$22$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLCallDriverCompletionRoutine$27$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$7$myNondetVar_0: int, inline$BDLGetDebugLevel$311$myNondetVar_0: int, inline$storm_KeSetEvent$34$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$430$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$10$havoc_stringTemp: int, inline$BDLGetDebugLevel$584$myNondetVar_0: int, inline$BDLPnPStop$0$$result.DbgPrint$2208.0$21$: int, inline$CallCompletionRoutine$7$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLGetDebugLevel$394$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$14$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$CallCompletionRoutine$26$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$129$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$517$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$30$havoc_stringTemp: int, inline$BDLPnP$0$$result.BDLPnPCancelRemove$952.35$33$: int, inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$329$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$130$myNondetVar_0: int, inline$BDLGetDebugLevel$709$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$275$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeInitializeSpinLock$1$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4: int, inline$BDLDevicePowerIoCompletion$2$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$49$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$6$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1: int, inline$BDLGetDebugLevel$780$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$187$myNondetVar_0: int, inline$BDLPnPStop$0$$pIrp$3$2184.40$BDLPnPStop$12_.1: int, inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0: int, inline$storm_KeInitializeEvent$2$$Event$1$203.14$storm_KeInitializeEvent$12: int, inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp: int, inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$614$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoGetCurrentIrpStackLocation$41$myVar_1: int, inline$IoGetCurrentIrpStackLocation$41$myVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$3$: int, inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$686$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$59$havoc_stringTemp: int, inline$BDLGetDebugLevel$170$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$63$$result.storm_nondet$338.2$1$: int, inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8_.1: int, inline$BDLGetDebugLevel$774$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$412$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$105$myVar_1: int, inline$IoGetCurrentIrpStackLocation$105$myVar_0: int, inline$BDLCallDriverCompletionRoutine$13$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$8$: int, inline$storm_IoCallDriver$6$$result.storm_IoCallDriver$456.0$1$: int, inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$73$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$552$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$701$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$52$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$587$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLPnP$0$$result.BDLPnPCancelStop$925.33$30$: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$IoGetCurrentIrpStackLocation$105$myNondetVar_0: int, inline$storm_KeAcquireSpinLock$3$$result.storm_getThreadID$128.29$1$: int, inline$storm_KeSetEvent$32$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_PoCallDriver$104.29$3$: int, inline$BDLGetDebugLevel$472$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$396$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$63$myVar_1: int, inline$IoGetCurrentIrpStackLocation$63$myVar_0: int, inline$BDLGetDebugLevel$428$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$1$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$7$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$342$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$0$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$639$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$23$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$323$myNondetVar_0: int, inline$BDLGetDebugLevel$296$myNondetVar_0: int, inline$BDLGetDebugLevel$300$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4_.1: int, inline$BDLDevicePowerIoCompletion$6$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$303$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$93$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$115$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$220$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$26$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLDevicePowerIoCompletion$6$$callresult.$1687.68$15$: int, inline$BDLPnPCancelRemove$0$$pIrp$3$2318.40$BDLPnPCancelRemove$12: int, inline$BDLGetDebugLevel$158$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$74$myVar_0: int, inline$BDLGetDebugLevel$322$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$451$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$16$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$25$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$81$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$26$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$120$myVar_0: int, inline$IoGetCurrentIrpStackLocation$120$myVar_1: int, inline$BDLGetDebugLevel$619$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLPnPQueryRemove$0$$pIrp$3$2258.40$BDLPnPQueryRemove$12: int, inline$storm_KeAcquireSpinLock$1$$tid$3$128.6$storm_KeAcquireSpinLock$8: int, inline$BDLGetDebugLevel$782$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$623$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$39$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$168$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$49$: int, inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$storm_KeWaitForSingleObject$1$$result.storm_KeWaitForSingleObject$243.0$1$: int, inline$BDLGetDebugLevel$101$myNondetVar_0: int, inline$storm_IoCompleteRequest$1$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$42$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$36$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLSystemPowerIoCompletion$22$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$3$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$147$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$139$myVar_0: int, inline$IoGetCurrentIrpStackLocation$139$myVar_1: int, inline$IoGetNextIrpStackLocation$8$havoc_stringTemp: int, inline$BDLGetDebugLevel$640$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$212$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$93$myVar_0: int, inline$IoGetCurrentIrpStackLocation$93$myVar_1: int, inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoSetNextIrpStackLocation$15$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$8$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$192$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$7$: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1440.0$40$: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLCleanupNotificationStruct$0$$irql$3$3113.45$BDLCleanupNotificationStruct$4: int, inline$BDLDevicePowerIoCompletion$8$myNondetVar_0: int, inline$BDLGetDebugLevel$734$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$18$$result.completionRoutine$448.30$3$: int, inline$BDLCleanupNotificationStruct$1$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$56$: int, inline$BDLGetDebugLevel$438$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$28$: int, inline$IoGetCurrentIrpStackLocation$6$myNondetVar_0: int, inline$storm_KeSetEvent$11$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$731$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$340$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$185$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$368$myNondetVar_0: int, inline$BDLGetDebugLevel$345$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStop$0$$pBDLExtension$1$2182.40$BDLPnPStop$12: int, inline$BDLGetDebugLevel$34$myNondetVar_0: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$45$: int, inline$RemoveHeadList$3$$result.RemoveHeadList$8121.0$1$: int, inline$BDLGetDebugLevel$461$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$29$myNondetVar_0: int, inline$BDLGetDebugLevel$481$myNondetVar_0: int, inline$BDLGetDebugLevel$339$myNondetVar_0: int, inline$BDLGetDebugLevel$488$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$246$myNondetVar_0: int, inline$BDLGetDebugLevel$400$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$10$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2549.0$20$: int, inline$IoGetNextIrpStackLocation$12$havoc_stringTemp: int, inline$BDLCleanupDataHandles$1$$result.BDLGetFirstHandle$3264.27$12$: int, inline$IoGetCurrentIrpStackLocation$3$havoc_stringTemp: int, inline$storm_IoCompleteRequest$5$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_KeReleaseSpinLock$7$$result.storm_getThreadID$145.0$1$: int, inline$BDLGetDebugLevel$20$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$124$havoc_stringTemp: int, inline$IoSetNextIrpStackLocation$2$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$3$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$665$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$2$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$11$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$44$myNondetVar_0: int, inline$storm_KeInitializeEvent$4$$Event$1$203.14$storm_KeInitializeEvent$12: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$24$: int, inline$IoSetNextIrpStackLocation$6$myVar_0: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$24$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCleanupDataHandles$1$$bddiCloseHandleParams$5$3248.28$BDLCleanupDataHandles$4: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$44$: int, inline$IoGetCurrentIrpStackLocation$83$myVar_1: int, inline$IoGetCurrentIrpStackLocation$83$myVar_0: int, inline$CallCompletionRoutine$19$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1428.0$29$: int, inline$BDLCallDriverCompletionRoutine$6$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLPnPStop$0$$result.DbgPrint$2243.0$39$: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1440.0$40$: int, inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$136$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$29$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$33$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$519$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$152$myVar_1: int, inline$IoGetCurrentIrpStackLocation$152$myVar_0: int, inline$BDLGetDebugLevel$698$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$14$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$7$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$25$myNondetVar_0: int, inline$BDLGetDebugLevel$435$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$518$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$25$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$89$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLDevicePowerIoCompletion$16$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$21$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$279$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1723.0$34$: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$70$myNondetVar_0: int, inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$597$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$35$myVar_0: int, inline$IoGetCurrentIrpStackLocation$35$myVar_1: int, inline$BDLGetDebugLevel$611$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1440.0$45$: int, inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$125$myVar_1: int, inline$IoGetCurrentIrpStackLocation$125$myVar_0: int, inline$BDLGetDebugLevel$281$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$427$$result.BDLGetDebugLevel$39.0$1$: int, inline$IsListEmpty$0$$ListHead$1$8097.28$IsListEmpty$4: int, inline$BDLDevicePowerIoCompletion$30$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$9$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$103$myVar_0: int, inline$BDLCallDriverCompletionRoutine$21$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8: int, inline$storm_PoCallDriver$4$$Irp$2$496.14$storm_PoCallDriver$8_.1: int, inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$771$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1358.0$15$: int, inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$272$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$0$myNondetVar_0: int, inline$BDLGetDebugLevel$692$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$42$havoc_stringTemp: int, inline$BDLGetDebugLevel$550$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$11$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$747$myNondetVar_0: int, inline$BDLGetDebugLevel$259$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$21$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1344.0$9$: int, inline$IoGetCurrentIrpStackLocation$16$myVar_1: int, inline$IoGetCurrentIrpStackLocation$16$myVar_0: int, inline$BDLDevicePowerIoCompletion$19$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$24$: int, inline$IoGetCurrentIrpStackLocation$37$havoc_stringTemp: int, inline$BDLGetDebugLevel$25$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$31$: int, inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$430$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_KeWaitForSingleObject$3$$result.storm_nondet$256.20$2$: int, inline$IoGetCurrentIrpStackLocation$103$myNondetVar_0: int, inline$BDLGetDebugLevel$378$myNondetVar_0: int, inline$BDLGetDebugLevel$202$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$43$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$26$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1344.0$9$: int, inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$19$: int, inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$33$: int, inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLCallDriverCompletionRoutine$28$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLGetDebugLevel$127$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$233$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1358.0$20$: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$223$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$175$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1700.0$18$: int, inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$24$: int, inline$BDLGetDebugLevel$163$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$662$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$2$: int, inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$105$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$26$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$55$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$57$myVar_1: int, inline$BDLSystemPowerIoCompletion$5$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPQueryRemove$0$$pBDLExtension$1$2256.40$BDLPnPQueryRemove$12_.1: int, inline$BDLPnPSurpriseRemoval$0$$status$4$2534.16$BDLPnPSurpriseRemoval$12: int, inline$BDLGetDebugLevel$384$myNondetVar_0: int, inline$BDLPnP$0$$result.BDLPnPRemove$961.29$34$: int, inline$BDLGetDebugLevel$69$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_KeSetEvent$33$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$678$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$9$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$193$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$632$myNondetVar_0: int, inline$BDLGetDebugLevel$445$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$17$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$174$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$3$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$183$myNondetVar_0: int, inline$BDLGetDebugLevel$196$myNondetVar_0: int, inline$BDLGetDebugLevel$117$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoSkipCurrentIrpStackLocation$1$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1440.0$40$: int, inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$12$: int, inline$BDLDevicePowerIoCompletion$25$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$751$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$208$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoSetCompletionRoutine$3$$result.storm_nondet$405.2$1$: int, inline$BDLPnPStop$0$$result.DbgPrint$2231.0$33$: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1358.0$15$: int, inline$BDLPnP$0$$result.DbgPrint$865.0$3$: int, inline$BDLCleanupDataHandles$1$$bddDataHandle$4$3247.28$BDLCleanupDataHandles$4: int, inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$786$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$44$myVar_0: int, inline$IoGetCurrentIrpStackLocation$44$myVar_1: int, inline$BDLGetDebugLevel$629$myNondetVar_0: int, inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12_.1: int, inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$96$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$258$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$50$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$13$$result.PoSetPowerState$1693.27$16$: int, inline$BDLSystemPowerIoCompletion$6$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_PoCallDriver$3$$result.storm_IoCallDriver$499.27$2$: int, inline$BDLGetDebugLevel$338$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$26$: int, inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1723.0$29$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$28$: int, inline$BDLCallDriverCompletionRoutine$28$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$10$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1358.0$20$: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1440.0$40$: int, inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1665.0$4$: int, inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8: int, inline$BDLGetDebugLevel$507$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$131$myVar_0: int, inline$IoGetCurrentIrpStackLocation$131$myVar_1: int, inline$storm_KeSetEvent$6$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLSystemPowerIoCompletion$23$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$22$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$72$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$10$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCleanupDataHandles$0$$bddDataHandle$4$3247.28$BDLCleanupDataHandles$4: int, inline$BDLGetDebugLevel$7$myNondetVar_0: int, inline$BDLGetDebugLevel$792$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$447$myNondetVar_0: int, inline$BDLPnPStart$0$$result.memset$1992.4$25$: int, inline$CallCompletionRoutine$30$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$261$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$608$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$1$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$252$myNondetVar_0: int, inline$BDLGetDebugLevel$769$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$20$: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLGetDebugLevel$553$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$727$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$71$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$40$myVar_0: int, inline$IoGetCurrentIrpStackLocation$40$myVar_1: int, inline$BDLGetDebugLevel$253$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$249$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$10$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$124$myNondetVar_0: int, inline$BDLGetDebugLevel$209$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$470$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$95$havoc_stringTemp: int, inline$BDLCallDriverCompletionRoutine$16$myNondetVar_0: int, inline$BDLGetDebugLevel$478$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$2$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$143$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$772$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$42$: int, inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4: int, inline$BDLDevicePowerIoCompletion$26$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1428.0$29$: int, inline$BDLSystemPowerIoCompletion$11$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$13$: int, inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20: int, inline$BDLGetDebugLevel$758$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$433$myNondetVar_0: int, inline$storm_IoCallDriver$1$$status$4$462.11$storm_IoCallDriver$8: int, inline$CallCompletionRoutine$20$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$266$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1665.0$4$: int, inline$storm_IoCallDriver$7$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLGetDebugLevel$151$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$784$myNondetVar_0: int, inline$BDLGetDebugLevel$422$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$callresult.$1687.68$15$: int, inline$BDLCallDriverCompletionRoutine$6$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$64$myVar_0: int, inline$IoGetCurrentIrpStackLocation$64$myVar_1: int, inline$BDLSystemPowerIoCompletion$17$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$480$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLGetDebugLevel$111$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$28$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$566$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$350$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1700.0$23$: int, inline$IoGetCurrentIrpStackLocation$25$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1358.0$20$: int, inline$BDLCallDriverCompletionRoutine$22$myNondetVar_0: int, inline$BDLGetDebugLevel$40$myNondetVar_0: int, inline$storm_IoCompleteRequest$26$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$35$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoGetCurrentIrpStackLocation$42$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$6$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$IoCopyCurrentIrpStackLocationToNext$5$$result.memcpy$25110.4$3$: int, inline$BDLGetDebugLevel$286$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$15$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$16$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$17$myVar_0: int, inline$IoGetCurrentIrpStackLocation$17$myVar_1: int, inline$storm_KeWaitForSingleObject$5$$result.storm_nondet$256.20$2$: int, inline$BDLGetDebugLevel$90$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$138$myVar_1: int, inline$IoGetCurrentIrpStackLocation$138$myVar_0: int, inline$IoGetCurrentIrpStackLocation$127$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$754$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$21$: int, inline$BDLGetDebugLevel$498$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$0$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$27$: int, inline$storm_KeReleaseSpinLock$2$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$BDLGetDebugLevel$158$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$385$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$140$havoc_stringTemp: int, inline$BDLPnPCancelRemove$0$$result.BDLCallLowerLevelDriverAndWait$2332.43$13$: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLPnPRemove$0$$result.DbgPrint$2516.0$15$: int, inline$IoSetNextIrpStackLocation$5$myVar_0: int, inline$BDLGetDebugLevel$697$myNondetVar_0: int, inline$storm_IoCallDriver$4$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLSystemPowerIoCompletion$9$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$347$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$99$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$86$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$90$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$74$havoc_stringTemp: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$17$: int, inline$IoGetCurrentIrpStackLocation$89$havoc_stringTemp: int, inline$BDLGetDebugLevel$116$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$13$: int, inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$254$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$783$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$713$myNondetVar_0: int, inline$CallCompletionRoutine$19$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$188$myNondetVar_0: int, inline$BDLGetDebugLevel$330$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4: int, inline$BDLPnPQueryStop$0$$result.BDLCallLowerLevelDriverAndWait$2116.47$13$: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1344.0$4$: int, inline$IoGetCurrentIrpStackLocation$139$havoc_stringTemp: int, inline$BDLGetDebugLevel$0$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$781$$result.BDLGetDebugLevel$39.0$1$: int, $result.storm_IoAllocateIrp$100.0$1$: int, inline$BDLGetDebugLevel$683$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$680$myNondetVar_0: int, inline$CallCompletionRoutine$9$$result.completionRoutine$448.30$3$: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$21$: int, inline$BDLDevicePowerIoCompletion$15$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$25$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$195$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$198$myNondetVar_0: int, inline$BDLGetDebugLevel$492$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.RemoveHeadList$3153.26$14$: int, inline$IoGetCurrentIrpStackLocation$66$havoc_stringTemp: int, inline$BDLPnPRemove$0$$result.DbgPrint$2486.0$8$: int, inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$14$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$storm_KeAcquireSpinLock$2$$tid$3$128.6$storm_KeAcquireSpinLock$8: int, inline$BDLGetDebugLevel$189$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLGetDebugLevel$218$myNondetVar_0: int, inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp: int, inline$BDLGetDebugLevel$437$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3231.0$32$: int, inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1700.0$18$: int, inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$153$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$28$: int, inline$storm_IoCallDriver$10$$result.storm_IoCallDriver$456.0$1$: int, inline$storm_IoCallDriver$7$$result.storm_nondet$465.2$2$: int, inline$BDLGetDebugLevel$211$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$108$myVar_0: int, inline$IoGetCurrentIrpStackLocation$108$myVar_1: int, inline$BDLGetDebugLevel$424$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$325$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1344.0$4$: int, inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$2$: int, inline$storm_KeInitializeSpinLock$0$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4: int, inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$568$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3178.0$22$: int, inline$IoSetNextIrpStackLocation$12$myVar_0: int, inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$548$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$649$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$1$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$96$myNondetVar_0: int, inline$BDLGetDebugLevel$414$myNondetVar_0: int, inline$BDLGetDebugLevel$95$myNondetVar_0: int, inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$673$myNondetVar_0: int, inline$storm_KeSetEvent$26$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$553$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$result.DbgPrint$3251.0$7$: int, inline$BDLGetDebugLevel$732$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$294$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLCallLowerLevelDriverAndWait$5$$result.BDLCallLowerLevelDriverAndWait$71.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$222$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$150$myNondetVar_0: int, inline$BDLGetDebugLevel$112$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$7$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$21$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$$result.DbgPrint$3290.0$16$: int, inline$BDLGetDebugLevel$344$myNondetVar_0: int, inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$7$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp: int, inline$BDLGetDebugLevel$307$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1723.0$34$: int, inline$BDLRemoveHandleFromList$0$myNondetVar_1: int, inline$BDLRemoveHandleFromList$0$myNondetVar_0: int, inline$BDLGetDebugLevel$578$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$748$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3215.23$29$: int, inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4: int, inline$IoGetCurrentIrpStackLocation$131$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$534$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$450$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$5$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$32$: int, inline$BDLHandleRemove$1$$result.DbgPrint$2386.0$8$: int, inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$BDLPnPCancelStop$0$$result.DbgPrint$2152.0$20$: int, inline$BDLGetDebugLevel$766$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$CallCompletionRoutine$20$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1428.0$34$: int, inline$storm_KeSetEvent$26$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$768$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$659$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$19$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$719$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1700.0$23$: int, inline$BDLGetDebugLevel$509$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1: int, inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$763$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$626$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$257$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1344.0$9$: int, inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$31$: int, inline$BDLGetDebugLevel$671$myNondetVar_0: int, inline$BDLGetDebugLevel$786$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$5$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$BDLGetDebugLevel$371$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$131$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$22$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$528$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$61$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$793$myNondetVar_0: int, inline$BDLGetDebugLevel$453$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_PoCallDriver$2$$Irp$2$496.14$storm_PoCallDriver$8_.1: int, inline$BDLGetDebugLevel$538$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$308$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$22$: int, inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$477$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$502$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3123.0$2$: int, inline$IoGetCurrentIrpStackLocation$33$myVar_0: int, inline$IoGetCurrentIrpStackLocation$33$myVar_1: int, inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1: int, inline$BDLGetDebugLevel$668$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLCallDriverCompletionRoutine$25$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$472$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$4$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$28$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$14$: int, inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$243$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$15$myNondetVar_0: int, inline$BDLGetDebugLevel$240$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$582$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$482$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$15$: int, inline$BDLDevicePowerIoCompletion$3$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$404$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$634$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1440.0$40$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$8$: int, inline$IoGetCurrentIrpStackLocation$63$havoc_stringTemp: int, inline$storm_PoCallDriver$3$$Irp$2$496.14$storm_PoCallDriver$8_.1: int, inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4_.1: int, inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$666$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeAcquireSpinLock$4$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8: int, inline$BDLDevicePowerIoCompletion$20$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLPnPStart$0$$result.DbgPrint$2037.0$43$: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$742$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1358.0$20$: int, inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$8$$result.memset$1683.8$14$: int, inline$IsListEmpty$1$$ListHead$1$8097.28$IsListEmpty$4: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$3$: int, inline$IoGetCurrentIrpStackLocation$87$havoc_stringTemp: int, inline$BDLHandleRemove$0$$result.DbgPrint$2465.0$57$: int, inline$BDLGetDebugLevel$130$myNondetVar_0: int, inline$BDLGetDebugLevel$62$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$23$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLCallDriverCompletionRoutine$19$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1700.0$23$: int, inline$IsListEmpty$4$myNondetVar_0: int, inline$BDLGetDebugLevel$417$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$246$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$236$myNondetVar_0: int, inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_PoCallDriver$104.29$3$: int, inline$BDLSystemPowerIoCompletion$15$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPQueryRemove$0$$result.BDLPnPQueryRemove$2254.0$1$: int, inline$BDLDevicePowerIoCompletion$16$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$441$myNondetVar_0: int, inline$storm_KeSetEvent$25$$Event$1$213.14$storm_KeSetEvent$12: int, inline$IsListEmpty$2$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$104$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLGetDebugLevel$639$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1: int, inline$IoGetCurrentIrpStackLocation$107$myVar_0: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$184$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$$result.DbgPrint$3251.0$7$: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$224$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLSystemPowerIoCompletion$12$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1: int, inline$IoGetCurrentIrpStackLocation$48$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoSkipCurrentIrpStackLocation$2$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$27$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$27$: int, inline$storm_IoAllocateIrp$0$$result.storm_IoAllocateIrp$270.0$1$: int, inline$BDLGetDebugLevel$39$myNondetVar_0: int, inline$RemoveHeadList$2$myNondetVar_0: int, inline$BDLGetDebugLevel$373$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$14$: int, inline$BDLGetDebugLevel$332$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$23$$callresult.$1687.68$15$: int, inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$679$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$25$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$21$myNondetVar_0: int, inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetCurrentIrpStackLocation$69$myVar_0: int, inline$IoGetCurrentIrpStackLocation$2$myNondetVar_0: int, inline$BDLPnPRemove$0$$pDeviceObject$2$2479.40$BDLPnPRemove$16: int, inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4: int, inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$620$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$486$myNondetVar_0: int, inline$BDLGetDebugLevel$460$myNondetVar_0: int, inline$BDLPnP$0$$result.DbgPrint$865.0$8$: int, inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24: int, inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$714$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$734$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$151$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$145$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$401$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$704$myNondetVar_0: int, inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp: int, inline$BDLGetDebugLevel$442$myNondetVar_0: int, inline$BDLGetDebugLevel$432$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1700.0$23$: int, inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$CallCompletionRoutine$0$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$236$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$1$myNondetVar_0: int, inline$BDLGetDebugLevel$375$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$39$: int, inline$IoGetCurrentIrpStackLocation$41$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoSkipCurrentIrpStackLocation$2$myNondetVar_0: int, inline$BDLGetDebugLevel$717$myNondetVar_0: int, inline$BDLGetDebugLevel$346$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$38$: int, inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20: int, inline$BDLSystemPowerIoCompletion$17$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$13$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$207$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$116$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$70$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$13$: int, inline$CallCompletionRoutine$5$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLCallDriverCompletionRoutine$11$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLDevicePowerIoCompletion$13$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$storm_KeWaitForSingleObject$4$$result.storm_nondet$256.20$2$: int, inline$storm_IoCallDriver$12$$status$4$462.11$storm_IoCallDriver$8: int, inline$IoGetCurrentIrpStackLocation$141$havoc_stringTemp: int, inline$BDLPnPRemove$0$$pDeviceObject$2$2479.40$BDLPnPRemove$16_.1: int, inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1723.0$34$: int, inline$BDLSystemPowerIoCompletion$26$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1: int, inline$BDLGetDebugLevel$755$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$24$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$32$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$581$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$3$: int, inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1358.0$15$: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$11$: int, inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$48$: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$304$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$96$myNondetVar_0: int, inline$BDLGetDebugLevel$730$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$36$: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$49$: int, inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$231$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1665.0$4$: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$589$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1358.0$15$: int, inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8: int, inline$BDLGetDebugLevel$131$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$8$$result.storm_nondet$465.2$2$: int, inline$BDLSystemPowerIoCompletion$4$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$37$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$127$myVar_1: int, inline$IoGetCurrentIrpStackLocation$127$myVar_0: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$598$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$85$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$53$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$15$: int, inline$BDLDevicePowerIoCompletion$16$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLPnPStart$0$$result.DbgPrint$2063.0$56$: int, inline$BDLDevicePowerIoCompletion$11$myNondetVar_0: int, inline$storm_IoCallDriver$13$$result.storm_nondet$465.2$2$: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLCallDriverCompletionRoutine$6$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLGetDebugLevel$268$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeClearEvent$0$$Event$1$236.14$storm_KeClearEvent$4_.1: int, inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1344.0$9$: int, inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$416$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$19$: int, inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$19$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$0$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1: int, inline$BDLPnPStop$0$$result.DbgPrint$2208.0$16$: int, inline$BDLDevicePowerIoCompletion$20$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLCleanupNotificationStruct$1$$irql$3$3113.45$BDLCleanupNotificationStruct$4: int, inline$IoGetCurrentIrpStackLocation$133$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1665.0$4$: int, inline$storm_KeSetEvent$14$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$11$: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1440.0$40$: int, inline$IoGetCurrentIrpStackLocation$135$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1: int, inline$BDLSystemPowerIoCompletion$2$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLGetDebugLevel$186$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2353.0$27$: int, inline$BDLGetDebugLevel$205$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$11$$result.memset$1683.8$14$: int, inline$BDLCallDriverCompletionRoutine$28$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$20$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$50$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$22$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLSystemPowerIoCompletion$14$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$16$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$28$havoc_stringTemp: int, inline$BDLGetDebugLevel$689$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$505$myNondetVar_0: int, inline$BDLGetDebugLevel$156$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$262$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$5$$result.storm_nondet$472.22$4$: int, inline$IoGetCurrentIrpStackLocation$130$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$334$myNondetVar_0: int, inline$BDLGetDebugLevel$185$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1665.0$9$: int, inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1700.0$23$: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLCallDriverCompletionRoutine$30$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$513$myNondetVar_0: int, inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16: int, inline$BDLGetDebugLevel$643$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$210$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.memcpy$2018.0$38$: int, inline$BDLDevicePowerIoCompletion$5$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$606$myNondetVar_0: int, inline$BDLGetDebugLevel$442$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$38$: int, inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$356$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$26$: int, inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$storm_getThreadID$9$tid: int, inline$storm_PoCallDriver$5$$result.storm_PoCallDriver$494.0$1$: int, inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1700.0$18$: int, inline$BDLDevicePowerIoCompletion$8$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_getThreadID$6$tid: int, inline$CallCompletionRoutine$19$$result.completionRoutine$448.30$3$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$48$: int, inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$329$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$33$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$132$havoc_stringTemp: int, inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$2$: int, inline$BDLCleanupDeviceCapabilities$0$$j$4$1733.13$BDLCleanupDeviceCapabilities$4: int, inline$BDLGetDebugLevel$431$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$26$myNondetVar_0: int, inline$BDLGetDebugLevel$176$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$104$myVar_0: int, inline$IoGetCurrentIrpStackLocation$104$myVar_1: int, inline$BDLPnPRemove$0$$pIrp$4$2481.40$BDLPnPRemove$16_.1: int, inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLHandleRemove$0$$result.DbgPrint$2441.0$29$: int, inline$BDLGetDebugLevel$293$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$94$myVar_1: int, inline$IoGetCurrentIrpStackLocation$94$myVar_0: int, inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLGetDebugLevel$344$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$426$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IsListEmpty$0$$ListHead$1$8097.28$IsListEmpty$4_.1: int, inline$BDLGetDebugLevel$739$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$27$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$75$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$751$myNondetVar_0: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$12$: int, inline$BDLGetDebugLevel$539$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$490$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$13$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$IoGetCurrentIrpStackLocation$68$myVar_0: int, inline$IoGetCurrentIrpStackLocation$68$myVar_1: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$40$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$38$myNondetVar_0: int, inline$BDLGetDebugLevel$621$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$98$myVar_1: int, inline$IoGetCurrentIrpStackLocation$98$myVar_0: int, inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_KeInitializeEvent$5$$Event$1$203.14$storm_KeInitializeEvent$12: int, inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$20$myVar_0: int, inline$IoGetCurrentIrpStackLocation$20$myVar_1: int, inline$BDLCallLowerLevelDriverAndWait$5$havoc_stringTemp: int, inline$BDLGetDebugLevel$64$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$400$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$8$: int, inline$storm_KeInitializeEvent$4$$Event$1$203.14$storm_KeInitializeEvent$12_.1: int, inline$BDLSystemPowerIoCompletion$28$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$557$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1428.0$29$: int, inline$BDLDevicePowerIoCompletion$28$$result.memset$1683.8$14$: int, inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1723.0$29$: int, inline$IoGetCurrentIrpStackLocation$81$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$3$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1: int, inline$storm_KeSetEvent$30$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLSystemPowerIoCompletion$30$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$19$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$15$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IoSetNextIrpStackLocation$7$tempBoogie0: int, inline$BDLPnPStart$0$$result.BDLPnPStart$1954.0$1$: int, inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$413$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$4$tempBoogie0: int, inline$CallCompletionRoutine$2$$context$2$435.8$CallCompletionRoutine$4: int, inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$541$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$119$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLGetDebugLevel$796$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$3$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$128$myVar_0: int, inline$IoGetCurrentIrpStackLocation$128$myVar_1: int, inline$IoGetCurrentIrpStackLocation$151$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$75$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeWaitForSingleObject$4$$result.storm_KeWaitForSingleObject$243.0$1$: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$139$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$2$$result.storm_nondet$338.2$1$: int, inline$BDLCallDriverCompletionRoutine$7$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$44$: int, inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$351$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$81$myVar_1: int, inline$IoGetCurrentIrpStackLocation$81$myVar_0: int, inline$BDLGetDebugLevel$306$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$787$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$249$myNondetVar_0: int, inline$BDLGetDebugLevel$789$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLSystemPowerIoCompletion$28$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$387$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$13$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$44$: int, inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$144$myNondetVar_0: int, inline$BDLGetDebugLevel$51$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$17$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8: int, inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1723.0$34$: int, inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$651$myNondetVar_0: int, inline$BDLGetDebugLevel$521$myNondetVar_0: int, inline$storm_IoCompleteRequest$3$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$65$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLCallDriverCompletionRoutine$1$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$794$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1428.0$29$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$15$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$97$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$140$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12: int, inline$IoGetCurrentIrpStackLocation$103$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$23$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$130$havoc_stringTemp: int, inline$BDLCallDriverCompletionRoutine$30$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLDevicePowerIoCompletion$13$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$135$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$386$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$29$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1344.0$9$: int, inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$55$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetNextIrpStackLocation$2$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$27$: int, inline$CallCompletionRoutine$14$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4: int, inline$BDLHandleRemove$1$$result.storm_IoCallDriver$2453.25$39$: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$25$: int, inline$IoGetCurrentIrpStackLocation$90$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$225$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$99$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$555$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$367$myNondetVar_0: int, inline$BDLLockHandleList$1$myNondetVar_1: int, inline$BDLLockHandleList$1$myNondetVar_0: int, inline$BDLGetDebugLevel$120$myNondetVar_0: int, inline$BDLGetDebugLevel$118$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1723.0$29$: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$110$myVar_1: int, inline$IoGetCurrentIrpStackLocation$110$myVar_0: int, inline$BDLCleanupNotificationStruct$0$$status$11$3121.36$BDLCleanupNotificationStruct$4: int, inline$IoGetCurrentIrpStackLocation$119$myVar_0: int, inline$IoGetCurrentIrpStackLocation$119$myVar_1: int, inline$BDLGetDebugLevel$197$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$72$myVar_1: int, inline$IoGetCurrentIrpStackLocation$72$myVar_0: int, inline$BDLGetDebugLevel$391$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$100$havoc_stringTemp: int, inline$storm_KeInitializeEvent$5$$State$3$205.13$storm_KeInitializeEvent$12: int, inline$BDLDevicePowerIoCompletion$15$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$13$: int, inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$114$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20: int, inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$103$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLGetDebugLevel$708$myNondetVar_0: int, inline$storm_KeSetEvent$3$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$5$: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$78$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$33$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$93$havoc_stringTemp: int, inline$BDLGetDebugLevel$537$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$750$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$12$$result.memset$1683.8$14$: int, inline$storm_KeSetEvent$15$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_IoCallDriver$108.29$4$: int, inline$BDLGetDebugLevel$544$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2323.0$3$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$456$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1700.0$23$: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$40$: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$8$: int, inline$storm_IoCallDriver$12$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLGetDebugLevel$709$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$15$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_IoCallDriver$9$$result.storm_nondet$465.2$2$: int, inline$storm_KeSetEvent$24$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp: int, inline$BDLCallDriverCompletionRoutine$5$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$11$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$219$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$115$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$26$: int, inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1700.0$18$: int, inline$BDLCallDriverCompletionRoutine$30$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLPnP$0$$result.BDLPnPStart$906.28$28$: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$149$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$558$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$20$havoc_stringTemp: int, inline$storm_IoCompleteRequest$29$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$667$myNondetVar_0: int, inline$BDLGetDebugLevel$267$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$IoGetCurrentIrpStackLocation$40$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$90$myNondetVar_0: int, inline$BDLGetDebugLevel$104$myNondetVar_0: int, inline$IoSkipCurrentIrpStackLocation$2$tempBoogie0: int, inline$BDLDevicePowerIoCompletion$8$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$761$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$10$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$515$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$5$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$291$myNondetVar_0: int, inline$BDLGetDebugLevel$736$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3199.23$27$: int, inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$IoGetCurrentIrpStackLocation$75$myVar_0: int, inline$IoGetCurrentIrpStackLocation$75$myVar_1: int, inline$CallCompletionRoutine$18$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLCallDriverCompletionRoutine$23$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$789$myNondetVar_0: int, inline$bdliFree$1$$pvBlock$1$2740.28$bdliFree$4_.1: int, inline$BDLGetDebugLevel$354$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$8$: int, inline$storm_KeInitializeSpinLock$1$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1: int, inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1700.0$23$: int, inline$BDLHandleRemove$1$$result.DbgPrint$2423.0$22$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$741$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$187$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeInitializeEvent$1$$Event$1$203.14$storm_KeInitializeEvent$12_.1: int, inline$IoGetNextIrpStackLocation$1$myVar_0: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1344.0$4$: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetCurrentIrpStackLocation$85$havoc_stringTemp: int, inline$BDLGetDebugLevel$624$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$6$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPStart$0$$pIrp$3$1958.40$BDLPnPStart$16: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1440.0$45$: int, inline$BDLSystemPowerIoCompletion$9$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$11$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$25$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$159$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$54$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$2$: int, inline$BDLGetDebugLevel$658$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLGetDebugLevel$541$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1700.0$18$: int, inline$IoGetCurrentIrpStackLocation$85$myVar_1: int, inline$IoGetCurrentIrpStackLocation$85$myVar_0: int, inline$IoGetCurrentIrpStackLocation$78$myVar_1: int, inline$IoGetCurrentIrpStackLocation$78$myVar_0: int, inline$BDLDevicePowerIoCompletion$5$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp: int, inline$BDLGetDebugLevel$365$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeInitializeSpinLock$3$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1: int, inline$BDLSystemPowerIoCompletion$24$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$8$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3199.23$27$: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$1$: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1440.0$40$: int, inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$130$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$86$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoSetNextIrpStackLocation$4$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$132$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$3$myNondetVar_0: int, inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$BDLCallLowerLevelDriverAndWait$3$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$6$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$73$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$25$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetFirstHandle$1$$result.BDLGetFirstHandle$276.0$1$: int, inline$BDLGetDebugLevel$575$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$424$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$20$$result.memset$1683.8$14$: int, inline$myInitDriver$0$$pBDLExtension$2$5.33$myInitDriver$4: int, inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$33$: int, inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20: int, inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeSetEvent$21$$Event$1$213.14$storm_KeSetEvent$12: int, inline$storm_IoSetCompletionRoutine$5$$result.storm_nondet$405.2$1$: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1428.0$29$: int, inline$CallCompletionRoutine$25$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$82$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$228$myNondetVar_0: int, inline$BDLGetDebugLevel$397$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$161$myNondetVar_0: int, inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCallDriverCompletionRoutine$23$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$718$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3231.0$37$: int, inline$IoGetCurrentIrpStackLocation$39$myNondetVar_0: int, inline$storm_IoCompleteRequest$57$$result.storm_nondet$338.2$1$: int, inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_PoCallDriver$104.29$3$: int, inline$IoGetCurrentIrpStackLocation$69$myVar_1: int, inline$BDLGetDebugLevel$790$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$21$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$642$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$611$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$8$myNondetVar_0: int, inline$CallCompletionRoutine$27$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$49$myVar_1: int, inline$IoGetCurrentIrpStackLocation$49$myVar_0: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$240$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$20$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$565$myNondetVar_0: int, inline$BDLGetDebugLevel$573$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$412$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$28$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$625$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$11$myVar_1: int, inline$BDLGetDebugLevel$201$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$result.PoSetPowerState$1693.27$16$: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$798$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$8$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$45$havoc_stringTemp: int, inline$BDLPnPCancelStop$0$$result.DbgPrint$2139.0$3$: int, inline$BDLGetDebugLevel$227$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$307$myNondetVar_0: int, inline$BDLGetDebugLevel$801$myNondetVar_0: int, inline$storm_KeSetEvent$10$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$328$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$65$myVar_1: int, inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$376$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$7$myVar_0: int, inline$BDLCallDriverCompletionRoutine$7$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$17$myNondetVar_0: int, inline$BDLGetDebugLevel$53$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$349$myNondetVar_0: int, inline$BDLGetDebugLevel$163$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8: int, inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$182$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$30$myVar_1: int, inline$IoGetCurrentIrpStackLocation$30$myVar_0: int, inline$BDLCallLowerLevelDriverAndWait$2$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLDevicePowerIoCompletion$23$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_KeSetEvent$0$$Event$1$213.14$storm_KeSetEvent$12: int, inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$30$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_PoCallDriver$4$$result.storm_IoCallDriver$499.27$2$: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1358.0$20$: int, inline$BDLPnPStart$0$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$callresult.$3284.85$14$: int, inline$storm_PoCallDriver$2$$result.storm_PoCallDriver$494.0$1$: int, inline$storm_KeInitializeEvent$0$$Event$1$203.14$storm_KeInitializeEvent$12: int, inline$BDLCleanupDataHandles$0$$status$2$3245.28$BDLCleanupDataHandles$4: int, inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1700.0$23$: int, inline$BDLGetDebugLevel$532$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$22$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$593$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IsListEmpty$2$$ListHead$1$8097.28$IsListEmpty$4_.1: int, inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$540$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$171$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$335$myNondetVar_0: int, inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$57$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1440.0$45$: int, inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPStart$0$$result.DbgPrint$2063.0$61$: int, inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1358.0$15$: int, inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1700.0$23$: int, inline$BDLPnP$0$$result.BDLPnPQueryRemove$943.34$32$: int, inline$BDLCallDriverCompletionRoutine$27$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_getThreadID$7$tid: int, inline$BDLGetDebugLevel$785$myNondetVar_0: int, inline$BDLGetDebugLevel$630$myNondetVar_0: int, inline$BDLGetDebugLevel$503$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLHandleRemove$1$$result.DbgPrint$2457.0$46$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$8$: int, inline$storm_KeReleaseSpinLock$6$$result.storm_getThreadID$145.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1700.0$18$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$19$: int, inline$storm_IoCompleteRequest$60$$result.storm_nondet$338.2$1$: int, inline$CallCompletionRoutine$2$myNondetVar_0: int, inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$IoGetCurrentIrpStackLocation$79$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$120$myNondetVar_0: int, inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12: int, inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$52$: int, inline$BDLSystemPowerIoCompletion$5$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$8$havoc_stringTemp: int, inline$IoSetNextIrpStackLocation$6$tempBoogie0: int, inline$BDLGetDebugLevel$171$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$3$: int, inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$277$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStop$0$$pBDLExtension$1$2182.40$BDLPnPStop$12_.1: int, inline$BDLHandleRemove$0$$result.DbgPrint$2386.0$3$: int, inline$BDLGetDebugLevel$554$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$0$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1358.0$15$: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$30$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$0$$result.memset$1683.8$14$: int, inline$BDLGetDebugLevel$760$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$5$myVar_0: int, inline$IoGetNextIrpStackLocation$1$havoc_stringTemp: int, inline$storm_IoCompleteRequest$50$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1700.0$23$: int, inline$BDLDevicePowerIoCompletion$15$$result.PoSetPowerState$1693.27$16$: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$8$: int, inline$IoGetCurrentIrpStackLocation$110$myNondetVar_0: int, inline$bdliFree$0$$pvBlock$1$2740.28$bdliFree$4: int, inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8_.1: int, inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$623$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$24$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$102$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$379$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$65$myNondetVar_0: int, inline$BDLGetDebugLevel$350$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetNextIrpStackLocation$12$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$1$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$153$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$563$myNondetVar_0: int, inline$BDLGetDebugLevel$200$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$366$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$140$myVar_0: int, inline$IoGetCurrentIrpStackLocation$140$myVar_1: int, inline$BDLDevicePowerIoCompletion$5$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$18$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_PoCallDriver$104.29$3$: int, inline$BDLGetDebugLevel$692$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$556$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$callresult.$1999.70$26$: int, inline$IoGetCurrentIrpStackLocation$46$myVar_0: int, inline$IoGetCurrentIrpStackLocation$46$myVar_1: int, inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$512$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_KeSetEvent$2$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$IoGetCurrentIrpStackLocation$70$myVar_1: int, inline$IoGetCurrentIrpStackLocation$70$myVar_0: int, inline$BDLDevicePowerIoCompletion$5$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$124$myVar_0: int, inline$IoGetCurrentIrpStackLocation$124$myVar_1: int, inline$BDLGetDebugLevel$357$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPQueryRemove$0$$result.DbgPrint$2303.0$32$: int, inline$IoSkipCurrentIrpStackLocation$1$myNondetVar_0: int, inline$BDLGetDebugLevel$617$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$1$: int, inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12_.1: int, inline$storm_getThreadID$2$tid: int, inline$IoGetCurrentIrpStackLocation$146$myVar_0: int, inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$storm_KeSetEvent$28$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$24$: int, inline$IoGetCurrentIrpStackLocation$89$myVar_1: int, inline$BDLGetDebugLevel$722$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$746$myNondetVar_0: int, inline$CallCompletionRoutine$13$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$641$myNondetVar_0: int, inline$CallCompletionRoutine$5$$result.completionRoutine$448.30$3$: int, inline$BDLGetDebugLevel$95$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$500$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$0$myNondetVar_0: int, inline$BDLGetDebugLevel$705$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$600$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$638$myNondetVar_0: int, inline$storm_IoAllocateIrp$0$$result.malloc$279.0$3$: int, inline$BDLGetDebugLevel$331$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$203$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetCurrentIrpStackLocation$84$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$544$myNondetVar_0: int, inline$BDLGetDebugLevel$83$myNondetVar_0: int, inline$BDLGetDebugLevel$569$myNondetVar_0: int, inline$BDLGetDebugLevel$479$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1344.0$9$: int, inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1665.0$4$: int, inline$storm_IoCompleteRequest$13$$result.storm_nondet$338.2$1$: int, inline$BDLCallDriverCompletionRoutine$2$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLHandleRemove$1$$result.DbgPrint$2441.0$34$: int, inline$CallCompletionRoutine$7$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$144$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$3$myVar_0: int, inline$IoGetCurrentIrpStackLocation$37$myNondetVar_0: int, inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLSystemPowerIoCompletion$25$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp: int, inline$BDLGetDebugLevel$444$myNondetVar_0: int, inline$BDLGetDebugLevel$19$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$143$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$613$myNondetVar_0: int, inline$BDLGetDebugLevel$345$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$119$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp: int, inline$BDLGetDebugLevel$657$myNondetVar_0: int, inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$1$: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1428.0$29$: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLGetDebugLevel$497$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$storm_IoCompleteRequest$35$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$10$myVar_0: int, inline$BDLGetDebugLevel$545$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$11$: int, inline$BDLCallDriverCompletionRoutine$8$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPStop$0$$pIrp$3$2184.40$BDLPnPStop$12: int, inline$BDLGetDebugLevel$69$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$547$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_PoCallDriver$3$$Irp$2$496.14$storm_PoCallDriver$8: int, inline$BDLPnP$0$$result.DbgPrint$886.0$18$: int, inline$BDLGetDebugLevel$690$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$318$myNondetVar_0: int, inline$storm_KeSetEvent$4$$Event$1$213.14$storm_KeSetEvent$12: int, inline$storm_KeInitializeEvent$0$$State$3$205.13$storm_KeInitializeEvent$12: int, inline$IoSkipCurrentIrpStackLocation$0$havoc_stringTemp: int, inline$BDLPnPCancelStop$0$$pIrp$3$2134.40$BDLPnPCancelStop$12: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$6$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1440.0$40$: int, inline$CallCompletionRoutine$17$$status$5$438.11$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLSystemPowerIoCompletion$9$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCallDriver$3$$result.storm_nondet$472.22$4$: int, inline$BDLDevicePowerIoCompletion$10$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLCallDriverCompletionRoutine$0$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$20$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLCallDriverCompletionRoutine$4$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$410$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$605$myNondetVar_0: int, inline$BDLGetDebugLevel$142$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$167$myNondetVar_0: int, inline$BDLGetDebugLevel$613$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24: int, inline$BDLSystemPowerIoCompletion$26$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPQueryRemove$0$$result.DbgPrint$2263.0$8$: int, inline$IoGetCurrentIrpStackLocation$12$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$696$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$41$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$15$havoc_stringTemp: int, inline$BDLGetDebugLevel$420$myNondetVar_0: int, inline$storm_KeAcquireSpinLock$4$$tid$3$128.6$storm_KeAcquireSpinLock$8: int, inline$BDLCleanupDataHandles$1$$callresult.$3284.85$14$: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$546$myNondetVar_0: int, inline$BDLGetDebugLevel$399$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$22$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$29$myNondetVar_0: int, inline$BDLGetDebugLevel$216$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$20$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$18$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$30$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$20$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$577$myNondetVar_0: int, inline$BDLGetDebugLevel$752$myNondetVar_0: int, inline$IsListEmpty$3$$ListHead$1$8097.28$IsListEmpty$4_.1: int, inline$BDLGetDebugLevel$606$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$301$myNondetVar_0: int, inline$BDLGetDebugLevel$732$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$217$myNondetVar_0: int, inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8_.1: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$36$: int, inline$BDLReleaseHandleList$0$$pBDLExtension$1$145.40$BDLReleaseHandleList$8_.1: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$10$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$153$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$3$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$506$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$386$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$25$: int, inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$281$myNondetVar_0: int, inline$BDLGetDebugLevel$52$myNondetVar_0: int, inline$BDLGetDebugLevel$296$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1428.0$29$: int, inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$12$: int, inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp: int, inline$BDLGetDebugLevel$454$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1358.0$20$: int, inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$24$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$7$: int, inline$BDLPnPCancelRemove$0$$pBDLExtension$1$2316.40$BDLPnPCancelRemove$12: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$27$: int, inline$storm_KeSetEvent$32$$Event$1$213.14$storm_KeSetEvent$12: int, inline$storm_IoCallDriver$0$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLGetDebugLevel$687$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$229$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1723.0$29$: int, inline$BDLSystemPowerIoCompletion$20$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPStart$0$$pIrp$3$1958.40$BDLPnPStart$16_.1: int, inline$CallCompletionRoutine$5$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$141$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$62$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1428.0$34$: int, inline$BDLDevicePowerIoCompletion$7$$result.PoSetPowerState$1693.27$16$: int, inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1700.0$23$: int, inline$IoSetNextIrpStackLocation$10$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$3$: int, inline$IoGetCurrentIrpStackLocation$31$myNondetVar_0: int, inline$BDLGetDebugLevel$54$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$76$myVar_1: int, inline$IoGetCurrentIrpStackLocation$76$myVar_0: int, inline$BDLGetDebugLevel$647$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$314$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$11$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$66$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$295$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1700.0$18$: int, inline$BDLDevicePowerIoCompletion$1$$result.memset$1683.8$14$: int, inline$BDLGetDebugLevel$765$myNondetVar_0: int, inline$BDLGetDebugLevel$238$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$9$myVar_0: int, inline$IoGetCurrentIrpStackLocation$9$myVar_1: int, inline$BDLGetDebugLevel$297$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$135$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$676$myNondetVar_0: int, inline$BDLGetDebugLevel$453$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1358.0$20$: int, inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2549.0$15$: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$0$myNondetVar_0: int, inline$CallCompletionRoutine$24$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$429$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$127$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$109$myNondetVar_0: int, inline$BDLGetDebugLevel$589$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$27$: int, inline$storm_IoCallDriver$1$$result.storm_nondet$465.2$2$: int, inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$63$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$745$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1665.0$9$: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$12$: int, inline$storm_IoCompleteRequest$8$$result.storm_nondet$338.2$1$: int, inline$IoSkipCurrentIrpStackLocation$2$myVar_1: int, inline$IoSkipCurrentIrpStackLocation$2$myVar_0: int, inline$BDLGetDebugLevel$469$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$134$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLPnPStart$0$$bdsiInitializeResourcesParams$7$1964.32$BDLPnPStart$16: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1440.0$45$: int, inline$IoGetCurrentIrpStackLocation$107$havoc_stringTemp: int, inline$CallCompletionRoutine$3$$result.completionRoutine$448.30$3$: int, inline$BDLGetDebugLevel$687$myNondetVar_0: int, inline$BDLPnPCancelRemove$0$$result.BDLPnPCancelRemove$2314.0$1$: int, inline$BDLGetDebugLevel$29$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$89$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$IoGetCurrentIrpStackLocation$98$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2365.0$43$: int, inline$storm_KeSetEvent$29$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1665.0$9$: int, inline$IoGetCurrentIrpStackLocation$104$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLDevicePowerIoCompletion$0$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$12$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_PoCallDriver$1$$Irp$2$496.14$storm_PoCallDriver$8: int, inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1700.0$18$: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1358.0$20$: int, inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$3$: int, inline$BDLGetDebugLevel$392$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$21$myNondetVar_0: int, inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$14$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$IsListEmpty$3$myNondetVar_0: int, inline$BDLGetDebugLevel$496$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$244$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$769$myNondetVar_0: int, inline$BDLGetDebugLevel$738$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$38$havoc_stringTemp: int, inline$BDLGetDebugLevel$574$myNondetVar_0: int, inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12_.1: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$19$: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$storm_KeSetEvent$23$$Event$1$213.14$storm_KeSetEvent$12: int, inline$IoGetCurrentIrpStackLocation$113$myNondetVar_0: int, inline$BDLGetDebugLevel$92$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLGetDebugLevel$194$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$7$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$67$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$1$$result.storm_nondet$256.20$2$: int, inline$BDLGetDebugLevel$629$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$4$$result.BDLCallLowerLevelDriverAndWait$71.0$1$: int, inline$BDLGetDebugLevel$276$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$585$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$464$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$4$$result.storm_nondet$465.2$2$: int, inline$BDLGetDebugLevel$370$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$384$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$800$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$38$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$618$myNondetVar_0: int, inline$BDLGetDebugLevel$593$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$14$$result.storm_IoCallDriver$456.0$1$: int, inline$IoGetCurrentIrpStackLocation$126$myVar_0: int, inline$IoGetCurrentIrpStackLocation$126$myVar_1: int, inline$BDLGetDebugLevel$463$myNondetVar_0: int, inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$718$myNondetVar_0: int, inline$CallCompletionRoutine$12$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLPnP$0$$result.BDLPnPSurpriseRemoval$973.38$35$: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$13$: int, inline$storm_getThreadID$12$tid: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$2$: int, inline$BDLSystemPowerIoCompletion$1$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$457$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$14$: int, inline$IoGetCurrentIrpStackLocation$58$myNondetVar_0: int, inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1358.0$15$: int, inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$102$havoc_stringTemp: int, inline$storm_IoCallDriver$7$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLGetDebugLevel$576$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1700.0$18$: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$17$: int, inline$IsListEmpty$0$$result.IsListEmpty$8096.0$1$: int, inline$BDLGetDebugLevel$262$myNondetVar_0: int, inline$BDLGetDebugLevel$761$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$86$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$39$: int, inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1: int, inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1665.0$9$: int, inline$IoGetCurrentIrpStackLocation$17$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1440.0$40$: int, inline$IoSetNextIrpStackLocation$14$myVar_0: int, inline$BDLGetDebugLevel$8$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$363$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$234$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1: int, inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$myInitDriver$0$myNondetVar_0: int, inline$myInitDriver$0$myNondetVar_1: int, inline$BDLGetDebugLevel$694$myNondetVar_0: int, inline$BDLGetDebugLevel$66$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$88$havoc_stringTemp: int, inline$BDLGetDebugLevel$607$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$312$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$361$myNondetVar_0: int, inline$BDLGetDebugLevel$221$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$14$$result.storm_nondet$338.2$1$: int, inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8: int, inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1: int, inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$405$myNondetVar_0: int, inline$BDLGetDebugLevel$570$myNondetVar_0: int, inline$BDLGetDebugLevel$409$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$6$havoc_stringTemp: int, inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1665.0$4$: int, inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1723.0$29$: int, inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1723.0$34$: int, inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$117$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1440.0$40$: int, inline$BDLSystemPowerIoCompletion$6$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$77$havoc_stringTemp: int, inline$BDLGetDebugLevel$71$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$storm_IoCompleteRequest$32$$result.storm_nondet$338.2$1$: int, inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$461$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1700.0$18$: int, inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$47$: int, inline$BDLGetDebugLevel$247$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$109$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$36$: int, inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$38$: int, inline$storm_IoCallDriver$2$$result.storm_nondet$472.22$4$: int, inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$258$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$285$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$152$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1440.0$45$: int, inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$94$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1358.0$20$: int, inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$17$: int, inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$27$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$99$havoc_stringTemp: int, inline$BDLGetDebugLevel$377$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$53$: int, inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$779$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$152$myNondetVar_0: int, inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$783$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$16$: int, inline$IoSetNextIrpStackLocation$5$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$13$: int, inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$storm_KeAcquireSpinLock$0$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1358.0$20$: int, inline$storm_KeInitializeEvent$2$$State$3$205.13$storm_KeInitializeEvent$12_.1: int, inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$434$myNondetVar_0: int, inline$CallCompletionRoutine$1$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$25$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$455$myNondetVar_0: int, inline$BDLGetDebugLevel$615$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLCallDriverCompletionRoutine$17$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$575$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$140$myNondetVar_0: int, inline$storm_getThreadID$0$tid: int, inline$IoGetCurrentIrpStackLocation$117$myNondetVar_0: int, inline$BDLGetDebugLevel$183$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$143$myVar_1: int, inline$BDLGetDebugLevel$448$myNondetVar_0: int, inline$storm_KeSetEvent$8$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1665.0$9$: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$27$: int, inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$BDLGetDebugLevel$172$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1428.0$34$: int, inline$BDLCallDriverCompletionRoutine$27$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$191$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$18$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$68$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$332$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$3$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$102$myVar_0: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$1$: int, inline$BDLGetDebugLevel$423$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$148$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$storm_PoCallDriver$5$$Irp$2$496.14$storm_PoCallDriver$8: int, inline$IoGetCurrentIrpStackLocation$64$myNondetVar_0: int, inline$BDLGetDebugLevel$45$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPQueryRemove$0$$result.IoSetDeviceInterfaceState$2272.29$13$: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLDevicePowerIoCompletion$26$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20: int, inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLPnPStop$0$$callresult.$2204.67$14$: int, inline$CallCompletionRoutine$8$myNondetVar_0: int, inline$BDLPnPStart$0$havoc_stringTemp: int, inline$BDLGetDebugLevel$288$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$19$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12: int, inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$storm_PoCallDriver$1$$Irp$2$496.14$storm_PoCallDriver$8_.1: int, inline$BDLGetDebugLevel$37$myNondetVar_0: int, inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLPnPStop$0$havoc_stringTemp: int, inline$BDLGetDebugLevel$269$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4_.1: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$38$: int, inline$CallCompletionRoutine$12$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$8$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$679$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$4$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$19$$callresult.$1687.68$15$: int, inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$254$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1: int, inline$BDLCallDriverCompletionRoutine$7$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$16$$result.completionRoutine$448.30$3$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3123.0$7$: int, inline$BDLGetDebugLevel$797$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$215$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$21$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$176$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLCallDriverCompletionRoutine$18$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$4$havoc_stringTemp: int, inline$BDLGetDebugLevel$165$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4: int, inline$BDLGetDebugLevel$251$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$22$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$800$myNondetVar_0: int, inline$BDLGetDebugLevel$735$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$99$myVar_0: int, inline$IoGetCurrentIrpStackLocation$99$myVar_1: int, inline$BDLGetDebugLevel$121$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$492$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$6$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$767$myNondetVar_0: int, inline$IsListEmpty$5$$result.IsListEmpty$8096.0$1$: int, inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$31$myNondetVar_0: int, inline$BDLGetDebugLevel$522$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$30$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$669$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$153$myVar_0: int, inline$IoGetCurrentIrpStackLocation$153$myVar_1: int, inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1665.0$4$: int, inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLPnP$0$$result.storm_IoCallDriver$995.29$47$: int, inline$BDLGetDebugLevel$86$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLDevicePowerIoCompletion$8$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$30$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$44$$result.storm_nondet$338.2$1$: int, inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_IoCallDriver$108.29$4$: int, inline$IoGetCurrentIrpStackLocation$111$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$265$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$14$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLGetDebugLevel$420$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$723$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$86$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLDevicePowerIoCompletion$6$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$13$: int, inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$IoGetCurrentIrpStackLocation$122$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$16$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$25$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$24$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1700.0$23$: int, inline$BDLCallLowerLevelDriverAndWait$1$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8: int, inline$IoGetCurrentIrpStackLocation$20$myNondetVar_0: int, inline$CallCompletionRoutine$5$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$136$myVar_1: int, inline$IoGetCurrentIrpStackLocation$136$myVar_0: int, inline$BDLSystemPowerIoCompletion$15$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$439$myNondetVar_0: int, inline$BDLGetDebugLevel$594$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.DbgPrint$1966.0$3$: int, inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4: int, inline$BDLGetDebugLevel$241$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$8$tempBoogie0: int, inline$BDLGetDebugLevel$343$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$128$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnP$0$$result.DbgPrint$1023.0$49$: int, inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$542$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$13$: int, inline$IoGetNextIrpStackLocation$3$myVar_0: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$591$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$560$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$59$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4: int, inline$BDLGetDebugLevel$225$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$26$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$$result.DbgPrint$3308.0$32$: int, inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1: int, inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$228$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$67$myVar_1: int, inline$IoGetCurrentIrpStackLocation$67$myVar_0: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1358.0$15$: int, inline$IsListEmpty$4$$result.IsListEmpty$8096.0$1$: int, inline$BDLHandleRemove$0$havoc_stringTemp: int, inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$313$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4: int, inline$storm_KeSetEvent$12$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLCallDriverCompletionRoutine$18$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp: int, inline$BDLGetDebugLevel$405$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$602$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStart$0$$result.DbgPrint$1979.0$20$: int, inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$154$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$0$$result.storm_nondet$256.20$2$: int, inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLCallLowerLevelDriverAndWait$3$$result.BDLCallLowerLevelDriverAndWait$71.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$8$: int, inline$CallCompletionRoutine$29$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$65$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnPQueryStop$0$$result.DbgPrint$2085.0$3$: int, inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20: int, inline$BDLGetDebugLevel$700$myNondetVar_0: int, inline$BDLGetDebugLevel$427$myNondetVar_0: int, inline$BDLGetDebugLevel$170$myNondetVar_0: int, inline$BDLGetDebugLevel$470$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$19$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1358.0$15$: int, inline$storm_KeInitializeEvent$3$$State$3$205.13$storm_KeInitializeEvent$12_.1: int, inline$storm_PoCallDriver$0$$Irp$2$496.14$storm_PoCallDriver$8_.1: int, inline$BDLGetDebugLevel$716$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$699$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$80$myVar_0: int, inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1723.0$34$: int, inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$483$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$$result.DbgPrint$2291.0$16$: int, inline$BDLGetDebugLevel$216$myNondetVar_0: int, inline$BDLGetDebugLevel$379$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$102$myNondetVar_0: int, inline$BDLGetDebugLevel$793$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$670$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$2$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$13$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$378$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$41$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$9$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$21$myVar_0: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLPnPQueryStop$0$$result.DbgPrint$2119.0$15$: int, inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1700.0$23$: int, inline$BDLGetDebugLevel$667$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$217$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$19$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLCallDriverCompletionRoutine$5$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$16$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1665.0$4$: int, inline$BDLCleanupNotificationStruct$1$myNondetVar_1: int, inline$BDLCleanupNotificationStruct$1$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$725$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$30$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$471$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$16$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24: int, inline$BDLDevicePowerIoCompletion$27$$callresult.$1687.68$15$: int, inline$BDLCallDriverCompletionRoutine$12$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$263$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$739$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$9$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$18$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$34$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$21$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$695$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$67$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$22$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$8$: int, inline$storm_IoAllocateIrp$0$$result.storm_nondet$277.22$2$: int, inline$BDLCallDriverCompletionRoutine$25$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLDevicePowerIoCompletion$23$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1700.0$23$: int, inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1358.0$20$: int, inline$BDLDevicePowerIoCompletion$20$$callresult.$1687.68$15$: int, inline$IoGetCurrentIrpStackLocation$69$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$7$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$21$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLCallDriverCompletionRoutine$14$myNondetVar_0: int, inline$IsListEmpty$5$$ListHead$1$8097.28$IsListEmpty$4_.1: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$49$: int, inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$290$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$628$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$8$: int, inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$12$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$24$: int, inline$storm_IoCompleteRequest$40$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$263$myNondetVar_0: int, inline$BDLGetDebugLevel$603$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$19$: int, inline$storm_KeAcquireSpinLock$3$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1344.0$9$: int, inline$storm_IoCompleteRequest$6$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1700.0$23$: int, inline$BDLGetDebugLevel$764$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoSetCompletionRoutine$4$$result.storm_nondet$405.2$1$: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLReleaseHandleList$1$myNondetVar_0: int, inline$BDLReleaseHandleList$1$myNondetVar_1: int, inline$BDLPnPCancelRemove$0$$result.DbgPrint$2365.0$38$: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLGetDebugLevel$467$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1665.0$9$: int, inline$BDLDevicePowerIoCompletion$7$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$402$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$316$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$14$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$26$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$79$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp: int, inline$BDLGetDebugLevel$626$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$19$: int, inline$BDLGetDebugLevel$501$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$2$$callresult.$1687.68$15$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLPnPRemove$0$$result.BDLPnPRemove$2476.0$1$: int, inline$BDLGetDebugLevel$638$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$0$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$36$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$71$havoc_stringTemp: int, inline$storm_KeSetEvent$12$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$27$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$6$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$648$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$126$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$callresult.$1687.68$15$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$14$: int, inline$BDLGetDebugLevel$540$myNondetVar_0: int, inline$BDLGetDebugLevel$755$myNondetVar_0: int, inline$storm_KeInitializeEvent$0$$Event$1$203.14$storm_KeInitializeEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$489$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$22$: int, inline$CallCompletionRoutine$26$$result.completionRoutine$448.30$3$: int, inline$BDLGetDebugLevel$269$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$259$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$29$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$23$$result.memset$1683.8$14$: int, inline$IoGetCurrentIrpStackLocation$120$havoc_stringTemp: int, inline$BDLGetDebugLevel$526$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$0$$result.DbgPrint$2423.0$22$: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$464$myNondetVar_0: int, inline$BDLGetDebugLevel$616$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$67$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$8$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$13$: int, inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$76$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$13$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_getThreadID$11$tid: int, inline$BDLGetDebugLevel$731$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$39$: int, inline$IoGetCurrentIrpStackLocation$32$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1440.0$45$: int, inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1358.0$20$: int, inline$BDLDevicePowerIoCompletion$9$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IoSkipCurrentIrpStackLocation$0$myVar_1: int, inline$IoSkipCurrentIrpStackLocation$0$myVar_0: int, inline$BDLSystemPowerIoCompletion$7$myNondetVar_0: int, inline$BDLGetDebugLevel$200$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1358.0$15$: int, inline$IoGetCurrentIrpStackLocation$98$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$302$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$7$$result.storm_nondet$472.22$4$: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$39$: int, inline$storm_KeReleaseSpinLock$6$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$IoGetCurrentIrpStackLocation$67$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1344.0$4$: int, inline$IoGetCurrentIrpStackLocation$13$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$8$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$53$myVar_0: int, inline$IoGetCurrentIrpStackLocation$53$myVar_1: int, inline$BDLGetDebugLevel$432$myNondetVar_0: int, inline$BDLGetDebugLevel$367$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$132$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$29$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$188$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$25$: int, inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$138$myNondetVar_0: int, inline$BDLGetDebugLevel$157$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$11$$result.storm_nondet$465.2$2$: int, inline$BDLGetDebugLevel$532$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$14$myNondetVar_0: int, inline$BDLGetDebugLevel$468$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$119$myNondetVar_0: int, inline$BDLGetDebugLevel$214$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$56$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$706$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$333$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$6$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$11$$result.PoSetPowerState$1693.27$16$: int, inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1: int, inline$BDLGetDebugLevel$587$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$605$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeWaitForSingleObject$2$$result.storm_KeWaitForSingleObject$243.0$1$: int, inline$BDLCallDriverCompletionRoutine$21$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLDevicePowerIoCompletion$20$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLCallDriverCompletionRoutine$5$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoGetCurrentIrpStackLocation$84$myVar_0: int, inline$IoGetCurrentIrpStackLocation$84$myVar_1: int, inline$BDLGetDebugLevel$122$myNondetVar_0: int, inline$BDLGetDebugLevel$79$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$51$: int, inline$IoGetCurrentIrpStackLocation$116$myVar_1: int, inline$IoGetCurrentIrpStackLocation$116$myVar_0: int, inline$BDLSystemPowerIoCompletion$20$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$12$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLCallDriverCompletionRoutine$16$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1723.0$29$: int, inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1440.0$40$: int, inline$CallCompletionRoutine$4$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$763$myNondetVar_0: int, inline$BDLGetDebugLevel$73$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4_.1: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLSystemPowerIoCompletion$7$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$26$: int, inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$45$myNondetVar_0: int, inline$BDLGetDebugLevel$490$myNondetVar_0: int, inline$BDLGetDebugLevel$675$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$27$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$577$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$19$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLGetDebugLevel$539$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$13$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$16$$result.memset$1683.8$14$: int, inline$IoGetNextIrpStackLocation$10$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLDevicePowerIoCompletion$7$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$397$myNondetVar_0: int, inline$storm_IoCompleteRequest$53$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$724$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$615$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$23$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$306$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$785$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$12$$result.storm_nondet$465.2$2$: int, inline$BDLDevicePowerIoCompletion$22$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$77$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLDevicePowerIoCompletion$15$$callresult.$1687.68$15$: int, inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$288$myNondetVar_0: int, inline$BDLGetDebugLevel$597$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$22$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$18$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$663$myNondetVar_0: int, inline$BDLGetDebugLevel$499$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$27$myNondetVar_0: int, inline$CallCompletionRoutine$4$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$28$myVar_0: int, inline$BDLDevicePowerIoCompletion$12$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$395$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLSystemPowerIoCompletion$12$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12: int, inline$BDLDevicePowerIoCompletion$28$$callresult.$1687.68$15$: int, inline$BDLDevicePowerIoCompletion$29$$result.memset$1683.8$14$: int, inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$62$myVar_0: int, inline$IoGetCurrentIrpStackLocation$62$myVar_1: int, inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$143$myVar_0: int, inline$IoGetCurrentIrpStackLocation$136$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$12$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$134$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$68$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$131$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$54$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1700.0$23$: int, inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1723.0$29$: int, inline$CallCompletionRoutine$7$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp: int, inline$storm_IoCompleteRequest$19$$result.storm_nondet$338.2$1$: int, inline$storm_IoCompleteRequest$4$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1700.0$18$: int, inline$storm_KeReleaseSpinLock$0$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$BDLCallDriverCompletionRoutine$16$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$150$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$3$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$2$: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IsListEmpty$0$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$myNondetVar_0: int, inline$BDLGetDebugLevel$523$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnPQueryStop$0$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$14$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLCleanupNotificationStruct$1$$result.KfRaiseIrql$3141.8$12$: int, inline$BDLCallDriverCompletionRoutine$3$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$90$myVar_1: int, inline$IoGetCurrentIrpStackLocation$90$myVar_0: int, inline$BDLSystemPowerIoCompletion$9$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPCancelStop$0$$pIrp$3$2134.40$BDLPnPCancelStop$12_.1: int, inline$BDLGetDebugLevel$776$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1700.0$18$: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$7$: int, inline$BDLGetDebugLevel$521$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$28$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$749$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$21$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLDevicePowerIoCompletion$11$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$331$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1723.0$34$: int, inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$27$: int, inline$IsListEmpty$5$$ListHead$1$8097.28$IsListEmpty$4: int, inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$192$myNondetVar_0: int, inline$BDLGetDebugLevel$232$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLSystemPowerIoCompletion$15$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$storm_getThreadID$5$tid: int, inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$14$: int, inline$IoGetNextIrpStackLocation$4$myVar_0: int, inline$BDLGetDebugLevel$297$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$641$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$66$myVar_0: int, inline$IoGetCurrentIrpStackLocation$66$myVar_1: int, inline$BDLGetDebugLevel$402$myNondetVar_0: int, inline$BDLGetDebugLevel$586$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$184$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$408$myNondetVar_0: int, inline$storm_getThreadID$10$tid: int, inline$BDLDevicePowerIoCompletion$30$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$IoGetCurrentIrpStackLocation$91$myVar_1: int, inline$BDLGetDebugLevel$284$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12_.1: int, inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1723.0$29$: int, inline$CallCompletionRoutine$6$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$678$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12: int, inline$IoGetCurrentIrpStackLocation$147$havoc_stringTemp: int, inline$BDLGetDebugLevel$38$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$473$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$39$: int, inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$699$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoSetNextIrpStackLocation$2$myNondetVar_0: int, inline$BDLGetDebugLevel$328$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$429$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$28$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$48$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$18$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$270$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPCancelRemove$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$10$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$150$myVar_1: int, inline$IoGetCurrentIrpStackLocation$150$myVar_0: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLPnP$0$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$14$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$66$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$527$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLDevicePowerIoCompletion$27$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$12$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1723.0$29$: int, inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8_.1: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$318$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_PoCallDriver$1$$result.storm_PoCallDriver$494.0$1$: int, inline$BDLGetDebugLevel$493$myNondetVar_0: int, inline$BDLGetDebugLevel$362$myNondetVar_0: int, inline$BDLPnPRemove$0$$pIrp$4$2481.40$BDLPnPRemove$16: int, inline$BDLGetDebugLevel$119$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$4$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$12$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$3$$result.memset$1683.8$14$: int, inline$BDLGetDebugLevel$354$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$30$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$10$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$355$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$147$myVar_1: int, inline$IoGetCurrentIrpStackLocation$147$myVar_0: int, inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$390$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$0$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$207$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1700.0$18$: int, inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$439$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$98$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$23$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$569$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$113$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$720$myNondetVar_0: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$36$: int, inline$BDLGetDebugLevel$637$myNondetVar_0: int, inline$BDLGetDebugLevel$369$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$10$$result.storm_nondet$465.2$2$: int, inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$26$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$579$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLCallDriverCompletionRoutine$23$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$446$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$26$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$68$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1440.0$45$: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLCallDriverCompletionRoutine$13$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1358.0$15$: int, inline$BDLPnPQueryStop$0$myNondetVar_1: int, inline$BDLPnPQueryStop$0$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$74$myVar_1: int, inline$BDLGetDebugLevel$491$myNondetVar_0: int, inline$BDLGetDebugLevel$348$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$10$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$storm_PoCallDriver$0$$result.storm_PoCallDriver$494.0$1$: int, inline$BDLGetDebugLevel$358$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$0$$callresult.$2419.71$15$: int, inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$46$: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$8$: int, inline$storm_KeSetEvent$27$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$362$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$404$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1665.0$9$: int, inline$IoGetCurrentIrpStackLocation$101$myVar_1: int, inline$IoGetCurrentIrpStackLocation$101$myVar_0: int, inline$BDLGetDebugLevel$408$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLCleanupNotificationStruct$1$$result.RemoveHeadList$3218.26$30$: int, inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$235$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$11$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$19$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$264$myNondetVar_0: int, inline$storm_KeSetEvent$31$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$389$myNondetVar_0: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$26$: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$19$: int, inline$BDLGetDebugLevel$172$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLDevicePowerIoCompletion$26$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$742$myNondetVar_0: int, inline$storm_IoCompleteRequest$15$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$319$myNondetVar_0: int, inline$BDLGetDebugLevel$497$myNondetVar_0: int, inline$BDLRemoveHandleFromList$1$myNondetVar_0: int, inline$BDLRemoveHandleFromList$1$myNondetVar_1: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$222$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$28$myNondetVar_0: int, inline$BDLGetDebugLevel$239$myNondetVar_0: int, inline$storm_KeSetEvent$13$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLCleanupNotificationStruct$0$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4: int, inline$IoGetCurrentIrpStackLocation$18$havoc_stringTemp: int, inline$BDLHandleRemove$1$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$82$havoc_stringTemp: int, inline$BDLGetDebugLevel$146$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$26$: int, inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLGetDebugLevel$406$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$495$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$94$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$721$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$722$myNondetVar_0: int, inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLCleanupNotificationStruct$0$$result.RemoveHeadList$3218.26$30$: int, inline$BDLSystemPowerIoCompletion$1$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCompleteRequest$25$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$504$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$16$: int, inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_IoCompleteRequest$33$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$22$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$59$myVar_0: int, inline$IoGetCurrentIrpStackLocation$59$myVar_1: int, inline$BDLGetDebugLevel$511$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$33$: int, inline$storm_KeInitializeEvent$2$$State$3$205.13$storm_KeInitializeEvent$12: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1344.0$9$: int, inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLDevicePowerIoCompletion$25$$result.memset$1683.8$14$: int, inline$BDLDevicePowerIoCompletion$24$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLCallDriverCompletionRoutine$15$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$693$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupDataHandles$0$$result.DbgPrint$3308.0$27$: int, inline$BDLGetDebugLevel$689$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$39$: int, inline$IoSetNextIrpStackLocation$8$myVar_0: int, inline$BDLGetDebugLevel$459$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12: int, inline$BDLSystemPowerIoCompletion$26$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IoSetNextIrpStackLocation$2$myVar_0: int, inline$storm_IoCompleteRequest$43$$result.storm_nondet$338.2$1$: int, inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8: int, inline$BDLSystemPowerIoCompletion$29$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$132$myVar_1: int, inline$IoGetCurrentIrpStackLocation$132$myVar_0: int, inline$storm_PoCallDriver$4$$Irp$2$496.14$storm_PoCallDriver$8: int, inline$BDLGetDebugLevel$46$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$5$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLCallDriverCompletionRoutine$17$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$IoGetCurrentIrpStackLocation$115$myVar_0: int, inline$IoGetCurrentIrpStackLocation$115$myVar_1: int, inline$BDLGetDebugLevel$370$myNondetVar_0: int, inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLSystemPowerIoCompletion$27$myNondetVar_0: int, inline$BDLGetDebugLevel$13$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$61$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$44$: int, inline$IoGetCurrentIrpStackLocation$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1428.0$29$: int, inline$BDLDevicePowerIoCompletion$1$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$3$: int, inline$IoGetCurrentIrpStackLocation$82$myVar_0: int, inline$IoGetCurrentIrpStackLocation$82$myVar_1: int, inline$BDLGetDebugLevel$740$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$419$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$770$myNondetVar_0: int, inline$BDLGetDebugLevel$327$myNondetVar_0: int, inline$BDLGetDebugLevel$139$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1428.0$29$: int, inline$BDLPnPStart$0$$result.DbgPrint$2005.0$28$: int, inline$BDLGetDebugLevel$162$myNondetVar_0: int, inline$BDLGetDebugLevel$440$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$707$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1: int, inline$IoSetNextIrpStackLocation$15$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLSystemPowerIoCompletion$5$$result.PoRequestPowerIrp$1410.31$27$: int, inline$CallCompletionRoutine$1$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoGetNextIrpStackLocation$6$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.IoSetDeviceInterfaceState$2406.29$14$: int, inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$63$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLSystemPowerIoCompletion$14$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_KeWaitForSingleObject$116.38$5$: int, inline$BDLGetDebugLevel$790$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$25$myVar_1: int, inline$IoGetCurrentIrpStackLocation$25$myVar_0: int, inline$IoGetCurrentIrpStackLocation$18$myNondetVar_0: int, inline$BDLGetDebugLevel$292$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$8$$status$5$438.11$CallCompletionRoutine$4: int, inline$storm_KeAcquireSpinLock$3$$tid$3$128.6$storm_KeAcquireSpinLock$8: int, inline$storm_PoCallDriver$5$$result.storm_IoCallDriver$499.27$2$: int, inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$372$myNondetVar_0: int, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0: int, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1: int, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2: int, inline$BDLGetDebugLevel$646$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$268$myNondetVar_0: int, inline$storm_KeSetEvent$27$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$3$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$707$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLPnPCancelStop$0$$result.BDLCallLowerLevelDriverAndWait$2148.43$13$: int, inline$BDLSystemPowerIoCompletion$4$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPStop$0$$result.DbgPrint$2231.0$28$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$44$: int, inline$IoGetCurrentIrpStackLocation$55$myVar_0: int, inline$IoGetCurrentIrpStackLocation$55$myVar_1: int, inline$BDLGetDebugLevel$720$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12: int, inline$BDLCleanupDataHandles$1$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$10$myNondetVar_0: int, inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$154$havoc_stringTemp: int, inline$BDLGetDebugLevel$531$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1665.0$9$: int, inline$BDLSystemPowerIoCompletion$16$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1358.0$20$: int, inline$storm_IoCompleteRequest$59$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$106$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$30$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$130$myVar_1: int, inline$BDLGetDebugLevel$801$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$694$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$382$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLGetDebugLevel$126$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$43$havoc_stringTemp: int, inline$BDLGetDebugLevel$616$myNondetVar_0: int, inline$storm_IoSetCompletionRoutine$2$$result.storm_nondet$405.2$1$: int, inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$301$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$425$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$264$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$129$myNondetVar_0: int, inline$CallCompletionRoutine$3$$status$5$438.11$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$12$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoGetCurrentIrpStackLocation$22$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_PoCallDriver$104.29$3$: int, inline$IoGetNextIrpStackLocation$9$myVar_0: int, inline$BDLCallDriverCompletionRoutine$0$myNondetVar_0: int, inline$BDLGetDebugLevel$356$myNondetVar_0: int, inline$BDLGetDebugLevel$182$myNondetVar_0: int, inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_KeAcquireSpinLock$1$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8: int, inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1700.0$23$: int, inline$CallCompletionRoutine$6$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$16$$callresult.$1687.68$15$: int, inline$IoGetCurrentIrpStackLocation$121$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLDevicePowerIoCompletion$29$$callresult.$1687.68$15$: int, inline$CallCompletionRoutine$15$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$23$$result.PoSetPowerState$1693.27$16$: int, inline$BDLGetDebugLevel$274$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$13$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLGetDebugLevel$203$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$661$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$13$: int, inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$713$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$24$: int, inline$IoSetNextIrpStackLocation$7$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$206$myNondetVar_0: int, inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$15$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$9$tempBoogie0: int, inline$BDLSystemPowerIoCompletion$1$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1344.0$4$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$33$: int, inline$storm_IoCallDriver$5$$status$4$462.11$storm_IoCallDriver$8: int, inline$IoGetCurrentIrpStackLocation$36$myVar_1: int, inline$IoGetCurrentIrpStackLocation$36$myVar_0: int, inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$353$myNondetVar_0: int, inline$BDLGetDebugLevel$753$myNondetVar_0: int, inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLPnPStop$0$$result.BDLCallLowerLevelDriverAndWait$2227.43$26$: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$562$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$61$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1: int, inline$BDLGetDebugLevel$132$myNondetVar_0: int, inline$BDLGetDebugLevel$654$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$748$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$30$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$storm_IoCompleteRequest$55$$result.storm_nondet$338.2$1$: int, inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$38$: int, inline$BDLGetDebugLevel$234$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$25$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$209$myNondetVar_0: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$65$: int, inline$BDLGetDebugLevel$104$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$154$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$2$: int, inline$IoGetCurrentIrpStackLocation$126$havoc_stringTemp: int, inline$RemoveHeadList$1$myNondetVar_0: int, inline$BDLPnPStop$0$myNondetVar_0: int, inline$BDLGetDebugLevel$271$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$3$$result.PoRequestPowerIrp$1410.31$27$: int, inline$CallCompletionRoutine$7$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLHandleRemove$1$$result.DbgPrint$2465.0$57$: int, inline$BDLCleanupDataHandles$1$$status$2$3245.28$BDLCleanupDataHandles$4: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$51$: int, inline$BDLGetDebugLevel$149$myNondetVar_0: int, inline$BDLGetDebugLevel$645$myNondetVar_0: int, inline$BDLGetDebugLevel$764$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$423$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$715$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$149$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$0$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$112$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$726$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$106$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$154$myVar_1: int, inline$IoGetCurrentIrpStackLocation$154$myVar_0: int, inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$8$: int, inline$storm_IoCompleteRequest$20$$result.storm_nondet$338.2$1$: int, inline$BDLCallDriverCompletionRoutine$17$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLDevicePowerIoCompletion$21$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$RemoveHeadList$5$$result.RemoveHeadList$8121.0$1$: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1344.0$9$: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$102$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1344.0$4$: int, inline$BDLGetDebugLevel$469$myNondetVar_0: int, inline$BDLGetDebugLevel$588$myNondetVar_0: int, inline$BDLGetDebugLevel$514$myNondetVar_0: int, inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLGetDebugLevel$291$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$17$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$26$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$40$: int, inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20: int, inline$BDLGetDebugLevel$273$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1723.0$34$: int, inline$IoGetCurrentIrpStackLocation$22$myVar_0: int, inline$IoGetCurrentIrpStackLocation$22$myVar_1: int, inline$BDLGetFirstHandle$1$myNondetVar_0: int, inline$BDLGetFirstHandle$1$myNondetVar_1: int, inline$BDLSystemPowerIoCompletion$16$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$750$myNondetVar_0: int, inline$storm_IoCompleteRequest$46$$result.storm_nondet$338.2$1$: int, inline$BDLPnP$0$$result.DbgPrint$987.0$37$: int, inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$0$$result.storm_KeWaitForSingleObject$243.0$1$: int, inline$BDLGetDebugLevel$599$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$callresult.$1687.68$15$: int, inline$BDLGetDebugLevel$157$myNondetVar_0: int, inline$BDLGetDebugLevel$528$myNondetVar_0: int, inline$BDLGetDebugLevel$106$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$359$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$230$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$18$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$RemoveHeadList$3$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$13$$callresult.$1687.68$15$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$61$: int, inline$BDLCallLowerLevelDriverAndWait$3$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLDevicePowerIoCompletion$8$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$441$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$710$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$92$myVar_1: int, inline$IoGetCurrentIrpStackLocation$92$myVar_0: int, inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1428.0$34$: int, inline$storm_PoCallDriver$5$$Irp$2$496.14$storm_PoCallDriver$8_.1: int, inline$BDLGetDebugLevel$410$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$136$myNondetVar_0: int, inline$BDLPnPRemove$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$243$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$20$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$14$: int, inline$CallCompletionRoutine$20$$status$5$438.11$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$145$myVar_1: int, inline$IoGetCurrentIrpStackLocation$145$myVar_0: int, inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_IoCallDriver$108.29$4$: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1428.0$34$: int, inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1440.0$40$: int, inline$IoGetCurrentIrpStackLocation$24$myVar_0: int, inline$IoGetCurrentIrpStackLocation$24$myVar_1: int, inline$BDLGetDebugLevel$113$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$20$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$25$: int, inline$BDLDevicePowerIoCompletion$6$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$19$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$30$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$798$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1358.0$15$: int, inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$IoSetNextIrpStackLocation$2$tempBoogie0: int, inline$IoSetNextIrpStackLocation$13$tempBoogie0: int, inline$BDLCallDriverCompletionRoutine$3$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoCopyCurrentIrpStackLocationToNext$0$$result.memcpy$25110.4$3$: int, inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1700.0$23$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLGetDebugLevel$456$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$14$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1440.0$40$: int, inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$92$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$686$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$571$myNondetVar_0: int, inline$BDLGetDebugLevel$198$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$650$myNondetVar_0: int, inline$BDLGetDebugLevel$724$myNondetVar_0: int, inline$BDLGetDebugLevel$164$myNondetVar_0: int, inline$BDLGetDebugLevel$393$myNondetVar_0: int, inline$BDLGetDebugLevel$376$myNondetVar_0: int, inline$storm_IoCallDriver$3$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLDevicePowerIoCompletion$11$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$CallCompletionRoutine$29$$context$2$435.8$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$570$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$9$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$206$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$18$myVar_1: int, inline$IoGetCurrentIrpStackLocation$18$myVar_0: int, inline$BDLGetDebugLevel$549$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$15$myNondetVar_0: int, inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1: int, inline$BDLGetDebugLevel$388$myNondetVar_0: int, inline$BDLGetDebugLevel$529$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$144$myNondetVar_0: int, inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$14$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$204$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$91$myVar_0: int, inline$IoGetCurrentIrpStackLocation$121$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$15$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$138$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$8$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$277$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$4$myVar_0: int, inline$IoSetNextIrpStackLocation$10$havoc_stringTemp: int, inline$storm_KeSetEvent$28$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLSystemPowerIoCompletion$20$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$77$myVar_0: int, inline$IoGetCurrentIrpStackLocation$77$myVar_1: int, inline$BDLReleaseHandleList$1$$pBDLExtension$1$145.40$BDLReleaseHandleList$8_.1: int, inline$IoGetCurrentIrpStackLocation$135$myVar_0: int, inline$IoGetCurrentIrpStackLocation$135$myVar_1: int, inline$BDLGetDebugLevel$614$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$49$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$285$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$93$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$29$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLCallDriverCompletionRoutine$12$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$IoGetNextIrpStackLocation$8$myVar_0: int, inline$BDLGetDebugLevel$672$myNondetVar_0: int, inline$BDLGetDebugLevel$762$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1665.0$4$: int, inline$IoSetNextIrpStackLocation$6$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$26$myNondetVar_0: int, inline$BDLGetDebugLevel$730$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_IoCallDriver$108.29$4$: int, inline$BDLGetDebugLevel$727$myNondetVar_0: int, inline$BDLLockHandleList$1$$pBDLExtension$1$134.40$BDLLockHandleList$8: int, inline$BDLGetDebugLevel$304$myNondetVar_0: int, inline$BDLGetDebugLevel$393$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPCancelStop$0$havoc_stringTemp: int, inline$BDLGetDebugLevel$612$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$130$myVar_0: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$2$: int, inline$BDLGetDebugLevel$392$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPStop$0$$result.DbgPrint$2243.0$44$: int, inline$storm_getThreadID$4$tid: int, inline$BDLDevicePowerIoCompletion$17$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$522$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$30$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$543$myNondetVar_0: int, inline$BDLGetDebugLevel$335$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$436$myNondetVar_0: int, inline$BDLGetDebugLevel$390$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3178.0$22$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$24$: int, inline$IoSetNextIrpStackLocation$14$tempBoogie0: int, inline$IoGetCurrentIrpStackLocation$37$myVar_0: int, inline$IoGetCurrentIrpStackLocation$37$myVar_1: int, inline$BDLGetDebugLevel$39$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$0$$result.IoSetDeviceInterfaceState$2406.29$14$: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$0$myNondetVar_0: int, inline$BDLGetDebugLevel$84$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$51$myNondetVar_0: int, inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$12$: int, inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLDevicePowerIoCompletion$22$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$BDLSystemPowerIoCompletion$16$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$7$: int, inline$BDLGetDebugLevel$462$myNondetVar_0: int, inline$BDLGetDebugLevel$32$myNondetVar_0: int, inline$bdliFree$0$$pvBlock$1$2740.28$bdliFree$4_.1: int, inline$BDLCleanupNotificationStruct$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1358.0$15$: int, inline$storm_KeSetEvent$1$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$245$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$49$: int, inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp: int, inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLSystemPowerIoCompletion$7$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPRemove$0$$status$5$2484.16$BDLPnPRemove$16: int, inline$BDLGetDebugLevel$631$myNondetVar_0: int, inline$BDLGetDebugLevel$52$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLGetDebugLevel$181$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLDevicePowerIoCompletion$10$$result.memset$1683.8$14$: int, inline$storm_KeSetEvent$18$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_IoCallDriver$108.29$4$: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$32$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLGetDebugLevel$324$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$336$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$358$myNondetVar_0: int, inline$BDLGetDebugLevel$406$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLSystemPowerIoCompletion$17$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$11$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$116$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$11$$result.completionRoutine$448.30$3$: int, inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$31$: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$46$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$20$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$21$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$702$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$5$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$30$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$290$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0: int, inline$CallCompletionRoutine$11$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$27$: int, inline$IoGetCurrentIrpStackLocation$9$havoc_stringTemp: int, inline$BDLGetDebugLevel$338$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp: int, inline$BDLPnPStop$0$$result.DbgPrint$2190.0$8$: int, inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1700.0$23$: int, inline$BDLPnPQueryRemove$0$$result.BDLCallLowerLevelDriverAndWait$2287.43$14$: int, inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_IoCancelIrp$0$$oldCancelRoutine$2$347.17$storm_IoCancelIrp$4: int, inline$BDLGetDebugLevel$658$myNondetVar_0: int, inline$BDLGetDebugLevel$30$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$storm_KeSetEvent$16$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLSystemPowerIoCompletion$18$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$39$: int, inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$219$myNondetVar_0: int, inline$BDLGetFirstHandle$0$myNondetVar_1: int, inline$BDLGetFirstHandle$0$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$802$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$520$myNondetVar_0: int, inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$508$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$2$myVar_1: int, inline$IoGetCurrentIrpStackLocation$2$myVar_0: int, inline$BDLGetDebugLevel$195$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$28$: int, inline$storm_getThreadID$1$tid: int, inline$BDLGetDebugLevel$559$myNondetVar_0: int, inline$BDLGetDebugLevel$169$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$474$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$4$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLGetDebugLevel$124$myNondetVar_0: int, inline$BDLGetDebugLevel$305$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$12$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLCallDriverCompletionRoutine$18$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$660$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$27$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$103$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$271$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$36$: int, inline$BDLGetDebugLevel$12$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$3$$result.PoSetPowerState$1693.27$16$: int, inline$BDLGetDebugLevel$444$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$78$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$39$myVar_0: int, inline$IoGetCurrentIrpStackLocation$39$myVar_1: int, inline$BDLDevicePowerIoCompletion$28$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$19$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$133$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$0$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$186$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$33$: int, inline$IoGetCurrentIrpStackLocation$27$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLGetDebugLevel$796$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$117$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$7$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$459$myNondetVar_0: int, inline$CallCompletionRoutine$12$$result.completionRoutine$448.30$3$: int, inline$BDLDevicePowerIoCompletion$13$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$19$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1665.0$9$: int, inline$BDLGetDebugLevel$114$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$21$havoc_stringTemp: int, inline$storm_KeReleaseSpinLock$4$$result.storm_getThreadID$145.0$1$: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$13$: int, inline$IoGetCurrentIrpStackLocation$37$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLCallDriverCompletionRoutine$4$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$CallCompletionRoutine$10$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$110$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$33$: int, inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$571$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$26$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$12$: int, inline$IoGetCurrentIrpStackLocation$34$myVar_1: int, inline$IoGetCurrentIrpStackLocation$34$myVar_0: int, inline$IoGetCurrentIrpStackLocation$7$myNondetVar_0: int, inline$BDLGetDebugLevel$76$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$389$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8: int, inline$IoGetCurrentIrpStackLocation$57$myNondetVar_0: int, inline$BDLGetDebugLevel$655$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$17$: int, inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$44$: int, inline$IoGetCurrentIrpStackLocation$133$myVar_0: int, inline$IoGetCurrentIrpStackLocation$133$myVar_1: int, inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp: int, inline$BDLGetDebugLevel$653$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$684$myNondetVar_0: int, inline$BDLGetDebugLevel$784$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$703$myNondetVar_0: int, inline$BDLGetDebugLevel$212$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1440.0$40$: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLDevicePowerIoCompletion$13$myNondetVar_0: int, inline$BDLGetDebugLevel$213$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$479$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1665.0$9$: int, inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$CallCompletionRoutine$9$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$745$myNondetVar_0: int, inline$BDLGetDebugLevel$443$myNondetVar_0: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$12$: int, inline$IoGetCurrentIrpStackLocation$47$myVar_1: int, inline$IoGetCurrentIrpStackLocation$47$myVar_0: int, inline$storm_KeInitializeEvent$3$$State$3$205.13$storm_KeInitializeEvent$12: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$14$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$4$$result.memset$1683.8$14$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLSystemPowerIoCompletion$3$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$6$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$396$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$150$havoc_stringTemp: int, inline$storm_IoCallDriver$9$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$765$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$28$: int, inline$IoGetCurrentIrpStackLocation$70$myNondetVar_0: int, inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLSystemPowerIoCompletion$29$$result.PoRequestPowerIrp$1410.31$27$: int, inline$CallCompletionRoutine$21$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1344.0$4$: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$13$: int, inline$IoGetCurrentIrpStackLocation$87$myVar_1: int, inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IsListEmpty$4$$ListHead$1$8097.28$IsListEmpty$4_.1: int, inline$BDLGetDebugLevel$91$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$58$myVar_1: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1428.0$34$: int, inline$BDLGetDebugLevel$422$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3231.0$37$: int, inline$BDLDevicePowerIoCompletion$6$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$8$: int, inline$IoGetCurrentIrpStackLocation$123$havoc_stringTemp: int, inline$BDLCallDriverCompletionRoutine$11$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$298$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$19$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$95$myVar_0: int, inline$IoGetCurrentIrpStackLocation$95$myVar_1: int, inline$BDLGetDebugLevel$693$myNondetVar_0: int, inline$BDLGetDebugLevel$559$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$445$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$118$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$68$myNondetVar_0: int, inline$CallCompletionRoutine$14$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$267$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp: int, inline$storm_thread_cancel$0$$Irp$1$64.5$storm_thread_cancel$4_.1: int, inline$BDLDevicePowerIoCompletion$4$$callresult.$1687.68$15$: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$1$: int, inline$IoGetCurrentIrpStackLocation$128$myNondetVar_0: int, inline$BDLGetDebugLevel$248$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$791$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$221$myNondetVar_0: int, inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$10$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_PoCallDriver$2$$Irp$2$496.14$storm_PoCallDriver$8: int, inline$storm_IoCallDriver$3$$result.storm_nondet$465.2$2$: int, inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12: int, inline$BDLHandleRemove$1$$result.DbgPrint$2386.0$3$: int, inline$BDLGetDebugLevel$795$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$17$: int, inline$storm_KeSetEvent$21$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLSystemPowerIoCompletion$30$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$7$: int, inline$BDLGetDebugLevel$625$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$29$myVar_1: int, inline$IoGetCurrentIrpStackLocation$29$myVar_0: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLPnPRemove$0$$result.DbgPrint$2516.0$20$: int, inline$BDLDevicePowerIoCompletion$23$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$24$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$691$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLReleaseHandleList$0$$pBDLExtension$1$145.40$BDLReleaseHandleList$8: int, inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$17$: int, inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetNextIrpStackLocation$0$havoc_stringTemp: int, inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$20$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$320$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$20$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$746$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1: int, inline$CallCompletionRoutine$22$$result.completionRoutine$448.30$3$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$37$: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLCallLowerLevelDriverAndWait$4$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLGetDebugLevel$295$myNondetVar_0: int, inline$CallCompletionRoutine$0$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$72$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1428.0$34$: int, inline$IoSetNextIrpStackLocation$6$havoc_stringTemp: int, inline$IoSetNextIrpStackLocation$4$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$5$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$558$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$244$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoGetNextIrpStackLocation$1$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1344.0$4$: int, inline$BDLPnPCancelRemove$0$$result.IoSetDeviceInterfaceState$2349.38$25$: int, inline$IoGetCurrentIrpStackLocation$2$havoc_stringTemp: int, inline$BDLGetDebugLevel$218$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$18$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1723.0$34$: int, inline$IoGetCurrentIrpStackLocation$5$havoc_stringTemp: int, inline$BDLPnPStart$0$$result.DbgPrint$2005.0$33$: int, inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_KeWaitForSingleObject$116.38$5$: int, inline$BDLGetDebugLevel$385$myNondetVar_0: int, inline$BDLLockHandleList$0$$pBDLExtension$1$134.40$BDLLockHandleList$8_.1: int, inline$IoGetCurrentIrpStackLocation$125$havoc_stringTemp: int, inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLGetDebugLevel$627$myNondetVar_0: int, inline$BDLGetDebugLevel$568$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$5$myVar_0: int, inline$BDLSystemPowerIoCompletion$23$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp: int, inline$BDLCleanupNotificationStruct$0$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$myNondetVar_1: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$334$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$6$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$8$: int, inline$storm_IoCallDriver$2$$result.storm_nondet$465.2$2$: int, inline$BDLGetDebugLevel$136$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp: int, inline$BDLCallDriverCompletionRoutine$8$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$330$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1440.0$45$: int, inline$BDLSystemPowerIoCompletion$14$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$677$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8: int, inline$BDLPnPQueryStop$0$$pIrp$3$2078.40$BDLPnPQueryStop$12_.1: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$443$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$50$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$17$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1344.0$4$: int, inline$BDLCallDriverCompletionRoutine$29$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1358.0$15$: int, inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1428.0$29$: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLPnPCancelStop$0$$result.DbgPrint$2152.0$15$: int, inline$BDLDevicePowerIoCompletion$28$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$29$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$15$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$IoGetNextIrpStackLocation$4$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$23$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLGetDebugLevel$253$myNondetVar_0: int, inline$BDLGetDebugLevel$498$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$27$$context$2$435.8$CallCompletionRoutine$4: int, inline$CallCompletionRoutine$13$$result.completionRoutine$448.30$3$: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$2$: int, inline$BDLGetDebugLevel$85$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$31$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$9$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$336$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$38$: int, inline$IoGetCurrentIrpStackLocation$138$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$27$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$44$: int, inline$IoGetCurrentIrpStackLocation$26$myVar_0: int, inline$IoGetCurrentIrpStackLocation$26$myVar_1: int, inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$26$: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1358.0$15$: int, inline$BDLGetDebugLevel$372$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$653$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1665.0$4$: int, inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_KeWaitForSingleObject$116.38$5$: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1440.0$45$: int, inline$BDLSystemPowerIoCompletion$18$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLCallDriverCompletionRoutine$29$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4: int, inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$22$: int, inline$storm_IoCompleteRequest$11$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$642$myNondetVar_0: int, inline$storm_KeSetEvent$5$$Event$1$213.14$storm_KeSetEvent$12: int, inline$storm_KeAcquireSpinLock$1$$result.storm_getThreadID$128.29$1$: int, inline$IoGetCurrentIrpStackLocation$56$myVar_1: int, inline$IoGetCurrentIrpStackLocation$56$myVar_0: int, inline$BDLDevicePowerIoCompletion$7$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$6$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLHandleRemove$1$$callresult.$2419.71$15$: int, inline$BDLGetDebugLevel$418$myNondetVar_0: int, inline$BDLGetDebugLevel$49$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$543$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$106$myVar_0: int, inline$IoGetCurrentIrpStackLocation$106$myVar_1: int, inline$BDLGetDebugLevel$452$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1440.0$45$: int, inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$387$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$101$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$627$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$14$: int, inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp: int, inline$BDLGetDebugLevel$557$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$360$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$31$: int, inline$BDLGetDebugLevel$251$myNondetVar_0: int, inline$BDLGetDebugLevel$460$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1723.0$29$: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$8$: int, inline$storm_IoCompleteRequest$37$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$383$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLSystemPowerIoCompletion$7$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$0$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24: int, inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$IoGetCurrentIrpStackLocation$27$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$26$$callresult.$1687.68$15$: int, inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$49$: int, inline$IoGetCurrentIrpStackLocation$144$havoc_stringTemp: int, inline$BDLGetDebugLevel$449$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$3$$callresult.$1687.68$15$: int, inline$BDLGetDebugLevel$546$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$5$havoc_stringTemp: int, inline$BDLGetDebugLevel$383$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_KeSetEvent$33$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$134$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$27$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLCallDriverCompletionRoutine$9$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$8$: int, inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$13$: int, inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoCopyCurrentIrpStackLocationToNext$4$$result.memcpy$25110.4$3$: int, inline$BDLDevicePowerIoCompletion$25$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$237$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$325$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$199$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1665.0$4$: int, inline$storm_thread_cancel$0$$Irp$1$64.5$storm_thread_cancel$4: int, inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLGetDebugLevel$121$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$795$myNondetVar_0: int, inline$BDLHandleRemove$0$$result.DbgPrint$2423.0$17$: int, inline$BDLGetDebugLevel$16$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$327$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$24$: int, inline$IoGetCurrentIrpStackLocation$87$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$20$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$48$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$19$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$117$myVar_0: int, inline$IoGetCurrentIrpStackLocation$117$myVar_1: int, inline$BDLSystemPowerIoCompletion$20$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$711$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$15$$result.completionRoutine$448.30$3$: int, inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$701$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$142$myVar_0: int, inline$IoGetCurrentIrpStackLocation$142$myVar_1: int, inline$BDLCallDriverCompletionRoutine$2$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$57$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1428.0$29$: int, inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$663$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$18$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$123$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$26$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLCallDriverCompletionRoutine$20$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLDevicePowerIoCompletion$17$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1665.0$4$: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1428.0$29$: int, inline$IoGetCurrentIrpStackLocation$15$myNondetVar_0: int, inline$BDLGetDebugLevel$60$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$545$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLGetDebugLevel$757$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeWaitForSingleObject$2$$result.storm_nondet$256.20$2$: int, inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLHandleRemove$1$$callresult.$2437.63$27$: int, inline$BDLGetDebugLevel$339$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$19$myVar_0: int, inline$IoGetCurrentIrpStackLocation$19$myVar_1: int, inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$5$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1: int, inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$60$myVar_0: int, inline$IoGetCurrentIrpStackLocation$60$myVar_1: int, inline$BDLDevicePowerIoCompletion$8$$result.PoSetPowerState$1693.27$16$: int, inline$IoSetNextIrpStackLocation$1$myVar_0: int, inline$BDLGetDebugLevel$674$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$695$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$27$myVar_1: int, inline$IoGetCurrentIrpStackLocation$27$myVar_0: int, inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$293$myNondetVar_0: int, inline$CallCompletionRoutine$24$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1428.0$29$: int, inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLCleanupDataHandles$0$$irql$6$3249.28$BDLCleanupDataHandles$4: int, inline$IoGetCurrentIrpStackLocation$95$myNondetVar_0: int, inline$BDLGetDebugLevel$680$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$482$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$466$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$685$myNondetVar_0: int, inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLCallDriverCompletionRoutine$27$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLGetDebugLevel$592$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$2$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLGetDebugLevel$524$myNondetVar_0: int, inline$BDLGetDebugLevel$282$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1358.0$15$: int, inline$BDLCleanupNotificationStruct$1$$callresult.$3172.84$15$: int, inline$BDLSystemPowerIoCompletion$2$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$438$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$4$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLGetDebugLevel$220$myNondetVar_0: int, inline$BDLGetDebugLevel$366$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeReleaseSpinLock$5$$result.storm_getThreadID$145.0$1$: int, inline$BDLGetDebugLevel$111$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$14$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$36$: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$15$: int, inline$storm_IoCompleteRequest$61$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$123$myVar_1: int, inline$IoGetCurrentIrpStackLocation$123$myVar_0: int, inline$BDLPnPCancelStop$0$$pBDLExtension$1$2132.40$BDLPnPCancelStop$12_.1: int, inline$BDLGetDebugLevel$300$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCallDriverCompletionRoutine$20$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLPnPStop$0$$result.IoSetDeviceInterfaceState$2199.29$13$: int, $irp$1$96.7$storm_main$0: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$3$: int, inline$storm_IoCallDriver$13$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1700.0$18$: int, inline$storm_KeSetEvent$29$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$341$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$121$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$137$myVar_0: int, inline$IoGetCurrentIrpStackLocation$137$myVar_1: int, inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4: int, inline$BDLSystemPowerIoCompletion$15$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLSystemPowerIoCompletion$8$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1428.0$29$: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLGetDebugLevel$191$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetNextIrpStackLocation$11$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$19$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$90$myNondetVar_0: int, inline$BDLGetDebugLevel$278$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$156$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp: int, inline$BDLGetDebugLevel$486$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnP$0$$IoAcquireRemoveLockEx.arg.3$15$: int, inline$BDLGetDebugLevel$10$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$160$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$10$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$IsListEmpty$1$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1358.0$20$: int, inline$BDLGetDebugLevel$677$myNondetVar_0: int, inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$32$myVar_1: int, inline$IoGetCurrentIrpStackLocation$32$myVar_0: int, inline$storm_KeSetEvent$2$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$270$myNondetVar_0: int, inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20: int, inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$16$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$18$$result.PoSetPowerState$1693.27$16$: int, inline$storm_IoCompleteRequest$48$$result.storm_nondet$338.2$1$: int, inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1700.0$18$: int, inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$242$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$0$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$IoGetCurrentIrpStackLocation$16$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$97$myVar_0: int, inline$IoGetCurrentIrpStackLocation$97$myVar_1: int, inline$BDLSystemPowerIoCompletion$14$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$83$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1700.0$18$: int, inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1700.0$23$: int, inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$IoSetNextIrpStackLocation$12$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1723.0$34$: int, inline$BDLPnPQueryStop$0$$result.DbgPrint$2085.0$8$: int, inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLCallDriverCompletionRoutine$16$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$storm_IoCompleteRequest$62$$result.storm_nondet$338.2$1$: int, inline$BDLSystemPowerIoCompletion$18$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$IoSetNextIrpStackLocation$0$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLGetDebugLevel$88$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$17$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$49$: int, inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$38$: int, inline$storm_KeSetEvent$8$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$735$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$21$$result.completionRoutine$448.30$3$: int, inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20: int, inline$storm_IoCallDriver$14$$result.storm_nondet$465.2$2$: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLGetDebugLevel$77$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$496$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$3$: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1440.0$45$: int, inline$BDLGetDebugLevel$621$myNondetVar_0: int, inline$storm_KeSetEvent$20$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$storm_IoCompleteRequest$17$$result.storm_nondet$338.2$1$: int, inline$bdliFree$1$$pvBlock$1$2740.28$bdliFree$4: int, inline$BDLPnP$0$myVar_0: int, inline$BDLGetDebugLevel$255$myNondetVar_0: int, inline$BDLGetDebugLevel$487$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$413$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$10$myVar_0: int, inline$BDLGetDebugLevel$333$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$592$myNondetVar_0: int, inline$BDLGetDebugLevel$632$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$15$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$28$: int, inline$IsListEmpty$1$$ListHead$1$8097.28$IsListEmpty$4_.1: int, inline$BDLGetDebugLevel$484$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$484$myNondetVar_0: int, inline$BDLGetDebugLevel$245$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$24$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$113$myVar_0: int, inline$IoGetCurrentIrpStackLocation$113$myVar_1: int, inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$598$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$14$: int, inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$719$myNondetVar_0: int, inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$CallCompletionRoutine$13$myNondetVar_0: int, inline$BDLGetDebugLevel$162$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$2$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$38$: int, inline$storm_IoCompleteRequest$31$$result.storm_nondet$338.2$1$: int, inline$BDLGetDebugLevel$552$myNondetVar_0: int, inline$BDLHandleRemove$1$$result.DbgPrint$2441.0$29$: int, inline$BDLGetDebugLevel$257$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$7$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLSystemPowerIoCompletion$1$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$storm_IoCallDriver$11$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$3$: int, inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$17$: int, inline$IoGetCurrentIrpStackLocation$6$myVar_1: int, inline$IoGetCurrentIrpStackLocation$6$myVar_0: int, inline$IoGetCurrentIrpStackLocation$110$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLGetDebugLevel$600$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1358.0$15$: int, inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1344.0$9$: int, inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1358.0$15$: int, inline$BDLSystemPowerIoCompletion$27$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$449$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$30$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$78$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$9$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLCallDriverCompletionRoutine$25$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLSystemPowerIoCompletion$27$$result.PoRequestPowerIrp$1410.31$27$: int, inline$CallCompletionRoutine$23$$context$2$435.8$CallCompletionRoutine$4: int, inline$storm_KeSetEvent$3$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$81$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$661$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$79$havoc_stringTemp: int, inline$BDLPnPCancelStop$0$$status$4$2137.16$BDLPnPCancelStop$12: int, inline$BDLSystemPowerIoCompletion$24$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLGetDebugLevel$622$myNondetVar_0: int, inline$storm_IoCallDriver$13$$result.storm_nondet$472.22$4$: int, inline$IoSkipCurrentIrpStackLocation$1$myVar_0: int, inline$IoSkipCurrentIrpStackLocation$1$myVar_1: int, inline$BDLGetDebugLevel$164$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupDeviceCapabilities$0$$i$3$1733.10$BDLCleanupDeviceCapabilities$4: int, inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$61$havoc_stringTemp: int, inline$BDLGetDebugLevel$411$myNondetVar_0: int, inline$BDLGetDebugLevel$526$myNondetVar_0: int, inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1: int, inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLCleanupNotificationStruct$1$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4: int, inline$IoSetNextIrpStackLocation$9$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1344.0$9$: int, inline$BDLSystemPowerIoCompletion$6$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLDevicePowerIoCompletion$10$$result.PoSetPowerState$1693.27$16$: int, inline$IoGetCurrentIrpStackLocation$8$myVar_1: int, inline$IoGetCurrentIrpStackLocation$8$myVar_0: int, inline$storm_KeInitializeSpinLock$0$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1: int, inline$BDLDevicePowerIoCompletion$13$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp: int, inline$BDLGetDebugLevel$87$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1700.0$18$: int, inline$BDLGetDebugLevel$15$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$22$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$33$: int, inline$storm_KeSetEvent$14$$Event$1$213.14$storm_KeSetEvent$12: int, inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$721$myNondetVar_0: int, inline$BDLGetDebugLevel$802$myNondetVar_0: int, inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$IoGetCurrentIrpStackLocation$76$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$89$myNondetVar_0: int, inline$BDLGetDebugLevel$467$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$736$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$47$: int, inline$BDLSystemPowerIoCompletion$18$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$7$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8: int, inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$13$: int, inline$storm_KeInitializeEvent$4$$State$3$205.13$storm_KeInitializeEvent$12_.1: int, inline$IoGetCurrentIrpStackLocation$11$myVar_0: int, inline$BDLGetDebugLevel$608$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$1$$status$11$3121.36$BDLCleanupNotificationStruct$4: int, inline$storm_KeSetEvent$4$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$454$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1665.0$9$: int, inline$IoGetCurrentIrpStackLocation$101$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLDevicePowerIoCompletion$1$$result.PoSetPowerState$1693.27$16$: int, inline$BDLDevicePowerIoCompletion$22$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLDevicePowerIoCompletion$2$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$storm_IoAllocateIrp$0$$result.malloc$279.0$4$: int, inline$BDLGetDebugLevel$179$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$result.PoSetPowerState$1693.27$16$: int, inline$BDLSystemPowerIoCompletion$6$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$514$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeSetEvent$6$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLDevicePowerIoCompletion$22$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1: int, inline$BDLGetDebugLevel$215$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$21$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$23$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$33$: int, inline$BDLGetDebugLevel$741$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$23$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$738$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1723.0$34$: int, inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$BDLGetDebugLevel$173$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1428.0$29$: int, inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1344.0$9$: int, inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$26$: int, inline$storm_IoCompleteRequest$54$$result.storm_nondet$338.2$1$: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12: int, inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1723.0$34$: int, inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$757$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$39$: int, inline$storm_IoCompleteRequest$38$$result.storm_nondet$338.2$1$: int, inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLGetDebugLevel$674$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8: int, inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$675$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$705$myNondetVar_0: int, inline$BDLGetDebugLevel$778$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$19$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$759$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeInitializeSpinLock$3$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4: int, inline$BDLSystemPowerIoCompletion$13$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$744$myNondetVar_0: int, inline$BDLGetDebugLevel$315$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$711$myNondetVar_0: int, inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8: int, inline$BDLGetDebugLevel$226$myNondetVar_0: int, inline$storm_KeInitializeSpinLock$2$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4: int, inline$BDLHandleRemove$0$$result.DbgPrint$2457.0$46$: int, inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$554$myNondetVar_0: int, inline$BDLGetDebugLevel$594$myNondetVar_0: int, inline$BDLGetDebugLevel$12$myNondetVar_0: int, inline$BDLGetDebugLevel$704$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$45$: int, inline$BDLDevicePowerIoCompletion$1$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1723.0$29$: int, inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$14$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_KeSetEvent$11$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$656$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPRemove$0$$pAttachedDeviceObject$3$2480.40$BDLPnPRemove$16: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1358.0$15$: int, inline$BDLPnPQueryRemove$0$$result.DbgPrint$2291.0$21$: int, inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_KeInitializeEvent$1$$State$3$205.13$storm_KeInitializeEvent$12: int, inline$storm_IoCallDriver$13$$result.storm_IoCallDriver$456.0$1$: int, inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1428.0$34$: int, inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$134$myVar_1: int, inline$IoGetCurrentIrpStackLocation$134$myVar_0: int, inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$13$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLGetDebugLevel$180$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$107$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$5$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLHandleRemove$0$$result.DbgPrint$2465.0$52$: int, inline$IsListEmpty$2$$ListHead$1$8097.28$IsListEmpty$4: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$38$: int, inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$8$: int, inline$IoGetCurrentIrpStackLocation$82$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLPnPCancelStop$0$$result.BDLPnPCancelStop$2130.0$1$: int, inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$12$: int, inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$8$: int, inline$IoGetCurrentIrpStackLocation$4$myNondetVar_0: int, inline$BDLPnPStart$0$$result.DbgPrint$1966.0$8$: int, inline$storm_KeSetEvent$22$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLGetDebugLevel$152$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$39$: int, inline$BDLGetDebugLevel$537$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$23$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$590$myNondetVar_0: int, inline$BDLGetDebugLevel$655$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$40$myNondetVar_0: int, inline$BDLGetDebugLevel$137$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$646$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$3$: int, inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$78$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1723.0$34$: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLDevicePowerIoCompletion$10$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$41$: int, inline$IoGetCurrentIrpStackLocation$46$havoc_stringTemp: int, inline$CallCompletionRoutine$16$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$result.PoRequestPowerIrp$1410.31$27$: int, inline$IoGetCurrentIrpStackLocation$114$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$21$$callresult.$1687.68$15$: int, inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLGetDebugLevel$342$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$21$: int, inline$BDLGetDebugLevel$688$myNondetVar_0: int, inline$BDLGetDebugLevel$42$myNondetVar_0: int, inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$7$: int, inline$BDLGetDebugLevel$682$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$106$havoc_stringTemp: int, inline$CallCompletionRoutine$29$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$result.DbgPrint$3251.0$2$: int, inline$BDLGetDebugLevel$381$myNondetVar_0: int, inline$BDLGetDebugLevel$760$myNondetVar_0: int, inline$storm_IoCallDriver$1$$result.storm_IoCallDriver$456.0$1$: int, inline$BDLGetDebugLevel$708$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$135$havoc_stringTemp: int, inline$RemoveHeadList$4$myNondetVar_0: int, inline$BDLGetDebugLevel$280$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$583$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1700.0$18$: int, inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12_.1: int, inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1440.0$40$: int, inline$BDLGetDebugLevel$728$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeAcquireSpinLock$4$$result.storm_getThreadID$128.29$1$: int, inline$BDLDevicePowerIoCompletion$27$$result.memset$1683.8$14$: int, inline$BDLGetDebugLevel$5$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$74$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$$result.memset$1683.8$14$: int, inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8: int, inline$BDLGetDebugLevel$47$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$38$: int, inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1440.0$40$: int, inline$BDLSystemPowerIoCompletion$7$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLSystemPowerIoCompletion$16$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$28$: int, inline$BDLDevicePowerIoCompletion$21$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$22$: int, inline$BDLDevicePowerIoCompletion$27$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$19$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$7$$callresult.$1687.68$15$: int, inline$BDLGetDebugLevel$97$myNondetVar_0: int, inline$IoSetNextIrpStackLocation$3$myNondetVar_0: int, inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$storm_KeSetEvent$24$$Event$1$213.14$storm_KeSetEvent$12: int, inline$BDLCallDriverCompletionRoutine$2$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLGetDebugLevel$100$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$45$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1344.0$9$: int, inline$BDLGetDebugLevel$566$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$27$: int, inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1: int, inline$BDLDevicePowerIoCompletion$4$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$773$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$101$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$38$: int, inline$BDLGetDebugLevel$340$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$199$myNondetVar_0: int, inline$BDLGetDebugLevel$365$myNondetVar_0: int, inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$BDLGetDebugLevel$684$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3231.0$32$: int, inline$BDLGetDebugLevel$152$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$58$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$118$havoc_stringTemp: int, inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1700.0$23$: int, inline$BDLGetDebugLevel$535$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8: int, inline$BDLGetDebugLevel$265$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$13$: int, inline$BDLGetDebugLevel$572$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp: int, inline$BDLGetDebugLevel$462$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$13$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1665.0$9$: int, inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1723.0$34$: int, inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_KeWaitForSingleObject$116.38$5$: int, inline$BDLGetDebugLevel$781$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1440.0$45$: int, inline$IoGetCurrentIrpStackLocation$9$myNondetVar_0: int, inline$BDLGetDebugLevel$55$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1723.0$29$: int, inline$BDLGetDebugLevel$373$myNondetVar_0: int, inline$BDLCleanupDataHandles$1$myNondetVar_0: int, inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$IoGetCurrentIrpStackLocation$44$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLGetDebugLevel$466$myNondetVar_0: int, inline$BDLGetDebugLevel$744$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1428.0$34$: int, inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_PoCallDriver$104.29$3$: int, inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1700.0$23$: int, inline$BDLSystemPowerIoCompletion$17$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1700.0$23$: int, inline$storm_KeReleaseSpinLock$2$$result.storm_getThreadID$145.0$1$: int, inline$IoSetNextIrpStackLocation$13$havoc_stringTemp: int, inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3123.0$7$: int, inline$BDLDevicePowerIoCompletion$15$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLGetDebugLevel$175$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$565$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$19$: int, inline$IoGetCurrentIrpStackLocation$1$myVar_0: int, inline$IoGetCurrentIrpStackLocation$1$myVar_1: int, inline$BDLGetDebugLevel$671$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4: int, inline$BDLGetDebugLevel$533$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLCleanupDataHandles$0$$bddiCloseHandleParams$5$3248.28$BDLCleanupDataHandles$4: int, inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$758$myNondetVar_0: int, inline$BDLPnPStart$0$$result.DbgPrint$1979.0$15$: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoGetCurrentIrpStackLocation$45$myVar_1: int, inline$IoGetCurrentIrpStackLocation$45$myVar_0: int, inline$BDLDevicePowerIoCompletion$18$$callresult.$1687.68$15$: int, inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$635$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$28$: int, inline$BDLGetDebugLevel$407$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLGetDebugLevel$507$myNondetVar_0: int, inline$BDLGetDebugLevel$286$myNondetVar_0: int, inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$101$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$87$myVar_0: int, inline$BDLSystemPowerIoCompletion$10$$Context$3$1335.24$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$27$: int, inline$BDLPnPQueryRemove$0$$pIrp$3$2258.40$BDLPnPQueryRemove$12_.1: int, inline$BDLGetDebugLevel$585$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$4$myVar_1: int, inline$IoGetCurrentIrpStackLocation$4$myVar_0: int, inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$3$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$46$myNondetVar_0: int, inline$storm_IoCallDriver$0$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$248$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1428.0$29$: int, inline$storm_KeReleaseSpinLock$3$$result.storm_getThreadID$145.0$1$: int, inline$BDLGetDebugLevel$242$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$3$: int, inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$154$myNondetVar_0: int, inline$storm_IoCancelIrp$0$myNondetVar_0: int, inline$storm_IoCancelIrp$0$myNondetVar_1: int, inline$CallCompletionRoutine$22$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$7$myVar_1: int, inline$BDLGetDebugLevel$337$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1440.0$40$: int, inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$797$myNondetVar_0: int, inline$BDLPnPQueryStop$0$$result.DbgPrint$2119.0$20$: int, inline$IoGetNextIrpStackLocation$7$myVar_0: int, inline$CallCompletionRoutine$10$$context$2$435.8$CallCompletionRoutine$4: int, inline$BDLDevicePowerIoCompletion$8$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$368$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$703$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$27$$result.IoGetCurrentIrpStackLocation$1661.86$2$: int, inline$BDLGetDebugLevel$504$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$16$$status$5$438.11$CallCompletionRoutine$4: int, inline$CallCompletionRoutine$20$$result.completionRoutine$448.30$3$: int, inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$33$: int, inline$IoGetNextIrpStackLocation$12$myVar_0: int, inline$BDLGetDebugLevel$448$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$137$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$14$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1: int, inline$IoGetCurrentIrpStackLocation$106$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4: int, inline$BDLGetDebugLevel$321$myNondetVar_0: int, inline$BDLGetDebugLevel$518$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$21$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12: int, inline$BDLGetDebugLevel$536$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$25$myNondetVar_0: int, inline$BDLGetDebugLevel$463$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$14$havoc_stringTemp: int, inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1: int, inline$BDLGetDebugLevel$698$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$561$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$645$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$145$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$108$myNondetVar_0: int, inline$storm_IoCompleteRequest$7$$result.storm_nondet$338.2$1$: int, inline$BDLSystemPowerIoCompletion$25$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLPnPStart$0$$result.IoSetDeviceInterfaceState$2033.38$41$: int, inline$BDLDevicePowerIoCompletion$0$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$29$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$313$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$0$$callresult.$1687.68$15$: int, inline$BDLSystemPowerIoCompletion$2$$result.PoRequestPowerIrp$1410.31$27$: int, inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$3$: int, inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$BDLDevicePowerIoCompletion$17$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12: int, inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$28$: int, inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$IoGetCurrentIrpStackLocation$29$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1440.0$40$: int, inline$IoGetCurrentIrpStackLocation$81$havoc_stringTemp: int, inline$IoSetNextIrpStackLocation$7$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLGetDebugLevel$178$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$11$$callresult.$1687.68$15$: int, inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4_.1: int, inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1665.0$9$: int, inline$IoGetCurrentIrpStackLocation$121$myVar_1: int, inline$IoGetCurrentIrpStackLocation$121$myVar_0: int, inline$BDLGetDebugLevel$361$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$2$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1: int, inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$IoGetCurrentIrpStackLocation$149$myVar_1: int, inline$IoGetCurrentIrpStackLocation$149$myVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1344.0$4$: int, inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8_.1: int, inline$storm_KeSetEvent$30$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$IoSkipCurrentIrpStackLocation$0$tempBoogie0: int, inline$BDLSystemPowerIoCompletion$13$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$159$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$24$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$777$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$9$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1: int, inline$BDLGetDebugLevel$431$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1358.0$15$: int, inline$CallCompletionRoutine$10$myNondetVar_0: int, inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$26$: int, inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$14$: int, inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$13$: int, inline$BDLGetDebugLevel$148$myNondetVar_0: int, inline$BDLCallDriverCompletionRoutine$17$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLSystemPowerIoCompletion$22$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLGetDebugLevel$534$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLDevicePowerIoCompletion$27$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1344.0$9$: int, inline$BDLCallLowerLevelDriverAndWait$2$havoc_stringTemp: int, inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8_.1: int, inline$BDLSystemPowerIoCompletion$26$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$391$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$19$: int, inline$BDLDevicePowerIoCompletion$1$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$17$: int, inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$3$: int, inline$CallCompletionRoutine$28$$status$5$438.11$CallCompletionRoutine$4: int, inline$BDLPnPSurpriseRemoval$0$$pBDLExtension$1$2529.40$BDLPnPSurpriseRemoval$12: int, inline$IoGetCurrentIrpStackLocation$57$havoc_stringTemp: int, inline$BDLGetDebugLevel$134$myNondetVar_0: int, inline$BDLGetDebugLevel$346$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCallDriverCompletionRoutine$21$myNondetVar_0: int, inline$BDLGetDebugLevel$706$myNondetVar_0: int, inline$BDLGetDebugLevel$476$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$398$myNondetVar_0: int, inline$storm_KeInitializeSpinLock$2$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1: int, inline$storm_PoCallDriver$2$$result.storm_IoCallDriver$499.27$2$: int, inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$31$: int, inline$BDLGetDebugLevel$112$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$648$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp: int, inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLSystemPowerIoCompletion$1331.0$1$: int, inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$8$: int, inline$BDLSystemPowerIoCompletion$25$$result.PoRequestPowerIrp$1410.31$27$: int, inline$storm_KeSetEvent$31$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$storm_IoCallDriver$8$$result.storm_nondet$472.22$4$: int, inline$BDLGetDebugLevel$70$$result.BDLGetDebugLevel$39.0$1$: int, inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4: int, inline$BDLGetDebugLevel$560$$result.BDLGetDebugLevel$39.0$1$: int, inline$IoGetCurrentIrpStackLocation$32$$result.IoGetCurrentIrpStackLocation$24489.0$1$: int, inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$1$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$19$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$18$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4: int, inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$IoGetCurrentIrpStackLocation$34$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$145$havoc_stringTemp: int, inline$BDLGetDebugLevel$777$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$563$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLReleaseHandleList$0$myNondetVar_1: int, inline$BDLReleaseHandleList$0$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$9$$result.PoSetPowerState$1693.27$16$: int, inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_KeWaitForSingleObject$116.38$5$: int, inline$BDLDevicePowerIoCompletion$21$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12: int, inline$storm_IoCallDriver$8$$status$4$462.11$storm_IoCallDriver$8: int, inline$BDLPnPQueryStop$0$$irql$5$2082.16$BDLPnPQueryStop$12: int, inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1440.0$40$: int, inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1723.0$34$: int, inline$BDLGetDebugLevel$93$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$6$: int, inline$BDLGetDebugLevel$517$myNondetVar_0: int, inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4_.1: int, inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1: int, inline$BDLGetDebugLevel$480$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1665.0$4$: int, inline$BDLGetDebugLevel$181$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$24$: int, inline$BDLSystemPowerIoCompletion$28$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12: int, inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1665.0$9$: int, inline$BDLDevicePowerIoCompletion$7$$result.BDLDevicePowerIoCompletion$1651.0$1$: int, inline$BDLGetDebugLevel$352$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$11$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12: int, inline$BDLGetDebugLevel$542$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLGetDebugLevel$691$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLDevicePowerIoCompletion$26$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12: int, inline$BDLGetDebugLevel$357$myNondetVar_0: int, inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1: int, inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8_.1: int, inline$BDLPnP$0$$result.DbgPrint$1023.0$54$: int, inline$BDLPnPSurpriseRemoval$0$$result.BDLPnPSurpriseRemoval$2527.0$1$: int, inline$BDLCallDriverCompletionRoutine$18$$result.BDLCallDriverCompletionRoutine$46.0$1$: int, inline$BDLPnPCancelStop$0$$result.DbgPrint$2169.0$32$: int, inline$BDLGetDebugLevel$644$myNondetVar_0: int, inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$44$: int, inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$33$: int, inline$BDLDevicePowerIoCompletion$8$$Context$3$1655.24$BDLDevicePowerIoCompletion$12: int, inline$IoGetCurrentIrpStackLocation$7$myVar_0: int, inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$27$: int, inline$BDLGetDebugLevel$465$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1428.0$29$: int, inline$BDLGetDebugLevel$91$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp: int, inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$22$: int, inline$IoGetCurrentIrpStackLocation$141$myNondetVar_0: int, inline$BDLGetDebugLevel$488$myNondetVar_0: int, inline$storm_KeSetEvent$22$$Event$1$213.14$storm_KeSetEvent$12_.1: int, inline$BDLGetDebugLevel$146$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20: int, inline$BDLGetDebugLevel$468$myNondetVar_0: int, inline$BDLGetDebugLevel$1$myNondetVar_0: int, inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4: int, inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$8$: int, inline$BDLSystemPowerIoCompletion$22$myNondetVar_0: int, inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1700.0$23$: int, inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8: int, inline$BDLGetDebugLevel$26$$result.BDLGetDebugLevel$39.0$1$: int, inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8: int, inline$BDLGetDebugLevel$155$$result.BDLGetDebugLevel$39.0$1$: int, inline$BDLSystemPowerIoCompletion$6$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1: int, inline$BDLDevicePowerIoCompletion$14$$result.memset$1683.8$14$: int, inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1665.0$9$: int;

  start#1:
    __storm_thread_done_1 := false;
    __storm_thread_done_2 := false;
    __storm_thread_done_3 := false;
    __storm_thread_done_4 := false;
    k := 0;
    errorReached := false;
    __storm_atomic := false;
    __storm_init := false;
    goto label_3#1;

  label_3#1:
    goto label_4#1;

  label_4#1:
    goto label_5#1;

  label_5#1:
    __storm_atomic := true;
    __storm_init := true;
    goto label_8#1;

  label_8#1:
    cancelLockStatus_0 := 0;
    call contextSwitch();
    goto label_9#1;

  label_9#1:
    created_irp_0 := 0;
    call contextSwitch();
    goto label_10#1;

  label_10#1:
    goto inline$storm_IoAllocateIrp$0$Entry#1;

  inline$storm_IoAllocateIrp$0$Entry#1:
    inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8_.1 := 2;
    goto inline$storm_IoAllocateIrp$0$start#1;

  inline$storm_IoAllocateIrp$0$start#1:
    inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8 := inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8_.1;
    goto inline$storm_IoAllocateIrp$0$label_3#1;

  inline$storm_IoAllocateIrp$0$label_3#1:
    goto inline$storm_IoAllocateIrp$0$label_4#1;

  inline$storm_IoAllocateIrp$0$label_4#1:
    goto inline$storm_IoAllocateIrp$0$label_5#1;

  inline$storm_IoAllocateIrp$0$label_5#1:
    call inline$storm_IoAllocateIrp$0$$result.storm_nondet$277.22$2$ := storm_nondet();
    goto inline$storm_IoAllocateIrp$0$label_8#1;

  inline$storm_IoAllocateIrp$0$label_8#1:
    goto inline$storm_IoAllocateIrp$0$label_8_case_0#1, inline$storm_IoAllocateIrp$0$label_8_case_1#1;

  inline$storm_IoAllocateIrp$0$label_8_case_1#1:
    assume inline$storm_IoAllocateIrp$0$$result.storm_nondet$277.22$2$ == 0;
    goto inline$storm_IoAllocateIrp$0$label_10#1;

  inline$storm_IoAllocateIrp$0$label_10#1:
    __storm_atomic := true;
    goto inline$storm_IoAllocateIrp$0$label_13#1;

  inline$storm_IoAllocateIrp$0$label_13#1:
    call inline$storm_IoAllocateIrp$0$$result.malloc$279.0$3$ := __HAVOC_malloc(112);
    goto inline$storm_IoAllocateIrp$0$label_16#1;

  inline$storm_IoAllocateIrp$0$label_16#1:
    inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8 := inline$storm_IoAllocateIrp$0$$result.malloc$279.0$3$;
    goto inline$storm_IoAllocateIrp$0$label_17#1;

  inline$storm_IoAllocateIrp$0$label_17#1:
    goto inline$storm_IoAllocateIrp$0$label_18#1;

  inline$storm_IoAllocateIrp$0$label_18#1:
    Mem_0_T.CancelRoutine__IRP := Mem_0_T.CancelRoutine__IRP[CancelRoutine__IRP(inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8) := 0];
    call contextSwitch();
    goto inline$storm_IoAllocateIrp$0$label_19#1;

  inline$storm_IoAllocateIrp$0$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8 := 0];
    call contextSwitch();
    goto inline$storm_IoAllocateIrp$0$label_20#1;

  inline$storm_IoAllocateIrp$0$label_20#1:
    havoc raiseException;
    goto inline$storm_IoAllocateIrp$0$anon6_Then#1, inline$storm_IoAllocateIrp$0$anon6_Else#1;

  inline$storm_IoAllocateIrp$0$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoAllocateIrp$0$anon1#1;

  inline$storm_IoAllocateIrp$0$anon1#1:
    assume INT_LT(0, inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8);
    goto inline$storm_IoAllocateIrp$0$label_21#1;

  inline$storm_IoAllocateIrp$0$label_21#1:
    inline$storm_IoAllocateIrp$0$$malloc.arg.1$5$ := MULT(inline$storm_IoAllocateIrp$0$$StackSize$1$271.11$storm_IoAllocateIrp$8, 36);
    goto inline$storm_IoAllocateIrp$0$label_22#1;

  inline$storm_IoAllocateIrp$0$label_22#1:
    call inline$storm_IoAllocateIrp$0$$result.malloc$279.0$4$ := __HAVOC_malloc(inline$storm_IoAllocateIrp$0$$malloc.arg.1$5$);
    goto inline$storm_IoAllocateIrp$0$label_25#1;

  inline$storm_IoAllocateIrp$0$label_25#1:
    goto inline$storm_IoAllocateIrp$0$label_26#1;

  inline$storm_IoAllocateIrp$0$label_26#1:
    goto inline$storm_IoAllocateIrp$0$label_27#1;

  inline$storm_IoAllocateIrp$0$label_27#1:
    goto inline$IoGetNextIrpStackLocation$0$Entry#1;

  inline$IoGetNextIrpStackLocation$0$Entry#1:
    inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8;
    goto inline$IoGetNextIrpStackLocation$0$start#1;

  inline$IoGetNextIrpStackLocation$0$start#1:
    inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$0$label_3#1;

  inline$IoGetNextIrpStackLocation$0$label_3#1:
    goto inline$IoGetNextIrpStackLocation$0$label_3_true#1, inline$IoGetNextIrpStackLocation$0$label_3_false#1;

  inline$IoGetNextIrpStackLocation$0$label_3_false#1:
    inline$IoGetNextIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$0$myVar_0);
    goto inline$IoGetNextIrpStackLocation$0$label_4#1;

  inline$IoGetNextIrpStackLocation$0$label_4#1:
    call inline$IoGetNextIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$0$label_6#1;

  inline$IoGetNextIrpStackLocation$0$label_6#1:
    call inline$IoGetNextIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$0$label_7#1;

  inline$IoGetNextIrpStackLocation$0$label_7#1:
    goto inline$IoGetNextIrpStackLocation$0$label_5#1;

  inline$IoGetNextIrpStackLocation$0$label_3_true#1:
    inline$IoGetNextIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$0$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$0$myVar_0);
    goto inline$IoGetNextIrpStackLocation$0$label_5#1;

  inline$IoGetNextIrpStackLocation$0$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$0$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$0$label_1#1;

  inline$IoGetNextIrpStackLocation$0$label_1#1:
    goto inline$IoGetNextIrpStackLocation$0$Return#1;

  inline$IoGetNextIrpStackLocation$0$Return#1:
    goto inline$storm_IoAllocateIrp$0$label_27$1#1;

  inline$storm_IoAllocateIrp$0$label_27$1#1:
    goto inline$storm_IoAllocateIrp$0$anon7_Then#1, inline$storm_IoAllocateIrp$0$anon7_Else#1;

  inline$storm_IoAllocateIrp$0$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_IoAllocateIrp$0$anon3#1;

  inline$storm_IoAllocateIrp$0$anon3#1:
    goto inline$storm_IoAllocateIrp$0$label_30#1;

  inline$storm_IoAllocateIrp$0$label_30#1:
    goto inline$storm_IoAllocateIrp$0$label_31#1;

  inline$storm_IoAllocateIrp$0$label_31#1:
    goto inline$storm_IoAllocateIrp$0$label_32#1;

  inline$storm_IoAllocateIrp$0$label_32#1:
    goto inline$storm_IoAllocateIrp$0$label_33#1;

  inline$storm_IoAllocateIrp$0$label_33#1:
    goto inline$storm_IoAllocateIrp$0$anon8_Then#1, inline$storm_IoAllocateIrp$0$anon8_Else#1;

  inline$storm_IoAllocateIrp$0$anon8_Else#1:
    assume __storm_init;
    goto inline$storm_IoAllocateIrp$0$anon5#1;

  inline$storm_IoAllocateIrp$0$anon8_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_IoAllocateIrp$0$anon5#1;

  inline$storm_IoAllocateIrp$0$anon5#1:
    call contextSwitch();
    goto inline$storm_IoAllocateIrp$0$label_36#1;

  inline$storm_IoAllocateIrp$0$anon7_Then#1:
    assume raiseException;
    goto inline$storm_IoAllocateIrp$0$Return#1;

  inline$storm_IoAllocateIrp$0$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoAllocateIrp$0$Return#1;

  inline$storm_IoAllocateIrp$0$label_8_case_0#1:
    assume inline$storm_IoAllocateIrp$0$$result.storm_nondet$277.22$2$ != 0;
    goto inline$storm_IoAllocateIrp$0$label_9#1;

  inline$storm_IoAllocateIrp$0$label_9#1:
    inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8 := 0;
    goto inline$storm_IoAllocateIrp$0$label_36#1;

  inline$storm_IoAllocateIrp$0$label_36#1:
    inline$storm_IoAllocateIrp$0$$result.storm_IoAllocateIrp$270.0$1$ := inline$storm_IoAllocateIrp$0$$createdIrp$3$275.7$storm_IoAllocateIrp$8;
    goto inline$storm_IoAllocateIrp$0$label_1#1;

  inline$storm_IoAllocateIrp$0$label_1#1:
    goto inline$storm_IoAllocateIrp$0$Return#1;

  inline$storm_IoAllocateIrp$0$Return#1:
    $result.storm_IoAllocateIrp$100.0$1$ := inline$storm_IoAllocateIrp$0$$result.storm_IoAllocateIrp$270.0$1$;
    goto label_10$1#1;

  label_10$1#1:
    goto anon10_Then#1, anon10_Else#1;

  anon10_Else#1:
    assume !raiseException;
    goto anon1#1;

  anon1#1:
    goto label_13#1;

  label_13#1:
    $irp$1$96.7$storm_main$0 := $result.storm_IoAllocateIrp$100.0$1$;
    goto label_14#1;

  label_14#1:
    havoc raiseException;
    goto anon11_Then#1, anon11_Else#1;

  anon11_Else#1:
    assume !raiseException;
    goto anon3#1;

  anon3#1:
    assume INT_NEQ($irp$1$96.7$storm_main$0, 0);
    goto label_15#1;

  label_15#1:
    goto inline$IoSetNextIrpStackLocation$0$Entry#1;

  inline$IoSetNextIrpStackLocation$0$Entry#1:
    inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := $irp$1$96.7$storm_main$0;
    goto inline$IoSetNextIrpStackLocation$0$start#1;

  inline$IoSetNextIrpStackLocation$0$start#1:
    inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$0$label_3#1;

  inline$IoSetNextIrpStackLocation$0$label_3#1:
    goto inline$IoSetNextIrpStackLocation$0$label_3_true#1, inline$IoSetNextIrpStackLocation$0$label_3_false#1;

  inline$IoSetNextIrpStackLocation$0$label_3_false#1:
    inline$IoSetNextIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$0$myVar_0);
    goto inline$IoSetNextIrpStackLocation$0$label_4#1;

  inline$IoSetNextIrpStackLocation$0$label_4#1:
    call inline$IoSetNextIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$0$label_7#1;

  inline$IoSetNextIrpStackLocation$0$label_7#1:
    call inline$IoSetNextIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$0$label_8#1;

  inline$IoSetNextIrpStackLocation$0$label_8#1:
    goto inline$IoSetNextIrpStackLocation$0$label_5#1;

  inline$IoSetNextIrpStackLocation$0$label_3_true#1:
    inline$IoSetNextIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$0$myVar_0);
    goto inline$IoSetNextIrpStackLocation$0$label_5#1;

  inline$IoSetNextIrpStackLocation$0$label_5#1:
    inline$IoSetNextIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$0$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$0$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$0$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$0$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$0$label_6#1;

  inline$IoSetNextIrpStackLocation$0$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$0$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$0$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$0$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$0$label_1#1;

  inline$IoSetNextIrpStackLocation$0$label_1#1:
    goto inline$IoSetNextIrpStackLocation$0$Return#1;

  inline$IoSetNextIrpStackLocation$0$Return#1:
    goto label_15$1#1;

  label_15$1#1:
    goto anon12_Then#1, anon12_Else#1;

  anon12_Else#1:
    assume !raiseException;
    goto anon5#1;

  anon5#1:
    goto label_18#1;

  label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$0$Entry#1;

  inline$IoGetCurrentIrpStackLocation$0$Entry#1:
    inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := $irp$1$96.7$storm_main$0;
    goto inline$IoGetCurrentIrpStackLocation$0$start#1;

  inline$IoGetCurrentIrpStackLocation$0$start#1:
    inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$0$label_3#1;

  inline$IoGetCurrentIrpStackLocation$0$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$0$label_3_true#1, inline$IoGetCurrentIrpStackLocation$0$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$0$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$0$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$0$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$0$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$0$label_4#1;

  inline$IoGetCurrentIrpStackLocation$0$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$0$label_6#1;

  inline$IoGetCurrentIrpStackLocation$0$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$0$label_7#1;

  inline$IoGetCurrentIrpStackLocation$0$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$0$label_5#1;

  inline$IoGetCurrentIrpStackLocation$0$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$0$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$0$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$0$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$0$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$0$label_5#1;

  inline$IoGetCurrentIrpStackLocation$0$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$0$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$0$label_1#1;

  inline$IoGetCurrentIrpStackLocation$0$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$0$Return#1;

  inline$IoGetCurrentIrpStackLocation$0$Return#1:
    goto label_18$1#1;

  label_18$1#1:
    goto anon13_Then#1, anon13_Else#1;

  anon13_Else#1:
    assume !raiseException;
    goto anon7#1;

  anon7#1:
    goto label_21#1;

  label_21#1:
    goto label_22#1;

  label_22#1:
    goto label_23#1;

  label_23#1:
    goto inline$myInitDriver$0$Entry#1;

  inline$myInitDriver$0$Entry#1:
    goto inline$myInitDriver$0$start#1;

  inline$myInitDriver$0$start#1:
    goto inline$myInitDriver$0$label_3#1;

  inline$myInitDriver$0$label_3#1:
    goto inline$myInitDriver$0$label_4#1;

  inline$myInitDriver$0$label_4#1:
    inline$myInitDriver$0$myVar_0 := Mem_0_T.DeviceExtension__DEVICE_OBJECT[DeviceExtension__DEVICE_OBJECT(hdevobj)];
    call contextSwitch();
    inline$myInitDriver$0$$pBDLExtension$2$5.33$myInitDriver$4 := inline$myInitDriver$0$myVar_0;
    goto inline$myInitDriver$0$label_5#1;

  inline$myInitDriver$0$label_5#1:
    goto inline$myInitDriver$0$label_6#1;

  inline$myInitDriver$0$label_6#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    havoc inline$myInitDriver$0$myNondetVar_1;
    assume inline$myInitDriver$0$myNondetVar_0 == inline$myInitDriver$0$myNondetVar_1;
    goto inline$storm_KeInitializeSpinLock$0$Entry#1;

  inline$storm_KeInitializeSpinLock$0$Entry#1:
    inline$storm_KeInitializeSpinLock$0$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1 := SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$myInitDriver$0$$pBDLExtension$2$5.33$myInitDriver$4);
    goto inline$storm_KeInitializeSpinLock$0$start#1;

  inline$storm_KeInitializeSpinLock$0$start#1:
    inline$storm_KeInitializeSpinLock$0$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := inline$storm_KeInitializeSpinLock$0$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1;
    goto inline$storm_KeInitializeSpinLock$0$label_3#1;

  inline$storm_KeInitializeSpinLock$0$label_3#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeInitializeSpinLock$0$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := 0];
    call contextSwitch();
    goto inline$storm_KeInitializeSpinLock$0$label_1#1;

  inline$storm_KeInitializeSpinLock$0$label_1#1:
    goto inline$storm_KeInitializeSpinLock$0$Return#1;

  inline$storm_KeInitializeSpinLock$0$Return#1:
    goto inline$myInitDriver$0$label_6$1#1;

  inline$myInitDriver$0$label_6$1#1:
    goto inline$myInitDriver$0$anon8_Then#1, inline$myInitDriver$0$anon8_Else#1;

  inline$myInitDriver$0$anon8_Else#1:
    assume !raiseException;
    goto inline$myInitDriver$0$anon1#1;

  inline$myInitDriver$0$anon1#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    goto inline$myInitDriver$0$label_9#1;

  inline$myInitDriver$0$label_9#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    havoc inline$myInitDriver$0$myNondetVar_1;
    assume inline$myInitDriver$0$myNondetVar_0 == inline$myInitDriver$0$myNondetVar_1;
    goto inline$storm_KeInitializeSpinLock$1$Entry#1;

  inline$storm_KeInitializeSpinLock$1$Entry#1:
    inline$storm_KeInitializeSpinLock$1$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1 := ISRControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$myInitDriver$0$$pBDLExtension$2$5.33$myInitDriver$4));
    goto inline$storm_KeInitializeSpinLock$1$start#1;

  inline$storm_KeInitializeSpinLock$1$start#1:
    inline$storm_KeInitializeSpinLock$1$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := inline$storm_KeInitializeSpinLock$1$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1;
    goto inline$storm_KeInitializeSpinLock$1$label_3#1;

  inline$storm_KeInitializeSpinLock$1$label_3#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeInitializeSpinLock$1$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := 0];
    call contextSwitch();
    goto inline$storm_KeInitializeSpinLock$1$label_1#1;

  inline$storm_KeInitializeSpinLock$1$label_1#1:
    goto inline$storm_KeInitializeSpinLock$1$Return#1;

  inline$storm_KeInitializeSpinLock$1$Return#1:
    goto inline$myInitDriver$0$label_9$1#1;

  inline$myInitDriver$0$label_9$1#1:
    goto inline$myInitDriver$0$anon9_Then#1, inline$myInitDriver$0$anon9_Else#1;

  inline$myInitDriver$0$anon9_Else#1:
    assume !raiseException;
    goto inline$myInitDriver$0$anon3#1;

  inline$myInitDriver$0$anon3#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    goto inline$myInitDriver$0$label_12#1;

  inline$myInitDriver$0$label_12#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    havoc inline$myInitDriver$0$myNondetVar_1;
    assume inline$myInitDriver$0$myNondetVar_0 == inline$myInitDriver$0$myNondetVar_1;
    goto inline$storm_KeInitializeSpinLock$2$Entry#1;

  inline$storm_KeInitializeSpinLock$2$Entry#1:
    inline$storm_KeInitializeSpinLock$2$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$myInitDriver$0$$pBDLExtension$2$5.33$myInitDriver$4));
    goto inline$storm_KeInitializeSpinLock$2$start#1;

  inline$storm_KeInitializeSpinLock$2$start#1:
    inline$storm_KeInitializeSpinLock$2$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := inline$storm_KeInitializeSpinLock$2$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1;
    goto inline$storm_KeInitializeSpinLock$2$label_3#1;

  inline$storm_KeInitializeSpinLock$2$label_3#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeInitializeSpinLock$2$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := 0];
    call contextSwitch();
    goto inline$storm_KeInitializeSpinLock$2$label_1#1;

  inline$storm_KeInitializeSpinLock$2$label_1#1:
    goto inline$storm_KeInitializeSpinLock$2$Return#1;

  inline$storm_KeInitializeSpinLock$2$Return#1:
    goto inline$myInitDriver$0$label_12$1#1;

  inline$myInitDriver$0$label_12$1#1:
    goto inline$myInitDriver$0$anon10_Then#1, inline$myInitDriver$0$anon10_Else#1;

  inline$myInitDriver$0$anon10_Else#1:
    assume !raiseException;
    goto inline$myInitDriver$0$anon5#1;

  inline$myInitDriver$0$anon5#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    goto inline$myInitDriver$0$label_15#1;

  inline$myInitDriver$0$label_15#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    havoc inline$myInitDriver$0$myNondetVar_1;
    assume inline$myInitDriver$0$myNondetVar_0 == inline$myInitDriver$0$myNondetVar_1;
    goto inline$storm_KeInitializeSpinLock$3$Entry#1;

  inline$storm_KeInitializeSpinLock$3$Entry#1:
    inline$storm_KeInitializeSpinLock$3$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1 := HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$myInitDriver$0$$pBDLExtension$2$5.33$myInitDriver$4);
    goto inline$storm_KeInitializeSpinLock$3$start#1;

  inline$storm_KeInitializeSpinLock$3$start#1:
    inline$storm_KeInitializeSpinLock$3$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := inline$storm_KeInitializeSpinLock$3$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4_.1;
    goto inline$storm_KeInitializeSpinLock$3$label_3#1;

  inline$storm_KeInitializeSpinLock$3$label_3#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeInitializeSpinLock$3$$SpinLock$1$116.17$storm_KeInitializeSpinLock$4 := 0];
    call contextSwitch();
    goto inline$storm_KeInitializeSpinLock$3$label_1#1;

  inline$storm_KeInitializeSpinLock$3$label_1#1:
    goto inline$storm_KeInitializeSpinLock$3$Return#1;

  inline$storm_KeInitializeSpinLock$3$Return#1:
    goto inline$myInitDriver$0$label_15$1#1;

  inline$myInitDriver$0$label_15$1#1:
    goto inline$myInitDriver$0$anon11_Then#1, inline$myInitDriver$0$anon11_Else#1;

  inline$myInitDriver$0$anon11_Else#1:
    assume !raiseException;
    goto inline$myInitDriver$0$anon7#1;

  inline$myInitDriver$0$anon7#1:
    havoc inline$myInitDriver$0$myNondetVar_0;
    goto inline$myInitDriver$0$label_1#1;

  inline$myInitDriver$0$label_1#1:
    goto inline$myInitDriver$0$Return#1;

  inline$myInitDriver$0$anon11_Then#1:
    assume raiseException;
    goto inline$myInitDriver$0$Return#1;

  inline$myInitDriver$0$anon10_Then#1:
    assume raiseException;
    goto inline$myInitDriver$0$Return#1;

  inline$myInitDriver$0$anon9_Then#1:
    assume raiseException;
    goto inline$myInitDriver$0$Return#1;

  inline$myInitDriver$0$anon8_Then#1:
    assume raiseException;
    goto inline$myInitDriver$0$Return#1;

  inline$myInitDriver$0$Return#1:
    goto label_23$1#1;

  label_23$1#1:
    goto anon14_Then#1, anon14_Else#1;

  anon14_Else#1:
    assume !raiseException;
    goto anon9#1;

  anon9#1:
    goto label_26#1;

  label_26#1:
    __storm_atomic := false;
    __storm_init := false;
    goto label_29#1;

  label_29#1:
    goto inline$storm_thread_dispatch$0$Entry#1;

  inline$storm_thread_dispatch$0$Entry#1:
    inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4_.1 := $irp$1$96.7$storm_main$0;
    goto inline$storm_thread_dispatch$0$start#1;

  inline$storm_thread_dispatch$0$start#1:
    k := 0;
    raiseException := false;
    __storm_thread_id := 3;
    call contextSwitch();
    inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4 := inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4_.1;
    goto inline$storm_thread_dispatch$0$label_3#1;

  inline$storm_thread_dispatch$0$label_3#1:
    goto inline$storm_thread_dispatch$0$label_4#1;

  inline$storm_thread_dispatch$0$label_4#1:
    goto inline$IoGetCurrentIrpStackLocation$1$Entry#1;

  inline$IoGetCurrentIrpStackLocation$1$Entry#1:
    inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4;
    goto inline$IoGetCurrentIrpStackLocation$1$start#1;

  inline$IoGetCurrentIrpStackLocation$1$start#1:
    inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$1$label_3#1;

  inline$IoGetCurrentIrpStackLocation$1$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$1$label_3_true#1, inline$IoGetCurrentIrpStackLocation$1$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$1$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$1$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$1$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$1$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$1$label_4#1;

  inline$IoGetCurrentIrpStackLocation$1$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$1$label_6#1;

  inline$IoGetCurrentIrpStackLocation$1$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$1$label_7#1;

  inline$IoGetCurrentIrpStackLocation$1$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$1$label_5#1;

  inline$IoGetCurrentIrpStackLocation$1$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$1$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$1$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$1$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$1$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$1$label_5#1;

  inline$IoGetCurrentIrpStackLocation$1$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$1$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$1$label_1#1;

  inline$IoGetCurrentIrpStackLocation$1$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$1$Return#1;

  inline$IoGetCurrentIrpStackLocation$1$Return#1:
    goto inline$storm_thread_dispatch$0$label_4$1#1;

  inline$storm_thread_dispatch$0$label_4$1#1:
    goto inline$storm_thread_dispatch$0$anon4_Then#1, inline$storm_thread_dispatch$0$anon4_Else#1;

  inline$storm_thread_dispatch$0$anon4_Else#1:
    assume !raiseException;
    goto inline$storm_thread_dispatch$0$anon1#1;

  inline$storm_thread_dispatch$0$anon1#1:
    goto inline$storm_thread_dispatch$0$label_7#1;

  inline$storm_thread_dispatch$0$label_7#1:
    goto inline$storm_thread_dispatch$0$label_8#1;

  inline$storm_thread_dispatch$0$label_8#1:
    goto inline$BDLPnP$0$Entry#1;

  inline$BDLPnP$0$Entry#1:
    inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8_.1 := hdevobj;
    inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8_.1 := inline$storm_thread_dispatch$0$$Irp$1$8.5$storm_thread_dispatch$4;
    goto inline$BDLPnP$0$start#1;

  inline$BDLPnP$0$start#1:
    inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8 := inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8_.1;
    inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8_.1;
    goto inline$BDLPnP$0$label_3#1;

  inline$BDLPnP$0$label_3#1:
    goto inline$BDLPnP$0$label_4#1;

  inline$BDLPnP$0$label_4#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := 0;
    goto inline$BDLPnP$0$label_5#1;

  inline$BDLPnP$0$label_5#1:
    goto inline$BDLPnP$0$label_6#1;

  inline$BDLPnP$0$label_6#1:
    inline$BDLPnP$0$myVar_0 := Mem_0_T.DeviceExtension__DEVICE_OBJECT[DeviceExtension__DEVICE_OBJECT(inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8)];
    call contextSwitch();
    inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8 := inline$BDLPnP$0$myVar_0;
    goto inline$BDLPnP$0$label_7#1;

  inline$BDLPnP$0$label_7#1:
    goto inline$BDLPnP$0$label_8#1;

  inline$BDLPnP$0$label_8#1:
    goto inline$BDLPnP$0$label_9#1;

  inline$BDLPnP$0$label_9#1:
    goto inline$BDLPnP$0$label_10#1;

  inline$BDLPnP$0$label_10#1:
    inline$BDLPnP$0$$pAttachedDeviceObject$6$862.36$BDLPnP$8 := 0;
    goto inline$BDLPnP$0$label_11#1;

  inline$BDLPnP$0$label_11#1:
    goto inline$BDLPnP$0$label_12#1;

  inline$BDLPnP$0$label_12#1:
    inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8 := 1;
    goto inline$BDLPnP$0$label_13#1;

  inline$BDLPnP$0$label_13#1:
    goto inline$BDLGetDebugLevel$0$Entry#1;

  inline$BDLGetDebugLevel$0$Entry#1:
    goto inline$BDLGetDebugLevel$0$start#1;

  inline$BDLGetDebugLevel$0$start#1:
    goto inline$BDLGetDebugLevel$0$label_3#1;

  inline$BDLGetDebugLevel$0$label_3#1:
    havoc inline$BDLGetDebugLevel$0$myNondetVar_0;
    inline$BDLGetDebugLevel$0$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$0$myNondetVar_0;
    goto inline$BDLGetDebugLevel$0$label_1#1;

  inline$BDLGetDebugLevel$0$label_1#1:
    goto inline$BDLGetDebugLevel$0$Return#1;

  inline$BDLGetDebugLevel$0$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$2$ := inline$BDLGetDebugLevel$0$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_13$1#1;

  inline$BDLPnP$0$label_13$1#1:
    goto inline$BDLPnP$0$anon54_Then#1, inline$BDLPnP$0$anon54_Else#1;

  inline$BDLPnP$0$anon54_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon1#1;

  inline$BDLPnP$0$anon1#1:
    goto inline$BDLPnP$0$label_16#1;

  inline$BDLPnP$0$label_16#1:
    goto inline$BDLPnP$0$label_16_true#1, inline$BDLPnP$0$label_16_false#1;

  inline$BDLPnP$0$label_16_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$2$) == 0;
    goto inline$BDLPnP$0$label_17#1;

  inline$BDLPnP$0$label_16_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$2$) != 0;
    goto inline$BDLPnP$0$label_20#1;

  inline$BDLPnP$0$label_20#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_21#1;

  inline$BDLPnP$0$label_21#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_22#1;

  inline$BDLPnP$0$label_22#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_23#1;

  inline$BDLPnP$0$label_23#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$865.0$3$;
    goto inline$BDLPnP$0$label_17#1;

  inline$BDLPnP$0$label_17#1:
    goto inline$BDLGetDebugLevel$1$Entry#1;

  inline$BDLGetDebugLevel$1$Entry#1:
    goto inline$BDLGetDebugLevel$1$start#1;

  inline$BDLGetDebugLevel$1$start#1:
    goto inline$BDLGetDebugLevel$1$label_3#1;

  inline$BDLGetDebugLevel$1$label_3#1:
    havoc inline$BDLGetDebugLevel$1$myNondetVar_0;
    inline$BDLGetDebugLevel$1$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$1$myNondetVar_0;
    goto inline$BDLGetDebugLevel$1$label_1#1;

  inline$BDLGetDebugLevel$1$label_1#1:
    goto inline$BDLGetDebugLevel$1$Return#1;

  inline$BDLGetDebugLevel$1$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$7$ := inline$BDLGetDebugLevel$1$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_17$1#1;

  inline$BDLPnP$0$label_17$1#1:
    goto inline$BDLPnP$0$anon55_Then#1, inline$BDLPnP$0$anon55_Else#1;

  inline$BDLPnP$0$anon55_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon3#1;

  inline$BDLPnP$0$anon3#1:
    goto inline$BDLPnP$0$label_26#1;

  inline$BDLPnP$0$label_26#1:
    goto inline$BDLPnP$0$label_26_true#1, inline$BDLPnP$0$label_26_false#1;

  inline$BDLPnP$0$label_26_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$7$) == 0;
    goto inline$BDLPnP$0$label_27#1;

  inline$BDLPnP$0$label_26_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$7$) != 0;
    goto inline$BDLPnP$0$label_30#1;

  inline$BDLPnP$0$label_30#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_31#1;

  inline$BDLPnP$0$label_31#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_32#1;

  inline$BDLPnP$0$label_32#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_33#1;

  inline$BDLPnP$0$label_33#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$865.0$8$;
    goto inline$BDLPnP$0$label_27#1;

  inline$BDLPnP$0$label_27#1:
    goto inline$BDLGetDebugLevel$2$Entry#1;

  inline$BDLGetDebugLevel$2$Entry#1:
    goto inline$BDLGetDebugLevel$2$start#1;

  inline$BDLGetDebugLevel$2$start#1:
    goto inline$BDLGetDebugLevel$2$label_3#1;

  inline$BDLGetDebugLevel$2$label_3#1:
    havoc inline$BDLGetDebugLevel$2$myNondetVar_0;
    inline$BDLGetDebugLevel$2$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$2$myNondetVar_0;
    goto inline$BDLGetDebugLevel$2$label_1#1;

  inline$BDLGetDebugLevel$2$label_1#1:
    goto inline$BDLGetDebugLevel$2$Return#1;

  inline$BDLGetDebugLevel$2$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$12$ := inline$BDLGetDebugLevel$2$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_27$1#1;

  inline$BDLPnP$0$label_27$1#1:
    goto inline$BDLPnP$0$anon56_Then#1, inline$BDLPnP$0$anon56_Else#1;

  inline$BDLPnP$0$anon56_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon5#1;

  inline$BDLPnP$0$anon5#1:
    goto inline$BDLPnP$0$label_36#1;

  inline$BDLPnP$0$label_36#1:
    goto inline$BDLPnP$0$label_36_true#1, inline$BDLPnP$0$label_36_false#1;

  inline$BDLPnP$0$label_36_false#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$12$, 4) == 0;
    goto inline$BDLPnP$0$label_37#1;

  inline$BDLPnP$0$label_36_true#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$865.0$12$, 4) != 0;
    goto inline$BDLPnP$0$label_38#1;

  inline$BDLPnP$0$label_38#1:
    goto inline$BDLPnP$0$label_37#1;

  inline$BDLPnP$0$label_37#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    inline$BDLPnP$0$$pAttachedDeviceObject$6$862.36$BDLPnP$8 := inline$BDLPnP$0$myNondetVar_0;
    goto inline$BDLPnP$0$label_39#1;

  inline$BDLPnP$0$label_39#1:
    goto inline$IoGetCurrentIrpStackLocation$2$Entry#1;

  inline$IoGetCurrentIrpStackLocation$2$Entry#1:
    inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$IoGetCurrentIrpStackLocation$2$start#1;

  inline$IoGetCurrentIrpStackLocation$2$start#1:
    inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$2$label_3#1;

  inline$IoGetCurrentIrpStackLocation$2$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$2$label_3_true#1, inline$IoGetCurrentIrpStackLocation$2$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$2$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$2$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$2$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$2$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$2$label_4#1;

  inline$IoGetCurrentIrpStackLocation$2$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$2$label_6#1;

  inline$IoGetCurrentIrpStackLocation$2$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$2$label_7#1;

  inline$IoGetCurrentIrpStackLocation$2$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$2$label_5#1;

  inline$IoGetCurrentIrpStackLocation$2$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$2$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$2$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$2$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$2$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$2$label_5#1;

  inline$IoGetCurrentIrpStackLocation$2$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$2$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$2$label_1#1;

  inline$IoGetCurrentIrpStackLocation$2$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$2$Return#1;

  inline$IoGetCurrentIrpStackLocation$2$Return#1:
    goto inline$BDLPnP$0$label_39$1#1;

  inline$BDLPnP$0$label_39$1#1:
    goto inline$BDLPnP$0$anon57_Then#1, inline$BDLPnP$0$anon57_Else#1;

  inline$BDLPnP$0$anon57_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon7#1;

  inline$BDLPnP$0$anon7#1:
    goto inline$BDLPnP$0$label_42#1;

  inline$BDLPnP$0$label_42#1:
    goto inline$BDLPnP$0$label_43#1;

  inline$BDLPnP$0$label_43#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    inline$BDLPnP$0$$IoAcquireRemoveLockEx.arg.3$15$ := inline$BDLPnP$0$havoc_stringTemp;
    goto inline$BDLPnP$0$label_44#1;

  inline$BDLPnP$0$label_44#1:
    goto inline$BDLPnP$0$label_44_true#1, inline$BDLPnP$0$label_44_false#1;

  inline$BDLPnP$0$label_44_false#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume !INT_NEQ(inline$BDLPnP$0$myNondetVar_0, 2);
    goto inline$BDLPnP$0$label_45#1;

  inline$BDLPnP$0$label_45#1:
    inline$BDLPnP$0$$result.question.16$ := 544632146;
    goto inline$BDLPnP$0$label_47#1;

  inline$BDLPnP$0$label_44_true#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume INT_NEQ(inline$BDLPnP$0$myNondetVar_0, 2);
    goto inline$BDLPnP$0$label_46#1;

  inline$BDLPnP$0$label_46#1:
    inline$BDLPnP$0$$result.question.16$ := 542142032;
    goto inline$BDLPnP$0$label_47#1;

  inline$BDLPnP$0$label_47#1:
    call inline$BDLPnP$0$$result.IoAcquireRemoveLockEx$879.0$14$ := IoAcquireRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8), inline$BDLPnP$0$$result.question.16$, inline$BDLPnP$0$$IoAcquireRemoveLockEx.arg.3$15$, 882, 88);
    goto inline$BDLPnP$0$anon58_Then#1, inline$BDLPnP$0$anon58_Else#1;

  inline$BDLPnP$0$anon58_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon9#1;

  inline$BDLPnP$0$anon9#1:
    goto inline$BDLPnP$0$label_50#1;

  inline$BDLPnP$0$label_50#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.IoAcquireRemoveLockEx$879.0$14$;
    goto inline$BDLPnP$0$label_51#1;

  inline$BDLPnP$0$label_51#1:
    goto inline$BDLPnP$0$label_51_true#1, inline$BDLPnP$0$label_51_false#1;

  inline$BDLPnP$0$label_51_false#1:
    assume inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 == 0;
    goto inline$BDLPnP$0$label_52#1;

  inline$BDLPnP$0$label_52#1:
    goto inline$BDLPnP$0$label_52_case_0#1, inline$BDLPnP$0$label_52_case_1#1, inline$BDLPnP$0$label_52_case_2#1, inline$BDLPnP$0$label_52_case_3#1, inline$BDLPnP$0$label_52_case_4#1, inline$BDLPnP$0$label_52_case_5#1, inline$BDLPnP$0$label_52_case_6#1, inline$BDLPnP$0$label_52_case_7#1, inline$BDLPnP$0$label_52_case_8#1;

  inline$BDLPnP$0$label_52_case_8#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 23;
    goto inline$BDLPnP$0$label_134#1;

  inline$BDLPnP$0$label_134#1:
    goto inline$BDLPnPSurpriseRemoval$0$Entry#1;

  inline$BDLPnPSurpriseRemoval$0$Entry#1:
    inline$BDLPnPSurpriseRemoval$0$$pBDLExtension$1$2529.40$BDLPnPSurpriseRemoval$12_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPSurpriseRemoval$0$$pIrp$3$2531.40$BDLPnPSurpriseRemoval$12_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPSurpriseRemoval$0$start#1;

  inline$BDLPnPSurpriseRemoval$0$start#1:
    inline$BDLPnPSurpriseRemoval$0$$pBDLExtension$1$2529.40$BDLPnPSurpriseRemoval$12 := inline$BDLPnPSurpriseRemoval$0$$pBDLExtension$1$2529.40$BDLPnPSurpriseRemoval$12_.1;
    inline$BDLPnPSurpriseRemoval$0$$pIrp$3$2531.40$BDLPnPSurpriseRemoval$12 := inline$BDLPnPSurpriseRemoval$0$$pIrp$3$2531.40$BDLPnPSurpriseRemoval$12_.1;
    goto inline$BDLPnPSurpriseRemoval$0$label_3#1;

  inline$BDLPnPSurpriseRemoval$0$label_3#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_4#1;

  inline$BDLPnPSurpriseRemoval$0$label_4#1:
    inline$BDLPnPSurpriseRemoval$0$$status$4$2534.16$BDLPnPSurpriseRemoval$12 := 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_5#1;

  inline$BDLPnPSurpriseRemoval$0$label_5#1:
    goto inline$BDLGetDebugLevel$658$Entry#1;

  inline$BDLGetDebugLevel$658$Entry#1:
    goto inline$BDLGetDebugLevel$658$start#1;

  inline$BDLGetDebugLevel$658$start#1:
    goto inline$BDLGetDebugLevel$658$label_3#1;

  inline$BDLGetDebugLevel$658$label_3#1:
    havoc inline$BDLGetDebugLevel$658$myNondetVar_0;
    inline$BDLGetDebugLevel$658$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$658$myNondetVar_0;
    goto inline$BDLGetDebugLevel$658$label_1#1;

  inline$BDLGetDebugLevel$658$label_1#1:
    goto inline$BDLGetDebugLevel$658$Return#1;

  inline$BDLGetDebugLevel$658$Return#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$2$ := inline$BDLGetDebugLevel$658$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPSurpriseRemoval$0$label_5$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_5$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon14_Then#1, inline$BDLPnPSurpriseRemoval$0$anon14_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon14_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon1#1;

  inline$BDLPnPSurpriseRemoval$0$anon1#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_8#1;

  inline$BDLPnPSurpriseRemoval$0$label_8#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_8_true#1, inline$BDLPnPSurpriseRemoval$0$label_8_false#1;

  inline$BDLPnPSurpriseRemoval$0$label_8_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$2$) == 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_9#1;

  inline$BDLPnPSurpriseRemoval$0$label_8_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$2$) != 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_12#1;

  inline$BDLPnPSurpriseRemoval$0$label_12#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_13#1;

  inline$BDLPnPSurpriseRemoval$0$label_13#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_14#1;

  inline$BDLPnPSurpriseRemoval$0$label_14#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_15#1;

  inline$BDLPnPSurpriseRemoval$0$label_15#1:
    havoc inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2536.0$3$;
    goto inline$BDLPnPSurpriseRemoval$0$label_9#1;

  inline$BDLPnPSurpriseRemoval$0$label_9#1:
    goto inline$BDLGetDebugLevel$659$Entry#1;

  inline$BDLGetDebugLevel$659$Entry#1:
    goto inline$BDLGetDebugLevel$659$start#1;

  inline$BDLGetDebugLevel$659$start#1:
    goto inline$BDLGetDebugLevel$659$label_3#1;

  inline$BDLGetDebugLevel$659$label_3#1:
    havoc inline$BDLGetDebugLevel$659$myNondetVar_0;
    inline$BDLGetDebugLevel$659$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$659$myNondetVar_0;
    goto inline$BDLGetDebugLevel$659$label_1#1;

  inline$BDLGetDebugLevel$659$label_1#1:
    goto inline$BDLGetDebugLevel$659$Return#1;

  inline$BDLGetDebugLevel$659$Return#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$7$ := inline$BDLGetDebugLevel$659$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPSurpriseRemoval$0$label_9$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_9$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon15_Then#1, inline$BDLPnPSurpriseRemoval$0$anon15_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon15_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon3#1;

  inline$BDLPnPSurpriseRemoval$0$anon3#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_18#1;

  inline$BDLPnPSurpriseRemoval$0$label_18#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_18_true#1, inline$BDLPnPSurpriseRemoval$0$label_18_false#1;

  inline$BDLPnPSurpriseRemoval$0$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$7$) == 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_19#1;

  inline$BDLPnPSurpriseRemoval$0$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$7$) != 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_22#1;

  inline$BDLPnPSurpriseRemoval$0$label_22#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_23#1;

  inline$BDLPnPSurpriseRemoval$0$label_23#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_24#1;

  inline$BDLPnPSurpriseRemoval$0$label_24#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_25#1;

  inline$BDLPnPSurpriseRemoval$0$label_25#1:
    havoc inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2536.0$8$;
    goto inline$BDLPnPSurpriseRemoval$0$label_19#1;

  inline$BDLPnPSurpriseRemoval$0$label_19#1:
    goto inline$BDLGetDebugLevel$660$Entry#1;

  inline$BDLGetDebugLevel$660$Entry#1:
    goto inline$BDLGetDebugLevel$660$start#1;

  inline$BDLGetDebugLevel$660$start#1:
    goto inline$BDLGetDebugLevel$660$label_3#1;

  inline$BDLGetDebugLevel$660$label_3#1:
    havoc inline$BDLGetDebugLevel$660$myNondetVar_0;
    inline$BDLGetDebugLevel$660$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$660$myNondetVar_0;
    goto inline$BDLGetDebugLevel$660$label_1#1;

  inline$BDLGetDebugLevel$660$label_1#1:
    goto inline$BDLGetDebugLevel$660$Return#1;

  inline$BDLGetDebugLevel$660$Return#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$12$ := inline$BDLGetDebugLevel$660$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPSurpriseRemoval$0$label_19$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_19$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon16_Then#1, inline$BDLPnPSurpriseRemoval$0$anon16_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon5#1;

  inline$BDLPnPSurpriseRemoval$0$anon5#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_28#1;

  inline$BDLPnPSurpriseRemoval$0$label_28#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_28_true#1, inline$BDLPnPSurpriseRemoval$0$label_28_false#1;

  inline$BDLPnPSurpriseRemoval$0$label_28_false#1:
    assume BIT_BAND(inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$12$, 4) == 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_29#1;

  inline$BDLPnPSurpriseRemoval$0$label_28_true#1:
    assume BIT_BAND(inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2536.0$12$, 4) != 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_30#1;

  inline$BDLPnPSurpriseRemoval$0$label_30#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_29#1;

  inline$BDLPnPSurpriseRemoval$0$label_29#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_31#1;

  inline$BDLPnPSurpriseRemoval$0$label_31#1:
    goto inline$BDLHandleRemove$1$Entry#1;

  inline$BDLHandleRemove$1$Entry#1:
    inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12_.1 := inline$BDLPnPSurpriseRemoval$0$$pBDLExtension$1$2529.40$BDLPnPSurpriseRemoval$12;
    inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12_.1 := inline$BDLPnPSurpriseRemoval$0$$pIrp$3$2531.40$BDLPnPSurpriseRemoval$12;
    goto inline$BDLHandleRemove$1$start#1;

  inline$BDLHandleRemove$1$start#1:
    inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12 := inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12_.1;
    inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12 := inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12_.1;
    goto inline$BDLHandleRemove$1$label_3#1;

  inline$BDLHandleRemove$1$label_3#1:
    goto inline$BDLHandleRemove$1$label_4#1;

  inline$BDLHandleRemove$1$label_4#1:
    inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 := 0;
    goto inline$BDLHandleRemove$1$label_5#1;

  inline$BDLHandleRemove$1$label_5#1:
    goto inline$BDLHandleRemove$1$label_6#1;

  inline$BDLHandleRemove$1$label_6#1:
    havoc inline$BDLHandleRemove$1$myNondetVar_0;
    goto inline$BDLHandleRemove$1$label_7#1;

  inline$BDLHandleRemove$1$label_7#1:
    goto inline$BDLGetDebugLevel$661$Entry#1;

  inline$BDLGetDebugLevel$661$Entry#1:
    goto inline$BDLGetDebugLevel$661$start#1;

  inline$BDLGetDebugLevel$661$start#1:
    goto inline$BDLGetDebugLevel$661$label_3#1;

  inline$BDLGetDebugLevel$661$label_3#1:
    havoc inline$BDLGetDebugLevel$661$myNondetVar_0;
    inline$BDLGetDebugLevel$661$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$661$myNondetVar_0;
    goto inline$BDLGetDebugLevel$661$label_1#1;

  inline$BDLGetDebugLevel$661$label_1#1:
    goto inline$BDLGetDebugLevel$661$Return#1;

  inline$BDLGetDebugLevel$661$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$2$ := inline$BDLGetDebugLevel$661$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_7$1#1;

  inline$BDLHandleRemove$1$label_7$1#1:
    goto inline$BDLHandleRemove$1$anon42_Then#1, inline$BDLHandleRemove$1$anon42_Else#1;

  inline$BDLHandleRemove$1$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon1#1;

  inline$BDLHandleRemove$1$anon1#1:
    goto inline$BDLHandleRemove$1$label_10#1;

  inline$BDLHandleRemove$1$label_10#1:
    goto inline$BDLHandleRemove$1$label_10_true#1, inline$BDLHandleRemove$1$label_10_false#1;

  inline$BDLHandleRemove$1$label_10_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$2$) == 0;
    goto inline$BDLHandleRemove$1$label_11#1;

  inline$BDLHandleRemove$1$label_10_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$2$) != 0;
    goto inline$BDLHandleRemove$1$label_14#1;

  inline$BDLHandleRemove$1$label_14#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_15#1;

  inline$BDLHandleRemove$1$label_15#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_16#1;

  inline$BDLHandleRemove$1$label_16#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_17#1;

  inline$BDLHandleRemove$1$label_17#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2386.0$3$;
    goto inline$BDLHandleRemove$1$label_11#1;

  inline$BDLHandleRemove$1$label_11#1:
    goto inline$BDLGetDebugLevel$662$Entry#1;

  inline$BDLGetDebugLevel$662$Entry#1:
    goto inline$BDLGetDebugLevel$662$start#1;

  inline$BDLGetDebugLevel$662$start#1:
    goto inline$BDLGetDebugLevel$662$label_3#1;

  inline$BDLGetDebugLevel$662$label_3#1:
    havoc inline$BDLGetDebugLevel$662$myNondetVar_0;
    inline$BDLGetDebugLevel$662$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$662$myNondetVar_0;
    goto inline$BDLGetDebugLevel$662$label_1#1;

  inline$BDLGetDebugLevel$662$label_1#1:
    goto inline$BDLGetDebugLevel$662$Return#1;

  inline$BDLGetDebugLevel$662$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$7$ := inline$BDLGetDebugLevel$662$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_11$1#1;

  inline$BDLHandleRemove$1$label_11$1#1:
    goto inline$BDLHandleRemove$1$anon43_Then#1, inline$BDLHandleRemove$1$anon43_Else#1;

  inline$BDLHandleRemove$1$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon3#1;

  inline$BDLHandleRemove$1$anon3#1:
    goto inline$BDLHandleRemove$1$label_20#1;

  inline$BDLHandleRemove$1$label_20#1:
    goto inline$BDLHandleRemove$1$label_20_true#1, inline$BDLHandleRemove$1$label_20_false#1;

  inline$BDLHandleRemove$1$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$7$) == 0;
    goto inline$BDLHandleRemove$1$label_21#1;

  inline$BDLHandleRemove$1$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$7$) != 0;
    goto inline$BDLHandleRemove$1$label_24#1;

  inline$BDLHandleRemove$1$label_24#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_25#1;

  inline$BDLHandleRemove$1$label_25#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_26#1;

  inline$BDLHandleRemove$1$label_26#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_27#1;

  inline$BDLHandleRemove$1$label_27#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2386.0$8$;
    goto inline$BDLHandleRemove$1$label_21#1;

  inline$BDLHandleRemove$1$label_21#1:
    goto inline$BDLGetDebugLevel$663$Entry#1;

  inline$BDLGetDebugLevel$663$Entry#1:
    goto inline$BDLGetDebugLevel$663$start#1;

  inline$BDLGetDebugLevel$663$start#1:
    goto inline$BDLGetDebugLevel$663$label_3#1;

  inline$BDLGetDebugLevel$663$label_3#1:
    havoc inline$BDLGetDebugLevel$663$myNondetVar_0;
    inline$BDLGetDebugLevel$663$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$663$myNondetVar_0;
    goto inline$BDLGetDebugLevel$663$label_1#1;

  inline$BDLGetDebugLevel$663$label_1#1:
    goto inline$BDLGetDebugLevel$663$Return#1;

  inline$BDLGetDebugLevel$663$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$12$ := inline$BDLGetDebugLevel$663$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_21$1#1;

  inline$BDLHandleRemove$1$label_21$1#1:
    goto inline$BDLHandleRemove$1$anon44_Then#1, inline$BDLHandleRemove$1$anon44_Else#1;

  inline$BDLHandleRemove$1$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon5#1;

  inline$BDLHandleRemove$1$anon5#1:
    goto inline$BDLHandleRemove$1$label_30#1;

  inline$BDLHandleRemove$1$label_30#1:
    goto inline$BDLHandleRemove$1$label_30_true#1, inline$BDLHandleRemove$1$label_30_false#1;

  inline$BDLHandleRemove$1$label_30_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$12$, 4) == 0;
    goto inline$BDLHandleRemove$1$label_31#1;

  inline$BDLHandleRemove$1$label_30_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2386.0$12$, 4) != 0;
    goto inline$BDLHandleRemove$1$label_34#1;

  inline$BDLHandleRemove$1$label_34#1:
    goto inline$BDLHandleRemove$1$label_31#1;

  inline$BDLHandleRemove$1$label_31#1:
    goto inline$storm_KeSetEvent$29$Entry#1;

  inline$storm_KeSetEvent$29$Entry#1:
    inline$storm_KeSetEvent$29$$Event$1$213.14$storm_KeSetEvent$12_.1 := DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12);
    goto inline$storm_KeSetEvent$29$start#1;

  inline$storm_KeSetEvent$29$start#1:
    inline$storm_KeSetEvent$29$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$29$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$29$label_3#1;

  inline$storm_KeSetEvent$29$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$29$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$29$label_1#1;

  inline$storm_KeSetEvent$29$label_1#1:
    goto inline$storm_KeSetEvent$29$Return#1;

  inline$storm_KeSetEvent$29$Return#1:
    goto inline$BDLHandleRemove$1$label_31$1#1;

  inline$BDLHandleRemove$1$label_31$1#1:
    goto inline$BDLHandleRemove$1$anon45_Then#1, inline$BDLHandleRemove$1$anon45_Else#1;

  inline$BDLHandleRemove$1$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon7#1;

  inline$BDLHandleRemove$1$anon7#1:
    goto inline$BDLHandleRemove$1$label_35#1;

  inline$BDLHandleRemove$1$label_35#1:
    call inline$BDLHandleRemove$1$$result.IoSetDeviceInterfaceState$2406.29$14$ := IoSetDeviceInterfaceState(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12), 0);
    goto inline$BDLHandleRemove$1$anon46_Then#1, inline$BDLHandleRemove$1$anon46_Else#1;

  inline$BDLHandleRemove$1$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon9#1;

  inline$BDLHandleRemove$1$anon9#1:
    goto inline$BDLHandleRemove$1$label_38#1;

  inline$BDLHandleRemove$1$label_38#1:
    goto inline$BDLCleanupNotificationStruct$1$Entry#1;

  inline$BDLCleanupNotificationStruct$1$Entry#1:
    inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4_.1 := inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12;
    goto inline$BDLCleanupNotificationStruct$1$start#1;

  inline$BDLCleanupNotificationStruct$1$start#1:
    call inline$BDLCleanupNotificationStruct$1$$bddiRegisterNotifyParams$10$3120.36$BDLCleanupNotificationStruct$4 := __HAVOC_malloc(20);
    call inline$BDLCleanupNotificationStruct$1$$irql$3$3113.45$BDLCleanupNotificationStruct$4 := __HAVOC_malloc(1);
    inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4_.1;
    goto inline$BDLCleanupNotificationStruct$1$label_3#1;

  inline$BDLCleanupNotificationStruct$1$label_3#1:
    goto inline$BDLCleanupNotificationStruct$1$label_4#1;

  inline$BDLCleanupNotificationStruct$1$label_4#1:
    goto inline$BDLCleanupNotificationStruct$1$label_5#1;

  inline$BDLCleanupNotificationStruct$1$label_5#1:
    goto inline$BDLCleanupNotificationStruct$1$label_6#1;

  inline$BDLCleanupNotificationStruct$1$label_6#1:
    goto inline$BDLCleanupNotificationStruct$1$label_7#1;

  inline$BDLCleanupNotificationStruct$1$label_7#1:
    goto inline$BDLCleanupNotificationStruct$1$label_8#1;

  inline$BDLCleanupNotificationStruct$1$label_8#1:
    goto inline$BDLCleanupNotificationStruct$1$label_9#1;

  inline$BDLCleanupNotificationStruct$1$label_9#1:
    goto inline$BDLCleanupNotificationStruct$1$label_10#1;

  inline$BDLCleanupNotificationStruct$1$label_10#1:
    inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$1$label_11#1;

  inline$BDLCleanupNotificationStruct$1$label_11#1:
    goto inline$BDLCleanupNotificationStruct$1$label_12#1;

  inline$BDLCleanupNotificationStruct$1$label_12#1:
    inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$1$label_13#1;

  inline$BDLCleanupNotificationStruct$1$label_13#1:
    goto inline$BDLCleanupNotificationStruct$1$label_14#1;

  inline$BDLCleanupNotificationStruct$1$label_14#1:
    inline$BDLCleanupNotificationStruct$1$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$1$label_15#1;

  inline$BDLCleanupNotificationStruct$1$label_15#1:
    goto inline$BDLCleanupNotificationStruct$1$label_16#1;

  inline$BDLCleanupNotificationStruct$1$label_16#1:
    inline$BDLCleanupNotificationStruct$1$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$1$label_17#1;

  inline$BDLCleanupNotificationStruct$1$label_17#1:
    goto inline$BDLCleanupNotificationStruct$1$label_18#1;

  inline$BDLCleanupNotificationStruct$1$label_18#1:
    goto inline$BDLCleanupNotificationStruct$1$label_19#1;

  inline$BDLCleanupNotificationStruct$1$label_19#1:
    goto inline$BDLGetDebugLevel$664$Entry#1;

  inline$BDLGetDebugLevel$664$Entry#1:
    goto inline$BDLGetDebugLevel$664$start#1;

  inline$BDLGetDebugLevel$664$start#1:
    goto inline$BDLGetDebugLevel$664$label_3#1;

  inline$BDLGetDebugLevel$664$label_3#1:
    havoc inline$BDLGetDebugLevel$664$myNondetVar_0;
    inline$BDLGetDebugLevel$664$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$664$myNondetVar_0;
    goto inline$BDLGetDebugLevel$664$label_1#1;

  inline$BDLGetDebugLevel$664$label_1#1:
    goto inline$BDLGetDebugLevel$664$Return#1;

  inline$BDLGetDebugLevel$664$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$1$ := inline$BDLGetDebugLevel$664$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_19$1#1;

  inline$BDLCleanupNotificationStruct$1$label_19$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon46_Then#1, inline$BDLCleanupNotificationStruct$1$anon46_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon1#1;

  inline$BDLCleanupNotificationStruct$1$anon1#1:
    goto inline$BDLCleanupNotificationStruct$1$label_22#1;

  inline$BDLCleanupNotificationStruct$1$label_22#1:
    goto inline$BDLCleanupNotificationStruct$1$label_22_true#1, inline$BDLCleanupNotificationStruct$1$label_22_false#1;

  inline$BDLCleanupNotificationStruct$1$label_22_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$1$) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_23#1;

  inline$BDLCleanupNotificationStruct$1$label_22_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$1$) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_26#1;

  inline$BDLCleanupNotificationStruct$1$label_26#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_27#1;

  inline$BDLCleanupNotificationStruct$1$label_27#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_28#1;

  inline$BDLCleanupNotificationStruct$1$label_28#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_29#1;

  inline$BDLCleanupNotificationStruct$1$label_29#1:
    havoc inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3123.0$2$;
    goto inline$BDLCleanupNotificationStruct$1$label_23#1;

  inline$BDLCleanupNotificationStruct$1$label_23#1:
    goto inline$BDLGetDebugLevel$665$Entry#1;

  inline$BDLGetDebugLevel$665$Entry#1:
    goto inline$BDLGetDebugLevel$665$start#1;

  inline$BDLGetDebugLevel$665$start#1:
    goto inline$BDLGetDebugLevel$665$label_3#1;

  inline$BDLGetDebugLevel$665$label_3#1:
    havoc inline$BDLGetDebugLevel$665$myNondetVar_0;
    inline$BDLGetDebugLevel$665$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$665$myNondetVar_0;
    goto inline$BDLGetDebugLevel$665$label_1#1;

  inline$BDLGetDebugLevel$665$label_1#1:
    goto inline$BDLGetDebugLevel$665$Return#1;

  inline$BDLGetDebugLevel$665$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$6$ := inline$BDLGetDebugLevel$665$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_23$1#1;

  inline$BDLCleanupNotificationStruct$1$label_23$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon47_Then#1, inline$BDLCleanupNotificationStruct$1$anon47_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon3#1;

  inline$BDLCleanupNotificationStruct$1$anon3#1:
    goto inline$BDLCleanupNotificationStruct$1$label_32#1;

  inline$BDLCleanupNotificationStruct$1$label_32#1:
    goto inline$BDLCleanupNotificationStruct$1$label_32_true#1, inline$BDLCleanupNotificationStruct$1$label_32_false#1;

  inline$BDLCleanupNotificationStruct$1$label_32_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$6$) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_33#1;

  inline$BDLCleanupNotificationStruct$1$label_32_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$6$) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_36#1;

  inline$BDLCleanupNotificationStruct$1$label_36#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_37#1;

  inline$BDLCleanupNotificationStruct$1$label_37#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_38#1;

  inline$BDLCleanupNotificationStruct$1$label_38#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_39#1;

  inline$BDLCleanupNotificationStruct$1$label_39#1:
    havoc inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3123.0$7$;
    goto inline$BDLCleanupNotificationStruct$1$label_33#1;

  inline$BDLCleanupNotificationStruct$1$label_33#1:
    goto inline$BDLGetDebugLevel$666$Entry#1;

  inline$BDLGetDebugLevel$666$Entry#1:
    goto inline$BDLGetDebugLevel$666$start#1;

  inline$BDLGetDebugLevel$666$start#1:
    goto inline$BDLGetDebugLevel$666$label_3#1;

  inline$BDLGetDebugLevel$666$label_3#1:
    havoc inline$BDLGetDebugLevel$666$myNondetVar_0;
    inline$BDLGetDebugLevel$666$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$666$myNondetVar_0;
    goto inline$BDLGetDebugLevel$666$label_1#1;

  inline$BDLGetDebugLevel$666$label_1#1:
    goto inline$BDLGetDebugLevel$666$Return#1;

  inline$BDLGetDebugLevel$666$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$11$ := inline$BDLGetDebugLevel$666$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_33$1#1;

  inline$BDLCleanupNotificationStruct$1$label_33$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon48_Then#1, inline$BDLCleanupNotificationStruct$1$anon48_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon5#1;

  inline$BDLCleanupNotificationStruct$1$anon5#1:
    goto inline$BDLCleanupNotificationStruct$1$label_42#1;

  inline$BDLCleanupNotificationStruct$1$label_42#1:
    goto inline$BDLCleanupNotificationStruct$1$label_42_true#1, inline$BDLCleanupNotificationStruct$1$label_42_false#1;

  inline$BDLCleanupNotificationStruct$1$label_42_false#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$11$, 4) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_43#1;

  inline$BDLCleanupNotificationStruct$1$label_42_true#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3123.0$11$, 4) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_44#1;

  inline$BDLCleanupNotificationStruct$1$label_44#1:
    goto inline$BDLCleanupNotificationStruct$1$label_43#1;

  inline$BDLCleanupNotificationStruct$1$label_43#1:
    goto inline$BDLCleanupNotificationStruct$1$label_45#1;

  inline$BDLCleanupNotificationStruct$1$label_45#1:
    goto inline$BDLCleanupNotificationStruct$1$label_45_head#1;

  inline$BDLCleanupNotificationStruct$1$label_45_head#1:
    goto inline$BDLCleanupNotificationStruct$1$label_45_true#1, inline$BDLCleanupNotificationStruct$1$label_45_false#1;

  inline$BDLCleanupNotificationStruct$1$label_45_false#1:
    assume 1 == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_46#1;

  inline$BDLCleanupNotificationStruct$1$label_45_true#1:
    assume 1 != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_49#1;

  inline$BDLCleanupNotificationStruct$1$label_49#1:
    call inline$BDLCleanupNotificationStruct$1$$result.KfRaiseIrql$3141.8$12$ := KfRaiseIrql(2);
    goto inline$BDLCleanupNotificationStruct$1$anon50_Then#1, inline$BDLCleanupNotificationStruct$1$anon50_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon9#1;

  inline$BDLCleanupNotificationStruct$1$anon9#1:
    goto inline$BDLCleanupNotificationStruct$1$label_52#1;

  inline$BDLCleanupNotificationStruct$1$label_52#1:
    inline$BDLCleanupNotificationStruct$1$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$1$$result.KfRaiseIrql$3141.8$12$;
    goto inline$BDLCleanupNotificationStruct$1$label_53#1;

  inline$BDLCleanupNotificationStruct$1$label_53#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_1;
    assume inline$BDLCleanupNotificationStruct$1$myNondetVar_0 == inline$BDLCleanupNotificationStruct$1$myNondetVar_1;
    goto inline$storm_KeAcquireSpinLock$3$Entry#1;

  inline$storm_KeAcquireSpinLock$3$Entry#1:
    inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$storm_KeAcquireSpinLock$3$start#1;

  inline$storm_KeAcquireSpinLock$3$start#1:
    inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1;
    goto inline$storm_KeAcquireSpinLock$3$label_3#1;

  inline$storm_KeAcquireSpinLock$3$label_3#1:
    goto inline$storm_KeAcquireSpinLock$3$label_4#1;

  inline$storm_KeAcquireSpinLock$3$label_4#1:
    goto inline$storm_getThreadID$8$Entry#1;

  inline$storm_getThreadID$8$Entry#1:
    goto inline$storm_getThreadID$8$anon0#1;

  inline$storm_getThreadID$8$anon0#1:
    inline$storm_getThreadID$8$tid := __storm_thread_id;
    goto inline$storm_getThreadID$8$Return#1;

  inline$storm_getThreadID$8$Return#1:
    inline$storm_KeAcquireSpinLock$3$$result.storm_getThreadID$128.29$1$ := inline$storm_getThreadID$8$tid;
    goto inline$storm_KeAcquireSpinLock$3$label_4$1#1;

  inline$storm_KeAcquireSpinLock$3$label_4$1#1:
    goto inline$storm_KeAcquireSpinLock$3$label_7#1;

  inline$storm_KeAcquireSpinLock$3$label_7#1:
    inline$storm_KeAcquireSpinLock$3$$tid$3$128.6$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$3$$result.storm_getThreadID$128.29$1$;
    goto inline$storm_KeAcquireSpinLock$3$label_8#1;

  inline$storm_KeAcquireSpinLock$3$label_8#1:
    goto inline$storm_KeAcquireSpinLock$3$label_9#1;

  inline$storm_KeAcquireSpinLock$3$label_9#1:
    __storm_atomic := true;
    goto inline$storm_KeAcquireSpinLock$3$label_12#1;

  inline$storm_KeAcquireSpinLock$3$label_12#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$3$anon7_Then#1, inline$storm_KeAcquireSpinLock$3$anon7_Else#1;

  inline$storm_KeAcquireSpinLock$3$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$3$anon1#1;

  inline$storm_KeAcquireSpinLock$3$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8], inline$storm_KeAcquireSpinLock$3$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$3$label_13#1;

  inline$storm_KeAcquireSpinLock$3$label_13#1:
    goto inline$storm_KeAcquireSpinLock$3$label_13_true#1, inline$storm_KeAcquireSpinLock$3$label_13_false#1;

  inline$storm_KeAcquireSpinLock$3$label_13_false#1:
    assume !INT_NEQ(inline$storm_KeAcquireSpinLock$3$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$3$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$3$label_14#1;

  inline$storm_KeAcquireSpinLock$3$label_14#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeAcquireSpinLock$3$label_1#1;

  inline$storm_KeAcquireSpinLock$3$label_13_true#1:
    assume INT_NEQ(inline$storm_KeAcquireSpinLock$3$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$3$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$3$label_17#1;

  inline$storm_KeAcquireSpinLock$3$label_17#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$3$anon8_Then#1, inline$storm_KeAcquireSpinLock$3$anon8_Else#1;

  inline$storm_KeAcquireSpinLock$3$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$3$anon4#1;

  inline$storm_KeAcquireSpinLock$3$anon4#1:
    assume INT_EQ(inline$storm_KeAcquireSpinLock$3$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8, 0);
    goto inline$storm_KeAcquireSpinLock$3$label_18#1;

  inline$storm_KeAcquireSpinLock$3$label_18#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeAcquireSpinLock$3$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$3$$tid$3$128.6$storm_KeAcquireSpinLock$8];
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$3$label_19#1;

  inline$storm_KeAcquireSpinLock$3$label_19#1:
    goto inline$storm_KeAcquireSpinLock$3$anon9_Then#1, inline$storm_KeAcquireSpinLock$3$anon9_Else#1;

  inline$storm_KeAcquireSpinLock$3$anon9_Else#1:
    assume __storm_init;
    goto inline$storm_KeAcquireSpinLock$3$anon6#1;

  inline$storm_KeAcquireSpinLock$3$anon9_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeAcquireSpinLock$3$anon6#1;

  inline$storm_KeAcquireSpinLock$3$anon6#1:
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$3$label_1#1;

  inline$storm_KeAcquireSpinLock$3$label_1#1:
    goto inline$storm_KeAcquireSpinLock$3$Return#1;

  inline$storm_KeAcquireSpinLock$3$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$3$Return#1;

  inline$storm_KeAcquireSpinLock$3$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$3$Return#1;

  inline$storm_KeAcquireSpinLock$3$Return#1:
    goto inline$BDLCleanupNotificationStruct$1$label_53$1#1;

  inline$BDLCleanupNotificationStruct$1$label_53$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon51_Then#1, inline$BDLCleanupNotificationStruct$1$anon51_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon11#1;

  inline$BDLCleanupNotificationStruct$1$anon11#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$1$label_56#1;

  inline$BDLCleanupNotificationStruct$1$label_56#1:
    goto inline$IsListEmpty$4$Entry#1;

  inline$IsListEmpty$4$Entry#1:
    inline$IsListEmpty$4$$ListHead$1$8097.28$IsListEmpty$4_.1 := ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$IsListEmpty$4$start#1;

  inline$IsListEmpty$4$start#1:
    inline$IsListEmpty$4$$ListHead$1$8097.28$IsListEmpty$4 := inline$IsListEmpty$4$$ListHead$1$8097.28$IsListEmpty$4_.1;
    goto inline$IsListEmpty$4$label_3#1;

  inline$IsListEmpty$4$label_3#1:
    havoc inline$IsListEmpty$4$myNondetVar_0;
    inline$IsListEmpty$4$$result.IsListEmpty$8096.0$1$ := LIFT(INT_EQ(inline$IsListEmpty$4$myNondetVar_0, inline$IsListEmpty$4$$ListHead$1$8097.28$IsListEmpty$4));
    goto inline$IsListEmpty$4$label_1#1;

  inline$IsListEmpty$4$label_1#1:
    goto inline$IsListEmpty$4$Return#1;

  inline$IsListEmpty$4$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3144.23$13$ := inline$IsListEmpty$4$$result.IsListEmpty$8096.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_56$1#1;

  inline$BDLCleanupNotificationStruct$1$label_56$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon52_Then#1, inline$BDLCleanupNotificationStruct$1$anon52_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon13#1;

  inline$BDLCleanupNotificationStruct$1$anon13#1:
    goto inline$BDLCleanupNotificationStruct$1$label_59#1;

  inline$BDLCleanupNotificationStruct$1$label_59#1:
    goto inline$BDLCleanupNotificationStruct$1$label_59_true#1, inline$BDLCleanupNotificationStruct$1$label_59_false#1;

  inline$BDLCleanupNotificationStruct$1$label_59_false#1:
    assume inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3144.23$13$ == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_60#1;

  inline$BDLCleanupNotificationStruct$1$label_60#1:
    goto inline$RemoveHeadList$3$Entry#1;

  inline$RemoveHeadList$3$Entry#1:
    goto inline$RemoveHeadList$3$start#1;

  inline$RemoveHeadList$3$start#1:
    goto inline$RemoveHeadList$3$label_3#1;

  inline$RemoveHeadList$3$label_3#1:
    goto inline$RemoveHeadList$3$label_4#1;

  inline$RemoveHeadList$3$label_4#1:
    goto inline$RemoveHeadList$3$label_5#1;

  inline$RemoveHeadList$3$label_5#1:
    havoc inline$RemoveHeadList$3$myNondetVar_0;
    inline$RemoveHeadList$3$$Entry$3$8126.16$RemoveHeadList$4 := inline$RemoveHeadList$3$myNondetVar_0;
    goto inline$RemoveHeadList$3$label_6#1;

  inline$RemoveHeadList$3$label_6#1:
    havoc inline$RemoveHeadList$3$myNondetVar_0;
    goto inline$RemoveHeadList$3$label_7#1;

  inline$RemoveHeadList$3$label_7#1:
    goto inline$RemoveHeadList$3$label_8#1;

  inline$RemoveHeadList$3$label_8#1:
    goto inline$RemoveHeadList$3$label_9#1;

  inline$RemoveHeadList$3$label_9#1:
    inline$RemoveHeadList$3$$result.RemoveHeadList$8121.0$1$ := inline$RemoveHeadList$3$$Entry$3$8126.16$RemoveHeadList$4;
    goto inline$RemoveHeadList$3$label_1#1;

  inline$RemoveHeadList$3$label_1#1:
    goto inline$RemoveHeadList$3$Return#1;

  inline$RemoveHeadList$3$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.RemoveHeadList$3153.26$14$ := inline$RemoveHeadList$3$$result.RemoveHeadList$8121.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_60$1#1;

  inline$BDLCleanupNotificationStruct$1$label_60$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon53_Then#1, inline$BDLCleanupNotificationStruct$1$anon53_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon15#1;

  inline$BDLCleanupNotificationStruct$1$anon15#1:
    goto inline$BDLCleanupNotificationStruct$1$label_63#1;

  inline$BDLCleanupNotificationStruct$1$label_63#1:
    inline$BDLCleanupNotificationStruct$1$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$1$$result.RemoveHeadList$3153.26$14$;
    goto inline$BDLCleanupNotificationStruct$1$label_64#1;

  inline$BDLCleanupNotificationStruct$1$label_64#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_1;
    assume inline$BDLCleanupNotificationStruct$1$myNondetVar_0 == inline$BDLCleanupNotificationStruct$1$myNondetVar_1;
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$storm_KeReleaseSpinLock$5$Entry#1;

  inline$storm_KeReleaseSpinLock$5$Entry#1:
    inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$storm_KeReleaseSpinLock$5$start#1;

  inline$storm_KeReleaseSpinLock$5$start#1:
    inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$5$label_3#1;

  inline$storm_KeReleaseSpinLock$5$label_3#1:
    goto inline$storm_KeReleaseSpinLock$5$label_4#1;

  inline$storm_KeReleaseSpinLock$5$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$5$label_7#1;

  inline$storm_KeReleaseSpinLock$5$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$5$anon5_Then#1, inline$storm_KeReleaseSpinLock$5$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$5$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$5$anon1#1;

  inline$storm_KeReleaseSpinLock$5$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$5$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$5$label_8#1;

  inline$storm_KeReleaseSpinLock$5$label_8#1:
    goto inline$storm_getThreadID$9$Entry#1;

  inline$storm_getThreadID$9$Entry#1:
    goto inline$storm_getThreadID$9$anon0#1;

  inline$storm_getThreadID$9$anon0#1:
    inline$storm_getThreadID$9$tid := __storm_thread_id;
    goto inline$storm_getThreadID$9$Return#1;

  inline$storm_getThreadID$9$Return#1:
    inline$storm_KeReleaseSpinLock$5$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$9$tid;
    goto inline$storm_KeReleaseSpinLock$5$label_8$1#1;

  inline$storm_KeReleaseSpinLock$5$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$5$label_11#1;

  inline$storm_KeReleaseSpinLock$5$label_11#1:
    goto inline$storm_KeReleaseSpinLock$5$label_11_true#1, inline$storm_KeReleaseSpinLock$5$label_11_false#1;

  inline$storm_KeReleaseSpinLock$5$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$5$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$5$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$5$label_12#1;

  inline$storm_KeReleaseSpinLock$5$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$5$label_1#1;

  inline$storm_KeReleaseSpinLock$5$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$5$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$5$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$5$label_15#1;

  inline$storm_KeReleaseSpinLock$5$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$5$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$5$label_16#1;

  inline$storm_KeReleaseSpinLock$5$label_16#1:
    goto inline$storm_KeReleaseSpinLock$5$anon6_Then#1, inline$storm_KeReleaseSpinLock$5$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$5$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$5$anon4#1;

  inline$storm_KeReleaseSpinLock$5$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$5$anon4#1;

  inline$storm_KeReleaseSpinLock$5$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$5$label_1#1;

  inline$storm_KeReleaseSpinLock$5$label_1#1:
    goto inline$storm_KeReleaseSpinLock$5$Return#1;

  inline$storm_KeReleaseSpinLock$5$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$5$Return#1;

  inline$storm_KeReleaseSpinLock$5$Return#1:
    goto inline$BDLCleanupNotificationStruct$1$label_64$1#1;

  inline$BDLCleanupNotificationStruct$1$label_64$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon54_Then#1, inline$BDLCleanupNotificationStruct$1$anon54_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon54_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon17#1;

  inline$BDLCleanupNotificationStruct$1$anon17#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$1$label_67#1;

  inline$BDLCleanupNotificationStruct$1$label_67#1:
    call KfLowerIrql(inline$BDLCleanupNotificationStruct$1$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4);
    goto inline$BDLCleanupNotificationStruct$1$anon55_Then#1, inline$BDLCleanupNotificationStruct$1$anon55_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon55_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon19#1;

  inline$BDLCleanupNotificationStruct$1$anon19#1:
    goto inline$BDLCleanupNotificationStruct$1$label_70#1;

  inline$BDLCleanupNotificationStruct$1$label_70#1:
    inline$BDLCleanupNotificationStruct$1$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4 := MINUS_LEFT_PTR(inline$BDLCleanupNotificationStruct$1$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4, 1, 12);
    goto inline$BDLCleanupNotificationStruct$1$label_71#1;

  inline$BDLCleanupNotificationStruct$1$label_71#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$1$label_72#1;

  inline$BDLCleanupNotificationStruct$1$label_72#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$1$label_73#1;

  inline$BDLCleanupNotificationStruct$1$label_73#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$1$label_74#1;

  inline$BDLCleanupNotificationStruct$1$label_74#1:
    call ExFreePoolWithTag(inline$BDLCleanupNotificationStruct$1$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4, 541869122);
    goto inline$BDLCleanupNotificationStruct$1$anon56_Then#1, inline$BDLCleanupNotificationStruct$1$anon56_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon56_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon21#1;

  inline$BDLCleanupNotificationStruct$1$anon21#1:
    goto inline$BDLCleanupNotificationStruct$1$label_77#1;

  inline$BDLCleanupNotificationStruct$1$label_77#1:
    goto inline$BDLCleanupNotificationStruct$1$label_80#1;

  inline$BDLCleanupNotificationStruct$1$label_80#1:
    inline$BDLCleanupNotificationStruct$1$$status$11$3121.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$1$$callresult.$3172.84$15$;
    goto inline$BDLCleanupNotificationStruct$1$label_81#1;

  inline$BDLCleanupNotificationStruct$1$label_81#1:
    goto inline$BDLCleanupNotificationStruct$1$label_81_true#1, inline$BDLCleanupNotificationStruct$1$label_81_false#1;

  inline$BDLCleanupNotificationStruct$1$label_81_false#1:
    assume inline$BDLCleanupNotificationStruct$1$$status$11$3121.36$BDLCleanupNotificationStruct$4 == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_45_head#0;

  inline$BDLCleanupNotificationStruct$1$label_81_true#1:
    assume inline$BDLCleanupNotificationStruct$1$$status$11$3121.36$BDLCleanupNotificationStruct$4 != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_82#1;

  inline$BDLCleanupNotificationStruct$1$label_82#1:
    goto inline$BDLGetDebugLevel$667$Entry#1;

  inline$BDLGetDebugLevel$667$Entry#1:
    goto inline$BDLGetDebugLevel$667$start#1;

  inline$BDLGetDebugLevel$667$start#1:
    goto inline$BDLGetDebugLevel$667$label_3#1;

  inline$BDLGetDebugLevel$667$label_3#1:
    havoc inline$BDLGetDebugLevel$667$myNondetVar_0;
    inline$BDLGetDebugLevel$667$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$667$myNondetVar_0;
    goto inline$BDLGetDebugLevel$667$label_1#1;

  inline$BDLGetDebugLevel$667$label_1#1:
    goto inline$BDLGetDebugLevel$667$Return#1;

  inline$BDLGetDebugLevel$667$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$16$ := inline$BDLGetDebugLevel$667$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_82$1#1;

  inline$BDLCleanupNotificationStruct$1$label_82$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon57_Then#1, inline$BDLCleanupNotificationStruct$1$anon57_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon57_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon23#1;

  inline$BDLCleanupNotificationStruct$1$anon23#1:
    goto inline$BDLCleanupNotificationStruct$1$label_85#1;

  inline$BDLCleanupNotificationStruct$1$label_85#1:
    goto inline$BDLCleanupNotificationStruct$1$label_85_true#1, inline$BDLCleanupNotificationStruct$1$label_85_false#1;

  inline$BDLCleanupNotificationStruct$1$label_85_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$16$) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_86#1;

  inline$BDLCleanupNotificationStruct$1$label_85_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$16$) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_89#1;

  inline$BDLCleanupNotificationStruct$1$label_89#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_90#1;

  inline$BDLCleanupNotificationStruct$1$label_90#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_91#1;

  inline$BDLCleanupNotificationStruct$1$label_91#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_92#1;

  inline$BDLCleanupNotificationStruct$1$label_92#1:
    havoc inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3178.0$17$;
    goto inline$BDLCleanupNotificationStruct$1$label_86#1;

  inline$BDLCleanupNotificationStruct$1$label_86#1:
    goto inline$BDLGetDebugLevel$668$Entry#1;

  inline$BDLGetDebugLevel$668$Entry#1:
    goto inline$BDLGetDebugLevel$668$start#1;

  inline$BDLGetDebugLevel$668$start#1:
    goto inline$BDLGetDebugLevel$668$label_3#1;

  inline$BDLGetDebugLevel$668$label_3#1:
    havoc inline$BDLGetDebugLevel$668$myNondetVar_0;
    inline$BDLGetDebugLevel$668$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$668$myNondetVar_0;
    goto inline$BDLGetDebugLevel$668$label_1#1;

  inline$BDLGetDebugLevel$668$label_1#1:
    goto inline$BDLGetDebugLevel$668$Return#1;

  inline$BDLGetDebugLevel$668$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$21$ := inline$BDLGetDebugLevel$668$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_86$1#1;

  inline$BDLCleanupNotificationStruct$1$label_86$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon58_Then#1, inline$BDLCleanupNotificationStruct$1$anon58_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon58_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon25#1;

  inline$BDLCleanupNotificationStruct$1$anon25#1:
    goto inline$BDLCleanupNotificationStruct$1$label_95#1;

  inline$BDLCleanupNotificationStruct$1$label_95#1:
    goto inline$BDLCleanupNotificationStruct$1$label_95_true#1, inline$BDLCleanupNotificationStruct$1$label_95_false#1;

  inline$BDLCleanupNotificationStruct$1$label_95_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$21$) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_96#1;

  inline$BDLCleanupNotificationStruct$1$label_95_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$21$) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_99#1;

  inline$BDLCleanupNotificationStruct$1$label_99#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_100#1;

  inline$BDLCleanupNotificationStruct$1$label_100#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_101#1;

  inline$BDLCleanupNotificationStruct$1$label_101#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_102#1;

  inline$BDLCleanupNotificationStruct$1$label_102#1:
    havoc inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3178.0$22$;
    goto inline$BDLCleanupNotificationStruct$1$label_96#1;

  inline$BDLCleanupNotificationStruct$1$label_96#1:
    goto inline$BDLGetDebugLevel$669$Entry#1;

  inline$BDLGetDebugLevel$669$Entry#1:
    goto inline$BDLGetDebugLevel$669$start#1;

  inline$BDLGetDebugLevel$669$start#1:
    goto inline$BDLGetDebugLevel$669$label_3#1;

  inline$BDLGetDebugLevel$669$label_3#1:
    havoc inline$BDLGetDebugLevel$669$myNondetVar_0;
    inline$BDLGetDebugLevel$669$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$669$myNondetVar_0;
    goto inline$BDLGetDebugLevel$669$label_1#1;

  inline$BDLGetDebugLevel$669$label_1#1:
    goto inline$BDLGetDebugLevel$669$Return#1;

  inline$BDLGetDebugLevel$669$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$26$ := inline$BDLGetDebugLevel$669$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_96$1#1;

  inline$BDLCleanupNotificationStruct$1$label_96$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon59_Then#1, inline$BDLCleanupNotificationStruct$1$anon59_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon59_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon27#1;

  inline$BDLCleanupNotificationStruct$1$anon27#1:
    goto inline$BDLCleanupNotificationStruct$1$label_105#1;

  inline$BDLCleanupNotificationStruct$1$label_105#1:
    goto inline$BDLCleanupNotificationStruct$1$label_105_true#1, inline$BDLCleanupNotificationStruct$1$label_105_false#1;

  inline$BDLCleanupNotificationStruct$1$label_105_false#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$26$, 4) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_45_head#0;

  inline$BDLCleanupNotificationStruct$1$label_105_true#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3178.0$26$, 4) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_106#1;

  inline$BDLCleanupNotificationStruct$1$label_106#1:
    goto inline$BDLCleanupNotificationStruct$1$label_45_head#0;

  inline$BDLCleanupNotificationStruct$1$label_45_head#0:
    assume false;
    return;

  inline$BDLCleanupNotificationStruct$1$anon59_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon58_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon57_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon56_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon55_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon54_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon53_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$label_59_true#1:
    assume inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3144.23$13$ != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_46#1;

  inline$BDLCleanupNotificationStruct$1$label_46#1:
    goto inline$BDLCleanupNotificationStruct$1$label_46_head#1;

  inline$BDLCleanupNotificationStruct$1$label_46_head#1:
    goto inline$IsListEmpty$3$Entry#1;

  inline$IsListEmpty$3$Entry#1:
    inline$IsListEmpty$3$$ListHead$1$8097.28$IsListEmpty$4_.1 := ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$IsListEmpty$3$start#1;

  inline$IsListEmpty$3$start#1:
    inline$IsListEmpty$3$$ListHead$1$8097.28$IsListEmpty$4 := inline$IsListEmpty$3$$ListHead$1$8097.28$IsListEmpty$4_.1;
    goto inline$IsListEmpty$3$label_3#1;

  inline$IsListEmpty$3$label_3#1:
    havoc inline$IsListEmpty$3$myNondetVar_0;
    inline$IsListEmpty$3$$result.IsListEmpty$8096.0$1$ := LIFT(INT_EQ(inline$IsListEmpty$3$myNondetVar_0, inline$IsListEmpty$3$$ListHead$1$8097.28$IsListEmpty$4));
    goto inline$IsListEmpty$3$label_1#1;

  inline$IsListEmpty$3$label_1#1:
    goto inline$IsListEmpty$3$Return#1;

  inline$IsListEmpty$3$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3199.23$27$ := inline$IsListEmpty$3$$result.IsListEmpty$8096.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_46_head$1#1;

  inline$BDLCleanupNotificationStruct$1$label_46_head$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon49_Then#1, inline$BDLCleanupNotificationStruct$1$anon49_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon7#1;

  inline$BDLCleanupNotificationStruct$1$anon7#1:
    goto inline$BDLCleanupNotificationStruct$1$label_107#1;

  inline$BDLCleanupNotificationStruct$1$label_107#1:
    goto inline$BDLCleanupNotificationStruct$1$label_107_true#1, inline$BDLCleanupNotificationStruct$1$label_107_false#1;

  inline$BDLCleanupNotificationStruct$1$label_107_false#1:
    assume inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3199.23$27$ == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_108#1;

  inline$BDLCleanupNotificationStruct$1$label_108#1:
    goto inline$RemoveHeadList$4$Entry#1;

  inline$RemoveHeadList$4$Entry#1:
    goto inline$RemoveHeadList$4$start#1;

  inline$RemoveHeadList$4$start#1:
    goto inline$RemoveHeadList$4$label_3#1;

  inline$RemoveHeadList$4$label_3#1:
    goto inline$RemoveHeadList$4$label_4#1;

  inline$RemoveHeadList$4$label_4#1:
    goto inline$RemoveHeadList$4$label_5#1;

  inline$RemoveHeadList$4$label_5#1:
    havoc inline$RemoveHeadList$4$myNondetVar_0;
    goto inline$RemoveHeadList$4$label_6#1;

  inline$RemoveHeadList$4$label_6#1:
    havoc inline$RemoveHeadList$4$myNondetVar_0;
    goto inline$RemoveHeadList$4$label_7#1;

  inline$RemoveHeadList$4$label_7#1:
    goto inline$RemoveHeadList$4$label_8#1;

  inline$RemoveHeadList$4$label_8#1:
    goto inline$RemoveHeadList$4$label_9#1;

  inline$RemoveHeadList$4$label_9#1:
    goto inline$RemoveHeadList$4$label_1#1;

  inline$RemoveHeadList$4$label_1#1:
    goto inline$RemoveHeadList$4$Return#1;

  inline$RemoveHeadList$4$Return#1:
    goto inline$BDLCleanupNotificationStruct$1$label_108$1#1;

  inline$BDLCleanupNotificationStruct$1$label_108$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon60_Then#1, inline$BDLCleanupNotificationStruct$1$anon60_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon60_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon29#1;

  inline$BDLCleanupNotificationStruct$1$anon29#1:
    goto inline$BDLCleanupNotificationStruct$1$label_154#1;

  inline$BDLCleanupNotificationStruct$1$label_154#1:
    goto inline$BDLCleanupNotificationStruct$1$label_155#1;

  inline$BDLCleanupNotificationStruct$1$label_155#1:
    goto inline$BDLCleanupNotificationStruct$1$label_156#1;

  inline$BDLCleanupNotificationStruct$1$label_156#1:
    goto inline$BDLCleanupNotificationStruct$1$label_46_head#0;

  inline$BDLCleanupNotificationStruct$1$label_46_head#0:
    assume false;
    return;

  inline$BDLCleanupNotificationStruct$1$anon60_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$label_107_true#1:
    assume inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3199.23$27$ != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_111#1;

  inline$BDLCleanupNotificationStruct$1$label_111#1:
    goto inline$BDLCleanupNotificationStruct$1$label_111_head#1;

  inline$BDLCleanupNotificationStruct$1$label_111_head#1:
    goto inline$IsListEmpty$5$Entry#1;

  inline$IsListEmpty$5$Entry#1:
    inline$IsListEmpty$5$$ListHead$1$8097.28$IsListEmpty$4_.1 := IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$IsListEmpty$5$start#1;

  inline$IsListEmpty$5$start#1:
    inline$IsListEmpty$5$$ListHead$1$8097.28$IsListEmpty$4 := inline$IsListEmpty$5$$ListHead$1$8097.28$IsListEmpty$4_.1;
    goto inline$IsListEmpty$5$label_3#1;

  inline$IsListEmpty$5$label_3#1:
    havoc inline$IsListEmpty$5$myNondetVar_0;
    inline$IsListEmpty$5$$result.IsListEmpty$8096.0$1$ := LIFT(INT_EQ(inline$IsListEmpty$5$myNondetVar_0, inline$IsListEmpty$5$$ListHead$1$8097.28$IsListEmpty$4));
    goto inline$IsListEmpty$5$label_1#1;

  inline$IsListEmpty$5$label_1#1:
    goto inline$IsListEmpty$5$Return#1;

  inline$IsListEmpty$5$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3215.23$29$ := inline$IsListEmpty$5$$result.IsListEmpty$8096.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_111_head$1#1;

  inline$BDLCleanupNotificationStruct$1$label_111_head$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon61_Then#1, inline$BDLCleanupNotificationStruct$1$anon61_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon61_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon31#1;

  inline$BDLCleanupNotificationStruct$1$anon31#1:
    goto inline$BDLCleanupNotificationStruct$1$label_114#1;

  inline$BDLCleanupNotificationStruct$1$label_114#1:
    goto inline$BDLCleanupNotificationStruct$1$label_114_true#1, inline$BDLCleanupNotificationStruct$1$label_114_false#1;

  inline$BDLCleanupNotificationStruct$1$label_114_false#1:
    assume inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3215.23$29$ == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_115#1;

  inline$BDLCleanupNotificationStruct$1$label_115#1:
    goto inline$RemoveHeadList$5$Entry#1;

  inline$RemoveHeadList$5$Entry#1:
    goto inline$RemoveHeadList$5$start#1;

  inline$RemoveHeadList$5$start#1:
    goto inline$RemoveHeadList$5$label_3#1;

  inline$RemoveHeadList$5$label_3#1:
    goto inline$RemoveHeadList$5$label_4#1;

  inline$RemoveHeadList$5$label_4#1:
    goto inline$RemoveHeadList$5$label_5#1;

  inline$RemoveHeadList$5$label_5#1:
    havoc inline$RemoveHeadList$5$myNondetVar_0;
    inline$RemoveHeadList$5$$Entry$3$8126.16$RemoveHeadList$4 := inline$RemoveHeadList$5$myNondetVar_0;
    goto inline$RemoveHeadList$5$label_6#1;

  inline$RemoveHeadList$5$label_6#1:
    havoc inline$RemoveHeadList$5$myNondetVar_0;
    goto inline$RemoveHeadList$5$label_7#1;

  inline$RemoveHeadList$5$label_7#1:
    goto inline$RemoveHeadList$5$label_8#1;

  inline$RemoveHeadList$5$label_8#1:
    goto inline$RemoveHeadList$5$label_9#1;

  inline$RemoveHeadList$5$label_9#1:
    inline$RemoveHeadList$5$$result.RemoveHeadList$8121.0$1$ := inline$RemoveHeadList$5$$Entry$3$8126.16$RemoveHeadList$4;
    goto inline$RemoveHeadList$5$label_1#1;

  inline$RemoveHeadList$5$label_1#1:
    goto inline$RemoveHeadList$5$Return#1;

  inline$RemoveHeadList$5$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.RemoveHeadList$3218.26$30$ := inline$RemoveHeadList$5$$result.RemoveHeadList$8121.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_115$1#1;

  inline$BDLCleanupNotificationStruct$1$label_115$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon62_Then#1, inline$BDLCleanupNotificationStruct$1$anon62_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon62_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon33#1;

  inline$BDLCleanupNotificationStruct$1$anon33#1:
    goto inline$BDLCleanupNotificationStruct$1$label_149#1;

  inline$BDLCleanupNotificationStruct$1$label_149#1:
    inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$1$$result.RemoveHeadList$3218.26$30$;
    goto inline$BDLCleanupNotificationStruct$1$label_150#1;

  inline$BDLCleanupNotificationStruct$1$label_150#1:
    inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4 := MINUS_LEFT_PTR(inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4, 1, 16);
    goto inline$BDLCleanupNotificationStruct$1$label_151#1;

  inline$BDLCleanupNotificationStruct$1$label_151#1:
    call ExFreePoolWithTag(inline$BDLCleanupNotificationStruct$1$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4, 541869122);
    goto inline$BDLCleanupNotificationStruct$1$anon68_Then#1, inline$BDLCleanupNotificationStruct$1$anon68_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon68_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon45#1;

  inline$BDLCleanupNotificationStruct$1$anon45#1:
    goto inline$BDLCleanupNotificationStruct$1$label_111_head#0;

  inline$BDLCleanupNotificationStruct$1$label_111_head#0:
    assume false;
    return;

  inline$BDLCleanupNotificationStruct$1$anon68_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon62_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$label_114_true#1:
    assume inline$BDLCleanupNotificationStruct$1$$result.IsListEmpty$3215.23$29$ != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_118#1;

  inline$BDLCleanupNotificationStruct$1$label_118#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_1;
    assume inline$BDLCleanupNotificationStruct$1$myNondetVar_0 == inline$BDLCleanupNotificationStruct$1$myNondetVar_1;
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$storm_KeReleaseSpinLock$6$Entry#1;

  inline$storm_KeReleaseSpinLock$6$Entry#1:
    inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$1$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$storm_KeReleaseSpinLock$6$start#1;

  inline$storm_KeReleaseSpinLock$6$start#1:
    inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$6$label_3#1;

  inline$storm_KeReleaseSpinLock$6$label_3#1:
    goto inline$storm_KeReleaseSpinLock$6$label_4#1;

  inline$storm_KeReleaseSpinLock$6$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$6$label_7#1;

  inline$storm_KeReleaseSpinLock$6$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$6$anon5_Then#1, inline$storm_KeReleaseSpinLock$6$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$6$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$6$anon1#1;

  inline$storm_KeReleaseSpinLock$6$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$6$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$6$label_8#1;

  inline$storm_KeReleaseSpinLock$6$label_8#1:
    goto inline$storm_getThreadID$10$Entry#1;

  inline$storm_getThreadID$10$Entry#1:
    goto inline$storm_getThreadID$10$anon0#1;

  inline$storm_getThreadID$10$anon0#1:
    inline$storm_getThreadID$10$tid := __storm_thread_id;
    goto inline$storm_getThreadID$10$Return#1;

  inline$storm_getThreadID$10$Return#1:
    inline$storm_KeReleaseSpinLock$6$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$10$tid;
    goto inline$storm_KeReleaseSpinLock$6$label_8$1#1;

  inline$storm_KeReleaseSpinLock$6$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$6$label_11#1;

  inline$storm_KeReleaseSpinLock$6$label_11#1:
    goto inline$storm_KeReleaseSpinLock$6$label_11_true#1, inline$storm_KeReleaseSpinLock$6$label_11_false#1;

  inline$storm_KeReleaseSpinLock$6$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$6$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$6$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$6$label_12#1;

  inline$storm_KeReleaseSpinLock$6$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$6$label_1#1;

  inline$storm_KeReleaseSpinLock$6$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$6$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$6$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$6$label_15#1;

  inline$storm_KeReleaseSpinLock$6$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$6$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$6$label_16#1;

  inline$storm_KeReleaseSpinLock$6$label_16#1:
    goto inline$storm_KeReleaseSpinLock$6$anon6_Then#1, inline$storm_KeReleaseSpinLock$6$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$6$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$6$anon4#1;

  inline$storm_KeReleaseSpinLock$6$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$6$anon4#1;

  inline$storm_KeReleaseSpinLock$6$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$6$label_1#1;

  inline$storm_KeReleaseSpinLock$6$label_1#1:
    goto inline$storm_KeReleaseSpinLock$6$Return#1;

  inline$storm_KeReleaseSpinLock$6$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$6$Return#1;

  inline$storm_KeReleaseSpinLock$6$Return#1:
    goto inline$BDLCleanupNotificationStruct$1$label_118$1#1;

  inline$BDLCleanupNotificationStruct$1$label_118$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon63_Then#1, inline$BDLCleanupNotificationStruct$1$anon63_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon63_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon35#1;

  inline$BDLCleanupNotificationStruct$1$anon35#1:
    havoc inline$BDLCleanupNotificationStruct$1$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$1$label_121#1;

  inline$BDLCleanupNotificationStruct$1$label_121#1:
    call KfLowerIrql(inline$BDLCleanupNotificationStruct$1$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4);
    goto inline$BDLCleanupNotificationStruct$1$anon64_Then#1, inline$BDLCleanupNotificationStruct$1$anon64_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon64_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon37#1;

  inline$BDLCleanupNotificationStruct$1$anon37#1:
    goto inline$BDLCleanupNotificationStruct$1$label_124#1;

  inline$BDLCleanupNotificationStruct$1$label_124#1:
    goto inline$BDLGetDebugLevel$670$Entry#1;

  inline$BDLGetDebugLevel$670$Entry#1:
    goto inline$BDLGetDebugLevel$670$start#1;

  inline$BDLGetDebugLevel$670$start#1:
    goto inline$BDLGetDebugLevel$670$label_3#1;

  inline$BDLGetDebugLevel$670$label_3#1:
    havoc inline$BDLGetDebugLevel$670$myNondetVar_0;
    inline$BDLGetDebugLevel$670$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$670$myNondetVar_0;
    goto inline$BDLGetDebugLevel$670$label_1#1;

  inline$BDLGetDebugLevel$670$label_1#1:
    goto inline$BDLGetDebugLevel$670$Return#1;

  inline$BDLGetDebugLevel$670$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$31$ := inline$BDLGetDebugLevel$670$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_124$1#1;

  inline$BDLCleanupNotificationStruct$1$label_124$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon65_Then#1, inline$BDLCleanupNotificationStruct$1$anon65_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon65_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon39#1;

  inline$BDLCleanupNotificationStruct$1$anon39#1:
    goto inline$BDLCleanupNotificationStruct$1$label_127#1;

  inline$BDLCleanupNotificationStruct$1$label_127#1:
    goto inline$BDLCleanupNotificationStruct$1$label_127_true#1, inline$BDLCleanupNotificationStruct$1$label_127_false#1;

  inline$BDLCleanupNotificationStruct$1$label_127_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$31$) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_128#1;

  inline$BDLCleanupNotificationStruct$1$label_127_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$31$) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_131#1;

  inline$BDLCleanupNotificationStruct$1$label_131#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_132#1;

  inline$BDLCleanupNotificationStruct$1$label_132#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_133#1;

  inline$BDLCleanupNotificationStruct$1$label_133#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_134#1;

  inline$BDLCleanupNotificationStruct$1$label_134#1:
    havoc inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3231.0$32$;
    goto inline$BDLCleanupNotificationStruct$1$label_128#1;

  inline$BDLCleanupNotificationStruct$1$label_128#1:
    goto inline$BDLGetDebugLevel$671$Entry#1;

  inline$BDLGetDebugLevel$671$Entry#1:
    goto inline$BDLGetDebugLevel$671$start#1;

  inline$BDLGetDebugLevel$671$start#1:
    goto inline$BDLGetDebugLevel$671$label_3#1;

  inline$BDLGetDebugLevel$671$label_3#1:
    havoc inline$BDLGetDebugLevel$671$myNondetVar_0;
    inline$BDLGetDebugLevel$671$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$671$myNondetVar_0;
    goto inline$BDLGetDebugLevel$671$label_1#1;

  inline$BDLGetDebugLevel$671$label_1#1:
    goto inline$BDLGetDebugLevel$671$Return#1;

  inline$BDLGetDebugLevel$671$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$36$ := inline$BDLGetDebugLevel$671$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_128$1#1;

  inline$BDLCleanupNotificationStruct$1$label_128$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon66_Then#1, inline$BDLCleanupNotificationStruct$1$anon66_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon66_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon41#1;

  inline$BDLCleanupNotificationStruct$1$anon41#1:
    goto inline$BDLCleanupNotificationStruct$1$label_137#1;

  inline$BDLCleanupNotificationStruct$1$label_137#1:
    goto inline$BDLCleanupNotificationStruct$1$label_137_true#1, inline$BDLCleanupNotificationStruct$1$label_137_false#1;

  inline$BDLCleanupNotificationStruct$1$label_137_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$36$) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_138#1;

  inline$BDLCleanupNotificationStruct$1$label_137_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$36$) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_141#1;

  inline$BDLCleanupNotificationStruct$1$label_141#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_142#1;

  inline$BDLCleanupNotificationStruct$1$label_142#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_143#1;

  inline$BDLCleanupNotificationStruct$1$label_143#1:
    call inline$BDLCleanupNotificationStruct$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$1$label_144#1;

  inline$BDLCleanupNotificationStruct$1$label_144#1:
    havoc inline$BDLCleanupNotificationStruct$1$$result.DbgPrint$3231.0$37$;
    goto inline$BDLCleanupNotificationStruct$1$label_138#1;

  inline$BDLCleanupNotificationStruct$1$label_138#1:
    goto inline$BDLGetDebugLevel$672$Entry#1;

  inline$BDLGetDebugLevel$672$Entry#1:
    goto inline$BDLGetDebugLevel$672$start#1;

  inline$BDLGetDebugLevel$672$start#1:
    goto inline$BDLGetDebugLevel$672$label_3#1;

  inline$BDLGetDebugLevel$672$label_3#1:
    havoc inline$BDLGetDebugLevel$672$myNondetVar_0;
    inline$BDLGetDebugLevel$672$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$672$myNondetVar_0;
    goto inline$BDLGetDebugLevel$672$label_1#1;

  inline$BDLGetDebugLevel$672$label_1#1:
    goto inline$BDLGetDebugLevel$672$Return#1;

  inline$BDLGetDebugLevel$672$Return#1:
    inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$41$ := inline$BDLGetDebugLevel$672$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$1$label_138$1#1;

  inline$BDLCleanupNotificationStruct$1$label_138$1#1:
    goto inline$BDLCleanupNotificationStruct$1$anon67_Then#1, inline$BDLCleanupNotificationStruct$1$anon67_Else#1;

  inline$BDLCleanupNotificationStruct$1$anon67_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$1$anon43#1;

  inline$BDLCleanupNotificationStruct$1$anon43#1:
    goto inline$BDLCleanupNotificationStruct$1$label_147#1;

  inline$BDLCleanupNotificationStruct$1$label_147#1:
    goto inline$BDLCleanupNotificationStruct$1$label_147_true#1, inline$BDLCleanupNotificationStruct$1$label_147_false#1;

  inline$BDLCleanupNotificationStruct$1$label_147_false#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$41$, 4) == 0;
    goto inline$BDLCleanupNotificationStruct$1$label_1#1;

  inline$BDLCleanupNotificationStruct$1$label_147_true#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$1$$result.BDLGetDebugLevel$3231.0$41$, 4) != 0;
    goto inline$BDLCleanupNotificationStruct$1$label_148#1;

  inline$BDLCleanupNotificationStruct$1$label_148#1:
    goto inline$BDLCleanupNotificationStruct$1$label_1#1;

  inline$BDLCleanupNotificationStruct$1$label_1#1:
    call __HAVOC_free(inline$BDLCleanupNotificationStruct$1$$bddiRegisterNotifyParams$10$3120.36$BDLCleanupNotificationStruct$4);
    call __HAVOC_free(inline$BDLCleanupNotificationStruct$1$$irql$3$3113.45$BDLCleanupNotificationStruct$4);
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon67_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon66_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon65_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon64_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon63_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon61_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon49_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon52_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon51_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon50_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon48_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon47_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$anon46_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$1$Return#1;

  inline$BDLCleanupNotificationStruct$1$Return#1:
    goto inline$BDLHandleRemove$1$label_38$1#1;

  inline$BDLHandleRemove$1$label_38$1#1:
    goto inline$BDLHandleRemove$1$anon47_Then#1, inline$BDLHandleRemove$1$anon47_Else#1;

  inline$BDLHandleRemove$1$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon11#1;

  inline$BDLHandleRemove$1$anon11#1:
    goto inline$BDLHandleRemove$1$label_41#1;

  inline$BDLHandleRemove$1$label_41#1:
    goto inline$BDLCleanupDataHandles$1$Entry#1;

  inline$BDLCleanupDataHandles$1$Entry#1:
    inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4_.1 := inline$BDLHandleRemove$1$$pBDLExtension$1$2378.40$BDLHandleRemove$12;
    goto inline$BDLCleanupDataHandles$1$start#1;

  inline$BDLCleanupDataHandles$1$start#1:
    call inline$BDLCleanupDataHandles$1$$bddDataHandle$4$3247.28$BDLCleanupDataHandles$4 := __HAVOC_malloc(4);
    call inline$BDLCleanupDataHandles$1$$bddiCloseHandleParams$5$3248.28$BDLCleanupDataHandles$4 := __HAVOC_malloc(8);
    call inline$BDLCleanupDataHandles$1$$irql$6$3249.28$BDLCleanupDataHandles$4 := __HAVOC_malloc(1);
    inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4 := inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4_.1;
    goto inline$BDLCleanupDataHandles$1$label_3#1;

  inline$BDLCleanupDataHandles$1$label_3#1:
    goto inline$BDLCleanupDataHandles$1$label_4#1;

  inline$BDLCleanupDataHandles$1$label_4#1:
    goto inline$BDLCleanupDataHandles$1$label_5#1;

  inline$BDLCleanupDataHandles$1$label_5#1:
    inline$BDLCleanupDataHandles$1$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4 := 0;
    goto inline$BDLCleanupDataHandles$1$label_6#1;

  inline$BDLCleanupDataHandles$1$label_6#1:
    goto inline$BDLCleanupDataHandles$1$label_7#1;

  inline$BDLCleanupDataHandles$1$label_7#1:
    goto inline$BDLCleanupDataHandles$1$label_8#1;

  inline$BDLCleanupDataHandles$1$label_8#1:
    goto inline$BDLCleanupDataHandles$1$label_9#1;

  inline$BDLCleanupDataHandles$1$label_9#1:
    goto inline$BDLGetDebugLevel$673$Entry#1;

  inline$BDLGetDebugLevel$673$Entry#1:
    goto inline$BDLGetDebugLevel$673$start#1;

  inline$BDLGetDebugLevel$673$start#1:
    goto inline$BDLGetDebugLevel$673$label_3#1;

  inline$BDLGetDebugLevel$673$label_3#1:
    havoc inline$BDLGetDebugLevel$673$myNondetVar_0;
    inline$BDLGetDebugLevel$673$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$673$myNondetVar_0;
    goto inline$BDLGetDebugLevel$673$label_1#1;

  inline$BDLGetDebugLevel$673$label_1#1:
    goto inline$BDLGetDebugLevel$673$Return#1;

  inline$BDLGetDebugLevel$673$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$1$ := inline$BDLGetDebugLevel$673$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_9$1#1;

  inline$BDLCleanupDataHandles$1$label_9$1#1:
    goto inline$BDLCleanupDataHandles$1$anon30_Then#1, inline$BDLCleanupDataHandles$1$anon30_Else#1;

  inline$BDLCleanupDataHandles$1$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon1#1;

  inline$BDLCleanupDataHandles$1$anon1#1:
    goto inline$BDLCleanupDataHandles$1$label_12#1;

  inline$BDLCleanupDataHandles$1$label_12#1:
    goto inline$BDLCleanupDataHandles$1$label_12_true#1, inline$BDLCleanupDataHandles$1$label_12_false#1;

  inline$BDLCleanupDataHandles$1$label_12_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$1$) == 0;
    goto inline$BDLCleanupDataHandles$1$label_13#1;

  inline$BDLCleanupDataHandles$1$label_12_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$1$) != 0;
    goto inline$BDLCleanupDataHandles$1$label_16#1;

  inline$BDLCleanupDataHandles$1$label_16#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_17#1;

  inline$BDLCleanupDataHandles$1$label_17#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_18#1;

  inline$BDLCleanupDataHandles$1$label_18#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_19#1;

  inline$BDLCleanupDataHandles$1$label_19#1:
    havoc inline$BDLCleanupDataHandles$1$$result.DbgPrint$3251.0$2$;
    goto inline$BDLCleanupDataHandles$1$label_13#1;

  inline$BDLCleanupDataHandles$1$label_13#1:
    goto inline$BDLGetDebugLevel$674$Entry#1;

  inline$BDLGetDebugLevel$674$Entry#1:
    goto inline$BDLGetDebugLevel$674$start#1;

  inline$BDLGetDebugLevel$674$start#1:
    goto inline$BDLGetDebugLevel$674$label_3#1;

  inline$BDLGetDebugLevel$674$label_3#1:
    havoc inline$BDLGetDebugLevel$674$myNondetVar_0;
    inline$BDLGetDebugLevel$674$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$674$myNondetVar_0;
    goto inline$BDLGetDebugLevel$674$label_1#1;

  inline$BDLGetDebugLevel$674$label_1#1:
    goto inline$BDLGetDebugLevel$674$Return#1;

  inline$BDLGetDebugLevel$674$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$6$ := inline$BDLGetDebugLevel$674$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_13$1#1;

  inline$BDLCleanupDataHandles$1$label_13$1#1:
    goto inline$BDLCleanupDataHandles$1$anon31_Then#1, inline$BDLCleanupDataHandles$1$anon31_Else#1;

  inline$BDLCleanupDataHandles$1$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon3#1;

  inline$BDLCleanupDataHandles$1$anon3#1:
    goto inline$BDLCleanupDataHandles$1$label_22#1;

  inline$BDLCleanupDataHandles$1$label_22#1:
    goto inline$BDLCleanupDataHandles$1$label_22_true#1, inline$BDLCleanupDataHandles$1$label_22_false#1;

  inline$BDLCleanupDataHandles$1$label_22_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$6$) == 0;
    goto inline$BDLCleanupDataHandles$1$label_23#1;

  inline$BDLCleanupDataHandles$1$label_22_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$6$) != 0;
    goto inline$BDLCleanupDataHandles$1$label_26#1;

  inline$BDLCleanupDataHandles$1$label_26#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_27#1;

  inline$BDLCleanupDataHandles$1$label_27#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_28#1;

  inline$BDLCleanupDataHandles$1$label_28#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_29#1;

  inline$BDLCleanupDataHandles$1$label_29#1:
    havoc inline$BDLCleanupDataHandles$1$$result.DbgPrint$3251.0$7$;
    goto inline$BDLCleanupDataHandles$1$label_23#1;

  inline$BDLCleanupDataHandles$1$label_23#1:
    goto inline$BDLGetDebugLevel$675$Entry#1;

  inline$BDLGetDebugLevel$675$Entry#1:
    goto inline$BDLGetDebugLevel$675$start#1;

  inline$BDLGetDebugLevel$675$start#1:
    goto inline$BDLGetDebugLevel$675$label_3#1;

  inline$BDLGetDebugLevel$675$label_3#1:
    havoc inline$BDLGetDebugLevel$675$myNondetVar_0;
    inline$BDLGetDebugLevel$675$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$675$myNondetVar_0;
    goto inline$BDLGetDebugLevel$675$label_1#1;

  inline$BDLGetDebugLevel$675$label_1#1:
    goto inline$BDLGetDebugLevel$675$Return#1;

  inline$BDLGetDebugLevel$675$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$11$ := inline$BDLGetDebugLevel$675$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_23$1#1;

  inline$BDLCleanupDataHandles$1$label_23$1#1:
    goto inline$BDLCleanupDataHandles$1$anon32_Then#1, inline$BDLCleanupDataHandles$1$anon32_Else#1;

  inline$BDLCleanupDataHandles$1$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon5#1;

  inline$BDLCleanupDataHandles$1$anon5#1:
    goto inline$BDLCleanupDataHandles$1$label_32#1;

  inline$BDLCleanupDataHandles$1$label_32#1:
    goto inline$BDLCleanupDataHandles$1$label_32_true#1, inline$BDLCleanupDataHandles$1$label_32_false#1;

  inline$BDLCleanupDataHandles$1$label_32_false#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$11$, 4) == 0;
    goto inline$BDLCleanupDataHandles$1$label_33#1;

  inline$BDLCleanupDataHandles$1$label_32_true#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3251.0$11$, 4) != 0;
    goto inline$BDLCleanupDataHandles$1$label_34#1;

  inline$BDLCleanupDataHandles$1$label_34#1:
    goto inline$BDLCleanupDataHandles$1$label_33#1;

  inline$BDLCleanupDataHandles$1$label_33#1:
    goto inline$BDLCleanupDataHandles$1$label_35#1;

  inline$BDLCleanupDataHandles$1$label_35#1:
    goto inline$BDLLockHandleList$1$Entry#1;

  inline$BDLLockHandleList$1$Entry#1:
    inline$BDLLockHandleList$1$$pBDLExtension$1$134.40$BDLLockHandleList$8_.1 := inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4;
    goto inline$BDLLockHandleList$1$start#1;

  inline$BDLLockHandleList$1$start#1:
    inline$BDLLockHandleList$1$$pBDLExtension$1$134.40$BDLLockHandleList$8 := inline$BDLLockHandleList$1$$pBDLExtension$1$134.40$BDLLockHandleList$8_.1;
    goto inline$BDLLockHandleList$1$label_3#1;

  inline$BDLLockHandleList$1$label_3#1:
    havoc inline$BDLLockHandleList$1$myNondetVar_0;
    havoc inline$BDLLockHandleList$1$myNondetVar_1;
    assume inline$BDLLockHandleList$1$myNondetVar_0 == inline$BDLLockHandleList$1$myNondetVar_1;
    goto inline$storm_KeAcquireSpinLock$4$Entry#1;

  inline$storm_KeAcquireSpinLock$4$Entry#1:
    inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1 := HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLLockHandleList$1$$pBDLExtension$1$134.40$BDLLockHandleList$8);
    goto inline$storm_KeAcquireSpinLock$4$start#1;

  inline$storm_KeAcquireSpinLock$4$start#1:
    inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1;
    goto inline$storm_KeAcquireSpinLock$4$label_3#1;

  inline$storm_KeAcquireSpinLock$4$label_3#1:
    goto inline$storm_KeAcquireSpinLock$4$label_4#1;

  inline$storm_KeAcquireSpinLock$4$label_4#1:
    goto inline$storm_getThreadID$11$Entry#1;

  inline$storm_getThreadID$11$Entry#1:
    goto inline$storm_getThreadID$11$anon0#1;

  inline$storm_getThreadID$11$anon0#1:
    inline$storm_getThreadID$11$tid := __storm_thread_id;
    goto inline$storm_getThreadID$11$Return#1;

  inline$storm_getThreadID$11$Return#1:
    inline$storm_KeAcquireSpinLock$4$$result.storm_getThreadID$128.29$1$ := inline$storm_getThreadID$11$tid;
    goto inline$storm_KeAcquireSpinLock$4$label_4$1#1;

  inline$storm_KeAcquireSpinLock$4$label_4$1#1:
    goto inline$storm_KeAcquireSpinLock$4$label_7#1;

  inline$storm_KeAcquireSpinLock$4$label_7#1:
    inline$storm_KeAcquireSpinLock$4$$tid$3$128.6$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$4$$result.storm_getThreadID$128.29$1$;
    goto inline$storm_KeAcquireSpinLock$4$label_8#1;

  inline$storm_KeAcquireSpinLock$4$label_8#1:
    goto inline$storm_KeAcquireSpinLock$4$label_9#1;

  inline$storm_KeAcquireSpinLock$4$label_9#1:
    __storm_atomic := true;
    goto inline$storm_KeAcquireSpinLock$4$label_12#1;

  inline$storm_KeAcquireSpinLock$4$label_12#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$4$anon7_Then#1, inline$storm_KeAcquireSpinLock$4$anon7_Else#1;

  inline$storm_KeAcquireSpinLock$4$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$4$anon1#1;

  inline$storm_KeAcquireSpinLock$4$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8], inline$storm_KeAcquireSpinLock$4$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$4$label_13#1;

  inline$storm_KeAcquireSpinLock$4$label_13#1:
    goto inline$storm_KeAcquireSpinLock$4$label_13_true#1, inline$storm_KeAcquireSpinLock$4$label_13_false#1;

  inline$storm_KeAcquireSpinLock$4$label_13_false#1:
    assume !INT_NEQ(inline$storm_KeAcquireSpinLock$4$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$4$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$4$label_14#1;

  inline$storm_KeAcquireSpinLock$4$label_14#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeAcquireSpinLock$4$label_1#1;

  inline$storm_KeAcquireSpinLock$4$label_13_true#1:
    assume INT_NEQ(inline$storm_KeAcquireSpinLock$4$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$4$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$4$label_17#1;

  inline$storm_KeAcquireSpinLock$4$label_17#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$4$anon8_Then#1, inline$storm_KeAcquireSpinLock$4$anon8_Else#1;

  inline$storm_KeAcquireSpinLock$4$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$4$anon4#1;

  inline$storm_KeAcquireSpinLock$4$anon4#1:
    assume INT_EQ(inline$storm_KeAcquireSpinLock$4$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8, 0);
    goto inline$storm_KeAcquireSpinLock$4$label_18#1;

  inline$storm_KeAcquireSpinLock$4$label_18#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeAcquireSpinLock$4$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$4$$tid$3$128.6$storm_KeAcquireSpinLock$8];
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$4$label_19#1;

  inline$storm_KeAcquireSpinLock$4$label_19#1:
    goto inline$storm_KeAcquireSpinLock$4$anon9_Then#1, inline$storm_KeAcquireSpinLock$4$anon9_Else#1;

  inline$storm_KeAcquireSpinLock$4$anon9_Else#1:
    assume __storm_init;
    goto inline$storm_KeAcquireSpinLock$4$anon6#1;

  inline$storm_KeAcquireSpinLock$4$anon9_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeAcquireSpinLock$4$anon6#1;

  inline$storm_KeAcquireSpinLock$4$anon6#1:
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$4$label_1#1;

  inline$storm_KeAcquireSpinLock$4$label_1#1:
    goto inline$storm_KeAcquireSpinLock$4$Return#1;

  inline$storm_KeAcquireSpinLock$4$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$4$Return#1;

  inline$storm_KeAcquireSpinLock$4$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$4$Return#1;

  inline$storm_KeAcquireSpinLock$4$Return#1:
    goto inline$BDLLockHandleList$1$label_3$1#1;

  inline$BDLLockHandleList$1$label_3$1#1:
    goto inline$BDLLockHandleList$1$anon2_Then#1, inline$BDLLockHandleList$1$anon2_Else#1;

  inline$BDLLockHandleList$1$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLLockHandleList$1$anon1#1;

  inline$BDLLockHandleList$1$anon1#1:
    havoc inline$BDLLockHandleList$1$myNondetVar_0;
    goto inline$BDLLockHandleList$1$label_1#1;

  inline$BDLLockHandleList$1$label_1#1:
    goto inline$BDLLockHandleList$1$Return#1;

  inline$BDLLockHandleList$1$anon2_Then#1:
    assume raiseException;
    goto inline$BDLLockHandleList$1$Return#1;

  inline$BDLLockHandleList$1$Return#1:
    goto inline$BDLCleanupDataHandles$1$label_35$1#1;

  inline$BDLCleanupDataHandles$1$label_35$1#1:
    goto inline$BDLCleanupDataHandles$1$anon33_Then#1, inline$BDLCleanupDataHandles$1$anon33_Else#1;

  inline$BDLCleanupDataHandles$1$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon7#1;

  inline$BDLCleanupDataHandles$1$anon7#1:
    goto inline$BDLCleanupDataHandles$1$label_38#1;

  inline$BDLCleanupDataHandles$1$label_38#1:
    goto inline$BDLCleanupDataHandles$1$label_38_head#1;

  inline$BDLCleanupDataHandles$1$label_38_head#1:
    goto inline$BDLGetFirstHandle$1$Entry#1;

  inline$BDLGetFirstHandle$1$Entry#1:
    goto inline$BDLGetFirstHandle$1$start#1;

  inline$BDLGetFirstHandle$1$start#1:
    goto inline$BDLGetFirstHandle$1$label_3#1;

  inline$BDLGetFirstHandle$1$label_3#1:
    goto inline$BDLGetFirstHandle$1$label_3_true#1, inline$BDLGetFirstHandle$1$label_3_false#1;

  inline$BDLGetFirstHandle$1$label_3_false#1:
    havoc inline$BDLGetFirstHandle$1$myNondetVar_0;
    assume inline$BDLGetFirstHandle$1$myNondetVar_0 == 0;
    goto inline$BDLGetFirstHandle$1$label_4#1;

  inline$BDLGetFirstHandle$1$label_4#1:
    inline$BDLGetFirstHandle$1$$result.BDLGetFirstHandle$276.0$1$ := 0;
    goto inline$BDLGetFirstHandle$1$label_1#1;

  inline$BDLGetFirstHandle$1$label_3_true#1:
    havoc inline$BDLGetFirstHandle$1$myNondetVar_0;
    assume inline$BDLGetFirstHandle$1$myNondetVar_0 != 0;
    goto inline$BDLGetFirstHandle$1$label_5#1;

  inline$BDLGetFirstHandle$1$label_5#1:
    havoc inline$BDLGetFirstHandle$1$myNondetVar_0;
    havoc inline$BDLGetFirstHandle$1$myNondetVar_1;
    goto inline$BDLGetFirstHandle$1$label_6#1;

  inline$BDLGetFirstHandle$1$label_6#1:
    inline$BDLGetFirstHandle$1$$result.BDLGetFirstHandle$276.0$1$ := 1;
    goto inline$BDLGetFirstHandle$1$label_1#1;

  inline$BDLGetFirstHandle$1$label_1#1:
    goto inline$BDLGetFirstHandle$1$Return#1;

  inline$BDLGetFirstHandle$1$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetFirstHandle$3264.27$12$ := inline$BDLGetFirstHandle$1$$result.BDLGetFirstHandle$276.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_38_head$1#1;

  inline$BDLCleanupDataHandles$1$label_38_head$1#1:
    goto inline$BDLCleanupDataHandles$1$anon34_Then#1, inline$BDLCleanupDataHandles$1$anon34_Else#1;

  inline$BDLCleanupDataHandles$1$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon9#1;

  inline$BDLCleanupDataHandles$1$anon9#1:
    goto inline$BDLCleanupDataHandles$1$label_41#1;

  inline$BDLCleanupDataHandles$1$label_41#1:
    goto inline$BDLCleanupDataHandles$1$label_41_true#1, inline$BDLCleanupDataHandles$1$label_41_false#1;

  inline$BDLCleanupDataHandles$1$label_41_false#1:
    assume !INT_EQ(inline$BDLCleanupDataHandles$1$$result.BDLGetFirstHandle$3264.27$12$, 1);
    goto inline$BDLCleanupDataHandles$1$label_42#1;

  inline$BDLCleanupDataHandles$1$label_42#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$BDLReleaseHandleList$1$Entry#1;

  inline$BDLReleaseHandleList$1$Entry#1:
    inline$BDLReleaseHandleList$1$$pBDLExtension$1$145.40$BDLReleaseHandleList$8_.1 := inline$BDLCleanupDataHandles$1$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4;
    goto inline$BDLReleaseHandleList$1$start#1;

  inline$BDLReleaseHandleList$1$start#1:
    inline$BDLReleaseHandleList$1$$pBDLExtension$1$145.40$BDLReleaseHandleList$8 := inline$BDLReleaseHandleList$1$$pBDLExtension$1$145.40$BDLReleaseHandleList$8_.1;
    goto inline$BDLReleaseHandleList$1$label_3#1;

  inline$BDLReleaseHandleList$1$label_3#1:
    havoc inline$BDLReleaseHandleList$1$myNondetVar_0;
    havoc inline$BDLReleaseHandleList$1$myNondetVar_1;
    assume inline$BDLReleaseHandleList$1$myNondetVar_0 == inline$BDLReleaseHandleList$1$myNondetVar_1;
    goto inline$storm_KeReleaseSpinLock$7$Entry#1;

  inline$storm_KeReleaseSpinLock$7$Entry#1:
    inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLReleaseHandleList$1$$pBDLExtension$1$145.40$BDLReleaseHandleList$8);
    goto inline$storm_KeReleaseSpinLock$7$start#1;

  inline$storm_KeReleaseSpinLock$7$start#1:
    inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$7$label_3#1;

  inline$storm_KeReleaseSpinLock$7$label_3#1:
    goto inline$storm_KeReleaseSpinLock$7$label_4#1;

  inline$storm_KeReleaseSpinLock$7$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$7$label_7#1;

  inline$storm_KeReleaseSpinLock$7$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$7$anon5_Then#1, inline$storm_KeReleaseSpinLock$7$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$7$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$7$anon1#1;

  inline$storm_KeReleaseSpinLock$7$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$7$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$7$label_8#1;

  inline$storm_KeReleaseSpinLock$7$label_8#1:
    goto inline$storm_getThreadID$12$Entry#1;

  inline$storm_getThreadID$12$Entry#1:
    goto inline$storm_getThreadID$12$anon0#1;

  inline$storm_getThreadID$12$anon0#1:
    inline$storm_getThreadID$12$tid := __storm_thread_id;
    goto inline$storm_getThreadID$12$Return#1;

  inline$storm_getThreadID$12$Return#1:
    inline$storm_KeReleaseSpinLock$7$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$12$tid;
    goto inline$storm_KeReleaseSpinLock$7$label_8$1#1;

  inline$storm_KeReleaseSpinLock$7$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$7$label_11#1;

  inline$storm_KeReleaseSpinLock$7$label_11#1:
    goto inline$storm_KeReleaseSpinLock$7$label_11_true#1, inline$storm_KeReleaseSpinLock$7$label_11_false#1;

  inline$storm_KeReleaseSpinLock$7$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$7$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$7$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$7$label_12#1;

  inline$storm_KeReleaseSpinLock$7$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$7$label_1#1;

  inline$storm_KeReleaseSpinLock$7$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$7$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$7$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$7$label_15#1;

  inline$storm_KeReleaseSpinLock$7$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$7$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$7$label_16#1;

  inline$storm_KeReleaseSpinLock$7$label_16#1:
    goto inline$storm_KeReleaseSpinLock$7$anon6_Then#1, inline$storm_KeReleaseSpinLock$7$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$7$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$7$anon4#1;

  inline$storm_KeReleaseSpinLock$7$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$7$anon4#1;

  inline$storm_KeReleaseSpinLock$7$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$7$label_1#1;

  inline$storm_KeReleaseSpinLock$7$label_1#1:
    goto inline$storm_KeReleaseSpinLock$7$Return#1;

  inline$storm_KeReleaseSpinLock$7$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$7$Return#1;

  inline$storm_KeReleaseSpinLock$7$Return#1:
    goto inline$BDLReleaseHandleList$1$label_3$1#1;

  inline$BDLReleaseHandleList$1$label_3$1#1:
    goto inline$BDLReleaseHandleList$1$anon2_Then#1, inline$BDLReleaseHandleList$1$anon2_Else#1;

  inline$BDLReleaseHandleList$1$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLReleaseHandleList$1$anon1#1;

  inline$BDLReleaseHandleList$1$anon1#1:
    havoc inline$BDLReleaseHandleList$1$myNondetVar_0;
    goto inline$BDLReleaseHandleList$1$label_1#1;

  inline$BDLReleaseHandleList$1$label_1#1:
    goto inline$BDLReleaseHandleList$1$Return#1;

  inline$BDLReleaseHandleList$1$anon2_Then#1:
    assume raiseException;
    goto inline$BDLReleaseHandleList$1$Return#1;

  inline$BDLReleaseHandleList$1$Return#1:
    goto inline$BDLCleanupDataHandles$1$label_42$1#1;

  inline$BDLCleanupDataHandles$1$label_42$1#1:
    goto inline$BDLCleanupDataHandles$1$anon35_Then#1, inline$BDLCleanupDataHandles$1$anon35_Else#1;

  inline$BDLCleanupDataHandles$1$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon11#1;

  inline$BDLCleanupDataHandles$1$anon11#1:
    goto inline$BDLCleanupDataHandles$1$label_87#1;

  inline$BDLCleanupDataHandles$1$label_87#1:
    goto inline$BDLGetDebugLevel$679$Entry#1;

  inline$BDLGetDebugLevel$679$Entry#1:
    goto inline$BDLGetDebugLevel$679$start#1;

  inline$BDLGetDebugLevel$679$start#1:
    goto inline$BDLGetDebugLevel$679$label_3#1;

  inline$BDLGetDebugLevel$679$label_3#1:
    havoc inline$BDLGetDebugLevel$679$myNondetVar_0;
    inline$BDLGetDebugLevel$679$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$679$myNondetVar_0;
    goto inline$BDLGetDebugLevel$679$label_1#1;

  inline$BDLGetDebugLevel$679$label_1#1:
    goto inline$BDLGetDebugLevel$679$Return#1;

  inline$BDLGetDebugLevel$679$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$26$ := inline$BDLGetDebugLevel$679$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_87$1#1;

  inline$BDLCleanupDataHandles$1$label_87$1#1:
    goto inline$BDLCleanupDataHandles$1$anon42_Then#1, inline$BDLCleanupDataHandles$1$anon42_Else#1;

  inline$BDLCleanupDataHandles$1$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon25#1;

  inline$BDLCleanupDataHandles$1$anon25#1:
    goto inline$BDLCleanupDataHandles$1$label_90#1;

  inline$BDLCleanupDataHandles$1$label_90#1:
    goto inline$BDLCleanupDataHandles$1$label_90_true#1, inline$BDLCleanupDataHandles$1$label_90_false#1;

  inline$BDLCleanupDataHandles$1$label_90_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$26$) == 0;
    goto inline$BDLCleanupDataHandles$1$label_91#1;

  inline$BDLCleanupDataHandles$1$label_90_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$26$) != 0;
    goto inline$BDLCleanupDataHandles$1$label_94#1;

  inline$BDLCleanupDataHandles$1$label_94#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_95#1;

  inline$BDLCleanupDataHandles$1$label_95#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_96#1;

  inline$BDLCleanupDataHandles$1$label_96#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_97#1;

  inline$BDLCleanupDataHandles$1$label_97#1:
    havoc inline$BDLCleanupDataHandles$1$$result.DbgPrint$3308.0$27$;
    goto inline$BDLCleanupDataHandles$1$label_91#1;

  inline$BDLCleanupDataHandles$1$label_91#1:
    goto inline$BDLGetDebugLevel$680$Entry#1;

  inline$BDLGetDebugLevel$680$Entry#1:
    goto inline$BDLGetDebugLevel$680$start#1;

  inline$BDLGetDebugLevel$680$start#1:
    goto inline$BDLGetDebugLevel$680$label_3#1;

  inline$BDLGetDebugLevel$680$label_3#1:
    havoc inline$BDLGetDebugLevel$680$myNondetVar_0;
    inline$BDLGetDebugLevel$680$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$680$myNondetVar_0;
    goto inline$BDLGetDebugLevel$680$label_1#1;

  inline$BDLGetDebugLevel$680$label_1#1:
    goto inline$BDLGetDebugLevel$680$Return#1;

  inline$BDLGetDebugLevel$680$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$31$ := inline$BDLGetDebugLevel$680$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_91$1#1;

  inline$BDLCleanupDataHandles$1$label_91$1#1:
    goto inline$BDLCleanupDataHandles$1$anon43_Then#1, inline$BDLCleanupDataHandles$1$anon43_Else#1;

  inline$BDLCleanupDataHandles$1$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon27#1;

  inline$BDLCleanupDataHandles$1$anon27#1:
    goto inline$BDLCleanupDataHandles$1$label_100#1;

  inline$BDLCleanupDataHandles$1$label_100#1:
    goto inline$BDLCleanupDataHandles$1$label_100_true#1, inline$BDLCleanupDataHandles$1$label_100_false#1;

  inline$BDLCleanupDataHandles$1$label_100_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$31$) == 0;
    goto inline$BDLCleanupDataHandles$1$label_101#1;

  inline$BDLCleanupDataHandles$1$label_100_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$31$) != 0;
    goto inline$BDLCleanupDataHandles$1$label_104#1;

  inline$BDLCleanupDataHandles$1$label_104#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_105#1;

  inline$BDLCleanupDataHandles$1$label_105#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_106#1;

  inline$BDLCleanupDataHandles$1$label_106#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_107#1;

  inline$BDLCleanupDataHandles$1$label_107#1:
    havoc inline$BDLCleanupDataHandles$1$$result.DbgPrint$3308.0$32$;
    goto inline$BDLCleanupDataHandles$1$label_101#1;

  inline$BDLCleanupDataHandles$1$label_101#1:
    goto inline$BDLGetDebugLevel$681$Entry#1;

  inline$BDLGetDebugLevel$681$Entry#1:
    goto inline$BDLGetDebugLevel$681$start#1;

  inline$BDLGetDebugLevel$681$start#1:
    goto inline$BDLGetDebugLevel$681$label_3#1;

  inline$BDLGetDebugLevel$681$label_3#1:
    havoc inline$BDLGetDebugLevel$681$myNondetVar_0;
    inline$BDLGetDebugLevel$681$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$681$myNondetVar_0;
    goto inline$BDLGetDebugLevel$681$label_1#1;

  inline$BDLGetDebugLevel$681$label_1#1:
    goto inline$BDLGetDebugLevel$681$Return#1;

  inline$BDLGetDebugLevel$681$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$36$ := inline$BDLGetDebugLevel$681$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_101$1#1;

  inline$BDLCleanupDataHandles$1$label_101$1#1:
    goto inline$BDLCleanupDataHandles$1$anon44_Then#1, inline$BDLCleanupDataHandles$1$anon44_Else#1;

  inline$BDLCleanupDataHandles$1$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon29#1;

  inline$BDLCleanupDataHandles$1$anon29#1:
    goto inline$BDLCleanupDataHandles$1$label_110#1;

  inline$BDLCleanupDataHandles$1$label_110#1:
    goto inline$BDLCleanupDataHandles$1$label_110_true#1, inline$BDLCleanupDataHandles$1$label_110_false#1;

  inline$BDLCleanupDataHandles$1$label_110_false#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$36$, 4) == 0;
    goto inline$BDLCleanupDataHandles$1$label_1#1;

  inline$BDLCleanupDataHandles$1$label_110_true#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3308.0$36$, 4) != 0;
    goto inline$BDLCleanupDataHandles$1$label_111#1;

  inline$BDLCleanupDataHandles$1$label_111#1:
    goto inline$BDLCleanupDataHandles$1$label_1#1;

  inline$BDLCleanupDataHandles$1$label_1#1:
    call __HAVOC_free(inline$BDLCleanupDataHandles$1$$bddDataHandle$4$3247.28$BDLCleanupDataHandles$4);
    call __HAVOC_free(inline$BDLCleanupDataHandles$1$$bddiCloseHandleParams$5$3248.28$BDLCleanupDataHandles$4);
    call __HAVOC_free(inline$BDLCleanupDataHandles$1$$irql$6$3249.28$BDLCleanupDataHandles$4);
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon44_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon43_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon42_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon35_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$label_41_true#1:
    assume INT_EQ(inline$BDLCleanupDataHandles$1$$result.BDLGetFirstHandle$3264.27$12$, 1);
    goto inline$BDLCleanupDataHandles$1$label_45#1;

  inline$BDLCleanupDataHandles$1$label_45#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$Entry#1;

  inline$BDLRemoveHandleFromList$1$Entry#1:
    inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8_.1 := inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$start#1;

  inline$BDLRemoveHandleFromList$1$start#1:
    inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8_.1;
    goto inline$BDLRemoveHandleFromList$1$label_3#1;

  inline$BDLRemoveHandleFromList$1$label_3#1:
    goto inline$BDLRemoveHandleFromList$1$label_4#1;

  inline$BDLRemoveHandleFromList$1$label_4#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_5#1;

  inline$BDLRemoveHandleFromList$1$label_5#1:
    goto inline$BDLRemoveHandleFromList$1$label_6#1;

  inline$BDLRemoveHandleFromList$1$label_6#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_7#1;

  inline$BDLRemoveHandleFromList$1$label_7#1:
    goto inline$BDLRemoveHandleFromList$1$label_7_true#1, inline$BDLRemoveHandleFromList$1$label_7_false#1;

  inline$BDLRemoveHandleFromList$1$label_7_false#1:
    assume inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 == 0;
    goto inline$BDLRemoveHandleFromList$1$label_8#1;

  inline$BDLRemoveHandleFromList$1$label_8#1:
    goto inline$BDLRemoveHandleFromList$1$label_1#1;

  inline$BDLRemoveHandleFromList$1$label_7_true#1:
    assume inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 != 0;
    goto inline$BDLRemoveHandleFromList$1$label_9#1;

  inline$BDLRemoveHandleFromList$1$label_9#1:
    goto inline$BDLRemoveHandleFromList$1$label_9_true#1, inline$BDLRemoveHandleFromList$1$label_9_false#1;

  inline$BDLRemoveHandleFromList$1$label_9_false#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$1$label_10#1;

  inline$BDLRemoveHandleFromList$1$label_10#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_20#1;

  inline$BDLRemoveHandleFromList$1$label_20#1:
    goto inline$BDLRemoveHandleFromList$1$label_20_head#1;

  inline$BDLRemoveHandleFromList$1$label_20_head#1:
    goto inline$BDLRemoveHandleFromList$1$label_20_true#1, inline$BDLRemoveHandleFromList$1$label_20_false#1;

  inline$BDLRemoveHandleFromList$1$label_20_false#1:
    assume inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 == 0;
    goto inline$BDLRemoveHandleFromList$1$label_21#1;

  inline$BDLRemoveHandleFromList$1$label_20_true#1:
    assume inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 != 0;
    goto inline$BDLRemoveHandleFromList$1$label_22#1;

  inline$BDLRemoveHandleFromList$1$label_22#1:
    goto inline$BDLRemoveHandleFromList$1$label_22_true#1, inline$BDLRemoveHandleFromList$1$label_22_false#1;

  inline$BDLRemoveHandleFromList$1$label_22_false#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    assume !INT_NEQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$1$label_21#1;

  inline$BDLRemoveHandleFromList$1$label_21#1:
    goto inline$BDLRemoveHandleFromList$1$label_21_true#1, inline$BDLRemoveHandleFromList$1$label_21_false#1;

  inline$BDLRemoveHandleFromList$1$label_21_false#1:
    assume inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 == 0;
    goto inline$BDLRemoveHandleFromList$1$label_25#1;

  inline$BDLRemoveHandleFromList$1$label_25#1:
    goto inline$BDLRemoveHandleFromList$1$label_1#1;

  inline$BDLRemoveHandleFromList$1$label_21_true#1:
    assume inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 != 0;
    goto inline$BDLRemoveHandleFromList$1$label_26#1;

  inline$BDLRemoveHandleFromList$1$label_26#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_27#1;

  inline$BDLRemoveHandleFromList$1$label_27#1:
    goto inline$BDLRemoveHandleFromList$1$label_27_true#1, inline$BDLRemoveHandleFromList$1$label_27_false#1;

  inline$BDLRemoveHandleFromList$1$label_27_false#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$1$label_15#1;

  inline$BDLRemoveHandleFromList$1$label_27_true#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    assume INT_EQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$1$label_28#1;

  inline$BDLRemoveHandleFromList$1$label_28#1:
    goto inline$BDLRemoveHandleFromList$1$label_15#1;

  inline$BDLRemoveHandleFromList$1$label_22_true#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    assume INT_NEQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$1$label_23#1;

  inline$BDLRemoveHandleFromList$1$label_23#1:
    goto inline$BDLRemoveHandleFromList$1$label_24#1;

  inline$BDLRemoveHandleFromList$1$label_24#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_20_head#0;

  inline$BDLRemoveHandleFromList$1$label_20_head#0:
    assume false;
    return;

  inline$BDLRemoveHandleFromList$1$label_9_true#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    assume INT_EQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$1$label_11#1;

  inline$BDLRemoveHandleFromList$1$label_11#1:
    goto inline$BDLRemoveHandleFromList$1$label_11_true#1, inline$BDLRemoveHandleFromList$1$label_11_false#1;

  inline$BDLRemoveHandleFromList$1$label_11_false#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_1;
    assume !INT_EQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$myNondetVar_1);
    goto inline$BDLRemoveHandleFromList$1$label_12#1;

  inline$BDLRemoveHandleFromList$1$label_12#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_15#1;

  inline$BDLRemoveHandleFromList$1$label_11_true#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_1;
    assume INT_EQ(inline$BDLRemoveHandleFromList$1$myNondetVar_0, inline$BDLRemoveHandleFromList$1$myNondetVar_1);
    goto inline$BDLRemoveHandleFromList$1$label_13#1;

  inline$BDLRemoveHandleFromList$1$label_13#1:
    goto inline$BDLRemoveHandleFromList$1$label_14#1;

  inline$BDLRemoveHandleFromList$1$label_14#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_15#1;

  inline$BDLRemoveHandleFromList$1$label_15#1:
    havoc inline$BDLRemoveHandleFromList$1$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$1$label_16#1;

  inline$BDLRemoveHandleFromList$1$label_16#1:
    call ExFreePoolWithTag(inline$BDLRemoveHandleFromList$1$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8, 1280066626);
    goto inline$BDLRemoveHandleFromList$1$anon2_Then#1, inline$BDLRemoveHandleFromList$1$anon2_Else#1;

  inline$BDLRemoveHandleFromList$1$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLRemoveHandleFromList$1$anon1#1;

  inline$BDLRemoveHandleFromList$1$anon1#1:
    goto inline$BDLRemoveHandleFromList$1$label_19#1;

  inline$BDLRemoveHandleFromList$1$label_19#1:
    goto inline$BDLRemoveHandleFromList$1$label_1#1;

  inline$BDLRemoveHandleFromList$1$label_1#1:
    goto inline$BDLRemoveHandleFromList$1$Return#1;

  inline$BDLRemoveHandleFromList$1$anon2_Then#1:
    assume raiseException;
    goto inline$BDLRemoveHandleFromList$1$Return#1;

  inline$BDLRemoveHandleFromList$1$Return#1:
    goto inline$BDLCleanupDataHandles$1$label_45$1#1;

  inline$BDLCleanupDataHandles$1$label_45$1#1:
    goto inline$BDLCleanupDataHandles$1$anon36_Then#1, inline$BDLCleanupDataHandles$1$anon36_Else#1;

  inline$BDLCleanupDataHandles$1$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon13#1;

  inline$BDLCleanupDataHandles$1$anon13#1:
    goto inline$BDLCleanupDataHandles$1$label_48#1;

  inline$BDLCleanupDataHandles$1$label_48#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    inline$BDLCleanupDataHandles$1$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4 := inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$BDLCleanupDataHandles$1$label_49#1;

  inline$BDLCleanupDataHandles$1$label_49#1:
    goto inline$BDLCleanupDataHandles$1$label_49_true#1, inline$BDLCleanupDataHandles$1$label_49_false#1;

  inline$BDLCleanupDataHandles$1$label_49_false#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLCleanupDataHandles$1$myNondetVar_0, 2);
    goto inline$BDLCleanupDataHandles$1$label_50#1;

  inline$BDLCleanupDataHandles$1$label_50#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$BDLCleanupDataHandles$1$label_57#1;

  inline$BDLCleanupDataHandles$1$label_57#1:
    goto inline$BDLCleanupDataHandles$1$label_60#1;

  inline$BDLCleanupDataHandles$1$label_60#1:
    inline$BDLCleanupDataHandles$1$$status$2$3245.28$BDLCleanupDataHandles$4 := inline$BDLCleanupDataHandles$1$$callresult.$3284.85$14$;
    goto inline$BDLCleanupDataHandles$1$label_61#1;

  inline$BDLCleanupDataHandles$1$label_61#1:
    goto inline$BDLCleanupDataHandles$1$label_61_true#1, inline$BDLCleanupDataHandles$1$label_61_false#1;

  inline$BDLCleanupDataHandles$1$label_61_false#1:
    assume inline$BDLCleanupDataHandles$1$$status$2$3245.28$BDLCleanupDataHandles$4 == 0;
    goto inline$BDLCleanupDataHandles$1$label_54#1;

  inline$BDLCleanupDataHandles$1$label_61_true#1:
    assume inline$BDLCleanupDataHandles$1$$status$2$3245.28$BDLCleanupDataHandles$4 != 0;
    goto inline$BDLCleanupDataHandles$1$label_62#1;

  inline$BDLCleanupDataHandles$1$label_62#1:
    goto inline$BDLGetDebugLevel$676$Entry#1;

  inline$BDLGetDebugLevel$676$Entry#1:
    goto inline$BDLGetDebugLevel$676$start#1;

  inline$BDLGetDebugLevel$676$start#1:
    goto inline$BDLGetDebugLevel$676$label_3#1;

  inline$BDLGetDebugLevel$676$label_3#1:
    havoc inline$BDLGetDebugLevel$676$myNondetVar_0;
    inline$BDLGetDebugLevel$676$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$676$myNondetVar_0;
    goto inline$BDLGetDebugLevel$676$label_1#1;

  inline$BDLGetDebugLevel$676$label_1#1:
    goto inline$BDLGetDebugLevel$676$Return#1;

  inline$BDLGetDebugLevel$676$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$15$ := inline$BDLGetDebugLevel$676$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_62$1#1;

  inline$BDLCleanupDataHandles$1$label_62$1#1:
    goto inline$BDLCleanupDataHandles$1$anon39_Then#1, inline$BDLCleanupDataHandles$1$anon39_Else#1;

  inline$BDLCleanupDataHandles$1$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon19#1;

  inline$BDLCleanupDataHandles$1$anon19#1:
    goto inline$BDLCleanupDataHandles$1$label_65#1;

  inline$BDLCleanupDataHandles$1$label_65#1:
    goto inline$BDLCleanupDataHandles$1$label_65_true#1, inline$BDLCleanupDataHandles$1$label_65_false#1;

  inline$BDLCleanupDataHandles$1$label_65_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$15$) == 0;
    goto inline$BDLCleanupDataHandles$1$label_66#1;

  inline$BDLCleanupDataHandles$1$label_65_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$15$) != 0;
    goto inline$BDLCleanupDataHandles$1$label_69#1;

  inline$BDLCleanupDataHandles$1$label_69#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_70#1;

  inline$BDLCleanupDataHandles$1$label_70#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_71#1;

  inline$BDLCleanupDataHandles$1$label_71#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_72#1;

  inline$BDLCleanupDataHandles$1$label_72#1:
    havoc inline$BDLCleanupDataHandles$1$$result.DbgPrint$3290.0$16$;
    goto inline$BDLCleanupDataHandles$1$label_66#1;

  inline$BDLCleanupDataHandles$1$label_66#1:
    goto inline$BDLGetDebugLevel$677$Entry#1;

  inline$BDLGetDebugLevel$677$Entry#1:
    goto inline$BDLGetDebugLevel$677$start#1;

  inline$BDLGetDebugLevel$677$start#1:
    goto inline$BDLGetDebugLevel$677$label_3#1;

  inline$BDLGetDebugLevel$677$label_3#1:
    havoc inline$BDLGetDebugLevel$677$myNondetVar_0;
    inline$BDLGetDebugLevel$677$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$677$myNondetVar_0;
    goto inline$BDLGetDebugLevel$677$label_1#1;

  inline$BDLGetDebugLevel$677$label_1#1:
    goto inline$BDLGetDebugLevel$677$Return#1;

  inline$BDLGetDebugLevel$677$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$20$ := inline$BDLGetDebugLevel$677$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_66$1#1;

  inline$BDLCleanupDataHandles$1$label_66$1#1:
    goto inline$BDLCleanupDataHandles$1$anon40_Then#1, inline$BDLCleanupDataHandles$1$anon40_Else#1;

  inline$BDLCleanupDataHandles$1$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon21#1;

  inline$BDLCleanupDataHandles$1$anon21#1:
    goto inline$BDLCleanupDataHandles$1$label_75#1;

  inline$BDLCleanupDataHandles$1$label_75#1:
    goto inline$BDLCleanupDataHandles$1$label_75_true#1, inline$BDLCleanupDataHandles$1$label_75_false#1;

  inline$BDLCleanupDataHandles$1$label_75_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$20$) == 0;
    goto inline$BDLCleanupDataHandles$1$label_76#1;

  inline$BDLCleanupDataHandles$1$label_75_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$20$) != 0;
    goto inline$BDLCleanupDataHandles$1$label_79#1;

  inline$BDLCleanupDataHandles$1$label_79#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_80#1;

  inline$BDLCleanupDataHandles$1$label_80#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_81#1;

  inline$BDLCleanupDataHandles$1$label_81#1:
    call inline$BDLCleanupDataHandles$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$1$label_82#1;

  inline$BDLCleanupDataHandles$1$label_82#1:
    havoc inline$BDLCleanupDataHandles$1$$result.DbgPrint$3290.0$21$;
    goto inline$BDLCleanupDataHandles$1$label_76#1;

  inline$BDLCleanupDataHandles$1$label_76#1:
    goto inline$BDLGetDebugLevel$678$Entry#1;

  inline$BDLGetDebugLevel$678$Entry#1:
    goto inline$BDLGetDebugLevel$678$start#1;

  inline$BDLGetDebugLevel$678$start#1:
    goto inline$BDLGetDebugLevel$678$label_3#1;

  inline$BDLGetDebugLevel$678$label_3#1:
    havoc inline$BDLGetDebugLevel$678$myNondetVar_0;
    inline$BDLGetDebugLevel$678$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$678$myNondetVar_0;
    goto inline$BDLGetDebugLevel$678$label_1#1;

  inline$BDLGetDebugLevel$678$label_1#1:
    goto inline$BDLGetDebugLevel$678$Return#1;

  inline$BDLGetDebugLevel$678$Return#1:
    inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$25$ := inline$BDLGetDebugLevel$678$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$1$label_76$1#1;

  inline$BDLCleanupDataHandles$1$label_76$1#1:
    goto inline$BDLCleanupDataHandles$1$anon41_Then#1, inline$BDLCleanupDataHandles$1$anon41_Else#1;

  inline$BDLCleanupDataHandles$1$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon23#1;

  inline$BDLCleanupDataHandles$1$anon23#1:
    goto inline$BDLCleanupDataHandles$1$label_85#1;

  inline$BDLCleanupDataHandles$1$label_85#1:
    goto inline$BDLCleanupDataHandles$1$label_85_true#1, inline$BDLCleanupDataHandles$1$label_85_false#1;

  inline$BDLCleanupDataHandles$1$label_85_false#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$25$, 4) == 0;
    goto inline$BDLCleanupDataHandles$1$label_54#1;

  inline$BDLCleanupDataHandles$1$label_85_true#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$1$$result.BDLGetDebugLevel$3290.0$25$, 4) != 0;
    goto inline$BDLCleanupDataHandles$1$label_86#1;

  inline$BDLCleanupDataHandles$1$label_86#1:
    goto inline$BDLCleanupDataHandles$1$label_54#1;

  inline$BDLCleanupDataHandles$1$anon41_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon40_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon39_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$label_49_true#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    assume INT_EQ(inline$BDLCleanupDataHandles$1$myNondetVar_0, 2);
    goto inline$BDLCleanupDataHandles$1$label_51#1;

  inline$BDLCleanupDataHandles$1$label_51#1:
    havoc inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$bdliFree$1$Entry#1;

  inline$bdliFree$1$Entry#1:
    inline$bdliFree$1$$pvBlock$1$2740.28$bdliFree$4_.1 := inline$BDLCleanupDataHandles$1$myNondetVar_0;
    goto inline$bdliFree$1$start#1;

  inline$bdliFree$1$start#1:
    inline$bdliFree$1$$pvBlock$1$2740.28$bdliFree$4 := inline$bdliFree$1$$pvBlock$1$2740.28$bdliFree$4_.1;
    goto inline$bdliFree$1$label_3#1;

  inline$bdliFree$1$label_3#1:
    call ExFreePoolWithTag(inline$bdliFree$1$$pvBlock$1$2740.28$bdliFree$4, 1229734978);
    goto inline$bdliFree$1$anon2_Then#1, inline$bdliFree$1$anon2_Else#1;

  inline$bdliFree$1$anon2_Else#1:
    assume !raiseException;
    goto inline$bdliFree$1$anon1#1;

  inline$bdliFree$1$anon1#1:
    goto inline$bdliFree$1$label_1#1;

  inline$bdliFree$1$label_1#1:
    goto inline$bdliFree$1$Return#1;

  inline$bdliFree$1$anon2_Then#1:
    assume raiseException;
    goto inline$bdliFree$1$Return#1;

  inline$bdliFree$1$Return#1:
    goto inline$BDLCleanupDataHandles$1$label_51$1#1;

  inline$BDLCleanupDataHandles$1$label_51$1#1:
    goto inline$BDLCleanupDataHandles$1$anon37_Then#1, inline$BDLCleanupDataHandles$1$anon37_Else#1;

  inline$BDLCleanupDataHandles$1$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon15#1;

  inline$BDLCleanupDataHandles$1$anon15#1:
    goto inline$BDLCleanupDataHandles$1$label_54#1;

  inline$BDLCleanupDataHandles$1$label_54#1:
    call ExFreePoolWithTag(inline$BDLCleanupDataHandles$1$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4, 541869122);
    goto inline$BDLCleanupDataHandles$1$anon38_Then#1, inline$BDLCleanupDataHandles$1$anon38_Else#1;

  inline$BDLCleanupDataHandles$1$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$1$anon17#1;

  inline$BDLCleanupDataHandles$1$anon17#1:
    goto inline$BDLCleanupDataHandles$1$label_38_head#0;

  inline$BDLCleanupDataHandles$1$label_38_head#0:
    assume false;
    return;

  inline$BDLCleanupDataHandles$1$anon38_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon37_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon36_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon34_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon33_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon32_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon31_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$anon30_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$1$Return#1;

  inline$BDLCleanupDataHandles$1$Return#1:
    goto inline$BDLHandleRemove$1$label_41$1#1;

  inline$BDLHandleRemove$1$label_41$1#1:
    goto inline$BDLHandleRemove$1$anon48_Then#1, inline$BDLHandleRemove$1$anon48_Else#1;

  inline$BDLHandleRemove$1$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon13#1;

  inline$BDLHandleRemove$1$anon13#1:
    goto inline$BDLHandleRemove$1$label_44#1;

  inline$BDLHandleRemove$1$label_44#1:
    goto inline$BDLHandleRemove$1$label_44_true#1, inline$BDLHandleRemove$1$label_44_false#1;

  inline$BDLHandleRemove$1$label_44_false#1:
    havoc inline$BDLHandleRemove$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLHandleRemove$1$myNondetVar_0, 1);
    goto inline$BDLHandleRemove$1$label_45#1;

  inline$BDLHandleRemove$1$label_44_true#1:
    havoc inline$BDLHandleRemove$1$myNondetVar_0;
    assume INT_EQ(inline$BDLHandleRemove$1$myNondetVar_0, 1);
    goto inline$BDLHandleRemove$1$label_48#1;

  inline$BDLHandleRemove$1$label_48#1:
    goto inline$BDLHandleRemove$1$label_51#1;

  inline$BDLHandleRemove$1$label_51#1:
    inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 := inline$BDLHandleRemove$1$$callresult.$2419.71$15$;
    goto inline$BDLHandleRemove$1$label_52#1;

  inline$BDLHandleRemove$1$label_52#1:
    goto inline$BDLHandleRemove$1$label_52_true#1, inline$BDLHandleRemove$1$label_52_false#1;

  inline$BDLHandleRemove$1$label_52_false#1:
    assume inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 == 0;
    goto inline$BDLHandleRemove$1$label_53#1;

  inline$BDLHandleRemove$1$label_52_true#1:
    assume inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 != 0;
    goto inline$BDLHandleRemove$1$label_54#1;

  inline$BDLHandleRemove$1$label_54#1:
    goto inline$BDLGetDebugLevel$682$Entry#1;

  inline$BDLGetDebugLevel$682$Entry#1:
    goto inline$BDLGetDebugLevel$682$start#1;

  inline$BDLGetDebugLevel$682$start#1:
    goto inline$BDLGetDebugLevel$682$label_3#1;

  inline$BDLGetDebugLevel$682$label_3#1:
    havoc inline$BDLGetDebugLevel$682$myNondetVar_0;
    inline$BDLGetDebugLevel$682$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$682$myNondetVar_0;
    goto inline$BDLGetDebugLevel$682$label_1#1;

  inline$BDLGetDebugLevel$682$label_1#1:
    goto inline$BDLGetDebugLevel$682$Return#1;

  inline$BDLGetDebugLevel$682$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$16$ := inline$BDLGetDebugLevel$682$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_54$1#1;

  inline$BDLHandleRemove$1$label_54$1#1:
    goto inline$BDLHandleRemove$1$anon49_Then#1, inline$BDLHandleRemove$1$anon49_Else#1;

  inline$BDLHandleRemove$1$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon15#1;

  inline$BDLHandleRemove$1$anon15#1:
    goto inline$BDLHandleRemove$1$label_57#1;

  inline$BDLHandleRemove$1$label_57#1:
    goto inline$BDLHandleRemove$1$label_57_true#1, inline$BDLHandleRemove$1$label_57_false#1;

  inline$BDLHandleRemove$1$label_57_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$16$) == 0;
    goto inline$BDLHandleRemove$1$label_58#1;

  inline$BDLHandleRemove$1$label_57_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$16$) != 0;
    goto inline$BDLHandleRemove$1$label_61#1;

  inline$BDLHandleRemove$1$label_61#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_62#1;

  inline$BDLHandleRemove$1$label_62#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_63#1;

  inline$BDLHandleRemove$1$label_63#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_64#1;

  inline$BDLHandleRemove$1$label_64#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2423.0$17$;
    goto inline$BDLHandleRemove$1$label_58#1;

  inline$BDLHandleRemove$1$label_58#1:
    goto inline$BDLGetDebugLevel$683$Entry#1;

  inline$BDLGetDebugLevel$683$Entry#1:
    goto inline$BDLGetDebugLevel$683$start#1;

  inline$BDLGetDebugLevel$683$start#1:
    goto inline$BDLGetDebugLevel$683$label_3#1;

  inline$BDLGetDebugLevel$683$label_3#1:
    havoc inline$BDLGetDebugLevel$683$myNondetVar_0;
    inline$BDLGetDebugLevel$683$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$683$myNondetVar_0;
    goto inline$BDLGetDebugLevel$683$label_1#1;

  inline$BDLGetDebugLevel$683$label_1#1:
    goto inline$BDLGetDebugLevel$683$Return#1;

  inline$BDLGetDebugLevel$683$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$21$ := inline$BDLGetDebugLevel$683$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_58$1#1;

  inline$BDLHandleRemove$1$label_58$1#1:
    goto inline$BDLHandleRemove$1$anon50_Then#1, inline$BDLHandleRemove$1$anon50_Else#1;

  inline$BDLHandleRemove$1$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon17#1;

  inline$BDLHandleRemove$1$anon17#1:
    goto inline$BDLHandleRemove$1$label_67#1;

  inline$BDLHandleRemove$1$label_67#1:
    goto inline$BDLHandleRemove$1$label_67_true#1, inline$BDLHandleRemove$1$label_67_false#1;

  inline$BDLHandleRemove$1$label_67_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$21$) == 0;
    goto inline$BDLHandleRemove$1$label_68#1;

  inline$BDLHandleRemove$1$label_67_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$21$) != 0;
    goto inline$BDLHandleRemove$1$label_71#1;

  inline$BDLHandleRemove$1$label_71#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_72#1;

  inline$BDLHandleRemove$1$label_72#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_73#1;

  inline$BDLHandleRemove$1$label_73#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_74#1;

  inline$BDLHandleRemove$1$label_74#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2423.0$22$;
    goto inline$BDLHandleRemove$1$label_68#1;

  inline$BDLHandleRemove$1$label_68#1:
    goto inline$BDLGetDebugLevel$684$Entry#1;

  inline$BDLGetDebugLevel$684$Entry#1:
    goto inline$BDLGetDebugLevel$684$start#1;

  inline$BDLGetDebugLevel$684$start#1:
    goto inline$BDLGetDebugLevel$684$label_3#1;

  inline$BDLGetDebugLevel$684$label_3#1:
    havoc inline$BDLGetDebugLevel$684$myNondetVar_0;
    inline$BDLGetDebugLevel$684$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$684$myNondetVar_0;
    goto inline$BDLGetDebugLevel$684$label_1#1;

  inline$BDLGetDebugLevel$684$label_1#1:
    goto inline$BDLGetDebugLevel$684$Return#1;

  inline$BDLGetDebugLevel$684$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$26$ := inline$BDLGetDebugLevel$684$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_68$1#1;

  inline$BDLHandleRemove$1$label_68$1#1:
    goto inline$BDLHandleRemove$1$anon51_Then#1, inline$BDLHandleRemove$1$anon51_Else#1;

  inline$BDLHandleRemove$1$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon19#1;

  inline$BDLHandleRemove$1$anon19#1:
    goto inline$BDLHandleRemove$1$label_77#1;

  inline$BDLHandleRemove$1$label_77#1:
    goto inline$BDLHandleRemove$1$label_77_true#1, inline$BDLHandleRemove$1$label_77_false#1;

  inline$BDLHandleRemove$1$label_77_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$26$, 4) == 0;
    goto inline$BDLHandleRemove$1$label_53#1;

  inline$BDLHandleRemove$1$label_77_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2423.0$26$, 4) != 0;
    goto inline$BDLHandleRemove$1$label_78#1;

  inline$BDLHandleRemove$1$label_78#1:
    goto inline$BDLHandleRemove$1$label_53#1;

  inline$BDLHandleRemove$1$label_53#1:
    goto inline$BDLHandleRemove$1$label_45#1;

  inline$BDLHandleRemove$1$label_45#1:
    goto inline$BDLHandleRemove$1$label_79#1;

  inline$BDLHandleRemove$1$label_79#1:
    inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 := inline$BDLHandleRemove$1$$callresult.$2437.63$27$;
    goto inline$BDLHandleRemove$1$label_80#1;

  inline$BDLHandleRemove$1$label_80#1:
    goto inline$BDLHandleRemove$1$label_80_true#1, inline$BDLHandleRemove$1$label_80_false#1;

  inline$BDLHandleRemove$1$label_80_false#1:
    assume inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 == 0;
    goto inline$BDLHandleRemove$1$label_81#1;

  inline$BDLHandleRemove$1$label_80_true#1:
    assume inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 != 0;
    goto inline$BDLHandleRemove$1$label_84#1;

  inline$BDLHandleRemove$1$label_84#1:
    goto inline$BDLGetDebugLevel$685$Entry#1;

  inline$BDLGetDebugLevel$685$Entry#1:
    goto inline$BDLGetDebugLevel$685$start#1;

  inline$BDLGetDebugLevel$685$start#1:
    goto inline$BDLGetDebugLevel$685$label_3#1;

  inline$BDLGetDebugLevel$685$label_3#1:
    havoc inline$BDLGetDebugLevel$685$myNondetVar_0;
    inline$BDLGetDebugLevel$685$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$685$myNondetVar_0;
    goto inline$BDLGetDebugLevel$685$label_1#1;

  inline$BDLGetDebugLevel$685$label_1#1:
    goto inline$BDLGetDebugLevel$685$Return#1;

  inline$BDLGetDebugLevel$685$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$28$ := inline$BDLGetDebugLevel$685$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_84$1#1;

  inline$BDLHandleRemove$1$label_84$1#1:
    goto inline$BDLHandleRemove$1$anon53_Then#1, inline$BDLHandleRemove$1$anon53_Else#1;

  inline$BDLHandleRemove$1$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon23#1;

  inline$BDLHandleRemove$1$anon23#1:
    goto inline$BDLHandleRemove$1$label_87#1;

  inline$BDLHandleRemove$1$label_87#1:
    goto inline$BDLHandleRemove$1$label_87_true#1, inline$BDLHandleRemove$1$label_87_false#1;

  inline$BDLHandleRemove$1$label_87_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$28$) == 0;
    goto inline$BDLHandleRemove$1$label_88#1;

  inline$BDLHandleRemove$1$label_87_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$28$) != 0;
    goto inline$BDLHandleRemove$1$label_91#1;

  inline$BDLHandleRemove$1$label_91#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_92#1;

  inline$BDLHandleRemove$1$label_92#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_93#1;

  inline$BDLHandleRemove$1$label_93#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_94#1;

  inline$BDLHandleRemove$1$label_94#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2441.0$29$;
    goto inline$BDLHandleRemove$1$label_88#1;

  inline$BDLHandleRemove$1$label_88#1:
    goto inline$BDLGetDebugLevel$686$Entry#1;

  inline$BDLGetDebugLevel$686$Entry#1:
    goto inline$BDLGetDebugLevel$686$start#1;

  inline$BDLGetDebugLevel$686$start#1:
    goto inline$BDLGetDebugLevel$686$label_3#1;

  inline$BDLGetDebugLevel$686$label_3#1:
    havoc inline$BDLGetDebugLevel$686$myNondetVar_0;
    inline$BDLGetDebugLevel$686$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$686$myNondetVar_0;
    goto inline$BDLGetDebugLevel$686$label_1#1;

  inline$BDLGetDebugLevel$686$label_1#1:
    goto inline$BDLGetDebugLevel$686$Return#1;

  inline$BDLGetDebugLevel$686$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$33$ := inline$BDLGetDebugLevel$686$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_88$1#1;

  inline$BDLHandleRemove$1$label_88$1#1:
    goto inline$BDLHandleRemove$1$anon54_Then#1, inline$BDLHandleRemove$1$anon54_Else#1;

  inline$BDLHandleRemove$1$anon54_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon25#1;

  inline$BDLHandleRemove$1$anon25#1:
    goto inline$BDLHandleRemove$1$label_97#1;

  inline$BDLHandleRemove$1$label_97#1:
    goto inline$BDLHandleRemove$1$label_97_true#1, inline$BDLHandleRemove$1$label_97_false#1;

  inline$BDLHandleRemove$1$label_97_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$33$) == 0;
    goto inline$BDLHandleRemove$1$label_98#1;

  inline$BDLHandleRemove$1$label_97_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$33$) != 0;
    goto inline$BDLHandleRemove$1$label_101#1;

  inline$BDLHandleRemove$1$label_101#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_102#1;

  inline$BDLHandleRemove$1$label_102#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_103#1;

  inline$BDLHandleRemove$1$label_103#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_104#1;

  inline$BDLHandleRemove$1$label_104#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2441.0$34$;
    goto inline$BDLHandleRemove$1$label_98#1;

  inline$BDLHandleRemove$1$label_98#1:
    goto inline$BDLGetDebugLevel$687$Entry#1;

  inline$BDLGetDebugLevel$687$Entry#1:
    goto inline$BDLGetDebugLevel$687$start#1;

  inline$BDLGetDebugLevel$687$start#1:
    goto inline$BDLGetDebugLevel$687$label_3#1;

  inline$BDLGetDebugLevel$687$label_3#1:
    havoc inline$BDLGetDebugLevel$687$myNondetVar_0;
    inline$BDLGetDebugLevel$687$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$687$myNondetVar_0;
    goto inline$BDLGetDebugLevel$687$label_1#1;

  inline$BDLGetDebugLevel$687$label_1#1:
    goto inline$BDLGetDebugLevel$687$Return#1;

  inline$BDLGetDebugLevel$687$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$38$ := inline$BDLGetDebugLevel$687$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_98$1#1;

  inline$BDLHandleRemove$1$label_98$1#1:
    goto inline$BDLHandleRemove$1$anon55_Then#1, inline$BDLHandleRemove$1$anon55_Else#1;

  inline$BDLHandleRemove$1$anon55_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon27#1;

  inline$BDLHandleRemove$1$anon27#1:
    goto inline$BDLHandleRemove$1$label_107#1;

  inline$BDLHandleRemove$1$label_107#1:
    goto inline$BDLHandleRemove$1$label_107_true#1, inline$BDLHandleRemove$1$label_107_false#1;

  inline$BDLHandleRemove$1$label_107_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$38$, 4) == 0;
    goto inline$BDLHandleRemove$1$label_81#1;

  inline$BDLHandleRemove$1$label_107_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2441.0$38$, 4) != 0;
    goto inline$BDLHandleRemove$1$label_108#1;

  inline$BDLHandleRemove$1$label_108#1:
    goto inline$BDLHandleRemove$1$label_81#1;

  inline$BDLHandleRemove$1$label_81#1:
    goto inline$IoSkipCurrentIrpStackLocation$1$Entry#1;

  inline$IoSkipCurrentIrpStackLocation$1$Entry#1:
    inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1 := inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12;
    goto inline$IoSkipCurrentIrpStackLocation$1$start#1;

  inline$IoSkipCurrentIrpStackLocation$1$start#1:
    inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4 := inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1;
    goto inline$IoSkipCurrentIrpStackLocation$1$label_3#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_3#1:
    goto inline$IoSkipCurrentIrpStackLocation$1$label_3_true#1, inline$IoSkipCurrentIrpStackLocation$1$label_3_false#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_3_false#1:
    inline$IoSkipCurrentIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$1$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoSkipCurrentIrpStackLocation$1$myVar_0, inline$IoSkipCurrentIrpStackLocation$1$myVar_1);
    goto inline$IoSkipCurrentIrpStackLocation$1$label_4#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_4#1:
    call inline$IoSkipCurrentIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSkipCurrentIrpStackLocation$1$label_7#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_7#1:
    call inline$IoSkipCurrentIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSkipCurrentIrpStackLocation$1$label_8#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_8#1:
    goto inline$IoSkipCurrentIrpStackLocation$1$label_5#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_3_true#1:
    inline$IoSkipCurrentIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$1$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoSkipCurrentIrpStackLocation$1$myVar_0, inline$IoSkipCurrentIrpStackLocation$1$myVar_1);
    goto inline$IoSkipCurrentIrpStackLocation$1$label_5#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_5#1:
    inline$IoSkipCurrentIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$1$tempBoogie0 := PLUS(inline$IoSkipCurrentIrpStackLocation$1$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$1$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4) := inline$IoSkipCurrentIrpStackLocation$1$tempBoogie0];
    call contextSwitch();
    goto inline$IoSkipCurrentIrpStackLocation$1$label_6#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_6#1:
    havoc inline$IoSkipCurrentIrpStackLocation$1$myNondetVar_0;
    inline$IoSkipCurrentIrpStackLocation$1$tempBoogie0 := PLUS(inline$IoSkipCurrentIrpStackLocation$1$myNondetVar_0, 36, 1);
    goto inline$IoSkipCurrentIrpStackLocation$1$label_1#1;

  inline$IoSkipCurrentIrpStackLocation$1$label_1#1:
    goto inline$IoSkipCurrentIrpStackLocation$1$Return#1;

  inline$IoSkipCurrentIrpStackLocation$1$Return#1:
    goto inline$BDLHandleRemove$1$label_81$1#1;

  inline$BDLHandleRemove$1$label_81$1#1:
    goto inline$BDLHandleRemove$1$anon52_Then#1, inline$BDLHandleRemove$1$anon52_Else#1;

  inline$BDLHandleRemove$1$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon21#1;

  inline$BDLHandleRemove$1$anon21#1:
    goto inline$BDLHandleRemove$1$label_109#1;

  inline$BDLHandleRemove$1$label_109#1:
    goto inline$storm_IoCallDriver$13$Entry#1;

  inline$storm_IoCallDriver$13$Entry#1:
    inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLHandleRemove$1$$pIrp$3$2380.40$BDLHandleRemove$12;
    goto inline$storm_IoCallDriver$13$start#1;

  inline$storm_IoCallDriver$13$start#1:
    inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$13$label_3#1;

  inline$storm_IoCallDriver$13$label_3#1:
    goto inline$storm_IoCallDriver$13$label_4#1;

  inline$storm_IoCallDriver$13$label_4#1:
    goto inline$storm_IoCallDriver$13$label_5#1;

  inline$storm_IoCallDriver$13$label_5#1:
    goto inline$storm_IoCallDriver$13$label_6#1;

  inline$storm_IoCallDriver$13$label_6#1:
    call inline$storm_IoCallDriver$13$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$13$label_9#1;

  inline$storm_IoCallDriver$13$label_9#1:
    goto inline$storm_IoCallDriver$13$label_9_true#1, inline$storm_IoCallDriver$13$label_9_false#1;

  inline$storm_IoCallDriver$13$label_9_false#1:
    assume inline$storm_IoCallDriver$13$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$13$label_10#1;

  inline$storm_IoCallDriver$13$label_9_true#1:
    assume inline$storm_IoCallDriver$13$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$13$label_13#1;

  inline$storm_IoCallDriver$13$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$13$anon12_Then#1, inline$storm_IoCallDriver$13$anon12_Else#1;

  inline$storm_IoCallDriver$13$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$13$anon3#1;

  inline$storm_IoCallDriver$13$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$13$label_14#1;

  inline$storm_IoCallDriver$13$label_14#1:
    goto inline$storm_IoCallDriver$13$label_14_true#1, inline$storm_IoCallDriver$13$label_14_false#1;

  inline$storm_IoCallDriver$13$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$13$label_15#1;

  inline$storm_IoCallDriver$13$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$13$label_1#1;

  inline$storm_IoCallDriver$13$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$13$label_10#1;

  inline$storm_IoCallDriver$13$label_10#1:
    goto inline$IoSetNextIrpStackLocation$14$Entry#1;

  inline$IoSetNextIrpStackLocation$14$Entry#1:
    inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$14$start#1;

  inline$IoSetNextIrpStackLocation$14$start#1:
    inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$14$label_3#1;

  inline$IoSetNextIrpStackLocation$14$label_3#1:
    goto inline$IoSetNextIrpStackLocation$14$label_3_true#1, inline$IoSetNextIrpStackLocation$14$label_3_false#1;

  inline$IoSetNextIrpStackLocation$14$label_3_false#1:
    inline$IoSetNextIrpStackLocation$14$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$14$myVar_0);
    goto inline$IoSetNextIrpStackLocation$14$label_4#1;

  inline$IoSetNextIrpStackLocation$14$label_4#1:
    call inline$IoSetNextIrpStackLocation$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$14$label_7#1;

  inline$IoSetNextIrpStackLocation$14$label_7#1:
    call inline$IoSetNextIrpStackLocation$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$14$label_8#1;

  inline$IoSetNextIrpStackLocation$14$label_8#1:
    goto inline$IoSetNextIrpStackLocation$14$label_5#1;

  inline$IoSetNextIrpStackLocation$14$label_3_true#1:
    inline$IoSetNextIrpStackLocation$14$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$14$myVar_0);
    goto inline$IoSetNextIrpStackLocation$14$label_5#1;

  inline$IoSetNextIrpStackLocation$14$label_5#1:
    inline$IoSetNextIrpStackLocation$14$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$14$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$14$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$14$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$14$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$14$label_6#1;

  inline$IoSetNextIrpStackLocation$14$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$14$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$14$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$14$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$14$label_1#1;

  inline$IoSetNextIrpStackLocation$14$label_1#1:
    goto inline$IoSetNextIrpStackLocation$14$Return#1;

  inline$IoSetNextIrpStackLocation$14$Return#1:
    goto inline$storm_IoCallDriver$13$label_10$1#1;

  inline$storm_IoCallDriver$13$label_10$1#1:
    goto inline$storm_IoCallDriver$13$anon11_Then#1, inline$storm_IoCallDriver$13$anon11_Else#1;

  inline$storm_IoCallDriver$13$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$13$anon1#1;

  inline$storm_IoCallDriver$13$anon1#1:
    goto inline$storm_IoCallDriver$13$label_18#1;

  inline$storm_IoCallDriver$13$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$132$Entry#1;

  inline$IoGetCurrentIrpStackLocation$132$Entry#1:
    inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$132$start#1;

  inline$IoGetCurrentIrpStackLocation$132$start#1:
    inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$132$label_3#1;

  inline$IoGetCurrentIrpStackLocation$132$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$132$label_3_true#1, inline$IoGetCurrentIrpStackLocation$132$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$132$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$132$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$132$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$132$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$132$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$132$label_4#1;

  inline$IoGetCurrentIrpStackLocation$132$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$132$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$132$label_6#1;

  inline$IoGetCurrentIrpStackLocation$132$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$132$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$132$label_7#1;

  inline$IoGetCurrentIrpStackLocation$132$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$132$label_5#1;

  inline$IoGetCurrentIrpStackLocation$132$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$132$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$132$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$132$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$132$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$132$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$132$label_5#1;

  inline$IoGetCurrentIrpStackLocation$132$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$132$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$132$label_1#1;

  inline$IoGetCurrentIrpStackLocation$132$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$132$Return#1;

  inline$IoGetCurrentIrpStackLocation$132$Return#1:
    goto inline$storm_IoCallDriver$13$label_18$1#1;

  inline$storm_IoCallDriver$13$label_18$1#1:
    goto inline$storm_IoCallDriver$13$anon13_Then#1, inline$storm_IoCallDriver$13$anon13_Else#1;

  inline$storm_IoCallDriver$13$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$13$anon6#1;

  inline$storm_IoCallDriver$13$anon6#1:
    goto inline$storm_IoCallDriver$13$label_21#1;

  inline$storm_IoCallDriver$13$label_21#1:
    goto inline$storm_IoCallDriver$13$label_22#1;

  inline$storm_IoCallDriver$13$label_22#1:
    goto inline$storm_IoCallDriver$13$label_23#1;

  inline$storm_IoCallDriver$13$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$13$label_24#1;

  inline$storm_IoCallDriver$13$label_24#1:
    call inline$storm_IoCallDriver$13$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$13$label_27#1;

  inline$storm_IoCallDriver$13$label_27#1:
    goto inline$storm_IoCallDriver$13$label_27_case_0#1, inline$storm_IoCallDriver$13$label_27_case_1#1, inline$storm_IoCallDriver$13$label_27_case_2#1;

  inline$storm_IoCallDriver$13$label_27_case_2#1:
    assume inline$storm_IoCallDriver$13$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$13$label_30#1;

  inline$storm_IoCallDriver$13$label_30#1:
    inline$storm_IoCallDriver$13$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$13$label_31#1;

  inline$storm_IoCallDriver$13$label_31#1:
    goto inline$storm_IoCallDriver$13$label_32#1;

  inline$storm_IoCallDriver$13$label_32#1:
    goto inline$storm_IoCallDriver$13$label_33#1;

  inline$storm_IoCallDriver$13$label_33#1:
    goto inline$CallCompletionRoutine$26$Entry#1;

  inline$CallCompletionRoutine$26$Entry#1:
    inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$26$start#1;

  inline$CallCompletionRoutine$26$start#1:
    inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$26$label_3#1;

  inline$CallCompletionRoutine$26$label_3#1:
    goto inline$CallCompletionRoutine$26$label_4#1;

  inline$CallCompletionRoutine$26$label_4#1:
    goto inline$CallCompletionRoutine$26$label_5#1;

  inline$CallCompletionRoutine$26$label_5#1:
    goto inline$CallCompletionRoutine$26$label_6#1;

  inline$CallCompletionRoutine$26$label_6#1:
    goto inline$CallCompletionRoutine$26$label_7#1;

  inline$CallCompletionRoutine$26$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$133$Entry#1;

  inline$IoGetCurrentIrpStackLocation$133$Entry#1:
    inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$133$start#1;

  inline$IoGetCurrentIrpStackLocation$133$start#1:
    inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$133$label_3#1;

  inline$IoGetCurrentIrpStackLocation$133$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$133$label_3_true#1, inline$IoGetCurrentIrpStackLocation$133$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$133$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$133$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$133$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$133$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$133$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$133$label_4#1;

  inline$IoGetCurrentIrpStackLocation$133$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$133$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$133$label_6#1;

  inline$IoGetCurrentIrpStackLocation$133$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$133$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$133$label_7#1;

  inline$IoGetCurrentIrpStackLocation$133$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$133$label_5#1;

  inline$IoGetCurrentIrpStackLocation$133$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$133$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$133$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$133$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$133$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$133$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$133$label_5#1;

  inline$IoGetCurrentIrpStackLocation$133$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$133$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$133$label_1#1;

  inline$IoGetCurrentIrpStackLocation$133$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$133$Return#1;

  inline$IoGetCurrentIrpStackLocation$133$Return#1:
    goto inline$CallCompletionRoutine$26$label_7$1#1;

  inline$CallCompletionRoutine$26$label_7$1#1:
    goto inline$CallCompletionRoutine$26$anon10_Then#1, inline$CallCompletionRoutine$26$anon10_Else#1;

  inline$CallCompletionRoutine$26$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$26$anon1#1;

  inline$CallCompletionRoutine$26$anon1#1:
    goto inline$CallCompletionRoutine$26$label_10#1;

  inline$CallCompletionRoutine$26$label_10#1:
    goto inline$CallCompletionRoutine$26$label_11#1;

  inline$CallCompletionRoutine$26$label_11#1:
    havoc inline$CallCompletionRoutine$26$myNondetVar_0;
    inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$26$myNondetVar_0;
    goto inline$CallCompletionRoutine$26$label_12#1;

  inline$CallCompletionRoutine$26$label_12#1:
    havoc inline$CallCompletionRoutine$26$myNondetVar_0;
    inline$CallCompletionRoutine$26$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$26$myNondetVar_0;
    goto inline$CallCompletionRoutine$26$label_13#1;

  inline$CallCompletionRoutine$26$label_13#1:
    havoc inline$CallCompletionRoutine$26$myNondetVar_0;
    goto inline$CallCompletionRoutine$26$label_14#1;

  inline$CallCompletionRoutine$26$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$134$Entry#1;

  inline$IoGetCurrentIrpStackLocation$134$Entry#1:
    inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$134$start#1;

  inline$IoGetCurrentIrpStackLocation$134$start#1:
    inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$134$label_3#1;

  inline$IoGetCurrentIrpStackLocation$134$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$134$label_3_true#1, inline$IoGetCurrentIrpStackLocation$134$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$134$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$134$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$134$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$134$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$134$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$134$label_4#1;

  inline$IoGetCurrentIrpStackLocation$134$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$134$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$134$label_6#1;

  inline$IoGetCurrentIrpStackLocation$134$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$134$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$134$label_7#1;

  inline$IoGetCurrentIrpStackLocation$134$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$134$label_5#1;

  inline$IoGetCurrentIrpStackLocation$134$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$134$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$134$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$134$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$134$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$134$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$134$label_5#1;

  inline$IoGetCurrentIrpStackLocation$134$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$134$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$134$label_1#1;

  inline$IoGetCurrentIrpStackLocation$134$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$134$Return#1;

  inline$IoGetCurrentIrpStackLocation$134$Return#1:
    goto inline$CallCompletionRoutine$26$label_14$1#1;

  inline$CallCompletionRoutine$26$label_14$1#1:
    goto inline$CallCompletionRoutine$26$anon11_Then#1, inline$CallCompletionRoutine$26$anon11_Else#1;

  inline$CallCompletionRoutine$26$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$26$anon3#1;

  inline$CallCompletionRoutine$26$anon3#1:
    goto inline$CallCompletionRoutine$26$label_17#1;

  inline$CallCompletionRoutine$26$label_17#1:
    goto inline$CallCompletionRoutine$26$label_18#1;

  inline$CallCompletionRoutine$26$label_18#1:
    goto inline$CallCompletionRoutine$26$label_18_true#1, inline$CallCompletionRoutine$26$label_18_false#1;

  inline$CallCompletionRoutine$26$label_18_false#1:
    assume inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$26$label_1#1;

  inline$CallCompletionRoutine$26$label_18_true#1:
    assume inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$26$label_19#1;

  inline$CallCompletionRoutine$26$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$26$label_20#1;

  inline$CallCompletionRoutine$26$label_20#1:
    goto inline$CallCompletionRoutine$26$label_20_icall_1#1, inline$CallCompletionRoutine$26$label_20_icall_2#1, inline$CallCompletionRoutine$26$label_20_icall_3#1;

  inline$CallCompletionRoutine$26$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$26$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$26$Entry#1;

  inline$BDLSystemPowerIoCompletion$26$Entry#1:
    inline$BDLSystemPowerIoCompletion$26$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$26$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$26$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$26$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$26$start#1;

  inline$BDLSystemPowerIoCompletion$26$start#1:
    call inline$BDLSystemPowerIoCompletion$26$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$26$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$26$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$26$label_3#1;

  inline$BDLSystemPowerIoCompletion$26$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_4#1;

  inline$BDLSystemPowerIoCompletion$26$label_4#1:
    inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_5#1;

  inline$BDLSystemPowerIoCompletion$26$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_6#1;

  inline$BDLSystemPowerIoCompletion$26$label_6#1:
    inline$BDLSystemPowerIoCompletion$26$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$26$label_7#1;

  inline$BDLSystemPowerIoCompletion$26$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_8#1;

  inline$BDLSystemPowerIoCompletion$26$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$26$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$26$label_9#1;

  inline$BDLSystemPowerIoCompletion$26$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_10#1;

  inline$BDLSystemPowerIoCompletion$26$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$136$Entry#1;

  inline$IoGetCurrentIrpStackLocation$136$Entry#1:
    inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$136$start#1;

  inline$IoGetCurrentIrpStackLocation$136$start#1:
    inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$136$label_3#1;

  inline$IoGetCurrentIrpStackLocation$136$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$136$label_3_true#1, inline$IoGetCurrentIrpStackLocation$136$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$136$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$136$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$136$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$136$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$136$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$136$label_4#1;

  inline$IoGetCurrentIrpStackLocation$136$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$136$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$136$label_6#1;

  inline$IoGetCurrentIrpStackLocation$136$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$136$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$136$label_7#1;

  inline$IoGetCurrentIrpStackLocation$136$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$136$label_5#1;

  inline$IoGetCurrentIrpStackLocation$136$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$136$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$136$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$136$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$136$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$136$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$136$label_5#1;

  inline$IoGetCurrentIrpStackLocation$136$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$136$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$136$label_1#1;

  inline$IoGetCurrentIrpStackLocation$136$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$136$Return#1;

  inline$IoGetCurrentIrpStackLocation$136$Return#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon36_Then#1, inline$BDLSystemPowerIoCompletion$26$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon1#1;

  inline$BDLSystemPowerIoCompletion$26$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_13#1;

  inline$BDLSystemPowerIoCompletion$26$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_14#1;

  inline$BDLSystemPowerIoCompletion$26$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_15#1;

  inline$BDLSystemPowerIoCompletion$26$label_15#1:
    goto inline$BDLGetDebugLevel$697$Entry#1;

  inline$BDLGetDebugLevel$697$Entry#1:
    goto inline$BDLGetDebugLevel$697$start#1;

  inline$BDLGetDebugLevel$697$start#1:
    goto inline$BDLGetDebugLevel$697$label_3#1;

  inline$BDLGetDebugLevel$697$label_3#1:
    havoc inline$BDLGetDebugLevel$697$myNondetVar_0;
    inline$BDLGetDebugLevel$697$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$697$myNondetVar_0;
    goto inline$BDLGetDebugLevel$697$label_1#1;

  inline$BDLGetDebugLevel$697$label_1#1:
    goto inline$BDLGetDebugLevel$697$Return#1;

  inline$BDLGetDebugLevel$697$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$697$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon37_Then#1, inline$BDLSystemPowerIoCompletion$26$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon3#1;

  inline$BDLSystemPowerIoCompletion$26$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_18#1;

  inline$BDLSystemPowerIoCompletion$26$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_18_true#1, inline$BDLSystemPowerIoCompletion$26$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_19#1;

  inline$BDLSystemPowerIoCompletion$26$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_22#1;

  inline$BDLSystemPowerIoCompletion$26$label_22#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_23#1;

  inline$BDLSystemPowerIoCompletion$26$label_23#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_24#1;

  inline$BDLSystemPowerIoCompletion$26$label_24#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_25#1;

  inline$BDLSystemPowerIoCompletion$26$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$26$label_19#1;

  inline$BDLSystemPowerIoCompletion$26$label_19#1:
    goto inline$BDLGetDebugLevel$698$Entry#1;

  inline$BDLGetDebugLevel$698$Entry#1:
    goto inline$BDLGetDebugLevel$698$start#1;

  inline$BDLGetDebugLevel$698$start#1:
    goto inline$BDLGetDebugLevel$698$label_3#1;

  inline$BDLGetDebugLevel$698$label_3#1:
    havoc inline$BDLGetDebugLevel$698$myNondetVar_0;
    inline$BDLGetDebugLevel$698$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$698$myNondetVar_0;
    goto inline$BDLGetDebugLevel$698$label_1#1;

  inline$BDLGetDebugLevel$698$label_1#1:
    goto inline$BDLGetDebugLevel$698$Return#1;

  inline$BDLGetDebugLevel$698$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$698$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon38_Then#1, inline$BDLSystemPowerIoCompletion$26$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon5#1;

  inline$BDLSystemPowerIoCompletion$26$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_28#1;

  inline$BDLSystemPowerIoCompletion$26$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_28_true#1, inline$BDLSystemPowerIoCompletion$26$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_29#1;

  inline$BDLSystemPowerIoCompletion$26$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_32#1;

  inline$BDLSystemPowerIoCompletion$26$label_32#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_33#1;

  inline$BDLSystemPowerIoCompletion$26$label_33#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_34#1;

  inline$BDLSystemPowerIoCompletion$26$label_34#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_35#1;

  inline$BDLSystemPowerIoCompletion$26$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$26$label_29#1;

  inline$BDLSystemPowerIoCompletion$26$label_29#1:
    goto inline$BDLGetDebugLevel$699$Entry#1;

  inline$BDLGetDebugLevel$699$Entry#1:
    goto inline$BDLGetDebugLevel$699$start#1;

  inline$BDLGetDebugLevel$699$start#1:
    goto inline$BDLGetDebugLevel$699$label_3#1;

  inline$BDLGetDebugLevel$699$label_3#1:
    havoc inline$BDLGetDebugLevel$699$myNondetVar_0;
    inline$BDLGetDebugLevel$699$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$699$myNondetVar_0;
    goto inline$BDLGetDebugLevel$699$label_1#1;

  inline$BDLGetDebugLevel$699$label_1#1:
    goto inline$BDLGetDebugLevel$699$Return#1;

  inline$BDLGetDebugLevel$699$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$699$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon39_Then#1, inline$BDLSystemPowerIoCompletion$26$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon7#1;

  inline$BDLSystemPowerIoCompletion$26$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_38#1;

  inline$BDLSystemPowerIoCompletion$26$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_38_true#1, inline$BDLSystemPowerIoCompletion$26$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_39#1;

  inline$BDLSystemPowerIoCompletion$26$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_40#1;

  inline$BDLSystemPowerIoCompletion$26$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_39#1;

  inline$BDLSystemPowerIoCompletion$26$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_39_true#1, inline$BDLSystemPowerIoCompletion$26$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_41#1;

  inline$BDLSystemPowerIoCompletion$26$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$26$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$26$label_107#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$26$label_108#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$26$label_108#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$26$label_108#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$26$label_108#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$26$label_108#1;

  inline$BDLSystemPowerIoCompletion$26$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_109#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$26$label_107#1;

  inline$BDLSystemPowerIoCompletion$26$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_109#1;

  inline$BDLSystemPowerIoCompletion$26$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$26$label_106#1;

  inline$BDLSystemPowerIoCompletion$26$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_106_true#1, inline$BDLSystemPowerIoCompletion$26$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_142#1;

  inline$BDLSystemPowerIoCompletion$26$label_142#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_143#1;

  inline$BDLSystemPowerIoCompletion$26$label_143#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_144#1;

  inline$BDLSystemPowerIoCompletion$26$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_109#1;

  inline$BDLSystemPowerIoCompletion$26$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_109#1;

  inline$BDLSystemPowerIoCompletion$26$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$26$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$26$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$26$myNondetVar_0, inline$BDLSystemPowerIoCompletion$26$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$26$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$26$anon50_Then#1, inline$BDLSystemPowerIoCompletion$26$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon29#1;

  inline$BDLSystemPowerIoCompletion$26$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_112#1;

  inline$BDLSystemPowerIoCompletion$26$label_112#1:
    inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$26$label_113#1;

  inline$BDLSystemPowerIoCompletion$26$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_113_true#1, inline$BDLSystemPowerIoCompletion$26$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$26$label_114#1;

  inline$BDLSystemPowerIoCompletion$26$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_116#1;

  inline$BDLSystemPowerIoCompletion$26$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_117#1;

  inline$BDLSystemPowerIoCompletion$26$label_117#1:
    goto inline$BDLGetDebugLevel$706$Entry#1;

  inline$BDLGetDebugLevel$706$Entry#1:
    goto inline$BDLGetDebugLevel$706$start#1;

  inline$BDLGetDebugLevel$706$start#1:
    goto inline$BDLGetDebugLevel$706$label_3#1;

  inline$BDLGetDebugLevel$706$label_3#1:
    havoc inline$BDLGetDebugLevel$706$myNondetVar_0;
    inline$BDLGetDebugLevel$706$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$706$myNondetVar_0;
    goto inline$BDLGetDebugLevel$706$label_1#1;

  inline$BDLGetDebugLevel$706$label_1#1:
    goto inline$BDLGetDebugLevel$706$Return#1;

  inline$BDLGetDebugLevel$706$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$706$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon51_Then#1, inline$BDLSystemPowerIoCompletion$26$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon31#1;

  inline$BDLSystemPowerIoCompletion$26$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_120#1;

  inline$BDLSystemPowerIoCompletion$26$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_120_true#1, inline$BDLSystemPowerIoCompletion$26$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_121#1;

  inline$BDLSystemPowerIoCompletion$26$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_124#1;

  inline$BDLSystemPowerIoCompletion$26$label_124#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_125#1;

  inline$BDLSystemPowerIoCompletion$26$label_125#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_126#1;

  inline$BDLSystemPowerIoCompletion$26$label_126#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_127#1;

  inline$BDLSystemPowerIoCompletion$26$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$26$label_121#1;

  inline$BDLSystemPowerIoCompletion$26$label_121#1:
    goto inline$BDLGetDebugLevel$707$Entry#1;

  inline$BDLGetDebugLevel$707$Entry#1:
    goto inline$BDLGetDebugLevel$707$start#1;

  inline$BDLGetDebugLevel$707$start#1:
    goto inline$BDLGetDebugLevel$707$label_3#1;

  inline$BDLGetDebugLevel$707$label_3#1:
    havoc inline$BDLGetDebugLevel$707$myNondetVar_0;
    inline$BDLGetDebugLevel$707$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$707$myNondetVar_0;
    goto inline$BDLGetDebugLevel$707$label_1#1;

  inline$BDLGetDebugLevel$707$label_1#1:
    goto inline$BDLGetDebugLevel$707$Return#1;

  inline$BDLGetDebugLevel$707$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$707$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon52_Then#1, inline$BDLSystemPowerIoCompletion$26$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon33#1;

  inline$BDLSystemPowerIoCompletion$26$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_130#1;

  inline$BDLSystemPowerIoCompletion$26$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_130_true#1, inline$BDLSystemPowerIoCompletion$26$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_131#1;

  inline$BDLSystemPowerIoCompletion$26$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_134#1;

  inline$BDLSystemPowerIoCompletion$26$label_134#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_135#1;

  inline$BDLSystemPowerIoCompletion$26$label_135#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_136#1;

  inline$BDLSystemPowerIoCompletion$26$label_136#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_137#1;

  inline$BDLSystemPowerIoCompletion$26$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$26$label_131#1;

  inline$BDLSystemPowerIoCompletion$26$label_131#1:
    goto inline$BDLGetDebugLevel$708$Entry#1;

  inline$BDLGetDebugLevel$708$Entry#1:
    goto inline$BDLGetDebugLevel$708$start#1;

  inline$BDLGetDebugLevel$708$start#1:
    goto inline$BDLGetDebugLevel$708$label_3#1;

  inline$BDLGetDebugLevel$708$label_3#1:
    havoc inline$BDLGetDebugLevel$708$myNondetVar_0;
    inline$BDLGetDebugLevel$708$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$708$myNondetVar_0;
    goto inline$BDLGetDebugLevel$708$label_1#1;

  inline$BDLGetDebugLevel$708$label_1#1:
    goto inline$BDLGetDebugLevel$708$Return#1;

  inline$BDLGetDebugLevel$708$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$708$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon53_Then#1, inline$BDLSystemPowerIoCompletion$26$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon35#1;

  inline$BDLSystemPowerIoCompletion$26$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_140#1;

  inline$BDLSystemPowerIoCompletion$26$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_140_true#1, inline$BDLSystemPowerIoCompletion$26$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_67#1;

  inline$BDLSystemPowerIoCompletion$26$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_141#1;

  inline$BDLSystemPowerIoCompletion$26$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_67#1;

  inline$BDLSystemPowerIoCompletion$26$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$26$label_115#1;

  inline$BDLSystemPowerIoCompletion$26$label_115#1:
    inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$26$label_80#1;

  inline$BDLSystemPowerIoCompletion$26$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$26$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_42#1;

  inline$BDLSystemPowerIoCompletion$26$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$26$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$26$label_43#1;

  inline$BDLSystemPowerIoCompletion$26$label_43#1:
    goto inline$BDLGetDebugLevel$700$Entry#1;

  inline$BDLGetDebugLevel$700$Entry#1:
    goto inline$BDLGetDebugLevel$700$start#1;

  inline$BDLGetDebugLevel$700$start#1:
    goto inline$BDLGetDebugLevel$700$label_3#1;

  inline$BDLGetDebugLevel$700$label_3#1:
    havoc inline$BDLGetDebugLevel$700$myNondetVar_0;
    inline$BDLGetDebugLevel$700$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$700$myNondetVar_0;
    goto inline$BDLGetDebugLevel$700$label_1#1;

  inline$BDLGetDebugLevel$700$label_1#1:
    goto inline$BDLGetDebugLevel$700$Return#1;

  inline$BDLGetDebugLevel$700$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$700$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon40_Then#1, inline$BDLSystemPowerIoCompletion$26$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon9#1;

  inline$BDLSystemPowerIoCompletion$26$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_46#1;

  inline$BDLSystemPowerIoCompletion$26$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_46_true#1, inline$BDLSystemPowerIoCompletion$26$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_47#1;

  inline$BDLSystemPowerIoCompletion$26$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_50#1;

  inline$BDLSystemPowerIoCompletion$26$label_50#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_51#1;

  inline$BDLSystemPowerIoCompletion$26$label_51#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_52#1;

  inline$BDLSystemPowerIoCompletion$26$label_52#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_53#1;

  inline$BDLSystemPowerIoCompletion$26$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$26$label_47#1;

  inline$BDLSystemPowerIoCompletion$26$label_47#1:
    goto inline$BDLGetDebugLevel$701$Entry#1;

  inline$BDLGetDebugLevel$701$Entry#1:
    goto inline$BDLGetDebugLevel$701$start#1;

  inline$BDLGetDebugLevel$701$start#1:
    goto inline$BDLGetDebugLevel$701$label_3#1;

  inline$BDLGetDebugLevel$701$label_3#1:
    havoc inline$BDLGetDebugLevel$701$myNondetVar_0;
    inline$BDLGetDebugLevel$701$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$701$myNondetVar_0;
    goto inline$BDLGetDebugLevel$701$label_1#1;

  inline$BDLGetDebugLevel$701$label_1#1:
    goto inline$BDLGetDebugLevel$701$Return#1;

  inline$BDLGetDebugLevel$701$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$701$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon41_Then#1, inline$BDLSystemPowerIoCompletion$26$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon11#1;

  inline$BDLSystemPowerIoCompletion$26$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_56#1;

  inline$BDLSystemPowerIoCompletion$26$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_56_true#1, inline$BDLSystemPowerIoCompletion$26$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_57#1;

  inline$BDLSystemPowerIoCompletion$26$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_60#1;

  inline$BDLSystemPowerIoCompletion$26$label_60#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_61#1;

  inline$BDLSystemPowerIoCompletion$26$label_61#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_62#1;

  inline$BDLSystemPowerIoCompletion$26$label_62#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_63#1;

  inline$BDLSystemPowerIoCompletion$26$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$26$label_57#1;

  inline$BDLSystemPowerIoCompletion$26$label_57#1:
    goto inline$BDLGetDebugLevel$702$Entry#1;

  inline$BDLGetDebugLevel$702$Entry#1:
    goto inline$BDLGetDebugLevel$702$start#1;

  inline$BDLGetDebugLevel$702$start#1:
    goto inline$BDLGetDebugLevel$702$label_3#1;

  inline$BDLGetDebugLevel$702$label_3#1:
    havoc inline$BDLGetDebugLevel$702$myNondetVar_0;
    inline$BDLGetDebugLevel$702$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$702$myNondetVar_0;
    goto inline$BDLGetDebugLevel$702$label_1#1;

  inline$BDLGetDebugLevel$702$label_1#1:
    goto inline$BDLGetDebugLevel$702$Return#1;

  inline$BDLGetDebugLevel$702$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$702$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon42_Then#1, inline$BDLSystemPowerIoCompletion$26$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon13#1;

  inline$BDLSystemPowerIoCompletion$26$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_66#1;

  inline$BDLSystemPowerIoCompletion$26$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_66_true#1, inline$BDLSystemPowerIoCompletion$26$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_67#1;

  inline$BDLSystemPowerIoCompletion$26$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_70#1;

  inline$BDLSystemPowerIoCompletion$26$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_67#1;

  inline$BDLSystemPowerIoCompletion$26$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$26$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$26$anon43_Then#1, inline$BDLSystemPowerIoCompletion$26$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon15#1;

  inline$BDLSystemPowerIoCompletion$26$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_71#1;

  inline$BDLSystemPowerIoCompletion$26$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$26$anon44_Then#1, inline$BDLSystemPowerIoCompletion$26$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon17#1;

  inline$BDLSystemPowerIoCompletion$26$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_74#1;

  inline$BDLSystemPowerIoCompletion$26$label_74#1:
    goto inline$storm_IoCompleteRequest$54$Entry#1;

  inline$storm_IoCompleteRequest$54$Entry#1:
    inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$26$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$54$start#1;

  inline$storm_IoCompleteRequest$54$start#1:
    inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$54$label_3#1;

  inline$storm_IoCompleteRequest$54$label_3#1:
    call inline$storm_IoCompleteRequest$54$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$54$label_6#1;

  inline$storm_IoCompleteRequest$54$label_6#1:
    goto inline$storm_IoCompleteRequest$54$label_6_true#1, inline$storm_IoCompleteRequest$54$label_6_false#1;

  inline$storm_IoCompleteRequest$54$label_6_false#1:
    assume inline$storm_IoCompleteRequest$54$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$54$label_7#1;

  inline$storm_IoCompleteRequest$54$label_6_true#1:
    assume inline$storm_IoCompleteRequest$54$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$54$label_8#1;

  inline$storm_IoCompleteRequest$54$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$54$anon3_Then#1, inline$storm_IoCompleteRequest$54$anon3_Else#1;

  inline$storm_IoCompleteRequest$54$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$54$anon1#1;

  inline$storm_IoCompleteRequest$54$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$54$label_9#1;

  inline$storm_IoCompleteRequest$54$label_9#1:
    goto inline$storm_IoCompleteRequest$54$label_9_true#1, inline$storm_IoCompleteRequest$54$label_9_false#1;

  inline$storm_IoCompleteRequest$54$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$54$label_10#1;

  inline$storm_IoCompleteRequest$54$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$54$label_1#1;

  inline$storm_IoCompleteRequest$54$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$54$label_7#1;

  inline$storm_IoCompleteRequest$54$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$54$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$54$label_1#1;

  inline$storm_IoCompleteRequest$54$label_1#1:
    goto inline$storm_IoCompleteRequest$54$Return#1;

  inline$storm_IoCompleteRequest$54$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$54$Return#1;

  inline$storm_IoCompleteRequest$54$Return#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon45_Then#1, inline$BDLSystemPowerIoCompletion$26$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon19#1;

  inline$BDLSystemPowerIoCompletion$26$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_77#1;

  inline$BDLSystemPowerIoCompletion$26$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$26$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$26$anon46_Then#1, inline$BDLSystemPowerIoCompletion$26$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon21#1;

  inline$BDLSystemPowerIoCompletion$26$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_80#1;

  inline$BDLSystemPowerIoCompletion$26$label_80#1:
    goto inline$BDLGetDebugLevel$703$Entry#1;

  inline$BDLGetDebugLevel$703$Entry#1:
    goto inline$BDLGetDebugLevel$703$start#1;

  inline$BDLGetDebugLevel$703$start#1:
    goto inline$BDLGetDebugLevel$703$label_3#1;

  inline$BDLGetDebugLevel$703$label_3#1:
    havoc inline$BDLGetDebugLevel$703$myNondetVar_0;
    inline$BDLGetDebugLevel$703$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$703$myNondetVar_0;
    goto inline$BDLGetDebugLevel$703$label_1#1;

  inline$BDLGetDebugLevel$703$label_1#1:
    goto inline$BDLGetDebugLevel$703$Return#1;

  inline$BDLGetDebugLevel$703$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$703$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon47_Then#1, inline$BDLSystemPowerIoCompletion$26$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon23#1;

  inline$BDLSystemPowerIoCompletion$26$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_83#1;

  inline$BDLSystemPowerIoCompletion$26$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_83_true#1, inline$BDLSystemPowerIoCompletion$26$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_84#1;

  inline$BDLSystemPowerIoCompletion$26$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_87#1;

  inline$BDLSystemPowerIoCompletion$26$label_87#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_88#1;

  inline$BDLSystemPowerIoCompletion$26$label_88#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_89#1;

  inline$BDLSystemPowerIoCompletion$26$label_89#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_90#1;

  inline$BDLSystemPowerIoCompletion$26$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$26$label_84#1;

  inline$BDLSystemPowerIoCompletion$26$label_84#1:
    goto inline$BDLGetDebugLevel$704$Entry#1;

  inline$BDLGetDebugLevel$704$Entry#1:
    goto inline$BDLGetDebugLevel$704$start#1;

  inline$BDLGetDebugLevel$704$start#1:
    goto inline$BDLGetDebugLevel$704$label_3#1;

  inline$BDLGetDebugLevel$704$label_3#1:
    havoc inline$BDLGetDebugLevel$704$myNondetVar_0;
    inline$BDLGetDebugLevel$704$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$704$myNondetVar_0;
    goto inline$BDLGetDebugLevel$704$label_1#1;

  inline$BDLGetDebugLevel$704$label_1#1:
    goto inline$BDLGetDebugLevel$704$Return#1;

  inline$BDLGetDebugLevel$704$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$704$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon48_Then#1, inline$BDLSystemPowerIoCompletion$26$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon25#1;

  inline$BDLSystemPowerIoCompletion$26$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_93#1;

  inline$BDLSystemPowerIoCompletion$26$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_93_true#1, inline$BDLSystemPowerIoCompletion$26$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_94#1;

  inline$BDLSystemPowerIoCompletion$26$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_97#1;

  inline$BDLSystemPowerIoCompletion$26$label_97#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_98#1;

  inline$BDLSystemPowerIoCompletion$26$label_98#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_99#1;

  inline$BDLSystemPowerIoCompletion$26$label_99#1:
    call inline$BDLSystemPowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$26$label_100#1;

  inline$BDLSystemPowerIoCompletion$26$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$26$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$26$label_94#1;

  inline$BDLSystemPowerIoCompletion$26$label_94#1:
    goto inline$BDLGetDebugLevel$705$Entry#1;

  inline$BDLGetDebugLevel$705$Entry#1:
    goto inline$BDLGetDebugLevel$705$start#1;

  inline$BDLGetDebugLevel$705$start#1:
    goto inline$BDLGetDebugLevel$705$label_3#1;

  inline$BDLGetDebugLevel$705$label_3#1:
    havoc inline$BDLGetDebugLevel$705$myNondetVar_0;
    inline$BDLGetDebugLevel$705$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$705$myNondetVar_0;
    goto inline$BDLGetDebugLevel$705$label_1#1;

  inline$BDLGetDebugLevel$705$label_1#1:
    goto inline$BDLGetDebugLevel$705$Return#1;

  inline$BDLGetDebugLevel$705$Return#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$705$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$26$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$26$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$26$anon49_Then#1, inline$BDLSystemPowerIoCompletion$26$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$26$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$anon27#1;

  inline$BDLSystemPowerIoCompletion$26$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_103#1;

  inline$BDLSystemPowerIoCompletion$26$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_103_true#1, inline$BDLSystemPowerIoCompletion$26$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$26$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_104#1;

  inline$BDLSystemPowerIoCompletion$26$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$26$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$26$label_105#1;

  inline$BDLSystemPowerIoCompletion$26$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$26$label_104#1;

  inline$BDLSystemPowerIoCompletion$26$label_104#1:
    inline$BDLSystemPowerIoCompletion$26$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$26$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$26$label_1#1;

  inline$BDLSystemPowerIoCompletion$26$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$26$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$26$Return#1;

  inline$BDLSystemPowerIoCompletion$26$Return#1:
    inline$CallCompletionRoutine$26$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$26$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$26$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$26$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$26$anon14_Then#1, inline$CallCompletionRoutine$26$anon14_Else#1;

  inline$CallCompletionRoutine$26$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$26$anon9#1;

  inline$CallCompletionRoutine$26$anon9#1:
    goto inline$CallCompletionRoutine$26$label_20_icall_return#1;

  inline$CallCompletionRoutine$26$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$26$Return#1;

  inline$CallCompletionRoutine$26$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$26$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$26$Entry#1;

  inline$BDLDevicePowerIoCompletion$26$Entry#1:
    inline$BDLDevicePowerIoCompletion$26$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$26$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$26$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$26$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$26$start#1;

  inline$BDLDevicePowerIoCompletion$26$start#1:
    call inline$BDLDevicePowerIoCompletion$26$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$26$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$26$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$26$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$26$label_3#1;

  inline$BDLDevicePowerIoCompletion$26$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_4#1;

  inline$BDLDevicePowerIoCompletion$26$label_4#1:
    inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_5#1;

  inline$BDLDevicePowerIoCompletion$26$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_6#1;

  inline$BDLDevicePowerIoCompletion$26$label_6#1:
    inline$BDLDevicePowerIoCompletion$26$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$26$label_7#1;

  inline$BDLDevicePowerIoCompletion$26$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_8#1;

  inline$BDLDevicePowerIoCompletion$26$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$26$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$26$label_9#1;

  inline$BDLDevicePowerIoCompletion$26$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_10#1;

  inline$BDLDevicePowerIoCompletion$26$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$135$Entry#1;

  inline$IoGetCurrentIrpStackLocation$135$Entry#1:
    inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$135$start#1;

  inline$IoGetCurrentIrpStackLocation$135$start#1:
    inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$135$label_3#1;

  inline$IoGetCurrentIrpStackLocation$135$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$135$label_3_true#1, inline$IoGetCurrentIrpStackLocation$135$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$135$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$135$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$135$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$135$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$135$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$135$label_4#1;

  inline$IoGetCurrentIrpStackLocation$135$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$135$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$135$label_6#1;

  inline$IoGetCurrentIrpStackLocation$135$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$135$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$135$label_7#1;

  inline$IoGetCurrentIrpStackLocation$135$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$135$label_5#1;

  inline$IoGetCurrentIrpStackLocation$135$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$135$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$135$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$135$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$135$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$135$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$135$label_5#1;

  inline$IoGetCurrentIrpStackLocation$135$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$135$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$135$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$135$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$135$label_1#1;

  inline$IoGetCurrentIrpStackLocation$135$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$135$Return#1;

  inline$IoGetCurrentIrpStackLocation$135$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$135$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon30_Then#1, inline$BDLDevicePowerIoCompletion$26$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon1#1;

  inline$BDLDevicePowerIoCompletion$26$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_13#1;

  inline$BDLDevicePowerIoCompletion$26$label_13#1:
    inline$BDLDevicePowerIoCompletion$26$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$26$label_14#1;

  inline$BDLDevicePowerIoCompletion$26$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_15#1;

  inline$BDLDevicePowerIoCompletion$26$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$26$label_16#1;

  inline$BDLDevicePowerIoCompletion$26$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_17#1;

  inline$BDLDevicePowerIoCompletion$26$label_17#1:
    goto inline$BDLGetDebugLevel$688$Entry#1;

  inline$BDLGetDebugLevel$688$Entry#1:
    goto inline$BDLGetDebugLevel$688$start#1;

  inline$BDLGetDebugLevel$688$start#1:
    goto inline$BDLGetDebugLevel$688$label_3#1;

  inline$BDLGetDebugLevel$688$label_3#1:
    havoc inline$BDLGetDebugLevel$688$myNondetVar_0;
    inline$BDLGetDebugLevel$688$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$688$myNondetVar_0;
    goto inline$BDLGetDebugLevel$688$label_1#1;

  inline$BDLGetDebugLevel$688$label_1#1:
    goto inline$BDLGetDebugLevel$688$Return#1;

  inline$BDLGetDebugLevel$688$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$688$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon31_Then#1, inline$BDLDevicePowerIoCompletion$26$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon3#1;

  inline$BDLDevicePowerIoCompletion$26$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_20#1;

  inline$BDLDevicePowerIoCompletion$26$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_20_true#1, inline$BDLDevicePowerIoCompletion$26$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_21#1;

  inline$BDLDevicePowerIoCompletion$26$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_24#1;

  inline$BDLDevicePowerIoCompletion$26$label_24#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_25#1;

  inline$BDLDevicePowerIoCompletion$26$label_25#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_26#1;

  inline$BDLDevicePowerIoCompletion$26$label_26#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_27#1;

  inline$BDLDevicePowerIoCompletion$26$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$26$label_21#1;

  inline$BDLDevicePowerIoCompletion$26$label_21#1:
    goto inline$BDLGetDebugLevel$689$Entry#1;

  inline$BDLGetDebugLevel$689$Entry#1:
    goto inline$BDLGetDebugLevel$689$start#1;

  inline$BDLGetDebugLevel$689$start#1:
    goto inline$BDLGetDebugLevel$689$label_3#1;

  inline$BDLGetDebugLevel$689$label_3#1:
    havoc inline$BDLGetDebugLevel$689$myNondetVar_0;
    inline$BDLGetDebugLevel$689$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$689$myNondetVar_0;
    goto inline$BDLGetDebugLevel$689$label_1#1;

  inline$BDLGetDebugLevel$689$label_1#1:
    goto inline$BDLGetDebugLevel$689$Return#1;

  inline$BDLGetDebugLevel$689$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$689$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon32_Then#1, inline$BDLDevicePowerIoCompletion$26$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon5#1;

  inline$BDLDevicePowerIoCompletion$26$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_30#1;

  inline$BDLDevicePowerIoCompletion$26$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_30_true#1, inline$BDLDevicePowerIoCompletion$26$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_31#1;

  inline$BDLDevicePowerIoCompletion$26$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_34#1;

  inline$BDLDevicePowerIoCompletion$26$label_34#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_35#1;

  inline$BDLDevicePowerIoCompletion$26$label_35#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_36#1;

  inline$BDLDevicePowerIoCompletion$26$label_36#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_37#1;

  inline$BDLDevicePowerIoCompletion$26$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$26$label_31#1;

  inline$BDLDevicePowerIoCompletion$26$label_31#1:
    goto inline$BDLGetDebugLevel$690$Entry#1;

  inline$BDLGetDebugLevel$690$Entry#1:
    goto inline$BDLGetDebugLevel$690$start#1;

  inline$BDLGetDebugLevel$690$start#1:
    goto inline$BDLGetDebugLevel$690$label_3#1;

  inline$BDLGetDebugLevel$690$label_3#1:
    havoc inline$BDLGetDebugLevel$690$myNondetVar_0;
    inline$BDLGetDebugLevel$690$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$690$myNondetVar_0;
    goto inline$BDLGetDebugLevel$690$label_1#1;

  inline$BDLGetDebugLevel$690$label_1#1:
    goto inline$BDLGetDebugLevel$690$Return#1;

  inline$BDLGetDebugLevel$690$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$690$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon33_Then#1, inline$BDLDevicePowerIoCompletion$26$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon7#1;

  inline$BDLDevicePowerIoCompletion$26$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_40#1;

  inline$BDLDevicePowerIoCompletion$26$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_40_true#1, inline$BDLDevicePowerIoCompletion$26$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_41#1;

  inline$BDLDevicePowerIoCompletion$26$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_42#1;

  inline$BDLDevicePowerIoCompletion$26$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_41#1;

  inline$BDLDevicePowerIoCompletion$26$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_41_true#1, inline$BDLDevicePowerIoCompletion$26$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$26$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$26$label_43#1;

  inline$BDLDevicePowerIoCompletion$26$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$26$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$26$label_44#1;

  inline$BDLDevicePowerIoCompletion$26$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_44_true#1, inline$BDLDevicePowerIoCompletion$26$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$26$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$26$label_45#1;

  inline$BDLDevicePowerIoCompletion$26$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_45_true#1, inline$BDLDevicePowerIoCompletion$26$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$26$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$26$label_43#1;

  inline$BDLDevicePowerIoCompletion$26$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$26$label_86#1;

  inline$BDLDevicePowerIoCompletion$26$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$26$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$26$label_46#1;

  inline$BDLDevicePowerIoCompletion$26$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$26$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$26$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$26$label_46#1;

  inline$BDLDevicePowerIoCompletion$26$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$26$label_49#1;

  inline$BDLDevicePowerIoCompletion$26$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_50#1;

  inline$BDLDevicePowerIoCompletion$26$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_51#1;

  inline$BDLDevicePowerIoCompletion$26$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_54#1;

  inline$BDLDevicePowerIoCompletion$26$label_54#1:
    inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$26$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$26$label_55#1;

  inline$BDLDevicePowerIoCompletion$26$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_55_true#1, inline$BDLDevicePowerIoCompletion$26$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_56#1;

  inline$BDLDevicePowerIoCompletion$26$label_56#1:
    call inline$BDLDevicePowerIoCompletion$26$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$26$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$26$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$26$anon34_Then#1, inline$BDLDevicePowerIoCompletion$26$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon9#1;

  inline$BDLDevicePowerIoCompletion$26$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_83#1;

  inline$BDLDevicePowerIoCompletion$26$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_59#1;

  inline$BDLDevicePowerIoCompletion$26$label_59#1:
    goto inline$BDLGetDebugLevel$691$Entry#1;

  inline$BDLGetDebugLevel$691$Entry#1:
    goto inline$BDLGetDebugLevel$691$start#1;

  inline$BDLGetDebugLevel$691$start#1:
    goto inline$BDLGetDebugLevel$691$label_3#1;

  inline$BDLGetDebugLevel$691$label_3#1:
    havoc inline$BDLGetDebugLevel$691$myNondetVar_0;
    inline$BDLGetDebugLevel$691$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$691$myNondetVar_0;
    goto inline$BDLGetDebugLevel$691$label_1#1;

  inline$BDLGetDebugLevel$691$label_1#1:
    goto inline$BDLGetDebugLevel$691$Return#1;

  inline$BDLGetDebugLevel$691$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$691$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon35_Then#1, inline$BDLDevicePowerIoCompletion$26$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon11#1;

  inline$BDLDevicePowerIoCompletion$26$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_62#1;

  inline$BDLDevicePowerIoCompletion$26$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_62_true#1, inline$BDLDevicePowerIoCompletion$26$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_63#1;

  inline$BDLDevicePowerIoCompletion$26$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_66#1;

  inline$BDLDevicePowerIoCompletion$26$label_66#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_67#1;

  inline$BDLDevicePowerIoCompletion$26$label_67#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_68#1;

  inline$BDLDevicePowerIoCompletion$26$label_68#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_69#1;

  inline$BDLDevicePowerIoCompletion$26$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$26$label_63#1;

  inline$BDLDevicePowerIoCompletion$26$label_63#1:
    goto inline$BDLGetDebugLevel$692$Entry#1;

  inline$BDLGetDebugLevel$692$Entry#1:
    goto inline$BDLGetDebugLevel$692$start#1;

  inline$BDLGetDebugLevel$692$start#1:
    goto inline$BDLGetDebugLevel$692$label_3#1;

  inline$BDLGetDebugLevel$692$label_3#1:
    havoc inline$BDLGetDebugLevel$692$myNondetVar_0;
    inline$BDLGetDebugLevel$692$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$692$myNondetVar_0;
    goto inline$BDLGetDebugLevel$692$label_1#1;

  inline$BDLGetDebugLevel$692$label_1#1:
    goto inline$BDLGetDebugLevel$692$Return#1;

  inline$BDLGetDebugLevel$692$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$692$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon36_Then#1, inline$BDLDevicePowerIoCompletion$26$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon13#1;

  inline$BDLDevicePowerIoCompletion$26$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_72#1;

  inline$BDLDevicePowerIoCompletion$26$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_72_true#1, inline$BDLDevicePowerIoCompletion$26$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_73#1;

  inline$BDLDevicePowerIoCompletion$26$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_76#1;

  inline$BDLDevicePowerIoCompletion$26$label_76#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_77#1;

  inline$BDLDevicePowerIoCompletion$26$label_77#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_78#1;

  inline$BDLDevicePowerIoCompletion$26$label_78#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_79#1;

  inline$BDLDevicePowerIoCompletion$26$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$26$label_73#1;

  inline$BDLDevicePowerIoCompletion$26$label_73#1:
    goto inline$BDLGetDebugLevel$693$Entry#1;

  inline$BDLGetDebugLevel$693$Entry#1:
    goto inline$BDLGetDebugLevel$693$start#1;

  inline$BDLGetDebugLevel$693$start#1:
    goto inline$BDLGetDebugLevel$693$label_3#1;

  inline$BDLGetDebugLevel$693$label_3#1:
    havoc inline$BDLGetDebugLevel$693$myNondetVar_0;
    inline$BDLGetDebugLevel$693$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$693$myNondetVar_0;
    goto inline$BDLGetDebugLevel$693$label_1#1;

  inline$BDLGetDebugLevel$693$label_1#1:
    goto inline$BDLGetDebugLevel$693$Return#1;

  inline$BDLGetDebugLevel$693$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$693$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon37_Then#1, inline$BDLDevicePowerIoCompletion$26$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon15#1;

  inline$BDLDevicePowerIoCompletion$26$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_82#1;

  inline$BDLDevicePowerIoCompletion$26$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_82_true#1, inline$BDLDevicePowerIoCompletion$26$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_83#1;

  inline$BDLDevicePowerIoCompletion$26$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_84#1;

  inline$BDLDevicePowerIoCompletion$26$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_83#1;

  inline$BDLDevicePowerIoCompletion$26$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_85#1;

  inline$BDLDevicePowerIoCompletion$26$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_86#1;

  inline$BDLDevicePowerIoCompletion$26$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$26$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$26$anon38_Then#1, inline$BDLDevicePowerIoCompletion$26$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon17#1;

  inline$BDLDevicePowerIoCompletion$26$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_89#1;

  inline$BDLDevicePowerIoCompletion$26$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$26$anon39_Then#1, inline$BDLDevicePowerIoCompletion$26$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon19#1;

  inline$BDLDevicePowerIoCompletion$26$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_92#1;

  inline$BDLDevicePowerIoCompletion$26$label_92#1:
    goto inline$storm_IoCompleteRequest$53$Entry#1;

  inline$storm_IoCompleteRequest$53$Entry#1:
    inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$26$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$53$start#1;

  inline$storm_IoCompleteRequest$53$start#1:
    inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$53$label_3#1;

  inline$storm_IoCompleteRequest$53$label_3#1:
    call inline$storm_IoCompleteRequest$53$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$53$label_6#1;

  inline$storm_IoCompleteRequest$53$label_6#1:
    goto inline$storm_IoCompleteRequest$53$label_6_true#1, inline$storm_IoCompleteRequest$53$label_6_false#1;

  inline$storm_IoCompleteRequest$53$label_6_false#1:
    assume inline$storm_IoCompleteRequest$53$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$53$label_7#1;

  inline$storm_IoCompleteRequest$53$label_6_true#1:
    assume inline$storm_IoCompleteRequest$53$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$53$label_8#1;

  inline$storm_IoCompleteRequest$53$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$53$anon3_Then#1, inline$storm_IoCompleteRequest$53$anon3_Else#1;

  inline$storm_IoCompleteRequest$53$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$53$anon1#1;

  inline$storm_IoCompleteRequest$53$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$53$label_9#1;

  inline$storm_IoCompleteRequest$53$label_9#1:
    goto inline$storm_IoCompleteRequest$53$label_9_true#1, inline$storm_IoCompleteRequest$53$label_9_false#1;

  inline$storm_IoCompleteRequest$53$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$53$label_10#1;

  inline$storm_IoCompleteRequest$53$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$53$label_1#1;

  inline$storm_IoCompleteRequest$53$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$53$label_7#1;

  inline$storm_IoCompleteRequest$53$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$53$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$53$label_1#1;

  inline$storm_IoCompleteRequest$53$label_1#1:
    goto inline$storm_IoCompleteRequest$53$Return#1;

  inline$storm_IoCompleteRequest$53$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$53$Return#1;

  inline$storm_IoCompleteRequest$53$Return#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon40_Then#1, inline$BDLDevicePowerIoCompletion$26$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon21#1;

  inline$BDLDevicePowerIoCompletion$26$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_95#1;

  inline$BDLDevicePowerIoCompletion$26$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$26$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$26$anon41_Then#1, inline$BDLDevicePowerIoCompletion$26$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon23#1;

  inline$BDLDevicePowerIoCompletion$26$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_98#1;

  inline$BDLDevicePowerIoCompletion$26$label_98#1:
    goto inline$BDLGetDebugLevel$694$Entry#1;

  inline$BDLGetDebugLevel$694$Entry#1:
    goto inline$BDLGetDebugLevel$694$start#1;

  inline$BDLGetDebugLevel$694$start#1:
    goto inline$BDLGetDebugLevel$694$label_3#1;

  inline$BDLGetDebugLevel$694$label_3#1:
    havoc inline$BDLGetDebugLevel$694$myNondetVar_0;
    inline$BDLGetDebugLevel$694$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$694$myNondetVar_0;
    goto inline$BDLGetDebugLevel$694$label_1#1;

  inline$BDLGetDebugLevel$694$label_1#1:
    goto inline$BDLGetDebugLevel$694$Return#1;

  inline$BDLGetDebugLevel$694$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$694$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon42_Then#1, inline$BDLDevicePowerIoCompletion$26$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon25#1;

  inline$BDLDevicePowerIoCompletion$26$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_101#1;

  inline$BDLDevicePowerIoCompletion$26$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_101_true#1, inline$BDLDevicePowerIoCompletion$26$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_102#1;

  inline$BDLDevicePowerIoCompletion$26$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_105#1;

  inline$BDLDevicePowerIoCompletion$26$label_105#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_106#1;

  inline$BDLDevicePowerIoCompletion$26$label_106#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_107#1;

  inline$BDLDevicePowerIoCompletion$26$label_107#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_108#1;

  inline$BDLDevicePowerIoCompletion$26$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$26$label_102#1;

  inline$BDLDevicePowerIoCompletion$26$label_102#1:
    goto inline$BDLGetDebugLevel$695$Entry#1;

  inline$BDLGetDebugLevel$695$Entry#1:
    goto inline$BDLGetDebugLevel$695$start#1;

  inline$BDLGetDebugLevel$695$start#1:
    goto inline$BDLGetDebugLevel$695$label_3#1;

  inline$BDLGetDebugLevel$695$label_3#1:
    havoc inline$BDLGetDebugLevel$695$myNondetVar_0;
    inline$BDLGetDebugLevel$695$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$695$myNondetVar_0;
    goto inline$BDLGetDebugLevel$695$label_1#1;

  inline$BDLGetDebugLevel$695$label_1#1:
    goto inline$BDLGetDebugLevel$695$Return#1;

  inline$BDLGetDebugLevel$695$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$695$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon43_Then#1, inline$BDLDevicePowerIoCompletion$26$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon27#1;

  inline$BDLDevicePowerIoCompletion$26$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_111#1;

  inline$BDLDevicePowerIoCompletion$26$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_111_true#1, inline$BDLDevicePowerIoCompletion$26$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_112#1;

  inline$BDLDevicePowerIoCompletion$26$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_115#1;

  inline$BDLDevicePowerIoCompletion$26$label_115#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_116#1;

  inline$BDLDevicePowerIoCompletion$26$label_116#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_117#1;

  inline$BDLDevicePowerIoCompletion$26$label_117#1:
    call inline$BDLDevicePowerIoCompletion$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$26$label_118#1;

  inline$BDLDevicePowerIoCompletion$26$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$26$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$26$label_112#1;

  inline$BDLDevicePowerIoCompletion$26$label_112#1:
    goto inline$BDLGetDebugLevel$696$Entry#1;

  inline$BDLGetDebugLevel$696$Entry#1:
    goto inline$BDLGetDebugLevel$696$start#1;

  inline$BDLGetDebugLevel$696$start#1:
    goto inline$BDLGetDebugLevel$696$label_3#1;

  inline$BDLGetDebugLevel$696$label_3#1:
    havoc inline$BDLGetDebugLevel$696$myNondetVar_0;
    inline$BDLGetDebugLevel$696$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$696$myNondetVar_0;
    goto inline$BDLGetDebugLevel$696$label_1#1;

  inline$BDLGetDebugLevel$696$label_1#1:
    goto inline$BDLGetDebugLevel$696$Return#1;

  inline$BDLGetDebugLevel$696$Return#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$696$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$26$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$26$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$26$anon44_Then#1, inline$BDLDevicePowerIoCompletion$26$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$26$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$anon29#1;

  inline$BDLDevicePowerIoCompletion$26$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_121#1;

  inline$BDLDevicePowerIoCompletion$26$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_121_true#1, inline$BDLDevicePowerIoCompletion$26$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$26$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_122#1;

  inline$BDLDevicePowerIoCompletion$26$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$26$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$26$label_123#1;

  inline$BDLDevicePowerIoCompletion$26$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$26$label_122#1;

  inline$BDLDevicePowerIoCompletion$26$label_122#1:
    inline$BDLDevicePowerIoCompletion$26$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$26$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$26$label_1#1;

  inline$BDLDevicePowerIoCompletion$26$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$26$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$26$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$26$Return#1;

  inline$BDLDevicePowerIoCompletion$26$Return#1:
    inline$CallCompletionRoutine$26$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$26$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$26$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$26$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$26$anon13_Then#1, inline$CallCompletionRoutine$26$anon13_Else#1;

  inline$CallCompletionRoutine$26$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$26$anon7#1;

  inline$CallCompletionRoutine$26$anon7#1:
    goto inline$CallCompletionRoutine$26$label_20_icall_return#1;

  inline$CallCompletionRoutine$26$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$26$Return#1;

  inline$CallCompletionRoutine$26$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$26$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$26$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$26$Entry#1;

  inline$BDLCallDriverCompletionRoutine$26$Entry#1:
    inline$BDLCallDriverCompletionRoutine$26$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$26$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$26$start#1;

  inline$BDLCallDriverCompletionRoutine$26$start#1:
    inline$BDLCallDriverCompletionRoutine$26$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$26$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$26$label_3#1;

  inline$BDLCallDriverCompletionRoutine$26$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$26$label_3_true#1, inline$BDLCallDriverCompletionRoutine$26$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$26$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$26$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$26$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$26$label_4#1;

  inline$BDLCallDriverCompletionRoutine$26$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$26$label_6#1;

  inline$BDLCallDriverCompletionRoutine$26$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$26$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$26$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$26$label_5#1;

  inline$BDLCallDriverCompletionRoutine$26$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$26$label_6#1;

  inline$BDLCallDriverCompletionRoutine$26$label_6#1:
    goto inline$storm_KeSetEvent$30$Entry#1;

  inline$storm_KeSetEvent$30$Entry#1:
    inline$storm_KeSetEvent$30$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$26$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$30$start#1;

  inline$storm_KeSetEvent$30$start#1:
    inline$storm_KeSetEvent$30$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$30$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$30$label_3#1;

  inline$storm_KeSetEvent$30$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$30$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$30$label_1#1;

  inline$storm_KeSetEvent$30$label_1#1:
    goto inline$storm_KeSetEvent$30$Return#1;

  inline$storm_KeSetEvent$30$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$26$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$26$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$26$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$26$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$26$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$26$anon1#1;

  inline$BDLCallDriverCompletionRoutine$26$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$26$label_9#1;

  inline$BDLCallDriverCompletionRoutine$26$label_9#1:
    inline$BDLCallDriverCompletionRoutine$26$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$26$label_1#1;

  inline$BDLCallDriverCompletionRoutine$26$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$26$Return#1;

  inline$BDLCallDriverCompletionRoutine$26$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$26$Return#1;

  inline$BDLCallDriverCompletionRoutine$26$Return#1:
    inline$CallCompletionRoutine$26$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$26$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$26$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$26$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$26$anon12_Then#1, inline$CallCompletionRoutine$26$anon12_Else#1;

  inline$CallCompletionRoutine$26$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$26$anon5#1;

  inline$CallCompletionRoutine$26$anon5#1:
    goto inline$CallCompletionRoutine$26$label_20_icall_return#1;

  inline$CallCompletionRoutine$26$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$26$label_23#1;

  inline$CallCompletionRoutine$26$label_23#1:
    inline$CallCompletionRoutine$26$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$26$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$26$label_24#1;

  inline$CallCompletionRoutine$26$label_24#1:
    goto inline$CallCompletionRoutine$26$label_24_true#1, inline$CallCompletionRoutine$26$label_24_false#1;

  inline$CallCompletionRoutine$26$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$26$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$26$label_1#1;

  inline$CallCompletionRoutine$26$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$26$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$26$label_25#1;

  inline$CallCompletionRoutine$26$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$26$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$26$label_1#1;

  inline$CallCompletionRoutine$26$label_1#1:
    goto inline$CallCompletionRoutine$26$Return#1;

  inline$CallCompletionRoutine$26$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$26$Return#1;

  inline$CallCompletionRoutine$26$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$26$Return#1;

  inline$CallCompletionRoutine$26$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$26$Return#1;

  inline$CallCompletionRoutine$26$Return#1:
    goto inline$storm_IoCallDriver$13$label_33$1#1;

  inline$storm_IoCallDriver$13$label_33$1#1:
    goto inline$storm_IoCallDriver$13$anon14_Then#1, inline$storm_IoCallDriver$13$anon14_Else#1;

  inline$storm_IoCallDriver$13$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$13$anon8#1;

  inline$storm_IoCallDriver$13$anon8#1:
    goto inline$storm_IoCallDriver$13$label_36#1;

  inline$storm_IoCallDriver$13$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$13$Return#1;

  inline$storm_IoCallDriver$13$label_27_case_1#1:
    assume inline$storm_IoCallDriver$13$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$13$label_29#1;

  inline$storm_IoCallDriver$13$label_29#1:
    inline$storm_IoCallDriver$13$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$13$label_37#1;

  inline$storm_IoCallDriver$13$label_37#1:
    goto inline$storm_IoCallDriver$13$label_38#1;

  inline$storm_IoCallDriver$13$label_38#1:
    goto inline$storm_IoCallDriver$13$label_39#1;

  inline$storm_IoCallDriver$13$label_39#1:
    goto inline$CallCompletionRoutine$27$Entry#1;

  inline$CallCompletionRoutine$27$Entry#1:
    inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$27$start#1;

  inline$CallCompletionRoutine$27$start#1:
    inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$27$label_3#1;

  inline$CallCompletionRoutine$27$label_3#1:
    goto inline$CallCompletionRoutine$27$label_4#1;

  inline$CallCompletionRoutine$27$label_4#1:
    goto inline$CallCompletionRoutine$27$label_5#1;

  inline$CallCompletionRoutine$27$label_5#1:
    goto inline$CallCompletionRoutine$27$label_6#1;

  inline$CallCompletionRoutine$27$label_6#1:
    goto inline$CallCompletionRoutine$27$label_7#1;

  inline$CallCompletionRoutine$27$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$137$Entry#1;

  inline$IoGetCurrentIrpStackLocation$137$Entry#1:
    inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$137$start#1;

  inline$IoGetCurrentIrpStackLocation$137$start#1:
    inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$137$label_3#1;

  inline$IoGetCurrentIrpStackLocation$137$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$137$label_3_true#1, inline$IoGetCurrentIrpStackLocation$137$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$137$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$137$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$137$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$137$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$137$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$137$label_4#1;

  inline$IoGetCurrentIrpStackLocation$137$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$137$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$137$label_6#1;

  inline$IoGetCurrentIrpStackLocation$137$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$137$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$137$label_7#1;

  inline$IoGetCurrentIrpStackLocation$137$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$137$label_5#1;

  inline$IoGetCurrentIrpStackLocation$137$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$137$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$137$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$137$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$137$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$137$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$137$label_5#1;

  inline$IoGetCurrentIrpStackLocation$137$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$137$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$137$label_1#1;

  inline$IoGetCurrentIrpStackLocation$137$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$137$Return#1;

  inline$IoGetCurrentIrpStackLocation$137$Return#1:
    goto inline$CallCompletionRoutine$27$label_7$1#1;

  inline$CallCompletionRoutine$27$label_7$1#1:
    goto inline$CallCompletionRoutine$27$anon10_Then#1, inline$CallCompletionRoutine$27$anon10_Else#1;

  inline$CallCompletionRoutine$27$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$27$anon1#1;

  inline$CallCompletionRoutine$27$anon1#1:
    goto inline$CallCompletionRoutine$27$label_10#1;

  inline$CallCompletionRoutine$27$label_10#1:
    goto inline$CallCompletionRoutine$27$label_11#1;

  inline$CallCompletionRoutine$27$label_11#1:
    havoc inline$CallCompletionRoutine$27$myNondetVar_0;
    inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$27$myNondetVar_0;
    goto inline$CallCompletionRoutine$27$label_12#1;

  inline$CallCompletionRoutine$27$label_12#1:
    havoc inline$CallCompletionRoutine$27$myNondetVar_0;
    inline$CallCompletionRoutine$27$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$27$myNondetVar_0;
    goto inline$CallCompletionRoutine$27$label_13#1;

  inline$CallCompletionRoutine$27$label_13#1:
    havoc inline$CallCompletionRoutine$27$myNondetVar_0;
    goto inline$CallCompletionRoutine$27$label_14#1;

  inline$CallCompletionRoutine$27$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$138$Entry#1;

  inline$IoGetCurrentIrpStackLocation$138$Entry#1:
    inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$138$start#1;

  inline$IoGetCurrentIrpStackLocation$138$start#1:
    inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$138$label_3#1;

  inline$IoGetCurrentIrpStackLocation$138$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$138$label_3_true#1, inline$IoGetCurrentIrpStackLocation$138$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$138$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$138$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$138$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$138$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$138$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$138$label_4#1;

  inline$IoGetCurrentIrpStackLocation$138$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$138$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$138$label_6#1;

  inline$IoGetCurrentIrpStackLocation$138$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$138$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$138$label_7#1;

  inline$IoGetCurrentIrpStackLocation$138$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$138$label_5#1;

  inline$IoGetCurrentIrpStackLocation$138$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$138$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$138$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$138$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$138$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$138$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$138$label_5#1;

  inline$IoGetCurrentIrpStackLocation$138$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$138$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$138$label_1#1;

  inline$IoGetCurrentIrpStackLocation$138$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$138$Return#1;

  inline$IoGetCurrentIrpStackLocation$138$Return#1:
    goto inline$CallCompletionRoutine$27$label_14$1#1;

  inline$CallCompletionRoutine$27$label_14$1#1:
    goto inline$CallCompletionRoutine$27$anon11_Then#1, inline$CallCompletionRoutine$27$anon11_Else#1;

  inline$CallCompletionRoutine$27$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$27$anon3#1;

  inline$CallCompletionRoutine$27$anon3#1:
    goto inline$CallCompletionRoutine$27$label_17#1;

  inline$CallCompletionRoutine$27$label_17#1:
    goto inline$CallCompletionRoutine$27$label_18#1;

  inline$CallCompletionRoutine$27$label_18#1:
    goto inline$CallCompletionRoutine$27$label_18_true#1, inline$CallCompletionRoutine$27$label_18_false#1;

  inline$CallCompletionRoutine$27$label_18_false#1:
    assume inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$27$label_1#1;

  inline$CallCompletionRoutine$27$label_18_true#1:
    assume inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$27$label_19#1;

  inline$CallCompletionRoutine$27$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$27$label_20#1;

  inline$CallCompletionRoutine$27$label_20#1:
    goto inline$CallCompletionRoutine$27$label_20_icall_1#1, inline$CallCompletionRoutine$27$label_20_icall_2#1, inline$CallCompletionRoutine$27$label_20_icall_3#1;

  inline$CallCompletionRoutine$27$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$27$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$27$Entry#1;

  inline$BDLSystemPowerIoCompletion$27$Entry#1:
    inline$BDLSystemPowerIoCompletion$27$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$27$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$27$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$27$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$27$start#1;

  inline$BDLSystemPowerIoCompletion$27$start#1:
    call inline$BDLSystemPowerIoCompletion$27$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$27$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$27$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$27$label_3#1;

  inline$BDLSystemPowerIoCompletion$27$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_4#1;

  inline$BDLSystemPowerIoCompletion$27$label_4#1:
    inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_5#1;

  inline$BDLSystemPowerIoCompletion$27$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_6#1;

  inline$BDLSystemPowerIoCompletion$27$label_6#1:
    inline$BDLSystemPowerIoCompletion$27$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$27$label_7#1;

  inline$BDLSystemPowerIoCompletion$27$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_8#1;

  inline$BDLSystemPowerIoCompletion$27$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$27$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$27$label_9#1;

  inline$BDLSystemPowerIoCompletion$27$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_10#1;

  inline$BDLSystemPowerIoCompletion$27$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$140$Entry#1;

  inline$IoGetCurrentIrpStackLocation$140$Entry#1:
    inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$140$start#1;

  inline$IoGetCurrentIrpStackLocation$140$start#1:
    inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$140$label_3#1;

  inline$IoGetCurrentIrpStackLocation$140$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$140$label_3_true#1, inline$IoGetCurrentIrpStackLocation$140$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$140$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$140$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$140$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$140$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$140$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$140$label_4#1;

  inline$IoGetCurrentIrpStackLocation$140$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$140$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$140$label_6#1;

  inline$IoGetCurrentIrpStackLocation$140$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$140$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$140$label_7#1;

  inline$IoGetCurrentIrpStackLocation$140$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$140$label_5#1;

  inline$IoGetCurrentIrpStackLocation$140$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$140$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$140$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$140$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$140$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$140$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$140$label_5#1;

  inline$IoGetCurrentIrpStackLocation$140$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$140$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$140$label_1#1;

  inline$IoGetCurrentIrpStackLocation$140$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$140$Return#1;

  inline$IoGetCurrentIrpStackLocation$140$Return#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon36_Then#1, inline$BDLSystemPowerIoCompletion$27$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon1#1;

  inline$BDLSystemPowerIoCompletion$27$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_13#1;

  inline$BDLSystemPowerIoCompletion$27$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_14#1;

  inline$BDLSystemPowerIoCompletion$27$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_15#1;

  inline$BDLSystemPowerIoCompletion$27$label_15#1:
    goto inline$BDLGetDebugLevel$718$Entry#1;

  inline$BDLGetDebugLevel$718$Entry#1:
    goto inline$BDLGetDebugLevel$718$start#1;

  inline$BDLGetDebugLevel$718$start#1:
    goto inline$BDLGetDebugLevel$718$label_3#1;

  inline$BDLGetDebugLevel$718$label_3#1:
    havoc inline$BDLGetDebugLevel$718$myNondetVar_0;
    inline$BDLGetDebugLevel$718$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$718$myNondetVar_0;
    goto inline$BDLGetDebugLevel$718$label_1#1;

  inline$BDLGetDebugLevel$718$label_1#1:
    goto inline$BDLGetDebugLevel$718$Return#1;

  inline$BDLGetDebugLevel$718$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$718$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon37_Then#1, inline$BDLSystemPowerIoCompletion$27$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon3#1;

  inline$BDLSystemPowerIoCompletion$27$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_18#1;

  inline$BDLSystemPowerIoCompletion$27$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_18_true#1, inline$BDLSystemPowerIoCompletion$27$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_19#1;

  inline$BDLSystemPowerIoCompletion$27$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_22#1;

  inline$BDLSystemPowerIoCompletion$27$label_22#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_23#1;

  inline$BDLSystemPowerIoCompletion$27$label_23#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_24#1;

  inline$BDLSystemPowerIoCompletion$27$label_24#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_25#1;

  inline$BDLSystemPowerIoCompletion$27$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$27$label_19#1;

  inline$BDLSystemPowerIoCompletion$27$label_19#1:
    goto inline$BDLGetDebugLevel$719$Entry#1;

  inline$BDLGetDebugLevel$719$Entry#1:
    goto inline$BDLGetDebugLevel$719$start#1;

  inline$BDLGetDebugLevel$719$start#1:
    goto inline$BDLGetDebugLevel$719$label_3#1;

  inline$BDLGetDebugLevel$719$label_3#1:
    havoc inline$BDLGetDebugLevel$719$myNondetVar_0;
    inline$BDLGetDebugLevel$719$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$719$myNondetVar_0;
    goto inline$BDLGetDebugLevel$719$label_1#1;

  inline$BDLGetDebugLevel$719$label_1#1:
    goto inline$BDLGetDebugLevel$719$Return#1;

  inline$BDLGetDebugLevel$719$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$719$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon38_Then#1, inline$BDLSystemPowerIoCompletion$27$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon5#1;

  inline$BDLSystemPowerIoCompletion$27$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_28#1;

  inline$BDLSystemPowerIoCompletion$27$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_28_true#1, inline$BDLSystemPowerIoCompletion$27$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_29#1;

  inline$BDLSystemPowerIoCompletion$27$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_32#1;

  inline$BDLSystemPowerIoCompletion$27$label_32#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_33#1;

  inline$BDLSystemPowerIoCompletion$27$label_33#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_34#1;

  inline$BDLSystemPowerIoCompletion$27$label_34#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_35#1;

  inline$BDLSystemPowerIoCompletion$27$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$27$label_29#1;

  inline$BDLSystemPowerIoCompletion$27$label_29#1:
    goto inline$BDLGetDebugLevel$720$Entry#1;

  inline$BDLGetDebugLevel$720$Entry#1:
    goto inline$BDLGetDebugLevel$720$start#1;

  inline$BDLGetDebugLevel$720$start#1:
    goto inline$BDLGetDebugLevel$720$label_3#1;

  inline$BDLGetDebugLevel$720$label_3#1:
    havoc inline$BDLGetDebugLevel$720$myNondetVar_0;
    inline$BDLGetDebugLevel$720$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$720$myNondetVar_0;
    goto inline$BDLGetDebugLevel$720$label_1#1;

  inline$BDLGetDebugLevel$720$label_1#1:
    goto inline$BDLGetDebugLevel$720$Return#1;

  inline$BDLGetDebugLevel$720$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$720$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon39_Then#1, inline$BDLSystemPowerIoCompletion$27$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon7#1;

  inline$BDLSystemPowerIoCompletion$27$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_38#1;

  inline$BDLSystemPowerIoCompletion$27$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_38_true#1, inline$BDLSystemPowerIoCompletion$27$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_39#1;

  inline$BDLSystemPowerIoCompletion$27$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_40#1;

  inline$BDLSystemPowerIoCompletion$27$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_39#1;

  inline$BDLSystemPowerIoCompletion$27$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_39_true#1, inline$BDLSystemPowerIoCompletion$27$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_41#1;

  inline$BDLSystemPowerIoCompletion$27$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$27$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$27$label_107#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$27$label_108#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$27$label_108#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$27$label_108#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$27$label_108#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$27$label_108#1;

  inline$BDLSystemPowerIoCompletion$27$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_109#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$27$label_107#1;

  inline$BDLSystemPowerIoCompletion$27$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_109#1;

  inline$BDLSystemPowerIoCompletion$27$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$27$label_106#1;

  inline$BDLSystemPowerIoCompletion$27$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_106_true#1, inline$BDLSystemPowerIoCompletion$27$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_142#1;

  inline$BDLSystemPowerIoCompletion$27$label_142#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_143#1;

  inline$BDLSystemPowerIoCompletion$27$label_143#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_144#1;

  inline$BDLSystemPowerIoCompletion$27$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_109#1;

  inline$BDLSystemPowerIoCompletion$27$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_109#1;

  inline$BDLSystemPowerIoCompletion$27$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$27$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$27$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$27$myNondetVar_0, inline$BDLSystemPowerIoCompletion$27$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$27$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$27$anon50_Then#1, inline$BDLSystemPowerIoCompletion$27$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon29#1;

  inline$BDLSystemPowerIoCompletion$27$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_112#1;

  inline$BDLSystemPowerIoCompletion$27$label_112#1:
    inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$27$label_113#1;

  inline$BDLSystemPowerIoCompletion$27$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_113_true#1, inline$BDLSystemPowerIoCompletion$27$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$27$label_114#1;

  inline$BDLSystemPowerIoCompletion$27$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_116#1;

  inline$BDLSystemPowerIoCompletion$27$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_117#1;

  inline$BDLSystemPowerIoCompletion$27$label_117#1:
    goto inline$BDLGetDebugLevel$727$Entry#1;

  inline$BDLGetDebugLevel$727$Entry#1:
    goto inline$BDLGetDebugLevel$727$start#1;

  inline$BDLGetDebugLevel$727$start#1:
    goto inline$BDLGetDebugLevel$727$label_3#1;

  inline$BDLGetDebugLevel$727$label_3#1:
    havoc inline$BDLGetDebugLevel$727$myNondetVar_0;
    inline$BDLGetDebugLevel$727$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$727$myNondetVar_0;
    goto inline$BDLGetDebugLevel$727$label_1#1;

  inline$BDLGetDebugLevel$727$label_1#1:
    goto inline$BDLGetDebugLevel$727$Return#1;

  inline$BDLGetDebugLevel$727$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$727$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon51_Then#1, inline$BDLSystemPowerIoCompletion$27$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon31#1;

  inline$BDLSystemPowerIoCompletion$27$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_120#1;

  inline$BDLSystemPowerIoCompletion$27$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_120_true#1, inline$BDLSystemPowerIoCompletion$27$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_121#1;

  inline$BDLSystemPowerIoCompletion$27$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_124#1;

  inline$BDLSystemPowerIoCompletion$27$label_124#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_125#1;

  inline$BDLSystemPowerIoCompletion$27$label_125#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_126#1;

  inline$BDLSystemPowerIoCompletion$27$label_126#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_127#1;

  inline$BDLSystemPowerIoCompletion$27$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$27$label_121#1;

  inline$BDLSystemPowerIoCompletion$27$label_121#1:
    goto inline$BDLGetDebugLevel$728$Entry#1;

  inline$BDLGetDebugLevel$728$Entry#1:
    goto inline$BDLGetDebugLevel$728$start#1;

  inline$BDLGetDebugLevel$728$start#1:
    goto inline$BDLGetDebugLevel$728$label_3#1;

  inline$BDLGetDebugLevel$728$label_3#1:
    havoc inline$BDLGetDebugLevel$728$myNondetVar_0;
    inline$BDLGetDebugLevel$728$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$728$myNondetVar_0;
    goto inline$BDLGetDebugLevel$728$label_1#1;

  inline$BDLGetDebugLevel$728$label_1#1:
    goto inline$BDLGetDebugLevel$728$Return#1;

  inline$BDLGetDebugLevel$728$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$728$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon52_Then#1, inline$BDLSystemPowerIoCompletion$27$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon33#1;

  inline$BDLSystemPowerIoCompletion$27$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_130#1;

  inline$BDLSystemPowerIoCompletion$27$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_130_true#1, inline$BDLSystemPowerIoCompletion$27$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_131#1;

  inline$BDLSystemPowerIoCompletion$27$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_134#1;

  inline$BDLSystemPowerIoCompletion$27$label_134#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_135#1;

  inline$BDLSystemPowerIoCompletion$27$label_135#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_136#1;

  inline$BDLSystemPowerIoCompletion$27$label_136#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_137#1;

  inline$BDLSystemPowerIoCompletion$27$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$27$label_131#1;

  inline$BDLSystemPowerIoCompletion$27$label_131#1:
    goto inline$BDLGetDebugLevel$729$Entry#1;

  inline$BDLGetDebugLevel$729$Entry#1:
    goto inline$BDLGetDebugLevel$729$start#1;

  inline$BDLGetDebugLevel$729$start#1:
    goto inline$BDLGetDebugLevel$729$label_3#1;

  inline$BDLGetDebugLevel$729$label_3#1:
    havoc inline$BDLGetDebugLevel$729$myNondetVar_0;
    inline$BDLGetDebugLevel$729$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$729$myNondetVar_0;
    goto inline$BDLGetDebugLevel$729$label_1#1;

  inline$BDLGetDebugLevel$729$label_1#1:
    goto inline$BDLGetDebugLevel$729$Return#1;

  inline$BDLGetDebugLevel$729$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$729$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon53_Then#1, inline$BDLSystemPowerIoCompletion$27$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon35#1;

  inline$BDLSystemPowerIoCompletion$27$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_140#1;

  inline$BDLSystemPowerIoCompletion$27$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_140_true#1, inline$BDLSystemPowerIoCompletion$27$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_67#1;

  inline$BDLSystemPowerIoCompletion$27$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_141#1;

  inline$BDLSystemPowerIoCompletion$27$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_67#1;

  inline$BDLSystemPowerIoCompletion$27$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$27$label_115#1;

  inline$BDLSystemPowerIoCompletion$27$label_115#1:
    inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$27$label_80#1;

  inline$BDLSystemPowerIoCompletion$27$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$27$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_42#1;

  inline$BDLSystemPowerIoCompletion$27$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$27$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$27$label_43#1;

  inline$BDLSystemPowerIoCompletion$27$label_43#1:
    goto inline$BDLGetDebugLevel$721$Entry#1;

  inline$BDLGetDebugLevel$721$Entry#1:
    goto inline$BDLGetDebugLevel$721$start#1;

  inline$BDLGetDebugLevel$721$start#1:
    goto inline$BDLGetDebugLevel$721$label_3#1;

  inline$BDLGetDebugLevel$721$label_3#1:
    havoc inline$BDLGetDebugLevel$721$myNondetVar_0;
    inline$BDLGetDebugLevel$721$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$721$myNondetVar_0;
    goto inline$BDLGetDebugLevel$721$label_1#1;

  inline$BDLGetDebugLevel$721$label_1#1:
    goto inline$BDLGetDebugLevel$721$Return#1;

  inline$BDLGetDebugLevel$721$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$721$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon40_Then#1, inline$BDLSystemPowerIoCompletion$27$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon9#1;

  inline$BDLSystemPowerIoCompletion$27$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_46#1;

  inline$BDLSystemPowerIoCompletion$27$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_46_true#1, inline$BDLSystemPowerIoCompletion$27$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_47#1;

  inline$BDLSystemPowerIoCompletion$27$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_50#1;

  inline$BDLSystemPowerIoCompletion$27$label_50#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_51#1;

  inline$BDLSystemPowerIoCompletion$27$label_51#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_52#1;

  inline$BDLSystemPowerIoCompletion$27$label_52#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_53#1;

  inline$BDLSystemPowerIoCompletion$27$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$27$label_47#1;

  inline$BDLSystemPowerIoCompletion$27$label_47#1:
    goto inline$BDLGetDebugLevel$722$Entry#1;

  inline$BDLGetDebugLevel$722$Entry#1:
    goto inline$BDLGetDebugLevel$722$start#1;

  inline$BDLGetDebugLevel$722$start#1:
    goto inline$BDLGetDebugLevel$722$label_3#1;

  inline$BDLGetDebugLevel$722$label_3#1:
    havoc inline$BDLGetDebugLevel$722$myNondetVar_0;
    inline$BDLGetDebugLevel$722$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$722$myNondetVar_0;
    goto inline$BDLGetDebugLevel$722$label_1#1;

  inline$BDLGetDebugLevel$722$label_1#1:
    goto inline$BDLGetDebugLevel$722$Return#1;

  inline$BDLGetDebugLevel$722$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$722$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon41_Then#1, inline$BDLSystemPowerIoCompletion$27$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon11#1;

  inline$BDLSystemPowerIoCompletion$27$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_56#1;

  inline$BDLSystemPowerIoCompletion$27$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_56_true#1, inline$BDLSystemPowerIoCompletion$27$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_57#1;

  inline$BDLSystemPowerIoCompletion$27$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_60#1;

  inline$BDLSystemPowerIoCompletion$27$label_60#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_61#1;

  inline$BDLSystemPowerIoCompletion$27$label_61#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_62#1;

  inline$BDLSystemPowerIoCompletion$27$label_62#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_63#1;

  inline$BDLSystemPowerIoCompletion$27$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$27$label_57#1;

  inline$BDLSystemPowerIoCompletion$27$label_57#1:
    goto inline$BDLGetDebugLevel$723$Entry#1;

  inline$BDLGetDebugLevel$723$Entry#1:
    goto inline$BDLGetDebugLevel$723$start#1;

  inline$BDLGetDebugLevel$723$start#1:
    goto inline$BDLGetDebugLevel$723$label_3#1;

  inline$BDLGetDebugLevel$723$label_3#1:
    havoc inline$BDLGetDebugLevel$723$myNondetVar_0;
    inline$BDLGetDebugLevel$723$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$723$myNondetVar_0;
    goto inline$BDLGetDebugLevel$723$label_1#1;

  inline$BDLGetDebugLevel$723$label_1#1:
    goto inline$BDLGetDebugLevel$723$Return#1;

  inline$BDLGetDebugLevel$723$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$723$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon42_Then#1, inline$BDLSystemPowerIoCompletion$27$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon13#1;

  inline$BDLSystemPowerIoCompletion$27$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_66#1;

  inline$BDLSystemPowerIoCompletion$27$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_66_true#1, inline$BDLSystemPowerIoCompletion$27$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_67#1;

  inline$BDLSystemPowerIoCompletion$27$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_70#1;

  inline$BDLSystemPowerIoCompletion$27$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_67#1;

  inline$BDLSystemPowerIoCompletion$27$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$27$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$27$anon43_Then#1, inline$BDLSystemPowerIoCompletion$27$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon15#1;

  inline$BDLSystemPowerIoCompletion$27$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_71#1;

  inline$BDLSystemPowerIoCompletion$27$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$27$anon44_Then#1, inline$BDLSystemPowerIoCompletion$27$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon17#1;

  inline$BDLSystemPowerIoCompletion$27$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_74#1;

  inline$BDLSystemPowerIoCompletion$27$label_74#1:
    goto inline$storm_IoCompleteRequest$56$Entry#1;

  inline$storm_IoCompleteRequest$56$Entry#1:
    inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$27$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$56$start#1;

  inline$storm_IoCompleteRequest$56$start#1:
    inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$56$label_3#1;

  inline$storm_IoCompleteRequest$56$label_3#1:
    call inline$storm_IoCompleteRequest$56$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$56$label_6#1;

  inline$storm_IoCompleteRequest$56$label_6#1:
    goto inline$storm_IoCompleteRequest$56$label_6_true#1, inline$storm_IoCompleteRequest$56$label_6_false#1;

  inline$storm_IoCompleteRequest$56$label_6_false#1:
    assume inline$storm_IoCompleteRequest$56$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$56$label_7#1;

  inline$storm_IoCompleteRequest$56$label_6_true#1:
    assume inline$storm_IoCompleteRequest$56$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$56$label_8#1;

  inline$storm_IoCompleteRequest$56$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$56$anon3_Then#1, inline$storm_IoCompleteRequest$56$anon3_Else#1;

  inline$storm_IoCompleteRequest$56$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$56$anon1#1;

  inline$storm_IoCompleteRequest$56$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$56$label_9#1;

  inline$storm_IoCompleteRequest$56$label_9#1:
    goto inline$storm_IoCompleteRequest$56$label_9_true#1, inline$storm_IoCompleteRequest$56$label_9_false#1;

  inline$storm_IoCompleteRequest$56$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$56$label_10#1;

  inline$storm_IoCompleteRequest$56$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$56$label_1#1;

  inline$storm_IoCompleteRequest$56$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$56$label_7#1;

  inline$storm_IoCompleteRequest$56$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$56$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$56$label_1#1;

  inline$storm_IoCompleteRequest$56$label_1#1:
    goto inline$storm_IoCompleteRequest$56$Return#1;

  inline$storm_IoCompleteRequest$56$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$56$Return#1;

  inline$storm_IoCompleteRequest$56$Return#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon45_Then#1, inline$BDLSystemPowerIoCompletion$27$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon19#1;

  inline$BDLSystemPowerIoCompletion$27$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_77#1;

  inline$BDLSystemPowerIoCompletion$27$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$27$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$27$anon46_Then#1, inline$BDLSystemPowerIoCompletion$27$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon21#1;

  inline$BDLSystemPowerIoCompletion$27$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_80#1;

  inline$BDLSystemPowerIoCompletion$27$label_80#1:
    goto inline$BDLGetDebugLevel$724$Entry#1;

  inline$BDLGetDebugLevel$724$Entry#1:
    goto inline$BDLGetDebugLevel$724$start#1;

  inline$BDLGetDebugLevel$724$start#1:
    goto inline$BDLGetDebugLevel$724$label_3#1;

  inline$BDLGetDebugLevel$724$label_3#1:
    havoc inline$BDLGetDebugLevel$724$myNondetVar_0;
    inline$BDLGetDebugLevel$724$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$724$myNondetVar_0;
    goto inline$BDLGetDebugLevel$724$label_1#1;

  inline$BDLGetDebugLevel$724$label_1#1:
    goto inline$BDLGetDebugLevel$724$Return#1;

  inline$BDLGetDebugLevel$724$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$724$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon47_Then#1, inline$BDLSystemPowerIoCompletion$27$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon23#1;

  inline$BDLSystemPowerIoCompletion$27$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_83#1;

  inline$BDLSystemPowerIoCompletion$27$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_83_true#1, inline$BDLSystemPowerIoCompletion$27$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_84#1;

  inline$BDLSystemPowerIoCompletion$27$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_87#1;

  inline$BDLSystemPowerIoCompletion$27$label_87#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_88#1;

  inline$BDLSystemPowerIoCompletion$27$label_88#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_89#1;

  inline$BDLSystemPowerIoCompletion$27$label_89#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_90#1;

  inline$BDLSystemPowerIoCompletion$27$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$27$label_84#1;

  inline$BDLSystemPowerIoCompletion$27$label_84#1:
    goto inline$BDLGetDebugLevel$725$Entry#1;

  inline$BDLGetDebugLevel$725$Entry#1:
    goto inline$BDLGetDebugLevel$725$start#1;

  inline$BDLGetDebugLevel$725$start#1:
    goto inline$BDLGetDebugLevel$725$label_3#1;

  inline$BDLGetDebugLevel$725$label_3#1:
    havoc inline$BDLGetDebugLevel$725$myNondetVar_0;
    inline$BDLGetDebugLevel$725$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$725$myNondetVar_0;
    goto inline$BDLGetDebugLevel$725$label_1#1;

  inline$BDLGetDebugLevel$725$label_1#1:
    goto inline$BDLGetDebugLevel$725$Return#1;

  inline$BDLGetDebugLevel$725$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$725$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon48_Then#1, inline$BDLSystemPowerIoCompletion$27$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon25#1;

  inline$BDLSystemPowerIoCompletion$27$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_93#1;

  inline$BDLSystemPowerIoCompletion$27$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_93_true#1, inline$BDLSystemPowerIoCompletion$27$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_94#1;

  inline$BDLSystemPowerIoCompletion$27$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_97#1;

  inline$BDLSystemPowerIoCompletion$27$label_97#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_98#1;

  inline$BDLSystemPowerIoCompletion$27$label_98#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_99#1;

  inline$BDLSystemPowerIoCompletion$27$label_99#1:
    call inline$BDLSystemPowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$27$label_100#1;

  inline$BDLSystemPowerIoCompletion$27$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$27$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$27$label_94#1;

  inline$BDLSystemPowerIoCompletion$27$label_94#1:
    goto inline$BDLGetDebugLevel$726$Entry#1;

  inline$BDLGetDebugLevel$726$Entry#1:
    goto inline$BDLGetDebugLevel$726$start#1;

  inline$BDLGetDebugLevel$726$start#1:
    goto inline$BDLGetDebugLevel$726$label_3#1;

  inline$BDLGetDebugLevel$726$label_3#1:
    havoc inline$BDLGetDebugLevel$726$myNondetVar_0;
    inline$BDLGetDebugLevel$726$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$726$myNondetVar_0;
    goto inline$BDLGetDebugLevel$726$label_1#1;

  inline$BDLGetDebugLevel$726$label_1#1:
    goto inline$BDLGetDebugLevel$726$Return#1;

  inline$BDLGetDebugLevel$726$Return#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$726$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$27$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$27$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$27$anon49_Then#1, inline$BDLSystemPowerIoCompletion$27$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$27$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$anon27#1;

  inline$BDLSystemPowerIoCompletion$27$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_103#1;

  inline$BDLSystemPowerIoCompletion$27$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_103_true#1, inline$BDLSystemPowerIoCompletion$27$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$27$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_104#1;

  inline$BDLSystemPowerIoCompletion$27$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$27$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$27$label_105#1;

  inline$BDLSystemPowerIoCompletion$27$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$27$label_104#1;

  inline$BDLSystemPowerIoCompletion$27$label_104#1:
    inline$BDLSystemPowerIoCompletion$27$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$27$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$27$label_1#1;

  inline$BDLSystemPowerIoCompletion$27$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$27$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$27$Return#1;

  inline$BDLSystemPowerIoCompletion$27$Return#1:
    inline$CallCompletionRoutine$27$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$27$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$27$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$27$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$27$anon14_Then#1, inline$CallCompletionRoutine$27$anon14_Else#1;

  inline$CallCompletionRoutine$27$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$27$anon9#1;

  inline$CallCompletionRoutine$27$anon9#1:
    goto inline$CallCompletionRoutine$27$label_20_icall_return#1;

  inline$CallCompletionRoutine$27$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$27$Return#1;

  inline$CallCompletionRoutine$27$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$27$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$27$Entry#1;

  inline$BDLDevicePowerIoCompletion$27$Entry#1:
    inline$BDLDevicePowerIoCompletion$27$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$27$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$27$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$27$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$27$start#1;

  inline$BDLDevicePowerIoCompletion$27$start#1:
    call inline$BDLDevicePowerIoCompletion$27$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$27$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$27$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$27$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$27$label_3#1;

  inline$BDLDevicePowerIoCompletion$27$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_4#1;

  inline$BDLDevicePowerIoCompletion$27$label_4#1:
    inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_5#1;

  inline$BDLDevicePowerIoCompletion$27$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_6#1;

  inline$BDLDevicePowerIoCompletion$27$label_6#1:
    inline$BDLDevicePowerIoCompletion$27$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$27$label_7#1;

  inline$BDLDevicePowerIoCompletion$27$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_8#1;

  inline$BDLDevicePowerIoCompletion$27$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$27$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$27$label_9#1;

  inline$BDLDevicePowerIoCompletion$27$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_10#1;

  inline$BDLDevicePowerIoCompletion$27$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$139$Entry#1;

  inline$IoGetCurrentIrpStackLocation$139$Entry#1:
    inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$139$start#1;

  inline$IoGetCurrentIrpStackLocation$139$start#1:
    inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$139$label_3#1;

  inline$IoGetCurrentIrpStackLocation$139$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$139$label_3_true#1, inline$IoGetCurrentIrpStackLocation$139$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$139$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$139$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$139$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$139$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$139$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$139$label_4#1;

  inline$IoGetCurrentIrpStackLocation$139$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$139$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$139$label_6#1;

  inline$IoGetCurrentIrpStackLocation$139$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$139$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$139$label_7#1;

  inline$IoGetCurrentIrpStackLocation$139$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$139$label_5#1;

  inline$IoGetCurrentIrpStackLocation$139$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$139$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$139$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$139$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$139$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$139$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$139$label_5#1;

  inline$IoGetCurrentIrpStackLocation$139$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$139$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$139$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$139$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$139$label_1#1;

  inline$IoGetCurrentIrpStackLocation$139$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$139$Return#1;

  inline$IoGetCurrentIrpStackLocation$139$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$139$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon30_Then#1, inline$BDLDevicePowerIoCompletion$27$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon1#1;

  inline$BDLDevicePowerIoCompletion$27$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_13#1;

  inline$BDLDevicePowerIoCompletion$27$label_13#1:
    inline$BDLDevicePowerIoCompletion$27$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$27$label_14#1;

  inline$BDLDevicePowerIoCompletion$27$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_15#1;

  inline$BDLDevicePowerIoCompletion$27$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$27$label_16#1;

  inline$BDLDevicePowerIoCompletion$27$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_17#1;

  inline$BDLDevicePowerIoCompletion$27$label_17#1:
    goto inline$BDLGetDebugLevel$709$Entry#1;

  inline$BDLGetDebugLevel$709$Entry#1:
    goto inline$BDLGetDebugLevel$709$start#1;

  inline$BDLGetDebugLevel$709$start#1:
    goto inline$BDLGetDebugLevel$709$label_3#1;

  inline$BDLGetDebugLevel$709$label_3#1:
    havoc inline$BDLGetDebugLevel$709$myNondetVar_0;
    inline$BDLGetDebugLevel$709$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$709$myNondetVar_0;
    goto inline$BDLGetDebugLevel$709$label_1#1;

  inline$BDLGetDebugLevel$709$label_1#1:
    goto inline$BDLGetDebugLevel$709$Return#1;

  inline$BDLGetDebugLevel$709$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$709$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon31_Then#1, inline$BDLDevicePowerIoCompletion$27$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon3#1;

  inline$BDLDevicePowerIoCompletion$27$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_20#1;

  inline$BDLDevicePowerIoCompletion$27$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_20_true#1, inline$BDLDevicePowerIoCompletion$27$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_21#1;

  inline$BDLDevicePowerIoCompletion$27$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_24#1;

  inline$BDLDevicePowerIoCompletion$27$label_24#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_25#1;

  inline$BDLDevicePowerIoCompletion$27$label_25#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_26#1;

  inline$BDLDevicePowerIoCompletion$27$label_26#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_27#1;

  inline$BDLDevicePowerIoCompletion$27$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$27$label_21#1;

  inline$BDLDevicePowerIoCompletion$27$label_21#1:
    goto inline$BDLGetDebugLevel$710$Entry#1;

  inline$BDLGetDebugLevel$710$Entry#1:
    goto inline$BDLGetDebugLevel$710$start#1;

  inline$BDLGetDebugLevel$710$start#1:
    goto inline$BDLGetDebugLevel$710$label_3#1;

  inline$BDLGetDebugLevel$710$label_3#1:
    havoc inline$BDLGetDebugLevel$710$myNondetVar_0;
    inline$BDLGetDebugLevel$710$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$710$myNondetVar_0;
    goto inline$BDLGetDebugLevel$710$label_1#1;

  inline$BDLGetDebugLevel$710$label_1#1:
    goto inline$BDLGetDebugLevel$710$Return#1;

  inline$BDLGetDebugLevel$710$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$710$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon32_Then#1, inline$BDLDevicePowerIoCompletion$27$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon5#1;

  inline$BDLDevicePowerIoCompletion$27$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_30#1;

  inline$BDLDevicePowerIoCompletion$27$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_30_true#1, inline$BDLDevicePowerIoCompletion$27$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_31#1;

  inline$BDLDevicePowerIoCompletion$27$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_34#1;

  inline$BDLDevicePowerIoCompletion$27$label_34#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_35#1;

  inline$BDLDevicePowerIoCompletion$27$label_35#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_36#1;

  inline$BDLDevicePowerIoCompletion$27$label_36#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_37#1;

  inline$BDLDevicePowerIoCompletion$27$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$27$label_31#1;

  inline$BDLDevicePowerIoCompletion$27$label_31#1:
    goto inline$BDLGetDebugLevel$711$Entry#1;

  inline$BDLGetDebugLevel$711$Entry#1:
    goto inline$BDLGetDebugLevel$711$start#1;

  inline$BDLGetDebugLevel$711$start#1:
    goto inline$BDLGetDebugLevel$711$label_3#1;

  inline$BDLGetDebugLevel$711$label_3#1:
    havoc inline$BDLGetDebugLevel$711$myNondetVar_0;
    inline$BDLGetDebugLevel$711$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$711$myNondetVar_0;
    goto inline$BDLGetDebugLevel$711$label_1#1;

  inline$BDLGetDebugLevel$711$label_1#1:
    goto inline$BDLGetDebugLevel$711$Return#1;

  inline$BDLGetDebugLevel$711$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$711$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon33_Then#1, inline$BDLDevicePowerIoCompletion$27$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon7#1;

  inline$BDLDevicePowerIoCompletion$27$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_40#1;

  inline$BDLDevicePowerIoCompletion$27$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_40_true#1, inline$BDLDevicePowerIoCompletion$27$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_41#1;

  inline$BDLDevicePowerIoCompletion$27$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_42#1;

  inline$BDLDevicePowerIoCompletion$27$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_41#1;

  inline$BDLDevicePowerIoCompletion$27$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_41_true#1, inline$BDLDevicePowerIoCompletion$27$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$27$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$27$label_43#1;

  inline$BDLDevicePowerIoCompletion$27$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$27$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$27$label_44#1;

  inline$BDLDevicePowerIoCompletion$27$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_44_true#1, inline$BDLDevicePowerIoCompletion$27$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$27$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$27$label_45#1;

  inline$BDLDevicePowerIoCompletion$27$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_45_true#1, inline$BDLDevicePowerIoCompletion$27$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$27$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$27$label_43#1;

  inline$BDLDevicePowerIoCompletion$27$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$27$label_86#1;

  inline$BDLDevicePowerIoCompletion$27$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$27$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$27$label_46#1;

  inline$BDLDevicePowerIoCompletion$27$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$27$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$27$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$27$label_46#1;

  inline$BDLDevicePowerIoCompletion$27$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$27$label_49#1;

  inline$BDLDevicePowerIoCompletion$27$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_50#1;

  inline$BDLDevicePowerIoCompletion$27$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_51#1;

  inline$BDLDevicePowerIoCompletion$27$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_54#1;

  inline$BDLDevicePowerIoCompletion$27$label_54#1:
    inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$27$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$27$label_55#1;

  inline$BDLDevicePowerIoCompletion$27$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_55_true#1, inline$BDLDevicePowerIoCompletion$27$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_56#1;

  inline$BDLDevicePowerIoCompletion$27$label_56#1:
    call inline$BDLDevicePowerIoCompletion$27$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$27$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$27$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$27$anon34_Then#1, inline$BDLDevicePowerIoCompletion$27$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon9#1;

  inline$BDLDevicePowerIoCompletion$27$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_83#1;

  inline$BDLDevicePowerIoCompletion$27$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_59#1;

  inline$BDLDevicePowerIoCompletion$27$label_59#1:
    goto inline$BDLGetDebugLevel$712$Entry#1;

  inline$BDLGetDebugLevel$712$Entry#1:
    goto inline$BDLGetDebugLevel$712$start#1;

  inline$BDLGetDebugLevel$712$start#1:
    goto inline$BDLGetDebugLevel$712$label_3#1;

  inline$BDLGetDebugLevel$712$label_3#1:
    havoc inline$BDLGetDebugLevel$712$myNondetVar_0;
    inline$BDLGetDebugLevel$712$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$712$myNondetVar_0;
    goto inline$BDLGetDebugLevel$712$label_1#1;

  inline$BDLGetDebugLevel$712$label_1#1:
    goto inline$BDLGetDebugLevel$712$Return#1;

  inline$BDLGetDebugLevel$712$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$712$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon35_Then#1, inline$BDLDevicePowerIoCompletion$27$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon11#1;

  inline$BDLDevicePowerIoCompletion$27$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_62#1;

  inline$BDLDevicePowerIoCompletion$27$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_62_true#1, inline$BDLDevicePowerIoCompletion$27$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_63#1;

  inline$BDLDevicePowerIoCompletion$27$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_66#1;

  inline$BDLDevicePowerIoCompletion$27$label_66#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_67#1;

  inline$BDLDevicePowerIoCompletion$27$label_67#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_68#1;

  inline$BDLDevicePowerIoCompletion$27$label_68#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_69#1;

  inline$BDLDevicePowerIoCompletion$27$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$27$label_63#1;

  inline$BDLDevicePowerIoCompletion$27$label_63#1:
    goto inline$BDLGetDebugLevel$713$Entry#1;

  inline$BDLGetDebugLevel$713$Entry#1:
    goto inline$BDLGetDebugLevel$713$start#1;

  inline$BDLGetDebugLevel$713$start#1:
    goto inline$BDLGetDebugLevel$713$label_3#1;

  inline$BDLGetDebugLevel$713$label_3#1:
    havoc inline$BDLGetDebugLevel$713$myNondetVar_0;
    inline$BDLGetDebugLevel$713$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$713$myNondetVar_0;
    goto inline$BDLGetDebugLevel$713$label_1#1;

  inline$BDLGetDebugLevel$713$label_1#1:
    goto inline$BDLGetDebugLevel$713$Return#1;

  inline$BDLGetDebugLevel$713$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$713$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon36_Then#1, inline$BDLDevicePowerIoCompletion$27$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon13#1;

  inline$BDLDevicePowerIoCompletion$27$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_72#1;

  inline$BDLDevicePowerIoCompletion$27$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_72_true#1, inline$BDLDevicePowerIoCompletion$27$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_73#1;

  inline$BDLDevicePowerIoCompletion$27$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_76#1;

  inline$BDLDevicePowerIoCompletion$27$label_76#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_77#1;

  inline$BDLDevicePowerIoCompletion$27$label_77#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_78#1;

  inline$BDLDevicePowerIoCompletion$27$label_78#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_79#1;

  inline$BDLDevicePowerIoCompletion$27$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$27$label_73#1;

  inline$BDLDevicePowerIoCompletion$27$label_73#1:
    goto inline$BDLGetDebugLevel$714$Entry#1;

  inline$BDLGetDebugLevel$714$Entry#1:
    goto inline$BDLGetDebugLevel$714$start#1;

  inline$BDLGetDebugLevel$714$start#1:
    goto inline$BDLGetDebugLevel$714$label_3#1;

  inline$BDLGetDebugLevel$714$label_3#1:
    havoc inline$BDLGetDebugLevel$714$myNondetVar_0;
    inline$BDLGetDebugLevel$714$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$714$myNondetVar_0;
    goto inline$BDLGetDebugLevel$714$label_1#1;

  inline$BDLGetDebugLevel$714$label_1#1:
    goto inline$BDLGetDebugLevel$714$Return#1;

  inline$BDLGetDebugLevel$714$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$714$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon37_Then#1, inline$BDLDevicePowerIoCompletion$27$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon15#1;

  inline$BDLDevicePowerIoCompletion$27$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_82#1;

  inline$BDLDevicePowerIoCompletion$27$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_82_true#1, inline$BDLDevicePowerIoCompletion$27$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_83#1;

  inline$BDLDevicePowerIoCompletion$27$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_84#1;

  inline$BDLDevicePowerIoCompletion$27$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_83#1;

  inline$BDLDevicePowerIoCompletion$27$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_85#1;

  inline$BDLDevicePowerIoCompletion$27$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_86#1;

  inline$BDLDevicePowerIoCompletion$27$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$27$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$27$anon38_Then#1, inline$BDLDevicePowerIoCompletion$27$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon17#1;

  inline$BDLDevicePowerIoCompletion$27$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_89#1;

  inline$BDLDevicePowerIoCompletion$27$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$27$anon39_Then#1, inline$BDLDevicePowerIoCompletion$27$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon19#1;

  inline$BDLDevicePowerIoCompletion$27$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_92#1;

  inline$BDLDevicePowerIoCompletion$27$label_92#1:
    goto inline$storm_IoCompleteRequest$55$Entry#1;

  inline$storm_IoCompleteRequest$55$Entry#1:
    inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$27$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$55$start#1;

  inline$storm_IoCompleteRequest$55$start#1:
    inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$55$label_3#1;

  inline$storm_IoCompleteRequest$55$label_3#1:
    call inline$storm_IoCompleteRequest$55$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$55$label_6#1;

  inline$storm_IoCompleteRequest$55$label_6#1:
    goto inline$storm_IoCompleteRequest$55$label_6_true#1, inline$storm_IoCompleteRequest$55$label_6_false#1;

  inline$storm_IoCompleteRequest$55$label_6_false#1:
    assume inline$storm_IoCompleteRequest$55$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$55$label_7#1;

  inline$storm_IoCompleteRequest$55$label_6_true#1:
    assume inline$storm_IoCompleteRequest$55$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$55$label_8#1;

  inline$storm_IoCompleteRequest$55$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$55$anon3_Then#1, inline$storm_IoCompleteRequest$55$anon3_Else#1;

  inline$storm_IoCompleteRequest$55$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$55$anon1#1;

  inline$storm_IoCompleteRequest$55$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$55$label_9#1;

  inline$storm_IoCompleteRequest$55$label_9#1:
    goto inline$storm_IoCompleteRequest$55$label_9_true#1, inline$storm_IoCompleteRequest$55$label_9_false#1;

  inline$storm_IoCompleteRequest$55$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$55$label_10#1;

  inline$storm_IoCompleteRequest$55$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$55$label_1#1;

  inline$storm_IoCompleteRequest$55$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$55$label_7#1;

  inline$storm_IoCompleteRequest$55$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$55$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$55$label_1#1;

  inline$storm_IoCompleteRequest$55$label_1#1:
    goto inline$storm_IoCompleteRequest$55$Return#1;

  inline$storm_IoCompleteRequest$55$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$55$Return#1;

  inline$storm_IoCompleteRequest$55$Return#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon40_Then#1, inline$BDLDevicePowerIoCompletion$27$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon21#1;

  inline$BDLDevicePowerIoCompletion$27$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_95#1;

  inline$BDLDevicePowerIoCompletion$27$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$27$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$27$anon41_Then#1, inline$BDLDevicePowerIoCompletion$27$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon23#1;

  inline$BDLDevicePowerIoCompletion$27$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_98#1;

  inline$BDLDevicePowerIoCompletion$27$label_98#1:
    goto inline$BDLGetDebugLevel$715$Entry#1;

  inline$BDLGetDebugLevel$715$Entry#1:
    goto inline$BDLGetDebugLevel$715$start#1;

  inline$BDLGetDebugLevel$715$start#1:
    goto inline$BDLGetDebugLevel$715$label_3#1;

  inline$BDLGetDebugLevel$715$label_3#1:
    havoc inline$BDLGetDebugLevel$715$myNondetVar_0;
    inline$BDLGetDebugLevel$715$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$715$myNondetVar_0;
    goto inline$BDLGetDebugLevel$715$label_1#1;

  inline$BDLGetDebugLevel$715$label_1#1:
    goto inline$BDLGetDebugLevel$715$Return#1;

  inline$BDLGetDebugLevel$715$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$715$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon42_Then#1, inline$BDLDevicePowerIoCompletion$27$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon25#1;

  inline$BDLDevicePowerIoCompletion$27$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_101#1;

  inline$BDLDevicePowerIoCompletion$27$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_101_true#1, inline$BDLDevicePowerIoCompletion$27$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_102#1;

  inline$BDLDevicePowerIoCompletion$27$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_105#1;

  inline$BDLDevicePowerIoCompletion$27$label_105#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_106#1;

  inline$BDLDevicePowerIoCompletion$27$label_106#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_107#1;

  inline$BDLDevicePowerIoCompletion$27$label_107#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_108#1;

  inline$BDLDevicePowerIoCompletion$27$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$27$label_102#1;

  inline$BDLDevicePowerIoCompletion$27$label_102#1:
    goto inline$BDLGetDebugLevel$716$Entry#1;

  inline$BDLGetDebugLevel$716$Entry#1:
    goto inline$BDLGetDebugLevel$716$start#1;

  inline$BDLGetDebugLevel$716$start#1:
    goto inline$BDLGetDebugLevel$716$label_3#1;

  inline$BDLGetDebugLevel$716$label_3#1:
    havoc inline$BDLGetDebugLevel$716$myNondetVar_0;
    inline$BDLGetDebugLevel$716$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$716$myNondetVar_0;
    goto inline$BDLGetDebugLevel$716$label_1#1;

  inline$BDLGetDebugLevel$716$label_1#1:
    goto inline$BDLGetDebugLevel$716$Return#1;

  inline$BDLGetDebugLevel$716$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$716$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon43_Then#1, inline$BDLDevicePowerIoCompletion$27$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon27#1;

  inline$BDLDevicePowerIoCompletion$27$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_111#1;

  inline$BDLDevicePowerIoCompletion$27$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_111_true#1, inline$BDLDevicePowerIoCompletion$27$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_112#1;

  inline$BDLDevicePowerIoCompletion$27$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_115#1;

  inline$BDLDevicePowerIoCompletion$27$label_115#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_116#1;

  inline$BDLDevicePowerIoCompletion$27$label_116#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_117#1;

  inline$BDLDevicePowerIoCompletion$27$label_117#1:
    call inline$BDLDevicePowerIoCompletion$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$27$label_118#1;

  inline$BDLDevicePowerIoCompletion$27$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$27$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$27$label_112#1;

  inline$BDLDevicePowerIoCompletion$27$label_112#1:
    goto inline$BDLGetDebugLevel$717$Entry#1;

  inline$BDLGetDebugLevel$717$Entry#1:
    goto inline$BDLGetDebugLevel$717$start#1;

  inline$BDLGetDebugLevel$717$start#1:
    goto inline$BDLGetDebugLevel$717$label_3#1;

  inline$BDLGetDebugLevel$717$label_3#1:
    havoc inline$BDLGetDebugLevel$717$myNondetVar_0;
    inline$BDLGetDebugLevel$717$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$717$myNondetVar_0;
    goto inline$BDLGetDebugLevel$717$label_1#1;

  inline$BDLGetDebugLevel$717$label_1#1:
    goto inline$BDLGetDebugLevel$717$Return#1;

  inline$BDLGetDebugLevel$717$Return#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$717$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$27$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$27$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$27$anon44_Then#1, inline$BDLDevicePowerIoCompletion$27$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$27$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$anon29#1;

  inline$BDLDevicePowerIoCompletion$27$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_121#1;

  inline$BDLDevicePowerIoCompletion$27$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_121_true#1, inline$BDLDevicePowerIoCompletion$27$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$27$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_122#1;

  inline$BDLDevicePowerIoCompletion$27$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$27$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$27$label_123#1;

  inline$BDLDevicePowerIoCompletion$27$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$27$label_122#1;

  inline$BDLDevicePowerIoCompletion$27$label_122#1:
    inline$BDLDevicePowerIoCompletion$27$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$27$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$27$label_1#1;

  inline$BDLDevicePowerIoCompletion$27$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$27$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$27$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$27$Return#1;

  inline$BDLDevicePowerIoCompletion$27$Return#1:
    inline$CallCompletionRoutine$27$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$27$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$27$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$27$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$27$anon13_Then#1, inline$CallCompletionRoutine$27$anon13_Else#1;

  inline$CallCompletionRoutine$27$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$27$anon7#1;

  inline$CallCompletionRoutine$27$anon7#1:
    goto inline$CallCompletionRoutine$27$label_20_icall_return#1;

  inline$CallCompletionRoutine$27$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$27$Return#1;

  inline$CallCompletionRoutine$27$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$27$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$27$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$27$Entry#1;

  inline$BDLCallDriverCompletionRoutine$27$Entry#1:
    inline$BDLCallDriverCompletionRoutine$27$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$27$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$27$start#1;

  inline$BDLCallDriverCompletionRoutine$27$start#1:
    inline$BDLCallDriverCompletionRoutine$27$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$27$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$27$label_3#1;

  inline$BDLCallDriverCompletionRoutine$27$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$27$label_3_true#1, inline$BDLCallDriverCompletionRoutine$27$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$27$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$27$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$27$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$27$label_4#1;

  inline$BDLCallDriverCompletionRoutine$27$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$27$label_6#1;

  inline$BDLCallDriverCompletionRoutine$27$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$27$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$27$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$27$label_5#1;

  inline$BDLCallDriverCompletionRoutine$27$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$27$label_6#1;

  inline$BDLCallDriverCompletionRoutine$27$label_6#1:
    goto inline$storm_KeSetEvent$31$Entry#1;

  inline$storm_KeSetEvent$31$Entry#1:
    inline$storm_KeSetEvent$31$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$27$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$31$start#1;

  inline$storm_KeSetEvent$31$start#1:
    inline$storm_KeSetEvent$31$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$31$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$31$label_3#1;

  inline$storm_KeSetEvent$31$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$31$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$31$label_1#1;

  inline$storm_KeSetEvent$31$label_1#1:
    goto inline$storm_KeSetEvent$31$Return#1;

  inline$storm_KeSetEvent$31$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$27$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$27$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$27$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$27$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$27$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$27$anon1#1;

  inline$BDLCallDriverCompletionRoutine$27$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$27$label_9#1;

  inline$BDLCallDriverCompletionRoutine$27$label_9#1:
    inline$BDLCallDriverCompletionRoutine$27$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$27$label_1#1;

  inline$BDLCallDriverCompletionRoutine$27$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$27$Return#1;

  inline$BDLCallDriverCompletionRoutine$27$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$27$Return#1;

  inline$BDLCallDriverCompletionRoutine$27$Return#1:
    inline$CallCompletionRoutine$27$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$27$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$27$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$27$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$27$anon12_Then#1, inline$CallCompletionRoutine$27$anon12_Else#1;

  inline$CallCompletionRoutine$27$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$27$anon5#1;

  inline$CallCompletionRoutine$27$anon5#1:
    goto inline$CallCompletionRoutine$27$label_20_icall_return#1;

  inline$CallCompletionRoutine$27$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$27$label_23#1;

  inline$CallCompletionRoutine$27$label_23#1:
    inline$CallCompletionRoutine$27$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$27$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$27$label_24#1;

  inline$CallCompletionRoutine$27$label_24#1:
    goto inline$CallCompletionRoutine$27$label_24_true#1, inline$CallCompletionRoutine$27$label_24_false#1;

  inline$CallCompletionRoutine$27$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$27$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$27$label_1#1;

  inline$CallCompletionRoutine$27$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$27$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$27$label_25#1;

  inline$CallCompletionRoutine$27$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$27$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$27$label_1#1;

  inline$CallCompletionRoutine$27$label_1#1:
    goto inline$CallCompletionRoutine$27$Return#1;

  inline$CallCompletionRoutine$27$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$27$Return#1;

  inline$CallCompletionRoutine$27$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$27$Return#1;

  inline$CallCompletionRoutine$27$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$27$Return#1;

  inline$CallCompletionRoutine$27$Return#1:
    goto inline$storm_IoCallDriver$13$label_39$1#1;

  inline$storm_IoCallDriver$13$label_39$1#1:
    goto inline$storm_IoCallDriver$13$anon15_Then#1, inline$storm_IoCallDriver$13$anon15_Else#1;

  inline$storm_IoCallDriver$13$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$13$anon10#1;

  inline$storm_IoCallDriver$13$anon10#1:
    goto inline$storm_IoCallDriver$13$label_36#1;

  inline$storm_IoCallDriver$13$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$13$Return#1;

  inline$storm_IoCallDriver$13$label_27_case_0#1:
    assume inline$storm_IoCallDriver$13$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$13$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$13$label_28#1;

  inline$storm_IoCallDriver$13$label_28#1:
    inline$storm_IoCallDriver$13$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$13$label_42#1;

  inline$storm_IoCallDriver$13$label_42#1:
    goto inline$storm_IoCallDriver$13$label_43#1;

  inline$storm_IoCallDriver$13$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$13$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$13$label_36#1;

  inline$storm_IoCallDriver$13$label_36#1:
    inline$storm_IoCallDriver$13$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$13$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$13$label_1#1;

  inline$storm_IoCallDriver$13$label_1#1:
    goto inline$storm_IoCallDriver$13$Return#1;

  inline$storm_IoCallDriver$13$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$13$Return#1;

  inline$storm_IoCallDriver$13$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$13$Return#1;

  inline$storm_IoCallDriver$13$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$13$Return#1;

  inline$storm_IoCallDriver$13$Return#1:
    inline$BDLHandleRemove$1$$result.storm_IoCallDriver$2453.25$39$ := inline$storm_IoCallDriver$13$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLHandleRemove$1$label_109$1#1;

  inline$BDLHandleRemove$1$label_109$1#1:
    goto inline$BDLHandleRemove$1$anon56_Then#1, inline$BDLHandleRemove$1$anon56_Else#1;

  inline$BDLHandleRemove$1$anon56_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon29#1;

  inline$BDLHandleRemove$1$anon29#1:
    goto inline$BDLHandleRemove$1$label_112#1;

  inline$BDLHandleRemove$1$label_112#1:
    inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 := inline$BDLHandleRemove$1$$result.storm_IoCallDriver$2453.25$39$;
    goto inline$BDLHandleRemove$1$label_113#1;

  inline$BDLHandleRemove$1$label_113#1:
    goto inline$BDLHandleRemove$1$label_113_true#1, inline$BDLHandleRemove$1$label_113_false#1;

  inline$BDLHandleRemove$1$label_113_false#1:
    assume inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 == 0;
    goto inline$BDLHandleRemove$1$label_114#1;

  inline$BDLHandleRemove$1$label_113_true#1:
    assume inline$BDLHandleRemove$1$$status$4$2383.28$BDLHandleRemove$12 != 0;
    goto inline$BDLHandleRemove$1$label_117#1;

  inline$BDLHandleRemove$1$label_117#1:
    goto inline$BDLGetDebugLevel$731$Entry#1;

  inline$BDLGetDebugLevel$731$Entry#1:
    goto inline$BDLGetDebugLevel$731$start#1;

  inline$BDLGetDebugLevel$731$start#1:
    goto inline$BDLGetDebugLevel$731$label_3#1;

  inline$BDLGetDebugLevel$731$label_3#1:
    havoc inline$BDLGetDebugLevel$731$myNondetVar_0;
    inline$BDLGetDebugLevel$731$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$731$myNondetVar_0;
    goto inline$BDLGetDebugLevel$731$label_1#1;

  inline$BDLGetDebugLevel$731$label_1#1:
    goto inline$BDLGetDebugLevel$731$Return#1;

  inline$BDLGetDebugLevel$731$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$40$ := inline$BDLGetDebugLevel$731$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_117$1#1;

  inline$BDLHandleRemove$1$label_117$1#1:
    goto inline$BDLHandleRemove$1$anon58_Then#1, inline$BDLHandleRemove$1$anon58_Else#1;

  inline$BDLHandleRemove$1$anon58_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon33#1;

  inline$BDLHandleRemove$1$anon33#1:
    goto inline$BDLHandleRemove$1$label_120#1;

  inline$BDLHandleRemove$1$label_120#1:
    goto inline$BDLHandleRemove$1$label_120_true#1, inline$BDLHandleRemove$1$label_120_false#1;

  inline$BDLHandleRemove$1$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$40$) == 0;
    goto inline$BDLHandleRemove$1$label_121#1;

  inline$BDLHandleRemove$1$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$40$) != 0;
    goto inline$BDLHandleRemove$1$label_124#1;

  inline$BDLHandleRemove$1$label_124#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_125#1;

  inline$BDLHandleRemove$1$label_125#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_126#1;

  inline$BDLHandleRemove$1$label_126#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_127#1;

  inline$BDLHandleRemove$1$label_127#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2457.0$41$;
    goto inline$BDLHandleRemove$1$label_121#1;

  inline$BDLHandleRemove$1$label_121#1:
    goto inline$BDLGetDebugLevel$732$Entry#1;

  inline$BDLGetDebugLevel$732$Entry#1:
    goto inline$BDLGetDebugLevel$732$start#1;

  inline$BDLGetDebugLevel$732$start#1:
    goto inline$BDLGetDebugLevel$732$label_3#1;

  inline$BDLGetDebugLevel$732$label_3#1:
    havoc inline$BDLGetDebugLevel$732$myNondetVar_0;
    inline$BDLGetDebugLevel$732$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$732$myNondetVar_0;
    goto inline$BDLGetDebugLevel$732$label_1#1;

  inline$BDLGetDebugLevel$732$label_1#1:
    goto inline$BDLGetDebugLevel$732$Return#1;

  inline$BDLGetDebugLevel$732$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$45$ := inline$BDLGetDebugLevel$732$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_121$1#1;

  inline$BDLHandleRemove$1$label_121$1#1:
    goto inline$BDLHandleRemove$1$anon59_Then#1, inline$BDLHandleRemove$1$anon59_Else#1;

  inline$BDLHandleRemove$1$anon59_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon35#1;

  inline$BDLHandleRemove$1$anon35#1:
    goto inline$BDLHandleRemove$1$label_130#1;

  inline$BDLHandleRemove$1$label_130#1:
    goto inline$BDLHandleRemove$1$label_130_true#1, inline$BDLHandleRemove$1$label_130_false#1;

  inline$BDLHandleRemove$1$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$45$) == 0;
    goto inline$BDLHandleRemove$1$label_131#1;

  inline$BDLHandleRemove$1$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$45$) != 0;
    goto inline$BDLHandleRemove$1$label_134#1;

  inline$BDLHandleRemove$1$label_134#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_135#1;

  inline$BDLHandleRemove$1$label_135#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_136#1;

  inline$BDLHandleRemove$1$label_136#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_137#1;

  inline$BDLHandleRemove$1$label_137#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2457.0$46$;
    goto inline$BDLHandleRemove$1$label_131#1;

  inline$BDLHandleRemove$1$label_131#1:
    goto inline$BDLGetDebugLevel$733$Entry#1;

  inline$BDLGetDebugLevel$733$Entry#1:
    goto inline$BDLGetDebugLevel$733$start#1;

  inline$BDLGetDebugLevel$733$start#1:
    goto inline$BDLGetDebugLevel$733$label_3#1;

  inline$BDLGetDebugLevel$733$label_3#1:
    havoc inline$BDLGetDebugLevel$733$myNondetVar_0;
    inline$BDLGetDebugLevel$733$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$733$myNondetVar_0;
    goto inline$BDLGetDebugLevel$733$label_1#1;

  inline$BDLGetDebugLevel$733$label_1#1:
    goto inline$BDLGetDebugLevel$733$Return#1;

  inline$BDLGetDebugLevel$733$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$50$ := inline$BDLGetDebugLevel$733$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_131$1#1;

  inline$BDLHandleRemove$1$label_131$1#1:
    goto inline$BDLHandleRemove$1$anon60_Then#1, inline$BDLHandleRemove$1$anon60_Else#1;

  inline$BDLHandleRemove$1$anon60_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon37#1;

  inline$BDLHandleRemove$1$anon37#1:
    goto inline$BDLHandleRemove$1$label_140#1;

  inline$BDLHandleRemove$1$label_140#1:
    goto inline$BDLHandleRemove$1$label_140_true#1, inline$BDLHandleRemove$1$label_140_false#1;

  inline$BDLHandleRemove$1$label_140_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$50$, 4) == 0;
    goto inline$BDLHandleRemove$1$label_114#1;

  inline$BDLHandleRemove$1$label_140_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2457.0$50$, 4) != 0;
    goto inline$BDLHandleRemove$1$label_141#1;

  inline$BDLHandleRemove$1$label_141#1:
    goto inline$BDLHandleRemove$1$label_114#1;

  inline$BDLHandleRemove$1$label_114#1:
    goto inline$BDLGetDebugLevel$730$Entry#1;

  inline$BDLGetDebugLevel$730$Entry#1:
    goto inline$BDLGetDebugLevel$730$start#1;

  inline$BDLGetDebugLevel$730$start#1:
    goto inline$BDLGetDebugLevel$730$label_3#1;

  inline$BDLGetDebugLevel$730$label_3#1:
    havoc inline$BDLGetDebugLevel$730$myNondetVar_0;
    inline$BDLGetDebugLevel$730$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$730$myNondetVar_0;
    goto inline$BDLGetDebugLevel$730$label_1#1;

  inline$BDLGetDebugLevel$730$label_1#1:
    goto inline$BDLGetDebugLevel$730$Return#1;

  inline$BDLGetDebugLevel$730$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$51$ := inline$BDLGetDebugLevel$730$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_114$1#1;

  inline$BDLHandleRemove$1$label_114$1#1:
    goto inline$BDLHandleRemove$1$anon57_Then#1, inline$BDLHandleRemove$1$anon57_Else#1;

  inline$BDLHandleRemove$1$anon57_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon31#1;

  inline$BDLHandleRemove$1$anon31#1:
    goto inline$BDLHandleRemove$1$label_142#1;

  inline$BDLHandleRemove$1$label_142#1:
    goto inline$BDLHandleRemove$1$label_142_true#1, inline$BDLHandleRemove$1$label_142_false#1;

  inline$BDLHandleRemove$1$label_142_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$51$) == 0;
    goto inline$BDLHandleRemove$1$label_143#1;

  inline$BDLHandleRemove$1$label_142_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$51$) != 0;
    goto inline$BDLHandleRemove$1$label_146#1;

  inline$BDLHandleRemove$1$label_146#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_147#1;

  inline$BDLHandleRemove$1$label_147#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_148#1;

  inline$BDLHandleRemove$1$label_148#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_149#1;

  inline$BDLHandleRemove$1$label_149#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2465.0$52$;
    goto inline$BDLHandleRemove$1$label_143#1;

  inline$BDLHandleRemove$1$label_143#1:
    goto inline$BDLGetDebugLevel$734$Entry#1;

  inline$BDLGetDebugLevel$734$Entry#1:
    goto inline$BDLGetDebugLevel$734$start#1;

  inline$BDLGetDebugLevel$734$start#1:
    goto inline$BDLGetDebugLevel$734$label_3#1;

  inline$BDLGetDebugLevel$734$label_3#1:
    havoc inline$BDLGetDebugLevel$734$myNondetVar_0;
    inline$BDLGetDebugLevel$734$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$734$myNondetVar_0;
    goto inline$BDLGetDebugLevel$734$label_1#1;

  inline$BDLGetDebugLevel$734$label_1#1:
    goto inline$BDLGetDebugLevel$734$Return#1;

  inline$BDLGetDebugLevel$734$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$56$ := inline$BDLGetDebugLevel$734$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_143$1#1;

  inline$BDLHandleRemove$1$label_143$1#1:
    goto inline$BDLHandleRemove$1$anon61_Then#1, inline$BDLHandleRemove$1$anon61_Else#1;

  inline$BDLHandleRemove$1$anon61_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon39#1;

  inline$BDLHandleRemove$1$anon39#1:
    goto inline$BDLHandleRemove$1$label_152#1;

  inline$BDLHandleRemove$1$label_152#1:
    goto inline$BDLHandleRemove$1$label_152_true#1, inline$BDLHandleRemove$1$label_152_false#1;

  inline$BDLHandleRemove$1$label_152_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$56$) == 0;
    goto inline$BDLHandleRemove$1$label_153#1;

  inline$BDLHandleRemove$1$label_152_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$56$) != 0;
    goto inline$BDLHandleRemove$1$label_156#1;

  inline$BDLHandleRemove$1$label_156#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_157#1;

  inline$BDLHandleRemove$1$label_157#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_158#1;

  inline$BDLHandleRemove$1$label_158#1:
    call inline$BDLHandleRemove$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$1$label_159#1;

  inline$BDLHandleRemove$1$label_159#1:
    havoc inline$BDLHandleRemove$1$$result.DbgPrint$2465.0$57$;
    goto inline$BDLHandleRemove$1$label_153#1;

  inline$BDLHandleRemove$1$label_153#1:
    goto inline$BDLGetDebugLevel$735$Entry#1;

  inline$BDLGetDebugLevel$735$Entry#1:
    goto inline$BDLGetDebugLevel$735$start#1;

  inline$BDLGetDebugLevel$735$start#1:
    goto inline$BDLGetDebugLevel$735$label_3#1;

  inline$BDLGetDebugLevel$735$label_3#1:
    havoc inline$BDLGetDebugLevel$735$myNondetVar_0;
    inline$BDLGetDebugLevel$735$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$735$myNondetVar_0;
    goto inline$BDLGetDebugLevel$735$label_1#1;

  inline$BDLGetDebugLevel$735$label_1#1:
    goto inline$BDLGetDebugLevel$735$Return#1;

  inline$BDLGetDebugLevel$735$Return#1:
    inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$61$ := inline$BDLGetDebugLevel$735$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$1$label_153$1#1;

  inline$BDLHandleRemove$1$label_153$1#1:
    goto inline$BDLHandleRemove$1$anon62_Then#1, inline$BDLHandleRemove$1$anon62_Else#1;

  inline$BDLHandleRemove$1$anon62_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$1$anon41#1;

  inline$BDLHandleRemove$1$anon41#1:
    goto inline$BDLHandleRemove$1$label_162#1;

  inline$BDLHandleRemove$1$label_162#1:
    goto inline$BDLHandleRemove$1$label_162_true#1, inline$BDLHandleRemove$1$label_162_false#1;

  inline$BDLHandleRemove$1$label_162_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$61$, 4) == 0;
    goto inline$BDLHandleRemove$1$label_163#1;

  inline$BDLHandleRemove$1$label_162_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$1$$result.BDLGetDebugLevel$2465.0$61$, 4) != 0;
    goto inline$BDLHandleRemove$1$label_164#1;

  inline$BDLHandleRemove$1$label_164#1:
    goto inline$BDLHandleRemove$1$label_163#1;

  inline$BDLHandleRemove$1$label_163#1:
    goto inline$BDLHandleRemove$1$label_1#1;

  inline$BDLHandleRemove$1$label_1#1:
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon62_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon61_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon57_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon60_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon59_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon58_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon56_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon52_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon55_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon54_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon53_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon51_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon50_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon49_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon48_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon47_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon46_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon45_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon44_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon43_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$anon42_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$1$Return#1;

  inline$BDLHandleRemove$1$Return#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_31$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_31$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon17_Then#1, inline$BDLPnPSurpriseRemoval$0$anon17_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon7#1;

  inline$BDLPnPSurpriseRemoval$0$anon7#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_34#1;

  inline$BDLPnPSurpriseRemoval$0$label_34#1:
    goto inline$BDLGetDebugLevel$736$Entry#1;

  inline$BDLGetDebugLevel$736$Entry#1:
    goto inline$BDLGetDebugLevel$736$start#1;

  inline$BDLGetDebugLevel$736$start#1:
    goto inline$BDLGetDebugLevel$736$label_3#1;

  inline$BDLGetDebugLevel$736$label_3#1:
    havoc inline$BDLGetDebugLevel$736$myNondetVar_0;
    inline$BDLGetDebugLevel$736$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$736$myNondetVar_0;
    goto inline$BDLGetDebugLevel$736$label_1#1;

  inline$BDLGetDebugLevel$736$label_1#1:
    goto inline$BDLGetDebugLevel$736$Return#1;

  inline$BDLGetDebugLevel$736$Return#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$14$ := inline$BDLGetDebugLevel$736$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPSurpriseRemoval$0$label_34$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_34$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon18_Then#1, inline$BDLPnPSurpriseRemoval$0$anon18_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon9#1;

  inline$BDLPnPSurpriseRemoval$0$anon9#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_37#1;

  inline$BDLPnPSurpriseRemoval$0$label_37#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_37_true#1, inline$BDLPnPSurpriseRemoval$0$label_37_false#1;

  inline$BDLPnPSurpriseRemoval$0$label_37_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$14$) == 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_38#1;

  inline$BDLPnPSurpriseRemoval$0$label_37_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$14$) != 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_41#1;

  inline$BDLPnPSurpriseRemoval$0$label_41#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_42#1;

  inline$BDLPnPSurpriseRemoval$0$label_42#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_43#1;

  inline$BDLPnPSurpriseRemoval$0$label_43#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_44#1;

  inline$BDLPnPSurpriseRemoval$0$label_44#1:
    havoc inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2549.0$15$;
    goto inline$BDLPnPSurpriseRemoval$0$label_38#1;

  inline$BDLPnPSurpriseRemoval$0$label_38#1:
    goto inline$BDLGetDebugLevel$737$Entry#1;

  inline$BDLGetDebugLevel$737$Entry#1:
    goto inline$BDLGetDebugLevel$737$start#1;

  inline$BDLGetDebugLevel$737$start#1:
    goto inline$BDLGetDebugLevel$737$label_3#1;

  inline$BDLGetDebugLevel$737$label_3#1:
    havoc inline$BDLGetDebugLevel$737$myNondetVar_0;
    inline$BDLGetDebugLevel$737$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$737$myNondetVar_0;
    goto inline$BDLGetDebugLevel$737$label_1#1;

  inline$BDLGetDebugLevel$737$label_1#1:
    goto inline$BDLGetDebugLevel$737$Return#1;

  inline$BDLGetDebugLevel$737$Return#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$19$ := inline$BDLGetDebugLevel$737$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPSurpriseRemoval$0$label_38$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_38$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon19_Then#1, inline$BDLPnPSurpriseRemoval$0$anon19_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon11#1;

  inline$BDLPnPSurpriseRemoval$0$anon11#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_47#1;

  inline$BDLPnPSurpriseRemoval$0$label_47#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_47_true#1, inline$BDLPnPSurpriseRemoval$0$label_47_false#1;

  inline$BDLPnPSurpriseRemoval$0$label_47_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$19$) == 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_48#1;

  inline$BDLPnPSurpriseRemoval$0$label_47_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$19$) != 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_51#1;

  inline$BDLPnPSurpriseRemoval$0$label_51#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_52#1;

  inline$BDLPnPSurpriseRemoval$0$label_52#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_53#1;

  inline$BDLPnPSurpriseRemoval$0$label_53#1:
    call inline$BDLPnPSurpriseRemoval$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPSurpriseRemoval$0$label_54#1;

  inline$BDLPnPSurpriseRemoval$0$label_54#1:
    havoc inline$BDLPnPSurpriseRemoval$0$$result.DbgPrint$2549.0$20$;
    goto inline$BDLPnPSurpriseRemoval$0$label_48#1;

  inline$BDLPnPSurpriseRemoval$0$label_48#1:
    goto inline$BDLGetDebugLevel$738$Entry#1;

  inline$BDLGetDebugLevel$738$Entry#1:
    goto inline$BDLGetDebugLevel$738$start#1;

  inline$BDLGetDebugLevel$738$start#1:
    goto inline$BDLGetDebugLevel$738$label_3#1;

  inline$BDLGetDebugLevel$738$label_3#1:
    havoc inline$BDLGetDebugLevel$738$myNondetVar_0;
    inline$BDLGetDebugLevel$738$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$738$myNondetVar_0;
    goto inline$BDLGetDebugLevel$738$label_1#1;

  inline$BDLGetDebugLevel$738$label_1#1:
    goto inline$BDLGetDebugLevel$738$Return#1;

  inline$BDLGetDebugLevel$738$Return#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$24$ := inline$BDLGetDebugLevel$738$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPSurpriseRemoval$0$label_48$1#1;

  inline$BDLPnPSurpriseRemoval$0$label_48$1#1:
    goto inline$BDLPnPSurpriseRemoval$0$anon20_Then#1, inline$BDLPnPSurpriseRemoval$0$anon20_Else#1;

  inline$BDLPnPSurpriseRemoval$0$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$anon13#1;

  inline$BDLPnPSurpriseRemoval$0$anon13#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_57#1;

  inline$BDLPnPSurpriseRemoval$0$label_57#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_57_true#1, inline$BDLPnPSurpriseRemoval$0$label_57_false#1;

  inline$BDLPnPSurpriseRemoval$0$label_57_false#1:
    assume BIT_BAND(inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$24$, 4) == 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_58#1;

  inline$BDLPnPSurpriseRemoval$0$label_57_true#1:
    assume BIT_BAND(inline$BDLPnPSurpriseRemoval$0$$result.BDLGetDebugLevel$2549.0$24$, 4) != 0;
    goto inline$BDLPnPSurpriseRemoval$0$label_59#1;

  inline$BDLPnPSurpriseRemoval$0$label_59#1:
    goto inline$BDLPnPSurpriseRemoval$0$label_58#1;

  inline$BDLPnPSurpriseRemoval$0$label_58#1:
    inline$BDLPnPSurpriseRemoval$0$$result.BDLPnPSurpriseRemoval$2527.0$1$ := inline$BDLPnPSurpriseRemoval$0$$status$4$2534.16$BDLPnPSurpriseRemoval$12;
    goto inline$BDLPnPSurpriseRemoval$0$label_1#1;

  inline$BDLPnPSurpriseRemoval$0$label_1#1:
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon20_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon19_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon18_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon17_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon16_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon15_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$anon14_Then#1:
    assume raiseException;
    goto inline$BDLPnPSurpriseRemoval$0$Return#1;

  inline$BDLPnPSurpriseRemoval$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPSurpriseRemoval$973.38$35$ := inline$BDLPnPSurpriseRemoval$0$$result.BDLPnPSurpriseRemoval$2527.0$1$;
    goto inline$BDLPnP$0$label_134$1#1;

  inline$BDLPnP$0$label_134$1#1:
    goto inline$BDLPnP$0$anon74_Then#1, inline$BDLPnP$0$anon74_Else#1;

  inline$BDLPnP$0$anon74_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon41#1;

  inline$BDLPnP$0$anon41#1:
    goto inline$BDLPnP$0$label_137#1;

  inline$BDLPnP$0$label_137#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPSurpriseRemoval$973.38$35$;
    goto inline$BDLPnP$0$label_138#1;

  inline$BDLPnP$0$label_138#1:
    inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8 := 0;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon74_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_7#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 6;
    goto inline$BDLPnP$0$label_131#1;

  inline$BDLPnP$0$label_131#1:
    goto inline$BDLPnPCancelStop$0$Entry#1;

  inline$BDLPnPCancelStop$0$Entry#1:
    inline$BDLPnPCancelStop$0$$pBDLExtension$1$2132.40$BDLPnPCancelStop$12_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPCancelStop$0$$pIrp$3$2134.40$BDLPnPCancelStop$12_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPCancelStop$0$start#1;

  inline$BDLPnPCancelStop$0$start#1:
    inline$BDLPnPCancelStop$0$$pBDLExtension$1$2132.40$BDLPnPCancelStop$12 := inline$BDLPnPCancelStop$0$$pBDLExtension$1$2132.40$BDLPnPCancelStop$12_.1;
    inline$BDLPnPCancelStop$0$$pIrp$3$2134.40$BDLPnPCancelStop$12 := inline$BDLPnPCancelStop$0$$pIrp$3$2134.40$BDLPnPCancelStop$12_.1;
    goto inline$BDLPnPCancelStop$0$label_3#1;

  inline$BDLPnPCancelStop$0$label_3#1:
    goto inline$BDLPnPCancelStop$0$label_4#1;

  inline$BDLPnPCancelStop$0$label_4#1:
    inline$BDLPnPCancelStop$0$$status$4$2137.16$BDLPnPCancelStop$12 := 0;
    goto inline$BDLPnPCancelStop$0$label_5#1;

  inline$BDLPnPCancelStop$0$label_5#1:
    goto inline$BDLGetDebugLevel$565$Entry#1;

  inline$BDLGetDebugLevel$565$Entry#1:
    goto inline$BDLGetDebugLevel$565$start#1;

  inline$BDLGetDebugLevel$565$start#1:
    goto inline$BDLGetDebugLevel$565$label_3#1;

  inline$BDLGetDebugLevel$565$label_3#1:
    havoc inline$BDLGetDebugLevel$565$myNondetVar_0;
    inline$BDLGetDebugLevel$565$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$565$myNondetVar_0;
    goto inline$BDLGetDebugLevel$565$label_1#1;

  inline$BDLGetDebugLevel$565$label_1#1:
    goto inline$BDLGetDebugLevel$565$Return#1;

  inline$BDLGetDebugLevel$565$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$2$ := inline$BDLGetDebugLevel$565$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_5$1#1;

  inline$BDLPnPCancelStop$0$label_5$1#1:
    goto inline$BDLPnPCancelStop$0$anon22_Then#1, inline$BDLPnPCancelStop$0$anon22_Else#1;

  inline$BDLPnPCancelStop$0$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon1#1;

  inline$BDLPnPCancelStop$0$anon1#1:
    goto inline$BDLPnPCancelStop$0$label_8#1;

  inline$BDLPnPCancelStop$0$label_8#1:
    goto inline$BDLPnPCancelStop$0$label_8_true#1, inline$BDLPnPCancelStop$0$label_8_false#1;

  inline$BDLPnPCancelStop$0$label_8_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$2$) == 0;
    goto inline$BDLPnPCancelStop$0$label_9#1;

  inline$BDLPnPCancelStop$0$label_8_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$2$) != 0;
    goto inline$BDLPnPCancelStop$0$label_12#1;

  inline$BDLPnPCancelStop$0$label_12#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_13#1;

  inline$BDLPnPCancelStop$0$label_13#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_14#1;

  inline$BDLPnPCancelStop$0$label_14#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_15#1;

  inline$BDLPnPCancelStop$0$label_15#1:
    havoc inline$BDLPnPCancelStop$0$$result.DbgPrint$2139.0$3$;
    goto inline$BDLPnPCancelStop$0$label_9#1;

  inline$BDLPnPCancelStop$0$label_9#1:
    goto inline$BDLGetDebugLevel$566$Entry#1;

  inline$BDLGetDebugLevel$566$Entry#1:
    goto inline$BDLGetDebugLevel$566$start#1;

  inline$BDLGetDebugLevel$566$start#1:
    goto inline$BDLGetDebugLevel$566$label_3#1;

  inline$BDLGetDebugLevel$566$label_3#1:
    havoc inline$BDLGetDebugLevel$566$myNondetVar_0;
    inline$BDLGetDebugLevel$566$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$566$myNondetVar_0;
    goto inline$BDLGetDebugLevel$566$label_1#1;

  inline$BDLGetDebugLevel$566$label_1#1:
    goto inline$BDLGetDebugLevel$566$Return#1;

  inline$BDLGetDebugLevel$566$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$7$ := inline$BDLGetDebugLevel$566$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_9$1#1;

  inline$BDLPnPCancelStop$0$label_9$1#1:
    goto inline$BDLPnPCancelStop$0$anon23_Then#1, inline$BDLPnPCancelStop$0$anon23_Else#1;

  inline$BDLPnPCancelStop$0$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon3#1;

  inline$BDLPnPCancelStop$0$anon3#1:
    goto inline$BDLPnPCancelStop$0$label_18#1;

  inline$BDLPnPCancelStop$0$label_18#1:
    goto inline$BDLPnPCancelStop$0$label_18_true#1, inline$BDLPnPCancelStop$0$label_18_false#1;

  inline$BDLPnPCancelStop$0$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$7$) == 0;
    goto inline$BDLPnPCancelStop$0$label_19#1;

  inline$BDLPnPCancelStop$0$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$7$) != 0;
    goto inline$BDLPnPCancelStop$0$label_22#1;

  inline$BDLPnPCancelStop$0$label_22#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_23#1;

  inline$BDLPnPCancelStop$0$label_23#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_24#1;

  inline$BDLPnPCancelStop$0$label_24#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_25#1;

  inline$BDLPnPCancelStop$0$label_25#1:
    havoc inline$BDLPnPCancelStop$0$$result.DbgPrint$2139.0$8$;
    goto inline$BDLPnPCancelStop$0$label_19#1;

  inline$BDLPnPCancelStop$0$label_19#1:
    goto inline$BDLGetDebugLevel$567$Entry#1;

  inline$BDLGetDebugLevel$567$Entry#1:
    goto inline$BDLGetDebugLevel$567$start#1;

  inline$BDLGetDebugLevel$567$start#1:
    goto inline$BDLGetDebugLevel$567$label_3#1;

  inline$BDLGetDebugLevel$567$label_3#1:
    havoc inline$BDLGetDebugLevel$567$myNondetVar_0;
    inline$BDLGetDebugLevel$567$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$567$myNondetVar_0;
    goto inline$BDLGetDebugLevel$567$label_1#1;

  inline$BDLGetDebugLevel$567$label_1#1:
    goto inline$BDLGetDebugLevel$567$Return#1;

  inline$BDLGetDebugLevel$567$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$12$ := inline$BDLGetDebugLevel$567$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_19$1#1;

  inline$BDLPnPCancelStop$0$label_19$1#1:
    goto inline$BDLPnPCancelStop$0$anon24_Then#1, inline$BDLPnPCancelStop$0$anon24_Else#1;

  inline$BDLPnPCancelStop$0$anon24_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon5#1;

  inline$BDLPnPCancelStop$0$anon5#1:
    goto inline$BDLPnPCancelStop$0$label_28#1;

  inline$BDLPnPCancelStop$0$label_28#1:
    goto inline$BDLPnPCancelStop$0$label_28_true#1, inline$BDLPnPCancelStop$0$label_28_false#1;

  inline$BDLPnPCancelStop$0$label_28_false#1:
    assume BIT_BAND(inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$12$, 4) == 0;
    goto inline$BDLPnPCancelStop$0$label_29#1;

  inline$BDLPnPCancelStop$0$label_28_true#1:
    assume BIT_BAND(inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2139.0$12$, 4) != 0;
    goto inline$BDLPnPCancelStop$0$label_32#1;

  inline$BDLPnPCancelStop$0$label_32#1:
    goto inline$BDLPnPCancelStop$0$label_29#1;

  inline$BDLPnPCancelStop$0$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$Entry#1;

  inline$BDLCallLowerLevelDriverAndWait$5$Entry#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1 := inline$BDLPnPCancelStop$0$$pIrp$3$2134.40$BDLPnPCancelStop$12;
    goto inline$BDLCallLowerLevelDriverAndWait$5$start#1;

  inline$BDLCallLowerLevelDriverAndWait$5$start#1:
    call inline$BDLCallLowerLevelDriverAndWait$5$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8 := __HAVOC_malloc(16);
    inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_3#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_4#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_4#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := 0;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_5#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_6#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_6#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$Entry#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$Entry#1:
    inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$start#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$start#1:
    inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4 := inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_4#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_4#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_5#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_5#1:
    goto inline$IoGetCurrentIrpStackLocation$112$Entry#1;

  inline$IoGetCurrentIrpStackLocation$112$Entry#1:
    inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetCurrentIrpStackLocation$112$start#1;

  inline$IoGetCurrentIrpStackLocation$112$start#1:
    inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$112$label_3#1;

  inline$IoGetCurrentIrpStackLocation$112$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$112$label_3_true#1, inline$IoGetCurrentIrpStackLocation$112$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$112$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$112$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$112$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$112$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$112$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$112$label_4#1;

  inline$IoGetCurrentIrpStackLocation$112$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$112$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$112$label_6#1;

  inline$IoGetCurrentIrpStackLocation$112$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$112$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$112$label_7#1;

  inline$IoGetCurrentIrpStackLocation$112$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$112$label_5#1;

  inline$IoGetCurrentIrpStackLocation$112$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$112$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$112$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$112$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$112$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$112$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$112$label_5#1;

  inline$IoGetCurrentIrpStackLocation$112$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$112$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$112$label_1#1;

  inline$IoGetCurrentIrpStackLocation$112$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$112$Return#1;

  inline$IoGetCurrentIrpStackLocation$112$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_5$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_5$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$anon4_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$5$anon4_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$anon4_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$anon1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$anon1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_8#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_8#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_9#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_9#1:
    goto inline$IoGetNextIrpStackLocation$11$Entry#1;

  inline$IoGetNextIrpStackLocation$11$Entry#1:
    inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$5$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetNextIrpStackLocation$11$start#1;

  inline$IoGetNextIrpStackLocation$11$start#1:
    inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$11$label_3#1;

  inline$IoGetNextIrpStackLocation$11$label_3#1:
    goto inline$IoGetNextIrpStackLocation$11$label_3_true#1, inline$IoGetNextIrpStackLocation$11$label_3_false#1;

  inline$IoGetNextIrpStackLocation$11$label_3_false#1:
    inline$IoGetNextIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$11$myVar_0);
    goto inline$IoGetNextIrpStackLocation$11$label_4#1;

  inline$IoGetNextIrpStackLocation$11$label_4#1:
    call inline$IoGetNextIrpStackLocation$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$11$label_6#1;

  inline$IoGetNextIrpStackLocation$11$label_6#1:
    call inline$IoGetNextIrpStackLocation$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$11$label_7#1;

  inline$IoGetNextIrpStackLocation$11$label_7#1:
    goto inline$IoGetNextIrpStackLocation$11$label_5#1;

  inline$IoGetNextIrpStackLocation$11$label_3_true#1:
    inline$IoGetNextIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$11$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$11$myVar_0);
    goto inline$IoGetNextIrpStackLocation$11$label_5#1;

  inline$IoGetNextIrpStackLocation$11$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$11$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$11$label_1#1;

  inline$IoGetNextIrpStackLocation$11$label_1#1:
    goto inline$IoGetNextIrpStackLocation$11$Return#1;

  inline$IoGetNextIrpStackLocation$11$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_9$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_9$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$anon5_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$5$anon5_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$anon5_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$anon3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$anon3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_12#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_12#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_13#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_13#1:
    havoc inline$IoCopyCurrentIrpStackLocationToNext$5$$result.memcpy$25110.4$3$;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_16#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_16#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$label_1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$label_1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$anon5_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$anon4_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$5$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$5$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_6$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_6$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon16_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon16_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_9#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_9#1:
    goto inline$storm_KeInitializeEvent$5$Entry#1;

  inline$storm_KeInitializeEvent$5$Entry#1:
    inline$storm_KeInitializeEvent$5$$Event$1$203.14$storm_KeInitializeEvent$12_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeInitializeEvent$5$$State$3$205.13$storm_KeInitializeEvent$12_.1 := 0;
    goto inline$storm_KeInitializeEvent$5$start#1;

  inline$storm_KeInitializeEvent$5$start#1:
    inline$storm_KeInitializeEvent$5$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$5$$Event$1$203.14$storm_KeInitializeEvent$12_.1;
    inline$storm_KeInitializeEvent$5$$State$3$205.13$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$5$$State$3$205.13$storm_KeInitializeEvent$12_.1;
    goto inline$storm_KeInitializeEvent$5$label_3#1;

  inline$storm_KeInitializeEvent$5$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeInitializeEvent$5$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$5$$State$3$205.13$storm_KeInitializeEvent$12];
    call contextSwitch();
    goto inline$storm_KeInitializeEvent$5$label_1#1;

  inline$storm_KeInitializeEvent$5$label_1#1:
    goto inline$storm_KeInitializeEvent$5$Return#1;

  inline$storm_KeInitializeEvent$5$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_9$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_9$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon17_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon17_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon3#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_12#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$5$Entry#1;

  inline$storm_IoSetCompletionRoutine$5$Entry#1:
    inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoSetCompletionRoutine$5$start#1;

  inline$storm_IoSetCompletionRoutine$5$start#1:
    inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24 := inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1;
    goto inline$storm_IoSetCompletionRoutine$5$label_3#1;

  inline$storm_IoSetCompletionRoutine$5$label_3#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_4#1;

  inline$storm_IoSetCompletionRoutine$5$label_4#1:
    call inline$storm_IoSetCompletionRoutine$5$$result.storm_nondet$405.2$1$ := storm_nondet();
    goto inline$storm_IoSetCompletionRoutine$5$label_7#1;

  inline$storm_IoSetCompletionRoutine$5$label_7#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_7_true#1, inline$storm_IoSetCompletionRoutine$5$label_7_false#1;

  inline$storm_IoSetCompletionRoutine$5$label_7_false#1:
    assume inline$storm_IoSetCompletionRoutine$5$$result.storm_nondet$405.2$1$ == 0;
    goto inline$storm_IoSetCompletionRoutine$5$label_8#1;

  inline$storm_IoSetCompletionRoutine$5$label_7_true#1:
    assume inline$storm_IoSetCompletionRoutine$5$$result.storm_nondet$405.2$1$ != 0;
    goto inline$storm_IoSetCompletionRoutine$5$label_11#1;

  inline$storm_IoSetCompletionRoutine$5$label_11#1:
    havoc raiseException;
    goto inline$storm_IoSetCompletionRoutine$5$anon6_Then#1, inline$storm_IoSetCompletionRoutine$5$anon6_Else#1;

  inline$storm_IoSetCompletionRoutine$5$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$5$anon3#1;

  inline$storm_IoSetCompletionRoutine$5$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24], 1);
    call contextSwitch();
    goto inline$storm_IoSetCompletionRoutine$5$label_12#1;

  inline$storm_IoSetCompletionRoutine$5$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_12_true#1, inline$storm_IoSetCompletionRoutine$5$label_12_false#1;

  inline$storm_IoSetCompletionRoutine$5$label_12_false#1:
    assume 0 == 0;
    goto inline$storm_IoSetCompletionRoutine$5$label_13#1;

  inline$storm_IoSetCompletionRoutine$5$label_13#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoSetCompletionRoutine$5$label_1#1;

  inline$storm_IoSetCompletionRoutine$5$label_12_true#1:
    assume 0 != 0;
    goto inline$storm_IoSetCompletionRoutine$5$label_8#1;

  inline$storm_IoSetCompletionRoutine$5$label_8#1:
    goto inline$IoGetNextIrpStackLocation$12$Entry#1;

  inline$IoGetNextIrpStackLocation$12$Entry#1:
    inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoSetCompletionRoutine$5$$pirp$1$396.10$storm_IoSetCompletionRoutine$24;
    goto inline$IoGetNextIrpStackLocation$12$start#1;

  inline$IoGetNextIrpStackLocation$12$start#1:
    inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$12$label_3#1;

  inline$IoGetNextIrpStackLocation$12$label_3#1:
    goto inline$IoGetNextIrpStackLocation$12$label_3_true#1, inline$IoGetNextIrpStackLocation$12$label_3_false#1;

  inline$IoGetNextIrpStackLocation$12$label_3_false#1:
    inline$IoGetNextIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$12$myVar_0);
    goto inline$IoGetNextIrpStackLocation$12$label_4#1;

  inline$IoGetNextIrpStackLocation$12$label_4#1:
    call inline$IoGetNextIrpStackLocation$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$12$label_6#1;

  inline$IoGetNextIrpStackLocation$12$label_6#1:
    call inline$IoGetNextIrpStackLocation$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$12$label_7#1;

  inline$IoGetNextIrpStackLocation$12$label_7#1:
    goto inline$IoGetNextIrpStackLocation$12$label_5#1;

  inline$IoGetNextIrpStackLocation$12$label_3_true#1:
    inline$IoGetNextIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$12$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$12$myVar_0);
    goto inline$IoGetNextIrpStackLocation$12$label_5#1;

  inline$IoGetNextIrpStackLocation$12$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$12$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$12$label_1#1;

  inline$IoGetNextIrpStackLocation$12$label_1#1:
    goto inline$IoGetNextIrpStackLocation$12$Return#1;

  inline$IoGetNextIrpStackLocation$12$Return#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_8$1#1;

  inline$storm_IoSetCompletionRoutine$5$label_8$1#1:
    goto inline$storm_IoSetCompletionRoutine$5$anon5_Then#1, inline$storm_IoSetCompletionRoutine$5$anon5_Else#1;

  inline$storm_IoSetCompletionRoutine$5$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$5$anon1#1;

  inline$storm_IoSetCompletionRoutine$5$anon1#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_16#1;

  inline$storm_IoSetCompletionRoutine$5$label_16#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_17#1;

  inline$storm_IoSetCompletionRoutine$5$label_17#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_18#1;

  inline$storm_IoSetCompletionRoutine$5$label_18#1:
    goto inline$storm_IoSetCompletionRoutine$5$label_1#1;

  inline$storm_IoSetCompletionRoutine$5$label_1#1:
    goto inline$storm_IoSetCompletionRoutine$5$Return#1;

  inline$storm_IoSetCompletionRoutine$5$anon5_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$5$Return#1;

  inline$storm_IoSetCompletionRoutine$5$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$5$Return#1;

  inline$storm_IoSetCompletionRoutine$5$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_12$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_12$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon18_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon18_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon5#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_15#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_15#1:
    goto inline$IoGetCurrentIrpStackLocation$113$Entry#1;

  inline$IoGetCurrentIrpStackLocation$113$Entry#1:
    inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoGetCurrentIrpStackLocation$113$start#1;

  inline$IoGetCurrentIrpStackLocation$113$start#1:
    inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$113$label_3#1;

  inline$IoGetCurrentIrpStackLocation$113$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$113$label_3_true#1, inline$IoGetCurrentIrpStackLocation$113$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$113$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$113$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$113$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$113$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$113$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$113$label_4#1;

  inline$IoGetCurrentIrpStackLocation$113$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$113$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$113$label_6#1;

  inline$IoGetCurrentIrpStackLocation$113$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$113$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$113$label_7#1;

  inline$IoGetCurrentIrpStackLocation$113$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$113$label_5#1;

  inline$IoGetCurrentIrpStackLocation$113$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$113$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$113$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$113$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$113$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$113$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$113$label_5#1;

  inline$IoGetCurrentIrpStackLocation$113$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$113$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$113$label_1#1;

  inline$IoGetCurrentIrpStackLocation$113$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$113$Return#1;

  inline$IoGetCurrentIrpStackLocation$113$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_15$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_15$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon19_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon19_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon7#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon7#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_18#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_18#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_18_true#1, inline$BDLCallLowerLevelDriverAndWait$5$label_18_false#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_18_false#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0;
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_19#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_19#1:
    goto inline$storm_IoCallDriver$11$Entry#1;

  inline$storm_IoCallDriver$11$Entry#1:
    inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoCallDriver$11$start#1;

  inline$storm_IoCallDriver$11$start#1:
    inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$11$label_3#1;

  inline$storm_IoCallDriver$11$label_3#1:
    goto inline$storm_IoCallDriver$11$label_4#1;

  inline$storm_IoCallDriver$11$label_4#1:
    goto inline$storm_IoCallDriver$11$label_5#1;

  inline$storm_IoCallDriver$11$label_5#1:
    goto inline$storm_IoCallDriver$11$label_6#1;

  inline$storm_IoCallDriver$11$label_6#1:
    call inline$storm_IoCallDriver$11$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$11$label_9#1;

  inline$storm_IoCallDriver$11$label_9#1:
    goto inline$storm_IoCallDriver$11$label_9_true#1, inline$storm_IoCallDriver$11$label_9_false#1;

  inline$storm_IoCallDriver$11$label_9_false#1:
    assume inline$storm_IoCallDriver$11$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$11$label_10#1;

  inline$storm_IoCallDriver$11$label_9_true#1:
    assume inline$storm_IoCallDriver$11$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$11$label_13#1;

  inline$storm_IoCallDriver$11$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$11$anon12_Then#1, inline$storm_IoCallDriver$11$anon12_Else#1;

  inline$storm_IoCallDriver$11$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$11$anon3#1;

  inline$storm_IoCallDriver$11$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$11$label_14#1;

  inline$storm_IoCallDriver$11$label_14#1:
    goto inline$storm_IoCallDriver$11$label_14_true#1, inline$storm_IoCallDriver$11$label_14_false#1;

  inline$storm_IoCallDriver$11$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$11$label_15#1;

  inline$storm_IoCallDriver$11$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$11$label_1#1;

  inline$storm_IoCallDriver$11$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$11$label_10#1;

  inline$storm_IoCallDriver$11$label_10#1:
    goto inline$IoSetNextIrpStackLocation$12$Entry#1;

  inline$IoSetNextIrpStackLocation$12$Entry#1:
    inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$12$start#1;

  inline$IoSetNextIrpStackLocation$12$start#1:
    inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$12$label_3#1;

  inline$IoSetNextIrpStackLocation$12$label_3#1:
    goto inline$IoSetNextIrpStackLocation$12$label_3_true#1, inline$IoSetNextIrpStackLocation$12$label_3_false#1;

  inline$IoSetNextIrpStackLocation$12$label_3_false#1:
    inline$IoSetNextIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$12$myVar_0);
    goto inline$IoSetNextIrpStackLocation$12$label_4#1;

  inline$IoSetNextIrpStackLocation$12$label_4#1:
    call inline$IoSetNextIrpStackLocation$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$12$label_7#1;

  inline$IoSetNextIrpStackLocation$12$label_7#1:
    call inline$IoSetNextIrpStackLocation$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$12$label_8#1;

  inline$IoSetNextIrpStackLocation$12$label_8#1:
    goto inline$IoSetNextIrpStackLocation$12$label_5#1;

  inline$IoSetNextIrpStackLocation$12$label_3_true#1:
    inline$IoSetNextIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$12$myVar_0);
    goto inline$IoSetNextIrpStackLocation$12$label_5#1;

  inline$IoSetNextIrpStackLocation$12$label_5#1:
    inline$IoSetNextIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$12$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$12$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$12$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$12$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$12$label_6#1;

  inline$IoSetNextIrpStackLocation$12$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$12$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$12$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$12$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$12$label_1#1;

  inline$IoSetNextIrpStackLocation$12$label_1#1:
    goto inline$IoSetNextIrpStackLocation$12$Return#1;

  inline$IoSetNextIrpStackLocation$12$Return#1:
    goto inline$storm_IoCallDriver$11$label_10$1#1;

  inline$storm_IoCallDriver$11$label_10$1#1:
    goto inline$storm_IoCallDriver$11$anon11_Then#1, inline$storm_IoCallDriver$11$anon11_Else#1;

  inline$storm_IoCallDriver$11$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$11$anon1#1;

  inline$storm_IoCallDriver$11$anon1#1:
    goto inline$storm_IoCallDriver$11$label_18#1;

  inline$storm_IoCallDriver$11$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$114$Entry#1;

  inline$IoGetCurrentIrpStackLocation$114$Entry#1:
    inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$114$start#1;

  inline$IoGetCurrentIrpStackLocation$114$start#1:
    inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$114$label_3#1;

  inline$IoGetCurrentIrpStackLocation$114$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$114$label_3_true#1, inline$IoGetCurrentIrpStackLocation$114$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$114$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$114$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$114$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$114$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$114$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$114$label_4#1;

  inline$IoGetCurrentIrpStackLocation$114$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$114$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$114$label_6#1;

  inline$IoGetCurrentIrpStackLocation$114$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$114$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$114$label_7#1;

  inline$IoGetCurrentIrpStackLocation$114$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$114$label_5#1;

  inline$IoGetCurrentIrpStackLocation$114$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$114$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$114$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$114$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$114$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$114$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$114$label_5#1;

  inline$IoGetCurrentIrpStackLocation$114$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$114$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$114$label_1#1;

  inline$IoGetCurrentIrpStackLocation$114$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$114$Return#1;

  inline$IoGetCurrentIrpStackLocation$114$Return#1:
    goto inline$storm_IoCallDriver$11$label_18$1#1;

  inline$storm_IoCallDriver$11$label_18$1#1:
    goto inline$storm_IoCallDriver$11$anon13_Then#1, inline$storm_IoCallDriver$11$anon13_Else#1;

  inline$storm_IoCallDriver$11$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$11$anon6#1;

  inline$storm_IoCallDriver$11$anon6#1:
    goto inline$storm_IoCallDriver$11$label_21#1;

  inline$storm_IoCallDriver$11$label_21#1:
    goto inline$storm_IoCallDriver$11$label_22#1;

  inline$storm_IoCallDriver$11$label_22#1:
    goto inline$storm_IoCallDriver$11$label_23#1;

  inline$storm_IoCallDriver$11$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$11$label_24#1;

  inline$storm_IoCallDriver$11$label_24#1:
    call inline$storm_IoCallDriver$11$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$11$label_27#1;

  inline$storm_IoCallDriver$11$label_27#1:
    goto inline$storm_IoCallDriver$11$label_27_case_0#1, inline$storm_IoCallDriver$11$label_27_case_1#1, inline$storm_IoCallDriver$11$label_27_case_2#1;

  inline$storm_IoCallDriver$11$label_27_case_2#1:
    assume inline$storm_IoCallDriver$11$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$11$label_30#1;

  inline$storm_IoCallDriver$11$label_30#1:
    inline$storm_IoCallDriver$11$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$11$label_31#1;

  inline$storm_IoCallDriver$11$label_31#1:
    goto inline$storm_IoCallDriver$11$label_32#1;

  inline$storm_IoCallDriver$11$label_32#1:
    goto inline$storm_IoCallDriver$11$label_33#1;

  inline$storm_IoCallDriver$11$label_33#1:
    goto inline$CallCompletionRoutine$22$Entry#1;

  inline$CallCompletionRoutine$22$Entry#1:
    inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$22$start#1;

  inline$CallCompletionRoutine$22$start#1:
    inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$22$label_3#1;

  inline$CallCompletionRoutine$22$label_3#1:
    goto inline$CallCompletionRoutine$22$label_4#1;

  inline$CallCompletionRoutine$22$label_4#1:
    goto inline$CallCompletionRoutine$22$label_5#1;

  inline$CallCompletionRoutine$22$label_5#1:
    goto inline$CallCompletionRoutine$22$label_6#1;

  inline$CallCompletionRoutine$22$label_6#1:
    goto inline$CallCompletionRoutine$22$label_7#1;

  inline$CallCompletionRoutine$22$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$115$Entry#1;

  inline$IoGetCurrentIrpStackLocation$115$Entry#1:
    inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$115$start#1;

  inline$IoGetCurrentIrpStackLocation$115$start#1:
    inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$115$label_3#1;

  inline$IoGetCurrentIrpStackLocation$115$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$115$label_3_true#1, inline$IoGetCurrentIrpStackLocation$115$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$115$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$115$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$115$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$115$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$115$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$115$label_4#1;

  inline$IoGetCurrentIrpStackLocation$115$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$115$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$115$label_6#1;

  inline$IoGetCurrentIrpStackLocation$115$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$115$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$115$label_7#1;

  inline$IoGetCurrentIrpStackLocation$115$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$115$label_5#1;

  inline$IoGetCurrentIrpStackLocation$115$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$115$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$115$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$115$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$115$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$115$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$115$label_5#1;

  inline$IoGetCurrentIrpStackLocation$115$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$115$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$115$label_1#1;

  inline$IoGetCurrentIrpStackLocation$115$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$115$Return#1;

  inline$IoGetCurrentIrpStackLocation$115$Return#1:
    goto inline$CallCompletionRoutine$22$label_7$1#1;

  inline$CallCompletionRoutine$22$label_7$1#1:
    goto inline$CallCompletionRoutine$22$anon10_Then#1, inline$CallCompletionRoutine$22$anon10_Else#1;

  inline$CallCompletionRoutine$22$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$22$anon1#1;

  inline$CallCompletionRoutine$22$anon1#1:
    goto inline$CallCompletionRoutine$22$label_10#1;

  inline$CallCompletionRoutine$22$label_10#1:
    goto inline$CallCompletionRoutine$22$label_11#1;

  inline$CallCompletionRoutine$22$label_11#1:
    havoc inline$CallCompletionRoutine$22$myNondetVar_0;
    inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$22$myNondetVar_0;
    goto inline$CallCompletionRoutine$22$label_12#1;

  inline$CallCompletionRoutine$22$label_12#1:
    havoc inline$CallCompletionRoutine$22$myNondetVar_0;
    inline$CallCompletionRoutine$22$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$22$myNondetVar_0;
    goto inline$CallCompletionRoutine$22$label_13#1;

  inline$CallCompletionRoutine$22$label_13#1:
    havoc inline$CallCompletionRoutine$22$myNondetVar_0;
    goto inline$CallCompletionRoutine$22$label_14#1;

  inline$CallCompletionRoutine$22$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$116$Entry#1;

  inline$IoGetCurrentIrpStackLocation$116$Entry#1:
    inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$116$start#1;

  inline$IoGetCurrentIrpStackLocation$116$start#1:
    inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$116$label_3#1;

  inline$IoGetCurrentIrpStackLocation$116$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$116$label_3_true#1, inline$IoGetCurrentIrpStackLocation$116$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$116$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$116$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$116$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$116$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$116$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$116$label_4#1;

  inline$IoGetCurrentIrpStackLocation$116$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$116$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$116$label_6#1;

  inline$IoGetCurrentIrpStackLocation$116$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$116$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$116$label_7#1;

  inline$IoGetCurrentIrpStackLocation$116$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$116$label_5#1;

  inline$IoGetCurrentIrpStackLocation$116$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$116$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$116$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$116$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$116$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$116$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$116$label_5#1;

  inline$IoGetCurrentIrpStackLocation$116$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$116$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$116$label_1#1;

  inline$IoGetCurrentIrpStackLocation$116$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$116$Return#1;

  inline$IoGetCurrentIrpStackLocation$116$Return#1:
    goto inline$CallCompletionRoutine$22$label_14$1#1;

  inline$CallCompletionRoutine$22$label_14$1#1:
    goto inline$CallCompletionRoutine$22$anon11_Then#1, inline$CallCompletionRoutine$22$anon11_Else#1;

  inline$CallCompletionRoutine$22$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$22$anon3#1;

  inline$CallCompletionRoutine$22$anon3#1:
    goto inline$CallCompletionRoutine$22$label_17#1;

  inline$CallCompletionRoutine$22$label_17#1:
    goto inline$CallCompletionRoutine$22$label_18#1;

  inline$CallCompletionRoutine$22$label_18#1:
    goto inline$CallCompletionRoutine$22$label_18_true#1, inline$CallCompletionRoutine$22$label_18_false#1;

  inline$CallCompletionRoutine$22$label_18_false#1:
    assume inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$22$label_1#1;

  inline$CallCompletionRoutine$22$label_18_true#1:
    assume inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$22$label_19#1;

  inline$CallCompletionRoutine$22$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$22$label_20#1;

  inline$CallCompletionRoutine$22$label_20#1:
    goto inline$CallCompletionRoutine$22$label_20_icall_1#1, inline$CallCompletionRoutine$22$label_20_icall_2#1, inline$CallCompletionRoutine$22$label_20_icall_3#1;

  inline$CallCompletionRoutine$22$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$22$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$22$Entry#1;

  inline$BDLSystemPowerIoCompletion$22$Entry#1:
    inline$BDLSystemPowerIoCompletion$22$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$22$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$22$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$22$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$22$start#1;

  inline$BDLSystemPowerIoCompletion$22$start#1:
    call inline$BDLSystemPowerIoCompletion$22$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$22$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$22$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$22$label_3#1;

  inline$BDLSystemPowerIoCompletion$22$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_4#1;

  inline$BDLSystemPowerIoCompletion$22$label_4#1:
    inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_5#1;

  inline$BDLSystemPowerIoCompletion$22$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_6#1;

  inline$BDLSystemPowerIoCompletion$22$label_6#1:
    inline$BDLSystemPowerIoCompletion$22$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$22$label_7#1;

  inline$BDLSystemPowerIoCompletion$22$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_8#1;

  inline$BDLSystemPowerIoCompletion$22$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$22$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$22$label_9#1;

  inline$BDLSystemPowerIoCompletion$22$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_10#1;

  inline$BDLSystemPowerIoCompletion$22$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$118$Entry#1;

  inline$IoGetCurrentIrpStackLocation$118$Entry#1:
    inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$118$start#1;

  inline$IoGetCurrentIrpStackLocation$118$start#1:
    inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$118$label_3#1;

  inline$IoGetCurrentIrpStackLocation$118$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$118$label_3_true#1, inline$IoGetCurrentIrpStackLocation$118$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$118$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$118$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$118$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$118$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$118$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$118$label_4#1;

  inline$IoGetCurrentIrpStackLocation$118$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$118$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$118$label_6#1;

  inline$IoGetCurrentIrpStackLocation$118$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$118$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$118$label_7#1;

  inline$IoGetCurrentIrpStackLocation$118$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$118$label_5#1;

  inline$IoGetCurrentIrpStackLocation$118$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$118$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$118$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$118$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$118$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$118$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$118$label_5#1;

  inline$IoGetCurrentIrpStackLocation$118$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$118$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$118$label_1#1;

  inline$IoGetCurrentIrpStackLocation$118$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$118$Return#1;

  inline$IoGetCurrentIrpStackLocation$118$Return#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon36_Then#1, inline$BDLSystemPowerIoCompletion$22$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon1#1;

  inline$BDLSystemPowerIoCompletion$22$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_13#1;

  inline$BDLSystemPowerIoCompletion$22$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_14#1;

  inline$BDLSystemPowerIoCompletion$22$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_15#1;

  inline$BDLSystemPowerIoCompletion$22$label_15#1:
    goto inline$BDLGetDebugLevel$577$Entry#1;

  inline$BDLGetDebugLevel$577$Entry#1:
    goto inline$BDLGetDebugLevel$577$start#1;

  inline$BDLGetDebugLevel$577$start#1:
    goto inline$BDLGetDebugLevel$577$label_3#1;

  inline$BDLGetDebugLevel$577$label_3#1:
    havoc inline$BDLGetDebugLevel$577$myNondetVar_0;
    inline$BDLGetDebugLevel$577$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$577$myNondetVar_0;
    goto inline$BDLGetDebugLevel$577$label_1#1;

  inline$BDLGetDebugLevel$577$label_1#1:
    goto inline$BDLGetDebugLevel$577$Return#1;

  inline$BDLGetDebugLevel$577$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$577$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon37_Then#1, inline$BDLSystemPowerIoCompletion$22$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon3#1;

  inline$BDLSystemPowerIoCompletion$22$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_18#1;

  inline$BDLSystemPowerIoCompletion$22$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_18_true#1, inline$BDLSystemPowerIoCompletion$22$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_19#1;

  inline$BDLSystemPowerIoCompletion$22$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_22#1;

  inline$BDLSystemPowerIoCompletion$22$label_22#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_23#1;

  inline$BDLSystemPowerIoCompletion$22$label_23#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_24#1;

  inline$BDLSystemPowerIoCompletion$22$label_24#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_25#1;

  inline$BDLSystemPowerIoCompletion$22$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$22$label_19#1;

  inline$BDLSystemPowerIoCompletion$22$label_19#1:
    goto inline$BDLGetDebugLevel$578$Entry#1;

  inline$BDLGetDebugLevel$578$Entry#1:
    goto inline$BDLGetDebugLevel$578$start#1;

  inline$BDLGetDebugLevel$578$start#1:
    goto inline$BDLGetDebugLevel$578$label_3#1;

  inline$BDLGetDebugLevel$578$label_3#1:
    havoc inline$BDLGetDebugLevel$578$myNondetVar_0;
    inline$BDLGetDebugLevel$578$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$578$myNondetVar_0;
    goto inline$BDLGetDebugLevel$578$label_1#1;

  inline$BDLGetDebugLevel$578$label_1#1:
    goto inline$BDLGetDebugLevel$578$Return#1;

  inline$BDLGetDebugLevel$578$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$578$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon38_Then#1, inline$BDLSystemPowerIoCompletion$22$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon5#1;

  inline$BDLSystemPowerIoCompletion$22$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_28#1;

  inline$BDLSystemPowerIoCompletion$22$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_28_true#1, inline$BDLSystemPowerIoCompletion$22$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_29#1;

  inline$BDLSystemPowerIoCompletion$22$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_32#1;

  inline$BDLSystemPowerIoCompletion$22$label_32#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_33#1;

  inline$BDLSystemPowerIoCompletion$22$label_33#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_34#1;

  inline$BDLSystemPowerIoCompletion$22$label_34#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_35#1;

  inline$BDLSystemPowerIoCompletion$22$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$22$label_29#1;

  inline$BDLSystemPowerIoCompletion$22$label_29#1:
    goto inline$BDLGetDebugLevel$579$Entry#1;

  inline$BDLGetDebugLevel$579$Entry#1:
    goto inline$BDLGetDebugLevel$579$start#1;

  inline$BDLGetDebugLevel$579$start#1:
    goto inline$BDLGetDebugLevel$579$label_3#1;

  inline$BDLGetDebugLevel$579$label_3#1:
    havoc inline$BDLGetDebugLevel$579$myNondetVar_0;
    inline$BDLGetDebugLevel$579$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$579$myNondetVar_0;
    goto inline$BDLGetDebugLevel$579$label_1#1;

  inline$BDLGetDebugLevel$579$label_1#1:
    goto inline$BDLGetDebugLevel$579$Return#1;

  inline$BDLGetDebugLevel$579$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$579$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon39_Then#1, inline$BDLSystemPowerIoCompletion$22$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon7#1;

  inline$BDLSystemPowerIoCompletion$22$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_38#1;

  inline$BDLSystemPowerIoCompletion$22$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_38_true#1, inline$BDLSystemPowerIoCompletion$22$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_39#1;

  inline$BDLSystemPowerIoCompletion$22$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_40#1;

  inline$BDLSystemPowerIoCompletion$22$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_39#1;

  inline$BDLSystemPowerIoCompletion$22$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_39_true#1, inline$BDLSystemPowerIoCompletion$22$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_41#1;

  inline$BDLSystemPowerIoCompletion$22$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$22$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$22$label_107#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$22$label_108#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$22$label_108#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$22$label_108#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$22$label_108#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$22$label_108#1;

  inline$BDLSystemPowerIoCompletion$22$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_109#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$22$label_107#1;

  inline$BDLSystemPowerIoCompletion$22$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_109#1;

  inline$BDLSystemPowerIoCompletion$22$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$22$label_106#1;

  inline$BDLSystemPowerIoCompletion$22$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_106_true#1, inline$BDLSystemPowerIoCompletion$22$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_142#1;

  inline$BDLSystemPowerIoCompletion$22$label_142#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_143#1;

  inline$BDLSystemPowerIoCompletion$22$label_143#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_144#1;

  inline$BDLSystemPowerIoCompletion$22$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_109#1;

  inline$BDLSystemPowerIoCompletion$22$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_109#1;

  inline$BDLSystemPowerIoCompletion$22$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$22$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$22$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$22$myNondetVar_0, inline$BDLSystemPowerIoCompletion$22$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$22$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$22$anon50_Then#1, inline$BDLSystemPowerIoCompletion$22$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon29#1;

  inline$BDLSystemPowerIoCompletion$22$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_112#1;

  inline$BDLSystemPowerIoCompletion$22$label_112#1:
    inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$22$label_113#1;

  inline$BDLSystemPowerIoCompletion$22$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_113_true#1, inline$BDLSystemPowerIoCompletion$22$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$22$label_114#1;

  inline$BDLSystemPowerIoCompletion$22$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_116#1;

  inline$BDLSystemPowerIoCompletion$22$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_117#1;

  inline$BDLSystemPowerIoCompletion$22$label_117#1:
    goto inline$BDLGetDebugLevel$586$Entry#1;

  inline$BDLGetDebugLevel$586$Entry#1:
    goto inline$BDLGetDebugLevel$586$start#1;

  inline$BDLGetDebugLevel$586$start#1:
    goto inline$BDLGetDebugLevel$586$label_3#1;

  inline$BDLGetDebugLevel$586$label_3#1:
    havoc inline$BDLGetDebugLevel$586$myNondetVar_0;
    inline$BDLGetDebugLevel$586$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$586$myNondetVar_0;
    goto inline$BDLGetDebugLevel$586$label_1#1;

  inline$BDLGetDebugLevel$586$label_1#1:
    goto inline$BDLGetDebugLevel$586$Return#1;

  inline$BDLGetDebugLevel$586$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$586$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon51_Then#1, inline$BDLSystemPowerIoCompletion$22$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon31#1;

  inline$BDLSystemPowerIoCompletion$22$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_120#1;

  inline$BDLSystemPowerIoCompletion$22$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_120_true#1, inline$BDLSystemPowerIoCompletion$22$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_121#1;

  inline$BDLSystemPowerIoCompletion$22$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_124#1;

  inline$BDLSystemPowerIoCompletion$22$label_124#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_125#1;

  inline$BDLSystemPowerIoCompletion$22$label_125#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_126#1;

  inline$BDLSystemPowerIoCompletion$22$label_126#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_127#1;

  inline$BDLSystemPowerIoCompletion$22$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$22$label_121#1;

  inline$BDLSystemPowerIoCompletion$22$label_121#1:
    goto inline$BDLGetDebugLevel$587$Entry#1;

  inline$BDLGetDebugLevel$587$Entry#1:
    goto inline$BDLGetDebugLevel$587$start#1;

  inline$BDLGetDebugLevel$587$start#1:
    goto inline$BDLGetDebugLevel$587$label_3#1;

  inline$BDLGetDebugLevel$587$label_3#1:
    havoc inline$BDLGetDebugLevel$587$myNondetVar_0;
    inline$BDLGetDebugLevel$587$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$587$myNondetVar_0;
    goto inline$BDLGetDebugLevel$587$label_1#1;

  inline$BDLGetDebugLevel$587$label_1#1:
    goto inline$BDLGetDebugLevel$587$Return#1;

  inline$BDLGetDebugLevel$587$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$587$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon52_Then#1, inline$BDLSystemPowerIoCompletion$22$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon33#1;

  inline$BDLSystemPowerIoCompletion$22$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_130#1;

  inline$BDLSystemPowerIoCompletion$22$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_130_true#1, inline$BDLSystemPowerIoCompletion$22$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_131#1;

  inline$BDLSystemPowerIoCompletion$22$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_134#1;

  inline$BDLSystemPowerIoCompletion$22$label_134#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_135#1;

  inline$BDLSystemPowerIoCompletion$22$label_135#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_136#1;

  inline$BDLSystemPowerIoCompletion$22$label_136#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_137#1;

  inline$BDLSystemPowerIoCompletion$22$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$22$label_131#1;

  inline$BDLSystemPowerIoCompletion$22$label_131#1:
    goto inline$BDLGetDebugLevel$588$Entry#1;

  inline$BDLGetDebugLevel$588$Entry#1:
    goto inline$BDLGetDebugLevel$588$start#1;

  inline$BDLGetDebugLevel$588$start#1:
    goto inline$BDLGetDebugLevel$588$label_3#1;

  inline$BDLGetDebugLevel$588$label_3#1:
    havoc inline$BDLGetDebugLevel$588$myNondetVar_0;
    inline$BDLGetDebugLevel$588$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$588$myNondetVar_0;
    goto inline$BDLGetDebugLevel$588$label_1#1;

  inline$BDLGetDebugLevel$588$label_1#1:
    goto inline$BDLGetDebugLevel$588$Return#1;

  inline$BDLGetDebugLevel$588$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$588$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon53_Then#1, inline$BDLSystemPowerIoCompletion$22$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon35#1;

  inline$BDLSystemPowerIoCompletion$22$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_140#1;

  inline$BDLSystemPowerIoCompletion$22$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_140_true#1, inline$BDLSystemPowerIoCompletion$22$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_67#1;

  inline$BDLSystemPowerIoCompletion$22$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_141#1;

  inline$BDLSystemPowerIoCompletion$22$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_67#1;

  inline$BDLSystemPowerIoCompletion$22$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$22$label_115#1;

  inline$BDLSystemPowerIoCompletion$22$label_115#1:
    inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$22$label_80#1;

  inline$BDLSystemPowerIoCompletion$22$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$22$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_42#1;

  inline$BDLSystemPowerIoCompletion$22$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$22$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$22$label_43#1;

  inline$BDLSystemPowerIoCompletion$22$label_43#1:
    goto inline$BDLGetDebugLevel$580$Entry#1;

  inline$BDLGetDebugLevel$580$Entry#1:
    goto inline$BDLGetDebugLevel$580$start#1;

  inline$BDLGetDebugLevel$580$start#1:
    goto inline$BDLGetDebugLevel$580$label_3#1;

  inline$BDLGetDebugLevel$580$label_3#1:
    havoc inline$BDLGetDebugLevel$580$myNondetVar_0;
    inline$BDLGetDebugLevel$580$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$580$myNondetVar_0;
    goto inline$BDLGetDebugLevel$580$label_1#1;

  inline$BDLGetDebugLevel$580$label_1#1:
    goto inline$BDLGetDebugLevel$580$Return#1;

  inline$BDLGetDebugLevel$580$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$580$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon40_Then#1, inline$BDLSystemPowerIoCompletion$22$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon9#1;

  inline$BDLSystemPowerIoCompletion$22$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_46#1;

  inline$BDLSystemPowerIoCompletion$22$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_46_true#1, inline$BDLSystemPowerIoCompletion$22$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_47#1;

  inline$BDLSystemPowerIoCompletion$22$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_50#1;

  inline$BDLSystemPowerIoCompletion$22$label_50#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_51#1;

  inline$BDLSystemPowerIoCompletion$22$label_51#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_52#1;

  inline$BDLSystemPowerIoCompletion$22$label_52#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_53#1;

  inline$BDLSystemPowerIoCompletion$22$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$22$label_47#1;

  inline$BDLSystemPowerIoCompletion$22$label_47#1:
    goto inline$BDLGetDebugLevel$581$Entry#1;

  inline$BDLGetDebugLevel$581$Entry#1:
    goto inline$BDLGetDebugLevel$581$start#1;

  inline$BDLGetDebugLevel$581$start#1:
    goto inline$BDLGetDebugLevel$581$label_3#1;

  inline$BDLGetDebugLevel$581$label_3#1:
    havoc inline$BDLGetDebugLevel$581$myNondetVar_0;
    inline$BDLGetDebugLevel$581$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$581$myNondetVar_0;
    goto inline$BDLGetDebugLevel$581$label_1#1;

  inline$BDLGetDebugLevel$581$label_1#1:
    goto inline$BDLGetDebugLevel$581$Return#1;

  inline$BDLGetDebugLevel$581$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$581$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon41_Then#1, inline$BDLSystemPowerIoCompletion$22$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon11#1;

  inline$BDLSystemPowerIoCompletion$22$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_56#1;

  inline$BDLSystemPowerIoCompletion$22$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_56_true#1, inline$BDLSystemPowerIoCompletion$22$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_57#1;

  inline$BDLSystemPowerIoCompletion$22$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_60#1;

  inline$BDLSystemPowerIoCompletion$22$label_60#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_61#1;

  inline$BDLSystemPowerIoCompletion$22$label_61#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_62#1;

  inline$BDLSystemPowerIoCompletion$22$label_62#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_63#1;

  inline$BDLSystemPowerIoCompletion$22$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$22$label_57#1;

  inline$BDLSystemPowerIoCompletion$22$label_57#1:
    goto inline$BDLGetDebugLevel$582$Entry#1;

  inline$BDLGetDebugLevel$582$Entry#1:
    goto inline$BDLGetDebugLevel$582$start#1;

  inline$BDLGetDebugLevel$582$start#1:
    goto inline$BDLGetDebugLevel$582$label_3#1;

  inline$BDLGetDebugLevel$582$label_3#1:
    havoc inline$BDLGetDebugLevel$582$myNondetVar_0;
    inline$BDLGetDebugLevel$582$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$582$myNondetVar_0;
    goto inline$BDLGetDebugLevel$582$label_1#1;

  inline$BDLGetDebugLevel$582$label_1#1:
    goto inline$BDLGetDebugLevel$582$Return#1;

  inline$BDLGetDebugLevel$582$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$582$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon42_Then#1, inline$BDLSystemPowerIoCompletion$22$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon13#1;

  inline$BDLSystemPowerIoCompletion$22$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_66#1;

  inline$BDLSystemPowerIoCompletion$22$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_66_true#1, inline$BDLSystemPowerIoCompletion$22$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_67#1;

  inline$BDLSystemPowerIoCompletion$22$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_70#1;

  inline$BDLSystemPowerIoCompletion$22$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_67#1;

  inline$BDLSystemPowerIoCompletion$22$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$22$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$22$anon43_Then#1, inline$BDLSystemPowerIoCompletion$22$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon15#1;

  inline$BDLSystemPowerIoCompletion$22$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_71#1;

  inline$BDLSystemPowerIoCompletion$22$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$22$anon44_Then#1, inline$BDLSystemPowerIoCompletion$22$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon17#1;

  inline$BDLSystemPowerIoCompletion$22$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_74#1;

  inline$BDLSystemPowerIoCompletion$22$label_74#1:
    goto inline$storm_IoCompleteRequest$46$Entry#1;

  inline$storm_IoCompleteRequest$46$Entry#1:
    inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$22$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$46$start#1;

  inline$storm_IoCompleteRequest$46$start#1:
    inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$46$label_3#1;

  inline$storm_IoCompleteRequest$46$label_3#1:
    call inline$storm_IoCompleteRequest$46$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$46$label_6#1;

  inline$storm_IoCompleteRequest$46$label_6#1:
    goto inline$storm_IoCompleteRequest$46$label_6_true#1, inline$storm_IoCompleteRequest$46$label_6_false#1;

  inline$storm_IoCompleteRequest$46$label_6_false#1:
    assume inline$storm_IoCompleteRequest$46$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$46$label_7#1;

  inline$storm_IoCompleteRequest$46$label_6_true#1:
    assume inline$storm_IoCompleteRequest$46$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$46$label_8#1;

  inline$storm_IoCompleteRequest$46$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$46$anon3_Then#1, inline$storm_IoCompleteRequest$46$anon3_Else#1;

  inline$storm_IoCompleteRequest$46$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$46$anon1#1;

  inline$storm_IoCompleteRequest$46$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$46$label_9#1;

  inline$storm_IoCompleteRequest$46$label_9#1:
    goto inline$storm_IoCompleteRequest$46$label_9_true#1, inline$storm_IoCompleteRequest$46$label_9_false#1;

  inline$storm_IoCompleteRequest$46$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$46$label_10#1;

  inline$storm_IoCompleteRequest$46$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$46$label_1#1;

  inline$storm_IoCompleteRequest$46$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$46$label_7#1;

  inline$storm_IoCompleteRequest$46$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$46$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$46$label_1#1;

  inline$storm_IoCompleteRequest$46$label_1#1:
    goto inline$storm_IoCompleteRequest$46$Return#1;

  inline$storm_IoCompleteRequest$46$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$46$Return#1;

  inline$storm_IoCompleteRequest$46$Return#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon45_Then#1, inline$BDLSystemPowerIoCompletion$22$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon19#1;

  inline$BDLSystemPowerIoCompletion$22$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_77#1;

  inline$BDLSystemPowerIoCompletion$22$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$22$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$22$anon46_Then#1, inline$BDLSystemPowerIoCompletion$22$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon21#1;

  inline$BDLSystemPowerIoCompletion$22$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_80#1;

  inline$BDLSystemPowerIoCompletion$22$label_80#1:
    goto inline$BDLGetDebugLevel$583$Entry#1;

  inline$BDLGetDebugLevel$583$Entry#1:
    goto inline$BDLGetDebugLevel$583$start#1;

  inline$BDLGetDebugLevel$583$start#1:
    goto inline$BDLGetDebugLevel$583$label_3#1;

  inline$BDLGetDebugLevel$583$label_3#1:
    havoc inline$BDLGetDebugLevel$583$myNondetVar_0;
    inline$BDLGetDebugLevel$583$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$583$myNondetVar_0;
    goto inline$BDLGetDebugLevel$583$label_1#1;

  inline$BDLGetDebugLevel$583$label_1#1:
    goto inline$BDLGetDebugLevel$583$Return#1;

  inline$BDLGetDebugLevel$583$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$583$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon47_Then#1, inline$BDLSystemPowerIoCompletion$22$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon23#1;

  inline$BDLSystemPowerIoCompletion$22$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_83#1;

  inline$BDLSystemPowerIoCompletion$22$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_83_true#1, inline$BDLSystemPowerIoCompletion$22$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_84#1;

  inline$BDLSystemPowerIoCompletion$22$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_87#1;

  inline$BDLSystemPowerIoCompletion$22$label_87#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_88#1;

  inline$BDLSystemPowerIoCompletion$22$label_88#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_89#1;

  inline$BDLSystemPowerIoCompletion$22$label_89#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_90#1;

  inline$BDLSystemPowerIoCompletion$22$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$22$label_84#1;

  inline$BDLSystemPowerIoCompletion$22$label_84#1:
    goto inline$BDLGetDebugLevel$584$Entry#1;

  inline$BDLGetDebugLevel$584$Entry#1:
    goto inline$BDLGetDebugLevel$584$start#1;

  inline$BDLGetDebugLevel$584$start#1:
    goto inline$BDLGetDebugLevel$584$label_3#1;

  inline$BDLGetDebugLevel$584$label_3#1:
    havoc inline$BDLGetDebugLevel$584$myNondetVar_0;
    inline$BDLGetDebugLevel$584$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$584$myNondetVar_0;
    goto inline$BDLGetDebugLevel$584$label_1#1;

  inline$BDLGetDebugLevel$584$label_1#1:
    goto inline$BDLGetDebugLevel$584$Return#1;

  inline$BDLGetDebugLevel$584$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$584$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon48_Then#1, inline$BDLSystemPowerIoCompletion$22$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon25#1;

  inline$BDLSystemPowerIoCompletion$22$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_93#1;

  inline$BDLSystemPowerIoCompletion$22$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_93_true#1, inline$BDLSystemPowerIoCompletion$22$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_94#1;

  inline$BDLSystemPowerIoCompletion$22$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_97#1;

  inline$BDLSystemPowerIoCompletion$22$label_97#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_98#1;

  inline$BDLSystemPowerIoCompletion$22$label_98#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_99#1;

  inline$BDLSystemPowerIoCompletion$22$label_99#1:
    call inline$BDLSystemPowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$22$label_100#1;

  inline$BDLSystemPowerIoCompletion$22$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$22$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$22$label_94#1;

  inline$BDLSystemPowerIoCompletion$22$label_94#1:
    goto inline$BDLGetDebugLevel$585$Entry#1;

  inline$BDLGetDebugLevel$585$Entry#1:
    goto inline$BDLGetDebugLevel$585$start#1;

  inline$BDLGetDebugLevel$585$start#1:
    goto inline$BDLGetDebugLevel$585$label_3#1;

  inline$BDLGetDebugLevel$585$label_3#1:
    havoc inline$BDLGetDebugLevel$585$myNondetVar_0;
    inline$BDLGetDebugLevel$585$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$585$myNondetVar_0;
    goto inline$BDLGetDebugLevel$585$label_1#1;

  inline$BDLGetDebugLevel$585$label_1#1:
    goto inline$BDLGetDebugLevel$585$Return#1;

  inline$BDLGetDebugLevel$585$Return#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$585$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$22$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$22$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$22$anon49_Then#1, inline$BDLSystemPowerIoCompletion$22$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$22$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$anon27#1;

  inline$BDLSystemPowerIoCompletion$22$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_103#1;

  inline$BDLSystemPowerIoCompletion$22$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_103_true#1, inline$BDLSystemPowerIoCompletion$22$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$22$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_104#1;

  inline$BDLSystemPowerIoCompletion$22$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$22$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$22$label_105#1;

  inline$BDLSystemPowerIoCompletion$22$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$22$label_104#1;

  inline$BDLSystemPowerIoCompletion$22$label_104#1:
    inline$BDLSystemPowerIoCompletion$22$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$22$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$22$label_1#1;

  inline$BDLSystemPowerIoCompletion$22$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$22$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$22$Return#1;

  inline$BDLSystemPowerIoCompletion$22$Return#1:
    inline$CallCompletionRoutine$22$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$22$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$22$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$22$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$22$anon14_Then#1, inline$CallCompletionRoutine$22$anon14_Else#1;

  inline$CallCompletionRoutine$22$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$22$anon9#1;

  inline$CallCompletionRoutine$22$anon9#1:
    goto inline$CallCompletionRoutine$22$label_20_icall_return#1;

  inline$CallCompletionRoutine$22$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$22$Return#1;

  inline$CallCompletionRoutine$22$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$22$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$22$Entry#1;

  inline$BDLDevicePowerIoCompletion$22$Entry#1:
    inline$BDLDevicePowerIoCompletion$22$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$22$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$22$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$22$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$22$start#1;

  inline$BDLDevicePowerIoCompletion$22$start#1:
    call inline$BDLDevicePowerIoCompletion$22$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$22$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$22$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$22$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$22$label_3#1;

  inline$BDLDevicePowerIoCompletion$22$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_4#1;

  inline$BDLDevicePowerIoCompletion$22$label_4#1:
    inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_5#1;

  inline$BDLDevicePowerIoCompletion$22$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_6#1;

  inline$BDLDevicePowerIoCompletion$22$label_6#1:
    inline$BDLDevicePowerIoCompletion$22$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$22$label_7#1;

  inline$BDLDevicePowerIoCompletion$22$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_8#1;

  inline$BDLDevicePowerIoCompletion$22$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$22$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$22$label_9#1;

  inline$BDLDevicePowerIoCompletion$22$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_10#1;

  inline$BDLDevicePowerIoCompletion$22$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$117$Entry#1;

  inline$IoGetCurrentIrpStackLocation$117$Entry#1:
    inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$117$start#1;

  inline$IoGetCurrentIrpStackLocation$117$start#1:
    inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$117$label_3#1;

  inline$IoGetCurrentIrpStackLocation$117$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$117$label_3_true#1, inline$IoGetCurrentIrpStackLocation$117$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$117$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$117$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$117$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$117$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$117$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$117$label_4#1;

  inline$IoGetCurrentIrpStackLocation$117$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$117$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$117$label_6#1;

  inline$IoGetCurrentIrpStackLocation$117$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$117$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$117$label_7#1;

  inline$IoGetCurrentIrpStackLocation$117$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$117$label_5#1;

  inline$IoGetCurrentIrpStackLocation$117$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$117$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$117$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$117$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$117$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$117$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$117$label_5#1;

  inline$IoGetCurrentIrpStackLocation$117$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$117$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$117$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$117$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$117$label_1#1;

  inline$IoGetCurrentIrpStackLocation$117$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$117$Return#1;

  inline$IoGetCurrentIrpStackLocation$117$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$117$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon30_Then#1, inline$BDLDevicePowerIoCompletion$22$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon1#1;

  inline$BDLDevicePowerIoCompletion$22$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_13#1;

  inline$BDLDevicePowerIoCompletion$22$label_13#1:
    inline$BDLDevicePowerIoCompletion$22$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$22$label_14#1;

  inline$BDLDevicePowerIoCompletion$22$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_15#1;

  inline$BDLDevicePowerIoCompletion$22$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$22$label_16#1;

  inline$BDLDevicePowerIoCompletion$22$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_17#1;

  inline$BDLDevicePowerIoCompletion$22$label_17#1:
    goto inline$BDLGetDebugLevel$568$Entry#1;

  inline$BDLGetDebugLevel$568$Entry#1:
    goto inline$BDLGetDebugLevel$568$start#1;

  inline$BDLGetDebugLevel$568$start#1:
    goto inline$BDLGetDebugLevel$568$label_3#1;

  inline$BDLGetDebugLevel$568$label_3#1:
    havoc inline$BDLGetDebugLevel$568$myNondetVar_0;
    inline$BDLGetDebugLevel$568$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$568$myNondetVar_0;
    goto inline$BDLGetDebugLevel$568$label_1#1;

  inline$BDLGetDebugLevel$568$label_1#1:
    goto inline$BDLGetDebugLevel$568$Return#1;

  inline$BDLGetDebugLevel$568$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$568$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon31_Then#1, inline$BDLDevicePowerIoCompletion$22$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon3#1;

  inline$BDLDevicePowerIoCompletion$22$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_20#1;

  inline$BDLDevicePowerIoCompletion$22$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_20_true#1, inline$BDLDevicePowerIoCompletion$22$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_21#1;

  inline$BDLDevicePowerIoCompletion$22$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_24#1;

  inline$BDLDevicePowerIoCompletion$22$label_24#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_25#1;

  inline$BDLDevicePowerIoCompletion$22$label_25#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_26#1;

  inline$BDLDevicePowerIoCompletion$22$label_26#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_27#1;

  inline$BDLDevicePowerIoCompletion$22$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$22$label_21#1;

  inline$BDLDevicePowerIoCompletion$22$label_21#1:
    goto inline$BDLGetDebugLevel$569$Entry#1;

  inline$BDLGetDebugLevel$569$Entry#1:
    goto inline$BDLGetDebugLevel$569$start#1;

  inline$BDLGetDebugLevel$569$start#1:
    goto inline$BDLGetDebugLevel$569$label_3#1;

  inline$BDLGetDebugLevel$569$label_3#1:
    havoc inline$BDLGetDebugLevel$569$myNondetVar_0;
    inline$BDLGetDebugLevel$569$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$569$myNondetVar_0;
    goto inline$BDLGetDebugLevel$569$label_1#1;

  inline$BDLGetDebugLevel$569$label_1#1:
    goto inline$BDLGetDebugLevel$569$Return#1;

  inline$BDLGetDebugLevel$569$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$569$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon32_Then#1, inline$BDLDevicePowerIoCompletion$22$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon5#1;

  inline$BDLDevicePowerIoCompletion$22$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_30#1;

  inline$BDLDevicePowerIoCompletion$22$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_30_true#1, inline$BDLDevicePowerIoCompletion$22$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_31#1;

  inline$BDLDevicePowerIoCompletion$22$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_34#1;

  inline$BDLDevicePowerIoCompletion$22$label_34#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_35#1;

  inline$BDLDevicePowerIoCompletion$22$label_35#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_36#1;

  inline$BDLDevicePowerIoCompletion$22$label_36#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_37#1;

  inline$BDLDevicePowerIoCompletion$22$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$22$label_31#1;

  inline$BDLDevicePowerIoCompletion$22$label_31#1:
    goto inline$BDLGetDebugLevel$570$Entry#1;

  inline$BDLGetDebugLevel$570$Entry#1:
    goto inline$BDLGetDebugLevel$570$start#1;

  inline$BDLGetDebugLevel$570$start#1:
    goto inline$BDLGetDebugLevel$570$label_3#1;

  inline$BDLGetDebugLevel$570$label_3#1:
    havoc inline$BDLGetDebugLevel$570$myNondetVar_0;
    inline$BDLGetDebugLevel$570$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$570$myNondetVar_0;
    goto inline$BDLGetDebugLevel$570$label_1#1;

  inline$BDLGetDebugLevel$570$label_1#1:
    goto inline$BDLGetDebugLevel$570$Return#1;

  inline$BDLGetDebugLevel$570$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$570$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon33_Then#1, inline$BDLDevicePowerIoCompletion$22$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon7#1;

  inline$BDLDevicePowerIoCompletion$22$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_40#1;

  inline$BDLDevicePowerIoCompletion$22$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_40_true#1, inline$BDLDevicePowerIoCompletion$22$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_41#1;

  inline$BDLDevicePowerIoCompletion$22$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_42#1;

  inline$BDLDevicePowerIoCompletion$22$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_41#1;

  inline$BDLDevicePowerIoCompletion$22$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_41_true#1, inline$BDLDevicePowerIoCompletion$22$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$22$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$22$label_43#1;

  inline$BDLDevicePowerIoCompletion$22$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$22$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$22$label_44#1;

  inline$BDLDevicePowerIoCompletion$22$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_44_true#1, inline$BDLDevicePowerIoCompletion$22$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$22$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$22$label_45#1;

  inline$BDLDevicePowerIoCompletion$22$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_45_true#1, inline$BDLDevicePowerIoCompletion$22$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$22$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$22$label_43#1;

  inline$BDLDevicePowerIoCompletion$22$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$22$label_86#1;

  inline$BDLDevicePowerIoCompletion$22$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$22$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$22$label_46#1;

  inline$BDLDevicePowerIoCompletion$22$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$22$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$22$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$22$label_46#1;

  inline$BDLDevicePowerIoCompletion$22$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$22$label_49#1;

  inline$BDLDevicePowerIoCompletion$22$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_50#1;

  inline$BDLDevicePowerIoCompletion$22$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_51#1;

  inline$BDLDevicePowerIoCompletion$22$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_54#1;

  inline$BDLDevicePowerIoCompletion$22$label_54#1:
    inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$22$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$22$label_55#1;

  inline$BDLDevicePowerIoCompletion$22$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_55_true#1, inline$BDLDevicePowerIoCompletion$22$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_56#1;

  inline$BDLDevicePowerIoCompletion$22$label_56#1:
    call inline$BDLDevicePowerIoCompletion$22$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$22$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$22$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$22$anon34_Then#1, inline$BDLDevicePowerIoCompletion$22$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon9#1;

  inline$BDLDevicePowerIoCompletion$22$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_83#1;

  inline$BDLDevicePowerIoCompletion$22$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_59#1;

  inline$BDLDevicePowerIoCompletion$22$label_59#1:
    goto inline$BDLGetDebugLevel$571$Entry#1;

  inline$BDLGetDebugLevel$571$Entry#1:
    goto inline$BDLGetDebugLevel$571$start#1;

  inline$BDLGetDebugLevel$571$start#1:
    goto inline$BDLGetDebugLevel$571$label_3#1;

  inline$BDLGetDebugLevel$571$label_3#1:
    havoc inline$BDLGetDebugLevel$571$myNondetVar_0;
    inline$BDLGetDebugLevel$571$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$571$myNondetVar_0;
    goto inline$BDLGetDebugLevel$571$label_1#1;

  inline$BDLGetDebugLevel$571$label_1#1:
    goto inline$BDLGetDebugLevel$571$Return#1;

  inline$BDLGetDebugLevel$571$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$571$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon35_Then#1, inline$BDLDevicePowerIoCompletion$22$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon11#1;

  inline$BDLDevicePowerIoCompletion$22$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_62#1;

  inline$BDLDevicePowerIoCompletion$22$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_62_true#1, inline$BDLDevicePowerIoCompletion$22$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_63#1;

  inline$BDLDevicePowerIoCompletion$22$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_66#1;

  inline$BDLDevicePowerIoCompletion$22$label_66#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_67#1;

  inline$BDLDevicePowerIoCompletion$22$label_67#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_68#1;

  inline$BDLDevicePowerIoCompletion$22$label_68#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_69#1;

  inline$BDLDevicePowerIoCompletion$22$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$22$label_63#1;

  inline$BDLDevicePowerIoCompletion$22$label_63#1:
    goto inline$BDLGetDebugLevel$572$Entry#1;

  inline$BDLGetDebugLevel$572$Entry#1:
    goto inline$BDLGetDebugLevel$572$start#1;

  inline$BDLGetDebugLevel$572$start#1:
    goto inline$BDLGetDebugLevel$572$label_3#1;

  inline$BDLGetDebugLevel$572$label_3#1:
    havoc inline$BDLGetDebugLevel$572$myNondetVar_0;
    inline$BDLGetDebugLevel$572$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$572$myNondetVar_0;
    goto inline$BDLGetDebugLevel$572$label_1#1;

  inline$BDLGetDebugLevel$572$label_1#1:
    goto inline$BDLGetDebugLevel$572$Return#1;

  inline$BDLGetDebugLevel$572$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$572$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon36_Then#1, inline$BDLDevicePowerIoCompletion$22$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon13#1;

  inline$BDLDevicePowerIoCompletion$22$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_72#1;

  inline$BDLDevicePowerIoCompletion$22$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_72_true#1, inline$BDLDevicePowerIoCompletion$22$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_73#1;

  inline$BDLDevicePowerIoCompletion$22$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_76#1;

  inline$BDLDevicePowerIoCompletion$22$label_76#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_77#1;

  inline$BDLDevicePowerIoCompletion$22$label_77#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_78#1;

  inline$BDLDevicePowerIoCompletion$22$label_78#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_79#1;

  inline$BDLDevicePowerIoCompletion$22$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$22$label_73#1;

  inline$BDLDevicePowerIoCompletion$22$label_73#1:
    goto inline$BDLGetDebugLevel$573$Entry#1;

  inline$BDLGetDebugLevel$573$Entry#1:
    goto inline$BDLGetDebugLevel$573$start#1;

  inline$BDLGetDebugLevel$573$start#1:
    goto inline$BDLGetDebugLevel$573$label_3#1;

  inline$BDLGetDebugLevel$573$label_3#1:
    havoc inline$BDLGetDebugLevel$573$myNondetVar_0;
    inline$BDLGetDebugLevel$573$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$573$myNondetVar_0;
    goto inline$BDLGetDebugLevel$573$label_1#1;

  inline$BDLGetDebugLevel$573$label_1#1:
    goto inline$BDLGetDebugLevel$573$Return#1;

  inline$BDLGetDebugLevel$573$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$573$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon37_Then#1, inline$BDLDevicePowerIoCompletion$22$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon15#1;

  inline$BDLDevicePowerIoCompletion$22$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_82#1;

  inline$BDLDevicePowerIoCompletion$22$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_82_true#1, inline$BDLDevicePowerIoCompletion$22$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_83#1;

  inline$BDLDevicePowerIoCompletion$22$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_84#1;

  inline$BDLDevicePowerIoCompletion$22$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_83#1;

  inline$BDLDevicePowerIoCompletion$22$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_85#1;

  inline$BDLDevicePowerIoCompletion$22$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_86#1;

  inline$BDLDevicePowerIoCompletion$22$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$22$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$22$anon38_Then#1, inline$BDLDevicePowerIoCompletion$22$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon17#1;

  inline$BDLDevicePowerIoCompletion$22$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_89#1;

  inline$BDLDevicePowerIoCompletion$22$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$22$anon39_Then#1, inline$BDLDevicePowerIoCompletion$22$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon19#1;

  inline$BDLDevicePowerIoCompletion$22$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_92#1;

  inline$BDLDevicePowerIoCompletion$22$label_92#1:
    goto inline$storm_IoCompleteRequest$45$Entry#1;

  inline$storm_IoCompleteRequest$45$Entry#1:
    inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$22$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$45$start#1;

  inline$storm_IoCompleteRequest$45$start#1:
    inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$45$label_3#1;

  inline$storm_IoCompleteRequest$45$label_3#1:
    call inline$storm_IoCompleteRequest$45$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$45$label_6#1;

  inline$storm_IoCompleteRequest$45$label_6#1:
    goto inline$storm_IoCompleteRequest$45$label_6_true#1, inline$storm_IoCompleteRequest$45$label_6_false#1;

  inline$storm_IoCompleteRequest$45$label_6_false#1:
    assume inline$storm_IoCompleteRequest$45$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$45$label_7#1;

  inline$storm_IoCompleteRequest$45$label_6_true#1:
    assume inline$storm_IoCompleteRequest$45$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$45$label_8#1;

  inline$storm_IoCompleteRequest$45$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$45$anon3_Then#1, inline$storm_IoCompleteRequest$45$anon3_Else#1;

  inline$storm_IoCompleteRequest$45$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$45$anon1#1;

  inline$storm_IoCompleteRequest$45$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$45$label_9#1;

  inline$storm_IoCompleteRequest$45$label_9#1:
    goto inline$storm_IoCompleteRequest$45$label_9_true#1, inline$storm_IoCompleteRequest$45$label_9_false#1;

  inline$storm_IoCompleteRequest$45$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$45$label_10#1;

  inline$storm_IoCompleteRequest$45$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$45$label_1#1;

  inline$storm_IoCompleteRequest$45$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$45$label_7#1;

  inline$storm_IoCompleteRequest$45$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$45$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$45$label_1#1;

  inline$storm_IoCompleteRequest$45$label_1#1:
    goto inline$storm_IoCompleteRequest$45$Return#1;

  inline$storm_IoCompleteRequest$45$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$45$Return#1;

  inline$storm_IoCompleteRequest$45$Return#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon40_Then#1, inline$BDLDevicePowerIoCompletion$22$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon21#1;

  inline$BDLDevicePowerIoCompletion$22$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_95#1;

  inline$BDLDevicePowerIoCompletion$22$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$22$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$22$anon41_Then#1, inline$BDLDevicePowerIoCompletion$22$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon23#1;

  inline$BDLDevicePowerIoCompletion$22$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_98#1;

  inline$BDLDevicePowerIoCompletion$22$label_98#1:
    goto inline$BDLGetDebugLevel$574$Entry#1;

  inline$BDLGetDebugLevel$574$Entry#1:
    goto inline$BDLGetDebugLevel$574$start#1;

  inline$BDLGetDebugLevel$574$start#1:
    goto inline$BDLGetDebugLevel$574$label_3#1;

  inline$BDLGetDebugLevel$574$label_3#1:
    havoc inline$BDLGetDebugLevel$574$myNondetVar_0;
    inline$BDLGetDebugLevel$574$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$574$myNondetVar_0;
    goto inline$BDLGetDebugLevel$574$label_1#1;

  inline$BDLGetDebugLevel$574$label_1#1:
    goto inline$BDLGetDebugLevel$574$Return#1;

  inline$BDLGetDebugLevel$574$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$574$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon42_Then#1, inline$BDLDevicePowerIoCompletion$22$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon25#1;

  inline$BDLDevicePowerIoCompletion$22$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_101#1;

  inline$BDLDevicePowerIoCompletion$22$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_101_true#1, inline$BDLDevicePowerIoCompletion$22$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_102#1;

  inline$BDLDevicePowerIoCompletion$22$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_105#1;

  inline$BDLDevicePowerIoCompletion$22$label_105#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_106#1;

  inline$BDLDevicePowerIoCompletion$22$label_106#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_107#1;

  inline$BDLDevicePowerIoCompletion$22$label_107#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_108#1;

  inline$BDLDevicePowerIoCompletion$22$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$22$label_102#1;

  inline$BDLDevicePowerIoCompletion$22$label_102#1:
    goto inline$BDLGetDebugLevel$575$Entry#1;

  inline$BDLGetDebugLevel$575$Entry#1:
    goto inline$BDLGetDebugLevel$575$start#1;

  inline$BDLGetDebugLevel$575$start#1:
    goto inline$BDLGetDebugLevel$575$label_3#1;

  inline$BDLGetDebugLevel$575$label_3#1:
    havoc inline$BDLGetDebugLevel$575$myNondetVar_0;
    inline$BDLGetDebugLevel$575$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$575$myNondetVar_0;
    goto inline$BDLGetDebugLevel$575$label_1#1;

  inline$BDLGetDebugLevel$575$label_1#1:
    goto inline$BDLGetDebugLevel$575$Return#1;

  inline$BDLGetDebugLevel$575$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$575$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon43_Then#1, inline$BDLDevicePowerIoCompletion$22$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon27#1;

  inline$BDLDevicePowerIoCompletion$22$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_111#1;

  inline$BDLDevicePowerIoCompletion$22$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_111_true#1, inline$BDLDevicePowerIoCompletion$22$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_112#1;

  inline$BDLDevicePowerIoCompletion$22$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_115#1;

  inline$BDLDevicePowerIoCompletion$22$label_115#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_116#1;

  inline$BDLDevicePowerIoCompletion$22$label_116#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_117#1;

  inline$BDLDevicePowerIoCompletion$22$label_117#1:
    call inline$BDLDevicePowerIoCompletion$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$22$label_118#1;

  inline$BDLDevicePowerIoCompletion$22$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$22$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$22$label_112#1;

  inline$BDLDevicePowerIoCompletion$22$label_112#1:
    goto inline$BDLGetDebugLevel$576$Entry#1;

  inline$BDLGetDebugLevel$576$Entry#1:
    goto inline$BDLGetDebugLevel$576$start#1;

  inline$BDLGetDebugLevel$576$start#1:
    goto inline$BDLGetDebugLevel$576$label_3#1;

  inline$BDLGetDebugLevel$576$label_3#1:
    havoc inline$BDLGetDebugLevel$576$myNondetVar_0;
    inline$BDLGetDebugLevel$576$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$576$myNondetVar_0;
    goto inline$BDLGetDebugLevel$576$label_1#1;

  inline$BDLGetDebugLevel$576$label_1#1:
    goto inline$BDLGetDebugLevel$576$Return#1;

  inline$BDLGetDebugLevel$576$Return#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$576$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$22$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$22$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$22$anon44_Then#1, inline$BDLDevicePowerIoCompletion$22$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$22$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$anon29#1;

  inline$BDLDevicePowerIoCompletion$22$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_121#1;

  inline$BDLDevicePowerIoCompletion$22$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_121_true#1, inline$BDLDevicePowerIoCompletion$22$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$22$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_122#1;

  inline$BDLDevicePowerIoCompletion$22$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$22$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$22$label_123#1;

  inline$BDLDevicePowerIoCompletion$22$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$22$label_122#1;

  inline$BDLDevicePowerIoCompletion$22$label_122#1:
    inline$BDLDevicePowerIoCompletion$22$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$22$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$22$label_1#1;

  inline$BDLDevicePowerIoCompletion$22$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$22$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$22$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$22$Return#1;

  inline$BDLDevicePowerIoCompletion$22$Return#1:
    inline$CallCompletionRoutine$22$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$22$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$22$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$22$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$22$anon13_Then#1, inline$CallCompletionRoutine$22$anon13_Else#1;

  inline$CallCompletionRoutine$22$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$22$anon7#1;

  inline$CallCompletionRoutine$22$anon7#1:
    goto inline$CallCompletionRoutine$22$label_20_icall_return#1;

  inline$CallCompletionRoutine$22$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$22$Return#1;

  inline$CallCompletionRoutine$22$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$22$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$22$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$22$Entry#1;

  inline$BDLCallDriverCompletionRoutine$22$Entry#1:
    inline$BDLCallDriverCompletionRoutine$22$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$22$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$22$start#1;

  inline$BDLCallDriverCompletionRoutine$22$start#1:
    inline$BDLCallDriverCompletionRoutine$22$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$22$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$22$label_3#1;

  inline$BDLCallDriverCompletionRoutine$22$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$22$label_3_true#1, inline$BDLCallDriverCompletionRoutine$22$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$22$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$22$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$22$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$22$label_4#1;

  inline$BDLCallDriverCompletionRoutine$22$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$22$label_6#1;

  inline$BDLCallDriverCompletionRoutine$22$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$22$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$22$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$22$label_5#1;

  inline$BDLCallDriverCompletionRoutine$22$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$22$label_6#1;

  inline$BDLCallDriverCompletionRoutine$22$label_6#1:
    goto inline$storm_KeSetEvent$24$Entry#1;

  inline$storm_KeSetEvent$24$Entry#1:
    inline$storm_KeSetEvent$24$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$22$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$24$start#1;

  inline$storm_KeSetEvent$24$start#1:
    inline$storm_KeSetEvent$24$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$24$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$24$label_3#1;

  inline$storm_KeSetEvent$24$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$24$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$24$label_1#1;

  inline$storm_KeSetEvent$24$label_1#1:
    goto inline$storm_KeSetEvent$24$Return#1;

  inline$storm_KeSetEvent$24$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$22$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$22$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$22$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$22$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$22$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$22$anon1#1;

  inline$BDLCallDriverCompletionRoutine$22$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$22$label_9#1;

  inline$BDLCallDriverCompletionRoutine$22$label_9#1:
    inline$BDLCallDriverCompletionRoutine$22$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$22$label_1#1;

  inline$BDLCallDriverCompletionRoutine$22$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$22$Return#1;

  inline$BDLCallDriverCompletionRoutine$22$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$22$Return#1;

  inline$BDLCallDriverCompletionRoutine$22$Return#1:
    inline$CallCompletionRoutine$22$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$22$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$22$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$22$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$22$anon12_Then#1, inline$CallCompletionRoutine$22$anon12_Else#1;

  inline$CallCompletionRoutine$22$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$22$anon5#1;

  inline$CallCompletionRoutine$22$anon5#1:
    goto inline$CallCompletionRoutine$22$label_20_icall_return#1;

  inline$CallCompletionRoutine$22$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$22$label_23#1;

  inline$CallCompletionRoutine$22$label_23#1:
    inline$CallCompletionRoutine$22$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$22$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$22$label_24#1;

  inline$CallCompletionRoutine$22$label_24#1:
    goto inline$CallCompletionRoutine$22$label_24_true#1, inline$CallCompletionRoutine$22$label_24_false#1;

  inline$CallCompletionRoutine$22$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$22$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$22$label_1#1;

  inline$CallCompletionRoutine$22$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$22$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$22$label_25#1;

  inline$CallCompletionRoutine$22$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$22$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$22$label_1#1;

  inline$CallCompletionRoutine$22$label_1#1:
    goto inline$CallCompletionRoutine$22$Return#1;

  inline$CallCompletionRoutine$22$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$22$Return#1;

  inline$CallCompletionRoutine$22$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$22$Return#1;

  inline$CallCompletionRoutine$22$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$22$Return#1;

  inline$CallCompletionRoutine$22$Return#1:
    goto inline$storm_IoCallDriver$11$label_33$1#1;

  inline$storm_IoCallDriver$11$label_33$1#1:
    goto inline$storm_IoCallDriver$11$anon14_Then#1, inline$storm_IoCallDriver$11$anon14_Else#1;

  inline$storm_IoCallDriver$11$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$11$anon8#1;

  inline$storm_IoCallDriver$11$anon8#1:
    goto inline$storm_IoCallDriver$11$label_36#1;

  inline$storm_IoCallDriver$11$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$11$Return#1;

  inline$storm_IoCallDriver$11$label_27_case_1#1:
    assume inline$storm_IoCallDriver$11$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$11$label_29#1;

  inline$storm_IoCallDriver$11$label_29#1:
    inline$storm_IoCallDriver$11$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$11$label_37#1;

  inline$storm_IoCallDriver$11$label_37#1:
    goto inline$storm_IoCallDriver$11$label_38#1;

  inline$storm_IoCallDriver$11$label_38#1:
    goto inline$storm_IoCallDriver$11$label_39#1;

  inline$storm_IoCallDriver$11$label_39#1:
    goto inline$CallCompletionRoutine$23$Entry#1;

  inline$CallCompletionRoutine$23$Entry#1:
    inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$23$start#1;

  inline$CallCompletionRoutine$23$start#1:
    inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$23$label_3#1;

  inline$CallCompletionRoutine$23$label_3#1:
    goto inline$CallCompletionRoutine$23$label_4#1;

  inline$CallCompletionRoutine$23$label_4#1:
    goto inline$CallCompletionRoutine$23$label_5#1;

  inline$CallCompletionRoutine$23$label_5#1:
    goto inline$CallCompletionRoutine$23$label_6#1;

  inline$CallCompletionRoutine$23$label_6#1:
    goto inline$CallCompletionRoutine$23$label_7#1;

  inline$CallCompletionRoutine$23$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$119$Entry#1;

  inline$IoGetCurrentIrpStackLocation$119$Entry#1:
    inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$119$start#1;

  inline$IoGetCurrentIrpStackLocation$119$start#1:
    inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$119$label_3#1;

  inline$IoGetCurrentIrpStackLocation$119$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$119$label_3_true#1, inline$IoGetCurrentIrpStackLocation$119$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$119$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$119$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$119$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$119$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$119$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$119$label_4#1;

  inline$IoGetCurrentIrpStackLocation$119$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$119$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$119$label_6#1;

  inline$IoGetCurrentIrpStackLocation$119$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$119$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$119$label_7#1;

  inline$IoGetCurrentIrpStackLocation$119$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$119$label_5#1;

  inline$IoGetCurrentIrpStackLocation$119$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$119$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$119$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$119$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$119$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$119$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$119$label_5#1;

  inline$IoGetCurrentIrpStackLocation$119$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$119$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$119$label_1#1;

  inline$IoGetCurrentIrpStackLocation$119$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$119$Return#1;

  inline$IoGetCurrentIrpStackLocation$119$Return#1:
    goto inline$CallCompletionRoutine$23$label_7$1#1;

  inline$CallCompletionRoutine$23$label_7$1#1:
    goto inline$CallCompletionRoutine$23$anon10_Then#1, inline$CallCompletionRoutine$23$anon10_Else#1;

  inline$CallCompletionRoutine$23$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$23$anon1#1;

  inline$CallCompletionRoutine$23$anon1#1:
    goto inline$CallCompletionRoutine$23$label_10#1;

  inline$CallCompletionRoutine$23$label_10#1:
    goto inline$CallCompletionRoutine$23$label_11#1;

  inline$CallCompletionRoutine$23$label_11#1:
    havoc inline$CallCompletionRoutine$23$myNondetVar_0;
    inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$23$myNondetVar_0;
    goto inline$CallCompletionRoutine$23$label_12#1;

  inline$CallCompletionRoutine$23$label_12#1:
    havoc inline$CallCompletionRoutine$23$myNondetVar_0;
    inline$CallCompletionRoutine$23$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$23$myNondetVar_0;
    goto inline$CallCompletionRoutine$23$label_13#1;

  inline$CallCompletionRoutine$23$label_13#1:
    havoc inline$CallCompletionRoutine$23$myNondetVar_0;
    goto inline$CallCompletionRoutine$23$label_14#1;

  inline$CallCompletionRoutine$23$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$120$Entry#1;

  inline$IoGetCurrentIrpStackLocation$120$Entry#1:
    inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$120$start#1;

  inline$IoGetCurrentIrpStackLocation$120$start#1:
    inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$120$label_3#1;

  inline$IoGetCurrentIrpStackLocation$120$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$120$label_3_true#1, inline$IoGetCurrentIrpStackLocation$120$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$120$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$120$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$120$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$120$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$120$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$120$label_4#1;

  inline$IoGetCurrentIrpStackLocation$120$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$120$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$120$label_6#1;

  inline$IoGetCurrentIrpStackLocation$120$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$120$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$120$label_7#1;

  inline$IoGetCurrentIrpStackLocation$120$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$120$label_5#1;

  inline$IoGetCurrentIrpStackLocation$120$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$120$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$120$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$120$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$120$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$120$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$120$label_5#1;

  inline$IoGetCurrentIrpStackLocation$120$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$120$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$120$label_1#1;

  inline$IoGetCurrentIrpStackLocation$120$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$120$Return#1;

  inline$IoGetCurrentIrpStackLocation$120$Return#1:
    goto inline$CallCompletionRoutine$23$label_14$1#1;

  inline$CallCompletionRoutine$23$label_14$1#1:
    goto inline$CallCompletionRoutine$23$anon11_Then#1, inline$CallCompletionRoutine$23$anon11_Else#1;

  inline$CallCompletionRoutine$23$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$23$anon3#1;

  inline$CallCompletionRoutine$23$anon3#1:
    goto inline$CallCompletionRoutine$23$label_17#1;

  inline$CallCompletionRoutine$23$label_17#1:
    goto inline$CallCompletionRoutine$23$label_18#1;

  inline$CallCompletionRoutine$23$label_18#1:
    goto inline$CallCompletionRoutine$23$label_18_true#1, inline$CallCompletionRoutine$23$label_18_false#1;

  inline$CallCompletionRoutine$23$label_18_false#1:
    assume inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$23$label_1#1;

  inline$CallCompletionRoutine$23$label_18_true#1:
    assume inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$23$label_19#1;

  inline$CallCompletionRoutine$23$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$23$label_20#1;

  inline$CallCompletionRoutine$23$label_20#1:
    goto inline$CallCompletionRoutine$23$label_20_icall_1#1, inline$CallCompletionRoutine$23$label_20_icall_2#1, inline$CallCompletionRoutine$23$label_20_icall_3#1;

  inline$CallCompletionRoutine$23$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$23$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$23$Entry#1;

  inline$BDLSystemPowerIoCompletion$23$Entry#1:
    inline$BDLSystemPowerIoCompletion$23$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$23$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$23$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$23$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$23$start#1;

  inline$BDLSystemPowerIoCompletion$23$start#1:
    call inline$BDLSystemPowerIoCompletion$23$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$23$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$23$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$23$label_3#1;

  inline$BDLSystemPowerIoCompletion$23$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_4#1;

  inline$BDLSystemPowerIoCompletion$23$label_4#1:
    inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_5#1;

  inline$BDLSystemPowerIoCompletion$23$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_6#1;

  inline$BDLSystemPowerIoCompletion$23$label_6#1:
    inline$BDLSystemPowerIoCompletion$23$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$23$label_7#1;

  inline$BDLSystemPowerIoCompletion$23$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_8#1;

  inline$BDLSystemPowerIoCompletion$23$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$23$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$23$label_9#1;

  inline$BDLSystemPowerIoCompletion$23$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_10#1;

  inline$BDLSystemPowerIoCompletion$23$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$122$Entry#1;

  inline$IoGetCurrentIrpStackLocation$122$Entry#1:
    inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$122$start#1;

  inline$IoGetCurrentIrpStackLocation$122$start#1:
    inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$122$label_3#1;

  inline$IoGetCurrentIrpStackLocation$122$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$122$label_3_true#1, inline$IoGetCurrentIrpStackLocation$122$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$122$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$122$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$122$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$122$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$122$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$122$label_4#1;

  inline$IoGetCurrentIrpStackLocation$122$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$122$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$122$label_6#1;

  inline$IoGetCurrentIrpStackLocation$122$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$122$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$122$label_7#1;

  inline$IoGetCurrentIrpStackLocation$122$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$122$label_5#1;

  inline$IoGetCurrentIrpStackLocation$122$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$122$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$122$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$122$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$122$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$122$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$122$label_5#1;

  inline$IoGetCurrentIrpStackLocation$122$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$122$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$122$label_1#1;

  inline$IoGetCurrentIrpStackLocation$122$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$122$Return#1;

  inline$IoGetCurrentIrpStackLocation$122$Return#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon36_Then#1, inline$BDLSystemPowerIoCompletion$23$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon1#1;

  inline$BDLSystemPowerIoCompletion$23$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_13#1;

  inline$BDLSystemPowerIoCompletion$23$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_14#1;

  inline$BDLSystemPowerIoCompletion$23$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_15#1;

  inline$BDLSystemPowerIoCompletion$23$label_15#1:
    goto inline$BDLGetDebugLevel$598$Entry#1;

  inline$BDLGetDebugLevel$598$Entry#1:
    goto inline$BDLGetDebugLevel$598$start#1;

  inline$BDLGetDebugLevel$598$start#1:
    goto inline$BDLGetDebugLevel$598$label_3#1;

  inline$BDLGetDebugLevel$598$label_3#1:
    havoc inline$BDLGetDebugLevel$598$myNondetVar_0;
    inline$BDLGetDebugLevel$598$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$598$myNondetVar_0;
    goto inline$BDLGetDebugLevel$598$label_1#1;

  inline$BDLGetDebugLevel$598$label_1#1:
    goto inline$BDLGetDebugLevel$598$Return#1;

  inline$BDLGetDebugLevel$598$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$598$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon37_Then#1, inline$BDLSystemPowerIoCompletion$23$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon3#1;

  inline$BDLSystemPowerIoCompletion$23$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_18#1;

  inline$BDLSystemPowerIoCompletion$23$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_18_true#1, inline$BDLSystemPowerIoCompletion$23$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_19#1;

  inline$BDLSystemPowerIoCompletion$23$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_22#1;

  inline$BDLSystemPowerIoCompletion$23$label_22#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_23#1;

  inline$BDLSystemPowerIoCompletion$23$label_23#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_24#1;

  inline$BDLSystemPowerIoCompletion$23$label_24#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_25#1;

  inline$BDLSystemPowerIoCompletion$23$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$23$label_19#1;

  inline$BDLSystemPowerIoCompletion$23$label_19#1:
    goto inline$BDLGetDebugLevel$599$Entry#1;

  inline$BDLGetDebugLevel$599$Entry#1:
    goto inline$BDLGetDebugLevel$599$start#1;

  inline$BDLGetDebugLevel$599$start#1:
    goto inline$BDLGetDebugLevel$599$label_3#1;

  inline$BDLGetDebugLevel$599$label_3#1:
    havoc inline$BDLGetDebugLevel$599$myNondetVar_0;
    inline$BDLGetDebugLevel$599$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$599$myNondetVar_0;
    goto inline$BDLGetDebugLevel$599$label_1#1;

  inline$BDLGetDebugLevel$599$label_1#1:
    goto inline$BDLGetDebugLevel$599$Return#1;

  inline$BDLGetDebugLevel$599$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$599$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon38_Then#1, inline$BDLSystemPowerIoCompletion$23$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon5#1;

  inline$BDLSystemPowerIoCompletion$23$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_28#1;

  inline$BDLSystemPowerIoCompletion$23$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_28_true#1, inline$BDLSystemPowerIoCompletion$23$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_29#1;

  inline$BDLSystemPowerIoCompletion$23$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_32#1;

  inline$BDLSystemPowerIoCompletion$23$label_32#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_33#1;

  inline$BDLSystemPowerIoCompletion$23$label_33#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_34#1;

  inline$BDLSystemPowerIoCompletion$23$label_34#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_35#1;

  inline$BDLSystemPowerIoCompletion$23$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$23$label_29#1;

  inline$BDLSystemPowerIoCompletion$23$label_29#1:
    goto inline$BDLGetDebugLevel$600$Entry#1;

  inline$BDLGetDebugLevel$600$Entry#1:
    goto inline$BDLGetDebugLevel$600$start#1;

  inline$BDLGetDebugLevel$600$start#1:
    goto inline$BDLGetDebugLevel$600$label_3#1;

  inline$BDLGetDebugLevel$600$label_3#1:
    havoc inline$BDLGetDebugLevel$600$myNondetVar_0;
    inline$BDLGetDebugLevel$600$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$600$myNondetVar_0;
    goto inline$BDLGetDebugLevel$600$label_1#1;

  inline$BDLGetDebugLevel$600$label_1#1:
    goto inline$BDLGetDebugLevel$600$Return#1;

  inline$BDLGetDebugLevel$600$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$600$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon39_Then#1, inline$BDLSystemPowerIoCompletion$23$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon7#1;

  inline$BDLSystemPowerIoCompletion$23$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_38#1;

  inline$BDLSystemPowerIoCompletion$23$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_38_true#1, inline$BDLSystemPowerIoCompletion$23$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_39#1;

  inline$BDLSystemPowerIoCompletion$23$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_40#1;

  inline$BDLSystemPowerIoCompletion$23$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_39#1;

  inline$BDLSystemPowerIoCompletion$23$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_39_true#1, inline$BDLSystemPowerIoCompletion$23$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_41#1;

  inline$BDLSystemPowerIoCompletion$23$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$23$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$23$label_107#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$23$label_108#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$23$label_108#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$23$label_108#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$23$label_108#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$23$label_108#1;

  inline$BDLSystemPowerIoCompletion$23$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_109#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$23$label_107#1;

  inline$BDLSystemPowerIoCompletion$23$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_109#1;

  inline$BDLSystemPowerIoCompletion$23$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$23$label_106#1;

  inline$BDLSystemPowerIoCompletion$23$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_106_true#1, inline$BDLSystemPowerIoCompletion$23$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_142#1;

  inline$BDLSystemPowerIoCompletion$23$label_142#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_143#1;

  inline$BDLSystemPowerIoCompletion$23$label_143#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_144#1;

  inline$BDLSystemPowerIoCompletion$23$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_109#1;

  inline$BDLSystemPowerIoCompletion$23$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_109#1;

  inline$BDLSystemPowerIoCompletion$23$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$23$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$23$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$23$myNondetVar_0, inline$BDLSystemPowerIoCompletion$23$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$23$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$23$anon50_Then#1, inline$BDLSystemPowerIoCompletion$23$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon29#1;

  inline$BDLSystemPowerIoCompletion$23$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_112#1;

  inline$BDLSystemPowerIoCompletion$23$label_112#1:
    inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$23$label_113#1;

  inline$BDLSystemPowerIoCompletion$23$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_113_true#1, inline$BDLSystemPowerIoCompletion$23$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$23$label_114#1;

  inline$BDLSystemPowerIoCompletion$23$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_116#1;

  inline$BDLSystemPowerIoCompletion$23$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_117#1;

  inline$BDLSystemPowerIoCompletion$23$label_117#1:
    goto inline$BDLGetDebugLevel$607$Entry#1;

  inline$BDLGetDebugLevel$607$Entry#1:
    goto inline$BDLGetDebugLevel$607$start#1;

  inline$BDLGetDebugLevel$607$start#1:
    goto inline$BDLGetDebugLevel$607$label_3#1;

  inline$BDLGetDebugLevel$607$label_3#1:
    havoc inline$BDLGetDebugLevel$607$myNondetVar_0;
    inline$BDLGetDebugLevel$607$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$607$myNondetVar_0;
    goto inline$BDLGetDebugLevel$607$label_1#1;

  inline$BDLGetDebugLevel$607$label_1#1:
    goto inline$BDLGetDebugLevel$607$Return#1;

  inline$BDLGetDebugLevel$607$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$607$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon51_Then#1, inline$BDLSystemPowerIoCompletion$23$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon31#1;

  inline$BDLSystemPowerIoCompletion$23$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_120#1;

  inline$BDLSystemPowerIoCompletion$23$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_120_true#1, inline$BDLSystemPowerIoCompletion$23$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_121#1;

  inline$BDLSystemPowerIoCompletion$23$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_124#1;

  inline$BDLSystemPowerIoCompletion$23$label_124#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_125#1;

  inline$BDLSystemPowerIoCompletion$23$label_125#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_126#1;

  inline$BDLSystemPowerIoCompletion$23$label_126#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_127#1;

  inline$BDLSystemPowerIoCompletion$23$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$23$label_121#1;

  inline$BDLSystemPowerIoCompletion$23$label_121#1:
    goto inline$BDLGetDebugLevel$608$Entry#1;

  inline$BDLGetDebugLevel$608$Entry#1:
    goto inline$BDLGetDebugLevel$608$start#1;

  inline$BDLGetDebugLevel$608$start#1:
    goto inline$BDLGetDebugLevel$608$label_3#1;

  inline$BDLGetDebugLevel$608$label_3#1:
    havoc inline$BDLGetDebugLevel$608$myNondetVar_0;
    inline$BDLGetDebugLevel$608$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$608$myNondetVar_0;
    goto inline$BDLGetDebugLevel$608$label_1#1;

  inline$BDLGetDebugLevel$608$label_1#1:
    goto inline$BDLGetDebugLevel$608$Return#1;

  inline$BDLGetDebugLevel$608$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$608$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon52_Then#1, inline$BDLSystemPowerIoCompletion$23$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon33#1;

  inline$BDLSystemPowerIoCompletion$23$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_130#1;

  inline$BDLSystemPowerIoCompletion$23$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_130_true#1, inline$BDLSystemPowerIoCompletion$23$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_131#1;

  inline$BDLSystemPowerIoCompletion$23$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_134#1;

  inline$BDLSystemPowerIoCompletion$23$label_134#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_135#1;

  inline$BDLSystemPowerIoCompletion$23$label_135#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_136#1;

  inline$BDLSystemPowerIoCompletion$23$label_136#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_137#1;

  inline$BDLSystemPowerIoCompletion$23$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$23$label_131#1;

  inline$BDLSystemPowerIoCompletion$23$label_131#1:
    goto inline$BDLGetDebugLevel$609$Entry#1;

  inline$BDLGetDebugLevel$609$Entry#1:
    goto inline$BDLGetDebugLevel$609$start#1;

  inline$BDLGetDebugLevel$609$start#1:
    goto inline$BDLGetDebugLevel$609$label_3#1;

  inline$BDLGetDebugLevel$609$label_3#1:
    havoc inline$BDLGetDebugLevel$609$myNondetVar_0;
    inline$BDLGetDebugLevel$609$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$609$myNondetVar_0;
    goto inline$BDLGetDebugLevel$609$label_1#1;

  inline$BDLGetDebugLevel$609$label_1#1:
    goto inline$BDLGetDebugLevel$609$Return#1;

  inline$BDLGetDebugLevel$609$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$609$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon53_Then#1, inline$BDLSystemPowerIoCompletion$23$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon35#1;

  inline$BDLSystemPowerIoCompletion$23$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_140#1;

  inline$BDLSystemPowerIoCompletion$23$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_140_true#1, inline$BDLSystemPowerIoCompletion$23$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_67#1;

  inline$BDLSystemPowerIoCompletion$23$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_141#1;

  inline$BDLSystemPowerIoCompletion$23$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_67#1;

  inline$BDLSystemPowerIoCompletion$23$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$23$label_115#1;

  inline$BDLSystemPowerIoCompletion$23$label_115#1:
    inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$23$label_80#1;

  inline$BDLSystemPowerIoCompletion$23$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$23$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_42#1;

  inline$BDLSystemPowerIoCompletion$23$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$23$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$23$label_43#1;

  inline$BDLSystemPowerIoCompletion$23$label_43#1:
    goto inline$BDLGetDebugLevel$601$Entry#1;

  inline$BDLGetDebugLevel$601$Entry#1:
    goto inline$BDLGetDebugLevel$601$start#1;

  inline$BDLGetDebugLevel$601$start#1:
    goto inline$BDLGetDebugLevel$601$label_3#1;

  inline$BDLGetDebugLevel$601$label_3#1:
    havoc inline$BDLGetDebugLevel$601$myNondetVar_0;
    inline$BDLGetDebugLevel$601$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$601$myNondetVar_0;
    goto inline$BDLGetDebugLevel$601$label_1#1;

  inline$BDLGetDebugLevel$601$label_1#1:
    goto inline$BDLGetDebugLevel$601$Return#1;

  inline$BDLGetDebugLevel$601$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$601$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon40_Then#1, inline$BDLSystemPowerIoCompletion$23$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon9#1;

  inline$BDLSystemPowerIoCompletion$23$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_46#1;

  inline$BDLSystemPowerIoCompletion$23$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_46_true#1, inline$BDLSystemPowerIoCompletion$23$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_47#1;

  inline$BDLSystemPowerIoCompletion$23$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_50#1;

  inline$BDLSystemPowerIoCompletion$23$label_50#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_51#1;

  inline$BDLSystemPowerIoCompletion$23$label_51#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_52#1;

  inline$BDLSystemPowerIoCompletion$23$label_52#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_53#1;

  inline$BDLSystemPowerIoCompletion$23$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$23$label_47#1;

  inline$BDLSystemPowerIoCompletion$23$label_47#1:
    goto inline$BDLGetDebugLevel$602$Entry#1;

  inline$BDLGetDebugLevel$602$Entry#1:
    goto inline$BDLGetDebugLevel$602$start#1;

  inline$BDLGetDebugLevel$602$start#1:
    goto inline$BDLGetDebugLevel$602$label_3#1;

  inline$BDLGetDebugLevel$602$label_3#1:
    havoc inline$BDLGetDebugLevel$602$myNondetVar_0;
    inline$BDLGetDebugLevel$602$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$602$myNondetVar_0;
    goto inline$BDLGetDebugLevel$602$label_1#1;

  inline$BDLGetDebugLevel$602$label_1#1:
    goto inline$BDLGetDebugLevel$602$Return#1;

  inline$BDLGetDebugLevel$602$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$602$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon41_Then#1, inline$BDLSystemPowerIoCompletion$23$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon11#1;

  inline$BDLSystemPowerIoCompletion$23$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_56#1;

  inline$BDLSystemPowerIoCompletion$23$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_56_true#1, inline$BDLSystemPowerIoCompletion$23$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_57#1;

  inline$BDLSystemPowerIoCompletion$23$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_60#1;

  inline$BDLSystemPowerIoCompletion$23$label_60#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_61#1;

  inline$BDLSystemPowerIoCompletion$23$label_61#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_62#1;

  inline$BDLSystemPowerIoCompletion$23$label_62#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_63#1;

  inline$BDLSystemPowerIoCompletion$23$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$23$label_57#1;

  inline$BDLSystemPowerIoCompletion$23$label_57#1:
    goto inline$BDLGetDebugLevel$603$Entry#1;

  inline$BDLGetDebugLevel$603$Entry#1:
    goto inline$BDLGetDebugLevel$603$start#1;

  inline$BDLGetDebugLevel$603$start#1:
    goto inline$BDLGetDebugLevel$603$label_3#1;

  inline$BDLGetDebugLevel$603$label_3#1:
    havoc inline$BDLGetDebugLevel$603$myNondetVar_0;
    inline$BDLGetDebugLevel$603$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$603$myNondetVar_0;
    goto inline$BDLGetDebugLevel$603$label_1#1;

  inline$BDLGetDebugLevel$603$label_1#1:
    goto inline$BDLGetDebugLevel$603$Return#1;

  inline$BDLGetDebugLevel$603$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$603$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon42_Then#1, inline$BDLSystemPowerIoCompletion$23$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon13#1;

  inline$BDLSystemPowerIoCompletion$23$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_66#1;

  inline$BDLSystemPowerIoCompletion$23$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_66_true#1, inline$BDLSystemPowerIoCompletion$23$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_67#1;

  inline$BDLSystemPowerIoCompletion$23$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_70#1;

  inline$BDLSystemPowerIoCompletion$23$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_67#1;

  inline$BDLSystemPowerIoCompletion$23$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$23$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$23$anon43_Then#1, inline$BDLSystemPowerIoCompletion$23$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon15#1;

  inline$BDLSystemPowerIoCompletion$23$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_71#1;

  inline$BDLSystemPowerIoCompletion$23$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$23$anon44_Then#1, inline$BDLSystemPowerIoCompletion$23$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon17#1;

  inline$BDLSystemPowerIoCompletion$23$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_74#1;

  inline$BDLSystemPowerIoCompletion$23$label_74#1:
    goto inline$storm_IoCompleteRequest$48$Entry#1;

  inline$storm_IoCompleteRequest$48$Entry#1:
    inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$23$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$48$start#1;

  inline$storm_IoCompleteRequest$48$start#1:
    inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$48$label_3#1;

  inline$storm_IoCompleteRequest$48$label_3#1:
    call inline$storm_IoCompleteRequest$48$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$48$label_6#1;

  inline$storm_IoCompleteRequest$48$label_6#1:
    goto inline$storm_IoCompleteRequest$48$label_6_true#1, inline$storm_IoCompleteRequest$48$label_6_false#1;

  inline$storm_IoCompleteRequest$48$label_6_false#1:
    assume inline$storm_IoCompleteRequest$48$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$48$label_7#1;

  inline$storm_IoCompleteRequest$48$label_6_true#1:
    assume inline$storm_IoCompleteRequest$48$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$48$label_8#1;

  inline$storm_IoCompleteRequest$48$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$48$anon3_Then#1, inline$storm_IoCompleteRequest$48$anon3_Else#1;

  inline$storm_IoCompleteRequest$48$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$48$anon1#1;

  inline$storm_IoCompleteRequest$48$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$48$label_9#1;

  inline$storm_IoCompleteRequest$48$label_9#1:
    goto inline$storm_IoCompleteRequest$48$label_9_true#1, inline$storm_IoCompleteRequest$48$label_9_false#1;

  inline$storm_IoCompleteRequest$48$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$48$label_10#1;

  inline$storm_IoCompleteRequest$48$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$48$label_1#1;

  inline$storm_IoCompleteRequest$48$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$48$label_7#1;

  inline$storm_IoCompleteRequest$48$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$48$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$48$label_1#1;

  inline$storm_IoCompleteRequest$48$label_1#1:
    goto inline$storm_IoCompleteRequest$48$Return#1;

  inline$storm_IoCompleteRequest$48$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$48$Return#1;

  inline$storm_IoCompleteRequest$48$Return#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon45_Then#1, inline$BDLSystemPowerIoCompletion$23$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon19#1;

  inline$BDLSystemPowerIoCompletion$23$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_77#1;

  inline$BDLSystemPowerIoCompletion$23$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$23$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$23$anon46_Then#1, inline$BDLSystemPowerIoCompletion$23$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon21#1;

  inline$BDLSystemPowerIoCompletion$23$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_80#1;

  inline$BDLSystemPowerIoCompletion$23$label_80#1:
    goto inline$BDLGetDebugLevel$604$Entry#1;

  inline$BDLGetDebugLevel$604$Entry#1:
    goto inline$BDLGetDebugLevel$604$start#1;

  inline$BDLGetDebugLevel$604$start#1:
    goto inline$BDLGetDebugLevel$604$label_3#1;

  inline$BDLGetDebugLevel$604$label_3#1:
    havoc inline$BDLGetDebugLevel$604$myNondetVar_0;
    inline$BDLGetDebugLevel$604$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$604$myNondetVar_0;
    goto inline$BDLGetDebugLevel$604$label_1#1;

  inline$BDLGetDebugLevel$604$label_1#1:
    goto inline$BDLGetDebugLevel$604$Return#1;

  inline$BDLGetDebugLevel$604$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$604$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon47_Then#1, inline$BDLSystemPowerIoCompletion$23$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon23#1;

  inline$BDLSystemPowerIoCompletion$23$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_83#1;

  inline$BDLSystemPowerIoCompletion$23$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_83_true#1, inline$BDLSystemPowerIoCompletion$23$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_84#1;

  inline$BDLSystemPowerIoCompletion$23$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_87#1;

  inline$BDLSystemPowerIoCompletion$23$label_87#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_88#1;

  inline$BDLSystemPowerIoCompletion$23$label_88#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_89#1;

  inline$BDLSystemPowerIoCompletion$23$label_89#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_90#1;

  inline$BDLSystemPowerIoCompletion$23$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$23$label_84#1;

  inline$BDLSystemPowerIoCompletion$23$label_84#1:
    goto inline$BDLGetDebugLevel$605$Entry#1;

  inline$BDLGetDebugLevel$605$Entry#1:
    goto inline$BDLGetDebugLevel$605$start#1;

  inline$BDLGetDebugLevel$605$start#1:
    goto inline$BDLGetDebugLevel$605$label_3#1;

  inline$BDLGetDebugLevel$605$label_3#1:
    havoc inline$BDLGetDebugLevel$605$myNondetVar_0;
    inline$BDLGetDebugLevel$605$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$605$myNondetVar_0;
    goto inline$BDLGetDebugLevel$605$label_1#1;

  inline$BDLGetDebugLevel$605$label_1#1:
    goto inline$BDLGetDebugLevel$605$Return#1;

  inline$BDLGetDebugLevel$605$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$605$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon48_Then#1, inline$BDLSystemPowerIoCompletion$23$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon25#1;

  inline$BDLSystemPowerIoCompletion$23$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_93#1;

  inline$BDLSystemPowerIoCompletion$23$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_93_true#1, inline$BDLSystemPowerIoCompletion$23$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_94#1;

  inline$BDLSystemPowerIoCompletion$23$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_97#1;

  inline$BDLSystemPowerIoCompletion$23$label_97#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_98#1;

  inline$BDLSystemPowerIoCompletion$23$label_98#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_99#1;

  inline$BDLSystemPowerIoCompletion$23$label_99#1:
    call inline$BDLSystemPowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$23$label_100#1;

  inline$BDLSystemPowerIoCompletion$23$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$23$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$23$label_94#1;

  inline$BDLSystemPowerIoCompletion$23$label_94#1:
    goto inline$BDLGetDebugLevel$606$Entry#1;

  inline$BDLGetDebugLevel$606$Entry#1:
    goto inline$BDLGetDebugLevel$606$start#1;

  inline$BDLGetDebugLevel$606$start#1:
    goto inline$BDLGetDebugLevel$606$label_3#1;

  inline$BDLGetDebugLevel$606$label_3#1:
    havoc inline$BDLGetDebugLevel$606$myNondetVar_0;
    inline$BDLGetDebugLevel$606$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$606$myNondetVar_0;
    goto inline$BDLGetDebugLevel$606$label_1#1;

  inline$BDLGetDebugLevel$606$label_1#1:
    goto inline$BDLGetDebugLevel$606$Return#1;

  inline$BDLGetDebugLevel$606$Return#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$606$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$23$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$23$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$23$anon49_Then#1, inline$BDLSystemPowerIoCompletion$23$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$23$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$anon27#1;

  inline$BDLSystemPowerIoCompletion$23$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_103#1;

  inline$BDLSystemPowerIoCompletion$23$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_103_true#1, inline$BDLSystemPowerIoCompletion$23$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$23$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_104#1;

  inline$BDLSystemPowerIoCompletion$23$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$23$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$23$label_105#1;

  inline$BDLSystemPowerIoCompletion$23$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$23$label_104#1;

  inline$BDLSystemPowerIoCompletion$23$label_104#1:
    inline$BDLSystemPowerIoCompletion$23$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$23$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$23$label_1#1;

  inline$BDLSystemPowerIoCompletion$23$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$23$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$23$Return#1;

  inline$BDLSystemPowerIoCompletion$23$Return#1:
    inline$CallCompletionRoutine$23$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$23$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$23$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$23$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$23$anon14_Then#1, inline$CallCompletionRoutine$23$anon14_Else#1;

  inline$CallCompletionRoutine$23$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$23$anon9#1;

  inline$CallCompletionRoutine$23$anon9#1:
    goto inline$CallCompletionRoutine$23$label_20_icall_return#1;

  inline$CallCompletionRoutine$23$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$23$Return#1;

  inline$CallCompletionRoutine$23$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$23$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$23$Entry#1;

  inline$BDLDevicePowerIoCompletion$23$Entry#1:
    inline$BDLDevicePowerIoCompletion$23$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$23$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$23$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$23$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$23$start#1;

  inline$BDLDevicePowerIoCompletion$23$start#1:
    call inline$BDLDevicePowerIoCompletion$23$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$23$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$23$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$23$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$23$label_3#1;

  inline$BDLDevicePowerIoCompletion$23$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_4#1;

  inline$BDLDevicePowerIoCompletion$23$label_4#1:
    inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_5#1;

  inline$BDLDevicePowerIoCompletion$23$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_6#1;

  inline$BDLDevicePowerIoCompletion$23$label_6#1:
    inline$BDLDevicePowerIoCompletion$23$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$23$label_7#1;

  inline$BDLDevicePowerIoCompletion$23$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_8#1;

  inline$BDLDevicePowerIoCompletion$23$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$23$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$23$label_9#1;

  inline$BDLDevicePowerIoCompletion$23$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_10#1;

  inline$BDLDevicePowerIoCompletion$23$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$121$Entry#1;

  inline$IoGetCurrentIrpStackLocation$121$Entry#1:
    inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$121$start#1;

  inline$IoGetCurrentIrpStackLocation$121$start#1:
    inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$121$label_3#1;

  inline$IoGetCurrentIrpStackLocation$121$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$121$label_3_true#1, inline$IoGetCurrentIrpStackLocation$121$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$121$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$121$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$121$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$121$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$121$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$121$label_4#1;

  inline$IoGetCurrentIrpStackLocation$121$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$121$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$121$label_6#1;

  inline$IoGetCurrentIrpStackLocation$121$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$121$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$121$label_7#1;

  inline$IoGetCurrentIrpStackLocation$121$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$121$label_5#1;

  inline$IoGetCurrentIrpStackLocation$121$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$121$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$121$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$121$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$121$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$121$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$121$label_5#1;

  inline$IoGetCurrentIrpStackLocation$121$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$121$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$121$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$121$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$121$label_1#1;

  inline$IoGetCurrentIrpStackLocation$121$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$121$Return#1;

  inline$IoGetCurrentIrpStackLocation$121$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$121$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon30_Then#1, inline$BDLDevicePowerIoCompletion$23$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon1#1;

  inline$BDLDevicePowerIoCompletion$23$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_13#1;

  inline$BDLDevicePowerIoCompletion$23$label_13#1:
    inline$BDLDevicePowerIoCompletion$23$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$23$label_14#1;

  inline$BDLDevicePowerIoCompletion$23$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_15#1;

  inline$BDLDevicePowerIoCompletion$23$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$23$label_16#1;

  inline$BDLDevicePowerIoCompletion$23$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_17#1;

  inline$BDLDevicePowerIoCompletion$23$label_17#1:
    goto inline$BDLGetDebugLevel$589$Entry#1;

  inline$BDLGetDebugLevel$589$Entry#1:
    goto inline$BDLGetDebugLevel$589$start#1;

  inline$BDLGetDebugLevel$589$start#1:
    goto inline$BDLGetDebugLevel$589$label_3#1;

  inline$BDLGetDebugLevel$589$label_3#1:
    havoc inline$BDLGetDebugLevel$589$myNondetVar_0;
    inline$BDLGetDebugLevel$589$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$589$myNondetVar_0;
    goto inline$BDLGetDebugLevel$589$label_1#1;

  inline$BDLGetDebugLevel$589$label_1#1:
    goto inline$BDLGetDebugLevel$589$Return#1;

  inline$BDLGetDebugLevel$589$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$589$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon31_Then#1, inline$BDLDevicePowerIoCompletion$23$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon3#1;

  inline$BDLDevicePowerIoCompletion$23$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_20#1;

  inline$BDLDevicePowerIoCompletion$23$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_20_true#1, inline$BDLDevicePowerIoCompletion$23$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_21#1;

  inline$BDLDevicePowerIoCompletion$23$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_24#1;

  inline$BDLDevicePowerIoCompletion$23$label_24#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_25#1;

  inline$BDLDevicePowerIoCompletion$23$label_25#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_26#1;

  inline$BDLDevicePowerIoCompletion$23$label_26#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_27#1;

  inline$BDLDevicePowerIoCompletion$23$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$23$label_21#1;

  inline$BDLDevicePowerIoCompletion$23$label_21#1:
    goto inline$BDLGetDebugLevel$590$Entry#1;

  inline$BDLGetDebugLevel$590$Entry#1:
    goto inline$BDLGetDebugLevel$590$start#1;

  inline$BDLGetDebugLevel$590$start#1:
    goto inline$BDLGetDebugLevel$590$label_3#1;

  inline$BDLGetDebugLevel$590$label_3#1:
    havoc inline$BDLGetDebugLevel$590$myNondetVar_0;
    inline$BDLGetDebugLevel$590$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$590$myNondetVar_0;
    goto inline$BDLGetDebugLevel$590$label_1#1;

  inline$BDLGetDebugLevel$590$label_1#1:
    goto inline$BDLGetDebugLevel$590$Return#1;

  inline$BDLGetDebugLevel$590$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$590$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon32_Then#1, inline$BDLDevicePowerIoCompletion$23$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon5#1;

  inline$BDLDevicePowerIoCompletion$23$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_30#1;

  inline$BDLDevicePowerIoCompletion$23$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_30_true#1, inline$BDLDevicePowerIoCompletion$23$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_31#1;

  inline$BDLDevicePowerIoCompletion$23$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_34#1;

  inline$BDLDevicePowerIoCompletion$23$label_34#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_35#1;

  inline$BDLDevicePowerIoCompletion$23$label_35#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_36#1;

  inline$BDLDevicePowerIoCompletion$23$label_36#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_37#1;

  inline$BDLDevicePowerIoCompletion$23$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$23$label_31#1;

  inline$BDLDevicePowerIoCompletion$23$label_31#1:
    goto inline$BDLGetDebugLevel$591$Entry#1;

  inline$BDLGetDebugLevel$591$Entry#1:
    goto inline$BDLGetDebugLevel$591$start#1;

  inline$BDLGetDebugLevel$591$start#1:
    goto inline$BDLGetDebugLevel$591$label_3#1;

  inline$BDLGetDebugLevel$591$label_3#1:
    havoc inline$BDLGetDebugLevel$591$myNondetVar_0;
    inline$BDLGetDebugLevel$591$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$591$myNondetVar_0;
    goto inline$BDLGetDebugLevel$591$label_1#1;

  inline$BDLGetDebugLevel$591$label_1#1:
    goto inline$BDLGetDebugLevel$591$Return#1;

  inline$BDLGetDebugLevel$591$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$591$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon33_Then#1, inline$BDLDevicePowerIoCompletion$23$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon7#1;

  inline$BDLDevicePowerIoCompletion$23$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_40#1;

  inline$BDLDevicePowerIoCompletion$23$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_40_true#1, inline$BDLDevicePowerIoCompletion$23$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_41#1;

  inline$BDLDevicePowerIoCompletion$23$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_42#1;

  inline$BDLDevicePowerIoCompletion$23$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_41#1;

  inline$BDLDevicePowerIoCompletion$23$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_41_true#1, inline$BDLDevicePowerIoCompletion$23$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$23$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$23$label_43#1;

  inline$BDLDevicePowerIoCompletion$23$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$23$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$23$label_44#1;

  inline$BDLDevicePowerIoCompletion$23$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_44_true#1, inline$BDLDevicePowerIoCompletion$23$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$23$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$23$label_45#1;

  inline$BDLDevicePowerIoCompletion$23$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_45_true#1, inline$BDLDevicePowerIoCompletion$23$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$23$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$23$label_43#1;

  inline$BDLDevicePowerIoCompletion$23$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$23$label_86#1;

  inline$BDLDevicePowerIoCompletion$23$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$23$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$23$label_46#1;

  inline$BDLDevicePowerIoCompletion$23$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$23$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$23$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$23$label_46#1;

  inline$BDLDevicePowerIoCompletion$23$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$23$label_49#1;

  inline$BDLDevicePowerIoCompletion$23$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_50#1;

  inline$BDLDevicePowerIoCompletion$23$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_51#1;

  inline$BDLDevicePowerIoCompletion$23$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_54#1;

  inline$BDLDevicePowerIoCompletion$23$label_54#1:
    inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$23$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$23$label_55#1;

  inline$BDLDevicePowerIoCompletion$23$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_55_true#1, inline$BDLDevicePowerIoCompletion$23$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_56#1;

  inline$BDLDevicePowerIoCompletion$23$label_56#1:
    call inline$BDLDevicePowerIoCompletion$23$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$23$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$23$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$23$anon34_Then#1, inline$BDLDevicePowerIoCompletion$23$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon9#1;

  inline$BDLDevicePowerIoCompletion$23$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_83#1;

  inline$BDLDevicePowerIoCompletion$23$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_59#1;

  inline$BDLDevicePowerIoCompletion$23$label_59#1:
    goto inline$BDLGetDebugLevel$592$Entry#1;

  inline$BDLGetDebugLevel$592$Entry#1:
    goto inline$BDLGetDebugLevel$592$start#1;

  inline$BDLGetDebugLevel$592$start#1:
    goto inline$BDLGetDebugLevel$592$label_3#1;

  inline$BDLGetDebugLevel$592$label_3#1:
    havoc inline$BDLGetDebugLevel$592$myNondetVar_0;
    inline$BDLGetDebugLevel$592$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$592$myNondetVar_0;
    goto inline$BDLGetDebugLevel$592$label_1#1;

  inline$BDLGetDebugLevel$592$label_1#1:
    goto inline$BDLGetDebugLevel$592$Return#1;

  inline$BDLGetDebugLevel$592$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$592$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon35_Then#1, inline$BDLDevicePowerIoCompletion$23$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon11#1;

  inline$BDLDevicePowerIoCompletion$23$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_62#1;

  inline$BDLDevicePowerIoCompletion$23$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_62_true#1, inline$BDLDevicePowerIoCompletion$23$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_63#1;

  inline$BDLDevicePowerIoCompletion$23$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_66#1;

  inline$BDLDevicePowerIoCompletion$23$label_66#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_67#1;

  inline$BDLDevicePowerIoCompletion$23$label_67#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_68#1;

  inline$BDLDevicePowerIoCompletion$23$label_68#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_69#1;

  inline$BDLDevicePowerIoCompletion$23$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$23$label_63#1;

  inline$BDLDevicePowerIoCompletion$23$label_63#1:
    goto inline$BDLGetDebugLevel$593$Entry#1;

  inline$BDLGetDebugLevel$593$Entry#1:
    goto inline$BDLGetDebugLevel$593$start#1;

  inline$BDLGetDebugLevel$593$start#1:
    goto inline$BDLGetDebugLevel$593$label_3#1;

  inline$BDLGetDebugLevel$593$label_3#1:
    havoc inline$BDLGetDebugLevel$593$myNondetVar_0;
    inline$BDLGetDebugLevel$593$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$593$myNondetVar_0;
    goto inline$BDLGetDebugLevel$593$label_1#1;

  inline$BDLGetDebugLevel$593$label_1#1:
    goto inline$BDLGetDebugLevel$593$Return#1;

  inline$BDLGetDebugLevel$593$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$593$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon36_Then#1, inline$BDLDevicePowerIoCompletion$23$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon13#1;

  inline$BDLDevicePowerIoCompletion$23$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_72#1;

  inline$BDLDevicePowerIoCompletion$23$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_72_true#1, inline$BDLDevicePowerIoCompletion$23$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_73#1;

  inline$BDLDevicePowerIoCompletion$23$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_76#1;

  inline$BDLDevicePowerIoCompletion$23$label_76#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_77#1;

  inline$BDLDevicePowerIoCompletion$23$label_77#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_78#1;

  inline$BDLDevicePowerIoCompletion$23$label_78#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_79#1;

  inline$BDLDevicePowerIoCompletion$23$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$23$label_73#1;

  inline$BDLDevicePowerIoCompletion$23$label_73#1:
    goto inline$BDLGetDebugLevel$594$Entry#1;

  inline$BDLGetDebugLevel$594$Entry#1:
    goto inline$BDLGetDebugLevel$594$start#1;

  inline$BDLGetDebugLevel$594$start#1:
    goto inline$BDLGetDebugLevel$594$label_3#1;

  inline$BDLGetDebugLevel$594$label_3#1:
    havoc inline$BDLGetDebugLevel$594$myNondetVar_0;
    inline$BDLGetDebugLevel$594$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$594$myNondetVar_0;
    goto inline$BDLGetDebugLevel$594$label_1#1;

  inline$BDLGetDebugLevel$594$label_1#1:
    goto inline$BDLGetDebugLevel$594$Return#1;

  inline$BDLGetDebugLevel$594$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$594$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon37_Then#1, inline$BDLDevicePowerIoCompletion$23$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon15#1;

  inline$BDLDevicePowerIoCompletion$23$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_82#1;

  inline$BDLDevicePowerIoCompletion$23$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_82_true#1, inline$BDLDevicePowerIoCompletion$23$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_83#1;

  inline$BDLDevicePowerIoCompletion$23$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_84#1;

  inline$BDLDevicePowerIoCompletion$23$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_83#1;

  inline$BDLDevicePowerIoCompletion$23$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_85#1;

  inline$BDLDevicePowerIoCompletion$23$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_86#1;

  inline$BDLDevicePowerIoCompletion$23$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$23$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$23$anon38_Then#1, inline$BDLDevicePowerIoCompletion$23$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon17#1;

  inline$BDLDevicePowerIoCompletion$23$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_89#1;

  inline$BDLDevicePowerIoCompletion$23$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$23$anon39_Then#1, inline$BDLDevicePowerIoCompletion$23$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon19#1;

  inline$BDLDevicePowerIoCompletion$23$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_92#1;

  inline$BDLDevicePowerIoCompletion$23$label_92#1:
    goto inline$storm_IoCompleteRequest$47$Entry#1;

  inline$storm_IoCompleteRequest$47$Entry#1:
    inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$23$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$47$start#1;

  inline$storm_IoCompleteRequest$47$start#1:
    inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$47$label_3#1;

  inline$storm_IoCompleteRequest$47$label_3#1:
    call inline$storm_IoCompleteRequest$47$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$47$label_6#1;

  inline$storm_IoCompleteRequest$47$label_6#1:
    goto inline$storm_IoCompleteRequest$47$label_6_true#1, inline$storm_IoCompleteRequest$47$label_6_false#1;

  inline$storm_IoCompleteRequest$47$label_6_false#1:
    assume inline$storm_IoCompleteRequest$47$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$47$label_7#1;

  inline$storm_IoCompleteRequest$47$label_6_true#1:
    assume inline$storm_IoCompleteRequest$47$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$47$label_8#1;

  inline$storm_IoCompleteRequest$47$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$47$anon3_Then#1, inline$storm_IoCompleteRequest$47$anon3_Else#1;

  inline$storm_IoCompleteRequest$47$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$47$anon1#1;

  inline$storm_IoCompleteRequest$47$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$47$label_9#1;

  inline$storm_IoCompleteRequest$47$label_9#1:
    goto inline$storm_IoCompleteRequest$47$label_9_true#1, inline$storm_IoCompleteRequest$47$label_9_false#1;

  inline$storm_IoCompleteRequest$47$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$47$label_10#1;

  inline$storm_IoCompleteRequest$47$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$47$label_1#1;

  inline$storm_IoCompleteRequest$47$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$47$label_7#1;

  inline$storm_IoCompleteRequest$47$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$47$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$47$label_1#1;

  inline$storm_IoCompleteRequest$47$label_1#1:
    goto inline$storm_IoCompleteRequest$47$Return#1;

  inline$storm_IoCompleteRequest$47$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$47$Return#1;

  inline$storm_IoCompleteRequest$47$Return#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon40_Then#1, inline$BDLDevicePowerIoCompletion$23$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon21#1;

  inline$BDLDevicePowerIoCompletion$23$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_95#1;

  inline$BDLDevicePowerIoCompletion$23$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$23$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$23$anon41_Then#1, inline$BDLDevicePowerIoCompletion$23$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon23#1;

  inline$BDLDevicePowerIoCompletion$23$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_98#1;

  inline$BDLDevicePowerIoCompletion$23$label_98#1:
    goto inline$BDLGetDebugLevel$595$Entry#1;

  inline$BDLGetDebugLevel$595$Entry#1:
    goto inline$BDLGetDebugLevel$595$start#1;

  inline$BDLGetDebugLevel$595$start#1:
    goto inline$BDLGetDebugLevel$595$label_3#1;

  inline$BDLGetDebugLevel$595$label_3#1:
    havoc inline$BDLGetDebugLevel$595$myNondetVar_0;
    inline$BDLGetDebugLevel$595$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$595$myNondetVar_0;
    goto inline$BDLGetDebugLevel$595$label_1#1;

  inline$BDLGetDebugLevel$595$label_1#1:
    goto inline$BDLGetDebugLevel$595$Return#1;

  inline$BDLGetDebugLevel$595$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$595$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon42_Then#1, inline$BDLDevicePowerIoCompletion$23$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon25#1;

  inline$BDLDevicePowerIoCompletion$23$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_101#1;

  inline$BDLDevicePowerIoCompletion$23$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_101_true#1, inline$BDLDevicePowerIoCompletion$23$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_102#1;

  inline$BDLDevicePowerIoCompletion$23$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_105#1;

  inline$BDLDevicePowerIoCompletion$23$label_105#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_106#1;

  inline$BDLDevicePowerIoCompletion$23$label_106#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_107#1;

  inline$BDLDevicePowerIoCompletion$23$label_107#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_108#1;

  inline$BDLDevicePowerIoCompletion$23$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$23$label_102#1;

  inline$BDLDevicePowerIoCompletion$23$label_102#1:
    goto inline$BDLGetDebugLevel$596$Entry#1;

  inline$BDLGetDebugLevel$596$Entry#1:
    goto inline$BDLGetDebugLevel$596$start#1;

  inline$BDLGetDebugLevel$596$start#1:
    goto inline$BDLGetDebugLevel$596$label_3#1;

  inline$BDLGetDebugLevel$596$label_3#1:
    havoc inline$BDLGetDebugLevel$596$myNondetVar_0;
    inline$BDLGetDebugLevel$596$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$596$myNondetVar_0;
    goto inline$BDLGetDebugLevel$596$label_1#1;

  inline$BDLGetDebugLevel$596$label_1#1:
    goto inline$BDLGetDebugLevel$596$Return#1;

  inline$BDLGetDebugLevel$596$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$596$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon43_Then#1, inline$BDLDevicePowerIoCompletion$23$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon27#1;

  inline$BDLDevicePowerIoCompletion$23$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_111#1;

  inline$BDLDevicePowerIoCompletion$23$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_111_true#1, inline$BDLDevicePowerIoCompletion$23$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_112#1;

  inline$BDLDevicePowerIoCompletion$23$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_115#1;

  inline$BDLDevicePowerIoCompletion$23$label_115#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_116#1;

  inline$BDLDevicePowerIoCompletion$23$label_116#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_117#1;

  inline$BDLDevicePowerIoCompletion$23$label_117#1:
    call inline$BDLDevicePowerIoCompletion$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$23$label_118#1;

  inline$BDLDevicePowerIoCompletion$23$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$23$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$23$label_112#1;

  inline$BDLDevicePowerIoCompletion$23$label_112#1:
    goto inline$BDLGetDebugLevel$597$Entry#1;

  inline$BDLGetDebugLevel$597$Entry#1:
    goto inline$BDLGetDebugLevel$597$start#1;

  inline$BDLGetDebugLevel$597$start#1:
    goto inline$BDLGetDebugLevel$597$label_3#1;

  inline$BDLGetDebugLevel$597$label_3#1:
    havoc inline$BDLGetDebugLevel$597$myNondetVar_0;
    inline$BDLGetDebugLevel$597$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$597$myNondetVar_0;
    goto inline$BDLGetDebugLevel$597$label_1#1;

  inline$BDLGetDebugLevel$597$label_1#1:
    goto inline$BDLGetDebugLevel$597$Return#1;

  inline$BDLGetDebugLevel$597$Return#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$597$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$23$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$23$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$23$anon44_Then#1, inline$BDLDevicePowerIoCompletion$23$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$23$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$anon29#1;

  inline$BDLDevicePowerIoCompletion$23$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_121#1;

  inline$BDLDevicePowerIoCompletion$23$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_121_true#1, inline$BDLDevicePowerIoCompletion$23$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$23$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_122#1;

  inline$BDLDevicePowerIoCompletion$23$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$23$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$23$label_123#1;

  inline$BDLDevicePowerIoCompletion$23$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$23$label_122#1;

  inline$BDLDevicePowerIoCompletion$23$label_122#1:
    inline$BDLDevicePowerIoCompletion$23$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$23$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$23$label_1#1;

  inline$BDLDevicePowerIoCompletion$23$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$23$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$23$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$23$Return#1;

  inline$BDLDevicePowerIoCompletion$23$Return#1:
    inline$CallCompletionRoutine$23$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$23$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$23$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$23$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$23$anon13_Then#1, inline$CallCompletionRoutine$23$anon13_Else#1;

  inline$CallCompletionRoutine$23$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$23$anon7#1;

  inline$CallCompletionRoutine$23$anon7#1:
    goto inline$CallCompletionRoutine$23$label_20_icall_return#1;

  inline$CallCompletionRoutine$23$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$23$Return#1;

  inline$CallCompletionRoutine$23$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$23$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$23$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$23$Entry#1;

  inline$BDLCallDriverCompletionRoutine$23$Entry#1:
    inline$BDLCallDriverCompletionRoutine$23$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$23$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$23$start#1;

  inline$BDLCallDriverCompletionRoutine$23$start#1:
    inline$BDLCallDriverCompletionRoutine$23$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$23$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$23$label_3#1;

  inline$BDLCallDriverCompletionRoutine$23$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$23$label_3_true#1, inline$BDLCallDriverCompletionRoutine$23$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$23$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$23$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$23$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$23$label_4#1;

  inline$BDLCallDriverCompletionRoutine$23$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$23$label_6#1;

  inline$BDLCallDriverCompletionRoutine$23$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$23$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$23$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$23$label_5#1;

  inline$BDLCallDriverCompletionRoutine$23$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$23$label_6#1;

  inline$BDLCallDriverCompletionRoutine$23$label_6#1:
    goto inline$storm_KeSetEvent$25$Entry#1;

  inline$storm_KeSetEvent$25$Entry#1:
    inline$storm_KeSetEvent$25$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$23$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$25$start#1;

  inline$storm_KeSetEvent$25$start#1:
    inline$storm_KeSetEvent$25$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$25$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$25$label_3#1;

  inline$storm_KeSetEvent$25$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$25$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$25$label_1#1;

  inline$storm_KeSetEvent$25$label_1#1:
    goto inline$storm_KeSetEvent$25$Return#1;

  inline$storm_KeSetEvent$25$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$23$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$23$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$23$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$23$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$23$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$23$anon1#1;

  inline$BDLCallDriverCompletionRoutine$23$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$23$label_9#1;

  inline$BDLCallDriverCompletionRoutine$23$label_9#1:
    inline$BDLCallDriverCompletionRoutine$23$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$23$label_1#1;

  inline$BDLCallDriverCompletionRoutine$23$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$23$Return#1;

  inline$BDLCallDriverCompletionRoutine$23$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$23$Return#1;

  inline$BDLCallDriverCompletionRoutine$23$Return#1:
    inline$CallCompletionRoutine$23$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$23$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$23$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$23$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$23$anon12_Then#1, inline$CallCompletionRoutine$23$anon12_Else#1;

  inline$CallCompletionRoutine$23$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$23$anon5#1;

  inline$CallCompletionRoutine$23$anon5#1:
    goto inline$CallCompletionRoutine$23$label_20_icall_return#1;

  inline$CallCompletionRoutine$23$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$23$label_23#1;

  inline$CallCompletionRoutine$23$label_23#1:
    inline$CallCompletionRoutine$23$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$23$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$23$label_24#1;

  inline$CallCompletionRoutine$23$label_24#1:
    goto inline$CallCompletionRoutine$23$label_24_true#1, inline$CallCompletionRoutine$23$label_24_false#1;

  inline$CallCompletionRoutine$23$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$23$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$23$label_1#1;

  inline$CallCompletionRoutine$23$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$23$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$23$label_25#1;

  inline$CallCompletionRoutine$23$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$23$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$23$label_1#1;

  inline$CallCompletionRoutine$23$label_1#1:
    goto inline$CallCompletionRoutine$23$Return#1;

  inline$CallCompletionRoutine$23$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$23$Return#1;

  inline$CallCompletionRoutine$23$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$23$Return#1;

  inline$CallCompletionRoutine$23$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$23$Return#1;

  inline$CallCompletionRoutine$23$Return#1:
    goto inline$storm_IoCallDriver$11$label_39$1#1;

  inline$storm_IoCallDriver$11$label_39$1#1:
    goto inline$storm_IoCallDriver$11$anon15_Then#1, inline$storm_IoCallDriver$11$anon15_Else#1;

  inline$storm_IoCallDriver$11$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$11$anon10#1;

  inline$storm_IoCallDriver$11$anon10#1:
    goto inline$storm_IoCallDriver$11$label_36#1;

  inline$storm_IoCallDriver$11$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$11$Return#1;

  inline$storm_IoCallDriver$11$label_27_case_0#1:
    assume inline$storm_IoCallDriver$11$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$11$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$11$label_28#1;

  inline$storm_IoCallDriver$11$label_28#1:
    inline$storm_IoCallDriver$11$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$11$label_42#1;

  inline$storm_IoCallDriver$11$label_42#1:
    goto inline$storm_IoCallDriver$11$label_43#1;

  inline$storm_IoCallDriver$11$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$11$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$11$label_36#1;

  inline$storm_IoCallDriver$11$label_36#1:
    inline$storm_IoCallDriver$11$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$11$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$11$label_1#1;

  inline$storm_IoCallDriver$11$label_1#1:
    goto inline$storm_IoCallDriver$11$Return#1;

  inline$storm_IoCallDriver$11$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$11$Return#1;

  inline$storm_IoCallDriver$11$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$11$Return#1;

  inline$storm_IoCallDriver$11$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$11$Return#1;

  inline$storm_IoCallDriver$11$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_IoCallDriver$108.29$4$ := inline$storm_IoCallDriver$11$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_19$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_19$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon20_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon20_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon9#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon9#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_42#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_42#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_IoCallDriver$108.29$4$;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_18_true#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0;
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_22#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_22#1:
    call PoStartNextPowerIrp(inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon21_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon21_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon21_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon11#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon11#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_25#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_25#1:
    goto inline$storm_PoCallDriver$5$Entry#1;

  inline$storm_PoCallDriver$5$Entry#1:
    inline$storm_PoCallDriver$5$$Irp$2$496.14$storm_PoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_PoCallDriver$5$start#1;

  inline$storm_PoCallDriver$5$start#1:
    inline$storm_PoCallDriver$5$$Irp$2$496.14$storm_PoCallDriver$8 := inline$storm_PoCallDriver$5$$Irp$2$496.14$storm_PoCallDriver$8_.1;
    goto inline$storm_PoCallDriver$5$label_3#1;

  inline$storm_PoCallDriver$5$label_3#1:
    goto inline$storm_IoCallDriver$12$Entry#1;

  inline$storm_IoCallDriver$12$Entry#1:
    inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$storm_PoCallDriver$5$$Irp$2$496.14$storm_PoCallDriver$8;
    goto inline$storm_IoCallDriver$12$start#1;

  inline$storm_IoCallDriver$12$start#1:
    inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$12$label_3#1;

  inline$storm_IoCallDriver$12$label_3#1:
    goto inline$storm_IoCallDriver$12$label_4#1;

  inline$storm_IoCallDriver$12$label_4#1:
    goto inline$storm_IoCallDriver$12$label_5#1;

  inline$storm_IoCallDriver$12$label_5#1:
    goto inline$storm_IoCallDriver$12$label_6#1;

  inline$storm_IoCallDriver$12$label_6#1:
    call inline$storm_IoCallDriver$12$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$12$label_9#1;

  inline$storm_IoCallDriver$12$label_9#1:
    goto inline$storm_IoCallDriver$12$label_9_true#1, inline$storm_IoCallDriver$12$label_9_false#1;

  inline$storm_IoCallDriver$12$label_9_false#1:
    assume inline$storm_IoCallDriver$12$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$12$label_10#1;

  inline$storm_IoCallDriver$12$label_9_true#1:
    assume inline$storm_IoCallDriver$12$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$12$label_13#1;

  inline$storm_IoCallDriver$12$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$12$anon12_Then#1, inline$storm_IoCallDriver$12$anon12_Else#1;

  inline$storm_IoCallDriver$12$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$12$anon3#1;

  inline$storm_IoCallDriver$12$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$12$label_14#1;

  inline$storm_IoCallDriver$12$label_14#1:
    goto inline$storm_IoCallDriver$12$label_14_true#1, inline$storm_IoCallDriver$12$label_14_false#1;

  inline$storm_IoCallDriver$12$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$12$label_15#1;

  inline$storm_IoCallDriver$12$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$12$label_1#1;

  inline$storm_IoCallDriver$12$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$12$label_10#1;

  inline$storm_IoCallDriver$12$label_10#1:
    goto inline$IoSetNextIrpStackLocation$13$Entry#1;

  inline$IoSetNextIrpStackLocation$13$Entry#1:
    inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$13$start#1;

  inline$IoSetNextIrpStackLocation$13$start#1:
    inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$13$label_3#1;

  inline$IoSetNextIrpStackLocation$13$label_3#1:
    goto inline$IoSetNextIrpStackLocation$13$label_3_true#1, inline$IoSetNextIrpStackLocation$13$label_3_false#1;

  inline$IoSetNextIrpStackLocation$13$label_3_false#1:
    inline$IoSetNextIrpStackLocation$13$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$13$myVar_0);
    goto inline$IoSetNextIrpStackLocation$13$label_4#1;

  inline$IoSetNextIrpStackLocation$13$label_4#1:
    call inline$IoSetNextIrpStackLocation$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$13$label_7#1;

  inline$IoSetNextIrpStackLocation$13$label_7#1:
    call inline$IoSetNextIrpStackLocation$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$13$label_8#1;

  inline$IoSetNextIrpStackLocation$13$label_8#1:
    goto inline$IoSetNextIrpStackLocation$13$label_5#1;

  inline$IoSetNextIrpStackLocation$13$label_3_true#1:
    inline$IoSetNextIrpStackLocation$13$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$13$myVar_0);
    goto inline$IoSetNextIrpStackLocation$13$label_5#1;

  inline$IoSetNextIrpStackLocation$13$label_5#1:
    inline$IoSetNextIrpStackLocation$13$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$13$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$13$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$13$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$13$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$13$label_6#1;

  inline$IoSetNextIrpStackLocation$13$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$13$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$13$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$13$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$13$label_1#1;

  inline$IoSetNextIrpStackLocation$13$label_1#1:
    goto inline$IoSetNextIrpStackLocation$13$Return#1;

  inline$IoSetNextIrpStackLocation$13$Return#1:
    goto inline$storm_IoCallDriver$12$label_10$1#1;

  inline$storm_IoCallDriver$12$label_10$1#1:
    goto inline$storm_IoCallDriver$12$anon11_Then#1, inline$storm_IoCallDriver$12$anon11_Else#1;

  inline$storm_IoCallDriver$12$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$12$anon1#1;

  inline$storm_IoCallDriver$12$anon1#1:
    goto inline$storm_IoCallDriver$12$label_18#1;

  inline$storm_IoCallDriver$12$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$123$Entry#1;

  inline$IoGetCurrentIrpStackLocation$123$Entry#1:
    inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$123$start#1;

  inline$IoGetCurrentIrpStackLocation$123$start#1:
    inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$123$label_3#1;

  inline$IoGetCurrentIrpStackLocation$123$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$123$label_3_true#1, inline$IoGetCurrentIrpStackLocation$123$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$123$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$123$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$123$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$123$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$123$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$123$label_4#1;

  inline$IoGetCurrentIrpStackLocation$123$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$123$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$123$label_6#1;

  inline$IoGetCurrentIrpStackLocation$123$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$123$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$123$label_7#1;

  inline$IoGetCurrentIrpStackLocation$123$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$123$label_5#1;

  inline$IoGetCurrentIrpStackLocation$123$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$123$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$123$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$123$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$123$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$123$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$123$label_5#1;

  inline$IoGetCurrentIrpStackLocation$123$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$123$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$123$label_1#1;

  inline$IoGetCurrentIrpStackLocation$123$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$123$Return#1;

  inline$IoGetCurrentIrpStackLocation$123$Return#1:
    goto inline$storm_IoCallDriver$12$label_18$1#1;

  inline$storm_IoCallDriver$12$label_18$1#1:
    goto inline$storm_IoCallDriver$12$anon13_Then#1, inline$storm_IoCallDriver$12$anon13_Else#1;

  inline$storm_IoCallDriver$12$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$12$anon6#1;

  inline$storm_IoCallDriver$12$anon6#1:
    goto inline$storm_IoCallDriver$12$label_21#1;

  inline$storm_IoCallDriver$12$label_21#1:
    goto inline$storm_IoCallDriver$12$label_22#1;

  inline$storm_IoCallDriver$12$label_22#1:
    goto inline$storm_IoCallDriver$12$label_23#1;

  inline$storm_IoCallDriver$12$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$12$label_24#1;

  inline$storm_IoCallDriver$12$label_24#1:
    call inline$storm_IoCallDriver$12$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$12$label_27#1;

  inline$storm_IoCallDriver$12$label_27#1:
    goto inline$storm_IoCallDriver$12$label_27_case_0#1, inline$storm_IoCallDriver$12$label_27_case_1#1, inline$storm_IoCallDriver$12$label_27_case_2#1;

  inline$storm_IoCallDriver$12$label_27_case_2#1:
    assume inline$storm_IoCallDriver$12$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$12$label_30#1;

  inline$storm_IoCallDriver$12$label_30#1:
    inline$storm_IoCallDriver$12$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$12$label_31#1;

  inline$storm_IoCallDriver$12$label_31#1:
    goto inline$storm_IoCallDriver$12$label_32#1;

  inline$storm_IoCallDriver$12$label_32#1:
    goto inline$storm_IoCallDriver$12$label_33#1;

  inline$storm_IoCallDriver$12$label_33#1:
    goto inline$CallCompletionRoutine$24$Entry#1;

  inline$CallCompletionRoutine$24$Entry#1:
    inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$24$start#1;

  inline$CallCompletionRoutine$24$start#1:
    inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$24$label_3#1;

  inline$CallCompletionRoutine$24$label_3#1:
    goto inline$CallCompletionRoutine$24$label_4#1;

  inline$CallCompletionRoutine$24$label_4#1:
    goto inline$CallCompletionRoutine$24$label_5#1;

  inline$CallCompletionRoutine$24$label_5#1:
    goto inline$CallCompletionRoutine$24$label_6#1;

  inline$CallCompletionRoutine$24$label_6#1:
    goto inline$CallCompletionRoutine$24$label_7#1;

  inline$CallCompletionRoutine$24$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$124$Entry#1;

  inline$IoGetCurrentIrpStackLocation$124$Entry#1:
    inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$124$start#1;

  inline$IoGetCurrentIrpStackLocation$124$start#1:
    inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$124$label_3#1;

  inline$IoGetCurrentIrpStackLocation$124$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$124$label_3_true#1, inline$IoGetCurrentIrpStackLocation$124$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$124$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$124$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$124$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$124$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$124$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$124$label_4#1;

  inline$IoGetCurrentIrpStackLocation$124$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$124$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$124$label_6#1;

  inline$IoGetCurrentIrpStackLocation$124$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$124$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$124$label_7#1;

  inline$IoGetCurrentIrpStackLocation$124$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$124$label_5#1;

  inline$IoGetCurrentIrpStackLocation$124$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$124$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$124$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$124$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$124$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$124$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$124$label_5#1;

  inline$IoGetCurrentIrpStackLocation$124$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$124$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$124$label_1#1;

  inline$IoGetCurrentIrpStackLocation$124$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$124$Return#1;

  inline$IoGetCurrentIrpStackLocation$124$Return#1:
    goto inline$CallCompletionRoutine$24$label_7$1#1;

  inline$CallCompletionRoutine$24$label_7$1#1:
    goto inline$CallCompletionRoutine$24$anon10_Then#1, inline$CallCompletionRoutine$24$anon10_Else#1;

  inline$CallCompletionRoutine$24$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$24$anon1#1;

  inline$CallCompletionRoutine$24$anon1#1:
    goto inline$CallCompletionRoutine$24$label_10#1;

  inline$CallCompletionRoutine$24$label_10#1:
    goto inline$CallCompletionRoutine$24$label_11#1;

  inline$CallCompletionRoutine$24$label_11#1:
    havoc inline$CallCompletionRoutine$24$myNondetVar_0;
    inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$24$myNondetVar_0;
    goto inline$CallCompletionRoutine$24$label_12#1;

  inline$CallCompletionRoutine$24$label_12#1:
    havoc inline$CallCompletionRoutine$24$myNondetVar_0;
    inline$CallCompletionRoutine$24$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$24$myNondetVar_0;
    goto inline$CallCompletionRoutine$24$label_13#1;

  inline$CallCompletionRoutine$24$label_13#1:
    havoc inline$CallCompletionRoutine$24$myNondetVar_0;
    goto inline$CallCompletionRoutine$24$label_14#1;

  inline$CallCompletionRoutine$24$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$125$Entry#1;

  inline$IoGetCurrentIrpStackLocation$125$Entry#1:
    inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$125$start#1;

  inline$IoGetCurrentIrpStackLocation$125$start#1:
    inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$125$label_3#1;

  inline$IoGetCurrentIrpStackLocation$125$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$125$label_3_true#1, inline$IoGetCurrentIrpStackLocation$125$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$125$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$125$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$125$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$125$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$125$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$125$label_4#1;

  inline$IoGetCurrentIrpStackLocation$125$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$125$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$125$label_6#1;

  inline$IoGetCurrentIrpStackLocation$125$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$125$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$125$label_7#1;

  inline$IoGetCurrentIrpStackLocation$125$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$125$label_5#1;

  inline$IoGetCurrentIrpStackLocation$125$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$125$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$125$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$125$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$125$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$125$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$125$label_5#1;

  inline$IoGetCurrentIrpStackLocation$125$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$125$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$125$label_1#1;

  inline$IoGetCurrentIrpStackLocation$125$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$125$Return#1;

  inline$IoGetCurrentIrpStackLocation$125$Return#1:
    goto inline$CallCompletionRoutine$24$label_14$1#1;

  inline$CallCompletionRoutine$24$label_14$1#1:
    goto inline$CallCompletionRoutine$24$anon11_Then#1, inline$CallCompletionRoutine$24$anon11_Else#1;

  inline$CallCompletionRoutine$24$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$24$anon3#1;

  inline$CallCompletionRoutine$24$anon3#1:
    goto inline$CallCompletionRoutine$24$label_17#1;

  inline$CallCompletionRoutine$24$label_17#1:
    goto inline$CallCompletionRoutine$24$label_18#1;

  inline$CallCompletionRoutine$24$label_18#1:
    goto inline$CallCompletionRoutine$24$label_18_true#1, inline$CallCompletionRoutine$24$label_18_false#1;

  inline$CallCompletionRoutine$24$label_18_false#1:
    assume inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$24$label_1#1;

  inline$CallCompletionRoutine$24$label_18_true#1:
    assume inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$24$label_19#1;

  inline$CallCompletionRoutine$24$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$24$label_20#1;

  inline$CallCompletionRoutine$24$label_20#1:
    goto inline$CallCompletionRoutine$24$label_20_icall_1#1, inline$CallCompletionRoutine$24$label_20_icall_2#1, inline$CallCompletionRoutine$24$label_20_icall_3#1;

  inline$CallCompletionRoutine$24$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$24$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$24$Entry#1;

  inline$BDLSystemPowerIoCompletion$24$Entry#1:
    inline$BDLSystemPowerIoCompletion$24$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$24$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$24$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$24$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$24$start#1;

  inline$BDLSystemPowerIoCompletion$24$start#1:
    call inline$BDLSystemPowerIoCompletion$24$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$24$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$24$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$24$label_3#1;

  inline$BDLSystemPowerIoCompletion$24$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_4#1;

  inline$BDLSystemPowerIoCompletion$24$label_4#1:
    inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_5#1;

  inline$BDLSystemPowerIoCompletion$24$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_6#1;

  inline$BDLSystemPowerIoCompletion$24$label_6#1:
    inline$BDLSystemPowerIoCompletion$24$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$24$label_7#1;

  inline$BDLSystemPowerIoCompletion$24$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_8#1;

  inline$BDLSystemPowerIoCompletion$24$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$24$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$24$label_9#1;

  inline$BDLSystemPowerIoCompletion$24$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_10#1;

  inline$BDLSystemPowerIoCompletion$24$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$127$Entry#1;

  inline$IoGetCurrentIrpStackLocation$127$Entry#1:
    inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$127$start#1;

  inline$IoGetCurrentIrpStackLocation$127$start#1:
    inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$127$label_3#1;

  inline$IoGetCurrentIrpStackLocation$127$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$127$label_3_true#1, inline$IoGetCurrentIrpStackLocation$127$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$127$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$127$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$127$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$127$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$127$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$127$label_4#1;

  inline$IoGetCurrentIrpStackLocation$127$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$127$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$127$label_6#1;

  inline$IoGetCurrentIrpStackLocation$127$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$127$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$127$label_7#1;

  inline$IoGetCurrentIrpStackLocation$127$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$127$label_5#1;

  inline$IoGetCurrentIrpStackLocation$127$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$127$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$127$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$127$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$127$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$127$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$127$label_5#1;

  inline$IoGetCurrentIrpStackLocation$127$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$127$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$127$label_1#1;

  inline$IoGetCurrentIrpStackLocation$127$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$127$Return#1;

  inline$IoGetCurrentIrpStackLocation$127$Return#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon36_Then#1, inline$BDLSystemPowerIoCompletion$24$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon1#1;

  inline$BDLSystemPowerIoCompletion$24$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_13#1;

  inline$BDLSystemPowerIoCompletion$24$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_14#1;

  inline$BDLSystemPowerIoCompletion$24$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_15#1;

  inline$BDLSystemPowerIoCompletion$24$label_15#1:
    goto inline$BDLGetDebugLevel$619$Entry#1;

  inline$BDLGetDebugLevel$619$Entry#1:
    goto inline$BDLGetDebugLevel$619$start#1;

  inline$BDLGetDebugLevel$619$start#1:
    goto inline$BDLGetDebugLevel$619$label_3#1;

  inline$BDLGetDebugLevel$619$label_3#1:
    havoc inline$BDLGetDebugLevel$619$myNondetVar_0;
    inline$BDLGetDebugLevel$619$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$619$myNondetVar_0;
    goto inline$BDLGetDebugLevel$619$label_1#1;

  inline$BDLGetDebugLevel$619$label_1#1:
    goto inline$BDLGetDebugLevel$619$Return#1;

  inline$BDLGetDebugLevel$619$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$619$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon37_Then#1, inline$BDLSystemPowerIoCompletion$24$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon3#1;

  inline$BDLSystemPowerIoCompletion$24$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_18#1;

  inline$BDLSystemPowerIoCompletion$24$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_18_true#1, inline$BDLSystemPowerIoCompletion$24$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_19#1;

  inline$BDLSystemPowerIoCompletion$24$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_22#1;

  inline$BDLSystemPowerIoCompletion$24$label_22#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_23#1;

  inline$BDLSystemPowerIoCompletion$24$label_23#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_24#1;

  inline$BDLSystemPowerIoCompletion$24$label_24#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_25#1;

  inline$BDLSystemPowerIoCompletion$24$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$24$label_19#1;

  inline$BDLSystemPowerIoCompletion$24$label_19#1:
    goto inline$BDLGetDebugLevel$620$Entry#1;

  inline$BDLGetDebugLevel$620$Entry#1:
    goto inline$BDLGetDebugLevel$620$start#1;

  inline$BDLGetDebugLevel$620$start#1:
    goto inline$BDLGetDebugLevel$620$label_3#1;

  inline$BDLGetDebugLevel$620$label_3#1:
    havoc inline$BDLGetDebugLevel$620$myNondetVar_0;
    inline$BDLGetDebugLevel$620$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$620$myNondetVar_0;
    goto inline$BDLGetDebugLevel$620$label_1#1;

  inline$BDLGetDebugLevel$620$label_1#1:
    goto inline$BDLGetDebugLevel$620$Return#1;

  inline$BDLGetDebugLevel$620$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$620$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon38_Then#1, inline$BDLSystemPowerIoCompletion$24$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon5#1;

  inline$BDLSystemPowerIoCompletion$24$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_28#1;

  inline$BDLSystemPowerIoCompletion$24$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_28_true#1, inline$BDLSystemPowerIoCompletion$24$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_29#1;

  inline$BDLSystemPowerIoCompletion$24$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_32#1;

  inline$BDLSystemPowerIoCompletion$24$label_32#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_33#1;

  inline$BDLSystemPowerIoCompletion$24$label_33#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_34#1;

  inline$BDLSystemPowerIoCompletion$24$label_34#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_35#1;

  inline$BDLSystemPowerIoCompletion$24$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$24$label_29#1;

  inline$BDLSystemPowerIoCompletion$24$label_29#1:
    goto inline$BDLGetDebugLevel$621$Entry#1;

  inline$BDLGetDebugLevel$621$Entry#1:
    goto inline$BDLGetDebugLevel$621$start#1;

  inline$BDLGetDebugLevel$621$start#1:
    goto inline$BDLGetDebugLevel$621$label_3#1;

  inline$BDLGetDebugLevel$621$label_3#1:
    havoc inline$BDLGetDebugLevel$621$myNondetVar_0;
    inline$BDLGetDebugLevel$621$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$621$myNondetVar_0;
    goto inline$BDLGetDebugLevel$621$label_1#1;

  inline$BDLGetDebugLevel$621$label_1#1:
    goto inline$BDLGetDebugLevel$621$Return#1;

  inline$BDLGetDebugLevel$621$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$621$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon39_Then#1, inline$BDLSystemPowerIoCompletion$24$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon7#1;

  inline$BDLSystemPowerIoCompletion$24$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_38#1;

  inline$BDLSystemPowerIoCompletion$24$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_38_true#1, inline$BDLSystemPowerIoCompletion$24$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_39#1;

  inline$BDLSystemPowerIoCompletion$24$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_40#1;

  inline$BDLSystemPowerIoCompletion$24$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_39#1;

  inline$BDLSystemPowerIoCompletion$24$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_39_true#1, inline$BDLSystemPowerIoCompletion$24$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_41#1;

  inline$BDLSystemPowerIoCompletion$24$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$24$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$24$label_107#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$24$label_108#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$24$label_108#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$24$label_108#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$24$label_108#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$24$label_108#1;

  inline$BDLSystemPowerIoCompletion$24$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_109#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$24$label_107#1;

  inline$BDLSystemPowerIoCompletion$24$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_109#1;

  inline$BDLSystemPowerIoCompletion$24$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$24$label_106#1;

  inline$BDLSystemPowerIoCompletion$24$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_106_true#1, inline$BDLSystemPowerIoCompletion$24$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_142#1;

  inline$BDLSystemPowerIoCompletion$24$label_142#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_143#1;

  inline$BDLSystemPowerIoCompletion$24$label_143#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_144#1;

  inline$BDLSystemPowerIoCompletion$24$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_109#1;

  inline$BDLSystemPowerIoCompletion$24$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_109#1;

  inline$BDLSystemPowerIoCompletion$24$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$24$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$24$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$24$myNondetVar_0, inline$BDLSystemPowerIoCompletion$24$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$24$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$24$anon50_Then#1, inline$BDLSystemPowerIoCompletion$24$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon29#1;

  inline$BDLSystemPowerIoCompletion$24$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_112#1;

  inline$BDLSystemPowerIoCompletion$24$label_112#1:
    inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$24$label_113#1;

  inline$BDLSystemPowerIoCompletion$24$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_113_true#1, inline$BDLSystemPowerIoCompletion$24$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$24$label_114#1;

  inline$BDLSystemPowerIoCompletion$24$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_116#1;

  inline$BDLSystemPowerIoCompletion$24$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_117#1;

  inline$BDLSystemPowerIoCompletion$24$label_117#1:
    goto inline$BDLGetDebugLevel$628$Entry#1;

  inline$BDLGetDebugLevel$628$Entry#1:
    goto inline$BDLGetDebugLevel$628$start#1;

  inline$BDLGetDebugLevel$628$start#1:
    goto inline$BDLGetDebugLevel$628$label_3#1;

  inline$BDLGetDebugLevel$628$label_3#1:
    havoc inline$BDLGetDebugLevel$628$myNondetVar_0;
    inline$BDLGetDebugLevel$628$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$628$myNondetVar_0;
    goto inline$BDLGetDebugLevel$628$label_1#1;

  inline$BDLGetDebugLevel$628$label_1#1:
    goto inline$BDLGetDebugLevel$628$Return#1;

  inline$BDLGetDebugLevel$628$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$628$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon51_Then#1, inline$BDLSystemPowerIoCompletion$24$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon31#1;

  inline$BDLSystemPowerIoCompletion$24$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_120#1;

  inline$BDLSystemPowerIoCompletion$24$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_120_true#1, inline$BDLSystemPowerIoCompletion$24$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_121#1;

  inline$BDLSystemPowerIoCompletion$24$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_124#1;

  inline$BDLSystemPowerIoCompletion$24$label_124#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_125#1;

  inline$BDLSystemPowerIoCompletion$24$label_125#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_126#1;

  inline$BDLSystemPowerIoCompletion$24$label_126#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_127#1;

  inline$BDLSystemPowerIoCompletion$24$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$24$label_121#1;

  inline$BDLSystemPowerIoCompletion$24$label_121#1:
    goto inline$BDLGetDebugLevel$629$Entry#1;

  inline$BDLGetDebugLevel$629$Entry#1:
    goto inline$BDLGetDebugLevel$629$start#1;

  inline$BDLGetDebugLevel$629$start#1:
    goto inline$BDLGetDebugLevel$629$label_3#1;

  inline$BDLGetDebugLevel$629$label_3#1:
    havoc inline$BDLGetDebugLevel$629$myNondetVar_0;
    inline$BDLGetDebugLevel$629$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$629$myNondetVar_0;
    goto inline$BDLGetDebugLevel$629$label_1#1;

  inline$BDLGetDebugLevel$629$label_1#1:
    goto inline$BDLGetDebugLevel$629$Return#1;

  inline$BDLGetDebugLevel$629$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$629$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon52_Then#1, inline$BDLSystemPowerIoCompletion$24$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon33#1;

  inline$BDLSystemPowerIoCompletion$24$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_130#1;

  inline$BDLSystemPowerIoCompletion$24$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_130_true#1, inline$BDLSystemPowerIoCompletion$24$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_131#1;

  inline$BDLSystemPowerIoCompletion$24$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_134#1;

  inline$BDLSystemPowerIoCompletion$24$label_134#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_135#1;

  inline$BDLSystemPowerIoCompletion$24$label_135#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_136#1;

  inline$BDLSystemPowerIoCompletion$24$label_136#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_137#1;

  inline$BDLSystemPowerIoCompletion$24$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$24$label_131#1;

  inline$BDLSystemPowerIoCompletion$24$label_131#1:
    goto inline$BDLGetDebugLevel$630$Entry#1;

  inline$BDLGetDebugLevel$630$Entry#1:
    goto inline$BDLGetDebugLevel$630$start#1;

  inline$BDLGetDebugLevel$630$start#1:
    goto inline$BDLGetDebugLevel$630$label_3#1;

  inline$BDLGetDebugLevel$630$label_3#1:
    havoc inline$BDLGetDebugLevel$630$myNondetVar_0;
    inline$BDLGetDebugLevel$630$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$630$myNondetVar_0;
    goto inline$BDLGetDebugLevel$630$label_1#1;

  inline$BDLGetDebugLevel$630$label_1#1:
    goto inline$BDLGetDebugLevel$630$Return#1;

  inline$BDLGetDebugLevel$630$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$630$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon53_Then#1, inline$BDLSystemPowerIoCompletion$24$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon35#1;

  inline$BDLSystemPowerIoCompletion$24$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_140#1;

  inline$BDLSystemPowerIoCompletion$24$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_140_true#1, inline$BDLSystemPowerIoCompletion$24$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_67#1;

  inline$BDLSystemPowerIoCompletion$24$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_141#1;

  inline$BDLSystemPowerIoCompletion$24$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_67#1;

  inline$BDLSystemPowerIoCompletion$24$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$24$label_115#1;

  inline$BDLSystemPowerIoCompletion$24$label_115#1:
    inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$24$label_80#1;

  inline$BDLSystemPowerIoCompletion$24$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$24$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_42#1;

  inline$BDLSystemPowerIoCompletion$24$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$24$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$24$label_43#1;

  inline$BDLSystemPowerIoCompletion$24$label_43#1:
    goto inline$BDLGetDebugLevel$622$Entry#1;

  inline$BDLGetDebugLevel$622$Entry#1:
    goto inline$BDLGetDebugLevel$622$start#1;

  inline$BDLGetDebugLevel$622$start#1:
    goto inline$BDLGetDebugLevel$622$label_3#1;

  inline$BDLGetDebugLevel$622$label_3#1:
    havoc inline$BDLGetDebugLevel$622$myNondetVar_0;
    inline$BDLGetDebugLevel$622$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$622$myNondetVar_0;
    goto inline$BDLGetDebugLevel$622$label_1#1;

  inline$BDLGetDebugLevel$622$label_1#1:
    goto inline$BDLGetDebugLevel$622$Return#1;

  inline$BDLGetDebugLevel$622$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$622$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon40_Then#1, inline$BDLSystemPowerIoCompletion$24$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon9#1;

  inline$BDLSystemPowerIoCompletion$24$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_46#1;

  inline$BDLSystemPowerIoCompletion$24$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_46_true#1, inline$BDLSystemPowerIoCompletion$24$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_47#1;

  inline$BDLSystemPowerIoCompletion$24$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_50#1;

  inline$BDLSystemPowerIoCompletion$24$label_50#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_51#1;

  inline$BDLSystemPowerIoCompletion$24$label_51#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_52#1;

  inline$BDLSystemPowerIoCompletion$24$label_52#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_53#1;

  inline$BDLSystemPowerIoCompletion$24$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$24$label_47#1;

  inline$BDLSystemPowerIoCompletion$24$label_47#1:
    goto inline$BDLGetDebugLevel$623$Entry#1;

  inline$BDLGetDebugLevel$623$Entry#1:
    goto inline$BDLGetDebugLevel$623$start#1;

  inline$BDLGetDebugLevel$623$start#1:
    goto inline$BDLGetDebugLevel$623$label_3#1;

  inline$BDLGetDebugLevel$623$label_3#1:
    havoc inline$BDLGetDebugLevel$623$myNondetVar_0;
    inline$BDLGetDebugLevel$623$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$623$myNondetVar_0;
    goto inline$BDLGetDebugLevel$623$label_1#1;

  inline$BDLGetDebugLevel$623$label_1#1:
    goto inline$BDLGetDebugLevel$623$Return#1;

  inline$BDLGetDebugLevel$623$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$623$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon41_Then#1, inline$BDLSystemPowerIoCompletion$24$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon11#1;

  inline$BDLSystemPowerIoCompletion$24$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_56#1;

  inline$BDLSystemPowerIoCompletion$24$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_56_true#1, inline$BDLSystemPowerIoCompletion$24$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_57#1;

  inline$BDLSystemPowerIoCompletion$24$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_60#1;

  inline$BDLSystemPowerIoCompletion$24$label_60#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_61#1;

  inline$BDLSystemPowerIoCompletion$24$label_61#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_62#1;

  inline$BDLSystemPowerIoCompletion$24$label_62#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_63#1;

  inline$BDLSystemPowerIoCompletion$24$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$24$label_57#1;

  inline$BDLSystemPowerIoCompletion$24$label_57#1:
    goto inline$BDLGetDebugLevel$624$Entry#1;

  inline$BDLGetDebugLevel$624$Entry#1:
    goto inline$BDLGetDebugLevel$624$start#1;

  inline$BDLGetDebugLevel$624$start#1:
    goto inline$BDLGetDebugLevel$624$label_3#1;

  inline$BDLGetDebugLevel$624$label_3#1:
    havoc inline$BDLGetDebugLevel$624$myNondetVar_0;
    inline$BDLGetDebugLevel$624$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$624$myNondetVar_0;
    goto inline$BDLGetDebugLevel$624$label_1#1;

  inline$BDLGetDebugLevel$624$label_1#1:
    goto inline$BDLGetDebugLevel$624$Return#1;

  inline$BDLGetDebugLevel$624$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$624$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon42_Then#1, inline$BDLSystemPowerIoCompletion$24$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon13#1;

  inline$BDLSystemPowerIoCompletion$24$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_66#1;

  inline$BDLSystemPowerIoCompletion$24$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_66_true#1, inline$BDLSystemPowerIoCompletion$24$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_67#1;

  inline$BDLSystemPowerIoCompletion$24$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_70#1;

  inline$BDLSystemPowerIoCompletion$24$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_67#1;

  inline$BDLSystemPowerIoCompletion$24$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$24$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$24$anon43_Then#1, inline$BDLSystemPowerIoCompletion$24$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon15#1;

  inline$BDLSystemPowerIoCompletion$24$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_71#1;

  inline$BDLSystemPowerIoCompletion$24$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$24$anon44_Then#1, inline$BDLSystemPowerIoCompletion$24$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon17#1;

  inline$BDLSystemPowerIoCompletion$24$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_74#1;

  inline$BDLSystemPowerIoCompletion$24$label_74#1:
    goto inline$storm_IoCompleteRequest$50$Entry#1;

  inline$storm_IoCompleteRequest$50$Entry#1:
    inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$24$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$50$start#1;

  inline$storm_IoCompleteRequest$50$start#1:
    inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$50$label_3#1;

  inline$storm_IoCompleteRequest$50$label_3#1:
    call inline$storm_IoCompleteRequest$50$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$50$label_6#1;

  inline$storm_IoCompleteRequest$50$label_6#1:
    goto inline$storm_IoCompleteRequest$50$label_6_true#1, inline$storm_IoCompleteRequest$50$label_6_false#1;

  inline$storm_IoCompleteRequest$50$label_6_false#1:
    assume inline$storm_IoCompleteRequest$50$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$50$label_7#1;

  inline$storm_IoCompleteRequest$50$label_6_true#1:
    assume inline$storm_IoCompleteRequest$50$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$50$label_8#1;

  inline$storm_IoCompleteRequest$50$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$50$anon3_Then#1, inline$storm_IoCompleteRequest$50$anon3_Else#1;

  inline$storm_IoCompleteRequest$50$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$50$anon1#1;

  inline$storm_IoCompleteRequest$50$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$50$label_9#1;

  inline$storm_IoCompleteRequest$50$label_9#1:
    goto inline$storm_IoCompleteRequest$50$label_9_true#1, inline$storm_IoCompleteRequest$50$label_9_false#1;

  inline$storm_IoCompleteRequest$50$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$50$label_10#1;

  inline$storm_IoCompleteRequest$50$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$50$label_1#1;

  inline$storm_IoCompleteRequest$50$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$50$label_7#1;

  inline$storm_IoCompleteRequest$50$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$50$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$50$label_1#1;

  inline$storm_IoCompleteRequest$50$label_1#1:
    goto inline$storm_IoCompleteRequest$50$Return#1;

  inline$storm_IoCompleteRequest$50$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$50$Return#1;

  inline$storm_IoCompleteRequest$50$Return#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon45_Then#1, inline$BDLSystemPowerIoCompletion$24$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon19#1;

  inline$BDLSystemPowerIoCompletion$24$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_77#1;

  inline$BDLSystemPowerIoCompletion$24$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$24$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$24$anon46_Then#1, inline$BDLSystemPowerIoCompletion$24$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon21#1;

  inline$BDLSystemPowerIoCompletion$24$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_80#1;

  inline$BDLSystemPowerIoCompletion$24$label_80#1:
    goto inline$BDLGetDebugLevel$625$Entry#1;

  inline$BDLGetDebugLevel$625$Entry#1:
    goto inline$BDLGetDebugLevel$625$start#1;

  inline$BDLGetDebugLevel$625$start#1:
    goto inline$BDLGetDebugLevel$625$label_3#1;

  inline$BDLGetDebugLevel$625$label_3#1:
    havoc inline$BDLGetDebugLevel$625$myNondetVar_0;
    inline$BDLGetDebugLevel$625$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$625$myNondetVar_0;
    goto inline$BDLGetDebugLevel$625$label_1#1;

  inline$BDLGetDebugLevel$625$label_1#1:
    goto inline$BDLGetDebugLevel$625$Return#1;

  inline$BDLGetDebugLevel$625$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$625$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon47_Then#1, inline$BDLSystemPowerIoCompletion$24$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon23#1;

  inline$BDLSystemPowerIoCompletion$24$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_83#1;

  inline$BDLSystemPowerIoCompletion$24$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_83_true#1, inline$BDLSystemPowerIoCompletion$24$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_84#1;

  inline$BDLSystemPowerIoCompletion$24$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_87#1;

  inline$BDLSystemPowerIoCompletion$24$label_87#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_88#1;

  inline$BDLSystemPowerIoCompletion$24$label_88#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_89#1;

  inline$BDLSystemPowerIoCompletion$24$label_89#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_90#1;

  inline$BDLSystemPowerIoCompletion$24$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$24$label_84#1;

  inline$BDLSystemPowerIoCompletion$24$label_84#1:
    goto inline$BDLGetDebugLevel$626$Entry#1;

  inline$BDLGetDebugLevel$626$Entry#1:
    goto inline$BDLGetDebugLevel$626$start#1;

  inline$BDLGetDebugLevel$626$start#1:
    goto inline$BDLGetDebugLevel$626$label_3#1;

  inline$BDLGetDebugLevel$626$label_3#1:
    havoc inline$BDLGetDebugLevel$626$myNondetVar_0;
    inline$BDLGetDebugLevel$626$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$626$myNondetVar_0;
    goto inline$BDLGetDebugLevel$626$label_1#1;

  inline$BDLGetDebugLevel$626$label_1#1:
    goto inline$BDLGetDebugLevel$626$Return#1;

  inline$BDLGetDebugLevel$626$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$626$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon48_Then#1, inline$BDLSystemPowerIoCompletion$24$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon25#1;

  inline$BDLSystemPowerIoCompletion$24$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_93#1;

  inline$BDLSystemPowerIoCompletion$24$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_93_true#1, inline$BDLSystemPowerIoCompletion$24$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_94#1;

  inline$BDLSystemPowerIoCompletion$24$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_97#1;

  inline$BDLSystemPowerIoCompletion$24$label_97#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_98#1;

  inline$BDLSystemPowerIoCompletion$24$label_98#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_99#1;

  inline$BDLSystemPowerIoCompletion$24$label_99#1:
    call inline$BDLSystemPowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$24$label_100#1;

  inline$BDLSystemPowerIoCompletion$24$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$24$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$24$label_94#1;

  inline$BDLSystemPowerIoCompletion$24$label_94#1:
    goto inline$BDLGetDebugLevel$627$Entry#1;

  inline$BDLGetDebugLevel$627$Entry#1:
    goto inline$BDLGetDebugLevel$627$start#1;

  inline$BDLGetDebugLevel$627$start#1:
    goto inline$BDLGetDebugLevel$627$label_3#1;

  inline$BDLGetDebugLevel$627$label_3#1:
    havoc inline$BDLGetDebugLevel$627$myNondetVar_0;
    inline$BDLGetDebugLevel$627$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$627$myNondetVar_0;
    goto inline$BDLGetDebugLevel$627$label_1#1;

  inline$BDLGetDebugLevel$627$label_1#1:
    goto inline$BDLGetDebugLevel$627$Return#1;

  inline$BDLGetDebugLevel$627$Return#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$627$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$24$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$24$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$24$anon49_Then#1, inline$BDLSystemPowerIoCompletion$24$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$24$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$anon27#1;

  inline$BDLSystemPowerIoCompletion$24$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_103#1;

  inline$BDLSystemPowerIoCompletion$24$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_103_true#1, inline$BDLSystemPowerIoCompletion$24$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$24$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_104#1;

  inline$BDLSystemPowerIoCompletion$24$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$24$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$24$label_105#1;

  inline$BDLSystemPowerIoCompletion$24$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$24$label_104#1;

  inline$BDLSystemPowerIoCompletion$24$label_104#1:
    inline$BDLSystemPowerIoCompletion$24$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$24$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$24$label_1#1;

  inline$BDLSystemPowerIoCompletion$24$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$24$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$24$Return#1;

  inline$BDLSystemPowerIoCompletion$24$Return#1:
    inline$CallCompletionRoutine$24$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$24$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$24$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$24$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$24$anon14_Then#1, inline$CallCompletionRoutine$24$anon14_Else#1;

  inline$CallCompletionRoutine$24$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$24$anon9#1;

  inline$CallCompletionRoutine$24$anon9#1:
    goto inline$CallCompletionRoutine$24$label_20_icall_return#1;

  inline$CallCompletionRoutine$24$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$24$Return#1;

  inline$CallCompletionRoutine$24$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$24$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$24$Entry#1;

  inline$BDLDevicePowerIoCompletion$24$Entry#1:
    inline$BDLDevicePowerIoCompletion$24$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$24$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$24$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$24$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$24$start#1;

  inline$BDLDevicePowerIoCompletion$24$start#1:
    call inline$BDLDevicePowerIoCompletion$24$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$24$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$24$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$24$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$24$label_3#1;

  inline$BDLDevicePowerIoCompletion$24$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_4#1;

  inline$BDLDevicePowerIoCompletion$24$label_4#1:
    inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_5#1;

  inline$BDLDevicePowerIoCompletion$24$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_6#1;

  inline$BDLDevicePowerIoCompletion$24$label_6#1:
    inline$BDLDevicePowerIoCompletion$24$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$24$label_7#1;

  inline$BDLDevicePowerIoCompletion$24$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_8#1;

  inline$BDLDevicePowerIoCompletion$24$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$24$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$24$label_9#1;

  inline$BDLDevicePowerIoCompletion$24$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_10#1;

  inline$BDLDevicePowerIoCompletion$24$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$126$Entry#1;

  inline$IoGetCurrentIrpStackLocation$126$Entry#1:
    inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$126$start#1;

  inline$IoGetCurrentIrpStackLocation$126$start#1:
    inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$126$label_3#1;

  inline$IoGetCurrentIrpStackLocation$126$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$126$label_3_true#1, inline$IoGetCurrentIrpStackLocation$126$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$126$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$126$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$126$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$126$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$126$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$126$label_4#1;

  inline$IoGetCurrentIrpStackLocation$126$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$126$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$126$label_6#1;

  inline$IoGetCurrentIrpStackLocation$126$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$126$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$126$label_7#1;

  inline$IoGetCurrentIrpStackLocation$126$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$126$label_5#1;

  inline$IoGetCurrentIrpStackLocation$126$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$126$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$126$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$126$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$126$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$126$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$126$label_5#1;

  inline$IoGetCurrentIrpStackLocation$126$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$126$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$126$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$126$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$126$label_1#1;

  inline$IoGetCurrentIrpStackLocation$126$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$126$Return#1;

  inline$IoGetCurrentIrpStackLocation$126$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$126$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon30_Then#1, inline$BDLDevicePowerIoCompletion$24$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon1#1;

  inline$BDLDevicePowerIoCompletion$24$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_13#1;

  inline$BDLDevicePowerIoCompletion$24$label_13#1:
    inline$BDLDevicePowerIoCompletion$24$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$24$label_14#1;

  inline$BDLDevicePowerIoCompletion$24$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_15#1;

  inline$BDLDevicePowerIoCompletion$24$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$24$label_16#1;

  inline$BDLDevicePowerIoCompletion$24$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_17#1;

  inline$BDLDevicePowerIoCompletion$24$label_17#1:
    goto inline$BDLGetDebugLevel$610$Entry#1;

  inline$BDLGetDebugLevel$610$Entry#1:
    goto inline$BDLGetDebugLevel$610$start#1;

  inline$BDLGetDebugLevel$610$start#1:
    goto inline$BDLGetDebugLevel$610$label_3#1;

  inline$BDLGetDebugLevel$610$label_3#1:
    havoc inline$BDLGetDebugLevel$610$myNondetVar_0;
    inline$BDLGetDebugLevel$610$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$610$myNondetVar_0;
    goto inline$BDLGetDebugLevel$610$label_1#1;

  inline$BDLGetDebugLevel$610$label_1#1:
    goto inline$BDLGetDebugLevel$610$Return#1;

  inline$BDLGetDebugLevel$610$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$610$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon31_Then#1, inline$BDLDevicePowerIoCompletion$24$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon3#1;

  inline$BDLDevicePowerIoCompletion$24$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_20#1;

  inline$BDLDevicePowerIoCompletion$24$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_20_true#1, inline$BDLDevicePowerIoCompletion$24$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_21#1;

  inline$BDLDevicePowerIoCompletion$24$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_24#1;

  inline$BDLDevicePowerIoCompletion$24$label_24#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_25#1;

  inline$BDLDevicePowerIoCompletion$24$label_25#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_26#1;

  inline$BDLDevicePowerIoCompletion$24$label_26#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_27#1;

  inline$BDLDevicePowerIoCompletion$24$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$24$label_21#1;

  inline$BDLDevicePowerIoCompletion$24$label_21#1:
    goto inline$BDLGetDebugLevel$611$Entry#1;

  inline$BDLGetDebugLevel$611$Entry#1:
    goto inline$BDLGetDebugLevel$611$start#1;

  inline$BDLGetDebugLevel$611$start#1:
    goto inline$BDLGetDebugLevel$611$label_3#1;

  inline$BDLGetDebugLevel$611$label_3#1:
    havoc inline$BDLGetDebugLevel$611$myNondetVar_0;
    inline$BDLGetDebugLevel$611$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$611$myNondetVar_0;
    goto inline$BDLGetDebugLevel$611$label_1#1;

  inline$BDLGetDebugLevel$611$label_1#1:
    goto inline$BDLGetDebugLevel$611$Return#1;

  inline$BDLGetDebugLevel$611$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$611$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon32_Then#1, inline$BDLDevicePowerIoCompletion$24$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon5#1;

  inline$BDLDevicePowerIoCompletion$24$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_30#1;

  inline$BDLDevicePowerIoCompletion$24$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_30_true#1, inline$BDLDevicePowerIoCompletion$24$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_31#1;

  inline$BDLDevicePowerIoCompletion$24$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_34#1;

  inline$BDLDevicePowerIoCompletion$24$label_34#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_35#1;

  inline$BDLDevicePowerIoCompletion$24$label_35#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_36#1;

  inline$BDLDevicePowerIoCompletion$24$label_36#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_37#1;

  inline$BDLDevicePowerIoCompletion$24$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$24$label_31#1;

  inline$BDLDevicePowerIoCompletion$24$label_31#1:
    goto inline$BDLGetDebugLevel$612$Entry#1;

  inline$BDLGetDebugLevel$612$Entry#1:
    goto inline$BDLGetDebugLevel$612$start#1;

  inline$BDLGetDebugLevel$612$start#1:
    goto inline$BDLGetDebugLevel$612$label_3#1;

  inline$BDLGetDebugLevel$612$label_3#1:
    havoc inline$BDLGetDebugLevel$612$myNondetVar_0;
    inline$BDLGetDebugLevel$612$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$612$myNondetVar_0;
    goto inline$BDLGetDebugLevel$612$label_1#1;

  inline$BDLGetDebugLevel$612$label_1#1:
    goto inline$BDLGetDebugLevel$612$Return#1;

  inline$BDLGetDebugLevel$612$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$612$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon33_Then#1, inline$BDLDevicePowerIoCompletion$24$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon7#1;

  inline$BDLDevicePowerIoCompletion$24$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_40#1;

  inline$BDLDevicePowerIoCompletion$24$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_40_true#1, inline$BDLDevicePowerIoCompletion$24$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_41#1;

  inline$BDLDevicePowerIoCompletion$24$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_42#1;

  inline$BDLDevicePowerIoCompletion$24$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_41#1;

  inline$BDLDevicePowerIoCompletion$24$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_41_true#1, inline$BDLDevicePowerIoCompletion$24$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$24$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$24$label_43#1;

  inline$BDLDevicePowerIoCompletion$24$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$24$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$24$label_44#1;

  inline$BDLDevicePowerIoCompletion$24$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_44_true#1, inline$BDLDevicePowerIoCompletion$24$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$24$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$24$label_45#1;

  inline$BDLDevicePowerIoCompletion$24$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_45_true#1, inline$BDLDevicePowerIoCompletion$24$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$24$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$24$label_43#1;

  inline$BDLDevicePowerIoCompletion$24$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$24$label_86#1;

  inline$BDLDevicePowerIoCompletion$24$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$24$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$24$label_46#1;

  inline$BDLDevicePowerIoCompletion$24$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$24$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$24$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$24$label_46#1;

  inline$BDLDevicePowerIoCompletion$24$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$24$label_49#1;

  inline$BDLDevicePowerIoCompletion$24$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_50#1;

  inline$BDLDevicePowerIoCompletion$24$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_51#1;

  inline$BDLDevicePowerIoCompletion$24$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_54#1;

  inline$BDLDevicePowerIoCompletion$24$label_54#1:
    inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$24$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$24$label_55#1;

  inline$BDLDevicePowerIoCompletion$24$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_55_true#1, inline$BDLDevicePowerIoCompletion$24$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_56#1;

  inline$BDLDevicePowerIoCompletion$24$label_56#1:
    call inline$BDLDevicePowerIoCompletion$24$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$24$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$24$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$24$anon34_Then#1, inline$BDLDevicePowerIoCompletion$24$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon9#1;

  inline$BDLDevicePowerIoCompletion$24$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_83#1;

  inline$BDLDevicePowerIoCompletion$24$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_59#1;

  inline$BDLDevicePowerIoCompletion$24$label_59#1:
    goto inline$BDLGetDebugLevel$613$Entry#1;

  inline$BDLGetDebugLevel$613$Entry#1:
    goto inline$BDLGetDebugLevel$613$start#1;

  inline$BDLGetDebugLevel$613$start#1:
    goto inline$BDLGetDebugLevel$613$label_3#1;

  inline$BDLGetDebugLevel$613$label_3#1:
    havoc inline$BDLGetDebugLevel$613$myNondetVar_0;
    inline$BDLGetDebugLevel$613$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$613$myNondetVar_0;
    goto inline$BDLGetDebugLevel$613$label_1#1;

  inline$BDLGetDebugLevel$613$label_1#1:
    goto inline$BDLGetDebugLevel$613$Return#1;

  inline$BDLGetDebugLevel$613$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$613$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon35_Then#1, inline$BDLDevicePowerIoCompletion$24$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon11#1;

  inline$BDLDevicePowerIoCompletion$24$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_62#1;

  inline$BDLDevicePowerIoCompletion$24$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_62_true#1, inline$BDLDevicePowerIoCompletion$24$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_63#1;

  inline$BDLDevicePowerIoCompletion$24$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_66#1;

  inline$BDLDevicePowerIoCompletion$24$label_66#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_67#1;

  inline$BDLDevicePowerIoCompletion$24$label_67#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_68#1;

  inline$BDLDevicePowerIoCompletion$24$label_68#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_69#1;

  inline$BDLDevicePowerIoCompletion$24$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$24$label_63#1;

  inline$BDLDevicePowerIoCompletion$24$label_63#1:
    goto inline$BDLGetDebugLevel$614$Entry#1;

  inline$BDLGetDebugLevel$614$Entry#1:
    goto inline$BDLGetDebugLevel$614$start#1;

  inline$BDLGetDebugLevel$614$start#1:
    goto inline$BDLGetDebugLevel$614$label_3#1;

  inline$BDLGetDebugLevel$614$label_3#1:
    havoc inline$BDLGetDebugLevel$614$myNondetVar_0;
    inline$BDLGetDebugLevel$614$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$614$myNondetVar_0;
    goto inline$BDLGetDebugLevel$614$label_1#1;

  inline$BDLGetDebugLevel$614$label_1#1:
    goto inline$BDLGetDebugLevel$614$Return#1;

  inline$BDLGetDebugLevel$614$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$614$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon36_Then#1, inline$BDLDevicePowerIoCompletion$24$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon13#1;

  inline$BDLDevicePowerIoCompletion$24$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_72#1;

  inline$BDLDevicePowerIoCompletion$24$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_72_true#1, inline$BDLDevicePowerIoCompletion$24$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_73#1;

  inline$BDLDevicePowerIoCompletion$24$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_76#1;

  inline$BDLDevicePowerIoCompletion$24$label_76#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_77#1;

  inline$BDLDevicePowerIoCompletion$24$label_77#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_78#1;

  inline$BDLDevicePowerIoCompletion$24$label_78#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_79#1;

  inline$BDLDevicePowerIoCompletion$24$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$24$label_73#1;

  inline$BDLDevicePowerIoCompletion$24$label_73#1:
    goto inline$BDLGetDebugLevel$615$Entry#1;

  inline$BDLGetDebugLevel$615$Entry#1:
    goto inline$BDLGetDebugLevel$615$start#1;

  inline$BDLGetDebugLevel$615$start#1:
    goto inline$BDLGetDebugLevel$615$label_3#1;

  inline$BDLGetDebugLevel$615$label_3#1:
    havoc inline$BDLGetDebugLevel$615$myNondetVar_0;
    inline$BDLGetDebugLevel$615$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$615$myNondetVar_0;
    goto inline$BDLGetDebugLevel$615$label_1#1;

  inline$BDLGetDebugLevel$615$label_1#1:
    goto inline$BDLGetDebugLevel$615$Return#1;

  inline$BDLGetDebugLevel$615$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$615$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon37_Then#1, inline$BDLDevicePowerIoCompletion$24$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon15#1;

  inline$BDLDevicePowerIoCompletion$24$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_82#1;

  inline$BDLDevicePowerIoCompletion$24$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_82_true#1, inline$BDLDevicePowerIoCompletion$24$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_83#1;

  inline$BDLDevicePowerIoCompletion$24$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_84#1;

  inline$BDLDevicePowerIoCompletion$24$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_83#1;

  inline$BDLDevicePowerIoCompletion$24$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_85#1;

  inline$BDLDevicePowerIoCompletion$24$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_86#1;

  inline$BDLDevicePowerIoCompletion$24$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$24$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$24$anon38_Then#1, inline$BDLDevicePowerIoCompletion$24$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon17#1;

  inline$BDLDevicePowerIoCompletion$24$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_89#1;

  inline$BDLDevicePowerIoCompletion$24$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$24$anon39_Then#1, inline$BDLDevicePowerIoCompletion$24$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon19#1;

  inline$BDLDevicePowerIoCompletion$24$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_92#1;

  inline$BDLDevicePowerIoCompletion$24$label_92#1:
    goto inline$storm_IoCompleteRequest$49$Entry#1;

  inline$storm_IoCompleteRequest$49$Entry#1:
    inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$24$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$49$start#1;

  inline$storm_IoCompleteRequest$49$start#1:
    inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$49$label_3#1;

  inline$storm_IoCompleteRequest$49$label_3#1:
    call inline$storm_IoCompleteRequest$49$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$49$label_6#1;

  inline$storm_IoCompleteRequest$49$label_6#1:
    goto inline$storm_IoCompleteRequest$49$label_6_true#1, inline$storm_IoCompleteRequest$49$label_6_false#1;

  inline$storm_IoCompleteRequest$49$label_6_false#1:
    assume inline$storm_IoCompleteRequest$49$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$49$label_7#1;

  inline$storm_IoCompleteRequest$49$label_6_true#1:
    assume inline$storm_IoCompleteRequest$49$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$49$label_8#1;

  inline$storm_IoCompleteRequest$49$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$49$anon3_Then#1, inline$storm_IoCompleteRequest$49$anon3_Else#1;

  inline$storm_IoCompleteRequest$49$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$49$anon1#1;

  inline$storm_IoCompleteRequest$49$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$49$label_9#1;

  inline$storm_IoCompleteRequest$49$label_9#1:
    goto inline$storm_IoCompleteRequest$49$label_9_true#1, inline$storm_IoCompleteRequest$49$label_9_false#1;

  inline$storm_IoCompleteRequest$49$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$49$label_10#1;

  inline$storm_IoCompleteRequest$49$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$49$label_1#1;

  inline$storm_IoCompleteRequest$49$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$49$label_7#1;

  inline$storm_IoCompleteRequest$49$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$49$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$49$label_1#1;

  inline$storm_IoCompleteRequest$49$label_1#1:
    goto inline$storm_IoCompleteRequest$49$Return#1;

  inline$storm_IoCompleteRequest$49$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$49$Return#1;

  inline$storm_IoCompleteRequest$49$Return#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon40_Then#1, inline$BDLDevicePowerIoCompletion$24$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon21#1;

  inline$BDLDevicePowerIoCompletion$24$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_95#1;

  inline$BDLDevicePowerIoCompletion$24$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$24$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$24$anon41_Then#1, inline$BDLDevicePowerIoCompletion$24$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon23#1;

  inline$BDLDevicePowerIoCompletion$24$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_98#1;

  inline$BDLDevicePowerIoCompletion$24$label_98#1:
    goto inline$BDLGetDebugLevel$616$Entry#1;

  inline$BDLGetDebugLevel$616$Entry#1:
    goto inline$BDLGetDebugLevel$616$start#1;

  inline$BDLGetDebugLevel$616$start#1:
    goto inline$BDLGetDebugLevel$616$label_3#1;

  inline$BDLGetDebugLevel$616$label_3#1:
    havoc inline$BDLGetDebugLevel$616$myNondetVar_0;
    inline$BDLGetDebugLevel$616$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$616$myNondetVar_0;
    goto inline$BDLGetDebugLevel$616$label_1#1;

  inline$BDLGetDebugLevel$616$label_1#1:
    goto inline$BDLGetDebugLevel$616$Return#1;

  inline$BDLGetDebugLevel$616$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$616$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon42_Then#1, inline$BDLDevicePowerIoCompletion$24$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon25#1;

  inline$BDLDevicePowerIoCompletion$24$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_101#1;

  inline$BDLDevicePowerIoCompletion$24$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_101_true#1, inline$BDLDevicePowerIoCompletion$24$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_102#1;

  inline$BDLDevicePowerIoCompletion$24$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_105#1;

  inline$BDLDevicePowerIoCompletion$24$label_105#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_106#1;

  inline$BDLDevicePowerIoCompletion$24$label_106#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_107#1;

  inline$BDLDevicePowerIoCompletion$24$label_107#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_108#1;

  inline$BDLDevicePowerIoCompletion$24$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$24$label_102#1;

  inline$BDLDevicePowerIoCompletion$24$label_102#1:
    goto inline$BDLGetDebugLevel$617$Entry#1;

  inline$BDLGetDebugLevel$617$Entry#1:
    goto inline$BDLGetDebugLevel$617$start#1;

  inline$BDLGetDebugLevel$617$start#1:
    goto inline$BDLGetDebugLevel$617$label_3#1;

  inline$BDLGetDebugLevel$617$label_3#1:
    havoc inline$BDLGetDebugLevel$617$myNondetVar_0;
    inline$BDLGetDebugLevel$617$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$617$myNondetVar_0;
    goto inline$BDLGetDebugLevel$617$label_1#1;

  inline$BDLGetDebugLevel$617$label_1#1:
    goto inline$BDLGetDebugLevel$617$Return#1;

  inline$BDLGetDebugLevel$617$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$617$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon43_Then#1, inline$BDLDevicePowerIoCompletion$24$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon27#1;

  inline$BDLDevicePowerIoCompletion$24$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_111#1;

  inline$BDLDevicePowerIoCompletion$24$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_111_true#1, inline$BDLDevicePowerIoCompletion$24$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_112#1;

  inline$BDLDevicePowerIoCompletion$24$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_115#1;

  inline$BDLDevicePowerIoCompletion$24$label_115#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_116#1;

  inline$BDLDevicePowerIoCompletion$24$label_116#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_117#1;

  inline$BDLDevicePowerIoCompletion$24$label_117#1:
    call inline$BDLDevicePowerIoCompletion$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$24$label_118#1;

  inline$BDLDevicePowerIoCompletion$24$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$24$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$24$label_112#1;

  inline$BDLDevicePowerIoCompletion$24$label_112#1:
    goto inline$BDLGetDebugLevel$618$Entry#1;

  inline$BDLGetDebugLevel$618$Entry#1:
    goto inline$BDLGetDebugLevel$618$start#1;

  inline$BDLGetDebugLevel$618$start#1:
    goto inline$BDLGetDebugLevel$618$label_3#1;

  inline$BDLGetDebugLevel$618$label_3#1:
    havoc inline$BDLGetDebugLevel$618$myNondetVar_0;
    inline$BDLGetDebugLevel$618$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$618$myNondetVar_0;
    goto inline$BDLGetDebugLevel$618$label_1#1;

  inline$BDLGetDebugLevel$618$label_1#1:
    goto inline$BDLGetDebugLevel$618$Return#1;

  inline$BDLGetDebugLevel$618$Return#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$618$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$24$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$24$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$24$anon44_Then#1, inline$BDLDevicePowerIoCompletion$24$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$24$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$anon29#1;

  inline$BDLDevicePowerIoCompletion$24$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_121#1;

  inline$BDLDevicePowerIoCompletion$24$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_121_true#1, inline$BDLDevicePowerIoCompletion$24$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$24$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_122#1;

  inline$BDLDevicePowerIoCompletion$24$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$24$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$24$label_123#1;

  inline$BDLDevicePowerIoCompletion$24$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$24$label_122#1;

  inline$BDLDevicePowerIoCompletion$24$label_122#1:
    inline$BDLDevicePowerIoCompletion$24$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$24$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$24$label_1#1;

  inline$BDLDevicePowerIoCompletion$24$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$24$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$24$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$24$Return#1;

  inline$BDLDevicePowerIoCompletion$24$Return#1:
    inline$CallCompletionRoutine$24$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$24$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$24$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$24$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$24$anon13_Then#1, inline$CallCompletionRoutine$24$anon13_Else#1;

  inline$CallCompletionRoutine$24$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$24$anon7#1;

  inline$CallCompletionRoutine$24$anon7#1:
    goto inline$CallCompletionRoutine$24$label_20_icall_return#1;

  inline$CallCompletionRoutine$24$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$24$Return#1;

  inline$CallCompletionRoutine$24$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$24$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$24$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$24$Entry#1;

  inline$BDLCallDriverCompletionRoutine$24$Entry#1:
    inline$BDLCallDriverCompletionRoutine$24$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$24$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$24$start#1;

  inline$BDLCallDriverCompletionRoutine$24$start#1:
    inline$BDLCallDriverCompletionRoutine$24$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$24$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$24$label_3#1;

  inline$BDLCallDriverCompletionRoutine$24$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$24$label_3_true#1, inline$BDLCallDriverCompletionRoutine$24$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$24$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$24$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$24$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$24$label_4#1;

  inline$BDLCallDriverCompletionRoutine$24$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$24$label_6#1;

  inline$BDLCallDriverCompletionRoutine$24$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$24$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$24$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$24$label_5#1;

  inline$BDLCallDriverCompletionRoutine$24$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$24$label_6#1;

  inline$BDLCallDriverCompletionRoutine$24$label_6#1:
    goto inline$storm_KeSetEvent$26$Entry#1;

  inline$storm_KeSetEvent$26$Entry#1:
    inline$storm_KeSetEvent$26$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$24$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$26$start#1;

  inline$storm_KeSetEvent$26$start#1:
    inline$storm_KeSetEvent$26$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$26$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$26$label_3#1;

  inline$storm_KeSetEvent$26$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$26$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$26$label_1#1;

  inline$storm_KeSetEvent$26$label_1#1:
    goto inline$storm_KeSetEvent$26$Return#1;

  inline$storm_KeSetEvent$26$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$24$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$24$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$24$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$24$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$24$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$24$anon1#1;

  inline$BDLCallDriverCompletionRoutine$24$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$24$label_9#1;

  inline$BDLCallDriverCompletionRoutine$24$label_9#1:
    inline$BDLCallDriverCompletionRoutine$24$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$24$label_1#1;

  inline$BDLCallDriverCompletionRoutine$24$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$24$Return#1;

  inline$BDLCallDriverCompletionRoutine$24$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$24$Return#1;

  inline$BDLCallDriverCompletionRoutine$24$Return#1:
    inline$CallCompletionRoutine$24$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$24$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$24$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$24$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$24$anon12_Then#1, inline$CallCompletionRoutine$24$anon12_Else#1;

  inline$CallCompletionRoutine$24$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$24$anon5#1;

  inline$CallCompletionRoutine$24$anon5#1:
    goto inline$CallCompletionRoutine$24$label_20_icall_return#1;

  inline$CallCompletionRoutine$24$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$24$label_23#1;

  inline$CallCompletionRoutine$24$label_23#1:
    inline$CallCompletionRoutine$24$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$24$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$24$label_24#1;

  inline$CallCompletionRoutine$24$label_24#1:
    goto inline$CallCompletionRoutine$24$label_24_true#1, inline$CallCompletionRoutine$24$label_24_false#1;

  inline$CallCompletionRoutine$24$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$24$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$24$label_1#1;

  inline$CallCompletionRoutine$24$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$24$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$24$label_25#1;

  inline$CallCompletionRoutine$24$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$24$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$24$label_1#1;

  inline$CallCompletionRoutine$24$label_1#1:
    goto inline$CallCompletionRoutine$24$Return#1;

  inline$CallCompletionRoutine$24$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$24$Return#1;

  inline$CallCompletionRoutine$24$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$24$Return#1;

  inline$CallCompletionRoutine$24$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$24$Return#1;

  inline$CallCompletionRoutine$24$Return#1:
    goto inline$storm_IoCallDriver$12$label_33$1#1;

  inline$storm_IoCallDriver$12$label_33$1#1:
    goto inline$storm_IoCallDriver$12$anon14_Then#1, inline$storm_IoCallDriver$12$anon14_Else#1;

  inline$storm_IoCallDriver$12$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$12$anon8#1;

  inline$storm_IoCallDriver$12$anon8#1:
    goto inline$storm_IoCallDriver$12$label_36#1;

  inline$storm_IoCallDriver$12$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$12$Return#1;

  inline$storm_IoCallDriver$12$label_27_case_1#1:
    assume inline$storm_IoCallDriver$12$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$12$label_29#1;

  inline$storm_IoCallDriver$12$label_29#1:
    inline$storm_IoCallDriver$12$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$12$label_37#1;

  inline$storm_IoCallDriver$12$label_37#1:
    goto inline$storm_IoCallDriver$12$label_38#1;

  inline$storm_IoCallDriver$12$label_38#1:
    goto inline$storm_IoCallDriver$12$label_39#1;

  inline$storm_IoCallDriver$12$label_39#1:
    goto inline$CallCompletionRoutine$25$Entry#1;

  inline$CallCompletionRoutine$25$Entry#1:
    inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$25$start#1;

  inline$CallCompletionRoutine$25$start#1:
    inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$25$label_3#1;

  inline$CallCompletionRoutine$25$label_3#1:
    goto inline$CallCompletionRoutine$25$label_4#1;

  inline$CallCompletionRoutine$25$label_4#1:
    goto inline$CallCompletionRoutine$25$label_5#1;

  inline$CallCompletionRoutine$25$label_5#1:
    goto inline$CallCompletionRoutine$25$label_6#1;

  inline$CallCompletionRoutine$25$label_6#1:
    goto inline$CallCompletionRoutine$25$label_7#1;

  inline$CallCompletionRoutine$25$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$128$Entry#1;

  inline$IoGetCurrentIrpStackLocation$128$Entry#1:
    inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$128$start#1;

  inline$IoGetCurrentIrpStackLocation$128$start#1:
    inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$128$label_3#1;

  inline$IoGetCurrentIrpStackLocation$128$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$128$label_3_true#1, inline$IoGetCurrentIrpStackLocation$128$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$128$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$128$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$128$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$128$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$128$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$128$label_4#1;

  inline$IoGetCurrentIrpStackLocation$128$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$128$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$128$label_6#1;

  inline$IoGetCurrentIrpStackLocation$128$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$128$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$128$label_7#1;

  inline$IoGetCurrentIrpStackLocation$128$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$128$label_5#1;

  inline$IoGetCurrentIrpStackLocation$128$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$128$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$128$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$128$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$128$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$128$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$128$label_5#1;

  inline$IoGetCurrentIrpStackLocation$128$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$128$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$128$label_1#1;

  inline$IoGetCurrentIrpStackLocation$128$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$128$Return#1;

  inline$IoGetCurrentIrpStackLocation$128$Return#1:
    goto inline$CallCompletionRoutine$25$label_7$1#1;

  inline$CallCompletionRoutine$25$label_7$1#1:
    goto inline$CallCompletionRoutine$25$anon10_Then#1, inline$CallCompletionRoutine$25$anon10_Else#1;

  inline$CallCompletionRoutine$25$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$25$anon1#1;

  inline$CallCompletionRoutine$25$anon1#1:
    goto inline$CallCompletionRoutine$25$label_10#1;

  inline$CallCompletionRoutine$25$label_10#1:
    goto inline$CallCompletionRoutine$25$label_11#1;

  inline$CallCompletionRoutine$25$label_11#1:
    havoc inline$CallCompletionRoutine$25$myNondetVar_0;
    inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$25$myNondetVar_0;
    goto inline$CallCompletionRoutine$25$label_12#1;

  inline$CallCompletionRoutine$25$label_12#1:
    havoc inline$CallCompletionRoutine$25$myNondetVar_0;
    inline$CallCompletionRoutine$25$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$25$myNondetVar_0;
    goto inline$CallCompletionRoutine$25$label_13#1;

  inline$CallCompletionRoutine$25$label_13#1:
    havoc inline$CallCompletionRoutine$25$myNondetVar_0;
    goto inline$CallCompletionRoutine$25$label_14#1;

  inline$CallCompletionRoutine$25$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$129$Entry#1;

  inline$IoGetCurrentIrpStackLocation$129$Entry#1:
    inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$129$start#1;

  inline$IoGetCurrentIrpStackLocation$129$start#1:
    inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$129$label_3#1;

  inline$IoGetCurrentIrpStackLocation$129$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$129$label_3_true#1, inline$IoGetCurrentIrpStackLocation$129$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$129$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$129$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$129$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$129$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$129$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$129$label_4#1;

  inline$IoGetCurrentIrpStackLocation$129$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$129$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$129$label_6#1;

  inline$IoGetCurrentIrpStackLocation$129$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$129$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$129$label_7#1;

  inline$IoGetCurrentIrpStackLocation$129$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$129$label_5#1;

  inline$IoGetCurrentIrpStackLocation$129$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$129$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$129$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$129$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$129$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$129$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$129$label_5#1;

  inline$IoGetCurrentIrpStackLocation$129$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$129$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$129$label_1#1;

  inline$IoGetCurrentIrpStackLocation$129$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$129$Return#1;

  inline$IoGetCurrentIrpStackLocation$129$Return#1:
    goto inline$CallCompletionRoutine$25$label_14$1#1;

  inline$CallCompletionRoutine$25$label_14$1#1:
    goto inline$CallCompletionRoutine$25$anon11_Then#1, inline$CallCompletionRoutine$25$anon11_Else#1;

  inline$CallCompletionRoutine$25$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$25$anon3#1;

  inline$CallCompletionRoutine$25$anon3#1:
    goto inline$CallCompletionRoutine$25$label_17#1;

  inline$CallCompletionRoutine$25$label_17#1:
    goto inline$CallCompletionRoutine$25$label_18#1;

  inline$CallCompletionRoutine$25$label_18#1:
    goto inline$CallCompletionRoutine$25$label_18_true#1, inline$CallCompletionRoutine$25$label_18_false#1;

  inline$CallCompletionRoutine$25$label_18_false#1:
    assume inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$25$label_1#1;

  inline$CallCompletionRoutine$25$label_18_true#1:
    assume inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$25$label_19#1;

  inline$CallCompletionRoutine$25$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$25$label_20#1;

  inline$CallCompletionRoutine$25$label_20#1:
    goto inline$CallCompletionRoutine$25$label_20_icall_1#1, inline$CallCompletionRoutine$25$label_20_icall_2#1, inline$CallCompletionRoutine$25$label_20_icall_3#1;

  inline$CallCompletionRoutine$25$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$25$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$25$Entry#1;

  inline$BDLSystemPowerIoCompletion$25$Entry#1:
    inline$BDLSystemPowerIoCompletion$25$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$25$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$25$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$25$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$25$start#1;

  inline$BDLSystemPowerIoCompletion$25$start#1:
    call inline$BDLSystemPowerIoCompletion$25$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$25$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$25$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$25$label_3#1;

  inline$BDLSystemPowerIoCompletion$25$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_4#1;

  inline$BDLSystemPowerIoCompletion$25$label_4#1:
    inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_5#1;

  inline$BDLSystemPowerIoCompletion$25$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_6#1;

  inline$BDLSystemPowerIoCompletion$25$label_6#1:
    inline$BDLSystemPowerIoCompletion$25$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$25$label_7#1;

  inline$BDLSystemPowerIoCompletion$25$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_8#1;

  inline$BDLSystemPowerIoCompletion$25$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$25$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$25$label_9#1;

  inline$BDLSystemPowerIoCompletion$25$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_10#1;

  inline$BDLSystemPowerIoCompletion$25$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$131$Entry#1;

  inline$IoGetCurrentIrpStackLocation$131$Entry#1:
    inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$131$start#1;

  inline$IoGetCurrentIrpStackLocation$131$start#1:
    inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$131$label_3#1;

  inline$IoGetCurrentIrpStackLocation$131$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$131$label_3_true#1, inline$IoGetCurrentIrpStackLocation$131$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$131$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$131$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$131$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$131$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$131$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$131$label_4#1;

  inline$IoGetCurrentIrpStackLocation$131$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$131$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$131$label_6#1;

  inline$IoGetCurrentIrpStackLocation$131$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$131$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$131$label_7#1;

  inline$IoGetCurrentIrpStackLocation$131$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$131$label_5#1;

  inline$IoGetCurrentIrpStackLocation$131$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$131$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$131$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$131$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$131$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$131$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$131$label_5#1;

  inline$IoGetCurrentIrpStackLocation$131$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$131$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$131$label_1#1;

  inline$IoGetCurrentIrpStackLocation$131$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$131$Return#1;

  inline$IoGetCurrentIrpStackLocation$131$Return#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon36_Then#1, inline$BDLSystemPowerIoCompletion$25$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon1#1;

  inline$BDLSystemPowerIoCompletion$25$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_13#1;

  inline$BDLSystemPowerIoCompletion$25$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_14#1;

  inline$BDLSystemPowerIoCompletion$25$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_15#1;

  inline$BDLSystemPowerIoCompletion$25$label_15#1:
    goto inline$BDLGetDebugLevel$640$Entry#1;

  inline$BDLGetDebugLevel$640$Entry#1:
    goto inline$BDLGetDebugLevel$640$start#1;

  inline$BDLGetDebugLevel$640$start#1:
    goto inline$BDLGetDebugLevel$640$label_3#1;

  inline$BDLGetDebugLevel$640$label_3#1:
    havoc inline$BDLGetDebugLevel$640$myNondetVar_0;
    inline$BDLGetDebugLevel$640$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$640$myNondetVar_0;
    goto inline$BDLGetDebugLevel$640$label_1#1;

  inline$BDLGetDebugLevel$640$label_1#1:
    goto inline$BDLGetDebugLevel$640$Return#1;

  inline$BDLGetDebugLevel$640$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$640$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon37_Then#1, inline$BDLSystemPowerIoCompletion$25$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon3#1;

  inline$BDLSystemPowerIoCompletion$25$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_18#1;

  inline$BDLSystemPowerIoCompletion$25$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_18_true#1, inline$BDLSystemPowerIoCompletion$25$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_19#1;

  inline$BDLSystemPowerIoCompletion$25$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_22#1;

  inline$BDLSystemPowerIoCompletion$25$label_22#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_23#1;

  inline$BDLSystemPowerIoCompletion$25$label_23#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_24#1;

  inline$BDLSystemPowerIoCompletion$25$label_24#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_25#1;

  inline$BDLSystemPowerIoCompletion$25$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$25$label_19#1;

  inline$BDLSystemPowerIoCompletion$25$label_19#1:
    goto inline$BDLGetDebugLevel$641$Entry#1;

  inline$BDLGetDebugLevel$641$Entry#1:
    goto inline$BDLGetDebugLevel$641$start#1;

  inline$BDLGetDebugLevel$641$start#1:
    goto inline$BDLGetDebugLevel$641$label_3#1;

  inline$BDLGetDebugLevel$641$label_3#1:
    havoc inline$BDLGetDebugLevel$641$myNondetVar_0;
    inline$BDLGetDebugLevel$641$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$641$myNondetVar_0;
    goto inline$BDLGetDebugLevel$641$label_1#1;

  inline$BDLGetDebugLevel$641$label_1#1:
    goto inline$BDLGetDebugLevel$641$Return#1;

  inline$BDLGetDebugLevel$641$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$641$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon38_Then#1, inline$BDLSystemPowerIoCompletion$25$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon5#1;

  inline$BDLSystemPowerIoCompletion$25$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_28#1;

  inline$BDLSystemPowerIoCompletion$25$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_28_true#1, inline$BDLSystemPowerIoCompletion$25$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_29#1;

  inline$BDLSystemPowerIoCompletion$25$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_32#1;

  inline$BDLSystemPowerIoCompletion$25$label_32#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_33#1;

  inline$BDLSystemPowerIoCompletion$25$label_33#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_34#1;

  inline$BDLSystemPowerIoCompletion$25$label_34#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_35#1;

  inline$BDLSystemPowerIoCompletion$25$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$25$label_29#1;

  inline$BDLSystemPowerIoCompletion$25$label_29#1:
    goto inline$BDLGetDebugLevel$642$Entry#1;

  inline$BDLGetDebugLevel$642$Entry#1:
    goto inline$BDLGetDebugLevel$642$start#1;

  inline$BDLGetDebugLevel$642$start#1:
    goto inline$BDLGetDebugLevel$642$label_3#1;

  inline$BDLGetDebugLevel$642$label_3#1:
    havoc inline$BDLGetDebugLevel$642$myNondetVar_0;
    inline$BDLGetDebugLevel$642$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$642$myNondetVar_0;
    goto inline$BDLGetDebugLevel$642$label_1#1;

  inline$BDLGetDebugLevel$642$label_1#1:
    goto inline$BDLGetDebugLevel$642$Return#1;

  inline$BDLGetDebugLevel$642$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$642$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon39_Then#1, inline$BDLSystemPowerIoCompletion$25$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon7#1;

  inline$BDLSystemPowerIoCompletion$25$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_38#1;

  inline$BDLSystemPowerIoCompletion$25$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_38_true#1, inline$BDLSystemPowerIoCompletion$25$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_39#1;

  inline$BDLSystemPowerIoCompletion$25$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_40#1;

  inline$BDLSystemPowerIoCompletion$25$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_39#1;

  inline$BDLSystemPowerIoCompletion$25$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_39_true#1, inline$BDLSystemPowerIoCompletion$25$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_41#1;

  inline$BDLSystemPowerIoCompletion$25$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$25$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$25$label_107#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$25$label_108#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$25$label_108#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$25$label_108#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$25$label_108#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$25$label_108#1;

  inline$BDLSystemPowerIoCompletion$25$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_109#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$25$label_107#1;

  inline$BDLSystemPowerIoCompletion$25$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_109#1;

  inline$BDLSystemPowerIoCompletion$25$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$25$label_106#1;

  inline$BDLSystemPowerIoCompletion$25$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_106_true#1, inline$BDLSystemPowerIoCompletion$25$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_142#1;

  inline$BDLSystemPowerIoCompletion$25$label_142#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_143#1;

  inline$BDLSystemPowerIoCompletion$25$label_143#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_144#1;

  inline$BDLSystemPowerIoCompletion$25$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_109#1;

  inline$BDLSystemPowerIoCompletion$25$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_109#1;

  inline$BDLSystemPowerIoCompletion$25$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$25$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$25$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$25$myNondetVar_0, inline$BDLSystemPowerIoCompletion$25$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$25$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$25$anon50_Then#1, inline$BDLSystemPowerIoCompletion$25$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon29#1;

  inline$BDLSystemPowerIoCompletion$25$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_112#1;

  inline$BDLSystemPowerIoCompletion$25$label_112#1:
    inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$25$label_113#1;

  inline$BDLSystemPowerIoCompletion$25$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_113_true#1, inline$BDLSystemPowerIoCompletion$25$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$25$label_114#1;

  inline$BDLSystemPowerIoCompletion$25$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_116#1;

  inline$BDLSystemPowerIoCompletion$25$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_117#1;

  inline$BDLSystemPowerIoCompletion$25$label_117#1:
    goto inline$BDLGetDebugLevel$649$Entry#1;

  inline$BDLGetDebugLevel$649$Entry#1:
    goto inline$BDLGetDebugLevel$649$start#1;

  inline$BDLGetDebugLevel$649$start#1:
    goto inline$BDLGetDebugLevel$649$label_3#1;

  inline$BDLGetDebugLevel$649$label_3#1:
    havoc inline$BDLGetDebugLevel$649$myNondetVar_0;
    inline$BDLGetDebugLevel$649$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$649$myNondetVar_0;
    goto inline$BDLGetDebugLevel$649$label_1#1;

  inline$BDLGetDebugLevel$649$label_1#1:
    goto inline$BDLGetDebugLevel$649$Return#1;

  inline$BDLGetDebugLevel$649$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$649$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon51_Then#1, inline$BDLSystemPowerIoCompletion$25$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon31#1;

  inline$BDLSystemPowerIoCompletion$25$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_120#1;

  inline$BDLSystemPowerIoCompletion$25$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_120_true#1, inline$BDLSystemPowerIoCompletion$25$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_121#1;

  inline$BDLSystemPowerIoCompletion$25$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_124#1;

  inline$BDLSystemPowerIoCompletion$25$label_124#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_125#1;

  inline$BDLSystemPowerIoCompletion$25$label_125#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_126#1;

  inline$BDLSystemPowerIoCompletion$25$label_126#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_127#1;

  inline$BDLSystemPowerIoCompletion$25$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$25$label_121#1;

  inline$BDLSystemPowerIoCompletion$25$label_121#1:
    goto inline$BDLGetDebugLevel$650$Entry#1;

  inline$BDLGetDebugLevel$650$Entry#1:
    goto inline$BDLGetDebugLevel$650$start#1;

  inline$BDLGetDebugLevel$650$start#1:
    goto inline$BDLGetDebugLevel$650$label_3#1;

  inline$BDLGetDebugLevel$650$label_3#1:
    havoc inline$BDLGetDebugLevel$650$myNondetVar_0;
    inline$BDLGetDebugLevel$650$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$650$myNondetVar_0;
    goto inline$BDLGetDebugLevel$650$label_1#1;

  inline$BDLGetDebugLevel$650$label_1#1:
    goto inline$BDLGetDebugLevel$650$Return#1;

  inline$BDLGetDebugLevel$650$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$650$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon52_Then#1, inline$BDLSystemPowerIoCompletion$25$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon33#1;

  inline$BDLSystemPowerIoCompletion$25$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_130#1;

  inline$BDLSystemPowerIoCompletion$25$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_130_true#1, inline$BDLSystemPowerIoCompletion$25$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_131#1;

  inline$BDLSystemPowerIoCompletion$25$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_134#1;

  inline$BDLSystemPowerIoCompletion$25$label_134#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_135#1;

  inline$BDLSystemPowerIoCompletion$25$label_135#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_136#1;

  inline$BDLSystemPowerIoCompletion$25$label_136#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_137#1;

  inline$BDLSystemPowerIoCompletion$25$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$25$label_131#1;

  inline$BDLSystemPowerIoCompletion$25$label_131#1:
    goto inline$BDLGetDebugLevel$651$Entry#1;

  inline$BDLGetDebugLevel$651$Entry#1:
    goto inline$BDLGetDebugLevel$651$start#1;

  inline$BDLGetDebugLevel$651$start#1:
    goto inline$BDLGetDebugLevel$651$label_3#1;

  inline$BDLGetDebugLevel$651$label_3#1:
    havoc inline$BDLGetDebugLevel$651$myNondetVar_0;
    inline$BDLGetDebugLevel$651$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$651$myNondetVar_0;
    goto inline$BDLGetDebugLevel$651$label_1#1;

  inline$BDLGetDebugLevel$651$label_1#1:
    goto inline$BDLGetDebugLevel$651$Return#1;

  inline$BDLGetDebugLevel$651$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$651$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon53_Then#1, inline$BDLSystemPowerIoCompletion$25$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon35#1;

  inline$BDLSystemPowerIoCompletion$25$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_140#1;

  inline$BDLSystemPowerIoCompletion$25$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_140_true#1, inline$BDLSystemPowerIoCompletion$25$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_67#1;

  inline$BDLSystemPowerIoCompletion$25$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_141#1;

  inline$BDLSystemPowerIoCompletion$25$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_67#1;

  inline$BDLSystemPowerIoCompletion$25$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$25$label_115#1;

  inline$BDLSystemPowerIoCompletion$25$label_115#1:
    inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$25$label_80#1;

  inline$BDLSystemPowerIoCompletion$25$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$25$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_42#1;

  inline$BDLSystemPowerIoCompletion$25$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$25$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$25$label_43#1;

  inline$BDLSystemPowerIoCompletion$25$label_43#1:
    goto inline$BDLGetDebugLevel$643$Entry#1;

  inline$BDLGetDebugLevel$643$Entry#1:
    goto inline$BDLGetDebugLevel$643$start#1;

  inline$BDLGetDebugLevel$643$start#1:
    goto inline$BDLGetDebugLevel$643$label_3#1;

  inline$BDLGetDebugLevel$643$label_3#1:
    havoc inline$BDLGetDebugLevel$643$myNondetVar_0;
    inline$BDLGetDebugLevel$643$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$643$myNondetVar_0;
    goto inline$BDLGetDebugLevel$643$label_1#1;

  inline$BDLGetDebugLevel$643$label_1#1:
    goto inline$BDLGetDebugLevel$643$Return#1;

  inline$BDLGetDebugLevel$643$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$643$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon40_Then#1, inline$BDLSystemPowerIoCompletion$25$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon9#1;

  inline$BDLSystemPowerIoCompletion$25$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_46#1;

  inline$BDLSystemPowerIoCompletion$25$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_46_true#1, inline$BDLSystemPowerIoCompletion$25$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_47#1;

  inline$BDLSystemPowerIoCompletion$25$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_50#1;

  inline$BDLSystemPowerIoCompletion$25$label_50#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_51#1;

  inline$BDLSystemPowerIoCompletion$25$label_51#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_52#1;

  inline$BDLSystemPowerIoCompletion$25$label_52#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_53#1;

  inline$BDLSystemPowerIoCompletion$25$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$25$label_47#1;

  inline$BDLSystemPowerIoCompletion$25$label_47#1:
    goto inline$BDLGetDebugLevel$644$Entry#1;

  inline$BDLGetDebugLevel$644$Entry#1:
    goto inline$BDLGetDebugLevel$644$start#1;

  inline$BDLGetDebugLevel$644$start#1:
    goto inline$BDLGetDebugLevel$644$label_3#1;

  inline$BDLGetDebugLevel$644$label_3#1:
    havoc inline$BDLGetDebugLevel$644$myNondetVar_0;
    inline$BDLGetDebugLevel$644$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$644$myNondetVar_0;
    goto inline$BDLGetDebugLevel$644$label_1#1;

  inline$BDLGetDebugLevel$644$label_1#1:
    goto inline$BDLGetDebugLevel$644$Return#1;

  inline$BDLGetDebugLevel$644$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$644$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon41_Then#1, inline$BDLSystemPowerIoCompletion$25$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon11#1;

  inline$BDLSystemPowerIoCompletion$25$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_56#1;

  inline$BDLSystemPowerIoCompletion$25$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_56_true#1, inline$BDLSystemPowerIoCompletion$25$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_57#1;

  inline$BDLSystemPowerIoCompletion$25$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_60#1;

  inline$BDLSystemPowerIoCompletion$25$label_60#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_61#1;

  inline$BDLSystemPowerIoCompletion$25$label_61#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_62#1;

  inline$BDLSystemPowerIoCompletion$25$label_62#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_63#1;

  inline$BDLSystemPowerIoCompletion$25$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$25$label_57#1;

  inline$BDLSystemPowerIoCompletion$25$label_57#1:
    goto inline$BDLGetDebugLevel$645$Entry#1;

  inline$BDLGetDebugLevel$645$Entry#1:
    goto inline$BDLGetDebugLevel$645$start#1;

  inline$BDLGetDebugLevel$645$start#1:
    goto inline$BDLGetDebugLevel$645$label_3#1;

  inline$BDLGetDebugLevel$645$label_3#1:
    havoc inline$BDLGetDebugLevel$645$myNondetVar_0;
    inline$BDLGetDebugLevel$645$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$645$myNondetVar_0;
    goto inline$BDLGetDebugLevel$645$label_1#1;

  inline$BDLGetDebugLevel$645$label_1#1:
    goto inline$BDLGetDebugLevel$645$Return#1;

  inline$BDLGetDebugLevel$645$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$645$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon42_Then#1, inline$BDLSystemPowerIoCompletion$25$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon13#1;

  inline$BDLSystemPowerIoCompletion$25$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_66#1;

  inline$BDLSystemPowerIoCompletion$25$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_66_true#1, inline$BDLSystemPowerIoCompletion$25$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_67#1;

  inline$BDLSystemPowerIoCompletion$25$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_70#1;

  inline$BDLSystemPowerIoCompletion$25$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_67#1;

  inline$BDLSystemPowerIoCompletion$25$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$25$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$25$anon43_Then#1, inline$BDLSystemPowerIoCompletion$25$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon15#1;

  inline$BDLSystemPowerIoCompletion$25$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_71#1;

  inline$BDLSystemPowerIoCompletion$25$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$25$anon44_Then#1, inline$BDLSystemPowerIoCompletion$25$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon17#1;

  inline$BDLSystemPowerIoCompletion$25$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_74#1;

  inline$BDLSystemPowerIoCompletion$25$label_74#1:
    goto inline$storm_IoCompleteRequest$52$Entry#1;

  inline$storm_IoCompleteRequest$52$Entry#1:
    inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$25$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$52$start#1;

  inline$storm_IoCompleteRequest$52$start#1:
    inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$52$label_3#1;

  inline$storm_IoCompleteRequest$52$label_3#1:
    call inline$storm_IoCompleteRequest$52$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$52$label_6#1;

  inline$storm_IoCompleteRequest$52$label_6#1:
    goto inline$storm_IoCompleteRequest$52$label_6_true#1, inline$storm_IoCompleteRequest$52$label_6_false#1;

  inline$storm_IoCompleteRequest$52$label_6_false#1:
    assume inline$storm_IoCompleteRequest$52$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$52$label_7#1;

  inline$storm_IoCompleteRequest$52$label_6_true#1:
    assume inline$storm_IoCompleteRequest$52$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$52$label_8#1;

  inline$storm_IoCompleteRequest$52$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$52$anon3_Then#1, inline$storm_IoCompleteRequest$52$anon3_Else#1;

  inline$storm_IoCompleteRequest$52$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$52$anon1#1;

  inline$storm_IoCompleteRequest$52$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$52$label_9#1;

  inline$storm_IoCompleteRequest$52$label_9#1:
    goto inline$storm_IoCompleteRequest$52$label_9_true#1, inline$storm_IoCompleteRequest$52$label_9_false#1;

  inline$storm_IoCompleteRequest$52$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$52$label_10#1;

  inline$storm_IoCompleteRequest$52$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$52$label_1#1;

  inline$storm_IoCompleteRequest$52$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$52$label_7#1;

  inline$storm_IoCompleteRequest$52$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$52$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$52$label_1#1;

  inline$storm_IoCompleteRequest$52$label_1#1:
    goto inline$storm_IoCompleteRequest$52$Return#1;

  inline$storm_IoCompleteRequest$52$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$52$Return#1;

  inline$storm_IoCompleteRequest$52$Return#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon45_Then#1, inline$BDLSystemPowerIoCompletion$25$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon19#1;

  inline$BDLSystemPowerIoCompletion$25$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_77#1;

  inline$BDLSystemPowerIoCompletion$25$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$25$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$25$anon46_Then#1, inline$BDLSystemPowerIoCompletion$25$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon21#1;

  inline$BDLSystemPowerIoCompletion$25$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_80#1;

  inline$BDLSystemPowerIoCompletion$25$label_80#1:
    goto inline$BDLGetDebugLevel$646$Entry#1;

  inline$BDLGetDebugLevel$646$Entry#1:
    goto inline$BDLGetDebugLevel$646$start#1;

  inline$BDLGetDebugLevel$646$start#1:
    goto inline$BDLGetDebugLevel$646$label_3#1;

  inline$BDLGetDebugLevel$646$label_3#1:
    havoc inline$BDLGetDebugLevel$646$myNondetVar_0;
    inline$BDLGetDebugLevel$646$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$646$myNondetVar_0;
    goto inline$BDLGetDebugLevel$646$label_1#1;

  inline$BDLGetDebugLevel$646$label_1#1:
    goto inline$BDLGetDebugLevel$646$Return#1;

  inline$BDLGetDebugLevel$646$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$646$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon47_Then#1, inline$BDLSystemPowerIoCompletion$25$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon23#1;

  inline$BDLSystemPowerIoCompletion$25$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_83#1;

  inline$BDLSystemPowerIoCompletion$25$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_83_true#1, inline$BDLSystemPowerIoCompletion$25$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_84#1;

  inline$BDLSystemPowerIoCompletion$25$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_87#1;

  inline$BDLSystemPowerIoCompletion$25$label_87#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_88#1;

  inline$BDLSystemPowerIoCompletion$25$label_88#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_89#1;

  inline$BDLSystemPowerIoCompletion$25$label_89#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_90#1;

  inline$BDLSystemPowerIoCompletion$25$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$25$label_84#1;

  inline$BDLSystemPowerIoCompletion$25$label_84#1:
    goto inline$BDLGetDebugLevel$647$Entry#1;

  inline$BDLGetDebugLevel$647$Entry#1:
    goto inline$BDLGetDebugLevel$647$start#1;

  inline$BDLGetDebugLevel$647$start#1:
    goto inline$BDLGetDebugLevel$647$label_3#1;

  inline$BDLGetDebugLevel$647$label_3#1:
    havoc inline$BDLGetDebugLevel$647$myNondetVar_0;
    inline$BDLGetDebugLevel$647$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$647$myNondetVar_0;
    goto inline$BDLGetDebugLevel$647$label_1#1;

  inline$BDLGetDebugLevel$647$label_1#1:
    goto inline$BDLGetDebugLevel$647$Return#1;

  inline$BDLGetDebugLevel$647$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$647$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon48_Then#1, inline$BDLSystemPowerIoCompletion$25$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon25#1;

  inline$BDLSystemPowerIoCompletion$25$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_93#1;

  inline$BDLSystemPowerIoCompletion$25$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_93_true#1, inline$BDLSystemPowerIoCompletion$25$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_94#1;

  inline$BDLSystemPowerIoCompletion$25$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_97#1;

  inline$BDLSystemPowerIoCompletion$25$label_97#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_98#1;

  inline$BDLSystemPowerIoCompletion$25$label_98#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_99#1;

  inline$BDLSystemPowerIoCompletion$25$label_99#1:
    call inline$BDLSystemPowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$25$label_100#1;

  inline$BDLSystemPowerIoCompletion$25$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$25$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$25$label_94#1;

  inline$BDLSystemPowerIoCompletion$25$label_94#1:
    goto inline$BDLGetDebugLevel$648$Entry#1;

  inline$BDLGetDebugLevel$648$Entry#1:
    goto inline$BDLGetDebugLevel$648$start#1;

  inline$BDLGetDebugLevel$648$start#1:
    goto inline$BDLGetDebugLevel$648$label_3#1;

  inline$BDLGetDebugLevel$648$label_3#1:
    havoc inline$BDLGetDebugLevel$648$myNondetVar_0;
    inline$BDLGetDebugLevel$648$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$648$myNondetVar_0;
    goto inline$BDLGetDebugLevel$648$label_1#1;

  inline$BDLGetDebugLevel$648$label_1#1:
    goto inline$BDLGetDebugLevel$648$Return#1;

  inline$BDLGetDebugLevel$648$Return#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$648$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$25$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$25$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$25$anon49_Then#1, inline$BDLSystemPowerIoCompletion$25$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$25$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$anon27#1;

  inline$BDLSystemPowerIoCompletion$25$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_103#1;

  inline$BDLSystemPowerIoCompletion$25$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_103_true#1, inline$BDLSystemPowerIoCompletion$25$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$25$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_104#1;

  inline$BDLSystemPowerIoCompletion$25$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$25$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$25$label_105#1;

  inline$BDLSystemPowerIoCompletion$25$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$25$label_104#1;

  inline$BDLSystemPowerIoCompletion$25$label_104#1:
    inline$BDLSystemPowerIoCompletion$25$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$25$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$25$label_1#1;

  inline$BDLSystemPowerIoCompletion$25$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$25$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$25$Return#1;

  inline$BDLSystemPowerIoCompletion$25$Return#1:
    inline$CallCompletionRoutine$25$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$25$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$25$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$25$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$25$anon14_Then#1, inline$CallCompletionRoutine$25$anon14_Else#1;

  inline$CallCompletionRoutine$25$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$25$anon9#1;

  inline$CallCompletionRoutine$25$anon9#1:
    goto inline$CallCompletionRoutine$25$label_20_icall_return#1;

  inline$CallCompletionRoutine$25$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$25$Return#1;

  inline$CallCompletionRoutine$25$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$25$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$25$Entry#1;

  inline$BDLDevicePowerIoCompletion$25$Entry#1:
    inline$BDLDevicePowerIoCompletion$25$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$25$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$25$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$25$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$25$start#1;

  inline$BDLDevicePowerIoCompletion$25$start#1:
    call inline$BDLDevicePowerIoCompletion$25$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$25$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$25$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$25$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$25$label_3#1;

  inline$BDLDevicePowerIoCompletion$25$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_4#1;

  inline$BDLDevicePowerIoCompletion$25$label_4#1:
    inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_5#1;

  inline$BDLDevicePowerIoCompletion$25$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_6#1;

  inline$BDLDevicePowerIoCompletion$25$label_6#1:
    inline$BDLDevicePowerIoCompletion$25$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$25$label_7#1;

  inline$BDLDevicePowerIoCompletion$25$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_8#1;

  inline$BDLDevicePowerIoCompletion$25$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$25$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$25$label_9#1;

  inline$BDLDevicePowerIoCompletion$25$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_10#1;

  inline$BDLDevicePowerIoCompletion$25$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$130$Entry#1;

  inline$IoGetCurrentIrpStackLocation$130$Entry#1:
    inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$130$start#1;

  inline$IoGetCurrentIrpStackLocation$130$start#1:
    inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$130$label_3#1;

  inline$IoGetCurrentIrpStackLocation$130$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$130$label_3_true#1, inline$IoGetCurrentIrpStackLocation$130$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$130$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$130$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$130$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$130$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$130$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$130$label_4#1;

  inline$IoGetCurrentIrpStackLocation$130$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$130$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$130$label_6#1;

  inline$IoGetCurrentIrpStackLocation$130$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$130$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$130$label_7#1;

  inline$IoGetCurrentIrpStackLocation$130$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$130$label_5#1;

  inline$IoGetCurrentIrpStackLocation$130$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$130$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$130$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$130$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$130$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$130$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$130$label_5#1;

  inline$IoGetCurrentIrpStackLocation$130$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$130$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$130$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$130$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$130$label_1#1;

  inline$IoGetCurrentIrpStackLocation$130$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$130$Return#1;

  inline$IoGetCurrentIrpStackLocation$130$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$130$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon30_Then#1, inline$BDLDevicePowerIoCompletion$25$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon1#1;

  inline$BDLDevicePowerIoCompletion$25$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_13#1;

  inline$BDLDevicePowerIoCompletion$25$label_13#1:
    inline$BDLDevicePowerIoCompletion$25$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$25$label_14#1;

  inline$BDLDevicePowerIoCompletion$25$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_15#1;

  inline$BDLDevicePowerIoCompletion$25$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$25$label_16#1;

  inline$BDLDevicePowerIoCompletion$25$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_17#1;

  inline$BDLDevicePowerIoCompletion$25$label_17#1:
    goto inline$BDLGetDebugLevel$631$Entry#1;

  inline$BDLGetDebugLevel$631$Entry#1:
    goto inline$BDLGetDebugLevel$631$start#1;

  inline$BDLGetDebugLevel$631$start#1:
    goto inline$BDLGetDebugLevel$631$label_3#1;

  inline$BDLGetDebugLevel$631$label_3#1:
    havoc inline$BDLGetDebugLevel$631$myNondetVar_0;
    inline$BDLGetDebugLevel$631$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$631$myNondetVar_0;
    goto inline$BDLGetDebugLevel$631$label_1#1;

  inline$BDLGetDebugLevel$631$label_1#1:
    goto inline$BDLGetDebugLevel$631$Return#1;

  inline$BDLGetDebugLevel$631$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$631$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon31_Then#1, inline$BDLDevicePowerIoCompletion$25$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon3#1;

  inline$BDLDevicePowerIoCompletion$25$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_20#1;

  inline$BDLDevicePowerIoCompletion$25$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_20_true#1, inline$BDLDevicePowerIoCompletion$25$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_21#1;

  inline$BDLDevicePowerIoCompletion$25$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_24#1;

  inline$BDLDevicePowerIoCompletion$25$label_24#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_25#1;

  inline$BDLDevicePowerIoCompletion$25$label_25#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_26#1;

  inline$BDLDevicePowerIoCompletion$25$label_26#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_27#1;

  inline$BDLDevicePowerIoCompletion$25$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$25$label_21#1;

  inline$BDLDevicePowerIoCompletion$25$label_21#1:
    goto inline$BDLGetDebugLevel$632$Entry#1;

  inline$BDLGetDebugLevel$632$Entry#1:
    goto inline$BDLGetDebugLevel$632$start#1;

  inline$BDLGetDebugLevel$632$start#1:
    goto inline$BDLGetDebugLevel$632$label_3#1;

  inline$BDLGetDebugLevel$632$label_3#1:
    havoc inline$BDLGetDebugLevel$632$myNondetVar_0;
    inline$BDLGetDebugLevel$632$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$632$myNondetVar_0;
    goto inline$BDLGetDebugLevel$632$label_1#1;

  inline$BDLGetDebugLevel$632$label_1#1:
    goto inline$BDLGetDebugLevel$632$Return#1;

  inline$BDLGetDebugLevel$632$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$632$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon32_Then#1, inline$BDLDevicePowerIoCompletion$25$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon5#1;

  inline$BDLDevicePowerIoCompletion$25$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_30#1;

  inline$BDLDevicePowerIoCompletion$25$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_30_true#1, inline$BDLDevicePowerIoCompletion$25$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_31#1;

  inline$BDLDevicePowerIoCompletion$25$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_34#1;

  inline$BDLDevicePowerIoCompletion$25$label_34#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_35#1;

  inline$BDLDevicePowerIoCompletion$25$label_35#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_36#1;

  inline$BDLDevicePowerIoCompletion$25$label_36#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_37#1;

  inline$BDLDevicePowerIoCompletion$25$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$25$label_31#1;

  inline$BDLDevicePowerIoCompletion$25$label_31#1:
    goto inline$BDLGetDebugLevel$633$Entry#1;

  inline$BDLGetDebugLevel$633$Entry#1:
    goto inline$BDLGetDebugLevel$633$start#1;

  inline$BDLGetDebugLevel$633$start#1:
    goto inline$BDLGetDebugLevel$633$label_3#1;

  inline$BDLGetDebugLevel$633$label_3#1:
    havoc inline$BDLGetDebugLevel$633$myNondetVar_0;
    inline$BDLGetDebugLevel$633$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$633$myNondetVar_0;
    goto inline$BDLGetDebugLevel$633$label_1#1;

  inline$BDLGetDebugLevel$633$label_1#1:
    goto inline$BDLGetDebugLevel$633$Return#1;

  inline$BDLGetDebugLevel$633$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$633$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon33_Then#1, inline$BDLDevicePowerIoCompletion$25$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon7#1;

  inline$BDLDevicePowerIoCompletion$25$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_40#1;

  inline$BDLDevicePowerIoCompletion$25$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_40_true#1, inline$BDLDevicePowerIoCompletion$25$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_41#1;

  inline$BDLDevicePowerIoCompletion$25$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_42#1;

  inline$BDLDevicePowerIoCompletion$25$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_41#1;

  inline$BDLDevicePowerIoCompletion$25$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_41_true#1, inline$BDLDevicePowerIoCompletion$25$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$25$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$25$label_43#1;

  inline$BDLDevicePowerIoCompletion$25$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$25$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$25$label_44#1;

  inline$BDLDevicePowerIoCompletion$25$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_44_true#1, inline$BDLDevicePowerIoCompletion$25$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$25$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$25$label_45#1;

  inline$BDLDevicePowerIoCompletion$25$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_45_true#1, inline$BDLDevicePowerIoCompletion$25$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$25$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$25$label_43#1;

  inline$BDLDevicePowerIoCompletion$25$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$25$label_86#1;

  inline$BDLDevicePowerIoCompletion$25$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$25$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$25$label_46#1;

  inline$BDLDevicePowerIoCompletion$25$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$25$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$25$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$25$label_46#1;

  inline$BDLDevicePowerIoCompletion$25$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$25$label_49#1;

  inline$BDLDevicePowerIoCompletion$25$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_50#1;

  inline$BDLDevicePowerIoCompletion$25$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_51#1;

  inline$BDLDevicePowerIoCompletion$25$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_54#1;

  inline$BDLDevicePowerIoCompletion$25$label_54#1:
    inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$25$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$25$label_55#1;

  inline$BDLDevicePowerIoCompletion$25$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_55_true#1, inline$BDLDevicePowerIoCompletion$25$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_56#1;

  inline$BDLDevicePowerIoCompletion$25$label_56#1:
    call inline$BDLDevicePowerIoCompletion$25$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$25$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$25$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$25$anon34_Then#1, inline$BDLDevicePowerIoCompletion$25$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon9#1;

  inline$BDLDevicePowerIoCompletion$25$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_83#1;

  inline$BDLDevicePowerIoCompletion$25$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_59#1;

  inline$BDLDevicePowerIoCompletion$25$label_59#1:
    goto inline$BDLGetDebugLevel$634$Entry#1;

  inline$BDLGetDebugLevel$634$Entry#1:
    goto inline$BDLGetDebugLevel$634$start#1;

  inline$BDLGetDebugLevel$634$start#1:
    goto inline$BDLGetDebugLevel$634$label_3#1;

  inline$BDLGetDebugLevel$634$label_3#1:
    havoc inline$BDLGetDebugLevel$634$myNondetVar_0;
    inline$BDLGetDebugLevel$634$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$634$myNondetVar_0;
    goto inline$BDLGetDebugLevel$634$label_1#1;

  inline$BDLGetDebugLevel$634$label_1#1:
    goto inline$BDLGetDebugLevel$634$Return#1;

  inline$BDLGetDebugLevel$634$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$634$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon35_Then#1, inline$BDLDevicePowerIoCompletion$25$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon11#1;

  inline$BDLDevicePowerIoCompletion$25$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_62#1;

  inline$BDLDevicePowerIoCompletion$25$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_62_true#1, inline$BDLDevicePowerIoCompletion$25$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_63#1;

  inline$BDLDevicePowerIoCompletion$25$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_66#1;

  inline$BDLDevicePowerIoCompletion$25$label_66#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_67#1;

  inline$BDLDevicePowerIoCompletion$25$label_67#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_68#1;

  inline$BDLDevicePowerIoCompletion$25$label_68#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_69#1;

  inline$BDLDevicePowerIoCompletion$25$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$25$label_63#1;

  inline$BDLDevicePowerIoCompletion$25$label_63#1:
    goto inline$BDLGetDebugLevel$635$Entry#1;

  inline$BDLGetDebugLevel$635$Entry#1:
    goto inline$BDLGetDebugLevel$635$start#1;

  inline$BDLGetDebugLevel$635$start#1:
    goto inline$BDLGetDebugLevel$635$label_3#1;

  inline$BDLGetDebugLevel$635$label_3#1:
    havoc inline$BDLGetDebugLevel$635$myNondetVar_0;
    inline$BDLGetDebugLevel$635$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$635$myNondetVar_0;
    goto inline$BDLGetDebugLevel$635$label_1#1;

  inline$BDLGetDebugLevel$635$label_1#1:
    goto inline$BDLGetDebugLevel$635$Return#1;

  inline$BDLGetDebugLevel$635$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$635$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon36_Then#1, inline$BDLDevicePowerIoCompletion$25$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon13#1;

  inline$BDLDevicePowerIoCompletion$25$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_72#1;

  inline$BDLDevicePowerIoCompletion$25$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_72_true#1, inline$BDLDevicePowerIoCompletion$25$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_73#1;

  inline$BDLDevicePowerIoCompletion$25$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_76#1;

  inline$BDLDevicePowerIoCompletion$25$label_76#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_77#1;

  inline$BDLDevicePowerIoCompletion$25$label_77#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_78#1;

  inline$BDLDevicePowerIoCompletion$25$label_78#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_79#1;

  inline$BDLDevicePowerIoCompletion$25$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$25$label_73#1;

  inline$BDLDevicePowerIoCompletion$25$label_73#1:
    goto inline$BDLGetDebugLevel$636$Entry#1;

  inline$BDLGetDebugLevel$636$Entry#1:
    goto inline$BDLGetDebugLevel$636$start#1;

  inline$BDLGetDebugLevel$636$start#1:
    goto inline$BDLGetDebugLevel$636$label_3#1;

  inline$BDLGetDebugLevel$636$label_3#1:
    havoc inline$BDLGetDebugLevel$636$myNondetVar_0;
    inline$BDLGetDebugLevel$636$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$636$myNondetVar_0;
    goto inline$BDLGetDebugLevel$636$label_1#1;

  inline$BDLGetDebugLevel$636$label_1#1:
    goto inline$BDLGetDebugLevel$636$Return#1;

  inline$BDLGetDebugLevel$636$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$636$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon37_Then#1, inline$BDLDevicePowerIoCompletion$25$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon15#1;

  inline$BDLDevicePowerIoCompletion$25$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_82#1;

  inline$BDLDevicePowerIoCompletion$25$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_82_true#1, inline$BDLDevicePowerIoCompletion$25$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_83#1;

  inline$BDLDevicePowerIoCompletion$25$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_84#1;

  inline$BDLDevicePowerIoCompletion$25$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_83#1;

  inline$BDLDevicePowerIoCompletion$25$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_85#1;

  inline$BDLDevicePowerIoCompletion$25$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_86#1;

  inline$BDLDevicePowerIoCompletion$25$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$25$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$25$anon38_Then#1, inline$BDLDevicePowerIoCompletion$25$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon17#1;

  inline$BDLDevicePowerIoCompletion$25$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_89#1;

  inline$BDLDevicePowerIoCompletion$25$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$25$anon39_Then#1, inline$BDLDevicePowerIoCompletion$25$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon19#1;

  inline$BDLDevicePowerIoCompletion$25$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_92#1;

  inline$BDLDevicePowerIoCompletion$25$label_92#1:
    goto inline$storm_IoCompleteRequest$51$Entry#1;

  inline$storm_IoCompleteRequest$51$Entry#1:
    inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$25$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$51$start#1;

  inline$storm_IoCompleteRequest$51$start#1:
    inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$51$label_3#1;

  inline$storm_IoCompleteRequest$51$label_3#1:
    call inline$storm_IoCompleteRequest$51$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$51$label_6#1;

  inline$storm_IoCompleteRequest$51$label_6#1:
    goto inline$storm_IoCompleteRequest$51$label_6_true#1, inline$storm_IoCompleteRequest$51$label_6_false#1;

  inline$storm_IoCompleteRequest$51$label_6_false#1:
    assume inline$storm_IoCompleteRequest$51$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$51$label_7#1;

  inline$storm_IoCompleteRequest$51$label_6_true#1:
    assume inline$storm_IoCompleteRequest$51$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$51$label_8#1;

  inline$storm_IoCompleteRequest$51$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$51$anon3_Then#1, inline$storm_IoCompleteRequest$51$anon3_Else#1;

  inline$storm_IoCompleteRequest$51$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$51$anon1#1;

  inline$storm_IoCompleteRequest$51$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$51$label_9#1;

  inline$storm_IoCompleteRequest$51$label_9#1:
    goto inline$storm_IoCompleteRequest$51$label_9_true#1, inline$storm_IoCompleteRequest$51$label_9_false#1;

  inline$storm_IoCompleteRequest$51$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$51$label_10#1;

  inline$storm_IoCompleteRequest$51$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$51$label_1#1;

  inline$storm_IoCompleteRequest$51$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$51$label_7#1;

  inline$storm_IoCompleteRequest$51$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$51$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$51$label_1#1;

  inline$storm_IoCompleteRequest$51$label_1#1:
    goto inline$storm_IoCompleteRequest$51$Return#1;

  inline$storm_IoCompleteRequest$51$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$51$Return#1;

  inline$storm_IoCompleteRequest$51$Return#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon40_Then#1, inline$BDLDevicePowerIoCompletion$25$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon21#1;

  inline$BDLDevicePowerIoCompletion$25$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_95#1;

  inline$BDLDevicePowerIoCompletion$25$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$25$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$25$anon41_Then#1, inline$BDLDevicePowerIoCompletion$25$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon23#1;

  inline$BDLDevicePowerIoCompletion$25$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_98#1;

  inline$BDLDevicePowerIoCompletion$25$label_98#1:
    goto inline$BDLGetDebugLevel$637$Entry#1;

  inline$BDLGetDebugLevel$637$Entry#1:
    goto inline$BDLGetDebugLevel$637$start#1;

  inline$BDLGetDebugLevel$637$start#1:
    goto inline$BDLGetDebugLevel$637$label_3#1;

  inline$BDLGetDebugLevel$637$label_3#1:
    havoc inline$BDLGetDebugLevel$637$myNondetVar_0;
    inline$BDLGetDebugLevel$637$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$637$myNondetVar_0;
    goto inline$BDLGetDebugLevel$637$label_1#1;

  inline$BDLGetDebugLevel$637$label_1#1:
    goto inline$BDLGetDebugLevel$637$Return#1;

  inline$BDLGetDebugLevel$637$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$637$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon42_Then#1, inline$BDLDevicePowerIoCompletion$25$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon25#1;

  inline$BDLDevicePowerIoCompletion$25$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_101#1;

  inline$BDLDevicePowerIoCompletion$25$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_101_true#1, inline$BDLDevicePowerIoCompletion$25$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_102#1;

  inline$BDLDevicePowerIoCompletion$25$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_105#1;

  inline$BDLDevicePowerIoCompletion$25$label_105#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_106#1;

  inline$BDLDevicePowerIoCompletion$25$label_106#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_107#1;

  inline$BDLDevicePowerIoCompletion$25$label_107#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_108#1;

  inline$BDLDevicePowerIoCompletion$25$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$25$label_102#1;

  inline$BDLDevicePowerIoCompletion$25$label_102#1:
    goto inline$BDLGetDebugLevel$638$Entry#1;

  inline$BDLGetDebugLevel$638$Entry#1:
    goto inline$BDLGetDebugLevel$638$start#1;

  inline$BDLGetDebugLevel$638$start#1:
    goto inline$BDLGetDebugLevel$638$label_3#1;

  inline$BDLGetDebugLevel$638$label_3#1:
    havoc inline$BDLGetDebugLevel$638$myNondetVar_0;
    inline$BDLGetDebugLevel$638$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$638$myNondetVar_0;
    goto inline$BDLGetDebugLevel$638$label_1#1;

  inline$BDLGetDebugLevel$638$label_1#1:
    goto inline$BDLGetDebugLevel$638$Return#1;

  inline$BDLGetDebugLevel$638$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$638$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon43_Then#1, inline$BDLDevicePowerIoCompletion$25$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon27#1;

  inline$BDLDevicePowerIoCompletion$25$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_111#1;

  inline$BDLDevicePowerIoCompletion$25$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_111_true#1, inline$BDLDevicePowerIoCompletion$25$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_112#1;

  inline$BDLDevicePowerIoCompletion$25$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_115#1;

  inline$BDLDevicePowerIoCompletion$25$label_115#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_116#1;

  inline$BDLDevicePowerIoCompletion$25$label_116#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_117#1;

  inline$BDLDevicePowerIoCompletion$25$label_117#1:
    call inline$BDLDevicePowerIoCompletion$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$25$label_118#1;

  inline$BDLDevicePowerIoCompletion$25$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$25$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$25$label_112#1;

  inline$BDLDevicePowerIoCompletion$25$label_112#1:
    goto inline$BDLGetDebugLevel$639$Entry#1;

  inline$BDLGetDebugLevel$639$Entry#1:
    goto inline$BDLGetDebugLevel$639$start#1;

  inline$BDLGetDebugLevel$639$start#1:
    goto inline$BDLGetDebugLevel$639$label_3#1;

  inline$BDLGetDebugLevel$639$label_3#1:
    havoc inline$BDLGetDebugLevel$639$myNondetVar_0;
    inline$BDLGetDebugLevel$639$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$639$myNondetVar_0;
    goto inline$BDLGetDebugLevel$639$label_1#1;

  inline$BDLGetDebugLevel$639$label_1#1:
    goto inline$BDLGetDebugLevel$639$Return#1;

  inline$BDLGetDebugLevel$639$Return#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$639$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$25$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$25$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$25$anon44_Then#1, inline$BDLDevicePowerIoCompletion$25$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$25$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$anon29#1;

  inline$BDLDevicePowerIoCompletion$25$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_121#1;

  inline$BDLDevicePowerIoCompletion$25$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_121_true#1, inline$BDLDevicePowerIoCompletion$25$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$25$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_122#1;

  inline$BDLDevicePowerIoCompletion$25$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$25$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$25$label_123#1;

  inline$BDLDevicePowerIoCompletion$25$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$25$label_122#1;

  inline$BDLDevicePowerIoCompletion$25$label_122#1:
    inline$BDLDevicePowerIoCompletion$25$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$25$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$25$label_1#1;

  inline$BDLDevicePowerIoCompletion$25$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$25$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$25$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$25$Return#1;

  inline$BDLDevicePowerIoCompletion$25$Return#1:
    inline$CallCompletionRoutine$25$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$25$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$25$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$25$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$25$anon13_Then#1, inline$CallCompletionRoutine$25$anon13_Else#1;

  inline$CallCompletionRoutine$25$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$25$anon7#1;

  inline$CallCompletionRoutine$25$anon7#1:
    goto inline$CallCompletionRoutine$25$label_20_icall_return#1;

  inline$CallCompletionRoutine$25$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$25$Return#1;

  inline$CallCompletionRoutine$25$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$25$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$25$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$25$Entry#1;

  inline$BDLCallDriverCompletionRoutine$25$Entry#1:
    inline$BDLCallDriverCompletionRoutine$25$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$25$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$25$start#1;

  inline$BDLCallDriverCompletionRoutine$25$start#1:
    inline$BDLCallDriverCompletionRoutine$25$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$25$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$25$label_3#1;

  inline$BDLCallDriverCompletionRoutine$25$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$25$label_3_true#1, inline$BDLCallDriverCompletionRoutine$25$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$25$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$25$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$25$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$25$label_4#1;

  inline$BDLCallDriverCompletionRoutine$25$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$25$label_6#1;

  inline$BDLCallDriverCompletionRoutine$25$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$25$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$25$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$25$label_5#1;

  inline$BDLCallDriverCompletionRoutine$25$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$25$label_6#1;

  inline$BDLCallDriverCompletionRoutine$25$label_6#1:
    goto inline$storm_KeSetEvent$27$Entry#1;

  inline$storm_KeSetEvent$27$Entry#1:
    inline$storm_KeSetEvent$27$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$25$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$27$start#1;

  inline$storm_KeSetEvent$27$start#1:
    inline$storm_KeSetEvent$27$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$27$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$27$label_3#1;

  inline$storm_KeSetEvent$27$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$27$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$27$label_1#1;

  inline$storm_KeSetEvent$27$label_1#1:
    goto inline$storm_KeSetEvent$27$Return#1;

  inline$storm_KeSetEvent$27$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$25$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$25$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$25$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$25$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$25$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$25$anon1#1;

  inline$BDLCallDriverCompletionRoutine$25$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$25$label_9#1;

  inline$BDLCallDriverCompletionRoutine$25$label_9#1:
    inline$BDLCallDriverCompletionRoutine$25$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$25$label_1#1;

  inline$BDLCallDriverCompletionRoutine$25$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$25$Return#1;

  inline$BDLCallDriverCompletionRoutine$25$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$25$Return#1;

  inline$BDLCallDriverCompletionRoutine$25$Return#1:
    inline$CallCompletionRoutine$25$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$25$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$25$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$25$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$25$anon12_Then#1, inline$CallCompletionRoutine$25$anon12_Else#1;

  inline$CallCompletionRoutine$25$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$25$anon5#1;

  inline$CallCompletionRoutine$25$anon5#1:
    goto inline$CallCompletionRoutine$25$label_20_icall_return#1;

  inline$CallCompletionRoutine$25$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$25$label_23#1;

  inline$CallCompletionRoutine$25$label_23#1:
    inline$CallCompletionRoutine$25$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$25$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$25$label_24#1;

  inline$CallCompletionRoutine$25$label_24#1:
    goto inline$CallCompletionRoutine$25$label_24_true#1, inline$CallCompletionRoutine$25$label_24_false#1;

  inline$CallCompletionRoutine$25$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$25$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$25$label_1#1;

  inline$CallCompletionRoutine$25$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$25$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$25$label_25#1;

  inline$CallCompletionRoutine$25$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$25$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$25$label_1#1;

  inline$CallCompletionRoutine$25$label_1#1:
    goto inline$CallCompletionRoutine$25$Return#1;

  inline$CallCompletionRoutine$25$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$25$Return#1;

  inline$CallCompletionRoutine$25$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$25$Return#1;

  inline$CallCompletionRoutine$25$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$25$Return#1;

  inline$CallCompletionRoutine$25$Return#1:
    goto inline$storm_IoCallDriver$12$label_39$1#1;

  inline$storm_IoCallDriver$12$label_39$1#1:
    goto inline$storm_IoCallDriver$12$anon15_Then#1, inline$storm_IoCallDriver$12$anon15_Else#1;

  inline$storm_IoCallDriver$12$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$12$anon10#1;

  inline$storm_IoCallDriver$12$anon10#1:
    goto inline$storm_IoCallDriver$12$label_36#1;

  inline$storm_IoCallDriver$12$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$12$Return#1;

  inline$storm_IoCallDriver$12$label_27_case_0#1:
    assume inline$storm_IoCallDriver$12$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$12$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$12$label_28#1;

  inline$storm_IoCallDriver$12$label_28#1:
    inline$storm_IoCallDriver$12$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$12$label_42#1;

  inline$storm_IoCallDriver$12$label_42#1:
    goto inline$storm_IoCallDriver$12$label_43#1;

  inline$storm_IoCallDriver$12$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$12$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$12$label_36#1;

  inline$storm_IoCallDriver$12$label_36#1:
    inline$storm_IoCallDriver$12$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$12$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$12$label_1#1;

  inline$storm_IoCallDriver$12$label_1#1:
    goto inline$storm_IoCallDriver$12$Return#1;

  inline$storm_IoCallDriver$12$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$12$Return#1;

  inline$storm_IoCallDriver$12$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$12$Return#1;

  inline$storm_IoCallDriver$12$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$12$Return#1;

  inline$storm_IoCallDriver$12$Return#1:
    inline$storm_PoCallDriver$5$$result.storm_IoCallDriver$499.27$2$ := inline$storm_IoCallDriver$12$$result.storm_IoCallDriver$456.0$1$;
    goto inline$storm_PoCallDriver$5$label_3$1#1;

  inline$storm_PoCallDriver$5$label_3$1#1:
    goto inline$storm_PoCallDriver$5$anon2_Then#1, inline$storm_PoCallDriver$5$anon2_Else#1;

  inline$storm_PoCallDriver$5$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_PoCallDriver$5$anon1#1;

  inline$storm_PoCallDriver$5$anon1#1:
    goto inline$storm_PoCallDriver$5$label_6#1;

  inline$storm_PoCallDriver$5$label_6#1:
    inline$storm_PoCallDriver$5$$result.storm_PoCallDriver$494.0$1$ := inline$storm_PoCallDriver$5$$result.storm_IoCallDriver$499.27$2$;
    goto inline$storm_PoCallDriver$5$label_1#1;

  inline$storm_PoCallDriver$5$label_1#1:
    goto inline$storm_PoCallDriver$5$Return#1;

  inline$storm_PoCallDriver$5$anon2_Then#1:
    assume raiseException;
    goto inline$storm_PoCallDriver$5$Return#1;

  inline$storm_PoCallDriver$5$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_PoCallDriver$104.29$3$ := inline$storm_PoCallDriver$5$$result.storm_PoCallDriver$494.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_25$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_25$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon22_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon22_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon13#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon13#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_28#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_28#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_PoCallDriver$104.29$3$;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_29_true#1, inline$BDLCallLowerLevelDriverAndWait$5$label_29_false#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_29_false#1:
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_29_true#1:
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_31#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_31#1:
    goto inline$storm_KeWaitForSingleObject$5$Entry#1;

  inline$storm_KeWaitForSingleObject$5$Entry#1:
    inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1 := inline$BDLCallLowerLevelDriverAndWait$5$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1 := 0;
    goto inline$storm_KeWaitForSingleObject$5$start#1;

  inline$storm_KeWaitForSingleObject$5$start#1:
    inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1;
    inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1;
    goto inline$storm_KeWaitForSingleObject$5$label_3#1;

  inline$storm_KeWaitForSingleObject$5$label_3#1:
    goto inline$storm_KeWaitForSingleObject$5$label_3_true#1, inline$storm_KeWaitForSingleObject$5$label_3_false#1;

  inline$storm_KeWaitForSingleObject$5$label_3_false#1:
    assume inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 == 0;
    goto inline$storm_KeWaitForSingleObject$5$label_4#1;

  inline$storm_KeWaitForSingleObject$5$label_4#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$5$anon6_Then#1, inline$storm_KeWaitForSingleObject$5$anon6_Else#1;

  inline$storm_KeWaitForSingleObject$5$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$5$anon1#1;

  inline$storm_KeWaitForSingleObject$5$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$5$label_13#1;

  inline$storm_KeWaitForSingleObject$5$label_13#1:
    inline$storm_KeWaitForSingleObject$5$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$5$label_1#1;

  inline$storm_KeWaitForSingleObject$5$anon6_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$5$Return#1;

  inline$storm_KeWaitForSingleObject$5$label_3_true#1:
    assume inline$storm_KeWaitForSingleObject$5$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 != 0;
    goto inline$storm_KeWaitForSingleObject$5$label_5#1;

  inline$storm_KeWaitForSingleObject$5$label_5#1:
    call inline$storm_KeWaitForSingleObject$5$$result.storm_nondet$256.20$2$ := storm_nondet();
    goto inline$storm_KeWaitForSingleObject$5$label_8#1;

  inline$storm_KeWaitForSingleObject$5$label_8#1:
    goto inline$storm_KeWaitForSingleObject$5$label_8_true#1, inline$storm_KeWaitForSingleObject$5$label_8_false#1;

  inline$storm_KeWaitForSingleObject$5$label_8_false#1:
    assume inline$storm_KeWaitForSingleObject$5$$result.storm_nondet$256.20$2$ == 0;
    goto inline$storm_KeWaitForSingleObject$5$label_9#1;

  inline$storm_KeWaitForSingleObject$5$label_9#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$5$anon7_Then#1, inline$storm_KeWaitForSingleObject$5$anon7_Else#1;

  inline$storm_KeWaitForSingleObject$5$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$5$anon3#1;

  inline$storm_KeWaitForSingleObject$5$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20], 0);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$5$label_12#1;

  inline$storm_KeWaitForSingleObject$5$label_12#1:
    inline$storm_KeWaitForSingleObject$5$$result.storm_KeWaitForSingleObject$243.0$1$ := 258;
    goto inline$storm_KeWaitForSingleObject$5$label_1#1;

  inline$storm_KeWaitForSingleObject$5$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$5$Return#1;

  inline$storm_KeWaitForSingleObject$5$label_8_true#1:
    assume inline$storm_KeWaitForSingleObject$5$$result.storm_nondet$256.20$2$ != 0;
    goto inline$storm_KeWaitForSingleObject$5$label_10#1;

  inline$storm_KeWaitForSingleObject$5$label_10#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$5$anon8_Then#1, inline$storm_KeWaitForSingleObject$5$anon8_Else#1;

  inline$storm_KeWaitForSingleObject$5$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$5$anon5#1;

  inline$storm_KeWaitForSingleObject$5$anon5#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$5$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$5$label_11#1;

  inline$storm_KeWaitForSingleObject$5$label_11#1:
    inline$storm_KeWaitForSingleObject$5$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$5$label_1#1;

  inline$storm_KeWaitForSingleObject$5$label_1#1:
    goto inline$storm_KeWaitForSingleObject$5$Return#1;

  inline$storm_KeWaitForSingleObject$5$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$5$Return#1;

  inline$storm_KeWaitForSingleObject$5$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_KeWaitForSingleObject$116.38$5$ := inline$storm_KeWaitForSingleObject$5$$result.storm_KeWaitForSingleObject$243.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_31$1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_31$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon23_Then#1, inline$BDLCallLowerLevelDriverAndWait$5$anon23_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$anon15#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon15#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_34#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_34#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$5$$result.storm_KeWaitForSingleObject$116.38$5$;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_35#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_35#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_35_true#1, inline$BDLCallLowerLevelDriverAndWait$5$label_35_false#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_35_false#1:
    assume inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 == 0;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_35_true#1:
    assume inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 != 0;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_37#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_37#1:
    call inline$BDLCallLowerLevelDriverAndWait$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_38#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_38#1:
    call inline$BDLCallLowerLevelDriverAndWait$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_39#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_39#1:
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_36#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0;
    inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$5$myNondetVar_0;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_30#1:
    inline$BDLCallLowerLevelDriverAndWait$5$$result.BDLCallLowerLevelDriverAndWait$71.0$1$ := inline$BDLCallLowerLevelDriverAndWait$5$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8;
    goto inline$BDLCallLowerLevelDriverAndWait$5$label_1#1;

  inline$BDLCallLowerLevelDriverAndWait$5$label_1#1:
    call __HAVOC_free(inline$BDLCallLowerLevelDriverAndWait$5$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon23_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon22_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon21_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$5$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$5$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLCallLowerLevelDriverAndWait$2148.43$13$ := inline$BDLCallLowerLevelDriverAndWait$5$$result.BDLCallLowerLevelDriverAndWait$71.0$1$;
    goto inline$BDLPnPCancelStop$0$label_29$1#1;

  inline$BDLPnPCancelStop$0$label_29$1#1:
    goto inline$BDLPnPCancelStop$0$anon25_Then#1, inline$BDLPnPCancelStop$0$anon25_Else#1;

  inline$BDLPnPCancelStop$0$anon25_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon7#1;

  inline$BDLPnPCancelStop$0$anon7#1:
    goto inline$BDLPnPCancelStop$0$label_33#1;

  inline$BDLPnPCancelStop$0$label_33#1:
    inline$BDLPnPCancelStop$0$$status$4$2137.16$BDLPnPCancelStop$12 := inline$BDLPnPCancelStop$0$$result.BDLCallLowerLevelDriverAndWait$2148.43$13$;
    goto inline$BDLPnPCancelStop$0$label_34#1;

  inline$BDLPnPCancelStop$0$label_34#1:
    goto inline$BDLPnPCancelStop$0$label_34_true#1, inline$BDLPnPCancelStop$0$label_34_false#1;

  inline$BDLPnPCancelStop$0$label_34_false#1:
    assume inline$BDLPnPCancelStop$0$$status$4$2137.16$BDLPnPCancelStop$12 == 0;
    goto inline$BDLPnPCancelStop$0$label_35#1;

  inline$BDLPnPCancelStop$0$label_35#1:
    goto inline$storm_KeSetEvent$28$Entry#1;

  inline$storm_KeSetEvent$28$Entry#1:
    inline$storm_KeSetEvent$28$$Event$1$213.14$storm_KeSetEvent$12_.1 := DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPCancelStop$0$$pBDLExtension$1$2132.40$BDLPnPCancelStop$12);
    goto inline$storm_KeSetEvent$28$start#1;

  inline$storm_KeSetEvent$28$start#1:
    inline$storm_KeSetEvent$28$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$28$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$28$label_3#1;

  inline$storm_KeSetEvent$28$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$28$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$28$label_1#1;

  inline$storm_KeSetEvent$28$label_1#1:
    goto inline$storm_KeSetEvent$28$Return#1;

  inline$storm_KeSetEvent$28$Return#1:
    goto inline$BDLPnPCancelStop$0$label_35$1#1;

  inline$BDLPnPCancelStop$0$label_35$1#1:
    goto inline$BDLPnPCancelStop$0$anon26_Then#1, inline$BDLPnPCancelStop$0$anon26_Else#1;

  inline$BDLPnPCancelStop$0$anon26_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon9#1;

  inline$BDLPnPCancelStop$0$anon9#1:
    goto inline$BDLPnPCancelStop$0$label_62#1;

  inline$BDLPnPCancelStop$0$anon26_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$label_34_true#1:
    assume inline$BDLPnPCancelStop$0$$status$4$2137.16$BDLPnPCancelStop$12 != 0;
    goto inline$BDLPnPCancelStop$0$label_38#1;

  inline$BDLPnPCancelStop$0$label_38#1:
    goto inline$BDLGetDebugLevel$652$Entry#1;

  inline$BDLGetDebugLevel$652$Entry#1:
    goto inline$BDLGetDebugLevel$652$start#1;

  inline$BDLGetDebugLevel$652$start#1:
    goto inline$BDLGetDebugLevel$652$label_3#1;

  inline$BDLGetDebugLevel$652$label_3#1:
    havoc inline$BDLGetDebugLevel$652$myNondetVar_0;
    inline$BDLGetDebugLevel$652$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$652$myNondetVar_0;
    goto inline$BDLGetDebugLevel$652$label_1#1;

  inline$BDLGetDebugLevel$652$label_1#1:
    goto inline$BDLGetDebugLevel$652$Return#1;

  inline$BDLGetDebugLevel$652$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$14$ := inline$BDLGetDebugLevel$652$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_38$1#1;

  inline$BDLPnPCancelStop$0$label_38$1#1:
    goto inline$BDLPnPCancelStop$0$anon27_Then#1, inline$BDLPnPCancelStop$0$anon27_Else#1;

  inline$BDLPnPCancelStop$0$anon27_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon11#1;

  inline$BDLPnPCancelStop$0$anon11#1:
    goto inline$BDLPnPCancelStop$0$label_41#1;

  inline$BDLPnPCancelStop$0$label_41#1:
    goto inline$BDLPnPCancelStop$0$label_41_true#1, inline$BDLPnPCancelStop$0$label_41_false#1;

  inline$BDLPnPCancelStop$0$label_41_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$14$) == 0;
    goto inline$BDLPnPCancelStop$0$label_42#1;

  inline$BDLPnPCancelStop$0$label_41_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$14$) != 0;
    goto inline$BDLPnPCancelStop$0$label_45#1;

  inline$BDLPnPCancelStop$0$label_45#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_46#1;

  inline$BDLPnPCancelStop$0$label_46#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_47#1;

  inline$BDLPnPCancelStop$0$label_47#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_48#1;

  inline$BDLPnPCancelStop$0$label_48#1:
    havoc inline$BDLPnPCancelStop$0$$result.DbgPrint$2152.0$15$;
    goto inline$BDLPnPCancelStop$0$label_42#1;

  inline$BDLPnPCancelStop$0$label_42#1:
    goto inline$BDLGetDebugLevel$653$Entry#1;

  inline$BDLGetDebugLevel$653$Entry#1:
    goto inline$BDLGetDebugLevel$653$start#1;

  inline$BDLGetDebugLevel$653$start#1:
    goto inline$BDLGetDebugLevel$653$label_3#1;

  inline$BDLGetDebugLevel$653$label_3#1:
    havoc inline$BDLGetDebugLevel$653$myNondetVar_0;
    inline$BDLGetDebugLevel$653$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$653$myNondetVar_0;
    goto inline$BDLGetDebugLevel$653$label_1#1;

  inline$BDLGetDebugLevel$653$label_1#1:
    goto inline$BDLGetDebugLevel$653$Return#1;

  inline$BDLGetDebugLevel$653$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$19$ := inline$BDLGetDebugLevel$653$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_42$1#1;

  inline$BDLPnPCancelStop$0$label_42$1#1:
    goto inline$BDLPnPCancelStop$0$anon28_Then#1, inline$BDLPnPCancelStop$0$anon28_Else#1;

  inline$BDLPnPCancelStop$0$anon28_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon13#1;

  inline$BDLPnPCancelStop$0$anon13#1:
    goto inline$BDLPnPCancelStop$0$label_51#1;

  inline$BDLPnPCancelStop$0$label_51#1:
    goto inline$BDLPnPCancelStop$0$label_51_true#1, inline$BDLPnPCancelStop$0$label_51_false#1;

  inline$BDLPnPCancelStop$0$label_51_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$19$) == 0;
    goto inline$BDLPnPCancelStop$0$label_52#1;

  inline$BDLPnPCancelStop$0$label_51_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$19$) != 0;
    goto inline$BDLPnPCancelStop$0$label_55#1;

  inline$BDLPnPCancelStop$0$label_55#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_56#1;

  inline$BDLPnPCancelStop$0$label_56#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_57#1;

  inline$BDLPnPCancelStop$0$label_57#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_58#1;

  inline$BDLPnPCancelStop$0$label_58#1:
    havoc inline$BDLPnPCancelStop$0$$result.DbgPrint$2152.0$20$;
    goto inline$BDLPnPCancelStop$0$label_52#1;

  inline$BDLPnPCancelStop$0$label_52#1:
    goto inline$BDLGetDebugLevel$654$Entry#1;

  inline$BDLGetDebugLevel$654$Entry#1:
    goto inline$BDLGetDebugLevel$654$start#1;

  inline$BDLGetDebugLevel$654$start#1:
    goto inline$BDLGetDebugLevel$654$label_3#1;

  inline$BDLGetDebugLevel$654$label_3#1:
    havoc inline$BDLGetDebugLevel$654$myNondetVar_0;
    inline$BDLGetDebugLevel$654$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$654$myNondetVar_0;
    goto inline$BDLGetDebugLevel$654$label_1#1;

  inline$BDLGetDebugLevel$654$label_1#1:
    goto inline$BDLGetDebugLevel$654$Return#1;

  inline$BDLGetDebugLevel$654$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$24$ := inline$BDLGetDebugLevel$654$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_52$1#1;

  inline$BDLPnPCancelStop$0$label_52$1#1:
    goto inline$BDLPnPCancelStop$0$anon29_Then#1, inline$BDLPnPCancelStop$0$anon29_Else#1;

  inline$BDLPnPCancelStop$0$anon29_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon15#1;

  inline$BDLPnPCancelStop$0$anon15#1:
    goto inline$BDLPnPCancelStop$0$label_61#1;

  inline$BDLPnPCancelStop$0$label_61#1:
    goto inline$BDLPnPCancelStop$0$label_61_true#1, inline$BDLPnPCancelStop$0$label_61_false#1;

  inline$BDLPnPCancelStop$0$label_61_false#1:
    assume BIT_BAND(inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$24$, 4) == 0;
    goto inline$BDLPnPCancelStop$0$label_62#1;

  inline$BDLPnPCancelStop$0$label_61_true#1:
    assume BIT_BAND(inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2152.0$24$, 4) != 0;
    goto inline$BDLPnPCancelStop$0$label_65#1;

  inline$BDLPnPCancelStop$0$label_65#1:
    goto inline$BDLPnPCancelStop$0$label_62#1;

  inline$BDLPnPCancelStop$0$label_62#1:
    goto inline$BDLGetDebugLevel$655$Entry#1;

  inline$BDLGetDebugLevel$655$Entry#1:
    goto inline$BDLGetDebugLevel$655$start#1;

  inline$BDLGetDebugLevel$655$start#1:
    goto inline$BDLGetDebugLevel$655$label_3#1;

  inline$BDLGetDebugLevel$655$label_3#1:
    havoc inline$BDLGetDebugLevel$655$myNondetVar_0;
    inline$BDLGetDebugLevel$655$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$655$myNondetVar_0;
    goto inline$BDLGetDebugLevel$655$label_1#1;

  inline$BDLGetDebugLevel$655$label_1#1:
    goto inline$BDLGetDebugLevel$655$Return#1;

  inline$BDLGetDebugLevel$655$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$26$ := inline$BDLGetDebugLevel$655$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_62$1#1;

  inline$BDLPnPCancelStop$0$label_62$1#1:
    goto inline$BDLPnPCancelStop$0$anon30_Then#1, inline$BDLPnPCancelStop$0$anon30_Else#1;

  inline$BDLPnPCancelStop$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon17#1;

  inline$BDLPnPCancelStop$0$anon17#1:
    goto inline$BDLPnPCancelStop$0$label_66#1;

  inline$BDLPnPCancelStop$0$label_66#1:
    goto inline$BDLPnPCancelStop$0$label_66_true#1, inline$BDLPnPCancelStop$0$label_66_false#1;

  inline$BDLPnPCancelStop$0$label_66_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$26$) == 0;
    goto inline$BDLPnPCancelStop$0$label_67#1;

  inline$BDLPnPCancelStop$0$label_66_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$26$) != 0;
    goto inline$BDLPnPCancelStop$0$label_70#1;

  inline$BDLPnPCancelStop$0$label_70#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_71#1;

  inline$BDLPnPCancelStop$0$label_71#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_72#1;

  inline$BDLPnPCancelStop$0$label_72#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_73#1;

  inline$BDLPnPCancelStop$0$label_73#1:
    havoc inline$BDLPnPCancelStop$0$$result.DbgPrint$2169.0$27$;
    goto inline$BDLPnPCancelStop$0$label_67#1;

  inline$BDLPnPCancelStop$0$label_67#1:
    goto inline$BDLGetDebugLevel$656$Entry#1;

  inline$BDLGetDebugLevel$656$Entry#1:
    goto inline$BDLGetDebugLevel$656$start#1;

  inline$BDLGetDebugLevel$656$start#1:
    goto inline$BDLGetDebugLevel$656$label_3#1;

  inline$BDLGetDebugLevel$656$label_3#1:
    havoc inline$BDLGetDebugLevel$656$myNondetVar_0;
    inline$BDLGetDebugLevel$656$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$656$myNondetVar_0;
    goto inline$BDLGetDebugLevel$656$label_1#1;

  inline$BDLGetDebugLevel$656$label_1#1:
    goto inline$BDLGetDebugLevel$656$Return#1;

  inline$BDLGetDebugLevel$656$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$31$ := inline$BDLGetDebugLevel$656$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_67$1#1;

  inline$BDLPnPCancelStop$0$label_67$1#1:
    goto inline$BDLPnPCancelStop$0$anon31_Then#1, inline$BDLPnPCancelStop$0$anon31_Else#1;

  inline$BDLPnPCancelStop$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon19#1;

  inline$BDLPnPCancelStop$0$anon19#1:
    goto inline$BDLPnPCancelStop$0$label_76#1;

  inline$BDLPnPCancelStop$0$label_76#1:
    goto inline$BDLPnPCancelStop$0$label_76_true#1, inline$BDLPnPCancelStop$0$label_76_false#1;

  inline$BDLPnPCancelStop$0$label_76_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$31$) == 0;
    goto inline$BDLPnPCancelStop$0$label_77#1;

  inline$BDLPnPCancelStop$0$label_76_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$31$) != 0;
    goto inline$BDLPnPCancelStop$0$label_80#1;

  inline$BDLPnPCancelStop$0$label_80#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_81#1;

  inline$BDLPnPCancelStop$0$label_81#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_82#1;

  inline$BDLPnPCancelStop$0$label_82#1:
    call inline$BDLPnPCancelStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelStop$0$label_83#1;

  inline$BDLPnPCancelStop$0$label_83#1:
    havoc inline$BDLPnPCancelStop$0$$result.DbgPrint$2169.0$32$;
    goto inline$BDLPnPCancelStop$0$label_77#1;

  inline$BDLPnPCancelStop$0$label_77#1:
    goto inline$BDLGetDebugLevel$657$Entry#1;

  inline$BDLGetDebugLevel$657$Entry#1:
    goto inline$BDLGetDebugLevel$657$start#1;

  inline$BDLGetDebugLevel$657$start#1:
    goto inline$BDLGetDebugLevel$657$label_3#1;

  inline$BDLGetDebugLevel$657$label_3#1:
    havoc inline$BDLGetDebugLevel$657$myNondetVar_0;
    inline$BDLGetDebugLevel$657$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$657$myNondetVar_0;
    goto inline$BDLGetDebugLevel$657$label_1#1;

  inline$BDLGetDebugLevel$657$label_1#1:
    goto inline$BDLGetDebugLevel$657$Return#1;

  inline$BDLGetDebugLevel$657$Return#1:
    inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$36$ := inline$BDLGetDebugLevel$657$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelStop$0$label_77$1#1;

  inline$BDLPnPCancelStop$0$label_77$1#1:
    goto inline$BDLPnPCancelStop$0$anon32_Then#1, inline$BDLPnPCancelStop$0$anon32_Else#1;

  inline$BDLPnPCancelStop$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelStop$0$anon21#1;

  inline$BDLPnPCancelStop$0$anon21#1:
    goto inline$BDLPnPCancelStop$0$label_86#1;

  inline$BDLPnPCancelStop$0$label_86#1:
    goto inline$BDLPnPCancelStop$0$label_86_true#1, inline$BDLPnPCancelStop$0$label_86_false#1;

  inline$BDLPnPCancelStop$0$label_86_false#1:
    assume BIT_BAND(inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$36$, 4) == 0;
    goto inline$BDLPnPCancelStop$0$label_87#1;

  inline$BDLPnPCancelStop$0$label_86_true#1:
    assume BIT_BAND(inline$BDLPnPCancelStop$0$$result.BDLGetDebugLevel$2169.0$36$, 4) != 0;
    goto inline$BDLPnPCancelStop$0$label_88#1;

  inline$BDLPnPCancelStop$0$label_88#1:
    goto inline$BDLPnPCancelStop$0$label_87#1;

  inline$BDLPnPCancelStop$0$label_87#1:
    inline$BDLPnPCancelStop$0$$result.BDLPnPCancelStop$2130.0$1$ := inline$BDLPnPCancelStop$0$$status$4$2137.16$BDLPnPCancelStop$12;
    goto inline$BDLPnPCancelStop$0$label_1#1;

  inline$BDLPnPCancelStop$0$label_1#1:
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon29_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon28_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon27_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon25_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon24_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon23_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$anon22_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelStop$0$Return#1;

  inline$BDLPnPCancelStop$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPCancelStop$925.33$30$ := inline$BDLPnPCancelStop$0$$result.BDLPnPCancelStop$2130.0$1$;
    goto inline$BDLPnP$0$label_131$1#1;

  inline$BDLPnP$0$label_131$1#1:
    goto inline$BDLPnP$0$anon73_Then#1, inline$BDLPnP$0$anon73_Else#1;

  inline$BDLPnP$0$anon73_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon39#1;

  inline$BDLPnP$0$anon39#1:
    goto inline$BDLPnP$0$label_148#1;

  inline$BDLPnP$0$label_148#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPCancelStop$925.33$30$;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon73_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_6#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 5;
    goto inline$BDLPnP$0$label_128#1;

  inline$BDLPnP$0$label_128#1:
    goto inline$BDLPnPQueryStop$0$Entry#1;

  inline$BDLPnPQueryStop$0$Entry#1:
    inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPQueryStop$0$$pIrp$3$2078.40$BDLPnPQueryStop$12_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPQueryStop$0$start#1;

  inline$BDLPnPQueryStop$0$start#1:
    call inline$BDLPnPQueryStop$0$$irql$5$2082.16$BDLPnPQueryStop$12 := __HAVOC_malloc(1);
    inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12 := inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12_.1;
    inline$BDLPnPQueryStop$0$$pIrp$3$2078.40$BDLPnPQueryStop$12 := inline$BDLPnPQueryStop$0$$pIrp$3$2078.40$BDLPnPQueryStop$12_.1;
    goto inline$BDLPnPQueryStop$0$label_3#1;

  inline$BDLPnPQueryStop$0$label_3#1:
    goto inline$BDLPnPQueryStop$0$label_4#1;

  inline$BDLPnPQueryStop$0$label_4#1:
    inline$BDLPnPQueryStop$0$$status$4$2081.16$BDLPnPQueryStop$12 := 0;
    goto inline$BDLPnPQueryStop$0$label_5#1;

  inline$BDLPnPQueryStop$0$label_5#1:
    goto inline$BDLPnPQueryStop$0$label_6#1;

  inline$BDLPnPQueryStop$0$label_6#1:
    goto inline$BDLGetDebugLevel$475$Entry#1;

  inline$BDLGetDebugLevel$475$Entry#1:
    goto inline$BDLGetDebugLevel$475$start#1;

  inline$BDLGetDebugLevel$475$start#1:
    goto inline$BDLGetDebugLevel$475$label_3#1;

  inline$BDLGetDebugLevel$475$label_3#1:
    havoc inline$BDLGetDebugLevel$475$myNondetVar_0;
    inline$BDLGetDebugLevel$475$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$475$myNondetVar_0;
    goto inline$BDLGetDebugLevel$475$label_1#1;

  inline$BDLGetDebugLevel$475$label_1#1:
    goto inline$BDLGetDebugLevel$475$Return#1;

  inline$BDLGetDebugLevel$475$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$2$ := inline$BDLGetDebugLevel$475$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryStop$0$label_6$1#1;

  inline$BDLPnPQueryStop$0$label_6$1#1:
    goto inline$BDLPnPQueryStop$0$anon22_Then#1, inline$BDLPnPQueryStop$0$anon22_Else#1;

  inline$BDLPnPQueryStop$0$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon1#1;

  inline$BDLPnPQueryStop$0$anon1#1:
    goto inline$BDLPnPQueryStop$0$label_9#1;

  inline$BDLPnPQueryStop$0$label_9#1:
    goto inline$BDLPnPQueryStop$0$label_9_true#1, inline$BDLPnPQueryStop$0$label_9_false#1;

  inline$BDLPnPQueryStop$0$label_9_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$2$) == 0;
    goto inline$BDLPnPQueryStop$0$label_10#1;

  inline$BDLPnPQueryStop$0$label_9_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$2$) != 0;
    goto inline$BDLPnPQueryStop$0$label_13#1;

  inline$BDLPnPQueryStop$0$label_13#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_14#1;

  inline$BDLPnPQueryStop$0$label_14#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_15#1;

  inline$BDLPnPQueryStop$0$label_15#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_16#1;

  inline$BDLPnPQueryStop$0$label_16#1:
    havoc inline$BDLPnPQueryStop$0$$result.DbgPrint$2085.0$3$;
    goto inline$BDLPnPQueryStop$0$label_10#1;

  inline$BDLPnPQueryStop$0$label_10#1:
    goto inline$BDLGetDebugLevel$476$Entry#1;

  inline$BDLGetDebugLevel$476$Entry#1:
    goto inline$BDLGetDebugLevel$476$start#1;

  inline$BDLGetDebugLevel$476$start#1:
    goto inline$BDLGetDebugLevel$476$label_3#1;

  inline$BDLGetDebugLevel$476$label_3#1:
    havoc inline$BDLGetDebugLevel$476$myNondetVar_0;
    inline$BDLGetDebugLevel$476$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$476$myNondetVar_0;
    goto inline$BDLGetDebugLevel$476$label_1#1;

  inline$BDLGetDebugLevel$476$label_1#1:
    goto inline$BDLGetDebugLevel$476$Return#1;

  inline$BDLGetDebugLevel$476$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$7$ := inline$BDLGetDebugLevel$476$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryStop$0$label_10$1#1;

  inline$BDLPnPQueryStop$0$label_10$1#1:
    goto inline$BDLPnPQueryStop$0$anon23_Then#1, inline$BDLPnPQueryStop$0$anon23_Else#1;

  inline$BDLPnPQueryStop$0$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon3#1;

  inline$BDLPnPQueryStop$0$anon3#1:
    goto inline$BDLPnPQueryStop$0$label_19#1;

  inline$BDLPnPQueryStop$0$label_19#1:
    goto inline$BDLPnPQueryStop$0$label_19_true#1, inline$BDLPnPQueryStop$0$label_19_false#1;

  inline$BDLPnPQueryStop$0$label_19_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$7$) == 0;
    goto inline$BDLPnPQueryStop$0$label_20#1;

  inline$BDLPnPQueryStop$0$label_19_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$7$) != 0;
    goto inline$BDLPnPQueryStop$0$label_23#1;

  inline$BDLPnPQueryStop$0$label_23#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_24#1;

  inline$BDLPnPQueryStop$0$label_24#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_25#1;

  inline$BDLPnPQueryStop$0$label_25#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_26#1;

  inline$BDLPnPQueryStop$0$label_26#1:
    havoc inline$BDLPnPQueryStop$0$$result.DbgPrint$2085.0$8$;
    goto inline$BDLPnPQueryStop$0$label_20#1;

  inline$BDLPnPQueryStop$0$label_20#1:
    goto inline$BDLGetDebugLevel$477$Entry#1;

  inline$BDLGetDebugLevel$477$Entry#1:
    goto inline$BDLGetDebugLevel$477$start#1;

  inline$BDLGetDebugLevel$477$start#1:
    goto inline$BDLGetDebugLevel$477$label_3#1;

  inline$BDLGetDebugLevel$477$label_3#1:
    havoc inline$BDLGetDebugLevel$477$myNondetVar_0;
    inline$BDLGetDebugLevel$477$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$477$myNondetVar_0;
    goto inline$BDLGetDebugLevel$477$label_1#1;

  inline$BDLGetDebugLevel$477$label_1#1:
    goto inline$BDLGetDebugLevel$477$Return#1;

  inline$BDLGetDebugLevel$477$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$12$ := inline$BDLGetDebugLevel$477$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryStop$0$label_20$1#1;

  inline$BDLPnPQueryStop$0$label_20$1#1:
    goto inline$BDLPnPQueryStop$0$anon24_Then#1, inline$BDLPnPQueryStop$0$anon24_Else#1;

  inline$BDLPnPQueryStop$0$anon24_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon5#1;

  inline$BDLPnPQueryStop$0$anon5#1:
    goto inline$BDLPnPQueryStop$0$label_29#1;

  inline$BDLPnPQueryStop$0$label_29#1:
    goto inline$BDLPnPQueryStop$0$label_29_true#1, inline$BDLPnPQueryStop$0$label_29_false#1;

  inline$BDLPnPQueryStop$0$label_29_false#1:
    assume BIT_BAND(inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$12$, 4) == 0;
    goto inline$BDLPnPQueryStop$0$label_30#1;

  inline$BDLPnPQueryStop$0$label_29_true#1:
    assume BIT_BAND(inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2085.0$12$, 4) != 0;
    goto inline$BDLPnPQueryStop$0$label_33#1;

  inline$BDLPnPQueryStop$0$label_33#1:
    goto inline$BDLPnPQueryStop$0$label_30#1;

  inline$BDLPnPQueryStop$0$label_30#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    havoc inline$BDLPnPQueryStop$0$myNondetVar_1;
    assume inline$BDLPnPQueryStop$0$myNondetVar_0 == inline$BDLPnPQueryStop$0$myNondetVar_1;
    goto inline$storm_KeAcquireSpinLock$2$Entry#1;

  inline$storm_KeAcquireSpinLock$2$Entry#1:
    inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1 := SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12);
    goto inline$storm_KeAcquireSpinLock$2$start#1;

  inline$storm_KeAcquireSpinLock$2$start#1:
    inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1;
    goto inline$storm_KeAcquireSpinLock$2$label_3#1;

  inline$storm_KeAcquireSpinLock$2$label_3#1:
    goto inline$storm_KeAcquireSpinLock$2$label_4#1;

  inline$storm_KeAcquireSpinLock$2$label_4#1:
    goto inline$storm_getThreadID$5$Entry#1;

  inline$storm_getThreadID$5$Entry#1:
    goto inline$storm_getThreadID$5$anon0#1;

  inline$storm_getThreadID$5$anon0#1:
    inline$storm_getThreadID$5$tid := __storm_thread_id;
    goto inline$storm_getThreadID$5$Return#1;

  inline$storm_getThreadID$5$Return#1:
    inline$storm_KeAcquireSpinLock$2$$result.storm_getThreadID$128.29$1$ := inline$storm_getThreadID$5$tid;
    goto inline$storm_KeAcquireSpinLock$2$label_4$1#1;

  inline$storm_KeAcquireSpinLock$2$label_4$1#1:
    goto inline$storm_KeAcquireSpinLock$2$label_7#1;

  inline$storm_KeAcquireSpinLock$2$label_7#1:
    inline$storm_KeAcquireSpinLock$2$$tid$3$128.6$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$2$$result.storm_getThreadID$128.29$1$;
    goto inline$storm_KeAcquireSpinLock$2$label_8#1;

  inline$storm_KeAcquireSpinLock$2$label_8#1:
    goto inline$storm_KeAcquireSpinLock$2$label_9#1;

  inline$storm_KeAcquireSpinLock$2$label_9#1:
    __storm_atomic := true;
    goto inline$storm_KeAcquireSpinLock$2$label_12#1;

  inline$storm_KeAcquireSpinLock$2$label_12#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$2$anon7_Then#1, inline$storm_KeAcquireSpinLock$2$anon7_Else#1;

  inline$storm_KeAcquireSpinLock$2$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$2$anon1#1;

  inline$storm_KeAcquireSpinLock$2$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8], inline$storm_KeAcquireSpinLock$2$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$2$label_13#1;

  inline$storm_KeAcquireSpinLock$2$label_13#1:
    goto inline$storm_KeAcquireSpinLock$2$label_13_true#1, inline$storm_KeAcquireSpinLock$2$label_13_false#1;

  inline$storm_KeAcquireSpinLock$2$label_13_false#1:
    assume !INT_NEQ(inline$storm_KeAcquireSpinLock$2$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$2$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$2$label_14#1;

  inline$storm_KeAcquireSpinLock$2$label_14#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeAcquireSpinLock$2$label_1#1;

  inline$storm_KeAcquireSpinLock$2$label_13_true#1:
    assume INT_NEQ(inline$storm_KeAcquireSpinLock$2$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$2$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$2$label_17#1;

  inline$storm_KeAcquireSpinLock$2$label_17#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$2$anon8_Then#1, inline$storm_KeAcquireSpinLock$2$anon8_Else#1;

  inline$storm_KeAcquireSpinLock$2$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$2$anon4#1;

  inline$storm_KeAcquireSpinLock$2$anon4#1:
    assume INT_EQ(inline$storm_KeAcquireSpinLock$2$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8, 0);
    goto inline$storm_KeAcquireSpinLock$2$label_18#1;

  inline$storm_KeAcquireSpinLock$2$label_18#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeAcquireSpinLock$2$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$2$$tid$3$128.6$storm_KeAcquireSpinLock$8];
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$2$label_19#1;

  inline$storm_KeAcquireSpinLock$2$label_19#1:
    goto inline$storm_KeAcquireSpinLock$2$anon9_Then#1, inline$storm_KeAcquireSpinLock$2$anon9_Else#1;

  inline$storm_KeAcquireSpinLock$2$anon9_Else#1:
    assume __storm_init;
    goto inline$storm_KeAcquireSpinLock$2$anon6#1;

  inline$storm_KeAcquireSpinLock$2$anon9_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeAcquireSpinLock$2$anon6#1;

  inline$storm_KeAcquireSpinLock$2$anon6#1:
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$2$label_1#1;

  inline$storm_KeAcquireSpinLock$2$label_1#1:
    goto inline$storm_KeAcquireSpinLock$2$Return#1;

  inline$storm_KeAcquireSpinLock$2$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$2$Return#1;

  inline$storm_KeAcquireSpinLock$2$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$2$Return#1;

  inline$storm_KeAcquireSpinLock$2$Return#1:
    goto inline$BDLPnPQueryStop$0$label_30$1#1;

  inline$BDLPnPQueryStop$0$label_30$1#1:
    goto inline$BDLPnPQueryStop$0$anon25_Then#1, inline$BDLPnPQueryStop$0$anon25_Else#1;

  inline$BDLPnPQueryStop$0$anon25_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon7#1;

  inline$BDLPnPQueryStop$0$anon7#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    goto inline$BDLPnPQueryStop$0$label_34#1;

  inline$BDLPnPQueryStop$0$label_34#1:
    goto inline$BDLPnPQueryStop$0$label_34_true#1, inline$BDLPnPQueryStop$0$label_34_false#1;

  inline$BDLPnPQueryStop$0$label_34_false#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    assume !INT_ULT(0, inline$BDLPnPQueryStop$0$myNondetVar_0);
    goto inline$BDLPnPQueryStop$0$label_35#1;

  inline$BDLPnPQueryStop$0$label_35#1:
    goto inline$storm_KeClearEvent$0$Entry#1;

  inline$storm_KeClearEvent$0$Entry#1:
    inline$storm_KeClearEvent$0$$Event$1$236.14$storm_KeClearEvent$4_.1 := DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12);
    goto inline$storm_KeClearEvent$0$start#1;

  inline$storm_KeClearEvent$0$start#1:
    inline$storm_KeClearEvent$0$$Event$1$236.14$storm_KeClearEvent$4 := inline$storm_KeClearEvent$0$$Event$1$236.14$storm_KeClearEvent$4_.1;
    goto inline$storm_KeClearEvent$0$label_3#1;

  inline$storm_KeClearEvent$0$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeClearEvent$0$$Event$1$236.14$storm_KeClearEvent$4 := 0];
    call contextSwitch();
    goto inline$storm_KeClearEvent$0$label_1#1;

  inline$storm_KeClearEvent$0$label_1#1:
    goto inline$storm_KeClearEvent$0$Return#1;

  inline$storm_KeClearEvent$0$Return#1:
    goto inline$BDLPnPQueryStop$0$label_35$1#1;

  inline$BDLPnPQueryStop$0$label_35$1#1:
    goto inline$BDLPnPQueryStop$0$anon26_Then#1, inline$BDLPnPQueryStop$0$anon26_Else#1;

  inline$BDLPnPQueryStop$0$anon26_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon9#1;

  inline$BDLPnPQueryStop$0$anon9#1:
    goto inline$BDLPnPQueryStop$0$label_68#1;

  inline$BDLPnPQueryStop$0$label_68#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    havoc inline$BDLPnPQueryStop$0$myNondetVar_1;
    assume inline$BDLPnPQueryStop$0$myNondetVar_0 == inline$BDLPnPQueryStop$0$myNondetVar_1;
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    goto inline$storm_KeReleaseSpinLock$4$Entry#1;

  inline$storm_KeReleaseSpinLock$4$Entry#1:
    inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12);
    goto inline$storm_KeReleaseSpinLock$4$start#1;

  inline$storm_KeReleaseSpinLock$4$start#1:
    inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$4$label_3#1;

  inline$storm_KeReleaseSpinLock$4$label_3#1:
    goto inline$storm_KeReleaseSpinLock$4$label_4#1;

  inline$storm_KeReleaseSpinLock$4$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$4$label_7#1;

  inline$storm_KeReleaseSpinLock$4$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$4$anon5_Then#1, inline$storm_KeReleaseSpinLock$4$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$4$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$4$anon1#1;

  inline$storm_KeReleaseSpinLock$4$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$4$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$4$label_8#1;

  inline$storm_KeReleaseSpinLock$4$label_8#1:
    goto inline$storm_getThreadID$7$Entry#1;

  inline$storm_getThreadID$7$Entry#1:
    goto inline$storm_getThreadID$7$anon0#1;

  inline$storm_getThreadID$7$anon0#1:
    inline$storm_getThreadID$7$tid := __storm_thread_id;
    goto inline$storm_getThreadID$7$Return#1;

  inline$storm_getThreadID$7$Return#1:
    inline$storm_KeReleaseSpinLock$4$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$7$tid;
    goto inline$storm_KeReleaseSpinLock$4$label_8$1#1;

  inline$storm_KeReleaseSpinLock$4$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$4$label_11#1;

  inline$storm_KeReleaseSpinLock$4$label_11#1:
    goto inline$storm_KeReleaseSpinLock$4$label_11_true#1, inline$storm_KeReleaseSpinLock$4$label_11_false#1;

  inline$storm_KeReleaseSpinLock$4$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$4$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$4$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$4$label_12#1;

  inline$storm_KeReleaseSpinLock$4$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$4$label_1#1;

  inline$storm_KeReleaseSpinLock$4$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$4$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$4$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$4$label_15#1;

  inline$storm_KeReleaseSpinLock$4$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$4$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$4$label_16#1;

  inline$storm_KeReleaseSpinLock$4$label_16#1:
    goto inline$storm_KeReleaseSpinLock$4$anon6_Then#1, inline$storm_KeReleaseSpinLock$4$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$4$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$4$anon4#1;

  inline$storm_KeReleaseSpinLock$4$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$4$anon4#1;

  inline$storm_KeReleaseSpinLock$4$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$4$label_1#1;

  inline$storm_KeReleaseSpinLock$4$label_1#1:
    goto inline$storm_KeReleaseSpinLock$4$Return#1;

  inline$storm_KeReleaseSpinLock$4$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$4$Return#1;

  inline$storm_KeReleaseSpinLock$4$Return#1:
    goto inline$BDLPnPQueryStop$0$label_68$1#1;

  inline$BDLPnPQueryStop$0$label_68$1#1:
    goto inline$BDLPnPQueryStop$0$anon31_Then#1, inline$BDLPnPQueryStop$0$anon31_Else#1;

  inline$BDLPnPQueryStop$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon19#1;

  inline$BDLPnPQueryStop$0$anon19#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    goto inline$BDLPnPQueryStop$0$label_71#1;

  inline$BDLPnPQueryStop$0$label_71#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$Entry#1;

  inline$BDLCallLowerLevelDriverAndWait$4$Entry#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1 := inline$BDLPnPQueryStop$0$$pIrp$3$2078.40$BDLPnPQueryStop$12;
    goto inline$BDLCallLowerLevelDriverAndWait$4$start#1;

  inline$BDLCallLowerLevelDriverAndWait$4$start#1:
    call inline$BDLCallLowerLevelDriverAndWait$4$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8 := __HAVOC_malloc(16);
    inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_3#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_4#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_4#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := 0;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_5#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_6#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_6#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$Entry#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$Entry#1:
    inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$start#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$start#1:
    inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4 := inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_4#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_4#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_5#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_5#1:
    goto inline$IoGetCurrentIrpStackLocation$92$Entry#1;

  inline$IoGetCurrentIrpStackLocation$92$Entry#1:
    inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetCurrentIrpStackLocation$92$start#1;

  inline$IoGetCurrentIrpStackLocation$92$start#1:
    inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$92$label_3#1;

  inline$IoGetCurrentIrpStackLocation$92$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$92$label_3_true#1, inline$IoGetCurrentIrpStackLocation$92$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$92$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$92$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$92$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$92$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$92$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$92$label_4#1;

  inline$IoGetCurrentIrpStackLocation$92$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$92$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$92$label_6#1;

  inline$IoGetCurrentIrpStackLocation$92$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$92$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$92$label_7#1;

  inline$IoGetCurrentIrpStackLocation$92$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$92$label_5#1;

  inline$IoGetCurrentIrpStackLocation$92$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$92$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$92$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$92$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$92$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$92$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$92$label_5#1;

  inline$IoGetCurrentIrpStackLocation$92$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$92$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$92$label_1#1;

  inline$IoGetCurrentIrpStackLocation$92$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$92$Return#1;

  inline$IoGetCurrentIrpStackLocation$92$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_5$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_5$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$anon4_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$4$anon4_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$anon4_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$anon1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$anon1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_8#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_8#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_9#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_9#1:
    goto inline$IoGetNextIrpStackLocation$9$Entry#1;

  inline$IoGetNextIrpStackLocation$9$Entry#1:
    inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$4$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetNextIrpStackLocation$9$start#1;

  inline$IoGetNextIrpStackLocation$9$start#1:
    inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$9$label_3#1;

  inline$IoGetNextIrpStackLocation$9$label_3#1:
    goto inline$IoGetNextIrpStackLocation$9$label_3_true#1, inline$IoGetNextIrpStackLocation$9$label_3_false#1;

  inline$IoGetNextIrpStackLocation$9$label_3_false#1:
    inline$IoGetNextIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$9$myVar_0);
    goto inline$IoGetNextIrpStackLocation$9$label_4#1;

  inline$IoGetNextIrpStackLocation$9$label_4#1:
    call inline$IoGetNextIrpStackLocation$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$9$label_6#1;

  inline$IoGetNextIrpStackLocation$9$label_6#1:
    call inline$IoGetNextIrpStackLocation$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$9$label_7#1;

  inline$IoGetNextIrpStackLocation$9$label_7#1:
    goto inline$IoGetNextIrpStackLocation$9$label_5#1;

  inline$IoGetNextIrpStackLocation$9$label_3_true#1:
    inline$IoGetNextIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$9$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$9$myVar_0);
    goto inline$IoGetNextIrpStackLocation$9$label_5#1;

  inline$IoGetNextIrpStackLocation$9$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$9$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$9$label_1#1;

  inline$IoGetNextIrpStackLocation$9$label_1#1:
    goto inline$IoGetNextIrpStackLocation$9$Return#1;

  inline$IoGetNextIrpStackLocation$9$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_9$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_9$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$anon5_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$4$anon5_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$anon5_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$anon3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$anon3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_12#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_12#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_13#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_13#1:
    havoc inline$IoCopyCurrentIrpStackLocationToNext$4$$result.memcpy$25110.4$3$;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_16#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_16#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$label_1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$label_1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$anon5_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$anon4_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$4$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$4$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_6$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_6$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon16_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon16_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_9#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_9#1:
    goto inline$storm_KeInitializeEvent$4$Entry#1;

  inline$storm_KeInitializeEvent$4$Entry#1:
    inline$storm_KeInitializeEvent$4$$Event$1$203.14$storm_KeInitializeEvent$12_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeInitializeEvent$4$$State$3$205.13$storm_KeInitializeEvent$12_.1 := 0;
    goto inline$storm_KeInitializeEvent$4$start#1;

  inline$storm_KeInitializeEvent$4$start#1:
    inline$storm_KeInitializeEvent$4$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$4$$Event$1$203.14$storm_KeInitializeEvent$12_.1;
    inline$storm_KeInitializeEvent$4$$State$3$205.13$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$4$$State$3$205.13$storm_KeInitializeEvent$12_.1;
    goto inline$storm_KeInitializeEvent$4$label_3#1;

  inline$storm_KeInitializeEvent$4$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeInitializeEvent$4$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$4$$State$3$205.13$storm_KeInitializeEvent$12];
    call contextSwitch();
    goto inline$storm_KeInitializeEvent$4$label_1#1;

  inline$storm_KeInitializeEvent$4$label_1#1:
    goto inline$storm_KeInitializeEvent$4$Return#1;

  inline$storm_KeInitializeEvent$4$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_9$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_9$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon17_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon17_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon3#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_12#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$4$Entry#1;

  inline$storm_IoSetCompletionRoutine$4$Entry#1:
    inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoSetCompletionRoutine$4$start#1;

  inline$storm_IoSetCompletionRoutine$4$start#1:
    inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24 := inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1;
    goto inline$storm_IoSetCompletionRoutine$4$label_3#1;

  inline$storm_IoSetCompletionRoutine$4$label_3#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_4#1;

  inline$storm_IoSetCompletionRoutine$4$label_4#1:
    call inline$storm_IoSetCompletionRoutine$4$$result.storm_nondet$405.2$1$ := storm_nondet();
    goto inline$storm_IoSetCompletionRoutine$4$label_7#1;

  inline$storm_IoSetCompletionRoutine$4$label_7#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_7_true#1, inline$storm_IoSetCompletionRoutine$4$label_7_false#1;

  inline$storm_IoSetCompletionRoutine$4$label_7_false#1:
    assume inline$storm_IoSetCompletionRoutine$4$$result.storm_nondet$405.2$1$ == 0;
    goto inline$storm_IoSetCompletionRoutine$4$label_8#1;

  inline$storm_IoSetCompletionRoutine$4$label_7_true#1:
    assume inline$storm_IoSetCompletionRoutine$4$$result.storm_nondet$405.2$1$ != 0;
    goto inline$storm_IoSetCompletionRoutine$4$label_11#1;

  inline$storm_IoSetCompletionRoutine$4$label_11#1:
    havoc raiseException;
    goto inline$storm_IoSetCompletionRoutine$4$anon6_Then#1, inline$storm_IoSetCompletionRoutine$4$anon6_Else#1;

  inline$storm_IoSetCompletionRoutine$4$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$4$anon3#1;

  inline$storm_IoSetCompletionRoutine$4$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24], 1);
    call contextSwitch();
    goto inline$storm_IoSetCompletionRoutine$4$label_12#1;

  inline$storm_IoSetCompletionRoutine$4$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_12_true#1, inline$storm_IoSetCompletionRoutine$4$label_12_false#1;

  inline$storm_IoSetCompletionRoutine$4$label_12_false#1:
    assume 0 == 0;
    goto inline$storm_IoSetCompletionRoutine$4$label_13#1;

  inline$storm_IoSetCompletionRoutine$4$label_13#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoSetCompletionRoutine$4$label_1#1;

  inline$storm_IoSetCompletionRoutine$4$label_12_true#1:
    assume 0 != 0;
    goto inline$storm_IoSetCompletionRoutine$4$label_8#1;

  inline$storm_IoSetCompletionRoutine$4$label_8#1:
    goto inline$IoGetNextIrpStackLocation$10$Entry#1;

  inline$IoGetNextIrpStackLocation$10$Entry#1:
    inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoSetCompletionRoutine$4$$pirp$1$396.10$storm_IoSetCompletionRoutine$24;
    goto inline$IoGetNextIrpStackLocation$10$start#1;

  inline$IoGetNextIrpStackLocation$10$start#1:
    inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$10$label_3#1;

  inline$IoGetNextIrpStackLocation$10$label_3#1:
    goto inline$IoGetNextIrpStackLocation$10$label_3_true#1, inline$IoGetNextIrpStackLocation$10$label_3_false#1;

  inline$IoGetNextIrpStackLocation$10$label_3_false#1:
    inline$IoGetNextIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$10$myVar_0);
    goto inline$IoGetNextIrpStackLocation$10$label_4#1;

  inline$IoGetNextIrpStackLocation$10$label_4#1:
    call inline$IoGetNextIrpStackLocation$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$10$label_6#1;

  inline$IoGetNextIrpStackLocation$10$label_6#1:
    call inline$IoGetNextIrpStackLocation$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$10$label_7#1;

  inline$IoGetNextIrpStackLocation$10$label_7#1:
    goto inline$IoGetNextIrpStackLocation$10$label_5#1;

  inline$IoGetNextIrpStackLocation$10$label_3_true#1:
    inline$IoGetNextIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$10$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$10$myVar_0);
    goto inline$IoGetNextIrpStackLocation$10$label_5#1;

  inline$IoGetNextIrpStackLocation$10$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$10$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$10$label_1#1;

  inline$IoGetNextIrpStackLocation$10$label_1#1:
    goto inline$IoGetNextIrpStackLocation$10$Return#1;

  inline$IoGetNextIrpStackLocation$10$Return#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_8$1#1;

  inline$storm_IoSetCompletionRoutine$4$label_8$1#1:
    goto inline$storm_IoSetCompletionRoutine$4$anon5_Then#1, inline$storm_IoSetCompletionRoutine$4$anon5_Else#1;

  inline$storm_IoSetCompletionRoutine$4$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$4$anon1#1;

  inline$storm_IoSetCompletionRoutine$4$anon1#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_16#1;

  inline$storm_IoSetCompletionRoutine$4$label_16#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_17#1;

  inline$storm_IoSetCompletionRoutine$4$label_17#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_18#1;

  inline$storm_IoSetCompletionRoutine$4$label_18#1:
    goto inline$storm_IoSetCompletionRoutine$4$label_1#1;

  inline$storm_IoSetCompletionRoutine$4$label_1#1:
    goto inline$storm_IoSetCompletionRoutine$4$Return#1;

  inline$storm_IoSetCompletionRoutine$4$anon5_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$4$Return#1;

  inline$storm_IoSetCompletionRoutine$4$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$4$Return#1;

  inline$storm_IoSetCompletionRoutine$4$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_12$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_12$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon18_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon18_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon5#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_15#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_15#1:
    goto inline$IoGetCurrentIrpStackLocation$93$Entry#1;

  inline$IoGetCurrentIrpStackLocation$93$Entry#1:
    inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoGetCurrentIrpStackLocation$93$start#1;

  inline$IoGetCurrentIrpStackLocation$93$start#1:
    inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$93$label_3#1;

  inline$IoGetCurrentIrpStackLocation$93$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$93$label_3_true#1, inline$IoGetCurrentIrpStackLocation$93$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$93$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$93$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$93$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$93$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$93$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$93$label_4#1;

  inline$IoGetCurrentIrpStackLocation$93$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$93$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$93$label_6#1;

  inline$IoGetCurrentIrpStackLocation$93$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$93$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$93$label_7#1;

  inline$IoGetCurrentIrpStackLocation$93$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$93$label_5#1;

  inline$IoGetCurrentIrpStackLocation$93$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$93$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$93$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$93$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$93$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$93$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$93$label_5#1;

  inline$IoGetCurrentIrpStackLocation$93$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$93$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$93$label_1#1;

  inline$IoGetCurrentIrpStackLocation$93$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$93$Return#1;

  inline$IoGetCurrentIrpStackLocation$93$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_15$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_15$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon19_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon19_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon7#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon7#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_18#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_18#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_18_true#1, inline$BDLCallLowerLevelDriverAndWait$4$label_18_false#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_18_false#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0;
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_19#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_19#1:
    goto inline$storm_IoCallDriver$9$Entry#1;

  inline$storm_IoCallDriver$9$Entry#1:
    inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoCallDriver$9$start#1;

  inline$storm_IoCallDriver$9$start#1:
    inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$9$label_3#1;

  inline$storm_IoCallDriver$9$label_3#1:
    goto inline$storm_IoCallDriver$9$label_4#1;

  inline$storm_IoCallDriver$9$label_4#1:
    goto inline$storm_IoCallDriver$9$label_5#1;

  inline$storm_IoCallDriver$9$label_5#1:
    goto inline$storm_IoCallDriver$9$label_6#1;

  inline$storm_IoCallDriver$9$label_6#1:
    call inline$storm_IoCallDriver$9$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$9$label_9#1;

  inline$storm_IoCallDriver$9$label_9#1:
    goto inline$storm_IoCallDriver$9$label_9_true#1, inline$storm_IoCallDriver$9$label_9_false#1;

  inline$storm_IoCallDriver$9$label_9_false#1:
    assume inline$storm_IoCallDriver$9$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$9$label_10#1;

  inline$storm_IoCallDriver$9$label_9_true#1:
    assume inline$storm_IoCallDriver$9$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$9$label_13#1;

  inline$storm_IoCallDriver$9$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$9$anon12_Then#1, inline$storm_IoCallDriver$9$anon12_Else#1;

  inline$storm_IoCallDriver$9$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$9$anon3#1;

  inline$storm_IoCallDriver$9$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$9$label_14#1;

  inline$storm_IoCallDriver$9$label_14#1:
    goto inline$storm_IoCallDriver$9$label_14_true#1, inline$storm_IoCallDriver$9$label_14_false#1;

  inline$storm_IoCallDriver$9$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$9$label_15#1;

  inline$storm_IoCallDriver$9$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$9$label_1#1;

  inline$storm_IoCallDriver$9$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$9$label_10#1;

  inline$storm_IoCallDriver$9$label_10#1:
    goto inline$IoSetNextIrpStackLocation$10$Entry#1;

  inline$IoSetNextIrpStackLocation$10$Entry#1:
    inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$10$start#1;

  inline$IoSetNextIrpStackLocation$10$start#1:
    inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$10$label_3#1;

  inline$IoSetNextIrpStackLocation$10$label_3#1:
    goto inline$IoSetNextIrpStackLocation$10$label_3_true#1, inline$IoSetNextIrpStackLocation$10$label_3_false#1;

  inline$IoSetNextIrpStackLocation$10$label_3_false#1:
    inline$IoSetNextIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$10$myVar_0);
    goto inline$IoSetNextIrpStackLocation$10$label_4#1;

  inline$IoSetNextIrpStackLocation$10$label_4#1:
    call inline$IoSetNextIrpStackLocation$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$10$label_7#1;

  inline$IoSetNextIrpStackLocation$10$label_7#1:
    call inline$IoSetNextIrpStackLocation$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$10$label_8#1;

  inline$IoSetNextIrpStackLocation$10$label_8#1:
    goto inline$IoSetNextIrpStackLocation$10$label_5#1;

  inline$IoSetNextIrpStackLocation$10$label_3_true#1:
    inline$IoSetNextIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$10$myVar_0);
    goto inline$IoSetNextIrpStackLocation$10$label_5#1;

  inline$IoSetNextIrpStackLocation$10$label_5#1:
    inline$IoSetNextIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$10$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$10$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$10$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$10$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$10$label_6#1;

  inline$IoSetNextIrpStackLocation$10$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$10$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$10$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$10$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$10$label_1#1;

  inline$IoSetNextIrpStackLocation$10$label_1#1:
    goto inline$IoSetNextIrpStackLocation$10$Return#1;

  inline$IoSetNextIrpStackLocation$10$Return#1:
    goto inline$storm_IoCallDriver$9$label_10$1#1;

  inline$storm_IoCallDriver$9$label_10$1#1:
    goto inline$storm_IoCallDriver$9$anon11_Then#1, inline$storm_IoCallDriver$9$anon11_Else#1;

  inline$storm_IoCallDriver$9$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$9$anon1#1;

  inline$storm_IoCallDriver$9$anon1#1:
    goto inline$storm_IoCallDriver$9$label_18#1;

  inline$storm_IoCallDriver$9$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$94$Entry#1;

  inline$IoGetCurrentIrpStackLocation$94$Entry#1:
    inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$94$start#1;

  inline$IoGetCurrentIrpStackLocation$94$start#1:
    inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$94$label_3#1;

  inline$IoGetCurrentIrpStackLocation$94$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$94$label_3_true#1, inline$IoGetCurrentIrpStackLocation$94$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$94$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$94$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$94$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$94$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$94$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$94$label_4#1;

  inline$IoGetCurrentIrpStackLocation$94$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$94$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$94$label_6#1;

  inline$IoGetCurrentIrpStackLocation$94$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$94$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$94$label_7#1;

  inline$IoGetCurrentIrpStackLocation$94$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$94$label_5#1;

  inline$IoGetCurrentIrpStackLocation$94$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$94$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$94$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$94$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$94$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$94$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$94$label_5#1;

  inline$IoGetCurrentIrpStackLocation$94$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$94$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$94$label_1#1;

  inline$IoGetCurrentIrpStackLocation$94$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$94$Return#1;

  inline$IoGetCurrentIrpStackLocation$94$Return#1:
    goto inline$storm_IoCallDriver$9$label_18$1#1;

  inline$storm_IoCallDriver$9$label_18$1#1:
    goto inline$storm_IoCallDriver$9$anon13_Then#1, inline$storm_IoCallDriver$9$anon13_Else#1;

  inline$storm_IoCallDriver$9$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$9$anon6#1;

  inline$storm_IoCallDriver$9$anon6#1:
    goto inline$storm_IoCallDriver$9$label_21#1;

  inline$storm_IoCallDriver$9$label_21#1:
    goto inline$storm_IoCallDriver$9$label_22#1;

  inline$storm_IoCallDriver$9$label_22#1:
    goto inline$storm_IoCallDriver$9$label_23#1;

  inline$storm_IoCallDriver$9$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$9$label_24#1;

  inline$storm_IoCallDriver$9$label_24#1:
    call inline$storm_IoCallDriver$9$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$9$label_27#1;

  inline$storm_IoCallDriver$9$label_27#1:
    goto inline$storm_IoCallDriver$9$label_27_case_0#1, inline$storm_IoCallDriver$9$label_27_case_1#1, inline$storm_IoCallDriver$9$label_27_case_2#1;

  inline$storm_IoCallDriver$9$label_27_case_2#1:
    assume inline$storm_IoCallDriver$9$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$9$label_30#1;

  inline$storm_IoCallDriver$9$label_30#1:
    inline$storm_IoCallDriver$9$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$9$label_31#1;

  inline$storm_IoCallDriver$9$label_31#1:
    goto inline$storm_IoCallDriver$9$label_32#1;

  inline$storm_IoCallDriver$9$label_32#1:
    goto inline$storm_IoCallDriver$9$label_33#1;

  inline$storm_IoCallDriver$9$label_33#1:
    goto inline$CallCompletionRoutine$18$Entry#1;

  inline$CallCompletionRoutine$18$Entry#1:
    inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$18$start#1;

  inline$CallCompletionRoutine$18$start#1:
    inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$18$label_3#1;

  inline$CallCompletionRoutine$18$label_3#1:
    goto inline$CallCompletionRoutine$18$label_4#1;

  inline$CallCompletionRoutine$18$label_4#1:
    goto inline$CallCompletionRoutine$18$label_5#1;

  inline$CallCompletionRoutine$18$label_5#1:
    goto inline$CallCompletionRoutine$18$label_6#1;

  inline$CallCompletionRoutine$18$label_6#1:
    goto inline$CallCompletionRoutine$18$label_7#1;

  inline$CallCompletionRoutine$18$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$95$Entry#1;

  inline$IoGetCurrentIrpStackLocation$95$Entry#1:
    inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$95$start#1;

  inline$IoGetCurrentIrpStackLocation$95$start#1:
    inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$95$label_3#1;

  inline$IoGetCurrentIrpStackLocation$95$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$95$label_3_true#1, inline$IoGetCurrentIrpStackLocation$95$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$95$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$95$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$95$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$95$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$95$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$95$label_4#1;

  inline$IoGetCurrentIrpStackLocation$95$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$95$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$95$label_6#1;

  inline$IoGetCurrentIrpStackLocation$95$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$95$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$95$label_7#1;

  inline$IoGetCurrentIrpStackLocation$95$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$95$label_5#1;

  inline$IoGetCurrentIrpStackLocation$95$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$95$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$95$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$95$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$95$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$95$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$95$label_5#1;

  inline$IoGetCurrentIrpStackLocation$95$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$95$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$95$label_1#1;

  inline$IoGetCurrentIrpStackLocation$95$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$95$Return#1;

  inline$IoGetCurrentIrpStackLocation$95$Return#1:
    goto inline$CallCompletionRoutine$18$label_7$1#1;

  inline$CallCompletionRoutine$18$label_7$1#1:
    goto inline$CallCompletionRoutine$18$anon10_Then#1, inline$CallCompletionRoutine$18$anon10_Else#1;

  inline$CallCompletionRoutine$18$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$18$anon1#1;

  inline$CallCompletionRoutine$18$anon1#1:
    goto inline$CallCompletionRoutine$18$label_10#1;

  inline$CallCompletionRoutine$18$label_10#1:
    goto inline$CallCompletionRoutine$18$label_11#1;

  inline$CallCompletionRoutine$18$label_11#1:
    havoc inline$CallCompletionRoutine$18$myNondetVar_0;
    inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$18$myNondetVar_0;
    goto inline$CallCompletionRoutine$18$label_12#1;

  inline$CallCompletionRoutine$18$label_12#1:
    havoc inline$CallCompletionRoutine$18$myNondetVar_0;
    inline$CallCompletionRoutine$18$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$18$myNondetVar_0;
    goto inline$CallCompletionRoutine$18$label_13#1;

  inline$CallCompletionRoutine$18$label_13#1:
    havoc inline$CallCompletionRoutine$18$myNondetVar_0;
    goto inline$CallCompletionRoutine$18$label_14#1;

  inline$CallCompletionRoutine$18$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$96$Entry#1;

  inline$IoGetCurrentIrpStackLocation$96$Entry#1:
    inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$96$start#1;

  inline$IoGetCurrentIrpStackLocation$96$start#1:
    inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$96$label_3#1;

  inline$IoGetCurrentIrpStackLocation$96$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$96$label_3_true#1, inline$IoGetCurrentIrpStackLocation$96$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$96$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$96$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$96$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$96$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$96$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$96$label_4#1;

  inline$IoGetCurrentIrpStackLocation$96$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$96$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$96$label_6#1;

  inline$IoGetCurrentIrpStackLocation$96$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$96$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$96$label_7#1;

  inline$IoGetCurrentIrpStackLocation$96$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$96$label_5#1;

  inline$IoGetCurrentIrpStackLocation$96$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$96$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$96$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$96$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$96$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$96$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$96$label_5#1;

  inline$IoGetCurrentIrpStackLocation$96$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$96$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$96$label_1#1;

  inline$IoGetCurrentIrpStackLocation$96$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$96$Return#1;

  inline$IoGetCurrentIrpStackLocation$96$Return#1:
    goto inline$CallCompletionRoutine$18$label_14$1#1;

  inline$CallCompletionRoutine$18$label_14$1#1:
    goto inline$CallCompletionRoutine$18$anon11_Then#1, inline$CallCompletionRoutine$18$anon11_Else#1;

  inline$CallCompletionRoutine$18$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$18$anon3#1;

  inline$CallCompletionRoutine$18$anon3#1:
    goto inline$CallCompletionRoutine$18$label_17#1;

  inline$CallCompletionRoutine$18$label_17#1:
    goto inline$CallCompletionRoutine$18$label_18#1;

  inline$CallCompletionRoutine$18$label_18#1:
    goto inline$CallCompletionRoutine$18$label_18_true#1, inline$CallCompletionRoutine$18$label_18_false#1;

  inline$CallCompletionRoutine$18$label_18_false#1:
    assume inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$18$label_1#1;

  inline$CallCompletionRoutine$18$label_18_true#1:
    assume inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$18$label_19#1;

  inline$CallCompletionRoutine$18$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$18$label_20#1;

  inline$CallCompletionRoutine$18$label_20#1:
    goto inline$CallCompletionRoutine$18$label_20_icall_1#1, inline$CallCompletionRoutine$18$label_20_icall_2#1, inline$CallCompletionRoutine$18$label_20_icall_3#1;

  inline$CallCompletionRoutine$18$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$18$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$18$Entry#1;

  inline$BDLSystemPowerIoCompletion$18$Entry#1:
    inline$BDLSystemPowerIoCompletion$18$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$18$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$18$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$18$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$18$start#1;

  inline$BDLSystemPowerIoCompletion$18$start#1:
    call inline$BDLSystemPowerIoCompletion$18$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$18$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$18$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$18$label_3#1;

  inline$BDLSystemPowerIoCompletion$18$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_4#1;

  inline$BDLSystemPowerIoCompletion$18$label_4#1:
    inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_5#1;

  inline$BDLSystemPowerIoCompletion$18$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_6#1;

  inline$BDLSystemPowerIoCompletion$18$label_6#1:
    inline$BDLSystemPowerIoCompletion$18$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$18$label_7#1;

  inline$BDLSystemPowerIoCompletion$18$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_8#1;

  inline$BDLSystemPowerIoCompletion$18$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$18$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$18$label_9#1;

  inline$BDLSystemPowerIoCompletion$18$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_10#1;

  inline$BDLSystemPowerIoCompletion$18$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$98$Entry#1;

  inline$IoGetCurrentIrpStackLocation$98$Entry#1:
    inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$98$start#1;

  inline$IoGetCurrentIrpStackLocation$98$start#1:
    inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$98$label_3#1;

  inline$IoGetCurrentIrpStackLocation$98$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$98$label_3_true#1, inline$IoGetCurrentIrpStackLocation$98$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$98$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$98$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$98$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$98$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$98$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$98$label_4#1;

  inline$IoGetCurrentIrpStackLocation$98$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$98$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$98$label_6#1;

  inline$IoGetCurrentIrpStackLocation$98$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$98$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$98$label_7#1;

  inline$IoGetCurrentIrpStackLocation$98$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$98$label_5#1;

  inline$IoGetCurrentIrpStackLocation$98$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$98$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$98$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$98$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$98$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$98$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$98$label_5#1;

  inline$IoGetCurrentIrpStackLocation$98$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$98$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$98$label_1#1;

  inline$IoGetCurrentIrpStackLocation$98$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$98$Return#1;

  inline$IoGetCurrentIrpStackLocation$98$Return#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon36_Then#1, inline$BDLSystemPowerIoCompletion$18$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon1#1;

  inline$BDLSystemPowerIoCompletion$18$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_13#1;

  inline$BDLSystemPowerIoCompletion$18$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_14#1;

  inline$BDLSystemPowerIoCompletion$18$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_15#1;

  inline$BDLSystemPowerIoCompletion$18$label_15#1:
    goto inline$BDLGetDebugLevel$490$Entry#1;

  inline$BDLGetDebugLevel$490$Entry#1:
    goto inline$BDLGetDebugLevel$490$start#1;

  inline$BDLGetDebugLevel$490$start#1:
    goto inline$BDLGetDebugLevel$490$label_3#1;

  inline$BDLGetDebugLevel$490$label_3#1:
    havoc inline$BDLGetDebugLevel$490$myNondetVar_0;
    inline$BDLGetDebugLevel$490$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$490$myNondetVar_0;
    goto inline$BDLGetDebugLevel$490$label_1#1;

  inline$BDLGetDebugLevel$490$label_1#1:
    goto inline$BDLGetDebugLevel$490$Return#1;

  inline$BDLGetDebugLevel$490$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$490$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon37_Then#1, inline$BDLSystemPowerIoCompletion$18$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon3#1;

  inline$BDLSystemPowerIoCompletion$18$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_18#1;

  inline$BDLSystemPowerIoCompletion$18$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_18_true#1, inline$BDLSystemPowerIoCompletion$18$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_19#1;

  inline$BDLSystemPowerIoCompletion$18$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_22#1;

  inline$BDLSystemPowerIoCompletion$18$label_22#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_23#1;

  inline$BDLSystemPowerIoCompletion$18$label_23#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_24#1;

  inline$BDLSystemPowerIoCompletion$18$label_24#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_25#1;

  inline$BDLSystemPowerIoCompletion$18$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$18$label_19#1;

  inline$BDLSystemPowerIoCompletion$18$label_19#1:
    goto inline$BDLGetDebugLevel$491$Entry#1;

  inline$BDLGetDebugLevel$491$Entry#1:
    goto inline$BDLGetDebugLevel$491$start#1;

  inline$BDLGetDebugLevel$491$start#1:
    goto inline$BDLGetDebugLevel$491$label_3#1;

  inline$BDLGetDebugLevel$491$label_3#1:
    havoc inline$BDLGetDebugLevel$491$myNondetVar_0;
    inline$BDLGetDebugLevel$491$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$491$myNondetVar_0;
    goto inline$BDLGetDebugLevel$491$label_1#1;

  inline$BDLGetDebugLevel$491$label_1#1:
    goto inline$BDLGetDebugLevel$491$Return#1;

  inline$BDLGetDebugLevel$491$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$491$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon38_Then#1, inline$BDLSystemPowerIoCompletion$18$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon5#1;

  inline$BDLSystemPowerIoCompletion$18$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_28#1;

  inline$BDLSystemPowerIoCompletion$18$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_28_true#1, inline$BDLSystemPowerIoCompletion$18$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_29#1;

  inline$BDLSystemPowerIoCompletion$18$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_32#1;

  inline$BDLSystemPowerIoCompletion$18$label_32#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_33#1;

  inline$BDLSystemPowerIoCompletion$18$label_33#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_34#1;

  inline$BDLSystemPowerIoCompletion$18$label_34#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_35#1;

  inline$BDLSystemPowerIoCompletion$18$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$18$label_29#1;

  inline$BDLSystemPowerIoCompletion$18$label_29#1:
    goto inline$BDLGetDebugLevel$492$Entry#1;

  inline$BDLGetDebugLevel$492$Entry#1:
    goto inline$BDLGetDebugLevel$492$start#1;

  inline$BDLGetDebugLevel$492$start#1:
    goto inline$BDLGetDebugLevel$492$label_3#1;

  inline$BDLGetDebugLevel$492$label_3#1:
    havoc inline$BDLGetDebugLevel$492$myNondetVar_0;
    inline$BDLGetDebugLevel$492$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$492$myNondetVar_0;
    goto inline$BDLGetDebugLevel$492$label_1#1;

  inline$BDLGetDebugLevel$492$label_1#1:
    goto inline$BDLGetDebugLevel$492$Return#1;

  inline$BDLGetDebugLevel$492$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$492$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon39_Then#1, inline$BDLSystemPowerIoCompletion$18$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon7#1;

  inline$BDLSystemPowerIoCompletion$18$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_38#1;

  inline$BDLSystemPowerIoCompletion$18$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_38_true#1, inline$BDLSystemPowerIoCompletion$18$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_39#1;

  inline$BDLSystemPowerIoCompletion$18$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_40#1;

  inline$BDLSystemPowerIoCompletion$18$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_39#1;

  inline$BDLSystemPowerIoCompletion$18$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_39_true#1, inline$BDLSystemPowerIoCompletion$18$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_41#1;

  inline$BDLSystemPowerIoCompletion$18$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$18$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$18$label_107#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$18$label_108#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$18$label_108#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$18$label_108#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$18$label_108#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$18$label_108#1;

  inline$BDLSystemPowerIoCompletion$18$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_109#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$18$label_107#1;

  inline$BDLSystemPowerIoCompletion$18$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_109#1;

  inline$BDLSystemPowerIoCompletion$18$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$18$label_106#1;

  inline$BDLSystemPowerIoCompletion$18$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_106_true#1, inline$BDLSystemPowerIoCompletion$18$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_142#1;

  inline$BDLSystemPowerIoCompletion$18$label_142#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_143#1;

  inline$BDLSystemPowerIoCompletion$18$label_143#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_144#1;

  inline$BDLSystemPowerIoCompletion$18$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_109#1;

  inline$BDLSystemPowerIoCompletion$18$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_109#1;

  inline$BDLSystemPowerIoCompletion$18$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$18$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$18$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$18$myNondetVar_0, inline$BDLSystemPowerIoCompletion$18$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$18$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$18$anon50_Then#1, inline$BDLSystemPowerIoCompletion$18$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon29#1;

  inline$BDLSystemPowerIoCompletion$18$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_112#1;

  inline$BDLSystemPowerIoCompletion$18$label_112#1:
    inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$18$label_113#1;

  inline$BDLSystemPowerIoCompletion$18$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_113_true#1, inline$BDLSystemPowerIoCompletion$18$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$18$label_114#1;

  inline$BDLSystemPowerIoCompletion$18$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_116#1;

  inline$BDLSystemPowerIoCompletion$18$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_117#1;

  inline$BDLSystemPowerIoCompletion$18$label_117#1:
    goto inline$BDLGetDebugLevel$499$Entry#1;

  inline$BDLGetDebugLevel$499$Entry#1:
    goto inline$BDLGetDebugLevel$499$start#1;

  inline$BDLGetDebugLevel$499$start#1:
    goto inline$BDLGetDebugLevel$499$label_3#1;

  inline$BDLGetDebugLevel$499$label_3#1:
    havoc inline$BDLGetDebugLevel$499$myNondetVar_0;
    inline$BDLGetDebugLevel$499$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$499$myNondetVar_0;
    goto inline$BDLGetDebugLevel$499$label_1#1;

  inline$BDLGetDebugLevel$499$label_1#1:
    goto inline$BDLGetDebugLevel$499$Return#1;

  inline$BDLGetDebugLevel$499$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$499$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon51_Then#1, inline$BDLSystemPowerIoCompletion$18$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon31#1;

  inline$BDLSystemPowerIoCompletion$18$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_120#1;

  inline$BDLSystemPowerIoCompletion$18$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_120_true#1, inline$BDLSystemPowerIoCompletion$18$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_121#1;

  inline$BDLSystemPowerIoCompletion$18$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_124#1;

  inline$BDLSystemPowerIoCompletion$18$label_124#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_125#1;

  inline$BDLSystemPowerIoCompletion$18$label_125#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_126#1;

  inline$BDLSystemPowerIoCompletion$18$label_126#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_127#1;

  inline$BDLSystemPowerIoCompletion$18$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$18$label_121#1;

  inline$BDLSystemPowerIoCompletion$18$label_121#1:
    goto inline$BDLGetDebugLevel$500$Entry#1;

  inline$BDLGetDebugLevel$500$Entry#1:
    goto inline$BDLGetDebugLevel$500$start#1;

  inline$BDLGetDebugLevel$500$start#1:
    goto inline$BDLGetDebugLevel$500$label_3#1;

  inline$BDLGetDebugLevel$500$label_3#1:
    havoc inline$BDLGetDebugLevel$500$myNondetVar_0;
    inline$BDLGetDebugLevel$500$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$500$myNondetVar_0;
    goto inline$BDLGetDebugLevel$500$label_1#1;

  inline$BDLGetDebugLevel$500$label_1#1:
    goto inline$BDLGetDebugLevel$500$Return#1;

  inline$BDLGetDebugLevel$500$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$500$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon52_Then#1, inline$BDLSystemPowerIoCompletion$18$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon33#1;

  inline$BDLSystemPowerIoCompletion$18$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_130#1;

  inline$BDLSystemPowerIoCompletion$18$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_130_true#1, inline$BDLSystemPowerIoCompletion$18$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_131#1;

  inline$BDLSystemPowerIoCompletion$18$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_134#1;

  inline$BDLSystemPowerIoCompletion$18$label_134#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_135#1;

  inline$BDLSystemPowerIoCompletion$18$label_135#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_136#1;

  inline$BDLSystemPowerIoCompletion$18$label_136#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_137#1;

  inline$BDLSystemPowerIoCompletion$18$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$18$label_131#1;

  inline$BDLSystemPowerIoCompletion$18$label_131#1:
    goto inline$BDLGetDebugLevel$501$Entry#1;

  inline$BDLGetDebugLevel$501$Entry#1:
    goto inline$BDLGetDebugLevel$501$start#1;

  inline$BDLGetDebugLevel$501$start#1:
    goto inline$BDLGetDebugLevel$501$label_3#1;

  inline$BDLGetDebugLevel$501$label_3#1:
    havoc inline$BDLGetDebugLevel$501$myNondetVar_0;
    inline$BDLGetDebugLevel$501$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$501$myNondetVar_0;
    goto inline$BDLGetDebugLevel$501$label_1#1;

  inline$BDLGetDebugLevel$501$label_1#1:
    goto inline$BDLGetDebugLevel$501$Return#1;

  inline$BDLGetDebugLevel$501$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$501$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon53_Then#1, inline$BDLSystemPowerIoCompletion$18$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon35#1;

  inline$BDLSystemPowerIoCompletion$18$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_140#1;

  inline$BDLSystemPowerIoCompletion$18$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_140_true#1, inline$BDLSystemPowerIoCompletion$18$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_67#1;

  inline$BDLSystemPowerIoCompletion$18$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_141#1;

  inline$BDLSystemPowerIoCompletion$18$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_67#1;

  inline$BDLSystemPowerIoCompletion$18$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$18$label_115#1;

  inline$BDLSystemPowerIoCompletion$18$label_115#1:
    inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$18$label_80#1;

  inline$BDLSystemPowerIoCompletion$18$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$18$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_42#1;

  inline$BDLSystemPowerIoCompletion$18$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$18$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$18$label_43#1;

  inline$BDLSystemPowerIoCompletion$18$label_43#1:
    goto inline$BDLGetDebugLevel$493$Entry#1;

  inline$BDLGetDebugLevel$493$Entry#1:
    goto inline$BDLGetDebugLevel$493$start#1;

  inline$BDLGetDebugLevel$493$start#1:
    goto inline$BDLGetDebugLevel$493$label_3#1;

  inline$BDLGetDebugLevel$493$label_3#1:
    havoc inline$BDLGetDebugLevel$493$myNondetVar_0;
    inline$BDLGetDebugLevel$493$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$493$myNondetVar_0;
    goto inline$BDLGetDebugLevel$493$label_1#1;

  inline$BDLGetDebugLevel$493$label_1#1:
    goto inline$BDLGetDebugLevel$493$Return#1;

  inline$BDLGetDebugLevel$493$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$493$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon40_Then#1, inline$BDLSystemPowerIoCompletion$18$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon9#1;

  inline$BDLSystemPowerIoCompletion$18$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_46#1;

  inline$BDLSystemPowerIoCompletion$18$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_46_true#1, inline$BDLSystemPowerIoCompletion$18$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_47#1;

  inline$BDLSystemPowerIoCompletion$18$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_50#1;

  inline$BDLSystemPowerIoCompletion$18$label_50#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_51#1;

  inline$BDLSystemPowerIoCompletion$18$label_51#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_52#1;

  inline$BDLSystemPowerIoCompletion$18$label_52#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_53#1;

  inline$BDLSystemPowerIoCompletion$18$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$18$label_47#1;

  inline$BDLSystemPowerIoCompletion$18$label_47#1:
    goto inline$BDLGetDebugLevel$494$Entry#1;

  inline$BDLGetDebugLevel$494$Entry#1:
    goto inline$BDLGetDebugLevel$494$start#1;

  inline$BDLGetDebugLevel$494$start#1:
    goto inline$BDLGetDebugLevel$494$label_3#1;

  inline$BDLGetDebugLevel$494$label_3#1:
    havoc inline$BDLGetDebugLevel$494$myNondetVar_0;
    inline$BDLGetDebugLevel$494$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$494$myNondetVar_0;
    goto inline$BDLGetDebugLevel$494$label_1#1;

  inline$BDLGetDebugLevel$494$label_1#1:
    goto inline$BDLGetDebugLevel$494$Return#1;

  inline$BDLGetDebugLevel$494$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$494$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon41_Then#1, inline$BDLSystemPowerIoCompletion$18$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon11#1;

  inline$BDLSystemPowerIoCompletion$18$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_56#1;

  inline$BDLSystemPowerIoCompletion$18$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_56_true#1, inline$BDLSystemPowerIoCompletion$18$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_57#1;

  inline$BDLSystemPowerIoCompletion$18$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_60#1;

  inline$BDLSystemPowerIoCompletion$18$label_60#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_61#1;

  inline$BDLSystemPowerIoCompletion$18$label_61#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_62#1;

  inline$BDLSystemPowerIoCompletion$18$label_62#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_63#1;

  inline$BDLSystemPowerIoCompletion$18$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$18$label_57#1;

  inline$BDLSystemPowerIoCompletion$18$label_57#1:
    goto inline$BDLGetDebugLevel$495$Entry#1;

  inline$BDLGetDebugLevel$495$Entry#1:
    goto inline$BDLGetDebugLevel$495$start#1;

  inline$BDLGetDebugLevel$495$start#1:
    goto inline$BDLGetDebugLevel$495$label_3#1;

  inline$BDLGetDebugLevel$495$label_3#1:
    havoc inline$BDLGetDebugLevel$495$myNondetVar_0;
    inline$BDLGetDebugLevel$495$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$495$myNondetVar_0;
    goto inline$BDLGetDebugLevel$495$label_1#1;

  inline$BDLGetDebugLevel$495$label_1#1:
    goto inline$BDLGetDebugLevel$495$Return#1;

  inline$BDLGetDebugLevel$495$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$495$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon42_Then#1, inline$BDLSystemPowerIoCompletion$18$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon13#1;

  inline$BDLSystemPowerIoCompletion$18$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_66#1;

  inline$BDLSystemPowerIoCompletion$18$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_66_true#1, inline$BDLSystemPowerIoCompletion$18$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_67#1;

  inline$BDLSystemPowerIoCompletion$18$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_70#1;

  inline$BDLSystemPowerIoCompletion$18$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_67#1;

  inline$BDLSystemPowerIoCompletion$18$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$18$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$18$anon43_Then#1, inline$BDLSystemPowerIoCompletion$18$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon15#1;

  inline$BDLSystemPowerIoCompletion$18$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_71#1;

  inline$BDLSystemPowerIoCompletion$18$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$18$anon44_Then#1, inline$BDLSystemPowerIoCompletion$18$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon17#1;

  inline$BDLSystemPowerIoCompletion$18$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_74#1;

  inline$BDLSystemPowerIoCompletion$18$label_74#1:
    goto inline$storm_IoCompleteRequest$38$Entry#1;

  inline$storm_IoCompleteRequest$38$Entry#1:
    inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$18$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$38$start#1;

  inline$storm_IoCompleteRequest$38$start#1:
    inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$38$label_3#1;

  inline$storm_IoCompleteRequest$38$label_3#1:
    call inline$storm_IoCompleteRequest$38$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$38$label_6#1;

  inline$storm_IoCompleteRequest$38$label_6#1:
    goto inline$storm_IoCompleteRequest$38$label_6_true#1, inline$storm_IoCompleteRequest$38$label_6_false#1;

  inline$storm_IoCompleteRequest$38$label_6_false#1:
    assume inline$storm_IoCompleteRequest$38$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$38$label_7#1;

  inline$storm_IoCompleteRequest$38$label_6_true#1:
    assume inline$storm_IoCompleteRequest$38$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$38$label_8#1;

  inline$storm_IoCompleteRequest$38$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$38$anon3_Then#1, inline$storm_IoCompleteRequest$38$anon3_Else#1;

  inline$storm_IoCompleteRequest$38$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$38$anon1#1;

  inline$storm_IoCompleteRequest$38$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$38$label_9#1;

  inline$storm_IoCompleteRequest$38$label_9#1:
    goto inline$storm_IoCompleteRequest$38$label_9_true#1, inline$storm_IoCompleteRequest$38$label_9_false#1;

  inline$storm_IoCompleteRequest$38$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$38$label_10#1;

  inline$storm_IoCompleteRequest$38$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$38$label_1#1;

  inline$storm_IoCompleteRequest$38$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$38$label_7#1;

  inline$storm_IoCompleteRequest$38$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$38$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$38$label_1#1;

  inline$storm_IoCompleteRequest$38$label_1#1:
    goto inline$storm_IoCompleteRequest$38$Return#1;

  inline$storm_IoCompleteRequest$38$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$38$Return#1;

  inline$storm_IoCompleteRequest$38$Return#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon45_Then#1, inline$BDLSystemPowerIoCompletion$18$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon19#1;

  inline$BDLSystemPowerIoCompletion$18$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_77#1;

  inline$BDLSystemPowerIoCompletion$18$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$18$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$18$anon46_Then#1, inline$BDLSystemPowerIoCompletion$18$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon21#1;

  inline$BDLSystemPowerIoCompletion$18$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_80#1;

  inline$BDLSystemPowerIoCompletion$18$label_80#1:
    goto inline$BDLGetDebugLevel$496$Entry#1;

  inline$BDLGetDebugLevel$496$Entry#1:
    goto inline$BDLGetDebugLevel$496$start#1;

  inline$BDLGetDebugLevel$496$start#1:
    goto inline$BDLGetDebugLevel$496$label_3#1;

  inline$BDLGetDebugLevel$496$label_3#1:
    havoc inline$BDLGetDebugLevel$496$myNondetVar_0;
    inline$BDLGetDebugLevel$496$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$496$myNondetVar_0;
    goto inline$BDLGetDebugLevel$496$label_1#1;

  inline$BDLGetDebugLevel$496$label_1#1:
    goto inline$BDLGetDebugLevel$496$Return#1;

  inline$BDLGetDebugLevel$496$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$496$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon47_Then#1, inline$BDLSystemPowerIoCompletion$18$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon23#1;

  inline$BDLSystemPowerIoCompletion$18$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_83#1;

  inline$BDLSystemPowerIoCompletion$18$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_83_true#1, inline$BDLSystemPowerIoCompletion$18$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_84#1;

  inline$BDLSystemPowerIoCompletion$18$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_87#1;

  inline$BDLSystemPowerIoCompletion$18$label_87#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_88#1;

  inline$BDLSystemPowerIoCompletion$18$label_88#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_89#1;

  inline$BDLSystemPowerIoCompletion$18$label_89#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_90#1;

  inline$BDLSystemPowerIoCompletion$18$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$18$label_84#1;

  inline$BDLSystemPowerIoCompletion$18$label_84#1:
    goto inline$BDLGetDebugLevel$497$Entry#1;

  inline$BDLGetDebugLevel$497$Entry#1:
    goto inline$BDLGetDebugLevel$497$start#1;

  inline$BDLGetDebugLevel$497$start#1:
    goto inline$BDLGetDebugLevel$497$label_3#1;

  inline$BDLGetDebugLevel$497$label_3#1:
    havoc inline$BDLGetDebugLevel$497$myNondetVar_0;
    inline$BDLGetDebugLevel$497$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$497$myNondetVar_0;
    goto inline$BDLGetDebugLevel$497$label_1#1;

  inline$BDLGetDebugLevel$497$label_1#1:
    goto inline$BDLGetDebugLevel$497$Return#1;

  inline$BDLGetDebugLevel$497$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$497$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon48_Then#1, inline$BDLSystemPowerIoCompletion$18$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon25#1;

  inline$BDLSystemPowerIoCompletion$18$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_93#1;

  inline$BDLSystemPowerIoCompletion$18$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_93_true#1, inline$BDLSystemPowerIoCompletion$18$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_94#1;

  inline$BDLSystemPowerIoCompletion$18$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_97#1;

  inline$BDLSystemPowerIoCompletion$18$label_97#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_98#1;

  inline$BDLSystemPowerIoCompletion$18$label_98#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_99#1;

  inline$BDLSystemPowerIoCompletion$18$label_99#1:
    call inline$BDLSystemPowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$18$label_100#1;

  inline$BDLSystemPowerIoCompletion$18$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$18$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$18$label_94#1;

  inline$BDLSystemPowerIoCompletion$18$label_94#1:
    goto inline$BDLGetDebugLevel$498$Entry#1;

  inline$BDLGetDebugLevel$498$Entry#1:
    goto inline$BDLGetDebugLevel$498$start#1;

  inline$BDLGetDebugLevel$498$start#1:
    goto inline$BDLGetDebugLevel$498$label_3#1;

  inline$BDLGetDebugLevel$498$label_3#1:
    havoc inline$BDLGetDebugLevel$498$myNondetVar_0;
    inline$BDLGetDebugLevel$498$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$498$myNondetVar_0;
    goto inline$BDLGetDebugLevel$498$label_1#1;

  inline$BDLGetDebugLevel$498$label_1#1:
    goto inline$BDLGetDebugLevel$498$Return#1;

  inline$BDLGetDebugLevel$498$Return#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$498$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$18$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$18$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$18$anon49_Then#1, inline$BDLSystemPowerIoCompletion$18$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$18$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$anon27#1;

  inline$BDLSystemPowerIoCompletion$18$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_103#1;

  inline$BDLSystemPowerIoCompletion$18$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_103_true#1, inline$BDLSystemPowerIoCompletion$18$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$18$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_104#1;

  inline$BDLSystemPowerIoCompletion$18$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$18$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$18$label_105#1;

  inline$BDLSystemPowerIoCompletion$18$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$18$label_104#1;

  inline$BDLSystemPowerIoCompletion$18$label_104#1:
    inline$BDLSystemPowerIoCompletion$18$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$18$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$18$label_1#1;

  inline$BDLSystemPowerIoCompletion$18$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$18$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$18$Return#1;

  inline$BDLSystemPowerIoCompletion$18$Return#1:
    inline$CallCompletionRoutine$18$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$18$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$18$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$18$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$18$anon14_Then#1, inline$CallCompletionRoutine$18$anon14_Else#1;

  inline$CallCompletionRoutine$18$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$18$anon9#1;

  inline$CallCompletionRoutine$18$anon9#1:
    goto inline$CallCompletionRoutine$18$label_20_icall_return#1;

  inline$CallCompletionRoutine$18$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$18$Return#1;

  inline$CallCompletionRoutine$18$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$18$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$18$Entry#1;

  inline$BDLDevicePowerIoCompletion$18$Entry#1:
    inline$BDLDevicePowerIoCompletion$18$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$18$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$18$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$18$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$18$start#1;

  inline$BDLDevicePowerIoCompletion$18$start#1:
    call inline$BDLDevicePowerIoCompletion$18$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$18$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$18$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$18$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$18$label_3#1;

  inline$BDLDevicePowerIoCompletion$18$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_4#1;

  inline$BDLDevicePowerIoCompletion$18$label_4#1:
    inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_5#1;

  inline$BDLDevicePowerIoCompletion$18$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_6#1;

  inline$BDLDevicePowerIoCompletion$18$label_6#1:
    inline$BDLDevicePowerIoCompletion$18$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$18$label_7#1;

  inline$BDLDevicePowerIoCompletion$18$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_8#1;

  inline$BDLDevicePowerIoCompletion$18$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$18$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$18$label_9#1;

  inline$BDLDevicePowerIoCompletion$18$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_10#1;

  inline$BDLDevicePowerIoCompletion$18$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$97$Entry#1;

  inline$IoGetCurrentIrpStackLocation$97$Entry#1:
    inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$97$start#1;

  inline$IoGetCurrentIrpStackLocation$97$start#1:
    inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$97$label_3#1;

  inline$IoGetCurrentIrpStackLocation$97$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$97$label_3_true#1, inline$IoGetCurrentIrpStackLocation$97$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$97$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$97$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$97$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$97$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$97$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$97$label_4#1;

  inline$IoGetCurrentIrpStackLocation$97$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$97$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$97$label_6#1;

  inline$IoGetCurrentIrpStackLocation$97$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$97$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$97$label_7#1;

  inline$IoGetCurrentIrpStackLocation$97$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$97$label_5#1;

  inline$IoGetCurrentIrpStackLocation$97$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$97$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$97$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$97$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$97$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$97$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$97$label_5#1;

  inline$IoGetCurrentIrpStackLocation$97$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$97$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$97$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$97$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$97$label_1#1;

  inline$IoGetCurrentIrpStackLocation$97$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$97$Return#1;

  inline$IoGetCurrentIrpStackLocation$97$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$97$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon30_Then#1, inline$BDLDevicePowerIoCompletion$18$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon1#1;

  inline$BDLDevicePowerIoCompletion$18$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_13#1;

  inline$BDLDevicePowerIoCompletion$18$label_13#1:
    inline$BDLDevicePowerIoCompletion$18$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$18$label_14#1;

  inline$BDLDevicePowerIoCompletion$18$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_15#1;

  inline$BDLDevicePowerIoCompletion$18$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$18$label_16#1;

  inline$BDLDevicePowerIoCompletion$18$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_17#1;

  inline$BDLDevicePowerIoCompletion$18$label_17#1:
    goto inline$BDLGetDebugLevel$481$Entry#1;

  inline$BDLGetDebugLevel$481$Entry#1:
    goto inline$BDLGetDebugLevel$481$start#1;

  inline$BDLGetDebugLevel$481$start#1:
    goto inline$BDLGetDebugLevel$481$label_3#1;

  inline$BDLGetDebugLevel$481$label_3#1:
    havoc inline$BDLGetDebugLevel$481$myNondetVar_0;
    inline$BDLGetDebugLevel$481$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$481$myNondetVar_0;
    goto inline$BDLGetDebugLevel$481$label_1#1;

  inline$BDLGetDebugLevel$481$label_1#1:
    goto inline$BDLGetDebugLevel$481$Return#1;

  inline$BDLGetDebugLevel$481$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$481$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon31_Then#1, inline$BDLDevicePowerIoCompletion$18$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon3#1;

  inline$BDLDevicePowerIoCompletion$18$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_20#1;

  inline$BDLDevicePowerIoCompletion$18$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_20_true#1, inline$BDLDevicePowerIoCompletion$18$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_21#1;

  inline$BDLDevicePowerIoCompletion$18$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_24#1;

  inline$BDLDevicePowerIoCompletion$18$label_24#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_25#1;

  inline$BDLDevicePowerIoCompletion$18$label_25#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_26#1;

  inline$BDLDevicePowerIoCompletion$18$label_26#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_27#1;

  inline$BDLDevicePowerIoCompletion$18$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$18$label_21#1;

  inline$BDLDevicePowerIoCompletion$18$label_21#1:
    goto inline$BDLGetDebugLevel$482$Entry#1;

  inline$BDLGetDebugLevel$482$Entry#1:
    goto inline$BDLGetDebugLevel$482$start#1;

  inline$BDLGetDebugLevel$482$start#1:
    goto inline$BDLGetDebugLevel$482$label_3#1;

  inline$BDLGetDebugLevel$482$label_3#1:
    havoc inline$BDLGetDebugLevel$482$myNondetVar_0;
    inline$BDLGetDebugLevel$482$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$482$myNondetVar_0;
    goto inline$BDLGetDebugLevel$482$label_1#1;

  inline$BDLGetDebugLevel$482$label_1#1:
    goto inline$BDLGetDebugLevel$482$Return#1;

  inline$BDLGetDebugLevel$482$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$482$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon32_Then#1, inline$BDLDevicePowerIoCompletion$18$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon5#1;

  inline$BDLDevicePowerIoCompletion$18$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_30#1;

  inline$BDLDevicePowerIoCompletion$18$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_30_true#1, inline$BDLDevicePowerIoCompletion$18$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_31#1;

  inline$BDLDevicePowerIoCompletion$18$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_34#1;

  inline$BDLDevicePowerIoCompletion$18$label_34#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_35#1;

  inline$BDLDevicePowerIoCompletion$18$label_35#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_36#1;

  inline$BDLDevicePowerIoCompletion$18$label_36#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_37#1;

  inline$BDLDevicePowerIoCompletion$18$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$18$label_31#1;

  inline$BDLDevicePowerIoCompletion$18$label_31#1:
    goto inline$BDLGetDebugLevel$483$Entry#1;

  inline$BDLGetDebugLevel$483$Entry#1:
    goto inline$BDLGetDebugLevel$483$start#1;

  inline$BDLGetDebugLevel$483$start#1:
    goto inline$BDLGetDebugLevel$483$label_3#1;

  inline$BDLGetDebugLevel$483$label_3#1:
    havoc inline$BDLGetDebugLevel$483$myNondetVar_0;
    inline$BDLGetDebugLevel$483$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$483$myNondetVar_0;
    goto inline$BDLGetDebugLevel$483$label_1#1;

  inline$BDLGetDebugLevel$483$label_1#1:
    goto inline$BDLGetDebugLevel$483$Return#1;

  inline$BDLGetDebugLevel$483$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$483$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon33_Then#1, inline$BDLDevicePowerIoCompletion$18$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon7#1;

  inline$BDLDevicePowerIoCompletion$18$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_40#1;

  inline$BDLDevicePowerIoCompletion$18$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_40_true#1, inline$BDLDevicePowerIoCompletion$18$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_41#1;

  inline$BDLDevicePowerIoCompletion$18$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_42#1;

  inline$BDLDevicePowerIoCompletion$18$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_41#1;

  inline$BDLDevicePowerIoCompletion$18$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_41_true#1, inline$BDLDevicePowerIoCompletion$18$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$18$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$18$label_43#1;

  inline$BDLDevicePowerIoCompletion$18$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$18$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$18$label_44#1;

  inline$BDLDevicePowerIoCompletion$18$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_44_true#1, inline$BDLDevicePowerIoCompletion$18$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$18$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$18$label_45#1;

  inline$BDLDevicePowerIoCompletion$18$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_45_true#1, inline$BDLDevicePowerIoCompletion$18$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$18$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$18$label_43#1;

  inline$BDLDevicePowerIoCompletion$18$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$18$label_86#1;

  inline$BDLDevicePowerIoCompletion$18$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$18$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$18$label_46#1;

  inline$BDLDevicePowerIoCompletion$18$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$18$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$18$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$18$label_46#1;

  inline$BDLDevicePowerIoCompletion$18$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$18$label_49#1;

  inline$BDLDevicePowerIoCompletion$18$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_50#1;

  inline$BDLDevicePowerIoCompletion$18$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_51#1;

  inline$BDLDevicePowerIoCompletion$18$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_54#1;

  inline$BDLDevicePowerIoCompletion$18$label_54#1:
    inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$18$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$18$label_55#1;

  inline$BDLDevicePowerIoCompletion$18$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_55_true#1, inline$BDLDevicePowerIoCompletion$18$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_56#1;

  inline$BDLDevicePowerIoCompletion$18$label_56#1:
    call inline$BDLDevicePowerIoCompletion$18$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$18$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$18$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$18$anon34_Then#1, inline$BDLDevicePowerIoCompletion$18$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon9#1;

  inline$BDLDevicePowerIoCompletion$18$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_83#1;

  inline$BDLDevicePowerIoCompletion$18$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_59#1;

  inline$BDLDevicePowerIoCompletion$18$label_59#1:
    goto inline$BDLGetDebugLevel$484$Entry#1;

  inline$BDLGetDebugLevel$484$Entry#1:
    goto inline$BDLGetDebugLevel$484$start#1;

  inline$BDLGetDebugLevel$484$start#1:
    goto inline$BDLGetDebugLevel$484$label_3#1;

  inline$BDLGetDebugLevel$484$label_3#1:
    havoc inline$BDLGetDebugLevel$484$myNondetVar_0;
    inline$BDLGetDebugLevel$484$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$484$myNondetVar_0;
    goto inline$BDLGetDebugLevel$484$label_1#1;

  inline$BDLGetDebugLevel$484$label_1#1:
    goto inline$BDLGetDebugLevel$484$Return#1;

  inline$BDLGetDebugLevel$484$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$484$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon35_Then#1, inline$BDLDevicePowerIoCompletion$18$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon11#1;

  inline$BDLDevicePowerIoCompletion$18$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_62#1;

  inline$BDLDevicePowerIoCompletion$18$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_62_true#1, inline$BDLDevicePowerIoCompletion$18$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_63#1;

  inline$BDLDevicePowerIoCompletion$18$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_66#1;

  inline$BDLDevicePowerIoCompletion$18$label_66#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_67#1;

  inline$BDLDevicePowerIoCompletion$18$label_67#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_68#1;

  inline$BDLDevicePowerIoCompletion$18$label_68#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_69#1;

  inline$BDLDevicePowerIoCompletion$18$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$18$label_63#1;

  inline$BDLDevicePowerIoCompletion$18$label_63#1:
    goto inline$BDLGetDebugLevel$485$Entry#1;

  inline$BDLGetDebugLevel$485$Entry#1:
    goto inline$BDLGetDebugLevel$485$start#1;

  inline$BDLGetDebugLevel$485$start#1:
    goto inline$BDLGetDebugLevel$485$label_3#1;

  inline$BDLGetDebugLevel$485$label_3#1:
    havoc inline$BDLGetDebugLevel$485$myNondetVar_0;
    inline$BDLGetDebugLevel$485$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$485$myNondetVar_0;
    goto inline$BDLGetDebugLevel$485$label_1#1;

  inline$BDLGetDebugLevel$485$label_1#1:
    goto inline$BDLGetDebugLevel$485$Return#1;

  inline$BDLGetDebugLevel$485$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$485$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon36_Then#1, inline$BDLDevicePowerIoCompletion$18$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon13#1;

  inline$BDLDevicePowerIoCompletion$18$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_72#1;

  inline$BDLDevicePowerIoCompletion$18$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_72_true#1, inline$BDLDevicePowerIoCompletion$18$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_73#1;

  inline$BDLDevicePowerIoCompletion$18$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_76#1;

  inline$BDLDevicePowerIoCompletion$18$label_76#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_77#1;

  inline$BDLDevicePowerIoCompletion$18$label_77#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_78#1;

  inline$BDLDevicePowerIoCompletion$18$label_78#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_79#1;

  inline$BDLDevicePowerIoCompletion$18$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$18$label_73#1;

  inline$BDLDevicePowerIoCompletion$18$label_73#1:
    goto inline$BDLGetDebugLevel$486$Entry#1;

  inline$BDLGetDebugLevel$486$Entry#1:
    goto inline$BDLGetDebugLevel$486$start#1;

  inline$BDLGetDebugLevel$486$start#1:
    goto inline$BDLGetDebugLevel$486$label_3#1;

  inline$BDLGetDebugLevel$486$label_3#1:
    havoc inline$BDLGetDebugLevel$486$myNondetVar_0;
    inline$BDLGetDebugLevel$486$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$486$myNondetVar_0;
    goto inline$BDLGetDebugLevel$486$label_1#1;

  inline$BDLGetDebugLevel$486$label_1#1:
    goto inline$BDLGetDebugLevel$486$Return#1;

  inline$BDLGetDebugLevel$486$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$486$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon37_Then#1, inline$BDLDevicePowerIoCompletion$18$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon15#1;

  inline$BDLDevicePowerIoCompletion$18$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_82#1;

  inline$BDLDevicePowerIoCompletion$18$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_82_true#1, inline$BDLDevicePowerIoCompletion$18$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_83#1;

  inline$BDLDevicePowerIoCompletion$18$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_84#1;

  inline$BDLDevicePowerIoCompletion$18$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_83#1;

  inline$BDLDevicePowerIoCompletion$18$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_85#1;

  inline$BDLDevicePowerIoCompletion$18$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_86#1;

  inline$BDLDevicePowerIoCompletion$18$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$18$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$18$anon38_Then#1, inline$BDLDevicePowerIoCompletion$18$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon17#1;

  inline$BDLDevicePowerIoCompletion$18$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_89#1;

  inline$BDLDevicePowerIoCompletion$18$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$18$anon39_Then#1, inline$BDLDevicePowerIoCompletion$18$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon19#1;

  inline$BDLDevicePowerIoCompletion$18$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_92#1;

  inline$BDLDevicePowerIoCompletion$18$label_92#1:
    goto inline$storm_IoCompleteRequest$37$Entry#1;

  inline$storm_IoCompleteRequest$37$Entry#1:
    inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$18$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$37$start#1;

  inline$storm_IoCompleteRequest$37$start#1:
    inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$37$label_3#1;

  inline$storm_IoCompleteRequest$37$label_3#1:
    call inline$storm_IoCompleteRequest$37$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$37$label_6#1;

  inline$storm_IoCompleteRequest$37$label_6#1:
    goto inline$storm_IoCompleteRequest$37$label_6_true#1, inline$storm_IoCompleteRequest$37$label_6_false#1;

  inline$storm_IoCompleteRequest$37$label_6_false#1:
    assume inline$storm_IoCompleteRequest$37$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$37$label_7#1;

  inline$storm_IoCompleteRequest$37$label_6_true#1:
    assume inline$storm_IoCompleteRequest$37$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$37$label_8#1;

  inline$storm_IoCompleteRequest$37$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$37$anon3_Then#1, inline$storm_IoCompleteRequest$37$anon3_Else#1;

  inline$storm_IoCompleteRequest$37$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$37$anon1#1;

  inline$storm_IoCompleteRequest$37$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$37$label_9#1;

  inline$storm_IoCompleteRequest$37$label_9#1:
    goto inline$storm_IoCompleteRequest$37$label_9_true#1, inline$storm_IoCompleteRequest$37$label_9_false#1;

  inline$storm_IoCompleteRequest$37$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$37$label_10#1;

  inline$storm_IoCompleteRequest$37$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$37$label_1#1;

  inline$storm_IoCompleteRequest$37$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$37$label_7#1;

  inline$storm_IoCompleteRequest$37$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$37$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$37$label_1#1;

  inline$storm_IoCompleteRequest$37$label_1#1:
    goto inline$storm_IoCompleteRequest$37$Return#1;

  inline$storm_IoCompleteRequest$37$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$37$Return#1;

  inline$storm_IoCompleteRequest$37$Return#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon40_Then#1, inline$BDLDevicePowerIoCompletion$18$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon21#1;

  inline$BDLDevicePowerIoCompletion$18$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_95#1;

  inline$BDLDevicePowerIoCompletion$18$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$18$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$18$anon41_Then#1, inline$BDLDevicePowerIoCompletion$18$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon23#1;

  inline$BDLDevicePowerIoCompletion$18$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_98#1;

  inline$BDLDevicePowerIoCompletion$18$label_98#1:
    goto inline$BDLGetDebugLevel$487$Entry#1;

  inline$BDLGetDebugLevel$487$Entry#1:
    goto inline$BDLGetDebugLevel$487$start#1;

  inline$BDLGetDebugLevel$487$start#1:
    goto inline$BDLGetDebugLevel$487$label_3#1;

  inline$BDLGetDebugLevel$487$label_3#1:
    havoc inline$BDLGetDebugLevel$487$myNondetVar_0;
    inline$BDLGetDebugLevel$487$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$487$myNondetVar_0;
    goto inline$BDLGetDebugLevel$487$label_1#1;

  inline$BDLGetDebugLevel$487$label_1#1:
    goto inline$BDLGetDebugLevel$487$Return#1;

  inline$BDLGetDebugLevel$487$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$487$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon42_Then#1, inline$BDLDevicePowerIoCompletion$18$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon25#1;

  inline$BDLDevicePowerIoCompletion$18$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_101#1;

  inline$BDLDevicePowerIoCompletion$18$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_101_true#1, inline$BDLDevicePowerIoCompletion$18$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_102#1;

  inline$BDLDevicePowerIoCompletion$18$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_105#1;

  inline$BDLDevicePowerIoCompletion$18$label_105#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_106#1;

  inline$BDLDevicePowerIoCompletion$18$label_106#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_107#1;

  inline$BDLDevicePowerIoCompletion$18$label_107#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_108#1;

  inline$BDLDevicePowerIoCompletion$18$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$18$label_102#1;

  inline$BDLDevicePowerIoCompletion$18$label_102#1:
    goto inline$BDLGetDebugLevel$488$Entry#1;

  inline$BDLGetDebugLevel$488$Entry#1:
    goto inline$BDLGetDebugLevel$488$start#1;

  inline$BDLGetDebugLevel$488$start#1:
    goto inline$BDLGetDebugLevel$488$label_3#1;

  inline$BDLGetDebugLevel$488$label_3#1:
    havoc inline$BDLGetDebugLevel$488$myNondetVar_0;
    inline$BDLGetDebugLevel$488$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$488$myNondetVar_0;
    goto inline$BDLGetDebugLevel$488$label_1#1;

  inline$BDLGetDebugLevel$488$label_1#1:
    goto inline$BDLGetDebugLevel$488$Return#1;

  inline$BDLGetDebugLevel$488$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$488$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon43_Then#1, inline$BDLDevicePowerIoCompletion$18$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon27#1;

  inline$BDLDevicePowerIoCompletion$18$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_111#1;

  inline$BDLDevicePowerIoCompletion$18$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_111_true#1, inline$BDLDevicePowerIoCompletion$18$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_112#1;

  inline$BDLDevicePowerIoCompletion$18$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_115#1;

  inline$BDLDevicePowerIoCompletion$18$label_115#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_116#1;

  inline$BDLDevicePowerIoCompletion$18$label_116#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_117#1;

  inline$BDLDevicePowerIoCompletion$18$label_117#1:
    call inline$BDLDevicePowerIoCompletion$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$18$label_118#1;

  inline$BDLDevicePowerIoCompletion$18$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$18$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$18$label_112#1;

  inline$BDLDevicePowerIoCompletion$18$label_112#1:
    goto inline$BDLGetDebugLevel$489$Entry#1;

  inline$BDLGetDebugLevel$489$Entry#1:
    goto inline$BDLGetDebugLevel$489$start#1;

  inline$BDLGetDebugLevel$489$start#1:
    goto inline$BDLGetDebugLevel$489$label_3#1;

  inline$BDLGetDebugLevel$489$label_3#1:
    havoc inline$BDLGetDebugLevel$489$myNondetVar_0;
    inline$BDLGetDebugLevel$489$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$489$myNondetVar_0;
    goto inline$BDLGetDebugLevel$489$label_1#1;

  inline$BDLGetDebugLevel$489$label_1#1:
    goto inline$BDLGetDebugLevel$489$Return#1;

  inline$BDLGetDebugLevel$489$Return#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$489$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$18$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$18$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$18$anon44_Then#1, inline$BDLDevicePowerIoCompletion$18$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$18$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$anon29#1;

  inline$BDLDevicePowerIoCompletion$18$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_121#1;

  inline$BDLDevicePowerIoCompletion$18$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_121_true#1, inline$BDLDevicePowerIoCompletion$18$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$18$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_122#1;

  inline$BDLDevicePowerIoCompletion$18$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$18$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$18$label_123#1;

  inline$BDLDevicePowerIoCompletion$18$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$18$label_122#1;

  inline$BDLDevicePowerIoCompletion$18$label_122#1:
    inline$BDLDevicePowerIoCompletion$18$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$18$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$18$label_1#1;

  inline$BDLDevicePowerIoCompletion$18$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$18$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$18$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$18$Return#1;

  inline$BDLDevicePowerIoCompletion$18$Return#1:
    inline$CallCompletionRoutine$18$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$18$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$18$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$18$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$18$anon13_Then#1, inline$CallCompletionRoutine$18$anon13_Else#1;

  inline$CallCompletionRoutine$18$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$18$anon7#1;

  inline$CallCompletionRoutine$18$anon7#1:
    goto inline$CallCompletionRoutine$18$label_20_icall_return#1;

  inline$CallCompletionRoutine$18$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$18$Return#1;

  inline$CallCompletionRoutine$18$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$18$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$18$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$18$Entry#1;

  inline$BDLCallDriverCompletionRoutine$18$Entry#1:
    inline$BDLCallDriverCompletionRoutine$18$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$18$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$18$start#1;

  inline$BDLCallDriverCompletionRoutine$18$start#1:
    inline$BDLCallDriverCompletionRoutine$18$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$18$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$18$label_3#1;

  inline$BDLCallDriverCompletionRoutine$18$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$18$label_3_true#1, inline$BDLCallDriverCompletionRoutine$18$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$18$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$18$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$18$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$18$label_4#1;

  inline$BDLCallDriverCompletionRoutine$18$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$18$label_6#1;

  inline$BDLCallDriverCompletionRoutine$18$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$18$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$18$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$18$label_5#1;

  inline$BDLCallDriverCompletionRoutine$18$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$18$label_6#1;

  inline$BDLCallDriverCompletionRoutine$18$label_6#1:
    goto inline$storm_KeSetEvent$20$Entry#1;

  inline$storm_KeSetEvent$20$Entry#1:
    inline$storm_KeSetEvent$20$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$18$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$20$start#1;

  inline$storm_KeSetEvent$20$start#1:
    inline$storm_KeSetEvent$20$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$20$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$20$label_3#1;

  inline$storm_KeSetEvent$20$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$20$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$20$label_1#1;

  inline$storm_KeSetEvent$20$label_1#1:
    goto inline$storm_KeSetEvent$20$Return#1;

  inline$storm_KeSetEvent$20$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$18$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$18$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$18$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$18$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$18$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$18$anon1#1;

  inline$BDLCallDriverCompletionRoutine$18$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$18$label_9#1;

  inline$BDLCallDriverCompletionRoutine$18$label_9#1:
    inline$BDLCallDriverCompletionRoutine$18$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$18$label_1#1;

  inline$BDLCallDriverCompletionRoutine$18$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$18$Return#1;

  inline$BDLCallDriverCompletionRoutine$18$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$18$Return#1;

  inline$BDLCallDriverCompletionRoutine$18$Return#1:
    inline$CallCompletionRoutine$18$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$18$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$18$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$18$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$18$anon12_Then#1, inline$CallCompletionRoutine$18$anon12_Else#1;

  inline$CallCompletionRoutine$18$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$18$anon5#1;

  inline$CallCompletionRoutine$18$anon5#1:
    goto inline$CallCompletionRoutine$18$label_20_icall_return#1;

  inline$CallCompletionRoutine$18$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$18$label_23#1;

  inline$CallCompletionRoutine$18$label_23#1:
    inline$CallCompletionRoutine$18$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$18$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$18$label_24#1;

  inline$CallCompletionRoutine$18$label_24#1:
    goto inline$CallCompletionRoutine$18$label_24_true#1, inline$CallCompletionRoutine$18$label_24_false#1;

  inline$CallCompletionRoutine$18$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$18$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$18$label_1#1;

  inline$CallCompletionRoutine$18$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$18$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$18$label_25#1;

  inline$CallCompletionRoutine$18$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$18$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$18$label_1#1;

  inline$CallCompletionRoutine$18$label_1#1:
    goto inline$CallCompletionRoutine$18$Return#1;

  inline$CallCompletionRoutine$18$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$18$Return#1;

  inline$CallCompletionRoutine$18$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$18$Return#1;

  inline$CallCompletionRoutine$18$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$18$Return#1;

  inline$CallCompletionRoutine$18$Return#1:
    goto inline$storm_IoCallDriver$9$label_33$1#1;

  inline$storm_IoCallDriver$9$label_33$1#1:
    goto inline$storm_IoCallDriver$9$anon14_Then#1, inline$storm_IoCallDriver$9$anon14_Else#1;

  inline$storm_IoCallDriver$9$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$9$anon8#1;

  inline$storm_IoCallDriver$9$anon8#1:
    goto inline$storm_IoCallDriver$9$label_36#1;

  inline$storm_IoCallDriver$9$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$9$Return#1;

  inline$storm_IoCallDriver$9$label_27_case_1#1:
    assume inline$storm_IoCallDriver$9$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$9$label_29#1;

  inline$storm_IoCallDriver$9$label_29#1:
    inline$storm_IoCallDriver$9$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$9$label_37#1;

  inline$storm_IoCallDriver$9$label_37#1:
    goto inline$storm_IoCallDriver$9$label_38#1;

  inline$storm_IoCallDriver$9$label_38#1:
    goto inline$storm_IoCallDriver$9$label_39#1;

  inline$storm_IoCallDriver$9$label_39#1:
    goto inline$CallCompletionRoutine$19$Entry#1;

  inline$CallCompletionRoutine$19$Entry#1:
    inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$19$start#1;

  inline$CallCompletionRoutine$19$start#1:
    inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$19$label_3#1;

  inline$CallCompletionRoutine$19$label_3#1:
    goto inline$CallCompletionRoutine$19$label_4#1;

  inline$CallCompletionRoutine$19$label_4#1:
    goto inline$CallCompletionRoutine$19$label_5#1;

  inline$CallCompletionRoutine$19$label_5#1:
    goto inline$CallCompletionRoutine$19$label_6#1;

  inline$CallCompletionRoutine$19$label_6#1:
    goto inline$CallCompletionRoutine$19$label_7#1;

  inline$CallCompletionRoutine$19$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$99$Entry#1;

  inline$IoGetCurrentIrpStackLocation$99$Entry#1:
    inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$99$start#1;

  inline$IoGetCurrentIrpStackLocation$99$start#1:
    inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$99$label_3#1;

  inline$IoGetCurrentIrpStackLocation$99$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$99$label_3_true#1, inline$IoGetCurrentIrpStackLocation$99$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$99$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$99$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$99$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$99$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$99$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$99$label_4#1;

  inline$IoGetCurrentIrpStackLocation$99$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$99$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$99$label_6#1;

  inline$IoGetCurrentIrpStackLocation$99$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$99$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$99$label_7#1;

  inline$IoGetCurrentIrpStackLocation$99$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$99$label_5#1;

  inline$IoGetCurrentIrpStackLocation$99$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$99$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$99$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$99$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$99$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$99$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$99$label_5#1;

  inline$IoGetCurrentIrpStackLocation$99$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$99$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$99$label_1#1;

  inline$IoGetCurrentIrpStackLocation$99$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$99$Return#1;

  inline$IoGetCurrentIrpStackLocation$99$Return#1:
    goto inline$CallCompletionRoutine$19$label_7$1#1;

  inline$CallCompletionRoutine$19$label_7$1#1:
    goto inline$CallCompletionRoutine$19$anon10_Then#1, inline$CallCompletionRoutine$19$anon10_Else#1;

  inline$CallCompletionRoutine$19$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$19$anon1#1;

  inline$CallCompletionRoutine$19$anon1#1:
    goto inline$CallCompletionRoutine$19$label_10#1;

  inline$CallCompletionRoutine$19$label_10#1:
    goto inline$CallCompletionRoutine$19$label_11#1;

  inline$CallCompletionRoutine$19$label_11#1:
    havoc inline$CallCompletionRoutine$19$myNondetVar_0;
    inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$19$myNondetVar_0;
    goto inline$CallCompletionRoutine$19$label_12#1;

  inline$CallCompletionRoutine$19$label_12#1:
    havoc inline$CallCompletionRoutine$19$myNondetVar_0;
    inline$CallCompletionRoutine$19$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$19$myNondetVar_0;
    goto inline$CallCompletionRoutine$19$label_13#1;

  inline$CallCompletionRoutine$19$label_13#1:
    havoc inline$CallCompletionRoutine$19$myNondetVar_0;
    goto inline$CallCompletionRoutine$19$label_14#1;

  inline$CallCompletionRoutine$19$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$100$Entry#1;

  inline$IoGetCurrentIrpStackLocation$100$Entry#1:
    inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$100$start#1;

  inline$IoGetCurrentIrpStackLocation$100$start#1:
    inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$100$label_3#1;

  inline$IoGetCurrentIrpStackLocation$100$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$100$label_3_true#1, inline$IoGetCurrentIrpStackLocation$100$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$100$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$100$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$100$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$100$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$100$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$100$label_4#1;

  inline$IoGetCurrentIrpStackLocation$100$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$100$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$100$label_6#1;

  inline$IoGetCurrentIrpStackLocation$100$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$100$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$100$label_7#1;

  inline$IoGetCurrentIrpStackLocation$100$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$100$label_5#1;

  inline$IoGetCurrentIrpStackLocation$100$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$100$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$100$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$100$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$100$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$100$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$100$label_5#1;

  inline$IoGetCurrentIrpStackLocation$100$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$100$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$100$label_1#1;

  inline$IoGetCurrentIrpStackLocation$100$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$100$Return#1;

  inline$IoGetCurrentIrpStackLocation$100$Return#1:
    goto inline$CallCompletionRoutine$19$label_14$1#1;

  inline$CallCompletionRoutine$19$label_14$1#1:
    goto inline$CallCompletionRoutine$19$anon11_Then#1, inline$CallCompletionRoutine$19$anon11_Else#1;

  inline$CallCompletionRoutine$19$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$19$anon3#1;

  inline$CallCompletionRoutine$19$anon3#1:
    goto inline$CallCompletionRoutine$19$label_17#1;

  inline$CallCompletionRoutine$19$label_17#1:
    goto inline$CallCompletionRoutine$19$label_18#1;

  inline$CallCompletionRoutine$19$label_18#1:
    goto inline$CallCompletionRoutine$19$label_18_true#1, inline$CallCompletionRoutine$19$label_18_false#1;

  inline$CallCompletionRoutine$19$label_18_false#1:
    assume inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$19$label_1#1;

  inline$CallCompletionRoutine$19$label_18_true#1:
    assume inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$19$label_19#1;

  inline$CallCompletionRoutine$19$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$19$label_20#1;

  inline$CallCompletionRoutine$19$label_20#1:
    goto inline$CallCompletionRoutine$19$label_20_icall_1#1, inline$CallCompletionRoutine$19$label_20_icall_2#1, inline$CallCompletionRoutine$19$label_20_icall_3#1;

  inline$CallCompletionRoutine$19$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$19$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$19$Entry#1;

  inline$BDLSystemPowerIoCompletion$19$Entry#1:
    inline$BDLSystemPowerIoCompletion$19$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$19$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$19$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$19$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$19$start#1;

  inline$BDLSystemPowerIoCompletion$19$start#1:
    call inline$BDLSystemPowerIoCompletion$19$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$19$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$19$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$19$label_3#1;

  inline$BDLSystemPowerIoCompletion$19$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_4#1;

  inline$BDLSystemPowerIoCompletion$19$label_4#1:
    inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_5#1;

  inline$BDLSystemPowerIoCompletion$19$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_6#1;

  inline$BDLSystemPowerIoCompletion$19$label_6#1:
    inline$BDLSystemPowerIoCompletion$19$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$19$label_7#1;

  inline$BDLSystemPowerIoCompletion$19$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_8#1;

  inline$BDLSystemPowerIoCompletion$19$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$19$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$19$label_9#1;

  inline$BDLSystemPowerIoCompletion$19$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_10#1;

  inline$BDLSystemPowerIoCompletion$19$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$102$Entry#1;

  inline$IoGetCurrentIrpStackLocation$102$Entry#1:
    inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$102$start#1;

  inline$IoGetCurrentIrpStackLocation$102$start#1:
    inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$102$label_3#1;

  inline$IoGetCurrentIrpStackLocation$102$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$102$label_3_true#1, inline$IoGetCurrentIrpStackLocation$102$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$102$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$102$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$102$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$102$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$102$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$102$label_4#1;

  inline$IoGetCurrentIrpStackLocation$102$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$102$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$102$label_6#1;

  inline$IoGetCurrentIrpStackLocation$102$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$102$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$102$label_7#1;

  inline$IoGetCurrentIrpStackLocation$102$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$102$label_5#1;

  inline$IoGetCurrentIrpStackLocation$102$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$102$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$102$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$102$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$102$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$102$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$102$label_5#1;

  inline$IoGetCurrentIrpStackLocation$102$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$102$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$102$label_1#1;

  inline$IoGetCurrentIrpStackLocation$102$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$102$Return#1;

  inline$IoGetCurrentIrpStackLocation$102$Return#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon36_Then#1, inline$BDLSystemPowerIoCompletion$19$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon1#1;

  inline$BDLSystemPowerIoCompletion$19$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_13#1;

  inline$BDLSystemPowerIoCompletion$19$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_14#1;

  inline$BDLSystemPowerIoCompletion$19$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_15#1;

  inline$BDLSystemPowerIoCompletion$19$label_15#1:
    goto inline$BDLGetDebugLevel$511$Entry#1;

  inline$BDLGetDebugLevel$511$Entry#1:
    goto inline$BDLGetDebugLevel$511$start#1;

  inline$BDLGetDebugLevel$511$start#1:
    goto inline$BDLGetDebugLevel$511$label_3#1;

  inline$BDLGetDebugLevel$511$label_3#1:
    havoc inline$BDLGetDebugLevel$511$myNondetVar_0;
    inline$BDLGetDebugLevel$511$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$511$myNondetVar_0;
    goto inline$BDLGetDebugLevel$511$label_1#1;

  inline$BDLGetDebugLevel$511$label_1#1:
    goto inline$BDLGetDebugLevel$511$Return#1;

  inline$BDLGetDebugLevel$511$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$511$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon37_Then#1, inline$BDLSystemPowerIoCompletion$19$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon3#1;

  inline$BDLSystemPowerIoCompletion$19$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_18#1;

  inline$BDLSystemPowerIoCompletion$19$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_18_true#1, inline$BDLSystemPowerIoCompletion$19$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_19#1;

  inline$BDLSystemPowerIoCompletion$19$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_22#1;

  inline$BDLSystemPowerIoCompletion$19$label_22#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_23#1;

  inline$BDLSystemPowerIoCompletion$19$label_23#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_24#1;

  inline$BDLSystemPowerIoCompletion$19$label_24#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_25#1;

  inline$BDLSystemPowerIoCompletion$19$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$19$label_19#1;

  inline$BDLSystemPowerIoCompletion$19$label_19#1:
    goto inline$BDLGetDebugLevel$512$Entry#1;

  inline$BDLGetDebugLevel$512$Entry#1:
    goto inline$BDLGetDebugLevel$512$start#1;

  inline$BDLGetDebugLevel$512$start#1:
    goto inline$BDLGetDebugLevel$512$label_3#1;

  inline$BDLGetDebugLevel$512$label_3#1:
    havoc inline$BDLGetDebugLevel$512$myNondetVar_0;
    inline$BDLGetDebugLevel$512$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$512$myNondetVar_0;
    goto inline$BDLGetDebugLevel$512$label_1#1;

  inline$BDLGetDebugLevel$512$label_1#1:
    goto inline$BDLGetDebugLevel$512$Return#1;

  inline$BDLGetDebugLevel$512$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$512$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon38_Then#1, inline$BDLSystemPowerIoCompletion$19$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon5#1;

  inline$BDLSystemPowerIoCompletion$19$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_28#1;

  inline$BDLSystemPowerIoCompletion$19$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_28_true#1, inline$BDLSystemPowerIoCompletion$19$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_29#1;

  inline$BDLSystemPowerIoCompletion$19$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_32#1;

  inline$BDLSystemPowerIoCompletion$19$label_32#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_33#1;

  inline$BDLSystemPowerIoCompletion$19$label_33#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_34#1;

  inline$BDLSystemPowerIoCompletion$19$label_34#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_35#1;

  inline$BDLSystemPowerIoCompletion$19$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$19$label_29#1;

  inline$BDLSystemPowerIoCompletion$19$label_29#1:
    goto inline$BDLGetDebugLevel$513$Entry#1;

  inline$BDLGetDebugLevel$513$Entry#1:
    goto inline$BDLGetDebugLevel$513$start#1;

  inline$BDLGetDebugLevel$513$start#1:
    goto inline$BDLGetDebugLevel$513$label_3#1;

  inline$BDLGetDebugLevel$513$label_3#1:
    havoc inline$BDLGetDebugLevel$513$myNondetVar_0;
    inline$BDLGetDebugLevel$513$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$513$myNondetVar_0;
    goto inline$BDLGetDebugLevel$513$label_1#1;

  inline$BDLGetDebugLevel$513$label_1#1:
    goto inline$BDLGetDebugLevel$513$Return#1;

  inline$BDLGetDebugLevel$513$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$513$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon39_Then#1, inline$BDLSystemPowerIoCompletion$19$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon7#1;

  inline$BDLSystemPowerIoCompletion$19$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_38#1;

  inline$BDLSystemPowerIoCompletion$19$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_38_true#1, inline$BDLSystemPowerIoCompletion$19$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_39#1;

  inline$BDLSystemPowerIoCompletion$19$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_40#1;

  inline$BDLSystemPowerIoCompletion$19$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_39#1;

  inline$BDLSystemPowerIoCompletion$19$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_39_true#1, inline$BDLSystemPowerIoCompletion$19$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_41#1;

  inline$BDLSystemPowerIoCompletion$19$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$19$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$19$label_107#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$19$label_108#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$19$label_108#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$19$label_108#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$19$label_108#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$19$label_108#1;

  inline$BDLSystemPowerIoCompletion$19$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_109#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$19$label_107#1;

  inline$BDLSystemPowerIoCompletion$19$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_109#1;

  inline$BDLSystemPowerIoCompletion$19$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$19$label_106#1;

  inline$BDLSystemPowerIoCompletion$19$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_106_true#1, inline$BDLSystemPowerIoCompletion$19$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_142#1;

  inline$BDLSystemPowerIoCompletion$19$label_142#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_143#1;

  inline$BDLSystemPowerIoCompletion$19$label_143#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_144#1;

  inline$BDLSystemPowerIoCompletion$19$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_109#1;

  inline$BDLSystemPowerIoCompletion$19$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_109#1;

  inline$BDLSystemPowerIoCompletion$19$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$19$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$19$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$19$myNondetVar_0, inline$BDLSystemPowerIoCompletion$19$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$19$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$19$anon50_Then#1, inline$BDLSystemPowerIoCompletion$19$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon29#1;

  inline$BDLSystemPowerIoCompletion$19$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_112#1;

  inline$BDLSystemPowerIoCompletion$19$label_112#1:
    inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$19$label_113#1;

  inline$BDLSystemPowerIoCompletion$19$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_113_true#1, inline$BDLSystemPowerIoCompletion$19$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$19$label_114#1;

  inline$BDLSystemPowerIoCompletion$19$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_116#1;

  inline$BDLSystemPowerIoCompletion$19$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_117#1;

  inline$BDLSystemPowerIoCompletion$19$label_117#1:
    goto inline$BDLGetDebugLevel$520$Entry#1;

  inline$BDLGetDebugLevel$520$Entry#1:
    goto inline$BDLGetDebugLevel$520$start#1;

  inline$BDLGetDebugLevel$520$start#1:
    goto inline$BDLGetDebugLevel$520$label_3#1;

  inline$BDLGetDebugLevel$520$label_3#1:
    havoc inline$BDLGetDebugLevel$520$myNondetVar_0;
    inline$BDLGetDebugLevel$520$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$520$myNondetVar_0;
    goto inline$BDLGetDebugLevel$520$label_1#1;

  inline$BDLGetDebugLevel$520$label_1#1:
    goto inline$BDLGetDebugLevel$520$Return#1;

  inline$BDLGetDebugLevel$520$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$520$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon51_Then#1, inline$BDLSystemPowerIoCompletion$19$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon31#1;

  inline$BDLSystemPowerIoCompletion$19$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_120#1;

  inline$BDLSystemPowerIoCompletion$19$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_120_true#1, inline$BDLSystemPowerIoCompletion$19$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_121#1;

  inline$BDLSystemPowerIoCompletion$19$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_124#1;

  inline$BDLSystemPowerIoCompletion$19$label_124#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_125#1;

  inline$BDLSystemPowerIoCompletion$19$label_125#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_126#1;

  inline$BDLSystemPowerIoCompletion$19$label_126#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_127#1;

  inline$BDLSystemPowerIoCompletion$19$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$19$label_121#1;

  inline$BDLSystemPowerIoCompletion$19$label_121#1:
    goto inline$BDLGetDebugLevel$521$Entry#1;

  inline$BDLGetDebugLevel$521$Entry#1:
    goto inline$BDLGetDebugLevel$521$start#1;

  inline$BDLGetDebugLevel$521$start#1:
    goto inline$BDLGetDebugLevel$521$label_3#1;

  inline$BDLGetDebugLevel$521$label_3#1:
    havoc inline$BDLGetDebugLevel$521$myNondetVar_0;
    inline$BDLGetDebugLevel$521$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$521$myNondetVar_0;
    goto inline$BDLGetDebugLevel$521$label_1#1;

  inline$BDLGetDebugLevel$521$label_1#1:
    goto inline$BDLGetDebugLevel$521$Return#1;

  inline$BDLGetDebugLevel$521$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$521$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon52_Then#1, inline$BDLSystemPowerIoCompletion$19$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon33#1;

  inline$BDLSystemPowerIoCompletion$19$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_130#1;

  inline$BDLSystemPowerIoCompletion$19$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_130_true#1, inline$BDLSystemPowerIoCompletion$19$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_131#1;

  inline$BDLSystemPowerIoCompletion$19$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_134#1;

  inline$BDLSystemPowerIoCompletion$19$label_134#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_135#1;

  inline$BDLSystemPowerIoCompletion$19$label_135#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_136#1;

  inline$BDLSystemPowerIoCompletion$19$label_136#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_137#1;

  inline$BDLSystemPowerIoCompletion$19$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$19$label_131#1;

  inline$BDLSystemPowerIoCompletion$19$label_131#1:
    goto inline$BDLGetDebugLevel$522$Entry#1;

  inline$BDLGetDebugLevel$522$Entry#1:
    goto inline$BDLGetDebugLevel$522$start#1;

  inline$BDLGetDebugLevel$522$start#1:
    goto inline$BDLGetDebugLevel$522$label_3#1;

  inline$BDLGetDebugLevel$522$label_3#1:
    havoc inline$BDLGetDebugLevel$522$myNondetVar_0;
    inline$BDLGetDebugLevel$522$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$522$myNondetVar_0;
    goto inline$BDLGetDebugLevel$522$label_1#1;

  inline$BDLGetDebugLevel$522$label_1#1:
    goto inline$BDLGetDebugLevel$522$Return#1;

  inline$BDLGetDebugLevel$522$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$522$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon53_Then#1, inline$BDLSystemPowerIoCompletion$19$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon35#1;

  inline$BDLSystemPowerIoCompletion$19$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_140#1;

  inline$BDLSystemPowerIoCompletion$19$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_140_true#1, inline$BDLSystemPowerIoCompletion$19$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_67#1;

  inline$BDLSystemPowerIoCompletion$19$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_141#1;

  inline$BDLSystemPowerIoCompletion$19$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_67#1;

  inline$BDLSystemPowerIoCompletion$19$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$19$label_115#1;

  inline$BDLSystemPowerIoCompletion$19$label_115#1:
    inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$19$label_80#1;

  inline$BDLSystemPowerIoCompletion$19$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$19$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_42#1;

  inline$BDLSystemPowerIoCompletion$19$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$19$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$19$label_43#1;

  inline$BDLSystemPowerIoCompletion$19$label_43#1:
    goto inline$BDLGetDebugLevel$514$Entry#1;

  inline$BDLGetDebugLevel$514$Entry#1:
    goto inline$BDLGetDebugLevel$514$start#1;

  inline$BDLGetDebugLevel$514$start#1:
    goto inline$BDLGetDebugLevel$514$label_3#1;

  inline$BDLGetDebugLevel$514$label_3#1:
    havoc inline$BDLGetDebugLevel$514$myNondetVar_0;
    inline$BDLGetDebugLevel$514$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$514$myNondetVar_0;
    goto inline$BDLGetDebugLevel$514$label_1#1;

  inline$BDLGetDebugLevel$514$label_1#1:
    goto inline$BDLGetDebugLevel$514$Return#1;

  inline$BDLGetDebugLevel$514$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$514$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon40_Then#1, inline$BDLSystemPowerIoCompletion$19$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon9#1;

  inline$BDLSystemPowerIoCompletion$19$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_46#1;

  inline$BDLSystemPowerIoCompletion$19$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_46_true#1, inline$BDLSystemPowerIoCompletion$19$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_47#1;

  inline$BDLSystemPowerIoCompletion$19$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_50#1;

  inline$BDLSystemPowerIoCompletion$19$label_50#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_51#1;

  inline$BDLSystemPowerIoCompletion$19$label_51#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_52#1;

  inline$BDLSystemPowerIoCompletion$19$label_52#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_53#1;

  inline$BDLSystemPowerIoCompletion$19$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$19$label_47#1;

  inline$BDLSystemPowerIoCompletion$19$label_47#1:
    goto inline$BDLGetDebugLevel$515$Entry#1;

  inline$BDLGetDebugLevel$515$Entry#1:
    goto inline$BDLGetDebugLevel$515$start#1;

  inline$BDLGetDebugLevel$515$start#1:
    goto inline$BDLGetDebugLevel$515$label_3#1;

  inline$BDLGetDebugLevel$515$label_3#1:
    havoc inline$BDLGetDebugLevel$515$myNondetVar_0;
    inline$BDLGetDebugLevel$515$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$515$myNondetVar_0;
    goto inline$BDLGetDebugLevel$515$label_1#1;

  inline$BDLGetDebugLevel$515$label_1#1:
    goto inline$BDLGetDebugLevel$515$Return#1;

  inline$BDLGetDebugLevel$515$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$515$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon41_Then#1, inline$BDLSystemPowerIoCompletion$19$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon11#1;

  inline$BDLSystemPowerIoCompletion$19$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_56#1;

  inline$BDLSystemPowerIoCompletion$19$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_56_true#1, inline$BDLSystemPowerIoCompletion$19$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_57#1;

  inline$BDLSystemPowerIoCompletion$19$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_60#1;

  inline$BDLSystemPowerIoCompletion$19$label_60#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_61#1;

  inline$BDLSystemPowerIoCompletion$19$label_61#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_62#1;

  inline$BDLSystemPowerIoCompletion$19$label_62#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_63#1;

  inline$BDLSystemPowerIoCompletion$19$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$19$label_57#1;

  inline$BDLSystemPowerIoCompletion$19$label_57#1:
    goto inline$BDLGetDebugLevel$516$Entry#1;

  inline$BDLGetDebugLevel$516$Entry#1:
    goto inline$BDLGetDebugLevel$516$start#1;

  inline$BDLGetDebugLevel$516$start#1:
    goto inline$BDLGetDebugLevel$516$label_3#1;

  inline$BDLGetDebugLevel$516$label_3#1:
    havoc inline$BDLGetDebugLevel$516$myNondetVar_0;
    inline$BDLGetDebugLevel$516$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$516$myNondetVar_0;
    goto inline$BDLGetDebugLevel$516$label_1#1;

  inline$BDLGetDebugLevel$516$label_1#1:
    goto inline$BDLGetDebugLevel$516$Return#1;

  inline$BDLGetDebugLevel$516$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$516$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon42_Then#1, inline$BDLSystemPowerIoCompletion$19$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon13#1;

  inline$BDLSystemPowerIoCompletion$19$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_66#1;

  inline$BDLSystemPowerIoCompletion$19$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_66_true#1, inline$BDLSystemPowerIoCompletion$19$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_67#1;

  inline$BDLSystemPowerIoCompletion$19$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_70#1;

  inline$BDLSystemPowerIoCompletion$19$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_67#1;

  inline$BDLSystemPowerIoCompletion$19$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$19$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$19$anon43_Then#1, inline$BDLSystemPowerIoCompletion$19$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon15#1;

  inline$BDLSystemPowerIoCompletion$19$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_71#1;

  inline$BDLSystemPowerIoCompletion$19$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$19$anon44_Then#1, inline$BDLSystemPowerIoCompletion$19$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon17#1;

  inline$BDLSystemPowerIoCompletion$19$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_74#1;

  inline$BDLSystemPowerIoCompletion$19$label_74#1:
    goto inline$storm_IoCompleteRequest$40$Entry#1;

  inline$storm_IoCompleteRequest$40$Entry#1:
    inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$19$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$40$start#1;

  inline$storm_IoCompleteRequest$40$start#1:
    inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$40$label_3#1;

  inline$storm_IoCompleteRequest$40$label_3#1:
    call inline$storm_IoCompleteRequest$40$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$40$label_6#1;

  inline$storm_IoCompleteRequest$40$label_6#1:
    goto inline$storm_IoCompleteRequest$40$label_6_true#1, inline$storm_IoCompleteRequest$40$label_6_false#1;

  inline$storm_IoCompleteRequest$40$label_6_false#1:
    assume inline$storm_IoCompleteRequest$40$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$40$label_7#1;

  inline$storm_IoCompleteRequest$40$label_6_true#1:
    assume inline$storm_IoCompleteRequest$40$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$40$label_8#1;

  inline$storm_IoCompleteRequest$40$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$40$anon3_Then#1, inline$storm_IoCompleteRequest$40$anon3_Else#1;

  inline$storm_IoCompleteRequest$40$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$40$anon1#1;

  inline$storm_IoCompleteRequest$40$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$40$label_9#1;

  inline$storm_IoCompleteRequest$40$label_9#1:
    goto inline$storm_IoCompleteRequest$40$label_9_true#1, inline$storm_IoCompleteRequest$40$label_9_false#1;

  inline$storm_IoCompleteRequest$40$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$40$label_10#1;

  inline$storm_IoCompleteRequest$40$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$40$label_1#1;

  inline$storm_IoCompleteRequest$40$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$40$label_7#1;

  inline$storm_IoCompleteRequest$40$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$40$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$40$label_1#1;

  inline$storm_IoCompleteRequest$40$label_1#1:
    goto inline$storm_IoCompleteRequest$40$Return#1;

  inline$storm_IoCompleteRequest$40$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$40$Return#1;

  inline$storm_IoCompleteRequest$40$Return#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon45_Then#1, inline$BDLSystemPowerIoCompletion$19$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon19#1;

  inline$BDLSystemPowerIoCompletion$19$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_77#1;

  inline$BDLSystemPowerIoCompletion$19$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$19$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$19$anon46_Then#1, inline$BDLSystemPowerIoCompletion$19$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon21#1;

  inline$BDLSystemPowerIoCompletion$19$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_80#1;

  inline$BDLSystemPowerIoCompletion$19$label_80#1:
    goto inline$BDLGetDebugLevel$517$Entry#1;

  inline$BDLGetDebugLevel$517$Entry#1:
    goto inline$BDLGetDebugLevel$517$start#1;

  inline$BDLGetDebugLevel$517$start#1:
    goto inline$BDLGetDebugLevel$517$label_3#1;

  inline$BDLGetDebugLevel$517$label_3#1:
    havoc inline$BDLGetDebugLevel$517$myNondetVar_0;
    inline$BDLGetDebugLevel$517$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$517$myNondetVar_0;
    goto inline$BDLGetDebugLevel$517$label_1#1;

  inline$BDLGetDebugLevel$517$label_1#1:
    goto inline$BDLGetDebugLevel$517$Return#1;

  inline$BDLGetDebugLevel$517$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$517$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon47_Then#1, inline$BDLSystemPowerIoCompletion$19$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon23#1;

  inline$BDLSystemPowerIoCompletion$19$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_83#1;

  inline$BDLSystemPowerIoCompletion$19$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_83_true#1, inline$BDLSystemPowerIoCompletion$19$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_84#1;

  inline$BDLSystemPowerIoCompletion$19$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_87#1;

  inline$BDLSystemPowerIoCompletion$19$label_87#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_88#1;

  inline$BDLSystemPowerIoCompletion$19$label_88#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_89#1;

  inline$BDLSystemPowerIoCompletion$19$label_89#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_90#1;

  inline$BDLSystemPowerIoCompletion$19$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$19$label_84#1;

  inline$BDLSystemPowerIoCompletion$19$label_84#1:
    goto inline$BDLGetDebugLevel$518$Entry#1;

  inline$BDLGetDebugLevel$518$Entry#1:
    goto inline$BDLGetDebugLevel$518$start#1;

  inline$BDLGetDebugLevel$518$start#1:
    goto inline$BDLGetDebugLevel$518$label_3#1;

  inline$BDLGetDebugLevel$518$label_3#1:
    havoc inline$BDLGetDebugLevel$518$myNondetVar_0;
    inline$BDLGetDebugLevel$518$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$518$myNondetVar_0;
    goto inline$BDLGetDebugLevel$518$label_1#1;

  inline$BDLGetDebugLevel$518$label_1#1:
    goto inline$BDLGetDebugLevel$518$Return#1;

  inline$BDLGetDebugLevel$518$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$518$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon48_Then#1, inline$BDLSystemPowerIoCompletion$19$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon25#1;

  inline$BDLSystemPowerIoCompletion$19$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_93#1;

  inline$BDLSystemPowerIoCompletion$19$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_93_true#1, inline$BDLSystemPowerIoCompletion$19$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_94#1;

  inline$BDLSystemPowerIoCompletion$19$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_97#1;

  inline$BDLSystemPowerIoCompletion$19$label_97#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_98#1;

  inline$BDLSystemPowerIoCompletion$19$label_98#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_99#1;

  inline$BDLSystemPowerIoCompletion$19$label_99#1:
    call inline$BDLSystemPowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$19$label_100#1;

  inline$BDLSystemPowerIoCompletion$19$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$19$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$19$label_94#1;

  inline$BDLSystemPowerIoCompletion$19$label_94#1:
    goto inline$BDLGetDebugLevel$519$Entry#1;

  inline$BDLGetDebugLevel$519$Entry#1:
    goto inline$BDLGetDebugLevel$519$start#1;

  inline$BDLGetDebugLevel$519$start#1:
    goto inline$BDLGetDebugLevel$519$label_3#1;

  inline$BDLGetDebugLevel$519$label_3#1:
    havoc inline$BDLGetDebugLevel$519$myNondetVar_0;
    inline$BDLGetDebugLevel$519$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$519$myNondetVar_0;
    goto inline$BDLGetDebugLevel$519$label_1#1;

  inline$BDLGetDebugLevel$519$label_1#1:
    goto inline$BDLGetDebugLevel$519$Return#1;

  inline$BDLGetDebugLevel$519$Return#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$519$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$19$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$19$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$19$anon49_Then#1, inline$BDLSystemPowerIoCompletion$19$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$19$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$anon27#1;

  inline$BDLSystemPowerIoCompletion$19$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_103#1;

  inline$BDLSystemPowerIoCompletion$19$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_103_true#1, inline$BDLSystemPowerIoCompletion$19$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$19$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_104#1;

  inline$BDLSystemPowerIoCompletion$19$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$19$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$19$label_105#1;

  inline$BDLSystemPowerIoCompletion$19$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$19$label_104#1;

  inline$BDLSystemPowerIoCompletion$19$label_104#1:
    inline$BDLSystemPowerIoCompletion$19$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$19$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$19$label_1#1;

  inline$BDLSystemPowerIoCompletion$19$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$19$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$19$Return#1;

  inline$BDLSystemPowerIoCompletion$19$Return#1:
    inline$CallCompletionRoutine$19$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$19$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$19$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$19$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$19$anon14_Then#1, inline$CallCompletionRoutine$19$anon14_Else#1;

  inline$CallCompletionRoutine$19$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$19$anon9#1;

  inline$CallCompletionRoutine$19$anon9#1:
    goto inline$CallCompletionRoutine$19$label_20_icall_return#1;

  inline$CallCompletionRoutine$19$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$19$Return#1;

  inline$CallCompletionRoutine$19$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$19$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$19$Entry#1;

  inline$BDLDevicePowerIoCompletion$19$Entry#1:
    inline$BDLDevicePowerIoCompletion$19$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$19$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$19$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$19$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$19$start#1;

  inline$BDLDevicePowerIoCompletion$19$start#1:
    call inline$BDLDevicePowerIoCompletion$19$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$19$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$19$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$19$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$19$label_3#1;

  inline$BDLDevicePowerIoCompletion$19$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_4#1;

  inline$BDLDevicePowerIoCompletion$19$label_4#1:
    inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_5#1;

  inline$BDLDevicePowerIoCompletion$19$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_6#1;

  inline$BDLDevicePowerIoCompletion$19$label_6#1:
    inline$BDLDevicePowerIoCompletion$19$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$19$label_7#1;

  inline$BDLDevicePowerIoCompletion$19$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_8#1;

  inline$BDLDevicePowerIoCompletion$19$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$19$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$19$label_9#1;

  inline$BDLDevicePowerIoCompletion$19$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_10#1;

  inline$BDLDevicePowerIoCompletion$19$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$101$Entry#1;

  inline$IoGetCurrentIrpStackLocation$101$Entry#1:
    inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$101$start#1;

  inline$IoGetCurrentIrpStackLocation$101$start#1:
    inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$101$label_3#1;

  inline$IoGetCurrentIrpStackLocation$101$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$101$label_3_true#1, inline$IoGetCurrentIrpStackLocation$101$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$101$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$101$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$101$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$101$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$101$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$101$label_4#1;

  inline$IoGetCurrentIrpStackLocation$101$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$101$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$101$label_6#1;

  inline$IoGetCurrentIrpStackLocation$101$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$101$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$101$label_7#1;

  inline$IoGetCurrentIrpStackLocation$101$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$101$label_5#1;

  inline$IoGetCurrentIrpStackLocation$101$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$101$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$101$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$101$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$101$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$101$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$101$label_5#1;

  inline$IoGetCurrentIrpStackLocation$101$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$101$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$101$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$101$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$101$label_1#1;

  inline$IoGetCurrentIrpStackLocation$101$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$101$Return#1;

  inline$IoGetCurrentIrpStackLocation$101$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$101$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon30_Then#1, inline$BDLDevicePowerIoCompletion$19$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon1#1;

  inline$BDLDevicePowerIoCompletion$19$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_13#1;

  inline$BDLDevicePowerIoCompletion$19$label_13#1:
    inline$BDLDevicePowerIoCompletion$19$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$19$label_14#1;

  inline$BDLDevicePowerIoCompletion$19$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_15#1;

  inline$BDLDevicePowerIoCompletion$19$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$19$label_16#1;

  inline$BDLDevicePowerIoCompletion$19$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_17#1;

  inline$BDLDevicePowerIoCompletion$19$label_17#1:
    goto inline$BDLGetDebugLevel$502$Entry#1;

  inline$BDLGetDebugLevel$502$Entry#1:
    goto inline$BDLGetDebugLevel$502$start#1;

  inline$BDLGetDebugLevel$502$start#1:
    goto inline$BDLGetDebugLevel$502$label_3#1;

  inline$BDLGetDebugLevel$502$label_3#1:
    havoc inline$BDLGetDebugLevel$502$myNondetVar_0;
    inline$BDLGetDebugLevel$502$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$502$myNondetVar_0;
    goto inline$BDLGetDebugLevel$502$label_1#1;

  inline$BDLGetDebugLevel$502$label_1#1:
    goto inline$BDLGetDebugLevel$502$Return#1;

  inline$BDLGetDebugLevel$502$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$502$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon31_Then#1, inline$BDLDevicePowerIoCompletion$19$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon3#1;

  inline$BDLDevicePowerIoCompletion$19$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_20#1;

  inline$BDLDevicePowerIoCompletion$19$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_20_true#1, inline$BDLDevicePowerIoCompletion$19$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_21#1;

  inline$BDLDevicePowerIoCompletion$19$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_24#1;

  inline$BDLDevicePowerIoCompletion$19$label_24#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_25#1;

  inline$BDLDevicePowerIoCompletion$19$label_25#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_26#1;

  inline$BDLDevicePowerIoCompletion$19$label_26#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_27#1;

  inline$BDLDevicePowerIoCompletion$19$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$19$label_21#1;

  inline$BDLDevicePowerIoCompletion$19$label_21#1:
    goto inline$BDLGetDebugLevel$503$Entry#1;

  inline$BDLGetDebugLevel$503$Entry#1:
    goto inline$BDLGetDebugLevel$503$start#1;

  inline$BDLGetDebugLevel$503$start#1:
    goto inline$BDLGetDebugLevel$503$label_3#1;

  inline$BDLGetDebugLevel$503$label_3#1:
    havoc inline$BDLGetDebugLevel$503$myNondetVar_0;
    inline$BDLGetDebugLevel$503$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$503$myNondetVar_0;
    goto inline$BDLGetDebugLevel$503$label_1#1;

  inline$BDLGetDebugLevel$503$label_1#1:
    goto inline$BDLGetDebugLevel$503$Return#1;

  inline$BDLGetDebugLevel$503$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$503$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon32_Then#1, inline$BDLDevicePowerIoCompletion$19$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon5#1;

  inline$BDLDevicePowerIoCompletion$19$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_30#1;

  inline$BDLDevicePowerIoCompletion$19$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_30_true#1, inline$BDLDevicePowerIoCompletion$19$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_31#1;

  inline$BDLDevicePowerIoCompletion$19$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_34#1;

  inline$BDLDevicePowerIoCompletion$19$label_34#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_35#1;

  inline$BDLDevicePowerIoCompletion$19$label_35#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_36#1;

  inline$BDLDevicePowerIoCompletion$19$label_36#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_37#1;

  inline$BDLDevicePowerIoCompletion$19$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$19$label_31#1;

  inline$BDLDevicePowerIoCompletion$19$label_31#1:
    goto inline$BDLGetDebugLevel$504$Entry#1;

  inline$BDLGetDebugLevel$504$Entry#1:
    goto inline$BDLGetDebugLevel$504$start#1;

  inline$BDLGetDebugLevel$504$start#1:
    goto inline$BDLGetDebugLevel$504$label_3#1;

  inline$BDLGetDebugLevel$504$label_3#1:
    havoc inline$BDLGetDebugLevel$504$myNondetVar_0;
    inline$BDLGetDebugLevel$504$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$504$myNondetVar_0;
    goto inline$BDLGetDebugLevel$504$label_1#1;

  inline$BDLGetDebugLevel$504$label_1#1:
    goto inline$BDLGetDebugLevel$504$Return#1;

  inline$BDLGetDebugLevel$504$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$504$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon33_Then#1, inline$BDLDevicePowerIoCompletion$19$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon7#1;

  inline$BDLDevicePowerIoCompletion$19$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_40#1;

  inline$BDLDevicePowerIoCompletion$19$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_40_true#1, inline$BDLDevicePowerIoCompletion$19$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_41#1;

  inline$BDLDevicePowerIoCompletion$19$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_42#1;

  inline$BDLDevicePowerIoCompletion$19$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_41#1;

  inline$BDLDevicePowerIoCompletion$19$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_41_true#1, inline$BDLDevicePowerIoCompletion$19$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$19$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$19$label_43#1;

  inline$BDLDevicePowerIoCompletion$19$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$19$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$19$label_44#1;

  inline$BDLDevicePowerIoCompletion$19$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_44_true#1, inline$BDLDevicePowerIoCompletion$19$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$19$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$19$label_45#1;

  inline$BDLDevicePowerIoCompletion$19$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_45_true#1, inline$BDLDevicePowerIoCompletion$19$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$19$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$19$label_43#1;

  inline$BDLDevicePowerIoCompletion$19$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$19$label_86#1;

  inline$BDLDevicePowerIoCompletion$19$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$19$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$19$label_46#1;

  inline$BDLDevicePowerIoCompletion$19$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$19$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$19$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$19$label_46#1;

  inline$BDLDevicePowerIoCompletion$19$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$19$label_49#1;

  inline$BDLDevicePowerIoCompletion$19$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_50#1;

  inline$BDLDevicePowerIoCompletion$19$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_51#1;

  inline$BDLDevicePowerIoCompletion$19$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_54#1;

  inline$BDLDevicePowerIoCompletion$19$label_54#1:
    inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$19$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$19$label_55#1;

  inline$BDLDevicePowerIoCompletion$19$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_55_true#1, inline$BDLDevicePowerIoCompletion$19$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_56#1;

  inline$BDLDevicePowerIoCompletion$19$label_56#1:
    call inline$BDLDevicePowerIoCompletion$19$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$19$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$19$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$19$anon34_Then#1, inline$BDLDevicePowerIoCompletion$19$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon9#1;

  inline$BDLDevicePowerIoCompletion$19$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_83#1;

  inline$BDLDevicePowerIoCompletion$19$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_59#1;

  inline$BDLDevicePowerIoCompletion$19$label_59#1:
    goto inline$BDLGetDebugLevel$505$Entry#1;

  inline$BDLGetDebugLevel$505$Entry#1:
    goto inline$BDLGetDebugLevel$505$start#1;

  inline$BDLGetDebugLevel$505$start#1:
    goto inline$BDLGetDebugLevel$505$label_3#1;

  inline$BDLGetDebugLevel$505$label_3#1:
    havoc inline$BDLGetDebugLevel$505$myNondetVar_0;
    inline$BDLGetDebugLevel$505$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$505$myNondetVar_0;
    goto inline$BDLGetDebugLevel$505$label_1#1;

  inline$BDLGetDebugLevel$505$label_1#1:
    goto inline$BDLGetDebugLevel$505$Return#1;

  inline$BDLGetDebugLevel$505$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$505$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon35_Then#1, inline$BDLDevicePowerIoCompletion$19$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon11#1;

  inline$BDLDevicePowerIoCompletion$19$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_62#1;

  inline$BDLDevicePowerIoCompletion$19$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_62_true#1, inline$BDLDevicePowerIoCompletion$19$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_63#1;

  inline$BDLDevicePowerIoCompletion$19$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_66#1;

  inline$BDLDevicePowerIoCompletion$19$label_66#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_67#1;

  inline$BDLDevicePowerIoCompletion$19$label_67#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_68#1;

  inline$BDLDevicePowerIoCompletion$19$label_68#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_69#1;

  inline$BDLDevicePowerIoCompletion$19$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$19$label_63#1;

  inline$BDLDevicePowerIoCompletion$19$label_63#1:
    goto inline$BDLGetDebugLevel$506$Entry#1;

  inline$BDLGetDebugLevel$506$Entry#1:
    goto inline$BDLGetDebugLevel$506$start#1;

  inline$BDLGetDebugLevel$506$start#1:
    goto inline$BDLGetDebugLevel$506$label_3#1;

  inline$BDLGetDebugLevel$506$label_3#1:
    havoc inline$BDLGetDebugLevel$506$myNondetVar_0;
    inline$BDLGetDebugLevel$506$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$506$myNondetVar_0;
    goto inline$BDLGetDebugLevel$506$label_1#1;

  inline$BDLGetDebugLevel$506$label_1#1:
    goto inline$BDLGetDebugLevel$506$Return#1;

  inline$BDLGetDebugLevel$506$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$506$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon36_Then#1, inline$BDLDevicePowerIoCompletion$19$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon13#1;

  inline$BDLDevicePowerIoCompletion$19$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_72#1;

  inline$BDLDevicePowerIoCompletion$19$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_72_true#1, inline$BDLDevicePowerIoCompletion$19$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_73#1;

  inline$BDLDevicePowerIoCompletion$19$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_76#1;

  inline$BDLDevicePowerIoCompletion$19$label_76#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_77#1;

  inline$BDLDevicePowerIoCompletion$19$label_77#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_78#1;

  inline$BDLDevicePowerIoCompletion$19$label_78#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_79#1;

  inline$BDLDevicePowerIoCompletion$19$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$19$label_73#1;

  inline$BDLDevicePowerIoCompletion$19$label_73#1:
    goto inline$BDLGetDebugLevel$507$Entry#1;

  inline$BDLGetDebugLevel$507$Entry#1:
    goto inline$BDLGetDebugLevel$507$start#1;

  inline$BDLGetDebugLevel$507$start#1:
    goto inline$BDLGetDebugLevel$507$label_3#1;

  inline$BDLGetDebugLevel$507$label_3#1:
    havoc inline$BDLGetDebugLevel$507$myNondetVar_0;
    inline$BDLGetDebugLevel$507$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$507$myNondetVar_0;
    goto inline$BDLGetDebugLevel$507$label_1#1;

  inline$BDLGetDebugLevel$507$label_1#1:
    goto inline$BDLGetDebugLevel$507$Return#1;

  inline$BDLGetDebugLevel$507$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$507$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon37_Then#1, inline$BDLDevicePowerIoCompletion$19$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon15#1;

  inline$BDLDevicePowerIoCompletion$19$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_82#1;

  inline$BDLDevicePowerIoCompletion$19$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_82_true#1, inline$BDLDevicePowerIoCompletion$19$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_83#1;

  inline$BDLDevicePowerIoCompletion$19$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_84#1;

  inline$BDLDevicePowerIoCompletion$19$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_83#1;

  inline$BDLDevicePowerIoCompletion$19$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_85#1;

  inline$BDLDevicePowerIoCompletion$19$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_86#1;

  inline$BDLDevicePowerIoCompletion$19$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$19$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$19$anon38_Then#1, inline$BDLDevicePowerIoCompletion$19$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon17#1;

  inline$BDLDevicePowerIoCompletion$19$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_89#1;

  inline$BDLDevicePowerIoCompletion$19$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$19$anon39_Then#1, inline$BDLDevicePowerIoCompletion$19$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon19#1;

  inline$BDLDevicePowerIoCompletion$19$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_92#1;

  inline$BDLDevicePowerIoCompletion$19$label_92#1:
    goto inline$storm_IoCompleteRequest$39$Entry#1;

  inline$storm_IoCompleteRequest$39$Entry#1:
    inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$19$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$39$start#1;

  inline$storm_IoCompleteRequest$39$start#1:
    inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$39$label_3#1;

  inline$storm_IoCompleteRequest$39$label_3#1:
    call inline$storm_IoCompleteRequest$39$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$39$label_6#1;

  inline$storm_IoCompleteRequest$39$label_6#1:
    goto inline$storm_IoCompleteRequest$39$label_6_true#1, inline$storm_IoCompleteRequest$39$label_6_false#1;

  inline$storm_IoCompleteRequest$39$label_6_false#1:
    assume inline$storm_IoCompleteRequest$39$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$39$label_7#1;

  inline$storm_IoCompleteRequest$39$label_6_true#1:
    assume inline$storm_IoCompleteRequest$39$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$39$label_8#1;

  inline$storm_IoCompleteRequest$39$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$39$anon3_Then#1, inline$storm_IoCompleteRequest$39$anon3_Else#1;

  inline$storm_IoCompleteRequest$39$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$39$anon1#1;

  inline$storm_IoCompleteRequest$39$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$39$label_9#1;

  inline$storm_IoCompleteRequest$39$label_9#1:
    goto inline$storm_IoCompleteRequest$39$label_9_true#1, inline$storm_IoCompleteRequest$39$label_9_false#1;

  inline$storm_IoCompleteRequest$39$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$39$label_10#1;

  inline$storm_IoCompleteRequest$39$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$39$label_1#1;

  inline$storm_IoCompleteRequest$39$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$39$label_7#1;

  inline$storm_IoCompleteRequest$39$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$39$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$39$label_1#1;

  inline$storm_IoCompleteRequest$39$label_1#1:
    goto inline$storm_IoCompleteRequest$39$Return#1;

  inline$storm_IoCompleteRequest$39$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$39$Return#1;

  inline$storm_IoCompleteRequest$39$Return#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon40_Then#1, inline$BDLDevicePowerIoCompletion$19$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon21#1;

  inline$BDLDevicePowerIoCompletion$19$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_95#1;

  inline$BDLDevicePowerIoCompletion$19$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$19$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$19$anon41_Then#1, inline$BDLDevicePowerIoCompletion$19$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon23#1;

  inline$BDLDevicePowerIoCompletion$19$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_98#1;

  inline$BDLDevicePowerIoCompletion$19$label_98#1:
    goto inline$BDLGetDebugLevel$508$Entry#1;

  inline$BDLGetDebugLevel$508$Entry#1:
    goto inline$BDLGetDebugLevel$508$start#1;

  inline$BDLGetDebugLevel$508$start#1:
    goto inline$BDLGetDebugLevel$508$label_3#1;

  inline$BDLGetDebugLevel$508$label_3#1:
    havoc inline$BDLGetDebugLevel$508$myNondetVar_0;
    inline$BDLGetDebugLevel$508$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$508$myNondetVar_0;
    goto inline$BDLGetDebugLevel$508$label_1#1;

  inline$BDLGetDebugLevel$508$label_1#1:
    goto inline$BDLGetDebugLevel$508$Return#1;

  inline$BDLGetDebugLevel$508$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$508$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon42_Then#1, inline$BDLDevicePowerIoCompletion$19$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon25#1;

  inline$BDLDevicePowerIoCompletion$19$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_101#1;

  inline$BDLDevicePowerIoCompletion$19$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_101_true#1, inline$BDLDevicePowerIoCompletion$19$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_102#1;

  inline$BDLDevicePowerIoCompletion$19$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_105#1;

  inline$BDLDevicePowerIoCompletion$19$label_105#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_106#1;

  inline$BDLDevicePowerIoCompletion$19$label_106#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_107#1;

  inline$BDLDevicePowerIoCompletion$19$label_107#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_108#1;

  inline$BDLDevicePowerIoCompletion$19$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$19$label_102#1;

  inline$BDLDevicePowerIoCompletion$19$label_102#1:
    goto inline$BDLGetDebugLevel$509$Entry#1;

  inline$BDLGetDebugLevel$509$Entry#1:
    goto inline$BDLGetDebugLevel$509$start#1;

  inline$BDLGetDebugLevel$509$start#1:
    goto inline$BDLGetDebugLevel$509$label_3#1;

  inline$BDLGetDebugLevel$509$label_3#1:
    havoc inline$BDLGetDebugLevel$509$myNondetVar_0;
    inline$BDLGetDebugLevel$509$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$509$myNondetVar_0;
    goto inline$BDLGetDebugLevel$509$label_1#1;

  inline$BDLGetDebugLevel$509$label_1#1:
    goto inline$BDLGetDebugLevel$509$Return#1;

  inline$BDLGetDebugLevel$509$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$509$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon43_Then#1, inline$BDLDevicePowerIoCompletion$19$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon27#1;

  inline$BDLDevicePowerIoCompletion$19$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_111#1;

  inline$BDLDevicePowerIoCompletion$19$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_111_true#1, inline$BDLDevicePowerIoCompletion$19$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_112#1;

  inline$BDLDevicePowerIoCompletion$19$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_115#1;

  inline$BDLDevicePowerIoCompletion$19$label_115#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_116#1;

  inline$BDLDevicePowerIoCompletion$19$label_116#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_117#1;

  inline$BDLDevicePowerIoCompletion$19$label_117#1:
    call inline$BDLDevicePowerIoCompletion$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$19$label_118#1;

  inline$BDLDevicePowerIoCompletion$19$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$19$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$19$label_112#1;

  inline$BDLDevicePowerIoCompletion$19$label_112#1:
    goto inline$BDLGetDebugLevel$510$Entry#1;

  inline$BDLGetDebugLevel$510$Entry#1:
    goto inline$BDLGetDebugLevel$510$start#1;

  inline$BDLGetDebugLevel$510$start#1:
    goto inline$BDLGetDebugLevel$510$label_3#1;

  inline$BDLGetDebugLevel$510$label_3#1:
    havoc inline$BDLGetDebugLevel$510$myNondetVar_0;
    inline$BDLGetDebugLevel$510$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$510$myNondetVar_0;
    goto inline$BDLGetDebugLevel$510$label_1#1;

  inline$BDLGetDebugLevel$510$label_1#1:
    goto inline$BDLGetDebugLevel$510$Return#1;

  inline$BDLGetDebugLevel$510$Return#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$510$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$19$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$19$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$19$anon44_Then#1, inline$BDLDevicePowerIoCompletion$19$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$19$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$anon29#1;

  inline$BDLDevicePowerIoCompletion$19$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_121#1;

  inline$BDLDevicePowerIoCompletion$19$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_121_true#1, inline$BDLDevicePowerIoCompletion$19$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$19$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_122#1;

  inline$BDLDevicePowerIoCompletion$19$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$19$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$19$label_123#1;

  inline$BDLDevicePowerIoCompletion$19$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$19$label_122#1;

  inline$BDLDevicePowerIoCompletion$19$label_122#1:
    inline$BDLDevicePowerIoCompletion$19$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$19$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$19$label_1#1;

  inline$BDLDevicePowerIoCompletion$19$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$19$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$19$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$19$Return#1;

  inline$BDLDevicePowerIoCompletion$19$Return#1:
    inline$CallCompletionRoutine$19$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$19$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$19$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$19$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$19$anon13_Then#1, inline$CallCompletionRoutine$19$anon13_Else#1;

  inline$CallCompletionRoutine$19$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$19$anon7#1;

  inline$CallCompletionRoutine$19$anon7#1:
    goto inline$CallCompletionRoutine$19$label_20_icall_return#1;

  inline$CallCompletionRoutine$19$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$19$Return#1;

  inline$CallCompletionRoutine$19$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$19$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$19$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$19$Entry#1;

  inline$BDLCallDriverCompletionRoutine$19$Entry#1:
    inline$BDLCallDriverCompletionRoutine$19$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$19$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$19$start#1;

  inline$BDLCallDriverCompletionRoutine$19$start#1:
    inline$BDLCallDriverCompletionRoutine$19$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$19$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$19$label_3#1;

  inline$BDLCallDriverCompletionRoutine$19$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$19$label_3_true#1, inline$BDLCallDriverCompletionRoutine$19$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$19$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$19$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$19$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$19$label_4#1;

  inline$BDLCallDriverCompletionRoutine$19$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$19$label_6#1;

  inline$BDLCallDriverCompletionRoutine$19$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$19$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$19$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$19$label_5#1;

  inline$BDLCallDriverCompletionRoutine$19$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$19$label_6#1;

  inline$BDLCallDriverCompletionRoutine$19$label_6#1:
    goto inline$storm_KeSetEvent$21$Entry#1;

  inline$storm_KeSetEvent$21$Entry#1:
    inline$storm_KeSetEvent$21$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$19$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$21$start#1;

  inline$storm_KeSetEvent$21$start#1:
    inline$storm_KeSetEvent$21$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$21$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$21$label_3#1;

  inline$storm_KeSetEvent$21$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$21$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$21$label_1#1;

  inline$storm_KeSetEvent$21$label_1#1:
    goto inline$storm_KeSetEvent$21$Return#1;

  inline$storm_KeSetEvent$21$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$19$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$19$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$19$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$19$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$19$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$19$anon1#1;

  inline$BDLCallDriverCompletionRoutine$19$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$19$label_9#1;

  inline$BDLCallDriverCompletionRoutine$19$label_9#1:
    inline$BDLCallDriverCompletionRoutine$19$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$19$label_1#1;

  inline$BDLCallDriverCompletionRoutine$19$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$19$Return#1;

  inline$BDLCallDriverCompletionRoutine$19$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$19$Return#1;

  inline$BDLCallDriverCompletionRoutine$19$Return#1:
    inline$CallCompletionRoutine$19$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$19$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$19$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$19$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$19$anon12_Then#1, inline$CallCompletionRoutine$19$anon12_Else#1;

  inline$CallCompletionRoutine$19$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$19$anon5#1;

  inline$CallCompletionRoutine$19$anon5#1:
    goto inline$CallCompletionRoutine$19$label_20_icall_return#1;

  inline$CallCompletionRoutine$19$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$19$label_23#1;

  inline$CallCompletionRoutine$19$label_23#1:
    inline$CallCompletionRoutine$19$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$19$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$19$label_24#1;

  inline$CallCompletionRoutine$19$label_24#1:
    goto inline$CallCompletionRoutine$19$label_24_true#1, inline$CallCompletionRoutine$19$label_24_false#1;

  inline$CallCompletionRoutine$19$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$19$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$19$label_1#1;

  inline$CallCompletionRoutine$19$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$19$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$19$label_25#1;

  inline$CallCompletionRoutine$19$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$19$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$19$label_1#1;

  inline$CallCompletionRoutine$19$label_1#1:
    goto inline$CallCompletionRoutine$19$Return#1;

  inline$CallCompletionRoutine$19$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$19$Return#1;

  inline$CallCompletionRoutine$19$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$19$Return#1;

  inline$CallCompletionRoutine$19$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$19$Return#1;

  inline$CallCompletionRoutine$19$Return#1:
    goto inline$storm_IoCallDriver$9$label_39$1#1;

  inline$storm_IoCallDriver$9$label_39$1#1:
    goto inline$storm_IoCallDriver$9$anon15_Then#1, inline$storm_IoCallDriver$9$anon15_Else#1;

  inline$storm_IoCallDriver$9$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$9$anon10#1;

  inline$storm_IoCallDriver$9$anon10#1:
    goto inline$storm_IoCallDriver$9$label_36#1;

  inline$storm_IoCallDriver$9$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$9$Return#1;

  inline$storm_IoCallDriver$9$label_27_case_0#1:
    assume inline$storm_IoCallDriver$9$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$9$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$9$label_28#1;

  inline$storm_IoCallDriver$9$label_28#1:
    inline$storm_IoCallDriver$9$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$9$label_42#1;

  inline$storm_IoCallDriver$9$label_42#1:
    goto inline$storm_IoCallDriver$9$label_43#1;

  inline$storm_IoCallDriver$9$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$9$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$9$label_36#1;

  inline$storm_IoCallDriver$9$label_36#1:
    inline$storm_IoCallDriver$9$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$9$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$9$label_1#1;

  inline$storm_IoCallDriver$9$label_1#1:
    goto inline$storm_IoCallDriver$9$Return#1;

  inline$storm_IoCallDriver$9$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$9$Return#1;

  inline$storm_IoCallDriver$9$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$9$Return#1;

  inline$storm_IoCallDriver$9$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$9$Return#1;

  inline$storm_IoCallDriver$9$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_IoCallDriver$108.29$4$ := inline$storm_IoCallDriver$9$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_19$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_19$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon20_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon20_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon9#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon9#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_42#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_42#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_IoCallDriver$108.29$4$;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_18_true#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0;
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_22#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_22#1:
    call PoStartNextPowerIrp(inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon21_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon21_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon21_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon11#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon11#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_25#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_25#1:
    goto inline$storm_PoCallDriver$4$Entry#1;

  inline$storm_PoCallDriver$4$Entry#1:
    inline$storm_PoCallDriver$4$$Irp$2$496.14$storm_PoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_PoCallDriver$4$start#1;

  inline$storm_PoCallDriver$4$start#1:
    inline$storm_PoCallDriver$4$$Irp$2$496.14$storm_PoCallDriver$8 := inline$storm_PoCallDriver$4$$Irp$2$496.14$storm_PoCallDriver$8_.1;
    goto inline$storm_PoCallDriver$4$label_3#1;

  inline$storm_PoCallDriver$4$label_3#1:
    goto inline$storm_IoCallDriver$10$Entry#1;

  inline$storm_IoCallDriver$10$Entry#1:
    inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$storm_PoCallDriver$4$$Irp$2$496.14$storm_PoCallDriver$8;
    goto inline$storm_IoCallDriver$10$start#1;

  inline$storm_IoCallDriver$10$start#1:
    inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$10$label_3#1;

  inline$storm_IoCallDriver$10$label_3#1:
    goto inline$storm_IoCallDriver$10$label_4#1;

  inline$storm_IoCallDriver$10$label_4#1:
    goto inline$storm_IoCallDriver$10$label_5#1;

  inline$storm_IoCallDriver$10$label_5#1:
    goto inline$storm_IoCallDriver$10$label_6#1;

  inline$storm_IoCallDriver$10$label_6#1:
    call inline$storm_IoCallDriver$10$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$10$label_9#1;

  inline$storm_IoCallDriver$10$label_9#1:
    goto inline$storm_IoCallDriver$10$label_9_true#1, inline$storm_IoCallDriver$10$label_9_false#1;

  inline$storm_IoCallDriver$10$label_9_false#1:
    assume inline$storm_IoCallDriver$10$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$10$label_10#1;

  inline$storm_IoCallDriver$10$label_9_true#1:
    assume inline$storm_IoCallDriver$10$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$10$label_13#1;

  inline$storm_IoCallDriver$10$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$10$anon12_Then#1, inline$storm_IoCallDriver$10$anon12_Else#1;

  inline$storm_IoCallDriver$10$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$10$anon3#1;

  inline$storm_IoCallDriver$10$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$10$label_14#1;

  inline$storm_IoCallDriver$10$label_14#1:
    goto inline$storm_IoCallDriver$10$label_14_true#1, inline$storm_IoCallDriver$10$label_14_false#1;

  inline$storm_IoCallDriver$10$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$10$label_15#1;

  inline$storm_IoCallDriver$10$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$10$label_1#1;

  inline$storm_IoCallDriver$10$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$10$label_10#1;

  inline$storm_IoCallDriver$10$label_10#1:
    goto inline$IoSetNextIrpStackLocation$11$Entry#1;

  inline$IoSetNextIrpStackLocation$11$Entry#1:
    inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$11$start#1;

  inline$IoSetNextIrpStackLocation$11$start#1:
    inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$11$label_3#1;

  inline$IoSetNextIrpStackLocation$11$label_3#1:
    goto inline$IoSetNextIrpStackLocation$11$label_3_true#1, inline$IoSetNextIrpStackLocation$11$label_3_false#1;

  inline$IoSetNextIrpStackLocation$11$label_3_false#1:
    inline$IoSetNextIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$11$myVar_0);
    goto inline$IoSetNextIrpStackLocation$11$label_4#1;

  inline$IoSetNextIrpStackLocation$11$label_4#1:
    call inline$IoSetNextIrpStackLocation$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$11$label_7#1;

  inline$IoSetNextIrpStackLocation$11$label_7#1:
    call inline$IoSetNextIrpStackLocation$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$11$label_8#1;

  inline$IoSetNextIrpStackLocation$11$label_8#1:
    goto inline$IoSetNextIrpStackLocation$11$label_5#1;

  inline$IoSetNextIrpStackLocation$11$label_3_true#1:
    inline$IoSetNextIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$11$myVar_0);
    goto inline$IoSetNextIrpStackLocation$11$label_5#1;

  inline$IoSetNextIrpStackLocation$11$label_5#1:
    inline$IoSetNextIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$11$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$11$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$11$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$11$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$11$label_6#1;

  inline$IoSetNextIrpStackLocation$11$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$11$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$11$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$11$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$11$label_1#1;

  inline$IoSetNextIrpStackLocation$11$label_1#1:
    goto inline$IoSetNextIrpStackLocation$11$Return#1;

  inline$IoSetNextIrpStackLocation$11$Return#1:
    goto inline$storm_IoCallDriver$10$label_10$1#1;

  inline$storm_IoCallDriver$10$label_10$1#1:
    goto inline$storm_IoCallDriver$10$anon11_Then#1, inline$storm_IoCallDriver$10$anon11_Else#1;

  inline$storm_IoCallDriver$10$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$10$anon1#1;

  inline$storm_IoCallDriver$10$anon1#1:
    goto inline$storm_IoCallDriver$10$label_18#1;

  inline$storm_IoCallDriver$10$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$103$Entry#1;

  inline$IoGetCurrentIrpStackLocation$103$Entry#1:
    inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$103$start#1;

  inline$IoGetCurrentIrpStackLocation$103$start#1:
    inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$103$label_3#1;

  inline$IoGetCurrentIrpStackLocation$103$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$103$label_3_true#1, inline$IoGetCurrentIrpStackLocation$103$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$103$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$103$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$103$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$103$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$103$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$103$label_4#1;

  inline$IoGetCurrentIrpStackLocation$103$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$103$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$103$label_6#1;

  inline$IoGetCurrentIrpStackLocation$103$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$103$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$103$label_7#1;

  inline$IoGetCurrentIrpStackLocation$103$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$103$label_5#1;

  inline$IoGetCurrentIrpStackLocation$103$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$103$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$103$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$103$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$103$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$103$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$103$label_5#1;

  inline$IoGetCurrentIrpStackLocation$103$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$103$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$103$label_1#1;

  inline$IoGetCurrentIrpStackLocation$103$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$103$Return#1;

  inline$IoGetCurrentIrpStackLocation$103$Return#1:
    goto inline$storm_IoCallDriver$10$label_18$1#1;

  inline$storm_IoCallDriver$10$label_18$1#1:
    goto inline$storm_IoCallDriver$10$anon13_Then#1, inline$storm_IoCallDriver$10$anon13_Else#1;

  inline$storm_IoCallDriver$10$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$10$anon6#1;

  inline$storm_IoCallDriver$10$anon6#1:
    goto inline$storm_IoCallDriver$10$label_21#1;

  inline$storm_IoCallDriver$10$label_21#1:
    goto inline$storm_IoCallDriver$10$label_22#1;

  inline$storm_IoCallDriver$10$label_22#1:
    goto inline$storm_IoCallDriver$10$label_23#1;

  inline$storm_IoCallDriver$10$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$10$label_24#1;

  inline$storm_IoCallDriver$10$label_24#1:
    call inline$storm_IoCallDriver$10$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$10$label_27#1;

  inline$storm_IoCallDriver$10$label_27#1:
    goto inline$storm_IoCallDriver$10$label_27_case_0#1, inline$storm_IoCallDriver$10$label_27_case_1#1, inline$storm_IoCallDriver$10$label_27_case_2#1;

  inline$storm_IoCallDriver$10$label_27_case_2#1:
    assume inline$storm_IoCallDriver$10$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$10$label_30#1;

  inline$storm_IoCallDriver$10$label_30#1:
    inline$storm_IoCallDriver$10$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$10$label_31#1;

  inline$storm_IoCallDriver$10$label_31#1:
    goto inline$storm_IoCallDriver$10$label_32#1;

  inline$storm_IoCallDriver$10$label_32#1:
    goto inline$storm_IoCallDriver$10$label_33#1;

  inline$storm_IoCallDriver$10$label_33#1:
    goto inline$CallCompletionRoutine$20$Entry#1;

  inline$CallCompletionRoutine$20$Entry#1:
    inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$20$start#1;

  inline$CallCompletionRoutine$20$start#1:
    inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$20$label_3#1;

  inline$CallCompletionRoutine$20$label_3#1:
    goto inline$CallCompletionRoutine$20$label_4#1;

  inline$CallCompletionRoutine$20$label_4#1:
    goto inline$CallCompletionRoutine$20$label_5#1;

  inline$CallCompletionRoutine$20$label_5#1:
    goto inline$CallCompletionRoutine$20$label_6#1;

  inline$CallCompletionRoutine$20$label_6#1:
    goto inline$CallCompletionRoutine$20$label_7#1;

  inline$CallCompletionRoutine$20$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$104$Entry#1;

  inline$IoGetCurrentIrpStackLocation$104$Entry#1:
    inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$104$start#1;

  inline$IoGetCurrentIrpStackLocation$104$start#1:
    inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$104$label_3#1;

  inline$IoGetCurrentIrpStackLocation$104$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$104$label_3_true#1, inline$IoGetCurrentIrpStackLocation$104$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$104$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$104$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$104$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$104$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$104$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$104$label_4#1;

  inline$IoGetCurrentIrpStackLocation$104$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$104$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$104$label_6#1;

  inline$IoGetCurrentIrpStackLocation$104$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$104$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$104$label_7#1;

  inline$IoGetCurrentIrpStackLocation$104$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$104$label_5#1;

  inline$IoGetCurrentIrpStackLocation$104$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$104$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$104$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$104$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$104$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$104$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$104$label_5#1;

  inline$IoGetCurrentIrpStackLocation$104$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$104$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$104$label_1#1;

  inline$IoGetCurrentIrpStackLocation$104$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$104$Return#1;

  inline$IoGetCurrentIrpStackLocation$104$Return#1:
    goto inline$CallCompletionRoutine$20$label_7$1#1;

  inline$CallCompletionRoutine$20$label_7$1#1:
    goto inline$CallCompletionRoutine$20$anon10_Then#1, inline$CallCompletionRoutine$20$anon10_Else#1;

  inline$CallCompletionRoutine$20$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$20$anon1#1;

  inline$CallCompletionRoutine$20$anon1#1:
    goto inline$CallCompletionRoutine$20$label_10#1;

  inline$CallCompletionRoutine$20$label_10#1:
    goto inline$CallCompletionRoutine$20$label_11#1;

  inline$CallCompletionRoutine$20$label_11#1:
    havoc inline$CallCompletionRoutine$20$myNondetVar_0;
    inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$20$myNondetVar_0;
    goto inline$CallCompletionRoutine$20$label_12#1;

  inline$CallCompletionRoutine$20$label_12#1:
    havoc inline$CallCompletionRoutine$20$myNondetVar_0;
    inline$CallCompletionRoutine$20$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$20$myNondetVar_0;
    goto inline$CallCompletionRoutine$20$label_13#1;

  inline$CallCompletionRoutine$20$label_13#1:
    havoc inline$CallCompletionRoutine$20$myNondetVar_0;
    goto inline$CallCompletionRoutine$20$label_14#1;

  inline$CallCompletionRoutine$20$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$105$Entry#1;

  inline$IoGetCurrentIrpStackLocation$105$Entry#1:
    inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$105$start#1;

  inline$IoGetCurrentIrpStackLocation$105$start#1:
    inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$105$label_3#1;

  inline$IoGetCurrentIrpStackLocation$105$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$105$label_3_true#1, inline$IoGetCurrentIrpStackLocation$105$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$105$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$105$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$105$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$105$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$105$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$105$label_4#1;

  inline$IoGetCurrentIrpStackLocation$105$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$105$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$105$label_6#1;

  inline$IoGetCurrentIrpStackLocation$105$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$105$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$105$label_7#1;

  inline$IoGetCurrentIrpStackLocation$105$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$105$label_5#1;

  inline$IoGetCurrentIrpStackLocation$105$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$105$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$105$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$105$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$105$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$105$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$105$label_5#1;

  inline$IoGetCurrentIrpStackLocation$105$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$105$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$105$label_1#1;

  inline$IoGetCurrentIrpStackLocation$105$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$105$Return#1;

  inline$IoGetCurrentIrpStackLocation$105$Return#1:
    goto inline$CallCompletionRoutine$20$label_14$1#1;

  inline$CallCompletionRoutine$20$label_14$1#1:
    goto inline$CallCompletionRoutine$20$anon11_Then#1, inline$CallCompletionRoutine$20$anon11_Else#1;

  inline$CallCompletionRoutine$20$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$20$anon3#1;

  inline$CallCompletionRoutine$20$anon3#1:
    goto inline$CallCompletionRoutine$20$label_17#1;

  inline$CallCompletionRoutine$20$label_17#1:
    goto inline$CallCompletionRoutine$20$label_18#1;

  inline$CallCompletionRoutine$20$label_18#1:
    goto inline$CallCompletionRoutine$20$label_18_true#1, inline$CallCompletionRoutine$20$label_18_false#1;

  inline$CallCompletionRoutine$20$label_18_false#1:
    assume inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$20$label_1#1;

  inline$CallCompletionRoutine$20$label_18_true#1:
    assume inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$20$label_19#1;

  inline$CallCompletionRoutine$20$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$20$label_20#1;

  inline$CallCompletionRoutine$20$label_20#1:
    goto inline$CallCompletionRoutine$20$label_20_icall_1#1, inline$CallCompletionRoutine$20$label_20_icall_2#1, inline$CallCompletionRoutine$20$label_20_icall_3#1;

  inline$CallCompletionRoutine$20$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$20$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$20$Entry#1;

  inline$BDLSystemPowerIoCompletion$20$Entry#1:
    inline$BDLSystemPowerIoCompletion$20$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$20$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$20$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$20$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$20$start#1;

  inline$BDLSystemPowerIoCompletion$20$start#1:
    call inline$BDLSystemPowerIoCompletion$20$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$20$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$20$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$20$label_3#1;

  inline$BDLSystemPowerIoCompletion$20$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_4#1;

  inline$BDLSystemPowerIoCompletion$20$label_4#1:
    inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_5#1;

  inline$BDLSystemPowerIoCompletion$20$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_6#1;

  inline$BDLSystemPowerIoCompletion$20$label_6#1:
    inline$BDLSystemPowerIoCompletion$20$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$20$label_7#1;

  inline$BDLSystemPowerIoCompletion$20$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_8#1;

  inline$BDLSystemPowerIoCompletion$20$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$20$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$20$label_9#1;

  inline$BDLSystemPowerIoCompletion$20$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_10#1;

  inline$BDLSystemPowerIoCompletion$20$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$107$Entry#1;

  inline$IoGetCurrentIrpStackLocation$107$Entry#1:
    inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$107$start#1;

  inline$IoGetCurrentIrpStackLocation$107$start#1:
    inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$107$label_3#1;

  inline$IoGetCurrentIrpStackLocation$107$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$107$label_3_true#1, inline$IoGetCurrentIrpStackLocation$107$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$107$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$107$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$107$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$107$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$107$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$107$label_4#1;

  inline$IoGetCurrentIrpStackLocation$107$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$107$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$107$label_6#1;

  inline$IoGetCurrentIrpStackLocation$107$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$107$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$107$label_7#1;

  inline$IoGetCurrentIrpStackLocation$107$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$107$label_5#1;

  inline$IoGetCurrentIrpStackLocation$107$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$107$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$107$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$107$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$107$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$107$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$107$label_5#1;

  inline$IoGetCurrentIrpStackLocation$107$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$107$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$107$label_1#1;

  inline$IoGetCurrentIrpStackLocation$107$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$107$Return#1;

  inline$IoGetCurrentIrpStackLocation$107$Return#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon36_Then#1, inline$BDLSystemPowerIoCompletion$20$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon1#1;

  inline$BDLSystemPowerIoCompletion$20$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_13#1;

  inline$BDLSystemPowerIoCompletion$20$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_14#1;

  inline$BDLSystemPowerIoCompletion$20$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_15#1;

  inline$BDLSystemPowerIoCompletion$20$label_15#1:
    goto inline$BDLGetDebugLevel$532$Entry#1;

  inline$BDLGetDebugLevel$532$Entry#1:
    goto inline$BDLGetDebugLevel$532$start#1;

  inline$BDLGetDebugLevel$532$start#1:
    goto inline$BDLGetDebugLevel$532$label_3#1;

  inline$BDLGetDebugLevel$532$label_3#1:
    havoc inline$BDLGetDebugLevel$532$myNondetVar_0;
    inline$BDLGetDebugLevel$532$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$532$myNondetVar_0;
    goto inline$BDLGetDebugLevel$532$label_1#1;

  inline$BDLGetDebugLevel$532$label_1#1:
    goto inline$BDLGetDebugLevel$532$Return#1;

  inline$BDLGetDebugLevel$532$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$532$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon37_Then#1, inline$BDLSystemPowerIoCompletion$20$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon3#1;

  inline$BDLSystemPowerIoCompletion$20$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_18#1;

  inline$BDLSystemPowerIoCompletion$20$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_18_true#1, inline$BDLSystemPowerIoCompletion$20$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_19#1;

  inline$BDLSystemPowerIoCompletion$20$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_22#1;

  inline$BDLSystemPowerIoCompletion$20$label_22#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_23#1;

  inline$BDLSystemPowerIoCompletion$20$label_23#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_24#1;

  inline$BDLSystemPowerIoCompletion$20$label_24#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_25#1;

  inline$BDLSystemPowerIoCompletion$20$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$20$label_19#1;

  inline$BDLSystemPowerIoCompletion$20$label_19#1:
    goto inline$BDLGetDebugLevel$533$Entry#1;

  inline$BDLGetDebugLevel$533$Entry#1:
    goto inline$BDLGetDebugLevel$533$start#1;

  inline$BDLGetDebugLevel$533$start#1:
    goto inline$BDLGetDebugLevel$533$label_3#1;

  inline$BDLGetDebugLevel$533$label_3#1:
    havoc inline$BDLGetDebugLevel$533$myNondetVar_0;
    inline$BDLGetDebugLevel$533$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$533$myNondetVar_0;
    goto inline$BDLGetDebugLevel$533$label_1#1;

  inline$BDLGetDebugLevel$533$label_1#1:
    goto inline$BDLGetDebugLevel$533$Return#1;

  inline$BDLGetDebugLevel$533$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$533$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon38_Then#1, inline$BDLSystemPowerIoCompletion$20$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon5#1;

  inline$BDLSystemPowerIoCompletion$20$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_28#1;

  inline$BDLSystemPowerIoCompletion$20$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_28_true#1, inline$BDLSystemPowerIoCompletion$20$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_29#1;

  inline$BDLSystemPowerIoCompletion$20$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_32#1;

  inline$BDLSystemPowerIoCompletion$20$label_32#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_33#1;

  inline$BDLSystemPowerIoCompletion$20$label_33#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_34#1;

  inline$BDLSystemPowerIoCompletion$20$label_34#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_35#1;

  inline$BDLSystemPowerIoCompletion$20$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$20$label_29#1;

  inline$BDLSystemPowerIoCompletion$20$label_29#1:
    goto inline$BDLGetDebugLevel$534$Entry#1;

  inline$BDLGetDebugLevel$534$Entry#1:
    goto inline$BDLGetDebugLevel$534$start#1;

  inline$BDLGetDebugLevel$534$start#1:
    goto inline$BDLGetDebugLevel$534$label_3#1;

  inline$BDLGetDebugLevel$534$label_3#1:
    havoc inline$BDLGetDebugLevel$534$myNondetVar_0;
    inline$BDLGetDebugLevel$534$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$534$myNondetVar_0;
    goto inline$BDLGetDebugLevel$534$label_1#1;

  inline$BDLGetDebugLevel$534$label_1#1:
    goto inline$BDLGetDebugLevel$534$Return#1;

  inline$BDLGetDebugLevel$534$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$534$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon39_Then#1, inline$BDLSystemPowerIoCompletion$20$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon7#1;

  inline$BDLSystemPowerIoCompletion$20$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_38#1;

  inline$BDLSystemPowerIoCompletion$20$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_38_true#1, inline$BDLSystemPowerIoCompletion$20$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_39#1;

  inline$BDLSystemPowerIoCompletion$20$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_40#1;

  inline$BDLSystemPowerIoCompletion$20$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_39#1;

  inline$BDLSystemPowerIoCompletion$20$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_39_true#1, inline$BDLSystemPowerIoCompletion$20$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_41#1;

  inline$BDLSystemPowerIoCompletion$20$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$20$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$20$label_107#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$20$label_108#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$20$label_108#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$20$label_108#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$20$label_108#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$20$label_108#1;

  inline$BDLSystemPowerIoCompletion$20$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_109#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$20$label_107#1;

  inline$BDLSystemPowerIoCompletion$20$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_109#1;

  inline$BDLSystemPowerIoCompletion$20$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$20$label_106#1;

  inline$BDLSystemPowerIoCompletion$20$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_106_true#1, inline$BDLSystemPowerIoCompletion$20$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_142#1;

  inline$BDLSystemPowerIoCompletion$20$label_142#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_143#1;

  inline$BDLSystemPowerIoCompletion$20$label_143#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_144#1;

  inline$BDLSystemPowerIoCompletion$20$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_109#1;

  inline$BDLSystemPowerIoCompletion$20$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_109#1;

  inline$BDLSystemPowerIoCompletion$20$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$20$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$20$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$20$myNondetVar_0, inline$BDLSystemPowerIoCompletion$20$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$20$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$20$anon50_Then#1, inline$BDLSystemPowerIoCompletion$20$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon29#1;

  inline$BDLSystemPowerIoCompletion$20$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_112#1;

  inline$BDLSystemPowerIoCompletion$20$label_112#1:
    inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$20$label_113#1;

  inline$BDLSystemPowerIoCompletion$20$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_113_true#1, inline$BDLSystemPowerIoCompletion$20$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$20$label_114#1;

  inline$BDLSystemPowerIoCompletion$20$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_116#1;

  inline$BDLSystemPowerIoCompletion$20$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_117#1;

  inline$BDLSystemPowerIoCompletion$20$label_117#1:
    goto inline$BDLGetDebugLevel$541$Entry#1;

  inline$BDLGetDebugLevel$541$Entry#1:
    goto inline$BDLGetDebugLevel$541$start#1;

  inline$BDLGetDebugLevel$541$start#1:
    goto inline$BDLGetDebugLevel$541$label_3#1;

  inline$BDLGetDebugLevel$541$label_3#1:
    havoc inline$BDLGetDebugLevel$541$myNondetVar_0;
    inline$BDLGetDebugLevel$541$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$541$myNondetVar_0;
    goto inline$BDLGetDebugLevel$541$label_1#1;

  inline$BDLGetDebugLevel$541$label_1#1:
    goto inline$BDLGetDebugLevel$541$Return#1;

  inline$BDLGetDebugLevel$541$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$541$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon51_Then#1, inline$BDLSystemPowerIoCompletion$20$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon31#1;

  inline$BDLSystemPowerIoCompletion$20$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_120#1;

  inline$BDLSystemPowerIoCompletion$20$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_120_true#1, inline$BDLSystemPowerIoCompletion$20$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_121#1;

  inline$BDLSystemPowerIoCompletion$20$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_124#1;

  inline$BDLSystemPowerIoCompletion$20$label_124#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_125#1;

  inline$BDLSystemPowerIoCompletion$20$label_125#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_126#1;

  inline$BDLSystemPowerIoCompletion$20$label_126#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_127#1;

  inline$BDLSystemPowerIoCompletion$20$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$20$label_121#1;

  inline$BDLSystemPowerIoCompletion$20$label_121#1:
    goto inline$BDLGetDebugLevel$542$Entry#1;

  inline$BDLGetDebugLevel$542$Entry#1:
    goto inline$BDLGetDebugLevel$542$start#1;

  inline$BDLGetDebugLevel$542$start#1:
    goto inline$BDLGetDebugLevel$542$label_3#1;

  inline$BDLGetDebugLevel$542$label_3#1:
    havoc inline$BDLGetDebugLevel$542$myNondetVar_0;
    inline$BDLGetDebugLevel$542$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$542$myNondetVar_0;
    goto inline$BDLGetDebugLevel$542$label_1#1;

  inline$BDLGetDebugLevel$542$label_1#1:
    goto inline$BDLGetDebugLevel$542$Return#1;

  inline$BDLGetDebugLevel$542$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$542$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon52_Then#1, inline$BDLSystemPowerIoCompletion$20$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon33#1;

  inline$BDLSystemPowerIoCompletion$20$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_130#1;

  inline$BDLSystemPowerIoCompletion$20$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_130_true#1, inline$BDLSystemPowerIoCompletion$20$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_131#1;

  inline$BDLSystemPowerIoCompletion$20$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_134#1;

  inline$BDLSystemPowerIoCompletion$20$label_134#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_135#1;

  inline$BDLSystemPowerIoCompletion$20$label_135#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_136#1;

  inline$BDLSystemPowerIoCompletion$20$label_136#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_137#1;

  inline$BDLSystemPowerIoCompletion$20$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$20$label_131#1;

  inline$BDLSystemPowerIoCompletion$20$label_131#1:
    goto inline$BDLGetDebugLevel$543$Entry#1;

  inline$BDLGetDebugLevel$543$Entry#1:
    goto inline$BDLGetDebugLevel$543$start#1;

  inline$BDLGetDebugLevel$543$start#1:
    goto inline$BDLGetDebugLevel$543$label_3#1;

  inline$BDLGetDebugLevel$543$label_3#1:
    havoc inline$BDLGetDebugLevel$543$myNondetVar_0;
    inline$BDLGetDebugLevel$543$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$543$myNondetVar_0;
    goto inline$BDLGetDebugLevel$543$label_1#1;

  inline$BDLGetDebugLevel$543$label_1#1:
    goto inline$BDLGetDebugLevel$543$Return#1;

  inline$BDLGetDebugLevel$543$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$543$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon53_Then#1, inline$BDLSystemPowerIoCompletion$20$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon35#1;

  inline$BDLSystemPowerIoCompletion$20$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_140#1;

  inline$BDLSystemPowerIoCompletion$20$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_140_true#1, inline$BDLSystemPowerIoCompletion$20$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_67#1;

  inline$BDLSystemPowerIoCompletion$20$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_141#1;

  inline$BDLSystemPowerIoCompletion$20$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_67#1;

  inline$BDLSystemPowerIoCompletion$20$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$20$label_115#1;

  inline$BDLSystemPowerIoCompletion$20$label_115#1:
    inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$20$label_80#1;

  inline$BDLSystemPowerIoCompletion$20$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$20$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_42#1;

  inline$BDLSystemPowerIoCompletion$20$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$20$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$20$label_43#1;

  inline$BDLSystemPowerIoCompletion$20$label_43#1:
    goto inline$BDLGetDebugLevel$535$Entry#1;

  inline$BDLGetDebugLevel$535$Entry#1:
    goto inline$BDLGetDebugLevel$535$start#1;

  inline$BDLGetDebugLevel$535$start#1:
    goto inline$BDLGetDebugLevel$535$label_3#1;

  inline$BDLGetDebugLevel$535$label_3#1:
    havoc inline$BDLGetDebugLevel$535$myNondetVar_0;
    inline$BDLGetDebugLevel$535$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$535$myNondetVar_0;
    goto inline$BDLGetDebugLevel$535$label_1#1;

  inline$BDLGetDebugLevel$535$label_1#1:
    goto inline$BDLGetDebugLevel$535$Return#1;

  inline$BDLGetDebugLevel$535$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$535$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon40_Then#1, inline$BDLSystemPowerIoCompletion$20$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon9#1;

  inline$BDLSystemPowerIoCompletion$20$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_46#1;

  inline$BDLSystemPowerIoCompletion$20$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_46_true#1, inline$BDLSystemPowerIoCompletion$20$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_47#1;

  inline$BDLSystemPowerIoCompletion$20$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_50#1;

  inline$BDLSystemPowerIoCompletion$20$label_50#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_51#1;

  inline$BDLSystemPowerIoCompletion$20$label_51#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_52#1;

  inline$BDLSystemPowerIoCompletion$20$label_52#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_53#1;

  inline$BDLSystemPowerIoCompletion$20$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$20$label_47#1;

  inline$BDLSystemPowerIoCompletion$20$label_47#1:
    goto inline$BDLGetDebugLevel$536$Entry#1;

  inline$BDLGetDebugLevel$536$Entry#1:
    goto inline$BDLGetDebugLevel$536$start#1;

  inline$BDLGetDebugLevel$536$start#1:
    goto inline$BDLGetDebugLevel$536$label_3#1;

  inline$BDLGetDebugLevel$536$label_3#1:
    havoc inline$BDLGetDebugLevel$536$myNondetVar_0;
    inline$BDLGetDebugLevel$536$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$536$myNondetVar_0;
    goto inline$BDLGetDebugLevel$536$label_1#1;

  inline$BDLGetDebugLevel$536$label_1#1:
    goto inline$BDLGetDebugLevel$536$Return#1;

  inline$BDLGetDebugLevel$536$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$536$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon41_Then#1, inline$BDLSystemPowerIoCompletion$20$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon11#1;

  inline$BDLSystemPowerIoCompletion$20$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_56#1;

  inline$BDLSystemPowerIoCompletion$20$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_56_true#1, inline$BDLSystemPowerIoCompletion$20$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_57#1;

  inline$BDLSystemPowerIoCompletion$20$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_60#1;

  inline$BDLSystemPowerIoCompletion$20$label_60#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_61#1;

  inline$BDLSystemPowerIoCompletion$20$label_61#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_62#1;

  inline$BDLSystemPowerIoCompletion$20$label_62#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_63#1;

  inline$BDLSystemPowerIoCompletion$20$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$20$label_57#1;

  inline$BDLSystemPowerIoCompletion$20$label_57#1:
    goto inline$BDLGetDebugLevel$537$Entry#1;

  inline$BDLGetDebugLevel$537$Entry#1:
    goto inline$BDLGetDebugLevel$537$start#1;

  inline$BDLGetDebugLevel$537$start#1:
    goto inline$BDLGetDebugLevel$537$label_3#1;

  inline$BDLGetDebugLevel$537$label_3#1:
    havoc inline$BDLGetDebugLevel$537$myNondetVar_0;
    inline$BDLGetDebugLevel$537$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$537$myNondetVar_0;
    goto inline$BDLGetDebugLevel$537$label_1#1;

  inline$BDLGetDebugLevel$537$label_1#1:
    goto inline$BDLGetDebugLevel$537$Return#1;

  inline$BDLGetDebugLevel$537$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$537$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon42_Then#1, inline$BDLSystemPowerIoCompletion$20$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon13#1;

  inline$BDLSystemPowerIoCompletion$20$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_66#1;

  inline$BDLSystemPowerIoCompletion$20$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_66_true#1, inline$BDLSystemPowerIoCompletion$20$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_67#1;

  inline$BDLSystemPowerIoCompletion$20$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_70#1;

  inline$BDLSystemPowerIoCompletion$20$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_67#1;

  inline$BDLSystemPowerIoCompletion$20$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$20$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$20$anon43_Then#1, inline$BDLSystemPowerIoCompletion$20$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon15#1;

  inline$BDLSystemPowerIoCompletion$20$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_71#1;

  inline$BDLSystemPowerIoCompletion$20$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$20$anon44_Then#1, inline$BDLSystemPowerIoCompletion$20$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon17#1;

  inline$BDLSystemPowerIoCompletion$20$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_74#1;

  inline$BDLSystemPowerIoCompletion$20$label_74#1:
    goto inline$storm_IoCompleteRequest$42$Entry#1;

  inline$storm_IoCompleteRequest$42$Entry#1:
    inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$20$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$42$start#1;

  inline$storm_IoCompleteRequest$42$start#1:
    inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$42$label_3#1;

  inline$storm_IoCompleteRequest$42$label_3#1:
    call inline$storm_IoCompleteRequest$42$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$42$label_6#1;

  inline$storm_IoCompleteRequest$42$label_6#1:
    goto inline$storm_IoCompleteRequest$42$label_6_true#1, inline$storm_IoCompleteRequest$42$label_6_false#1;

  inline$storm_IoCompleteRequest$42$label_6_false#1:
    assume inline$storm_IoCompleteRequest$42$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$42$label_7#1;

  inline$storm_IoCompleteRequest$42$label_6_true#1:
    assume inline$storm_IoCompleteRequest$42$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$42$label_8#1;

  inline$storm_IoCompleteRequest$42$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$42$anon3_Then#1, inline$storm_IoCompleteRequest$42$anon3_Else#1;

  inline$storm_IoCompleteRequest$42$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$42$anon1#1;

  inline$storm_IoCompleteRequest$42$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$42$label_9#1;

  inline$storm_IoCompleteRequest$42$label_9#1:
    goto inline$storm_IoCompleteRequest$42$label_9_true#1, inline$storm_IoCompleteRequest$42$label_9_false#1;

  inline$storm_IoCompleteRequest$42$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$42$label_10#1;

  inline$storm_IoCompleteRequest$42$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$42$label_1#1;

  inline$storm_IoCompleteRequest$42$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$42$label_7#1;

  inline$storm_IoCompleteRequest$42$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$42$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$42$label_1#1;

  inline$storm_IoCompleteRequest$42$label_1#1:
    goto inline$storm_IoCompleteRequest$42$Return#1;

  inline$storm_IoCompleteRequest$42$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$42$Return#1;

  inline$storm_IoCompleteRequest$42$Return#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon45_Then#1, inline$BDLSystemPowerIoCompletion$20$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon19#1;

  inline$BDLSystemPowerIoCompletion$20$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_77#1;

  inline$BDLSystemPowerIoCompletion$20$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$20$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$20$anon46_Then#1, inline$BDLSystemPowerIoCompletion$20$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon21#1;

  inline$BDLSystemPowerIoCompletion$20$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_80#1;

  inline$BDLSystemPowerIoCompletion$20$label_80#1:
    goto inline$BDLGetDebugLevel$538$Entry#1;

  inline$BDLGetDebugLevel$538$Entry#1:
    goto inline$BDLGetDebugLevel$538$start#1;

  inline$BDLGetDebugLevel$538$start#1:
    goto inline$BDLGetDebugLevel$538$label_3#1;

  inline$BDLGetDebugLevel$538$label_3#1:
    havoc inline$BDLGetDebugLevel$538$myNondetVar_0;
    inline$BDLGetDebugLevel$538$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$538$myNondetVar_0;
    goto inline$BDLGetDebugLevel$538$label_1#1;

  inline$BDLGetDebugLevel$538$label_1#1:
    goto inline$BDLGetDebugLevel$538$Return#1;

  inline$BDLGetDebugLevel$538$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$538$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon47_Then#1, inline$BDLSystemPowerIoCompletion$20$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon23#1;

  inline$BDLSystemPowerIoCompletion$20$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_83#1;

  inline$BDLSystemPowerIoCompletion$20$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_83_true#1, inline$BDLSystemPowerIoCompletion$20$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_84#1;

  inline$BDLSystemPowerIoCompletion$20$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_87#1;

  inline$BDLSystemPowerIoCompletion$20$label_87#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_88#1;

  inline$BDLSystemPowerIoCompletion$20$label_88#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_89#1;

  inline$BDLSystemPowerIoCompletion$20$label_89#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_90#1;

  inline$BDLSystemPowerIoCompletion$20$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$20$label_84#1;

  inline$BDLSystemPowerIoCompletion$20$label_84#1:
    goto inline$BDLGetDebugLevel$539$Entry#1;

  inline$BDLGetDebugLevel$539$Entry#1:
    goto inline$BDLGetDebugLevel$539$start#1;

  inline$BDLGetDebugLevel$539$start#1:
    goto inline$BDLGetDebugLevel$539$label_3#1;

  inline$BDLGetDebugLevel$539$label_3#1:
    havoc inline$BDLGetDebugLevel$539$myNondetVar_0;
    inline$BDLGetDebugLevel$539$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$539$myNondetVar_0;
    goto inline$BDLGetDebugLevel$539$label_1#1;

  inline$BDLGetDebugLevel$539$label_1#1:
    goto inline$BDLGetDebugLevel$539$Return#1;

  inline$BDLGetDebugLevel$539$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$539$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon48_Then#1, inline$BDLSystemPowerIoCompletion$20$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon25#1;

  inline$BDLSystemPowerIoCompletion$20$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_93#1;

  inline$BDLSystemPowerIoCompletion$20$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_93_true#1, inline$BDLSystemPowerIoCompletion$20$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_94#1;

  inline$BDLSystemPowerIoCompletion$20$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_97#1;

  inline$BDLSystemPowerIoCompletion$20$label_97#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_98#1;

  inline$BDLSystemPowerIoCompletion$20$label_98#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_99#1;

  inline$BDLSystemPowerIoCompletion$20$label_99#1:
    call inline$BDLSystemPowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$20$label_100#1;

  inline$BDLSystemPowerIoCompletion$20$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$20$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$20$label_94#1;

  inline$BDLSystemPowerIoCompletion$20$label_94#1:
    goto inline$BDLGetDebugLevel$540$Entry#1;

  inline$BDLGetDebugLevel$540$Entry#1:
    goto inline$BDLGetDebugLevel$540$start#1;

  inline$BDLGetDebugLevel$540$start#1:
    goto inline$BDLGetDebugLevel$540$label_3#1;

  inline$BDLGetDebugLevel$540$label_3#1:
    havoc inline$BDLGetDebugLevel$540$myNondetVar_0;
    inline$BDLGetDebugLevel$540$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$540$myNondetVar_0;
    goto inline$BDLGetDebugLevel$540$label_1#1;

  inline$BDLGetDebugLevel$540$label_1#1:
    goto inline$BDLGetDebugLevel$540$Return#1;

  inline$BDLGetDebugLevel$540$Return#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$540$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$20$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$20$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$20$anon49_Then#1, inline$BDLSystemPowerIoCompletion$20$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$20$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$anon27#1;

  inline$BDLSystemPowerIoCompletion$20$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_103#1;

  inline$BDLSystemPowerIoCompletion$20$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_103_true#1, inline$BDLSystemPowerIoCompletion$20$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$20$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_104#1;

  inline$BDLSystemPowerIoCompletion$20$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$20$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$20$label_105#1;

  inline$BDLSystemPowerIoCompletion$20$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$20$label_104#1;

  inline$BDLSystemPowerIoCompletion$20$label_104#1:
    inline$BDLSystemPowerIoCompletion$20$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$20$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$20$label_1#1;

  inline$BDLSystemPowerIoCompletion$20$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$20$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$20$Return#1;

  inline$BDLSystemPowerIoCompletion$20$Return#1:
    inline$CallCompletionRoutine$20$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$20$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$20$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$20$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$20$anon14_Then#1, inline$CallCompletionRoutine$20$anon14_Else#1;

  inline$CallCompletionRoutine$20$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$20$anon9#1;

  inline$CallCompletionRoutine$20$anon9#1:
    goto inline$CallCompletionRoutine$20$label_20_icall_return#1;

  inline$CallCompletionRoutine$20$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$20$Return#1;

  inline$CallCompletionRoutine$20$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$20$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$20$Entry#1;

  inline$BDLDevicePowerIoCompletion$20$Entry#1:
    inline$BDLDevicePowerIoCompletion$20$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$20$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$20$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$20$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$20$start#1;

  inline$BDLDevicePowerIoCompletion$20$start#1:
    call inline$BDLDevicePowerIoCompletion$20$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$20$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$20$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$20$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$20$label_3#1;

  inline$BDLDevicePowerIoCompletion$20$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_4#1;

  inline$BDLDevicePowerIoCompletion$20$label_4#1:
    inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_5#1;

  inline$BDLDevicePowerIoCompletion$20$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_6#1;

  inline$BDLDevicePowerIoCompletion$20$label_6#1:
    inline$BDLDevicePowerIoCompletion$20$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$20$label_7#1;

  inline$BDLDevicePowerIoCompletion$20$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_8#1;

  inline$BDLDevicePowerIoCompletion$20$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$20$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$20$label_9#1;

  inline$BDLDevicePowerIoCompletion$20$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_10#1;

  inline$BDLDevicePowerIoCompletion$20$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$106$Entry#1;

  inline$IoGetCurrentIrpStackLocation$106$Entry#1:
    inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$106$start#1;

  inline$IoGetCurrentIrpStackLocation$106$start#1:
    inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$106$label_3#1;

  inline$IoGetCurrentIrpStackLocation$106$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$106$label_3_true#1, inline$IoGetCurrentIrpStackLocation$106$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$106$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$106$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$106$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$106$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$106$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$106$label_4#1;

  inline$IoGetCurrentIrpStackLocation$106$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$106$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$106$label_6#1;

  inline$IoGetCurrentIrpStackLocation$106$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$106$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$106$label_7#1;

  inline$IoGetCurrentIrpStackLocation$106$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$106$label_5#1;

  inline$IoGetCurrentIrpStackLocation$106$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$106$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$106$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$106$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$106$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$106$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$106$label_5#1;

  inline$IoGetCurrentIrpStackLocation$106$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$106$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$106$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$106$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$106$label_1#1;

  inline$IoGetCurrentIrpStackLocation$106$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$106$Return#1;

  inline$IoGetCurrentIrpStackLocation$106$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$106$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon30_Then#1, inline$BDLDevicePowerIoCompletion$20$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon1#1;

  inline$BDLDevicePowerIoCompletion$20$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_13#1;

  inline$BDLDevicePowerIoCompletion$20$label_13#1:
    inline$BDLDevicePowerIoCompletion$20$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$20$label_14#1;

  inline$BDLDevicePowerIoCompletion$20$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_15#1;

  inline$BDLDevicePowerIoCompletion$20$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$20$label_16#1;

  inline$BDLDevicePowerIoCompletion$20$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_17#1;

  inline$BDLDevicePowerIoCompletion$20$label_17#1:
    goto inline$BDLGetDebugLevel$523$Entry#1;

  inline$BDLGetDebugLevel$523$Entry#1:
    goto inline$BDLGetDebugLevel$523$start#1;

  inline$BDLGetDebugLevel$523$start#1:
    goto inline$BDLGetDebugLevel$523$label_3#1;

  inline$BDLGetDebugLevel$523$label_3#1:
    havoc inline$BDLGetDebugLevel$523$myNondetVar_0;
    inline$BDLGetDebugLevel$523$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$523$myNondetVar_0;
    goto inline$BDLGetDebugLevel$523$label_1#1;

  inline$BDLGetDebugLevel$523$label_1#1:
    goto inline$BDLGetDebugLevel$523$Return#1;

  inline$BDLGetDebugLevel$523$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$523$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon31_Then#1, inline$BDLDevicePowerIoCompletion$20$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon3#1;

  inline$BDLDevicePowerIoCompletion$20$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_20#1;

  inline$BDLDevicePowerIoCompletion$20$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_20_true#1, inline$BDLDevicePowerIoCompletion$20$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_21#1;

  inline$BDLDevicePowerIoCompletion$20$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_24#1;

  inline$BDLDevicePowerIoCompletion$20$label_24#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_25#1;

  inline$BDLDevicePowerIoCompletion$20$label_25#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_26#1;

  inline$BDLDevicePowerIoCompletion$20$label_26#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_27#1;

  inline$BDLDevicePowerIoCompletion$20$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$20$label_21#1;

  inline$BDLDevicePowerIoCompletion$20$label_21#1:
    goto inline$BDLGetDebugLevel$524$Entry#1;

  inline$BDLGetDebugLevel$524$Entry#1:
    goto inline$BDLGetDebugLevel$524$start#1;

  inline$BDLGetDebugLevel$524$start#1:
    goto inline$BDLGetDebugLevel$524$label_3#1;

  inline$BDLGetDebugLevel$524$label_3#1:
    havoc inline$BDLGetDebugLevel$524$myNondetVar_0;
    inline$BDLGetDebugLevel$524$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$524$myNondetVar_0;
    goto inline$BDLGetDebugLevel$524$label_1#1;

  inline$BDLGetDebugLevel$524$label_1#1:
    goto inline$BDLGetDebugLevel$524$Return#1;

  inline$BDLGetDebugLevel$524$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$524$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon32_Then#1, inline$BDLDevicePowerIoCompletion$20$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon5#1;

  inline$BDLDevicePowerIoCompletion$20$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_30#1;

  inline$BDLDevicePowerIoCompletion$20$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_30_true#1, inline$BDLDevicePowerIoCompletion$20$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_31#1;

  inline$BDLDevicePowerIoCompletion$20$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_34#1;

  inline$BDLDevicePowerIoCompletion$20$label_34#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_35#1;

  inline$BDLDevicePowerIoCompletion$20$label_35#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_36#1;

  inline$BDLDevicePowerIoCompletion$20$label_36#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_37#1;

  inline$BDLDevicePowerIoCompletion$20$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$20$label_31#1;

  inline$BDLDevicePowerIoCompletion$20$label_31#1:
    goto inline$BDLGetDebugLevel$525$Entry#1;

  inline$BDLGetDebugLevel$525$Entry#1:
    goto inline$BDLGetDebugLevel$525$start#1;

  inline$BDLGetDebugLevel$525$start#1:
    goto inline$BDLGetDebugLevel$525$label_3#1;

  inline$BDLGetDebugLevel$525$label_3#1:
    havoc inline$BDLGetDebugLevel$525$myNondetVar_0;
    inline$BDLGetDebugLevel$525$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$525$myNondetVar_0;
    goto inline$BDLGetDebugLevel$525$label_1#1;

  inline$BDLGetDebugLevel$525$label_1#1:
    goto inline$BDLGetDebugLevel$525$Return#1;

  inline$BDLGetDebugLevel$525$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$525$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon33_Then#1, inline$BDLDevicePowerIoCompletion$20$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon7#1;

  inline$BDLDevicePowerIoCompletion$20$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_40#1;

  inline$BDLDevicePowerIoCompletion$20$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_40_true#1, inline$BDLDevicePowerIoCompletion$20$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_41#1;

  inline$BDLDevicePowerIoCompletion$20$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_42#1;

  inline$BDLDevicePowerIoCompletion$20$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_41#1;

  inline$BDLDevicePowerIoCompletion$20$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_41_true#1, inline$BDLDevicePowerIoCompletion$20$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$20$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$20$label_43#1;

  inline$BDLDevicePowerIoCompletion$20$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$20$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$20$label_44#1;

  inline$BDLDevicePowerIoCompletion$20$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_44_true#1, inline$BDLDevicePowerIoCompletion$20$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$20$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$20$label_45#1;

  inline$BDLDevicePowerIoCompletion$20$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_45_true#1, inline$BDLDevicePowerIoCompletion$20$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$20$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$20$label_43#1;

  inline$BDLDevicePowerIoCompletion$20$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$20$label_86#1;

  inline$BDLDevicePowerIoCompletion$20$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$20$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$20$label_46#1;

  inline$BDLDevicePowerIoCompletion$20$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$20$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$20$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$20$label_46#1;

  inline$BDLDevicePowerIoCompletion$20$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$20$label_49#1;

  inline$BDLDevicePowerIoCompletion$20$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_50#1;

  inline$BDLDevicePowerIoCompletion$20$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_51#1;

  inline$BDLDevicePowerIoCompletion$20$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_54#1;

  inline$BDLDevicePowerIoCompletion$20$label_54#1:
    inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$20$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$20$label_55#1;

  inline$BDLDevicePowerIoCompletion$20$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_55_true#1, inline$BDLDevicePowerIoCompletion$20$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_56#1;

  inline$BDLDevicePowerIoCompletion$20$label_56#1:
    call inline$BDLDevicePowerIoCompletion$20$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$20$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$20$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$20$anon34_Then#1, inline$BDLDevicePowerIoCompletion$20$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon9#1;

  inline$BDLDevicePowerIoCompletion$20$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_83#1;

  inline$BDLDevicePowerIoCompletion$20$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_59#1;

  inline$BDLDevicePowerIoCompletion$20$label_59#1:
    goto inline$BDLGetDebugLevel$526$Entry#1;

  inline$BDLGetDebugLevel$526$Entry#1:
    goto inline$BDLGetDebugLevel$526$start#1;

  inline$BDLGetDebugLevel$526$start#1:
    goto inline$BDLGetDebugLevel$526$label_3#1;

  inline$BDLGetDebugLevel$526$label_3#1:
    havoc inline$BDLGetDebugLevel$526$myNondetVar_0;
    inline$BDLGetDebugLevel$526$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$526$myNondetVar_0;
    goto inline$BDLGetDebugLevel$526$label_1#1;

  inline$BDLGetDebugLevel$526$label_1#1:
    goto inline$BDLGetDebugLevel$526$Return#1;

  inline$BDLGetDebugLevel$526$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$526$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon35_Then#1, inline$BDLDevicePowerIoCompletion$20$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon11#1;

  inline$BDLDevicePowerIoCompletion$20$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_62#1;

  inline$BDLDevicePowerIoCompletion$20$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_62_true#1, inline$BDLDevicePowerIoCompletion$20$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_63#1;

  inline$BDLDevicePowerIoCompletion$20$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_66#1;

  inline$BDLDevicePowerIoCompletion$20$label_66#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_67#1;

  inline$BDLDevicePowerIoCompletion$20$label_67#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_68#1;

  inline$BDLDevicePowerIoCompletion$20$label_68#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_69#1;

  inline$BDLDevicePowerIoCompletion$20$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$20$label_63#1;

  inline$BDLDevicePowerIoCompletion$20$label_63#1:
    goto inline$BDLGetDebugLevel$527$Entry#1;

  inline$BDLGetDebugLevel$527$Entry#1:
    goto inline$BDLGetDebugLevel$527$start#1;

  inline$BDLGetDebugLevel$527$start#1:
    goto inline$BDLGetDebugLevel$527$label_3#1;

  inline$BDLGetDebugLevel$527$label_3#1:
    havoc inline$BDLGetDebugLevel$527$myNondetVar_0;
    inline$BDLGetDebugLevel$527$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$527$myNondetVar_0;
    goto inline$BDLGetDebugLevel$527$label_1#1;

  inline$BDLGetDebugLevel$527$label_1#1:
    goto inline$BDLGetDebugLevel$527$Return#1;

  inline$BDLGetDebugLevel$527$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$527$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon36_Then#1, inline$BDLDevicePowerIoCompletion$20$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon13#1;

  inline$BDLDevicePowerIoCompletion$20$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_72#1;

  inline$BDLDevicePowerIoCompletion$20$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_72_true#1, inline$BDLDevicePowerIoCompletion$20$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_73#1;

  inline$BDLDevicePowerIoCompletion$20$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_76#1;

  inline$BDLDevicePowerIoCompletion$20$label_76#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_77#1;

  inline$BDLDevicePowerIoCompletion$20$label_77#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_78#1;

  inline$BDLDevicePowerIoCompletion$20$label_78#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_79#1;

  inline$BDLDevicePowerIoCompletion$20$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$20$label_73#1;

  inline$BDLDevicePowerIoCompletion$20$label_73#1:
    goto inline$BDLGetDebugLevel$528$Entry#1;

  inline$BDLGetDebugLevel$528$Entry#1:
    goto inline$BDLGetDebugLevel$528$start#1;

  inline$BDLGetDebugLevel$528$start#1:
    goto inline$BDLGetDebugLevel$528$label_3#1;

  inline$BDLGetDebugLevel$528$label_3#1:
    havoc inline$BDLGetDebugLevel$528$myNondetVar_0;
    inline$BDLGetDebugLevel$528$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$528$myNondetVar_0;
    goto inline$BDLGetDebugLevel$528$label_1#1;

  inline$BDLGetDebugLevel$528$label_1#1:
    goto inline$BDLGetDebugLevel$528$Return#1;

  inline$BDLGetDebugLevel$528$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$528$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon37_Then#1, inline$BDLDevicePowerIoCompletion$20$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon15#1;

  inline$BDLDevicePowerIoCompletion$20$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_82#1;

  inline$BDLDevicePowerIoCompletion$20$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_82_true#1, inline$BDLDevicePowerIoCompletion$20$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_83#1;

  inline$BDLDevicePowerIoCompletion$20$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_84#1;

  inline$BDLDevicePowerIoCompletion$20$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_83#1;

  inline$BDLDevicePowerIoCompletion$20$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_85#1;

  inline$BDLDevicePowerIoCompletion$20$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_86#1;

  inline$BDLDevicePowerIoCompletion$20$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$20$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$20$anon38_Then#1, inline$BDLDevicePowerIoCompletion$20$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon17#1;

  inline$BDLDevicePowerIoCompletion$20$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_89#1;

  inline$BDLDevicePowerIoCompletion$20$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$20$anon39_Then#1, inline$BDLDevicePowerIoCompletion$20$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon19#1;

  inline$BDLDevicePowerIoCompletion$20$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_92#1;

  inline$BDLDevicePowerIoCompletion$20$label_92#1:
    goto inline$storm_IoCompleteRequest$41$Entry#1;

  inline$storm_IoCompleteRequest$41$Entry#1:
    inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$20$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$41$start#1;

  inline$storm_IoCompleteRequest$41$start#1:
    inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$41$label_3#1;

  inline$storm_IoCompleteRequest$41$label_3#1:
    call inline$storm_IoCompleteRequest$41$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$41$label_6#1;

  inline$storm_IoCompleteRequest$41$label_6#1:
    goto inline$storm_IoCompleteRequest$41$label_6_true#1, inline$storm_IoCompleteRequest$41$label_6_false#1;

  inline$storm_IoCompleteRequest$41$label_6_false#1:
    assume inline$storm_IoCompleteRequest$41$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$41$label_7#1;

  inline$storm_IoCompleteRequest$41$label_6_true#1:
    assume inline$storm_IoCompleteRequest$41$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$41$label_8#1;

  inline$storm_IoCompleteRequest$41$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$41$anon3_Then#1, inline$storm_IoCompleteRequest$41$anon3_Else#1;

  inline$storm_IoCompleteRequest$41$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$41$anon1#1;

  inline$storm_IoCompleteRequest$41$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$41$label_9#1;

  inline$storm_IoCompleteRequest$41$label_9#1:
    goto inline$storm_IoCompleteRequest$41$label_9_true#1, inline$storm_IoCompleteRequest$41$label_9_false#1;

  inline$storm_IoCompleteRequest$41$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$41$label_10#1;

  inline$storm_IoCompleteRequest$41$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$41$label_1#1;

  inline$storm_IoCompleteRequest$41$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$41$label_7#1;

  inline$storm_IoCompleteRequest$41$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$41$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$41$label_1#1;

  inline$storm_IoCompleteRequest$41$label_1#1:
    goto inline$storm_IoCompleteRequest$41$Return#1;

  inline$storm_IoCompleteRequest$41$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$41$Return#1;

  inline$storm_IoCompleteRequest$41$Return#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon40_Then#1, inline$BDLDevicePowerIoCompletion$20$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon21#1;

  inline$BDLDevicePowerIoCompletion$20$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_95#1;

  inline$BDLDevicePowerIoCompletion$20$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$20$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$20$anon41_Then#1, inline$BDLDevicePowerIoCompletion$20$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon23#1;

  inline$BDLDevicePowerIoCompletion$20$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_98#1;

  inline$BDLDevicePowerIoCompletion$20$label_98#1:
    goto inline$BDLGetDebugLevel$529$Entry#1;

  inline$BDLGetDebugLevel$529$Entry#1:
    goto inline$BDLGetDebugLevel$529$start#1;

  inline$BDLGetDebugLevel$529$start#1:
    goto inline$BDLGetDebugLevel$529$label_3#1;

  inline$BDLGetDebugLevel$529$label_3#1:
    havoc inline$BDLGetDebugLevel$529$myNondetVar_0;
    inline$BDLGetDebugLevel$529$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$529$myNondetVar_0;
    goto inline$BDLGetDebugLevel$529$label_1#1;

  inline$BDLGetDebugLevel$529$label_1#1:
    goto inline$BDLGetDebugLevel$529$Return#1;

  inline$BDLGetDebugLevel$529$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$529$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon42_Then#1, inline$BDLDevicePowerIoCompletion$20$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon25#1;

  inline$BDLDevicePowerIoCompletion$20$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_101#1;

  inline$BDLDevicePowerIoCompletion$20$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_101_true#1, inline$BDLDevicePowerIoCompletion$20$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_102#1;

  inline$BDLDevicePowerIoCompletion$20$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_105#1;

  inline$BDLDevicePowerIoCompletion$20$label_105#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_106#1;

  inline$BDLDevicePowerIoCompletion$20$label_106#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_107#1;

  inline$BDLDevicePowerIoCompletion$20$label_107#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_108#1;

  inline$BDLDevicePowerIoCompletion$20$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$20$label_102#1;

  inline$BDLDevicePowerIoCompletion$20$label_102#1:
    goto inline$BDLGetDebugLevel$530$Entry#1;

  inline$BDLGetDebugLevel$530$Entry#1:
    goto inline$BDLGetDebugLevel$530$start#1;

  inline$BDLGetDebugLevel$530$start#1:
    goto inline$BDLGetDebugLevel$530$label_3#1;

  inline$BDLGetDebugLevel$530$label_3#1:
    havoc inline$BDLGetDebugLevel$530$myNondetVar_0;
    inline$BDLGetDebugLevel$530$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$530$myNondetVar_0;
    goto inline$BDLGetDebugLevel$530$label_1#1;

  inline$BDLGetDebugLevel$530$label_1#1:
    goto inline$BDLGetDebugLevel$530$Return#1;

  inline$BDLGetDebugLevel$530$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$530$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon43_Then#1, inline$BDLDevicePowerIoCompletion$20$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon27#1;

  inline$BDLDevicePowerIoCompletion$20$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_111#1;

  inline$BDLDevicePowerIoCompletion$20$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_111_true#1, inline$BDLDevicePowerIoCompletion$20$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_112#1;

  inline$BDLDevicePowerIoCompletion$20$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_115#1;

  inline$BDLDevicePowerIoCompletion$20$label_115#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_116#1;

  inline$BDLDevicePowerIoCompletion$20$label_116#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_117#1;

  inline$BDLDevicePowerIoCompletion$20$label_117#1:
    call inline$BDLDevicePowerIoCompletion$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$20$label_118#1;

  inline$BDLDevicePowerIoCompletion$20$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$20$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$20$label_112#1;

  inline$BDLDevicePowerIoCompletion$20$label_112#1:
    goto inline$BDLGetDebugLevel$531$Entry#1;

  inline$BDLGetDebugLevel$531$Entry#1:
    goto inline$BDLGetDebugLevel$531$start#1;

  inline$BDLGetDebugLevel$531$start#1:
    goto inline$BDLGetDebugLevel$531$label_3#1;

  inline$BDLGetDebugLevel$531$label_3#1:
    havoc inline$BDLGetDebugLevel$531$myNondetVar_0;
    inline$BDLGetDebugLevel$531$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$531$myNondetVar_0;
    goto inline$BDLGetDebugLevel$531$label_1#1;

  inline$BDLGetDebugLevel$531$label_1#1:
    goto inline$BDLGetDebugLevel$531$Return#1;

  inline$BDLGetDebugLevel$531$Return#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$531$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$20$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$20$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$20$anon44_Then#1, inline$BDLDevicePowerIoCompletion$20$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$20$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$anon29#1;

  inline$BDLDevicePowerIoCompletion$20$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_121#1;

  inline$BDLDevicePowerIoCompletion$20$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_121_true#1, inline$BDLDevicePowerIoCompletion$20$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$20$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_122#1;

  inline$BDLDevicePowerIoCompletion$20$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$20$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$20$label_123#1;

  inline$BDLDevicePowerIoCompletion$20$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$20$label_122#1;

  inline$BDLDevicePowerIoCompletion$20$label_122#1:
    inline$BDLDevicePowerIoCompletion$20$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$20$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$20$label_1#1;

  inline$BDLDevicePowerIoCompletion$20$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$20$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$20$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$20$Return#1;

  inline$BDLDevicePowerIoCompletion$20$Return#1:
    inline$CallCompletionRoutine$20$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$20$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$20$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$20$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$20$anon13_Then#1, inline$CallCompletionRoutine$20$anon13_Else#1;

  inline$CallCompletionRoutine$20$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$20$anon7#1;

  inline$CallCompletionRoutine$20$anon7#1:
    goto inline$CallCompletionRoutine$20$label_20_icall_return#1;

  inline$CallCompletionRoutine$20$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$20$Return#1;

  inline$CallCompletionRoutine$20$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$20$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$20$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$20$Entry#1;

  inline$BDLCallDriverCompletionRoutine$20$Entry#1:
    inline$BDLCallDriverCompletionRoutine$20$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$20$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$20$start#1;

  inline$BDLCallDriverCompletionRoutine$20$start#1:
    inline$BDLCallDriverCompletionRoutine$20$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$20$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$20$label_3#1;

  inline$BDLCallDriverCompletionRoutine$20$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$20$label_3_true#1, inline$BDLCallDriverCompletionRoutine$20$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$20$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$20$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$20$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$20$label_4#1;

  inline$BDLCallDriverCompletionRoutine$20$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$20$label_6#1;

  inline$BDLCallDriverCompletionRoutine$20$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$20$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$20$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$20$label_5#1;

  inline$BDLCallDriverCompletionRoutine$20$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$20$label_6#1;

  inline$BDLCallDriverCompletionRoutine$20$label_6#1:
    goto inline$storm_KeSetEvent$22$Entry#1;

  inline$storm_KeSetEvent$22$Entry#1:
    inline$storm_KeSetEvent$22$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$20$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$22$start#1;

  inline$storm_KeSetEvent$22$start#1:
    inline$storm_KeSetEvent$22$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$22$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$22$label_3#1;

  inline$storm_KeSetEvent$22$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$22$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$22$label_1#1;

  inline$storm_KeSetEvent$22$label_1#1:
    goto inline$storm_KeSetEvent$22$Return#1;

  inline$storm_KeSetEvent$22$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$20$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$20$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$20$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$20$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$20$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$20$anon1#1;

  inline$BDLCallDriverCompletionRoutine$20$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$20$label_9#1;

  inline$BDLCallDriverCompletionRoutine$20$label_9#1:
    inline$BDLCallDriverCompletionRoutine$20$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$20$label_1#1;

  inline$BDLCallDriverCompletionRoutine$20$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$20$Return#1;

  inline$BDLCallDriverCompletionRoutine$20$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$20$Return#1;

  inline$BDLCallDriverCompletionRoutine$20$Return#1:
    inline$CallCompletionRoutine$20$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$20$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$20$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$20$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$20$anon12_Then#1, inline$CallCompletionRoutine$20$anon12_Else#1;

  inline$CallCompletionRoutine$20$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$20$anon5#1;

  inline$CallCompletionRoutine$20$anon5#1:
    goto inline$CallCompletionRoutine$20$label_20_icall_return#1;

  inline$CallCompletionRoutine$20$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$20$label_23#1;

  inline$CallCompletionRoutine$20$label_23#1:
    inline$CallCompletionRoutine$20$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$20$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$20$label_24#1;

  inline$CallCompletionRoutine$20$label_24#1:
    goto inline$CallCompletionRoutine$20$label_24_true#1, inline$CallCompletionRoutine$20$label_24_false#1;

  inline$CallCompletionRoutine$20$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$20$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$20$label_1#1;

  inline$CallCompletionRoutine$20$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$20$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$20$label_25#1;

  inline$CallCompletionRoutine$20$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$20$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$20$label_1#1;

  inline$CallCompletionRoutine$20$label_1#1:
    goto inline$CallCompletionRoutine$20$Return#1;

  inline$CallCompletionRoutine$20$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$20$Return#1;

  inline$CallCompletionRoutine$20$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$20$Return#1;

  inline$CallCompletionRoutine$20$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$20$Return#1;

  inline$CallCompletionRoutine$20$Return#1:
    goto inline$storm_IoCallDriver$10$label_33$1#1;

  inline$storm_IoCallDriver$10$label_33$1#1:
    goto inline$storm_IoCallDriver$10$anon14_Then#1, inline$storm_IoCallDriver$10$anon14_Else#1;

  inline$storm_IoCallDriver$10$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$10$anon8#1;

  inline$storm_IoCallDriver$10$anon8#1:
    goto inline$storm_IoCallDriver$10$label_36#1;

  inline$storm_IoCallDriver$10$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$10$Return#1;

  inline$storm_IoCallDriver$10$label_27_case_1#1:
    assume inline$storm_IoCallDriver$10$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$10$label_29#1;

  inline$storm_IoCallDriver$10$label_29#1:
    inline$storm_IoCallDriver$10$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$10$label_37#1;

  inline$storm_IoCallDriver$10$label_37#1:
    goto inline$storm_IoCallDriver$10$label_38#1;

  inline$storm_IoCallDriver$10$label_38#1:
    goto inline$storm_IoCallDriver$10$label_39#1;

  inline$storm_IoCallDriver$10$label_39#1:
    goto inline$CallCompletionRoutine$21$Entry#1;

  inline$CallCompletionRoutine$21$Entry#1:
    inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$21$start#1;

  inline$CallCompletionRoutine$21$start#1:
    inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$21$label_3#1;

  inline$CallCompletionRoutine$21$label_3#1:
    goto inline$CallCompletionRoutine$21$label_4#1;

  inline$CallCompletionRoutine$21$label_4#1:
    goto inline$CallCompletionRoutine$21$label_5#1;

  inline$CallCompletionRoutine$21$label_5#1:
    goto inline$CallCompletionRoutine$21$label_6#1;

  inline$CallCompletionRoutine$21$label_6#1:
    goto inline$CallCompletionRoutine$21$label_7#1;

  inline$CallCompletionRoutine$21$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$108$Entry#1;

  inline$IoGetCurrentIrpStackLocation$108$Entry#1:
    inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$108$start#1;

  inline$IoGetCurrentIrpStackLocation$108$start#1:
    inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$108$label_3#1;

  inline$IoGetCurrentIrpStackLocation$108$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$108$label_3_true#1, inline$IoGetCurrentIrpStackLocation$108$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$108$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$108$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$108$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$108$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$108$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$108$label_4#1;

  inline$IoGetCurrentIrpStackLocation$108$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$108$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$108$label_6#1;

  inline$IoGetCurrentIrpStackLocation$108$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$108$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$108$label_7#1;

  inline$IoGetCurrentIrpStackLocation$108$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$108$label_5#1;

  inline$IoGetCurrentIrpStackLocation$108$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$108$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$108$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$108$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$108$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$108$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$108$label_5#1;

  inline$IoGetCurrentIrpStackLocation$108$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$108$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$108$label_1#1;

  inline$IoGetCurrentIrpStackLocation$108$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$108$Return#1;

  inline$IoGetCurrentIrpStackLocation$108$Return#1:
    goto inline$CallCompletionRoutine$21$label_7$1#1;

  inline$CallCompletionRoutine$21$label_7$1#1:
    goto inline$CallCompletionRoutine$21$anon10_Then#1, inline$CallCompletionRoutine$21$anon10_Else#1;

  inline$CallCompletionRoutine$21$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$21$anon1#1;

  inline$CallCompletionRoutine$21$anon1#1:
    goto inline$CallCompletionRoutine$21$label_10#1;

  inline$CallCompletionRoutine$21$label_10#1:
    goto inline$CallCompletionRoutine$21$label_11#1;

  inline$CallCompletionRoutine$21$label_11#1:
    havoc inline$CallCompletionRoutine$21$myNondetVar_0;
    inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$21$myNondetVar_0;
    goto inline$CallCompletionRoutine$21$label_12#1;

  inline$CallCompletionRoutine$21$label_12#1:
    havoc inline$CallCompletionRoutine$21$myNondetVar_0;
    inline$CallCompletionRoutine$21$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$21$myNondetVar_0;
    goto inline$CallCompletionRoutine$21$label_13#1;

  inline$CallCompletionRoutine$21$label_13#1:
    havoc inline$CallCompletionRoutine$21$myNondetVar_0;
    goto inline$CallCompletionRoutine$21$label_14#1;

  inline$CallCompletionRoutine$21$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$109$Entry#1;

  inline$IoGetCurrentIrpStackLocation$109$Entry#1:
    inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$109$start#1;

  inline$IoGetCurrentIrpStackLocation$109$start#1:
    inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$109$label_3#1;

  inline$IoGetCurrentIrpStackLocation$109$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$109$label_3_true#1, inline$IoGetCurrentIrpStackLocation$109$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$109$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$109$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$109$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$109$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$109$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$109$label_4#1;

  inline$IoGetCurrentIrpStackLocation$109$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$109$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$109$label_6#1;

  inline$IoGetCurrentIrpStackLocation$109$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$109$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$109$label_7#1;

  inline$IoGetCurrentIrpStackLocation$109$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$109$label_5#1;

  inline$IoGetCurrentIrpStackLocation$109$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$109$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$109$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$109$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$109$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$109$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$109$label_5#1;

  inline$IoGetCurrentIrpStackLocation$109$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$109$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$109$label_1#1;

  inline$IoGetCurrentIrpStackLocation$109$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$109$Return#1;

  inline$IoGetCurrentIrpStackLocation$109$Return#1:
    goto inline$CallCompletionRoutine$21$label_14$1#1;

  inline$CallCompletionRoutine$21$label_14$1#1:
    goto inline$CallCompletionRoutine$21$anon11_Then#1, inline$CallCompletionRoutine$21$anon11_Else#1;

  inline$CallCompletionRoutine$21$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$21$anon3#1;

  inline$CallCompletionRoutine$21$anon3#1:
    goto inline$CallCompletionRoutine$21$label_17#1;

  inline$CallCompletionRoutine$21$label_17#1:
    goto inline$CallCompletionRoutine$21$label_18#1;

  inline$CallCompletionRoutine$21$label_18#1:
    goto inline$CallCompletionRoutine$21$label_18_true#1, inline$CallCompletionRoutine$21$label_18_false#1;

  inline$CallCompletionRoutine$21$label_18_false#1:
    assume inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$21$label_1#1;

  inline$CallCompletionRoutine$21$label_18_true#1:
    assume inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$21$label_19#1;

  inline$CallCompletionRoutine$21$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$21$label_20#1;

  inline$CallCompletionRoutine$21$label_20#1:
    goto inline$CallCompletionRoutine$21$label_20_icall_1#1, inline$CallCompletionRoutine$21$label_20_icall_2#1, inline$CallCompletionRoutine$21$label_20_icall_3#1;

  inline$CallCompletionRoutine$21$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$21$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$21$Entry#1;

  inline$BDLSystemPowerIoCompletion$21$Entry#1:
    inline$BDLSystemPowerIoCompletion$21$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$21$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$21$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$21$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$21$start#1;

  inline$BDLSystemPowerIoCompletion$21$start#1:
    call inline$BDLSystemPowerIoCompletion$21$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$21$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$21$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$21$label_3#1;

  inline$BDLSystemPowerIoCompletion$21$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_4#1;

  inline$BDLSystemPowerIoCompletion$21$label_4#1:
    inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_5#1;

  inline$BDLSystemPowerIoCompletion$21$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_6#1;

  inline$BDLSystemPowerIoCompletion$21$label_6#1:
    inline$BDLSystemPowerIoCompletion$21$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$21$label_7#1;

  inline$BDLSystemPowerIoCompletion$21$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_8#1;

  inline$BDLSystemPowerIoCompletion$21$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$21$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$21$label_9#1;

  inline$BDLSystemPowerIoCompletion$21$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_10#1;

  inline$BDLSystemPowerIoCompletion$21$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$111$Entry#1;

  inline$IoGetCurrentIrpStackLocation$111$Entry#1:
    inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$111$start#1;

  inline$IoGetCurrentIrpStackLocation$111$start#1:
    inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$111$label_3#1;

  inline$IoGetCurrentIrpStackLocation$111$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$111$label_3_true#1, inline$IoGetCurrentIrpStackLocation$111$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$111$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$111$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$111$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$111$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$111$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$111$label_4#1;

  inline$IoGetCurrentIrpStackLocation$111$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$111$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$111$label_6#1;

  inline$IoGetCurrentIrpStackLocation$111$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$111$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$111$label_7#1;

  inline$IoGetCurrentIrpStackLocation$111$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$111$label_5#1;

  inline$IoGetCurrentIrpStackLocation$111$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$111$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$111$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$111$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$111$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$111$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$111$label_5#1;

  inline$IoGetCurrentIrpStackLocation$111$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$111$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$111$label_1#1;

  inline$IoGetCurrentIrpStackLocation$111$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$111$Return#1;

  inline$IoGetCurrentIrpStackLocation$111$Return#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon36_Then#1, inline$BDLSystemPowerIoCompletion$21$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon1#1;

  inline$BDLSystemPowerIoCompletion$21$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_13#1;

  inline$BDLSystemPowerIoCompletion$21$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_14#1;

  inline$BDLSystemPowerIoCompletion$21$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_15#1;

  inline$BDLSystemPowerIoCompletion$21$label_15#1:
    goto inline$BDLGetDebugLevel$553$Entry#1;

  inline$BDLGetDebugLevel$553$Entry#1:
    goto inline$BDLGetDebugLevel$553$start#1;

  inline$BDLGetDebugLevel$553$start#1:
    goto inline$BDLGetDebugLevel$553$label_3#1;

  inline$BDLGetDebugLevel$553$label_3#1:
    havoc inline$BDLGetDebugLevel$553$myNondetVar_0;
    inline$BDLGetDebugLevel$553$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$553$myNondetVar_0;
    goto inline$BDLGetDebugLevel$553$label_1#1;

  inline$BDLGetDebugLevel$553$label_1#1:
    goto inline$BDLGetDebugLevel$553$Return#1;

  inline$BDLGetDebugLevel$553$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$553$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon37_Then#1, inline$BDLSystemPowerIoCompletion$21$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon3#1;

  inline$BDLSystemPowerIoCompletion$21$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_18#1;

  inline$BDLSystemPowerIoCompletion$21$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_18_true#1, inline$BDLSystemPowerIoCompletion$21$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_19#1;

  inline$BDLSystemPowerIoCompletion$21$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_22#1;

  inline$BDLSystemPowerIoCompletion$21$label_22#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_23#1;

  inline$BDLSystemPowerIoCompletion$21$label_23#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_24#1;

  inline$BDLSystemPowerIoCompletion$21$label_24#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_25#1;

  inline$BDLSystemPowerIoCompletion$21$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$21$label_19#1;

  inline$BDLSystemPowerIoCompletion$21$label_19#1:
    goto inline$BDLGetDebugLevel$554$Entry#1;

  inline$BDLGetDebugLevel$554$Entry#1:
    goto inline$BDLGetDebugLevel$554$start#1;

  inline$BDLGetDebugLevel$554$start#1:
    goto inline$BDLGetDebugLevel$554$label_3#1;

  inline$BDLGetDebugLevel$554$label_3#1:
    havoc inline$BDLGetDebugLevel$554$myNondetVar_0;
    inline$BDLGetDebugLevel$554$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$554$myNondetVar_0;
    goto inline$BDLGetDebugLevel$554$label_1#1;

  inline$BDLGetDebugLevel$554$label_1#1:
    goto inline$BDLGetDebugLevel$554$Return#1;

  inline$BDLGetDebugLevel$554$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$554$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon38_Then#1, inline$BDLSystemPowerIoCompletion$21$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon5#1;

  inline$BDLSystemPowerIoCompletion$21$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_28#1;

  inline$BDLSystemPowerIoCompletion$21$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_28_true#1, inline$BDLSystemPowerIoCompletion$21$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_29#1;

  inline$BDLSystemPowerIoCompletion$21$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_32#1;

  inline$BDLSystemPowerIoCompletion$21$label_32#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_33#1;

  inline$BDLSystemPowerIoCompletion$21$label_33#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_34#1;

  inline$BDLSystemPowerIoCompletion$21$label_34#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_35#1;

  inline$BDLSystemPowerIoCompletion$21$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$21$label_29#1;

  inline$BDLSystemPowerIoCompletion$21$label_29#1:
    goto inline$BDLGetDebugLevel$555$Entry#1;

  inline$BDLGetDebugLevel$555$Entry#1:
    goto inline$BDLGetDebugLevel$555$start#1;

  inline$BDLGetDebugLevel$555$start#1:
    goto inline$BDLGetDebugLevel$555$label_3#1;

  inline$BDLGetDebugLevel$555$label_3#1:
    havoc inline$BDLGetDebugLevel$555$myNondetVar_0;
    inline$BDLGetDebugLevel$555$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$555$myNondetVar_0;
    goto inline$BDLGetDebugLevel$555$label_1#1;

  inline$BDLGetDebugLevel$555$label_1#1:
    goto inline$BDLGetDebugLevel$555$Return#1;

  inline$BDLGetDebugLevel$555$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$555$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon39_Then#1, inline$BDLSystemPowerIoCompletion$21$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon7#1;

  inline$BDLSystemPowerIoCompletion$21$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_38#1;

  inline$BDLSystemPowerIoCompletion$21$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_38_true#1, inline$BDLSystemPowerIoCompletion$21$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_39#1;

  inline$BDLSystemPowerIoCompletion$21$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_40#1;

  inline$BDLSystemPowerIoCompletion$21$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_39#1;

  inline$BDLSystemPowerIoCompletion$21$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_39_true#1, inline$BDLSystemPowerIoCompletion$21$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_41#1;

  inline$BDLSystemPowerIoCompletion$21$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$21$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$21$label_107#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$21$label_108#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$21$label_108#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$21$label_108#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$21$label_108#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$21$label_108#1;

  inline$BDLSystemPowerIoCompletion$21$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_109#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$21$label_107#1;

  inline$BDLSystemPowerIoCompletion$21$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_109#1;

  inline$BDLSystemPowerIoCompletion$21$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$21$label_106#1;

  inline$BDLSystemPowerIoCompletion$21$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_106_true#1, inline$BDLSystemPowerIoCompletion$21$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_142#1;

  inline$BDLSystemPowerIoCompletion$21$label_142#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_143#1;

  inline$BDLSystemPowerIoCompletion$21$label_143#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_144#1;

  inline$BDLSystemPowerIoCompletion$21$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_109#1;

  inline$BDLSystemPowerIoCompletion$21$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_109#1;

  inline$BDLSystemPowerIoCompletion$21$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$21$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$21$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$21$myNondetVar_0, inline$BDLSystemPowerIoCompletion$21$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$21$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$21$anon50_Then#1, inline$BDLSystemPowerIoCompletion$21$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon29#1;

  inline$BDLSystemPowerIoCompletion$21$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_112#1;

  inline$BDLSystemPowerIoCompletion$21$label_112#1:
    inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$21$label_113#1;

  inline$BDLSystemPowerIoCompletion$21$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_113_true#1, inline$BDLSystemPowerIoCompletion$21$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$21$label_114#1;

  inline$BDLSystemPowerIoCompletion$21$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_116#1;

  inline$BDLSystemPowerIoCompletion$21$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_117#1;

  inline$BDLSystemPowerIoCompletion$21$label_117#1:
    goto inline$BDLGetDebugLevel$562$Entry#1;

  inline$BDLGetDebugLevel$562$Entry#1:
    goto inline$BDLGetDebugLevel$562$start#1;

  inline$BDLGetDebugLevel$562$start#1:
    goto inline$BDLGetDebugLevel$562$label_3#1;

  inline$BDLGetDebugLevel$562$label_3#1:
    havoc inline$BDLGetDebugLevel$562$myNondetVar_0;
    inline$BDLGetDebugLevel$562$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$562$myNondetVar_0;
    goto inline$BDLGetDebugLevel$562$label_1#1;

  inline$BDLGetDebugLevel$562$label_1#1:
    goto inline$BDLGetDebugLevel$562$Return#1;

  inline$BDLGetDebugLevel$562$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$562$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon51_Then#1, inline$BDLSystemPowerIoCompletion$21$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon31#1;

  inline$BDLSystemPowerIoCompletion$21$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_120#1;

  inline$BDLSystemPowerIoCompletion$21$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_120_true#1, inline$BDLSystemPowerIoCompletion$21$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_121#1;

  inline$BDLSystemPowerIoCompletion$21$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_124#1;

  inline$BDLSystemPowerIoCompletion$21$label_124#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_125#1;

  inline$BDLSystemPowerIoCompletion$21$label_125#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_126#1;

  inline$BDLSystemPowerIoCompletion$21$label_126#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_127#1;

  inline$BDLSystemPowerIoCompletion$21$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$21$label_121#1;

  inline$BDLSystemPowerIoCompletion$21$label_121#1:
    goto inline$BDLGetDebugLevel$563$Entry#1;

  inline$BDLGetDebugLevel$563$Entry#1:
    goto inline$BDLGetDebugLevel$563$start#1;

  inline$BDLGetDebugLevel$563$start#1:
    goto inline$BDLGetDebugLevel$563$label_3#1;

  inline$BDLGetDebugLevel$563$label_3#1:
    havoc inline$BDLGetDebugLevel$563$myNondetVar_0;
    inline$BDLGetDebugLevel$563$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$563$myNondetVar_0;
    goto inline$BDLGetDebugLevel$563$label_1#1;

  inline$BDLGetDebugLevel$563$label_1#1:
    goto inline$BDLGetDebugLevel$563$Return#1;

  inline$BDLGetDebugLevel$563$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$563$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon52_Then#1, inline$BDLSystemPowerIoCompletion$21$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon33#1;

  inline$BDLSystemPowerIoCompletion$21$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_130#1;

  inline$BDLSystemPowerIoCompletion$21$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_130_true#1, inline$BDLSystemPowerIoCompletion$21$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_131#1;

  inline$BDLSystemPowerIoCompletion$21$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_134#1;

  inline$BDLSystemPowerIoCompletion$21$label_134#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_135#1;

  inline$BDLSystemPowerIoCompletion$21$label_135#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_136#1;

  inline$BDLSystemPowerIoCompletion$21$label_136#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_137#1;

  inline$BDLSystemPowerIoCompletion$21$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$21$label_131#1;

  inline$BDLSystemPowerIoCompletion$21$label_131#1:
    goto inline$BDLGetDebugLevel$564$Entry#1;

  inline$BDLGetDebugLevel$564$Entry#1:
    goto inline$BDLGetDebugLevel$564$start#1;

  inline$BDLGetDebugLevel$564$start#1:
    goto inline$BDLGetDebugLevel$564$label_3#1;

  inline$BDLGetDebugLevel$564$label_3#1:
    havoc inline$BDLGetDebugLevel$564$myNondetVar_0;
    inline$BDLGetDebugLevel$564$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$564$myNondetVar_0;
    goto inline$BDLGetDebugLevel$564$label_1#1;

  inline$BDLGetDebugLevel$564$label_1#1:
    goto inline$BDLGetDebugLevel$564$Return#1;

  inline$BDLGetDebugLevel$564$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$564$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon53_Then#1, inline$BDLSystemPowerIoCompletion$21$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon35#1;

  inline$BDLSystemPowerIoCompletion$21$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_140#1;

  inline$BDLSystemPowerIoCompletion$21$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_140_true#1, inline$BDLSystemPowerIoCompletion$21$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_67#1;

  inline$BDLSystemPowerIoCompletion$21$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_141#1;

  inline$BDLSystemPowerIoCompletion$21$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_67#1;

  inline$BDLSystemPowerIoCompletion$21$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$21$label_115#1;

  inline$BDLSystemPowerIoCompletion$21$label_115#1:
    inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$21$label_80#1;

  inline$BDLSystemPowerIoCompletion$21$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$21$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_42#1;

  inline$BDLSystemPowerIoCompletion$21$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$21$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$21$label_43#1;

  inline$BDLSystemPowerIoCompletion$21$label_43#1:
    goto inline$BDLGetDebugLevel$556$Entry#1;

  inline$BDLGetDebugLevel$556$Entry#1:
    goto inline$BDLGetDebugLevel$556$start#1;

  inline$BDLGetDebugLevel$556$start#1:
    goto inline$BDLGetDebugLevel$556$label_3#1;

  inline$BDLGetDebugLevel$556$label_3#1:
    havoc inline$BDLGetDebugLevel$556$myNondetVar_0;
    inline$BDLGetDebugLevel$556$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$556$myNondetVar_0;
    goto inline$BDLGetDebugLevel$556$label_1#1;

  inline$BDLGetDebugLevel$556$label_1#1:
    goto inline$BDLGetDebugLevel$556$Return#1;

  inline$BDLGetDebugLevel$556$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$556$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon40_Then#1, inline$BDLSystemPowerIoCompletion$21$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon9#1;

  inline$BDLSystemPowerIoCompletion$21$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_46#1;

  inline$BDLSystemPowerIoCompletion$21$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_46_true#1, inline$BDLSystemPowerIoCompletion$21$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_47#1;

  inline$BDLSystemPowerIoCompletion$21$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_50#1;

  inline$BDLSystemPowerIoCompletion$21$label_50#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_51#1;

  inline$BDLSystemPowerIoCompletion$21$label_51#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_52#1;

  inline$BDLSystemPowerIoCompletion$21$label_52#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_53#1;

  inline$BDLSystemPowerIoCompletion$21$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$21$label_47#1;

  inline$BDLSystemPowerIoCompletion$21$label_47#1:
    goto inline$BDLGetDebugLevel$557$Entry#1;

  inline$BDLGetDebugLevel$557$Entry#1:
    goto inline$BDLGetDebugLevel$557$start#1;

  inline$BDLGetDebugLevel$557$start#1:
    goto inline$BDLGetDebugLevel$557$label_3#1;

  inline$BDLGetDebugLevel$557$label_3#1:
    havoc inline$BDLGetDebugLevel$557$myNondetVar_0;
    inline$BDLGetDebugLevel$557$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$557$myNondetVar_0;
    goto inline$BDLGetDebugLevel$557$label_1#1;

  inline$BDLGetDebugLevel$557$label_1#1:
    goto inline$BDLGetDebugLevel$557$Return#1;

  inline$BDLGetDebugLevel$557$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$557$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon41_Then#1, inline$BDLSystemPowerIoCompletion$21$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon11#1;

  inline$BDLSystemPowerIoCompletion$21$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_56#1;

  inline$BDLSystemPowerIoCompletion$21$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_56_true#1, inline$BDLSystemPowerIoCompletion$21$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_57#1;

  inline$BDLSystemPowerIoCompletion$21$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_60#1;

  inline$BDLSystemPowerIoCompletion$21$label_60#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_61#1;

  inline$BDLSystemPowerIoCompletion$21$label_61#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_62#1;

  inline$BDLSystemPowerIoCompletion$21$label_62#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_63#1;

  inline$BDLSystemPowerIoCompletion$21$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$21$label_57#1;

  inline$BDLSystemPowerIoCompletion$21$label_57#1:
    goto inline$BDLGetDebugLevel$558$Entry#1;

  inline$BDLGetDebugLevel$558$Entry#1:
    goto inline$BDLGetDebugLevel$558$start#1;

  inline$BDLGetDebugLevel$558$start#1:
    goto inline$BDLGetDebugLevel$558$label_3#1;

  inline$BDLGetDebugLevel$558$label_3#1:
    havoc inline$BDLGetDebugLevel$558$myNondetVar_0;
    inline$BDLGetDebugLevel$558$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$558$myNondetVar_0;
    goto inline$BDLGetDebugLevel$558$label_1#1;

  inline$BDLGetDebugLevel$558$label_1#1:
    goto inline$BDLGetDebugLevel$558$Return#1;

  inline$BDLGetDebugLevel$558$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$558$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon42_Then#1, inline$BDLSystemPowerIoCompletion$21$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon13#1;

  inline$BDLSystemPowerIoCompletion$21$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_66#1;

  inline$BDLSystemPowerIoCompletion$21$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_66_true#1, inline$BDLSystemPowerIoCompletion$21$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_67#1;

  inline$BDLSystemPowerIoCompletion$21$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_70#1;

  inline$BDLSystemPowerIoCompletion$21$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_67#1;

  inline$BDLSystemPowerIoCompletion$21$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$21$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$21$anon43_Then#1, inline$BDLSystemPowerIoCompletion$21$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon15#1;

  inline$BDLSystemPowerIoCompletion$21$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_71#1;

  inline$BDLSystemPowerIoCompletion$21$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$21$anon44_Then#1, inline$BDLSystemPowerIoCompletion$21$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon17#1;

  inline$BDLSystemPowerIoCompletion$21$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_74#1;

  inline$BDLSystemPowerIoCompletion$21$label_74#1:
    goto inline$storm_IoCompleteRequest$44$Entry#1;

  inline$storm_IoCompleteRequest$44$Entry#1:
    inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$21$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$44$start#1;

  inline$storm_IoCompleteRequest$44$start#1:
    inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$44$label_3#1;

  inline$storm_IoCompleteRequest$44$label_3#1:
    call inline$storm_IoCompleteRequest$44$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$44$label_6#1;

  inline$storm_IoCompleteRequest$44$label_6#1:
    goto inline$storm_IoCompleteRequest$44$label_6_true#1, inline$storm_IoCompleteRequest$44$label_6_false#1;

  inline$storm_IoCompleteRequest$44$label_6_false#1:
    assume inline$storm_IoCompleteRequest$44$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$44$label_7#1;

  inline$storm_IoCompleteRequest$44$label_6_true#1:
    assume inline$storm_IoCompleteRequest$44$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$44$label_8#1;

  inline$storm_IoCompleteRequest$44$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$44$anon3_Then#1, inline$storm_IoCompleteRequest$44$anon3_Else#1;

  inline$storm_IoCompleteRequest$44$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$44$anon1#1;

  inline$storm_IoCompleteRequest$44$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$44$label_9#1;

  inline$storm_IoCompleteRequest$44$label_9#1:
    goto inline$storm_IoCompleteRequest$44$label_9_true#1, inline$storm_IoCompleteRequest$44$label_9_false#1;

  inline$storm_IoCompleteRequest$44$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$44$label_10#1;

  inline$storm_IoCompleteRequest$44$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$44$label_1#1;

  inline$storm_IoCompleteRequest$44$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$44$label_7#1;

  inline$storm_IoCompleteRequest$44$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$44$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$44$label_1#1;

  inline$storm_IoCompleteRequest$44$label_1#1:
    goto inline$storm_IoCompleteRequest$44$Return#1;

  inline$storm_IoCompleteRequest$44$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$44$Return#1;

  inline$storm_IoCompleteRequest$44$Return#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon45_Then#1, inline$BDLSystemPowerIoCompletion$21$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon19#1;

  inline$BDLSystemPowerIoCompletion$21$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_77#1;

  inline$BDLSystemPowerIoCompletion$21$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$21$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$21$anon46_Then#1, inline$BDLSystemPowerIoCompletion$21$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon21#1;

  inline$BDLSystemPowerIoCompletion$21$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_80#1;

  inline$BDLSystemPowerIoCompletion$21$label_80#1:
    goto inline$BDLGetDebugLevel$559$Entry#1;

  inline$BDLGetDebugLevel$559$Entry#1:
    goto inline$BDLGetDebugLevel$559$start#1;

  inline$BDLGetDebugLevel$559$start#1:
    goto inline$BDLGetDebugLevel$559$label_3#1;

  inline$BDLGetDebugLevel$559$label_3#1:
    havoc inline$BDLGetDebugLevel$559$myNondetVar_0;
    inline$BDLGetDebugLevel$559$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$559$myNondetVar_0;
    goto inline$BDLGetDebugLevel$559$label_1#1;

  inline$BDLGetDebugLevel$559$label_1#1:
    goto inline$BDLGetDebugLevel$559$Return#1;

  inline$BDLGetDebugLevel$559$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$559$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon47_Then#1, inline$BDLSystemPowerIoCompletion$21$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon23#1;

  inline$BDLSystemPowerIoCompletion$21$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_83#1;

  inline$BDLSystemPowerIoCompletion$21$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_83_true#1, inline$BDLSystemPowerIoCompletion$21$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_84#1;

  inline$BDLSystemPowerIoCompletion$21$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_87#1;

  inline$BDLSystemPowerIoCompletion$21$label_87#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_88#1;

  inline$BDLSystemPowerIoCompletion$21$label_88#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_89#1;

  inline$BDLSystemPowerIoCompletion$21$label_89#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_90#1;

  inline$BDLSystemPowerIoCompletion$21$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$21$label_84#1;

  inline$BDLSystemPowerIoCompletion$21$label_84#1:
    goto inline$BDLGetDebugLevel$560$Entry#1;

  inline$BDLGetDebugLevel$560$Entry#1:
    goto inline$BDLGetDebugLevel$560$start#1;

  inline$BDLGetDebugLevel$560$start#1:
    goto inline$BDLGetDebugLevel$560$label_3#1;

  inline$BDLGetDebugLevel$560$label_3#1:
    havoc inline$BDLGetDebugLevel$560$myNondetVar_0;
    inline$BDLGetDebugLevel$560$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$560$myNondetVar_0;
    goto inline$BDLGetDebugLevel$560$label_1#1;

  inline$BDLGetDebugLevel$560$label_1#1:
    goto inline$BDLGetDebugLevel$560$Return#1;

  inline$BDLGetDebugLevel$560$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$560$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon48_Then#1, inline$BDLSystemPowerIoCompletion$21$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon25#1;

  inline$BDLSystemPowerIoCompletion$21$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_93#1;

  inline$BDLSystemPowerIoCompletion$21$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_93_true#1, inline$BDLSystemPowerIoCompletion$21$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_94#1;

  inline$BDLSystemPowerIoCompletion$21$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_97#1;

  inline$BDLSystemPowerIoCompletion$21$label_97#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_98#1;

  inline$BDLSystemPowerIoCompletion$21$label_98#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_99#1;

  inline$BDLSystemPowerIoCompletion$21$label_99#1:
    call inline$BDLSystemPowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$21$label_100#1;

  inline$BDLSystemPowerIoCompletion$21$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$21$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$21$label_94#1;

  inline$BDLSystemPowerIoCompletion$21$label_94#1:
    goto inline$BDLGetDebugLevel$561$Entry#1;

  inline$BDLGetDebugLevel$561$Entry#1:
    goto inline$BDLGetDebugLevel$561$start#1;

  inline$BDLGetDebugLevel$561$start#1:
    goto inline$BDLGetDebugLevel$561$label_3#1;

  inline$BDLGetDebugLevel$561$label_3#1:
    havoc inline$BDLGetDebugLevel$561$myNondetVar_0;
    inline$BDLGetDebugLevel$561$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$561$myNondetVar_0;
    goto inline$BDLGetDebugLevel$561$label_1#1;

  inline$BDLGetDebugLevel$561$label_1#1:
    goto inline$BDLGetDebugLevel$561$Return#1;

  inline$BDLGetDebugLevel$561$Return#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$561$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$21$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$21$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$21$anon49_Then#1, inline$BDLSystemPowerIoCompletion$21$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$21$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$anon27#1;

  inline$BDLSystemPowerIoCompletion$21$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_103#1;

  inline$BDLSystemPowerIoCompletion$21$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_103_true#1, inline$BDLSystemPowerIoCompletion$21$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$21$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_104#1;

  inline$BDLSystemPowerIoCompletion$21$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$21$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$21$label_105#1;

  inline$BDLSystemPowerIoCompletion$21$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$21$label_104#1;

  inline$BDLSystemPowerIoCompletion$21$label_104#1:
    inline$BDLSystemPowerIoCompletion$21$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$21$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$21$label_1#1;

  inline$BDLSystemPowerIoCompletion$21$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$21$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$21$Return#1;

  inline$BDLSystemPowerIoCompletion$21$Return#1:
    inline$CallCompletionRoutine$21$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$21$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$21$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$21$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$21$anon14_Then#1, inline$CallCompletionRoutine$21$anon14_Else#1;

  inline$CallCompletionRoutine$21$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$21$anon9#1;

  inline$CallCompletionRoutine$21$anon9#1:
    goto inline$CallCompletionRoutine$21$label_20_icall_return#1;

  inline$CallCompletionRoutine$21$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$21$Return#1;

  inline$CallCompletionRoutine$21$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$21$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$21$Entry#1;

  inline$BDLDevicePowerIoCompletion$21$Entry#1:
    inline$BDLDevicePowerIoCompletion$21$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$21$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$21$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$21$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$21$start#1;

  inline$BDLDevicePowerIoCompletion$21$start#1:
    call inline$BDLDevicePowerIoCompletion$21$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$21$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$21$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$21$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$21$label_3#1;

  inline$BDLDevicePowerIoCompletion$21$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_4#1;

  inline$BDLDevicePowerIoCompletion$21$label_4#1:
    inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_5#1;

  inline$BDLDevicePowerIoCompletion$21$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_6#1;

  inline$BDLDevicePowerIoCompletion$21$label_6#1:
    inline$BDLDevicePowerIoCompletion$21$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$21$label_7#1;

  inline$BDLDevicePowerIoCompletion$21$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_8#1;

  inline$BDLDevicePowerIoCompletion$21$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$21$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$21$label_9#1;

  inline$BDLDevicePowerIoCompletion$21$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_10#1;

  inline$BDLDevicePowerIoCompletion$21$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$110$Entry#1;

  inline$IoGetCurrentIrpStackLocation$110$Entry#1:
    inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$110$start#1;

  inline$IoGetCurrentIrpStackLocation$110$start#1:
    inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$110$label_3#1;

  inline$IoGetCurrentIrpStackLocation$110$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$110$label_3_true#1, inline$IoGetCurrentIrpStackLocation$110$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$110$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$110$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$110$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$110$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$110$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$110$label_4#1;

  inline$IoGetCurrentIrpStackLocation$110$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$110$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$110$label_6#1;

  inline$IoGetCurrentIrpStackLocation$110$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$110$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$110$label_7#1;

  inline$IoGetCurrentIrpStackLocation$110$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$110$label_5#1;

  inline$IoGetCurrentIrpStackLocation$110$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$110$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$110$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$110$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$110$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$110$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$110$label_5#1;

  inline$IoGetCurrentIrpStackLocation$110$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$110$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$110$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$110$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$110$label_1#1;

  inline$IoGetCurrentIrpStackLocation$110$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$110$Return#1;

  inline$IoGetCurrentIrpStackLocation$110$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$110$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon30_Then#1, inline$BDLDevicePowerIoCompletion$21$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon1#1;

  inline$BDLDevicePowerIoCompletion$21$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_13#1;

  inline$BDLDevicePowerIoCompletion$21$label_13#1:
    inline$BDLDevicePowerIoCompletion$21$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$21$label_14#1;

  inline$BDLDevicePowerIoCompletion$21$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_15#1;

  inline$BDLDevicePowerIoCompletion$21$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$21$label_16#1;

  inline$BDLDevicePowerIoCompletion$21$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_17#1;

  inline$BDLDevicePowerIoCompletion$21$label_17#1:
    goto inline$BDLGetDebugLevel$544$Entry#1;

  inline$BDLGetDebugLevel$544$Entry#1:
    goto inline$BDLGetDebugLevel$544$start#1;

  inline$BDLGetDebugLevel$544$start#1:
    goto inline$BDLGetDebugLevel$544$label_3#1;

  inline$BDLGetDebugLevel$544$label_3#1:
    havoc inline$BDLGetDebugLevel$544$myNondetVar_0;
    inline$BDLGetDebugLevel$544$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$544$myNondetVar_0;
    goto inline$BDLGetDebugLevel$544$label_1#1;

  inline$BDLGetDebugLevel$544$label_1#1:
    goto inline$BDLGetDebugLevel$544$Return#1;

  inline$BDLGetDebugLevel$544$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$544$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon31_Then#1, inline$BDLDevicePowerIoCompletion$21$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon3#1;

  inline$BDLDevicePowerIoCompletion$21$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_20#1;

  inline$BDLDevicePowerIoCompletion$21$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_20_true#1, inline$BDLDevicePowerIoCompletion$21$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_21#1;

  inline$BDLDevicePowerIoCompletion$21$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_24#1;

  inline$BDLDevicePowerIoCompletion$21$label_24#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_25#1;

  inline$BDLDevicePowerIoCompletion$21$label_25#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_26#1;

  inline$BDLDevicePowerIoCompletion$21$label_26#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_27#1;

  inline$BDLDevicePowerIoCompletion$21$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$21$label_21#1;

  inline$BDLDevicePowerIoCompletion$21$label_21#1:
    goto inline$BDLGetDebugLevel$545$Entry#1;

  inline$BDLGetDebugLevel$545$Entry#1:
    goto inline$BDLGetDebugLevel$545$start#1;

  inline$BDLGetDebugLevel$545$start#1:
    goto inline$BDLGetDebugLevel$545$label_3#1;

  inline$BDLGetDebugLevel$545$label_3#1:
    havoc inline$BDLGetDebugLevel$545$myNondetVar_0;
    inline$BDLGetDebugLevel$545$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$545$myNondetVar_0;
    goto inline$BDLGetDebugLevel$545$label_1#1;

  inline$BDLGetDebugLevel$545$label_1#1:
    goto inline$BDLGetDebugLevel$545$Return#1;

  inline$BDLGetDebugLevel$545$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$545$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon32_Then#1, inline$BDLDevicePowerIoCompletion$21$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon5#1;

  inline$BDLDevicePowerIoCompletion$21$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_30#1;

  inline$BDLDevicePowerIoCompletion$21$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_30_true#1, inline$BDLDevicePowerIoCompletion$21$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_31#1;

  inline$BDLDevicePowerIoCompletion$21$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_34#1;

  inline$BDLDevicePowerIoCompletion$21$label_34#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_35#1;

  inline$BDLDevicePowerIoCompletion$21$label_35#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_36#1;

  inline$BDLDevicePowerIoCompletion$21$label_36#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_37#1;

  inline$BDLDevicePowerIoCompletion$21$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$21$label_31#1;

  inline$BDLDevicePowerIoCompletion$21$label_31#1:
    goto inline$BDLGetDebugLevel$546$Entry#1;

  inline$BDLGetDebugLevel$546$Entry#1:
    goto inline$BDLGetDebugLevel$546$start#1;

  inline$BDLGetDebugLevel$546$start#1:
    goto inline$BDLGetDebugLevel$546$label_3#1;

  inline$BDLGetDebugLevel$546$label_3#1:
    havoc inline$BDLGetDebugLevel$546$myNondetVar_0;
    inline$BDLGetDebugLevel$546$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$546$myNondetVar_0;
    goto inline$BDLGetDebugLevel$546$label_1#1;

  inline$BDLGetDebugLevel$546$label_1#1:
    goto inline$BDLGetDebugLevel$546$Return#1;

  inline$BDLGetDebugLevel$546$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$546$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon33_Then#1, inline$BDLDevicePowerIoCompletion$21$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon7#1;

  inline$BDLDevicePowerIoCompletion$21$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_40#1;

  inline$BDLDevicePowerIoCompletion$21$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_40_true#1, inline$BDLDevicePowerIoCompletion$21$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_41#1;

  inline$BDLDevicePowerIoCompletion$21$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_42#1;

  inline$BDLDevicePowerIoCompletion$21$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_41#1;

  inline$BDLDevicePowerIoCompletion$21$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_41_true#1, inline$BDLDevicePowerIoCompletion$21$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$21$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$21$label_43#1;

  inline$BDLDevicePowerIoCompletion$21$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$21$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$21$label_44#1;

  inline$BDLDevicePowerIoCompletion$21$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_44_true#1, inline$BDLDevicePowerIoCompletion$21$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$21$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$21$label_45#1;

  inline$BDLDevicePowerIoCompletion$21$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_45_true#1, inline$BDLDevicePowerIoCompletion$21$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$21$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$21$label_43#1;

  inline$BDLDevicePowerIoCompletion$21$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$21$label_86#1;

  inline$BDLDevicePowerIoCompletion$21$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$21$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$21$label_46#1;

  inline$BDLDevicePowerIoCompletion$21$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$21$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$21$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$21$label_46#1;

  inline$BDLDevicePowerIoCompletion$21$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$21$label_49#1;

  inline$BDLDevicePowerIoCompletion$21$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_50#1;

  inline$BDLDevicePowerIoCompletion$21$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_51#1;

  inline$BDLDevicePowerIoCompletion$21$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_54#1;

  inline$BDLDevicePowerIoCompletion$21$label_54#1:
    inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$21$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$21$label_55#1;

  inline$BDLDevicePowerIoCompletion$21$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_55_true#1, inline$BDLDevicePowerIoCompletion$21$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_56#1;

  inline$BDLDevicePowerIoCompletion$21$label_56#1:
    call inline$BDLDevicePowerIoCompletion$21$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$21$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$21$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$21$anon34_Then#1, inline$BDLDevicePowerIoCompletion$21$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon9#1;

  inline$BDLDevicePowerIoCompletion$21$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_83#1;

  inline$BDLDevicePowerIoCompletion$21$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_59#1;

  inline$BDLDevicePowerIoCompletion$21$label_59#1:
    goto inline$BDLGetDebugLevel$547$Entry#1;

  inline$BDLGetDebugLevel$547$Entry#1:
    goto inline$BDLGetDebugLevel$547$start#1;

  inline$BDLGetDebugLevel$547$start#1:
    goto inline$BDLGetDebugLevel$547$label_3#1;

  inline$BDLGetDebugLevel$547$label_3#1:
    havoc inline$BDLGetDebugLevel$547$myNondetVar_0;
    inline$BDLGetDebugLevel$547$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$547$myNondetVar_0;
    goto inline$BDLGetDebugLevel$547$label_1#1;

  inline$BDLGetDebugLevel$547$label_1#1:
    goto inline$BDLGetDebugLevel$547$Return#1;

  inline$BDLGetDebugLevel$547$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$547$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon35_Then#1, inline$BDLDevicePowerIoCompletion$21$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon11#1;

  inline$BDLDevicePowerIoCompletion$21$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_62#1;

  inline$BDLDevicePowerIoCompletion$21$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_62_true#1, inline$BDLDevicePowerIoCompletion$21$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_63#1;

  inline$BDLDevicePowerIoCompletion$21$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_66#1;

  inline$BDLDevicePowerIoCompletion$21$label_66#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_67#1;

  inline$BDLDevicePowerIoCompletion$21$label_67#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_68#1;

  inline$BDLDevicePowerIoCompletion$21$label_68#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_69#1;

  inline$BDLDevicePowerIoCompletion$21$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$21$label_63#1;

  inline$BDLDevicePowerIoCompletion$21$label_63#1:
    goto inline$BDLGetDebugLevel$548$Entry#1;

  inline$BDLGetDebugLevel$548$Entry#1:
    goto inline$BDLGetDebugLevel$548$start#1;

  inline$BDLGetDebugLevel$548$start#1:
    goto inline$BDLGetDebugLevel$548$label_3#1;

  inline$BDLGetDebugLevel$548$label_3#1:
    havoc inline$BDLGetDebugLevel$548$myNondetVar_0;
    inline$BDLGetDebugLevel$548$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$548$myNondetVar_0;
    goto inline$BDLGetDebugLevel$548$label_1#1;

  inline$BDLGetDebugLevel$548$label_1#1:
    goto inline$BDLGetDebugLevel$548$Return#1;

  inline$BDLGetDebugLevel$548$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$548$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon36_Then#1, inline$BDLDevicePowerIoCompletion$21$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon13#1;

  inline$BDLDevicePowerIoCompletion$21$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_72#1;

  inline$BDLDevicePowerIoCompletion$21$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_72_true#1, inline$BDLDevicePowerIoCompletion$21$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_73#1;

  inline$BDLDevicePowerIoCompletion$21$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_76#1;

  inline$BDLDevicePowerIoCompletion$21$label_76#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_77#1;

  inline$BDLDevicePowerIoCompletion$21$label_77#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_78#1;

  inline$BDLDevicePowerIoCompletion$21$label_78#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_79#1;

  inline$BDLDevicePowerIoCompletion$21$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$21$label_73#1;

  inline$BDLDevicePowerIoCompletion$21$label_73#1:
    goto inline$BDLGetDebugLevel$549$Entry#1;

  inline$BDLGetDebugLevel$549$Entry#1:
    goto inline$BDLGetDebugLevel$549$start#1;

  inline$BDLGetDebugLevel$549$start#1:
    goto inline$BDLGetDebugLevel$549$label_3#1;

  inline$BDLGetDebugLevel$549$label_3#1:
    havoc inline$BDLGetDebugLevel$549$myNondetVar_0;
    inline$BDLGetDebugLevel$549$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$549$myNondetVar_0;
    goto inline$BDLGetDebugLevel$549$label_1#1;

  inline$BDLGetDebugLevel$549$label_1#1:
    goto inline$BDLGetDebugLevel$549$Return#1;

  inline$BDLGetDebugLevel$549$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$549$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon37_Then#1, inline$BDLDevicePowerIoCompletion$21$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon15#1;

  inline$BDLDevicePowerIoCompletion$21$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_82#1;

  inline$BDLDevicePowerIoCompletion$21$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_82_true#1, inline$BDLDevicePowerIoCompletion$21$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_83#1;

  inline$BDLDevicePowerIoCompletion$21$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_84#1;

  inline$BDLDevicePowerIoCompletion$21$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_83#1;

  inline$BDLDevicePowerIoCompletion$21$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_85#1;

  inline$BDLDevicePowerIoCompletion$21$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_86#1;

  inline$BDLDevicePowerIoCompletion$21$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$21$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$21$anon38_Then#1, inline$BDLDevicePowerIoCompletion$21$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon17#1;

  inline$BDLDevicePowerIoCompletion$21$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_89#1;

  inline$BDLDevicePowerIoCompletion$21$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$21$anon39_Then#1, inline$BDLDevicePowerIoCompletion$21$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon19#1;

  inline$BDLDevicePowerIoCompletion$21$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_92#1;

  inline$BDLDevicePowerIoCompletion$21$label_92#1:
    goto inline$storm_IoCompleteRequest$43$Entry#1;

  inline$storm_IoCompleteRequest$43$Entry#1:
    inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$21$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$43$start#1;

  inline$storm_IoCompleteRequest$43$start#1:
    inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$43$label_3#1;

  inline$storm_IoCompleteRequest$43$label_3#1:
    call inline$storm_IoCompleteRequest$43$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$43$label_6#1;

  inline$storm_IoCompleteRequest$43$label_6#1:
    goto inline$storm_IoCompleteRequest$43$label_6_true#1, inline$storm_IoCompleteRequest$43$label_6_false#1;

  inline$storm_IoCompleteRequest$43$label_6_false#1:
    assume inline$storm_IoCompleteRequest$43$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$43$label_7#1;

  inline$storm_IoCompleteRequest$43$label_6_true#1:
    assume inline$storm_IoCompleteRequest$43$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$43$label_8#1;

  inline$storm_IoCompleteRequest$43$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$43$anon3_Then#1, inline$storm_IoCompleteRequest$43$anon3_Else#1;

  inline$storm_IoCompleteRequest$43$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$43$anon1#1;

  inline$storm_IoCompleteRequest$43$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$43$label_9#1;

  inline$storm_IoCompleteRequest$43$label_9#1:
    goto inline$storm_IoCompleteRequest$43$label_9_true#1, inline$storm_IoCompleteRequest$43$label_9_false#1;

  inline$storm_IoCompleteRequest$43$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$43$label_10#1;

  inline$storm_IoCompleteRequest$43$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$43$label_1#1;

  inline$storm_IoCompleteRequest$43$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$43$label_7#1;

  inline$storm_IoCompleteRequest$43$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$43$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$43$label_1#1;

  inline$storm_IoCompleteRequest$43$label_1#1:
    goto inline$storm_IoCompleteRequest$43$Return#1;

  inline$storm_IoCompleteRequest$43$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$43$Return#1;

  inline$storm_IoCompleteRequest$43$Return#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon40_Then#1, inline$BDLDevicePowerIoCompletion$21$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon21#1;

  inline$BDLDevicePowerIoCompletion$21$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_95#1;

  inline$BDLDevicePowerIoCompletion$21$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$21$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$21$anon41_Then#1, inline$BDLDevicePowerIoCompletion$21$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon23#1;

  inline$BDLDevicePowerIoCompletion$21$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_98#1;

  inline$BDLDevicePowerIoCompletion$21$label_98#1:
    goto inline$BDLGetDebugLevel$550$Entry#1;

  inline$BDLGetDebugLevel$550$Entry#1:
    goto inline$BDLGetDebugLevel$550$start#1;

  inline$BDLGetDebugLevel$550$start#1:
    goto inline$BDLGetDebugLevel$550$label_3#1;

  inline$BDLGetDebugLevel$550$label_3#1:
    havoc inline$BDLGetDebugLevel$550$myNondetVar_0;
    inline$BDLGetDebugLevel$550$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$550$myNondetVar_0;
    goto inline$BDLGetDebugLevel$550$label_1#1;

  inline$BDLGetDebugLevel$550$label_1#1:
    goto inline$BDLGetDebugLevel$550$Return#1;

  inline$BDLGetDebugLevel$550$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$550$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon42_Then#1, inline$BDLDevicePowerIoCompletion$21$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon25#1;

  inline$BDLDevicePowerIoCompletion$21$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_101#1;

  inline$BDLDevicePowerIoCompletion$21$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_101_true#1, inline$BDLDevicePowerIoCompletion$21$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_102#1;

  inline$BDLDevicePowerIoCompletion$21$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_105#1;

  inline$BDLDevicePowerIoCompletion$21$label_105#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_106#1;

  inline$BDLDevicePowerIoCompletion$21$label_106#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_107#1;

  inline$BDLDevicePowerIoCompletion$21$label_107#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_108#1;

  inline$BDLDevicePowerIoCompletion$21$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$21$label_102#1;

  inline$BDLDevicePowerIoCompletion$21$label_102#1:
    goto inline$BDLGetDebugLevel$551$Entry#1;

  inline$BDLGetDebugLevel$551$Entry#1:
    goto inline$BDLGetDebugLevel$551$start#1;

  inline$BDLGetDebugLevel$551$start#1:
    goto inline$BDLGetDebugLevel$551$label_3#1;

  inline$BDLGetDebugLevel$551$label_3#1:
    havoc inline$BDLGetDebugLevel$551$myNondetVar_0;
    inline$BDLGetDebugLevel$551$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$551$myNondetVar_0;
    goto inline$BDLGetDebugLevel$551$label_1#1;

  inline$BDLGetDebugLevel$551$label_1#1:
    goto inline$BDLGetDebugLevel$551$Return#1;

  inline$BDLGetDebugLevel$551$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$551$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon43_Then#1, inline$BDLDevicePowerIoCompletion$21$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon27#1;

  inline$BDLDevicePowerIoCompletion$21$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_111#1;

  inline$BDLDevicePowerIoCompletion$21$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_111_true#1, inline$BDLDevicePowerIoCompletion$21$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_112#1;

  inline$BDLDevicePowerIoCompletion$21$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_115#1;

  inline$BDLDevicePowerIoCompletion$21$label_115#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_116#1;

  inline$BDLDevicePowerIoCompletion$21$label_116#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_117#1;

  inline$BDLDevicePowerIoCompletion$21$label_117#1:
    call inline$BDLDevicePowerIoCompletion$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$21$label_118#1;

  inline$BDLDevicePowerIoCompletion$21$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$21$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$21$label_112#1;

  inline$BDLDevicePowerIoCompletion$21$label_112#1:
    goto inline$BDLGetDebugLevel$552$Entry#1;

  inline$BDLGetDebugLevel$552$Entry#1:
    goto inline$BDLGetDebugLevel$552$start#1;

  inline$BDLGetDebugLevel$552$start#1:
    goto inline$BDLGetDebugLevel$552$label_3#1;

  inline$BDLGetDebugLevel$552$label_3#1:
    havoc inline$BDLGetDebugLevel$552$myNondetVar_0;
    inline$BDLGetDebugLevel$552$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$552$myNondetVar_0;
    goto inline$BDLGetDebugLevel$552$label_1#1;

  inline$BDLGetDebugLevel$552$label_1#1:
    goto inline$BDLGetDebugLevel$552$Return#1;

  inline$BDLGetDebugLevel$552$Return#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$552$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$21$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$21$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$21$anon44_Then#1, inline$BDLDevicePowerIoCompletion$21$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$21$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$anon29#1;

  inline$BDLDevicePowerIoCompletion$21$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_121#1;

  inline$BDLDevicePowerIoCompletion$21$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_121_true#1, inline$BDLDevicePowerIoCompletion$21$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$21$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_122#1;

  inline$BDLDevicePowerIoCompletion$21$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$21$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$21$label_123#1;

  inline$BDLDevicePowerIoCompletion$21$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$21$label_122#1;

  inline$BDLDevicePowerIoCompletion$21$label_122#1:
    inline$BDLDevicePowerIoCompletion$21$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$21$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$21$label_1#1;

  inline$BDLDevicePowerIoCompletion$21$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$21$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$21$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$21$Return#1;

  inline$BDLDevicePowerIoCompletion$21$Return#1:
    inline$CallCompletionRoutine$21$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$21$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$21$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$21$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$21$anon13_Then#1, inline$CallCompletionRoutine$21$anon13_Else#1;

  inline$CallCompletionRoutine$21$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$21$anon7#1;

  inline$CallCompletionRoutine$21$anon7#1:
    goto inline$CallCompletionRoutine$21$label_20_icall_return#1;

  inline$CallCompletionRoutine$21$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$21$Return#1;

  inline$CallCompletionRoutine$21$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$21$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$21$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$21$Entry#1;

  inline$BDLCallDriverCompletionRoutine$21$Entry#1:
    inline$BDLCallDriverCompletionRoutine$21$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$21$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$21$start#1;

  inline$BDLCallDriverCompletionRoutine$21$start#1:
    inline$BDLCallDriverCompletionRoutine$21$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$21$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$21$label_3#1;

  inline$BDLCallDriverCompletionRoutine$21$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$21$label_3_true#1, inline$BDLCallDriverCompletionRoutine$21$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$21$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$21$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$21$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$21$label_4#1;

  inline$BDLCallDriverCompletionRoutine$21$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$21$label_6#1;

  inline$BDLCallDriverCompletionRoutine$21$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$21$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$21$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$21$label_5#1;

  inline$BDLCallDriverCompletionRoutine$21$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$21$label_6#1;

  inline$BDLCallDriverCompletionRoutine$21$label_6#1:
    goto inline$storm_KeSetEvent$23$Entry#1;

  inline$storm_KeSetEvent$23$Entry#1:
    inline$storm_KeSetEvent$23$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$21$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$23$start#1;

  inline$storm_KeSetEvent$23$start#1:
    inline$storm_KeSetEvent$23$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$23$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$23$label_3#1;

  inline$storm_KeSetEvent$23$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$23$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$23$label_1#1;

  inline$storm_KeSetEvent$23$label_1#1:
    goto inline$storm_KeSetEvent$23$Return#1;

  inline$storm_KeSetEvent$23$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$21$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$21$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$21$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$21$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$21$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$21$anon1#1;

  inline$BDLCallDriverCompletionRoutine$21$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$21$label_9#1;

  inline$BDLCallDriverCompletionRoutine$21$label_9#1:
    inline$BDLCallDriverCompletionRoutine$21$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$21$label_1#1;

  inline$BDLCallDriverCompletionRoutine$21$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$21$Return#1;

  inline$BDLCallDriverCompletionRoutine$21$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$21$Return#1;

  inline$BDLCallDriverCompletionRoutine$21$Return#1:
    inline$CallCompletionRoutine$21$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$21$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$21$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$21$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$21$anon12_Then#1, inline$CallCompletionRoutine$21$anon12_Else#1;

  inline$CallCompletionRoutine$21$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$21$anon5#1;

  inline$CallCompletionRoutine$21$anon5#1:
    goto inline$CallCompletionRoutine$21$label_20_icall_return#1;

  inline$CallCompletionRoutine$21$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$21$label_23#1;

  inline$CallCompletionRoutine$21$label_23#1:
    inline$CallCompletionRoutine$21$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$21$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$21$label_24#1;

  inline$CallCompletionRoutine$21$label_24#1:
    goto inline$CallCompletionRoutine$21$label_24_true#1, inline$CallCompletionRoutine$21$label_24_false#1;

  inline$CallCompletionRoutine$21$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$21$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$21$label_1#1;

  inline$CallCompletionRoutine$21$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$21$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$21$label_25#1;

  inline$CallCompletionRoutine$21$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$21$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$21$label_1#1;

  inline$CallCompletionRoutine$21$label_1#1:
    goto inline$CallCompletionRoutine$21$Return#1;

  inline$CallCompletionRoutine$21$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$21$Return#1;

  inline$CallCompletionRoutine$21$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$21$Return#1;

  inline$CallCompletionRoutine$21$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$21$Return#1;

  inline$CallCompletionRoutine$21$Return#1:
    goto inline$storm_IoCallDriver$10$label_39$1#1;

  inline$storm_IoCallDriver$10$label_39$1#1:
    goto inline$storm_IoCallDriver$10$anon15_Then#1, inline$storm_IoCallDriver$10$anon15_Else#1;

  inline$storm_IoCallDriver$10$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$10$anon10#1;

  inline$storm_IoCallDriver$10$anon10#1:
    goto inline$storm_IoCallDriver$10$label_36#1;

  inline$storm_IoCallDriver$10$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$10$Return#1;

  inline$storm_IoCallDriver$10$label_27_case_0#1:
    assume inline$storm_IoCallDriver$10$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$10$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$10$label_28#1;

  inline$storm_IoCallDriver$10$label_28#1:
    inline$storm_IoCallDriver$10$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$10$label_42#1;

  inline$storm_IoCallDriver$10$label_42#1:
    goto inline$storm_IoCallDriver$10$label_43#1;

  inline$storm_IoCallDriver$10$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$10$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$10$label_36#1;

  inline$storm_IoCallDriver$10$label_36#1:
    inline$storm_IoCallDriver$10$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$10$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$10$label_1#1;

  inline$storm_IoCallDriver$10$label_1#1:
    goto inline$storm_IoCallDriver$10$Return#1;

  inline$storm_IoCallDriver$10$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$10$Return#1;

  inline$storm_IoCallDriver$10$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$10$Return#1;

  inline$storm_IoCallDriver$10$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$10$Return#1;

  inline$storm_IoCallDriver$10$Return#1:
    inline$storm_PoCallDriver$4$$result.storm_IoCallDriver$499.27$2$ := inline$storm_IoCallDriver$10$$result.storm_IoCallDriver$456.0$1$;
    goto inline$storm_PoCallDriver$4$label_3$1#1;

  inline$storm_PoCallDriver$4$label_3$1#1:
    goto inline$storm_PoCallDriver$4$anon2_Then#1, inline$storm_PoCallDriver$4$anon2_Else#1;

  inline$storm_PoCallDriver$4$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_PoCallDriver$4$anon1#1;

  inline$storm_PoCallDriver$4$anon1#1:
    goto inline$storm_PoCallDriver$4$label_6#1;

  inline$storm_PoCallDriver$4$label_6#1:
    inline$storm_PoCallDriver$4$$result.storm_PoCallDriver$494.0$1$ := inline$storm_PoCallDriver$4$$result.storm_IoCallDriver$499.27$2$;
    goto inline$storm_PoCallDriver$4$label_1#1;

  inline$storm_PoCallDriver$4$label_1#1:
    goto inline$storm_PoCallDriver$4$Return#1;

  inline$storm_PoCallDriver$4$anon2_Then#1:
    assume raiseException;
    goto inline$storm_PoCallDriver$4$Return#1;

  inline$storm_PoCallDriver$4$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_PoCallDriver$104.29$3$ := inline$storm_PoCallDriver$4$$result.storm_PoCallDriver$494.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_25$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_25$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon22_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon22_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon13#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon13#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_28#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_28#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_PoCallDriver$104.29$3$;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_29_true#1, inline$BDLCallLowerLevelDriverAndWait$4$label_29_false#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_29_false#1:
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_29_true#1:
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_31#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_31#1:
    goto inline$storm_KeWaitForSingleObject$4$Entry#1;

  inline$storm_KeWaitForSingleObject$4$Entry#1:
    inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1 := inline$BDLCallLowerLevelDriverAndWait$4$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1 := 0;
    goto inline$storm_KeWaitForSingleObject$4$start#1;

  inline$storm_KeWaitForSingleObject$4$start#1:
    inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1;
    inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1;
    goto inline$storm_KeWaitForSingleObject$4$label_3#1;

  inline$storm_KeWaitForSingleObject$4$label_3#1:
    goto inline$storm_KeWaitForSingleObject$4$label_3_true#1, inline$storm_KeWaitForSingleObject$4$label_3_false#1;

  inline$storm_KeWaitForSingleObject$4$label_3_false#1:
    assume inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 == 0;
    goto inline$storm_KeWaitForSingleObject$4$label_4#1;

  inline$storm_KeWaitForSingleObject$4$label_4#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$4$anon6_Then#1, inline$storm_KeWaitForSingleObject$4$anon6_Else#1;

  inline$storm_KeWaitForSingleObject$4$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$4$anon1#1;

  inline$storm_KeWaitForSingleObject$4$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$4$label_13#1;

  inline$storm_KeWaitForSingleObject$4$label_13#1:
    inline$storm_KeWaitForSingleObject$4$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$4$label_1#1;

  inline$storm_KeWaitForSingleObject$4$anon6_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$4$Return#1;

  inline$storm_KeWaitForSingleObject$4$label_3_true#1:
    assume inline$storm_KeWaitForSingleObject$4$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 != 0;
    goto inline$storm_KeWaitForSingleObject$4$label_5#1;

  inline$storm_KeWaitForSingleObject$4$label_5#1:
    call inline$storm_KeWaitForSingleObject$4$$result.storm_nondet$256.20$2$ := storm_nondet();
    goto inline$storm_KeWaitForSingleObject$4$label_8#1;

  inline$storm_KeWaitForSingleObject$4$label_8#1:
    goto inline$storm_KeWaitForSingleObject$4$label_8_true#1, inline$storm_KeWaitForSingleObject$4$label_8_false#1;

  inline$storm_KeWaitForSingleObject$4$label_8_false#1:
    assume inline$storm_KeWaitForSingleObject$4$$result.storm_nondet$256.20$2$ == 0;
    goto inline$storm_KeWaitForSingleObject$4$label_9#1;

  inline$storm_KeWaitForSingleObject$4$label_9#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$4$anon7_Then#1, inline$storm_KeWaitForSingleObject$4$anon7_Else#1;

  inline$storm_KeWaitForSingleObject$4$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$4$anon3#1;

  inline$storm_KeWaitForSingleObject$4$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20], 0);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$4$label_12#1;

  inline$storm_KeWaitForSingleObject$4$label_12#1:
    inline$storm_KeWaitForSingleObject$4$$result.storm_KeWaitForSingleObject$243.0$1$ := 258;
    goto inline$storm_KeWaitForSingleObject$4$label_1#1;

  inline$storm_KeWaitForSingleObject$4$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$4$Return#1;

  inline$storm_KeWaitForSingleObject$4$label_8_true#1:
    assume inline$storm_KeWaitForSingleObject$4$$result.storm_nondet$256.20$2$ != 0;
    goto inline$storm_KeWaitForSingleObject$4$label_10#1;

  inline$storm_KeWaitForSingleObject$4$label_10#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$4$anon8_Then#1, inline$storm_KeWaitForSingleObject$4$anon8_Else#1;

  inline$storm_KeWaitForSingleObject$4$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$4$anon5#1;

  inline$storm_KeWaitForSingleObject$4$anon5#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$4$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$4$label_11#1;

  inline$storm_KeWaitForSingleObject$4$label_11#1:
    inline$storm_KeWaitForSingleObject$4$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$4$label_1#1;

  inline$storm_KeWaitForSingleObject$4$label_1#1:
    goto inline$storm_KeWaitForSingleObject$4$Return#1;

  inline$storm_KeWaitForSingleObject$4$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$4$Return#1;

  inline$storm_KeWaitForSingleObject$4$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_KeWaitForSingleObject$116.38$5$ := inline$storm_KeWaitForSingleObject$4$$result.storm_KeWaitForSingleObject$243.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_31$1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_31$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon23_Then#1, inline$BDLCallLowerLevelDriverAndWait$4$anon23_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$anon15#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon15#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_34#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_34#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$4$$result.storm_KeWaitForSingleObject$116.38$5$;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_35#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_35#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_35_true#1, inline$BDLCallLowerLevelDriverAndWait$4$label_35_false#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_35_false#1:
    assume inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 == 0;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_35_true#1:
    assume inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 != 0;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_37#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_37#1:
    call inline$BDLCallLowerLevelDriverAndWait$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_38#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_38#1:
    call inline$BDLCallLowerLevelDriverAndWait$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_39#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_39#1:
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_36#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0;
    inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$4$myNondetVar_0;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_30#1:
    inline$BDLCallLowerLevelDriverAndWait$4$$result.BDLCallLowerLevelDriverAndWait$71.0$1$ := inline$BDLCallLowerLevelDriverAndWait$4$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8;
    goto inline$BDLCallLowerLevelDriverAndWait$4$label_1#1;

  inline$BDLCallLowerLevelDriverAndWait$4$label_1#1:
    call __HAVOC_free(inline$BDLCallLowerLevelDriverAndWait$4$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon23_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon22_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon21_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$4$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$4$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLCallLowerLevelDriverAndWait$2116.47$13$ := inline$BDLCallLowerLevelDriverAndWait$4$$result.BDLCallLowerLevelDriverAndWait$71.0$1$;
    goto inline$BDLPnPQueryStop$0$label_71$1#1;

  inline$BDLPnPQueryStop$0$label_71$1#1:
    goto inline$BDLPnPQueryStop$0$anon32_Then#1, inline$BDLPnPQueryStop$0$anon32_Else#1;

  inline$BDLPnPQueryStop$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon21#1;

  inline$BDLPnPQueryStop$0$anon21#1:
    goto inline$BDLPnPQueryStop$0$label_74#1;

  inline$BDLPnPQueryStop$0$label_74#1:
    inline$BDLPnPQueryStop$0$$status$4$2081.16$BDLPnPQueryStop$12 := inline$BDLPnPQueryStop$0$$result.BDLCallLowerLevelDriverAndWait$2116.47$13$;
    goto inline$BDLPnPQueryStop$0$label_42#1;

  inline$BDLPnPQueryStop$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon26_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$label_34_true#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    assume INT_ULT(0, inline$BDLPnPQueryStop$0$myNondetVar_0);
    goto inline$BDLPnPQueryStop$0$label_38#1;

  inline$BDLPnPQueryStop$0$label_38#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    havoc inline$BDLPnPQueryStop$0$myNondetVar_1;
    assume inline$BDLPnPQueryStop$0$myNondetVar_0 == inline$BDLPnPQueryStop$0$myNondetVar_1;
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    goto inline$storm_KeReleaseSpinLock$3$Entry#1;

  inline$storm_KeReleaseSpinLock$3$Entry#1:
    inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := SpinLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPQueryStop$0$$pBDLExtension$1$2076.40$BDLPnPQueryStop$12);
    goto inline$storm_KeReleaseSpinLock$3$start#1;

  inline$storm_KeReleaseSpinLock$3$start#1:
    inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$3$label_3#1;

  inline$storm_KeReleaseSpinLock$3$label_3#1:
    goto inline$storm_KeReleaseSpinLock$3$label_4#1;

  inline$storm_KeReleaseSpinLock$3$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$3$label_7#1;

  inline$storm_KeReleaseSpinLock$3$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$3$anon5_Then#1, inline$storm_KeReleaseSpinLock$3$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$3$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$3$anon1#1;

  inline$storm_KeReleaseSpinLock$3$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$3$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$3$label_8#1;

  inline$storm_KeReleaseSpinLock$3$label_8#1:
    goto inline$storm_getThreadID$6$Entry#1;

  inline$storm_getThreadID$6$Entry#1:
    goto inline$storm_getThreadID$6$anon0#1;

  inline$storm_getThreadID$6$anon0#1:
    inline$storm_getThreadID$6$tid := __storm_thread_id;
    goto inline$storm_getThreadID$6$Return#1;

  inline$storm_getThreadID$6$Return#1:
    inline$storm_KeReleaseSpinLock$3$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$6$tid;
    goto inline$storm_KeReleaseSpinLock$3$label_8$1#1;

  inline$storm_KeReleaseSpinLock$3$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$3$label_11#1;

  inline$storm_KeReleaseSpinLock$3$label_11#1:
    goto inline$storm_KeReleaseSpinLock$3$label_11_true#1, inline$storm_KeReleaseSpinLock$3$label_11_false#1;

  inline$storm_KeReleaseSpinLock$3$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$3$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$3$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$3$label_12#1;

  inline$storm_KeReleaseSpinLock$3$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$3$label_1#1;

  inline$storm_KeReleaseSpinLock$3$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$3$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$3$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$3$label_15#1;

  inline$storm_KeReleaseSpinLock$3$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$3$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$3$label_16#1;

  inline$storm_KeReleaseSpinLock$3$label_16#1:
    goto inline$storm_KeReleaseSpinLock$3$anon6_Then#1, inline$storm_KeReleaseSpinLock$3$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$3$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$3$anon4#1;

  inline$storm_KeReleaseSpinLock$3$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$3$anon4#1;

  inline$storm_KeReleaseSpinLock$3$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$3$label_1#1;

  inline$storm_KeReleaseSpinLock$3$label_1#1:
    goto inline$storm_KeReleaseSpinLock$3$Return#1;

  inline$storm_KeReleaseSpinLock$3$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$3$Return#1;

  inline$storm_KeReleaseSpinLock$3$Return#1:
    goto inline$BDLPnPQueryStop$0$label_38$1#1;

  inline$BDLPnPQueryStop$0$label_38$1#1:
    goto inline$BDLPnPQueryStop$0$anon27_Then#1, inline$BDLPnPQueryStop$0$anon27_Else#1;

  inline$BDLPnPQueryStop$0$anon27_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon11#1;

  inline$BDLPnPQueryStop$0$anon11#1:
    havoc inline$BDLPnPQueryStop$0$myNondetVar_0;
    goto inline$BDLPnPQueryStop$0$label_41#1;

  inline$BDLPnPQueryStop$0$label_41#1:
    inline$BDLPnPQueryStop$0$$status$4$2081.16$BDLPnPQueryStop$12 := 0 - 2147483631;
    goto inline$BDLPnPQueryStop$0$label_42#1;

  inline$BDLPnPQueryStop$0$label_42#1:
    goto inline$BDLGetDebugLevel$478$Entry#1;

  inline$BDLGetDebugLevel$478$Entry#1:
    goto inline$BDLGetDebugLevel$478$start#1;

  inline$BDLGetDebugLevel$478$start#1:
    goto inline$BDLGetDebugLevel$478$label_3#1;

  inline$BDLGetDebugLevel$478$label_3#1:
    havoc inline$BDLGetDebugLevel$478$myNondetVar_0;
    inline$BDLGetDebugLevel$478$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$478$myNondetVar_0;
    goto inline$BDLGetDebugLevel$478$label_1#1;

  inline$BDLGetDebugLevel$478$label_1#1:
    goto inline$BDLGetDebugLevel$478$Return#1;

  inline$BDLGetDebugLevel$478$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$14$ := inline$BDLGetDebugLevel$478$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryStop$0$label_42$1#1;

  inline$BDLPnPQueryStop$0$label_42$1#1:
    goto inline$BDLPnPQueryStop$0$anon28_Then#1, inline$BDLPnPQueryStop$0$anon28_Else#1;

  inline$BDLPnPQueryStop$0$anon28_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon13#1;

  inline$BDLPnPQueryStop$0$anon13#1:
    goto inline$BDLPnPQueryStop$0$label_45#1;

  inline$BDLPnPQueryStop$0$label_45#1:
    goto inline$BDLPnPQueryStop$0$label_45_true#1, inline$BDLPnPQueryStop$0$label_45_false#1;

  inline$BDLPnPQueryStop$0$label_45_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$14$) == 0;
    goto inline$BDLPnPQueryStop$0$label_46#1;

  inline$BDLPnPQueryStop$0$label_45_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$14$) != 0;
    goto inline$BDLPnPQueryStop$0$label_49#1;

  inline$BDLPnPQueryStop$0$label_49#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_50#1;

  inline$BDLPnPQueryStop$0$label_50#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_51#1;

  inline$BDLPnPQueryStop$0$label_51#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_52#1;

  inline$BDLPnPQueryStop$0$label_52#1:
    havoc inline$BDLPnPQueryStop$0$$result.DbgPrint$2119.0$15$;
    goto inline$BDLPnPQueryStop$0$label_46#1;

  inline$BDLPnPQueryStop$0$label_46#1:
    goto inline$BDLGetDebugLevel$479$Entry#1;

  inline$BDLGetDebugLevel$479$Entry#1:
    goto inline$BDLGetDebugLevel$479$start#1;

  inline$BDLGetDebugLevel$479$start#1:
    goto inline$BDLGetDebugLevel$479$label_3#1;

  inline$BDLGetDebugLevel$479$label_3#1:
    havoc inline$BDLGetDebugLevel$479$myNondetVar_0;
    inline$BDLGetDebugLevel$479$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$479$myNondetVar_0;
    goto inline$BDLGetDebugLevel$479$label_1#1;

  inline$BDLGetDebugLevel$479$label_1#1:
    goto inline$BDLGetDebugLevel$479$Return#1;

  inline$BDLGetDebugLevel$479$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$19$ := inline$BDLGetDebugLevel$479$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryStop$0$label_46$1#1;

  inline$BDLPnPQueryStop$0$label_46$1#1:
    goto inline$BDLPnPQueryStop$0$anon29_Then#1, inline$BDLPnPQueryStop$0$anon29_Else#1;

  inline$BDLPnPQueryStop$0$anon29_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon15#1;

  inline$BDLPnPQueryStop$0$anon15#1:
    goto inline$BDLPnPQueryStop$0$label_55#1;

  inline$BDLPnPQueryStop$0$label_55#1:
    goto inline$BDLPnPQueryStop$0$label_55_true#1, inline$BDLPnPQueryStop$0$label_55_false#1;

  inline$BDLPnPQueryStop$0$label_55_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$19$) == 0;
    goto inline$BDLPnPQueryStop$0$label_56#1;

  inline$BDLPnPQueryStop$0$label_55_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$19$) != 0;
    goto inline$BDLPnPQueryStop$0$label_59#1;

  inline$BDLPnPQueryStop$0$label_59#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_60#1;

  inline$BDLPnPQueryStop$0$label_60#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_61#1;

  inline$BDLPnPQueryStop$0$label_61#1:
    call inline$BDLPnPQueryStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryStop$0$label_62#1;

  inline$BDLPnPQueryStop$0$label_62#1:
    havoc inline$BDLPnPQueryStop$0$$result.DbgPrint$2119.0$20$;
    goto inline$BDLPnPQueryStop$0$label_56#1;

  inline$BDLPnPQueryStop$0$label_56#1:
    goto inline$BDLGetDebugLevel$480$Entry#1;

  inline$BDLGetDebugLevel$480$Entry#1:
    goto inline$BDLGetDebugLevel$480$start#1;

  inline$BDLGetDebugLevel$480$start#1:
    goto inline$BDLGetDebugLevel$480$label_3#1;

  inline$BDLGetDebugLevel$480$label_3#1:
    havoc inline$BDLGetDebugLevel$480$myNondetVar_0;
    inline$BDLGetDebugLevel$480$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$480$myNondetVar_0;
    goto inline$BDLGetDebugLevel$480$label_1#1;

  inline$BDLGetDebugLevel$480$label_1#1:
    goto inline$BDLGetDebugLevel$480$Return#1;

  inline$BDLGetDebugLevel$480$Return#1:
    inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$24$ := inline$BDLGetDebugLevel$480$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryStop$0$label_56$1#1;

  inline$BDLPnPQueryStop$0$label_56$1#1:
    goto inline$BDLPnPQueryStop$0$anon30_Then#1, inline$BDLPnPQueryStop$0$anon30_Else#1;

  inline$BDLPnPQueryStop$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryStop$0$anon17#1;

  inline$BDLPnPQueryStop$0$anon17#1:
    goto inline$BDLPnPQueryStop$0$label_65#1;

  inline$BDLPnPQueryStop$0$label_65#1:
    goto inline$BDLPnPQueryStop$0$label_65_true#1, inline$BDLPnPQueryStop$0$label_65_false#1;

  inline$BDLPnPQueryStop$0$label_65_false#1:
    assume BIT_BAND(inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$24$, 4) == 0;
    goto inline$BDLPnPQueryStop$0$label_66#1;

  inline$BDLPnPQueryStop$0$label_65_true#1:
    assume BIT_BAND(inline$BDLPnPQueryStop$0$$result.BDLGetDebugLevel$2119.0$24$, 4) != 0;
    goto inline$BDLPnPQueryStop$0$label_67#1;

  inline$BDLPnPQueryStop$0$label_67#1:
    goto inline$BDLPnPQueryStop$0$label_66#1;

  inline$BDLPnPQueryStop$0$label_66#1:
    inline$BDLPnPQueryStop$0$$result.BDLPnPQueryStop$2074.0$1$ := inline$BDLPnPQueryStop$0$$status$4$2081.16$BDLPnPQueryStop$12;
    goto inline$BDLPnPQueryStop$0$label_1#1;

  inline$BDLPnPQueryStop$0$label_1#1:
    call __HAVOC_free(inline$BDLPnPQueryStop$0$$irql$5$2082.16$BDLPnPQueryStop$12);
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon29_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon28_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon27_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon25_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon24_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon23_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$anon22_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryStop$0$Return#1;

  inline$BDLPnPQueryStop$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPQueryStop$916.32$29$ := inline$BDLPnPQueryStop$0$$result.BDLPnPQueryStop$2074.0$1$;
    goto inline$BDLPnP$0$label_128$1#1;

  inline$BDLPnP$0$label_128$1#1:
    goto inline$BDLPnP$0$anon72_Then#1, inline$BDLPnP$0$anon72_Else#1;

  inline$BDLPnP$0$anon72_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon37#1;

  inline$BDLPnP$0$anon37#1:
    goto inline$BDLPnP$0$label_149#1;

  inline$BDLPnP$0$label_149#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPQueryStop$916.32$29$;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon72_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_5#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 4;
    goto inline$BDLPnP$0$label_125#1;

  inline$BDLPnP$0$label_125#1:
    goto inline$BDLPnPStop$0$Entry#1;

  inline$BDLPnPStop$0$Entry#1:
    inline$BDLPnPStop$0$$pBDLExtension$1$2182.40$BDLPnPStop$12_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPStop$0$$pIrp$3$2184.40$BDLPnPStop$12_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPStop$0$start#1;

  inline$BDLPnPStop$0$start#1:
    inline$BDLPnPStop$0$$pBDLExtension$1$2182.40$BDLPnPStop$12 := inline$BDLPnPStop$0$$pBDLExtension$1$2182.40$BDLPnPStop$12_.1;
    inline$BDLPnPStop$0$$pIrp$3$2184.40$BDLPnPStop$12 := inline$BDLPnPStop$0$$pIrp$3$2184.40$BDLPnPStop$12_.1;
    goto inline$BDLPnPStop$0$label_3#1;

  inline$BDLPnPStop$0$label_3#1:
    goto inline$BDLPnPStop$0$label_4#1;

  inline$BDLPnPStop$0$label_4#1:
    inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 := 0;
    goto inline$BDLPnPStop$0$label_5#1;

  inline$BDLPnPStop$0$label_5#1:
    goto inline$BDLPnPStop$0$label_6#1;

  inline$BDLPnPStop$0$label_6#1:
    havoc inline$BDLPnPStop$0$myNondetVar_0;
    goto inline$BDLPnPStop$0$label_7#1;

  inline$BDLPnPStop$0$label_7#1:
    goto inline$BDLGetDebugLevel$379$Entry#1;

  inline$BDLGetDebugLevel$379$Entry#1:
    goto inline$BDLGetDebugLevel$379$start#1;

  inline$BDLGetDebugLevel$379$start#1:
    goto inline$BDLGetDebugLevel$379$label_3#1;

  inline$BDLGetDebugLevel$379$label_3#1:
    havoc inline$BDLGetDebugLevel$379$myNondetVar_0;
    inline$BDLGetDebugLevel$379$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$379$myNondetVar_0;
    goto inline$BDLGetDebugLevel$379$label_1#1;

  inline$BDLGetDebugLevel$379$label_1#1:
    goto inline$BDLGetDebugLevel$379$Return#1;

  inline$BDLGetDebugLevel$379$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$2$ := inline$BDLGetDebugLevel$379$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_7$1#1;

  inline$BDLPnPStop$0$label_7$1#1:
    goto inline$BDLPnPStop$0$anon28_Then#1, inline$BDLPnPStop$0$anon28_Else#1;

  inline$BDLPnPStop$0$anon28_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon1#1;

  inline$BDLPnPStop$0$anon1#1:
    goto inline$BDLPnPStop$0$label_10#1;

  inline$BDLPnPStop$0$label_10#1:
    goto inline$BDLPnPStop$0$label_10_true#1, inline$BDLPnPStop$0$label_10_false#1;

  inline$BDLPnPStop$0$label_10_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$2$) == 0;
    goto inline$BDLPnPStop$0$label_11#1;

  inline$BDLPnPStop$0$label_10_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$2$) != 0;
    goto inline$BDLPnPStop$0$label_14#1;

  inline$BDLPnPStop$0$label_14#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_15#1;

  inline$BDLPnPStop$0$label_15#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_16#1;

  inline$BDLPnPStop$0$label_16#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_17#1;

  inline$BDLPnPStop$0$label_17#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2190.0$3$;
    goto inline$BDLPnPStop$0$label_11#1;

  inline$BDLPnPStop$0$label_11#1:
    goto inline$BDLGetDebugLevel$380$Entry#1;

  inline$BDLGetDebugLevel$380$Entry#1:
    goto inline$BDLGetDebugLevel$380$start#1;

  inline$BDLGetDebugLevel$380$start#1:
    goto inline$BDLGetDebugLevel$380$label_3#1;

  inline$BDLGetDebugLevel$380$label_3#1:
    havoc inline$BDLGetDebugLevel$380$myNondetVar_0;
    inline$BDLGetDebugLevel$380$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$380$myNondetVar_0;
    goto inline$BDLGetDebugLevel$380$label_1#1;

  inline$BDLGetDebugLevel$380$label_1#1:
    goto inline$BDLGetDebugLevel$380$Return#1;

  inline$BDLGetDebugLevel$380$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$7$ := inline$BDLGetDebugLevel$380$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_11$1#1;

  inline$BDLPnPStop$0$label_11$1#1:
    goto inline$BDLPnPStop$0$anon29_Then#1, inline$BDLPnPStop$0$anon29_Else#1;

  inline$BDLPnPStop$0$anon29_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon3#1;

  inline$BDLPnPStop$0$anon3#1:
    goto inline$BDLPnPStop$0$label_20#1;

  inline$BDLPnPStop$0$label_20#1:
    goto inline$BDLPnPStop$0$label_20_true#1, inline$BDLPnPStop$0$label_20_false#1;

  inline$BDLPnPStop$0$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$7$) == 0;
    goto inline$BDLPnPStop$0$label_21#1;

  inline$BDLPnPStop$0$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$7$) != 0;
    goto inline$BDLPnPStop$0$label_24#1;

  inline$BDLPnPStop$0$label_24#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_25#1;

  inline$BDLPnPStop$0$label_25#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_26#1;

  inline$BDLPnPStop$0$label_26#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_27#1;

  inline$BDLPnPStop$0$label_27#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2190.0$8$;
    goto inline$BDLPnPStop$0$label_21#1;

  inline$BDLPnPStop$0$label_21#1:
    goto inline$BDLGetDebugLevel$381$Entry#1;

  inline$BDLGetDebugLevel$381$Entry#1:
    goto inline$BDLGetDebugLevel$381$start#1;

  inline$BDLGetDebugLevel$381$start#1:
    goto inline$BDLGetDebugLevel$381$label_3#1;

  inline$BDLGetDebugLevel$381$label_3#1:
    havoc inline$BDLGetDebugLevel$381$myNondetVar_0;
    inline$BDLGetDebugLevel$381$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$381$myNondetVar_0;
    goto inline$BDLGetDebugLevel$381$label_1#1;

  inline$BDLGetDebugLevel$381$label_1#1:
    goto inline$BDLGetDebugLevel$381$Return#1;

  inline$BDLGetDebugLevel$381$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$12$ := inline$BDLGetDebugLevel$381$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_21$1#1;

  inline$BDLPnPStop$0$label_21$1#1:
    goto inline$BDLPnPStop$0$anon30_Then#1, inline$BDLPnPStop$0$anon30_Else#1;

  inline$BDLPnPStop$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon5#1;

  inline$BDLPnPStop$0$anon5#1:
    goto inline$BDLPnPStop$0$label_30#1;

  inline$BDLPnPStop$0$label_30#1:
    goto inline$BDLPnPStop$0$label_30_true#1, inline$BDLPnPStop$0$label_30_false#1;

  inline$BDLPnPStop$0$label_30_false#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$12$, 4) == 0;
    goto inline$BDLPnPStop$0$label_31#1;

  inline$BDLPnPStop$0$label_30_true#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2190.0$12$, 4) != 0;
    goto inline$BDLPnPStop$0$label_34#1;

  inline$BDLPnPStop$0$label_34#1:
    goto inline$BDLPnPStop$0$label_31#1;

  inline$BDLPnPStop$0$label_31#1:
    call inline$BDLPnPStop$0$$result.IoSetDeviceInterfaceState$2199.29$13$ := IoSetDeviceInterfaceState(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPStop$0$$pBDLExtension$1$2182.40$BDLPnPStop$12), 0);
    goto inline$BDLPnPStop$0$anon31_Then#1, inline$BDLPnPStop$0$anon31_Else#1;

  inline$BDLPnPStop$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon7#1;

  inline$BDLPnPStop$0$anon7#1:
    goto inline$BDLPnPStop$0$label_35#1;

  inline$BDLPnPStop$0$label_35#1:
    goto inline$BDLPnPStop$0$label_38#1;

  inline$BDLPnPStop$0$label_38#1:
    inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 := inline$BDLPnPStop$0$$callresult.$2204.67$14$;
    goto inline$BDLPnPStop$0$label_39#1;

  inline$BDLPnPStop$0$label_39#1:
    goto inline$BDLPnPStop$0$label_39_true#1, inline$BDLPnPStop$0$label_39_false#1;

  inline$BDLPnPStop$0$label_39_false#1:
    assume inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 == 0;
    goto inline$BDLPnPStop$0$label_40#1;

  inline$BDLPnPStop$0$label_40#1:
    goto inline$BDLPnPStop$0$label_92#1;

  inline$BDLPnPStop$0$label_92#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$Entry#1;

  inline$BDLCallLowerLevelDriverAndWait$3$Entry#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1 := inline$BDLPnPStop$0$$pIrp$3$2184.40$BDLPnPStop$12;
    goto inline$BDLCallLowerLevelDriverAndWait$3$start#1;

  inline$BDLCallLowerLevelDriverAndWait$3$start#1:
    call inline$BDLCallLowerLevelDriverAndWait$3$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8 := __HAVOC_malloc(16);
    inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_3#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_4#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_4#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := 0;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_5#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_6#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_6#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$Entry#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$Entry#1:
    inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$start#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$start#1:
    inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4 := inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_4#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_4#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_5#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_5#1:
    goto inline$IoGetCurrentIrpStackLocation$72$Entry#1;

  inline$IoGetCurrentIrpStackLocation$72$Entry#1:
    inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetCurrentIrpStackLocation$72$start#1;

  inline$IoGetCurrentIrpStackLocation$72$start#1:
    inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$72$label_3#1;

  inline$IoGetCurrentIrpStackLocation$72$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$72$label_3_true#1, inline$IoGetCurrentIrpStackLocation$72$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$72$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$72$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$72$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$72$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$72$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$72$label_4#1;

  inline$IoGetCurrentIrpStackLocation$72$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$72$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$72$label_6#1;

  inline$IoGetCurrentIrpStackLocation$72$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$72$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$72$label_7#1;

  inline$IoGetCurrentIrpStackLocation$72$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$72$label_5#1;

  inline$IoGetCurrentIrpStackLocation$72$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$72$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$72$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$72$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$72$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$72$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$72$label_5#1;

  inline$IoGetCurrentIrpStackLocation$72$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$72$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$72$label_1#1;

  inline$IoGetCurrentIrpStackLocation$72$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$72$Return#1;

  inline$IoGetCurrentIrpStackLocation$72$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_5$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_5$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$anon4_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$3$anon4_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$anon4_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$anon1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$anon1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_8#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_8#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_9#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_9#1:
    goto inline$IoGetNextIrpStackLocation$7$Entry#1;

  inline$IoGetNextIrpStackLocation$7$Entry#1:
    inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$3$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetNextIrpStackLocation$7$start#1;

  inline$IoGetNextIrpStackLocation$7$start#1:
    inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$7$label_3#1;

  inline$IoGetNextIrpStackLocation$7$label_3#1:
    goto inline$IoGetNextIrpStackLocation$7$label_3_true#1, inline$IoGetNextIrpStackLocation$7$label_3_false#1;

  inline$IoGetNextIrpStackLocation$7$label_3_false#1:
    inline$IoGetNextIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$7$myVar_0);
    goto inline$IoGetNextIrpStackLocation$7$label_4#1;

  inline$IoGetNextIrpStackLocation$7$label_4#1:
    call inline$IoGetNextIrpStackLocation$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$7$label_6#1;

  inline$IoGetNextIrpStackLocation$7$label_6#1:
    call inline$IoGetNextIrpStackLocation$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$7$label_7#1;

  inline$IoGetNextIrpStackLocation$7$label_7#1:
    goto inline$IoGetNextIrpStackLocation$7$label_5#1;

  inline$IoGetNextIrpStackLocation$7$label_3_true#1:
    inline$IoGetNextIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$7$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$7$myVar_0);
    goto inline$IoGetNextIrpStackLocation$7$label_5#1;

  inline$IoGetNextIrpStackLocation$7$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$7$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$7$label_1#1;

  inline$IoGetNextIrpStackLocation$7$label_1#1:
    goto inline$IoGetNextIrpStackLocation$7$Return#1;

  inline$IoGetNextIrpStackLocation$7$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_9$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_9$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$anon5_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$3$anon5_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$anon5_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$anon3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$anon3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_12#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_12#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_13#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_13#1:
    havoc inline$IoCopyCurrentIrpStackLocationToNext$3$$result.memcpy$25110.4$3$;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_16#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_16#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$label_1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$label_1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$anon5_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$anon4_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$3$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$3$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_6$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_6$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon16_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon16_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_9#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_9#1:
    goto inline$storm_KeInitializeEvent$3$Entry#1;

  inline$storm_KeInitializeEvent$3$Entry#1:
    inline$storm_KeInitializeEvent$3$$Event$1$203.14$storm_KeInitializeEvent$12_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeInitializeEvent$3$$State$3$205.13$storm_KeInitializeEvent$12_.1 := 0;
    goto inline$storm_KeInitializeEvent$3$start#1;

  inline$storm_KeInitializeEvent$3$start#1:
    inline$storm_KeInitializeEvent$3$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$3$$Event$1$203.14$storm_KeInitializeEvent$12_.1;
    inline$storm_KeInitializeEvent$3$$State$3$205.13$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$3$$State$3$205.13$storm_KeInitializeEvent$12_.1;
    goto inline$storm_KeInitializeEvent$3$label_3#1;

  inline$storm_KeInitializeEvent$3$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeInitializeEvent$3$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$3$$State$3$205.13$storm_KeInitializeEvent$12];
    call contextSwitch();
    goto inline$storm_KeInitializeEvent$3$label_1#1;

  inline$storm_KeInitializeEvent$3$label_1#1:
    goto inline$storm_KeInitializeEvent$3$Return#1;

  inline$storm_KeInitializeEvent$3$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_9$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_9$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon17_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon17_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon3#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_12#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$3$Entry#1;

  inline$storm_IoSetCompletionRoutine$3$Entry#1:
    inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoSetCompletionRoutine$3$start#1;

  inline$storm_IoSetCompletionRoutine$3$start#1:
    inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24 := inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1;
    goto inline$storm_IoSetCompletionRoutine$3$label_3#1;

  inline$storm_IoSetCompletionRoutine$3$label_3#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_4#1;

  inline$storm_IoSetCompletionRoutine$3$label_4#1:
    call inline$storm_IoSetCompletionRoutine$3$$result.storm_nondet$405.2$1$ := storm_nondet();
    goto inline$storm_IoSetCompletionRoutine$3$label_7#1;

  inline$storm_IoSetCompletionRoutine$3$label_7#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_7_true#1, inline$storm_IoSetCompletionRoutine$3$label_7_false#1;

  inline$storm_IoSetCompletionRoutine$3$label_7_false#1:
    assume inline$storm_IoSetCompletionRoutine$3$$result.storm_nondet$405.2$1$ == 0;
    goto inline$storm_IoSetCompletionRoutine$3$label_8#1;

  inline$storm_IoSetCompletionRoutine$3$label_7_true#1:
    assume inline$storm_IoSetCompletionRoutine$3$$result.storm_nondet$405.2$1$ != 0;
    goto inline$storm_IoSetCompletionRoutine$3$label_11#1;

  inline$storm_IoSetCompletionRoutine$3$label_11#1:
    havoc raiseException;
    goto inline$storm_IoSetCompletionRoutine$3$anon6_Then#1, inline$storm_IoSetCompletionRoutine$3$anon6_Else#1;

  inline$storm_IoSetCompletionRoutine$3$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$3$anon3#1;

  inline$storm_IoSetCompletionRoutine$3$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24], 1);
    call contextSwitch();
    goto inline$storm_IoSetCompletionRoutine$3$label_12#1;

  inline$storm_IoSetCompletionRoutine$3$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_12_true#1, inline$storm_IoSetCompletionRoutine$3$label_12_false#1;

  inline$storm_IoSetCompletionRoutine$3$label_12_false#1:
    assume 0 == 0;
    goto inline$storm_IoSetCompletionRoutine$3$label_13#1;

  inline$storm_IoSetCompletionRoutine$3$label_13#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoSetCompletionRoutine$3$label_1#1;

  inline$storm_IoSetCompletionRoutine$3$label_12_true#1:
    assume 0 != 0;
    goto inline$storm_IoSetCompletionRoutine$3$label_8#1;

  inline$storm_IoSetCompletionRoutine$3$label_8#1:
    goto inline$IoGetNextIrpStackLocation$8$Entry#1;

  inline$IoGetNextIrpStackLocation$8$Entry#1:
    inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoSetCompletionRoutine$3$$pirp$1$396.10$storm_IoSetCompletionRoutine$24;
    goto inline$IoGetNextIrpStackLocation$8$start#1;

  inline$IoGetNextIrpStackLocation$8$start#1:
    inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$8$label_3#1;

  inline$IoGetNextIrpStackLocation$8$label_3#1:
    goto inline$IoGetNextIrpStackLocation$8$label_3_true#1, inline$IoGetNextIrpStackLocation$8$label_3_false#1;

  inline$IoGetNextIrpStackLocation$8$label_3_false#1:
    inline$IoGetNextIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$8$myVar_0);
    goto inline$IoGetNextIrpStackLocation$8$label_4#1;

  inline$IoGetNextIrpStackLocation$8$label_4#1:
    call inline$IoGetNextIrpStackLocation$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$8$label_6#1;

  inline$IoGetNextIrpStackLocation$8$label_6#1:
    call inline$IoGetNextIrpStackLocation$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$8$label_7#1;

  inline$IoGetNextIrpStackLocation$8$label_7#1:
    goto inline$IoGetNextIrpStackLocation$8$label_5#1;

  inline$IoGetNextIrpStackLocation$8$label_3_true#1:
    inline$IoGetNextIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$8$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$8$myVar_0);
    goto inline$IoGetNextIrpStackLocation$8$label_5#1;

  inline$IoGetNextIrpStackLocation$8$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$8$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$8$label_1#1;

  inline$IoGetNextIrpStackLocation$8$label_1#1:
    goto inline$IoGetNextIrpStackLocation$8$Return#1;

  inline$IoGetNextIrpStackLocation$8$Return#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_8$1#1;

  inline$storm_IoSetCompletionRoutine$3$label_8$1#1:
    goto inline$storm_IoSetCompletionRoutine$3$anon5_Then#1, inline$storm_IoSetCompletionRoutine$3$anon5_Else#1;

  inline$storm_IoSetCompletionRoutine$3$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$3$anon1#1;

  inline$storm_IoSetCompletionRoutine$3$anon1#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_16#1;

  inline$storm_IoSetCompletionRoutine$3$label_16#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_17#1;

  inline$storm_IoSetCompletionRoutine$3$label_17#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_18#1;

  inline$storm_IoSetCompletionRoutine$3$label_18#1:
    goto inline$storm_IoSetCompletionRoutine$3$label_1#1;

  inline$storm_IoSetCompletionRoutine$3$label_1#1:
    goto inline$storm_IoSetCompletionRoutine$3$Return#1;

  inline$storm_IoSetCompletionRoutine$3$anon5_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$3$Return#1;

  inline$storm_IoSetCompletionRoutine$3$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$3$Return#1;

  inline$storm_IoSetCompletionRoutine$3$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_12$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_12$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon18_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon18_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon5#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_15#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_15#1:
    goto inline$IoGetCurrentIrpStackLocation$73$Entry#1;

  inline$IoGetCurrentIrpStackLocation$73$Entry#1:
    inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoGetCurrentIrpStackLocation$73$start#1;

  inline$IoGetCurrentIrpStackLocation$73$start#1:
    inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$73$label_3#1;

  inline$IoGetCurrentIrpStackLocation$73$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$73$label_3_true#1, inline$IoGetCurrentIrpStackLocation$73$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$73$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$73$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$73$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$73$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$73$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$73$label_4#1;

  inline$IoGetCurrentIrpStackLocation$73$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$73$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$73$label_6#1;

  inline$IoGetCurrentIrpStackLocation$73$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$73$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$73$label_7#1;

  inline$IoGetCurrentIrpStackLocation$73$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$73$label_5#1;

  inline$IoGetCurrentIrpStackLocation$73$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$73$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$73$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$73$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$73$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$73$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$73$label_5#1;

  inline$IoGetCurrentIrpStackLocation$73$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$73$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$73$label_1#1;

  inline$IoGetCurrentIrpStackLocation$73$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$73$Return#1;

  inline$IoGetCurrentIrpStackLocation$73$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_15$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_15$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon19_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon19_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon7#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon7#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_18#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_18#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_18_true#1, inline$BDLCallLowerLevelDriverAndWait$3$label_18_false#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_18_false#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0;
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_19#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_19#1:
    goto inline$storm_IoCallDriver$7$Entry#1;

  inline$storm_IoCallDriver$7$Entry#1:
    inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoCallDriver$7$start#1;

  inline$storm_IoCallDriver$7$start#1:
    inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$7$label_3#1;

  inline$storm_IoCallDriver$7$label_3#1:
    goto inline$storm_IoCallDriver$7$label_4#1;

  inline$storm_IoCallDriver$7$label_4#1:
    goto inline$storm_IoCallDriver$7$label_5#1;

  inline$storm_IoCallDriver$7$label_5#1:
    goto inline$storm_IoCallDriver$7$label_6#1;

  inline$storm_IoCallDriver$7$label_6#1:
    call inline$storm_IoCallDriver$7$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$7$label_9#1;

  inline$storm_IoCallDriver$7$label_9#1:
    goto inline$storm_IoCallDriver$7$label_9_true#1, inline$storm_IoCallDriver$7$label_9_false#1;

  inline$storm_IoCallDriver$7$label_9_false#1:
    assume inline$storm_IoCallDriver$7$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$7$label_10#1;

  inline$storm_IoCallDriver$7$label_9_true#1:
    assume inline$storm_IoCallDriver$7$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$7$label_13#1;

  inline$storm_IoCallDriver$7$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$7$anon12_Then#1, inline$storm_IoCallDriver$7$anon12_Else#1;

  inline$storm_IoCallDriver$7$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$7$anon3#1;

  inline$storm_IoCallDriver$7$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$7$label_14#1;

  inline$storm_IoCallDriver$7$label_14#1:
    goto inline$storm_IoCallDriver$7$label_14_true#1, inline$storm_IoCallDriver$7$label_14_false#1;

  inline$storm_IoCallDriver$7$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$7$label_15#1;

  inline$storm_IoCallDriver$7$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$7$label_1#1;

  inline$storm_IoCallDriver$7$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$7$label_10#1;

  inline$storm_IoCallDriver$7$label_10#1:
    goto inline$IoSetNextIrpStackLocation$8$Entry#1;

  inline$IoSetNextIrpStackLocation$8$Entry#1:
    inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$8$start#1;

  inline$IoSetNextIrpStackLocation$8$start#1:
    inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$8$label_3#1;

  inline$IoSetNextIrpStackLocation$8$label_3#1:
    goto inline$IoSetNextIrpStackLocation$8$label_3_true#1, inline$IoSetNextIrpStackLocation$8$label_3_false#1;

  inline$IoSetNextIrpStackLocation$8$label_3_false#1:
    inline$IoSetNextIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$8$myVar_0);
    goto inline$IoSetNextIrpStackLocation$8$label_4#1;

  inline$IoSetNextIrpStackLocation$8$label_4#1:
    call inline$IoSetNextIrpStackLocation$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$8$label_7#1;

  inline$IoSetNextIrpStackLocation$8$label_7#1:
    call inline$IoSetNextIrpStackLocation$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$8$label_8#1;

  inline$IoSetNextIrpStackLocation$8$label_8#1:
    goto inline$IoSetNextIrpStackLocation$8$label_5#1;

  inline$IoSetNextIrpStackLocation$8$label_3_true#1:
    inline$IoSetNextIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$8$myVar_0);
    goto inline$IoSetNextIrpStackLocation$8$label_5#1;

  inline$IoSetNextIrpStackLocation$8$label_5#1:
    inline$IoSetNextIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$8$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$8$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$8$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$8$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$8$label_6#1;

  inline$IoSetNextIrpStackLocation$8$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$8$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$8$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$8$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$8$label_1#1;

  inline$IoSetNextIrpStackLocation$8$label_1#1:
    goto inline$IoSetNextIrpStackLocation$8$Return#1;

  inline$IoSetNextIrpStackLocation$8$Return#1:
    goto inline$storm_IoCallDriver$7$label_10$1#1;

  inline$storm_IoCallDriver$7$label_10$1#1:
    goto inline$storm_IoCallDriver$7$anon11_Then#1, inline$storm_IoCallDriver$7$anon11_Else#1;

  inline$storm_IoCallDriver$7$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$7$anon1#1;

  inline$storm_IoCallDriver$7$anon1#1:
    goto inline$storm_IoCallDriver$7$label_18#1;

  inline$storm_IoCallDriver$7$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$74$Entry#1;

  inline$IoGetCurrentIrpStackLocation$74$Entry#1:
    inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$74$start#1;

  inline$IoGetCurrentIrpStackLocation$74$start#1:
    inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$74$label_3#1;

  inline$IoGetCurrentIrpStackLocation$74$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$74$label_3_true#1, inline$IoGetCurrentIrpStackLocation$74$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$74$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$74$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$74$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$74$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$74$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$74$label_4#1;

  inline$IoGetCurrentIrpStackLocation$74$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$74$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$74$label_6#1;

  inline$IoGetCurrentIrpStackLocation$74$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$74$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$74$label_7#1;

  inline$IoGetCurrentIrpStackLocation$74$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$74$label_5#1;

  inline$IoGetCurrentIrpStackLocation$74$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$74$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$74$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$74$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$74$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$74$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$74$label_5#1;

  inline$IoGetCurrentIrpStackLocation$74$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$74$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$74$label_1#1;

  inline$IoGetCurrentIrpStackLocation$74$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$74$Return#1;

  inline$IoGetCurrentIrpStackLocation$74$Return#1:
    goto inline$storm_IoCallDriver$7$label_18$1#1;

  inline$storm_IoCallDriver$7$label_18$1#1:
    goto inline$storm_IoCallDriver$7$anon13_Then#1, inline$storm_IoCallDriver$7$anon13_Else#1;

  inline$storm_IoCallDriver$7$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$7$anon6#1;

  inline$storm_IoCallDriver$7$anon6#1:
    goto inline$storm_IoCallDriver$7$label_21#1;

  inline$storm_IoCallDriver$7$label_21#1:
    goto inline$storm_IoCallDriver$7$label_22#1;

  inline$storm_IoCallDriver$7$label_22#1:
    goto inline$storm_IoCallDriver$7$label_23#1;

  inline$storm_IoCallDriver$7$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$7$label_24#1;

  inline$storm_IoCallDriver$7$label_24#1:
    call inline$storm_IoCallDriver$7$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$7$label_27#1;

  inline$storm_IoCallDriver$7$label_27#1:
    goto inline$storm_IoCallDriver$7$label_27_case_0#1, inline$storm_IoCallDriver$7$label_27_case_1#1, inline$storm_IoCallDriver$7$label_27_case_2#1;

  inline$storm_IoCallDriver$7$label_27_case_2#1:
    assume inline$storm_IoCallDriver$7$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$7$label_30#1;

  inline$storm_IoCallDriver$7$label_30#1:
    inline$storm_IoCallDriver$7$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$7$label_31#1;

  inline$storm_IoCallDriver$7$label_31#1:
    goto inline$storm_IoCallDriver$7$label_32#1;

  inline$storm_IoCallDriver$7$label_32#1:
    goto inline$storm_IoCallDriver$7$label_33#1;

  inline$storm_IoCallDriver$7$label_33#1:
    goto inline$CallCompletionRoutine$14$Entry#1;

  inline$CallCompletionRoutine$14$Entry#1:
    inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$14$start#1;

  inline$CallCompletionRoutine$14$start#1:
    inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$14$label_3#1;

  inline$CallCompletionRoutine$14$label_3#1:
    goto inline$CallCompletionRoutine$14$label_4#1;

  inline$CallCompletionRoutine$14$label_4#1:
    goto inline$CallCompletionRoutine$14$label_5#1;

  inline$CallCompletionRoutine$14$label_5#1:
    goto inline$CallCompletionRoutine$14$label_6#1;

  inline$CallCompletionRoutine$14$label_6#1:
    goto inline$CallCompletionRoutine$14$label_7#1;

  inline$CallCompletionRoutine$14$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$75$Entry#1;

  inline$IoGetCurrentIrpStackLocation$75$Entry#1:
    inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$75$start#1;

  inline$IoGetCurrentIrpStackLocation$75$start#1:
    inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$75$label_3#1;

  inline$IoGetCurrentIrpStackLocation$75$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$75$label_3_true#1, inline$IoGetCurrentIrpStackLocation$75$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$75$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$75$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$75$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$75$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$75$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$75$label_4#1;

  inline$IoGetCurrentIrpStackLocation$75$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$75$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$75$label_6#1;

  inline$IoGetCurrentIrpStackLocation$75$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$75$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$75$label_7#1;

  inline$IoGetCurrentIrpStackLocation$75$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$75$label_5#1;

  inline$IoGetCurrentIrpStackLocation$75$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$75$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$75$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$75$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$75$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$75$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$75$label_5#1;

  inline$IoGetCurrentIrpStackLocation$75$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$75$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$75$label_1#1;

  inline$IoGetCurrentIrpStackLocation$75$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$75$Return#1;

  inline$IoGetCurrentIrpStackLocation$75$Return#1:
    goto inline$CallCompletionRoutine$14$label_7$1#1;

  inline$CallCompletionRoutine$14$label_7$1#1:
    goto inline$CallCompletionRoutine$14$anon10_Then#1, inline$CallCompletionRoutine$14$anon10_Else#1;

  inline$CallCompletionRoutine$14$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$14$anon1#1;

  inline$CallCompletionRoutine$14$anon1#1:
    goto inline$CallCompletionRoutine$14$label_10#1;

  inline$CallCompletionRoutine$14$label_10#1:
    goto inline$CallCompletionRoutine$14$label_11#1;

  inline$CallCompletionRoutine$14$label_11#1:
    havoc inline$CallCompletionRoutine$14$myNondetVar_0;
    inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$14$myNondetVar_0;
    goto inline$CallCompletionRoutine$14$label_12#1;

  inline$CallCompletionRoutine$14$label_12#1:
    havoc inline$CallCompletionRoutine$14$myNondetVar_0;
    inline$CallCompletionRoutine$14$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$14$myNondetVar_0;
    goto inline$CallCompletionRoutine$14$label_13#1;

  inline$CallCompletionRoutine$14$label_13#1:
    havoc inline$CallCompletionRoutine$14$myNondetVar_0;
    goto inline$CallCompletionRoutine$14$label_14#1;

  inline$CallCompletionRoutine$14$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$76$Entry#1;

  inline$IoGetCurrentIrpStackLocation$76$Entry#1:
    inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$76$start#1;

  inline$IoGetCurrentIrpStackLocation$76$start#1:
    inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$76$label_3#1;

  inline$IoGetCurrentIrpStackLocation$76$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$76$label_3_true#1, inline$IoGetCurrentIrpStackLocation$76$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$76$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$76$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$76$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$76$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$76$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$76$label_4#1;

  inline$IoGetCurrentIrpStackLocation$76$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$76$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$76$label_6#1;

  inline$IoGetCurrentIrpStackLocation$76$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$76$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$76$label_7#1;

  inline$IoGetCurrentIrpStackLocation$76$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$76$label_5#1;

  inline$IoGetCurrentIrpStackLocation$76$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$76$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$76$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$76$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$76$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$76$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$76$label_5#1;

  inline$IoGetCurrentIrpStackLocation$76$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$76$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$76$label_1#1;

  inline$IoGetCurrentIrpStackLocation$76$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$76$Return#1;

  inline$IoGetCurrentIrpStackLocation$76$Return#1:
    goto inline$CallCompletionRoutine$14$label_14$1#1;

  inline$CallCompletionRoutine$14$label_14$1#1:
    goto inline$CallCompletionRoutine$14$anon11_Then#1, inline$CallCompletionRoutine$14$anon11_Else#1;

  inline$CallCompletionRoutine$14$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$14$anon3#1;

  inline$CallCompletionRoutine$14$anon3#1:
    goto inline$CallCompletionRoutine$14$label_17#1;

  inline$CallCompletionRoutine$14$label_17#1:
    goto inline$CallCompletionRoutine$14$label_18#1;

  inline$CallCompletionRoutine$14$label_18#1:
    goto inline$CallCompletionRoutine$14$label_18_true#1, inline$CallCompletionRoutine$14$label_18_false#1;

  inline$CallCompletionRoutine$14$label_18_false#1:
    assume inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$14$label_1#1;

  inline$CallCompletionRoutine$14$label_18_true#1:
    assume inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$14$label_19#1;

  inline$CallCompletionRoutine$14$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$14$label_20#1;

  inline$CallCompletionRoutine$14$label_20#1:
    goto inline$CallCompletionRoutine$14$label_20_icall_1#1, inline$CallCompletionRoutine$14$label_20_icall_2#1, inline$CallCompletionRoutine$14$label_20_icall_3#1;

  inline$CallCompletionRoutine$14$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$14$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$14$Entry#1;

  inline$BDLSystemPowerIoCompletion$14$Entry#1:
    inline$BDLSystemPowerIoCompletion$14$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$14$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$14$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$14$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$14$start#1;

  inline$BDLSystemPowerIoCompletion$14$start#1:
    call inline$BDLSystemPowerIoCompletion$14$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$14$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$14$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$14$label_3#1;

  inline$BDLSystemPowerIoCompletion$14$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_4#1;

  inline$BDLSystemPowerIoCompletion$14$label_4#1:
    inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_5#1;

  inline$BDLSystemPowerIoCompletion$14$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_6#1;

  inline$BDLSystemPowerIoCompletion$14$label_6#1:
    inline$BDLSystemPowerIoCompletion$14$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$14$label_7#1;

  inline$BDLSystemPowerIoCompletion$14$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_8#1;

  inline$BDLSystemPowerIoCompletion$14$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$14$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$14$label_9#1;

  inline$BDLSystemPowerIoCompletion$14$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_10#1;

  inline$BDLSystemPowerIoCompletion$14$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$78$Entry#1;

  inline$IoGetCurrentIrpStackLocation$78$Entry#1:
    inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$78$start#1;

  inline$IoGetCurrentIrpStackLocation$78$start#1:
    inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$78$label_3#1;

  inline$IoGetCurrentIrpStackLocation$78$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$78$label_3_true#1, inline$IoGetCurrentIrpStackLocation$78$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$78$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$78$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$78$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$78$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$78$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$78$label_4#1;

  inline$IoGetCurrentIrpStackLocation$78$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$78$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$78$label_6#1;

  inline$IoGetCurrentIrpStackLocation$78$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$78$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$78$label_7#1;

  inline$IoGetCurrentIrpStackLocation$78$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$78$label_5#1;

  inline$IoGetCurrentIrpStackLocation$78$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$78$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$78$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$78$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$78$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$78$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$78$label_5#1;

  inline$IoGetCurrentIrpStackLocation$78$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$78$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$78$label_1#1;

  inline$IoGetCurrentIrpStackLocation$78$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$78$Return#1;

  inline$IoGetCurrentIrpStackLocation$78$Return#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon36_Then#1, inline$BDLSystemPowerIoCompletion$14$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon1#1;

  inline$BDLSystemPowerIoCompletion$14$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_13#1;

  inline$BDLSystemPowerIoCompletion$14$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_14#1;

  inline$BDLSystemPowerIoCompletion$14$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_15#1;

  inline$BDLSystemPowerIoCompletion$14$label_15#1:
    goto inline$BDLGetDebugLevel$397$Entry#1;

  inline$BDLGetDebugLevel$397$Entry#1:
    goto inline$BDLGetDebugLevel$397$start#1;

  inline$BDLGetDebugLevel$397$start#1:
    goto inline$BDLGetDebugLevel$397$label_3#1;

  inline$BDLGetDebugLevel$397$label_3#1:
    havoc inline$BDLGetDebugLevel$397$myNondetVar_0;
    inline$BDLGetDebugLevel$397$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$397$myNondetVar_0;
    goto inline$BDLGetDebugLevel$397$label_1#1;

  inline$BDLGetDebugLevel$397$label_1#1:
    goto inline$BDLGetDebugLevel$397$Return#1;

  inline$BDLGetDebugLevel$397$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$397$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon37_Then#1, inline$BDLSystemPowerIoCompletion$14$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon3#1;

  inline$BDLSystemPowerIoCompletion$14$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_18#1;

  inline$BDLSystemPowerIoCompletion$14$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_18_true#1, inline$BDLSystemPowerIoCompletion$14$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_19#1;

  inline$BDLSystemPowerIoCompletion$14$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_22#1;

  inline$BDLSystemPowerIoCompletion$14$label_22#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_23#1;

  inline$BDLSystemPowerIoCompletion$14$label_23#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_24#1;

  inline$BDLSystemPowerIoCompletion$14$label_24#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_25#1;

  inline$BDLSystemPowerIoCompletion$14$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$14$label_19#1;

  inline$BDLSystemPowerIoCompletion$14$label_19#1:
    goto inline$BDLGetDebugLevel$398$Entry#1;

  inline$BDLGetDebugLevel$398$Entry#1:
    goto inline$BDLGetDebugLevel$398$start#1;

  inline$BDLGetDebugLevel$398$start#1:
    goto inline$BDLGetDebugLevel$398$label_3#1;

  inline$BDLGetDebugLevel$398$label_3#1:
    havoc inline$BDLGetDebugLevel$398$myNondetVar_0;
    inline$BDLGetDebugLevel$398$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$398$myNondetVar_0;
    goto inline$BDLGetDebugLevel$398$label_1#1;

  inline$BDLGetDebugLevel$398$label_1#1:
    goto inline$BDLGetDebugLevel$398$Return#1;

  inline$BDLGetDebugLevel$398$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$398$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon38_Then#1, inline$BDLSystemPowerIoCompletion$14$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon5#1;

  inline$BDLSystemPowerIoCompletion$14$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_28#1;

  inline$BDLSystemPowerIoCompletion$14$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_28_true#1, inline$BDLSystemPowerIoCompletion$14$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_29#1;

  inline$BDLSystemPowerIoCompletion$14$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_32#1;

  inline$BDLSystemPowerIoCompletion$14$label_32#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_33#1;

  inline$BDLSystemPowerIoCompletion$14$label_33#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_34#1;

  inline$BDLSystemPowerIoCompletion$14$label_34#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_35#1;

  inline$BDLSystemPowerIoCompletion$14$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$14$label_29#1;

  inline$BDLSystemPowerIoCompletion$14$label_29#1:
    goto inline$BDLGetDebugLevel$399$Entry#1;

  inline$BDLGetDebugLevel$399$Entry#1:
    goto inline$BDLGetDebugLevel$399$start#1;

  inline$BDLGetDebugLevel$399$start#1:
    goto inline$BDLGetDebugLevel$399$label_3#1;

  inline$BDLGetDebugLevel$399$label_3#1:
    havoc inline$BDLGetDebugLevel$399$myNondetVar_0;
    inline$BDLGetDebugLevel$399$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$399$myNondetVar_0;
    goto inline$BDLGetDebugLevel$399$label_1#1;

  inline$BDLGetDebugLevel$399$label_1#1:
    goto inline$BDLGetDebugLevel$399$Return#1;

  inline$BDLGetDebugLevel$399$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$399$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon39_Then#1, inline$BDLSystemPowerIoCompletion$14$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon7#1;

  inline$BDLSystemPowerIoCompletion$14$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_38#1;

  inline$BDLSystemPowerIoCompletion$14$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_38_true#1, inline$BDLSystemPowerIoCompletion$14$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_39#1;

  inline$BDLSystemPowerIoCompletion$14$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_40#1;

  inline$BDLSystemPowerIoCompletion$14$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_39#1;

  inline$BDLSystemPowerIoCompletion$14$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_39_true#1, inline$BDLSystemPowerIoCompletion$14$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_41#1;

  inline$BDLSystemPowerIoCompletion$14$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$14$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$14$label_107#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$14$label_108#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$14$label_108#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$14$label_108#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$14$label_108#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$14$label_108#1;

  inline$BDLSystemPowerIoCompletion$14$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_109#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$14$label_107#1;

  inline$BDLSystemPowerIoCompletion$14$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_109#1;

  inline$BDLSystemPowerIoCompletion$14$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$14$label_106#1;

  inline$BDLSystemPowerIoCompletion$14$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_106_true#1, inline$BDLSystemPowerIoCompletion$14$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_142#1;

  inline$BDLSystemPowerIoCompletion$14$label_142#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_143#1;

  inline$BDLSystemPowerIoCompletion$14$label_143#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_144#1;

  inline$BDLSystemPowerIoCompletion$14$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_109#1;

  inline$BDLSystemPowerIoCompletion$14$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_109#1;

  inline$BDLSystemPowerIoCompletion$14$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$14$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$14$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$14$myNondetVar_0, inline$BDLSystemPowerIoCompletion$14$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$14$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$14$anon50_Then#1, inline$BDLSystemPowerIoCompletion$14$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon29#1;

  inline$BDLSystemPowerIoCompletion$14$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_112#1;

  inline$BDLSystemPowerIoCompletion$14$label_112#1:
    inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$14$label_113#1;

  inline$BDLSystemPowerIoCompletion$14$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_113_true#1, inline$BDLSystemPowerIoCompletion$14$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$14$label_114#1;

  inline$BDLSystemPowerIoCompletion$14$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_116#1;

  inline$BDLSystemPowerIoCompletion$14$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_117#1;

  inline$BDLSystemPowerIoCompletion$14$label_117#1:
    goto inline$BDLGetDebugLevel$406$Entry#1;

  inline$BDLGetDebugLevel$406$Entry#1:
    goto inline$BDLGetDebugLevel$406$start#1;

  inline$BDLGetDebugLevel$406$start#1:
    goto inline$BDLGetDebugLevel$406$label_3#1;

  inline$BDLGetDebugLevel$406$label_3#1:
    havoc inline$BDLGetDebugLevel$406$myNondetVar_0;
    inline$BDLGetDebugLevel$406$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$406$myNondetVar_0;
    goto inline$BDLGetDebugLevel$406$label_1#1;

  inline$BDLGetDebugLevel$406$label_1#1:
    goto inline$BDLGetDebugLevel$406$Return#1;

  inline$BDLGetDebugLevel$406$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$406$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon51_Then#1, inline$BDLSystemPowerIoCompletion$14$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon31#1;

  inline$BDLSystemPowerIoCompletion$14$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_120#1;

  inline$BDLSystemPowerIoCompletion$14$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_120_true#1, inline$BDLSystemPowerIoCompletion$14$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_121#1;

  inline$BDLSystemPowerIoCompletion$14$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_124#1;

  inline$BDLSystemPowerIoCompletion$14$label_124#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_125#1;

  inline$BDLSystemPowerIoCompletion$14$label_125#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_126#1;

  inline$BDLSystemPowerIoCompletion$14$label_126#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_127#1;

  inline$BDLSystemPowerIoCompletion$14$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$14$label_121#1;

  inline$BDLSystemPowerIoCompletion$14$label_121#1:
    goto inline$BDLGetDebugLevel$407$Entry#1;

  inline$BDLGetDebugLevel$407$Entry#1:
    goto inline$BDLGetDebugLevel$407$start#1;

  inline$BDLGetDebugLevel$407$start#1:
    goto inline$BDLGetDebugLevel$407$label_3#1;

  inline$BDLGetDebugLevel$407$label_3#1:
    havoc inline$BDLGetDebugLevel$407$myNondetVar_0;
    inline$BDLGetDebugLevel$407$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$407$myNondetVar_0;
    goto inline$BDLGetDebugLevel$407$label_1#1;

  inline$BDLGetDebugLevel$407$label_1#1:
    goto inline$BDLGetDebugLevel$407$Return#1;

  inline$BDLGetDebugLevel$407$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$407$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon52_Then#1, inline$BDLSystemPowerIoCompletion$14$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon33#1;

  inline$BDLSystemPowerIoCompletion$14$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_130#1;

  inline$BDLSystemPowerIoCompletion$14$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_130_true#1, inline$BDLSystemPowerIoCompletion$14$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_131#1;

  inline$BDLSystemPowerIoCompletion$14$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_134#1;

  inline$BDLSystemPowerIoCompletion$14$label_134#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_135#1;

  inline$BDLSystemPowerIoCompletion$14$label_135#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_136#1;

  inline$BDLSystemPowerIoCompletion$14$label_136#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_137#1;

  inline$BDLSystemPowerIoCompletion$14$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$14$label_131#1;

  inline$BDLSystemPowerIoCompletion$14$label_131#1:
    goto inline$BDLGetDebugLevel$408$Entry#1;

  inline$BDLGetDebugLevel$408$Entry#1:
    goto inline$BDLGetDebugLevel$408$start#1;

  inline$BDLGetDebugLevel$408$start#1:
    goto inline$BDLGetDebugLevel$408$label_3#1;

  inline$BDLGetDebugLevel$408$label_3#1:
    havoc inline$BDLGetDebugLevel$408$myNondetVar_0;
    inline$BDLGetDebugLevel$408$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$408$myNondetVar_0;
    goto inline$BDLGetDebugLevel$408$label_1#1;

  inline$BDLGetDebugLevel$408$label_1#1:
    goto inline$BDLGetDebugLevel$408$Return#1;

  inline$BDLGetDebugLevel$408$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$408$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon53_Then#1, inline$BDLSystemPowerIoCompletion$14$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon35#1;

  inline$BDLSystemPowerIoCompletion$14$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_140#1;

  inline$BDLSystemPowerIoCompletion$14$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_140_true#1, inline$BDLSystemPowerIoCompletion$14$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_67#1;

  inline$BDLSystemPowerIoCompletion$14$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_141#1;

  inline$BDLSystemPowerIoCompletion$14$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_67#1;

  inline$BDLSystemPowerIoCompletion$14$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$14$label_115#1;

  inline$BDLSystemPowerIoCompletion$14$label_115#1:
    inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$14$label_80#1;

  inline$BDLSystemPowerIoCompletion$14$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$14$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_42#1;

  inline$BDLSystemPowerIoCompletion$14$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$14$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$14$label_43#1;

  inline$BDLSystemPowerIoCompletion$14$label_43#1:
    goto inline$BDLGetDebugLevel$400$Entry#1;

  inline$BDLGetDebugLevel$400$Entry#1:
    goto inline$BDLGetDebugLevel$400$start#1;

  inline$BDLGetDebugLevel$400$start#1:
    goto inline$BDLGetDebugLevel$400$label_3#1;

  inline$BDLGetDebugLevel$400$label_3#1:
    havoc inline$BDLGetDebugLevel$400$myNondetVar_0;
    inline$BDLGetDebugLevel$400$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$400$myNondetVar_0;
    goto inline$BDLGetDebugLevel$400$label_1#1;

  inline$BDLGetDebugLevel$400$label_1#1:
    goto inline$BDLGetDebugLevel$400$Return#1;

  inline$BDLGetDebugLevel$400$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$400$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon40_Then#1, inline$BDLSystemPowerIoCompletion$14$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon9#1;

  inline$BDLSystemPowerIoCompletion$14$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_46#1;

  inline$BDLSystemPowerIoCompletion$14$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_46_true#1, inline$BDLSystemPowerIoCompletion$14$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_47#1;

  inline$BDLSystemPowerIoCompletion$14$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_50#1;

  inline$BDLSystemPowerIoCompletion$14$label_50#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_51#1;

  inline$BDLSystemPowerIoCompletion$14$label_51#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_52#1;

  inline$BDLSystemPowerIoCompletion$14$label_52#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_53#1;

  inline$BDLSystemPowerIoCompletion$14$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$14$label_47#1;

  inline$BDLSystemPowerIoCompletion$14$label_47#1:
    goto inline$BDLGetDebugLevel$401$Entry#1;

  inline$BDLGetDebugLevel$401$Entry#1:
    goto inline$BDLGetDebugLevel$401$start#1;

  inline$BDLGetDebugLevel$401$start#1:
    goto inline$BDLGetDebugLevel$401$label_3#1;

  inline$BDLGetDebugLevel$401$label_3#1:
    havoc inline$BDLGetDebugLevel$401$myNondetVar_0;
    inline$BDLGetDebugLevel$401$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$401$myNondetVar_0;
    goto inline$BDLGetDebugLevel$401$label_1#1;

  inline$BDLGetDebugLevel$401$label_1#1:
    goto inline$BDLGetDebugLevel$401$Return#1;

  inline$BDLGetDebugLevel$401$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$401$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon41_Then#1, inline$BDLSystemPowerIoCompletion$14$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon11#1;

  inline$BDLSystemPowerIoCompletion$14$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_56#1;

  inline$BDLSystemPowerIoCompletion$14$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_56_true#1, inline$BDLSystemPowerIoCompletion$14$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_57#1;

  inline$BDLSystemPowerIoCompletion$14$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_60#1;

  inline$BDLSystemPowerIoCompletion$14$label_60#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_61#1;

  inline$BDLSystemPowerIoCompletion$14$label_61#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_62#1;

  inline$BDLSystemPowerIoCompletion$14$label_62#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_63#1;

  inline$BDLSystemPowerIoCompletion$14$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$14$label_57#1;

  inline$BDLSystemPowerIoCompletion$14$label_57#1:
    goto inline$BDLGetDebugLevel$402$Entry#1;

  inline$BDLGetDebugLevel$402$Entry#1:
    goto inline$BDLGetDebugLevel$402$start#1;

  inline$BDLGetDebugLevel$402$start#1:
    goto inline$BDLGetDebugLevel$402$label_3#1;

  inline$BDLGetDebugLevel$402$label_3#1:
    havoc inline$BDLGetDebugLevel$402$myNondetVar_0;
    inline$BDLGetDebugLevel$402$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$402$myNondetVar_0;
    goto inline$BDLGetDebugLevel$402$label_1#1;

  inline$BDLGetDebugLevel$402$label_1#1:
    goto inline$BDLGetDebugLevel$402$Return#1;

  inline$BDLGetDebugLevel$402$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$402$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon42_Then#1, inline$BDLSystemPowerIoCompletion$14$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon13#1;

  inline$BDLSystemPowerIoCompletion$14$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_66#1;

  inline$BDLSystemPowerIoCompletion$14$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_66_true#1, inline$BDLSystemPowerIoCompletion$14$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_67#1;

  inline$BDLSystemPowerIoCompletion$14$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_70#1;

  inline$BDLSystemPowerIoCompletion$14$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_67#1;

  inline$BDLSystemPowerIoCompletion$14$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$14$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$14$anon43_Then#1, inline$BDLSystemPowerIoCompletion$14$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon15#1;

  inline$BDLSystemPowerIoCompletion$14$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_71#1;

  inline$BDLSystemPowerIoCompletion$14$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$14$anon44_Then#1, inline$BDLSystemPowerIoCompletion$14$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon17#1;

  inline$BDLSystemPowerIoCompletion$14$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_74#1;

  inline$BDLSystemPowerIoCompletion$14$label_74#1:
    goto inline$storm_IoCompleteRequest$30$Entry#1;

  inline$storm_IoCompleteRequest$30$Entry#1:
    inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$14$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$30$start#1;

  inline$storm_IoCompleteRequest$30$start#1:
    inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$30$label_3#1;

  inline$storm_IoCompleteRequest$30$label_3#1:
    call inline$storm_IoCompleteRequest$30$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$30$label_6#1;

  inline$storm_IoCompleteRequest$30$label_6#1:
    goto inline$storm_IoCompleteRequest$30$label_6_true#1, inline$storm_IoCompleteRequest$30$label_6_false#1;

  inline$storm_IoCompleteRequest$30$label_6_false#1:
    assume inline$storm_IoCompleteRequest$30$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$30$label_7#1;

  inline$storm_IoCompleteRequest$30$label_6_true#1:
    assume inline$storm_IoCompleteRequest$30$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$30$label_8#1;

  inline$storm_IoCompleteRequest$30$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$30$anon3_Then#1, inline$storm_IoCompleteRequest$30$anon3_Else#1;

  inline$storm_IoCompleteRequest$30$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$30$anon1#1;

  inline$storm_IoCompleteRequest$30$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$30$label_9#1;

  inline$storm_IoCompleteRequest$30$label_9#1:
    goto inline$storm_IoCompleteRequest$30$label_9_true#1, inline$storm_IoCompleteRequest$30$label_9_false#1;

  inline$storm_IoCompleteRequest$30$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$30$label_10#1;

  inline$storm_IoCompleteRequest$30$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$30$label_1#1;

  inline$storm_IoCompleteRequest$30$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$30$label_7#1;

  inline$storm_IoCompleteRequest$30$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$30$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$30$label_1#1;

  inline$storm_IoCompleteRequest$30$label_1#1:
    goto inline$storm_IoCompleteRequest$30$Return#1;

  inline$storm_IoCompleteRequest$30$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$30$Return#1;

  inline$storm_IoCompleteRequest$30$Return#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon45_Then#1, inline$BDLSystemPowerIoCompletion$14$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon19#1;

  inline$BDLSystemPowerIoCompletion$14$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_77#1;

  inline$BDLSystemPowerIoCompletion$14$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$14$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$14$anon46_Then#1, inline$BDLSystemPowerIoCompletion$14$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon21#1;

  inline$BDLSystemPowerIoCompletion$14$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_80#1;

  inline$BDLSystemPowerIoCompletion$14$label_80#1:
    goto inline$BDLGetDebugLevel$403$Entry#1;

  inline$BDLGetDebugLevel$403$Entry#1:
    goto inline$BDLGetDebugLevel$403$start#1;

  inline$BDLGetDebugLevel$403$start#1:
    goto inline$BDLGetDebugLevel$403$label_3#1;

  inline$BDLGetDebugLevel$403$label_3#1:
    havoc inline$BDLGetDebugLevel$403$myNondetVar_0;
    inline$BDLGetDebugLevel$403$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$403$myNondetVar_0;
    goto inline$BDLGetDebugLevel$403$label_1#1;

  inline$BDLGetDebugLevel$403$label_1#1:
    goto inline$BDLGetDebugLevel$403$Return#1;

  inline$BDLGetDebugLevel$403$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$403$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon47_Then#1, inline$BDLSystemPowerIoCompletion$14$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon23#1;

  inline$BDLSystemPowerIoCompletion$14$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_83#1;

  inline$BDLSystemPowerIoCompletion$14$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_83_true#1, inline$BDLSystemPowerIoCompletion$14$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_84#1;

  inline$BDLSystemPowerIoCompletion$14$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_87#1;

  inline$BDLSystemPowerIoCompletion$14$label_87#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_88#1;

  inline$BDLSystemPowerIoCompletion$14$label_88#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_89#1;

  inline$BDLSystemPowerIoCompletion$14$label_89#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_90#1;

  inline$BDLSystemPowerIoCompletion$14$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$14$label_84#1;

  inline$BDLSystemPowerIoCompletion$14$label_84#1:
    goto inline$BDLGetDebugLevel$404$Entry#1;

  inline$BDLGetDebugLevel$404$Entry#1:
    goto inline$BDLGetDebugLevel$404$start#1;

  inline$BDLGetDebugLevel$404$start#1:
    goto inline$BDLGetDebugLevel$404$label_3#1;

  inline$BDLGetDebugLevel$404$label_3#1:
    havoc inline$BDLGetDebugLevel$404$myNondetVar_0;
    inline$BDLGetDebugLevel$404$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$404$myNondetVar_0;
    goto inline$BDLGetDebugLevel$404$label_1#1;

  inline$BDLGetDebugLevel$404$label_1#1:
    goto inline$BDLGetDebugLevel$404$Return#1;

  inline$BDLGetDebugLevel$404$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$404$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon48_Then#1, inline$BDLSystemPowerIoCompletion$14$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon25#1;

  inline$BDLSystemPowerIoCompletion$14$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_93#1;

  inline$BDLSystemPowerIoCompletion$14$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_93_true#1, inline$BDLSystemPowerIoCompletion$14$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_94#1;

  inline$BDLSystemPowerIoCompletion$14$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_97#1;

  inline$BDLSystemPowerIoCompletion$14$label_97#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_98#1;

  inline$BDLSystemPowerIoCompletion$14$label_98#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_99#1;

  inline$BDLSystemPowerIoCompletion$14$label_99#1:
    call inline$BDLSystemPowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$14$label_100#1;

  inline$BDLSystemPowerIoCompletion$14$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$14$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$14$label_94#1;

  inline$BDLSystemPowerIoCompletion$14$label_94#1:
    goto inline$BDLGetDebugLevel$405$Entry#1;

  inline$BDLGetDebugLevel$405$Entry#1:
    goto inline$BDLGetDebugLevel$405$start#1;

  inline$BDLGetDebugLevel$405$start#1:
    goto inline$BDLGetDebugLevel$405$label_3#1;

  inline$BDLGetDebugLevel$405$label_3#1:
    havoc inline$BDLGetDebugLevel$405$myNondetVar_0;
    inline$BDLGetDebugLevel$405$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$405$myNondetVar_0;
    goto inline$BDLGetDebugLevel$405$label_1#1;

  inline$BDLGetDebugLevel$405$label_1#1:
    goto inline$BDLGetDebugLevel$405$Return#1;

  inline$BDLGetDebugLevel$405$Return#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$405$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$14$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$14$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$14$anon49_Then#1, inline$BDLSystemPowerIoCompletion$14$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$14$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$anon27#1;

  inline$BDLSystemPowerIoCompletion$14$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_103#1;

  inline$BDLSystemPowerIoCompletion$14$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_103_true#1, inline$BDLSystemPowerIoCompletion$14$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$14$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_104#1;

  inline$BDLSystemPowerIoCompletion$14$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$14$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$14$label_105#1;

  inline$BDLSystemPowerIoCompletion$14$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$14$label_104#1;

  inline$BDLSystemPowerIoCompletion$14$label_104#1:
    inline$BDLSystemPowerIoCompletion$14$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$14$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$14$label_1#1;

  inline$BDLSystemPowerIoCompletion$14$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$14$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$14$Return#1;

  inline$BDLSystemPowerIoCompletion$14$Return#1:
    inline$CallCompletionRoutine$14$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$14$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$14$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$14$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$14$anon14_Then#1, inline$CallCompletionRoutine$14$anon14_Else#1;

  inline$CallCompletionRoutine$14$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$14$anon9#1;

  inline$CallCompletionRoutine$14$anon9#1:
    goto inline$CallCompletionRoutine$14$label_20_icall_return#1;

  inline$CallCompletionRoutine$14$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$14$Return#1;

  inline$CallCompletionRoutine$14$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$14$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$14$Entry#1;

  inline$BDLDevicePowerIoCompletion$14$Entry#1:
    inline$BDLDevicePowerIoCompletion$14$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$14$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$14$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$14$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$14$start#1;

  inline$BDLDevicePowerIoCompletion$14$start#1:
    call inline$BDLDevicePowerIoCompletion$14$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$14$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$14$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$14$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$14$label_3#1;

  inline$BDLDevicePowerIoCompletion$14$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_4#1;

  inline$BDLDevicePowerIoCompletion$14$label_4#1:
    inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_5#1;

  inline$BDLDevicePowerIoCompletion$14$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_6#1;

  inline$BDLDevicePowerIoCompletion$14$label_6#1:
    inline$BDLDevicePowerIoCompletion$14$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$14$label_7#1;

  inline$BDLDevicePowerIoCompletion$14$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_8#1;

  inline$BDLDevicePowerIoCompletion$14$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$14$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$14$label_9#1;

  inline$BDLDevicePowerIoCompletion$14$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_10#1;

  inline$BDLDevicePowerIoCompletion$14$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$77$Entry#1;

  inline$IoGetCurrentIrpStackLocation$77$Entry#1:
    inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$77$start#1;

  inline$IoGetCurrentIrpStackLocation$77$start#1:
    inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$77$label_3#1;

  inline$IoGetCurrentIrpStackLocation$77$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$77$label_3_true#1, inline$IoGetCurrentIrpStackLocation$77$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$77$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$77$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$77$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$77$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$77$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$77$label_4#1;

  inline$IoGetCurrentIrpStackLocation$77$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$77$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$77$label_6#1;

  inline$IoGetCurrentIrpStackLocation$77$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$77$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$77$label_7#1;

  inline$IoGetCurrentIrpStackLocation$77$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$77$label_5#1;

  inline$IoGetCurrentIrpStackLocation$77$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$77$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$77$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$77$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$77$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$77$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$77$label_5#1;

  inline$IoGetCurrentIrpStackLocation$77$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$77$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$77$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$77$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$77$label_1#1;

  inline$IoGetCurrentIrpStackLocation$77$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$77$Return#1;

  inline$IoGetCurrentIrpStackLocation$77$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$77$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon30_Then#1, inline$BDLDevicePowerIoCompletion$14$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon1#1;

  inline$BDLDevicePowerIoCompletion$14$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_13#1;

  inline$BDLDevicePowerIoCompletion$14$label_13#1:
    inline$BDLDevicePowerIoCompletion$14$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$14$label_14#1;

  inline$BDLDevicePowerIoCompletion$14$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_15#1;

  inline$BDLDevicePowerIoCompletion$14$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$14$label_16#1;

  inline$BDLDevicePowerIoCompletion$14$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_17#1;

  inline$BDLDevicePowerIoCompletion$14$label_17#1:
    goto inline$BDLGetDebugLevel$388$Entry#1;

  inline$BDLGetDebugLevel$388$Entry#1:
    goto inline$BDLGetDebugLevel$388$start#1;

  inline$BDLGetDebugLevel$388$start#1:
    goto inline$BDLGetDebugLevel$388$label_3#1;

  inline$BDLGetDebugLevel$388$label_3#1:
    havoc inline$BDLGetDebugLevel$388$myNondetVar_0;
    inline$BDLGetDebugLevel$388$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$388$myNondetVar_0;
    goto inline$BDLGetDebugLevel$388$label_1#1;

  inline$BDLGetDebugLevel$388$label_1#1:
    goto inline$BDLGetDebugLevel$388$Return#1;

  inline$BDLGetDebugLevel$388$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$388$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon31_Then#1, inline$BDLDevicePowerIoCompletion$14$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon3#1;

  inline$BDLDevicePowerIoCompletion$14$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_20#1;

  inline$BDLDevicePowerIoCompletion$14$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_20_true#1, inline$BDLDevicePowerIoCompletion$14$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_21#1;

  inline$BDLDevicePowerIoCompletion$14$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_24#1;

  inline$BDLDevicePowerIoCompletion$14$label_24#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_25#1;

  inline$BDLDevicePowerIoCompletion$14$label_25#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_26#1;

  inline$BDLDevicePowerIoCompletion$14$label_26#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_27#1;

  inline$BDLDevicePowerIoCompletion$14$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$14$label_21#1;

  inline$BDLDevicePowerIoCompletion$14$label_21#1:
    goto inline$BDLGetDebugLevel$389$Entry#1;

  inline$BDLGetDebugLevel$389$Entry#1:
    goto inline$BDLGetDebugLevel$389$start#1;

  inline$BDLGetDebugLevel$389$start#1:
    goto inline$BDLGetDebugLevel$389$label_3#1;

  inline$BDLGetDebugLevel$389$label_3#1:
    havoc inline$BDLGetDebugLevel$389$myNondetVar_0;
    inline$BDLGetDebugLevel$389$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$389$myNondetVar_0;
    goto inline$BDLGetDebugLevel$389$label_1#1;

  inline$BDLGetDebugLevel$389$label_1#1:
    goto inline$BDLGetDebugLevel$389$Return#1;

  inline$BDLGetDebugLevel$389$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$389$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon32_Then#1, inline$BDLDevicePowerIoCompletion$14$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon5#1;

  inline$BDLDevicePowerIoCompletion$14$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_30#1;

  inline$BDLDevicePowerIoCompletion$14$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_30_true#1, inline$BDLDevicePowerIoCompletion$14$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_31#1;

  inline$BDLDevicePowerIoCompletion$14$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_34#1;

  inline$BDLDevicePowerIoCompletion$14$label_34#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_35#1;

  inline$BDLDevicePowerIoCompletion$14$label_35#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_36#1;

  inline$BDLDevicePowerIoCompletion$14$label_36#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_37#1;

  inline$BDLDevicePowerIoCompletion$14$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$14$label_31#1;

  inline$BDLDevicePowerIoCompletion$14$label_31#1:
    goto inline$BDLGetDebugLevel$390$Entry#1;

  inline$BDLGetDebugLevel$390$Entry#1:
    goto inline$BDLGetDebugLevel$390$start#1;

  inline$BDLGetDebugLevel$390$start#1:
    goto inline$BDLGetDebugLevel$390$label_3#1;

  inline$BDLGetDebugLevel$390$label_3#1:
    havoc inline$BDLGetDebugLevel$390$myNondetVar_0;
    inline$BDLGetDebugLevel$390$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$390$myNondetVar_0;
    goto inline$BDLGetDebugLevel$390$label_1#1;

  inline$BDLGetDebugLevel$390$label_1#1:
    goto inline$BDLGetDebugLevel$390$Return#1;

  inline$BDLGetDebugLevel$390$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$390$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon33_Then#1, inline$BDLDevicePowerIoCompletion$14$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon7#1;

  inline$BDLDevicePowerIoCompletion$14$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_40#1;

  inline$BDLDevicePowerIoCompletion$14$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_40_true#1, inline$BDLDevicePowerIoCompletion$14$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_41#1;

  inline$BDLDevicePowerIoCompletion$14$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_42#1;

  inline$BDLDevicePowerIoCompletion$14$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_41#1;

  inline$BDLDevicePowerIoCompletion$14$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_41_true#1, inline$BDLDevicePowerIoCompletion$14$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$14$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$14$label_43#1;

  inline$BDLDevicePowerIoCompletion$14$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$14$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$14$label_44#1;

  inline$BDLDevicePowerIoCompletion$14$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_44_true#1, inline$BDLDevicePowerIoCompletion$14$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$14$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$14$label_45#1;

  inline$BDLDevicePowerIoCompletion$14$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_45_true#1, inline$BDLDevicePowerIoCompletion$14$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$14$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$14$label_43#1;

  inline$BDLDevicePowerIoCompletion$14$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$14$label_86#1;

  inline$BDLDevicePowerIoCompletion$14$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$14$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$14$label_46#1;

  inline$BDLDevicePowerIoCompletion$14$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$14$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$14$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$14$label_46#1;

  inline$BDLDevicePowerIoCompletion$14$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$14$label_49#1;

  inline$BDLDevicePowerIoCompletion$14$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_50#1;

  inline$BDLDevicePowerIoCompletion$14$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_51#1;

  inline$BDLDevicePowerIoCompletion$14$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_54#1;

  inline$BDLDevicePowerIoCompletion$14$label_54#1:
    inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$14$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$14$label_55#1;

  inline$BDLDevicePowerIoCompletion$14$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_55_true#1, inline$BDLDevicePowerIoCompletion$14$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_56#1;

  inline$BDLDevicePowerIoCompletion$14$label_56#1:
    call inline$BDLDevicePowerIoCompletion$14$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$14$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$14$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$14$anon34_Then#1, inline$BDLDevicePowerIoCompletion$14$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon9#1;

  inline$BDLDevicePowerIoCompletion$14$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_83#1;

  inline$BDLDevicePowerIoCompletion$14$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_59#1;

  inline$BDLDevicePowerIoCompletion$14$label_59#1:
    goto inline$BDLGetDebugLevel$391$Entry#1;

  inline$BDLGetDebugLevel$391$Entry#1:
    goto inline$BDLGetDebugLevel$391$start#1;

  inline$BDLGetDebugLevel$391$start#1:
    goto inline$BDLGetDebugLevel$391$label_3#1;

  inline$BDLGetDebugLevel$391$label_3#1:
    havoc inline$BDLGetDebugLevel$391$myNondetVar_0;
    inline$BDLGetDebugLevel$391$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$391$myNondetVar_0;
    goto inline$BDLGetDebugLevel$391$label_1#1;

  inline$BDLGetDebugLevel$391$label_1#1:
    goto inline$BDLGetDebugLevel$391$Return#1;

  inline$BDLGetDebugLevel$391$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$391$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon35_Then#1, inline$BDLDevicePowerIoCompletion$14$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon11#1;

  inline$BDLDevicePowerIoCompletion$14$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_62#1;

  inline$BDLDevicePowerIoCompletion$14$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_62_true#1, inline$BDLDevicePowerIoCompletion$14$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_63#1;

  inline$BDLDevicePowerIoCompletion$14$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_66#1;

  inline$BDLDevicePowerIoCompletion$14$label_66#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_67#1;

  inline$BDLDevicePowerIoCompletion$14$label_67#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_68#1;

  inline$BDLDevicePowerIoCompletion$14$label_68#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_69#1;

  inline$BDLDevicePowerIoCompletion$14$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$14$label_63#1;

  inline$BDLDevicePowerIoCompletion$14$label_63#1:
    goto inline$BDLGetDebugLevel$392$Entry#1;

  inline$BDLGetDebugLevel$392$Entry#1:
    goto inline$BDLGetDebugLevel$392$start#1;

  inline$BDLGetDebugLevel$392$start#1:
    goto inline$BDLGetDebugLevel$392$label_3#1;

  inline$BDLGetDebugLevel$392$label_3#1:
    havoc inline$BDLGetDebugLevel$392$myNondetVar_0;
    inline$BDLGetDebugLevel$392$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$392$myNondetVar_0;
    goto inline$BDLGetDebugLevel$392$label_1#1;

  inline$BDLGetDebugLevel$392$label_1#1:
    goto inline$BDLGetDebugLevel$392$Return#1;

  inline$BDLGetDebugLevel$392$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$392$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon36_Then#1, inline$BDLDevicePowerIoCompletion$14$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon13#1;

  inline$BDLDevicePowerIoCompletion$14$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_72#1;

  inline$BDLDevicePowerIoCompletion$14$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_72_true#1, inline$BDLDevicePowerIoCompletion$14$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_73#1;

  inline$BDLDevicePowerIoCompletion$14$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_76#1;

  inline$BDLDevicePowerIoCompletion$14$label_76#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_77#1;

  inline$BDLDevicePowerIoCompletion$14$label_77#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_78#1;

  inline$BDLDevicePowerIoCompletion$14$label_78#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_79#1;

  inline$BDLDevicePowerIoCompletion$14$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$14$label_73#1;

  inline$BDLDevicePowerIoCompletion$14$label_73#1:
    goto inline$BDLGetDebugLevel$393$Entry#1;

  inline$BDLGetDebugLevel$393$Entry#1:
    goto inline$BDLGetDebugLevel$393$start#1;

  inline$BDLGetDebugLevel$393$start#1:
    goto inline$BDLGetDebugLevel$393$label_3#1;

  inline$BDLGetDebugLevel$393$label_3#1:
    havoc inline$BDLGetDebugLevel$393$myNondetVar_0;
    inline$BDLGetDebugLevel$393$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$393$myNondetVar_0;
    goto inline$BDLGetDebugLevel$393$label_1#1;

  inline$BDLGetDebugLevel$393$label_1#1:
    goto inline$BDLGetDebugLevel$393$Return#1;

  inline$BDLGetDebugLevel$393$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$393$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon37_Then#1, inline$BDLDevicePowerIoCompletion$14$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon15#1;

  inline$BDLDevicePowerIoCompletion$14$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_82#1;

  inline$BDLDevicePowerIoCompletion$14$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_82_true#1, inline$BDLDevicePowerIoCompletion$14$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_83#1;

  inline$BDLDevicePowerIoCompletion$14$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_84#1;

  inline$BDLDevicePowerIoCompletion$14$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_83#1;

  inline$BDLDevicePowerIoCompletion$14$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_85#1;

  inline$BDLDevicePowerIoCompletion$14$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_86#1;

  inline$BDLDevicePowerIoCompletion$14$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$14$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$14$anon38_Then#1, inline$BDLDevicePowerIoCompletion$14$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon17#1;

  inline$BDLDevicePowerIoCompletion$14$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_89#1;

  inline$BDLDevicePowerIoCompletion$14$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$14$anon39_Then#1, inline$BDLDevicePowerIoCompletion$14$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon19#1;

  inline$BDLDevicePowerIoCompletion$14$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_92#1;

  inline$BDLDevicePowerIoCompletion$14$label_92#1:
    goto inline$storm_IoCompleteRequest$29$Entry#1;

  inline$storm_IoCompleteRequest$29$Entry#1:
    inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$14$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$29$start#1;

  inline$storm_IoCompleteRequest$29$start#1:
    inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$29$label_3#1;

  inline$storm_IoCompleteRequest$29$label_3#1:
    call inline$storm_IoCompleteRequest$29$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$29$label_6#1;

  inline$storm_IoCompleteRequest$29$label_6#1:
    goto inline$storm_IoCompleteRequest$29$label_6_true#1, inline$storm_IoCompleteRequest$29$label_6_false#1;

  inline$storm_IoCompleteRequest$29$label_6_false#1:
    assume inline$storm_IoCompleteRequest$29$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$29$label_7#1;

  inline$storm_IoCompleteRequest$29$label_6_true#1:
    assume inline$storm_IoCompleteRequest$29$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$29$label_8#1;

  inline$storm_IoCompleteRequest$29$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$29$anon3_Then#1, inline$storm_IoCompleteRequest$29$anon3_Else#1;

  inline$storm_IoCompleteRequest$29$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$29$anon1#1;

  inline$storm_IoCompleteRequest$29$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$29$label_9#1;

  inline$storm_IoCompleteRequest$29$label_9#1:
    goto inline$storm_IoCompleteRequest$29$label_9_true#1, inline$storm_IoCompleteRequest$29$label_9_false#1;

  inline$storm_IoCompleteRequest$29$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$29$label_10#1;

  inline$storm_IoCompleteRequest$29$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$29$label_1#1;

  inline$storm_IoCompleteRequest$29$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$29$label_7#1;

  inline$storm_IoCompleteRequest$29$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$29$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$29$label_1#1;

  inline$storm_IoCompleteRequest$29$label_1#1:
    goto inline$storm_IoCompleteRequest$29$Return#1;

  inline$storm_IoCompleteRequest$29$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$29$Return#1;

  inline$storm_IoCompleteRequest$29$Return#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon40_Then#1, inline$BDLDevicePowerIoCompletion$14$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon21#1;

  inline$BDLDevicePowerIoCompletion$14$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_95#1;

  inline$BDLDevicePowerIoCompletion$14$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$14$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$14$anon41_Then#1, inline$BDLDevicePowerIoCompletion$14$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon23#1;

  inline$BDLDevicePowerIoCompletion$14$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_98#1;

  inline$BDLDevicePowerIoCompletion$14$label_98#1:
    goto inline$BDLGetDebugLevel$394$Entry#1;

  inline$BDLGetDebugLevel$394$Entry#1:
    goto inline$BDLGetDebugLevel$394$start#1;

  inline$BDLGetDebugLevel$394$start#1:
    goto inline$BDLGetDebugLevel$394$label_3#1;

  inline$BDLGetDebugLevel$394$label_3#1:
    havoc inline$BDLGetDebugLevel$394$myNondetVar_0;
    inline$BDLGetDebugLevel$394$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$394$myNondetVar_0;
    goto inline$BDLGetDebugLevel$394$label_1#1;

  inline$BDLGetDebugLevel$394$label_1#1:
    goto inline$BDLGetDebugLevel$394$Return#1;

  inline$BDLGetDebugLevel$394$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$394$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon42_Then#1, inline$BDLDevicePowerIoCompletion$14$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon25#1;

  inline$BDLDevicePowerIoCompletion$14$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_101#1;

  inline$BDLDevicePowerIoCompletion$14$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_101_true#1, inline$BDLDevicePowerIoCompletion$14$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_102#1;

  inline$BDLDevicePowerIoCompletion$14$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_105#1;

  inline$BDLDevicePowerIoCompletion$14$label_105#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_106#1;

  inline$BDLDevicePowerIoCompletion$14$label_106#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_107#1;

  inline$BDLDevicePowerIoCompletion$14$label_107#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_108#1;

  inline$BDLDevicePowerIoCompletion$14$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$14$label_102#1;

  inline$BDLDevicePowerIoCompletion$14$label_102#1:
    goto inline$BDLGetDebugLevel$395$Entry#1;

  inline$BDLGetDebugLevel$395$Entry#1:
    goto inline$BDLGetDebugLevel$395$start#1;

  inline$BDLGetDebugLevel$395$start#1:
    goto inline$BDLGetDebugLevel$395$label_3#1;

  inline$BDLGetDebugLevel$395$label_3#1:
    havoc inline$BDLGetDebugLevel$395$myNondetVar_0;
    inline$BDLGetDebugLevel$395$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$395$myNondetVar_0;
    goto inline$BDLGetDebugLevel$395$label_1#1;

  inline$BDLGetDebugLevel$395$label_1#1:
    goto inline$BDLGetDebugLevel$395$Return#1;

  inline$BDLGetDebugLevel$395$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$395$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon43_Then#1, inline$BDLDevicePowerIoCompletion$14$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon27#1;

  inline$BDLDevicePowerIoCompletion$14$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_111#1;

  inline$BDLDevicePowerIoCompletion$14$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_111_true#1, inline$BDLDevicePowerIoCompletion$14$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_112#1;

  inline$BDLDevicePowerIoCompletion$14$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_115#1;

  inline$BDLDevicePowerIoCompletion$14$label_115#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_116#1;

  inline$BDLDevicePowerIoCompletion$14$label_116#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_117#1;

  inline$BDLDevicePowerIoCompletion$14$label_117#1:
    call inline$BDLDevicePowerIoCompletion$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$14$label_118#1;

  inline$BDLDevicePowerIoCompletion$14$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$14$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$14$label_112#1;

  inline$BDLDevicePowerIoCompletion$14$label_112#1:
    goto inline$BDLGetDebugLevel$396$Entry#1;

  inline$BDLGetDebugLevel$396$Entry#1:
    goto inline$BDLGetDebugLevel$396$start#1;

  inline$BDLGetDebugLevel$396$start#1:
    goto inline$BDLGetDebugLevel$396$label_3#1;

  inline$BDLGetDebugLevel$396$label_3#1:
    havoc inline$BDLGetDebugLevel$396$myNondetVar_0;
    inline$BDLGetDebugLevel$396$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$396$myNondetVar_0;
    goto inline$BDLGetDebugLevel$396$label_1#1;

  inline$BDLGetDebugLevel$396$label_1#1:
    goto inline$BDLGetDebugLevel$396$Return#1;

  inline$BDLGetDebugLevel$396$Return#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$396$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$14$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$14$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$14$anon44_Then#1, inline$BDLDevicePowerIoCompletion$14$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$14$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$anon29#1;

  inline$BDLDevicePowerIoCompletion$14$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_121#1;

  inline$BDLDevicePowerIoCompletion$14$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_121_true#1, inline$BDLDevicePowerIoCompletion$14$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$14$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_122#1;

  inline$BDLDevicePowerIoCompletion$14$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$14$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$14$label_123#1;

  inline$BDLDevicePowerIoCompletion$14$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$14$label_122#1;

  inline$BDLDevicePowerIoCompletion$14$label_122#1:
    inline$BDLDevicePowerIoCompletion$14$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$14$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$14$label_1#1;

  inline$BDLDevicePowerIoCompletion$14$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$14$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$14$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$14$Return#1;

  inline$BDLDevicePowerIoCompletion$14$Return#1:
    inline$CallCompletionRoutine$14$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$14$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$14$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$14$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$14$anon13_Then#1, inline$CallCompletionRoutine$14$anon13_Else#1;

  inline$CallCompletionRoutine$14$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$14$anon7#1;

  inline$CallCompletionRoutine$14$anon7#1:
    goto inline$CallCompletionRoutine$14$label_20_icall_return#1;

  inline$CallCompletionRoutine$14$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$14$Return#1;

  inline$CallCompletionRoutine$14$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$14$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$14$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$14$Entry#1;

  inline$BDLCallDriverCompletionRoutine$14$Entry#1:
    inline$BDLCallDriverCompletionRoutine$14$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$14$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$14$start#1;

  inline$BDLCallDriverCompletionRoutine$14$start#1:
    inline$BDLCallDriverCompletionRoutine$14$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$14$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$14$label_3#1;

  inline$BDLCallDriverCompletionRoutine$14$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$14$label_3_true#1, inline$BDLCallDriverCompletionRoutine$14$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$14$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$14$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$14$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$14$label_4#1;

  inline$BDLCallDriverCompletionRoutine$14$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$14$label_6#1;

  inline$BDLCallDriverCompletionRoutine$14$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$14$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$14$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$14$label_5#1;

  inline$BDLCallDriverCompletionRoutine$14$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$14$label_6#1;

  inline$BDLCallDriverCompletionRoutine$14$label_6#1:
    goto inline$storm_KeSetEvent$16$Entry#1;

  inline$storm_KeSetEvent$16$Entry#1:
    inline$storm_KeSetEvent$16$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$14$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$16$start#1;

  inline$storm_KeSetEvent$16$start#1:
    inline$storm_KeSetEvent$16$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$16$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$16$label_3#1;

  inline$storm_KeSetEvent$16$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$16$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$16$label_1#1;

  inline$storm_KeSetEvent$16$label_1#1:
    goto inline$storm_KeSetEvent$16$Return#1;

  inline$storm_KeSetEvent$16$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$14$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$14$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$14$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$14$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$14$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$14$anon1#1;

  inline$BDLCallDriverCompletionRoutine$14$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$14$label_9#1;

  inline$BDLCallDriverCompletionRoutine$14$label_9#1:
    inline$BDLCallDriverCompletionRoutine$14$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$14$label_1#1;

  inline$BDLCallDriverCompletionRoutine$14$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$14$Return#1;

  inline$BDLCallDriverCompletionRoutine$14$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$14$Return#1;

  inline$BDLCallDriverCompletionRoutine$14$Return#1:
    inline$CallCompletionRoutine$14$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$14$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$14$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$14$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$14$anon12_Then#1, inline$CallCompletionRoutine$14$anon12_Else#1;

  inline$CallCompletionRoutine$14$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$14$anon5#1;

  inline$CallCompletionRoutine$14$anon5#1:
    goto inline$CallCompletionRoutine$14$label_20_icall_return#1;

  inline$CallCompletionRoutine$14$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$14$label_23#1;

  inline$CallCompletionRoutine$14$label_23#1:
    inline$CallCompletionRoutine$14$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$14$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$14$label_24#1;

  inline$CallCompletionRoutine$14$label_24#1:
    goto inline$CallCompletionRoutine$14$label_24_true#1, inline$CallCompletionRoutine$14$label_24_false#1;

  inline$CallCompletionRoutine$14$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$14$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$14$label_1#1;

  inline$CallCompletionRoutine$14$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$14$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$14$label_25#1;

  inline$CallCompletionRoutine$14$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$14$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$14$label_1#1;

  inline$CallCompletionRoutine$14$label_1#1:
    goto inline$CallCompletionRoutine$14$Return#1;

  inline$CallCompletionRoutine$14$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$14$Return#1;

  inline$CallCompletionRoutine$14$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$14$Return#1;

  inline$CallCompletionRoutine$14$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$14$Return#1;

  inline$CallCompletionRoutine$14$Return#1:
    goto inline$storm_IoCallDriver$7$label_33$1#1;

  inline$storm_IoCallDriver$7$label_33$1#1:
    goto inline$storm_IoCallDriver$7$anon14_Then#1, inline$storm_IoCallDriver$7$anon14_Else#1;

  inline$storm_IoCallDriver$7$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$7$anon8#1;

  inline$storm_IoCallDriver$7$anon8#1:
    goto inline$storm_IoCallDriver$7$label_36#1;

  inline$storm_IoCallDriver$7$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$7$Return#1;

  inline$storm_IoCallDriver$7$label_27_case_1#1:
    assume inline$storm_IoCallDriver$7$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$7$label_29#1;

  inline$storm_IoCallDriver$7$label_29#1:
    inline$storm_IoCallDriver$7$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$7$label_37#1;

  inline$storm_IoCallDriver$7$label_37#1:
    goto inline$storm_IoCallDriver$7$label_38#1;

  inline$storm_IoCallDriver$7$label_38#1:
    goto inline$storm_IoCallDriver$7$label_39#1;

  inline$storm_IoCallDriver$7$label_39#1:
    goto inline$CallCompletionRoutine$15$Entry#1;

  inline$CallCompletionRoutine$15$Entry#1:
    inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$15$start#1;

  inline$CallCompletionRoutine$15$start#1:
    inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$15$label_3#1;

  inline$CallCompletionRoutine$15$label_3#1:
    goto inline$CallCompletionRoutine$15$label_4#1;

  inline$CallCompletionRoutine$15$label_4#1:
    goto inline$CallCompletionRoutine$15$label_5#1;

  inline$CallCompletionRoutine$15$label_5#1:
    goto inline$CallCompletionRoutine$15$label_6#1;

  inline$CallCompletionRoutine$15$label_6#1:
    goto inline$CallCompletionRoutine$15$label_7#1;

  inline$CallCompletionRoutine$15$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$79$Entry#1;

  inline$IoGetCurrentIrpStackLocation$79$Entry#1:
    inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$79$start#1;

  inline$IoGetCurrentIrpStackLocation$79$start#1:
    inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$79$label_3#1;

  inline$IoGetCurrentIrpStackLocation$79$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$79$label_3_true#1, inline$IoGetCurrentIrpStackLocation$79$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$79$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$79$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$79$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$79$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$79$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$79$label_4#1;

  inline$IoGetCurrentIrpStackLocation$79$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$79$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$79$label_6#1;

  inline$IoGetCurrentIrpStackLocation$79$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$79$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$79$label_7#1;

  inline$IoGetCurrentIrpStackLocation$79$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$79$label_5#1;

  inline$IoGetCurrentIrpStackLocation$79$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$79$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$79$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$79$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$79$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$79$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$79$label_5#1;

  inline$IoGetCurrentIrpStackLocation$79$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$79$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$79$label_1#1;

  inline$IoGetCurrentIrpStackLocation$79$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$79$Return#1;

  inline$IoGetCurrentIrpStackLocation$79$Return#1:
    goto inline$CallCompletionRoutine$15$label_7$1#1;

  inline$CallCompletionRoutine$15$label_7$1#1:
    goto inline$CallCompletionRoutine$15$anon10_Then#1, inline$CallCompletionRoutine$15$anon10_Else#1;

  inline$CallCompletionRoutine$15$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$15$anon1#1;

  inline$CallCompletionRoutine$15$anon1#1:
    goto inline$CallCompletionRoutine$15$label_10#1;

  inline$CallCompletionRoutine$15$label_10#1:
    goto inline$CallCompletionRoutine$15$label_11#1;

  inline$CallCompletionRoutine$15$label_11#1:
    havoc inline$CallCompletionRoutine$15$myNondetVar_0;
    inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$15$myNondetVar_0;
    goto inline$CallCompletionRoutine$15$label_12#1;

  inline$CallCompletionRoutine$15$label_12#1:
    havoc inline$CallCompletionRoutine$15$myNondetVar_0;
    inline$CallCompletionRoutine$15$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$15$myNondetVar_0;
    goto inline$CallCompletionRoutine$15$label_13#1;

  inline$CallCompletionRoutine$15$label_13#1:
    havoc inline$CallCompletionRoutine$15$myNondetVar_0;
    goto inline$CallCompletionRoutine$15$label_14#1;

  inline$CallCompletionRoutine$15$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$80$Entry#1;

  inline$IoGetCurrentIrpStackLocation$80$Entry#1:
    inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$80$start#1;

  inline$IoGetCurrentIrpStackLocation$80$start#1:
    inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$80$label_3#1;

  inline$IoGetCurrentIrpStackLocation$80$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$80$label_3_true#1, inline$IoGetCurrentIrpStackLocation$80$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$80$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$80$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$80$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$80$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$80$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$80$label_4#1;

  inline$IoGetCurrentIrpStackLocation$80$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$80$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$80$label_6#1;

  inline$IoGetCurrentIrpStackLocation$80$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$80$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$80$label_7#1;

  inline$IoGetCurrentIrpStackLocation$80$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$80$label_5#1;

  inline$IoGetCurrentIrpStackLocation$80$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$80$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$80$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$80$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$80$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$80$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$80$label_5#1;

  inline$IoGetCurrentIrpStackLocation$80$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$80$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$80$label_1#1;

  inline$IoGetCurrentIrpStackLocation$80$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$80$Return#1;

  inline$IoGetCurrentIrpStackLocation$80$Return#1:
    goto inline$CallCompletionRoutine$15$label_14$1#1;

  inline$CallCompletionRoutine$15$label_14$1#1:
    goto inline$CallCompletionRoutine$15$anon11_Then#1, inline$CallCompletionRoutine$15$anon11_Else#1;

  inline$CallCompletionRoutine$15$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$15$anon3#1;

  inline$CallCompletionRoutine$15$anon3#1:
    goto inline$CallCompletionRoutine$15$label_17#1;

  inline$CallCompletionRoutine$15$label_17#1:
    goto inline$CallCompletionRoutine$15$label_18#1;

  inline$CallCompletionRoutine$15$label_18#1:
    goto inline$CallCompletionRoutine$15$label_18_true#1, inline$CallCompletionRoutine$15$label_18_false#1;

  inline$CallCompletionRoutine$15$label_18_false#1:
    assume inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$15$label_1#1;

  inline$CallCompletionRoutine$15$label_18_true#1:
    assume inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$15$label_19#1;

  inline$CallCompletionRoutine$15$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$15$label_20#1;

  inline$CallCompletionRoutine$15$label_20#1:
    goto inline$CallCompletionRoutine$15$label_20_icall_1#1, inline$CallCompletionRoutine$15$label_20_icall_2#1, inline$CallCompletionRoutine$15$label_20_icall_3#1;

  inline$CallCompletionRoutine$15$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$15$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$15$Entry#1;

  inline$BDLSystemPowerIoCompletion$15$Entry#1:
    inline$BDLSystemPowerIoCompletion$15$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$15$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$15$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$15$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$15$start#1;

  inline$BDLSystemPowerIoCompletion$15$start#1:
    call inline$BDLSystemPowerIoCompletion$15$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$15$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$15$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$15$label_3#1;

  inline$BDLSystemPowerIoCompletion$15$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_4#1;

  inline$BDLSystemPowerIoCompletion$15$label_4#1:
    inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_5#1;

  inline$BDLSystemPowerIoCompletion$15$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_6#1;

  inline$BDLSystemPowerIoCompletion$15$label_6#1:
    inline$BDLSystemPowerIoCompletion$15$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$15$label_7#1;

  inline$BDLSystemPowerIoCompletion$15$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_8#1;

  inline$BDLSystemPowerIoCompletion$15$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$15$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$15$label_9#1;

  inline$BDLSystemPowerIoCompletion$15$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_10#1;

  inline$BDLSystemPowerIoCompletion$15$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$82$Entry#1;

  inline$IoGetCurrentIrpStackLocation$82$Entry#1:
    inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$82$start#1;

  inline$IoGetCurrentIrpStackLocation$82$start#1:
    inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$82$label_3#1;

  inline$IoGetCurrentIrpStackLocation$82$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$82$label_3_true#1, inline$IoGetCurrentIrpStackLocation$82$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$82$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$82$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$82$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$82$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$82$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$82$label_4#1;

  inline$IoGetCurrentIrpStackLocation$82$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$82$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$82$label_6#1;

  inline$IoGetCurrentIrpStackLocation$82$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$82$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$82$label_7#1;

  inline$IoGetCurrentIrpStackLocation$82$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$82$label_5#1;

  inline$IoGetCurrentIrpStackLocation$82$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$82$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$82$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$82$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$82$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$82$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$82$label_5#1;

  inline$IoGetCurrentIrpStackLocation$82$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$82$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$82$label_1#1;

  inline$IoGetCurrentIrpStackLocation$82$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$82$Return#1;

  inline$IoGetCurrentIrpStackLocation$82$Return#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon36_Then#1, inline$BDLSystemPowerIoCompletion$15$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon1#1;

  inline$BDLSystemPowerIoCompletion$15$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_13#1;

  inline$BDLSystemPowerIoCompletion$15$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_14#1;

  inline$BDLSystemPowerIoCompletion$15$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_15#1;

  inline$BDLSystemPowerIoCompletion$15$label_15#1:
    goto inline$BDLGetDebugLevel$418$Entry#1;

  inline$BDLGetDebugLevel$418$Entry#1:
    goto inline$BDLGetDebugLevel$418$start#1;

  inline$BDLGetDebugLevel$418$start#1:
    goto inline$BDLGetDebugLevel$418$label_3#1;

  inline$BDLGetDebugLevel$418$label_3#1:
    havoc inline$BDLGetDebugLevel$418$myNondetVar_0;
    inline$BDLGetDebugLevel$418$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$418$myNondetVar_0;
    goto inline$BDLGetDebugLevel$418$label_1#1;

  inline$BDLGetDebugLevel$418$label_1#1:
    goto inline$BDLGetDebugLevel$418$Return#1;

  inline$BDLGetDebugLevel$418$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$418$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon37_Then#1, inline$BDLSystemPowerIoCompletion$15$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon3#1;

  inline$BDLSystemPowerIoCompletion$15$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_18#1;

  inline$BDLSystemPowerIoCompletion$15$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_18_true#1, inline$BDLSystemPowerIoCompletion$15$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_19#1;

  inline$BDLSystemPowerIoCompletion$15$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_22#1;

  inline$BDLSystemPowerIoCompletion$15$label_22#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_23#1;

  inline$BDLSystemPowerIoCompletion$15$label_23#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_24#1;

  inline$BDLSystemPowerIoCompletion$15$label_24#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_25#1;

  inline$BDLSystemPowerIoCompletion$15$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$15$label_19#1;

  inline$BDLSystemPowerIoCompletion$15$label_19#1:
    goto inline$BDLGetDebugLevel$419$Entry#1;

  inline$BDLGetDebugLevel$419$Entry#1:
    goto inline$BDLGetDebugLevel$419$start#1;

  inline$BDLGetDebugLevel$419$start#1:
    goto inline$BDLGetDebugLevel$419$label_3#1;

  inline$BDLGetDebugLevel$419$label_3#1:
    havoc inline$BDLGetDebugLevel$419$myNondetVar_0;
    inline$BDLGetDebugLevel$419$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$419$myNondetVar_0;
    goto inline$BDLGetDebugLevel$419$label_1#1;

  inline$BDLGetDebugLevel$419$label_1#1:
    goto inline$BDLGetDebugLevel$419$Return#1;

  inline$BDLGetDebugLevel$419$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$419$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon38_Then#1, inline$BDLSystemPowerIoCompletion$15$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon5#1;

  inline$BDLSystemPowerIoCompletion$15$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_28#1;

  inline$BDLSystemPowerIoCompletion$15$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_28_true#1, inline$BDLSystemPowerIoCompletion$15$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_29#1;

  inline$BDLSystemPowerIoCompletion$15$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_32#1;

  inline$BDLSystemPowerIoCompletion$15$label_32#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_33#1;

  inline$BDLSystemPowerIoCompletion$15$label_33#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_34#1;

  inline$BDLSystemPowerIoCompletion$15$label_34#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_35#1;

  inline$BDLSystemPowerIoCompletion$15$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$15$label_29#1;

  inline$BDLSystemPowerIoCompletion$15$label_29#1:
    goto inline$BDLGetDebugLevel$420$Entry#1;

  inline$BDLGetDebugLevel$420$Entry#1:
    goto inline$BDLGetDebugLevel$420$start#1;

  inline$BDLGetDebugLevel$420$start#1:
    goto inline$BDLGetDebugLevel$420$label_3#1;

  inline$BDLGetDebugLevel$420$label_3#1:
    havoc inline$BDLGetDebugLevel$420$myNondetVar_0;
    inline$BDLGetDebugLevel$420$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$420$myNondetVar_0;
    goto inline$BDLGetDebugLevel$420$label_1#1;

  inline$BDLGetDebugLevel$420$label_1#1:
    goto inline$BDLGetDebugLevel$420$Return#1;

  inline$BDLGetDebugLevel$420$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$420$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon39_Then#1, inline$BDLSystemPowerIoCompletion$15$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon7#1;

  inline$BDLSystemPowerIoCompletion$15$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_38#1;

  inline$BDLSystemPowerIoCompletion$15$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_38_true#1, inline$BDLSystemPowerIoCompletion$15$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_39#1;

  inline$BDLSystemPowerIoCompletion$15$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_40#1;

  inline$BDLSystemPowerIoCompletion$15$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_39#1;

  inline$BDLSystemPowerIoCompletion$15$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_39_true#1, inline$BDLSystemPowerIoCompletion$15$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_41#1;

  inline$BDLSystemPowerIoCompletion$15$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$15$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$15$label_107#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$15$label_108#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$15$label_108#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$15$label_108#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$15$label_108#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$15$label_108#1;

  inline$BDLSystemPowerIoCompletion$15$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_109#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$15$label_107#1;

  inline$BDLSystemPowerIoCompletion$15$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_109#1;

  inline$BDLSystemPowerIoCompletion$15$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$15$label_106#1;

  inline$BDLSystemPowerIoCompletion$15$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_106_true#1, inline$BDLSystemPowerIoCompletion$15$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_142#1;

  inline$BDLSystemPowerIoCompletion$15$label_142#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_143#1;

  inline$BDLSystemPowerIoCompletion$15$label_143#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_144#1;

  inline$BDLSystemPowerIoCompletion$15$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_109#1;

  inline$BDLSystemPowerIoCompletion$15$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_109#1;

  inline$BDLSystemPowerIoCompletion$15$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$15$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$15$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$15$myNondetVar_0, inline$BDLSystemPowerIoCompletion$15$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$15$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$15$anon50_Then#1, inline$BDLSystemPowerIoCompletion$15$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon29#1;

  inline$BDLSystemPowerIoCompletion$15$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_112#1;

  inline$BDLSystemPowerIoCompletion$15$label_112#1:
    inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$15$label_113#1;

  inline$BDLSystemPowerIoCompletion$15$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_113_true#1, inline$BDLSystemPowerIoCompletion$15$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$15$label_114#1;

  inline$BDLSystemPowerIoCompletion$15$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_116#1;

  inline$BDLSystemPowerIoCompletion$15$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_117#1;

  inline$BDLSystemPowerIoCompletion$15$label_117#1:
    goto inline$BDLGetDebugLevel$427$Entry#1;

  inline$BDLGetDebugLevel$427$Entry#1:
    goto inline$BDLGetDebugLevel$427$start#1;

  inline$BDLGetDebugLevel$427$start#1:
    goto inline$BDLGetDebugLevel$427$label_3#1;

  inline$BDLGetDebugLevel$427$label_3#1:
    havoc inline$BDLGetDebugLevel$427$myNondetVar_0;
    inline$BDLGetDebugLevel$427$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$427$myNondetVar_0;
    goto inline$BDLGetDebugLevel$427$label_1#1;

  inline$BDLGetDebugLevel$427$label_1#1:
    goto inline$BDLGetDebugLevel$427$Return#1;

  inline$BDLGetDebugLevel$427$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$427$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon51_Then#1, inline$BDLSystemPowerIoCompletion$15$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon31#1;

  inline$BDLSystemPowerIoCompletion$15$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_120#1;

  inline$BDLSystemPowerIoCompletion$15$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_120_true#1, inline$BDLSystemPowerIoCompletion$15$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_121#1;

  inline$BDLSystemPowerIoCompletion$15$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_124#1;

  inline$BDLSystemPowerIoCompletion$15$label_124#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_125#1;

  inline$BDLSystemPowerIoCompletion$15$label_125#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_126#1;

  inline$BDLSystemPowerIoCompletion$15$label_126#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_127#1;

  inline$BDLSystemPowerIoCompletion$15$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$15$label_121#1;

  inline$BDLSystemPowerIoCompletion$15$label_121#1:
    goto inline$BDLGetDebugLevel$428$Entry#1;

  inline$BDLGetDebugLevel$428$Entry#1:
    goto inline$BDLGetDebugLevel$428$start#1;

  inline$BDLGetDebugLevel$428$start#1:
    goto inline$BDLGetDebugLevel$428$label_3#1;

  inline$BDLGetDebugLevel$428$label_3#1:
    havoc inline$BDLGetDebugLevel$428$myNondetVar_0;
    inline$BDLGetDebugLevel$428$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$428$myNondetVar_0;
    goto inline$BDLGetDebugLevel$428$label_1#1;

  inline$BDLGetDebugLevel$428$label_1#1:
    goto inline$BDLGetDebugLevel$428$Return#1;

  inline$BDLGetDebugLevel$428$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$428$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon52_Then#1, inline$BDLSystemPowerIoCompletion$15$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon33#1;

  inline$BDLSystemPowerIoCompletion$15$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_130#1;

  inline$BDLSystemPowerIoCompletion$15$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_130_true#1, inline$BDLSystemPowerIoCompletion$15$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_131#1;

  inline$BDLSystemPowerIoCompletion$15$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_134#1;

  inline$BDLSystemPowerIoCompletion$15$label_134#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_135#1;

  inline$BDLSystemPowerIoCompletion$15$label_135#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_136#1;

  inline$BDLSystemPowerIoCompletion$15$label_136#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_137#1;

  inline$BDLSystemPowerIoCompletion$15$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$15$label_131#1;

  inline$BDLSystemPowerIoCompletion$15$label_131#1:
    goto inline$BDLGetDebugLevel$429$Entry#1;

  inline$BDLGetDebugLevel$429$Entry#1:
    goto inline$BDLGetDebugLevel$429$start#1;

  inline$BDLGetDebugLevel$429$start#1:
    goto inline$BDLGetDebugLevel$429$label_3#1;

  inline$BDLGetDebugLevel$429$label_3#1:
    havoc inline$BDLGetDebugLevel$429$myNondetVar_0;
    inline$BDLGetDebugLevel$429$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$429$myNondetVar_0;
    goto inline$BDLGetDebugLevel$429$label_1#1;

  inline$BDLGetDebugLevel$429$label_1#1:
    goto inline$BDLGetDebugLevel$429$Return#1;

  inline$BDLGetDebugLevel$429$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$429$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon53_Then#1, inline$BDLSystemPowerIoCompletion$15$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon35#1;

  inline$BDLSystemPowerIoCompletion$15$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_140#1;

  inline$BDLSystemPowerIoCompletion$15$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_140_true#1, inline$BDLSystemPowerIoCompletion$15$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_67#1;

  inline$BDLSystemPowerIoCompletion$15$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_141#1;

  inline$BDLSystemPowerIoCompletion$15$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_67#1;

  inline$BDLSystemPowerIoCompletion$15$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$15$label_115#1;

  inline$BDLSystemPowerIoCompletion$15$label_115#1:
    inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$15$label_80#1;

  inline$BDLSystemPowerIoCompletion$15$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$15$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_42#1;

  inline$BDLSystemPowerIoCompletion$15$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$15$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$15$label_43#1;

  inline$BDLSystemPowerIoCompletion$15$label_43#1:
    goto inline$BDLGetDebugLevel$421$Entry#1;

  inline$BDLGetDebugLevel$421$Entry#1:
    goto inline$BDLGetDebugLevel$421$start#1;

  inline$BDLGetDebugLevel$421$start#1:
    goto inline$BDLGetDebugLevel$421$label_3#1;

  inline$BDLGetDebugLevel$421$label_3#1:
    havoc inline$BDLGetDebugLevel$421$myNondetVar_0;
    inline$BDLGetDebugLevel$421$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$421$myNondetVar_0;
    goto inline$BDLGetDebugLevel$421$label_1#1;

  inline$BDLGetDebugLevel$421$label_1#1:
    goto inline$BDLGetDebugLevel$421$Return#1;

  inline$BDLGetDebugLevel$421$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$421$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon40_Then#1, inline$BDLSystemPowerIoCompletion$15$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon9#1;

  inline$BDLSystemPowerIoCompletion$15$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_46#1;

  inline$BDLSystemPowerIoCompletion$15$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_46_true#1, inline$BDLSystemPowerIoCompletion$15$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_47#1;

  inline$BDLSystemPowerIoCompletion$15$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_50#1;

  inline$BDLSystemPowerIoCompletion$15$label_50#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_51#1;

  inline$BDLSystemPowerIoCompletion$15$label_51#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_52#1;

  inline$BDLSystemPowerIoCompletion$15$label_52#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_53#1;

  inline$BDLSystemPowerIoCompletion$15$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$15$label_47#1;

  inline$BDLSystemPowerIoCompletion$15$label_47#1:
    goto inline$BDLGetDebugLevel$422$Entry#1;

  inline$BDLGetDebugLevel$422$Entry#1:
    goto inline$BDLGetDebugLevel$422$start#1;

  inline$BDLGetDebugLevel$422$start#1:
    goto inline$BDLGetDebugLevel$422$label_3#1;

  inline$BDLGetDebugLevel$422$label_3#1:
    havoc inline$BDLGetDebugLevel$422$myNondetVar_0;
    inline$BDLGetDebugLevel$422$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$422$myNondetVar_0;
    goto inline$BDLGetDebugLevel$422$label_1#1;

  inline$BDLGetDebugLevel$422$label_1#1:
    goto inline$BDLGetDebugLevel$422$Return#1;

  inline$BDLGetDebugLevel$422$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$422$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon41_Then#1, inline$BDLSystemPowerIoCompletion$15$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon11#1;

  inline$BDLSystemPowerIoCompletion$15$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_56#1;

  inline$BDLSystemPowerIoCompletion$15$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_56_true#1, inline$BDLSystemPowerIoCompletion$15$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_57#1;

  inline$BDLSystemPowerIoCompletion$15$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_60#1;

  inline$BDLSystemPowerIoCompletion$15$label_60#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_61#1;

  inline$BDLSystemPowerIoCompletion$15$label_61#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_62#1;

  inline$BDLSystemPowerIoCompletion$15$label_62#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_63#1;

  inline$BDLSystemPowerIoCompletion$15$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$15$label_57#1;

  inline$BDLSystemPowerIoCompletion$15$label_57#1:
    goto inline$BDLGetDebugLevel$423$Entry#1;

  inline$BDLGetDebugLevel$423$Entry#1:
    goto inline$BDLGetDebugLevel$423$start#1;

  inline$BDLGetDebugLevel$423$start#1:
    goto inline$BDLGetDebugLevel$423$label_3#1;

  inline$BDLGetDebugLevel$423$label_3#1:
    havoc inline$BDLGetDebugLevel$423$myNondetVar_0;
    inline$BDLGetDebugLevel$423$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$423$myNondetVar_0;
    goto inline$BDLGetDebugLevel$423$label_1#1;

  inline$BDLGetDebugLevel$423$label_1#1:
    goto inline$BDLGetDebugLevel$423$Return#1;

  inline$BDLGetDebugLevel$423$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$423$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon42_Then#1, inline$BDLSystemPowerIoCompletion$15$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon13#1;

  inline$BDLSystemPowerIoCompletion$15$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_66#1;

  inline$BDLSystemPowerIoCompletion$15$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_66_true#1, inline$BDLSystemPowerIoCompletion$15$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_67#1;

  inline$BDLSystemPowerIoCompletion$15$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_70#1;

  inline$BDLSystemPowerIoCompletion$15$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_67#1;

  inline$BDLSystemPowerIoCompletion$15$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$15$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$15$anon43_Then#1, inline$BDLSystemPowerIoCompletion$15$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon15#1;

  inline$BDLSystemPowerIoCompletion$15$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_71#1;

  inline$BDLSystemPowerIoCompletion$15$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$15$anon44_Then#1, inline$BDLSystemPowerIoCompletion$15$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon17#1;

  inline$BDLSystemPowerIoCompletion$15$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_74#1;

  inline$BDLSystemPowerIoCompletion$15$label_74#1:
    goto inline$storm_IoCompleteRequest$32$Entry#1;

  inline$storm_IoCompleteRequest$32$Entry#1:
    inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$15$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$32$start#1;

  inline$storm_IoCompleteRequest$32$start#1:
    inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$32$label_3#1;

  inline$storm_IoCompleteRequest$32$label_3#1:
    call inline$storm_IoCompleteRequest$32$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$32$label_6#1;

  inline$storm_IoCompleteRequest$32$label_6#1:
    goto inline$storm_IoCompleteRequest$32$label_6_true#1, inline$storm_IoCompleteRequest$32$label_6_false#1;

  inline$storm_IoCompleteRequest$32$label_6_false#1:
    assume inline$storm_IoCompleteRequest$32$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$32$label_7#1;

  inline$storm_IoCompleteRequest$32$label_6_true#1:
    assume inline$storm_IoCompleteRequest$32$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$32$label_8#1;

  inline$storm_IoCompleteRequest$32$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$32$anon3_Then#1, inline$storm_IoCompleteRequest$32$anon3_Else#1;

  inline$storm_IoCompleteRequest$32$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$32$anon1#1;

  inline$storm_IoCompleteRequest$32$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$32$label_9#1;

  inline$storm_IoCompleteRequest$32$label_9#1:
    goto inline$storm_IoCompleteRequest$32$label_9_true#1, inline$storm_IoCompleteRequest$32$label_9_false#1;

  inline$storm_IoCompleteRequest$32$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$32$label_10#1;

  inline$storm_IoCompleteRequest$32$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$32$label_1#1;

  inline$storm_IoCompleteRequest$32$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$32$label_7#1;

  inline$storm_IoCompleteRequest$32$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$32$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$32$label_1#1;

  inline$storm_IoCompleteRequest$32$label_1#1:
    goto inline$storm_IoCompleteRequest$32$Return#1;

  inline$storm_IoCompleteRequest$32$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$32$Return#1;

  inline$storm_IoCompleteRequest$32$Return#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon45_Then#1, inline$BDLSystemPowerIoCompletion$15$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon19#1;

  inline$BDLSystemPowerIoCompletion$15$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_77#1;

  inline$BDLSystemPowerIoCompletion$15$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$15$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$15$anon46_Then#1, inline$BDLSystemPowerIoCompletion$15$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon21#1;

  inline$BDLSystemPowerIoCompletion$15$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_80#1;

  inline$BDLSystemPowerIoCompletion$15$label_80#1:
    goto inline$BDLGetDebugLevel$424$Entry#1;

  inline$BDLGetDebugLevel$424$Entry#1:
    goto inline$BDLGetDebugLevel$424$start#1;

  inline$BDLGetDebugLevel$424$start#1:
    goto inline$BDLGetDebugLevel$424$label_3#1;

  inline$BDLGetDebugLevel$424$label_3#1:
    havoc inline$BDLGetDebugLevel$424$myNondetVar_0;
    inline$BDLGetDebugLevel$424$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$424$myNondetVar_0;
    goto inline$BDLGetDebugLevel$424$label_1#1;

  inline$BDLGetDebugLevel$424$label_1#1:
    goto inline$BDLGetDebugLevel$424$Return#1;

  inline$BDLGetDebugLevel$424$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$424$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon47_Then#1, inline$BDLSystemPowerIoCompletion$15$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon23#1;

  inline$BDLSystemPowerIoCompletion$15$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_83#1;

  inline$BDLSystemPowerIoCompletion$15$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_83_true#1, inline$BDLSystemPowerIoCompletion$15$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_84#1;

  inline$BDLSystemPowerIoCompletion$15$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_87#1;

  inline$BDLSystemPowerIoCompletion$15$label_87#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_88#1;

  inline$BDLSystemPowerIoCompletion$15$label_88#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_89#1;

  inline$BDLSystemPowerIoCompletion$15$label_89#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_90#1;

  inline$BDLSystemPowerIoCompletion$15$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$15$label_84#1;

  inline$BDLSystemPowerIoCompletion$15$label_84#1:
    goto inline$BDLGetDebugLevel$425$Entry#1;

  inline$BDLGetDebugLevel$425$Entry#1:
    goto inline$BDLGetDebugLevel$425$start#1;

  inline$BDLGetDebugLevel$425$start#1:
    goto inline$BDLGetDebugLevel$425$label_3#1;

  inline$BDLGetDebugLevel$425$label_3#1:
    havoc inline$BDLGetDebugLevel$425$myNondetVar_0;
    inline$BDLGetDebugLevel$425$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$425$myNondetVar_0;
    goto inline$BDLGetDebugLevel$425$label_1#1;

  inline$BDLGetDebugLevel$425$label_1#1:
    goto inline$BDLGetDebugLevel$425$Return#1;

  inline$BDLGetDebugLevel$425$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$425$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon48_Then#1, inline$BDLSystemPowerIoCompletion$15$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon25#1;

  inline$BDLSystemPowerIoCompletion$15$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_93#1;

  inline$BDLSystemPowerIoCompletion$15$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_93_true#1, inline$BDLSystemPowerIoCompletion$15$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_94#1;

  inline$BDLSystemPowerIoCompletion$15$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_97#1;

  inline$BDLSystemPowerIoCompletion$15$label_97#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_98#1;

  inline$BDLSystemPowerIoCompletion$15$label_98#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_99#1;

  inline$BDLSystemPowerIoCompletion$15$label_99#1:
    call inline$BDLSystemPowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$15$label_100#1;

  inline$BDLSystemPowerIoCompletion$15$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$15$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$15$label_94#1;

  inline$BDLSystemPowerIoCompletion$15$label_94#1:
    goto inline$BDLGetDebugLevel$426$Entry#1;

  inline$BDLGetDebugLevel$426$Entry#1:
    goto inline$BDLGetDebugLevel$426$start#1;

  inline$BDLGetDebugLevel$426$start#1:
    goto inline$BDLGetDebugLevel$426$label_3#1;

  inline$BDLGetDebugLevel$426$label_3#1:
    havoc inline$BDLGetDebugLevel$426$myNondetVar_0;
    inline$BDLGetDebugLevel$426$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$426$myNondetVar_0;
    goto inline$BDLGetDebugLevel$426$label_1#1;

  inline$BDLGetDebugLevel$426$label_1#1:
    goto inline$BDLGetDebugLevel$426$Return#1;

  inline$BDLGetDebugLevel$426$Return#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$426$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$15$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$15$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$15$anon49_Then#1, inline$BDLSystemPowerIoCompletion$15$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$15$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$anon27#1;

  inline$BDLSystemPowerIoCompletion$15$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_103#1;

  inline$BDLSystemPowerIoCompletion$15$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_103_true#1, inline$BDLSystemPowerIoCompletion$15$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$15$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_104#1;

  inline$BDLSystemPowerIoCompletion$15$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$15$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$15$label_105#1;

  inline$BDLSystemPowerIoCompletion$15$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$15$label_104#1;

  inline$BDLSystemPowerIoCompletion$15$label_104#1:
    inline$BDLSystemPowerIoCompletion$15$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$15$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$15$label_1#1;

  inline$BDLSystemPowerIoCompletion$15$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$15$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$15$Return#1;

  inline$BDLSystemPowerIoCompletion$15$Return#1:
    inline$CallCompletionRoutine$15$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$15$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$15$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$15$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$15$anon14_Then#1, inline$CallCompletionRoutine$15$anon14_Else#1;

  inline$CallCompletionRoutine$15$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$15$anon9#1;

  inline$CallCompletionRoutine$15$anon9#1:
    goto inline$CallCompletionRoutine$15$label_20_icall_return#1;

  inline$CallCompletionRoutine$15$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$15$Return#1;

  inline$CallCompletionRoutine$15$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$15$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$15$Entry#1;

  inline$BDLDevicePowerIoCompletion$15$Entry#1:
    inline$BDLDevicePowerIoCompletion$15$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$15$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$15$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$15$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$15$start#1;

  inline$BDLDevicePowerIoCompletion$15$start#1:
    call inline$BDLDevicePowerIoCompletion$15$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$15$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$15$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$15$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$15$label_3#1;

  inline$BDLDevicePowerIoCompletion$15$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_4#1;

  inline$BDLDevicePowerIoCompletion$15$label_4#1:
    inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_5#1;

  inline$BDLDevicePowerIoCompletion$15$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_6#1;

  inline$BDLDevicePowerIoCompletion$15$label_6#1:
    inline$BDLDevicePowerIoCompletion$15$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$15$label_7#1;

  inline$BDLDevicePowerIoCompletion$15$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_8#1;

  inline$BDLDevicePowerIoCompletion$15$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$15$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$15$label_9#1;

  inline$BDLDevicePowerIoCompletion$15$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_10#1;

  inline$BDLDevicePowerIoCompletion$15$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$81$Entry#1;

  inline$IoGetCurrentIrpStackLocation$81$Entry#1:
    inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$81$start#1;

  inline$IoGetCurrentIrpStackLocation$81$start#1:
    inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$81$label_3#1;

  inline$IoGetCurrentIrpStackLocation$81$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$81$label_3_true#1, inline$IoGetCurrentIrpStackLocation$81$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$81$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$81$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$81$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$81$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$81$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$81$label_4#1;

  inline$IoGetCurrentIrpStackLocation$81$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$81$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$81$label_6#1;

  inline$IoGetCurrentIrpStackLocation$81$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$81$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$81$label_7#1;

  inline$IoGetCurrentIrpStackLocation$81$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$81$label_5#1;

  inline$IoGetCurrentIrpStackLocation$81$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$81$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$81$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$81$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$81$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$81$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$81$label_5#1;

  inline$IoGetCurrentIrpStackLocation$81$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$81$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$81$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$81$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$81$label_1#1;

  inline$IoGetCurrentIrpStackLocation$81$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$81$Return#1;

  inline$IoGetCurrentIrpStackLocation$81$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$81$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon30_Then#1, inline$BDLDevicePowerIoCompletion$15$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon1#1;

  inline$BDLDevicePowerIoCompletion$15$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_13#1;

  inline$BDLDevicePowerIoCompletion$15$label_13#1:
    inline$BDLDevicePowerIoCompletion$15$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$15$label_14#1;

  inline$BDLDevicePowerIoCompletion$15$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_15#1;

  inline$BDLDevicePowerIoCompletion$15$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$15$label_16#1;

  inline$BDLDevicePowerIoCompletion$15$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_17#1;

  inline$BDLDevicePowerIoCompletion$15$label_17#1:
    goto inline$BDLGetDebugLevel$409$Entry#1;

  inline$BDLGetDebugLevel$409$Entry#1:
    goto inline$BDLGetDebugLevel$409$start#1;

  inline$BDLGetDebugLevel$409$start#1:
    goto inline$BDLGetDebugLevel$409$label_3#1;

  inline$BDLGetDebugLevel$409$label_3#1:
    havoc inline$BDLGetDebugLevel$409$myNondetVar_0;
    inline$BDLGetDebugLevel$409$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$409$myNondetVar_0;
    goto inline$BDLGetDebugLevel$409$label_1#1;

  inline$BDLGetDebugLevel$409$label_1#1:
    goto inline$BDLGetDebugLevel$409$Return#1;

  inline$BDLGetDebugLevel$409$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$409$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon31_Then#1, inline$BDLDevicePowerIoCompletion$15$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon3#1;

  inline$BDLDevicePowerIoCompletion$15$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_20#1;

  inline$BDLDevicePowerIoCompletion$15$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_20_true#1, inline$BDLDevicePowerIoCompletion$15$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_21#1;

  inline$BDLDevicePowerIoCompletion$15$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_24#1;

  inline$BDLDevicePowerIoCompletion$15$label_24#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_25#1;

  inline$BDLDevicePowerIoCompletion$15$label_25#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_26#1;

  inline$BDLDevicePowerIoCompletion$15$label_26#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_27#1;

  inline$BDLDevicePowerIoCompletion$15$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$15$label_21#1;

  inline$BDLDevicePowerIoCompletion$15$label_21#1:
    goto inline$BDLGetDebugLevel$410$Entry#1;

  inline$BDLGetDebugLevel$410$Entry#1:
    goto inline$BDLGetDebugLevel$410$start#1;

  inline$BDLGetDebugLevel$410$start#1:
    goto inline$BDLGetDebugLevel$410$label_3#1;

  inline$BDLGetDebugLevel$410$label_3#1:
    havoc inline$BDLGetDebugLevel$410$myNondetVar_0;
    inline$BDLGetDebugLevel$410$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$410$myNondetVar_0;
    goto inline$BDLGetDebugLevel$410$label_1#1;

  inline$BDLGetDebugLevel$410$label_1#1:
    goto inline$BDLGetDebugLevel$410$Return#1;

  inline$BDLGetDebugLevel$410$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$410$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon32_Then#1, inline$BDLDevicePowerIoCompletion$15$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon5#1;

  inline$BDLDevicePowerIoCompletion$15$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_30#1;

  inline$BDLDevicePowerIoCompletion$15$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_30_true#1, inline$BDLDevicePowerIoCompletion$15$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_31#1;

  inline$BDLDevicePowerIoCompletion$15$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_34#1;

  inline$BDLDevicePowerIoCompletion$15$label_34#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_35#1;

  inline$BDLDevicePowerIoCompletion$15$label_35#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_36#1;

  inline$BDLDevicePowerIoCompletion$15$label_36#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_37#1;

  inline$BDLDevicePowerIoCompletion$15$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$15$label_31#1;

  inline$BDLDevicePowerIoCompletion$15$label_31#1:
    goto inline$BDLGetDebugLevel$411$Entry#1;

  inline$BDLGetDebugLevel$411$Entry#1:
    goto inline$BDLGetDebugLevel$411$start#1;

  inline$BDLGetDebugLevel$411$start#1:
    goto inline$BDLGetDebugLevel$411$label_3#1;

  inline$BDLGetDebugLevel$411$label_3#1:
    havoc inline$BDLGetDebugLevel$411$myNondetVar_0;
    inline$BDLGetDebugLevel$411$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$411$myNondetVar_0;
    goto inline$BDLGetDebugLevel$411$label_1#1;

  inline$BDLGetDebugLevel$411$label_1#1:
    goto inline$BDLGetDebugLevel$411$Return#1;

  inline$BDLGetDebugLevel$411$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$411$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon33_Then#1, inline$BDLDevicePowerIoCompletion$15$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon7#1;

  inline$BDLDevicePowerIoCompletion$15$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_40#1;

  inline$BDLDevicePowerIoCompletion$15$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_40_true#1, inline$BDLDevicePowerIoCompletion$15$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_41#1;

  inline$BDLDevicePowerIoCompletion$15$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_42#1;

  inline$BDLDevicePowerIoCompletion$15$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_41#1;

  inline$BDLDevicePowerIoCompletion$15$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_41_true#1, inline$BDLDevicePowerIoCompletion$15$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$15$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$15$label_43#1;

  inline$BDLDevicePowerIoCompletion$15$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$15$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$15$label_44#1;

  inline$BDLDevicePowerIoCompletion$15$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_44_true#1, inline$BDLDevicePowerIoCompletion$15$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$15$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$15$label_45#1;

  inline$BDLDevicePowerIoCompletion$15$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_45_true#1, inline$BDLDevicePowerIoCompletion$15$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$15$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$15$label_43#1;

  inline$BDLDevicePowerIoCompletion$15$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$15$label_86#1;

  inline$BDLDevicePowerIoCompletion$15$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$15$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$15$label_46#1;

  inline$BDLDevicePowerIoCompletion$15$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$15$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$15$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$15$label_46#1;

  inline$BDLDevicePowerIoCompletion$15$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$15$label_49#1;

  inline$BDLDevicePowerIoCompletion$15$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_50#1;

  inline$BDLDevicePowerIoCompletion$15$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_51#1;

  inline$BDLDevicePowerIoCompletion$15$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_54#1;

  inline$BDLDevicePowerIoCompletion$15$label_54#1:
    inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$15$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$15$label_55#1;

  inline$BDLDevicePowerIoCompletion$15$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_55_true#1, inline$BDLDevicePowerIoCompletion$15$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_56#1;

  inline$BDLDevicePowerIoCompletion$15$label_56#1:
    call inline$BDLDevicePowerIoCompletion$15$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$15$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$15$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$15$anon34_Then#1, inline$BDLDevicePowerIoCompletion$15$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon9#1;

  inline$BDLDevicePowerIoCompletion$15$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_83#1;

  inline$BDLDevicePowerIoCompletion$15$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_59#1;

  inline$BDLDevicePowerIoCompletion$15$label_59#1:
    goto inline$BDLGetDebugLevel$412$Entry#1;

  inline$BDLGetDebugLevel$412$Entry#1:
    goto inline$BDLGetDebugLevel$412$start#1;

  inline$BDLGetDebugLevel$412$start#1:
    goto inline$BDLGetDebugLevel$412$label_3#1;

  inline$BDLGetDebugLevel$412$label_3#1:
    havoc inline$BDLGetDebugLevel$412$myNondetVar_0;
    inline$BDLGetDebugLevel$412$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$412$myNondetVar_0;
    goto inline$BDLGetDebugLevel$412$label_1#1;

  inline$BDLGetDebugLevel$412$label_1#1:
    goto inline$BDLGetDebugLevel$412$Return#1;

  inline$BDLGetDebugLevel$412$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$412$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon35_Then#1, inline$BDLDevicePowerIoCompletion$15$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon11#1;

  inline$BDLDevicePowerIoCompletion$15$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_62#1;

  inline$BDLDevicePowerIoCompletion$15$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_62_true#1, inline$BDLDevicePowerIoCompletion$15$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_63#1;

  inline$BDLDevicePowerIoCompletion$15$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_66#1;

  inline$BDLDevicePowerIoCompletion$15$label_66#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_67#1;

  inline$BDLDevicePowerIoCompletion$15$label_67#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_68#1;

  inline$BDLDevicePowerIoCompletion$15$label_68#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_69#1;

  inline$BDLDevicePowerIoCompletion$15$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$15$label_63#1;

  inline$BDLDevicePowerIoCompletion$15$label_63#1:
    goto inline$BDLGetDebugLevel$413$Entry#1;

  inline$BDLGetDebugLevel$413$Entry#1:
    goto inline$BDLGetDebugLevel$413$start#1;

  inline$BDLGetDebugLevel$413$start#1:
    goto inline$BDLGetDebugLevel$413$label_3#1;

  inline$BDLGetDebugLevel$413$label_3#1:
    havoc inline$BDLGetDebugLevel$413$myNondetVar_0;
    inline$BDLGetDebugLevel$413$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$413$myNondetVar_0;
    goto inline$BDLGetDebugLevel$413$label_1#1;

  inline$BDLGetDebugLevel$413$label_1#1:
    goto inline$BDLGetDebugLevel$413$Return#1;

  inline$BDLGetDebugLevel$413$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$413$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon36_Then#1, inline$BDLDevicePowerIoCompletion$15$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon13#1;

  inline$BDLDevicePowerIoCompletion$15$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_72#1;

  inline$BDLDevicePowerIoCompletion$15$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_72_true#1, inline$BDLDevicePowerIoCompletion$15$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_73#1;

  inline$BDLDevicePowerIoCompletion$15$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_76#1;

  inline$BDLDevicePowerIoCompletion$15$label_76#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_77#1;

  inline$BDLDevicePowerIoCompletion$15$label_77#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_78#1;

  inline$BDLDevicePowerIoCompletion$15$label_78#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_79#1;

  inline$BDLDevicePowerIoCompletion$15$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$15$label_73#1;

  inline$BDLDevicePowerIoCompletion$15$label_73#1:
    goto inline$BDLGetDebugLevel$414$Entry#1;

  inline$BDLGetDebugLevel$414$Entry#1:
    goto inline$BDLGetDebugLevel$414$start#1;

  inline$BDLGetDebugLevel$414$start#1:
    goto inline$BDLGetDebugLevel$414$label_3#1;

  inline$BDLGetDebugLevel$414$label_3#1:
    havoc inline$BDLGetDebugLevel$414$myNondetVar_0;
    inline$BDLGetDebugLevel$414$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$414$myNondetVar_0;
    goto inline$BDLGetDebugLevel$414$label_1#1;

  inline$BDLGetDebugLevel$414$label_1#1:
    goto inline$BDLGetDebugLevel$414$Return#1;

  inline$BDLGetDebugLevel$414$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$414$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon37_Then#1, inline$BDLDevicePowerIoCompletion$15$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon15#1;

  inline$BDLDevicePowerIoCompletion$15$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_82#1;

  inline$BDLDevicePowerIoCompletion$15$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_82_true#1, inline$BDLDevicePowerIoCompletion$15$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_83#1;

  inline$BDLDevicePowerIoCompletion$15$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_84#1;

  inline$BDLDevicePowerIoCompletion$15$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_83#1;

  inline$BDLDevicePowerIoCompletion$15$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_85#1;

  inline$BDLDevicePowerIoCompletion$15$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_86#1;

  inline$BDLDevicePowerIoCompletion$15$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$15$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$15$anon38_Then#1, inline$BDLDevicePowerIoCompletion$15$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon17#1;

  inline$BDLDevicePowerIoCompletion$15$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_89#1;

  inline$BDLDevicePowerIoCompletion$15$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$15$anon39_Then#1, inline$BDLDevicePowerIoCompletion$15$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon19#1;

  inline$BDLDevicePowerIoCompletion$15$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_92#1;

  inline$BDLDevicePowerIoCompletion$15$label_92#1:
    goto inline$storm_IoCompleteRequest$31$Entry#1;

  inline$storm_IoCompleteRequest$31$Entry#1:
    inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$15$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$31$start#1;

  inline$storm_IoCompleteRequest$31$start#1:
    inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$31$label_3#1;

  inline$storm_IoCompleteRequest$31$label_3#1:
    call inline$storm_IoCompleteRequest$31$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$31$label_6#1;

  inline$storm_IoCompleteRequest$31$label_6#1:
    goto inline$storm_IoCompleteRequest$31$label_6_true#1, inline$storm_IoCompleteRequest$31$label_6_false#1;

  inline$storm_IoCompleteRequest$31$label_6_false#1:
    assume inline$storm_IoCompleteRequest$31$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$31$label_7#1;

  inline$storm_IoCompleteRequest$31$label_6_true#1:
    assume inline$storm_IoCompleteRequest$31$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$31$label_8#1;

  inline$storm_IoCompleteRequest$31$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$31$anon3_Then#1, inline$storm_IoCompleteRequest$31$anon3_Else#1;

  inline$storm_IoCompleteRequest$31$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$31$anon1#1;

  inline$storm_IoCompleteRequest$31$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$31$label_9#1;

  inline$storm_IoCompleteRequest$31$label_9#1:
    goto inline$storm_IoCompleteRequest$31$label_9_true#1, inline$storm_IoCompleteRequest$31$label_9_false#1;

  inline$storm_IoCompleteRequest$31$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$31$label_10#1;

  inline$storm_IoCompleteRequest$31$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$31$label_1#1;

  inline$storm_IoCompleteRequest$31$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$31$label_7#1;

  inline$storm_IoCompleteRequest$31$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$31$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$31$label_1#1;

  inline$storm_IoCompleteRequest$31$label_1#1:
    goto inline$storm_IoCompleteRequest$31$Return#1;

  inline$storm_IoCompleteRequest$31$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$31$Return#1;

  inline$storm_IoCompleteRequest$31$Return#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon40_Then#1, inline$BDLDevicePowerIoCompletion$15$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon21#1;

  inline$BDLDevicePowerIoCompletion$15$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_95#1;

  inline$BDLDevicePowerIoCompletion$15$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$15$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$15$anon41_Then#1, inline$BDLDevicePowerIoCompletion$15$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon23#1;

  inline$BDLDevicePowerIoCompletion$15$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_98#1;

  inline$BDLDevicePowerIoCompletion$15$label_98#1:
    goto inline$BDLGetDebugLevel$415$Entry#1;

  inline$BDLGetDebugLevel$415$Entry#1:
    goto inline$BDLGetDebugLevel$415$start#1;

  inline$BDLGetDebugLevel$415$start#1:
    goto inline$BDLGetDebugLevel$415$label_3#1;

  inline$BDLGetDebugLevel$415$label_3#1:
    havoc inline$BDLGetDebugLevel$415$myNondetVar_0;
    inline$BDLGetDebugLevel$415$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$415$myNondetVar_0;
    goto inline$BDLGetDebugLevel$415$label_1#1;

  inline$BDLGetDebugLevel$415$label_1#1:
    goto inline$BDLGetDebugLevel$415$Return#1;

  inline$BDLGetDebugLevel$415$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$415$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon42_Then#1, inline$BDLDevicePowerIoCompletion$15$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon25#1;

  inline$BDLDevicePowerIoCompletion$15$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_101#1;

  inline$BDLDevicePowerIoCompletion$15$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_101_true#1, inline$BDLDevicePowerIoCompletion$15$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_102#1;

  inline$BDLDevicePowerIoCompletion$15$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_105#1;

  inline$BDLDevicePowerIoCompletion$15$label_105#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_106#1;

  inline$BDLDevicePowerIoCompletion$15$label_106#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_107#1;

  inline$BDLDevicePowerIoCompletion$15$label_107#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_108#1;

  inline$BDLDevicePowerIoCompletion$15$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$15$label_102#1;

  inline$BDLDevicePowerIoCompletion$15$label_102#1:
    goto inline$BDLGetDebugLevel$416$Entry#1;

  inline$BDLGetDebugLevel$416$Entry#1:
    goto inline$BDLGetDebugLevel$416$start#1;

  inline$BDLGetDebugLevel$416$start#1:
    goto inline$BDLGetDebugLevel$416$label_3#1;

  inline$BDLGetDebugLevel$416$label_3#1:
    havoc inline$BDLGetDebugLevel$416$myNondetVar_0;
    inline$BDLGetDebugLevel$416$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$416$myNondetVar_0;
    goto inline$BDLGetDebugLevel$416$label_1#1;

  inline$BDLGetDebugLevel$416$label_1#1:
    goto inline$BDLGetDebugLevel$416$Return#1;

  inline$BDLGetDebugLevel$416$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$416$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon43_Then#1, inline$BDLDevicePowerIoCompletion$15$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon27#1;

  inline$BDLDevicePowerIoCompletion$15$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_111#1;

  inline$BDLDevicePowerIoCompletion$15$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_111_true#1, inline$BDLDevicePowerIoCompletion$15$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_112#1;

  inline$BDLDevicePowerIoCompletion$15$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_115#1;

  inline$BDLDevicePowerIoCompletion$15$label_115#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_116#1;

  inline$BDLDevicePowerIoCompletion$15$label_116#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_117#1;

  inline$BDLDevicePowerIoCompletion$15$label_117#1:
    call inline$BDLDevicePowerIoCompletion$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$15$label_118#1;

  inline$BDLDevicePowerIoCompletion$15$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$15$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$15$label_112#1;

  inline$BDLDevicePowerIoCompletion$15$label_112#1:
    goto inline$BDLGetDebugLevel$417$Entry#1;

  inline$BDLGetDebugLevel$417$Entry#1:
    goto inline$BDLGetDebugLevel$417$start#1;

  inline$BDLGetDebugLevel$417$start#1:
    goto inline$BDLGetDebugLevel$417$label_3#1;

  inline$BDLGetDebugLevel$417$label_3#1:
    havoc inline$BDLGetDebugLevel$417$myNondetVar_0;
    inline$BDLGetDebugLevel$417$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$417$myNondetVar_0;
    goto inline$BDLGetDebugLevel$417$label_1#1;

  inline$BDLGetDebugLevel$417$label_1#1:
    goto inline$BDLGetDebugLevel$417$Return#1;

  inline$BDLGetDebugLevel$417$Return#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$417$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$15$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$15$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$15$anon44_Then#1, inline$BDLDevicePowerIoCompletion$15$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$15$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$anon29#1;

  inline$BDLDevicePowerIoCompletion$15$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_121#1;

  inline$BDLDevicePowerIoCompletion$15$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_121_true#1, inline$BDLDevicePowerIoCompletion$15$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$15$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_122#1;

  inline$BDLDevicePowerIoCompletion$15$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$15$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$15$label_123#1;

  inline$BDLDevicePowerIoCompletion$15$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$15$label_122#1;

  inline$BDLDevicePowerIoCompletion$15$label_122#1:
    inline$BDLDevicePowerIoCompletion$15$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$15$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$15$label_1#1;

  inline$BDLDevicePowerIoCompletion$15$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$15$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$15$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$15$Return#1;

  inline$BDLDevicePowerIoCompletion$15$Return#1:
    inline$CallCompletionRoutine$15$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$15$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$15$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$15$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$15$anon13_Then#1, inline$CallCompletionRoutine$15$anon13_Else#1;

  inline$CallCompletionRoutine$15$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$15$anon7#1;

  inline$CallCompletionRoutine$15$anon7#1:
    goto inline$CallCompletionRoutine$15$label_20_icall_return#1;

  inline$CallCompletionRoutine$15$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$15$Return#1;

  inline$CallCompletionRoutine$15$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$15$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$15$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$15$Entry#1;

  inline$BDLCallDriverCompletionRoutine$15$Entry#1:
    inline$BDLCallDriverCompletionRoutine$15$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$15$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$15$start#1;

  inline$BDLCallDriverCompletionRoutine$15$start#1:
    inline$BDLCallDriverCompletionRoutine$15$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$15$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$15$label_3#1;

  inline$BDLCallDriverCompletionRoutine$15$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$15$label_3_true#1, inline$BDLCallDriverCompletionRoutine$15$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$15$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$15$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$15$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$15$label_4#1;

  inline$BDLCallDriverCompletionRoutine$15$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$15$label_6#1;

  inline$BDLCallDriverCompletionRoutine$15$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$15$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$15$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$15$label_5#1;

  inline$BDLCallDriverCompletionRoutine$15$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$15$label_6#1;

  inline$BDLCallDriverCompletionRoutine$15$label_6#1:
    goto inline$storm_KeSetEvent$17$Entry#1;

  inline$storm_KeSetEvent$17$Entry#1:
    inline$storm_KeSetEvent$17$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$15$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$17$start#1;

  inline$storm_KeSetEvent$17$start#1:
    inline$storm_KeSetEvent$17$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$17$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$17$label_3#1;

  inline$storm_KeSetEvent$17$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$17$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$17$label_1#1;

  inline$storm_KeSetEvent$17$label_1#1:
    goto inline$storm_KeSetEvent$17$Return#1;

  inline$storm_KeSetEvent$17$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$15$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$15$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$15$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$15$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$15$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$15$anon1#1;

  inline$BDLCallDriverCompletionRoutine$15$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$15$label_9#1;

  inline$BDLCallDriverCompletionRoutine$15$label_9#1:
    inline$BDLCallDriverCompletionRoutine$15$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$15$label_1#1;

  inline$BDLCallDriverCompletionRoutine$15$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$15$Return#1;

  inline$BDLCallDriverCompletionRoutine$15$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$15$Return#1;

  inline$BDLCallDriverCompletionRoutine$15$Return#1:
    inline$CallCompletionRoutine$15$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$15$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$15$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$15$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$15$anon12_Then#1, inline$CallCompletionRoutine$15$anon12_Else#1;

  inline$CallCompletionRoutine$15$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$15$anon5#1;

  inline$CallCompletionRoutine$15$anon5#1:
    goto inline$CallCompletionRoutine$15$label_20_icall_return#1;

  inline$CallCompletionRoutine$15$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$15$label_23#1;

  inline$CallCompletionRoutine$15$label_23#1:
    inline$CallCompletionRoutine$15$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$15$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$15$label_24#1;

  inline$CallCompletionRoutine$15$label_24#1:
    goto inline$CallCompletionRoutine$15$label_24_true#1, inline$CallCompletionRoutine$15$label_24_false#1;

  inline$CallCompletionRoutine$15$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$15$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$15$label_1#1;

  inline$CallCompletionRoutine$15$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$15$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$15$label_25#1;

  inline$CallCompletionRoutine$15$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$15$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$15$label_1#1;

  inline$CallCompletionRoutine$15$label_1#1:
    goto inline$CallCompletionRoutine$15$Return#1;

  inline$CallCompletionRoutine$15$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$15$Return#1;

  inline$CallCompletionRoutine$15$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$15$Return#1;

  inline$CallCompletionRoutine$15$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$15$Return#1;

  inline$CallCompletionRoutine$15$Return#1:
    goto inline$storm_IoCallDriver$7$label_39$1#1;

  inline$storm_IoCallDriver$7$label_39$1#1:
    goto inline$storm_IoCallDriver$7$anon15_Then#1, inline$storm_IoCallDriver$7$anon15_Else#1;

  inline$storm_IoCallDriver$7$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$7$anon10#1;

  inline$storm_IoCallDriver$7$anon10#1:
    goto inline$storm_IoCallDriver$7$label_36#1;

  inline$storm_IoCallDriver$7$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$7$Return#1;

  inline$storm_IoCallDriver$7$label_27_case_0#1:
    assume inline$storm_IoCallDriver$7$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$7$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$7$label_28#1;

  inline$storm_IoCallDriver$7$label_28#1:
    inline$storm_IoCallDriver$7$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$7$label_42#1;

  inline$storm_IoCallDriver$7$label_42#1:
    goto inline$storm_IoCallDriver$7$label_43#1;

  inline$storm_IoCallDriver$7$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$7$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$7$label_36#1;

  inline$storm_IoCallDriver$7$label_36#1:
    inline$storm_IoCallDriver$7$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$7$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$7$label_1#1;

  inline$storm_IoCallDriver$7$label_1#1:
    goto inline$storm_IoCallDriver$7$Return#1;

  inline$storm_IoCallDriver$7$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$7$Return#1;

  inline$storm_IoCallDriver$7$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$7$Return#1;

  inline$storm_IoCallDriver$7$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$7$Return#1;

  inline$storm_IoCallDriver$7$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_IoCallDriver$108.29$4$ := inline$storm_IoCallDriver$7$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_19$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_19$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon20_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon20_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon9#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon9#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_42#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_42#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_IoCallDriver$108.29$4$;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_18_true#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0;
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_22#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_22#1:
    call PoStartNextPowerIrp(inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon21_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon21_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon21_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon11#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon11#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_25#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_25#1:
    goto inline$storm_PoCallDriver$3$Entry#1;

  inline$storm_PoCallDriver$3$Entry#1:
    inline$storm_PoCallDriver$3$$Irp$2$496.14$storm_PoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_PoCallDriver$3$start#1;

  inline$storm_PoCallDriver$3$start#1:
    inline$storm_PoCallDriver$3$$Irp$2$496.14$storm_PoCallDriver$8 := inline$storm_PoCallDriver$3$$Irp$2$496.14$storm_PoCallDriver$8_.1;
    goto inline$storm_PoCallDriver$3$label_3#1;

  inline$storm_PoCallDriver$3$label_3#1:
    goto inline$storm_IoCallDriver$8$Entry#1;

  inline$storm_IoCallDriver$8$Entry#1:
    inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$storm_PoCallDriver$3$$Irp$2$496.14$storm_PoCallDriver$8;
    goto inline$storm_IoCallDriver$8$start#1;

  inline$storm_IoCallDriver$8$start#1:
    inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$8$label_3#1;

  inline$storm_IoCallDriver$8$label_3#1:
    goto inline$storm_IoCallDriver$8$label_4#1;

  inline$storm_IoCallDriver$8$label_4#1:
    goto inline$storm_IoCallDriver$8$label_5#1;

  inline$storm_IoCallDriver$8$label_5#1:
    goto inline$storm_IoCallDriver$8$label_6#1;

  inline$storm_IoCallDriver$8$label_6#1:
    call inline$storm_IoCallDriver$8$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$8$label_9#1;

  inline$storm_IoCallDriver$8$label_9#1:
    goto inline$storm_IoCallDriver$8$label_9_true#1, inline$storm_IoCallDriver$8$label_9_false#1;

  inline$storm_IoCallDriver$8$label_9_false#1:
    assume inline$storm_IoCallDriver$8$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$8$label_10#1;

  inline$storm_IoCallDriver$8$label_9_true#1:
    assume inline$storm_IoCallDriver$8$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$8$label_13#1;

  inline$storm_IoCallDriver$8$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$8$anon12_Then#1, inline$storm_IoCallDriver$8$anon12_Else#1;

  inline$storm_IoCallDriver$8$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$8$anon3#1;

  inline$storm_IoCallDriver$8$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$8$label_14#1;

  inline$storm_IoCallDriver$8$label_14#1:
    goto inline$storm_IoCallDriver$8$label_14_true#1, inline$storm_IoCallDriver$8$label_14_false#1;

  inline$storm_IoCallDriver$8$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$8$label_15#1;

  inline$storm_IoCallDriver$8$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$8$label_1#1;

  inline$storm_IoCallDriver$8$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$8$label_10#1;

  inline$storm_IoCallDriver$8$label_10#1:
    goto inline$IoSetNextIrpStackLocation$9$Entry#1;

  inline$IoSetNextIrpStackLocation$9$Entry#1:
    inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$9$start#1;

  inline$IoSetNextIrpStackLocation$9$start#1:
    inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$9$label_3#1;

  inline$IoSetNextIrpStackLocation$9$label_3#1:
    goto inline$IoSetNextIrpStackLocation$9$label_3_true#1, inline$IoSetNextIrpStackLocation$9$label_3_false#1;

  inline$IoSetNextIrpStackLocation$9$label_3_false#1:
    inline$IoSetNextIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$9$myVar_0);
    goto inline$IoSetNextIrpStackLocation$9$label_4#1;

  inline$IoSetNextIrpStackLocation$9$label_4#1:
    call inline$IoSetNextIrpStackLocation$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$9$label_7#1;

  inline$IoSetNextIrpStackLocation$9$label_7#1:
    call inline$IoSetNextIrpStackLocation$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$9$label_8#1;

  inline$IoSetNextIrpStackLocation$9$label_8#1:
    goto inline$IoSetNextIrpStackLocation$9$label_5#1;

  inline$IoSetNextIrpStackLocation$9$label_3_true#1:
    inline$IoSetNextIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$9$myVar_0);
    goto inline$IoSetNextIrpStackLocation$9$label_5#1;

  inline$IoSetNextIrpStackLocation$9$label_5#1:
    inline$IoSetNextIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$9$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$9$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$9$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$9$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$9$label_6#1;

  inline$IoSetNextIrpStackLocation$9$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$9$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$9$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$9$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$9$label_1#1;

  inline$IoSetNextIrpStackLocation$9$label_1#1:
    goto inline$IoSetNextIrpStackLocation$9$Return#1;

  inline$IoSetNextIrpStackLocation$9$Return#1:
    goto inline$storm_IoCallDriver$8$label_10$1#1;

  inline$storm_IoCallDriver$8$label_10$1#1:
    goto inline$storm_IoCallDriver$8$anon11_Then#1, inline$storm_IoCallDriver$8$anon11_Else#1;

  inline$storm_IoCallDriver$8$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$8$anon1#1;

  inline$storm_IoCallDriver$8$anon1#1:
    goto inline$storm_IoCallDriver$8$label_18#1;

  inline$storm_IoCallDriver$8$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$83$Entry#1;

  inline$IoGetCurrentIrpStackLocation$83$Entry#1:
    inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$83$start#1;

  inline$IoGetCurrentIrpStackLocation$83$start#1:
    inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$83$label_3#1;

  inline$IoGetCurrentIrpStackLocation$83$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$83$label_3_true#1, inline$IoGetCurrentIrpStackLocation$83$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$83$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$83$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$83$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$83$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$83$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$83$label_4#1;

  inline$IoGetCurrentIrpStackLocation$83$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$83$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$83$label_6#1;

  inline$IoGetCurrentIrpStackLocation$83$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$83$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$83$label_7#1;

  inline$IoGetCurrentIrpStackLocation$83$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$83$label_5#1;

  inline$IoGetCurrentIrpStackLocation$83$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$83$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$83$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$83$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$83$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$83$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$83$label_5#1;

  inline$IoGetCurrentIrpStackLocation$83$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$83$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$83$label_1#1;

  inline$IoGetCurrentIrpStackLocation$83$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$83$Return#1;

  inline$IoGetCurrentIrpStackLocation$83$Return#1:
    goto inline$storm_IoCallDriver$8$label_18$1#1;

  inline$storm_IoCallDriver$8$label_18$1#1:
    goto inline$storm_IoCallDriver$8$anon13_Then#1, inline$storm_IoCallDriver$8$anon13_Else#1;

  inline$storm_IoCallDriver$8$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$8$anon6#1;

  inline$storm_IoCallDriver$8$anon6#1:
    goto inline$storm_IoCallDriver$8$label_21#1;

  inline$storm_IoCallDriver$8$label_21#1:
    goto inline$storm_IoCallDriver$8$label_22#1;

  inline$storm_IoCallDriver$8$label_22#1:
    goto inline$storm_IoCallDriver$8$label_23#1;

  inline$storm_IoCallDriver$8$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$8$label_24#1;

  inline$storm_IoCallDriver$8$label_24#1:
    call inline$storm_IoCallDriver$8$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$8$label_27#1;

  inline$storm_IoCallDriver$8$label_27#1:
    goto inline$storm_IoCallDriver$8$label_27_case_0#1, inline$storm_IoCallDriver$8$label_27_case_1#1, inline$storm_IoCallDriver$8$label_27_case_2#1;

  inline$storm_IoCallDriver$8$label_27_case_2#1:
    assume inline$storm_IoCallDriver$8$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$8$label_30#1;

  inline$storm_IoCallDriver$8$label_30#1:
    inline$storm_IoCallDriver$8$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$8$label_31#1;

  inline$storm_IoCallDriver$8$label_31#1:
    goto inline$storm_IoCallDriver$8$label_32#1;

  inline$storm_IoCallDriver$8$label_32#1:
    goto inline$storm_IoCallDriver$8$label_33#1;

  inline$storm_IoCallDriver$8$label_33#1:
    goto inline$CallCompletionRoutine$16$Entry#1;

  inline$CallCompletionRoutine$16$Entry#1:
    inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$16$start#1;

  inline$CallCompletionRoutine$16$start#1:
    inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$16$label_3#1;

  inline$CallCompletionRoutine$16$label_3#1:
    goto inline$CallCompletionRoutine$16$label_4#1;

  inline$CallCompletionRoutine$16$label_4#1:
    goto inline$CallCompletionRoutine$16$label_5#1;

  inline$CallCompletionRoutine$16$label_5#1:
    goto inline$CallCompletionRoutine$16$label_6#1;

  inline$CallCompletionRoutine$16$label_6#1:
    goto inline$CallCompletionRoutine$16$label_7#1;

  inline$CallCompletionRoutine$16$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$84$Entry#1;

  inline$IoGetCurrentIrpStackLocation$84$Entry#1:
    inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$84$start#1;

  inline$IoGetCurrentIrpStackLocation$84$start#1:
    inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$84$label_3#1;

  inline$IoGetCurrentIrpStackLocation$84$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$84$label_3_true#1, inline$IoGetCurrentIrpStackLocation$84$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$84$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$84$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$84$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$84$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$84$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$84$label_4#1;

  inline$IoGetCurrentIrpStackLocation$84$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$84$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$84$label_6#1;

  inline$IoGetCurrentIrpStackLocation$84$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$84$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$84$label_7#1;

  inline$IoGetCurrentIrpStackLocation$84$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$84$label_5#1;

  inline$IoGetCurrentIrpStackLocation$84$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$84$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$84$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$84$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$84$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$84$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$84$label_5#1;

  inline$IoGetCurrentIrpStackLocation$84$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$84$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$84$label_1#1;

  inline$IoGetCurrentIrpStackLocation$84$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$84$Return#1;

  inline$IoGetCurrentIrpStackLocation$84$Return#1:
    goto inline$CallCompletionRoutine$16$label_7$1#1;

  inline$CallCompletionRoutine$16$label_7$1#1:
    goto inline$CallCompletionRoutine$16$anon10_Then#1, inline$CallCompletionRoutine$16$anon10_Else#1;

  inline$CallCompletionRoutine$16$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$16$anon1#1;

  inline$CallCompletionRoutine$16$anon1#1:
    goto inline$CallCompletionRoutine$16$label_10#1;

  inline$CallCompletionRoutine$16$label_10#1:
    goto inline$CallCompletionRoutine$16$label_11#1;

  inline$CallCompletionRoutine$16$label_11#1:
    havoc inline$CallCompletionRoutine$16$myNondetVar_0;
    inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$16$myNondetVar_0;
    goto inline$CallCompletionRoutine$16$label_12#1;

  inline$CallCompletionRoutine$16$label_12#1:
    havoc inline$CallCompletionRoutine$16$myNondetVar_0;
    inline$CallCompletionRoutine$16$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$16$myNondetVar_0;
    goto inline$CallCompletionRoutine$16$label_13#1;

  inline$CallCompletionRoutine$16$label_13#1:
    havoc inline$CallCompletionRoutine$16$myNondetVar_0;
    goto inline$CallCompletionRoutine$16$label_14#1;

  inline$CallCompletionRoutine$16$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$85$Entry#1;

  inline$IoGetCurrentIrpStackLocation$85$Entry#1:
    inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$85$start#1;

  inline$IoGetCurrentIrpStackLocation$85$start#1:
    inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$85$label_3#1;

  inline$IoGetCurrentIrpStackLocation$85$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$85$label_3_true#1, inline$IoGetCurrentIrpStackLocation$85$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$85$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$85$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$85$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$85$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$85$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$85$label_4#1;

  inline$IoGetCurrentIrpStackLocation$85$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$85$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$85$label_6#1;

  inline$IoGetCurrentIrpStackLocation$85$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$85$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$85$label_7#1;

  inline$IoGetCurrentIrpStackLocation$85$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$85$label_5#1;

  inline$IoGetCurrentIrpStackLocation$85$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$85$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$85$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$85$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$85$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$85$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$85$label_5#1;

  inline$IoGetCurrentIrpStackLocation$85$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$85$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$85$label_1#1;

  inline$IoGetCurrentIrpStackLocation$85$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$85$Return#1;

  inline$IoGetCurrentIrpStackLocation$85$Return#1:
    goto inline$CallCompletionRoutine$16$label_14$1#1;

  inline$CallCompletionRoutine$16$label_14$1#1:
    goto inline$CallCompletionRoutine$16$anon11_Then#1, inline$CallCompletionRoutine$16$anon11_Else#1;

  inline$CallCompletionRoutine$16$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$16$anon3#1;

  inline$CallCompletionRoutine$16$anon3#1:
    goto inline$CallCompletionRoutine$16$label_17#1;

  inline$CallCompletionRoutine$16$label_17#1:
    goto inline$CallCompletionRoutine$16$label_18#1;

  inline$CallCompletionRoutine$16$label_18#1:
    goto inline$CallCompletionRoutine$16$label_18_true#1, inline$CallCompletionRoutine$16$label_18_false#1;

  inline$CallCompletionRoutine$16$label_18_false#1:
    assume inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$16$label_1#1;

  inline$CallCompletionRoutine$16$label_18_true#1:
    assume inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$16$label_19#1;

  inline$CallCompletionRoutine$16$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$16$label_20#1;

  inline$CallCompletionRoutine$16$label_20#1:
    goto inline$CallCompletionRoutine$16$label_20_icall_1#1, inline$CallCompletionRoutine$16$label_20_icall_2#1, inline$CallCompletionRoutine$16$label_20_icall_3#1;

  inline$CallCompletionRoutine$16$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$16$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$16$Entry#1;

  inline$BDLSystemPowerIoCompletion$16$Entry#1:
    inline$BDLSystemPowerIoCompletion$16$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$16$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$16$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$16$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$16$start#1;

  inline$BDLSystemPowerIoCompletion$16$start#1:
    call inline$BDLSystemPowerIoCompletion$16$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$16$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$16$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$16$label_3#1;

  inline$BDLSystemPowerIoCompletion$16$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_4#1;

  inline$BDLSystemPowerIoCompletion$16$label_4#1:
    inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_5#1;

  inline$BDLSystemPowerIoCompletion$16$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_6#1;

  inline$BDLSystemPowerIoCompletion$16$label_6#1:
    inline$BDLSystemPowerIoCompletion$16$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$16$label_7#1;

  inline$BDLSystemPowerIoCompletion$16$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_8#1;

  inline$BDLSystemPowerIoCompletion$16$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$16$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$16$label_9#1;

  inline$BDLSystemPowerIoCompletion$16$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_10#1;

  inline$BDLSystemPowerIoCompletion$16$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$87$Entry#1;

  inline$IoGetCurrentIrpStackLocation$87$Entry#1:
    inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$87$start#1;

  inline$IoGetCurrentIrpStackLocation$87$start#1:
    inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$87$label_3#1;

  inline$IoGetCurrentIrpStackLocation$87$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$87$label_3_true#1, inline$IoGetCurrentIrpStackLocation$87$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$87$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$87$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$87$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$87$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$87$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$87$label_4#1;

  inline$IoGetCurrentIrpStackLocation$87$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$87$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$87$label_6#1;

  inline$IoGetCurrentIrpStackLocation$87$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$87$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$87$label_7#1;

  inline$IoGetCurrentIrpStackLocation$87$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$87$label_5#1;

  inline$IoGetCurrentIrpStackLocation$87$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$87$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$87$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$87$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$87$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$87$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$87$label_5#1;

  inline$IoGetCurrentIrpStackLocation$87$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$87$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$87$label_1#1;

  inline$IoGetCurrentIrpStackLocation$87$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$87$Return#1;

  inline$IoGetCurrentIrpStackLocation$87$Return#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon36_Then#1, inline$BDLSystemPowerIoCompletion$16$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon1#1;

  inline$BDLSystemPowerIoCompletion$16$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_13#1;

  inline$BDLSystemPowerIoCompletion$16$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_14#1;

  inline$BDLSystemPowerIoCompletion$16$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_15#1;

  inline$BDLSystemPowerIoCompletion$16$label_15#1:
    goto inline$BDLGetDebugLevel$439$Entry#1;

  inline$BDLGetDebugLevel$439$Entry#1:
    goto inline$BDLGetDebugLevel$439$start#1;

  inline$BDLGetDebugLevel$439$start#1:
    goto inline$BDLGetDebugLevel$439$label_3#1;

  inline$BDLGetDebugLevel$439$label_3#1:
    havoc inline$BDLGetDebugLevel$439$myNondetVar_0;
    inline$BDLGetDebugLevel$439$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$439$myNondetVar_0;
    goto inline$BDLGetDebugLevel$439$label_1#1;

  inline$BDLGetDebugLevel$439$label_1#1:
    goto inline$BDLGetDebugLevel$439$Return#1;

  inline$BDLGetDebugLevel$439$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$439$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon37_Then#1, inline$BDLSystemPowerIoCompletion$16$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon3#1;

  inline$BDLSystemPowerIoCompletion$16$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_18#1;

  inline$BDLSystemPowerIoCompletion$16$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_18_true#1, inline$BDLSystemPowerIoCompletion$16$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_19#1;

  inline$BDLSystemPowerIoCompletion$16$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_22#1;

  inline$BDLSystemPowerIoCompletion$16$label_22#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_23#1;

  inline$BDLSystemPowerIoCompletion$16$label_23#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_24#1;

  inline$BDLSystemPowerIoCompletion$16$label_24#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_25#1;

  inline$BDLSystemPowerIoCompletion$16$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$16$label_19#1;

  inline$BDLSystemPowerIoCompletion$16$label_19#1:
    goto inline$BDLGetDebugLevel$440$Entry#1;

  inline$BDLGetDebugLevel$440$Entry#1:
    goto inline$BDLGetDebugLevel$440$start#1;

  inline$BDLGetDebugLevel$440$start#1:
    goto inline$BDLGetDebugLevel$440$label_3#1;

  inline$BDLGetDebugLevel$440$label_3#1:
    havoc inline$BDLGetDebugLevel$440$myNondetVar_0;
    inline$BDLGetDebugLevel$440$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$440$myNondetVar_0;
    goto inline$BDLGetDebugLevel$440$label_1#1;

  inline$BDLGetDebugLevel$440$label_1#1:
    goto inline$BDLGetDebugLevel$440$Return#1;

  inline$BDLGetDebugLevel$440$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$440$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon38_Then#1, inline$BDLSystemPowerIoCompletion$16$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon5#1;

  inline$BDLSystemPowerIoCompletion$16$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_28#1;

  inline$BDLSystemPowerIoCompletion$16$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_28_true#1, inline$BDLSystemPowerIoCompletion$16$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_29#1;

  inline$BDLSystemPowerIoCompletion$16$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_32#1;

  inline$BDLSystemPowerIoCompletion$16$label_32#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_33#1;

  inline$BDLSystemPowerIoCompletion$16$label_33#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_34#1;

  inline$BDLSystemPowerIoCompletion$16$label_34#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_35#1;

  inline$BDLSystemPowerIoCompletion$16$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$16$label_29#1;

  inline$BDLSystemPowerIoCompletion$16$label_29#1:
    goto inline$BDLGetDebugLevel$441$Entry#1;

  inline$BDLGetDebugLevel$441$Entry#1:
    goto inline$BDLGetDebugLevel$441$start#1;

  inline$BDLGetDebugLevel$441$start#1:
    goto inline$BDLGetDebugLevel$441$label_3#1;

  inline$BDLGetDebugLevel$441$label_3#1:
    havoc inline$BDLGetDebugLevel$441$myNondetVar_0;
    inline$BDLGetDebugLevel$441$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$441$myNondetVar_0;
    goto inline$BDLGetDebugLevel$441$label_1#1;

  inline$BDLGetDebugLevel$441$label_1#1:
    goto inline$BDLGetDebugLevel$441$Return#1;

  inline$BDLGetDebugLevel$441$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$441$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon39_Then#1, inline$BDLSystemPowerIoCompletion$16$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon7#1;

  inline$BDLSystemPowerIoCompletion$16$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_38#1;

  inline$BDLSystemPowerIoCompletion$16$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_38_true#1, inline$BDLSystemPowerIoCompletion$16$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_39#1;

  inline$BDLSystemPowerIoCompletion$16$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_40#1;

  inline$BDLSystemPowerIoCompletion$16$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_39#1;

  inline$BDLSystemPowerIoCompletion$16$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_39_true#1, inline$BDLSystemPowerIoCompletion$16$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_41#1;

  inline$BDLSystemPowerIoCompletion$16$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$16$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$16$label_107#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$16$label_108#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$16$label_108#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$16$label_108#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$16$label_108#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$16$label_108#1;

  inline$BDLSystemPowerIoCompletion$16$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_109#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$16$label_107#1;

  inline$BDLSystemPowerIoCompletion$16$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_109#1;

  inline$BDLSystemPowerIoCompletion$16$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$16$label_106#1;

  inline$BDLSystemPowerIoCompletion$16$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_106_true#1, inline$BDLSystemPowerIoCompletion$16$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_142#1;

  inline$BDLSystemPowerIoCompletion$16$label_142#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_143#1;

  inline$BDLSystemPowerIoCompletion$16$label_143#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_144#1;

  inline$BDLSystemPowerIoCompletion$16$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_109#1;

  inline$BDLSystemPowerIoCompletion$16$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_109#1;

  inline$BDLSystemPowerIoCompletion$16$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$16$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$16$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$16$myNondetVar_0, inline$BDLSystemPowerIoCompletion$16$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$16$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$16$anon50_Then#1, inline$BDLSystemPowerIoCompletion$16$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon29#1;

  inline$BDLSystemPowerIoCompletion$16$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_112#1;

  inline$BDLSystemPowerIoCompletion$16$label_112#1:
    inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$16$label_113#1;

  inline$BDLSystemPowerIoCompletion$16$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_113_true#1, inline$BDLSystemPowerIoCompletion$16$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$16$label_114#1;

  inline$BDLSystemPowerIoCompletion$16$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_116#1;

  inline$BDLSystemPowerIoCompletion$16$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_117#1;

  inline$BDLSystemPowerIoCompletion$16$label_117#1:
    goto inline$BDLGetDebugLevel$448$Entry#1;

  inline$BDLGetDebugLevel$448$Entry#1:
    goto inline$BDLGetDebugLevel$448$start#1;

  inline$BDLGetDebugLevel$448$start#1:
    goto inline$BDLGetDebugLevel$448$label_3#1;

  inline$BDLGetDebugLevel$448$label_3#1:
    havoc inline$BDLGetDebugLevel$448$myNondetVar_0;
    inline$BDLGetDebugLevel$448$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$448$myNondetVar_0;
    goto inline$BDLGetDebugLevel$448$label_1#1;

  inline$BDLGetDebugLevel$448$label_1#1:
    goto inline$BDLGetDebugLevel$448$Return#1;

  inline$BDLGetDebugLevel$448$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$448$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon51_Then#1, inline$BDLSystemPowerIoCompletion$16$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon31#1;

  inline$BDLSystemPowerIoCompletion$16$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_120#1;

  inline$BDLSystemPowerIoCompletion$16$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_120_true#1, inline$BDLSystemPowerIoCompletion$16$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_121#1;

  inline$BDLSystemPowerIoCompletion$16$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_124#1;

  inline$BDLSystemPowerIoCompletion$16$label_124#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_125#1;

  inline$BDLSystemPowerIoCompletion$16$label_125#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_126#1;

  inline$BDLSystemPowerIoCompletion$16$label_126#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_127#1;

  inline$BDLSystemPowerIoCompletion$16$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$16$label_121#1;

  inline$BDLSystemPowerIoCompletion$16$label_121#1:
    goto inline$BDLGetDebugLevel$449$Entry#1;

  inline$BDLGetDebugLevel$449$Entry#1:
    goto inline$BDLGetDebugLevel$449$start#1;

  inline$BDLGetDebugLevel$449$start#1:
    goto inline$BDLGetDebugLevel$449$label_3#1;

  inline$BDLGetDebugLevel$449$label_3#1:
    havoc inline$BDLGetDebugLevel$449$myNondetVar_0;
    inline$BDLGetDebugLevel$449$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$449$myNondetVar_0;
    goto inline$BDLGetDebugLevel$449$label_1#1;

  inline$BDLGetDebugLevel$449$label_1#1:
    goto inline$BDLGetDebugLevel$449$Return#1;

  inline$BDLGetDebugLevel$449$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$449$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon52_Then#1, inline$BDLSystemPowerIoCompletion$16$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon33#1;

  inline$BDLSystemPowerIoCompletion$16$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_130#1;

  inline$BDLSystemPowerIoCompletion$16$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_130_true#1, inline$BDLSystemPowerIoCompletion$16$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_131#1;

  inline$BDLSystemPowerIoCompletion$16$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_134#1;

  inline$BDLSystemPowerIoCompletion$16$label_134#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_135#1;

  inline$BDLSystemPowerIoCompletion$16$label_135#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_136#1;

  inline$BDLSystemPowerIoCompletion$16$label_136#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_137#1;

  inline$BDLSystemPowerIoCompletion$16$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$16$label_131#1;

  inline$BDLSystemPowerIoCompletion$16$label_131#1:
    goto inline$BDLGetDebugLevel$450$Entry#1;

  inline$BDLGetDebugLevel$450$Entry#1:
    goto inline$BDLGetDebugLevel$450$start#1;

  inline$BDLGetDebugLevel$450$start#1:
    goto inline$BDLGetDebugLevel$450$label_3#1;

  inline$BDLGetDebugLevel$450$label_3#1:
    havoc inline$BDLGetDebugLevel$450$myNondetVar_0;
    inline$BDLGetDebugLevel$450$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$450$myNondetVar_0;
    goto inline$BDLGetDebugLevel$450$label_1#1;

  inline$BDLGetDebugLevel$450$label_1#1:
    goto inline$BDLGetDebugLevel$450$Return#1;

  inline$BDLGetDebugLevel$450$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$450$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon53_Then#1, inline$BDLSystemPowerIoCompletion$16$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon35#1;

  inline$BDLSystemPowerIoCompletion$16$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_140#1;

  inline$BDLSystemPowerIoCompletion$16$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_140_true#1, inline$BDLSystemPowerIoCompletion$16$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_67#1;

  inline$BDLSystemPowerIoCompletion$16$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_141#1;

  inline$BDLSystemPowerIoCompletion$16$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_67#1;

  inline$BDLSystemPowerIoCompletion$16$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$16$label_115#1;

  inline$BDLSystemPowerIoCompletion$16$label_115#1:
    inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$16$label_80#1;

  inline$BDLSystemPowerIoCompletion$16$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$16$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_42#1;

  inline$BDLSystemPowerIoCompletion$16$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$16$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$16$label_43#1;

  inline$BDLSystemPowerIoCompletion$16$label_43#1:
    goto inline$BDLGetDebugLevel$442$Entry#1;

  inline$BDLGetDebugLevel$442$Entry#1:
    goto inline$BDLGetDebugLevel$442$start#1;

  inline$BDLGetDebugLevel$442$start#1:
    goto inline$BDLGetDebugLevel$442$label_3#1;

  inline$BDLGetDebugLevel$442$label_3#1:
    havoc inline$BDLGetDebugLevel$442$myNondetVar_0;
    inline$BDLGetDebugLevel$442$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$442$myNondetVar_0;
    goto inline$BDLGetDebugLevel$442$label_1#1;

  inline$BDLGetDebugLevel$442$label_1#1:
    goto inline$BDLGetDebugLevel$442$Return#1;

  inline$BDLGetDebugLevel$442$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$442$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon40_Then#1, inline$BDLSystemPowerIoCompletion$16$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon9#1;

  inline$BDLSystemPowerIoCompletion$16$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_46#1;

  inline$BDLSystemPowerIoCompletion$16$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_46_true#1, inline$BDLSystemPowerIoCompletion$16$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_47#1;

  inline$BDLSystemPowerIoCompletion$16$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_50#1;

  inline$BDLSystemPowerIoCompletion$16$label_50#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_51#1;

  inline$BDLSystemPowerIoCompletion$16$label_51#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_52#1;

  inline$BDLSystemPowerIoCompletion$16$label_52#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_53#1;

  inline$BDLSystemPowerIoCompletion$16$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$16$label_47#1;

  inline$BDLSystemPowerIoCompletion$16$label_47#1:
    goto inline$BDLGetDebugLevel$443$Entry#1;

  inline$BDLGetDebugLevel$443$Entry#1:
    goto inline$BDLGetDebugLevel$443$start#1;

  inline$BDLGetDebugLevel$443$start#1:
    goto inline$BDLGetDebugLevel$443$label_3#1;

  inline$BDLGetDebugLevel$443$label_3#1:
    havoc inline$BDLGetDebugLevel$443$myNondetVar_0;
    inline$BDLGetDebugLevel$443$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$443$myNondetVar_0;
    goto inline$BDLGetDebugLevel$443$label_1#1;

  inline$BDLGetDebugLevel$443$label_1#1:
    goto inline$BDLGetDebugLevel$443$Return#1;

  inline$BDLGetDebugLevel$443$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$443$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon41_Then#1, inline$BDLSystemPowerIoCompletion$16$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon11#1;

  inline$BDLSystemPowerIoCompletion$16$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_56#1;

  inline$BDLSystemPowerIoCompletion$16$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_56_true#1, inline$BDLSystemPowerIoCompletion$16$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_57#1;

  inline$BDLSystemPowerIoCompletion$16$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_60#1;

  inline$BDLSystemPowerIoCompletion$16$label_60#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_61#1;

  inline$BDLSystemPowerIoCompletion$16$label_61#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_62#1;

  inline$BDLSystemPowerIoCompletion$16$label_62#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_63#1;

  inline$BDLSystemPowerIoCompletion$16$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$16$label_57#1;

  inline$BDLSystemPowerIoCompletion$16$label_57#1:
    goto inline$BDLGetDebugLevel$444$Entry#1;

  inline$BDLGetDebugLevel$444$Entry#1:
    goto inline$BDLGetDebugLevel$444$start#1;

  inline$BDLGetDebugLevel$444$start#1:
    goto inline$BDLGetDebugLevel$444$label_3#1;

  inline$BDLGetDebugLevel$444$label_3#1:
    havoc inline$BDLGetDebugLevel$444$myNondetVar_0;
    inline$BDLGetDebugLevel$444$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$444$myNondetVar_0;
    goto inline$BDLGetDebugLevel$444$label_1#1;

  inline$BDLGetDebugLevel$444$label_1#1:
    goto inline$BDLGetDebugLevel$444$Return#1;

  inline$BDLGetDebugLevel$444$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$444$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon42_Then#1, inline$BDLSystemPowerIoCompletion$16$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon13#1;

  inline$BDLSystemPowerIoCompletion$16$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_66#1;

  inline$BDLSystemPowerIoCompletion$16$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_66_true#1, inline$BDLSystemPowerIoCompletion$16$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_67#1;

  inline$BDLSystemPowerIoCompletion$16$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_70#1;

  inline$BDLSystemPowerIoCompletion$16$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_67#1;

  inline$BDLSystemPowerIoCompletion$16$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$16$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$16$anon43_Then#1, inline$BDLSystemPowerIoCompletion$16$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon15#1;

  inline$BDLSystemPowerIoCompletion$16$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_71#1;

  inline$BDLSystemPowerIoCompletion$16$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$16$anon44_Then#1, inline$BDLSystemPowerIoCompletion$16$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon17#1;

  inline$BDLSystemPowerIoCompletion$16$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_74#1;

  inline$BDLSystemPowerIoCompletion$16$label_74#1:
    goto inline$storm_IoCompleteRequest$34$Entry#1;

  inline$storm_IoCompleteRequest$34$Entry#1:
    inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$16$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$34$start#1;

  inline$storm_IoCompleteRequest$34$start#1:
    inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$34$label_3#1;

  inline$storm_IoCompleteRequest$34$label_3#1:
    call inline$storm_IoCompleteRequest$34$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$34$label_6#1;

  inline$storm_IoCompleteRequest$34$label_6#1:
    goto inline$storm_IoCompleteRequest$34$label_6_true#1, inline$storm_IoCompleteRequest$34$label_6_false#1;

  inline$storm_IoCompleteRequest$34$label_6_false#1:
    assume inline$storm_IoCompleteRequest$34$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$34$label_7#1;

  inline$storm_IoCompleteRequest$34$label_6_true#1:
    assume inline$storm_IoCompleteRequest$34$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$34$label_8#1;

  inline$storm_IoCompleteRequest$34$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$34$anon3_Then#1, inline$storm_IoCompleteRequest$34$anon3_Else#1;

  inline$storm_IoCompleteRequest$34$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$34$anon1#1;

  inline$storm_IoCompleteRequest$34$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$34$label_9#1;

  inline$storm_IoCompleteRequest$34$label_9#1:
    goto inline$storm_IoCompleteRequest$34$label_9_true#1, inline$storm_IoCompleteRequest$34$label_9_false#1;

  inline$storm_IoCompleteRequest$34$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$34$label_10#1;

  inline$storm_IoCompleteRequest$34$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$34$label_1#1;

  inline$storm_IoCompleteRequest$34$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$34$label_7#1;

  inline$storm_IoCompleteRequest$34$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$34$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$34$label_1#1;

  inline$storm_IoCompleteRequest$34$label_1#1:
    goto inline$storm_IoCompleteRequest$34$Return#1;

  inline$storm_IoCompleteRequest$34$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$34$Return#1;

  inline$storm_IoCompleteRequest$34$Return#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon45_Then#1, inline$BDLSystemPowerIoCompletion$16$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon19#1;

  inline$BDLSystemPowerIoCompletion$16$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_77#1;

  inline$BDLSystemPowerIoCompletion$16$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$16$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$16$anon46_Then#1, inline$BDLSystemPowerIoCompletion$16$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon21#1;

  inline$BDLSystemPowerIoCompletion$16$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_80#1;

  inline$BDLSystemPowerIoCompletion$16$label_80#1:
    goto inline$BDLGetDebugLevel$445$Entry#1;

  inline$BDLGetDebugLevel$445$Entry#1:
    goto inline$BDLGetDebugLevel$445$start#1;

  inline$BDLGetDebugLevel$445$start#1:
    goto inline$BDLGetDebugLevel$445$label_3#1;

  inline$BDLGetDebugLevel$445$label_3#1:
    havoc inline$BDLGetDebugLevel$445$myNondetVar_0;
    inline$BDLGetDebugLevel$445$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$445$myNondetVar_0;
    goto inline$BDLGetDebugLevel$445$label_1#1;

  inline$BDLGetDebugLevel$445$label_1#1:
    goto inline$BDLGetDebugLevel$445$Return#1;

  inline$BDLGetDebugLevel$445$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$445$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon47_Then#1, inline$BDLSystemPowerIoCompletion$16$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon23#1;

  inline$BDLSystemPowerIoCompletion$16$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_83#1;

  inline$BDLSystemPowerIoCompletion$16$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_83_true#1, inline$BDLSystemPowerIoCompletion$16$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_84#1;

  inline$BDLSystemPowerIoCompletion$16$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_87#1;

  inline$BDLSystemPowerIoCompletion$16$label_87#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_88#1;

  inline$BDLSystemPowerIoCompletion$16$label_88#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_89#1;

  inline$BDLSystemPowerIoCompletion$16$label_89#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_90#1;

  inline$BDLSystemPowerIoCompletion$16$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$16$label_84#1;

  inline$BDLSystemPowerIoCompletion$16$label_84#1:
    goto inline$BDLGetDebugLevel$446$Entry#1;

  inline$BDLGetDebugLevel$446$Entry#1:
    goto inline$BDLGetDebugLevel$446$start#1;

  inline$BDLGetDebugLevel$446$start#1:
    goto inline$BDLGetDebugLevel$446$label_3#1;

  inline$BDLGetDebugLevel$446$label_3#1:
    havoc inline$BDLGetDebugLevel$446$myNondetVar_0;
    inline$BDLGetDebugLevel$446$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$446$myNondetVar_0;
    goto inline$BDLGetDebugLevel$446$label_1#1;

  inline$BDLGetDebugLevel$446$label_1#1:
    goto inline$BDLGetDebugLevel$446$Return#1;

  inline$BDLGetDebugLevel$446$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$446$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon48_Then#1, inline$BDLSystemPowerIoCompletion$16$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon25#1;

  inline$BDLSystemPowerIoCompletion$16$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_93#1;

  inline$BDLSystemPowerIoCompletion$16$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_93_true#1, inline$BDLSystemPowerIoCompletion$16$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_94#1;

  inline$BDLSystemPowerIoCompletion$16$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_97#1;

  inline$BDLSystemPowerIoCompletion$16$label_97#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_98#1;

  inline$BDLSystemPowerIoCompletion$16$label_98#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_99#1;

  inline$BDLSystemPowerIoCompletion$16$label_99#1:
    call inline$BDLSystemPowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$16$label_100#1;

  inline$BDLSystemPowerIoCompletion$16$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$16$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$16$label_94#1;

  inline$BDLSystemPowerIoCompletion$16$label_94#1:
    goto inline$BDLGetDebugLevel$447$Entry#1;

  inline$BDLGetDebugLevel$447$Entry#1:
    goto inline$BDLGetDebugLevel$447$start#1;

  inline$BDLGetDebugLevel$447$start#1:
    goto inline$BDLGetDebugLevel$447$label_3#1;

  inline$BDLGetDebugLevel$447$label_3#1:
    havoc inline$BDLGetDebugLevel$447$myNondetVar_0;
    inline$BDLGetDebugLevel$447$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$447$myNondetVar_0;
    goto inline$BDLGetDebugLevel$447$label_1#1;

  inline$BDLGetDebugLevel$447$label_1#1:
    goto inline$BDLGetDebugLevel$447$Return#1;

  inline$BDLGetDebugLevel$447$Return#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$447$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$16$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$16$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$16$anon49_Then#1, inline$BDLSystemPowerIoCompletion$16$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$16$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$anon27#1;

  inline$BDLSystemPowerIoCompletion$16$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_103#1;

  inline$BDLSystemPowerIoCompletion$16$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_103_true#1, inline$BDLSystemPowerIoCompletion$16$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$16$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_104#1;

  inline$BDLSystemPowerIoCompletion$16$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$16$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$16$label_105#1;

  inline$BDLSystemPowerIoCompletion$16$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$16$label_104#1;

  inline$BDLSystemPowerIoCompletion$16$label_104#1:
    inline$BDLSystemPowerIoCompletion$16$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$16$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$16$label_1#1;

  inline$BDLSystemPowerIoCompletion$16$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$16$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$16$Return#1;

  inline$BDLSystemPowerIoCompletion$16$Return#1:
    inline$CallCompletionRoutine$16$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$16$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$16$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$16$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$16$anon14_Then#1, inline$CallCompletionRoutine$16$anon14_Else#1;

  inline$CallCompletionRoutine$16$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$16$anon9#1;

  inline$CallCompletionRoutine$16$anon9#1:
    goto inline$CallCompletionRoutine$16$label_20_icall_return#1;

  inline$CallCompletionRoutine$16$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$16$Return#1;

  inline$CallCompletionRoutine$16$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$16$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$16$Entry#1;

  inline$BDLDevicePowerIoCompletion$16$Entry#1:
    inline$BDLDevicePowerIoCompletion$16$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$16$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$16$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$16$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$16$start#1;

  inline$BDLDevicePowerIoCompletion$16$start#1:
    call inline$BDLDevicePowerIoCompletion$16$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$16$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$16$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$16$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$16$label_3#1;

  inline$BDLDevicePowerIoCompletion$16$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_4#1;

  inline$BDLDevicePowerIoCompletion$16$label_4#1:
    inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_5#1;

  inline$BDLDevicePowerIoCompletion$16$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_6#1;

  inline$BDLDevicePowerIoCompletion$16$label_6#1:
    inline$BDLDevicePowerIoCompletion$16$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$16$label_7#1;

  inline$BDLDevicePowerIoCompletion$16$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_8#1;

  inline$BDLDevicePowerIoCompletion$16$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$16$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$16$label_9#1;

  inline$BDLDevicePowerIoCompletion$16$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_10#1;

  inline$BDLDevicePowerIoCompletion$16$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$86$Entry#1;

  inline$IoGetCurrentIrpStackLocation$86$Entry#1:
    inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$86$start#1;

  inline$IoGetCurrentIrpStackLocation$86$start#1:
    inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$86$label_3#1;

  inline$IoGetCurrentIrpStackLocation$86$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$86$label_3_true#1, inline$IoGetCurrentIrpStackLocation$86$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$86$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$86$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$86$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$86$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$86$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$86$label_4#1;

  inline$IoGetCurrentIrpStackLocation$86$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$86$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$86$label_6#1;

  inline$IoGetCurrentIrpStackLocation$86$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$86$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$86$label_7#1;

  inline$IoGetCurrentIrpStackLocation$86$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$86$label_5#1;

  inline$IoGetCurrentIrpStackLocation$86$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$86$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$86$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$86$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$86$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$86$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$86$label_5#1;

  inline$IoGetCurrentIrpStackLocation$86$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$86$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$86$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$86$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$86$label_1#1;

  inline$IoGetCurrentIrpStackLocation$86$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$86$Return#1;

  inline$IoGetCurrentIrpStackLocation$86$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$86$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon30_Then#1, inline$BDLDevicePowerIoCompletion$16$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon1#1;

  inline$BDLDevicePowerIoCompletion$16$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_13#1;

  inline$BDLDevicePowerIoCompletion$16$label_13#1:
    inline$BDLDevicePowerIoCompletion$16$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$16$label_14#1;

  inline$BDLDevicePowerIoCompletion$16$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_15#1;

  inline$BDLDevicePowerIoCompletion$16$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$16$label_16#1;

  inline$BDLDevicePowerIoCompletion$16$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_17#1;

  inline$BDLDevicePowerIoCompletion$16$label_17#1:
    goto inline$BDLGetDebugLevel$430$Entry#1;

  inline$BDLGetDebugLevel$430$Entry#1:
    goto inline$BDLGetDebugLevel$430$start#1;

  inline$BDLGetDebugLevel$430$start#1:
    goto inline$BDLGetDebugLevel$430$label_3#1;

  inline$BDLGetDebugLevel$430$label_3#1:
    havoc inline$BDLGetDebugLevel$430$myNondetVar_0;
    inline$BDLGetDebugLevel$430$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$430$myNondetVar_0;
    goto inline$BDLGetDebugLevel$430$label_1#1;

  inline$BDLGetDebugLevel$430$label_1#1:
    goto inline$BDLGetDebugLevel$430$Return#1;

  inline$BDLGetDebugLevel$430$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$430$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon31_Then#1, inline$BDLDevicePowerIoCompletion$16$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon3#1;

  inline$BDLDevicePowerIoCompletion$16$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_20#1;

  inline$BDLDevicePowerIoCompletion$16$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_20_true#1, inline$BDLDevicePowerIoCompletion$16$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_21#1;

  inline$BDLDevicePowerIoCompletion$16$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_24#1;

  inline$BDLDevicePowerIoCompletion$16$label_24#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_25#1;

  inline$BDLDevicePowerIoCompletion$16$label_25#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_26#1;

  inline$BDLDevicePowerIoCompletion$16$label_26#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_27#1;

  inline$BDLDevicePowerIoCompletion$16$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$16$label_21#1;

  inline$BDLDevicePowerIoCompletion$16$label_21#1:
    goto inline$BDLGetDebugLevel$431$Entry#1;

  inline$BDLGetDebugLevel$431$Entry#1:
    goto inline$BDLGetDebugLevel$431$start#1;

  inline$BDLGetDebugLevel$431$start#1:
    goto inline$BDLGetDebugLevel$431$label_3#1;

  inline$BDLGetDebugLevel$431$label_3#1:
    havoc inline$BDLGetDebugLevel$431$myNondetVar_0;
    inline$BDLGetDebugLevel$431$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$431$myNondetVar_0;
    goto inline$BDLGetDebugLevel$431$label_1#1;

  inline$BDLGetDebugLevel$431$label_1#1:
    goto inline$BDLGetDebugLevel$431$Return#1;

  inline$BDLGetDebugLevel$431$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$431$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon32_Then#1, inline$BDLDevicePowerIoCompletion$16$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon5#1;

  inline$BDLDevicePowerIoCompletion$16$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_30#1;

  inline$BDLDevicePowerIoCompletion$16$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_30_true#1, inline$BDLDevicePowerIoCompletion$16$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_31#1;

  inline$BDLDevicePowerIoCompletion$16$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_34#1;

  inline$BDLDevicePowerIoCompletion$16$label_34#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_35#1;

  inline$BDLDevicePowerIoCompletion$16$label_35#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_36#1;

  inline$BDLDevicePowerIoCompletion$16$label_36#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_37#1;

  inline$BDLDevicePowerIoCompletion$16$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$16$label_31#1;

  inline$BDLDevicePowerIoCompletion$16$label_31#1:
    goto inline$BDLGetDebugLevel$432$Entry#1;

  inline$BDLGetDebugLevel$432$Entry#1:
    goto inline$BDLGetDebugLevel$432$start#1;

  inline$BDLGetDebugLevel$432$start#1:
    goto inline$BDLGetDebugLevel$432$label_3#1;

  inline$BDLGetDebugLevel$432$label_3#1:
    havoc inline$BDLGetDebugLevel$432$myNondetVar_0;
    inline$BDLGetDebugLevel$432$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$432$myNondetVar_0;
    goto inline$BDLGetDebugLevel$432$label_1#1;

  inline$BDLGetDebugLevel$432$label_1#1:
    goto inline$BDLGetDebugLevel$432$Return#1;

  inline$BDLGetDebugLevel$432$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$432$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon33_Then#1, inline$BDLDevicePowerIoCompletion$16$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon7#1;

  inline$BDLDevicePowerIoCompletion$16$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_40#1;

  inline$BDLDevicePowerIoCompletion$16$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_40_true#1, inline$BDLDevicePowerIoCompletion$16$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_41#1;

  inline$BDLDevicePowerIoCompletion$16$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_42#1;

  inline$BDLDevicePowerIoCompletion$16$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_41#1;

  inline$BDLDevicePowerIoCompletion$16$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_41_true#1, inline$BDLDevicePowerIoCompletion$16$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$16$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$16$label_43#1;

  inline$BDLDevicePowerIoCompletion$16$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$16$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$16$label_44#1;

  inline$BDLDevicePowerIoCompletion$16$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_44_true#1, inline$BDLDevicePowerIoCompletion$16$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$16$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$16$label_45#1;

  inline$BDLDevicePowerIoCompletion$16$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_45_true#1, inline$BDLDevicePowerIoCompletion$16$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$16$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$16$label_43#1;

  inline$BDLDevicePowerIoCompletion$16$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$16$label_86#1;

  inline$BDLDevicePowerIoCompletion$16$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$16$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$16$label_46#1;

  inline$BDLDevicePowerIoCompletion$16$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$16$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$16$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$16$label_46#1;

  inline$BDLDevicePowerIoCompletion$16$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$16$label_49#1;

  inline$BDLDevicePowerIoCompletion$16$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_50#1;

  inline$BDLDevicePowerIoCompletion$16$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_51#1;

  inline$BDLDevicePowerIoCompletion$16$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_54#1;

  inline$BDLDevicePowerIoCompletion$16$label_54#1:
    inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$16$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$16$label_55#1;

  inline$BDLDevicePowerIoCompletion$16$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_55_true#1, inline$BDLDevicePowerIoCompletion$16$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_56#1;

  inline$BDLDevicePowerIoCompletion$16$label_56#1:
    call inline$BDLDevicePowerIoCompletion$16$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$16$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$16$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$16$anon34_Then#1, inline$BDLDevicePowerIoCompletion$16$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon9#1;

  inline$BDLDevicePowerIoCompletion$16$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_83#1;

  inline$BDLDevicePowerIoCompletion$16$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_59#1;

  inline$BDLDevicePowerIoCompletion$16$label_59#1:
    goto inline$BDLGetDebugLevel$433$Entry#1;

  inline$BDLGetDebugLevel$433$Entry#1:
    goto inline$BDLGetDebugLevel$433$start#1;

  inline$BDLGetDebugLevel$433$start#1:
    goto inline$BDLGetDebugLevel$433$label_3#1;

  inline$BDLGetDebugLevel$433$label_3#1:
    havoc inline$BDLGetDebugLevel$433$myNondetVar_0;
    inline$BDLGetDebugLevel$433$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$433$myNondetVar_0;
    goto inline$BDLGetDebugLevel$433$label_1#1;

  inline$BDLGetDebugLevel$433$label_1#1:
    goto inline$BDLGetDebugLevel$433$Return#1;

  inline$BDLGetDebugLevel$433$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$433$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon35_Then#1, inline$BDLDevicePowerIoCompletion$16$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon11#1;

  inline$BDLDevicePowerIoCompletion$16$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_62#1;

  inline$BDLDevicePowerIoCompletion$16$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_62_true#1, inline$BDLDevicePowerIoCompletion$16$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_63#1;

  inline$BDLDevicePowerIoCompletion$16$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_66#1;

  inline$BDLDevicePowerIoCompletion$16$label_66#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_67#1;

  inline$BDLDevicePowerIoCompletion$16$label_67#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_68#1;

  inline$BDLDevicePowerIoCompletion$16$label_68#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_69#1;

  inline$BDLDevicePowerIoCompletion$16$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$16$label_63#1;

  inline$BDLDevicePowerIoCompletion$16$label_63#1:
    goto inline$BDLGetDebugLevel$434$Entry#1;

  inline$BDLGetDebugLevel$434$Entry#1:
    goto inline$BDLGetDebugLevel$434$start#1;

  inline$BDLGetDebugLevel$434$start#1:
    goto inline$BDLGetDebugLevel$434$label_3#1;

  inline$BDLGetDebugLevel$434$label_3#1:
    havoc inline$BDLGetDebugLevel$434$myNondetVar_0;
    inline$BDLGetDebugLevel$434$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$434$myNondetVar_0;
    goto inline$BDLGetDebugLevel$434$label_1#1;

  inline$BDLGetDebugLevel$434$label_1#1:
    goto inline$BDLGetDebugLevel$434$Return#1;

  inline$BDLGetDebugLevel$434$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$434$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon36_Then#1, inline$BDLDevicePowerIoCompletion$16$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon13#1;

  inline$BDLDevicePowerIoCompletion$16$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_72#1;

  inline$BDLDevicePowerIoCompletion$16$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_72_true#1, inline$BDLDevicePowerIoCompletion$16$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_73#1;

  inline$BDLDevicePowerIoCompletion$16$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_76#1;

  inline$BDLDevicePowerIoCompletion$16$label_76#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_77#1;

  inline$BDLDevicePowerIoCompletion$16$label_77#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_78#1;

  inline$BDLDevicePowerIoCompletion$16$label_78#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_79#1;

  inline$BDLDevicePowerIoCompletion$16$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$16$label_73#1;

  inline$BDLDevicePowerIoCompletion$16$label_73#1:
    goto inline$BDLGetDebugLevel$435$Entry#1;

  inline$BDLGetDebugLevel$435$Entry#1:
    goto inline$BDLGetDebugLevel$435$start#1;

  inline$BDLGetDebugLevel$435$start#1:
    goto inline$BDLGetDebugLevel$435$label_3#1;

  inline$BDLGetDebugLevel$435$label_3#1:
    havoc inline$BDLGetDebugLevel$435$myNondetVar_0;
    inline$BDLGetDebugLevel$435$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$435$myNondetVar_0;
    goto inline$BDLGetDebugLevel$435$label_1#1;

  inline$BDLGetDebugLevel$435$label_1#1:
    goto inline$BDLGetDebugLevel$435$Return#1;

  inline$BDLGetDebugLevel$435$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$435$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon37_Then#1, inline$BDLDevicePowerIoCompletion$16$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon15#1;

  inline$BDLDevicePowerIoCompletion$16$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_82#1;

  inline$BDLDevicePowerIoCompletion$16$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_82_true#1, inline$BDLDevicePowerIoCompletion$16$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_83#1;

  inline$BDLDevicePowerIoCompletion$16$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_84#1;

  inline$BDLDevicePowerIoCompletion$16$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_83#1;

  inline$BDLDevicePowerIoCompletion$16$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_85#1;

  inline$BDLDevicePowerIoCompletion$16$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_86#1;

  inline$BDLDevicePowerIoCompletion$16$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$16$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$16$anon38_Then#1, inline$BDLDevicePowerIoCompletion$16$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon17#1;

  inline$BDLDevicePowerIoCompletion$16$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_89#1;

  inline$BDLDevicePowerIoCompletion$16$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$16$anon39_Then#1, inline$BDLDevicePowerIoCompletion$16$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon19#1;

  inline$BDLDevicePowerIoCompletion$16$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_92#1;

  inline$BDLDevicePowerIoCompletion$16$label_92#1:
    goto inline$storm_IoCompleteRequest$33$Entry#1;

  inline$storm_IoCompleteRequest$33$Entry#1:
    inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$16$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$33$start#1;

  inline$storm_IoCompleteRequest$33$start#1:
    inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$33$label_3#1;

  inline$storm_IoCompleteRequest$33$label_3#1:
    call inline$storm_IoCompleteRequest$33$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$33$label_6#1;

  inline$storm_IoCompleteRequest$33$label_6#1:
    goto inline$storm_IoCompleteRequest$33$label_6_true#1, inline$storm_IoCompleteRequest$33$label_6_false#1;

  inline$storm_IoCompleteRequest$33$label_6_false#1:
    assume inline$storm_IoCompleteRequest$33$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$33$label_7#1;

  inline$storm_IoCompleteRequest$33$label_6_true#1:
    assume inline$storm_IoCompleteRequest$33$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$33$label_8#1;

  inline$storm_IoCompleteRequest$33$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$33$anon3_Then#1, inline$storm_IoCompleteRequest$33$anon3_Else#1;

  inline$storm_IoCompleteRequest$33$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$33$anon1#1;

  inline$storm_IoCompleteRequest$33$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$33$label_9#1;

  inline$storm_IoCompleteRequest$33$label_9#1:
    goto inline$storm_IoCompleteRequest$33$label_9_true#1, inline$storm_IoCompleteRequest$33$label_9_false#1;

  inline$storm_IoCompleteRequest$33$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$33$label_10#1;

  inline$storm_IoCompleteRequest$33$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$33$label_1#1;

  inline$storm_IoCompleteRequest$33$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$33$label_7#1;

  inline$storm_IoCompleteRequest$33$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$33$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$33$label_1#1;

  inline$storm_IoCompleteRequest$33$label_1#1:
    goto inline$storm_IoCompleteRequest$33$Return#1;

  inline$storm_IoCompleteRequest$33$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$33$Return#1;

  inline$storm_IoCompleteRequest$33$Return#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon40_Then#1, inline$BDLDevicePowerIoCompletion$16$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon21#1;

  inline$BDLDevicePowerIoCompletion$16$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_95#1;

  inline$BDLDevicePowerIoCompletion$16$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$16$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$16$anon41_Then#1, inline$BDLDevicePowerIoCompletion$16$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon23#1;

  inline$BDLDevicePowerIoCompletion$16$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_98#1;

  inline$BDLDevicePowerIoCompletion$16$label_98#1:
    goto inline$BDLGetDebugLevel$436$Entry#1;

  inline$BDLGetDebugLevel$436$Entry#1:
    goto inline$BDLGetDebugLevel$436$start#1;

  inline$BDLGetDebugLevel$436$start#1:
    goto inline$BDLGetDebugLevel$436$label_3#1;

  inline$BDLGetDebugLevel$436$label_3#1:
    havoc inline$BDLGetDebugLevel$436$myNondetVar_0;
    inline$BDLGetDebugLevel$436$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$436$myNondetVar_0;
    goto inline$BDLGetDebugLevel$436$label_1#1;

  inline$BDLGetDebugLevel$436$label_1#1:
    goto inline$BDLGetDebugLevel$436$Return#1;

  inline$BDLGetDebugLevel$436$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$436$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon42_Then#1, inline$BDLDevicePowerIoCompletion$16$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon25#1;

  inline$BDLDevicePowerIoCompletion$16$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_101#1;

  inline$BDLDevicePowerIoCompletion$16$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_101_true#1, inline$BDLDevicePowerIoCompletion$16$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_102#1;

  inline$BDLDevicePowerIoCompletion$16$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_105#1;

  inline$BDLDevicePowerIoCompletion$16$label_105#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_106#1;

  inline$BDLDevicePowerIoCompletion$16$label_106#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_107#1;

  inline$BDLDevicePowerIoCompletion$16$label_107#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_108#1;

  inline$BDLDevicePowerIoCompletion$16$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$16$label_102#1;

  inline$BDLDevicePowerIoCompletion$16$label_102#1:
    goto inline$BDLGetDebugLevel$437$Entry#1;

  inline$BDLGetDebugLevel$437$Entry#1:
    goto inline$BDLGetDebugLevel$437$start#1;

  inline$BDLGetDebugLevel$437$start#1:
    goto inline$BDLGetDebugLevel$437$label_3#1;

  inline$BDLGetDebugLevel$437$label_3#1:
    havoc inline$BDLGetDebugLevel$437$myNondetVar_0;
    inline$BDLGetDebugLevel$437$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$437$myNondetVar_0;
    goto inline$BDLGetDebugLevel$437$label_1#1;

  inline$BDLGetDebugLevel$437$label_1#1:
    goto inline$BDLGetDebugLevel$437$Return#1;

  inline$BDLGetDebugLevel$437$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$437$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon43_Then#1, inline$BDLDevicePowerIoCompletion$16$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon27#1;

  inline$BDLDevicePowerIoCompletion$16$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_111#1;

  inline$BDLDevicePowerIoCompletion$16$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_111_true#1, inline$BDLDevicePowerIoCompletion$16$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_112#1;

  inline$BDLDevicePowerIoCompletion$16$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_115#1;

  inline$BDLDevicePowerIoCompletion$16$label_115#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_116#1;

  inline$BDLDevicePowerIoCompletion$16$label_116#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_117#1;

  inline$BDLDevicePowerIoCompletion$16$label_117#1:
    call inline$BDLDevicePowerIoCompletion$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$16$label_118#1;

  inline$BDLDevicePowerIoCompletion$16$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$16$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$16$label_112#1;

  inline$BDLDevicePowerIoCompletion$16$label_112#1:
    goto inline$BDLGetDebugLevel$438$Entry#1;

  inline$BDLGetDebugLevel$438$Entry#1:
    goto inline$BDLGetDebugLevel$438$start#1;

  inline$BDLGetDebugLevel$438$start#1:
    goto inline$BDLGetDebugLevel$438$label_3#1;

  inline$BDLGetDebugLevel$438$label_3#1:
    havoc inline$BDLGetDebugLevel$438$myNondetVar_0;
    inline$BDLGetDebugLevel$438$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$438$myNondetVar_0;
    goto inline$BDLGetDebugLevel$438$label_1#1;

  inline$BDLGetDebugLevel$438$label_1#1:
    goto inline$BDLGetDebugLevel$438$Return#1;

  inline$BDLGetDebugLevel$438$Return#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$438$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$16$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$16$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$16$anon44_Then#1, inline$BDLDevicePowerIoCompletion$16$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$16$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$anon29#1;

  inline$BDLDevicePowerIoCompletion$16$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_121#1;

  inline$BDLDevicePowerIoCompletion$16$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_121_true#1, inline$BDLDevicePowerIoCompletion$16$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$16$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_122#1;

  inline$BDLDevicePowerIoCompletion$16$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$16$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$16$label_123#1;

  inline$BDLDevicePowerIoCompletion$16$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$16$label_122#1;

  inline$BDLDevicePowerIoCompletion$16$label_122#1:
    inline$BDLDevicePowerIoCompletion$16$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$16$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$16$label_1#1;

  inline$BDLDevicePowerIoCompletion$16$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$16$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$16$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$16$Return#1;

  inline$BDLDevicePowerIoCompletion$16$Return#1:
    inline$CallCompletionRoutine$16$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$16$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$16$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$16$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$16$anon13_Then#1, inline$CallCompletionRoutine$16$anon13_Else#1;

  inline$CallCompletionRoutine$16$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$16$anon7#1;

  inline$CallCompletionRoutine$16$anon7#1:
    goto inline$CallCompletionRoutine$16$label_20_icall_return#1;

  inline$CallCompletionRoutine$16$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$16$Return#1;

  inline$CallCompletionRoutine$16$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$16$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$16$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$16$Entry#1;

  inline$BDLCallDriverCompletionRoutine$16$Entry#1:
    inline$BDLCallDriverCompletionRoutine$16$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$16$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$16$start#1;

  inline$BDLCallDriverCompletionRoutine$16$start#1:
    inline$BDLCallDriverCompletionRoutine$16$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$16$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$16$label_3#1;

  inline$BDLCallDriverCompletionRoutine$16$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$16$label_3_true#1, inline$BDLCallDriverCompletionRoutine$16$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$16$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$16$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$16$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$16$label_4#1;

  inline$BDLCallDriverCompletionRoutine$16$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$16$label_6#1;

  inline$BDLCallDriverCompletionRoutine$16$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$16$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$16$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$16$label_5#1;

  inline$BDLCallDriverCompletionRoutine$16$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$16$label_6#1;

  inline$BDLCallDriverCompletionRoutine$16$label_6#1:
    goto inline$storm_KeSetEvent$18$Entry#1;

  inline$storm_KeSetEvent$18$Entry#1:
    inline$storm_KeSetEvent$18$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$16$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$18$start#1;

  inline$storm_KeSetEvent$18$start#1:
    inline$storm_KeSetEvent$18$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$18$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$18$label_3#1;

  inline$storm_KeSetEvent$18$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$18$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$18$label_1#1;

  inline$storm_KeSetEvent$18$label_1#1:
    goto inline$storm_KeSetEvent$18$Return#1;

  inline$storm_KeSetEvent$18$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$16$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$16$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$16$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$16$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$16$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$16$anon1#1;

  inline$BDLCallDriverCompletionRoutine$16$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$16$label_9#1;

  inline$BDLCallDriverCompletionRoutine$16$label_9#1:
    inline$BDLCallDriverCompletionRoutine$16$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$16$label_1#1;

  inline$BDLCallDriverCompletionRoutine$16$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$16$Return#1;

  inline$BDLCallDriverCompletionRoutine$16$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$16$Return#1;

  inline$BDLCallDriverCompletionRoutine$16$Return#1:
    inline$CallCompletionRoutine$16$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$16$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$16$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$16$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$16$anon12_Then#1, inline$CallCompletionRoutine$16$anon12_Else#1;

  inline$CallCompletionRoutine$16$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$16$anon5#1;

  inline$CallCompletionRoutine$16$anon5#1:
    goto inline$CallCompletionRoutine$16$label_20_icall_return#1;

  inline$CallCompletionRoutine$16$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$16$label_23#1;

  inline$CallCompletionRoutine$16$label_23#1:
    inline$CallCompletionRoutine$16$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$16$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$16$label_24#1;

  inline$CallCompletionRoutine$16$label_24#1:
    goto inline$CallCompletionRoutine$16$label_24_true#1, inline$CallCompletionRoutine$16$label_24_false#1;

  inline$CallCompletionRoutine$16$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$16$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$16$label_1#1;

  inline$CallCompletionRoutine$16$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$16$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$16$label_25#1;

  inline$CallCompletionRoutine$16$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$16$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$16$label_1#1;

  inline$CallCompletionRoutine$16$label_1#1:
    goto inline$CallCompletionRoutine$16$Return#1;

  inline$CallCompletionRoutine$16$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$16$Return#1;

  inline$CallCompletionRoutine$16$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$16$Return#1;

  inline$CallCompletionRoutine$16$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$16$Return#1;

  inline$CallCompletionRoutine$16$Return#1:
    goto inline$storm_IoCallDriver$8$label_33$1#1;

  inline$storm_IoCallDriver$8$label_33$1#1:
    goto inline$storm_IoCallDriver$8$anon14_Then#1, inline$storm_IoCallDriver$8$anon14_Else#1;

  inline$storm_IoCallDriver$8$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$8$anon8#1;

  inline$storm_IoCallDriver$8$anon8#1:
    goto inline$storm_IoCallDriver$8$label_36#1;

  inline$storm_IoCallDriver$8$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$8$Return#1;

  inline$storm_IoCallDriver$8$label_27_case_1#1:
    assume inline$storm_IoCallDriver$8$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$8$label_29#1;

  inline$storm_IoCallDriver$8$label_29#1:
    inline$storm_IoCallDriver$8$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$8$label_37#1;

  inline$storm_IoCallDriver$8$label_37#1:
    goto inline$storm_IoCallDriver$8$label_38#1;

  inline$storm_IoCallDriver$8$label_38#1:
    goto inline$storm_IoCallDriver$8$label_39#1;

  inline$storm_IoCallDriver$8$label_39#1:
    goto inline$CallCompletionRoutine$17$Entry#1;

  inline$CallCompletionRoutine$17$Entry#1:
    inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$17$start#1;

  inline$CallCompletionRoutine$17$start#1:
    inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$17$label_3#1;

  inline$CallCompletionRoutine$17$label_3#1:
    goto inline$CallCompletionRoutine$17$label_4#1;

  inline$CallCompletionRoutine$17$label_4#1:
    goto inline$CallCompletionRoutine$17$label_5#1;

  inline$CallCompletionRoutine$17$label_5#1:
    goto inline$CallCompletionRoutine$17$label_6#1;

  inline$CallCompletionRoutine$17$label_6#1:
    goto inline$CallCompletionRoutine$17$label_7#1;

  inline$CallCompletionRoutine$17$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$88$Entry#1;

  inline$IoGetCurrentIrpStackLocation$88$Entry#1:
    inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$88$start#1;

  inline$IoGetCurrentIrpStackLocation$88$start#1:
    inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$88$label_3#1;

  inline$IoGetCurrentIrpStackLocation$88$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$88$label_3_true#1, inline$IoGetCurrentIrpStackLocation$88$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$88$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$88$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$88$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$88$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$88$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$88$label_4#1;

  inline$IoGetCurrentIrpStackLocation$88$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$88$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$88$label_6#1;

  inline$IoGetCurrentIrpStackLocation$88$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$88$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$88$label_7#1;

  inline$IoGetCurrentIrpStackLocation$88$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$88$label_5#1;

  inline$IoGetCurrentIrpStackLocation$88$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$88$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$88$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$88$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$88$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$88$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$88$label_5#1;

  inline$IoGetCurrentIrpStackLocation$88$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$88$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$88$label_1#1;

  inline$IoGetCurrentIrpStackLocation$88$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$88$Return#1;

  inline$IoGetCurrentIrpStackLocation$88$Return#1:
    goto inline$CallCompletionRoutine$17$label_7$1#1;

  inline$CallCompletionRoutine$17$label_7$1#1:
    goto inline$CallCompletionRoutine$17$anon10_Then#1, inline$CallCompletionRoutine$17$anon10_Else#1;

  inline$CallCompletionRoutine$17$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$17$anon1#1;

  inline$CallCompletionRoutine$17$anon1#1:
    goto inline$CallCompletionRoutine$17$label_10#1;

  inline$CallCompletionRoutine$17$label_10#1:
    goto inline$CallCompletionRoutine$17$label_11#1;

  inline$CallCompletionRoutine$17$label_11#1:
    havoc inline$CallCompletionRoutine$17$myNondetVar_0;
    inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$17$myNondetVar_0;
    goto inline$CallCompletionRoutine$17$label_12#1;

  inline$CallCompletionRoutine$17$label_12#1:
    havoc inline$CallCompletionRoutine$17$myNondetVar_0;
    inline$CallCompletionRoutine$17$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$17$myNondetVar_0;
    goto inline$CallCompletionRoutine$17$label_13#1;

  inline$CallCompletionRoutine$17$label_13#1:
    havoc inline$CallCompletionRoutine$17$myNondetVar_0;
    goto inline$CallCompletionRoutine$17$label_14#1;

  inline$CallCompletionRoutine$17$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$89$Entry#1;

  inline$IoGetCurrentIrpStackLocation$89$Entry#1:
    inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$89$start#1;

  inline$IoGetCurrentIrpStackLocation$89$start#1:
    inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$89$label_3#1;

  inline$IoGetCurrentIrpStackLocation$89$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$89$label_3_true#1, inline$IoGetCurrentIrpStackLocation$89$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$89$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$89$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$89$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$89$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$89$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$89$label_4#1;

  inline$IoGetCurrentIrpStackLocation$89$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$89$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$89$label_6#1;

  inline$IoGetCurrentIrpStackLocation$89$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$89$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$89$label_7#1;

  inline$IoGetCurrentIrpStackLocation$89$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$89$label_5#1;

  inline$IoGetCurrentIrpStackLocation$89$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$89$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$89$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$89$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$89$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$89$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$89$label_5#1;

  inline$IoGetCurrentIrpStackLocation$89$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$89$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$89$label_1#1;

  inline$IoGetCurrentIrpStackLocation$89$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$89$Return#1;

  inline$IoGetCurrentIrpStackLocation$89$Return#1:
    goto inline$CallCompletionRoutine$17$label_14$1#1;

  inline$CallCompletionRoutine$17$label_14$1#1:
    goto inline$CallCompletionRoutine$17$anon11_Then#1, inline$CallCompletionRoutine$17$anon11_Else#1;

  inline$CallCompletionRoutine$17$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$17$anon3#1;

  inline$CallCompletionRoutine$17$anon3#1:
    goto inline$CallCompletionRoutine$17$label_17#1;

  inline$CallCompletionRoutine$17$label_17#1:
    goto inline$CallCompletionRoutine$17$label_18#1;

  inline$CallCompletionRoutine$17$label_18#1:
    goto inline$CallCompletionRoutine$17$label_18_true#1, inline$CallCompletionRoutine$17$label_18_false#1;

  inline$CallCompletionRoutine$17$label_18_false#1:
    assume inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$17$label_1#1;

  inline$CallCompletionRoutine$17$label_18_true#1:
    assume inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$17$label_19#1;

  inline$CallCompletionRoutine$17$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$17$label_20#1;

  inline$CallCompletionRoutine$17$label_20#1:
    goto inline$CallCompletionRoutine$17$label_20_icall_1#1, inline$CallCompletionRoutine$17$label_20_icall_2#1, inline$CallCompletionRoutine$17$label_20_icall_3#1;

  inline$CallCompletionRoutine$17$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$17$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$17$Entry#1;

  inline$BDLSystemPowerIoCompletion$17$Entry#1:
    inline$BDLSystemPowerIoCompletion$17$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$17$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$17$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$17$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$17$start#1;

  inline$BDLSystemPowerIoCompletion$17$start#1:
    call inline$BDLSystemPowerIoCompletion$17$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$17$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$17$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$17$label_3#1;

  inline$BDLSystemPowerIoCompletion$17$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_4#1;

  inline$BDLSystemPowerIoCompletion$17$label_4#1:
    inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_5#1;

  inline$BDLSystemPowerIoCompletion$17$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_6#1;

  inline$BDLSystemPowerIoCompletion$17$label_6#1:
    inline$BDLSystemPowerIoCompletion$17$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$17$label_7#1;

  inline$BDLSystemPowerIoCompletion$17$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_8#1;

  inline$BDLSystemPowerIoCompletion$17$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$17$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$17$label_9#1;

  inline$BDLSystemPowerIoCompletion$17$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_10#1;

  inline$BDLSystemPowerIoCompletion$17$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$91$Entry#1;

  inline$IoGetCurrentIrpStackLocation$91$Entry#1:
    inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$91$start#1;

  inline$IoGetCurrentIrpStackLocation$91$start#1:
    inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$91$label_3#1;

  inline$IoGetCurrentIrpStackLocation$91$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$91$label_3_true#1, inline$IoGetCurrentIrpStackLocation$91$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$91$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$91$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$91$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$91$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$91$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$91$label_4#1;

  inline$IoGetCurrentIrpStackLocation$91$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$91$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$91$label_6#1;

  inline$IoGetCurrentIrpStackLocation$91$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$91$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$91$label_7#1;

  inline$IoGetCurrentIrpStackLocation$91$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$91$label_5#1;

  inline$IoGetCurrentIrpStackLocation$91$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$91$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$91$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$91$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$91$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$91$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$91$label_5#1;

  inline$IoGetCurrentIrpStackLocation$91$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$91$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$91$label_1#1;

  inline$IoGetCurrentIrpStackLocation$91$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$91$Return#1;

  inline$IoGetCurrentIrpStackLocation$91$Return#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon36_Then#1, inline$BDLSystemPowerIoCompletion$17$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon1#1;

  inline$BDLSystemPowerIoCompletion$17$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_13#1;

  inline$BDLSystemPowerIoCompletion$17$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_14#1;

  inline$BDLSystemPowerIoCompletion$17$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_15#1;

  inline$BDLSystemPowerIoCompletion$17$label_15#1:
    goto inline$BDLGetDebugLevel$460$Entry#1;

  inline$BDLGetDebugLevel$460$Entry#1:
    goto inline$BDLGetDebugLevel$460$start#1;

  inline$BDLGetDebugLevel$460$start#1:
    goto inline$BDLGetDebugLevel$460$label_3#1;

  inline$BDLGetDebugLevel$460$label_3#1:
    havoc inline$BDLGetDebugLevel$460$myNondetVar_0;
    inline$BDLGetDebugLevel$460$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$460$myNondetVar_0;
    goto inline$BDLGetDebugLevel$460$label_1#1;

  inline$BDLGetDebugLevel$460$label_1#1:
    goto inline$BDLGetDebugLevel$460$Return#1;

  inline$BDLGetDebugLevel$460$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$460$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon37_Then#1, inline$BDLSystemPowerIoCompletion$17$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon3#1;

  inline$BDLSystemPowerIoCompletion$17$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_18#1;

  inline$BDLSystemPowerIoCompletion$17$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_18_true#1, inline$BDLSystemPowerIoCompletion$17$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_19#1;

  inline$BDLSystemPowerIoCompletion$17$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_22#1;

  inline$BDLSystemPowerIoCompletion$17$label_22#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_23#1;

  inline$BDLSystemPowerIoCompletion$17$label_23#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_24#1;

  inline$BDLSystemPowerIoCompletion$17$label_24#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_25#1;

  inline$BDLSystemPowerIoCompletion$17$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$17$label_19#1;

  inline$BDLSystemPowerIoCompletion$17$label_19#1:
    goto inline$BDLGetDebugLevel$461$Entry#1;

  inline$BDLGetDebugLevel$461$Entry#1:
    goto inline$BDLGetDebugLevel$461$start#1;

  inline$BDLGetDebugLevel$461$start#1:
    goto inline$BDLGetDebugLevel$461$label_3#1;

  inline$BDLGetDebugLevel$461$label_3#1:
    havoc inline$BDLGetDebugLevel$461$myNondetVar_0;
    inline$BDLGetDebugLevel$461$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$461$myNondetVar_0;
    goto inline$BDLGetDebugLevel$461$label_1#1;

  inline$BDLGetDebugLevel$461$label_1#1:
    goto inline$BDLGetDebugLevel$461$Return#1;

  inline$BDLGetDebugLevel$461$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$461$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon38_Then#1, inline$BDLSystemPowerIoCompletion$17$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon5#1;

  inline$BDLSystemPowerIoCompletion$17$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_28#1;

  inline$BDLSystemPowerIoCompletion$17$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_28_true#1, inline$BDLSystemPowerIoCompletion$17$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_29#1;

  inline$BDLSystemPowerIoCompletion$17$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_32#1;

  inline$BDLSystemPowerIoCompletion$17$label_32#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_33#1;

  inline$BDLSystemPowerIoCompletion$17$label_33#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_34#1;

  inline$BDLSystemPowerIoCompletion$17$label_34#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_35#1;

  inline$BDLSystemPowerIoCompletion$17$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$17$label_29#1;

  inline$BDLSystemPowerIoCompletion$17$label_29#1:
    goto inline$BDLGetDebugLevel$462$Entry#1;

  inline$BDLGetDebugLevel$462$Entry#1:
    goto inline$BDLGetDebugLevel$462$start#1;

  inline$BDLGetDebugLevel$462$start#1:
    goto inline$BDLGetDebugLevel$462$label_3#1;

  inline$BDLGetDebugLevel$462$label_3#1:
    havoc inline$BDLGetDebugLevel$462$myNondetVar_0;
    inline$BDLGetDebugLevel$462$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$462$myNondetVar_0;
    goto inline$BDLGetDebugLevel$462$label_1#1;

  inline$BDLGetDebugLevel$462$label_1#1:
    goto inline$BDLGetDebugLevel$462$Return#1;

  inline$BDLGetDebugLevel$462$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$462$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon39_Then#1, inline$BDLSystemPowerIoCompletion$17$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon7#1;

  inline$BDLSystemPowerIoCompletion$17$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_38#1;

  inline$BDLSystemPowerIoCompletion$17$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_38_true#1, inline$BDLSystemPowerIoCompletion$17$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_39#1;

  inline$BDLSystemPowerIoCompletion$17$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_40#1;

  inline$BDLSystemPowerIoCompletion$17$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_39#1;

  inline$BDLSystemPowerIoCompletion$17$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_39_true#1, inline$BDLSystemPowerIoCompletion$17$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_41#1;

  inline$BDLSystemPowerIoCompletion$17$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$17$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$17$label_107#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$17$label_108#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$17$label_108#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$17$label_108#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$17$label_108#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$17$label_108#1;

  inline$BDLSystemPowerIoCompletion$17$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_109#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$17$label_107#1;

  inline$BDLSystemPowerIoCompletion$17$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_109#1;

  inline$BDLSystemPowerIoCompletion$17$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$17$label_106#1;

  inline$BDLSystemPowerIoCompletion$17$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_106_true#1, inline$BDLSystemPowerIoCompletion$17$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_142#1;

  inline$BDLSystemPowerIoCompletion$17$label_142#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_143#1;

  inline$BDLSystemPowerIoCompletion$17$label_143#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_144#1;

  inline$BDLSystemPowerIoCompletion$17$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_109#1;

  inline$BDLSystemPowerIoCompletion$17$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_109#1;

  inline$BDLSystemPowerIoCompletion$17$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$17$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$17$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$17$myNondetVar_0, inline$BDLSystemPowerIoCompletion$17$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$17$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$17$anon50_Then#1, inline$BDLSystemPowerIoCompletion$17$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon29#1;

  inline$BDLSystemPowerIoCompletion$17$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_112#1;

  inline$BDLSystemPowerIoCompletion$17$label_112#1:
    inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$17$label_113#1;

  inline$BDLSystemPowerIoCompletion$17$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_113_true#1, inline$BDLSystemPowerIoCompletion$17$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$17$label_114#1;

  inline$BDLSystemPowerIoCompletion$17$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_116#1;

  inline$BDLSystemPowerIoCompletion$17$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_117#1;

  inline$BDLSystemPowerIoCompletion$17$label_117#1:
    goto inline$BDLGetDebugLevel$469$Entry#1;

  inline$BDLGetDebugLevel$469$Entry#1:
    goto inline$BDLGetDebugLevel$469$start#1;

  inline$BDLGetDebugLevel$469$start#1:
    goto inline$BDLGetDebugLevel$469$label_3#1;

  inline$BDLGetDebugLevel$469$label_3#1:
    havoc inline$BDLGetDebugLevel$469$myNondetVar_0;
    inline$BDLGetDebugLevel$469$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$469$myNondetVar_0;
    goto inline$BDLGetDebugLevel$469$label_1#1;

  inline$BDLGetDebugLevel$469$label_1#1:
    goto inline$BDLGetDebugLevel$469$Return#1;

  inline$BDLGetDebugLevel$469$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$469$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon51_Then#1, inline$BDLSystemPowerIoCompletion$17$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon31#1;

  inline$BDLSystemPowerIoCompletion$17$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_120#1;

  inline$BDLSystemPowerIoCompletion$17$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_120_true#1, inline$BDLSystemPowerIoCompletion$17$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_121#1;

  inline$BDLSystemPowerIoCompletion$17$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_124#1;

  inline$BDLSystemPowerIoCompletion$17$label_124#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_125#1;

  inline$BDLSystemPowerIoCompletion$17$label_125#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_126#1;

  inline$BDLSystemPowerIoCompletion$17$label_126#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_127#1;

  inline$BDLSystemPowerIoCompletion$17$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$17$label_121#1;

  inline$BDLSystemPowerIoCompletion$17$label_121#1:
    goto inline$BDLGetDebugLevel$470$Entry#1;

  inline$BDLGetDebugLevel$470$Entry#1:
    goto inline$BDLGetDebugLevel$470$start#1;

  inline$BDLGetDebugLevel$470$start#1:
    goto inline$BDLGetDebugLevel$470$label_3#1;

  inline$BDLGetDebugLevel$470$label_3#1:
    havoc inline$BDLGetDebugLevel$470$myNondetVar_0;
    inline$BDLGetDebugLevel$470$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$470$myNondetVar_0;
    goto inline$BDLGetDebugLevel$470$label_1#1;

  inline$BDLGetDebugLevel$470$label_1#1:
    goto inline$BDLGetDebugLevel$470$Return#1;

  inline$BDLGetDebugLevel$470$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$470$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon52_Then#1, inline$BDLSystemPowerIoCompletion$17$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon33#1;

  inline$BDLSystemPowerIoCompletion$17$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_130#1;

  inline$BDLSystemPowerIoCompletion$17$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_130_true#1, inline$BDLSystemPowerIoCompletion$17$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_131#1;

  inline$BDLSystemPowerIoCompletion$17$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_134#1;

  inline$BDLSystemPowerIoCompletion$17$label_134#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_135#1;

  inline$BDLSystemPowerIoCompletion$17$label_135#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_136#1;

  inline$BDLSystemPowerIoCompletion$17$label_136#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_137#1;

  inline$BDLSystemPowerIoCompletion$17$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$17$label_131#1;

  inline$BDLSystemPowerIoCompletion$17$label_131#1:
    goto inline$BDLGetDebugLevel$471$Entry#1;

  inline$BDLGetDebugLevel$471$Entry#1:
    goto inline$BDLGetDebugLevel$471$start#1;

  inline$BDLGetDebugLevel$471$start#1:
    goto inline$BDLGetDebugLevel$471$label_3#1;

  inline$BDLGetDebugLevel$471$label_3#1:
    havoc inline$BDLGetDebugLevel$471$myNondetVar_0;
    inline$BDLGetDebugLevel$471$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$471$myNondetVar_0;
    goto inline$BDLGetDebugLevel$471$label_1#1;

  inline$BDLGetDebugLevel$471$label_1#1:
    goto inline$BDLGetDebugLevel$471$Return#1;

  inline$BDLGetDebugLevel$471$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$471$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon53_Then#1, inline$BDLSystemPowerIoCompletion$17$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon35#1;

  inline$BDLSystemPowerIoCompletion$17$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_140#1;

  inline$BDLSystemPowerIoCompletion$17$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_140_true#1, inline$BDLSystemPowerIoCompletion$17$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_67#1;

  inline$BDLSystemPowerIoCompletion$17$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_141#1;

  inline$BDLSystemPowerIoCompletion$17$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_67#1;

  inline$BDLSystemPowerIoCompletion$17$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$17$label_115#1;

  inline$BDLSystemPowerIoCompletion$17$label_115#1:
    inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$17$label_80#1;

  inline$BDLSystemPowerIoCompletion$17$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$17$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_42#1;

  inline$BDLSystemPowerIoCompletion$17$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$17$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$17$label_43#1;

  inline$BDLSystemPowerIoCompletion$17$label_43#1:
    goto inline$BDLGetDebugLevel$463$Entry#1;

  inline$BDLGetDebugLevel$463$Entry#1:
    goto inline$BDLGetDebugLevel$463$start#1;

  inline$BDLGetDebugLevel$463$start#1:
    goto inline$BDLGetDebugLevel$463$label_3#1;

  inline$BDLGetDebugLevel$463$label_3#1:
    havoc inline$BDLGetDebugLevel$463$myNondetVar_0;
    inline$BDLGetDebugLevel$463$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$463$myNondetVar_0;
    goto inline$BDLGetDebugLevel$463$label_1#1;

  inline$BDLGetDebugLevel$463$label_1#1:
    goto inline$BDLGetDebugLevel$463$Return#1;

  inline$BDLGetDebugLevel$463$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$463$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon40_Then#1, inline$BDLSystemPowerIoCompletion$17$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon9#1;

  inline$BDLSystemPowerIoCompletion$17$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_46#1;

  inline$BDLSystemPowerIoCompletion$17$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_46_true#1, inline$BDLSystemPowerIoCompletion$17$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_47#1;

  inline$BDLSystemPowerIoCompletion$17$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_50#1;

  inline$BDLSystemPowerIoCompletion$17$label_50#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_51#1;

  inline$BDLSystemPowerIoCompletion$17$label_51#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_52#1;

  inline$BDLSystemPowerIoCompletion$17$label_52#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_53#1;

  inline$BDLSystemPowerIoCompletion$17$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$17$label_47#1;

  inline$BDLSystemPowerIoCompletion$17$label_47#1:
    goto inline$BDLGetDebugLevel$464$Entry#1;

  inline$BDLGetDebugLevel$464$Entry#1:
    goto inline$BDLGetDebugLevel$464$start#1;

  inline$BDLGetDebugLevel$464$start#1:
    goto inline$BDLGetDebugLevel$464$label_3#1;

  inline$BDLGetDebugLevel$464$label_3#1:
    havoc inline$BDLGetDebugLevel$464$myNondetVar_0;
    inline$BDLGetDebugLevel$464$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$464$myNondetVar_0;
    goto inline$BDLGetDebugLevel$464$label_1#1;

  inline$BDLGetDebugLevel$464$label_1#1:
    goto inline$BDLGetDebugLevel$464$Return#1;

  inline$BDLGetDebugLevel$464$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$464$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon41_Then#1, inline$BDLSystemPowerIoCompletion$17$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon11#1;

  inline$BDLSystemPowerIoCompletion$17$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_56#1;

  inline$BDLSystemPowerIoCompletion$17$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_56_true#1, inline$BDLSystemPowerIoCompletion$17$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_57#1;

  inline$BDLSystemPowerIoCompletion$17$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_60#1;

  inline$BDLSystemPowerIoCompletion$17$label_60#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_61#1;

  inline$BDLSystemPowerIoCompletion$17$label_61#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_62#1;

  inline$BDLSystemPowerIoCompletion$17$label_62#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_63#1;

  inline$BDLSystemPowerIoCompletion$17$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$17$label_57#1;

  inline$BDLSystemPowerIoCompletion$17$label_57#1:
    goto inline$BDLGetDebugLevel$465$Entry#1;

  inline$BDLGetDebugLevel$465$Entry#1:
    goto inline$BDLGetDebugLevel$465$start#1;

  inline$BDLGetDebugLevel$465$start#1:
    goto inline$BDLGetDebugLevel$465$label_3#1;

  inline$BDLGetDebugLevel$465$label_3#1:
    havoc inline$BDLGetDebugLevel$465$myNondetVar_0;
    inline$BDLGetDebugLevel$465$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$465$myNondetVar_0;
    goto inline$BDLGetDebugLevel$465$label_1#1;

  inline$BDLGetDebugLevel$465$label_1#1:
    goto inline$BDLGetDebugLevel$465$Return#1;

  inline$BDLGetDebugLevel$465$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$465$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon42_Then#1, inline$BDLSystemPowerIoCompletion$17$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon13#1;

  inline$BDLSystemPowerIoCompletion$17$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_66#1;

  inline$BDLSystemPowerIoCompletion$17$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_66_true#1, inline$BDLSystemPowerIoCompletion$17$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_67#1;

  inline$BDLSystemPowerIoCompletion$17$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_70#1;

  inline$BDLSystemPowerIoCompletion$17$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_67#1;

  inline$BDLSystemPowerIoCompletion$17$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$17$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$17$anon43_Then#1, inline$BDLSystemPowerIoCompletion$17$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon15#1;

  inline$BDLSystemPowerIoCompletion$17$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_71#1;

  inline$BDLSystemPowerIoCompletion$17$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$17$anon44_Then#1, inline$BDLSystemPowerIoCompletion$17$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon17#1;

  inline$BDLSystemPowerIoCompletion$17$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_74#1;

  inline$BDLSystemPowerIoCompletion$17$label_74#1:
    goto inline$storm_IoCompleteRequest$36$Entry#1;

  inline$storm_IoCompleteRequest$36$Entry#1:
    inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$17$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$36$start#1;

  inline$storm_IoCompleteRequest$36$start#1:
    inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$36$label_3#1;

  inline$storm_IoCompleteRequest$36$label_3#1:
    call inline$storm_IoCompleteRequest$36$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$36$label_6#1;

  inline$storm_IoCompleteRequest$36$label_6#1:
    goto inline$storm_IoCompleteRequest$36$label_6_true#1, inline$storm_IoCompleteRequest$36$label_6_false#1;

  inline$storm_IoCompleteRequest$36$label_6_false#1:
    assume inline$storm_IoCompleteRequest$36$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$36$label_7#1;

  inline$storm_IoCompleteRequest$36$label_6_true#1:
    assume inline$storm_IoCompleteRequest$36$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$36$label_8#1;

  inline$storm_IoCompleteRequest$36$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$36$anon3_Then#1, inline$storm_IoCompleteRequest$36$anon3_Else#1;

  inline$storm_IoCompleteRequest$36$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$36$anon1#1;

  inline$storm_IoCompleteRequest$36$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$36$label_9#1;

  inline$storm_IoCompleteRequest$36$label_9#1:
    goto inline$storm_IoCompleteRequest$36$label_9_true#1, inline$storm_IoCompleteRequest$36$label_9_false#1;

  inline$storm_IoCompleteRequest$36$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$36$label_10#1;

  inline$storm_IoCompleteRequest$36$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$36$label_1#1;

  inline$storm_IoCompleteRequest$36$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$36$label_7#1;

  inline$storm_IoCompleteRequest$36$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$36$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$36$label_1#1;

  inline$storm_IoCompleteRequest$36$label_1#1:
    goto inline$storm_IoCompleteRequest$36$Return#1;

  inline$storm_IoCompleteRequest$36$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$36$Return#1;

  inline$storm_IoCompleteRequest$36$Return#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon45_Then#1, inline$BDLSystemPowerIoCompletion$17$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon19#1;

  inline$BDLSystemPowerIoCompletion$17$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_77#1;

  inline$BDLSystemPowerIoCompletion$17$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$17$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$17$anon46_Then#1, inline$BDLSystemPowerIoCompletion$17$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon21#1;

  inline$BDLSystemPowerIoCompletion$17$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_80#1;

  inline$BDLSystemPowerIoCompletion$17$label_80#1:
    goto inline$BDLGetDebugLevel$466$Entry#1;

  inline$BDLGetDebugLevel$466$Entry#1:
    goto inline$BDLGetDebugLevel$466$start#1;

  inline$BDLGetDebugLevel$466$start#1:
    goto inline$BDLGetDebugLevel$466$label_3#1;

  inline$BDLGetDebugLevel$466$label_3#1:
    havoc inline$BDLGetDebugLevel$466$myNondetVar_0;
    inline$BDLGetDebugLevel$466$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$466$myNondetVar_0;
    goto inline$BDLGetDebugLevel$466$label_1#1;

  inline$BDLGetDebugLevel$466$label_1#1:
    goto inline$BDLGetDebugLevel$466$Return#1;

  inline$BDLGetDebugLevel$466$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$466$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon47_Then#1, inline$BDLSystemPowerIoCompletion$17$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon23#1;

  inline$BDLSystemPowerIoCompletion$17$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_83#1;

  inline$BDLSystemPowerIoCompletion$17$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_83_true#1, inline$BDLSystemPowerIoCompletion$17$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_84#1;

  inline$BDLSystemPowerIoCompletion$17$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_87#1;

  inline$BDLSystemPowerIoCompletion$17$label_87#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_88#1;

  inline$BDLSystemPowerIoCompletion$17$label_88#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_89#1;

  inline$BDLSystemPowerIoCompletion$17$label_89#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_90#1;

  inline$BDLSystemPowerIoCompletion$17$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$17$label_84#1;

  inline$BDLSystemPowerIoCompletion$17$label_84#1:
    goto inline$BDLGetDebugLevel$467$Entry#1;

  inline$BDLGetDebugLevel$467$Entry#1:
    goto inline$BDLGetDebugLevel$467$start#1;

  inline$BDLGetDebugLevel$467$start#1:
    goto inline$BDLGetDebugLevel$467$label_3#1;

  inline$BDLGetDebugLevel$467$label_3#1:
    havoc inline$BDLGetDebugLevel$467$myNondetVar_0;
    inline$BDLGetDebugLevel$467$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$467$myNondetVar_0;
    goto inline$BDLGetDebugLevel$467$label_1#1;

  inline$BDLGetDebugLevel$467$label_1#1:
    goto inline$BDLGetDebugLevel$467$Return#1;

  inline$BDLGetDebugLevel$467$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$467$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon48_Then#1, inline$BDLSystemPowerIoCompletion$17$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon25#1;

  inline$BDLSystemPowerIoCompletion$17$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_93#1;

  inline$BDLSystemPowerIoCompletion$17$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_93_true#1, inline$BDLSystemPowerIoCompletion$17$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_94#1;

  inline$BDLSystemPowerIoCompletion$17$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_97#1;

  inline$BDLSystemPowerIoCompletion$17$label_97#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_98#1;

  inline$BDLSystemPowerIoCompletion$17$label_98#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_99#1;

  inline$BDLSystemPowerIoCompletion$17$label_99#1:
    call inline$BDLSystemPowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$17$label_100#1;

  inline$BDLSystemPowerIoCompletion$17$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$17$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$17$label_94#1;

  inline$BDLSystemPowerIoCompletion$17$label_94#1:
    goto inline$BDLGetDebugLevel$468$Entry#1;

  inline$BDLGetDebugLevel$468$Entry#1:
    goto inline$BDLGetDebugLevel$468$start#1;

  inline$BDLGetDebugLevel$468$start#1:
    goto inline$BDLGetDebugLevel$468$label_3#1;

  inline$BDLGetDebugLevel$468$label_3#1:
    havoc inline$BDLGetDebugLevel$468$myNondetVar_0;
    inline$BDLGetDebugLevel$468$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$468$myNondetVar_0;
    goto inline$BDLGetDebugLevel$468$label_1#1;

  inline$BDLGetDebugLevel$468$label_1#1:
    goto inline$BDLGetDebugLevel$468$Return#1;

  inline$BDLGetDebugLevel$468$Return#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$468$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$17$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$17$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$17$anon49_Then#1, inline$BDLSystemPowerIoCompletion$17$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$17$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$anon27#1;

  inline$BDLSystemPowerIoCompletion$17$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_103#1;

  inline$BDLSystemPowerIoCompletion$17$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_103_true#1, inline$BDLSystemPowerIoCompletion$17$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$17$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_104#1;

  inline$BDLSystemPowerIoCompletion$17$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$17$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$17$label_105#1;

  inline$BDLSystemPowerIoCompletion$17$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$17$label_104#1;

  inline$BDLSystemPowerIoCompletion$17$label_104#1:
    inline$BDLSystemPowerIoCompletion$17$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$17$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$17$label_1#1;

  inline$BDLSystemPowerIoCompletion$17$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$17$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$17$Return#1;

  inline$BDLSystemPowerIoCompletion$17$Return#1:
    inline$CallCompletionRoutine$17$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$17$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$17$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$17$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$17$anon14_Then#1, inline$CallCompletionRoutine$17$anon14_Else#1;

  inline$CallCompletionRoutine$17$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$17$anon9#1;

  inline$CallCompletionRoutine$17$anon9#1:
    goto inline$CallCompletionRoutine$17$label_20_icall_return#1;

  inline$CallCompletionRoutine$17$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$17$Return#1;

  inline$CallCompletionRoutine$17$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$17$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$17$Entry#1;

  inline$BDLDevicePowerIoCompletion$17$Entry#1:
    inline$BDLDevicePowerIoCompletion$17$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$17$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$17$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$17$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$17$start#1;

  inline$BDLDevicePowerIoCompletion$17$start#1:
    call inline$BDLDevicePowerIoCompletion$17$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$17$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$17$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$17$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$17$label_3#1;

  inline$BDLDevicePowerIoCompletion$17$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_4#1;

  inline$BDLDevicePowerIoCompletion$17$label_4#1:
    inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_5#1;

  inline$BDLDevicePowerIoCompletion$17$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_6#1;

  inline$BDLDevicePowerIoCompletion$17$label_6#1:
    inline$BDLDevicePowerIoCompletion$17$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$17$label_7#1;

  inline$BDLDevicePowerIoCompletion$17$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_8#1;

  inline$BDLDevicePowerIoCompletion$17$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$17$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$17$label_9#1;

  inline$BDLDevicePowerIoCompletion$17$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_10#1;

  inline$BDLDevicePowerIoCompletion$17$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$90$Entry#1;

  inline$IoGetCurrentIrpStackLocation$90$Entry#1:
    inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$90$start#1;

  inline$IoGetCurrentIrpStackLocation$90$start#1:
    inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$90$label_3#1;

  inline$IoGetCurrentIrpStackLocation$90$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$90$label_3_true#1, inline$IoGetCurrentIrpStackLocation$90$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$90$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$90$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$90$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$90$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$90$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$90$label_4#1;

  inline$IoGetCurrentIrpStackLocation$90$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$90$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$90$label_6#1;

  inline$IoGetCurrentIrpStackLocation$90$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$90$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$90$label_7#1;

  inline$IoGetCurrentIrpStackLocation$90$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$90$label_5#1;

  inline$IoGetCurrentIrpStackLocation$90$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$90$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$90$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$90$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$90$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$90$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$90$label_5#1;

  inline$IoGetCurrentIrpStackLocation$90$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$90$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$90$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$90$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$90$label_1#1;

  inline$IoGetCurrentIrpStackLocation$90$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$90$Return#1;

  inline$IoGetCurrentIrpStackLocation$90$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$90$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon30_Then#1, inline$BDLDevicePowerIoCompletion$17$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon1#1;

  inline$BDLDevicePowerIoCompletion$17$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_13#1;

  inline$BDLDevicePowerIoCompletion$17$label_13#1:
    inline$BDLDevicePowerIoCompletion$17$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$17$label_14#1;

  inline$BDLDevicePowerIoCompletion$17$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_15#1;

  inline$BDLDevicePowerIoCompletion$17$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$17$label_16#1;

  inline$BDLDevicePowerIoCompletion$17$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_17#1;

  inline$BDLDevicePowerIoCompletion$17$label_17#1:
    goto inline$BDLGetDebugLevel$451$Entry#1;

  inline$BDLGetDebugLevel$451$Entry#1:
    goto inline$BDLGetDebugLevel$451$start#1;

  inline$BDLGetDebugLevel$451$start#1:
    goto inline$BDLGetDebugLevel$451$label_3#1;

  inline$BDLGetDebugLevel$451$label_3#1:
    havoc inline$BDLGetDebugLevel$451$myNondetVar_0;
    inline$BDLGetDebugLevel$451$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$451$myNondetVar_0;
    goto inline$BDLGetDebugLevel$451$label_1#1;

  inline$BDLGetDebugLevel$451$label_1#1:
    goto inline$BDLGetDebugLevel$451$Return#1;

  inline$BDLGetDebugLevel$451$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$451$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon31_Then#1, inline$BDLDevicePowerIoCompletion$17$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon3#1;

  inline$BDLDevicePowerIoCompletion$17$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_20#1;

  inline$BDLDevicePowerIoCompletion$17$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_20_true#1, inline$BDLDevicePowerIoCompletion$17$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_21#1;

  inline$BDLDevicePowerIoCompletion$17$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_24#1;

  inline$BDLDevicePowerIoCompletion$17$label_24#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_25#1;

  inline$BDLDevicePowerIoCompletion$17$label_25#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_26#1;

  inline$BDLDevicePowerIoCompletion$17$label_26#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_27#1;

  inline$BDLDevicePowerIoCompletion$17$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$17$label_21#1;

  inline$BDLDevicePowerIoCompletion$17$label_21#1:
    goto inline$BDLGetDebugLevel$452$Entry#1;

  inline$BDLGetDebugLevel$452$Entry#1:
    goto inline$BDLGetDebugLevel$452$start#1;

  inline$BDLGetDebugLevel$452$start#1:
    goto inline$BDLGetDebugLevel$452$label_3#1;

  inline$BDLGetDebugLevel$452$label_3#1:
    havoc inline$BDLGetDebugLevel$452$myNondetVar_0;
    inline$BDLGetDebugLevel$452$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$452$myNondetVar_0;
    goto inline$BDLGetDebugLevel$452$label_1#1;

  inline$BDLGetDebugLevel$452$label_1#1:
    goto inline$BDLGetDebugLevel$452$Return#1;

  inline$BDLGetDebugLevel$452$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$452$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon32_Then#1, inline$BDLDevicePowerIoCompletion$17$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon5#1;

  inline$BDLDevicePowerIoCompletion$17$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_30#1;

  inline$BDLDevicePowerIoCompletion$17$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_30_true#1, inline$BDLDevicePowerIoCompletion$17$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_31#1;

  inline$BDLDevicePowerIoCompletion$17$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_34#1;

  inline$BDLDevicePowerIoCompletion$17$label_34#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_35#1;

  inline$BDLDevicePowerIoCompletion$17$label_35#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_36#1;

  inline$BDLDevicePowerIoCompletion$17$label_36#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_37#1;

  inline$BDLDevicePowerIoCompletion$17$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$17$label_31#1;

  inline$BDLDevicePowerIoCompletion$17$label_31#1:
    goto inline$BDLGetDebugLevel$453$Entry#1;

  inline$BDLGetDebugLevel$453$Entry#1:
    goto inline$BDLGetDebugLevel$453$start#1;

  inline$BDLGetDebugLevel$453$start#1:
    goto inline$BDLGetDebugLevel$453$label_3#1;

  inline$BDLGetDebugLevel$453$label_3#1:
    havoc inline$BDLGetDebugLevel$453$myNondetVar_0;
    inline$BDLGetDebugLevel$453$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$453$myNondetVar_0;
    goto inline$BDLGetDebugLevel$453$label_1#1;

  inline$BDLGetDebugLevel$453$label_1#1:
    goto inline$BDLGetDebugLevel$453$Return#1;

  inline$BDLGetDebugLevel$453$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$453$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon33_Then#1, inline$BDLDevicePowerIoCompletion$17$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon7#1;

  inline$BDLDevicePowerIoCompletion$17$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_40#1;

  inline$BDLDevicePowerIoCompletion$17$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_40_true#1, inline$BDLDevicePowerIoCompletion$17$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_41#1;

  inline$BDLDevicePowerIoCompletion$17$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_42#1;

  inline$BDLDevicePowerIoCompletion$17$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_41#1;

  inline$BDLDevicePowerIoCompletion$17$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_41_true#1, inline$BDLDevicePowerIoCompletion$17$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$17$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$17$label_43#1;

  inline$BDLDevicePowerIoCompletion$17$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$17$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$17$label_44#1;

  inline$BDLDevicePowerIoCompletion$17$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_44_true#1, inline$BDLDevicePowerIoCompletion$17$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$17$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$17$label_45#1;

  inline$BDLDevicePowerIoCompletion$17$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_45_true#1, inline$BDLDevicePowerIoCompletion$17$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$17$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$17$label_43#1;

  inline$BDLDevicePowerIoCompletion$17$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$17$label_86#1;

  inline$BDLDevicePowerIoCompletion$17$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$17$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$17$label_46#1;

  inline$BDLDevicePowerIoCompletion$17$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$17$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$17$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$17$label_46#1;

  inline$BDLDevicePowerIoCompletion$17$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$17$label_49#1;

  inline$BDLDevicePowerIoCompletion$17$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_50#1;

  inline$BDLDevicePowerIoCompletion$17$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_51#1;

  inline$BDLDevicePowerIoCompletion$17$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_54#1;

  inline$BDLDevicePowerIoCompletion$17$label_54#1:
    inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$17$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$17$label_55#1;

  inline$BDLDevicePowerIoCompletion$17$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_55_true#1, inline$BDLDevicePowerIoCompletion$17$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_56#1;

  inline$BDLDevicePowerIoCompletion$17$label_56#1:
    call inline$BDLDevicePowerIoCompletion$17$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$17$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$17$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$17$anon34_Then#1, inline$BDLDevicePowerIoCompletion$17$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon9#1;

  inline$BDLDevicePowerIoCompletion$17$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_83#1;

  inline$BDLDevicePowerIoCompletion$17$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_59#1;

  inline$BDLDevicePowerIoCompletion$17$label_59#1:
    goto inline$BDLGetDebugLevel$454$Entry#1;

  inline$BDLGetDebugLevel$454$Entry#1:
    goto inline$BDLGetDebugLevel$454$start#1;

  inline$BDLGetDebugLevel$454$start#1:
    goto inline$BDLGetDebugLevel$454$label_3#1;

  inline$BDLGetDebugLevel$454$label_3#1:
    havoc inline$BDLGetDebugLevel$454$myNondetVar_0;
    inline$BDLGetDebugLevel$454$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$454$myNondetVar_0;
    goto inline$BDLGetDebugLevel$454$label_1#1;

  inline$BDLGetDebugLevel$454$label_1#1:
    goto inline$BDLGetDebugLevel$454$Return#1;

  inline$BDLGetDebugLevel$454$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$454$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon35_Then#1, inline$BDLDevicePowerIoCompletion$17$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon11#1;

  inline$BDLDevicePowerIoCompletion$17$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_62#1;

  inline$BDLDevicePowerIoCompletion$17$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_62_true#1, inline$BDLDevicePowerIoCompletion$17$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_63#1;

  inline$BDLDevicePowerIoCompletion$17$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_66#1;

  inline$BDLDevicePowerIoCompletion$17$label_66#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_67#1;

  inline$BDLDevicePowerIoCompletion$17$label_67#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_68#1;

  inline$BDLDevicePowerIoCompletion$17$label_68#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_69#1;

  inline$BDLDevicePowerIoCompletion$17$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$17$label_63#1;

  inline$BDLDevicePowerIoCompletion$17$label_63#1:
    goto inline$BDLGetDebugLevel$455$Entry#1;

  inline$BDLGetDebugLevel$455$Entry#1:
    goto inline$BDLGetDebugLevel$455$start#1;

  inline$BDLGetDebugLevel$455$start#1:
    goto inline$BDLGetDebugLevel$455$label_3#1;

  inline$BDLGetDebugLevel$455$label_3#1:
    havoc inline$BDLGetDebugLevel$455$myNondetVar_0;
    inline$BDLGetDebugLevel$455$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$455$myNondetVar_0;
    goto inline$BDLGetDebugLevel$455$label_1#1;

  inline$BDLGetDebugLevel$455$label_1#1:
    goto inline$BDLGetDebugLevel$455$Return#1;

  inline$BDLGetDebugLevel$455$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$455$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon36_Then#1, inline$BDLDevicePowerIoCompletion$17$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon13#1;

  inline$BDLDevicePowerIoCompletion$17$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_72#1;

  inline$BDLDevicePowerIoCompletion$17$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_72_true#1, inline$BDLDevicePowerIoCompletion$17$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_73#1;

  inline$BDLDevicePowerIoCompletion$17$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_76#1;

  inline$BDLDevicePowerIoCompletion$17$label_76#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_77#1;

  inline$BDLDevicePowerIoCompletion$17$label_77#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_78#1;

  inline$BDLDevicePowerIoCompletion$17$label_78#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_79#1;

  inline$BDLDevicePowerIoCompletion$17$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$17$label_73#1;

  inline$BDLDevicePowerIoCompletion$17$label_73#1:
    goto inline$BDLGetDebugLevel$456$Entry#1;

  inline$BDLGetDebugLevel$456$Entry#1:
    goto inline$BDLGetDebugLevel$456$start#1;

  inline$BDLGetDebugLevel$456$start#1:
    goto inline$BDLGetDebugLevel$456$label_3#1;

  inline$BDLGetDebugLevel$456$label_3#1:
    havoc inline$BDLGetDebugLevel$456$myNondetVar_0;
    inline$BDLGetDebugLevel$456$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$456$myNondetVar_0;
    goto inline$BDLGetDebugLevel$456$label_1#1;

  inline$BDLGetDebugLevel$456$label_1#1:
    goto inline$BDLGetDebugLevel$456$Return#1;

  inline$BDLGetDebugLevel$456$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$456$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon37_Then#1, inline$BDLDevicePowerIoCompletion$17$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon15#1;

  inline$BDLDevicePowerIoCompletion$17$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_82#1;

  inline$BDLDevicePowerIoCompletion$17$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_82_true#1, inline$BDLDevicePowerIoCompletion$17$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_83#1;

  inline$BDLDevicePowerIoCompletion$17$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_84#1;

  inline$BDLDevicePowerIoCompletion$17$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_83#1;

  inline$BDLDevicePowerIoCompletion$17$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_85#1;

  inline$BDLDevicePowerIoCompletion$17$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_86#1;

  inline$BDLDevicePowerIoCompletion$17$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$17$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$17$anon38_Then#1, inline$BDLDevicePowerIoCompletion$17$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon17#1;

  inline$BDLDevicePowerIoCompletion$17$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_89#1;

  inline$BDLDevicePowerIoCompletion$17$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$17$anon39_Then#1, inline$BDLDevicePowerIoCompletion$17$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon19#1;

  inline$BDLDevicePowerIoCompletion$17$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_92#1;

  inline$BDLDevicePowerIoCompletion$17$label_92#1:
    goto inline$storm_IoCompleteRequest$35$Entry#1;

  inline$storm_IoCompleteRequest$35$Entry#1:
    inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$17$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$35$start#1;

  inline$storm_IoCompleteRequest$35$start#1:
    inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$35$label_3#1;

  inline$storm_IoCompleteRequest$35$label_3#1:
    call inline$storm_IoCompleteRequest$35$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$35$label_6#1;

  inline$storm_IoCompleteRequest$35$label_6#1:
    goto inline$storm_IoCompleteRequest$35$label_6_true#1, inline$storm_IoCompleteRequest$35$label_6_false#1;

  inline$storm_IoCompleteRequest$35$label_6_false#1:
    assume inline$storm_IoCompleteRequest$35$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$35$label_7#1;

  inline$storm_IoCompleteRequest$35$label_6_true#1:
    assume inline$storm_IoCompleteRequest$35$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$35$label_8#1;

  inline$storm_IoCompleteRequest$35$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$35$anon3_Then#1, inline$storm_IoCompleteRequest$35$anon3_Else#1;

  inline$storm_IoCompleteRequest$35$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$35$anon1#1;

  inline$storm_IoCompleteRequest$35$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$35$label_9#1;

  inline$storm_IoCompleteRequest$35$label_9#1:
    goto inline$storm_IoCompleteRequest$35$label_9_true#1, inline$storm_IoCompleteRequest$35$label_9_false#1;

  inline$storm_IoCompleteRequest$35$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$35$label_10#1;

  inline$storm_IoCompleteRequest$35$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$35$label_1#1;

  inline$storm_IoCompleteRequest$35$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$35$label_7#1;

  inline$storm_IoCompleteRequest$35$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$35$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$35$label_1#1;

  inline$storm_IoCompleteRequest$35$label_1#1:
    goto inline$storm_IoCompleteRequest$35$Return#1;

  inline$storm_IoCompleteRequest$35$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$35$Return#1;

  inline$storm_IoCompleteRequest$35$Return#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon40_Then#1, inline$BDLDevicePowerIoCompletion$17$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon21#1;

  inline$BDLDevicePowerIoCompletion$17$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_95#1;

  inline$BDLDevicePowerIoCompletion$17$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$17$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$17$anon41_Then#1, inline$BDLDevicePowerIoCompletion$17$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon23#1;

  inline$BDLDevicePowerIoCompletion$17$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_98#1;

  inline$BDLDevicePowerIoCompletion$17$label_98#1:
    goto inline$BDLGetDebugLevel$457$Entry#1;

  inline$BDLGetDebugLevel$457$Entry#1:
    goto inline$BDLGetDebugLevel$457$start#1;

  inline$BDLGetDebugLevel$457$start#1:
    goto inline$BDLGetDebugLevel$457$label_3#1;

  inline$BDLGetDebugLevel$457$label_3#1:
    havoc inline$BDLGetDebugLevel$457$myNondetVar_0;
    inline$BDLGetDebugLevel$457$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$457$myNondetVar_0;
    goto inline$BDLGetDebugLevel$457$label_1#1;

  inline$BDLGetDebugLevel$457$label_1#1:
    goto inline$BDLGetDebugLevel$457$Return#1;

  inline$BDLGetDebugLevel$457$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$457$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon42_Then#1, inline$BDLDevicePowerIoCompletion$17$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon25#1;

  inline$BDLDevicePowerIoCompletion$17$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_101#1;

  inline$BDLDevicePowerIoCompletion$17$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_101_true#1, inline$BDLDevicePowerIoCompletion$17$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_102#1;

  inline$BDLDevicePowerIoCompletion$17$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_105#1;

  inline$BDLDevicePowerIoCompletion$17$label_105#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_106#1;

  inline$BDLDevicePowerIoCompletion$17$label_106#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_107#1;

  inline$BDLDevicePowerIoCompletion$17$label_107#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_108#1;

  inline$BDLDevicePowerIoCompletion$17$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$17$label_102#1;

  inline$BDLDevicePowerIoCompletion$17$label_102#1:
    goto inline$BDLGetDebugLevel$458$Entry#1;

  inline$BDLGetDebugLevel$458$Entry#1:
    goto inline$BDLGetDebugLevel$458$start#1;

  inline$BDLGetDebugLevel$458$start#1:
    goto inline$BDLGetDebugLevel$458$label_3#1;

  inline$BDLGetDebugLevel$458$label_3#1:
    havoc inline$BDLGetDebugLevel$458$myNondetVar_0;
    inline$BDLGetDebugLevel$458$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$458$myNondetVar_0;
    goto inline$BDLGetDebugLevel$458$label_1#1;

  inline$BDLGetDebugLevel$458$label_1#1:
    goto inline$BDLGetDebugLevel$458$Return#1;

  inline$BDLGetDebugLevel$458$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$458$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon43_Then#1, inline$BDLDevicePowerIoCompletion$17$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon27#1;

  inline$BDLDevicePowerIoCompletion$17$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_111#1;

  inline$BDLDevicePowerIoCompletion$17$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_111_true#1, inline$BDLDevicePowerIoCompletion$17$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_112#1;

  inline$BDLDevicePowerIoCompletion$17$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_115#1;

  inline$BDLDevicePowerIoCompletion$17$label_115#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_116#1;

  inline$BDLDevicePowerIoCompletion$17$label_116#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_117#1;

  inline$BDLDevicePowerIoCompletion$17$label_117#1:
    call inline$BDLDevicePowerIoCompletion$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$17$label_118#1;

  inline$BDLDevicePowerIoCompletion$17$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$17$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$17$label_112#1;

  inline$BDLDevicePowerIoCompletion$17$label_112#1:
    goto inline$BDLGetDebugLevel$459$Entry#1;

  inline$BDLGetDebugLevel$459$Entry#1:
    goto inline$BDLGetDebugLevel$459$start#1;

  inline$BDLGetDebugLevel$459$start#1:
    goto inline$BDLGetDebugLevel$459$label_3#1;

  inline$BDLGetDebugLevel$459$label_3#1:
    havoc inline$BDLGetDebugLevel$459$myNondetVar_0;
    inline$BDLGetDebugLevel$459$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$459$myNondetVar_0;
    goto inline$BDLGetDebugLevel$459$label_1#1;

  inline$BDLGetDebugLevel$459$label_1#1:
    goto inline$BDLGetDebugLevel$459$Return#1;

  inline$BDLGetDebugLevel$459$Return#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$459$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$17$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$17$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$17$anon44_Then#1, inline$BDLDevicePowerIoCompletion$17$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$17$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$anon29#1;

  inline$BDLDevicePowerIoCompletion$17$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_121#1;

  inline$BDLDevicePowerIoCompletion$17$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_121_true#1, inline$BDLDevicePowerIoCompletion$17$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$17$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_122#1;

  inline$BDLDevicePowerIoCompletion$17$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$17$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$17$label_123#1;

  inline$BDLDevicePowerIoCompletion$17$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$17$label_122#1;

  inline$BDLDevicePowerIoCompletion$17$label_122#1:
    inline$BDLDevicePowerIoCompletion$17$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$17$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$17$label_1#1;

  inline$BDLDevicePowerIoCompletion$17$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$17$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$17$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$17$Return#1;

  inline$BDLDevicePowerIoCompletion$17$Return#1:
    inline$CallCompletionRoutine$17$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$17$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$17$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$17$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$17$anon13_Then#1, inline$CallCompletionRoutine$17$anon13_Else#1;

  inline$CallCompletionRoutine$17$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$17$anon7#1;

  inline$CallCompletionRoutine$17$anon7#1:
    goto inline$CallCompletionRoutine$17$label_20_icall_return#1;

  inline$CallCompletionRoutine$17$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$17$Return#1;

  inline$CallCompletionRoutine$17$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$17$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$17$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$17$Entry#1;

  inline$BDLCallDriverCompletionRoutine$17$Entry#1:
    inline$BDLCallDriverCompletionRoutine$17$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$17$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$17$start#1;

  inline$BDLCallDriverCompletionRoutine$17$start#1:
    inline$BDLCallDriverCompletionRoutine$17$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$17$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$17$label_3#1;

  inline$BDLCallDriverCompletionRoutine$17$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$17$label_3_true#1, inline$BDLCallDriverCompletionRoutine$17$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$17$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$17$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$17$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$17$label_4#1;

  inline$BDLCallDriverCompletionRoutine$17$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$17$label_6#1;

  inline$BDLCallDriverCompletionRoutine$17$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$17$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$17$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$17$label_5#1;

  inline$BDLCallDriverCompletionRoutine$17$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$17$label_6#1;

  inline$BDLCallDriverCompletionRoutine$17$label_6#1:
    goto inline$storm_KeSetEvent$19$Entry#1;

  inline$storm_KeSetEvent$19$Entry#1:
    inline$storm_KeSetEvent$19$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$17$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$19$start#1;

  inline$storm_KeSetEvent$19$start#1:
    inline$storm_KeSetEvent$19$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$19$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$19$label_3#1;

  inline$storm_KeSetEvent$19$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$19$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$19$label_1#1;

  inline$storm_KeSetEvent$19$label_1#1:
    goto inline$storm_KeSetEvent$19$Return#1;

  inline$storm_KeSetEvent$19$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$17$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$17$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$17$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$17$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$17$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$17$anon1#1;

  inline$BDLCallDriverCompletionRoutine$17$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$17$label_9#1;

  inline$BDLCallDriverCompletionRoutine$17$label_9#1:
    inline$BDLCallDriverCompletionRoutine$17$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$17$label_1#1;

  inline$BDLCallDriverCompletionRoutine$17$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$17$Return#1;

  inline$BDLCallDriverCompletionRoutine$17$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$17$Return#1;

  inline$BDLCallDriverCompletionRoutine$17$Return#1:
    inline$CallCompletionRoutine$17$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$17$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$17$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$17$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$17$anon12_Then#1, inline$CallCompletionRoutine$17$anon12_Else#1;

  inline$CallCompletionRoutine$17$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$17$anon5#1;

  inline$CallCompletionRoutine$17$anon5#1:
    goto inline$CallCompletionRoutine$17$label_20_icall_return#1;

  inline$CallCompletionRoutine$17$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$17$label_23#1;

  inline$CallCompletionRoutine$17$label_23#1:
    inline$CallCompletionRoutine$17$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$17$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$17$label_24#1;

  inline$CallCompletionRoutine$17$label_24#1:
    goto inline$CallCompletionRoutine$17$label_24_true#1, inline$CallCompletionRoutine$17$label_24_false#1;

  inline$CallCompletionRoutine$17$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$17$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$17$label_1#1;

  inline$CallCompletionRoutine$17$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$17$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$17$label_25#1;

  inline$CallCompletionRoutine$17$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$17$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$17$label_1#1;

  inline$CallCompletionRoutine$17$label_1#1:
    goto inline$CallCompletionRoutine$17$Return#1;

  inline$CallCompletionRoutine$17$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$17$Return#1;

  inline$CallCompletionRoutine$17$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$17$Return#1;

  inline$CallCompletionRoutine$17$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$17$Return#1;

  inline$CallCompletionRoutine$17$Return#1:
    goto inline$storm_IoCallDriver$8$label_39$1#1;

  inline$storm_IoCallDriver$8$label_39$1#1:
    goto inline$storm_IoCallDriver$8$anon15_Then#1, inline$storm_IoCallDriver$8$anon15_Else#1;

  inline$storm_IoCallDriver$8$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$8$anon10#1;

  inline$storm_IoCallDriver$8$anon10#1:
    goto inline$storm_IoCallDriver$8$label_36#1;

  inline$storm_IoCallDriver$8$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$8$Return#1;

  inline$storm_IoCallDriver$8$label_27_case_0#1:
    assume inline$storm_IoCallDriver$8$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$8$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$8$label_28#1;

  inline$storm_IoCallDriver$8$label_28#1:
    inline$storm_IoCallDriver$8$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$8$label_42#1;

  inline$storm_IoCallDriver$8$label_42#1:
    goto inline$storm_IoCallDriver$8$label_43#1;

  inline$storm_IoCallDriver$8$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$8$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$8$label_36#1;

  inline$storm_IoCallDriver$8$label_36#1:
    inline$storm_IoCallDriver$8$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$8$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$8$label_1#1;

  inline$storm_IoCallDriver$8$label_1#1:
    goto inline$storm_IoCallDriver$8$Return#1;

  inline$storm_IoCallDriver$8$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$8$Return#1;

  inline$storm_IoCallDriver$8$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$8$Return#1;

  inline$storm_IoCallDriver$8$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$8$Return#1;

  inline$storm_IoCallDriver$8$Return#1:
    inline$storm_PoCallDriver$3$$result.storm_IoCallDriver$499.27$2$ := inline$storm_IoCallDriver$8$$result.storm_IoCallDriver$456.0$1$;
    goto inline$storm_PoCallDriver$3$label_3$1#1;

  inline$storm_PoCallDriver$3$label_3$1#1:
    goto inline$storm_PoCallDriver$3$anon2_Then#1, inline$storm_PoCallDriver$3$anon2_Else#1;

  inline$storm_PoCallDriver$3$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_PoCallDriver$3$anon1#1;

  inline$storm_PoCallDriver$3$anon1#1:
    goto inline$storm_PoCallDriver$3$label_6#1;

  inline$storm_PoCallDriver$3$label_6#1:
    inline$storm_PoCallDriver$3$$result.storm_PoCallDriver$494.0$1$ := inline$storm_PoCallDriver$3$$result.storm_IoCallDriver$499.27$2$;
    goto inline$storm_PoCallDriver$3$label_1#1;

  inline$storm_PoCallDriver$3$label_1#1:
    goto inline$storm_PoCallDriver$3$Return#1;

  inline$storm_PoCallDriver$3$anon2_Then#1:
    assume raiseException;
    goto inline$storm_PoCallDriver$3$Return#1;

  inline$storm_PoCallDriver$3$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_PoCallDriver$104.29$3$ := inline$storm_PoCallDriver$3$$result.storm_PoCallDriver$494.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_25$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_25$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon22_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon22_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon13#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon13#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_28#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_28#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_PoCallDriver$104.29$3$;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_29_true#1, inline$BDLCallLowerLevelDriverAndWait$3$label_29_false#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_29_false#1:
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_29_true#1:
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_31#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_31#1:
    goto inline$storm_KeWaitForSingleObject$3$Entry#1;

  inline$storm_KeWaitForSingleObject$3$Entry#1:
    inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1 := inline$BDLCallLowerLevelDriverAndWait$3$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1 := 0;
    goto inline$storm_KeWaitForSingleObject$3$start#1;

  inline$storm_KeWaitForSingleObject$3$start#1:
    inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1;
    inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1;
    goto inline$storm_KeWaitForSingleObject$3$label_3#1;

  inline$storm_KeWaitForSingleObject$3$label_3#1:
    goto inline$storm_KeWaitForSingleObject$3$label_3_true#1, inline$storm_KeWaitForSingleObject$3$label_3_false#1;

  inline$storm_KeWaitForSingleObject$3$label_3_false#1:
    assume inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 == 0;
    goto inline$storm_KeWaitForSingleObject$3$label_4#1;

  inline$storm_KeWaitForSingleObject$3$label_4#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$3$anon6_Then#1, inline$storm_KeWaitForSingleObject$3$anon6_Else#1;

  inline$storm_KeWaitForSingleObject$3$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$3$anon1#1;

  inline$storm_KeWaitForSingleObject$3$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$3$label_13#1;

  inline$storm_KeWaitForSingleObject$3$label_13#1:
    inline$storm_KeWaitForSingleObject$3$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$3$label_1#1;

  inline$storm_KeWaitForSingleObject$3$anon6_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$3$Return#1;

  inline$storm_KeWaitForSingleObject$3$label_3_true#1:
    assume inline$storm_KeWaitForSingleObject$3$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 != 0;
    goto inline$storm_KeWaitForSingleObject$3$label_5#1;

  inline$storm_KeWaitForSingleObject$3$label_5#1:
    call inline$storm_KeWaitForSingleObject$3$$result.storm_nondet$256.20$2$ := storm_nondet();
    goto inline$storm_KeWaitForSingleObject$3$label_8#1;

  inline$storm_KeWaitForSingleObject$3$label_8#1:
    goto inline$storm_KeWaitForSingleObject$3$label_8_true#1, inline$storm_KeWaitForSingleObject$3$label_8_false#1;

  inline$storm_KeWaitForSingleObject$3$label_8_false#1:
    assume inline$storm_KeWaitForSingleObject$3$$result.storm_nondet$256.20$2$ == 0;
    goto inline$storm_KeWaitForSingleObject$3$label_9#1;

  inline$storm_KeWaitForSingleObject$3$label_9#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$3$anon7_Then#1, inline$storm_KeWaitForSingleObject$3$anon7_Else#1;

  inline$storm_KeWaitForSingleObject$3$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$3$anon3#1;

  inline$storm_KeWaitForSingleObject$3$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20], 0);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$3$label_12#1;

  inline$storm_KeWaitForSingleObject$3$label_12#1:
    inline$storm_KeWaitForSingleObject$3$$result.storm_KeWaitForSingleObject$243.0$1$ := 258;
    goto inline$storm_KeWaitForSingleObject$3$label_1#1;

  inline$storm_KeWaitForSingleObject$3$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$3$Return#1;

  inline$storm_KeWaitForSingleObject$3$label_8_true#1:
    assume inline$storm_KeWaitForSingleObject$3$$result.storm_nondet$256.20$2$ != 0;
    goto inline$storm_KeWaitForSingleObject$3$label_10#1;

  inline$storm_KeWaitForSingleObject$3$label_10#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$3$anon8_Then#1, inline$storm_KeWaitForSingleObject$3$anon8_Else#1;

  inline$storm_KeWaitForSingleObject$3$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$3$anon5#1;

  inline$storm_KeWaitForSingleObject$3$anon5#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$3$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$3$label_11#1;

  inline$storm_KeWaitForSingleObject$3$label_11#1:
    inline$storm_KeWaitForSingleObject$3$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$3$label_1#1;

  inline$storm_KeWaitForSingleObject$3$label_1#1:
    goto inline$storm_KeWaitForSingleObject$3$Return#1;

  inline$storm_KeWaitForSingleObject$3$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$3$Return#1;

  inline$storm_KeWaitForSingleObject$3$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_KeWaitForSingleObject$116.38$5$ := inline$storm_KeWaitForSingleObject$3$$result.storm_KeWaitForSingleObject$243.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_31$1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_31$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon23_Then#1, inline$BDLCallLowerLevelDriverAndWait$3$anon23_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$anon15#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon15#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_34#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_34#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$3$$result.storm_KeWaitForSingleObject$116.38$5$;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_35#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_35#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_35_true#1, inline$BDLCallLowerLevelDriverAndWait$3$label_35_false#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_35_false#1:
    assume inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 == 0;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_35_true#1:
    assume inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 != 0;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_37#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_37#1:
    call inline$BDLCallLowerLevelDriverAndWait$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_38#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_38#1:
    call inline$BDLCallLowerLevelDriverAndWait$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_39#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_39#1:
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_36#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0;
    inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$3$myNondetVar_0;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_30#1:
    inline$BDLCallLowerLevelDriverAndWait$3$$result.BDLCallLowerLevelDriverAndWait$71.0$1$ := inline$BDLCallLowerLevelDriverAndWait$3$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8;
    goto inline$BDLCallLowerLevelDriverAndWait$3$label_1#1;

  inline$BDLCallLowerLevelDriverAndWait$3$label_1#1:
    call __HAVOC_free(inline$BDLCallLowerLevelDriverAndWait$3$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon23_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon22_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon21_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$3$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$3$Return#1:
    inline$BDLPnPStop$0$$result.BDLCallLowerLevelDriverAndWait$2227.43$26$ := inline$BDLCallLowerLevelDriverAndWait$3$$result.BDLCallLowerLevelDriverAndWait$71.0$1$;
    goto inline$BDLPnPStop$0$label_92$1#1;

  inline$BDLPnPStop$0$label_92$1#1:
    goto inline$BDLPnPStop$0$anon38_Then#1, inline$BDLPnPStop$0$anon38_Else#1;

  inline$BDLPnPStop$0$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon21#1;

  inline$BDLPnPStop$0$anon21#1:
    goto inline$BDLPnPStop$0$label_95#1;

  inline$BDLPnPStop$0$label_95#1:
    inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 := inline$BDLPnPStop$0$$result.BDLCallLowerLevelDriverAndWait$2227.43$26$;
    goto inline$BDLPnPStop$0$label_96#1;

  inline$BDLPnPStop$0$label_96#1:
    goto inline$BDLPnPStop$0$label_96_true#1, inline$BDLPnPStop$0$label_96_false#1;

  inline$BDLPnPStop$0$label_96_false#1:
    assume inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 == 0;
    goto inline$BDLPnPStop$0$label_65#1;

  inline$BDLPnPStop$0$label_96_true#1:
    assume inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 != 0;
    goto inline$BDLPnPStop$0$label_97#1;

  inline$BDLPnPStop$0$label_97#1:
    goto inline$BDLGetDebugLevel$472$Entry#1;

  inline$BDLGetDebugLevel$472$Entry#1:
    goto inline$BDLGetDebugLevel$472$start#1;

  inline$BDLGetDebugLevel$472$start#1:
    goto inline$BDLGetDebugLevel$472$label_3#1;

  inline$BDLGetDebugLevel$472$label_3#1:
    havoc inline$BDLGetDebugLevel$472$myNondetVar_0;
    inline$BDLGetDebugLevel$472$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$472$myNondetVar_0;
    goto inline$BDLGetDebugLevel$472$label_1#1;

  inline$BDLGetDebugLevel$472$label_1#1:
    goto inline$BDLGetDebugLevel$472$Return#1;

  inline$BDLGetDebugLevel$472$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$27$ := inline$BDLGetDebugLevel$472$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_97$1#1;

  inline$BDLPnPStop$0$label_97$1#1:
    goto inline$BDLPnPStop$0$anon39_Then#1, inline$BDLPnPStop$0$anon39_Else#1;

  inline$BDLPnPStop$0$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon23#1;

  inline$BDLPnPStop$0$anon23#1:
    goto inline$BDLPnPStop$0$label_100#1;

  inline$BDLPnPStop$0$label_100#1:
    goto inline$BDLPnPStop$0$label_100_true#1, inline$BDLPnPStop$0$label_100_false#1;

  inline$BDLPnPStop$0$label_100_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$27$) == 0;
    goto inline$BDLPnPStop$0$label_101#1;

  inline$BDLPnPStop$0$label_100_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$27$) != 0;
    goto inline$BDLPnPStop$0$label_104#1;

  inline$BDLPnPStop$0$label_104#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_105#1;

  inline$BDLPnPStop$0$label_105#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_106#1;

  inline$BDLPnPStop$0$label_106#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_107#1;

  inline$BDLPnPStop$0$label_107#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2231.0$28$;
    goto inline$BDLPnPStop$0$label_101#1;

  inline$BDLPnPStop$0$label_101#1:
    goto inline$BDLGetDebugLevel$473$Entry#1;

  inline$BDLGetDebugLevel$473$Entry#1:
    goto inline$BDLGetDebugLevel$473$start#1;

  inline$BDLGetDebugLevel$473$start#1:
    goto inline$BDLGetDebugLevel$473$label_3#1;

  inline$BDLGetDebugLevel$473$label_3#1:
    havoc inline$BDLGetDebugLevel$473$myNondetVar_0;
    inline$BDLGetDebugLevel$473$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$473$myNondetVar_0;
    goto inline$BDLGetDebugLevel$473$label_1#1;

  inline$BDLGetDebugLevel$473$label_1#1:
    goto inline$BDLGetDebugLevel$473$Return#1;

  inline$BDLGetDebugLevel$473$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$32$ := inline$BDLGetDebugLevel$473$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_101$1#1;

  inline$BDLPnPStop$0$label_101$1#1:
    goto inline$BDLPnPStop$0$anon40_Then#1, inline$BDLPnPStop$0$anon40_Else#1;

  inline$BDLPnPStop$0$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon25#1;

  inline$BDLPnPStop$0$anon25#1:
    goto inline$BDLPnPStop$0$label_110#1;

  inline$BDLPnPStop$0$label_110#1:
    goto inline$BDLPnPStop$0$label_110_true#1, inline$BDLPnPStop$0$label_110_false#1;

  inline$BDLPnPStop$0$label_110_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$32$) == 0;
    goto inline$BDLPnPStop$0$label_111#1;

  inline$BDLPnPStop$0$label_110_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$32$) != 0;
    goto inline$BDLPnPStop$0$label_114#1;

  inline$BDLPnPStop$0$label_114#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_115#1;

  inline$BDLPnPStop$0$label_115#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_116#1;

  inline$BDLPnPStop$0$label_116#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_117#1;

  inline$BDLPnPStop$0$label_117#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2231.0$33$;
    goto inline$BDLPnPStop$0$label_111#1;

  inline$BDLPnPStop$0$label_111#1:
    goto inline$BDLGetDebugLevel$474$Entry#1;

  inline$BDLGetDebugLevel$474$Entry#1:
    goto inline$BDLGetDebugLevel$474$start#1;

  inline$BDLGetDebugLevel$474$start#1:
    goto inline$BDLGetDebugLevel$474$label_3#1;

  inline$BDLGetDebugLevel$474$label_3#1:
    havoc inline$BDLGetDebugLevel$474$myNondetVar_0;
    inline$BDLGetDebugLevel$474$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$474$myNondetVar_0;
    goto inline$BDLGetDebugLevel$474$label_1#1;

  inline$BDLGetDebugLevel$474$label_1#1:
    goto inline$BDLGetDebugLevel$474$Return#1;

  inline$BDLGetDebugLevel$474$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$37$ := inline$BDLGetDebugLevel$474$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_111$1#1;

  inline$BDLPnPStop$0$label_111$1#1:
    goto inline$BDLPnPStop$0$anon41_Then#1, inline$BDLPnPStop$0$anon41_Else#1;

  inline$BDLPnPStop$0$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon27#1;

  inline$BDLPnPStop$0$anon27#1:
    goto inline$BDLPnPStop$0$label_120#1;

  inline$BDLPnPStop$0$label_120#1:
    goto inline$BDLPnPStop$0$label_120_true#1, inline$BDLPnPStop$0$label_120_false#1;

  inline$BDLPnPStop$0$label_120_false#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$37$, 4) == 0;
    goto inline$BDLPnPStop$0$label_65#1;

  inline$BDLPnPStop$0$label_120_true#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2231.0$37$, 4) != 0;
    goto inline$BDLPnPStop$0$label_121#1;

  inline$BDLPnPStop$0$label_121#1:
    goto inline$BDLPnPStop$0$label_65#1;

  inline$BDLPnPStop$0$anon41_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon40_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon39_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon38_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$label_39_true#1:
    assume inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12 != 0;
    goto inline$BDLPnPStop$0$label_41#1;

  inline$BDLPnPStop$0$label_41#1:
    goto inline$BDLGetDebugLevel$382$Entry#1;

  inline$BDLGetDebugLevel$382$Entry#1:
    goto inline$BDLGetDebugLevel$382$start#1;

  inline$BDLGetDebugLevel$382$start#1:
    goto inline$BDLGetDebugLevel$382$label_3#1;

  inline$BDLGetDebugLevel$382$label_3#1:
    havoc inline$BDLGetDebugLevel$382$myNondetVar_0;
    inline$BDLGetDebugLevel$382$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$382$myNondetVar_0;
    goto inline$BDLGetDebugLevel$382$label_1#1;

  inline$BDLGetDebugLevel$382$label_1#1:
    goto inline$BDLGetDebugLevel$382$Return#1;

  inline$BDLGetDebugLevel$382$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$15$ := inline$BDLGetDebugLevel$382$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_41$1#1;

  inline$BDLPnPStop$0$label_41$1#1:
    goto inline$BDLPnPStop$0$anon32_Then#1, inline$BDLPnPStop$0$anon32_Else#1;

  inline$BDLPnPStop$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon9#1;

  inline$BDLPnPStop$0$anon9#1:
    goto inline$BDLPnPStop$0$label_44#1;

  inline$BDLPnPStop$0$label_44#1:
    goto inline$BDLPnPStop$0$label_44_true#1, inline$BDLPnPStop$0$label_44_false#1;

  inline$BDLPnPStop$0$label_44_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$15$) == 0;
    goto inline$BDLPnPStop$0$label_45#1;

  inline$BDLPnPStop$0$label_44_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$15$) != 0;
    goto inline$BDLPnPStop$0$label_48#1;

  inline$BDLPnPStop$0$label_48#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_49#1;

  inline$BDLPnPStop$0$label_49#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_50#1;

  inline$BDLPnPStop$0$label_50#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_51#1;

  inline$BDLPnPStop$0$label_51#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2208.0$16$;
    goto inline$BDLPnPStop$0$label_45#1;

  inline$BDLPnPStop$0$label_45#1:
    goto inline$BDLGetDebugLevel$383$Entry#1;

  inline$BDLGetDebugLevel$383$Entry#1:
    goto inline$BDLGetDebugLevel$383$start#1;

  inline$BDLGetDebugLevel$383$start#1:
    goto inline$BDLGetDebugLevel$383$label_3#1;

  inline$BDLGetDebugLevel$383$label_3#1:
    havoc inline$BDLGetDebugLevel$383$myNondetVar_0;
    inline$BDLGetDebugLevel$383$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$383$myNondetVar_0;
    goto inline$BDLGetDebugLevel$383$label_1#1;

  inline$BDLGetDebugLevel$383$label_1#1:
    goto inline$BDLGetDebugLevel$383$Return#1;

  inline$BDLGetDebugLevel$383$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$20$ := inline$BDLGetDebugLevel$383$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_45$1#1;

  inline$BDLPnPStop$0$label_45$1#1:
    goto inline$BDLPnPStop$0$anon33_Then#1, inline$BDLPnPStop$0$anon33_Else#1;

  inline$BDLPnPStop$0$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon11#1;

  inline$BDLPnPStop$0$anon11#1:
    goto inline$BDLPnPStop$0$label_54#1;

  inline$BDLPnPStop$0$label_54#1:
    goto inline$BDLPnPStop$0$label_54_true#1, inline$BDLPnPStop$0$label_54_false#1;

  inline$BDLPnPStop$0$label_54_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$20$) == 0;
    goto inline$BDLPnPStop$0$label_55#1;

  inline$BDLPnPStop$0$label_54_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$20$) != 0;
    goto inline$BDLPnPStop$0$label_58#1;

  inline$BDLPnPStop$0$label_58#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_59#1;

  inline$BDLPnPStop$0$label_59#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_60#1;

  inline$BDLPnPStop$0$label_60#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_61#1;

  inline$BDLPnPStop$0$label_61#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2208.0$21$;
    goto inline$BDLPnPStop$0$label_55#1;

  inline$BDLPnPStop$0$label_55#1:
    goto inline$BDLGetDebugLevel$384$Entry#1;

  inline$BDLGetDebugLevel$384$Entry#1:
    goto inline$BDLGetDebugLevel$384$start#1;

  inline$BDLGetDebugLevel$384$start#1:
    goto inline$BDLGetDebugLevel$384$label_3#1;

  inline$BDLGetDebugLevel$384$label_3#1:
    havoc inline$BDLGetDebugLevel$384$myNondetVar_0;
    inline$BDLGetDebugLevel$384$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$384$myNondetVar_0;
    goto inline$BDLGetDebugLevel$384$label_1#1;

  inline$BDLGetDebugLevel$384$label_1#1:
    goto inline$BDLGetDebugLevel$384$Return#1;

  inline$BDLGetDebugLevel$384$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$25$ := inline$BDLGetDebugLevel$384$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_55$1#1;

  inline$BDLPnPStop$0$label_55$1#1:
    goto inline$BDLPnPStop$0$anon34_Then#1, inline$BDLPnPStop$0$anon34_Else#1;

  inline$BDLPnPStop$0$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon13#1;

  inline$BDLPnPStop$0$anon13#1:
    goto inline$BDLPnPStop$0$label_64#1;

  inline$BDLPnPStop$0$label_64#1:
    goto inline$BDLPnPStop$0$label_64_true#1, inline$BDLPnPStop$0$label_64_false#1;

  inline$BDLPnPStop$0$label_64_false#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$25$, 4) == 0;
    goto inline$BDLPnPStop$0$label_65#1;

  inline$BDLPnPStop$0$label_64_true#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2208.0$25$, 4) != 0;
    goto inline$BDLPnPStop$0$label_68#1;

  inline$BDLPnPStop$0$label_68#1:
    goto inline$BDLPnPStop$0$label_65#1;

  inline$BDLPnPStop$0$label_65#1:
    goto inline$BDLGetDebugLevel$385$Entry#1;

  inline$BDLGetDebugLevel$385$Entry#1:
    goto inline$BDLGetDebugLevel$385$start#1;

  inline$BDLGetDebugLevel$385$start#1:
    goto inline$BDLGetDebugLevel$385$label_3#1;

  inline$BDLGetDebugLevel$385$label_3#1:
    havoc inline$BDLGetDebugLevel$385$myNondetVar_0;
    inline$BDLGetDebugLevel$385$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$385$myNondetVar_0;
    goto inline$BDLGetDebugLevel$385$label_1#1;

  inline$BDLGetDebugLevel$385$label_1#1:
    goto inline$BDLGetDebugLevel$385$Return#1;

  inline$BDLGetDebugLevel$385$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$38$ := inline$BDLGetDebugLevel$385$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_65$1#1;

  inline$BDLPnPStop$0$label_65$1#1:
    goto inline$BDLPnPStop$0$anon35_Then#1, inline$BDLPnPStop$0$anon35_Else#1;

  inline$BDLPnPStop$0$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon15#1;

  inline$BDLPnPStop$0$anon15#1:
    goto inline$BDLPnPStop$0$label_69#1;

  inline$BDLPnPStop$0$label_69#1:
    goto inline$BDLPnPStop$0$label_69_true#1, inline$BDLPnPStop$0$label_69_false#1;

  inline$BDLPnPStop$0$label_69_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$38$) == 0;
    goto inline$BDLPnPStop$0$label_70#1;

  inline$BDLPnPStop$0$label_69_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$38$) != 0;
    goto inline$BDLPnPStop$0$label_73#1;

  inline$BDLPnPStop$0$label_73#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_74#1;

  inline$BDLPnPStop$0$label_74#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_75#1;

  inline$BDLPnPStop$0$label_75#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_76#1;

  inline$BDLPnPStop$0$label_76#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2243.0$39$;
    goto inline$BDLPnPStop$0$label_70#1;

  inline$BDLPnPStop$0$label_70#1:
    goto inline$BDLGetDebugLevel$386$Entry#1;

  inline$BDLGetDebugLevel$386$Entry#1:
    goto inline$BDLGetDebugLevel$386$start#1;

  inline$BDLGetDebugLevel$386$start#1:
    goto inline$BDLGetDebugLevel$386$label_3#1;

  inline$BDLGetDebugLevel$386$label_3#1:
    havoc inline$BDLGetDebugLevel$386$myNondetVar_0;
    inline$BDLGetDebugLevel$386$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$386$myNondetVar_0;
    goto inline$BDLGetDebugLevel$386$label_1#1;

  inline$BDLGetDebugLevel$386$label_1#1:
    goto inline$BDLGetDebugLevel$386$Return#1;

  inline$BDLGetDebugLevel$386$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$43$ := inline$BDLGetDebugLevel$386$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_70$1#1;

  inline$BDLPnPStop$0$label_70$1#1:
    goto inline$BDLPnPStop$0$anon36_Then#1, inline$BDLPnPStop$0$anon36_Else#1;

  inline$BDLPnPStop$0$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon17#1;

  inline$BDLPnPStop$0$anon17#1:
    goto inline$BDLPnPStop$0$label_79#1;

  inline$BDLPnPStop$0$label_79#1:
    goto inline$BDLPnPStop$0$label_79_true#1, inline$BDLPnPStop$0$label_79_false#1;

  inline$BDLPnPStop$0$label_79_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$43$) == 0;
    goto inline$BDLPnPStop$0$label_80#1;

  inline$BDLPnPStop$0$label_79_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$43$) != 0;
    goto inline$BDLPnPStop$0$label_83#1;

  inline$BDLPnPStop$0$label_83#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_84#1;

  inline$BDLPnPStop$0$label_84#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_85#1;

  inline$BDLPnPStop$0$label_85#1:
    call inline$BDLPnPStop$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStop$0$label_86#1;

  inline$BDLPnPStop$0$label_86#1:
    havoc inline$BDLPnPStop$0$$result.DbgPrint$2243.0$44$;
    goto inline$BDLPnPStop$0$label_80#1;

  inline$BDLPnPStop$0$label_80#1:
    goto inline$BDLGetDebugLevel$387$Entry#1;

  inline$BDLGetDebugLevel$387$Entry#1:
    goto inline$BDLGetDebugLevel$387$start#1;

  inline$BDLGetDebugLevel$387$start#1:
    goto inline$BDLGetDebugLevel$387$label_3#1;

  inline$BDLGetDebugLevel$387$label_3#1:
    havoc inline$BDLGetDebugLevel$387$myNondetVar_0;
    inline$BDLGetDebugLevel$387$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$387$myNondetVar_0;
    goto inline$BDLGetDebugLevel$387$label_1#1;

  inline$BDLGetDebugLevel$387$label_1#1:
    goto inline$BDLGetDebugLevel$387$Return#1;

  inline$BDLGetDebugLevel$387$Return#1:
    inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$48$ := inline$BDLGetDebugLevel$387$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStop$0$label_80$1#1;

  inline$BDLPnPStop$0$label_80$1#1:
    goto inline$BDLPnPStop$0$anon37_Then#1, inline$BDLPnPStop$0$anon37_Else#1;

  inline$BDLPnPStop$0$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStop$0$anon19#1;

  inline$BDLPnPStop$0$anon19#1:
    goto inline$BDLPnPStop$0$label_89#1;

  inline$BDLPnPStop$0$label_89#1:
    goto inline$BDLPnPStop$0$label_89_true#1, inline$BDLPnPStop$0$label_89_false#1;

  inline$BDLPnPStop$0$label_89_false#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$48$, 4) == 0;
    goto inline$BDLPnPStop$0$label_90#1;

  inline$BDLPnPStop$0$label_89_true#1:
    assume BIT_BAND(inline$BDLPnPStop$0$$result.BDLGetDebugLevel$2243.0$48$, 4) != 0;
    goto inline$BDLPnPStop$0$label_91#1;

  inline$BDLPnPStop$0$label_91#1:
    goto inline$BDLPnPStop$0$label_90#1;

  inline$BDLPnPStop$0$label_90#1:
    inline$BDLPnPStop$0$$result.BDLPnPStop$2180.0$1$ := inline$BDLPnPStop$0$$status$4$2187.28$BDLPnPStop$12;
    goto inline$BDLPnPStop$0$label_1#1;

  inline$BDLPnPStop$0$label_1#1:
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon37_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon36_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon35_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon34_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon33_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon29_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$anon28_Then#1:
    assume raiseException;
    goto inline$BDLPnPStop$0$Return#1;

  inline$BDLPnPStop$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPStop$934.27$31$ := inline$BDLPnPStop$0$$result.BDLPnPStop$2180.0$1$;
    goto inline$BDLPnP$0$label_125$1#1;

  inline$BDLPnP$0$label_125$1#1:
    goto inline$BDLPnP$0$anon71_Then#1, inline$BDLPnP$0$anon71_Else#1;

  inline$BDLPnP$0$anon71_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon35#1;

  inline$BDLPnP$0$anon35#1:
    goto inline$BDLPnP$0$label_150#1;

  inline$BDLPnP$0$label_150#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPStop$934.27$31$;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon71_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_4#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 3;
    goto inline$BDLPnP$0$label_122#1;

  inline$BDLPnP$0$label_122#1:
    goto inline$BDLPnPCancelRemove$0$Entry#1;

  inline$BDLPnPCancelRemove$0$Entry#1:
    inline$BDLPnPCancelRemove$0$$pBDLExtension$1$2316.40$BDLPnPCancelRemove$12_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPCancelRemove$0$$pIrp$3$2318.40$BDLPnPCancelRemove$12_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPCancelRemove$0$start#1;

  inline$BDLPnPCancelRemove$0$start#1:
    inline$BDLPnPCancelRemove$0$$pBDLExtension$1$2316.40$BDLPnPCancelRemove$12 := inline$BDLPnPCancelRemove$0$$pBDLExtension$1$2316.40$BDLPnPCancelRemove$12_.1;
    inline$BDLPnPCancelRemove$0$$pIrp$3$2318.40$BDLPnPCancelRemove$12 := inline$BDLPnPCancelRemove$0$$pIrp$3$2318.40$BDLPnPCancelRemove$12_.1;
    goto inline$BDLPnPCancelRemove$0$label_3#1;

  inline$BDLPnPCancelRemove$0$label_3#1:
    goto inline$BDLPnPCancelRemove$0$label_4#1;

  inline$BDLPnPCancelRemove$0$label_4#1:
    inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 := 0;
    goto inline$BDLPnPCancelRemove$0$label_5#1;

  inline$BDLPnPCancelRemove$0$label_5#1:
    goto inline$BDLGetDebugLevel$283$Entry#1;

  inline$BDLGetDebugLevel$283$Entry#1:
    goto inline$BDLGetDebugLevel$283$start#1;

  inline$BDLGetDebugLevel$283$start#1:
    goto inline$BDLGetDebugLevel$283$label_3#1;

  inline$BDLGetDebugLevel$283$label_3#1:
    havoc inline$BDLGetDebugLevel$283$myNondetVar_0;
    inline$BDLGetDebugLevel$283$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$283$myNondetVar_0;
    goto inline$BDLGetDebugLevel$283$label_1#1;

  inline$BDLGetDebugLevel$283$label_1#1:
    goto inline$BDLGetDebugLevel$283$Return#1;

  inline$BDLGetDebugLevel$283$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$2$ := inline$BDLGetDebugLevel$283$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_5$1#1;

  inline$BDLPnPCancelRemove$0$label_5$1#1:
    goto inline$BDLPnPCancelRemove$0$anon28_Then#1, inline$BDLPnPCancelRemove$0$anon28_Else#1;

  inline$BDLPnPCancelRemove$0$anon28_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon1#1;

  inline$BDLPnPCancelRemove$0$anon1#1:
    goto inline$BDLPnPCancelRemove$0$label_8#1;

  inline$BDLPnPCancelRemove$0$label_8#1:
    goto inline$BDLPnPCancelRemove$0$label_8_true#1, inline$BDLPnPCancelRemove$0$label_8_false#1;

  inline$BDLPnPCancelRemove$0$label_8_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$2$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_9#1;

  inline$BDLPnPCancelRemove$0$label_8_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$2$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_12#1;

  inline$BDLPnPCancelRemove$0$label_12#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_13#1;

  inline$BDLPnPCancelRemove$0$label_13#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_14#1;

  inline$BDLPnPCancelRemove$0$label_14#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_15#1;

  inline$BDLPnPCancelRemove$0$label_15#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2323.0$3$;
    goto inline$BDLPnPCancelRemove$0$label_9#1;

  inline$BDLPnPCancelRemove$0$label_9#1:
    goto inline$BDLGetDebugLevel$284$Entry#1;

  inline$BDLGetDebugLevel$284$Entry#1:
    goto inline$BDLGetDebugLevel$284$start#1;

  inline$BDLGetDebugLevel$284$start#1:
    goto inline$BDLGetDebugLevel$284$label_3#1;

  inline$BDLGetDebugLevel$284$label_3#1:
    havoc inline$BDLGetDebugLevel$284$myNondetVar_0;
    inline$BDLGetDebugLevel$284$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$284$myNondetVar_0;
    goto inline$BDLGetDebugLevel$284$label_1#1;

  inline$BDLGetDebugLevel$284$label_1#1:
    goto inline$BDLGetDebugLevel$284$Return#1;

  inline$BDLGetDebugLevel$284$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$7$ := inline$BDLGetDebugLevel$284$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_9$1#1;

  inline$BDLPnPCancelRemove$0$label_9$1#1:
    goto inline$BDLPnPCancelRemove$0$anon29_Then#1, inline$BDLPnPCancelRemove$0$anon29_Else#1;

  inline$BDLPnPCancelRemove$0$anon29_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon3#1;

  inline$BDLPnPCancelRemove$0$anon3#1:
    goto inline$BDLPnPCancelRemove$0$label_18#1;

  inline$BDLPnPCancelRemove$0$label_18#1:
    goto inline$BDLPnPCancelRemove$0$label_18_true#1, inline$BDLPnPCancelRemove$0$label_18_false#1;

  inline$BDLPnPCancelRemove$0$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$7$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_19#1;

  inline$BDLPnPCancelRemove$0$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$7$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_22#1;

  inline$BDLPnPCancelRemove$0$label_22#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_23#1;

  inline$BDLPnPCancelRemove$0$label_23#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_24#1;

  inline$BDLPnPCancelRemove$0$label_24#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_25#1;

  inline$BDLPnPCancelRemove$0$label_25#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2323.0$8$;
    goto inline$BDLPnPCancelRemove$0$label_19#1;

  inline$BDLPnPCancelRemove$0$label_19#1:
    goto inline$BDLGetDebugLevel$285$Entry#1;

  inline$BDLGetDebugLevel$285$Entry#1:
    goto inline$BDLGetDebugLevel$285$start#1;

  inline$BDLGetDebugLevel$285$start#1:
    goto inline$BDLGetDebugLevel$285$label_3#1;

  inline$BDLGetDebugLevel$285$label_3#1:
    havoc inline$BDLGetDebugLevel$285$myNondetVar_0;
    inline$BDLGetDebugLevel$285$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$285$myNondetVar_0;
    goto inline$BDLGetDebugLevel$285$label_1#1;

  inline$BDLGetDebugLevel$285$label_1#1:
    goto inline$BDLGetDebugLevel$285$Return#1;

  inline$BDLGetDebugLevel$285$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$12$ := inline$BDLGetDebugLevel$285$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_19$1#1;

  inline$BDLPnPCancelRemove$0$label_19$1#1:
    goto inline$BDLPnPCancelRemove$0$anon30_Then#1, inline$BDLPnPCancelRemove$0$anon30_Else#1;

  inline$BDLPnPCancelRemove$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon5#1;

  inline$BDLPnPCancelRemove$0$anon5#1:
    goto inline$BDLPnPCancelRemove$0$label_28#1;

  inline$BDLPnPCancelRemove$0$label_28#1:
    goto inline$BDLPnPCancelRemove$0$label_28_true#1, inline$BDLPnPCancelRemove$0$label_28_false#1;

  inline$BDLPnPCancelRemove$0$label_28_false#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$12$, 4) == 0;
    goto inline$BDLPnPCancelRemove$0$label_29#1;

  inline$BDLPnPCancelRemove$0$label_28_true#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2323.0$12$, 4) != 0;
    goto inline$BDLPnPCancelRemove$0$label_32#1;

  inline$BDLPnPCancelRemove$0$label_32#1:
    goto inline$BDLPnPCancelRemove$0$label_29#1;

  inline$BDLPnPCancelRemove$0$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$Entry#1;

  inline$BDLCallLowerLevelDriverAndWait$2$Entry#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1 := inline$BDLPnPCancelRemove$0$$pIrp$3$2318.40$BDLPnPCancelRemove$12;
    goto inline$BDLCallLowerLevelDriverAndWait$2$start#1;

  inline$BDLCallLowerLevelDriverAndWait$2$start#1:
    call inline$BDLCallLowerLevelDriverAndWait$2$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8 := __HAVOC_malloc(16);
    inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_3#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_4#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_4#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := 0;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_5#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_6#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_6#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$Entry#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$Entry#1:
    inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$start#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$start#1:
    inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4 := inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_4#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_4#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_5#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_5#1:
    goto inline$IoGetCurrentIrpStackLocation$52$Entry#1;

  inline$IoGetCurrentIrpStackLocation$52$Entry#1:
    inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetCurrentIrpStackLocation$52$start#1;

  inline$IoGetCurrentIrpStackLocation$52$start#1:
    inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$52$label_3#1;

  inline$IoGetCurrentIrpStackLocation$52$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$52$label_3_true#1, inline$IoGetCurrentIrpStackLocation$52$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$52$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$52$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$52$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$52$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$52$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$52$label_4#1;

  inline$IoGetCurrentIrpStackLocation$52$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$52$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$52$label_6#1;

  inline$IoGetCurrentIrpStackLocation$52$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$52$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$52$label_7#1;

  inline$IoGetCurrentIrpStackLocation$52$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$52$label_5#1;

  inline$IoGetCurrentIrpStackLocation$52$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$52$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$52$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$52$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$52$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$52$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$52$label_5#1;

  inline$IoGetCurrentIrpStackLocation$52$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$52$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$52$label_1#1;

  inline$IoGetCurrentIrpStackLocation$52$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$52$Return#1;

  inline$IoGetCurrentIrpStackLocation$52$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_5$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_5$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$anon4_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$2$anon4_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$anon4_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$anon1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$anon1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_8#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_8#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_9#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_9#1:
    goto inline$IoGetNextIrpStackLocation$5$Entry#1;

  inline$IoGetNextIrpStackLocation$5$Entry#1:
    inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$2$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetNextIrpStackLocation$5$start#1;

  inline$IoGetNextIrpStackLocation$5$start#1:
    inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$5$label_3#1;

  inline$IoGetNextIrpStackLocation$5$label_3#1:
    goto inline$IoGetNextIrpStackLocation$5$label_3_true#1, inline$IoGetNextIrpStackLocation$5$label_3_false#1;

  inline$IoGetNextIrpStackLocation$5$label_3_false#1:
    inline$IoGetNextIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$5$myVar_0);
    goto inline$IoGetNextIrpStackLocation$5$label_4#1;

  inline$IoGetNextIrpStackLocation$5$label_4#1:
    call inline$IoGetNextIrpStackLocation$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$5$label_6#1;

  inline$IoGetNextIrpStackLocation$5$label_6#1:
    call inline$IoGetNextIrpStackLocation$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$5$label_7#1;

  inline$IoGetNextIrpStackLocation$5$label_7#1:
    goto inline$IoGetNextIrpStackLocation$5$label_5#1;

  inline$IoGetNextIrpStackLocation$5$label_3_true#1:
    inline$IoGetNextIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$5$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$5$myVar_0);
    goto inline$IoGetNextIrpStackLocation$5$label_5#1;

  inline$IoGetNextIrpStackLocation$5$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$5$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$5$label_1#1;

  inline$IoGetNextIrpStackLocation$5$label_1#1:
    goto inline$IoGetNextIrpStackLocation$5$Return#1;

  inline$IoGetNextIrpStackLocation$5$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_9$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_9$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$anon5_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$2$anon5_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$anon5_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$anon3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$anon3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_12#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_12#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_13#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_13#1:
    havoc inline$IoCopyCurrentIrpStackLocationToNext$2$$result.memcpy$25110.4$3$;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_16#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_16#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$label_1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$label_1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$anon5_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$anon4_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$2$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$2$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_6$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_6$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon16_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon16_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_9#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_9#1:
    goto inline$storm_KeInitializeEvent$2$Entry#1;

  inline$storm_KeInitializeEvent$2$Entry#1:
    inline$storm_KeInitializeEvent$2$$Event$1$203.14$storm_KeInitializeEvent$12_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeInitializeEvent$2$$State$3$205.13$storm_KeInitializeEvent$12_.1 := 0;
    goto inline$storm_KeInitializeEvent$2$start#1;

  inline$storm_KeInitializeEvent$2$start#1:
    inline$storm_KeInitializeEvent$2$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$2$$Event$1$203.14$storm_KeInitializeEvent$12_.1;
    inline$storm_KeInitializeEvent$2$$State$3$205.13$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$2$$State$3$205.13$storm_KeInitializeEvent$12_.1;
    goto inline$storm_KeInitializeEvent$2$label_3#1;

  inline$storm_KeInitializeEvent$2$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeInitializeEvent$2$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$2$$State$3$205.13$storm_KeInitializeEvent$12];
    call contextSwitch();
    goto inline$storm_KeInitializeEvent$2$label_1#1;

  inline$storm_KeInitializeEvent$2$label_1#1:
    goto inline$storm_KeInitializeEvent$2$Return#1;

  inline$storm_KeInitializeEvent$2$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_9$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_9$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon17_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon17_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon3#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_12#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$2$Entry#1;

  inline$storm_IoSetCompletionRoutine$2$Entry#1:
    inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoSetCompletionRoutine$2$start#1;

  inline$storm_IoSetCompletionRoutine$2$start#1:
    inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24 := inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1;
    goto inline$storm_IoSetCompletionRoutine$2$label_3#1;

  inline$storm_IoSetCompletionRoutine$2$label_3#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_4#1;

  inline$storm_IoSetCompletionRoutine$2$label_4#1:
    call inline$storm_IoSetCompletionRoutine$2$$result.storm_nondet$405.2$1$ := storm_nondet();
    goto inline$storm_IoSetCompletionRoutine$2$label_7#1;

  inline$storm_IoSetCompletionRoutine$2$label_7#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_7_true#1, inline$storm_IoSetCompletionRoutine$2$label_7_false#1;

  inline$storm_IoSetCompletionRoutine$2$label_7_false#1:
    assume inline$storm_IoSetCompletionRoutine$2$$result.storm_nondet$405.2$1$ == 0;
    goto inline$storm_IoSetCompletionRoutine$2$label_8#1;

  inline$storm_IoSetCompletionRoutine$2$label_7_true#1:
    assume inline$storm_IoSetCompletionRoutine$2$$result.storm_nondet$405.2$1$ != 0;
    goto inline$storm_IoSetCompletionRoutine$2$label_11#1;

  inline$storm_IoSetCompletionRoutine$2$label_11#1:
    havoc raiseException;
    goto inline$storm_IoSetCompletionRoutine$2$anon6_Then#1, inline$storm_IoSetCompletionRoutine$2$anon6_Else#1;

  inline$storm_IoSetCompletionRoutine$2$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$2$anon3#1;

  inline$storm_IoSetCompletionRoutine$2$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24], 1);
    call contextSwitch();
    goto inline$storm_IoSetCompletionRoutine$2$label_12#1;

  inline$storm_IoSetCompletionRoutine$2$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_12_true#1, inline$storm_IoSetCompletionRoutine$2$label_12_false#1;

  inline$storm_IoSetCompletionRoutine$2$label_12_false#1:
    assume 0 == 0;
    goto inline$storm_IoSetCompletionRoutine$2$label_13#1;

  inline$storm_IoSetCompletionRoutine$2$label_13#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoSetCompletionRoutine$2$label_1#1;

  inline$storm_IoSetCompletionRoutine$2$label_12_true#1:
    assume 0 != 0;
    goto inline$storm_IoSetCompletionRoutine$2$label_8#1;

  inline$storm_IoSetCompletionRoutine$2$label_8#1:
    goto inline$IoGetNextIrpStackLocation$6$Entry#1;

  inline$IoGetNextIrpStackLocation$6$Entry#1:
    inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoSetCompletionRoutine$2$$pirp$1$396.10$storm_IoSetCompletionRoutine$24;
    goto inline$IoGetNextIrpStackLocation$6$start#1;

  inline$IoGetNextIrpStackLocation$6$start#1:
    inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$6$label_3#1;

  inline$IoGetNextIrpStackLocation$6$label_3#1:
    goto inline$IoGetNextIrpStackLocation$6$label_3_true#1, inline$IoGetNextIrpStackLocation$6$label_3_false#1;

  inline$IoGetNextIrpStackLocation$6$label_3_false#1:
    inline$IoGetNextIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$6$myVar_0);
    goto inline$IoGetNextIrpStackLocation$6$label_4#1;

  inline$IoGetNextIrpStackLocation$6$label_4#1:
    call inline$IoGetNextIrpStackLocation$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$6$label_6#1;

  inline$IoGetNextIrpStackLocation$6$label_6#1:
    call inline$IoGetNextIrpStackLocation$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$6$label_7#1;

  inline$IoGetNextIrpStackLocation$6$label_7#1:
    goto inline$IoGetNextIrpStackLocation$6$label_5#1;

  inline$IoGetNextIrpStackLocation$6$label_3_true#1:
    inline$IoGetNextIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$6$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$6$myVar_0);
    goto inline$IoGetNextIrpStackLocation$6$label_5#1;

  inline$IoGetNextIrpStackLocation$6$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$6$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$6$label_1#1;

  inline$IoGetNextIrpStackLocation$6$label_1#1:
    goto inline$IoGetNextIrpStackLocation$6$Return#1;

  inline$IoGetNextIrpStackLocation$6$Return#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_8$1#1;

  inline$storm_IoSetCompletionRoutine$2$label_8$1#1:
    goto inline$storm_IoSetCompletionRoutine$2$anon5_Then#1, inline$storm_IoSetCompletionRoutine$2$anon5_Else#1;

  inline$storm_IoSetCompletionRoutine$2$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$2$anon1#1;

  inline$storm_IoSetCompletionRoutine$2$anon1#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_16#1;

  inline$storm_IoSetCompletionRoutine$2$label_16#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_17#1;

  inline$storm_IoSetCompletionRoutine$2$label_17#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_18#1;

  inline$storm_IoSetCompletionRoutine$2$label_18#1:
    goto inline$storm_IoSetCompletionRoutine$2$label_1#1;

  inline$storm_IoSetCompletionRoutine$2$label_1#1:
    goto inline$storm_IoSetCompletionRoutine$2$Return#1;

  inline$storm_IoSetCompletionRoutine$2$anon5_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$2$Return#1;

  inline$storm_IoSetCompletionRoutine$2$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$2$Return#1;

  inline$storm_IoSetCompletionRoutine$2$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_12$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_12$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon18_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon18_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon5#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_15#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_15#1:
    goto inline$IoGetCurrentIrpStackLocation$53$Entry#1;

  inline$IoGetCurrentIrpStackLocation$53$Entry#1:
    inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoGetCurrentIrpStackLocation$53$start#1;

  inline$IoGetCurrentIrpStackLocation$53$start#1:
    inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$53$label_3#1;

  inline$IoGetCurrentIrpStackLocation$53$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$53$label_3_true#1, inline$IoGetCurrentIrpStackLocation$53$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$53$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$53$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$53$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$53$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$53$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$53$label_4#1;

  inline$IoGetCurrentIrpStackLocation$53$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$53$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$53$label_6#1;

  inline$IoGetCurrentIrpStackLocation$53$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$53$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$53$label_7#1;

  inline$IoGetCurrentIrpStackLocation$53$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$53$label_5#1;

  inline$IoGetCurrentIrpStackLocation$53$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$53$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$53$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$53$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$53$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$53$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$53$label_5#1;

  inline$IoGetCurrentIrpStackLocation$53$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$53$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$53$label_1#1;

  inline$IoGetCurrentIrpStackLocation$53$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$53$Return#1;

  inline$IoGetCurrentIrpStackLocation$53$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_15$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_15$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon19_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon19_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon7#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon7#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_18#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_18#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_18_true#1, inline$BDLCallLowerLevelDriverAndWait$2$label_18_false#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_18_false#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0;
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_19#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_19#1:
    goto inline$storm_IoCallDriver$5$Entry#1;

  inline$storm_IoCallDriver$5$Entry#1:
    inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoCallDriver$5$start#1;

  inline$storm_IoCallDriver$5$start#1:
    inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$5$label_3#1;

  inline$storm_IoCallDriver$5$label_3#1:
    goto inline$storm_IoCallDriver$5$label_4#1;

  inline$storm_IoCallDriver$5$label_4#1:
    goto inline$storm_IoCallDriver$5$label_5#1;

  inline$storm_IoCallDriver$5$label_5#1:
    goto inline$storm_IoCallDriver$5$label_6#1;

  inline$storm_IoCallDriver$5$label_6#1:
    call inline$storm_IoCallDriver$5$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$5$label_9#1;

  inline$storm_IoCallDriver$5$label_9#1:
    goto inline$storm_IoCallDriver$5$label_9_true#1, inline$storm_IoCallDriver$5$label_9_false#1;

  inline$storm_IoCallDriver$5$label_9_false#1:
    assume inline$storm_IoCallDriver$5$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$5$label_10#1;

  inline$storm_IoCallDriver$5$label_9_true#1:
    assume inline$storm_IoCallDriver$5$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$5$label_13#1;

  inline$storm_IoCallDriver$5$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$5$anon12_Then#1, inline$storm_IoCallDriver$5$anon12_Else#1;

  inline$storm_IoCallDriver$5$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$5$anon3#1;

  inline$storm_IoCallDriver$5$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$5$label_14#1;

  inline$storm_IoCallDriver$5$label_14#1:
    goto inline$storm_IoCallDriver$5$label_14_true#1, inline$storm_IoCallDriver$5$label_14_false#1;

  inline$storm_IoCallDriver$5$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$5$label_15#1;

  inline$storm_IoCallDriver$5$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$5$label_1#1;

  inline$storm_IoCallDriver$5$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$5$label_10#1;

  inline$storm_IoCallDriver$5$label_10#1:
    goto inline$IoSetNextIrpStackLocation$6$Entry#1;

  inline$IoSetNextIrpStackLocation$6$Entry#1:
    inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$6$start#1;

  inline$IoSetNextIrpStackLocation$6$start#1:
    inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$6$label_3#1;

  inline$IoSetNextIrpStackLocation$6$label_3#1:
    goto inline$IoSetNextIrpStackLocation$6$label_3_true#1, inline$IoSetNextIrpStackLocation$6$label_3_false#1;

  inline$IoSetNextIrpStackLocation$6$label_3_false#1:
    inline$IoSetNextIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$6$myVar_0);
    goto inline$IoSetNextIrpStackLocation$6$label_4#1;

  inline$IoSetNextIrpStackLocation$6$label_4#1:
    call inline$IoSetNextIrpStackLocation$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$6$label_7#1;

  inline$IoSetNextIrpStackLocation$6$label_7#1:
    call inline$IoSetNextIrpStackLocation$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$6$label_8#1;

  inline$IoSetNextIrpStackLocation$6$label_8#1:
    goto inline$IoSetNextIrpStackLocation$6$label_5#1;

  inline$IoSetNextIrpStackLocation$6$label_3_true#1:
    inline$IoSetNextIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$6$myVar_0);
    goto inline$IoSetNextIrpStackLocation$6$label_5#1;

  inline$IoSetNextIrpStackLocation$6$label_5#1:
    inline$IoSetNextIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$6$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$6$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$6$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$6$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$6$label_6#1;

  inline$IoSetNextIrpStackLocation$6$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$6$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$6$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$6$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$6$label_1#1;

  inline$IoSetNextIrpStackLocation$6$label_1#1:
    goto inline$IoSetNextIrpStackLocation$6$Return#1;

  inline$IoSetNextIrpStackLocation$6$Return#1:
    goto inline$storm_IoCallDriver$5$label_10$1#1;

  inline$storm_IoCallDriver$5$label_10$1#1:
    goto inline$storm_IoCallDriver$5$anon11_Then#1, inline$storm_IoCallDriver$5$anon11_Else#1;

  inline$storm_IoCallDriver$5$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$5$anon1#1;

  inline$storm_IoCallDriver$5$anon1#1:
    goto inline$storm_IoCallDriver$5$label_18#1;

  inline$storm_IoCallDriver$5$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$54$Entry#1;

  inline$IoGetCurrentIrpStackLocation$54$Entry#1:
    inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$54$start#1;

  inline$IoGetCurrentIrpStackLocation$54$start#1:
    inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$54$label_3#1;

  inline$IoGetCurrentIrpStackLocation$54$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$54$label_3_true#1, inline$IoGetCurrentIrpStackLocation$54$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$54$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$54$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$54$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$54$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$54$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$54$label_4#1;

  inline$IoGetCurrentIrpStackLocation$54$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$54$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$54$label_6#1;

  inline$IoGetCurrentIrpStackLocation$54$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$54$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$54$label_7#1;

  inline$IoGetCurrentIrpStackLocation$54$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$54$label_5#1;

  inline$IoGetCurrentIrpStackLocation$54$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$54$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$54$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$54$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$54$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$54$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$54$label_5#1;

  inline$IoGetCurrentIrpStackLocation$54$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$54$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$54$label_1#1;

  inline$IoGetCurrentIrpStackLocation$54$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$54$Return#1;

  inline$IoGetCurrentIrpStackLocation$54$Return#1:
    goto inline$storm_IoCallDriver$5$label_18$1#1;

  inline$storm_IoCallDriver$5$label_18$1#1:
    goto inline$storm_IoCallDriver$5$anon13_Then#1, inline$storm_IoCallDriver$5$anon13_Else#1;

  inline$storm_IoCallDriver$5$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$5$anon6#1;

  inline$storm_IoCallDriver$5$anon6#1:
    goto inline$storm_IoCallDriver$5$label_21#1;

  inline$storm_IoCallDriver$5$label_21#1:
    goto inline$storm_IoCallDriver$5$label_22#1;

  inline$storm_IoCallDriver$5$label_22#1:
    goto inline$storm_IoCallDriver$5$label_23#1;

  inline$storm_IoCallDriver$5$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$5$label_24#1;

  inline$storm_IoCallDriver$5$label_24#1:
    call inline$storm_IoCallDriver$5$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$5$label_27#1;

  inline$storm_IoCallDriver$5$label_27#1:
    goto inline$storm_IoCallDriver$5$label_27_case_0#1, inline$storm_IoCallDriver$5$label_27_case_1#1, inline$storm_IoCallDriver$5$label_27_case_2#1;

  inline$storm_IoCallDriver$5$label_27_case_2#1:
    assume inline$storm_IoCallDriver$5$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$5$label_30#1;

  inline$storm_IoCallDriver$5$label_30#1:
    inline$storm_IoCallDriver$5$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$5$label_31#1;

  inline$storm_IoCallDriver$5$label_31#1:
    goto inline$storm_IoCallDriver$5$label_32#1;

  inline$storm_IoCallDriver$5$label_32#1:
    goto inline$storm_IoCallDriver$5$label_33#1;

  inline$storm_IoCallDriver$5$label_33#1:
    goto inline$CallCompletionRoutine$10$Entry#1;

  inline$CallCompletionRoutine$10$Entry#1:
    inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$10$start#1;

  inline$CallCompletionRoutine$10$start#1:
    inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$10$label_3#1;

  inline$CallCompletionRoutine$10$label_3#1:
    goto inline$CallCompletionRoutine$10$label_4#1;

  inline$CallCompletionRoutine$10$label_4#1:
    goto inline$CallCompletionRoutine$10$label_5#1;

  inline$CallCompletionRoutine$10$label_5#1:
    goto inline$CallCompletionRoutine$10$label_6#1;

  inline$CallCompletionRoutine$10$label_6#1:
    goto inline$CallCompletionRoutine$10$label_7#1;

  inline$CallCompletionRoutine$10$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$55$Entry#1;

  inline$IoGetCurrentIrpStackLocation$55$Entry#1:
    inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$55$start#1;

  inline$IoGetCurrentIrpStackLocation$55$start#1:
    inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$55$label_3#1;

  inline$IoGetCurrentIrpStackLocation$55$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$55$label_3_true#1, inline$IoGetCurrentIrpStackLocation$55$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$55$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$55$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$55$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$55$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$55$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$55$label_4#1;

  inline$IoGetCurrentIrpStackLocation$55$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$55$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$55$label_6#1;

  inline$IoGetCurrentIrpStackLocation$55$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$55$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$55$label_7#1;

  inline$IoGetCurrentIrpStackLocation$55$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$55$label_5#1;

  inline$IoGetCurrentIrpStackLocation$55$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$55$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$55$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$55$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$55$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$55$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$55$label_5#1;

  inline$IoGetCurrentIrpStackLocation$55$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$55$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$55$label_1#1;

  inline$IoGetCurrentIrpStackLocation$55$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$55$Return#1;

  inline$IoGetCurrentIrpStackLocation$55$Return#1:
    goto inline$CallCompletionRoutine$10$label_7$1#1;

  inline$CallCompletionRoutine$10$label_7$1#1:
    goto inline$CallCompletionRoutine$10$anon10_Then#1, inline$CallCompletionRoutine$10$anon10_Else#1;

  inline$CallCompletionRoutine$10$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$10$anon1#1;

  inline$CallCompletionRoutine$10$anon1#1:
    goto inline$CallCompletionRoutine$10$label_10#1;

  inline$CallCompletionRoutine$10$label_10#1:
    goto inline$CallCompletionRoutine$10$label_11#1;

  inline$CallCompletionRoutine$10$label_11#1:
    havoc inline$CallCompletionRoutine$10$myNondetVar_0;
    inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$10$myNondetVar_0;
    goto inline$CallCompletionRoutine$10$label_12#1;

  inline$CallCompletionRoutine$10$label_12#1:
    havoc inline$CallCompletionRoutine$10$myNondetVar_0;
    inline$CallCompletionRoutine$10$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$10$myNondetVar_0;
    goto inline$CallCompletionRoutine$10$label_13#1;

  inline$CallCompletionRoutine$10$label_13#1:
    havoc inline$CallCompletionRoutine$10$myNondetVar_0;
    goto inline$CallCompletionRoutine$10$label_14#1;

  inline$CallCompletionRoutine$10$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$56$Entry#1;

  inline$IoGetCurrentIrpStackLocation$56$Entry#1:
    inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$56$start#1;

  inline$IoGetCurrentIrpStackLocation$56$start#1:
    inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$56$label_3#1;

  inline$IoGetCurrentIrpStackLocation$56$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$56$label_3_true#1, inline$IoGetCurrentIrpStackLocation$56$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$56$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$56$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$56$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$56$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$56$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$56$label_4#1;

  inline$IoGetCurrentIrpStackLocation$56$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$56$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$56$label_6#1;

  inline$IoGetCurrentIrpStackLocation$56$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$56$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$56$label_7#1;

  inline$IoGetCurrentIrpStackLocation$56$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$56$label_5#1;

  inline$IoGetCurrentIrpStackLocation$56$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$56$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$56$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$56$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$56$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$56$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$56$label_5#1;

  inline$IoGetCurrentIrpStackLocation$56$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$56$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$56$label_1#1;

  inline$IoGetCurrentIrpStackLocation$56$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$56$Return#1;

  inline$IoGetCurrentIrpStackLocation$56$Return#1:
    goto inline$CallCompletionRoutine$10$label_14$1#1;

  inline$CallCompletionRoutine$10$label_14$1#1:
    goto inline$CallCompletionRoutine$10$anon11_Then#1, inline$CallCompletionRoutine$10$anon11_Else#1;

  inline$CallCompletionRoutine$10$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$10$anon3#1;

  inline$CallCompletionRoutine$10$anon3#1:
    goto inline$CallCompletionRoutine$10$label_17#1;

  inline$CallCompletionRoutine$10$label_17#1:
    goto inline$CallCompletionRoutine$10$label_18#1;

  inline$CallCompletionRoutine$10$label_18#1:
    goto inline$CallCompletionRoutine$10$label_18_true#1, inline$CallCompletionRoutine$10$label_18_false#1;

  inline$CallCompletionRoutine$10$label_18_false#1:
    assume inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$10$label_1#1;

  inline$CallCompletionRoutine$10$label_18_true#1:
    assume inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$10$label_19#1;

  inline$CallCompletionRoutine$10$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$10$label_20#1;

  inline$CallCompletionRoutine$10$label_20#1:
    goto inline$CallCompletionRoutine$10$label_20_icall_1#1, inline$CallCompletionRoutine$10$label_20_icall_2#1, inline$CallCompletionRoutine$10$label_20_icall_3#1;

  inline$CallCompletionRoutine$10$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$10$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$10$Entry#1;

  inline$BDLSystemPowerIoCompletion$10$Entry#1:
    inline$BDLSystemPowerIoCompletion$10$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$10$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$10$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$10$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$10$start#1;

  inline$BDLSystemPowerIoCompletion$10$start#1:
    call inline$BDLSystemPowerIoCompletion$10$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$10$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$10$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$10$label_3#1;

  inline$BDLSystemPowerIoCompletion$10$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_4#1;

  inline$BDLSystemPowerIoCompletion$10$label_4#1:
    inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_5#1;

  inline$BDLSystemPowerIoCompletion$10$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_6#1;

  inline$BDLSystemPowerIoCompletion$10$label_6#1:
    inline$BDLSystemPowerIoCompletion$10$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$10$label_7#1;

  inline$BDLSystemPowerIoCompletion$10$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_8#1;

  inline$BDLSystemPowerIoCompletion$10$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$10$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$10$label_9#1;

  inline$BDLSystemPowerIoCompletion$10$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_10#1;

  inline$BDLSystemPowerIoCompletion$10$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$58$Entry#1;

  inline$IoGetCurrentIrpStackLocation$58$Entry#1:
    inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$58$start#1;

  inline$IoGetCurrentIrpStackLocation$58$start#1:
    inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$58$label_3#1;

  inline$IoGetCurrentIrpStackLocation$58$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$58$label_3_true#1, inline$IoGetCurrentIrpStackLocation$58$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$58$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$58$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$58$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$58$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$58$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$58$label_4#1;

  inline$IoGetCurrentIrpStackLocation$58$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$58$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$58$label_6#1;

  inline$IoGetCurrentIrpStackLocation$58$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$58$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$58$label_7#1;

  inline$IoGetCurrentIrpStackLocation$58$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$58$label_5#1;

  inline$IoGetCurrentIrpStackLocation$58$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$58$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$58$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$58$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$58$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$58$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$58$label_5#1;

  inline$IoGetCurrentIrpStackLocation$58$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$58$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$58$label_1#1;

  inline$IoGetCurrentIrpStackLocation$58$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$58$Return#1;

  inline$IoGetCurrentIrpStackLocation$58$Return#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon36_Then#1, inline$BDLSystemPowerIoCompletion$10$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon1#1;

  inline$BDLSystemPowerIoCompletion$10$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_13#1;

  inline$BDLSystemPowerIoCompletion$10$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_14#1;

  inline$BDLSystemPowerIoCompletion$10$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_15#1;

  inline$BDLSystemPowerIoCompletion$10$label_15#1:
    goto inline$BDLGetDebugLevel$295$Entry#1;

  inline$BDLGetDebugLevel$295$Entry#1:
    goto inline$BDLGetDebugLevel$295$start#1;

  inline$BDLGetDebugLevel$295$start#1:
    goto inline$BDLGetDebugLevel$295$label_3#1;

  inline$BDLGetDebugLevel$295$label_3#1:
    havoc inline$BDLGetDebugLevel$295$myNondetVar_0;
    inline$BDLGetDebugLevel$295$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$295$myNondetVar_0;
    goto inline$BDLGetDebugLevel$295$label_1#1;

  inline$BDLGetDebugLevel$295$label_1#1:
    goto inline$BDLGetDebugLevel$295$Return#1;

  inline$BDLGetDebugLevel$295$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$295$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon37_Then#1, inline$BDLSystemPowerIoCompletion$10$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon3#1;

  inline$BDLSystemPowerIoCompletion$10$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_18#1;

  inline$BDLSystemPowerIoCompletion$10$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_18_true#1, inline$BDLSystemPowerIoCompletion$10$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_19#1;

  inline$BDLSystemPowerIoCompletion$10$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_22#1;

  inline$BDLSystemPowerIoCompletion$10$label_22#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_23#1;

  inline$BDLSystemPowerIoCompletion$10$label_23#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_24#1;

  inline$BDLSystemPowerIoCompletion$10$label_24#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_25#1;

  inline$BDLSystemPowerIoCompletion$10$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$10$label_19#1;

  inline$BDLSystemPowerIoCompletion$10$label_19#1:
    goto inline$BDLGetDebugLevel$296$Entry#1;

  inline$BDLGetDebugLevel$296$Entry#1:
    goto inline$BDLGetDebugLevel$296$start#1;

  inline$BDLGetDebugLevel$296$start#1:
    goto inline$BDLGetDebugLevel$296$label_3#1;

  inline$BDLGetDebugLevel$296$label_3#1:
    havoc inline$BDLGetDebugLevel$296$myNondetVar_0;
    inline$BDLGetDebugLevel$296$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$296$myNondetVar_0;
    goto inline$BDLGetDebugLevel$296$label_1#1;

  inline$BDLGetDebugLevel$296$label_1#1:
    goto inline$BDLGetDebugLevel$296$Return#1;

  inline$BDLGetDebugLevel$296$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$296$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon38_Then#1, inline$BDLSystemPowerIoCompletion$10$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon5#1;

  inline$BDLSystemPowerIoCompletion$10$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_28#1;

  inline$BDLSystemPowerIoCompletion$10$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_28_true#1, inline$BDLSystemPowerIoCompletion$10$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_29#1;

  inline$BDLSystemPowerIoCompletion$10$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_32#1;

  inline$BDLSystemPowerIoCompletion$10$label_32#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_33#1;

  inline$BDLSystemPowerIoCompletion$10$label_33#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_34#1;

  inline$BDLSystemPowerIoCompletion$10$label_34#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_35#1;

  inline$BDLSystemPowerIoCompletion$10$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$10$label_29#1;

  inline$BDLSystemPowerIoCompletion$10$label_29#1:
    goto inline$BDLGetDebugLevel$297$Entry#1;

  inline$BDLGetDebugLevel$297$Entry#1:
    goto inline$BDLGetDebugLevel$297$start#1;

  inline$BDLGetDebugLevel$297$start#1:
    goto inline$BDLGetDebugLevel$297$label_3#1;

  inline$BDLGetDebugLevel$297$label_3#1:
    havoc inline$BDLGetDebugLevel$297$myNondetVar_0;
    inline$BDLGetDebugLevel$297$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$297$myNondetVar_0;
    goto inline$BDLGetDebugLevel$297$label_1#1;

  inline$BDLGetDebugLevel$297$label_1#1:
    goto inline$BDLGetDebugLevel$297$Return#1;

  inline$BDLGetDebugLevel$297$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$297$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon39_Then#1, inline$BDLSystemPowerIoCompletion$10$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon7#1;

  inline$BDLSystemPowerIoCompletion$10$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_38#1;

  inline$BDLSystemPowerIoCompletion$10$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_38_true#1, inline$BDLSystemPowerIoCompletion$10$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_39#1;

  inline$BDLSystemPowerIoCompletion$10$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_40#1;

  inline$BDLSystemPowerIoCompletion$10$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_39#1;

  inline$BDLSystemPowerIoCompletion$10$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_39_true#1, inline$BDLSystemPowerIoCompletion$10$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_41#1;

  inline$BDLSystemPowerIoCompletion$10$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$10$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$10$label_107#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$10$label_108#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$10$label_108#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$10$label_108#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$10$label_108#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$10$label_108#1;

  inline$BDLSystemPowerIoCompletion$10$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_109#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$10$label_107#1;

  inline$BDLSystemPowerIoCompletion$10$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_109#1;

  inline$BDLSystemPowerIoCompletion$10$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$10$label_106#1;

  inline$BDLSystemPowerIoCompletion$10$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_106_true#1, inline$BDLSystemPowerIoCompletion$10$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_142#1;

  inline$BDLSystemPowerIoCompletion$10$label_142#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_143#1;

  inline$BDLSystemPowerIoCompletion$10$label_143#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_144#1;

  inline$BDLSystemPowerIoCompletion$10$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_109#1;

  inline$BDLSystemPowerIoCompletion$10$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_109#1;

  inline$BDLSystemPowerIoCompletion$10$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$10$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$10$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$10$myNondetVar_0, inline$BDLSystemPowerIoCompletion$10$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$10$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$10$anon50_Then#1, inline$BDLSystemPowerIoCompletion$10$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon29#1;

  inline$BDLSystemPowerIoCompletion$10$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_112#1;

  inline$BDLSystemPowerIoCompletion$10$label_112#1:
    inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$10$label_113#1;

  inline$BDLSystemPowerIoCompletion$10$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_113_true#1, inline$BDLSystemPowerIoCompletion$10$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$10$label_114#1;

  inline$BDLSystemPowerIoCompletion$10$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_116#1;

  inline$BDLSystemPowerIoCompletion$10$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_117#1;

  inline$BDLSystemPowerIoCompletion$10$label_117#1:
    goto inline$BDLGetDebugLevel$304$Entry#1;

  inline$BDLGetDebugLevel$304$Entry#1:
    goto inline$BDLGetDebugLevel$304$start#1;

  inline$BDLGetDebugLevel$304$start#1:
    goto inline$BDLGetDebugLevel$304$label_3#1;

  inline$BDLGetDebugLevel$304$label_3#1:
    havoc inline$BDLGetDebugLevel$304$myNondetVar_0;
    inline$BDLGetDebugLevel$304$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$304$myNondetVar_0;
    goto inline$BDLGetDebugLevel$304$label_1#1;

  inline$BDLGetDebugLevel$304$label_1#1:
    goto inline$BDLGetDebugLevel$304$Return#1;

  inline$BDLGetDebugLevel$304$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$304$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon51_Then#1, inline$BDLSystemPowerIoCompletion$10$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon31#1;

  inline$BDLSystemPowerIoCompletion$10$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_120#1;

  inline$BDLSystemPowerIoCompletion$10$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_120_true#1, inline$BDLSystemPowerIoCompletion$10$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_121#1;

  inline$BDLSystemPowerIoCompletion$10$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_124#1;

  inline$BDLSystemPowerIoCompletion$10$label_124#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_125#1;

  inline$BDLSystemPowerIoCompletion$10$label_125#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_126#1;

  inline$BDLSystemPowerIoCompletion$10$label_126#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_127#1;

  inline$BDLSystemPowerIoCompletion$10$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$10$label_121#1;

  inline$BDLSystemPowerIoCompletion$10$label_121#1:
    goto inline$BDLGetDebugLevel$305$Entry#1;

  inline$BDLGetDebugLevel$305$Entry#1:
    goto inline$BDLGetDebugLevel$305$start#1;

  inline$BDLGetDebugLevel$305$start#1:
    goto inline$BDLGetDebugLevel$305$label_3#1;

  inline$BDLGetDebugLevel$305$label_3#1:
    havoc inline$BDLGetDebugLevel$305$myNondetVar_0;
    inline$BDLGetDebugLevel$305$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$305$myNondetVar_0;
    goto inline$BDLGetDebugLevel$305$label_1#1;

  inline$BDLGetDebugLevel$305$label_1#1:
    goto inline$BDLGetDebugLevel$305$Return#1;

  inline$BDLGetDebugLevel$305$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$305$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon52_Then#1, inline$BDLSystemPowerIoCompletion$10$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon33#1;

  inline$BDLSystemPowerIoCompletion$10$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_130#1;

  inline$BDLSystemPowerIoCompletion$10$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_130_true#1, inline$BDLSystemPowerIoCompletion$10$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_131#1;

  inline$BDLSystemPowerIoCompletion$10$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_134#1;

  inline$BDLSystemPowerIoCompletion$10$label_134#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_135#1;

  inline$BDLSystemPowerIoCompletion$10$label_135#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_136#1;

  inline$BDLSystemPowerIoCompletion$10$label_136#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_137#1;

  inline$BDLSystemPowerIoCompletion$10$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$10$label_131#1;

  inline$BDLSystemPowerIoCompletion$10$label_131#1:
    goto inline$BDLGetDebugLevel$306$Entry#1;

  inline$BDLGetDebugLevel$306$Entry#1:
    goto inline$BDLGetDebugLevel$306$start#1;

  inline$BDLGetDebugLevel$306$start#1:
    goto inline$BDLGetDebugLevel$306$label_3#1;

  inline$BDLGetDebugLevel$306$label_3#1:
    havoc inline$BDLGetDebugLevel$306$myNondetVar_0;
    inline$BDLGetDebugLevel$306$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$306$myNondetVar_0;
    goto inline$BDLGetDebugLevel$306$label_1#1;

  inline$BDLGetDebugLevel$306$label_1#1:
    goto inline$BDLGetDebugLevel$306$Return#1;

  inline$BDLGetDebugLevel$306$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$306$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon53_Then#1, inline$BDLSystemPowerIoCompletion$10$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon35#1;

  inline$BDLSystemPowerIoCompletion$10$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_140#1;

  inline$BDLSystemPowerIoCompletion$10$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_140_true#1, inline$BDLSystemPowerIoCompletion$10$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_67#1;

  inline$BDLSystemPowerIoCompletion$10$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_141#1;

  inline$BDLSystemPowerIoCompletion$10$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_67#1;

  inline$BDLSystemPowerIoCompletion$10$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$10$label_115#1;

  inline$BDLSystemPowerIoCompletion$10$label_115#1:
    inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$10$label_80#1;

  inline$BDLSystemPowerIoCompletion$10$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$10$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_42#1;

  inline$BDLSystemPowerIoCompletion$10$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$10$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$10$label_43#1;

  inline$BDLSystemPowerIoCompletion$10$label_43#1:
    goto inline$BDLGetDebugLevel$298$Entry#1;

  inline$BDLGetDebugLevel$298$Entry#1:
    goto inline$BDLGetDebugLevel$298$start#1;

  inline$BDLGetDebugLevel$298$start#1:
    goto inline$BDLGetDebugLevel$298$label_3#1;

  inline$BDLGetDebugLevel$298$label_3#1:
    havoc inline$BDLGetDebugLevel$298$myNondetVar_0;
    inline$BDLGetDebugLevel$298$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$298$myNondetVar_0;
    goto inline$BDLGetDebugLevel$298$label_1#1;

  inline$BDLGetDebugLevel$298$label_1#1:
    goto inline$BDLGetDebugLevel$298$Return#1;

  inline$BDLGetDebugLevel$298$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$298$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon40_Then#1, inline$BDLSystemPowerIoCompletion$10$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon9#1;

  inline$BDLSystemPowerIoCompletion$10$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_46#1;

  inline$BDLSystemPowerIoCompletion$10$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_46_true#1, inline$BDLSystemPowerIoCompletion$10$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_47#1;

  inline$BDLSystemPowerIoCompletion$10$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_50#1;

  inline$BDLSystemPowerIoCompletion$10$label_50#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_51#1;

  inline$BDLSystemPowerIoCompletion$10$label_51#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_52#1;

  inline$BDLSystemPowerIoCompletion$10$label_52#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_53#1;

  inline$BDLSystemPowerIoCompletion$10$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$10$label_47#1;

  inline$BDLSystemPowerIoCompletion$10$label_47#1:
    goto inline$BDLGetDebugLevel$299$Entry#1;

  inline$BDLGetDebugLevel$299$Entry#1:
    goto inline$BDLGetDebugLevel$299$start#1;

  inline$BDLGetDebugLevel$299$start#1:
    goto inline$BDLGetDebugLevel$299$label_3#1;

  inline$BDLGetDebugLevel$299$label_3#1:
    havoc inline$BDLGetDebugLevel$299$myNondetVar_0;
    inline$BDLGetDebugLevel$299$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$299$myNondetVar_0;
    goto inline$BDLGetDebugLevel$299$label_1#1;

  inline$BDLGetDebugLevel$299$label_1#1:
    goto inline$BDLGetDebugLevel$299$Return#1;

  inline$BDLGetDebugLevel$299$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$299$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon41_Then#1, inline$BDLSystemPowerIoCompletion$10$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon11#1;

  inline$BDLSystemPowerIoCompletion$10$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_56#1;

  inline$BDLSystemPowerIoCompletion$10$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_56_true#1, inline$BDLSystemPowerIoCompletion$10$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_57#1;

  inline$BDLSystemPowerIoCompletion$10$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_60#1;

  inline$BDLSystemPowerIoCompletion$10$label_60#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_61#1;

  inline$BDLSystemPowerIoCompletion$10$label_61#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_62#1;

  inline$BDLSystemPowerIoCompletion$10$label_62#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_63#1;

  inline$BDLSystemPowerIoCompletion$10$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$10$label_57#1;

  inline$BDLSystemPowerIoCompletion$10$label_57#1:
    goto inline$BDLGetDebugLevel$300$Entry#1;

  inline$BDLGetDebugLevel$300$Entry#1:
    goto inline$BDLGetDebugLevel$300$start#1;

  inline$BDLGetDebugLevel$300$start#1:
    goto inline$BDLGetDebugLevel$300$label_3#1;

  inline$BDLGetDebugLevel$300$label_3#1:
    havoc inline$BDLGetDebugLevel$300$myNondetVar_0;
    inline$BDLGetDebugLevel$300$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$300$myNondetVar_0;
    goto inline$BDLGetDebugLevel$300$label_1#1;

  inline$BDLGetDebugLevel$300$label_1#1:
    goto inline$BDLGetDebugLevel$300$Return#1;

  inline$BDLGetDebugLevel$300$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$300$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon42_Then#1, inline$BDLSystemPowerIoCompletion$10$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon13#1;

  inline$BDLSystemPowerIoCompletion$10$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_66#1;

  inline$BDLSystemPowerIoCompletion$10$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_66_true#1, inline$BDLSystemPowerIoCompletion$10$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_67#1;

  inline$BDLSystemPowerIoCompletion$10$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_70#1;

  inline$BDLSystemPowerIoCompletion$10$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_67#1;

  inline$BDLSystemPowerIoCompletion$10$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$10$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$10$anon43_Then#1, inline$BDLSystemPowerIoCompletion$10$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon15#1;

  inline$BDLSystemPowerIoCompletion$10$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_71#1;

  inline$BDLSystemPowerIoCompletion$10$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$10$anon44_Then#1, inline$BDLSystemPowerIoCompletion$10$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon17#1;

  inline$BDLSystemPowerIoCompletion$10$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_74#1;

  inline$BDLSystemPowerIoCompletion$10$label_74#1:
    goto inline$storm_IoCompleteRequest$22$Entry#1;

  inline$storm_IoCompleteRequest$22$Entry#1:
    inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$10$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$22$start#1;

  inline$storm_IoCompleteRequest$22$start#1:
    inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$22$label_3#1;

  inline$storm_IoCompleteRequest$22$label_3#1:
    call inline$storm_IoCompleteRequest$22$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$22$label_6#1;

  inline$storm_IoCompleteRequest$22$label_6#1:
    goto inline$storm_IoCompleteRequest$22$label_6_true#1, inline$storm_IoCompleteRequest$22$label_6_false#1;

  inline$storm_IoCompleteRequest$22$label_6_false#1:
    assume inline$storm_IoCompleteRequest$22$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$22$label_7#1;

  inline$storm_IoCompleteRequest$22$label_6_true#1:
    assume inline$storm_IoCompleteRequest$22$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$22$label_8#1;

  inline$storm_IoCompleteRequest$22$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$22$anon3_Then#1, inline$storm_IoCompleteRequest$22$anon3_Else#1;

  inline$storm_IoCompleteRequest$22$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$22$anon1#1;

  inline$storm_IoCompleteRequest$22$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$22$label_9#1;

  inline$storm_IoCompleteRequest$22$label_9#1:
    goto inline$storm_IoCompleteRequest$22$label_9_true#1, inline$storm_IoCompleteRequest$22$label_9_false#1;

  inline$storm_IoCompleteRequest$22$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$22$label_10#1;

  inline$storm_IoCompleteRequest$22$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$22$label_1#1;

  inline$storm_IoCompleteRequest$22$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$22$label_7#1;

  inline$storm_IoCompleteRequest$22$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$22$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$22$label_1#1;

  inline$storm_IoCompleteRequest$22$label_1#1:
    goto inline$storm_IoCompleteRequest$22$Return#1;

  inline$storm_IoCompleteRequest$22$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$22$Return#1;

  inline$storm_IoCompleteRequest$22$Return#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon45_Then#1, inline$BDLSystemPowerIoCompletion$10$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon19#1;

  inline$BDLSystemPowerIoCompletion$10$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_77#1;

  inline$BDLSystemPowerIoCompletion$10$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$10$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$10$anon46_Then#1, inline$BDLSystemPowerIoCompletion$10$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon21#1;

  inline$BDLSystemPowerIoCompletion$10$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_80#1;

  inline$BDLSystemPowerIoCompletion$10$label_80#1:
    goto inline$BDLGetDebugLevel$301$Entry#1;

  inline$BDLGetDebugLevel$301$Entry#1:
    goto inline$BDLGetDebugLevel$301$start#1;

  inline$BDLGetDebugLevel$301$start#1:
    goto inline$BDLGetDebugLevel$301$label_3#1;

  inline$BDLGetDebugLevel$301$label_3#1:
    havoc inline$BDLGetDebugLevel$301$myNondetVar_0;
    inline$BDLGetDebugLevel$301$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$301$myNondetVar_0;
    goto inline$BDLGetDebugLevel$301$label_1#1;

  inline$BDLGetDebugLevel$301$label_1#1:
    goto inline$BDLGetDebugLevel$301$Return#1;

  inline$BDLGetDebugLevel$301$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$301$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon47_Then#1, inline$BDLSystemPowerIoCompletion$10$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon23#1;

  inline$BDLSystemPowerIoCompletion$10$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_83#1;

  inline$BDLSystemPowerIoCompletion$10$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_83_true#1, inline$BDLSystemPowerIoCompletion$10$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_84#1;

  inline$BDLSystemPowerIoCompletion$10$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_87#1;

  inline$BDLSystemPowerIoCompletion$10$label_87#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_88#1;

  inline$BDLSystemPowerIoCompletion$10$label_88#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_89#1;

  inline$BDLSystemPowerIoCompletion$10$label_89#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_90#1;

  inline$BDLSystemPowerIoCompletion$10$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$10$label_84#1;

  inline$BDLSystemPowerIoCompletion$10$label_84#1:
    goto inline$BDLGetDebugLevel$302$Entry#1;

  inline$BDLGetDebugLevel$302$Entry#1:
    goto inline$BDLGetDebugLevel$302$start#1;

  inline$BDLGetDebugLevel$302$start#1:
    goto inline$BDLGetDebugLevel$302$label_3#1;

  inline$BDLGetDebugLevel$302$label_3#1:
    havoc inline$BDLGetDebugLevel$302$myNondetVar_0;
    inline$BDLGetDebugLevel$302$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$302$myNondetVar_0;
    goto inline$BDLGetDebugLevel$302$label_1#1;

  inline$BDLGetDebugLevel$302$label_1#1:
    goto inline$BDLGetDebugLevel$302$Return#1;

  inline$BDLGetDebugLevel$302$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$302$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon48_Then#1, inline$BDLSystemPowerIoCompletion$10$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon25#1;

  inline$BDLSystemPowerIoCompletion$10$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_93#1;

  inline$BDLSystemPowerIoCompletion$10$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_93_true#1, inline$BDLSystemPowerIoCompletion$10$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_94#1;

  inline$BDLSystemPowerIoCompletion$10$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_97#1;

  inline$BDLSystemPowerIoCompletion$10$label_97#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_98#1;

  inline$BDLSystemPowerIoCompletion$10$label_98#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_99#1;

  inline$BDLSystemPowerIoCompletion$10$label_99#1:
    call inline$BDLSystemPowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$10$label_100#1;

  inline$BDLSystemPowerIoCompletion$10$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$10$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$10$label_94#1;

  inline$BDLSystemPowerIoCompletion$10$label_94#1:
    goto inline$BDLGetDebugLevel$303$Entry#1;

  inline$BDLGetDebugLevel$303$Entry#1:
    goto inline$BDLGetDebugLevel$303$start#1;

  inline$BDLGetDebugLevel$303$start#1:
    goto inline$BDLGetDebugLevel$303$label_3#1;

  inline$BDLGetDebugLevel$303$label_3#1:
    havoc inline$BDLGetDebugLevel$303$myNondetVar_0;
    inline$BDLGetDebugLevel$303$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$303$myNondetVar_0;
    goto inline$BDLGetDebugLevel$303$label_1#1;

  inline$BDLGetDebugLevel$303$label_1#1:
    goto inline$BDLGetDebugLevel$303$Return#1;

  inline$BDLGetDebugLevel$303$Return#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$303$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$10$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$10$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$10$anon49_Then#1, inline$BDLSystemPowerIoCompletion$10$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$10$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$anon27#1;

  inline$BDLSystemPowerIoCompletion$10$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_103#1;

  inline$BDLSystemPowerIoCompletion$10$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_103_true#1, inline$BDLSystemPowerIoCompletion$10$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$10$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_104#1;

  inline$BDLSystemPowerIoCompletion$10$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$10$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$10$label_105#1;

  inline$BDLSystemPowerIoCompletion$10$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$10$label_104#1;

  inline$BDLSystemPowerIoCompletion$10$label_104#1:
    inline$BDLSystemPowerIoCompletion$10$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$10$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$10$label_1#1;

  inline$BDLSystemPowerIoCompletion$10$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$10$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$10$Return#1;

  inline$BDLSystemPowerIoCompletion$10$Return#1:
    inline$CallCompletionRoutine$10$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$10$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$10$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$10$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$10$anon14_Then#1, inline$CallCompletionRoutine$10$anon14_Else#1;

  inline$CallCompletionRoutine$10$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$10$anon9#1;

  inline$CallCompletionRoutine$10$anon9#1:
    goto inline$CallCompletionRoutine$10$label_20_icall_return#1;

  inline$CallCompletionRoutine$10$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$10$Return#1;

  inline$CallCompletionRoutine$10$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$10$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$10$Entry#1;

  inline$BDLDevicePowerIoCompletion$10$Entry#1:
    inline$BDLDevicePowerIoCompletion$10$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$10$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$10$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$10$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$10$start#1;

  inline$BDLDevicePowerIoCompletion$10$start#1:
    call inline$BDLDevicePowerIoCompletion$10$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$10$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$10$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$10$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$10$label_3#1;

  inline$BDLDevicePowerIoCompletion$10$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_4#1;

  inline$BDLDevicePowerIoCompletion$10$label_4#1:
    inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_5#1;

  inline$BDLDevicePowerIoCompletion$10$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_6#1;

  inline$BDLDevicePowerIoCompletion$10$label_6#1:
    inline$BDLDevicePowerIoCompletion$10$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$10$label_7#1;

  inline$BDLDevicePowerIoCompletion$10$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_8#1;

  inline$BDLDevicePowerIoCompletion$10$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$10$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$10$label_9#1;

  inline$BDLDevicePowerIoCompletion$10$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_10#1;

  inline$BDLDevicePowerIoCompletion$10$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$57$Entry#1;

  inline$IoGetCurrentIrpStackLocation$57$Entry#1:
    inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$57$start#1;

  inline$IoGetCurrentIrpStackLocation$57$start#1:
    inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$57$label_3#1;

  inline$IoGetCurrentIrpStackLocation$57$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$57$label_3_true#1, inline$IoGetCurrentIrpStackLocation$57$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$57$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$57$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$57$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$57$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$57$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$57$label_4#1;

  inline$IoGetCurrentIrpStackLocation$57$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$57$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$57$label_6#1;

  inline$IoGetCurrentIrpStackLocation$57$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$57$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$57$label_7#1;

  inline$IoGetCurrentIrpStackLocation$57$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$57$label_5#1;

  inline$IoGetCurrentIrpStackLocation$57$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$57$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$57$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$57$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$57$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$57$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$57$label_5#1;

  inline$IoGetCurrentIrpStackLocation$57$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$57$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$57$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$57$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$57$label_1#1;

  inline$IoGetCurrentIrpStackLocation$57$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$57$Return#1;

  inline$IoGetCurrentIrpStackLocation$57$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$57$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon30_Then#1, inline$BDLDevicePowerIoCompletion$10$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon1#1;

  inline$BDLDevicePowerIoCompletion$10$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_13#1;

  inline$BDLDevicePowerIoCompletion$10$label_13#1:
    inline$BDLDevicePowerIoCompletion$10$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$10$label_14#1;

  inline$BDLDevicePowerIoCompletion$10$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_15#1;

  inline$BDLDevicePowerIoCompletion$10$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$10$label_16#1;

  inline$BDLDevicePowerIoCompletion$10$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_17#1;

  inline$BDLDevicePowerIoCompletion$10$label_17#1:
    goto inline$BDLGetDebugLevel$286$Entry#1;

  inline$BDLGetDebugLevel$286$Entry#1:
    goto inline$BDLGetDebugLevel$286$start#1;

  inline$BDLGetDebugLevel$286$start#1:
    goto inline$BDLGetDebugLevel$286$label_3#1;

  inline$BDLGetDebugLevel$286$label_3#1:
    havoc inline$BDLGetDebugLevel$286$myNondetVar_0;
    inline$BDLGetDebugLevel$286$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$286$myNondetVar_0;
    goto inline$BDLGetDebugLevel$286$label_1#1;

  inline$BDLGetDebugLevel$286$label_1#1:
    goto inline$BDLGetDebugLevel$286$Return#1;

  inline$BDLGetDebugLevel$286$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$286$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon31_Then#1, inline$BDLDevicePowerIoCompletion$10$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon3#1;

  inline$BDLDevicePowerIoCompletion$10$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_20#1;

  inline$BDLDevicePowerIoCompletion$10$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_20_true#1, inline$BDLDevicePowerIoCompletion$10$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_21#1;

  inline$BDLDevicePowerIoCompletion$10$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_24#1;

  inline$BDLDevicePowerIoCompletion$10$label_24#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_25#1;

  inline$BDLDevicePowerIoCompletion$10$label_25#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_26#1;

  inline$BDLDevicePowerIoCompletion$10$label_26#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_27#1;

  inline$BDLDevicePowerIoCompletion$10$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$10$label_21#1;

  inline$BDLDevicePowerIoCompletion$10$label_21#1:
    goto inline$BDLGetDebugLevel$287$Entry#1;

  inline$BDLGetDebugLevel$287$Entry#1:
    goto inline$BDLGetDebugLevel$287$start#1;

  inline$BDLGetDebugLevel$287$start#1:
    goto inline$BDLGetDebugLevel$287$label_3#1;

  inline$BDLGetDebugLevel$287$label_3#1:
    havoc inline$BDLGetDebugLevel$287$myNondetVar_0;
    inline$BDLGetDebugLevel$287$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$287$myNondetVar_0;
    goto inline$BDLGetDebugLevel$287$label_1#1;

  inline$BDLGetDebugLevel$287$label_1#1:
    goto inline$BDLGetDebugLevel$287$Return#1;

  inline$BDLGetDebugLevel$287$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$287$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon32_Then#1, inline$BDLDevicePowerIoCompletion$10$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon5#1;

  inline$BDLDevicePowerIoCompletion$10$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_30#1;

  inline$BDLDevicePowerIoCompletion$10$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_30_true#1, inline$BDLDevicePowerIoCompletion$10$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_31#1;

  inline$BDLDevicePowerIoCompletion$10$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_34#1;

  inline$BDLDevicePowerIoCompletion$10$label_34#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_35#1;

  inline$BDLDevicePowerIoCompletion$10$label_35#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_36#1;

  inline$BDLDevicePowerIoCompletion$10$label_36#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_37#1;

  inline$BDLDevicePowerIoCompletion$10$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$10$label_31#1;

  inline$BDLDevicePowerIoCompletion$10$label_31#1:
    goto inline$BDLGetDebugLevel$288$Entry#1;

  inline$BDLGetDebugLevel$288$Entry#1:
    goto inline$BDLGetDebugLevel$288$start#1;

  inline$BDLGetDebugLevel$288$start#1:
    goto inline$BDLGetDebugLevel$288$label_3#1;

  inline$BDLGetDebugLevel$288$label_3#1:
    havoc inline$BDLGetDebugLevel$288$myNondetVar_0;
    inline$BDLGetDebugLevel$288$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$288$myNondetVar_0;
    goto inline$BDLGetDebugLevel$288$label_1#1;

  inline$BDLGetDebugLevel$288$label_1#1:
    goto inline$BDLGetDebugLevel$288$Return#1;

  inline$BDLGetDebugLevel$288$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$288$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon33_Then#1, inline$BDLDevicePowerIoCompletion$10$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon7#1;

  inline$BDLDevicePowerIoCompletion$10$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_40#1;

  inline$BDLDevicePowerIoCompletion$10$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_40_true#1, inline$BDLDevicePowerIoCompletion$10$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_41#1;

  inline$BDLDevicePowerIoCompletion$10$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_42#1;

  inline$BDLDevicePowerIoCompletion$10$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_41#1;

  inline$BDLDevicePowerIoCompletion$10$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_41_true#1, inline$BDLDevicePowerIoCompletion$10$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$10$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$10$label_43#1;

  inline$BDLDevicePowerIoCompletion$10$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$10$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$10$label_44#1;

  inline$BDLDevicePowerIoCompletion$10$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_44_true#1, inline$BDLDevicePowerIoCompletion$10$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$10$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$10$label_45#1;

  inline$BDLDevicePowerIoCompletion$10$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_45_true#1, inline$BDLDevicePowerIoCompletion$10$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$10$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$10$label_43#1;

  inline$BDLDevicePowerIoCompletion$10$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$10$label_86#1;

  inline$BDLDevicePowerIoCompletion$10$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$10$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$10$label_46#1;

  inline$BDLDevicePowerIoCompletion$10$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$10$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$10$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$10$label_46#1;

  inline$BDLDevicePowerIoCompletion$10$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$10$label_49#1;

  inline$BDLDevicePowerIoCompletion$10$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_50#1;

  inline$BDLDevicePowerIoCompletion$10$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_51#1;

  inline$BDLDevicePowerIoCompletion$10$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_54#1;

  inline$BDLDevicePowerIoCompletion$10$label_54#1:
    inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$10$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$10$label_55#1;

  inline$BDLDevicePowerIoCompletion$10$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_55_true#1, inline$BDLDevicePowerIoCompletion$10$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_56#1;

  inline$BDLDevicePowerIoCompletion$10$label_56#1:
    call inline$BDLDevicePowerIoCompletion$10$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$10$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$10$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$10$anon34_Then#1, inline$BDLDevicePowerIoCompletion$10$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon9#1;

  inline$BDLDevicePowerIoCompletion$10$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_83#1;

  inline$BDLDevicePowerIoCompletion$10$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_59#1;

  inline$BDLDevicePowerIoCompletion$10$label_59#1:
    goto inline$BDLGetDebugLevel$289$Entry#1;

  inline$BDLGetDebugLevel$289$Entry#1:
    goto inline$BDLGetDebugLevel$289$start#1;

  inline$BDLGetDebugLevel$289$start#1:
    goto inline$BDLGetDebugLevel$289$label_3#1;

  inline$BDLGetDebugLevel$289$label_3#1:
    havoc inline$BDLGetDebugLevel$289$myNondetVar_0;
    inline$BDLGetDebugLevel$289$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$289$myNondetVar_0;
    goto inline$BDLGetDebugLevel$289$label_1#1;

  inline$BDLGetDebugLevel$289$label_1#1:
    goto inline$BDLGetDebugLevel$289$Return#1;

  inline$BDLGetDebugLevel$289$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$289$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon35_Then#1, inline$BDLDevicePowerIoCompletion$10$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon11#1;

  inline$BDLDevicePowerIoCompletion$10$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_62#1;

  inline$BDLDevicePowerIoCompletion$10$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_62_true#1, inline$BDLDevicePowerIoCompletion$10$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_63#1;

  inline$BDLDevicePowerIoCompletion$10$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_66#1;

  inline$BDLDevicePowerIoCompletion$10$label_66#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_67#1;

  inline$BDLDevicePowerIoCompletion$10$label_67#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_68#1;

  inline$BDLDevicePowerIoCompletion$10$label_68#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_69#1;

  inline$BDLDevicePowerIoCompletion$10$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$10$label_63#1;

  inline$BDLDevicePowerIoCompletion$10$label_63#1:
    goto inline$BDLGetDebugLevel$290$Entry#1;

  inline$BDLGetDebugLevel$290$Entry#1:
    goto inline$BDLGetDebugLevel$290$start#1;

  inline$BDLGetDebugLevel$290$start#1:
    goto inline$BDLGetDebugLevel$290$label_3#1;

  inline$BDLGetDebugLevel$290$label_3#1:
    havoc inline$BDLGetDebugLevel$290$myNondetVar_0;
    inline$BDLGetDebugLevel$290$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$290$myNondetVar_0;
    goto inline$BDLGetDebugLevel$290$label_1#1;

  inline$BDLGetDebugLevel$290$label_1#1:
    goto inline$BDLGetDebugLevel$290$Return#1;

  inline$BDLGetDebugLevel$290$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$290$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon36_Then#1, inline$BDLDevicePowerIoCompletion$10$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon13#1;

  inline$BDLDevicePowerIoCompletion$10$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_72#1;

  inline$BDLDevicePowerIoCompletion$10$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_72_true#1, inline$BDLDevicePowerIoCompletion$10$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_73#1;

  inline$BDLDevicePowerIoCompletion$10$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_76#1;

  inline$BDLDevicePowerIoCompletion$10$label_76#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_77#1;

  inline$BDLDevicePowerIoCompletion$10$label_77#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_78#1;

  inline$BDLDevicePowerIoCompletion$10$label_78#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_79#1;

  inline$BDLDevicePowerIoCompletion$10$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$10$label_73#1;

  inline$BDLDevicePowerIoCompletion$10$label_73#1:
    goto inline$BDLGetDebugLevel$291$Entry#1;

  inline$BDLGetDebugLevel$291$Entry#1:
    goto inline$BDLGetDebugLevel$291$start#1;

  inline$BDLGetDebugLevel$291$start#1:
    goto inline$BDLGetDebugLevel$291$label_3#1;

  inline$BDLGetDebugLevel$291$label_3#1:
    havoc inline$BDLGetDebugLevel$291$myNondetVar_0;
    inline$BDLGetDebugLevel$291$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$291$myNondetVar_0;
    goto inline$BDLGetDebugLevel$291$label_1#1;

  inline$BDLGetDebugLevel$291$label_1#1:
    goto inline$BDLGetDebugLevel$291$Return#1;

  inline$BDLGetDebugLevel$291$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$291$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon37_Then#1, inline$BDLDevicePowerIoCompletion$10$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon15#1;

  inline$BDLDevicePowerIoCompletion$10$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_82#1;

  inline$BDLDevicePowerIoCompletion$10$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_82_true#1, inline$BDLDevicePowerIoCompletion$10$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_83#1;

  inline$BDLDevicePowerIoCompletion$10$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_84#1;

  inline$BDLDevicePowerIoCompletion$10$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_83#1;

  inline$BDLDevicePowerIoCompletion$10$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_85#1;

  inline$BDLDevicePowerIoCompletion$10$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_86#1;

  inline$BDLDevicePowerIoCompletion$10$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$10$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$10$anon38_Then#1, inline$BDLDevicePowerIoCompletion$10$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon17#1;

  inline$BDLDevicePowerIoCompletion$10$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_89#1;

  inline$BDLDevicePowerIoCompletion$10$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$10$anon39_Then#1, inline$BDLDevicePowerIoCompletion$10$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon19#1;

  inline$BDLDevicePowerIoCompletion$10$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_92#1;

  inline$BDLDevicePowerIoCompletion$10$label_92#1:
    goto inline$storm_IoCompleteRequest$21$Entry#1;

  inline$storm_IoCompleteRequest$21$Entry#1:
    inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$10$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$21$start#1;

  inline$storm_IoCompleteRequest$21$start#1:
    inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$21$label_3#1;

  inline$storm_IoCompleteRequest$21$label_3#1:
    call inline$storm_IoCompleteRequest$21$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$21$label_6#1;

  inline$storm_IoCompleteRequest$21$label_6#1:
    goto inline$storm_IoCompleteRequest$21$label_6_true#1, inline$storm_IoCompleteRequest$21$label_6_false#1;

  inline$storm_IoCompleteRequest$21$label_6_false#1:
    assume inline$storm_IoCompleteRequest$21$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$21$label_7#1;

  inline$storm_IoCompleteRequest$21$label_6_true#1:
    assume inline$storm_IoCompleteRequest$21$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$21$label_8#1;

  inline$storm_IoCompleteRequest$21$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$21$anon3_Then#1, inline$storm_IoCompleteRequest$21$anon3_Else#1;

  inline$storm_IoCompleteRequest$21$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$21$anon1#1;

  inline$storm_IoCompleteRequest$21$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$21$label_9#1;

  inline$storm_IoCompleteRequest$21$label_9#1:
    goto inline$storm_IoCompleteRequest$21$label_9_true#1, inline$storm_IoCompleteRequest$21$label_9_false#1;

  inline$storm_IoCompleteRequest$21$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$21$label_10#1;

  inline$storm_IoCompleteRequest$21$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$21$label_1#1;

  inline$storm_IoCompleteRequest$21$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$21$label_7#1;

  inline$storm_IoCompleteRequest$21$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$21$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$21$label_1#1;

  inline$storm_IoCompleteRequest$21$label_1#1:
    goto inline$storm_IoCompleteRequest$21$Return#1;

  inline$storm_IoCompleteRequest$21$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$21$Return#1;

  inline$storm_IoCompleteRequest$21$Return#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon40_Then#1, inline$BDLDevicePowerIoCompletion$10$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon21#1;

  inline$BDLDevicePowerIoCompletion$10$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_95#1;

  inline$BDLDevicePowerIoCompletion$10$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$10$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$10$anon41_Then#1, inline$BDLDevicePowerIoCompletion$10$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon23#1;

  inline$BDLDevicePowerIoCompletion$10$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_98#1;

  inline$BDLDevicePowerIoCompletion$10$label_98#1:
    goto inline$BDLGetDebugLevel$292$Entry#1;

  inline$BDLGetDebugLevel$292$Entry#1:
    goto inline$BDLGetDebugLevel$292$start#1;

  inline$BDLGetDebugLevel$292$start#1:
    goto inline$BDLGetDebugLevel$292$label_3#1;

  inline$BDLGetDebugLevel$292$label_3#1:
    havoc inline$BDLGetDebugLevel$292$myNondetVar_0;
    inline$BDLGetDebugLevel$292$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$292$myNondetVar_0;
    goto inline$BDLGetDebugLevel$292$label_1#1;

  inline$BDLGetDebugLevel$292$label_1#1:
    goto inline$BDLGetDebugLevel$292$Return#1;

  inline$BDLGetDebugLevel$292$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$292$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon42_Then#1, inline$BDLDevicePowerIoCompletion$10$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon25#1;

  inline$BDLDevicePowerIoCompletion$10$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_101#1;

  inline$BDLDevicePowerIoCompletion$10$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_101_true#1, inline$BDLDevicePowerIoCompletion$10$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_102#1;

  inline$BDLDevicePowerIoCompletion$10$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_105#1;

  inline$BDLDevicePowerIoCompletion$10$label_105#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_106#1;

  inline$BDLDevicePowerIoCompletion$10$label_106#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_107#1;

  inline$BDLDevicePowerIoCompletion$10$label_107#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_108#1;

  inline$BDLDevicePowerIoCompletion$10$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$10$label_102#1;

  inline$BDLDevicePowerIoCompletion$10$label_102#1:
    goto inline$BDLGetDebugLevel$293$Entry#1;

  inline$BDLGetDebugLevel$293$Entry#1:
    goto inline$BDLGetDebugLevel$293$start#1;

  inline$BDLGetDebugLevel$293$start#1:
    goto inline$BDLGetDebugLevel$293$label_3#1;

  inline$BDLGetDebugLevel$293$label_3#1:
    havoc inline$BDLGetDebugLevel$293$myNondetVar_0;
    inline$BDLGetDebugLevel$293$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$293$myNondetVar_0;
    goto inline$BDLGetDebugLevel$293$label_1#1;

  inline$BDLGetDebugLevel$293$label_1#1:
    goto inline$BDLGetDebugLevel$293$Return#1;

  inline$BDLGetDebugLevel$293$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$293$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon43_Then#1, inline$BDLDevicePowerIoCompletion$10$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon27#1;

  inline$BDLDevicePowerIoCompletion$10$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_111#1;

  inline$BDLDevicePowerIoCompletion$10$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_111_true#1, inline$BDLDevicePowerIoCompletion$10$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_112#1;

  inline$BDLDevicePowerIoCompletion$10$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_115#1;

  inline$BDLDevicePowerIoCompletion$10$label_115#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_116#1;

  inline$BDLDevicePowerIoCompletion$10$label_116#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_117#1;

  inline$BDLDevicePowerIoCompletion$10$label_117#1:
    call inline$BDLDevicePowerIoCompletion$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$10$label_118#1;

  inline$BDLDevicePowerIoCompletion$10$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$10$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$10$label_112#1;

  inline$BDLDevicePowerIoCompletion$10$label_112#1:
    goto inline$BDLGetDebugLevel$294$Entry#1;

  inline$BDLGetDebugLevel$294$Entry#1:
    goto inline$BDLGetDebugLevel$294$start#1;

  inline$BDLGetDebugLevel$294$start#1:
    goto inline$BDLGetDebugLevel$294$label_3#1;

  inline$BDLGetDebugLevel$294$label_3#1:
    havoc inline$BDLGetDebugLevel$294$myNondetVar_0;
    inline$BDLGetDebugLevel$294$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$294$myNondetVar_0;
    goto inline$BDLGetDebugLevel$294$label_1#1;

  inline$BDLGetDebugLevel$294$label_1#1:
    goto inline$BDLGetDebugLevel$294$Return#1;

  inline$BDLGetDebugLevel$294$Return#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$294$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$10$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$10$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$10$anon44_Then#1, inline$BDLDevicePowerIoCompletion$10$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$10$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$anon29#1;

  inline$BDLDevicePowerIoCompletion$10$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_121#1;

  inline$BDLDevicePowerIoCompletion$10$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_121_true#1, inline$BDLDevicePowerIoCompletion$10$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$10$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_122#1;

  inline$BDLDevicePowerIoCompletion$10$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$10$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$10$label_123#1;

  inline$BDLDevicePowerIoCompletion$10$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$10$label_122#1;

  inline$BDLDevicePowerIoCompletion$10$label_122#1:
    inline$BDLDevicePowerIoCompletion$10$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$10$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$10$label_1#1;

  inline$BDLDevicePowerIoCompletion$10$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$10$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$10$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$10$Return#1;

  inline$BDLDevicePowerIoCompletion$10$Return#1:
    inline$CallCompletionRoutine$10$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$10$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$10$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$10$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$10$anon13_Then#1, inline$CallCompletionRoutine$10$anon13_Else#1;

  inline$CallCompletionRoutine$10$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$10$anon7#1;

  inline$CallCompletionRoutine$10$anon7#1:
    goto inline$CallCompletionRoutine$10$label_20_icall_return#1;

  inline$CallCompletionRoutine$10$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$10$Return#1;

  inline$CallCompletionRoutine$10$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$10$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$10$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$10$Entry#1;

  inline$BDLCallDriverCompletionRoutine$10$Entry#1:
    inline$BDLCallDriverCompletionRoutine$10$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$10$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$10$start#1;

  inline$BDLCallDriverCompletionRoutine$10$start#1:
    inline$BDLCallDriverCompletionRoutine$10$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$10$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$10$label_3#1;

  inline$BDLCallDriverCompletionRoutine$10$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$10$label_3_true#1, inline$BDLCallDriverCompletionRoutine$10$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$10$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$10$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$10$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$10$label_4#1;

  inline$BDLCallDriverCompletionRoutine$10$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$10$label_6#1;

  inline$BDLCallDriverCompletionRoutine$10$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$10$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$10$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$10$label_5#1;

  inline$BDLCallDriverCompletionRoutine$10$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$10$label_6#1;

  inline$BDLCallDriverCompletionRoutine$10$label_6#1:
    goto inline$storm_KeSetEvent$12$Entry#1;

  inline$storm_KeSetEvent$12$Entry#1:
    inline$storm_KeSetEvent$12$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$10$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$12$start#1;

  inline$storm_KeSetEvent$12$start#1:
    inline$storm_KeSetEvent$12$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$12$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$12$label_3#1;

  inline$storm_KeSetEvent$12$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$12$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$12$label_1#1;

  inline$storm_KeSetEvent$12$label_1#1:
    goto inline$storm_KeSetEvent$12$Return#1;

  inline$storm_KeSetEvent$12$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$10$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$10$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$10$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$10$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$10$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$10$anon1#1;

  inline$BDLCallDriverCompletionRoutine$10$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$10$label_9#1;

  inline$BDLCallDriverCompletionRoutine$10$label_9#1:
    inline$BDLCallDriverCompletionRoutine$10$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$10$label_1#1;

  inline$BDLCallDriverCompletionRoutine$10$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$10$Return#1;

  inline$BDLCallDriverCompletionRoutine$10$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$10$Return#1;

  inline$BDLCallDriverCompletionRoutine$10$Return#1:
    inline$CallCompletionRoutine$10$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$10$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$10$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$10$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$10$anon12_Then#1, inline$CallCompletionRoutine$10$anon12_Else#1;

  inline$CallCompletionRoutine$10$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$10$anon5#1;

  inline$CallCompletionRoutine$10$anon5#1:
    goto inline$CallCompletionRoutine$10$label_20_icall_return#1;

  inline$CallCompletionRoutine$10$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$10$label_23#1;

  inline$CallCompletionRoutine$10$label_23#1:
    inline$CallCompletionRoutine$10$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$10$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$10$label_24#1;

  inline$CallCompletionRoutine$10$label_24#1:
    goto inline$CallCompletionRoutine$10$label_24_true#1, inline$CallCompletionRoutine$10$label_24_false#1;

  inline$CallCompletionRoutine$10$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$10$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$10$label_1#1;

  inline$CallCompletionRoutine$10$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$10$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$10$label_25#1;

  inline$CallCompletionRoutine$10$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$10$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$10$label_1#1;

  inline$CallCompletionRoutine$10$label_1#1:
    goto inline$CallCompletionRoutine$10$Return#1;

  inline$CallCompletionRoutine$10$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$10$Return#1;

  inline$CallCompletionRoutine$10$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$10$Return#1;

  inline$CallCompletionRoutine$10$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$10$Return#1;

  inline$CallCompletionRoutine$10$Return#1:
    goto inline$storm_IoCallDriver$5$label_33$1#1;

  inline$storm_IoCallDriver$5$label_33$1#1:
    goto inline$storm_IoCallDriver$5$anon14_Then#1, inline$storm_IoCallDriver$5$anon14_Else#1;

  inline$storm_IoCallDriver$5$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$5$anon8#1;

  inline$storm_IoCallDriver$5$anon8#1:
    goto inline$storm_IoCallDriver$5$label_36#1;

  inline$storm_IoCallDriver$5$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$5$Return#1;

  inline$storm_IoCallDriver$5$label_27_case_1#1:
    assume inline$storm_IoCallDriver$5$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$5$label_29#1;

  inline$storm_IoCallDriver$5$label_29#1:
    inline$storm_IoCallDriver$5$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$5$label_37#1;

  inline$storm_IoCallDriver$5$label_37#1:
    goto inline$storm_IoCallDriver$5$label_38#1;

  inline$storm_IoCallDriver$5$label_38#1:
    goto inline$storm_IoCallDriver$5$label_39#1;

  inline$storm_IoCallDriver$5$label_39#1:
    goto inline$CallCompletionRoutine$11$Entry#1;

  inline$CallCompletionRoutine$11$Entry#1:
    inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$11$start#1;

  inline$CallCompletionRoutine$11$start#1:
    inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$11$label_3#1;

  inline$CallCompletionRoutine$11$label_3#1:
    goto inline$CallCompletionRoutine$11$label_4#1;

  inline$CallCompletionRoutine$11$label_4#1:
    goto inline$CallCompletionRoutine$11$label_5#1;

  inline$CallCompletionRoutine$11$label_5#1:
    goto inline$CallCompletionRoutine$11$label_6#1;

  inline$CallCompletionRoutine$11$label_6#1:
    goto inline$CallCompletionRoutine$11$label_7#1;

  inline$CallCompletionRoutine$11$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$59$Entry#1;

  inline$IoGetCurrentIrpStackLocation$59$Entry#1:
    inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$59$start#1;

  inline$IoGetCurrentIrpStackLocation$59$start#1:
    inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$59$label_3#1;

  inline$IoGetCurrentIrpStackLocation$59$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$59$label_3_true#1, inline$IoGetCurrentIrpStackLocation$59$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$59$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$59$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$59$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$59$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$59$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$59$label_4#1;

  inline$IoGetCurrentIrpStackLocation$59$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$59$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$59$label_6#1;

  inline$IoGetCurrentIrpStackLocation$59$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$59$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$59$label_7#1;

  inline$IoGetCurrentIrpStackLocation$59$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$59$label_5#1;

  inline$IoGetCurrentIrpStackLocation$59$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$59$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$59$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$59$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$59$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$59$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$59$label_5#1;

  inline$IoGetCurrentIrpStackLocation$59$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$59$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$59$label_1#1;

  inline$IoGetCurrentIrpStackLocation$59$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$59$Return#1;

  inline$IoGetCurrentIrpStackLocation$59$Return#1:
    goto inline$CallCompletionRoutine$11$label_7$1#1;

  inline$CallCompletionRoutine$11$label_7$1#1:
    goto inline$CallCompletionRoutine$11$anon10_Then#1, inline$CallCompletionRoutine$11$anon10_Else#1;

  inline$CallCompletionRoutine$11$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$11$anon1#1;

  inline$CallCompletionRoutine$11$anon1#1:
    goto inline$CallCompletionRoutine$11$label_10#1;

  inline$CallCompletionRoutine$11$label_10#1:
    goto inline$CallCompletionRoutine$11$label_11#1;

  inline$CallCompletionRoutine$11$label_11#1:
    havoc inline$CallCompletionRoutine$11$myNondetVar_0;
    inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$11$myNondetVar_0;
    goto inline$CallCompletionRoutine$11$label_12#1;

  inline$CallCompletionRoutine$11$label_12#1:
    havoc inline$CallCompletionRoutine$11$myNondetVar_0;
    inline$CallCompletionRoutine$11$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$11$myNondetVar_0;
    goto inline$CallCompletionRoutine$11$label_13#1;

  inline$CallCompletionRoutine$11$label_13#1:
    havoc inline$CallCompletionRoutine$11$myNondetVar_0;
    goto inline$CallCompletionRoutine$11$label_14#1;

  inline$CallCompletionRoutine$11$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$60$Entry#1;

  inline$IoGetCurrentIrpStackLocation$60$Entry#1:
    inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$60$start#1;

  inline$IoGetCurrentIrpStackLocation$60$start#1:
    inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$60$label_3#1;

  inline$IoGetCurrentIrpStackLocation$60$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$60$label_3_true#1, inline$IoGetCurrentIrpStackLocation$60$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$60$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$60$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$60$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$60$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$60$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$60$label_4#1;

  inline$IoGetCurrentIrpStackLocation$60$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$60$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$60$label_6#1;

  inline$IoGetCurrentIrpStackLocation$60$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$60$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$60$label_7#1;

  inline$IoGetCurrentIrpStackLocation$60$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$60$label_5#1;

  inline$IoGetCurrentIrpStackLocation$60$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$60$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$60$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$60$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$60$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$60$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$60$label_5#1;

  inline$IoGetCurrentIrpStackLocation$60$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$60$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$60$label_1#1;

  inline$IoGetCurrentIrpStackLocation$60$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$60$Return#1;

  inline$IoGetCurrentIrpStackLocation$60$Return#1:
    goto inline$CallCompletionRoutine$11$label_14$1#1;

  inline$CallCompletionRoutine$11$label_14$1#1:
    goto inline$CallCompletionRoutine$11$anon11_Then#1, inline$CallCompletionRoutine$11$anon11_Else#1;

  inline$CallCompletionRoutine$11$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$11$anon3#1;

  inline$CallCompletionRoutine$11$anon3#1:
    goto inline$CallCompletionRoutine$11$label_17#1;

  inline$CallCompletionRoutine$11$label_17#1:
    goto inline$CallCompletionRoutine$11$label_18#1;

  inline$CallCompletionRoutine$11$label_18#1:
    goto inline$CallCompletionRoutine$11$label_18_true#1, inline$CallCompletionRoutine$11$label_18_false#1;

  inline$CallCompletionRoutine$11$label_18_false#1:
    assume inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$11$label_1#1;

  inline$CallCompletionRoutine$11$label_18_true#1:
    assume inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$11$label_19#1;

  inline$CallCompletionRoutine$11$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$11$label_20#1;

  inline$CallCompletionRoutine$11$label_20#1:
    goto inline$CallCompletionRoutine$11$label_20_icall_1#1, inline$CallCompletionRoutine$11$label_20_icall_2#1, inline$CallCompletionRoutine$11$label_20_icall_3#1;

  inline$CallCompletionRoutine$11$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$11$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$11$Entry#1;

  inline$BDLSystemPowerIoCompletion$11$Entry#1:
    inline$BDLSystemPowerIoCompletion$11$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$11$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$11$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$11$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$11$start#1;

  inline$BDLSystemPowerIoCompletion$11$start#1:
    call inline$BDLSystemPowerIoCompletion$11$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$11$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$11$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$11$label_3#1;

  inline$BDLSystemPowerIoCompletion$11$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_4#1;

  inline$BDLSystemPowerIoCompletion$11$label_4#1:
    inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_5#1;

  inline$BDLSystemPowerIoCompletion$11$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_6#1;

  inline$BDLSystemPowerIoCompletion$11$label_6#1:
    inline$BDLSystemPowerIoCompletion$11$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$11$label_7#1;

  inline$BDLSystemPowerIoCompletion$11$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_8#1;

  inline$BDLSystemPowerIoCompletion$11$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$11$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$11$label_9#1;

  inline$BDLSystemPowerIoCompletion$11$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_10#1;

  inline$BDLSystemPowerIoCompletion$11$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$62$Entry#1;

  inline$IoGetCurrentIrpStackLocation$62$Entry#1:
    inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$62$start#1;

  inline$IoGetCurrentIrpStackLocation$62$start#1:
    inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$62$label_3#1;

  inline$IoGetCurrentIrpStackLocation$62$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$62$label_3_true#1, inline$IoGetCurrentIrpStackLocation$62$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$62$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$62$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$62$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$62$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$62$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$62$label_4#1;

  inline$IoGetCurrentIrpStackLocation$62$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$62$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$62$label_6#1;

  inline$IoGetCurrentIrpStackLocation$62$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$62$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$62$label_7#1;

  inline$IoGetCurrentIrpStackLocation$62$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$62$label_5#1;

  inline$IoGetCurrentIrpStackLocation$62$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$62$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$62$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$62$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$62$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$62$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$62$label_5#1;

  inline$IoGetCurrentIrpStackLocation$62$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$62$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$62$label_1#1;

  inline$IoGetCurrentIrpStackLocation$62$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$62$Return#1;

  inline$IoGetCurrentIrpStackLocation$62$Return#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon36_Then#1, inline$BDLSystemPowerIoCompletion$11$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon1#1;

  inline$BDLSystemPowerIoCompletion$11$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_13#1;

  inline$BDLSystemPowerIoCompletion$11$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_14#1;

  inline$BDLSystemPowerIoCompletion$11$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_15#1;

  inline$BDLSystemPowerIoCompletion$11$label_15#1:
    goto inline$BDLGetDebugLevel$316$Entry#1;

  inline$BDLGetDebugLevel$316$Entry#1:
    goto inline$BDLGetDebugLevel$316$start#1;

  inline$BDLGetDebugLevel$316$start#1:
    goto inline$BDLGetDebugLevel$316$label_3#1;

  inline$BDLGetDebugLevel$316$label_3#1:
    havoc inline$BDLGetDebugLevel$316$myNondetVar_0;
    inline$BDLGetDebugLevel$316$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$316$myNondetVar_0;
    goto inline$BDLGetDebugLevel$316$label_1#1;

  inline$BDLGetDebugLevel$316$label_1#1:
    goto inline$BDLGetDebugLevel$316$Return#1;

  inline$BDLGetDebugLevel$316$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$316$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon37_Then#1, inline$BDLSystemPowerIoCompletion$11$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon3#1;

  inline$BDLSystemPowerIoCompletion$11$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_18#1;

  inline$BDLSystemPowerIoCompletion$11$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_18_true#1, inline$BDLSystemPowerIoCompletion$11$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_19#1;

  inline$BDLSystemPowerIoCompletion$11$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_22#1;

  inline$BDLSystemPowerIoCompletion$11$label_22#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_23#1;

  inline$BDLSystemPowerIoCompletion$11$label_23#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_24#1;

  inline$BDLSystemPowerIoCompletion$11$label_24#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_25#1;

  inline$BDLSystemPowerIoCompletion$11$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$11$label_19#1;

  inline$BDLSystemPowerIoCompletion$11$label_19#1:
    goto inline$BDLGetDebugLevel$317$Entry#1;

  inline$BDLGetDebugLevel$317$Entry#1:
    goto inline$BDLGetDebugLevel$317$start#1;

  inline$BDLGetDebugLevel$317$start#1:
    goto inline$BDLGetDebugLevel$317$label_3#1;

  inline$BDLGetDebugLevel$317$label_3#1:
    havoc inline$BDLGetDebugLevel$317$myNondetVar_0;
    inline$BDLGetDebugLevel$317$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$317$myNondetVar_0;
    goto inline$BDLGetDebugLevel$317$label_1#1;

  inline$BDLGetDebugLevel$317$label_1#1:
    goto inline$BDLGetDebugLevel$317$Return#1;

  inline$BDLGetDebugLevel$317$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$317$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon38_Then#1, inline$BDLSystemPowerIoCompletion$11$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon5#1;

  inline$BDLSystemPowerIoCompletion$11$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_28#1;

  inline$BDLSystemPowerIoCompletion$11$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_28_true#1, inline$BDLSystemPowerIoCompletion$11$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_29#1;

  inline$BDLSystemPowerIoCompletion$11$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_32#1;

  inline$BDLSystemPowerIoCompletion$11$label_32#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_33#1;

  inline$BDLSystemPowerIoCompletion$11$label_33#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_34#1;

  inline$BDLSystemPowerIoCompletion$11$label_34#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_35#1;

  inline$BDLSystemPowerIoCompletion$11$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$11$label_29#1;

  inline$BDLSystemPowerIoCompletion$11$label_29#1:
    goto inline$BDLGetDebugLevel$318$Entry#1;

  inline$BDLGetDebugLevel$318$Entry#1:
    goto inline$BDLGetDebugLevel$318$start#1;

  inline$BDLGetDebugLevel$318$start#1:
    goto inline$BDLGetDebugLevel$318$label_3#1;

  inline$BDLGetDebugLevel$318$label_3#1:
    havoc inline$BDLGetDebugLevel$318$myNondetVar_0;
    inline$BDLGetDebugLevel$318$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$318$myNondetVar_0;
    goto inline$BDLGetDebugLevel$318$label_1#1;

  inline$BDLGetDebugLevel$318$label_1#1:
    goto inline$BDLGetDebugLevel$318$Return#1;

  inline$BDLGetDebugLevel$318$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$318$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon39_Then#1, inline$BDLSystemPowerIoCompletion$11$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon7#1;

  inline$BDLSystemPowerIoCompletion$11$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_38#1;

  inline$BDLSystemPowerIoCompletion$11$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_38_true#1, inline$BDLSystemPowerIoCompletion$11$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_39#1;

  inline$BDLSystemPowerIoCompletion$11$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_40#1;

  inline$BDLSystemPowerIoCompletion$11$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_39#1;

  inline$BDLSystemPowerIoCompletion$11$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_39_true#1, inline$BDLSystemPowerIoCompletion$11$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_41#1;

  inline$BDLSystemPowerIoCompletion$11$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$11$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$11$label_107#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$11$label_108#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$11$label_108#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$11$label_108#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$11$label_108#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$11$label_108#1;

  inline$BDLSystemPowerIoCompletion$11$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_109#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$11$label_107#1;

  inline$BDLSystemPowerIoCompletion$11$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_109#1;

  inline$BDLSystemPowerIoCompletion$11$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$11$label_106#1;

  inline$BDLSystemPowerIoCompletion$11$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_106_true#1, inline$BDLSystemPowerIoCompletion$11$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_142#1;

  inline$BDLSystemPowerIoCompletion$11$label_142#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_143#1;

  inline$BDLSystemPowerIoCompletion$11$label_143#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_144#1;

  inline$BDLSystemPowerIoCompletion$11$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_109#1;

  inline$BDLSystemPowerIoCompletion$11$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_109#1;

  inline$BDLSystemPowerIoCompletion$11$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$11$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$11$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$11$myNondetVar_0, inline$BDLSystemPowerIoCompletion$11$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$11$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$11$anon50_Then#1, inline$BDLSystemPowerIoCompletion$11$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon29#1;

  inline$BDLSystemPowerIoCompletion$11$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_112#1;

  inline$BDLSystemPowerIoCompletion$11$label_112#1:
    inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$11$label_113#1;

  inline$BDLSystemPowerIoCompletion$11$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_113_true#1, inline$BDLSystemPowerIoCompletion$11$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$11$label_114#1;

  inline$BDLSystemPowerIoCompletion$11$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_116#1;

  inline$BDLSystemPowerIoCompletion$11$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_117#1;

  inline$BDLSystemPowerIoCompletion$11$label_117#1:
    goto inline$BDLGetDebugLevel$325$Entry#1;

  inline$BDLGetDebugLevel$325$Entry#1:
    goto inline$BDLGetDebugLevel$325$start#1;

  inline$BDLGetDebugLevel$325$start#1:
    goto inline$BDLGetDebugLevel$325$label_3#1;

  inline$BDLGetDebugLevel$325$label_3#1:
    havoc inline$BDLGetDebugLevel$325$myNondetVar_0;
    inline$BDLGetDebugLevel$325$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$325$myNondetVar_0;
    goto inline$BDLGetDebugLevel$325$label_1#1;

  inline$BDLGetDebugLevel$325$label_1#1:
    goto inline$BDLGetDebugLevel$325$Return#1;

  inline$BDLGetDebugLevel$325$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$325$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon51_Then#1, inline$BDLSystemPowerIoCompletion$11$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon31#1;

  inline$BDLSystemPowerIoCompletion$11$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_120#1;

  inline$BDLSystemPowerIoCompletion$11$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_120_true#1, inline$BDLSystemPowerIoCompletion$11$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_121#1;

  inline$BDLSystemPowerIoCompletion$11$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_124#1;

  inline$BDLSystemPowerIoCompletion$11$label_124#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_125#1;

  inline$BDLSystemPowerIoCompletion$11$label_125#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_126#1;

  inline$BDLSystemPowerIoCompletion$11$label_126#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_127#1;

  inline$BDLSystemPowerIoCompletion$11$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$11$label_121#1;

  inline$BDLSystemPowerIoCompletion$11$label_121#1:
    goto inline$BDLGetDebugLevel$326$Entry#1;

  inline$BDLGetDebugLevel$326$Entry#1:
    goto inline$BDLGetDebugLevel$326$start#1;

  inline$BDLGetDebugLevel$326$start#1:
    goto inline$BDLGetDebugLevel$326$label_3#1;

  inline$BDLGetDebugLevel$326$label_3#1:
    havoc inline$BDLGetDebugLevel$326$myNondetVar_0;
    inline$BDLGetDebugLevel$326$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$326$myNondetVar_0;
    goto inline$BDLGetDebugLevel$326$label_1#1;

  inline$BDLGetDebugLevel$326$label_1#1:
    goto inline$BDLGetDebugLevel$326$Return#1;

  inline$BDLGetDebugLevel$326$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$326$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon52_Then#1, inline$BDLSystemPowerIoCompletion$11$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon33#1;

  inline$BDLSystemPowerIoCompletion$11$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_130#1;

  inline$BDLSystemPowerIoCompletion$11$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_130_true#1, inline$BDLSystemPowerIoCompletion$11$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_131#1;

  inline$BDLSystemPowerIoCompletion$11$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_134#1;

  inline$BDLSystemPowerIoCompletion$11$label_134#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_135#1;

  inline$BDLSystemPowerIoCompletion$11$label_135#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_136#1;

  inline$BDLSystemPowerIoCompletion$11$label_136#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_137#1;

  inline$BDLSystemPowerIoCompletion$11$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$11$label_131#1;

  inline$BDLSystemPowerIoCompletion$11$label_131#1:
    goto inline$BDLGetDebugLevel$327$Entry#1;

  inline$BDLGetDebugLevel$327$Entry#1:
    goto inline$BDLGetDebugLevel$327$start#1;

  inline$BDLGetDebugLevel$327$start#1:
    goto inline$BDLGetDebugLevel$327$label_3#1;

  inline$BDLGetDebugLevel$327$label_3#1:
    havoc inline$BDLGetDebugLevel$327$myNondetVar_0;
    inline$BDLGetDebugLevel$327$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$327$myNondetVar_0;
    goto inline$BDLGetDebugLevel$327$label_1#1;

  inline$BDLGetDebugLevel$327$label_1#1:
    goto inline$BDLGetDebugLevel$327$Return#1;

  inline$BDLGetDebugLevel$327$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$327$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon53_Then#1, inline$BDLSystemPowerIoCompletion$11$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon35#1;

  inline$BDLSystemPowerIoCompletion$11$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_140#1;

  inline$BDLSystemPowerIoCompletion$11$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_140_true#1, inline$BDLSystemPowerIoCompletion$11$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_67#1;

  inline$BDLSystemPowerIoCompletion$11$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_141#1;

  inline$BDLSystemPowerIoCompletion$11$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_67#1;

  inline$BDLSystemPowerIoCompletion$11$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$11$label_115#1;

  inline$BDLSystemPowerIoCompletion$11$label_115#1:
    inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$11$label_80#1;

  inline$BDLSystemPowerIoCompletion$11$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$11$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_42#1;

  inline$BDLSystemPowerIoCompletion$11$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$11$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$11$label_43#1;

  inline$BDLSystemPowerIoCompletion$11$label_43#1:
    goto inline$BDLGetDebugLevel$319$Entry#1;

  inline$BDLGetDebugLevel$319$Entry#1:
    goto inline$BDLGetDebugLevel$319$start#1;

  inline$BDLGetDebugLevel$319$start#1:
    goto inline$BDLGetDebugLevel$319$label_3#1;

  inline$BDLGetDebugLevel$319$label_3#1:
    havoc inline$BDLGetDebugLevel$319$myNondetVar_0;
    inline$BDLGetDebugLevel$319$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$319$myNondetVar_0;
    goto inline$BDLGetDebugLevel$319$label_1#1;

  inline$BDLGetDebugLevel$319$label_1#1:
    goto inline$BDLGetDebugLevel$319$Return#1;

  inline$BDLGetDebugLevel$319$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$319$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon40_Then#1, inline$BDLSystemPowerIoCompletion$11$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon9#1;

  inline$BDLSystemPowerIoCompletion$11$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_46#1;

  inline$BDLSystemPowerIoCompletion$11$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_46_true#1, inline$BDLSystemPowerIoCompletion$11$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_47#1;

  inline$BDLSystemPowerIoCompletion$11$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_50#1;

  inline$BDLSystemPowerIoCompletion$11$label_50#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_51#1;

  inline$BDLSystemPowerIoCompletion$11$label_51#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_52#1;

  inline$BDLSystemPowerIoCompletion$11$label_52#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_53#1;

  inline$BDLSystemPowerIoCompletion$11$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$11$label_47#1;

  inline$BDLSystemPowerIoCompletion$11$label_47#1:
    goto inline$BDLGetDebugLevel$320$Entry#1;

  inline$BDLGetDebugLevel$320$Entry#1:
    goto inline$BDLGetDebugLevel$320$start#1;

  inline$BDLGetDebugLevel$320$start#1:
    goto inline$BDLGetDebugLevel$320$label_3#1;

  inline$BDLGetDebugLevel$320$label_3#1:
    havoc inline$BDLGetDebugLevel$320$myNondetVar_0;
    inline$BDLGetDebugLevel$320$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$320$myNondetVar_0;
    goto inline$BDLGetDebugLevel$320$label_1#1;

  inline$BDLGetDebugLevel$320$label_1#1:
    goto inline$BDLGetDebugLevel$320$Return#1;

  inline$BDLGetDebugLevel$320$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$320$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon41_Then#1, inline$BDLSystemPowerIoCompletion$11$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon11#1;

  inline$BDLSystemPowerIoCompletion$11$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_56#1;

  inline$BDLSystemPowerIoCompletion$11$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_56_true#1, inline$BDLSystemPowerIoCompletion$11$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_57#1;

  inline$BDLSystemPowerIoCompletion$11$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_60#1;

  inline$BDLSystemPowerIoCompletion$11$label_60#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_61#1;

  inline$BDLSystemPowerIoCompletion$11$label_61#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_62#1;

  inline$BDLSystemPowerIoCompletion$11$label_62#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_63#1;

  inline$BDLSystemPowerIoCompletion$11$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$11$label_57#1;

  inline$BDLSystemPowerIoCompletion$11$label_57#1:
    goto inline$BDLGetDebugLevel$321$Entry#1;

  inline$BDLGetDebugLevel$321$Entry#1:
    goto inline$BDLGetDebugLevel$321$start#1;

  inline$BDLGetDebugLevel$321$start#1:
    goto inline$BDLGetDebugLevel$321$label_3#1;

  inline$BDLGetDebugLevel$321$label_3#1:
    havoc inline$BDLGetDebugLevel$321$myNondetVar_0;
    inline$BDLGetDebugLevel$321$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$321$myNondetVar_0;
    goto inline$BDLGetDebugLevel$321$label_1#1;

  inline$BDLGetDebugLevel$321$label_1#1:
    goto inline$BDLGetDebugLevel$321$Return#1;

  inline$BDLGetDebugLevel$321$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$321$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon42_Then#1, inline$BDLSystemPowerIoCompletion$11$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon13#1;

  inline$BDLSystemPowerIoCompletion$11$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_66#1;

  inline$BDLSystemPowerIoCompletion$11$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_66_true#1, inline$BDLSystemPowerIoCompletion$11$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_67#1;

  inline$BDLSystemPowerIoCompletion$11$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_70#1;

  inline$BDLSystemPowerIoCompletion$11$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_67#1;

  inline$BDLSystemPowerIoCompletion$11$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$11$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$11$anon43_Then#1, inline$BDLSystemPowerIoCompletion$11$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon15#1;

  inline$BDLSystemPowerIoCompletion$11$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_71#1;

  inline$BDLSystemPowerIoCompletion$11$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$11$anon44_Then#1, inline$BDLSystemPowerIoCompletion$11$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon17#1;

  inline$BDLSystemPowerIoCompletion$11$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_74#1;

  inline$BDLSystemPowerIoCompletion$11$label_74#1:
    goto inline$storm_IoCompleteRequest$24$Entry#1;

  inline$storm_IoCompleteRequest$24$Entry#1:
    inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$11$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$24$start#1;

  inline$storm_IoCompleteRequest$24$start#1:
    inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$24$label_3#1;

  inline$storm_IoCompleteRequest$24$label_3#1:
    call inline$storm_IoCompleteRequest$24$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$24$label_6#1;

  inline$storm_IoCompleteRequest$24$label_6#1:
    goto inline$storm_IoCompleteRequest$24$label_6_true#1, inline$storm_IoCompleteRequest$24$label_6_false#1;

  inline$storm_IoCompleteRequest$24$label_6_false#1:
    assume inline$storm_IoCompleteRequest$24$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$24$label_7#1;

  inline$storm_IoCompleteRequest$24$label_6_true#1:
    assume inline$storm_IoCompleteRequest$24$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$24$label_8#1;

  inline$storm_IoCompleteRequest$24$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$24$anon3_Then#1, inline$storm_IoCompleteRequest$24$anon3_Else#1;

  inline$storm_IoCompleteRequest$24$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$24$anon1#1;

  inline$storm_IoCompleteRequest$24$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$24$label_9#1;

  inline$storm_IoCompleteRequest$24$label_9#1:
    goto inline$storm_IoCompleteRequest$24$label_9_true#1, inline$storm_IoCompleteRequest$24$label_9_false#1;

  inline$storm_IoCompleteRequest$24$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$24$label_10#1;

  inline$storm_IoCompleteRequest$24$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$24$label_1#1;

  inline$storm_IoCompleteRequest$24$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$24$label_7#1;

  inline$storm_IoCompleteRequest$24$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$24$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$24$label_1#1;

  inline$storm_IoCompleteRequest$24$label_1#1:
    goto inline$storm_IoCompleteRequest$24$Return#1;

  inline$storm_IoCompleteRequest$24$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$24$Return#1;

  inline$storm_IoCompleteRequest$24$Return#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon45_Then#1, inline$BDLSystemPowerIoCompletion$11$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon19#1;

  inline$BDLSystemPowerIoCompletion$11$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_77#1;

  inline$BDLSystemPowerIoCompletion$11$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$11$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$11$anon46_Then#1, inline$BDLSystemPowerIoCompletion$11$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon21#1;

  inline$BDLSystemPowerIoCompletion$11$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_80#1;

  inline$BDLSystemPowerIoCompletion$11$label_80#1:
    goto inline$BDLGetDebugLevel$322$Entry#1;

  inline$BDLGetDebugLevel$322$Entry#1:
    goto inline$BDLGetDebugLevel$322$start#1;

  inline$BDLGetDebugLevel$322$start#1:
    goto inline$BDLGetDebugLevel$322$label_3#1;

  inline$BDLGetDebugLevel$322$label_3#1:
    havoc inline$BDLGetDebugLevel$322$myNondetVar_0;
    inline$BDLGetDebugLevel$322$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$322$myNondetVar_0;
    goto inline$BDLGetDebugLevel$322$label_1#1;

  inline$BDLGetDebugLevel$322$label_1#1:
    goto inline$BDLGetDebugLevel$322$Return#1;

  inline$BDLGetDebugLevel$322$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$322$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon47_Then#1, inline$BDLSystemPowerIoCompletion$11$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon23#1;

  inline$BDLSystemPowerIoCompletion$11$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_83#1;

  inline$BDLSystemPowerIoCompletion$11$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_83_true#1, inline$BDLSystemPowerIoCompletion$11$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_84#1;

  inline$BDLSystemPowerIoCompletion$11$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_87#1;

  inline$BDLSystemPowerIoCompletion$11$label_87#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_88#1;

  inline$BDLSystemPowerIoCompletion$11$label_88#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_89#1;

  inline$BDLSystemPowerIoCompletion$11$label_89#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_90#1;

  inline$BDLSystemPowerIoCompletion$11$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$11$label_84#1;

  inline$BDLSystemPowerIoCompletion$11$label_84#1:
    goto inline$BDLGetDebugLevel$323$Entry#1;

  inline$BDLGetDebugLevel$323$Entry#1:
    goto inline$BDLGetDebugLevel$323$start#1;

  inline$BDLGetDebugLevel$323$start#1:
    goto inline$BDLGetDebugLevel$323$label_3#1;

  inline$BDLGetDebugLevel$323$label_3#1:
    havoc inline$BDLGetDebugLevel$323$myNondetVar_0;
    inline$BDLGetDebugLevel$323$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$323$myNondetVar_0;
    goto inline$BDLGetDebugLevel$323$label_1#1;

  inline$BDLGetDebugLevel$323$label_1#1:
    goto inline$BDLGetDebugLevel$323$Return#1;

  inline$BDLGetDebugLevel$323$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$323$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon48_Then#1, inline$BDLSystemPowerIoCompletion$11$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon25#1;

  inline$BDLSystemPowerIoCompletion$11$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_93#1;

  inline$BDLSystemPowerIoCompletion$11$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_93_true#1, inline$BDLSystemPowerIoCompletion$11$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_94#1;

  inline$BDLSystemPowerIoCompletion$11$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_97#1;

  inline$BDLSystemPowerIoCompletion$11$label_97#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_98#1;

  inline$BDLSystemPowerIoCompletion$11$label_98#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_99#1;

  inline$BDLSystemPowerIoCompletion$11$label_99#1:
    call inline$BDLSystemPowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$11$label_100#1;

  inline$BDLSystemPowerIoCompletion$11$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$11$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$11$label_94#1;

  inline$BDLSystemPowerIoCompletion$11$label_94#1:
    goto inline$BDLGetDebugLevel$324$Entry#1;

  inline$BDLGetDebugLevel$324$Entry#1:
    goto inline$BDLGetDebugLevel$324$start#1;

  inline$BDLGetDebugLevel$324$start#1:
    goto inline$BDLGetDebugLevel$324$label_3#1;

  inline$BDLGetDebugLevel$324$label_3#1:
    havoc inline$BDLGetDebugLevel$324$myNondetVar_0;
    inline$BDLGetDebugLevel$324$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$324$myNondetVar_0;
    goto inline$BDLGetDebugLevel$324$label_1#1;

  inline$BDLGetDebugLevel$324$label_1#1:
    goto inline$BDLGetDebugLevel$324$Return#1;

  inline$BDLGetDebugLevel$324$Return#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$324$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$11$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$11$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$11$anon49_Then#1, inline$BDLSystemPowerIoCompletion$11$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$11$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$anon27#1;

  inline$BDLSystemPowerIoCompletion$11$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_103#1;

  inline$BDLSystemPowerIoCompletion$11$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_103_true#1, inline$BDLSystemPowerIoCompletion$11$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$11$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_104#1;

  inline$BDLSystemPowerIoCompletion$11$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$11$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$11$label_105#1;

  inline$BDLSystemPowerIoCompletion$11$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$11$label_104#1;

  inline$BDLSystemPowerIoCompletion$11$label_104#1:
    inline$BDLSystemPowerIoCompletion$11$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$11$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$11$label_1#1;

  inline$BDLSystemPowerIoCompletion$11$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$11$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$11$Return#1;

  inline$BDLSystemPowerIoCompletion$11$Return#1:
    inline$CallCompletionRoutine$11$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$11$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$11$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$11$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$11$anon14_Then#1, inline$CallCompletionRoutine$11$anon14_Else#1;

  inline$CallCompletionRoutine$11$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$11$anon9#1;

  inline$CallCompletionRoutine$11$anon9#1:
    goto inline$CallCompletionRoutine$11$label_20_icall_return#1;

  inline$CallCompletionRoutine$11$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$11$Return#1;

  inline$CallCompletionRoutine$11$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$11$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$11$Entry#1;

  inline$BDLDevicePowerIoCompletion$11$Entry#1:
    inline$BDLDevicePowerIoCompletion$11$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$11$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$11$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$11$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$11$start#1;

  inline$BDLDevicePowerIoCompletion$11$start#1:
    call inline$BDLDevicePowerIoCompletion$11$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$11$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$11$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$11$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$11$label_3#1;

  inline$BDLDevicePowerIoCompletion$11$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_4#1;

  inline$BDLDevicePowerIoCompletion$11$label_4#1:
    inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_5#1;

  inline$BDLDevicePowerIoCompletion$11$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_6#1;

  inline$BDLDevicePowerIoCompletion$11$label_6#1:
    inline$BDLDevicePowerIoCompletion$11$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$11$label_7#1;

  inline$BDLDevicePowerIoCompletion$11$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_8#1;

  inline$BDLDevicePowerIoCompletion$11$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$11$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$11$label_9#1;

  inline$BDLDevicePowerIoCompletion$11$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_10#1;

  inline$BDLDevicePowerIoCompletion$11$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$61$Entry#1;

  inline$IoGetCurrentIrpStackLocation$61$Entry#1:
    inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$61$start#1;

  inline$IoGetCurrentIrpStackLocation$61$start#1:
    inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$61$label_3#1;

  inline$IoGetCurrentIrpStackLocation$61$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$61$label_3_true#1, inline$IoGetCurrentIrpStackLocation$61$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$61$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$61$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$61$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$61$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$61$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$61$label_4#1;

  inline$IoGetCurrentIrpStackLocation$61$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$61$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$61$label_6#1;

  inline$IoGetCurrentIrpStackLocation$61$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$61$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$61$label_7#1;

  inline$IoGetCurrentIrpStackLocation$61$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$61$label_5#1;

  inline$IoGetCurrentIrpStackLocation$61$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$61$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$61$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$61$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$61$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$61$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$61$label_5#1;

  inline$IoGetCurrentIrpStackLocation$61$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$61$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$61$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$61$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$61$label_1#1;

  inline$IoGetCurrentIrpStackLocation$61$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$61$Return#1;

  inline$IoGetCurrentIrpStackLocation$61$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$61$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon30_Then#1, inline$BDLDevicePowerIoCompletion$11$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon1#1;

  inline$BDLDevicePowerIoCompletion$11$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_13#1;

  inline$BDLDevicePowerIoCompletion$11$label_13#1:
    inline$BDLDevicePowerIoCompletion$11$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$11$label_14#1;

  inline$BDLDevicePowerIoCompletion$11$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_15#1;

  inline$BDLDevicePowerIoCompletion$11$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$11$label_16#1;

  inline$BDLDevicePowerIoCompletion$11$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_17#1;

  inline$BDLDevicePowerIoCompletion$11$label_17#1:
    goto inline$BDLGetDebugLevel$307$Entry#1;

  inline$BDLGetDebugLevel$307$Entry#1:
    goto inline$BDLGetDebugLevel$307$start#1;

  inline$BDLGetDebugLevel$307$start#1:
    goto inline$BDLGetDebugLevel$307$label_3#1;

  inline$BDLGetDebugLevel$307$label_3#1:
    havoc inline$BDLGetDebugLevel$307$myNondetVar_0;
    inline$BDLGetDebugLevel$307$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$307$myNondetVar_0;
    goto inline$BDLGetDebugLevel$307$label_1#1;

  inline$BDLGetDebugLevel$307$label_1#1:
    goto inline$BDLGetDebugLevel$307$Return#1;

  inline$BDLGetDebugLevel$307$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$307$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon31_Then#1, inline$BDLDevicePowerIoCompletion$11$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon3#1;

  inline$BDLDevicePowerIoCompletion$11$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_20#1;

  inline$BDLDevicePowerIoCompletion$11$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_20_true#1, inline$BDLDevicePowerIoCompletion$11$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_21#1;

  inline$BDLDevicePowerIoCompletion$11$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_24#1;

  inline$BDLDevicePowerIoCompletion$11$label_24#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_25#1;

  inline$BDLDevicePowerIoCompletion$11$label_25#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_26#1;

  inline$BDLDevicePowerIoCompletion$11$label_26#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_27#1;

  inline$BDLDevicePowerIoCompletion$11$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$11$label_21#1;

  inline$BDLDevicePowerIoCompletion$11$label_21#1:
    goto inline$BDLGetDebugLevel$308$Entry#1;

  inline$BDLGetDebugLevel$308$Entry#1:
    goto inline$BDLGetDebugLevel$308$start#1;

  inline$BDLGetDebugLevel$308$start#1:
    goto inline$BDLGetDebugLevel$308$label_3#1;

  inline$BDLGetDebugLevel$308$label_3#1:
    havoc inline$BDLGetDebugLevel$308$myNondetVar_0;
    inline$BDLGetDebugLevel$308$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$308$myNondetVar_0;
    goto inline$BDLGetDebugLevel$308$label_1#1;

  inline$BDLGetDebugLevel$308$label_1#1:
    goto inline$BDLGetDebugLevel$308$Return#1;

  inline$BDLGetDebugLevel$308$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$308$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon32_Then#1, inline$BDLDevicePowerIoCompletion$11$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon5#1;

  inline$BDLDevicePowerIoCompletion$11$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_30#1;

  inline$BDLDevicePowerIoCompletion$11$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_30_true#1, inline$BDLDevicePowerIoCompletion$11$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_31#1;

  inline$BDLDevicePowerIoCompletion$11$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_34#1;

  inline$BDLDevicePowerIoCompletion$11$label_34#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_35#1;

  inline$BDLDevicePowerIoCompletion$11$label_35#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_36#1;

  inline$BDLDevicePowerIoCompletion$11$label_36#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_37#1;

  inline$BDLDevicePowerIoCompletion$11$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$11$label_31#1;

  inline$BDLDevicePowerIoCompletion$11$label_31#1:
    goto inline$BDLGetDebugLevel$309$Entry#1;

  inline$BDLGetDebugLevel$309$Entry#1:
    goto inline$BDLGetDebugLevel$309$start#1;

  inline$BDLGetDebugLevel$309$start#1:
    goto inline$BDLGetDebugLevel$309$label_3#1;

  inline$BDLGetDebugLevel$309$label_3#1:
    havoc inline$BDLGetDebugLevel$309$myNondetVar_0;
    inline$BDLGetDebugLevel$309$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$309$myNondetVar_0;
    goto inline$BDLGetDebugLevel$309$label_1#1;

  inline$BDLGetDebugLevel$309$label_1#1:
    goto inline$BDLGetDebugLevel$309$Return#1;

  inline$BDLGetDebugLevel$309$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$309$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon33_Then#1, inline$BDLDevicePowerIoCompletion$11$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon7#1;

  inline$BDLDevicePowerIoCompletion$11$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_40#1;

  inline$BDLDevicePowerIoCompletion$11$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_40_true#1, inline$BDLDevicePowerIoCompletion$11$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_41#1;

  inline$BDLDevicePowerIoCompletion$11$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_42#1;

  inline$BDLDevicePowerIoCompletion$11$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_41#1;

  inline$BDLDevicePowerIoCompletion$11$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_41_true#1, inline$BDLDevicePowerIoCompletion$11$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$11$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$11$label_43#1;

  inline$BDLDevicePowerIoCompletion$11$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$11$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$11$label_44#1;

  inline$BDLDevicePowerIoCompletion$11$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_44_true#1, inline$BDLDevicePowerIoCompletion$11$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$11$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$11$label_45#1;

  inline$BDLDevicePowerIoCompletion$11$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_45_true#1, inline$BDLDevicePowerIoCompletion$11$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$11$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$11$label_43#1;

  inline$BDLDevicePowerIoCompletion$11$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$11$label_86#1;

  inline$BDLDevicePowerIoCompletion$11$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$11$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$11$label_46#1;

  inline$BDLDevicePowerIoCompletion$11$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$11$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$11$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$11$label_46#1;

  inline$BDLDevicePowerIoCompletion$11$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$11$label_49#1;

  inline$BDLDevicePowerIoCompletion$11$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_50#1;

  inline$BDLDevicePowerIoCompletion$11$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_51#1;

  inline$BDLDevicePowerIoCompletion$11$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_54#1;

  inline$BDLDevicePowerIoCompletion$11$label_54#1:
    inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$11$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$11$label_55#1;

  inline$BDLDevicePowerIoCompletion$11$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_55_true#1, inline$BDLDevicePowerIoCompletion$11$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_56#1;

  inline$BDLDevicePowerIoCompletion$11$label_56#1:
    call inline$BDLDevicePowerIoCompletion$11$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$11$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$11$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$11$anon34_Then#1, inline$BDLDevicePowerIoCompletion$11$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon9#1;

  inline$BDLDevicePowerIoCompletion$11$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_83#1;

  inline$BDLDevicePowerIoCompletion$11$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_59#1;

  inline$BDLDevicePowerIoCompletion$11$label_59#1:
    goto inline$BDLGetDebugLevel$310$Entry#1;

  inline$BDLGetDebugLevel$310$Entry#1:
    goto inline$BDLGetDebugLevel$310$start#1;

  inline$BDLGetDebugLevel$310$start#1:
    goto inline$BDLGetDebugLevel$310$label_3#1;

  inline$BDLGetDebugLevel$310$label_3#1:
    havoc inline$BDLGetDebugLevel$310$myNondetVar_0;
    inline$BDLGetDebugLevel$310$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$310$myNondetVar_0;
    goto inline$BDLGetDebugLevel$310$label_1#1;

  inline$BDLGetDebugLevel$310$label_1#1:
    goto inline$BDLGetDebugLevel$310$Return#1;

  inline$BDLGetDebugLevel$310$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$310$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon35_Then#1, inline$BDLDevicePowerIoCompletion$11$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon11#1;

  inline$BDLDevicePowerIoCompletion$11$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_62#1;

  inline$BDLDevicePowerIoCompletion$11$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_62_true#1, inline$BDLDevicePowerIoCompletion$11$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_63#1;

  inline$BDLDevicePowerIoCompletion$11$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_66#1;

  inline$BDLDevicePowerIoCompletion$11$label_66#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_67#1;

  inline$BDLDevicePowerIoCompletion$11$label_67#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_68#1;

  inline$BDLDevicePowerIoCompletion$11$label_68#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_69#1;

  inline$BDLDevicePowerIoCompletion$11$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$11$label_63#1;

  inline$BDLDevicePowerIoCompletion$11$label_63#1:
    goto inline$BDLGetDebugLevel$311$Entry#1;

  inline$BDLGetDebugLevel$311$Entry#1:
    goto inline$BDLGetDebugLevel$311$start#1;

  inline$BDLGetDebugLevel$311$start#1:
    goto inline$BDLGetDebugLevel$311$label_3#1;

  inline$BDLGetDebugLevel$311$label_3#1:
    havoc inline$BDLGetDebugLevel$311$myNondetVar_0;
    inline$BDLGetDebugLevel$311$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$311$myNondetVar_0;
    goto inline$BDLGetDebugLevel$311$label_1#1;

  inline$BDLGetDebugLevel$311$label_1#1:
    goto inline$BDLGetDebugLevel$311$Return#1;

  inline$BDLGetDebugLevel$311$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$311$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon36_Then#1, inline$BDLDevicePowerIoCompletion$11$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon13#1;

  inline$BDLDevicePowerIoCompletion$11$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_72#1;

  inline$BDLDevicePowerIoCompletion$11$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_72_true#1, inline$BDLDevicePowerIoCompletion$11$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_73#1;

  inline$BDLDevicePowerIoCompletion$11$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_76#1;

  inline$BDLDevicePowerIoCompletion$11$label_76#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_77#1;

  inline$BDLDevicePowerIoCompletion$11$label_77#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_78#1;

  inline$BDLDevicePowerIoCompletion$11$label_78#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_79#1;

  inline$BDLDevicePowerIoCompletion$11$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$11$label_73#1;

  inline$BDLDevicePowerIoCompletion$11$label_73#1:
    goto inline$BDLGetDebugLevel$312$Entry#1;

  inline$BDLGetDebugLevel$312$Entry#1:
    goto inline$BDLGetDebugLevel$312$start#1;

  inline$BDLGetDebugLevel$312$start#1:
    goto inline$BDLGetDebugLevel$312$label_3#1;

  inline$BDLGetDebugLevel$312$label_3#1:
    havoc inline$BDLGetDebugLevel$312$myNondetVar_0;
    inline$BDLGetDebugLevel$312$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$312$myNondetVar_0;
    goto inline$BDLGetDebugLevel$312$label_1#1;

  inline$BDLGetDebugLevel$312$label_1#1:
    goto inline$BDLGetDebugLevel$312$Return#1;

  inline$BDLGetDebugLevel$312$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$312$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon37_Then#1, inline$BDLDevicePowerIoCompletion$11$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon15#1;

  inline$BDLDevicePowerIoCompletion$11$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_82#1;

  inline$BDLDevicePowerIoCompletion$11$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_82_true#1, inline$BDLDevicePowerIoCompletion$11$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_83#1;

  inline$BDLDevicePowerIoCompletion$11$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_84#1;

  inline$BDLDevicePowerIoCompletion$11$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_83#1;

  inline$BDLDevicePowerIoCompletion$11$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_85#1;

  inline$BDLDevicePowerIoCompletion$11$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_86#1;

  inline$BDLDevicePowerIoCompletion$11$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$11$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$11$anon38_Then#1, inline$BDLDevicePowerIoCompletion$11$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon17#1;

  inline$BDLDevicePowerIoCompletion$11$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_89#1;

  inline$BDLDevicePowerIoCompletion$11$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$11$anon39_Then#1, inline$BDLDevicePowerIoCompletion$11$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon19#1;

  inline$BDLDevicePowerIoCompletion$11$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_92#1;

  inline$BDLDevicePowerIoCompletion$11$label_92#1:
    goto inline$storm_IoCompleteRequest$23$Entry#1;

  inline$storm_IoCompleteRequest$23$Entry#1:
    inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$11$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$23$start#1;

  inline$storm_IoCompleteRequest$23$start#1:
    inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$23$label_3#1;

  inline$storm_IoCompleteRequest$23$label_3#1:
    call inline$storm_IoCompleteRequest$23$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$23$label_6#1;

  inline$storm_IoCompleteRequest$23$label_6#1:
    goto inline$storm_IoCompleteRequest$23$label_6_true#1, inline$storm_IoCompleteRequest$23$label_6_false#1;

  inline$storm_IoCompleteRequest$23$label_6_false#1:
    assume inline$storm_IoCompleteRequest$23$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$23$label_7#1;

  inline$storm_IoCompleteRequest$23$label_6_true#1:
    assume inline$storm_IoCompleteRequest$23$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$23$label_8#1;

  inline$storm_IoCompleteRequest$23$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$23$anon3_Then#1, inline$storm_IoCompleteRequest$23$anon3_Else#1;

  inline$storm_IoCompleteRequest$23$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$23$anon1#1;

  inline$storm_IoCompleteRequest$23$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$23$label_9#1;

  inline$storm_IoCompleteRequest$23$label_9#1:
    goto inline$storm_IoCompleteRequest$23$label_9_true#1, inline$storm_IoCompleteRequest$23$label_9_false#1;

  inline$storm_IoCompleteRequest$23$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$23$label_10#1;

  inline$storm_IoCompleteRequest$23$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$23$label_1#1;

  inline$storm_IoCompleteRequest$23$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$23$label_7#1;

  inline$storm_IoCompleteRequest$23$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$23$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$23$label_1#1;

  inline$storm_IoCompleteRequest$23$label_1#1:
    goto inline$storm_IoCompleteRequest$23$Return#1;

  inline$storm_IoCompleteRequest$23$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$23$Return#1;

  inline$storm_IoCompleteRequest$23$Return#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon40_Then#1, inline$BDLDevicePowerIoCompletion$11$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon21#1;

  inline$BDLDevicePowerIoCompletion$11$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_95#1;

  inline$BDLDevicePowerIoCompletion$11$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$11$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$11$anon41_Then#1, inline$BDLDevicePowerIoCompletion$11$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon23#1;

  inline$BDLDevicePowerIoCompletion$11$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_98#1;

  inline$BDLDevicePowerIoCompletion$11$label_98#1:
    goto inline$BDLGetDebugLevel$313$Entry#1;

  inline$BDLGetDebugLevel$313$Entry#1:
    goto inline$BDLGetDebugLevel$313$start#1;

  inline$BDLGetDebugLevel$313$start#1:
    goto inline$BDLGetDebugLevel$313$label_3#1;

  inline$BDLGetDebugLevel$313$label_3#1:
    havoc inline$BDLGetDebugLevel$313$myNondetVar_0;
    inline$BDLGetDebugLevel$313$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$313$myNondetVar_0;
    goto inline$BDLGetDebugLevel$313$label_1#1;

  inline$BDLGetDebugLevel$313$label_1#1:
    goto inline$BDLGetDebugLevel$313$Return#1;

  inline$BDLGetDebugLevel$313$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$313$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon42_Then#1, inline$BDLDevicePowerIoCompletion$11$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon25#1;

  inline$BDLDevicePowerIoCompletion$11$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_101#1;

  inline$BDLDevicePowerIoCompletion$11$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_101_true#1, inline$BDLDevicePowerIoCompletion$11$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_102#1;

  inline$BDLDevicePowerIoCompletion$11$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_105#1;

  inline$BDLDevicePowerIoCompletion$11$label_105#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_106#1;

  inline$BDLDevicePowerIoCompletion$11$label_106#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_107#1;

  inline$BDLDevicePowerIoCompletion$11$label_107#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_108#1;

  inline$BDLDevicePowerIoCompletion$11$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$11$label_102#1;

  inline$BDLDevicePowerIoCompletion$11$label_102#1:
    goto inline$BDLGetDebugLevel$314$Entry#1;

  inline$BDLGetDebugLevel$314$Entry#1:
    goto inline$BDLGetDebugLevel$314$start#1;

  inline$BDLGetDebugLevel$314$start#1:
    goto inline$BDLGetDebugLevel$314$label_3#1;

  inline$BDLGetDebugLevel$314$label_3#1:
    havoc inline$BDLGetDebugLevel$314$myNondetVar_0;
    inline$BDLGetDebugLevel$314$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$314$myNondetVar_0;
    goto inline$BDLGetDebugLevel$314$label_1#1;

  inline$BDLGetDebugLevel$314$label_1#1:
    goto inline$BDLGetDebugLevel$314$Return#1;

  inline$BDLGetDebugLevel$314$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$314$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon43_Then#1, inline$BDLDevicePowerIoCompletion$11$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon27#1;

  inline$BDLDevicePowerIoCompletion$11$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_111#1;

  inline$BDLDevicePowerIoCompletion$11$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_111_true#1, inline$BDLDevicePowerIoCompletion$11$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_112#1;

  inline$BDLDevicePowerIoCompletion$11$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_115#1;

  inline$BDLDevicePowerIoCompletion$11$label_115#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_116#1;

  inline$BDLDevicePowerIoCompletion$11$label_116#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_117#1;

  inline$BDLDevicePowerIoCompletion$11$label_117#1:
    call inline$BDLDevicePowerIoCompletion$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$11$label_118#1;

  inline$BDLDevicePowerIoCompletion$11$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$11$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$11$label_112#1;

  inline$BDLDevicePowerIoCompletion$11$label_112#1:
    goto inline$BDLGetDebugLevel$315$Entry#1;

  inline$BDLGetDebugLevel$315$Entry#1:
    goto inline$BDLGetDebugLevel$315$start#1;

  inline$BDLGetDebugLevel$315$start#1:
    goto inline$BDLGetDebugLevel$315$label_3#1;

  inline$BDLGetDebugLevel$315$label_3#1:
    havoc inline$BDLGetDebugLevel$315$myNondetVar_0;
    inline$BDLGetDebugLevel$315$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$315$myNondetVar_0;
    goto inline$BDLGetDebugLevel$315$label_1#1;

  inline$BDLGetDebugLevel$315$label_1#1:
    goto inline$BDLGetDebugLevel$315$Return#1;

  inline$BDLGetDebugLevel$315$Return#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$315$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$11$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$11$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$11$anon44_Then#1, inline$BDLDevicePowerIoCompletion$11$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$11$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$anon29#1;

  inline$BDLDevicePowerIoCompletion$11$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_121#1;

  inline$BDLDevicePowerIoCompletion$11$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_121_true#1, inline$BDLDevicePowerIoCompletion$11$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$11$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_122#1;

  inline$BDLDevicePowerIoCompletion$11$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$11$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$11$label_123#1;

  inline$BDLDevicePowerIoCompletion$11$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$11$label_122#1;

  inline$BDLDevicePowerIoCompletion$11$label_122#1:
    inline$BDLDevicePowerIoCompletion$11$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$11$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$11$label_1#1;

  inline$BDLDevicePowerIoCompletion$11$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$11$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$11$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$11$Return#1;

  inline$BDLDevicePowerIoCompletion$11$Return#1:
    inline$CallCompletionRoutine$11$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$11$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$11$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$11$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$11$anon13_Then#1, inline$CallCompletionRoutine$11$anon13_Else#1;

  inline$CallCompletionRoutine$11$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$11$anon7#1;

  inline$CallCompletionRoutine$11$anon7#1:
    goto inline$CallCompletionRoutine$11$label_20_icall_return#1;

  inline$CallCompletionRoutine$11$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$11$Return#1;

  inline$CallCompletionRoutine$11$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$11$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$11$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$11$Entry#1;

  inline$BDLCallDriverCompletionRoutine$11$Entry#1:
    inline$BDLCallDriverCompletionRoutine$11$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$11$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$11$start#1;

  inline$BDLCallDriverCompletionRoutine$11$start#1:
    inline$BDLCallDriverCompletionRoutine$11$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$11$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$11$label_3#1;

  inline$BDLCallDriverCompletionRoutine$11$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$11$label_3_true#1, inline$BDLCallDriverCompletionRoutine$11$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$11$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$11$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$11$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$11$label_4#1;

  inline$BDLCallDriverCompletionRoutine$11$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$11$label_6#1;

  inline$BDLCallDriverCompletionRoutine$11$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$11$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$11$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$11$label_5#1;

  inline$BDLCallDriverCompletionRoutine$11$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$11$label_6#1;

  inline$BDLCallDriverCompletionRoutine$11$label_6#1:
    goto inline$storm_KeSetEvent$13$Entry#1;

  inline$storm_KeSetEvent$13$Entry#1:
    inline$storm_KeSetEvent$13$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$11$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$13$start#1;

  inline$storm_KeSetEvent$13$start#1:
    inline$storm_KeSetEvent$13$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$13$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$13$label_3#1;

  inline$storm_KeSetEvent$13$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$13$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$13$label_1#1;

  inline$storm_KeSetEvent$13$label_1#1:
    goto inline$storm_KeSetEvent$13$Return#1;

  inline$storm_KeSetEvent$13$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$11$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$11$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$11$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$11$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$11$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$11$anon1#1;

  inline$BDLCallDriverCompletionRoutine$11$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$11$label_9#1;

  inline$BDLCallDriverCompletionRoutine$11$label_9#1:
    inline$BDLCallDriverCompletionRoutine$11$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$11$label_1#1;

  inline$BDLCallDriverCompletionRoutine$11$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$11$Return#1;

  inline$BDLCallDriverCompletionRoutine$11$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$11$Return#1;

  inline$BDLCallDriverCompletionRoutine$11$Return#1:
    inline$CallCompletionRoutine$11$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$11$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$11$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$11$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$11$anon12_Then#1, inline$CallCompletionRoutine$11$anon12_Else#1;

  inline$CallCompletionRoutine$11$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$11$anon5#1;

  inline$CallCompletionRoutine$11$anon5#1:
    goto inline$CallCompletionRoutine$11$label_20_icall_return#1;

  inline$CallCompletionRoutine$11$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$11$label_23#1;

  inline$CallCompletionRoutine$11$label_23#1:
    inline$CallCompletionRoutine$11$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$11$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$11$label_24#1;

  inline$CallCompletionRoutine$11$label_24#1:
    goto inline$CallCompletionRoutine$11$label_24_true#1, inline$CallCompletionRoutine$11$label_24_false#1;

  inline$CallCompletionRoutine$11$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$11$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$11$label_1#1;

  inline$CallCompletionRoutine$11$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$11$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$11$label_25#1;

  inline$CallCompletionRoutine$11$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$11$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$11$label_1#1;

  inline$CallCompletionRoutine$11$label_1#1:
    goto inline$CallCompletionRoutine$11$Return#1;

  inline$CallCompletionRoutine$11$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$11$Return#1;

  inline$CallCompletionRoutine$11$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$11$Return#1;

  inline$CallCompletionRoutine$11$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$11$Return#1;

  inline$CallCompletionRoutine$11$Return#1:
    goto inline$storm_IoCallDriver$5$label_39$1#1;

  inline$storm_IoCallDriver$5$label_39$1#1:
    goto inline$storm_IoCallDriver$5$anon15_Then#1, inline$storm_IoCallDriver$5$anon15_Else#1;

  inline$storm_IoCallDriver$5$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$5$anon10#1;

  inline$storm_IoCallDriver$5$anon10#1:
    goto inline$storm_IoCallDriver$5$label_36#1;

  inline$storm_IoCallDriver$5$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$5$Return#1;

  inline$storm_IoCallDriver$5$label_27_case_0#1:
    assume inline$storm_IoCallDriver$5$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$5$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$5$label_28#1;

  inline$storm_IoCallDriver$5$label_28#1:
    inline$storm_IoCallDriver$5$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$5$label_42#1;

  inline$storm_IoCallDriver$5$label_42#1:
    goto inline$storm_IoCallDriver$5$label_43#1;

  inline$storm_IoCallDriver$5$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$5$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$5$label_36#1;

  inline$storm_IoCallDriver$5$label_36#1:
    inline$storm_IoCallDriver$5$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$5$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$5$label_1#1;

  inline$storm_IoCallDriver$5$label_1#1:
    goto inline$storm_IoCallDriver$5$Return#1;

  inline$storm_IoCallDriver$5$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$5$Return#1;

  inline$storm_IoCallDriver$5$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$5$Return#1;

  inline$storm_IoCallDriver$5$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$5$Return#1;

  inline$storm_IoCallDriver$5$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_IoCallDriver$108.29$4$ := inline$storm_IoCallDriver$5$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_19$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_19$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon20_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon20_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon9#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon9#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_42#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_42#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_IoCallDriver$108.29$4$;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_18_true#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0;
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_22#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_22#1:
    call PoStartNextPowerIrp(inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon21_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon21_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon21_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon11#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon11#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_25#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_25#1:
    goto inline$storm_PoCallDriver$2$Entry#1;

  inline$storm_PoCallDriver$2$Entry#1:
    inline$storm_PoCallDriver$2$$Irp$2$496.14$storm_PoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_PoCallDriver$2$start#1;

  inline$storm_PoCallDriver$2$start#1:
    inline$storm_PoCallDriver$2$$Irp$2$496.14$storm_PoCallDriver$8 := inline$storm_PoCallDriver$2$$Irp$2$496.14$storm_PoCallDriver$8_.1;
    goto inline$storm_PoCallDriver$2$label_3#1;

  inline$storm_PoCallDriver$2$label_3#1:
    goto inline$storm_IoCallDriver$6$Entry#1;

  inline$storm_IoCallDriver$6$Entry#1:
    inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$storm_PoCallDriver$2$$Irp$2$496.14$storm_PoCallDriver$8;
    goto inline$storm_IoCallDriver$6$start#1;

  inline$storm_IoCallDriver$6$start#1:
    inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$6$label_3#1;

  inline$storm_IoCallDriver$6$label_3#1:
    goto inline$storm_IoCallDriver$6$label_4#1;

  inline$storm_IoCallDriver$6$label_4#1:
    goto inline$storm_IoCallDriver$6$label_5#1;

  inline$storm_IoCallDriver$6$label_5#1:
    goto inline$storm_IoCallDriver$6$label_6#1;

  inline$storm_IoCallDriver$6$label_6#1:
    call inline$storm_IoCallDriver$6$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$6$label_9#1;

  inline$storm_IoCallDriver$6$label_9#1:
    goto inline$storm_IoCallDriver$6$label_9_true#1, inline$storm_IoCallDriver$6$label_9_false#1;

  inline$storm_IoCallDriver$6$label_9_false#1:
    assume inline$storm_IoCallDriver$6$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$6$label_10#1;

  inline$storm_IoCallDriver$6$label_9_true#1:
    assume inline$storm_IoCallDriver$6$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$6$label_13#1;

  inline$storm_IoCallDriver$6$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$6$anon12_Then#1, inline$storm_IoCallDriver$6$anon12_Else#1;

  inline$storm_IoCallDriver$6$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$6$anon3#1;

  inline$storm_IoCallDriver$6$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$6$label_14#1;

  inline$storm_IoCallDriver$6$label_14#1:
    goto inline$storm_IoCallDriver$6$label_14_true#1, inline$storm_IoCallDriver$6$label_14_false#1;

  inline$storm_IoCallDriver$6$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$6$label_15#1;

  inline$storm_IoCallDriver$6$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$6$label_1#1;

  inline$storm_IoCallDriver$6$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$6$label_10#1;

  inline$storm_IoCallDriver$6$label_10#1:
    goto inline$IoSetNextIrpStackLocation$7$Entry#1;

  inline$IoSetNextIrpStackLocation$7$Entry#1:
    inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$7$start#1;

  inline$IoSetNextIrpStackLocation$7$start#1:
    inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$7$label_3#1;

  inline$IoSetNextIrpStackLocation$7$label_3#1:
    goto inline$IoSetNextIrpStackLocation$7$label_3_true#1, inline$IoSetNextIrpStackLocation$7$label_3_false#1;

  inline$IoSetNextIrpStackLocation$7$label_3_false#1:
    inline$IoSetNextIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$7$myVar_0);
    goto inline$IoSetNextIrpStackLocation$7$label_4#1;

  inline$IoSetNextIrpStackLocation$7$label_4#1:
    call inline$IoSetNextIrpStackLocation$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$7$label_7#1;

  inline$IoSetNextIrpStackLocation$7$label_7#1:
    call inline$IoSetNextIrpStackLocation$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$7$label_8#1;

  inline$IoSetNextIrpStackLocation$7$label_8#1:
    goto inline$IoSetNextIrpStackLocation$7$label_5#1;

  inline$IoSetNextIrpStackLocation$7$label_3_true#1:
    inline$IoSetNextIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$7$myVar_0);
    goto inline$IoSetNextIrpStackLocation$7$label_5#1;

  inline$IoSetNextIrpStackLocation$7$label_5#1:
    inline$IoSetNextIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$7$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$7$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$7$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$7$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$7$label_6#1;

  inline$IoSetNextIrpStackLocation$7$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$7$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$7$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$7$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$7$label_1#1;

  inline$IoSetNextIrpStackLocation$7$label_1#1:
    goto inline$IoSetNextIrpStackLocation$7$Return#1;

  inline$IoSetNextIrpStackLocation$7$Return#1:
    goto inline$storm_IoCallDriver$6$label_10$1#1;

  inline$storm_IoCallDriver$6$label_10$1#1:
    goto inline$storm_IoCallDriver$6$anon11_Then#1, inline$storm_IoCallDriver$6$anon11_Else#1;

  inline$storm_IoCallDriver$6$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$6$anon1#1;

  inline$storm_IoCallDriver$6$anon1#1:
    goto inline$storm_IoCallDriver$6$label_18#1;

  inline$storm_IoCallDriver$6$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$63$Entry#1;

  inline$IoGetCurrentIrpStackLocation$63$Entry#1:
    inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$63$start#1;

  inline$IoGetCurrentIrpStackLocation$63$start#1:
    inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$63$label_3#1;

  inline$IoGetCurrentIrpStackLocation$63$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$63$label_3_true#1, inline$IoGetCurrentIrpStackLocation$63$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$63$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$63$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$63$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$63$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$63$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$63$label_4#1;

  inline$IoGetCurrentIrpStackLocation$63$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$63$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$63$label_6#1;

  inline$IoGetCurrentIrpStackLocation$63$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$63$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$63$label_7#1;

  inline$IoGetCurrentIrpStackLocation$63$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$63$label_5#1;

  inline$IoGetCurrentIrpStackLocation$63$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$63$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$63$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$63$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$63$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$63$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$63$label_5#1;

  inline$IoGetCurrentIrpStackLocation$63$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$63$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$63$label_1#1;

  inline$IoGetCurrentIrpStackLocation$63$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$63$Return#1;

  inline$IoGetCurrentIrpStackLocation$63$Return#1:
    goto inline$storm_IoCallDriver$6$label_18$1#1;

  inline$storm_IoCallDriver$6$label_18$1#1:
    goto inline$storm_IoCallDriver$6$anon13_Then#1, inline$storm_IoCallDriver$6$anon13_Else#1;

  inline$storm_IoCallDriver$6$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$6$anon6#1;

  inline$storm_IoCallDriver$6$anon6#1:
    goto inline$storm_IoCallDriver$6$label_21#1;

  inline$storm_IoCallDriver$6$label_21#1:
    goto inline$storm_IoCallDriver$6$label_22#1;

  inline$storm_IoCallDriver$6$label_22#1:
    goto inline$storm_IoCallDriver$6$label_23#1;

  inline$storm_IoCallDriver$6$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$6$label_24#1;

  inline$storm_IoCallDriver$6$label_24#1:
    call inline$storm_IoCallDriver$6$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$6$label_27#1;

  inline$storm_IoCallDriver$6$label_27#1:
    goto inline$storm_IoCallDriver$6$label_27_case_0#1, inline$storm_IoCallDriver$6$label_27_case_1#1, inline$storm_IoCallDriver$6$label_27_case_2#1;

  inline$storm_IoCallDriver$6$label_27_case_2#1:
    assume inline$storm_IoCallDriver$6$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$6$label_30#1;

  inline$storm_IoCallDriver$6$label_30#1:
    inline$storm_IoCallDriver$6$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$6$label_31#1;

  inline$storm_IoCallDriver$6$label_31#1:
    goto inline$storm_IoCallDriver$6$label_32#1;

  inline$storm_IoCallDriver$6$label_32#1:
    goto inline$storm_IoCallDriver$6$label_33#1;

  inline$storm_IoCallDriver$6$label_33#1:
    goto inline$CallCompletionRoutine$12$Entry#1;

  inline$CallCompletionRoutine$12$Entry#1:
    inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$12$start#1;

  inline$CallCompletionRoutine$12$start#1:
    inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$12$label_3#1;

  inline$CallCompletionRoutine$12$label_3#1:
    goto inline$CallCompletionRoutine$12$label_4#1;

  inline$CallCompletionRoutine$12$label_4#1:
    goto inline$CallCompletionRoutine$12$label_5#1;

  inline$CallCompletionRoutine$12$label_5#1:
    goto inline$CallCompletionRoutine$12$label_6#1;

  inline$CallCompletionRoutine$12$label_6#1:
    goto inline$CallCompletionRoutine$12$label_7#1;

  inline$CallCompletionRoutine$12$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$64$Entry#1;

  inline$IoGetCurrentIrpStackLocation$64$Entry#1:
    inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$64$start#1;

  inline$IoGetCurrentIrpStackLocation$64$start#1:
    inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$64$label_3#1;

  inline$IoGetCurrentIrpStackLocation$64$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$64$label_3_true#1, inline$IoGetCurrentIrpStackLocation$64$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$64$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$64$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$64$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$64$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$64$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$64$label_4#1;

  inline$IoGetCurrentIrpStackLocation$64$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$64$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$64$label_6#1;

  inline$IoGetCurrentIrpStackLocation$64$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$64$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$64$label_7#1;

  inline$IoGetCurrentIrpStackLocation$64$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$64$label_5#1;

  inline$IoGetCurrentIrpStackLocation$64$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$64$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$64$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$64$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$64$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$64$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$64$label_5#1;

  inline$IoGetCurrentIrpStackLocation$64$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$64$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$64$label_1#1;

  inline$IoGetCurrentIrpStackLocation$64$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$64$Return#1;

  inline$IoGetCurrentIrpStackLocation$64$Return#1:
    goto inline$CallCompletionRoutine$12$label_7$1#1;

  inline$CallCompletionRoutine$12$label_7$1#1:
    goto inline$CallCompletionRoutine$12$anon10_Then#1, inline$CallCompletionRoutine$12$anon10_Else#1;

  inline$CallCompletionRoutine$12$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$12$anon1#1;

  inline$CallCompletionRoutine$12$anon1#1:
    goto inline$CallCompletionRoutine$12$label_10#1;

  inline$CallCompletionRoutine$12$label_10#1:
    goto inline$CallCompletionRoutine$12$label_11#1;

  inline$CallCompletionRoutine$12$label_11#1:
    havoc inline$CallCompletionRoutine$12$myNondetVar_0;
    inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$12$myNondetVar_0;
    goto inline$CallCompletionRoutine$12$label_12#1;

  inline$CallCompletionRoutine$12$label_12#1:
    havoc inline$CallCompletionRoutine$12$myNondetVar_0;
    inline$CallCompletionRoutine$12$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$12$myNondetVar_0;
    goto inline$CallCompletionRoutine$12$label_13#1;

  inline$CallCompletionRoutine$12$label_13#1:
    havoc inline$CallCompletionRoutine$12$myNondetVar_0;
    goto inline$CallCompletionRoutine$12$label_14#1;

  inline$CallCompletionRoutine$12$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$65$Entry#1;

  inline$IoGetCurrentIrpStackLocation$65$Entry#1:
    inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$65$start#1;

  inline$IoGetCurrentIrpStackLocation$65$start#1:
    inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$65$label_3#1;

  inline$IoGetCurrentIrpStackLocation$65$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$65$label_3_true#1, inline$IoGetCurrentIrpStackLocation$65$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$65$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$65$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$65$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$65$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$65$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$65$label_4#1;

  inline$IoGetCurrentIrpStackLocation$65$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$65$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$65$label_6#1;

  inline$IoGetCurrentIrpStackLocation$65$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$65$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$65$label_7#1;

  inline$IoGetCurrentIrpStackLocation$65$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$65$label_5#1;

  inline$IoGetCurrentIrpStackLocation$65$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$65$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$65$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$65$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$65$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$65$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$65$label_5#1;

  inline$IoGetCurrentIrpStackLocation$65$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$65$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$65$label_1#1;

  inline$IoGetCurrentIrpStackLocation$65$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$65$Return#1;

  inline$IoGetCurrentIrpStackLocation$65$Return#1:
    goto inline$CallCompletionRoutine$12$label_14$1#1;

  inline$CallCompletionRoutine$12$label_14$1#1:
    goto inline$CallCompletionRoutine$12$anon11_Then#1, inline$CallCompletionRoutine$12$anon11_Else#1;

  inline$CallCompletionRoutine$12$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$12$anon3#1;

  inline$CallCompletionRoutine$12$anon3#1:
    goto inline$CallCompletionRoutine$12$label_17#1;

  inline$CallCompletionRoutine$12$label_17#1:
    goto inline$CallCompletionRoutine$12$label_18#1;

  inline$CallCompletionRoutine$12$label_18#1:
    goto inline$CallCompletionRoutine$12$label_18_true#1, inline$CallCompletionRoutine$12$label_18_false#1;

  inline$CallCompletionRoutine$12$label_18_false#1:
    assume inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$12$label_1#1;

  inline$CallCompletionRoutine$12$label_18_true#1:
    assume inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$12$label_19#1;

  inline$CallCompletionRoutine$12$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$12$label_20#1;

  inline$CallCompletionRoutine$12$label_20#1:
    goto inline$CallCompletionRoutine$12$label_20_icall_1#1, inline$CallCompletionRoutine$12$label_20_icall_2#1, inline$CallCompletionRoutine$12$label_20_icall_3#1;

  inline$CallCompletionRoutine$12$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$12$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$12$Entry#1;

  inline$BDLSystemPowerIoCompletion$12$Entry#1:
    inline$BDLSystemPowerIoCompletion$12$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$12$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$12$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$12$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$12$start#1;

  inline$BDLSystemPowerIoCompletion$12$start#1:
    call inline$BDLSystemPowerIoCompletion$12$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$12$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$12$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$12$label_3#1;

  inline$BDLSystemPowerIoCompletion$12$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_4#1;

  inline$BDLSystemPowerIoCompletion$12$label_4#1:
    inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_5#1;

  inline$BDLSystemPowerIoCompletion$12$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_6#1;

  inline$BDLSystemPowerIoCompletion$12$label_6#1:
    inline$BDLSystemPowerIoCompletion$12$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$12$label_7#1;

  inline$BDLSystemPowerIoCompletion$12$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_8#1;

  inline$BDLSystemPowerIoCompletion$12$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$12$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$12$label_9#1;

  inline$BDLSystemPowerIoCompletion$12$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_10#1;

  inline$BDLSystemPowerIoCompletion$12$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$67$Entry#1;

  inline$IoGetCurrentIrpStackLocation$67$Entry#1:
    inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$67$start#1;

  inline$IoGetCurrentIrpStackLocation$67$start#1:
    inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$67$label_3#1;

  inline$IoGetCurrentIrpStackLocation$67$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$67$label_3_true#1, inline$IoGetCurrentIrpStackLocation$67$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$67$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$67$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$67$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$67$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$67$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$67$label_4#1;

  inline$IoGetCurrentIrpStackLocation$67$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$67$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$67$label_6#1;

  inline$IoGetCurrentIrpStackLocation$67$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$67$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$67$label_7#1;

  inline$IoGetCurrentIrpStackLocation$67$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$67$label_5#1;

  inline$IoGetCurrentIrpStackLocation$67$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$67$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$67$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$67$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$67$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$67$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$67$label_5#1;

  inline$IoGetCurrentIrpStackLocation$67$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$67$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$67$label_1#1;

  inline$IoGetCurrentIrpStackLocation$67$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$67$Return#1;

  inline$IoGetCurrentIrpStackLocation$67$Return#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon36_Then#1, inline$BDLSystemPowerIoCompletion$12$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon1#1;

  inline$BDLSystemPowerIoCompletion$12$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_13#1;

  inline$BDLSystemPowerIoCompletion$12$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_14#1;

  inline$BDLSystemPowerIoCompletion$12$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_15#1;

  inline$BDLSystemPowerIoCompletion$12$label_15#1:
    goto inline$BDLGetDebugLevel$337$Entry#1;

  inline$BDLGetDebugLevel$337$Entry#1:
    goto inline$BDLGetDebugLevel$337$start#1;

  inline$BDLGetDebugLevel$337$start#1:
    goto inline$BDLGetDebugLevel$337$label_3#1;

  inline$BDLGetDebugLevel$337$label_3#1:
    havoc inline$BDLGetDebugLevel$337$myNondetVar_0;
    inline$BDLGetDebugLevel$337$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$337$myNondetVar_0;
    goto inline$BDLGetDebugLevel$337$label_1#1;

  inline$BDLGetDebugLevel$337$label_1#1:
    goto inline$BDLGetDebugLevel$337$Return#1;

  inline$BDLGetDebugLevel$337$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$337$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon37_Then#1, inline$BDLSystemPowerIoCompletion$12$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon3#1;

  inline$BDLSystemPowerIoCompletion$12$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_18#1;

  inline$BDLSystemPowerIoCompletion$12$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_18_true#1, inline$BDLSystemPowerIoCompletion$12$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_19#1;

  inline$BDLSystemPowerIoCompletion$12$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_22#1;

  inline$BDLSystemPowerIoCompletion$12$label_22#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_23#1;

  inline$BDLSystemPowerIoCompletion$12$label_23#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_24#1;

  inline$BDLSystemPowerIoCompletion$12$label_24#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_25#1;

  inline$BDLSystemPowerIoCompletion$12$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$12$label_19#1;

  inline$BDLSystemPowerIoCompletion$12$label_19#1:
    goto inline$BDLGetDebugLevel$338$Entry#1;

  inline$BDLGetDebugLevel$338$Entry#1:
    goto inline$BDLGetDebugLevel$338$start#1;

  inline$BDLGetDebugLevel$338$start#1:
    goto inline$BDLGetDebugLevel$338$label_3#1;

  inline$BDLGetDebugLevel$338$label_3#1:
    havoc inline$BDLGetDebugLevel$338$myNondetVar_0;
    inline$BDLGetDebugLevel$338$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$338$myNondetVar_0;
    goto inline$BDLGetDebugLevel$338$label_1#1;

  inline$BDLGetDebugLevel$338$label_1#1:
    goto inline$BDLGetDebugLevel$338$Return#1;

  inline$BDLGetDebugLevel$338$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$338$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon38_Then#1, inline$BDLSystemPowerIoCompletion$12$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon5#1;

  inline$BDLSystemPowerIoCompletion$12$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_28#1;

  inline$BDLSystemPowerIoCompletion$12$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_28_true#1, inline$BDLSystemPowerIoCompletion$12$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_29#1;

  inline$BDLSystemPowerIoCompletion$12$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_32#1;

  inline$BDLSystemPowerIoCompletion$12$label_32#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_33#1;

  inline$BDLSystemPowerIoCompletion$12$label_33#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_34#1;

  inline$BDLSystemPowerIoCompletion$12$label_34#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_35#1;

  inline$BDLSystemPowerIoCompletion$12$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$12$label_29#1;

  inline$BDLSystemPowerIoCompletion$12$label_29#1:
    goto inline$BDLGetDebugLevel$339$Entry#1;

  inline$BDLGetDebugLevel$339$Entry#1:
    goto inline$BDLGetDebugLevel$339$start#1;

  inline$BDLGetDebugLevel$339$start#1:
    goto inline$BDLGetDebugLevel$339$label_3#1;

  inline$BDLGetDebugLevel$339$label_3#1:
    havoc inline$BDLGetDebugLevel$339$myNondetVar_0;
    inline$BDLGetDebugLevel$339$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$339$myNondetVar_0;
    goto inline$BDLGetDebugLevel$339$label_1#1;

  inline$BDLGetDebugLevel$339$label_1#1:
    goto inline$BDLGetDebugLevel$339$Return#1;

  inline$BDLGetDebugLevel$339$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$339$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon39_Then#1, inline$BDLSystemPowerIoCompletion$12$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon7#1;

  inline$BDLSystemPowerIoCompletion$12$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_38#1;

  inline$BDLSystemPowerIoCompletion$12$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_38_true#1, inline$BDLSystemPowerIoCompletion$12$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_39#1;

  inline$BDLSystemPowerIoCompletion$12$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_40#1;

  inline$BDLSystemPowerIoCompletion$12$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_39#1;

  inline$BDLSystemPowerIoCompletion$12$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_39_true#1, inline$BDLSystemPowerIoCompletion$12$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_41#1;

  inline$BDLSystemPowerIoCompletion$12$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$12$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$12$label_107#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$12$label_108#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$12$label_108#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$12$label_108#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$12$label_108#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$12$label_108#1;

  inline$BDLSystemPowerIoCompletion$12$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_109#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$12$label_107#1;

  inline$BDLSystemPowerIoCompletion$12$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_109#1;

  inline$BDLSystemPowerIoCompletion$12$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$12$label_106#1;

  inline$BDLSystemPowerIoCompletion$12$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_106_true#1, inline$BDLSystemPowerIoCompletion$12$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_142#1;

  inline$BDLSystemPowerIoCompletion$12$label_142#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_143#1;

  inline$BDLSystemPowerIoCompletion$12$label_143#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_144#1;

  inline$BDLSystemPowerIoCompletion$12$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_109#1;

  inline$BDLSystemPowerIoCompletion$12$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_109#1;

  inline$BDLSystemPowerIoCompletion$12$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$12$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$12$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$12$myNondetVar_0, inline$BDLSystemPowerIoCompletion$12$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$12$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$12$anon50_Then#1, inline$BDLSystemPowerIoCompletion$12$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon29#1;

  inline$BDLSystemPowerIoCompletion$12$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_112#1;

  inline$BDLSystemPowerIoCompletion$12$label_112#1:
    inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$12$label_113#1;

  inline$BDLSystemPowerIoCompletion$12$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_113_true#1, inline$BDLSystemPowerIoCompletion$12$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$12$label_114#1;

  inline$BDLSystemPowerIoCompletion$12$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_116#1;

  inline$BDLSystemPowerIoCompletion$12$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_117#1;

  inline$BDLSystemPowerIoCompletion$12$label_117#1:
    goto inline$BDLGetDebugLevel$346$Entry#1;

  inline$BDLGetDebugLevel$346$Entry#1:
    goto inline$BDLGetDebugLevel$346$start#1;

  inline$BDLGetDebugLevel$346$start#1:
    goto inline$BDLGetDebugLevel$346$label_3#1;

  inline$BDLGetDebugLevel$346$label_3#1:
    havoc inline$BDLGetDebugLevel$346$myNondetVar_0;
    inline$BDLGetDebugLevel$346$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$346$myNondetVar_0;
    goto inline$BDLGetDebugLevel$346$label_1#1;

  inline$BDLGetDebugLevel$346$label_1#1:
    goto inline$BDLGetDebugLevel$346$Return#1;

  inline$BDLGetDebugLevel$346$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$346$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon51_Then#1, inline$BDLSystemPowerIoCompletion$12$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon31#1;

  inline$BDLSystemPowerIoCompletion$12$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_120#1;

  inline$BDLSystemPowerIoCompletion$12$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_120_true#1, inline$BDLSystemPowerIoCompletion$12$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_121#1;

  inline$BDLSystemPowerIoCompletion$12$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_124#1;

  inline$BDLSystemPowerIoCompletion$12$label_124#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_125#1;

  inline$BDLSystemPowerIoCompletion$12$label_125#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_126#1;

  inline$BDLSystemPowerIoCompletion$12$label_126#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_127#1;

  inline$BDLSystemPowerIoCompletion$12$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$12$label_121#1;

  inline$BDLSystemPowerIoCompletion$12$label_121#1:
    goto inline$BDLGetDebugLevel$347$Entry#1;

  inline$BDLGetDebugLevel$347$Entry#1:
    goto inline$BDLGetDebugLevel$347$start#1;

  inline$BDLGetDebugLevel$347$start#1:
    goto inline$BDLGetDebugLevel$347$label_3#1;

  inline$BDLGetDebugLevel$347$label_3#1:
    havoc inline$BDLGetDebugLevel$347$myNondetVar_0;
    inline$BDLGetDebugLevel$347$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$347$myNondetVar_0;
    goto inline$BDLGetDebugLevel$347$label_1#1;

  inline$BDLGetDebugLevel$347$label_1#1:
    goto inline$BDLGetDebugLevel$347$Return#1;

  inline$BDLGetDebugLevel$347$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$347$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon52_Then#1, inline$BDLSystemPowerIoCompletion$12$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon33#1;

  inline$BDLSystemPowerIoCompletion$12$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_130#1;

  inline$BDLSystemPowerIoCompletion$12$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_130_true#1, inline$BDLSystemPowerIoCompletion$12$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_131#1;

  inline$BDLSystemPowerIoCompletion$12$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_134#1;

  inline$BDLSystemPowerIoCompletion$12$label_134#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_135#1;

  inline$BDLSystemPowerIoCompletion$12$label_135#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_136#1;

  inline$BDLSystemPowerIoCompletion$12$label_136#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_137#1;

  inline$BDLSystemPowerIoCompletion$12$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$12$label_131#1;

  inline$BDLSystemPowerIoCompletion$12$label_131#1:
    goto inline$BDLGetDebugLevel$348$Entry#1;

  inline$BDLGetDebugLevel$348$Entry#1:
    goto inline$BDLGetDebugLevel$348$start#1;

  inline$BDLGetDebugLevel$348$start#1:
    goto inline$BDLGetDebugLevel$348$label_3#1;

  inline$BDLGetDebugLevel$348$label_3#1:
    havoc inline$BDLGetDebugLevel$348$myNondetVar_0;
    inline$BDLGetDebugLevel$348$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$348$myNondetVar_0;
    goto inline$BDLGetDebugLevel$348$label_1#1;

  inline$BDLGetDebugLevel$348$label_1#1:
    goto inline$BDLGetDebugLevel$348$Return#1;

  inline$BDLGetDebugLevel$348$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$348$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon53_Then#1, inline$BDLSystemPowerIoCompletion$12$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon35#1;

  inline$BDLSystemPowerIoCompletion$12$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_140#1;

  inline$BDLSystemPowerIoCompletion$12$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_140_true#1, inline$BDLSystemPowerIoCompletion$12$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_67#1;

  inline$BDLSystemPowerIoCompletion$12$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_141#1;

  inline$BDLSystemPowerIoCompletion$12$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_67#1;

  inline$BDLSystemPowerIoCompletion$12$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$12$label_115#1;

  inline$BDLSystemPowerIoCompletion$12$label_115#1:
    inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$12$label_80#1;

  inline$BDLSystemPowerIoCompletion$12$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$12$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_42#1;

  inline$BDLSystemPowerIoCompletion$12$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$12$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$12$label_43#1;

  inline$BDLSystemPowerIoCompletion$12$label_43#1:
    goto inline$BDLGetDebugLevel$340$Entry#1;

  inline$BDLGetDebugLevel$340$Entry#1:
    goto inline$BDLGetDebugLevel$340$start#1;

  inline$BDLGetDebugLevel$340$start#1:
    goto inline$BDLGetDebugLevel$340$label_3#1;

  inline$BDLGetDebugLevel$340$label_3#1:
    havoc inline$BDLGetDebugLevel$340$myNondetVar_0;
    inline$BDLGetDebugLevel$340$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$340$myNondetVar_0;
    goto inline$BDLGetDebugLevel$340$label_1#1;

  inline$BDLGetDebugLevel$340$label_1#1:
    goto inline$BDLGetDebugLevel$340$Return#1;

  inline$BDLGetDebugLevel$340$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$340$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon40_Then#1, inline$BDLSystemPowerIoCompletion$12$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon9#1;

  inline$BDLSystemPowerIoCompletion$12$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_46#1;

  inline$BDLSystemPowerIoCompletion$12$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_46_true#1, inline$BDLSystemPowerIoCompletion$12$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_47#1;

  inline$BDLSystemPowerIoCompletion$12$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_50#1;

  inline$BDLSystemPowerIoCompletion$12$label_50#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_51#1;

  inline$BDLSystemPowerIoCompletion$12$label_51#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_52#1;

  inline$BDLSystemPowerIoCompletion$12$label_52#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_53#1;

  inline$BDLSystemPowerIoCompletion$12$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$12$label_47#1;

  inline$BDLSystemPowerIoCompletion$12$label_47#1:
    goto inline$BDLGetDebugLevel$341$Entry#1;

  inline$BDLGetDebugLevel$341$Entry#1:
    goto inline$BDLGetDebugLevel$341$start#1;

  inline$BDLGetDebugLevel$341$start#1:
    goto inline$BDLGetDebugLevel$341$label_3#1;

  inline$BDLGetDebugLevel$341$label_3#1:
    havoc inline$BDLGetDebugLevel$341$myNondetVar_0;
    inline$BDLGetDebugLevel$341$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$341$myNondetVar_0;
    goto inline$BDLGetDebugLevel$341$label_1#1;

  inline$BDLGetDebugLevel$341$label_1#1:
    goto inline$BDLGetDebugLevel$341$Return#1;

  inline$BDLGetDebugLevel$341$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$341$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon41_Then#1, inline$BDLSystemPowerIoCompletion$12$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon11#1;

  inline$BDLSystemPowerIoCompletion$12$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_56#1;

  inline$BDLSystemPowerIoCompletion$12$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_56_true#1, inline$BDLSystemPowerIoCompletion$12$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_57#1;

  inline$BDLSystemPowerIoCompletion$12$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_60#1;

  inline$BDLSystemPowerIoCompletion$12$label_60#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_61#1;

  inline$BDLSystemPowerIoCompletion$12$label_61#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_62#1;

  inline$BDLSystemPowerIoCompletion$12$label_62#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_63#1;

  inline$BDLSystemPowerIoCompletion$12$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$12$label_57#1;

  inline$BDLSystemPowerIoCompletion$12$label_57#1:
    goto inline$BDLGetDebugLevel$342$Entry#1;

  inline$BDLGetDebugLevel$342$Entry#1:
    goto inline$BDLGetDebugLevel$342$start#1;

  inline$BDLGetDebugLevel$342$start#1:
    goto inline$BDLGetDebugLevel$342$label_3#1;

  inline$BDLGetDebugLevel$342$label_3#1:
    havoc inline$BDLGetDebugLevel$342$myNondetVar_0;
    inline$BDLGetDebugLevel$342$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$342$myNondetVar_0;
    goto inline$BDLGetDebugLevel$342$label_1#1;

  inline$BDLGetDebugLevel$342$label_1#1:
    goto inline$BDLGetDebugLevel$342$Return#1;

  inline$BDLGetDebugLevel$342$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$342$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon42_Then#1, inline$BDLSystemPowerIoCompletion$12$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon13#1;

  inline$BDLSystemPowerIoCompletion$12$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_66#1;

  inline$BDLSystemPowerIoCompletion$12$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_66_true#1, inline$BDLSystemPowerIoCompletion$12$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_67#1;

  inline$BDLSystemPowerIoCompletion$12$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_70#1;

  inline$BDLSystemPowerIoCompletion$12$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_67#1;

  inline$BDLSystemPowerIoCompletion$12$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$12$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$12$anon43_Then#1, inline$BDLSystemPowerIoCompletion$12$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon15#1;

  inline$BDLSystemPowerIoCompletion$12$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_71#1;

  inline$BDLSystemPowerIoCompletion$12$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$12$anon44_Then#1, inline$BDLSystemPowerIoCompletion$12$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon17#1;

  inline$BDLSystemPowerIoCompletion$12$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_74#1;

  inline$BDLSystemPowerIoCompletion$12$label_74#1:
    goto inline$storm_IoCompleteRequest$26$Entry#1;

  inline$storm_IoCompleteRequest$26$Entry#1:
    inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$12$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$26$start#1;

  inline$storm_IoCompleteRequest$26$start#1:
    inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$26$label_3#1;

  inline$storm_IoCompleteRequest$26$label_3#1:
    call inline$storm_IoCompleteRequest$26$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$26$label_6#1;

  inline$storm_IoCompleteRequest$26$label_6#1:
    goto inline$storm_IoCompleteRequest$26$label_6_true#1, inline$storm_IoCompleteRequest$26$label_6_false#1;

  inline$storm_IoCompleteRequest$26$label_6_false#1:
    assume inline$storm_IoCompleteRequest$26$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$26$label_7#1;

  inline$storm_IoCompleteRequest$26$label_6_true#1:
    assume inline$storm_IoCompleteRequest$26$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$26$label_8#1;

  inline$storm_IoCompleteRequest$26$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$26$anon3_Then#1, inline$storm_IoCompleteRequest$26$anon3_Else#1;

  inline$storm_IoCompleteRequest$26$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$26$anon1#1;

  inline$storm_IoCompleteRequest$26$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$26$label_9#1;

  inline$storm_IoCompleteRequest$26$label_9#1:
    goto inline$storm_IoCompleteRequest$26$label_9_true#1, inline$storm_IoCompleteRequest$26$label_9_false#1;

  inline$storm_IoCompleteRequest$26$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$26$label_10#1;

  inline$storm_IoCompleteRequest$26$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$26$label_1#1;

  inline$storm_IoCompleteRequest$26$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$26$label_7#1;

  inline$storm_IoCompleteRequest$26$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$26$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$26$label_1#1;

  inline$storm_IoCompleteRequest$26$label_1#1:
    goto inline$storm_IoCompleteRequest$26$Return#1;

  inline$storm_IoCompleteRequest$26$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$26$Return#1;

  inline$storm_IoCompleteRequest$26$Return#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon45_Then#1, inline$BDLSystemPowerIoCompletion$12$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon19#1;

  inline$BDLSystemPowerIoCompletion$12$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_77#1;

  inline$BDLSystemPowerIoCompletion$12$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$12$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$12$anon46_Then#1, inline$BDLSystemPowerIoCompletion$12$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon21#1;

  inline$BDLSystemPowerIoCompletion$12$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_80#1;

  inline$BDLSystemPowerIoCompletion$12$label_80#1:
    goto inline$BDLGetDebugLevel$343$Entry#1;

  inline$BDLGetDebugLevel$343$Entry#1:
    goto inline$BDLGetDebugLevel$343$start#1;

  inline$BDLGetDebugLevel$343$start#1:
    goto inline$BDLGetDebugLevel$343$label_3#1;

  inline$BDLGetDebugLevel$343$label_3#1:
    havoc inline$BDLGetDebugLevel$343$myNondetVar_0;
    inline$BDLGetDebugLevel$343$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$343$myNondetVar_0;
    goto inline$BDLGetDebugLevel$343$label_1#1;

  inline$BDLGetDebugLevel$343$label_1#1:
    goto inline$BDLGetDebugLevel$343$Return#1;

  inline$BDLGetDebugLevel$343$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$343$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon47_Then#1, inline$BDLSystemPowerIoCompletion$12$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon23#1;

  inline$BDLSystemPowerIoCompletion$12$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_83#1;

  inline$BDLSystemPowerIoCompletion$12$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_83_true#1, inline$BDLSystemPowerIoCompletion$12$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_84#1;

  inline$BDLSystemPowerIoCompletion$12$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_87#1;

  inline$BDLSystemPowerIoCompletion$12$label_87#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_88#1;

  inline$BDLSystemPowerIoCompletion$12$label_88#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_89#1;

  inline$BDLSystemPowerIoCompletion$12$label_89#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_90#1;

  inline$BDLSystemPowerIoCompletion$12$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$12$label_84#1;

  inline$BDLSystemPowerIoCompletion$12$label_84#1:
    goto inline$BDLGetDebugLevel$344$Entry#1;

  inline$BDLGetDebugLevel$344$Entry#1:
    goto inline$BDLGetDebugLevel$344$start#1;

  inline$BDLGetDebugLevel$344$start#1:
    goto inline$BDLGetDebugLevel$344$label_3#1;

  inline$BDLGetDebugLevel$344$label_3#1:
    havoc inline$BDLGetDebugLevel$344$myNondetVar_0;
    inline$BDLGetDebugLevel$344$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$344$myNondetVar_0;
    goto inline$BDLGetDebugLevel$344$label_1#1;

  inline$BDLGetDebugLevel$344$label_1#1:
    goto inline$BDLGetDebugLevel$344$Return#1;

  inline$BDLGetDebugLevel$344$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$344$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon48_Then#1, inline$BDLSystemPowerIoCompletion$12$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon25#1;

  inline$BDLSystemPowerIoCompletion$12$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_93#1;

  inline$BDLSystemPowerIoCompletion$12$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_93_true#1, inline$BDLSystemPowerIoCompletion$12$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_94#1;

  inline$BDLSystemPowerIoCompletion$12$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_97#1;

  inline$BDLSystemPowerIoCompletion$12$label_97#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_98#1;

  inline$BDLSystemPowerIoCompletion$12$label_98#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_99#1;

  inline$BDLSystemPowerIoCompletion$12$label_99#1:
    call inline$BDLSystemPowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$12$label_100#1;

  inline$BDLSystemPowerIoCompletion$12$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$12$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$12$label_94#1;

  inline$BDLSystemPowerIoCompletion$12$label_94#1:
    goto inline$BDLGetDebugLevel$345$Entry#1;

  inline$BDLGetDebugLevel$345$Entry#1:
    goto inline$BDLGetDebugLevel$345$start#1;

  inline$BDLGetDebugLevel$345$start#1:
    goto inline$BDLGetDebugLevel$345$label_3#1;

  inline$BDLGetDebugLevel$345$label_3#1:
    havoc inline$BDLGetDebugLevel$345$myNondetVar_0;
    inline$BDLGetDebugLevel$345$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$345$myNondetVar_0;
    goto inline$BDLGetDebugLevel$345$label_1#1;

  inline$BDLGetDebugLevel$345$label_1#1:
    goto inline$BDLGetDebugLevel$345$Return#1;

  inline$BDLGetDebugLevel$345$Return#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$345$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$12$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$12$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$12$anon49_Then#1, inline$BDLSystemPowerIoCompletion$12$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$12$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$anon27#1;

  inline$BDLSystemPowerIoCompletion$12$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_103#1;

  inline$BDLSystemPowerIoCompletion$12$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_103_true#1, inline$BDLSystemPowerIoCompletion$12$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$12$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_104#1;

  inline$BDLSystemPowerIoCompletion$12$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$12$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$12$label_105#1;

  inline$BDLSystemPowerIoCompletion$12$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$12$label_104#1;

  inline$BDLSystemPowerIoCompletion$12$label_104#1:
    inline$BDLSystemPowerIoCompletion$12$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$12$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$12$label_1#1;

  inline$BDLSystemPowerIoCompletion$12$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$12$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$12$Return#1;

  inline$BDLSystemPowerIoCompletion$12$Return#1:
    inline$CallCompletionRoutine$12$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$12$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$12$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$12$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$12$anon14_Then#1, inline$CallCompletionRoutine$12$anon14_Else#1;

  inline$CallCompletionRoutine$12$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$12$anon9#1;

  inline$CallCompletionRoutine$12$anon9#1:
    goto inline$CallCompletionRoutine$12$label_20_icall_return#1;

  inline$CallCompletionRoutine$12$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$12$Return#1;

  inline$CallCompletionRoutine$12$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$12$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$12$Entry#1;

  inline$BDLDevicePowerIoCompletion$12$Entry#1:
    inline$BDLDevicePowerIoCompletion$12$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$12$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$12$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$12$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$12$start#1;

  inline$BDLDevicePowerIoCompletion$12$start#1:
    call inline$BDLDevicePowerIoCompletion$12$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$12$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$12$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$12$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$12$label_3#1;

  inline$BDLDevicePowerIoCompletion$12$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_4#1;

  inline$BDLDevicePowerIoCompletion$12$label_4#1:
    inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_5#1;

  inline$BDLDevicePowerIoCompletion$12$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_6#1;

  inline$BDLDevicePowerIoCompletion$12$label_6#1:
    inline$BDLDevicePowerIoCompletion$12$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$12$label_7#1;

  inline$BDLDevicePowerIoCompletion$12$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_8#1;

  inline$BDLDevicePowerIoCompletion$12$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$12$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$12$label_9#1;

  inline$BDLDevicePowerIoCompletion$12$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_10#1;

  inline$BDLDevicePowerIoCompletion$12$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$66$Entry#1;

  inline$IoGetCurrentIrpStackLocation$66$Entry#1:
    inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$66$start#1;

  inline$IoGetCurrentIrpStackLocation$66$start#1:
    inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$66$label_3#1;

  inline$IoGetCurrentIrpStackLocation$66$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$66$label_3_true#1, inline$IoGetCurrentIrpStackLocation$66$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$66$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$66$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$66$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$66$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$66$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$66$label_4#1;

  inline$IoGetCurrentIrpStackLocation$66$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$66$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$66$label_6#1;

  inline$IoGetCurrentIrpStackLocation$66$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$66$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$66$label_7#1;

  inline$IoGetCurrentIrpStackLocation$66$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$66$label_5#1;

  inline$IoGetCurrentIrpStackLocation$66$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$66$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$66$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$66$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$66$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$66$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$66$label_5#1;

  inline$IoGetCurrentIrpStackLocation$66$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$66$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$66$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$66$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$66$label_1#1;

  inline$IoGetCurrentIrpStackLocation$66$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$66$Return#1;

  inline$IoGetCurrentIrpStackLocation$66$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$66$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon30_Then#1, inline$BDLDevicePowerIoCompletion$12$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon1#1;

  inline$BDLDevicePowerIoCompletion$12$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_13#1;

  inline$BDLDevicePowerIoCompletion$12$label_13#1:
    inline$BDLDevicePowerIoCompletion$12$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$12$label_14#1;

  inline$BDLDevicePowerIoCompletion$12$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_15#1;

  inline$BDLDevicePowerIoCompletion$12$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$12$label_16#1;

  inline$BDLDevicePowerIoCompletion$12$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_17#1;

  inline$BDLDevicePowerIoCompletion$12$label_17#1:
    goto inline$BDLGetDebugLevel$328$Entry#1;

  inline$BDLGetDebugLevel$328$Entry#1:
    goto inline$BDLGetDebugLevel$328$start#1;

  inline$BDLGetDebugLevel$328$start#1:
    goto inline$BDLGetDebugLevel$328$label_3#1;

  inline$BDLGetDebugLevel$328$label_3#1:
    havoc inline$BDLGetDebugLevel$328$myNondetVar_0;
    inline$BDLGetDebugLevel$328$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$328$myNondetVar_0;
    goto inline$BDLGetDebugLevel$328$label_1#1;

  inline$BDLGetDebugLevel$328$label_1#1:
    goto inline$BDLGetDebugLevel$328$Return#1;

  inline$BDLGetDebugLevel$328$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$328$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon31_Then#1, inline$BDLDevicePowerIoCompletion$12$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon3#1;

  inline$BDLDevicePowerIoCompletion$12$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_20#1;

  inline$BDLDevicePowerIoCompletion$12$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_20_true#1, inline$BDLDevicePowerIoCompletion$12$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_21#1;

  inline$BDLDevicePowerIoCompletion$12$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_24#1;

  inline$BDLDevicePowerIoCompletion$12$label_24#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_25#1;

  inline$BDLDevicePowerIoCompletion$12$label_25#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_26#1;

  inline$BDLDevicePowerIoCompletion$12$label_26#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_27#1;

  inline$BDLDevicePowerIoCompletion$12$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$12$label_21#1;

  inline$BDLDevicePowerIoCompletion$12$label_21#1:
    goto inline$BDLGetDebugLevel$329$Entry#1;

  inline$BDLGetDebugLevel$329$Entry#1:
    goto inline$BDLGetDebugLevel$329$start#1;

  inline$BDLGetDebugLevel$329$start#1:
    goto inline$BDLGetDebugLevel$329$label_3#1;

  inline$BDLGetDebugLevel$329$label_3#1:
    havoc inline$BDLGetDebugLevel$329$myNondetVar_0;
    inline$BDLGetDebugLevel$329$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$329$myNondetVar_0;
    goto inline$BDLGetDebugLevel$329$label_1#1;

  inline$BDLGetDebugLevel$329$label_1#1:
    goto inline$BDLGetDebugLevel$329$Return#1;

  inline$BDLGetDebugLevel$329$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$329$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon32_Then#1, inline$BDLDevicePowerIoCompletion$12$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon5#1;

  inline$BDLDevicePowerIoCompletion$12$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_30#1;

  inline$BDLDevicePowerIoCompletion$12$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_30_true#1, inline$BDLDevicePowerIoCompletion$12$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_31#1;

  inline$BDLDevicePowerIoCompletion$12$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_34#1;

  inline$BDLDevicePowerIoCompletion$12$label_34#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_35#1;

  inline$BDLDevicePowerIoCompletion$12$label_35#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_36#1;

  inline$BDLDevicePowerIoCompletion$12$label_36#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_37#1;

  inline$BDLDevicePowerIoCompletion$12$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$12$label_31#1;

  inline$BDLDevicePowerIoCompletion$12$label_31#1:
    goto inline$BDLGetDebugLevel$330$Entry#1;

  inline$BDLGetDebugLevel$330$Entry#1:
    goto inline$BDLGetDebugLevel$330$start#1;

  inline$BDLGetDebugLevel$330$start#1:
    goto inline$BDLGetDebugLevel$330$label_3#1;

  inline$BDLGetDebugLevel$330$label_3#1:
    havoc inline$BDLGetDebugLevel$330$myNondetVar_0;
    inline$BDLGetDebugLevel$330$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$330$myNondetVar_0;
    goto inline$BDLGetDebugLevel$330$label_1#1;

  inline$BDLGetDebugLevel$330$label_1#1:
    goto inline$BDLGetDebugLevel$330$Return#1;

  inline$BDLGetDebugLevel$330$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$330$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon33_Then#1, inline$BDLDevicePowerIoCompletion$12$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon7#1;

  inline$BDLDevicePowerIoCompletion$12$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_40#1;

  inline$BDLDevicePowerIoCompletion$12$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_40_true#1, inline$BDLDevicePowerIoCompletion$12$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_41#1;

  inline$BDLDevicePowerIoCompletion$12$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_42#1;

  inline$BDLDevicePowerIoCompletion$12$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_41#1;

  inline$BDLDevicePowerIoCompletion$12$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_41_true#1, inline$BDLDevicePowerIoCompletion$12$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$12$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$12$label_43#1;

  inline$BDLDevicePowerIoCompletion$12$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$12$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$12$label_44#1;

  inline$BDLDevicePowerIoCompletion$12$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_44_true#1, inline$BDLDevicePowerIoCompletion$12$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$12$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$12$label_45#1;

  inline$BDLDevicePowerIoCompletion$12$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_45_true#1, inline$BDLDevicePowerIoCompletion$12$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$12$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$12$label_43#1;

  inline$BDLDevicePowerIoCompletion$12$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$12$label_86#1;

  inline$BDLDevicePowerIoCompletion$12$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$12$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$12$label_46#1;

  inline$BDLDevicePowerIoCompletion$12$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$12$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$12$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$12$label_46#1;

  inline$BDLDevicePowerIoCompletion$12$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$12$label_49#1;

  inline$BDLDevicePowerIoCompletion$12$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_50#1;

  inline$BDLDevicePowerIoCompletion$12$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_51#1;

  inline$BDLDevicePowerIoCompletion$12$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_54#1;

  inline$BDLDevicePowerIoCompletion$12$label_54#1:
    inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$12$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$12$label_55#1;

  inline$BDLDevicePowerIoCompletion$12$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_55_true#1, inline$BDLDevicePowerIoCompletion$12$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_56#1;

  inline$BDLDevicePowerIoCompletion$12$label_56#1:
    call inline$BDLDevicePowerIoCompletion$12$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$12$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$12$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$12$anon34_Then#1, inline$BDLDevicePowerIoCompletion$12$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon9#1;

  inline$BDLDevicePowerIoCompletion$12$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_83#1;

  inline$BDLDevicePowerIoCompletion$12$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_59#1;

  inline$BDLDevicePowerIoCompletion$12$label_59#1:
    goto inline$BDLGetDebugLevel$331$Entry#1;

  inline$BDLGetDebugLevel$331$Entry#1:
    goto inline$BDLGetDebugLevel$331$start#1;

  inline$BDLGetDebugLevel$331$start#1:
    goto inline$BDLGetDebugLevel$331$label_3#1;

  inline$BDLGetDebugLevel$331$label_3#1:
    havoc inline$BDLGetDebugLevel$331$myNondetVar_0;
    inline$BDLGetDebugLevel$331$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$331$myNondetVar_0;
    goto inline$BDLGetDebugLevel$331$label_1#1;

  inline$BDLGetDebugLevel$331$label_1#1:
    goto inline$BDLGetDebugLevel$331$Return#1;

  inline$BDLGetDebugLevel$331$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$331$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon35_Then#1, inline$BDLDevicePowerIoCompletion$12$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon11#1;

  inline$BDLDevicePowerIoCompletion$12$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_62#1;

  inline$BDLDevicePowerIoCompletion$12$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_62_true#1, inline$BDLDevicePowerIoCompletion$12$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_63#1;

  inline$BDLDevicePowerIoCompletion$12$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_66#1;

  inline$BDLDevicePowerIoCompletion$12$label_66#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_67#1;

  inline$BDLDevicePowerIoCompletion$12$label_67#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_68#1;

  inline$BDLDevicePowerIoCompletion$12$label_68#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_69#1;

  inline$BDLDevicePowerIoCompletion$12$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$12$label_63#1;

  inline$BDLDevicePowerIoCompletion$12$label_63#1:
    goto inline$BDLGetDebugLevel$332$Entry#1;

  inline$BDLGetDebugLevel$332$Entry#1:
    goto inline$BDLGetDebugLevel$332$start#1;

  inline$BDLGetDebugLevel$332$start#1:
    goto inline$BDLGetDebugLevel$332$label_3#1;

  inline$BDLGetDebugLevel$332$label_3#1:
    havoc inline$BDLGetDebugLevel$332$myNondetVar_0;
    inline$BDLGetDebugLevel$332$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$332$myNondetVar_0;
    goto inline$BDLGetDebugLevel$332$label_1#1;

  inline$BDLGetDebugLevel$332$label_1#1:
    goto inline$BDLGetDebugLevel$332$Return#1;

  inline$BDLGetDebugLevel$332$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$332$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon36_Then#1, inline$BDLDevicePowerIoCompletion$12$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon13#1;

  inline$BDLDevicePowerIoCompletion$12$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_72#1;

  inline$BDLDevicePowerIoCompletion$12$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_72_true#1, inline$BDLDevicePowerIoCompletion$12$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_73#1;

  inline$BDLDevicePowerIoCompletion$12$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_76#1;

  inline$BDLDevicePowerIoCompletion$12$label_76#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_77#1;

  inline$BDLDevicePowerIoCompletion$12$label_77#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_78#1;

  inline$BDLDevicePowerIoCompletion$12$label_78#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_79#1;

  inline$BDLDevicePowerIoCompletion$12$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$12$label_73#1;

  inline$BDLDevicePowerIoCompletion$12$label_73#1:
    goto inline$BDLGetDebugLevel$333$Entry#1;

  inline$BDLGetDebugLevel$333$Entry#1:
    goto inline$BDLGetDebugLevel$333$start#1;

  inline$BDLGetDebugLevel$333$start#1:
    goto inline$BDLGetDebugLevel$333$label_3#1;

  inline$BDLGetDebugLevel$333$label_3#1:
    havoc inline$BDLGetDebugLevel$333$myNondetVar_0;
    inline$BDLGetDebugLevel$333$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$333$myNondetVar_0;
    goto inline$BDLGetDebugLevel$333$label_1#1;

  inline$BDLGetDebugLevel$333$label_1#1:
    goto inline$BDLGetDebugLevel$333$Return#1;

  inline$BDLGetDebugLevel$333$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$333$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon37_Then#1, inline$BDLDevicePowerIoCompletion$12$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon15#1;

  inline$BDLDevicePowerIoCompletion$12$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_82#1;

  inline$BDLDevicePowerIoCompletion$12$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_82_true#1, inline$BDLDevicePowerIoCompletion$12$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_83#1;

  inline$BDLDevicePowerIoCompletion$12$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_84#1;

  inline$BDLDevicePowerIoCompletion$12$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_83#1;

  inline$BDLDevicePowerIoCompletion$12$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_85#1;

  inline$BDLDevicePowerIoCompletion$12$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_86#1;

  inline$BDLDevicePowerIoCompletion$12$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$12$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$12$anon38_Then#1, inline$BDLDevicePowerIoCompletion$12$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon17#1;

  inline$BDLDevicePowerIoCompletion$12$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_89#1;

  inline$BDLDevicePowerIoCompletion$12$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$12$anon39_Then#1, inline$BDLDevicePowerIoCompletion$12$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon19#1;

  inline$BDLDevicePowerIoCompletion$12$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_92#1;

  inline$BDLDevicePowerIoCompletion$12$label_92#1:
    goto inline$storm_IoCompleteRequest$25$Entry#1;

  inline$storm_IoCompleteRequest$25$Entry#1:
    inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$12$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$25$start#1;

  inline$storm_IoCompleteRequest$25$start#1:
    inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$25$label_3#1;

  inline$storm_IoCompleteRequest$25$label_3#1:
    call inline$storm_IoCompleteRequest$25$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$25$label_6#1;

  inline$storm_IoCompleteRequest$25$label_6#1:
    goto inline$storm_IoCompleteRequest$25$label_6_true#1, inline$storm_IoCompleteRequest$25$label_6_false#1;

  inline$storm_IoCompleteRequest$25$label_6_false#1:
    assume inline$storm_IoCompleteRequest$25$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$25$label_7#1;

  inline$storm_IoCompleteRequest$25$label_6_true#1:
    assume inline$storm_IoCompleteRequest$25$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$25$label_8#1;

  inline$storm_IoCompleteRequest$25$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$25$anon3_Then#1, inline$storm_IoCompleteRequest$25$anon3_Else#1;

  inline$storm_IoCompleteRequest$25$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$25$anon1#1;

  inline$storm_IoCompleteRequest$25$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$25$label_9#1;

  inline$storm_IoCompleteRequest$25$label_9#1:
    goto inline$storm_IoCompleteRequest$25$label_9_true#1, inline$storm_IoCompleteRequest$25$label_9_false#1;

  inline$storm_IoCompleteRequest$25$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$25$label_10#1;

  inline$storm_IoCompleteRequest$25$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$25$label_1#1;

  inline$storm_IoCompleteRequest$25$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$25$label_7#1;

  inline$storm_IoCompleteRequest$25$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$25$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$25$label_1#1;

  inline$storm_IoCompleteRequest$25$label_1#1:
    goto inline$storm_IoCompleteRequest$25$Return#1;

  inline$storm_IoCompleteRequest$25$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$25$Return#1;

  inline$storm_IoCompleteRequest$25$Return#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon40_Then#1, inline$BDLDevicePowerIoCompletion$12$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon21#1;

  inline$BDLDevicePowerIoCompletion$12$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_95#1;

  inline$BDLDevicePowerIoCompletion$12$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$12$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$12$anon41_Then#1, inline$BDLDevicePowerIoCompletion$12$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon23#1;

  inline$BDLDevicePowerIoCompletion$12$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_98#1;

  inline$BDLDevicePowerIoCompletion$12$label_98#1:
    goto inline$BDLGetDebugLevel$334$Entry#1;

  inline$BDLGetDebugLevel$334$Entry#1:
    goto inline$BDLGetDebugLevel$334$start#1;

  inline$BDLGetDebugLevel$334$start#1:
    goto inline$BDLGetDebugLevel$334$label_3#1;

  inline$BDLGetDebugLevel$334$label_3#1:
    havoc inline$BDLGetDebugLevel$334$myNondetVar_0;
    inline$BDLGetDebugLevel$334$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$334$myNondetVar_0;
    goto inline$BDLGetDebugLevel$334$label_1#1;

  inline$BDLGetDebugLevel$334$label_1#1:
    goto inline$BDLGetDebugLevel$334$Return#1;

  inline$BDLGetDebugLevel$334$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$334$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon42_Then#1, inline$BDLDevicePowerIoCompletion$12$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon25#1;

  inline$BDLDevicePowerIoCompletion$12$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_101#1;

  inline$BDLDevicePowerIoCompletion$12$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_101_true#1, inline$BDLDevicePowerIoCompletion$12$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_102#1;

  inline$BDLDevicePowerIoCompletion$12$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_105#1;

  inline$BDLDevicePowerIoCompletion$12$label_105#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_106#1;

  inline$BDLDevicePowerIoCompletion$12$label_106#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_107#1;

  inline$BDLDevicePowerIoCompletion$12$label_107#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_108#1;

  inline$BDLDevicePowerIoCompletion$12$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$12$label_102#1;

  inline$BDLDevicePowerIoCompletion$12$label_102#1:
    goto inline$BDLGetDebugLevel$335$Entry#1;

  inline$BDLGetDebugLevel$335$Entry#1:
    goto inline$BDLGetDebugLevel$335$start#1;

  inline$BDLGetDebugLevel$335$start#1:
    goto inline$BDLGetDebugLevel$335$label_3#1;

  inline$BDLGetDebugLevel$335$label_3#1:
    havoc inline$BDLGetDebugLevel$335$myNondetVar_0;
    inline$BDLGetDebugLevel$335$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$335$myNondetVar_0;
    goto inline$BDLGetDebugLevel$335$label_1#1;

  inline$BDLGetDebugLevel$335$label_1#1:
    goto inline$BDLGetDebugLevel$335$Return#1;

  inline$BDLGetDebugLevel$335$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$335$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon43_Then#1, inline$BDLDevicePowerIoCompletion$12$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon27#1;

  inline$BDLDevicePowerIoCompletion$12$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_111#1;

  inline$BDLDevicePowerIoCompletion$12$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_111_true#1, inline$BDLDevicePowerIoCompletion$12$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_112#1;

  inline$BDLDevicePowerIoCompletion$12$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_115#1;

  inline$BDLDevicePowerIoCompletion$12$label_115#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_116#1;

  inline$BDLDevicePowerIoCompletion$12$label_116#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_117#1;

  inline$BDLDevicePowerIoCompletion$12$label_117#1:
    call inline$BDLDevicePowerIoCompletion$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$12$label_118#1;

  inline$BDLDevicePowerIoCompletion$12$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$12$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$12$label_112#1;

  inline$BDLDevicePowerIoCompletion$12$label_112#1:
    goto inline$BDLGetDebugLevel$336$Entry#1;

  inline$BDLGetDebugLevel$336$Entry#1:
    goto inline$BDLGetDebugLevel$336$start#1;

  inline$BDLGetDebugLevel$336$start#1:
    goto inline$BDLGetDebugLevel$336$label_3#1;

  inline$BDLGetDebugLevel$336$label_3#1:
    havoc inline$BDLGetDebugLevel$336$myNondetVar_0;
    inline$BDLGetDebugLevel$336$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$336$myNondetVar_0;
    goto inline$BDLGetDebugLevel$336$label_1#1;

  inline$BDLGetDebugLevel$336$label_1#1:
    goto inline$BDLGetDebugLevel$336$Return#1;

  inline$BDLGetDebugLevel$336$Return#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$336$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$12$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$12$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$12$anon44_Then#1, inline$BDLDevicePowerIoCompletion$12$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$12$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$anon29#1;

  inline$BDLDevicePowerIoCompletion$12$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_121#1;

  inline$BDLDevicePowerIoCompletion$12$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_121_true#1, inline$BDLDevicePowerIoCompletion$12$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$12$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_122#1;

  inline$BDLDevicePowerIoCompletion$12$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$12$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$12$label_123#1;

  inline$BDLDevicePowerIoCompletion$12$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$12$label_122#1;

  inline$BDLDevicePowerIoCompletion$12$label_122#1:
    inline$BDLDevicePowerIoCompletion$12$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$12$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$12$label_1#1;

  inline$BDLDevicePowerIoCompletion$12$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$12$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$12$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$12$Return#1;

  inline$BDLDevicePowerIoCompletion$12$Return#1:
    inline$CallCompletionRoutine$12$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$12$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$12$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$12$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$12$anon13_Then#1, inline$CallCompletionRoutine$12$anon13_Else#1;

  inline$CallCompletionRoutine$12$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$12$anon7#1;

  inline$CallCompletionRoutine$12$anon7#1:
    goto inline$CallCompletionRoutine$12$label_20_icall_return#1;

  inline$CallCompletionRoutine$12$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$12$Return#1;

  inline$CallCompletionRoutine$12$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$12$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$12$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$12$Entry#1;

  inline$BDLCallDriverCompletionRoutine$12$Entry#1:
    inline$BDLCallDriverCompletionRoutine$12$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$12$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$12$start#1;

  inline$BDLCallDriverCompletionRoutine$12$start#1:
    inline$BDLCallDriverCompletionRoutine$12$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$12$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$12$label_3#1;

  inline$BDLCallDriverCompletionRoutine$12$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$12$label_3_true#1, inline$BDLCallDriverCompletionRoutine$12$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$12$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$12$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$12$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$12$label_4#1;

  inline$BDLCallDriverCompletionRoutine$12$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$12$label_6#1;

  inline$BDLCallDriverCompletionRoutine$12$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$12$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$12$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$12$label_5#1;

  inline$BDLCallDriverCompletionRoutine$12$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$12$label_6#1;

  inline$BDLCallDriverCompletionRoutine$12$label_6#1:
    goto inline$storm_KeSetEvent$14$Entry#1;

  inline$storm_KeSetEvent$14$Entry#1:
    inline$storm_KeSetEvent$14$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$12$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$14$start#1;

  inline$storm_KeSetEvent$14$start#1:
    inline$storm_KeSetEvent$14$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$14$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$14$label_3#1;

  inline$storm_KeSetEvent$14$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$14$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$14$label_1#1;

  inline$storm_KeSetEvent$14$label_1#1:
    goto inline$storm_KeSetEvent$14$Return#1;

  inline$storm_KeSetEvent$14$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$12$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$12$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$12$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$12$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$12$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$12$anon1#1;

  inline$BDLCallDriverCompletionRoutine$12$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$12$label_9#1;

  inline$BDLCallDriverCompletionRoutine$12$label_9#1:
    inline$BDLCallDriverCompletionRoutine$12$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$12$label_1#1;

  inline$BDLCallDriverCompletionRoutine$12$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$12$Return#1;

  inline$BDLCallDriverCompletionRoutine$12$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$12$Return#1;

  inline$BDLCallDriverCompletionRoutine$12$Return#1:
    inline$CallCompletionRoutine$12$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$12$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$12$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$12$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$12$anon12_Then#1, inline$CallCompletionRoutine$12$anon12_Else#1;

  inline$CallCompletionRoutine$12$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$12$anon5#1;

  inline$CallCompletionRoutine$12$anon5#1:
    goto inline$CallCompletionRoutine$12$label_20_icall_return#1;

  inline$CallCompletionRoutine$12$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$12$label_23#1;

  inline$CallCompletionRoutine$12$label_23#1:
    inline$CallCompletionRoutine$12$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$12$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$12$label_24#1;

  inline$CallCompletionRoutine$12$label_24#1:
    goto inline$CallCompletionRoutine$12$label_24_true#1, inline$CallCompletionRoutine$12$label_24_false#1;

  inline$CallCompletionRoutine$12$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$12$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$12$label_1#1;

  inline$CallCompletionRoutine$12$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$12$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$12$label_25#1;

  inline$CallCompletionRoutine$12$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$12$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$12$label_1#1;

  inline$CallCompletionRoutine$12$label_1#1:
    goto inline$CallCompletionRoutine$12$Return#1;

  inline$CallCompletionRoutine$12$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$12$Return#1;

  inline$CallCompletionRoutine$12$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$12$Return#1;

  inline$CallCompletionRoutine$12$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$12$Return#1;

  inline$CallCompletionRoutine$12$Return#1:
    goto inline$storm_IoCallDriver$6$label_33$1#1;

  inline$storm_IoCallDriver$6$label_33$1#1:
    goto inline$storm_IoCallDriver$6$anon14_Then#1, inline$storm_IoCallDriver$6$anon14_Else#1;

  inline$storm_IoCallDriver$6$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$6$anon8#1;

  inline$storm_IoCallDriver$6$anon8#1:
    goto inline$storm_IoCallDriver$6$label_36#1;

  inline$storm_IoCallDriver$6$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$6$Return#1;

  inline$storm_IoCallDriver$6$label_27_case_1#1:
    assume inline$storm_IoCallDriver$6$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$6$label_29#1;

  inline$storm_IoCallDriver$6$label_29#1:
    inline$storm_IoCallDriver$6$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$6$label_37#1;

  inline$storm_IoCallDriver$6$label_37#1:
    goto inline$storm_IoCallDriver$6$label_38#1;

  inline$storm_IoCallDriver$6$label_38#1:
    goto inline$storm_IoCallDriver$6$label_39#1;

  inline$storm_IoCallDriver$6$label_39#1:
    goto inline$CallCompletionRoutine$13$Entry#1;

  inline$CallCompletionRoutine$13$Entry#1:
    inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$13$start#1;

  inline$CallCompletionRoutine$13$start#1:
    inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$13$label_3#1;

  inline$CallCompletionRoutine$13$label_3#1:
    goto inline$CallCompletionRoutine$13$label_4#1;

  inline$CallCompletionRoutine$13$label_4#1:
    goto inline$CallCompletionRoutine$13$label_5#1;

  inline$CallCompletionRoutine$13$label_5#1:
    goto inline$CallCompletionRoutine$13$label_6#1;

  inline$CallCompletionRoutine$13$label_6#1:
    goto inline$CallCompletionRoutine$13$label_7#1;

  inline$CallCompletionRoutine$13$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$68$Entry#1;

  inline$IoGetCurrentIrpStackLocation$68$Entry#1:
    inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$68$start#1;

  inline$IoGetCurrentIrpStackLocation$68$start#1:
    inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$68$label_3#1;

  inline$IoGetCurrentIrpStackLocation$68$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$68$label_3_true#1, inline$IoGetCurrentIrpStackLocation$68$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$68$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$68$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$68$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$68$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$68$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$68$label_4#1;

  inline$IoGetCurrentIrpStackLocation$68$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$68$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$68$label_6#1;

  inline$IoGetCurrentIrpStackLocation$68$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$68$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$68$label_7#1;

  inline$IoGetCurrentIrpStackLocation$68$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$68$label_5#1;

  inline$IoGetCurrentIrpStackLocation$68$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$68$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$68$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$68$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$68$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$68$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$68$label_5#1;

  inline$IoGetCurrentIrpStackLocation$68$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$68$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$68$label_1#1;

  inline$IoGetCurrentIrpStackLocation$68$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$68$Return#1;

  inline$IoGetCurrentIrpStackLocation$68$Return#1:
    goto inline$CallCompletionRoutine$13$label_7$1#1;

  inline$CallCompletionRoutine$13$label_7$1#1:
    goto inline$CallCompletionRoutine$13$anon10_Then#1, inline$CallCompletionRoutine$13$anon10_Else#1;

  inline$CallCompletionRoutine$13$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$13$anon1#1;

  inline$CallCompletionRoutine$13$anon1#1:
    goto inline$CallCompletionRoutine$13$label_10#1;

  inline$CallCompletionRoutine$13$label_10#1:
    goto inline$CallCompletionRoutine$13$label_11#1;

  inline$CallCompletionRoutine$13$label_11#1:
    havoc inline$CallCompletionRoutine$13$myNondetVar_0;
    inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$13$myNondetVar_0;
    goto inline$CallCompletionRoutine$13$label_12#1;

  inline$CallCompletionRoutine$13$label_12#1:
    havoc inline$CallCompletionRoutine$13$myNondetVar_0;
    inline$CallCompletionRoutine$13$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$13$myNondetVar_0;
    goto inline$CallCompletionRoutine$13$label_13#1;

  inline$CallCompletionRoutine$13$label_13#1:
    havoc inline$CallCompletionRoutine$13$myNondetVar_0;
    goto inline$CallCompletionRoutine$13$label_14#1;

  inline$CallCompletionRoutine$13$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$69$Entry#1;

  inline$IoGetCurrentIrpStackLocation$69$Entry#1:
    inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$69$start#1;

  inline$IoGetCurrentIrpStackLocation$69$start#1:
    inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$69$label_3#1;

  inline$IoGetCurrentIrpStackLocation$69$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$69$label_3_true#1, inline$IoGetCurrentIrpStackLocation$69$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$69$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$69$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$69$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$69$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$69$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$69$label_4#1;

  inline$IoGetCurrentIrpStackLocation$69$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$69$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$69$label_6#1;

  inline$IoGetCurrentIrpStackLocation$69$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$69$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$69$label_7#1;

  inline$IoGetCurrentIrpStackLocation$69$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$69$label_5#1;

  inline$IoGetCurrentIrpStackLocation$69$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$69$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$69$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$69$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$69$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$69$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$69$label_5#1;

  inline$IoGetCurrentIrpStackLocation$69$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$69$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$69$label_1#1;

  inline$IoGetCurrentIrpStackLocation$69$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$69$Return#1;

  inline$IoGetCurrentIrpStackLocation$69$Return#1:
    goto inline$CallCompletionRoutine$13$label_14$1#1;

  inline$CallCompletionRoutine$13$label_14$1#1:
    goto inline$CallCompletionRoutine$13$anon11_Then#1, inline$CallCompletionRoutine$13$anon11_Else#1;

  inline$CallCompletionRoutine$13$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$13$anon3#1;

  inline$CallCompletionRoutine$13$anon3#1:
    goto inline$CallCompletionRoutine$13$label_17#1;

  inline$CallCompletionRoutine$13$label_17#1:
    goto inline$CallCompletionRoutine$13$label_18#1;

  inline$CallCompletionRoutine$13$label_18#1:
    goto inline$CallCompletionRoutine$13$label_18_true#1, inline$CallCompletionRoutine$13$label_18_false#1;

  inline$CallCompletionRoutine$13$label_18_false#1:
    assume inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$13$label_1#1;

  inline$CallCompletionRoutine$13$label_18_true#1:
    assume inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$13$label_19#1;

  inline$CallCompletionRoutine$13$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$13$label_20#1;

  inline$CallCompletionRoutine$13$label_20#1:
    goto inline$CallCompletionRoutine$13$label_20_icall_1#1, inline$CallCompletionRoutine$13$label_20_icall_2#1, inline$CallCompletionRoutine$13$label_20_icall_3#1;

  inline$CallCompletionRoutine$13$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$13$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$13$Entry#1;

  inline$BDLSystemPowerIoCompletion$13$Entry#1:
    inline$BDLSystemPowerIoCompletion$13$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$13$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$13$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$13$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$13$start#1;

  inline$BDLSystemPowerIoCompletion$13$start#1:
    call inline$BDLSystemPowerIoCompletion$13$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$13$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$13$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$13$label_3#1;

  inline$BDLSystemPowerIoCompletion$13$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_4#1;

  inline$BDLSystemPowerIoCompletion$13$label_4#1:
    inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_5#1;

  inline$BDLSystemPowerIoCompletion$13$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_6#1;

  inline$BDLSystemPowerIoCompletion$13$label_6#1:
    inline$BDLSystemPowerIoCompletion$13$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$13$label_7#1;

  inline$BDLSystemPowerIoCompletion$13$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_8#1;

  inline$BDLSystemPowerIoCompletion$13$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$13$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$13$label_9#1;

  inline$BDLSystemPowerIoCompletion$13$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_10#1;

  inline$BDLSystemPowerIoCompletion$13$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$71$Entry#1;

  inline$IoGetCurrentIrpStackLocation$71$Entry#1:
    inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$71$start#1;

  inline$IoGetCurrentIrpStackLocation$71$start#1:
    inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$71$label_3#1;

  inline$IoGetCurrentIrpStackLocation$71$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$71$label_3_true#1, inline$IoGetCurrentIrpStackLocation$71$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$71$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$71$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$71$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$71$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$71$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$71$label_4#1;

  inline$IoGetCurrentIrpStackLocation$71$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$71$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$71$label_6#1;

  inline$IoGetCurrentIrpStackLocation$71$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$71$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$71$label_7#1;

  inline$IoGetCurrentIrpStackLocation$71$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$71$label_5#1;

  inline$IoGetCurrentIrpStackLocation$71$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$71$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$71$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$71$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$71$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$71$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$71$label_5#1;

  inline$IoGetCurrentIrpStackLocation$71$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$71$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$71$label_1#1;

  inline$IoGetCurrentIrpStackLocation$71$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$71$Return#1;

  inline$IoGetCurrentIrpStackLocation$71$Return#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon36_Then#1, inline$BDLSystemPowerIoCompletion$13$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon1#1;

  inline$BDLSystemPowerIoCompletion$13$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_13#1;

  inline$BDLSystemPowerIoCompletion$13$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_14#1;

  inline$BDLSystemPowerIoCompletion$13$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_15#1;

  inline$BDLSystemPowerIoCompletion$13$label_15#1:
    goto inline$BDLGetDebugLevel$358$Entry#1;

  inline$BDLGetDebugLevel$358$Entry#1:
    goto inline$BDLGetDebugLevel$358$start#1;

  inline$BDLGetDebugLevel$358$start#1:
    goto inline$BDLGetDebugLevel$358$label_3#1;

  inline$BDLGetDebugLevel$358$label_3#1:
    havoc inline$BDLGetDebugLevel$358$myNondetVar_0;
    inline$BDLGetDebugLevel$358$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$358$myNondetVar_0;
    goto inline$BDLGetDebugLevel$358$label_1#1;

  inline$BDLGetDebugLevel$358$label_1#1:
    goto inline$BDLGetDebugLevel$358$Return#1;

  inline$BDLGetDebugLevel$358$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$358$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon37_Then#1, inline$BDLSystemPowerIoCompletion$13$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon3#1;

  inline$BDLSystemPowerIoCompletion$13$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_18#1;

  inline$BDLSystemPowerIoCompletion$13$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_18_true#1, inline$BDLSystemPowerIoCompletion$13$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_19#1;

  inline$BDLSystemPowerIoCompletion$13$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_22#1;

  inline$BDLSystemPowerIoCompletion$13$label_22#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_23#1;

  inline$BDLSystemPowerIoCompletion$13$label_23#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_24#1;

  inline$BDLSystemPowerIoCompletion$13$label_24#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_25#1;

  inline$BDLSystemPowerIoCompletion$13$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$13$label_19#1;

  inline$BDLSystemPowerIoCompletion$13$label_19#1:
    goto inline$BDLGetDebugLevel$359$Entry#1;

  inline$BDLGetDebugLevel$359$Entry#1:
    goto inline$BDLGetDebugLevel$359$start#1;

  inline$BDLGetDebugLevel$359$start#1:
    goto inline$BDLGetDebugLevel$359$label_3#1;

  inline$BDLGetDebugLevel$359$label_3#1:
    havoc inline$BDLGetDebugLevel$359$myNondetVar_0;
    inline$BDLGetDebugLevel$359$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$359$myNondetVar_0;
    goto inline$BDLGetDebugLevel$359$label_1#1;

  inline$BDLGetDebugLevel$359$label_1#1:
    goto inline$BDLGetDebugLevel$359$Return#1;

  inline$BDLGetDebugLevel$359$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$359$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon38_Then#1, inline$BDLSystemPowerIoCompletion$13$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon5#1;

  inline$BDLSystemPowerIoCompletion$13$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_28#1;

  inline$BDLSystemPowerIoCompletion$13$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_28_true#1, inline$BDLSystemPowerIoCompletion$13$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_29#1;

  inline$BDLSystemPowerIoCompletion$13$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_32#1;

  inline$BDLSystemPowerIoCompletion$13$label_32#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_33#1;

  inline$BDLSystemPowerIoCompletion$13$label_33#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_34#1;

  inline$BDLSystemPowerIoCompletion$13$label_34#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_35#1;

  inline$BDLSystemPowerIoCompletion$13$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$13$label_29#1;

  inline$BDLSystemPowerIoCompletion$13$label_29#1:
    goto inline$BDLGetDebugLevel$360$Entry#1;

  inline$BDLGetDebugLevel$360$Entry#1:
    goto inline$BDLGetDebugLevel$360$start#1;

  inline$BDLGetDebugLevel$360$start#1:
    goto inline$BDLGetDebugLevel$360$label_3#1;

  inline$BDLGetDebugLevel$360$label_3#1:
    havoc inline$BDLGetDebugLevel$360$myNondetVar_0;
    inline$BDLGetDebugLevel$360$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$360$myNondetVar_0;
    goto inline$BDLGetDebugLevel$360$label_1#1;

  inline$BDLGetDebugLevel$360$label_1#1:
    goto inline$BDLGetDebugLevel$360$Return#1;

  inline$BDLGetDebugLevel$360$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$360$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon39_Then#1, inline$BDLSystemPowerIoCompletion$13$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon7#1;

  inline$BDLSystemPowerIoCompletion$13$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_38#1;

  inline$BDLSystemPowerIoCompletion$13$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_38_true#1, inline$BDLSystemPowerIoCompletion$13$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_39#1;

  inline$BDLSystemPowerIoCompletion$13$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_40#1;

  inline$BDLSystemPowerIoCompletion$13$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_39#1;

  inline$BDLSystemPowerIoCompletion$13$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_39_true#1, inline$BDLSystemPowerIoCompletion$13$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_41#1;

  inline$BDLSystemPowerIoCompletion$13$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$13$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$13$label_107#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$13$label_108#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$13$label_108#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$13$label_108#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$13$label_108#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$13$label_108#1;

  inline$BDLSystemPowerIoCompletion$13$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_109#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$13$label_107#1;

  inline$BDLSystemPowerIoCompletion$13$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_109#1;

  inline$BDLSystemPowerIoCompletion$13$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$13$label_106#1;

  inline$BDLSystemPowerIoCompletion$13$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_106_true#1, inline$BDLSystemPowerIoCompletion$13$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_142#1;

  inline$BDLSystemPowerIoCompletion$13$label_142#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_143#1;

  inline$BDLSystemPowerIoCompletion$13$label_143#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_144#1;

  inline$BDLSystemPowerIoCompletion$13$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_109#1;

  inline$BDLSystemPowerIoCompletion$13$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_109#1;

  inline$BDLSystemPowerIoCompletion$13$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$13$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$13$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$13$myNondetVar_0, inline$BDLSystemPowerIoCompletion$13$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$13$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$13$anon50_Then#1, inline$BDLSystemPowerIoCompletion$13$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon29#1;

  inline$BDLSystemPowerIoCompletion$13$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_112#1;

  inline$BDLSystemPowerIoCompletion$13$label_112#1:
    inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$13$label_113#1;

  inline$BDLSystemPowerIoCompletion$13$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_113_true#1, inline$BDLSystemPowerIoCompletion$13$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$13$label_114#1;

  inline$BDLSystemPowerIoCompletion$13$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_116#1;

  inline$BDLSystemPowerIoCompletion$13$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_117#1;

  inline$BDLSystemPowerIoCompletion$13$label_117#1:
    goto inline$BDLGetDebugLevel$367$Entry#1;

  inline$BDLGetDebugLevel$367$Entry#1:
    goto inline$BDLGetDebugLevel$367$start#1;

  inline$BDLGetDebugLevel$367$start#1:
    goto inline$BDLGetDebugLevel$367$label_3#1;

  inline$BDLGetDebugLevel$367$label_3#1:
    havoc inline$BDLGetDebugLevel$367$myNondetVar_0;
    inline$BDLGetDebugLevel$367$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$367$myNondetVar_0;
    goto inline$BDLGetDebugLevel$367$label_1#1;

  inline$BDLGetDebugLevel$367$label_1#1:
    goto inline$BDLGetDebugLevel$367$Return#1;

  inline$BDLGetDebugLevel$367$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$367$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon51_Then#1, inline$BDLSystemPowerIoCompletion$13$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon31#1;

  inline$BDLSystemPowerIoCompletion$13$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_120#1;

  inline$BDLSystemPowerIoCompletion$13$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_120_true#1, inline$BDLSystemPowerIoCompletion$13$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_121#1;

  inline$BDLSystemPowerIoCompletion$13$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_124#1;

  inline$BDLSystemPowerIoCompletion$13$label_124#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_125#1;

  inline$BDLSystemPowerIoCompletion$13$label_125#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_126#1;

  inline$BDLSystemPowerIoCompletion$13$label_126#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_127#1;

  inline$BDLSystemPowerIoCompletion$13$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$13$label_121#1;

  inline$BDLSystemPowerIoCompletion$13$label_121#1:
    goto inline$BDLGetDebugLevel$368$Entry#1;

  inline$BDLGetDebugLevel$368$Entry#1:
    goto inline$BDLGetDebugLevel$368$start#1;

  inline$BDLGetDebugLevel$368$start#1:
    goto inline$BDLGetDebugLevel$368$label_3#1;

  inline$BDLGetDebugLevel$368$label_3#1:
    havoc inline$BDLGetDebugLevel$368$myNondetVar_0;
    inline$BDLGetDebugLevel$368$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$368$myNondetVar_0;
    goto inline$BDLGetDebugLevel$368$label_1#1;

  inline$BDLGetDebugLevel$368$label_1#1:
    goto inline$BDLGetDebugLevel$368$Return#1;

  inline$BDLGetDebugLevel$368$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$368$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon52_Then#1, inline$BDLSystemPowerIoCompletion$13$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon33#1;

  inline$BDLSystemPowerIoCompletion$13$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_130#1;

  inline$BDLSystemPowerIoCompletion$13$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_130_true#1, inline$BDLSystemPowerIoCompletion$13$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_131#1;

  inline$BDLSystemPowerIoCompletion$13$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_134#1;

  inline$BDLSystemPowerIoCompletion$13$label_134#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_135#1;

  inline$BDLSystemPowerIoCompletion$13$label_135#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_136#1;

  inline$BDLSystemPowerIoCompletion$13$label_136#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_137#1;

  inline$BDLSystemPowerIoCompletion$13$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$13$label_131#1;

  inline$BDLSystemPowerIoCompletion$13$label_131#1:
    goto inline$BDLGetDebugLevel$369$Entry#1;

  inline$BDLGetDebugLevel$369$Entry#1:
    goto inline$BDLGetDebugLevel$369$start#1;

  inline$BDLGetDebugLevel$369$start#1:
    goto inline$BDLGetDebugLevel$369$label_3#1;

  inline$BDLGetDebugLevel$369$label_3#1:
    havoc inline$BDLGetDebugLevel$369$myNondetVar_0;
    inline$BDLGetDebugLevel$369$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$369$myNondetVar_0;
    goto inline$BDLGetDebugLevel$369$label_1#1;

  inline$BDLGetDebugLevel$369$label_1#1:
    goto inline$BDLGetDebugLevel$369$Return#1;

  inline$BDLGetDebugLevel$369$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$369$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon53_Then#1, inline$BDLSystemPowerIoCompletion$13$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon35#1;

  inline$BDLSystemPowerIoCompletion$13$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_140#1;

  inline$BDLSystemPowerIoCompletion$13$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_140_true#1, inline$BDLSystemPowerIoCompletion$13$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_67#1;

  inline$BDLSystemPowerIoCompletion$13$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_141#1;

  inline$BDLSystemPowerIoCompletion$13$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_67#1;

  inline$BDLSystemPowerIoCompletion$13$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$13$label_115#1;

  inline$BDLSystemPowerIoCompletion$13$label_115#1:
    inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$13$label_80#1;

  inline$BDLSystemPowerIoCompletion$13$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$13$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_42#1;

  inline$BDLSystemPowerIoCompletion$13$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$13$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$13$label_43#1;

  inline$BDLSystemPowerIoCompletion$13$label_43#1:
    goto inline$BDLGetDebugLevel$361$Entry#1;

  inline$BDLGetDebugLevel$361$Entry#1:
    goto inline$BDLGetDebugLevel$361$start#1;

  inline$BDLGetDebugLevel$361$start#1:
    goto inline$BDLGetDebugLevel$361$label_3#1;

  inline$BDLGetDebugLevel$361$label_3#1:
    havoc inline$BDLGetDebugLevel$361$myNondetVar_0;
    inline$BDLGetDebugLevel$361$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$361$myNondetVar_0;
    goto inline$BDLGetDebugLevel$361$label_1#1;

  inline$BDLGetDebugLevel$361$label_1#1:
    goto inline$BDLGetDebugLevel$361$Return#1;

  inline$BDLGetDebugLevel$361$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$361$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon40_Then#1, inline$BDLSystemPowerIoCompletion$13$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon9#1;

  inline$BDLSystemPowerIoCompletion$13$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_46#1;

  inline$BDLSystemPowerIoCompletion$13$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_46_true#1, inline$BDLSystemPowerIoCompletion$13$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_47#1;

  inline$BDLSystemPowerIoCompletion$13$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_50#1;

  inline$BDLSystemPowerIoCompletion$13$label_50#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_51#1;

  inline$BDLSystemPowerIoCompletion$13$label_51#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_52#1;

  inline$BDLSystemPowerIoCompletion$13$label_52#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_53#1;

  inline$BDLSystemPowerIoCompletion$13$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$13$label_47#1;

  inline$BDLSystemPowerIoCompletion$13$label_47#1:
    goto inline$BDLGetDebugLevel$362$Entry#1;

  inline$BDLGetDebugLevel$362$Entry#1:
    goto inline$BDLGetDebugLevel$362$start#1;

  inline$BDLGetDebugLevel$362$start#1:
    goto inline$BDLGetDebugLevel$362$label_3#1;

  inline$BDLGetDebugLevel$362$label_3#1:
    havoc inline$BDLGetDebugLevel$362$myNondetVar_0;
    inline$BDLGetDebugLevel$362$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$362$myNondetVar_0;
    goto inline$BDLGetDebugLevel$362$label_1#1;

  inline$BDLGetDebugLevel$362$label_1#1:
    goto inline$BDLGetDebugLevel$362$Return#1;

  inline$BDLGetDebugLevel$362$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$362$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon41_Then#1, inline$BDLSystemPowerIoCompletion$13$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon11#1;

  inline$BDLSystemPowerIoCompletion$13$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_56#1;

  inline$BDLSystemPowerIoCompletion$13$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_56_true#1, inline$BDLSystemPowerIoCompletion$13$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_57#1;

  inline$BDLSystemPowerIoCompletion$13$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_60#1;

  inline$BDLSystemPowerIoCompletion$13$label_60#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_61#1;

  inline$BDLSystemPowerIoCompletion$13$label_61#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_62#1;

  inline$BDLSystemPowerIoCompletion$13$label_62#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_63#1;

  inline$BDLSystemPowerIoCompletion$13$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$13$label_57#1;

  inline$BDLSystemPowerIoCompletion$13$label_57#1:
    goto inline$BDLGetDebugLevel$363$Entry#1;

  inline$BDLGetDebugLevel$363$Entry#1:
    goto inline$BDLGetDebugLevel$363$start#1;

  inline$BDLGetDebugLevel$363$start#1:
    goto inline$BDLGetDebugLevel$363$label_3#1;

  inline$BDLGetDebugLevel$363$label_3#1:
    havoc inline$BDLGetDebugLevel$363$myNondetVar_0;
    inline$BDLGetDebugLevel$363$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$363$myNondetVar_0;
    goto inline$BDLGetDebugLevel$363$label_1#1;

  inline$BDLGetDebugLevel$363$label_1#1:
    goto inline$BDLGetDebugLevel$363$Return#1;

  inline$BDLGetDebugLevel$363$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$363$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon42_Then#1, inline$BDLSystemPowerIoCompletion$13$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon13#1;

  inline$BDLSystemPowerIoCompletion$13$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_66#1;

  inline$BDLSystemPowerIoCompletion$13$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_66_true#1, inline$BDLSystemPowerIoCompletion$13$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_67#1;

  inline$BDLSystemPowerIoCompletion$13$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_70#1;

  inline$BDLSystemPowerIoCompletion$13$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_67#1;

  inline$BDLSystemPowerIoCompletion$13$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$13$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$13$anon43_Then#1, inline$BDLSystemPowerIoCompletion$13$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon15#1;

  inline$BDLSystemPowerIoCompletion$13$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_71#1;

  inline$BDLSystemPowerIoCompletion$13$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$13$anon44_Then#1, inline$BDLSystemPowerIoCompletion$13$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon17#1;

  inline$BDLSystemPowerIoCompletion$13$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_74#1;

  inline$BDLSystemPowerIoCompletion$13$label_74#1:
    goto inline$storm_IoCompleteRequest$28$Entry#1;

  inline$storm_IoCompleteRequest$28$Entry#1:
    inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$13$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$28$start#1;

  inline$storm_IoCompleteRequest$28$start#1:
    inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$28$label_3#1;

  inline$storm_IoCompleteRequest$28$label_3#1:
    call inline$storm_IoCompleteRequest$28$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$28$label_6#1;

  inline$storm_IoCompleteRequest$28$label_6#1:
    goto inline$storm_IoCompleteRequest$28$label_6_true#1, inline$storm_IoCompleteRequest$28$label_6_false#1;

  inline$storm_IoCompleteRequest$28$label_6_false#1:
    assume inline$storm_IoCompleteRequest$28$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$28$label_7#1;

  inline$storm_IoCompleteRequest$28$label_6_true#1:
    assume inline$storm_IoCompleteRequest$28$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$28$label_8#1;

  inline$storm_IoCompleteRequest$28$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$28$anon3_Then#1, inline$storm_IoCompleteRequest$28$anon3_Else#1;

  inline$storm_IoCompleteRequest$28$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$28$anon1#1;

  inline$storm_IoCompleteRequest$28$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$28$label_9#1;

  inline$storm_IoCompleteRequest$28$label_9#1:
    goto inline$storm_IoCompleteRequest$28$label_9_true#1, inline$storm_IoCompleteRequest$28$label_9_false#1;

  inline$storm_IoCompleteRequest$28$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$28$label_10#1;

  inline$storm_IoCompleteRequest$28$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$28$label_1#1;

  inline$storm_IoCompleteRequest$28$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$28$label_7#1;

  inline$storm_IoCompleteRequest$28$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$28$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$28$label_1#1;

  inline$storm_IoCompleteRequest$28$label_1#1:
    goto inline$storm_IoCompleteRequest$28$Return#1;

  inline$storm_IoCompleteRequest$28$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$28$Return#1;

  inline$storm_IoCompleteRequest$28$Return#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon45_Then#1, inline$BDLSystemPowerIoCompletion$13$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon19#1;

  inline$BDLSystemPowerIoCompletion$13$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_77#1;

  inline$BDLSystemPowerIoCompletion$13$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$13$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$13$anon46_Then#1, inline$BDLSystemPowerIoCompletion$13$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon21#1;

  inline$BDLSystemPowerIoCompletion$13$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_80#1;

  inline$BDLSystemPowerIoCompletion$13$label_80#1:
    goto inline$BDLGetDebugLevel$364$Entry#1;

  inline$BDLGetDebugLevel$364$Entry#1:
    goto inline$BDLGetDebugLevel$364$start#1;

  inline$BDLGetDebugLevel$364$start#1:
    goto inline$BDLGetDebugLevel$364$label_3#1;

  inline$BDLGetDebugLevel$364$label_3#1:
    havoc inline$BDLGetDebugLevel$364$myNondetVar_0;
    inline$BDLGetDebugLevel$364$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$364$myNondetVar_0;
    goto inline$BDLGetDebugLevel$364$label_1#1;

  inline$BDLGetDebugLevel$364$label_1#1:
    goto inline$BDLGetDebugLevel$364$Return#1;

  inline$BDLGetDebugLevel$364$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$364$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon47_Then#1, inline$BDLSystemPowerIoCompletion$13$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon23#1;

  inline$BDLSystemPowerIoCompletion$13$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_83#1;

  inline$BDLSystemPowerIoCompletion$13$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_83_true#1, inline$BDLSystemPowerIoCompletion$13$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_84#1;

  inline$BDLSystemPowerIoCompletion$13$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_87#1;

  inline$BDLSystemPowerIoCompletion$13$label_87#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_88#1;

  inline$BDLSystemPowerIoCompletion$13$label_88#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_89#1;

  inline$BDLSystemPowerIoCompletion$13$label_89#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_90#1;

  inline$BDLSystemPowerIoCompletion$13$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$13$label_84#1;

  inline$BDLSystemPowerIoCompletion$13$label_84#1:
    goto inline$BDLGetDebugLevel$365$Entry#1;

  inline$BDLGetDebugLevel$365$Entry#1:
    goto inline$BDLGetDebugLevel$365$start#1;

  inline$BDLGetDebugLevel$365$start#1:
    goto inline$BDLGetDebugLevel$365$label_3#1;

  inline$BDLGetDebugLevel$365$label_3#1:
    havoc inline$BDLGetDebugLevel$365$myNondetVar_0;
    inline$BDLGetDebugLevel$365$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$365$myNondetVar_0;
    goto inline$BDLGetDebugLevel$365$label_1#1;

  inline$BDLGetDebugLevel$365$label_1#1:
    goto inline$BDLGetDebugLevel$365$Return#1;

  inline$BDLGetDebugLevel$365$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$365$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon48_Then#1, inline$BDLSystemPowerIoCompletion$13$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon25#1;

  inline$BDLSystemPowerIoCompletion$13$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_93#1;

  inline$BDLSystemPowerIoCompletion$13$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_93_true#1, inline$BDLSystemPowerIoCompletion$13$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_94#1;

  inline$BDLSystemPowerIoCompletion$13$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_97#1;

  inline$BDLSystemPowerIoCompletion$13$label_97#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_98#1;

  inline$BDLSystemPowerIoCompletion$13$label_98#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_99#1;

  inline$BDLSystemPowerIoCompletion$13$label_99#1:
    call inline$BDLSystemPowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$13$label_100#1;

  inline$BDLSystemPowerIoCompletion$13$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$13$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$13$label_94#1;

  inline$BDLSystemPowerIoCompletion$13$label_94#1:
    goto inline$BDLGetDebugLevel$366$Entry#1;

  inline$BDLGetDebugLevel$366$Entry#1:
    goto inline$BDLGetDebugLevel$366$start#1;

  inline$BDLGetDebugLevel$366$start#1:
    goto inline$BDLGetDebugLevel$366$label_3#1;

  inline$BDLGetDebugLevel$366$label_3#1:
    havoc inline$BDLGetDebugLevel$366$myNondetVar_0;
    inline$BDLGetDebugLevel$366$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$366$myNondetVar_0;
    goto inline$BDLGetDebugLevel$366$label_1#1;

  inline$BDLGetDebugLevel$366$label_1#1:
    goto inline$BDLGetDebugLevel$366$Return#1;

  inline$BDLGetDebugLevel$366$Return#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$366$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$13$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$13$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$13$anon49_Then#1, inline$BDLSystemPowerIoCompletion$13$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$13$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$anon27#1;

  inline$BDLSystemPowerIoCompletion$13$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_103#1;

  inline$BDLSystemPowerIoCompletion$13$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_103_true#1, inline$BDLSystemPowerIoCompletion$13$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$13$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_104#1;

  inline$BDLSystemPowerIoCompletion$13$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$13$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$13$label_105#1;

  inline$BDLSystemPowerIoCompletion$13$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$13$label_104#1;

  inline$BDLSystemPowerIoCompletion$13$label_104#1:
    inline$BDLSystemPowerIoCompletion$13$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$13$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$13$label_1#1;

  inline$BDLSystemPowerIoCompletion$13$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$13$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$13$Return#1;

  inline$BDLSystemPowerIoCompletion$13$Return#1:
    inline$CallCompletionRoutine$13$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$13$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$13$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$13$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$13$anon14_Then#1, inline$CallCompletionRoutine$13$anon14_Else#1;

  inline$CallCompletionRoutine$13$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$13$anon9#1;

  inline$CallCompletionRoutine$13$anon9#1:
    goto inline$CallCompletionRoutine$13$label_20_icall_return#1;

  inline$CallCompletionRoutine$13$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$13$Return#1;

  inline$CallCompletionRoutine$13$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$13$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$13$Entry#1;

  inline$BDLDevicePowerIoCompletion$13$Entry#1:
    inline$BDLDevicePowerIoCompletion$13$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$13$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$13$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$13$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$13$start#1;

  inline$BDLDevicePowerIoCompletion$13$start#1:
    call inline$BDLDevicePowerIoCompletion$13$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$13$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$13$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$13$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$13$label_3#1;

  inline$BDLDevicePowerIoCompletion$13$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_4#1;

  inline$BDLDevicePowerIoCompletion$13$label_4#1:
    inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_5#1;

  inline$BDLDevicePowerIoCompletion$13$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_6#1;

  inline$BDLDevicePowerIoCompletion$13$label_6#1:
    inline$BDLDevicePowerIoCompletion$13$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$13$label_7#1;

  inline$BDLDevicePowerIoCompletion$13$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_8#1;

  inline$BDLDevicePowerIoCompletion$13$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$13$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$13$label_9#1;

  inline$BDLDevicePowerIoCompletion$13$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_10#1;

  inline$BDLDevicePowerIoCompletion$13$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$70$Entry#1;

  inline$IoGetCurrentIrpStackLocation$70$Entry#1:
    inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$70$start#1;

  inline$IoGetCurrentIrpStackLocation$70$start#1:
    inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$70$label_3#1;

  inline$IoGetCurrentIrpStackLocation$70$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$70$label_3_true#1, inline$IoGetCurrentIrpStackLocation$70$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$70$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$70$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$70$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$70$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$70$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$70$label_4#1;

  inline$IoGetCurrentIrpStackLocation$70$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$70$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$70$label_6#1;

  inline$IoGetCurrentIrpStackLocation$70$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$70$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$70$label_7#1;

  inline$IoGetCurrentIrpStackLocation$70$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$70$label_5#1;

  inline$IoGetCurrentIrpStackLocation$70$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$70$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$70$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$70$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$70$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$70$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$70$label_5#1;

  inline$IoGetCurrentIrpStackLocation$70$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$70$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$70$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$70$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$70$label_1#1;

  inline$IoGetCurrentIrpStackLocation$70$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$70$Return#1;

  inline$IoGetCurrentIrpStackLocation$70$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$70$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon30_Then#1, inline$BDLDevicePowerIoCompletion$13$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon1#1;

  inline$BDLDevicePowerIoCompletion$13$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_13#1;

  inline$BDLDevicePowerIoCompletion$13$label_13#1:
    inline$BDLDevicePowerIoCompletion$13$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$13$label_14#1;

  inline$BDLDevicePowerIoCompletion$13$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_15#1;

  inline$BDLDevicePowerIoCompletion$13$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$13$label_16#1;

  inline$BDLDevicePowerIoCompletion$13$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_17#1;

  inline$BDLDevicePowerIoCompletion$13$label_17#1:
    goto inline$BDLGetDebugLevel$349$Entry#1;

  inline$BDLGetDebugLevel$349$Entry#1:
    goto inline$BDLGetDebugLevel$349$start#1;

  inline$BDLGetDebugLevel$349$start#1:
    goto inline$BDLGetDebugLevel$349$label_3#1;

  inline$BDLGetDebugLevel$349$label_3#1:
    havoc inline$BDLGetDebugLevel$349$myNondetVar_0;
    inline$BDLGetDebugLevel$349$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$349$myNondetVar_0;
    goto inline$BDLGetDebugLevel$349$label_1#1;

  inline$BDLGetDebugLevel$349$label_1#1:
    goto inline$BDLGetDebugLevel$349$Return#1;

  inline$BDLGetDebugLevel$349$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$349$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon31_Then#1, inline$BDLDevicePowerIoCompletion$13$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon3#1;

  inline$BDLDevicePowerIoCompletion$13$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_20#1;

  inline$BDLDevicePowerIoCompletion$13$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_20_true#1, inline$BDLDevicePowerIoCompletion$13$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_21#1;

  inline$BDLDevicePowerIoCompletion$13$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_24#1;

  inline$BDLDevicePowerIoCompletion$13$label_24#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_25#1;

  inline$BDLDevicePowerIoCompletion$13$label_25#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_26#1;

  inline$BDLDevicePowerIoCompletion$13$label_26#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_27#1;

  inline$BDLDevicePowerIoCompletion$13$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$13$label_21#1;

  inline$BDLDevicePowerIoCompletion$13$label_21#1:
    goto inline$BDLGetDebugLevel$350$Entry#1;

  inline$BDLGetDebugLevel$350$Entry#1:
    goto inline$BDLGetDebugLevel$350$start#1;

  inline$BDLGetDebugLevel$350$start#1:
    goto inline$BDLGetDebugLevel$350$label_3#1;

  inline$BDLGetDebugLevel$350$label_3#1:
    havoc inline$BDLGetDebugLevel$350$myNondetVar_0;
    inline$BDLGetDebugLevel$350$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$350$myNondetVar_0;
    goto inline$BDLGetDebugLevel$350$label_1#1;

  inline$BDLGetDebugLevel$350$label_1#1:
    goto inline$BDLGetDebugLevel$350$Return#1;

  inline$BDLGetDebugLevel$350$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$350$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon32_Then#1, inline$BDLDevicePowerIoCompletion$13$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon5#1;

  inline$BDLDevicePowerIoCompletion$13$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_30#1;

  inline$BDLDevicePowerIoCompletion$13$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_30_true#1, inline$BDLDevicePowerIoCompletion$13$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_31#1;

  inline$BDLDevicePowerIoCompletion$13$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_34#1;

  inline$BDLDevicePowerIoCompletion$13$label_34#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_35#1;

  inline$BDLDevicePowerIoCompletion$13$label_35#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_36#1;

  inline$BDLDevicePowerIoCompletion$13$label_36#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_37#1;

  inline$BDLDevicePowerIoCompletion$13$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$13$label_31#1;

  inline$BDLDevicePowerIoCompletion$13$label_31#1:
    goto inline$BDLGetDebugLevel$351$Entry#1;

  inline$BDLGetDebugLevel$351$Entry#1:
    goto inline$BDLGetDebugLevel$351$start#1;

  inline$BDLGetDebugLevel$351$start#1:
    goto inline$BDLGetDebugLevel$351$label_3#1;

  inline$BDLGetDebugLevel$351$label_3#1:
    havoc inline$BDLGetDebugLevel$351$myNondetVar_0;
    inline$BDLGetDebugLevel$351$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$351$myNondetVar_0;
    goto inline$BDLGetDebugLevel$351$label_1#1;

  inline$BDLGetDebugLevel$351$label_1#1:
    goto inline$BDLGetDebugLevel$351$Return#1;

  inline$BDLGetDebugLevel$351$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$351$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon33_Then#1, inline$BDLDevicePowerIoCompletion$13$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon7#1;

  inline$BDLDevicePowerIoCompletion$13$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_40#1;

  inline$BDLDevicePowerIoCompletion$13$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_40_true#1, inline$BDLDevicePowerIoCompletion$13$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_41#1;

  inline$BDLDevicePowerIoCompletion$13$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_42#1;

  inline$BDLDevicePowerIoCompletion$13$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_41#1;

  inline$BDLDevicePowerIoCompletion$13$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_41_true#1, inline$BDLDevicePowerIoCompletion$13$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$13$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$13$label_43#1;

  inline$BDLDevicePowerIoCompletion$13$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$13$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$13$label_44#1;

  inline$BDLDevicePowerIoCompletion$13$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_44_true#1, inline$BDLDevicePowerIoCompletion$13$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$13$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$13$label_45#1;

  inline$BDLDevicePowerIoCompletion$13$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_45_true#1, inline$BDLDevicePowerIoCompletion$13$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$13$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$13$label_43#1;

  inline$BDLDevicePowerIoCompletion$13$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$13$label_86#1;

  inline$BDLDevicePowerIoCompletion$13$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$13$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$13$label_46#1;

  inline$BDLDevicePowerIoCompletion$13$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$13$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$13$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$13$label_46#1;

  inline$BDLDevicePowerIoCompletion$13$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$13$label_49#1;

  inline$BDLDevicePowerIoCompletion$13$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_50#1;

  inline$BDLDevicePowerIoCompletion$13$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_51#1;

  inline$BDLDevicePowerIoCompletion$13$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_54#1;

  inline$BDLDevicePowerIoCompletion$13$label_54#1:
    inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$13$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$13$label_55#1;

  inline$BDLDevicePowerIoCompletion$13$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_55_true#1, inline$BDLDevicePowerIoCompletion$13$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_56#1;

  inline$BDLDevicePowerIoCompletion$13$label_56#1:
    call inline$BDLDevicePowerIoCompletion$13$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$13$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$13$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$13$anon34_Then#1, inline$BDLDevicePowerIoCompletion$13$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon9#1;

  inline$BDLDevicePowerIoCompletion$13$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_83#1;

  inline$BDLDevicePowerIoCompletion$13$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_59#1;

  inline$BDLDevicePowerIoCompletion$13$label_59#1:
    goto inline$BDLGetDebugLevel$352$Entry#1;

  inline$BDLGetDebugLevel$352$Entry#1:
    goto inline$BDLGetDebugLevel$352$start#1;

  inline$BDLGetDebugLevel$352$start#1:
    goto inline$BDLGetDebugLevel$352$label_3#1;

  inline$BDLGetDebugLevel$352$label_3#1:
    havoc inline$BDLGetDebugLevel$352$myNondetVar_0;
    inline$BDLGetDebugLevel$352$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$352$myNondetVar_0;
    goto inline$BDLGetDebugLevel$352$label_1#1;

  inline$BDLGetDebugLevel$352$label_1#1:
    goto inline$BDLGetDebugLevel$352$Return#1;

  inline$BDLGetDebugLevel$352$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$352$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon35_Then#1, inline$BDLDevicePowerIoCompletion$13$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon11#1;

  inline$BDLDevicePowerIoCompletion$13$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_62#1;

  inline$BDLDevicePowerIoCompletion$13$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_62_true#1, inline$BDLDevicePowerIoCompletion$13$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_63#1;

  inline$BDLDevicePowerIoCompletion$13$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_66#1;

  inline$BDLDevicePowerIoCompletion$13$label_66#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_67#1;

  inline$BDLDevicePowerIoCompletion$13$label_67#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_68#1;

  inline$BDLDevicePowerIoCompletion$13$label_68#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_69#1;

  inline$BDLDevicePowerIoCompletion$13$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$13$label_63#1;

  inline$BDLDevicePowerIoCompletion$13$label_63#1:
    goto inline$BDLGetDebugLevel$353$Entry#1;

  inline$BDLGetDebugLevel$353$Entry#1:
    goto inline$BDLGetDebugLevel$353$start#1;

  inline$BDLGetDebugLevel$353$start#1:
    goto inline$BDLGetDebugLevel$353$label_3#1;

  inline$BDLGetDebugLevel$353$label_3#1:
    havoc inline$BDLGetDebugLevel$353$myNondetVar_0;
    inline$BDLGetDebugLevel$353$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$353$myNondetVar_0;
    goto inline$BDLGetDebugLevel$353$label_1#1;

  inline$BDLGetDebugLevel$353$label_1#1:
    goto inline$BDLGetDebugLevel$353$Return#1;

  inline$BDLGetDebugLevel$353$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$353$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon36_Then#1, inline$BDLDevicePowerIoCompletion$13$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon13#1;

  inline$BDLDevicePowerIoCompletion$13$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_72#1;

  inline$BDLDevicePowerIoCompletion$13$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_72_true#1, inline$BDLDevicePowerIoCompletion$13$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_73#1;

  inline$BDLDevicePowerIoCompletion$13$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_76#1;

  inline$BDLDevicePowerIoCompletion$13$label_76#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_77#1;

  inline$BDLDevicePowerIoCompletion$13$label_77#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_78#1;

  inline$BDLDevicePowerIoCompletion$13$label_78#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_79#1;

  inline$BDLDevicePowerIoCompletion$13$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$13$label_73#1;

  inline$BDLDevicePowerIoCompletion$13$label_73#1:
    goto inline$BDLGetDebugLevel$354$Entry#1;

  inline$BDLGetDebugLevel$354$Entry#1:
    goto inline$BDLGetDebugLevel$354$start#1;

  inline$BDLGetDebugLevel$354$start#1:
    goto inline$BDLGetDebugLevel$354$label_3#1;

  inline$BDLGetDebugLevel$354$label_3#1:
    havoc inline$BDLGetDebugLevel$354$myNondetVar_0;
    inline$BDLGetDebugLevel$354$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$354$myNondetVar_0;
    goto inline$BDLGetDebugLevel$354$label_1#1;

  inline$BDLGetDebugLevel$354$label_1#1:
    goto inline$BDLGetDebugLevel$354$Return#1;

  inline$BDLGetDebugLevel$354$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$354$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon37_Then#1, inline$BDLDevicePowerIoCompletion$13$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon15#1;

  inline$BDLDevicePowerIoCompletion$13$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_82#1;

  inline$BDLDevicePowerIoCompletion$13$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_82_true#1, inline$BDLDevicePowerIoCompletion$13$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_83#1;

  inline$BDLDevicePowerIoCompletion$13$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_84#1;

  inline$BDLDevicePowerIoCompletion$13$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_83#1;

  inline$BDLDevicePowerIoCompletion$13$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_85#1;

  inline$BDLDevicePowerIoCompletion$13$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_86#1;

  inline$BDLDevicePowerIoCompletion$13$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$13$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$13$anon38_Then#1, inline$BDLDevicePowerIoCompletion$13$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon17#1;

  inline$BDLDevicePowerIoCompletion$13$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_89#1;

  inline$BDLDevicePowerIoCompletion$13$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$13$anon39_Then#1, inline$BDLDevicePowerIoCompletion$13$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon19#1;

  inline$BDLDevicePowerIoCompletion$13$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_92#1;

  inline$BDLDevicePowerIoCompletion$13$label_92#1:
    goto inline$storm_IoCompleteRequest$27$Entry#1;

  inline$storm_IoCompleteRequest$27$Entry#1:
    inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$13$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$27$start#1;

  inline$storm_IoCompleteRequest$27$start#1:
    inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$27$label_3#1;

  inline$storm_IoCompleteRequest$27$label_3#1:
    call inline$storm_IoCompleteRequest$27$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$27$label_6#1;

  inline$storm_IoCompleteRequest$27$label_6#1:
    goto inline$storm_IoCompleteRequest$27$label_6_true#1, inline$storm_IoCompleteRequest$27$label_6_false#1;

  inline$storm_IoCompleteRequest$27$label_6_false#1:
    assume inline$storm_IoCompleteRequest$27$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$27$label_7#1;

  inline$storm_IoCompleteRequest$27$label_6_true#1:
    assume inline$storm_IoCompleteRequest$27$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$27$label_8#1;

  inline$storm_IoCompleteRequest$27$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$27$anon3_Then#1, inline$storm_IoCompleteRequest$27$anon3_Else#1;

  inline$storm_IoCompleteRequest$27$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$27$anon1#1;

  inline$storm_IoCompleteRequest$27$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$27$label_9#1;

  inline$storm_IoCompleteRequest$27$label_9#1:
    goto inline$storm_IoCompleteRequest$27$label_9_true#1, inline$storm_IoCompleteRequest$27$label_9_false#1;

  inline$storm_IoCompleteRequest$27$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$27$label_10#1;

  inline$storm_IoCompleteRequest$27$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$27$label_1#1;

  inline$storm_IoCompleteRequest$27$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$27$label_7#1;

  inline$storm_IoCompleteRequest$27$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$27$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$27$label_1#1;

  inline$storm_IoCompleteRequest$27$label_1#1:
    goto inline$storm_IoCompleteRequest$27$Return#1;

  inline$storm_IoCompleteRequest$27$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$27$Return#1;

  inline$storm_IoCompleteRequest$27$Return#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon40_Then#1, inline$BDLDevicePowerIoCompletion$13$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon21#1;

  inline$BDLDevicePowerIoCompletion$13$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_95#1;

  inline$BDLDevicePowerIoCompletion$13$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$13$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$13$anon41_Then#1, inline$BDLDevicePowerIoCompletion$13$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon23#1;

  inline$BDLDevicePowerIoCompletion$13$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_98#1;

  inline$BDLDevicePowerIoCompletion$13$label_98#1:
    goto inline$BDLGetDebugLevel$355$Entry#1;

  inline$BDLGetDebugLevel$355$Entry#1:
    goto inline$BDLGetDebugLevel$355$start#1;

  inline$BDLGetDebugLevel$355$start#1:
    goto inline$BDLGetDebugLevel$355$label_3#1;

  inline$BDLGetDebugLevel$355$label_3#1:
    havoc inline$BDLGetDebugLevel$355$myNondetVar_0;
    inline$BDLGetDebugLevel$355$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$355$myNondetVar_0;
    goto inline$BDLGetDebugLevel$355$label_1#1;

  inline$BDLGetDebugLevel$355$label_1#1:
    goto inline$BDLGetDebugLevel$355$Return#1;

  inline$BDLGetDebugLevel$355$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$355$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon42_Then#1, inline$BDLDevicePowerIoCompletion$13$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon25#1;

  inline$BDLDevicePowerIoCompletion$13$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_101#1;

  inline$BDLDevicePowerIoCompletion$13$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_101_true#1, inline$BDLDevicePowerIoCompletion$13$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_102#1;

  inline$BDLDevicePowerIoCompletion$13$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_105#1;

  inline$BDLDevicePowerIoCompletion$13$label_105#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_106#1;

  inline$BDLDevicePowerIoCompletion$13$label_106#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_107#1;

  inline$BDLDevicePowerIoCompletion$13$label_107#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_108#1;

  inline$BDLDevicePowerIoCompletion$13$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$13$label_102#1;

  inline$BDLDevicePowerIoCompletion$13$label_102#1:
    goto inline$BDLGetDebugLevel$356$Entry#1;

  inline$BDLGetDebugLevel$356$Entry#1:
    goto inline$BDLGetDebugLevel$356$start#1;

  inline$BDLGetDebugLevel$356$start#1:
    goto inline$BDLGetDebugLevel$356$label_3#1;

  inline$BDLGetDebugLevel$356$label_3#1:
    havoc inline$BDLGetDebugLevel$356$myNondetVar_0;
    inline$BDLGetDebugLevel$356$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$356$myNondetVar_0;
    goto inline$BDLGetDebugLevel$356$label_1#1;

  inline$BDLGetDebugLevel$356$label_1#1:
    goto inline$BDLGetDebugLevel$356$Return#1;

  inline$BDLGetDebugLevel$356$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$356$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon43_Then#1, inline$BDLDevicePowerIoCompletion$13$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon27#1;

  inline$BDLDevicePowerIoCompletion$13$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_111#1;

  inline$BDLDevicePowerIoCompletion$13$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_111_true#1, inline$BDLDevicePowerIoCompletion$13$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_112#1;

  inline$BDLDevicePowerIoCompletion$13$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_115#1;

  inline$BDLDevicePowerIoCompletion$13$label_115#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_116#1;

  inline$BDLDevicePowerIoCompletion$13$label_116#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_117#1;

  inline$BDLDevicePowerIoCompletion$13$label_117#1:
    call inline$BDLDevicePowerIoCompletion$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$13$label_118#1;

  inline$BDLDevicePowerIoCompletion$13$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$13$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$13$label_112#1;

  inline$BDLDevicePowerIoCompletion$13$label_112#1:
    goto inline$BDLGetDebugLevel$357$Entry#1;

  inline$BDLGetDebugLevel$357$Entry#1:
    goto inline$BDLGetDebugLevel$357$start#1;

  inline$BDLGetDebugLevel$357$start#1:
    goto inline$BDLGetDebugLevel$357$label_3#1;

  inline$BDLGetDebugLevel$357$label_3#1:
    havoc inline$BDLGetDebugLevel$357$myNondetVar_0;
    inline$BDLGetDebugLevel$357$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$357$myNondetVar_0;
    goto inline$BDLGetDebugLevel$357$label_1#1;

  inline$BDLGetDebugLevel$357$label_1#1:
    goto inline$BDLGetDebugLevel$357$Return#1;

  inline$BDLGetDebugLevel$357$Return#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$357$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$13$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$13$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$13$anon44_Then#1, inline$BDLDevicePowerIoCompletion$13$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$13$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$anon29#1;

  inline$BDLDevicePowerIoCompletion$13$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_121#1;

  inline$BDLDevicePowerIoCompletion$13$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_121_true#1, inline$BDLDevicePowerIoCompletion$13$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$13$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_122#1;

  inline$BDLDevicePowerIoCompletion$13$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$13$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$13$label_123#1;

  inline$BDLDevicePowerIoCompletion$13$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$13$label_122#1;

  inline$BDLDevicePowerIoCompletion$13$label_122#1:
    inline$BDLDevicePowerIoCompletion$13$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$13$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$13$label_1#1;

  inline$BDLDevicePowerIoCompletion$13$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$13$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$13$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$13$Return#1;

  inline$BDLDevicePowerIoCompletion$13$Return#1:
    inline$CallCompletionRoutine$13$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$13$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$13$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$13$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$13$anon13_Then#1, inline$CallCompletionRoutine$13$anon13_Else#1;

  inline$CallCompletionRoutine$13$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$13$anon7#1;

  inline$CallCompletionRoutine$13$anon7#1:
    goto inline$CallCompletionRoutine$13$label_20_icall_return#1;

  inline$CallCompletionRoutine$13$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$13$Return#1;

  inline$CallCompletionRoutine$13$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$13$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$13$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$13$Entry#1;

  inline$BDLCallDriverCompletionRoutine$13$Entry#1:
    inline$BDLCallDriverCompletionRoutine$13$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$13$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$13$start#1;

  inline$BDLCallDriverCompletionRoutine$13$start#1:
    inline$BDLCallDriverCompletionRoutine$13$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$13$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$13$label_3#1;

  inline$BDLCallDriverCompletionRoutine$13$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$13$label_3_true#1, inline$BDLCallDriverCompletionRoutine$13$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$13$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$13$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$13$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$13$label_4#1;

  inline$BDLCallDriverCompletionRoutine$13$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$13$label_6#1;

  inline$BDLCallDriverCompletionRoutine$13$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$13$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$13$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$13$label_5#1;

  inline$BDLCallDriverCompletionRoutine$13$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$13$label_6#1;

  inline$BDLCallDriverCompletionRoutine$13$label_6#1:
    goto inline$storm_KeSetEvent$15$Entry#1;

  inline$storm_KeSetEvent$15$Entry#1:
    inline$storm_KeSetEvent$15$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$13$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$15$start#1;

  inline$storm_KeSetEvent$15$start#1:
    inline$storm_KeSetEvent$15$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$15$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$15$label_3#1;

  inline$storm_KeSetEvent$15$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$15$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$15$label_1#1;

  inline$storm_KeSetEvent$15$label_1#1:
    goto inline$storm_KeSetEvent$15$Return#1;

  inline$storm_KeSetEvent$15$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$13$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$13$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$13$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$13$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$13$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$13$anon1#1;

  inline$BDLCallDriverCompletionRoutine$13$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$13$label_9#1;

  inline$BDLCallDriverCompletionRoutine$13$label_9#1:
    inline$BDLCallDriverCompletionRoutine$13$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$13$label_1#1;

  inline$BDLCallDriverCompletionRoutine$13$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$13$Return#1;

  inline$BDLCallDriverCompletionRoutine$13$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$13$Return#1;

  inline$BDLCallDriverCompletionRoutine$13$Return#1:
    inline$CallCompletionRoutine$13$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$13$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$13$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$13$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$13$anon12_Then#1, inline$CallCompletionRoutine$13$anon12_Else#1;

  inline$CallCompletionRoutine$13$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$13$anon5#1;

  inline$CallCompletionRoutine$13$anon5#1:
    goto inline$CallCompletionRoutine$13$label_20_icall_return#1;

  inline$CallCompletionRoutine$13$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$13$label_23#1;

  inline$CallCompletionRoutine$13$label_23#1:
    inline$CallCompletionRoutine$13$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$13$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$13$label_24#1;

  inline$CallCompletionRoutine$13$label_24#1:
    goto inline$CallCompletionRoutine$13$label_24_true#1, inline$CallCompletionRoutine$13$label_24_false#1;

  inline$CallCompletionRoutine$13$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$13$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$13$label_1#1;

  inline$CallCompletionRoutine$13$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$13$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$13$label_25#1;

  inline$CallCompletionRoutine$13$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$13$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$13$label_1#1;

  inline$CallCompletionRoutine$13$label_1#1:
    goto inline$CallCompletionRoutine$13$Return#1;

  inline$CallCompletionRoutine$13$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$13$Return#1;

  inline$CallCompletionRoutine$13$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$13$Return#1;

  inline$CallCompletionRoutine$13$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$13$Return#1;

  inline$CallCompletionRoutine$13$Return#1:
    goto inline$storm_IoCallDriver$6$label_39$1#1;

  inline$storm_IoCallDriver$6$label_39$1#1:
    goto inline$storm_IoCallDriver$6$anon15_Then#1, inline$storm_IoCallDriver$6$anon15_Else#1;

  inline$storm_IoCallDriver$6$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$6$anon10#1;

  inline$storm_IoCallDriver$6$anon10#1:
    goto inline$storm_IoCallDriver$6$label_36#1;

  inline$storm_IoCallDriver$6$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$6$Return#1;

  inline$storm_IoCallDriver$6$label_27_case_0#1:
    assume inline$storm_IoCallDriver$6$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$6$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$6$label_28#1;

  inline$storm_IoCallDriver$6$label_28#1:
    inline$storm_IoCallDriver$6$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$6$label_42#1;

  inline$storm_IoCallDriver$6$label_42#1:
    goto inline$storm_IoCallDriver$6$label_43#1;

  inline$storm_IoCallDriver$6$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$6$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$6$label_36#1;

  inline$storm_IoCallDriver$6$label_36#1:
    inline$storm_IoCallDriver$6$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$6$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$6$label_1#1;

  inline$storm_IoCallDriver$6$label_1#1:
    goto inline$storm_IoCallDriver$6$Return#1;

  inline$storm_IoCallDriver$6$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$6$Return#1;

  inline$storm_IoCallDriver$6$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$6$Return#1;

  inline$storm_IoCallDriver$6$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$6$Return#1;

  inline$storm_IoCallDriver$6$Return#1:
    inline$storm_PoCallDriver$2$$result.storm_IoCallDriver$499.27$2$ := inline$storm_IoCallDriver$6$$result.storm_IoCallDriver$456.0$1$;
    goto inline$storm_PoCallDriver$2$label_3$1#1;

  inline$storm_PoCallDriver$2$label_3$1#1:
    goto inline$storm_PoCallDriver$2$anon2_Then#1, inline$storm_PoCallDriver$2$anon2_Else#1;

  inline$storm_PoCallDriver$2$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_PoCallDriver$2$anon1#1;

  inline$storm_PoCallDriver$2$anon1#1:
    goto inline$storm_PoCallDriver$2$label_6#1;

  inline$storm_PoCallDriver$2$label_6#1:
    inline$storm_PoCallDriver$2$$result.storm_PoCallDriver$494.0$1$ := inline$storm_PoCallDriver$2$$result.storm_IoCallDriver$499.27$2$;
    goto inline$storm_PoCallDriver$2$label_1#1;

  inline$storm_PoCallDriver$2$label_1#1:
    goto inline$storm_PoCallDriver$2$Return#1;

  inline$storm_PoCallDriver$2$anon2_Then#1:
    assume raiseException;
    goto inline$storm_PoCallDriver$2$Return#1;

  inline$storm_PoCallDriver$2$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_PoCallDriver$104.29$3$ := inline$storm_PoCallDriver$2$$result.storm_PoCallDriver$494.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_25$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_25$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon22_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon22_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon13#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon13#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_28#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_28#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_PoCallDriver$104.29$3$;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_29_true#1, inline$BDLCallLowerLevelDriverAndWait$2$label_29_false#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_29_false#1:
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_29_true#1:
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_31#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_31#1:
    goto inline$storm_KeWaitForSingleObject$2$Entry#1;

  inline$storm_KeWaitForSingleObject$2$Entry#1:
    inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1 := inline$BDLCallLowerLevelDriverAndWait$2$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1 := 0;
    goto inline$storm_KeWaitForSingleObject$2$start#1;

  inline$storm_KeWaitForSingleObject$2$start#1:
    inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1;
    inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1;
    goto inline$storm_KeWaitForSingleObject$2$label_3#1;

  inline$storm_KeWaitForSingleObject$2$label_3#1:
    goto inline$storm_KeWaitForSingleObject$2$label_3_true#1, inline$storm_KeWaitForSingleObject$2$label_3_false#1;

  inline$storm_KeWaitForSingleObject$2$label_3_false#1:
    assume inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 == 0;
    goto inline$storm_KeWaitForSingleObject$2$label_4#1;

  inline$storm_KeWaitForSingleObject$2$label_4#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$2$anon6_Then#1, inline$storm_KeWaitForSingleObject$2$anon6_Else#1;

  inline$storm_KeWaitForSingleObject$2$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$2$anon1#1;

  inline$storm_KeWaitForSingleObject$2$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$2$label_13#1;

  inline$storm_KeWaitForSingleObject$2$label_13#1:
    inline$storm_KeWaitForSingleObject$2$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$2$label_1#1;

  inline$storm_KeWaitForSingleObject$2$anon6_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$2$Return#1;

  inline$storm_KeWaitForSingleObject$2$label_3_true#1:
    assume inline$storm_KeWaitForSingleObject$2$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 != 0;
    goto inline$storm_KeWaitForSingleObject$2$label_5#1;

  inline$storm_KeWaitForSingleObject$2$label_5#1:
    call inline$storm_KeWaitForSingleObject$2$$result.storm_nondet$256.20$2$ := storm_nondet();
    goto inline$storm_KeWaitForSingleObject$2$label_8#1;

  inline$storm_KeWaitForSingleObject$2$label_8#1:
    goto inline$storm_KeWaitForSingleObject$2$label_8_true#1, inline$storm_KeWaitForSingleObject$2$label_8_false#1;

  inline$storm_KeWaitForSingleObject$2$label_8_false#1:
    assume inline$storm_KeWaitForSingleObject$2$$result.storm_nondet$256.20$2$ == 0;
    goto inline$storm_KeWaitForSingleObject$2$label_9#1;

  inline$storm_KeWaitForSingleObject$2$label_9#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$2$anon7_Then#1, inline$storm_KeWaitForSingleObject$2$anon7_Else#1;

  inline$storm_KeWaitForSingleObject$2$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$2$anon3#1;

  inline$storm_KeWaitForSingleObject$2$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20], 0);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$2$label_12#1;

  inline$storm_KeWaitForSingleObject$2$label_12#1:
    inline$storm_KeWaitForSingleObject$2$$result.storm_KeWaitForSingleObject$243.0$1$ := 258;
    goto inline$storm_KeWaitForSingleObject$2$label_1#1;

  inline$storm_KeWaitForSingleObject$2$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$2$Return#1;

  inline$storm_KeWaitForSingleObject$2$label_8_true#1:
    assume inline$storm_KeWaitForSingleObject$2$$result.storm_nondet$256.20$2$ != 0;
    goto inline$storm_KeWaitForSingleObject$2$label_10#1;

  inline$storm_KeWaitForSingleObject$2$label_10#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$2$anon8_Then#1, inline$storm_KeWaitForSingleObject$2$anon8_Else#1;

  inline$storm_KeWaitForSingleObject$2$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$2$anon5#1;

  inline$storm_KeWaitForSingleObject$2$anon5#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$2$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$2$label_11#1;

  inline$storm_KeWaitForSingleObject$2$label_11#1:
    inline$storm_KeWaitForSingleObject$2$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$2$label_1#1;

  inline$storm_KeWaitForSingleObject$2$label_1#1:
    goto inline$storm_KeWaitForSingleObject$2$Return#1;

  inline$storm_KeWaitForSingleObject$2$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$2$Return#1;

  inline$storm_KeWaitForSingleObject$2$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_KeWaitForSingleObject$116.38$5$ := inline$storm_KeWaitForSingleObject$2$$result.storm_KeWaitForSingleObject$243.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_31$1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_31$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon23_Then#1, inline$BDLCallLowerLevelDriverAndWait$2$anon23_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$anon15#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon15#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_34#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_34#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$2$$result.storm_KeWaitForSingleObject$116.38$5$;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_35#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_35#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_35_true#1, inline$BDLCallLowerLevelDriverAndWait$2$label_35_false#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_35_false#1:
    assume inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 == 0;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_35_true#1:
    assume inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 != 0;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_37#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_37#1:
    call inline$BDLCallLowerLevelDriverAndWait$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_38#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_38#1:
    call inline$BDLCallLowerLevelDriverAndWait$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_39#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_39#1:
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_36#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0;
    inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$2$myNondetVar_0;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_30#1:
    inline$BDLCallLowerLevelDriverAndWait$2$$result.BDLCallLowerLevelDriverAndWait$71.0$1$ := inline$BDLCallLowerLevelDriverAndWait$2$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8;
    goto inline$BDLCallLowerLevelDriverAndWait$2$label_1#1;

  inline$BDLCallLowerLevelDriverAndWait$2$label_1#1:
    call __HAVOC_free(inline$BDLCallLowerLevelDriverAndWait$2$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon23_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon22_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon21_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$2$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$2$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLCallLowerLevelDriverAndWait$2332.43$13$ := inline$BDLCallLowerLevelDriverAndWait$2$$result.BDLCallLowerLevelDriverAndWait$71.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_29$1#1;

  inline$BDLPnPCancelRemove$0$label_29$1#1:
    goto inline$BDLPnPCancelRemove$0$anon31_Then#1, inline$BDLPnPCancelRemove$0$anon31_Else#1;

  inline$BDLPnPCancelRemove$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon7#1;

  inline$BDLPnPCancelRemove$0$anon7#1:
    goto inline$BDLPnPCancelRemove$0$label_33#1;

  inline$BDLPnPCancelRemove$0$label_33#1:
    inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 := inline$BDLPnPCancelRemove$0$$result.BDLCallLowerLevelDriverAndWait$2332.43$13$;
    goto inline$BDLPnPCancelRemove$0$label_34#1;

  inline$BDLPnPCancelRemove$0$label_34#1:
    goto inline$BDLPnPCancelRemove$0$label_34_true#1, inline$BDLPnPCancelRemove$0$label_34_false#1;

  inline$BDLPnPCancelRemove$0$label_34_false#1:
    assume inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 == 0;
    goto inline$BDLPnPCancelRemove$0$label_35#1;

  inline$BDLPnPCancelRemove$0$label_35#1:
    call inline$BDLPnPCancelRemove$0$$result.IoSetDeviceInterfaceState$2349.38$25$ := IoSetDeviceInterfaceState(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPCancelRemove$0$$pBDLExtension$1$2316.40$BDLPnPCancelRemove$12), 1);
    goto inline$BDLPnPCancelRemove$0$anon32_Then#1, inline$BDLPnPCancelRemove$0$anon32_Else#1;

  inline$BDLPnPCancelRemove$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon9#1;

  inline$BDLPnPCancelRemove$0$anon9#1:
    goto inline$BDLPnPCancelRemove$0$label_89#1;

  inline$BDLPnPCancelRemove$0$label_89#1:
    inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 := inline$BDLPnPCancelRemove$0$$result.IoSetDeviceInterfaceState$2349.38$25$;
    goto inline$BDLPnPCancelRemove$0$label_90#1;

  inline$BDLPnPCancelRemove$0$label_90#1:
    goto inline$BDLPnPCancelRemove$0$label_90_true#1, inline$BDLPnPCancelRemove$0$label_90_false#1;

  inline$BDLPnPCancelRemove$0$label_90_false#1:
    assume inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 == 0;
    goto inline$BDLPnPCancelRemove$0$label_62#1;

  inline$BDLPnPCancelRemove$0$label_90_true#1:
    assume inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 != 0;
    goto inline$BDLPnPCancelRemove$0$label_91#1;

  inline$BDLPnPCancelRemove$0$label_91#1:
    goto inline$BDLGetDebugLevel$376$Entry#1;

  inline$BDLGetDebugLevel$376$Entry#1:
    goto inline$BDLGetDebugLevel$376$start#1;

  inline$BDLGetDebugLevel$376$start#1:
    goto inline$BDLGetDebugLevel$376$label_3#1;

  inline$BDLGetDebugLevel$376$label_3#1:
    havoc inline$BDLGetDebugLevel$376$myNondetVar_0;
    inline$BDLGetDebugLevel$376$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$376$myNondetVar_0;
    goto inline$BDLGetDebugLevel$376$label_1#1;

  inline$BDLGetDebugLevel$376$label_1#1:
    goto inline$BDLGetDebugLevel$376$Return#1;

  inline$BDLGetDebugLevel$376$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$26$ := inline$BDLGetDebugLevel$376$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_91$1#1;

  inline$BDLPnPCancelRemove$0$label_91$1#1:
    goto inline$BDLPnPCancelRemove$0$anon39_Then#1, inline$BDLPnPCancelRemove$0$anon39_Else#1;

  inline$BDLPnPCancelRemove$0$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon23#1;

  inline$BDLPnPCancelRemove$0$anon23#1:
    goto inline$BDLPnPCancelRemove$0$label_94#1;

  inline$BDLPnPCancelRemove$0$label_94#1:
    goto inline$BDLPnPCancelRemove$0$label_94_true#1, inline$BDLPnPCancelRemove$0$label_94_false#1;

  inline$BDLPnPCancelRemove$0$label_94_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$26$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_95#1;

  inline$BDLPnPCancelRemove$0$label_94_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$26$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_98#1;

  inline$BDLPnPCancelRemove$0$label_98#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_99#1;

  inline$BDLPnPCancelRemove$0$label_99#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_100#1;

  inline$BDLPnPCancelRemove$0$label_100#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_101#1;

  inline$BDLPnPCancelRemove$0$label_101#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2353.0$27$;
    goto inline$BDLPnPCancelRemove$0$label_95#1;

  inline$BDLPnPCancelRemove$0$label_95#1:
    goto inline$BDLGetDebugLevel$377$Entry#1;

  inline$BDLGetDebugLevel$377$Entry#1:
    goto inline$BDLGetDebugLevel$377$start#1;

  inline$BDLGetDebugLevel$377$start#1:
    goto inline$BDLGetDebugLevel$377$label_3#1;

  inline$BDLGetDebugLevel$377$label_3#1:
    havoc inline$BDLGetDebugLevel$377$myNondetVar_0;
    inline$BDLGetDebugLevel$377$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$377$myNondetVar_0;
    goto inline$BDLGetDebugLevel$377$label_1#1;

  inline$BDLGetDebugLevel$377$label_1#1:
    goto inline$BDLGetDebugLevel$377$Return#1;

  inline$BDLGetDebugLevel$377$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$31$ := inline$BDLGetDebugLevel$377$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_95$1#1;

  inline$BDLPnPCancelRemove$0$label_95$1#1:
    goto inline$BDLPnPCancelRemove$0$anon40_Then#1, inline$BDLPnPCancelRemove$0$anon40_Else#1;

  inline$BDLPnPCancelRemove$0$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon25#1;

  inline$BDLPnPCancelRemove$0$anon25#1:
    goto inline$BDLPnPCancelRemove$0$label_104#1;

  inline$BDLPnPCancelRemove$0$label_104#1:
    goto inline$BDLPnPCancelRemove$0$label_104_true#1, inline$BDLPnPCancelRemove$0$label_104_false#1;

  inline$BDLPnPCancelRemove$0$label_104_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$31$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_105#1;

  inline$BDLPnPCancelRemove$0$label_104_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$31$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_108#1;

  inline$BDLPnPCancelRemove$0$label_108#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_109#1;

  inline$BDLPnPCancelRemove$0$label_109#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_110#1;

  inline$BDLPnPCancelRemove$0$label_110#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_111#1;

  inline$BDLPnPCancelRemove$0$label_111#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2353.0$32$;
    goto inline$BDLPnPCancelRemove$0$label_105#1;

  inline$BDLPnPCancelRemove$0$label_105#1:
    goto inline$BDLGetDebugLevel$378$Entry#1;

  inline$BDLGetDebugLevel$378$Entry#1:
    goto inline$BDLGetDebugLevel$378$start#1;

  inline$BDLGetDebugLevel$378$start#1:
    goto inline$BDLGetDebugLevel$378$label_3#1;

  inline$BDLGetDebugLevel$378$label_3#1:
    havoc inline$BDLGetDebugLevel$378$myNondetVar_0;
    inline$BDLGetDebugLevel$378$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$378$myNondetVar_0;
    goto inline$BDLGetDebugLevel$378$label_1#1;

  inline$BDLGetDebugLevel$378$label_1#1:
    goto inline$BDLGetDebugLevel$378$Return#1;

  inline$BDLGetDebugLevel$378$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$36$ := inline$BDLGetDebugLevel$378$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_105$1#1;

  inline$BDLPnPCancelRemove$0$label_105$1#1:
    goto inline$BDLPnPCancelRemove$0$anon41_Then#1, inline$BDLPnPCancelRemove$0$anon41_Else#1;

  inline$BDLPnPCancelRemove$0$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon27#1;

  inline$BDLPnPCancelRemove$0$anon27#1:
    goto inline$BDLPnPCancelRemove$0$label_114#1;

  inline$BDLPnPCancelRemove$0$label_114#1:
    goto inline$BDLPnPCancelRemove$0$label_114_true#1, inline$BDLPnPCancelRemove$0$label_114_false#1;

  inline$BDLPnPCancelRemove$0$label_114_false#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$36$, 4) == 0;
    goto inline$BDLPnPCancelRemove$0$label_62#1;

  inline$BDLPnPCancelRemove$0$label_114_true#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2353.0$36$, 4) != 0;
    goto inline$BDLPnPCancelRemove$0$label_115#1;

  inline$BDLPnPCancelRemove$0$label_115#1:
    goto inline$BDLPnPCancelRemove$0$label_62#1;

  inline$BDLPnPCancelRemove$0$anon41_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon40_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon39_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$label_34_true#1:
    assume inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12 != 0;
    goto inline$BDLPnPCancelRemove$0$label_38#1;

  inline$BDLPnPCancelRemove$0$label_38#1:
    goto inline$BDLGetDebugLevel$370$Entry#1;

  inline$BDLGetDebugLevel$370$Entry#1:
    goto inline$BDLGetDebugLevel$370$start#1;

  inline$BDLGetDebugLevel$370$start#1:
    goto inline$BDLGetDebugLevel$370$label_3#1;

  inline$BDLGetDebugLevel$370$label_3#1:
    havoc inline$BDLGetDebugLevel$370$myNondetVar_0;
    inline$BDLGetDebugLevel$370$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$370$myNondetVar_0;
    goto inline$BDLGetDebugLevel$370$label_1#1;

  inline$BDLGetDebugLevel$370$label_1#1:
    goto inline$BDLGetDebugLevel$370$Return#1;

  inline$BDLGetDebugLevel$370$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$14$ := inline$BDLGetDebugLevel$370$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_38$1#1;

  inline$BDLPnPCancelRemove$0$label_38$1#1:
    goto inline$BDLPnPCancelRemove$0$anon33_Then#1, inline$BDLPnPCancelRemove$0$anon33_Else#1;

  inline$BDLPnPCancelRemove$0$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon11#1;

  inline$BDLPnPCancelRemove$0$anon11#1:
    goto inline$BDLPnPCancelRemove$0$label_41#1;

  inline$BDLPnPCancelRemove$0$label_41#1:
    goto inline$BDLPnPCancelRemove$0$label_41_true#1, inline$BDLPnPCancelRemove$0$label_41_false#1;

  inline$BDLPnPCancelRemove$0$label_41_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$14$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_42#1;

  inline$BDLPnPCancelRemove$0$label_41_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$14$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_45#1;

  inline$BDLPnPCancelRemove$0$label_45#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_46#1;

  inline$BDLPnPCancelRemove$0$label_46#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_47#1;

  inline$BDLPnPCancelRemove$0$label_47#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_48#1;

  inline$BDLPnPCancelRemove$0$label_48#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2336.0$15$;
    goto inline$BDLPnPCancelRemove$0$label_42#1;

  inline$BDLPnPCancelRemove$0$label_42#1:
    goto inline$BDLGetDebugLevel$371$Entry#1;

  inline$BDLGetDebugLevel$371$Entry#1:
    goto inline$BDLGetDebugLevel$371$start#1;

  inline$BDLGetDebugLevel$371$start#1:
    goto inline$BDLGetDebugLevel$371$label_3#1;

  inline$BDLGetDebugLevel$371$label_3#1:
    havoc inline$BDLGetDebugLevel$371$myNondetVar_0;
    inline$BDLGetDebugLevel$371$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$371$myNondetVar_0;
    goto inline$BDLGetDebugLevel$371$label_1#1;

  inline$BDLGetDebugLevel$371$label_1#1:
    goto inline$BDLGetDebugLevel$371$Return#1;

  inline$BDLGetDebugLevel$371$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$19$ := inline$BDLGetDebugLevel$371$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_42$1#1;

  inline$BDLPnPCancelRemove$0$label_42$1#1:
    goto inline$BDLPnPCancelRemove$0$anon34_Then#1, inline$BDLPnPCancelRemove$0$anon34_Else#1;

  inline$BDLPnPCancelRemove$0$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon13#1;

  inline$BDLPnPCancelRemove$0$anon13#1:
    goto inline$BDLPnPCancelRemove$0$label_51#1;

  inline$BDLPnPCancelRemove$0$label_51#1:
    goto inline$BDLPnPCancelRemove$0$label_51_true#1, inline$BDLPnPCancelRemove$0$label_51_false#1;

  inline$BDLPnPCancelRemove$0$label_51_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$19$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_52#1;

  inline$BDLPnPCancelRemove$0$label_51_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$19$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_55#1;

  inline$BDLPnPCancelRemove$0$label_55#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_56#1;

  inline$BDLPnPCancelRemove$0$label_56#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_57#1;

  inline$BDLPnPCancelRemove$0$label_57#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_58#1;

  inline$BDLPnPCancelRemove$0$label_58#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2336.0$20$;
    goto inline$BDLPnPCancelRemove$0$label_52#1;

  inline$BDLPnPCancelRemove$0$label_52#1:
    goto inline$BDLGetDebugLevel$372$Entry#1;

  inline$BDLGetDebugLevel$372$Entry#1:
    goto inline$BDLGetDebugLevel$372$start#1;

  inline$BDLGetDebugLevel$372$start#1:
    goto inline$BDLGetDebugLevel$372$label_3#1;

  inline$BDLGetDebugLevel$372$label_3#1:
    havoc inline$BDLGetDebugLevel$372$myNondetVar_0;
    inline$BDLGetDebugLevel$372$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$372$myNondetVar_0;
    goto inline$BDLGetDebugLevel$372$label_1#1;

  inline$BDLGetDebugLevel$372$label_1#1:
    goto inline$BDLGetDebugLevel$372$Return#1;

  inline$BDLGetDebugLevel$372$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$24$ := inline$BDLGetDebugLevel$372$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_52$1#1;

  inline$BDLPnPCancelRemove$0$label_52$1#1:
    goto inline$BDLPnPCancelRemove$0$anon35_Then#1, inline$BDLPnPCancelRemove$0$anon35_Else#1;

  inline$BDLPnPCancelRemove$0$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon15#1;

  inline$BDLPnPCancelRemove$0$anon15#1:
    goto inline$BDLPnPCancelRemove$0$label_61#1;

  inline$BDLPnPCancelRemove$0$label_61#1:
    goto inline$BDLPnPCancelRemove$0$label_61_true#1, inline$BDLPnPCancelRemove$0$label_61_false#1;

  inline$BDLPnPCancelRemove$0$label_61_false#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$24$, 4) == 0;
    goto inline$BDLPnPCancelRemove$0$label_62#1;

  inline$BDLPnPCancelRemove$0$label_61_true#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2336.0$24$, 4) != 0;
    goto inline$BDLPnPCancelRemove$0$label_65#1;

  inline$BDLPnPCancelRemove$0$label_65#1:
    goto inline$BDLPnPCancelRemove$0$label_62#1;

  inline$BDLPnPCancelRemove$0$label_62#1:
    goto inline$BDLGetDebugLevel$373$Entry#1;

  inline$BDLGetDebugLevel$373$Entry#1:
    goto inline$BDLGetDebugLevel$373$start#1;

  inline$BDLGetDebugLevel$373$start#1:
    goto inline$BDLGetDebugLevel$373$label_3#1;

  inline$BDLGetDebugLevel$373$label_3#1:
    havoc inline$BDLGetDebugLevel$373$myNondetVar_0;
    inline$BDLGetDebugLevel$373$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$373$myNondetVar_0;
    goto inline$BDLGetDebugLevel$373$label_1#1;

  inline$BDLGetDebugLevel$373$label_1#1:
    goto inline$BDLGetDebugLevel$373$Return#1;

  inline$BDLGetDebugLevel$373$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$37$ := inline$BDLGetDebugLevel$373$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_62$1#1;

  inline$BDLPnPCancelRemove$0$label_62$1#1:
    goto inline$BDLPnPCancelRemove$0$anon36_Then#1, inline$BDLPnPCancelRemove$0$anon36_Else#1;

  inline$BDLPnPCancelRemove$0$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon17#1;

  inline$BDLPnPCancelRemove$0$anon17#1:
    goto inline$BDLPnPCancelRemove$0$label_66#1;

  inline$BDLPnPCancelRemove$0$label_66#1:
    goto inline$BDLPnPCancelRemove$0$label_66_true#1, inline$BDLPnPCancelRemove$0$label_66_false#1;

  inline$BDLPnPCancelRemove$0$label_66_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$37$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_67#1;

  inline$BDLPnPCancelRemove$0$label_66_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$37$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_70#1;

  inline$BDLPnPCancelRemove$0$label_70#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_71#1;

  inline$BDLPnPCancelRemove$0$label_71#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_72#1;

  inline$BDLPnPCancelRemove$0$label_72#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_73#1;

  inline$BDLPnPCancelRemove$0$label_73#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2365.0$38$;
    goto inline$BDLPnPCancelRemove$0$label_67#1;

  inline$BDLPnPCancelRemove$0$label_67#1:
    goto inline$BDLGetDebugLevel$374$Entry#1;

  inline$BDLGetDebugLevel$374$Entry#1:
    goto inline$BDLGetDebugLevel$374$start#1;

  inline$BDLGetDebugLevel$374$start#1:
    goto inline$BDLGetDebugLevel$374$label_3#1;

  inline$BDLGetDebugLevel$374$label_3#1:
    havoc inline$BDLGetDebugLevel$374$myNondetVar_0;
    inline$BDLGetDebugLevel$374$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$374$myNondetVar_0;
    goto inline$BDLGetDebugLevel$374$label_1#1;

  inline$BDLGetDebugLevel$374$label_1#1:
    goto inline$BDLGetDebugLevel$374$Return#1;

  inline$BDLGetDebugLevel$374$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$42$ := inline$BDLGetDebugLevel$374$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_67$1#1;

  inline$BDLPnPCancelRemove$0$label_67$1#1:
    goto inline$BDLPnPCancelRemove$0$anon37_Then#1, inline$BDLPnPCancelRemove$0$anon37_Else#1;

  inline$BDLPnPCancelRemove$0$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon19#1;

  inline$BDLPnPCancelRemove$0$anon19#1:
    goto inline$BDLPnPCancelRemove$0$label_76#1;

  inline$BDLPnPCancelRemove$0$label_76#1:
    goto inline$BDLPnPCancelRemove$0$label_76_true#1, inline$BDLPnPCancelRemove$0$label_76_false#1;

  inline$BDLPnPCancelRemove$0$label_76_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$42$) == 0;
    goto inline$BDLPnPCancelRemove$0$label_77#1;

  inline$BDLPnPCancelRemove$0$label_76_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$42$) != 0;
    goto inline$BDLPnPCancelRemove$0$label_80#1;

  inline$BDLPnPCancelRemove$0$label_80#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_81#1;

  inline$BDLPnPCancelRemove$0$label_81#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_82#1;

  inline$BDLPnPCancelRemove$0$label_82#1:
    call inline$BDLPnPCancelRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPCancelRemove$0$label_83#1;

  inline$BDLPnPCancelRemove$0$label_83#1:
    havoc inline$BDLPnPCancelRemove$0$$result.DbgPrint$2365.0$43$;
    goto inline$BDLPnPCancelRemove$0$label_77#1;

  inline$BDLPnPCancelRemove$0$label_77#1:
    goto inline$BDLGetDebugLevel$375$Entry#1;

  inline$BDLGetDebugLevel$375$Entry#1:
    goto inline$BDLGetDebugLevel$375$start#1;

  inline$BDLGetDebugLevel$375$start#1:
    goto inline$BDLGetDebugLevel$375$label_3#1;

  inline$BDLGetDebugLevel$375$label_3#1:
    havoc inline$BDLGetDebugLevel$375$myNondetVar_0;
    inline$BDLGetDebugLevel$375$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$375$myNondetVar_0;
    goto inline$BDLGetDebugLevel$375$label_1#1;

  inline$BDLGetDebugLevel$375$label_1#1:
    goto inline$BDLGetDebugLevel$375$Return#1;

  inline$BDLGetDebugLevel$375$Return#1:
    inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$47$ := inline$BDLGetDebugLevel$375$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPCancelRemove$0$label_77$1#1;

  inline$BDLPnPCancelRemove$0$label_77$1#1:
    goto inline$BDLPnPCancelRemove$0$anon38_Then#1, inline$BDLPnPCancelRemove$0$anon38_Else#1;

  inline$BDLPnPCancelRemove$0$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLPnPCancelRemove$0$anon21#1;

  inline$BDLPnPCancelRemove$0$anon21#1:
    goto inline$BDLPnPCancelRemove$0$label_86#1;

  inline$BDLPnPCancelRemove$0$label_86#1:
    goto inline$BDLPnPCancelRemove$0$label_86_true#1, inline$BDLPnPCancelRemove$0$label_86_false#1;

  inline$BDLPnPCancelRemove$0$label_86_false#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$47$, 4) == 0;
    goto inline$BDLPnPCancelRemove$0$label_87#1;

  inline$BDLPnPCancelRemove$0$label_86_true#1:
    assume BIT_BAND(inline$BDLPnPCancelRemove$0$$result.BDLGetDebugLevel$2365.0$47$, 4) != 0;
    goto inline$BDLPnPCancelRemove$0$label_88#1;

  inline$BDLPnPCancelRemove$0$label_88#1:
    goto inline$BDLPnPCancelRemove$0$label_87#1;

  inline$BDLPnPCancelRemove$0$label_87#1:
    inline$BDLPnPCancelRemove$0$$result.BDLPnPCancelRemove$2314.0$1$ := inline$BDLPnPCancelRemove$0$$status$4$2321.28$BDLPnPCancelRemove$12;
    goto inline$BDLPnPCancelRemove$0$label_1#1;

  inline$BDLPnPCancelRemove$0$label_1#1:
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon38_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon37_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon36_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon35_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon34_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon33_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon29_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$anon28_Then#1:
    assume raiseException;
    goto inline$BDLPnPCancelRemove$0$Return#1;

  inline$BDLPnPCancelRemove$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPCancelRemove$952.35$33$ := inline$BDLPnPCancelRemove$0$$result.BDLPnPCancelRemove$2314.0$1$;
    goto inline$BDLPnP$0$label_122$1#1;

  inline$BDLPnP$0$label_122$1#1:
    goto inline$BDLPnP$0$anon70_Then#1, inline$BDLPnP$0$anon70_Else#1;

  inline$BDLPnP$0$anon70_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon33#1;

  inline$BDLPnP$0$anon33#1:
    goto inline$BDLPnP$0$label_151#1;

  inline$BDLPnP$0$label_151#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPCancelRemove$952.35$33$;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon70_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_3#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 2;
    goto inline$BDLPnP$0$label_119#1;

  inline$BDLPnP$0$label_119#1:
    goto inline$BDLPnPRemove$0$Entry#1;

  inline$BDLPnPRemove$0$Entry#1:
    inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPRemove$0$$pDeviceObject$2$2479.40$BDLPnPRemove$16_.1 := inline$BDLPnP$0$$pDeviceObject$1$855.24$BDLPnP$8;
    inline$BDLPnPRemove$0$$pAttachedDeviceObject$3$2480.40$BDLPnPRemove$16_.1 := inline$BDLPnP$0$$pAttachedDeviceObject$6$862.36$BDLPnP$8;
    inline$BDLPnPRemove$0$$pIrp$4$2481.40$BDLPnPRemove$16_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPRemove$0$start#1;

  inline$BDLPnPRemove$0$start#1:
    inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16 := inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16_.1;
    inline$BDLPnPRemove$0$$pDeviceObject$2$2479.40$BDLPnPRemove$16 := inline$BDLPnPRemove$0$$pDeviceObject$2$2479.40$BDLPnPRemove$16_.1;
    inline$BDLPnPRemove$0$$pAttachedDeviceObject$3$2480.40$BDLPnPRemove$16 := inline$BDLPnPRemove$0$$pAttachedDeviceObject$3$2480.40$BDLPnPRemove$16_.1;
    inline$BDLPnPRemove$0$$pIrp$4$2481.40$BDLPnPRemove$16 := inline$BDLPnPRemove$0$$pIrp$4$2481.40$BDLPnPRemove$16_.1;
    goto inline$BDLPnPRemove$0$label_3#1;

  inline$BDLPnPRemove$0$label_3#1:
    goto inline$BDLPnPRemove$0$label_4#1;

  inline$BDLPnPRemove$0$label_4#1:
    inline$BDLPnPRemove$0$$status$5$2484.16$BDLPnPRemove$16 := 0;
    goto inline$BDLPnPRemove$0$label_5#1;

  inline$BDLPnPRemove$0$label_5#1:
    goto inline$BDLGetDebugLevel$202$Entry#1;

  inline$BDLGetDebugLevel$202$Entry#1:
    goto inline$BDLGetDebugLevel$202$start#1;

  inline$BDLGetDebugLevel$202$start#1:
    goto inline$BDLGetDebugLevel$202$label_3#1;

  inline$BDLGetDebugLevel$202$label_3#1:
    havoc inline$BDLGetDebugLevel$202$myNondetVar_0;
    inline$BDLGetDebugLevel$202$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$202$myNondetVar_0;
    goto inline$BDLGetDebugLevel$202$label_1#1;

  inline$BDLGetDebugLevel$202$label_1#1:
    goto inline$BDLGetDebugLevel$202$Return#1;

  inline$BDLGetDebugLevel$202$Return#1:
    inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$2$ := inline$BDLGetDebugLevel$202$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPRemove$0$label_5$1#1;

  inline$BDLPnPRemove$0$label_5$1#1:
    goto inline$BDLPnPRemove$0$anon24_Then#1, inline$BDLPnPRemove$0$anon24_Else#1;

  inline$BDLPnPRemove$0$anon24_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon1#1;

  inline$BDLPnPRemove$0$anon1#1:
    goto inline$BDLPnPRemove$0$label_8#1;

  inline$BDLPnPRemove$0$label_8#1:
    goto inline$BDLPnPRemove$0$label_8_true#1, inline$BDLPnPRemove$0$label_8_false#1;

  inline$BDLPnPRemove$0$label_8_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$2$) == 0;
    goto inline$BDLPnPRemove$0$label_9#1;

  inline$BDLPnPRemove$0$label_8_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$2$) != 0;
    goto inline$BDLPnPRemove$0$label_12#1;

  inline$BDLPnPRemove$0$label_12#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_13#1;

  inline$BDLPnPRemove$0$label_13#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_14#1;

  inline$BDLPnPRemove$0$label_14#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_15#1;

  inline$BDLPnPRemove$0$label_15#1:
    havoc inline$BDLPnPRemove$0$$result.DbgPrint$2486.0$3$;
    goto inline$BDLPnPRemove$0$label_9#1;

  inline$BDLPnPRemove$0$label_9#1:
    goto inline$BDLGetDebugLevel$203$Entry#1;

  inline$BDLGetDebugLevel$203$Entry#1:
    goto inline$BDLGetDebugLevel$203$start#1;

  inline$BDLGetDebugLevel$203$start#1:
    goto inline$BDLGetDebugLevel$203$label_3#1;

  inline$BDLGetDebugLevel$203$label_3#1:
    havoc inline$BDLGetDebugLevel$203$myNondetVar_0;
    inline$BDLGetDebugLevel$203$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$203$myNondetVar_0;
    goto inline$BDLGetDebugLevel$203$label_1#1;

  inline$BDLGetDebugLevel$203$label_1#1:
    goto inline$BDLGetDebugLevel$203$Return#1;

  inline$BDLGetDebugLevel$203$Return#1:
    inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$7$ := inline$BDLGetDebugLevel$203$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPRemove$0$label_9$1#1;

  inline$BDLPnPRemove$0$label_9$1#1:
    goto inline$BDLPnPRemove$0$anon25_Then#1, inline$BDLPnPRemove$0$anon25_Else#1;

  inline$BDLPnPRemove$0$anon25_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon3#1;

  inline$BDLPnPRemove$0$anon3#1:
    goto inline$BDLPnPRemove$0$label_18#1;

  inline$BDLPnPRemove$0$label_18#1:
    goto inline$BDLPnPRemove$0$label_18_true#1, inline$BDLPnPRemove$0$label_18_false#1;

  inline$BDLPnPRemove$0$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$7$) == 0;
    goto inline$BDLPnPRemove$0$label_19#1;

  inline$BDLPnPRemove$0$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$7$) != 0;
    goto inline$BDLPnPRemove$0$label_22#1;

  inline$BDLPnPRemove$0$label_22#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_23#1;

  inline$BDLPnPRemove$0$label_23#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_24#1;

  inline$BDLPnPRemove$0$label_24#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_25#1;

  inline$BDLPnPRemove$0$label_25#1:
    havoc inline$BDLPnPRemove$0$$result.DbgPrint$2486.0$8$;
    goto inline$BDLPnPRemove$0$label_19#1;

  inline$BDLPnPRemove$0$label_19#1:
    goto inline$BDLGetDebugLevel$204$Entry#1;

  inline$BDLGetDebugLevel$204$Entry#1:
    goto inline$BDLGetDebugLevel$204$start#1;

  inline$BDLGetDebugLevel$204$start#1:
    goto inline$BDLGetDebugLevel$204$label_3#1;

  inline$BDLGetDebugLevel$204$label_3#1:
    havoc inline$BDLGetDebugLevel$204$myNondetVar_0;
    inline$BDLGetDebugLevel$204$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$204$myNondetVar_0;
    goto inline$BDLGetDebugLevel$204$label_1#1;

  inline$BDLGetDebugLevel$204$label_1#1:
    goto inline$BDLGetDebugLevel$204$Return#1;

  inline$BDLGetDebugLevel$204$Return#1:
    inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$12$ := inline$BDLGetDebugLevel$204$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPRemove$0$label_19$1#1;

  inline$BDLPnPRemove$0$label_19$1#1:
    goto inline$BDLPnPRemove$0$anon26_Then#1, inline$BDLPnPRemove$0$anon26_Else#1;

  inline$BDLPnPRemove$0$anon26_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon5#1;

  inline$BDLPnPRemove$0$anon5#1:
    goto inline$BDLPnPRemove$0$label_28#1;

  inline$BDLPnPRemove$0$label_28#1:
    goto inline$BDLPnPRemove$0$label_28_true#1, inline$BDLPnPRemove$0$label_28_false#1;

  inline$BDLPnPRemove$0$label_28_false#1:
    assume BIT_BAND(inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$12$, 4) == 0;
    goto inline$BDLPnPRemove$0$label_29#1;

  inline$BDLPnPRemove$0$label_28_true#1:
    assume BIT_BAND(inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2486.0$12$, 4) != 0;
    goto inline$BDLPnPRemove$0$label_30#1;

  inline$BDLPnPRemove$0$label_30#1:
    goto inline$BDLPnPRemove$0$label_29#1;

  inline$BDLPnPRemove$0$label_29#1:
    goto inline$BDLPnPRemove$0$label_29_true#1, inline$BDLPnPRemove$0$label_29_false#1;

  inline$BDLPnPRemove$0$label_29_false#1:
    havoc inline$BDLPnPRemove$0$myNondetVar_0;
    assume inline$BDLPnPRemove$0$myNondetVar_0 == 0;
    goto inline$BDLPnPRemove$0$label_31#1;

  inline$BDLPnPRemove$0$label_31#1:
    goto inline$BDLPnPRemove$0$label_73#1;

  inline$BDLPnPRemove$0$label_73#1:
    goto inline$BDLHandleRemove$0$Entry#1;

  inline$BDLHandleRemove$0$Entry#1:
    inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12_.1 := inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16;
    inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12_.1 := inline$BDLPnPRemove$0$$pIrp$4$2481.40$BDLPnPRemove$16;
    goto inline$BDLHandleRemove$0$start#1;

  inline$BDLHandleRemove$0$start#1:
    inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12 := inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12_.1;
    inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12 := inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12_.1;
    goto inline$BDLHandleRemove$0$label_3#1;

  inline$BDLHandleRemove$0$label_3#1:
    goto inline$BDLHandleRemove$0$label_4#1;

  inline$BDLHandleRemove$0$label_4#1:
    inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 := 0;
    goto inline$BDLHandleRemove$0$label_5#1;

  inline$BDLHandleRemove$0$label_5#1:
    goto inline$BDLHandleRemove$0$label_6#1;

  inline$BDLHandleRemove$0$label_6#1:
    havoc inline$BDLHandleRemove$0$myNondetVar_0;
    goto inline$BDLHandleRemove$0$label_7#1;

  inline$BDLHandleRemove$0$label_7#1:
    goto inline$BDLGetDebugLevel$208$Entry#1;

  inline$BDLGetDebugLevel$208$Entry#1:
    goto inline$BDLGetDebugLevel$208$start#1;

  inline$BDLGetDebugLevel$208$start#1:
    goto inline$BDLGetDebugLevel$208$label_3#1;

  inline$BDLGetDebugLevel$208$label_3#1:
    havoc inline$BDLGetDebugLevel$208$myNondetVar_0;
    inline$BDLGetDebugLevel$208$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$208$myNondetVar_0;
    goto inline$BDLGetDebugLevel$208$label_1#1;

  inline$BDLGetDebugLevel$208$label_1#1:
    goto inline$BDLGetDebugLevel$208$Return#1;

  inline$BDLGetDebugLevel$208$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$2$ := inline$BDLGetDebugLevel$208$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_7$1#1;

  inline$BDLHandleRemove$0$label_7$1#1:
    goto inline$BDLHandleRemove$0$anon42_Then#1, inline$BDLHandleRemove$0$anon42_Else#1;

  inline$BDLHandleRemove$0$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon1#1;

  inline$BDLHandleRemove$0$anon1#1:
    goto inline$BDLHandleRemove$0$label_10#1;

  inline$BDLHandleRemove$0$label_10#1:
    goto inline$BDLHandleRemove$0$label_10_true#1, inline$BDLHandleRemove$0$label_10_false#1;

  inline$BDLHandleRemove$0$label_10_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$2$) == 0;
    goto inline$BDLHandleRemove$0$label_11#1;

  inline$BDLHandleRemove$0$label_10_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$2$) != 0;
    goto inline$BDLHandleRemove$0$label_14#1;

  inline$BDLHandleRemove$0$label_14#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_15#1;

  inline$BDLHandleRemove$0$label_15#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_16#1;

  inline$BDLHandleRemove$0$label_16#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_17#1;

  inline$BDLHandleRemove$0$label_17#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2386.0$3$;
    goto inline$BDLHandleRemove$0$label_11#1;

  inline$BDLHandleRemove$0$label_11#1:
    goto inline$BDLGetDebugLevel$209$Entry#1;

  inline$BDLGetDebugLevel$209$Entry#1:
    goto inline$BDLGetDebugLevel$209$start#1;

  inline$BDLGetDebugLevel$209$start#1:
    goto inline$BDLGetDebugLevel$209$label_3#1;

  inline$BDLGetDebugLevel$209$label_3#1:
    havoc inline$BDLGetDebugLevel$209$myNondetVar_0;
    inline$BDLGetDebugLevel$209$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$209$myNondetVar_0;
    goto inline$BDLGetDebugLevel$209$label_1#1;

  inline$BDLGetDebugLevel$209$label_1#1:
    goto inline$BDLGetDebugLevel$209$Return#1;

  inline$BDLGetDebugLevel$209$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$7$ := inline$BDLGetDebugLevel$209$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_11$1#1;

  inline$BDLHandleRemove$0$label_11$1#1:
    goto inline$BDLHandleRemove$0$anon43_Then#1, inline$BDLHandleRemove$0$anon43_Else#1;

  inline$BDLHandleRemove$0$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon3#1;

  inline$BDLHandleRemove$0$anon3#1:
    goto inline$BDLHandleRemove$0$label_20#1;

  inline$BDLHandleRemove$0$label_20#1:
    goto inline$BDLHandleRemove$0$label_20_true#1, inline$BDLHandleRemove$0$label_20_false#1;

  inline$BDLHandleRemove$0$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$7$) == 0;
    goto inline$BDLHandleRemove$0$label_21#1;

  inline$BDLHandleRemove$0$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$7$) != 0;
    goto inline$BDLHandleRemove$0$label_24#1;

  inline$BDLHandleRemove$0$label_24#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_25#1;

  inline$BDLHandleRemove$0$label_25#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_26#1;

  inline$BDLHandleRemove$0$label_26#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_27#1;

  inline$BDLHandleRemove$0$label_27#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2386.0$8$;
    goto inline$BDLHandleRemove$0$label_21#1;

  inline$BDLHandleRemove$0$label_21#1:
    goto inline$BDLGetDebugLevel$210$Entry#1;

  inline$BDLGetDebugLevel$210$Entry#1:
    goto inline$BDLGetDebugLevel$210$start#1;

  inline$BDLGetDebugLevel$210$start#1:
    goto inline$BDLGetDebugLevel$210$label_3#1;

  inline$BDLGetDebugLevel$210$label_3#1:
    havoc inline$BDLGetDebugLevel$210$myNondetVar_0;
    inline$BDLGetDebugLevel$210$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$210$myNondetVar_0;
    goto inline$BDLGetDebugLevel$210$label_1#1;

  inline$BDLGetDebugLevel$210$label_1#1:
    goto inline$BDLGetDebugLevel$210$Return#1;

  inline$BDLGetDebugLevel$210$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$12$ := inline$BDLGetDebugLevel$210$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_21$1#1;

  inline$BDLHandleRemove$0$label_21$1#1:
    goto inline$BDLHandleRemove$0$anon44_Then#1, inline$BDLHandleRemove$0$anon44_Else#1;

  inline$BDLHandleRemove$0$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon5#1;

  inline$BDLHandleRemove$0$anon5#1:
    goto inline$BDLHandleRemove$0$label_30#1;

  inline$BDLHandleRemove$0$label_30#1:
    goto inline$BDLHandleRemove$0$label_30_true#1, inline$BDLHandleRemove$0$label_30_false#1;

  inline$BDLHandleRemove$0$label_30_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$12$, 4) == 0;
    goto inline$BDLHandleRemove$0$label_31#1;

  inline$BDLHandleRemove$0$label_30_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2386.0$12$, 4) != 0;
    goto inline$BDLHandleRemove$0$label_34#1;

  inline$BDLHandleRemove$0$label_34#1:
    goto inline$BDLHandleRemove$0$label_31#1;

  inline$BDLHandleRemove$0$label_31#1:
    goto inline$storm_KeSetEvent$9$Entry#1;

  inline$storm_KeSetEvent$9$Entry#1:
    inline$storm_KeSetEvent$9$$Event$1$213.14$storm_KeSetEvent$12_.1 := DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12);
    goto inline$storm_KeSetEvent$9$start#1;

  inline$storm_KeSetEvent$9$start#1:
    inline$storm_KeSetEvent$9$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$9$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$9$label_3#1;

  inline$storm_KeSetEvent$9$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$9$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$9$label_1#1;

  inline$storm_KeSetEvent$9$label_1#1:
    goto inline$storm_KeSetEvent$9$Return#1;

  inline$storm_KeSetEvent$9$Return#1:
    goto inline$BDLHandleRemove$0$label_31$1#1;

  inline$BDLHandleRemove$0$label_31$1#1:
    goto inline$BDLHandleRemove$0$anon45_Then#1, inline$BDLHandleRemove$0$anon45_Else#1;

  inline$BDLHandleRemove$0$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon7#1;

  inline$BDLHandleRemove$0$anon7#1:
    goto inline$BDLHandleRemove$0$label_35#1;

  inline$BDLHandleRemove$0$label_35#1:
    call inline$BDLHandleRemove$0$$result.IoSetDeviceInterfaceState$2406.29$14$ := IoSetDeviceInterfaceState(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12), 0);
    goto inline$BDLHandleRemove$0$anon46_Then#1, inline$BDLHandleRemove$0$anon46_Else#1;

  inline$BDLHandleRemove$0$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon9#1;

  inline$BDLHandleRemove$0$anon9#1:
    goto inline$BDLHandleRemove$0$label_38#1;

  inline$BDLHandleRemove$0$label_38#1:
    goto inline$BDLCleanupNotificationStruct$0$Entry#1;

  inline$BDLCleanupNotificationStruct$0$Entry#1:
    inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4_.1 := inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12;
    goto inline$BDLCleanupNotificationStruct$0$start#1;

  inline$BDLCleanupNotificationStruct$0$start#1:
    call inline$BDLCleanupNotificationStruct$0$$bddiRegisterNotifyParams$10$3120.36$BDLCleanupNotificationStruct$4 := __HAVOC_malloc(20);
    call inline$BDLCleanupNotificationStruct$0$$irql$3$3113.45$BDLCleanupNotificationStruct$4 := __HAVOC_malloc(1);
    inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4_.1;
    goto inline$BDLCleanupNotificationStruct$0$label_3#1;

  inline$BDLCleanupNotificationStruct$0$label_3#1:
    goto inline$BDLCleanupNotificationStruct$0$label_4#1;

  inline$BDLCleanupNotificationStruct$0$label_4#1:
    goto inline$BDLCleanupNotificationStruct$0$label_5#1;

  inline$BDLCleanupNotificationStruct$0$label_5#1:
    goto inline$BDLCleanupNotificationStruct$0$label_6#1;

  inline$BDLCleanupNotificationStruct$0$label_6#1:
    goto inline$BDLCleanupNotificationStruct$0$label_7#1;

  inline$BDLCleanupNotificationStruct$0$label_7#1:
    goto inline$BDLCleanupNotificationStruct$0$label_8#1;

  inline$BDLCleanupNotificationStruct$0$label_8#1:
    goto inline$BDLCleanupNotificationStruct$0$label_9#1;

  inline$BDLCleanupNotificationStruct$0$label_9#1:
    goto inline$BDLCleanupNotificationStruct$0$label_10#1;

  inline$BDLCleanupNotificationStruct$0$label_10#1:
    inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$0$label_11#1;

  inline$BDLCleanupNotificationStruct$0$label_11#1:
    goto inline$BDLCleanupNotificationStruct$0$label_12#1;

  inline$BDLCleanupNotificationStruct$0$label_12#1:
    inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$0$label_13#1;

  inline$BDLCleanupNotificationStruct$0$label_13#1:
    goto inline$BDLCleanupNotificationStruct$0$label_14#1;

  inline$BDLCleanupNotificationStruct$0$label_14#1:
    inline$BDLCleanupNotificationStruct$0$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$0$label_15#1;

  inline$BDLCleanupNotificationStruct$0$label_15#1:
    goto inline$BDLCleanupNotificationStruct$0$label_16#1;

  inline$BDLCleanupNotificationStruct$0$label_16#1:
    inline$BDLCleanupNotificationStruct$0$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4 := 0;
    goto inline$BDLCleanupNotificationStruct$0$label_17#1;

  inline$BDLCleanupNotificationStruct$0$label_17#1:
    goto inline$BDLCleanupNotificationStruct$0$label_18#1;

  inline$BDLCleanupNotificationStruct$0$label_18#1:
    goto inline$BDLCleanupNotificationStruct$0$label_19#1;

  inline$BDLCleanupNotificationStruct$0$label_19#1:
    goto inline$BDLGetDebugLevel$211$Entry#1;

  inline$BDLGetDebugLevel$211$Entry#1:
    goto inline$BDLGetDebugLevel$211$start#1;

  inline$BDLGetDebugLevel$211$start#1:
    goto inline$BDLGetDebugLevel$211$label_3#1;

  inline$BDLGetDebugLevel$211$label_3#1:
    havoc inline$BDLGetDebugLevel$211$myNondetVar_0;
    inline$BDLGetDebugLevel$211$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$211$myNondetVar_0;
    goto inline$BDLGetDebugLevel$211$label_1#1;

  inline$BDLGetDebugLevel$211$label_1#1:
    goto inline$BDLGetDebugLevel$211$Return#1;

  inline$BDLGetDebugLevel$211$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$1$ := inline$BDLGetDebugLevel$211$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_19$1#1;

  inline$BDLCleanupNotificationStruct$0$label_19$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon46_Then#1, inline$BDLCleanupNotificationStruct$0$anon46_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon1#1;

  inline$BDLCleanupNotificationStruct$0$anon1#1:
    goto inline$BDLCleanupNotificationStruct$0$label_22#1;

  inline$BDLCleanupNotificationStruct$0$label_22#1:
    goto inline$BDLCleanupNotificationStruct$0$label_22_true#1, inline$BDLCleanupNotificationStruct$0$label_22_false#1;

  inline$BDLCleanupNotificationStruct$0$label_22_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$1$) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_23#1;

  inline$BDLCleanupNotificationStruct$0$label_22_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$1$) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_26#1;

  inline$BDLCleanupNotificationStruct$0$label_26#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_27#1;

  inline$BDLCleanupNotificationStruct$0$label_27#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_28#1;

  inline$BDLCleanupNotificationStruct$0$label_28#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_29#1;

  inline$BDLCleanupNotificationStruct$0$label_29#1:
    havoc inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3123.0$2$;
    goto inline$BDLCleanupNotificationStruct$0$label_23#1;

  inline$BDLCleanupNotificationStruct$0$label_23#1:
    goto inline$BDLGetDebugLevel$212$Entry#1;

  inline$BDLGetDebugLevel$212$Entry#1:
    goto inline$BDLGetDebugLevel$212$start#1;

  inline$BDLGetDebugLevel$212$start#1:
    goto inline$BDLGetDebugLevel$212$label_3#1;

  inline$BDLGetDebugLevel$212$label_3#1:
    havoc inline$BDLGetDebugLevel$212$myNondetVar_0;
    inline$BDLGetDebugLevel$212$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$212$myNondetVar_0;
    goto inline$BDLGetDebugLevel$212$label_1#1;

  inline$BDLGetDebugLevel$212$label_1#1:
    goto inline$BDLGetDebugLevel$212$Return#1;

  inline$BDLGetDebugLevel$212$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$6$ := inline$BDLGetDebugLevel$212$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_23$1#1;

  inline$BDLCleanupNotificationStruct$0$label_23$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon47_Then#1, inline$BDLCleanupNotificationStruct$0$anon47_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon3#1;

  inline$BDLCleanupNotificationStruct$0$anon3#1:
    goto inline$BDLCleanupNotificationStruct$0$label_32#1;

  inline$BDLCleanupNotificationStruct$0$label_32#1:
    goto inline$BDLCleanupNotificationStruct$0$label_32_true#1, inline$BDLCleanupNotificationStruct$0$label_32_false#1;

  inline$BDLCleanupNotificationStruct$0$label_32_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$6$) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_33#1;

  inline$BDLCleanupNotificationStruct$0$label_32_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$6$) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_36#1;

  inline$BDLCleanupNotificationStruct$0$label_36#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_37#1;

  inline$BDLCleanupNotificationStruct$0$label_37#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_38#1;

  inline$BDLCleanupNotificationStruct$0$label_38#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_39#1;

  inline$BDLCleanupNotificationStruct$0$label_39#1:
    havoc inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3123.0$7$;
    goto inline$BDLCleanupNotificationStruct$0$label_33#1;

  inline$BDLCleanupNotificationStruct$0$label_33#1:
    goto inline$BDLGetDebugLevel$213$Entry#1;

  inline$BDLGetDebugLevel$213$Entry#1:
    goto inline$BDLGetDebugLevel$213$start#1;

  inline$BDLGetDebugLevel$213$start#1:
    goto inline$BDLGetDebugLevel$213$label_3#1;

  inline$BDLGetDebugLevel$213$label_3#1:
    havoc inline$BDLGetDebugLevel$213$myNondetVar_0;
    inline$BDLGetDebugLevel$213$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$213$myNondetVar_0;
    goto inline$BDLGetDebugLevel$213$label_1#1;

  inline$BDLGetDebugLevel$213$label_1#1:
    goto inline$BDLGetDebugLevel$213$Return#1;

  inline$BDLGetDebugLevel$213$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$11$ := inline$BDLGetDebugLevel$213$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_33$1#1;

  inline$BDLCleanupNotificationStruct$0$label_33$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon48_Then#1, inline$BDLCleanupNotificationStruct$0$anon48_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon5#1;

  inline$BDLCleanupNotificationStruct$0$anon5#1:
    goto inline$BDLCleanupNotificationStruct$0$label_42#1;

  inline$BDLCleanupNotificationStruct$0$label_42#1:
    goto inline$BDLCleanupNotificationStruct$0$label_42_true#1, inline$BDLCleanupNotificationStruct$0$label_42_false#1;

  inline$BDLCleanupNotificationStruct$0$label_42_false#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$11$, 4) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_43#1;

  inline$BDLCleanupNotificationStruct$0$label_42_true#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3123.0$11$, 4) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_44#1;

  inline$BDLCleanupNotificationStruct$0$label_44#1:
    goto inline$BDLCleanupNotificationStruct$0$label_43#1;

  inline$BDLCleanupNotificationStruct$0$label_43#1:
    goto inline$BDLCleanupNotificationStruct$0$label_45#1;

  inline$BDLCleanupNotificationStruct$0$label_45#1:
    goto inline$BDLCleanupNotificationStruct$0$label_45_head#1;

  inline$BDLCleanupNotificationStruct$0$label_45_head#1:
    goto inline$BDLCleanupNotificationStruct$0$label_45_true#1, inline$BDLCleanupNotificationStruct$0$label_45_false#1;

  inline$BDLCleanupNotificationStruct$0$label_45_false#1:
    assume 1 == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_46#1;

  inline$BDLCleanupNotificationStruct$0$label_45_true#1:
    assume 1 != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_49#1;

  inline$BDLCleanupNotificationStruct$0$label_49#1:
    call inline$BDLCleanupNotificationStruct$0$$result.KfRaiseIrql$3141.8$12$ := KfRaiseIrql(2);
    goto inline$BDLCleanupNotificationStruct$0$anon50_Then#1, inline$BDLCleanupNotificationStruct$0$anon50_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon9#1;

  inline$BDLCleanupNotificationStruct$0$anon9#1:
    goto inline$BDLCleanupNotificationStruct$0$label_52#1;

  inline$BDLCleanupNotificationStruct$0$label_52#1:
    inline$BDLCleanupNotificationStruct$0$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$0$$result.KfRaiseIrql$3141.8$12$;
    goto inline$BDLCleanupNotificationStruct$0$label_53#1;

  inline$BDLCleanupNotificationStruct$0$label_53#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_1;
    assume inline$BDLCleanupNotificationStruct$0$myNondetVar_0 == inline$BDLCleanupNotificationStruct$0$myNondetVar_1;
    goto inline$storm_KeAcquireSpinLock$0$Entry#1;

  inline$storm_KeAcquireSpinLock$0$Entry#1:
    inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$storm_KeAcquireSpinLock$0$start#1;

  inline$storm_KeAcquireSpinLock$0$start#1:
    inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1;
    goto inline$storm_KeAcquireSpinLock$0$label_3#1;

  inline$storm_KeAcquireSpinLock$0$label_3#1:
    goto inline$storm_KeAcquireSpinLock$0$label_4#1;

  inline$storm_KeAcquireSpinLock$0$label_4#1:
    goto inline$storm_getThreadID$0$Entry#1;

  inline$storm_getThreadID$0$Entry#1:
    goto inline$storm_getThreadID$0$anon0#1;

  inline$storm_getThreadID$0$anon0#1:
    inline$storm_getThreadID$0$tid := __storm_thread_id;
    goto inline$storm_getThreadID$0$Return#1;

  inline$storm_getThreadID$0$Return#1:
    inline$storm_KeAcquireSpinLock$0$$result.storm_getThreadID$128.29$1$ := inline$storm_getThreadID$0$tid;
    goto inline$storm_KeAcquireSpinLock$0$label_4$1#1;

  inline$storm_KeAcquireSpinLock$0$label_4$1#1:
    goto inline$storm_KeAcquireSpinLock$0$label_7#1;

  inline$storm_KeAcquireSpinLock$0$label_7#1:
    inline$storm_KeAcquireSpinLock$0$$tid$3$128.6$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$0$$result.storm_getThreadID$128.29$1$;
    goto inline$storm_KeAcquireSpinLock$0$label_8#1;

  inline$storm_KeAcquireSpinLock$0$label_8#1:
    goto inline$storm_KeAcquireSpinLock$0$label_9#1;

  inline$storm_KeAcquireSpinLock$0$label_9#1:
    __storm_atomic := true;
    goto inline$storm_KeAcquireSpinLock$0$label_12#1;

  inline$storm_KeAcquireSpinLock$0$label_12#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$0$anon7_Then#1, inline$storm_KeAcquireSpinLock$0$anon7_Else#1;

  inline$storm_KeAcquireSpinLock$0$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$0$anon1#1;

  inline$storm_KeAcquireSpinLock$0$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8], inline$storm_KeAcquireSpinLock$0$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$0$label_13#1;

  inline$storm_KeAcquireSpinLock$0$label_13#1:
    goto inline$storm_KeAcquireSpinLock$0$label_13_true#1, inline$storm_KeAcquireSpinLock$0$label_13_false#1;

  inline$storm_KeAcquireSpinLock$0$label_13_false#1:
    assume !INT_NEQ(inline$storm_KeAcquireSpinLock$0$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$0$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$0$label_14#1;

  inline$storm_KeAcquireSpinLock$0$label_14#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeAcquireSpinLock$0$label_1#1;

  inline$storm_KeAcquireSpinLock$0$label_13_true#1:
    assume INT_NEQ(inline$storm_KeAcquireSpinLock$0$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$0$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$0$label_17#1;

  inline$storm_KeAcquireSpinLock$0$label_17#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$0$anon8_Then#1, inline$storm_KeAcquireSpinLock$0$anon8_Else#1;

  inline$storm_KeAcquireSpinLock$0$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$0$anon4#1;

  inline$storm_KeAcquireSpinLock$0$anon4#1:
    assume INT_EQ(inline$storm_KeAcquireSpinLock$0$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8, 0);
    goto inline$storm_KeAcquireSpinLock$0$label_18#1;

  inline$storm_KeAcquireSpinLock$0$label_18#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeAcquireSpinLock$0$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$0$$tid$3$128.6$storm_KeAcquireSpinLock$8];
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$0$label_19#1;

  inline$storm_KeAcquireSpinLock$0$label_19#1:
    goto inline$storm_KeAcquireSpinLock$0$anon9_Then#1, inline$storm_KeAcquireSpinLock$0$anon9_Else#1;

  inline$storm_KeAcquireSpinLock$0$anon9_Else#1:
    assume __storm_init;
    goto inline$storm_KeAcquireSpinLock$0$anon6#1;

  inline$storm_KeAcquireSpinLock$0$anon9_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeAcquireSpinLock$0$anon6#1;

  inline$storm_KeAcquireSpinLock$0$anon6#1:
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$0$label_1#1;

  inline$storm_KeAcquireSpinLock$0$label_1#1:
    goto inline$storm_KeAcquireSpinLock$0$Return#1;

  inline$storm_KeAcquireSpinLock$0$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$0$Return#1;

  inline$storm_KeAcquireSpinLock$0$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$0$Return#1;

  inline$storm_KeAcquireSpinLock$0$Return#1:
    goto inline$BDLCleanupNotificationStruct$0$label_53$1#1;

  inline$BDLCleanupNotificationStruct$0$label_53$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon51_Then#1, inline$BDLCleanupNotificationStruct$0$anon51_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon11#1;

  inline$BDLCleanupNotificationStruct$0$anon11#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$0$label_56#1;

  inline$BDLCleanupNotificationStruct$0$label_56#1:
    goto inline$IsListEmpty$1$Entry#1;

  inline$IsListEmpty$1$Entry#1:
    inline$IsListEmpty$1$$ListHead$1$8097.28$IsListEmpty$4_.1 := ControlChangeRegistrationList__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$IsListEmpty$1$start#1;

  inline$IsListEmpty$1$start#1:
    inline$IsListEmpty$1$$ListHead$1$8097.28$IsListEmpty$4 := inline$IsListEmpty$1$$ListHead$1$8097.28$IsListEmpty$4_.1;
    goto inline$IsListEmpty$1$label_3#1;

  inline$IsListEmpty$1$label_3#1:
    havoc inline$IsListEmpty$1$myNondetVar_0;
    inline$IsListEmpty$1$$result.IsListEmpty$8096.0$1$ := LIFT(INT_EQ(inline$IsListEmpty$1$myNondetVar_0, inline$IsListEmpty$1$$ListHead$1$8097.28$IsListEmpty$4));
    goto inline$IsListEmpty$1$label_1#1;

  inline$IsListEmpty$1$label_1#1:
    goto inline$IsListEmpty$1$Return#1;

  inline$IsListEmpty$1$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3144.23$13$ := inline$IsListEmpty$1$$result.IsListEmpty$8096.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_56$1#1;

  inline$BDLCleanupNotificationStruct$0$label_56$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon52_Then#1, inline$BDLCleanupNotificationStruct$0$anon52_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon13#1;

  inline$BDLCleanupNotificationStruct$0$anon13#1:
    goto inline$BDLCleanupNotificationStruct$0$label_59#1;

  inline$BDLCleanupNotificationStruct$0$label_59#1:
    goto inline$BDLCleanupNotificationStruct$0$label_59_true#1, inline$BDLCleanupNotificationStruct$0$label_59_false#1;

  inline$BDLCleanupNotificationStruct$0$label_59_false#1:
    assume inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3144.23$13$ == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_60#1;

  inline$BDLCleanupNotificationStruct$0$label_60#1:
    goto inline$RemoveHeadList$0$Entry#1;

  inline$RemoveHeadList$0$Entry#1:
    goto inline$RemoveHeadList$0$start#1;

  inline$RemoveHeadList$0$start#1:
    goto inline$RemoveHeadList$0$label_3#1;

  inline$RemoveHeadList$0$label_3#1:
    goto inline$RemoveHeadList$0$label_4#1;

  inline$RemoveHeadList$0$label_4#1:
    goto inline$RemoveHeadList$0$label_5#1;

  inline$RemoveHeadList$0$label_5#1:
    havoc inline$RemoveHeadList$0$myNondetVar_0;
    inline$RemoveHeadList$0$$Entry$3$8126.16$RemoveHeadList$4 := inline$RemoveHeadList$0$myNondetVar_0;
    goto inline$RemoveHeadList$0$label_6#1;

  inline$RemoveHeadList$0$label_6#1:
    havoc inline$RemoveHeadList$0$myNondetVar_0;
    goto inline$RemoveHeadList$0$label_7#1;

  inline$RemoveHeadList$0$label_7#1:
    goto inline$RemoveHeadList$0$label_8#1;

  inline$RemoveHeadList$0$label_8#1:
    goto inline$RemoveHeadList$0$label_9#1;

  inline$RemoveHeadList$0$label_9#1:
    inline$RemoveHeadList$0$$result.RemoveHeadList$8121.0$1$ := inline$RemoveHeadList$0$$Entry$3$8126.16$RemoveHeadList$4;
    goto inline$RemoveHeadList$0$label_1#1;

  inline$RemoveHeadList$0$label_1#1:
    goto inline$RemoveHeadList$0$Return#1;

  inline$RemoveHeadList$0$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.RemoveHeadList$3153.26$14$ := inline$RemoveHeadList$0$$result.RemoveHeadList$8121.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_60$1#1;

  inline$BDLCleanupNotificationStruct$0$label_60$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon53_Then#1, inline$BDLCleanupNotificationStruct$0$anon53_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon15#1;

  inline$BDLCleanupNotificationStruct$0$anon15#1:
    goto inline$BDLCleanupNotificationStruct$0$label_63#1;

  inline$BDLCleanupNotificationStruct$0$label_63#1:
    inline$BDLCleanupNotificationStruct$0$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$0$$result.RemoveHeadList$3153.26$14$;
    goto inline$BDLCleanupNotificationStruct$0$label_64#1;

  inline$BDLCleanupNotificationStruct$0$label_64#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_1;
    assume inline$BDLCleanupNotificationStruct$0$myNondetVar_0 == inline$BDLCleanupNotificationStruct$0$myNondetVar_1;
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$storm_KeReleaseSpinLock$0$Entry#1;

  inline$storm_KeReleaseSpinLock$0$Entry#1:
    inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$storm_KeReleaseSpinLock$0$start#1;

  inline$storm_KeReleaseSpinLock$0$start#1:
    inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$0$label_3#1;

  inline$storm_KeReleaseSpinLock$0$label_3#1:
    goto inline$storm_KeReleaseSpinLock$0$label_4#1;

  inline$storm_KeReleaseSpinLock$0$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$0$label_7#1;

  inline$storm_KeReleaseSpinLock$0$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$0$anon5_Then#1, inline$storm_KeReleaseSpinLock$0$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$0$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$0$anon1#1;

  inline$storm_KeReleaseSpinLock$0$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$0$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$0$label_8#1;

  inline$storm_KeReleaseSpinLock$0$label_8#1:
    goto inline$storm_getThreadID$1$Entry#1;

  inline$storm_getThreadID$1$Entry#1:
    goto inline$storm_getThreadID$1$anon0#1;

  inline$storm_getThreadID$1$anon0#1:
    inline$storm_getThreadID$1$tid := __storm_thread_id;
    goto inline$storm_getThreadID$1$Return#1;

  inline$storm_getThreadID$1$Return#1:
    inline$storm_KeReleaseSpinLock$0$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$1$tid;
    goto inline$storm_KeReleaseSpinLock$0$label_8$1#1;

  inline$storm_KeReleaseSpinLock$0$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$0$label_11#1;

  inline$storm_KeReleaseSpinLock$0$label_11#1:
    goto inline$storm_KeReleaseSpinLock$0$label_11_true#1, inline$storm_KeReleaseSpinLock$0$label_11_false#1;

  inline$storm_KeReleaseSpinLock$0$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$0$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$0$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$0$label_12#1;

  inline$storm_KeReleaseSpinLock$0$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$0$label_1#1;

  inline$storm_KeReleaseSpinLock$0$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$0$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$0$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$0$label_15#1;

  inline$storm_KeReleaseSpinLock$0$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$0$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$0$label_16#1;

  inline$storm_KeReleaseSpinLock$0$label_16#1:
    goto inline$storm_KeReleaseSpinLock$0$anon6_Then#1, inline$storm_KeReleaseSpinLock$0$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$0$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$0$anon4#1;

  inline$storm_KeReleaseSpinLock$0$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$0$anon4#1;

  inline$storm_KeReleaseSpinLock$0$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$0$label_1#1;

  inline$storm_KeReleaseSpinLock$0$label_1#1:
    goto inline$storm_KeReleaseSpinLock$0$Return#1;

  inline$storm_KeReleaseSpinLock$0$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$0$Return#1;

  inline$storm_KeReleaseSpinLock$0$Return#1:
    goto inline$BDLCleanupNotificationStruct$0$label_64$1#1;

  inline$BDLCleanupNotificationStruct$0$label_64$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon54_Then#1, inline$BDLCleanupNotificationStruct$0$anon54_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon54_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon17#1;

  inline$BDLCleanupNotificationStruct$0$anon17#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$0$label_67#1;

  inline$BDLCleanupNotificationStruct$0$label_67#1:
    call KfLowerIrql(inline$BDLCleanupNotificationStruct$0$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4);
    goto inline$BDLCleanupNotificationStruct$0$anon55_Then#1, inline$BDLCleanupNotificationStruct$0$anon55_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon55_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon19#1;

  inline$BDLCleanupNotificationStruct$0$anon19#1:
    goto inline$BDLCleanupNotificationStruct$0$label_70#1;

  inline$BDLCleanupNotificationStruct$0$label_70#1:
    inline$BDLCleanupNotificationStruct$0$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4 := MINUS_LEFT_PTR(inline$BDLCleanupNotificationStruct$0$$pRegistrationListEntry$9$3119.36$BDLCleanupNotificationStruct$4, 1, 12);
    goto inline$BDLCleanupNotificationStruct$0$label_71#1;

  inline$BDLCleanupNotificationStruct$0$label_71#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$0$label_72#1;

  inline$BDLCleanupNotificationStruct$0$label_72#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$0$label_73#1;

  inline$BDLCleanupNotificationStruct$0$label_73#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$0$label_74#1;

  inline$BDLCleanupNotificationStruct$0$label_74#1:
    call ExFreePoolWithTag(inline$BDLCleanupNotificationStruct$0$$pControlChangeRegistration$8$3118.37$BDLCleanupNotificationStruct$4, 541869122);
    goto inline$BDLCleanupNotificationStruct$0$anon56_Then#1, inline$BDLCleanupNotificationStruct$0$anon56_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon56_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon21#1;

  inline$BDLCleanupNotificationStruct$0$anon21#1:
    goto inline$BDLCleanupNotificationStruct$0$label_77#1;

  inline$BDLCleanupNotificationStruct$0$label_77#1:
    goto inline$BDLCleanupNotificationStruct$0$label_80#1;

  inline$BDLCleanupNotificationStruct$0$label_80#1:
    inline$BDLCleanupNotificationStruct$0$$status$11$3121.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$0$$callresult.$3172.84$15$;
    goto inline$BDLCleanupNotificationStruct$0$label_81#1;

  inline$BDLCleanupNotificationStruct$0$label_81#1:
    goto inline$BDLCleanupNotificationStruct$0$label_81_true#1, inline$BDLCleanupNotificationStruct$0$label_81_false#1;

  inline$BDLCleanupNotificationStruct$0$label_81_false#1:
    assume inline$BDLCleanupNotificationStruct$0$$status$11$3121.36$BDLCleanupNotificationStruct$4 == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_45_head#0;

  inline$BDLCleanupNotificationStruct$0$label_81_true#1:
    assume inline$BDLCleanupNotificationStruct$0$$status$11$3121.36$BDLCleanupNotificationStruct$4 != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_82#1;

  inline$BDLCleanupNotificationStruct$0$label_82#1:
    goto inline$BDLGetDebugLevel$214$Entry#1;

  inline$BDLGetDebugLevel$214$Entry#1:
    goto inline$BDLGetDebugLevel$214$start#1;

  inline$BDLGetDebugLevel$214$start#1:
    goto inline$BDLGetDebugLevel$214$label_3#1;

  inline$BDLGetDebugLevel$214$label_3#1:
    havoc inline$BDLGetDebugLevel$214$myNondetVar_0;
    inline$BDLGetDebugLevel$214$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$214$myNondetVar_0;
    goto inline$BDLGetDebugLevel$214$label_1#1;

  inline$BDLGetDebugLevel$214$label_1#1:
    goto inline$BDLGetDebugLevel$214$Return#1;

  inline$BDLGetDebugLevel$214$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$16$ := inline$BDLGetDebugLevel$214$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_82$1#1;

  inline$BDLCleanupNotificationStruct$0$label_82$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon57_Then#1, inline$BDLCleanupNotificationStruct$0$anon57_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon57_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon23#1;

  inline$BDLCleanupNotificationStruct$0$anon23#1:
    goto inline$BDLCleanupNotificationStruct$0$label_85#1;

  inline$BDLCleanupNotificationStruct$0$label_85#1:
    goto inline$BDLCleanupNotificationStruct$0$label_85_true#1, inline$BDLCleanupNotificationStruct$0$label_85_false#1;

  inline$BDLCleanupNotificationStruct$0$label_85_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$16$) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_86#1;

  inline$BDLCleanupNotificationStruct$0$label_85_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$16$) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_89#1;

  inline$BDLCleanupNotificationStruct$0$label_89#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_90#1;

  inline$BDLCleanupNotificationStruct$0$label_90#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_91#1;

  inline$BDLCleanupNotificationStruct$0$label_91#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_92#1;

  inline$BDLCleanupNotificationStruct$0$label_92#1:
    havoc inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3178.0$17$;
    goto inline$BDLCleanupNotificationStruct$0$label_86#1;

  inline$BDLCleanupNotificationStruct$0$label_86#1:
    goto inline$BDLGetDebugLevel$215$Entry#1;

  inline$BDLGetDebugLevel$215$Entry#1:
    goto inline$BDLGetDebugLevel$215$start#1;

  inline$BDLGetDebugLevel$215$start#1:
    goto inline$BDLGetDebugLevel$215$label_3#1;

  inline$BDLGetDebugLevel$215$label_3#1:
    havoc inline$BDLGetDebugLevel$215$myNondetVar_0;
    inline$BDLGetDebugLevel$215$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$215$myNondetVar_0;
    goto inline$BDLGetDebugLevel$215$label_1#1;

  inline$BDLGetDebugLevel$215$label_1#1:
    goto inline$BDLGetDebugLevel$215$Return#1;

  inline$BDLGetDebugLevel$215$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$21$ := inline$BDLGetDebugLevel$215$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_86$1#1;

  inline$BDLCleanupNotificationStruct$0$label_86$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon58_Then#1, inline$BDLCleanupNotificationStruct$0$anon58_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon58_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon25#1;

  inline$BDLCleanupNotificationStruct$0$anon25#1:
    goto inline$BDLCleanupNotificationStruct$0$label_95#1;

  inline$BDLCleanupNotificationStruct$0$label_95#1:
    goto inline$BDLCleanupNotificationStruct$0$label_95_true#1, inline$BDLCleanupNotificationStruct$0$label_95_false#1;

  inline$BDLCleanupNotificationStruct$0$label_95_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$21$) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_96#1;

  inline$BDLCleanupNotificationStruct$0$label_95_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$21$) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_99#1;

  inline$BDLCleanupNotificationStruct$0$label_99#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_100#1;

  inline$BDLCleanupNotificationStruct$0$label_100#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_101#1;

  inline$BDLCleanupNotificationStruct$0$label_101#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_102#1;

  inline$BDLCleanupNotificationStruct$0$label_102#1:
    havoc inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3178.0$22$;
    goto inline$BDLCleanupNotificationStruct$0$label_96#1;

  inline$BDLCleanupNotificationStruct$0$label_96#1:
    goto inline$BDLGetDebugLevel$216$Entry#1;

  inline$BDLGetDebugLevel$216$Entry#1:
    goto inline$BDLGetDebugLevel$216$start#1;

  inline$BDLGetDebugLevel$216$start#1:
    goto inline$BDLGetDebugLevel$216$label_3#1;

  inline$BDLGetDebugLevel$216$label_3#1:
    havoc inline$BDLGetDebugLevel$216$myNondetVar_0;
    inline$BDLGetDebugLevel$216$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$216$myNondetVar_0;
    goto inline$BDLGetDebugLevel$216$label_1#1;

  inline$BDLGetDebugLevel$216$label_1#1:
    goto inline$BDLGetDebugLevel$216$Return#1;

  inline$BDLGetDebugLevel$216$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$26$ := inline$BDLGetDebugLevel$216$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_96$1#1;

  inline$BDLCleanupNotificationStruct$0$label_96$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon59_Then#1, inline$BDLCleanupNotificationStruct$0$anon59_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon59_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon27#1;

  inline$BDLCleanupNotificationStruct$0$anon27#1:
    goto inline$BDLCleanupNotificationStruct$0$label_105#1;

  inline$BDLCleanupNotificationStruct$0$label_105#1:
    goto inline$BDLCleanupNotificationStruct$0$label_105_true#1, inline$BDLCleanupNotificationStruct$0$label_105_false#1;

  inline$BDLCleanupNotificationStruct$0$label_105_false#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$26$, 4) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_45_head#0;

  inline$BDLCleanupNotificationStruct$0$label_105_true#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3178.0$26$, 4) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_106#1;

  inline$BDLCleanupNotificationStruct$0$label_106#1:
    goto inline$BDLCleanupNotificationStruct$0$label_45_head#0;

  inline$BDLCleanupNotificationStruct$0$label_45_head#0:
    assume false;
    return;

  inline$BDLCleanupNotificationStruct$0$anon59_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon58_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon57_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon56_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon55_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon54_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon53_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$label_59_true#1:
    assume inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3144.23$13$ != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_46#1;

  inline$BDLCleanupNotificationStruct$0$label_46#1:
    goto inline$BDLCleanupNotificationStruct$0$label_46_head#1;

  inline$BDLCleanupNotificationStruct$0$label_46_head#1:
    goto inline$IsListEmpty$0$Entry#1;

  inline$IsListEmpty$0$Entry#1:
    inline$IsListEmpty$0$$ListHead$1$8097.28$IsListEmpty$4_.1 := ISRControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$IsListEmpty$0$start#1;

  inline$IsListEmpty$0$start#1:
    inline$IsListEmpty$0$$ListHead$1$8097.28$IsListEmpty$4 := inline$IsListEmpty$0$$ListHead$1$8097.28$IsListEmpty$4_.1;
    goto inline$IsListEmpty$0$label_3#1;

  inline$IsListEmpty$0$label_3#1:
    havoc inline$IsListEmpty$0$myNondetVar_0;
    inline$IsListEmpty$0$$result.IsListEmpty$8096.0$1$ := LIFT(INT_EQ(inline$IsListEmpty$0$myNondetVar_0, inline$IsListEmpty$0$$ListHead$1$8097.28$IsListEmpty$4));
    goto inline$IsListEmpty$0$label_1#1;

  inline$IsListEmpty$0$label_1#1:
    goto inline$IsListEmpty$0$Return#1;

  inline$IsListEmpty$0$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3199.23$27$ := inline$IsListEmpty$0$$result.IsListEmpty$8096.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_46_head$1#1;

  inline$BDLCleanupNotificationStruct$0$label_46_head$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon49_Then#1, inline$BDLCleanupNotificationStruct$0$anon49_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon7#1;

  inline$BDLCleanupNotificationStruct$0$anon7#1:
    goto inline$BDLCleanupNotificationStruct$0$label_107#1;

  inline$BDLCleanupNotificationStruct$0$label_107#1:
    goto inline$BDLCleanupNotificationStruct$0$label_107_true#1, inline$BDLCleanupNotificationStruct$0$label_107_false#1;

  inline$BDLCleanupNotificationStruct$0$label_107_false#1:
    assume inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3199.23$27$ == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_108#1;

  inline$BDLCleanupNotificationStruct$0$label_108#1:
    goto inline$RemoveHeadList$1$Entry#1;

  inline$RemoveHeadList$1$Entry#1:
    goto inline$RemoveHeadList$1$start#1;

  inline$RemoveHeadList$1$start#1:
    goto inline$RemoveHeadList$1$label_3#1;

  inline$RemoveHeadList$1$label_3#1:
    goto inline$RemoveHeadList$1$label_4#1;

  inline$RemoveHeadList$1$label_4#1:
    goto inline$RemoveHeadList$1$label_5#1;

  inline$RemoveHeadList$1$label_5#1:
    havoc inline$RemoveHeadList$1$myNondetVar_0;
    goto inline$RemoveHeadList$1$label_6#1;

  inline$RemoveHeadList$1$label_6#1:
    havoc inline$RemoveHeadList$1$myNondetVar_0;
    goto inline$RemoveHeadList$1$label_7#1;

  inline$RemoveHeadList$1$label_7#1:
    goto inline$RemoveHeadList$1$label_8#1;

  inline$RemoveHeadList$1$label_8#1:
    goto inline$RemoveHeadList$1$label_9#1;

  inline$RemoveHeadList$1$label_9#1:
    goto inline$RemoveHeadList$1$label_1#1;

  inline$RemoveHeadList$1$label_1#1:
    goto inline$RemoveHeadList$1$Return#1;

  inline$RemoveHeadList$1$Return#1:
    goto inline$BDLCleanupNotificationStruct$0$label_108$1#1;

  inline$BDLCleanupNotificationStruct$0$label_108$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon60_Then#1, inline$BDLCleanupNotificationStruct$0$anon60_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon60_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon29#1;

  inline$BDLCleanupNotificationStruct$0$anon29#1:
    goto inline$BDLCleanupNotificationStruct$0$label_154#1;

  inline$BDLCleanupNotificationStruct$0$label_154#1:
    goto inline$BDLCleanupNotificationStruct$0$label_155#1;

  inline$BDLCleanupNotificationStruct$0$label_155#1:
    goto inline$BDLCleanupNotificationStruct$0$label_156#1;

  inline$BDLCleanupNotificationStruct$0$label_156#1:
    goto inline$BDLCleanupNotificationStruct$0$label_46_head#0;

  inline$BDLCleanupNotificationStruct$0$label_46_head#0:
    assume false;
    return;

  inline$BDLCleanupNotificationStruct$0$anon60_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$label_107_true#1:
    assume inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3199.23$27$ != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_111#1;

  inline$BDLCleanupNotificationStruct$0$label_111#1:
    goto inline$BDLCleanupNotificationStruct$0$label_111_head#1;

  inline$BDLCleanupNotificationStruct$0$label_111_head#1:
    goto inline$IsListEmpty$2$Entry#1;

  inline$IsListEmpty$2$Entry#1:
    inline$IsListEmpty$2$$ListHead$1$8097.28$IsListEmpty$4_.1 := IOCTLControlChangeQueue__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$IsListEmpty$2$start#1;

  inline$IsListEmpty$2$start#1:
    inline$IsListEmpty$2$$ListHead$1$8097.28$IsListEmpty$4 := inline$IsListEmpty$2$$ListHead$1$8097.28$IsListEmpty$4_.1;
    goto inline$IsListEmpty$2$label_3#1;

  inline$IsListEmpty$2$label_3#1:
    havoc inline$IsListEmpty$2$myNondetVar_0;
    inline$IsListEmpty$2$$result.IsListEmpty$8096.0$1$ := LIFT(INT_EQ(inline$IsListEmpty$2$myNondetVar_0, inline$IsListEmpty$2$$ListHead$1$8097.28$IsListEmpty$4));
    goto inline$IsListEmpty$2$label_1#1;

  inline$IsListEmpty$2$label_1#1:
    goto inline$IsListEmpty$2$Return#1;

  inline$IsListEmpty$2$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3215.23$29$ := inline$IsListEmpty$2$$result.IsListEmpty$8096.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_111_head$1#1;

  inline$BDLCleanupNotificationStruct$0$label_111_head$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon61_Then#1, inline$BDLCleanupNotificationStruct$0$anon61_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon61_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon31#1;

  inline$BDLCleanupNotificationStruct$0$anon31#1:
    goto inline$BDLCleanupNotificationStruct$0$label_114#1;

  inline$BDLCleanupNotificationStruct$0$label_114#1:
    goto inline$BDLCleanupNotificationStruct$0$label_114_true#1, inline$BDLCleanupNotificationStruct$0$label_114_false#1;

  inline$BDLCleanupNotificationStruct$0$label_114_false#1:
    assume inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3215.23$29$ == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_115#1;

  inline$BDLCleanupNotificationStruct$0$label_115#1:
    goto inline$RemoveHeadList$2$Entry#1;

  inline$RemoveHeadList$2$Entry#1:
    goto inline$RemoveHeadList$2$start#1;

  inline$RemoveHeadList$2$start#1:
    goto inline$RemoveHeadList$2$label_3#1;

  inline$RemoveHeadList$2$label_3#1:
    goto inline$RemoveHeadList$2$label_4#1;

  inline$RemoveHeadList$2$label_4#1:
    goto inline$RemoveHeadList$2$label_5#1;

  inline$RemoveHeadList$2$label_5#1:
    havoc inline$RemoveHeadList$2$myNondetVar_0;
    inline$RemoveHeadList$2$$Entry$3$8126.16$RemoveHeadList$4 := inline$RemoveHeadList$2$myNondetVar_0;
    goto inline$RemoveHeadList$2$label_6#1;

  inline$RemoveHeadList$2$label_6#1:
    havoc inline$RemoveHeadList$2$myNondetVar_0;
    goto inline$RemoveHeadList$2$label_7#1;

  inline$RemoveHeadList$2$label_7#1:
    goto inline$RemoveHeadList$2$label_8#1;

  inline$RemoveHeadList$2$label_8#1:
    goto inline$RemoveHeadList$2$label_9#1;

  inline$RemoveHeadList$2$label_9#1:
    inline$RemoveHeadList$2$$result.RemoveHeadList$8121.0$1$ := inline$RemoveHeadList$2$$Entry$3$8126.16$RemoveHeadList$4;
    goto inline$RemoveHeadList$2$label_1#1;

  inline$RemoveHeadList$2$label_1#1:
    goto inline$RemoveHeadList$2$Return#1;

  inline$RemoveHeadList$2$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.RemoveHeadList$3218.26$30$ := inline$RemoveHeadList$2$$result.RemoveHeadList$8121.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_115$1#1;

  inline$BDLCleanupNotificationStruct$0$label_115$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon62_Then#1, inline$BDLCleanupNotificationStruct$0$anon62_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon62_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon33#1;

  inline$BDLCleanupNotificationStruct$0$anon33#1:
    goto inline$BDLCleanupNotificationStruct$0$label_149#1;

  inline$BDLCleanupNotificationStruct$0$label_149#1:
    inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4 := inline$BDLCleanupNotificationStruct$0$$result.RemoveHeadList$3218.26$30$;
    goto inline$BDLCleanupNotificationStruct$0$label_150#1;

  inline$BDLCleanupNotificationStruct$0$label_150#1:
    inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4 := MINUS_LEFT_PTR(inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeEntry$7$3117.36$BDLCleanupNotificationStruct$4, 1, 16);
    goto inline$BDLCleanupNotificationStruct$0$label_151#1;

  inline$BDLCleanupNotificationStruct$0$label_151#1:
    call ExFreePoolWithTag(inline$BDLCleanupNotificationStruct$0$$pIOCTLControlChangeItem$6$3116.37$BDLCleanupNotificationStruct$4, 541869122);
    goto inline$BDLCleanupNotificationStruct$0$anon68_Then#1, inline$BDLCleanupNotificationStruct$0$anon68_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon68_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon45#1;

  inline$BDLCleanupNotificationStruct$0$anon45#1:
    goto inline$BDLCleanupNotificationStruct$0$label_111_head#0;

  inline$BDLCleanupNotificationStruct$0$label_111_head#0:
    assume false;
    return;

  inline$BDLCleanupNotificationStruct$0$anon68_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon62_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$label_114_true#1:
    assume inline$BDLCleanupNotificationStruct$0$$result.IsListEmpty$3215.23$29$ != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_118#1;

  inline$BDLCleanupNotificationStruct$0$label_118#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_1;
    assume inline$BDLCleanupNotificationStruct$0$myNondetVar_0 == inline$BDLCleanupNotificationStruct$0$myNondetVar_1;
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$storm_KeReleaseSpinLock$1$Entry#1;

  inline$storm_KeReleaseSpinLock$1$Entry#1:
    inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := ControlChangeLock__BDL_CONTROL_CHANGE_STRUCT(ControlChangeStruct__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLCleanupNotificationStruct$0$$pBDLExtension$1$3110.40$BDLCleanupNotificationStruct$4));
    goto inline$storm_KeReleaseSpinLock$1$start#1;

  inline$storm_KeReleaseSpinLock$1$start#1:
    inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$1$label_3#1;

  inline$storm_KeReleaseSpinLock$1$label_3#1:
    goto inline$storm_KeReleaseSpinLock$1$label_4#1;

  inline$storm_KeReleaseSpinLock$1$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$1$label_7#1;

  inline$storm_KeReleaseSpinLock$1$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$1$anon5_Then#1, inline$storm_KeReleaseSpinLock$1$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$1$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$1$anon1#1;

  inline$storm_KeReleaseSpinLock$1$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$1$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$1$label_8#1;

  inline$storm_KeReleaseSpinLock$1$label_8#1:
    goto inline$storm_getThreadID$2$Entry#1;

  inline$storm_getThreadID$2$Entry#1:
    goto inline$storm_getThreadID$2$anon0#1;

  inline$storm_getThreadID$2$anon0#1:
    inline$storm_getThreadID$2$tid := __storm_thread_id;
    goto inline$storm_getThreadID$2$Return#1;

  inline$storm_getThreadID$2$Return#1:
    inline$storm_KeReleaseSpinLock$1$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$2$tid;
    goto inline$storm_KeReleaseSpinLock$1$label_8$1#1;

  inline$storm_KeReleaseSpinLock$1$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$1$label_11#1;

  inline$storm_KeReleaseSpinLock$1$label_11#1:
    goto inline$storm_KeReleaseSpinLock$1$label_11_true#1, inline$storm_KeReleaseSpinLock$1$label_11_false#1;

  inline$storm_KeReleaseSpinLock$1$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$1$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$1$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$1$label_12#1;

  inline$storm_KeReleaseSpinLock$1$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$1$label_1#1;

  inline$storm_KeReleaseSpinLock$1$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$1$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$1$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$1$label_15#1;

  inline$storm_KeReleaseSpinLock$1$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$1$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$1$label_16#1;

  inline$storm_KeReleaseSpinLock$1$label_16#1:
    goto inline$storm_KeReleaseSpinLock$1$anon6_Then#1, inline$storm_KeReleaseSpinLock$1$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$1$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$1$anon4#1;

  inline$storm_KeReleaseSpinLock$1$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$1$anon4#1;

  inline$storm_KeReleaseSpinLock$1$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$1$label_1#1;

  inline$storm_KeReleaseSpinLock$1$label_1#1:
    goto inline$storm_KeReleaseSpinLock$1$Return#1;

  inline$storm_KeReleaseSpinLock$1$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$1$Return#1;

  inline$storm_KeReleaseSpinLock$1$Return#1:
    goto inline$BDLCleanupNotificationStruct$0$label_118$1#1;

  inline$BDLCleanupNotificationStruct$0$label_118$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon63_Then#1, inline$BDLCleanupNotificationStruct$0$anon63_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon63_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon35#1;

  inline$BDLCleanupNotificationStruct$0$anon35#1:
    havoc inline$BDLCleanupNotificationStruct$0$myNondetVar_0;
    goto inline$BDLCleanupNotificationStruct$0$label_121#1;

  inline$BDLCleanupNotificationStruct$0$label_121#1:
    call KfLowerIrql(inline$BDLCleanupNotificationStruct$0$$OldIrql$2$3113.36$BDLCleanupNotificationStruct$4);
    goto inline$BDLCleanupNotificationStruct$0$anon64_Then#1, inline$BDLCleanupNotificationStruct$0$anon64_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon64_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon37#1;

  inline$BDLCleanupNotificationStruct$0$anon37#1:
    goto inline$BDLCleanupNotificationStruct$0$label_124#1;

  inline$BDLCleanupNotificationStruct$0$label_124#1:
    goto inline$BDLGetDebugLevel$217$Entry#1;

  inline$BDLGetDebugLevel$217$Entry#1:
    goto inline$BDLGetDebugLevel$217$start#1;

  inline$BDLGetDebugLevel$217$start#1:
    goto inline$BDLGetDebugLevel$217$label_3#1;

  inline$BDLGetDebugLevel$217$label_3#1:
    havoc inline$BDLGetDebugLevel$217$myNondetVar_0;
    inline$BDLGetDebugLevel$217$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$217$myNondetVar_0;
    goto inline$BDLGetDebugLevel$217$label_1#1;

  inline$BDLGetDebugLevel$217$label_1#1:
    goto inline$BDLGetDebugLevel$217$Return#1;

  inline$BDLGetDebugLevel$217$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$31$ := inline$BDLGetDebugLevel$217$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_124$1#1;

  inline$BDLCleanupNotificationStruct$0$label_124$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon65_Then#1, inline$BDLCleanupNotificationStruct$0$anon65_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon65_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon39#1;

  inline$BDLCleanupNotificationStruct$0$anon39#1:
    goto inline$BDLCleanupNotificationStruct$0$label_127#1;

  inline$BDLCleanupNotificationStruct$0$label_127#1:
    goto inline$BDLCleanupNotificationStruct$0$label_127_true#1, inline$BDLCleanupNotificationStruct$0$label_127_false#1;

  inline$BDLCleanupNotificationStruct$0$label_127_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$31$) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_128#1;

  inline$BDLCleanupNotificationStruct$0$label_127_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$31$) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_131#1;

  inline$BDLCleanupNotificationStruct$0$label_131#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_132#1;

  inline$BDLCleanupNotificationStruct$0$label_132#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_133#1;

  inline$BDLCleanupNotificationStruct$0$label_133#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_134#1;

  inline$BDLCleanupNotificationStruct$0$label_134#1:
    havoc inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3231.0$32$;
    goto inline$BDLCleanupNotificationStruct$0$label_128#1;

  inline$BDLCleanupNotificationStruct$0$label_128#1:
    goto inline$BDLGetDebugLevel$218$Entry#1;

  inline$BDLGetDebugLevel$218$Entry#1:
    goto inline$BDLGetDebugLevel$218$start#1;

  inline$BDLGetDebugLevel$218$start#1:
    goto inline$BDLGetDebugLevel$218$label_3#1;

  inline$BDLGetDebugLevel$218$label_3#1:
    havoc inline$BDLGetDebugLevel$218$myNondetVar_0;
    inline$BDLGetDebugLevel$218$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$218$myNondetVar_0;
    goto inline$BDLGetDebugLevel$218$label_1#1;

  inline$BDLGetDebugLevel$218$label_1#1:
    goto inline$BDLGetDebugLevel$218$Return#1;

  inline$BDLGetDebugLevel$218$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$36$ := inline$BDLGetDebugLevel$218$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_128$1#1;

  inline$BDLCleanupNotificationStruct$0$label_128$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon66_Then#1, inline$BDLCleanupNotificationStruct$0$anon66_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon66_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon41#1;

  inline$BDLCleanupNotificationStruct$0$anon41#1:
    goto inline$BDLCleanupNotificationStruct$0$label_137#1;

  inline$BDLCleanupNotificationStruct$0$label_137#1:
    goto inline$BDLCleanupNotificationStruct$0$label_137_true#1, inline$BDLCleanupNotificationStruct$0$label_137_false#1;

  inline$BDLCleanupNotificationStruct$0$label_137_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$36$) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_138#1;

  inline$BDLCleanupNotificationStruct$0$label_137_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$36$) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_141#1;

  inline$BDLCleanupNotificationStruct$0$label_141#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_142#1;

  inline$BDLCleanupNotificationStruct$0$label_142#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_143#1;

  inline$BDLCleanupNotificationStruct$0$label_143#1:
    call inline$BDLCleanupNotificationStruct$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupNotificationStruct$0$label_144#1;

  inline$BDLCleanupNotificationStruct$0$label_144#1:
    havoc inline$BDLCleanupNotificationStruct$0$$result.DbgPrint$3231.0$37$;
    goto inline$BDLCleanupNotificationStruct$0$label_138#1;

  inline$BDLCleanupNotificationStruct$0$label_138#1:
    goto inline$BDLGetDebugLevel$219$Entry#1;

  inline$BDLGetDebugLevel$219$Entry#1:
    goto inline$BDLGetDebugLevel$219$start#1;

  inline$BDLGetDebugLevel$219$start#1:
    goto inline$BDLGetDebugLevel$219$label_3#1;

  inline$BDLGetDebugLevel$219$label_3#1:
    havoc inline$BDLGetDebugLevel$219$myNondetVar_0;
    inline$BDLGetDebugLevel$219$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$219$myNondetVar_0;
    goto inline$BDLGetDebugLevel$219$label_1#1;

  inline$BDLGetDebugLevel$219$label_1#1:
    goto inline$BDLGetDebugLevel$219$Return#1;

  inline$BDLGetDebugLevel$219$Return#1:
    inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$41$ := inline$BDLGetDebugLevel$219$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupNotificationStruct$0$label_138$1#1;

  inline$BDLCleanupNotificationStruct$0$label_138$1#1:
    goto inline$BDLCleanupNotificationStruct$0$anon67_Then#1, inline$BDLCleanupNotificationStruct$0$anon67_Else#1;

  inline$BDLCleanupNotificationStruct$0$anon67_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupNotificationStruct$0$anon43#1;

  inline$BDLCleanupNotificationStruct$0$anon43#1:
    goto inline$BDLCleanupNotificationStruct$0$label_147#1;

  inline$BDLCleanupNotificationStruct$0$label_147#1:
    goto inline$BDLCleanupNotificationStruct$0$label_147_true#1, inline$BDLCleanupNotificationStruct$0$label_147_false#1;

  inline$BDLCleanupNotificationStruct$0$label_147_false#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$41$, 4) == 0;
    goto inline$BDLCleanupNotificationStruct$0$label_1#1;

  inline$BDLCleanupNotificationStruct$0$label_147_true#1:
    assume BIT_BAND(inline$BDLCleanupNotificationStruct$0$$result.BDLGetDebugLevel$3231.0$41$, 4) != 0;
    goto inline$BDLCleanupNotificationStruct$0$label_148#1;

  inline$BDLCleanupNotificationStruct$0$label_148#1:
    goto inline$BDLCleanupNotificationStruct$0$label_1#1;

  inline$BDLCleanupNotificationStruct$0$label_1#1:
    call __HAVOC_free(inline$BDLCleanupNotificationStruct$0$$bddiRegisterNotifyParams$10$3120.36$BDLCleanupNotificationStruct$4);
    call __HAVOC_free(inline$BDLCleanupNotificationStruct$0$$irql$3$3113.45$BDLCleanupNotificationStruct$4);
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon67_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon66_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon65_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon64_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon63_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon61_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon49_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon52_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon51_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon50_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon48_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon47_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$anon46_Then#1:
    assume raiseException;
    goto inline$BDLCleanupNotificationStruct$0$Return#1;

  inline$BDLCleanupNotificationStruct$0$Return#1:
    goto inline$BDLHandleRemove$0$label_38$1#1;

  inline$BDLHandleRemove$0$label_38$1#1:
    goto inline$BDLHandleRemove$0$anon47_Then#1, inline$BDLHandleRemove$0$anon47_Else#1;

  inline$BDLHandleRemove$0$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon11#1;

  inline$BDLHandleRemove$0$anon11#1:
    goto inline$BDLHandleRemove$0$label_41#1;

  inline$BDLHandleRemove$0$label_41#1:
    goto inline$BDLCleanupDataHandles$0$Entry#1;

  inline$BDLCleanupDataHandles$0$Entry#1:
    inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4_.1 := inline$BDLHandleRemove$0$$pBDLExtension$1$2378.40$BDLHandleRemove$12;
    goto inline$BDLCleanupDataHandles$0$start#1;

  inline$BDLCleanupDataHandles$0$start#1:
    call inline$BDLCleanupDataHandles$0$$bddDataHandle$4$3247.28$BDLCleanupDataHandles$4 := __HAVOC_malloc(4);
    call inline$BDLCleanupDataHandles$0$$bddiCloseHandleParams$5$3248.28$BDLCleanupDataHandles$4 := __HAVOC_malloc(8);
    call inline$BDLCleanupDataHandles$0$$irql$6$3249.28$BDLCleanupDataHandles$4 := __HAVOC_malloc(1);
    inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4 := inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4_.1;
    goto inline$BDLCleanupDataHandles$0$label_3#1;

  inline$BDLCleanupDataHandles$0$label_3#1:
    goto inline$BDLCleanupDataHandles$0$label_4#1;

  inline$BDLCleanupDataHandles$0$label_4#1:
    goto inline$BDLCleanupDataHandles$0$label_5#1;

  inline$BDLCleanupDataHandles$0$label_5#1:
    inline$BDLCleanupDataHandles$0$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4 := 0;
    goto inline$BDLCleanupDataHandles$0$label_6#1;

  inline$BDLCleanupDataHandles$0$label_6#1:
    goto inline$BDLCleanupDataHandles$0$label_7#1;

  inline$BDLCleanupDataHandles$0$label_7#1:
    goto inline$BDLCleanupDataHandles$0$label_8#1;

  inline$BDLCleanupDataHandles$0$label_8#1:
    goto inline$BDLCleanupDataHandles$0$label_9#1;

  inline$BDLCleanupDataHandles$0$label_9#1:
    goto inline$BDLGetDebugLevel$220$Entry#1;

  inline$BDLGetDebugLevel$220$Entry#1:
    goto inline$BDLGetDebugLevel$220$start#1;

  inline$BDLGetDebugLevel$220$start#1:
    goto inline$BDLGetDebugLevel$220$label_3#1;

  inline$BDLGetDebugLevel$220$label_3#1:
    havoc inline$BDLGetDebugLevel$220$myNondetVar_0;
    inline$BDLGetDebugLevel$220$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$220$myNondetVar_0;
    goto inline$BDLGetDebugLevel$220$label_1#1;

  inline$BDLGetDebugLevel$220$label_1#1:
    goto inline$BDLGetDebugLevel$220$Return#1;

  inline$BDLGetDebugLevel$220$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$1$ := inline$BDLGetDebugLevel$220$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_9$1#1;

  inline$BDLCleanupDataHandles$0$label_9$1#1:
    goto inline$BDLCleanupDataHandles$0$anon30_Then#1, inline$BDLCleanupDataHandles$0$anon30_Else#1;

  inline$BDLCleanupDataHandles$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon1#1;

  inline$BDLCleanupDataHandles$0$anon1#1:
    goto inline$BDLCleanupDataHandles$0$label_12#1;

  inline$BDLCleanupDataHandles$0$label_12#1:
    goto inline$BDLCleanupDataHandles$0$label_12_true#1, inline$BDLCleanupDataHandles$0$label_12_false#1;

  inline$BDLCleanupDataHandles$0$label_12_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$1$) == 0;
    goto inline$BDLCleanupDataHandles$0$label_13#1;

  inline$BDLCleanupDataHandles$0$label_12_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$1$) != 0;
    goto inline$BDLCleanupDataHandles$0$label_16#1;

  inline$BDLCleanupDataHandles$0$label_16#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_17#1;

  inline$BDLCleanupDataHandles$0$label_17#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_18#1;

  inline$BDLCleanupDataHandles$0$label_18#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_19#1;

  inline$BDLCleanupDataHandles$0$label_19#1:
    havoc inline$BDLCleanupDataHandles$0$$result.DbgPrint$3251.0$2$;
    goto inline$BDLCleanupDataHandles$0$label_13#1;

  inline$BDLCleanupDataHandles$0$label_13#1:
    goto inline$BDLGetDebugLevel$221$Entry#1;

  inline$BDLGetDebugLevel$221$Entry#1:
    goto inline$BDLGetDebugLevel$221$start#1;

  inline$BDLGetDebugLevel$221$start#1:
    goto inline$BDLGetDebugLevel$221$label_3#1;

  inline$BDLGetDebugLevel$221$label_3#1:
    havoc inline$BDLGetDebugLevel$221$myNondetVar_0;
    inline$BDLGetDebugLevel$221$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$221$myNondetVar_0;
    goto inline$BDLGetDebugLevel$221$label_1#1;

  inline$BDLGetDebugLevel$221$label_1#1:
    goto inline$BDLGetDebugLevel$221$Return#1;

  inline$BDLGetDebugLevel$221$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$6$ := inline$BDLGetDebugLevel$221$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_13$1#1;

  inline$BDLCleanupDataHandles$0$label_13$1#1:
    goto inline$BDLCleanupDataHandles$0$anon31_Then#1, inline$BDLCleanupDataHandles$0$anon31_Else#1;

  inline$BDLCleanupDataHandles$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon3#1;

  inline$BDLCleanupDataHandles$0$anon3#1:
    goto inline$BDLCleanupDataHandles$0$label_22#1;

  inline$BDLCleanupDataHandles$0$label_22#1:
    goto inline$BDLCleanupDataHandles$0$label_22_true#1, inline$BDLCleanupDataHandles$0$label_22_false#1;

  inline$BDLCleanupDataHandles$0$label_22_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$6$) == 0;
    goto inline$BDLCleanupDataHandles$0$label_23#1;

  inline$BDLCleanupDataHandles$0$label_22_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$6$) != 0;
    goto inline$BDLCleanupDataHandles$0$label_26#1;

  inline$BDLCleanupDataHandles$0$label_26#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_27#1;

  inline$BDLCleanupDataHandles$0$label_27#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_28#1;

  inline$BDLCleanupDataHandles$0$label_28#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_29#1;

  inline$BDLCleanupDataHandles$0$label_29#1:
    havoc inline$BDLCleanupDataHandles$0$$result.DbgPrint$3251.0$7$;
    goto inline$BDLCleanupDataHandles$0$label_23#1;

  inline$BDLCleanupDataHandles$0$label_23#1:
    goto inline$BDLGetDebugLevel$222$Entry#1;

  inline$BDLGetDebugLevel$222$Entry#1:
    goto inline$BDLGetDebugLevel$222$start#1;

  inline$BDLGetDebugLevel$222$start#1:
    goto inline$BDLGetDebugLevel$222$label_3#1;

  inline$BDLGetDebugLevel$222$label_3#1:
    havoc inline$BDLGetDebugLevel$222$myNondetVar_0;
    inline$BDLGetDebugLevel$222$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$222$myNondetVar_0;
    goto inline$BDLGetDebugLevel$222$label_1#1;

  inline$BDLGetDebugLevel$222$label_1#1:
    goto inline$BDLGetDebugLevel$222$Return#1;

  inline$BDLGetDebugLevel$222$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$11$ := inline$BDLGetDebugLevel$222$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_23$1#1;

  inline$BDLCleanupDataHandles$0$label_23$1#1:
    goto inline$BDLCleanupDataHandles$0$anon32_Then#1, inline$BDLCleanupDataHandles$0$anon32_Else#1;

  inline$BDLCleanupDataHandles$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon5#1;

  inline$BDLCleanupDataHandles$0$anon5#1:
    goto inline$BDLCleanupDataHandles$0$label_32#1;

  inline$BDLCleanupDataHandles$0$label_32#1:
    goto inline$BDLCleanupDataHandles$0$label_32_true#1, inline$BDLCleanupDataHandles$0$label_32_false#1;

  inline$BDLCleanupDataHandles$0$label_32_false#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$11$, 4) == 0;
    goto inline$BDLCleanupDataHandles$0$label_33#1;

  inline$BDLCleanupDataHandles$0$label_32_true#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3251.0$11$, 4) != 0;
    goto inline$BDLCleanupDataHandles$0$label_34#1;

  inline$BDLCleanupDataHandles$0$label_34#1:
    goto inline$BDLCleanupDataHandles$0$label_33#1;

  inline$BDLCleanupDataHandles$0$label_33#1:
    goto inline$BDLCleanupDataHandles$0$label_35#1;

  inline$BDLCleanupDataHandles$0$label_35#1:
    goto inline$BDLLockHandleList$0$Entry#1;

  inline$BDLLockHandleList$0$Entry#1:
    inline$BDLLockHandleList$0$$pBDLExtension$1$134.40$BDLLockHandleList$8_.1 := inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4;
    goto inline$BDLLockHandleList$0$start#1;

  inline$BDLLockHandleList$0$start#1:
    inline$BDLLockHandleList$0$$pBDLExtension$1$134.40$BDLLockHandleList$8 := inline$BDLLockHandleList$0$$pBDLExtension$1$134.40$BDLLockHandleList$8_.1;
    goto inline$BDLLockHandleList$0$label_3#1;

  inline$BDLLockHandleList$0$label_3#1:
    havoc inline$BDLLockHandleList$0$myNondetVar_0;
    havoc inline$BDLLockHandleList$0$myNondetVar_1;
    assume inline$BDLLockHandleList$0$myNondetVar_0 == inline$BDLLockHandleList$0$myNondetVar_1;
    goto inline$storm_KeAcquireSpinLock$1$Entry#1;

  inline$storm_KeAcquireSpinLock$1$Entry#1:
    inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1 := HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLLockHandleList$0$$pBDLExtension$1$134.40$BDLLockHandleList$8);
    goto inline$storm_KeAcquireSpinLock$1$start#1;

  inline$storm_KeAcquireSpinLock$1$start#1:
    inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8_.1;
    goto inline$storm_KeAcquireSpinLock$1$label_3#1;

  inline$storm_KeAcquireSpinLock$1$label_3#1:
    goto inline$storm_KeAcquireSpinLock$1$label_4#1;

  inline$storm_KeAcquireSpinLock$1$label_4#1:
    goto inline$storm_getThreadID$3$Entry#1;

  inline$storm_getThreadID$3$Entry#1:
    goto inline$storm_getThreadID$3$anon0#1;

  inline$storm_getThreadID$3$anon0#1:
    inline$storm_getThreadID$3$tid := __storm_thread_id;
    goto inline$storm_getThreadID$3$Return#1;

  inline$storm_getThreadID$3$Return#1:
    inline$storm_KeAcquireSpinLock$1$$result.storm_getThreadID$128.29$1$ := inline$storm_getThreadID$3$tid;
    goto inline$storm_KeAcquireSpinLock$1$label_4$1#1;

  inline$storm_KeAcquireSpinLock$1$label_4$1#1:
    goto inline$storm_KeAcquireSpinLock$1$label_7#1;

  inline$storm_KeAcquireSpinLock$1$label_7#1:
    inline$storm_KeAcquireSpinLock$1$$tid$3$128.6$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$1$$result.storm_getThreadID$128.29$1$;
    goto inline$storm_KeAcquireSpinLock$1$label_8#1;

  inline$storm_KeAcquireSpinLock$1$label_8#1:
    goto inline$storm_KeAcquireSpinLock$1$label_9#1;

  inline$storm_KeAcquireSpinLock$1$label_9#1:
    __storm_atomic := true;
    goto inline$storm_KeAcquireSpinLock$1$label_12#1;

  inline$storm_KeAcquireSpinLock$1$label_12#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$1$anon7_Then#1, inline$storm_KeAcquireSpinLock$1$anon7_Else#1;

  inline$storm_KeAcquireSpinLock$1$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$1$anon1#1;

  inline$storm_KeAcquireSpinLock$1$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8], inline$storm_KeAcquireSpinLock$1$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$1$label_13#1;

  inline$storm_KeAcquireSpinLock$1$label_13#1:
    goto inline$storm_KeAcquireSpinLock$1$label_13_true#1, inline$storm_KeAcquireSpinLock$1$label_13_false#1;

  inline$storm_KeAcquireSpinLock$1$label_13_false#1:
    assume !INT_NEQ(inline$storm_KeAcquireSpinLock$1$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$1$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$1$label_14#1;

  inline$storm_KeAcquireSpinLock$1$label_14#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeAcquireSpinLock$1$label_1#1;

  inline$storm_KeAcquireSpinLock$1$label_13_true#1:
    assume INT_NEQ(inline$storm_KeAcquireSpinLock$1$$tid$3$128.6$storm_KeAcquireSpinLock$8, inline$storm_KeAcquireSpinLock$1$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8);
    goto inline$storm_KeAcquireSpinLock$1$label_17#1;

  inline$storm_KeAcquireSpinLock$1$label_17#1:
    havoc raiseException;
    goto inline$storm_KeAcquireSpinLock$1$anon8_Then#1, inline$storm_KeAcquireSpinLock$1$anon8_Else#1;

  inline$storm_KeAcquireSpinLock$1$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeAcquireSpinLock$1$anon4#1;

  inline$storm_KeAcquireSpinLock$1$anon4#1:
    assume INT_EQ(inline$storm_KeAcquireSpinLock$1$$lockStatus$4$129.6$storm_KeAcquireSpinLock$8, 0);
    goto inline$storm_KeAcquireSpinLock$1$label_18#1;

  inline$storm_KeAcquireSpinLock$1$label_18#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeAcquireSpinLock$1$$SpinLock$1$124.17$storm_KeAcquireSpinLock$8 := inline$storm_KeAcquireSpinLock$1$$tid$3$128.6$storm_KeAcquireSpinLock$8];
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$1$label_19#1;

  inline$storm_KeAcquireSpinLock$1$label_19#1:
    goto inline$storm_KeAcquireSpinLock$1$anon9_Then#1, inline$storm_KeAcquireSpinLock$1$anon9_Else#1;

  inline$storm_KeAcquireSpinLock$1$anon9_Else#1:
    assume __storm_init;
    goto inline$storm_KeAcquireSpinLock$1$anon6#1;

  inline$storm_KeAcquireSpinLock$1$anon9_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeAcquireSpinLock$1$anon6#1;

  inline$storm_KeAcquireSpinLock$1$anon6#1:
    call contextSwitch();
    goto inline$storm_KeAcquireSpinLock$1$label_1#1;

  inline$storm_KeAcquireSpinLock$1$label_1#1:
    goto inline$storm_KeAcquireSpinLock$1$Return#1;

  inline$storm_KeAcquireSpinLock$1$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$1$Return#1;

  inline$storm_KeAcquireSpinLock$1$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeAcquireSpinLock$1$Return#1;

  inline$storm_KeAcquireSpinLock$1$Return#1:
    goto inline$BDLLockHandleList$0$label_3$1#1;

  inline$BDLLockHandleList$0$label_3$1#1:
    goto inline$BDLLockHandleList$0$anon2_Then#1, inline$BDLLockHandleList$0$anon2_Else#1;

  inline$BDLLockHandleList$0$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLLockHandleList$0$anon1#1;

  inline$BDLLockHandleList$0$anon1#1:
    havoc inline$BDLLockHandleList$0$myNondetVar_0;
    goto inline$BDLLockHandleList$0$label_1#1;

  inline$BDLLockHandleList$0$label_1#1:
    goto inline$BDLLockHandleList$0$Return#1;

  inline$BDLLockHandleList$0$anon2_Then#1:
    assume raiseException;
    goto inline$BDLLockHandleList$0$Return#1;

  inline$BDLLockHandleList$0$Return#1:
    goto inline$BDLCleanupDataHandles$0$label_35$1#1;

  inline$BDLCleanupDataHandles$0$label_35$1#1:
    goto inline$BDLCleanupDataHandles$0$anon33_Then#1, inline$BDLCleanupDataHandles$0$anon33_Else#1;

  inline$BDLCleanupDataHandles$0$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon7#1;

  inline$BDLCleanupDataHandles$0$anon7#1:
    goto inline$BDLCleanupDataHandles$0$label_38#1;

  inline$BDLCleanupDataHandles$0$label_38#1:
    goto inline$BDLCleanupDataHandles$0$label_38_head#1;

  inline$BDLCleanupDataHandles$0$label_38_head#1:
    goto inline$BDLGetFirstHandle$0$Entry#1;

  inline$BDLGetFirstHandle$0$Entry#1:
    goto inline$BDLGetFirstHandle$0$start#1;

  inline$BDLGetFirstHandle$0$start#1:
    goto inline$BDLGetFirstHandle$0$label_3#1;

  inline$BDLGetFirstHandle$0$label_3#1:
    goto inline$BDLGetFirstHandle$0$label_3_true#1, inline$BDLGetFirstHandle$0$label_3_false#1;

  inline$BDLGetFirstHandle$0$label_3_false#1:
    havoc inline$BDLGetFirstHandle$0$myNondetVar_0;
    assume inline$BDLGetFirstHandle$0$myNondetVar_0 == 0;
    goto inline$BDLGetFirstHandle$0$label_4#1;

  inline$BDLGetFirstHandle$0$label_4#1:
    inline$BDLGetFirstHandle$0$$result.BDLGetFirstHandle$276.0$1$ := 0;
    goto inline$BDLGetFirstHandle$0$label_1#1;

  inline$BDLGetFirstHandle$0$label_3_true#1:
    havoc inline$BDLGetFirstHandle$0$myNondetVar_0;
    assume inline$BDLGetFirstHandle$0$myNondetVar_0 != 0;
    goto inline$BDLGetFirstHandle$0$label_5#1;

  inline$BDLGetFirstHandle$0$label_5#1:
    havoc inline$BDLGetFirstHandle$0$myNondetVar_0;
    havoc inline$BDLGetFirstHandle$0$myNondetVar_1;
    goto inline$BDLGetFirstHandle$0$label_6#1;

  inline$BDLGetFirstHandle$0$label_6#1:
    inline$BDLGetFirstHandle$0$$result.BDLGetFirstHandle$276.0$1$ := 1;
    goto inline$BDLGetFirstHandle$0$label_1#1;

  inline$BDLGetFirstHandle$0$label_1#1:
    goto inline$BDLGetFirstHandle$0$Return#1;

  inline$BDLGetFirstHandle$0$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetFirstHandle$3264.27$12$ := inline$BDLGetFirstHandle$0$$result.BDLGetFirstHandle$276.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_38_head$1#1;

  inline$BDLCleanupDataHandles$0$label_38_head$1#1:
    goto inline$BDLCleanupDataHandles$0$anon34_Then#1, inline$BDLCleanupDataHandles$0$anon34_Else#1;

  inline$BDLCleanupDataHandles$0$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon9#1;

  inline$BDLCleanupDataHandles$0$anon9#1:
    goto inline$BDLCleanupDataHandles$0$label_41#1;

  inline$BDLCleanupDataHandles$0$label_41#1:
    goto inline$BDLCleanupDataHandles$0$label_41_true#1, inline$BDLCleanupDataHandles$0$label_41_false#1;

  inline$BDLCleanupDataHandles$0$label_41_false#1:
    assume !INT_EQ(inline$BDLCleanupDataHandles$0$$result.BDLGetFirstHandle$3264.27$12$, 1);
    goto inline$BDLCleanupDataHandles$0$label_42#1;

  inline$BDLCleanupDataHandles$0$label_42#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$BDLReleaseHandleList$0$Entry#1;

  inline$BDLReleaseHandleList$0$Entry#1:
    inline$BDLReleaseHandleList$0$$pBDLExtension$1$145.40$BDLReleaseHandleList$8_.1 := inline$BDLCleanupDataHandles$0$$pBDLExtension$1$3242.40$BDLCleanupDataHandles$4;
    goto inline$BDLReleaseHandleList$0$start#1;

  inline$BDLReleaseHandleList$0$start#1:
    inline$BDLReleaseHandleList$0$$pBDLExtension$1$145.40$BDLReleaseHandleList$8 := inline$BDLReleaseHandleList$0$$pBDLExtension$1$145.40$BDLReleaseHandleList$8_.1;
    goto inline$BDLReleaseHandleList$0$label_3#1;

  inline$BDLReleaseHandleList$0$label_3#1:
    havoc inline$BDLReleaseHandleList$0$myNondetVar_0;
    havoc inline$BDLReleaseHandleList$0$myNondetVar_1;
    assume inline$BDLReleaseHandleList$0$myNondetVar_0 == inline$BDLReleaseHandleList$0$myNondetVar_1;
    goto inline$storm_KeReleaseSpinLock$2$Entry#1;

  inline$storm_KeReleaseSpinLock$2$Entry#1:
    inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1 := HandleListLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLReleaseHandleList$0$$pBDLExtension$1$145.40$BDLReleaseHandleList$8);
    goto inline$storm_KeReleaseSpinLock$2$start#1;

  inline$storm_KeReleaseSpinLock$2$start#1:
    inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8_.1;
    goto inline$storm_KeReleaseSpinLock$2$label_3#1;

  inline$storm_KeReleaseSpinLock$2$label_3#1:
    goto inline$storm_KeReleaseSpinLock$2$label_4#1;

  inline$storm_KeReleaseSpinLock$2$label_4#1:
    __storm_atomic := true;
    goto inline$storm_KeReleaseSpinLock$2$label_7#1;

  inline$storm_KeReleaseSpinLock$2$label_7#1:
    havoc raiseException;
    goto inline$storm_KeReleaseSpinLock$2$anon5_Then#1, inline$storm_KeReleaseSpinLock$2$anon5_Else#1;

  inline$storm_KeReleaseSpinLock$2$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_KeReleaseSpinLock$2$anon1#1;

  inline$storm_KeReleaseSpinLock$2$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_LOCK[inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8], inline$storm_KeReleaseSpinLock$2$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8);
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$2$label_8#1;

  inline$storm_KeReleaseSpinLock$2$label_8#1:
    goto inline$storm_getThreadID$4$Entry#1;

  inline$storm_getThreadID$4$Entry#1:
    goto inline$storm_getThreadID$4$anon0#1;

  inline$storm_getThreadID$4$anon0#1:
    inline$storm_getThreadID$4$tid := __storm_thread_id;
    goto inline$storm_getThreadID$4$Return#1;

  inline$storm_getThreadID$4$Return#1:
    inline$storm_KeReleaseSpinLock$2$$result.storm_getThreadID$145.0$1$ := inline$storm_getThreadID$4$tid;
    goto inline$storm_KeReleaseSpinLock$2$label_8$1#1;

  inline$storm_KeReleaseSpinLock$2$label_8$1#1:
    goto inline$storm_KeReleaseSpinLock$2$label_11#1;

  inline$storm_KeReleaseSpinLock$2$label_11#1:
    goto inline$storm_KeReleaseSpinLock$2$label_11_true#1, inline$storm_KeReleaseSpinLock$2$label_11_false#1;

  inline$storm_KeReleaseSpinLock$2$label_11_false#1:
    assume !INT_EQ(inline$storm_KeReleaseSpinLock$2$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$2$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$2$label_12#1;

  inline$storm_KeReleaseSpinLock$2$label_12#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_KeReleaseSpinLock$2$label_1#1;

  inline$storm_KeReleaseSpinLock$2$label_11_true#1:
    assume INT_EQ(inline$storm_KeReleaseSpinLock$2$$lockStatus$3$144.6$storm_KeReleaseSpinLock$8, inline$storm_KeReleaseSpinLock$2$$result.storm_getThreadID$145.0$1$);
    goto inline$storm_KeReleaseSpinLock$2$label_15#1;

  inline$storm_KeReleaseSpinLock$2$label_15#1:
    Res_0_LOCK := Res_0_LOCK[inline$storm_KeReleaseSpinLock$2$$SpinLock$1$140.17$storm_KeReleaseSpinLock$8 := 0];
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$2$label_16#1;

  inline$storm_KeReleaseSpinLock$2$label_16#1:
    goto inline$storm_KeReleaseSpinLock$2$anon6_Then#1, inline$storm_KeReleaseSpinLock$2$anon6_Else#1;

  inline$storm_KeReleaseSpinLock$2$anon6_Else#1:
    assume __storm_init;
    goto inline$storm_KeReleaseSpinLock$2$anon4#1;

  inline$storm_KeReleaseSpinLock$2$anon6_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_KeReleaseSpinLock$2$anon4#1;

  inline$storm_KeReleaseSpinLock$2$anon4#1:
    call contextSwitch();
    goto inline$storm_KeReleaseSpinLock$2$label_1#1;

  inline$storm_KeReleaseSpinLock$2$label_1#1:
    goto inline$storm_KeReleaseSpinLock$2$Return#1;

  inline$storm_KeReleaseSpinLock$2$anon5_Then#1:
    assume raiseException;
    goto inline$storm_KeReleaseSpinLock$2$Return#1;

  inline$storm_KeReleaseSpinLock$2$Return#1:
    goto inline$BDLReleaseHandleList$0$label_3$1#1;

  inline$BDLReleaseHandleList$0$label_3$1#1:
    goto inline$BDLReleaseHandleList$0$anon2_Then#1, inline$BDLReleaseHandleList$0$anon2_Else#1;

  inline$BDLReleaseHandleList$0$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLReleaseHandleList$0$anon1#1;

  inline$BDLReleaseHandleList$0$anon1#1:
    havoc inline$BDLReleaseHandleList$0$myNondetVar_0;
    goto inline$BDLReleaseHandleList$0$label_1#1;

  inline$BDLReleaseHandleList$0$label_1#1:
    goto inline$BDLReleaseHandleList$0$Return#1;

  inline$BDLReleaseHandleList$0$anon2_Then#1:
    assume raiseException;
    goto inline$BDLReleaseHandleList$0$Return#1;

  inline$BDLReleaseHandleList$0$Return#1:
    goto inline$BDLCleanupDataHandles$0$label_42$1#1;

  inline$BDLCleanupDataHandles$0$label_42$1#1:
    goto inline$BDLCleanupDataHandles$0$anon35_Then#1, inline$BDLCleanupDataHandles$0$anon35_Else#1;

  inline$BDLCleanupDataHandles$0$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon11#1;

  inline$BDLCleanupDataHandles$0$anon11#1:
    goto inline$BDLCleanupDataHandles$0$label_87#1;

  inline$BDLCleanupDataHandles$0$label_87#1:
    goto inline$BDLGetDebugLevel$226$Entry#1;

  inline$BDLGetDebugLevel$226$Entry#1:
    goto inline$BDLGetDebugLevel$226$start#1;

  inline$BDLGetDebugLevel$226$start#1:
    goto inline$BDLGetDebugLevel$226$label_3#1;

  inline$BDLGetDebugLevel$226$label_3#1:
    havoc inline$BDLGetDebugLevel$226$myNondetVar_0;
    inline$BDLGetDebugLevel$226$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$226$myNondetVar_0;
    goto inline$BDLGetDebugLevel$226$label_1#1;

  inline$BDLGetDebugLevel$226$label_1#1:
    goto inline$BDLGetDebugLevel$226$Return#1;

  inline$BDLGetDebugLevel$226$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$26$ := inline$BDLGetDebugLevel$226$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_87$1#1;

  inline$BDLCleanupDataHandles$0$label_87$1#1:
    goto inline$BDLCleanupDataHandles$0$anon42_Then#1, inline$BDLCleanupDataHandles$0$anon42_Else#1;

  inline$BDLCleanupDataHandles$0$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon25#1;

  inline$BDLCleanupDataHandles$0$anon25#1:
    goto inline$BDLCleanupDataHandles$0$label_90#1;

  inline$BDLCleanupDataHandles$0$label_90#1:
    goto inline$BDLCleanupDataHandles$0$label_90_true#1, inline$BDLCleanupDataHandles$0$label_90_false#1;

  inline$BDLCleanupDataHandles$0$label_90_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$26$) == 0;
    goto inline$BDLCleanupDataHandles$0$label_91#1;

  inline$BDLCleanupDataHandles$0$label_90_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$26$) != 0;
    goto inline$BDLCleanupDataHandles$0$label_94#1;

  inline$BDLCleanupDataHandles$0$label_94#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_95#1;

  inline$BDLCleanupDataHandles$0$label_95#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_96#1;

  inline$BDLCleanupDataHandles$0$label_96#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_97#1;

  inline$BDLCleanupDataHandles$0$label_97#1:
    havoc inline$BDLCleanupDataHandles$0$$result.DbgPrint$3308.0$27$;
    goto inline$BDLCleanupDataHandles$0$label_91#1;

  inline$BDLCleanupDataHandles$0$label_91#1:
    goto inline$BDLGetDebugLevel$227$Entry#1;

  inline$BDLGetDebugLevel$227$Entry#1:
    goto inline$BDLGetDebugLevel$227$start#1;

  inline$BDLGetDebugLevel$227$start#1:
    goto inline$BDLGetDebugLevel$227$label_3#1;

  inline$BDLGetDebugLevel$227$label_3#1:
    havoc inline$BDLGetDebugLevel$227$myNondetVar_0;
    inline$BDLGetDebugLevel$227$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$227$myNondetVar_0;
    goto inline$BDLGetDebugLevel$227$label_1#1;

  inline$BDLGetDebugLevel$227$label_1#1:
    goto inline$BDLGetDebugLevel$227$Return#1;

  inline$BDLGetDebugLevel$227$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$31$ := inline$BDLGetDebugLevel$227$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_91$1#1;

  inline$BDLCleanupDataHandles$0$label_91$1#1:
    goto inline$BDLCleanupDataHandles$0$anon43_Then#1, inline$BDLCleanupDataHandles$0$anon43_Else#1;

  inline$BDLCleanupDataHandles$0$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon27#1;

  inline$BDLCleanupDataHandles$0$anon27#1:
    goto inline$BDLCleanupDataHandles$0$label_100#1;

  inline$BDLCleanupDataHandles$0$label_100#1:
    goto inline$BDLCleanupDataHandles$0$label_100_true#1, inline$BDLCleanupDataHandles$0$label_100_false#1;

  inline$BDLCleanupDataHandles$0$label_100_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$31$) == 0;
    goto inline$BDLCleanupDataHandles$0$label_101#1;

  inline$BDLCleanupDataHandles$0$label_100_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$31$) != 0;
    goto inline$BDLCleanupDataHandles$0$label_104#1;

  inline$BDLCleanupDataHandles$0$label_104#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_105#1;

  inline$BDLCleanupDataHandles$0$label_105#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_106#1;

  inline$BDLCleanupDataHandles$0$label_106#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_107#1;

  inline$BDLCleanupDataHandles$0$label_107#1:
    havoc inline$BDLCleanupDataHandles$0$$result.DbgPrint$3308.0$32$;
    goto inline$BDLCleanupDataHandles$0$label_101#1;

  inline$BDLCleanupDataHandles$0$label_101#1:
    goto inline$BDLGetDebugLevel$228$Entry#1;

  inline$BDLGetDebugLevel$228$Entry#1:
    goto inline$BDLGetDebugLevel$228$start#1;

  inline$BDLGetDebugLevel$228$start#1:
    goto inline$BDLGetDebugLevel$228$label_3#1;

  inline$BDLGetDebugLevel$228$label_3#1:
    havoc inline$BDLGetDebugLevel$228$myNondetVar_0;
    inline$BDLGetDebugLevel$228$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$228$myNondetVar_0;
    goto inline$BDLGetDebugLevel$228$label_1#1;

  inline$BDLGetDebugLevel$228$label_1#1:
    goto inline$BDLGetDebugLevel$228$Return#1;

  inline$BDLGetDebugLevel$228$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$36$ := inline$BDLGetDebugLevel$228$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_101$1#1;

  inline$BDLCleanupDataHandles$0$label_101$1#1:
    goto inline$BDLCleanupDataHandles$0$anon44_Then#1, inline$BDLCleanupDataHandles$0$anon44_Else#1;

  inline$BDLCleanupDataHandles$0$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon29#1;

  inline$BDLCleanupDataHandles$0$anon29#1:
    goto inline$BDLCleanupDataHandles$0$label_110#1;

  inline$BDLCleanupDataHandles$0$label_110#1:
    goto inline$BDLCleanupDataHandles$0$label_110_true#1, inline$BDLCleanupDataHandles$0$label_110_false#1;

  inline$BDLCleanupDataHandles$0$label_110_false#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$36$, 4) == 0;
    goto inline$BDLCleanupDataHandles$0$label_1#1;

  inline$BDLCleanupDataHandles$0$label_110_true#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3308.0$36$, 4) != 0;
    goto inline$BDLCleanupDataHandles$0$label_111#1;

  inline$BDLCleanupDataHandles$0$label_111#1:
    goto inline$BDLCleanupDataHandles$0$label_1#1;

  inline$BDLCleanupDataHandles$0$label_1#1:
    call __HAVOC_free(inline$BDLCleanupDataHandles$0$$bddDataHandle$4$3247.28$BDLCleanupDataHandles$4);
    call __HAVOC_free(inline$BDLCleanupDataHandles$0$$bddiCloseHandleParams$5$3248.28$BDLCleanupDataHandles$4);
    call __HAVOC_free(inline$BDLCleanupDataHandles$0$$irql$6$3249.28$BDLCleanupDataHandles$4);
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon44_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon43_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon42_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon35_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$label_41_true#1:
    assume INT_EQ(inline$BDLCleanupDataHandles$0$$result.BDLGetFirstHandle$3264.27$12$, 1);
    goto inline$BDLCleanupDataHandles$0$label_45#1;

  inline$BDLCleanupDataHandles$0$label_45#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$Entry#1;

  inline$BDLRemoveHandleFromList$0$Entry#1:
    inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8_.1 := inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$start#1;

  inline$BDLRemoveHandleFromList$0$start#1:
    inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8_.1;
    goto inline$BDLRemoveHandleFromList$0$label_3#1;

  inline$BDLRemoveHandleFromList$0$label_3#1:
    goto inline$BDLRemoveHandleFromList$0$label_4#1;

  inline$BDLRemoveHandleFromList$0$label_4#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_5#1;

  inline$BDLRemoveHandleFromList$0$label_5#1:
    goto inline$BDLRemoveHandleFromList$0$label_6#1;

  inline$BDLRemoveHandleFromList$0$label_6#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_7#1;

  inline$BDLRemoveHandleFromList$0$label_7#1:
    goto inline$BDLRemoveHandleFromList$0$label_7_true#1, inline$BDLRemoveHandleFromList$0$label_7_false#1;

  inline$BDLRemoveHandleFromList$0$label_7_false#1:
    assume inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 == 0;
    goto inline$BDLRemoveHandleFromList$0$label_8#1;

  inline$BDLRemoveHandleFromList$0$label_8#1:
    goto inline$BDLRemoveHandleFromList$0$label_1#1;

  inline$BDLRemoveHandleFromList$0$label_7_true#1:
    assume inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 != 0;
    goto inline$BDLRemoveHandleFromList$0$label_9#1;

  inline$BDLRemoveHandleFromList$0$label_9#1:
    goto inline$BDLRemoveHandleFromList$0$label_9_true#1, inline$BDLRemoveHandleFromList$0$label_9_false#1;

  inline$BDLRemoveHandleFromList$0$label_9_false#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$0$label_10#1;

  inline$BDLRemoveHandleFromList$0$label_10#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_20#1;

  inline$BDLRemoveHandleFromList$0$label_20#1:
    goto inline$BDLRemoveHandleFromList$0$label_20_head#1;

  inline$BDLRemoveHandleFromList$0$label_20_head#1:
    goto inline$BDLRemoveHandleFromList$0$label_20_true#1, inline$BDLRemoveHandleFromList$0$label_20_false#1;

  inline$BDLRemoveHandleFromList$0$label_20_false#1:
    assume inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 == 0;
    goto inline$BDLRemoveHandleFromList$0$label_21#1;

  inline$BDLRemoveHandleFromList$0$label_20_true#1:
    assume inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 != 0;
    goto inline$BDLRemoveHandleFromList$0$label_22#1;

  inline$BDLRemoveHandleFromList$0$label_22#1:
    goto inline$BDLRemoveHandleFromList$0$label_22_true#1, inline$BDLRemoveHandleFromList$0$label_22_false#1;

  inline$BDLRemoveHandleFromList$0$label_22_false#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    assume !INT_NEQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$0$label_21#1;

  inline$BDLRemoveHandleFromList$0$label_21#1:
    goto inline$BDLRemoveHandleFromList$0$label_21_true#1, inline$BDLRemoveHandleFromList$0$label_21_false#1;

  inline$BDLRemoveHandleFromList$0$label_21_false#1:
    assume inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 == 0;
    goto inline$BDLRemoveHandleFromList$0$label_25#1;

  inline$BDLRemoveHandleFromList$0$label_25#1:
    goto inline$BDLRemoveHandleFromList$0$label_1#1;

  inline$BDLRemoveHandleFromList$0$label_21_true#1:
    assume inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 != 0;
    goto inline$BDLRemoveHandleFromList$0$label_26#1;

  inline$BDLRemoveHandleFromList$0$label_26#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_27#1;

  inline$BDLRemoveHandleFromList$0$label_27#1:
    goto inline$BDLRemoveHandleFromList$0$label_27_true#1, inline$BDLRemoveHandleFromList$0$label_27_false#1;

  inline$BDLRemoveHandleFromList$0$label_27_false#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$0$label_15#1;

  inline$BDLRemoveHandleFromList$0$label_27_true#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    assume INT_EQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$0$label_28#1;

  inline$BDLRemoveHandleFromList$0$label_28#1:
    goto inline$BDLRemoveHandleFromList$0$label_15#1;

  inline$BDLRemoveHandleFromList$0$label_22_true#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    assume INT_NEQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$0$label_23#1;

  inline$BDLRemoveHandleFromList$0$label_23#1:
    goto inline$BDLRemoveHandleFromList$0$label_24#1;

  inline$BDLRemoveHandleFromList$0$label_24#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8 := inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_20_head#0;

  inline$BDLRemoveHandleFromList$0$label_20_head#0:
    assume false;
    return;

  inline$BDLRemoveHandleFromList$0$label_9_true#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    assume INT_EQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$$handle$2$218.24$BDLRemoveHandleFromList$8);
    goto inline$BDLRemoveHandleFromList$0$label_11#1;

  inline$BDLRemoveHandleFromList$0$label_11#1:
    goto inline$BDLRemoveHandleFromList$0$label_11_true#1, inline$BDLRemoveHandleFromList$0$label_11_false#1;

  inline$BDLRemoveHandleFromList$0$label_11_false#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_1;
    assume !INT_EQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$myNondetVar_1);
    goto inline$BDLRemoveHandleFromList$0$label_12#1;

  inline$BDLRemoveHandleFromList$0$label_12#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_15#1;

  inline$BDLRemoveHandleFromList$0$label_11_true#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_1;
    assume INT_EQ(inline$BDLRemoveHandleFromList$0$myNondetVar_0, inline$BDLRemoveHandleFromList$0$myNondetVar_1);
    goto inline$BDLRemoveHandleFromList$0$label_13#1;

  inline$BDLRemoveHandleFromList$0$label_13#1:
    goto inline$BDLRemoveHandleFromList$0$label_14#1;

  inline$BDLRemoveHandleFromList$0$label_14#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_15#1;

  inline$BDLRemoveHandleFromList$0$label_15#1:
    havoc inline$BDLRemoveHandleFromList$0$myNondetVar_0;
    goto inline$BDLRemoveHandleFromList$0$label_16#1;

  inline$BDLRemoveHandleFromList$0$label_16#1:
    call ExFreePoolWithTag(inline$BDLRemoveHandleFromList$0$$pListNodeToDelete$3$221.15$BDLRemoveHandleFromList$8, 1280066626);
    goto inline$BDLRemoveHandleFromList$0$anon2_Then#1, inline$BDLRemoveHandleFromList$0$anon2_Else#1;

  inline$BDLRemoveHandleFromList$0$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLRemoveHandleFromList$0$anon1#1;

  inline$BDLRemoveHandleFromList$0$anon1#1:
    goto inline$BDLRemoveHandleFromList$0$label_19#1;

  inline$BDLRemoveHandleFromList$0$label_19#1:
    goto inline$BDLRemoveHandleFromList$0$label_1#1;

  inline$BDLRemoveHandleFromList$0$label_1#1:
    goto inline$BDLRemoveHandleFromList$0$Return#1;

  inline$BDLRemoveHandleFromList$0$anon2_Then#1:
    assume raiseException;
    goto inline$BDLRemoveHandleFromList$0$Return#1;

  inline$BDLRemoveHandleFromList$0$Return#1:
    goto inline$BDLCleanupDataHandles$0$label_45$1#1;

  inline$BDLCleanupDataHandles$0$label_45$1#1:
    goto inline$BDLCleanupDataHandles$0$anon36_Then#1, inline$BDLCleanupDataHandles$0$anon36_Else#1;

  inline$BDLCleanupDataHandles$0$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon13#1;

  inline$BDLCleanupDataHandles$0$anon13#1:
    goto inline$BDLCleanupDataHandles$0$label_48#1;

  inline$BDLCleanupDataHandles$0$label_48#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    inline$BDLCleanupDataHandles$0$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4 := inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$BDLCleanupDataHandles$0$label_49#1;

  inline$BDLCleanupDataHandles$0$label_49#1:
    goto inline$BDLCleanupDataHandles$0$label_49_true#1, inline$BDLCleanupDataHandles$0$label_49_false#1;

  inline$BDLCleanupDataHandles$0$label_49_false#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLCleanupDataHandles$0$myNondetVar_0, 2);
    goto inline$BDLCleanupDataHandles$0$label_50#1;

  inline$BDLCleanupDataHandles$0$label_50#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$BDLCleanupDataHandles$0$label_57#1;

  inline$BDLCleanupDataHandles$0$label_57#1:
    goto inline$BDLCleanupDataHandles$0$label_60#1;

  inline$BDLCleanupDataHandles$0$label_60#1:
    inline$BDLCleanupDataHandles$0$$status$2$3245.28$BDLCleanupDataHandles$4 := inline$BDLCleanupDataHandles$0$$callresult.$3284.85$14$;
    goto inline$BDLCleanupDataHandles$0$label_61#1;

  inline$BDLCleanupDataHandles$0$label_61#1:
    goto inline$BDLCleanupDataHandles$0$label_61_true#1, inline$BDLCleanupDataHandles$0$label_61_false#1;

  inline$BDLCleanupDataHandles$0$label_61_false#1:
    assume inline$BDLCleanupDataHandles$0$$status$2$3245.28$BDLCleanupDataHandles$4 == 0;
    goto inline$BDLCleanupDataHandles$0$label_54#1;

  inline$BDLCleanupDataHandles$0$label_61_true#1:
    assume inline$BDLCleanupDataHandles$0$$status$2$3245.28$BDLCleanupDataHandles$4 != 0;
    goto inline$BDLCleanupDataHandles$0$label_62#1;

  inline$BDLCleanupDataHandles$0$label_62#1:
    goto inline$BDLGetDebugLevel$223$Entry#1;

  inline$BDLGetDebugLevel$223$Entry#1:
    goto inline$BDLGetDebugLevel$223$start#1;

  inline$BDLGetDebugLevel$223$start#1:
    goto inline$BDLGetDebugLevel$223$label_3#1;

  inline$BDLGetDebugLevel$223$label_3#1:
    havoc inline$BDLGetDebugLevel$223$myNondetVar_0;
    inline$BDLGetDebugLevel$223$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$223$myNondetVar_0;
    goto inline$BDLGetDebugLevel$223$label_1#1;

  inline$BDLGetDebugLevel$223$label_1#1:
    goto inline$BDLGetDebugLevel$223$Return#1;

  inline$BDLGetDebugLevel$223$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$15$ := inline$BDLGetDebugLevel$223$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_62$1#1;

  inline$BDLCleanupDataHandles$0$label_62$1#1:
    goto inline$BDLCleanupDataHandles$0$anon39_Then#1, inline$BDLCleanupDataHandles$0$anon39_Else#1;

  inline$BDLCleanupDataHandles$0$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon19#1;

  inline$BDLCleanupDataHandles$0$anon19#1:
    goto inline$BDLCleanupDataHandles$0$label_65#1;

  inline$BDLCleanupDataHandles$0$label_65#1:
    goto inline$BDLCleanupDataHandles$0$label_65_true#1, inline$BDLCleanupDataHandles$0$label_65_false#1;

  inline$BDLCleanupDataHandles$0$label_65_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$15$) == 0;
    goto inline$BDLCleanupDataHandles$0$label_66#1;

  inline$BDLCleanupDataHandles$0$label_65_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$15$) != 0;
    goto inline$BDLCleanupDataHandles$0$label_69#1;

  inline$BDLCleanupDataHandles$0$label_69#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_70#1;

  inline$BDLCleanupDataHandles$0$label_70#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_71#1;

  inline$BDLCleanupDataHandles$0$label_71#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_72#1;

  inline$BDLCleanupDataHandles$0$label_72#1:
    havoc inline$BDLCleanupDataHandles$0$$result.DbgPrint$3290.0$16$;
    goto inline$BDLCleanupDataHandles$0$label_66#1;

  inline$BDLCleanupDataHandles$0$label_66#1:
    goto inline$BDLGetDebugLevel$224$Entry#1;

  inline$BDLGetDebugLevel$224$Entry#1:
    goto inline$BDLGetDebugLevel$224$start#1;

  inline$BDLGetDebugLevel$224$start#1:
    goto inline$BDLGetDebugLevel$224$label_3#1;

  inline$BDLGetDebugLevel$224$label_3#1:
    havoc inline$BDLGetDebugLevel$224$myNondetVar_0;
    inline$BDLGetDebugLevel$224$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$224$myNondetVar_0;
    goto inline$BDLGetDebugLevel$224$label_1#1;

  inline$BDLGetDebugLevel$224$label_1#1:
    goto inline$BDLGetDebugLevel$224$Return#1;

  inline$BDLGetDebugLevel$224$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$20$ := inline$BDLGetDebugLevel$224$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_66$1#1;

  inline$BDLCleanupDataHandles$0$label_66$1#1:
    goto inline$BDLCleanupDataHandles$0$anon40_Then#1, inline$BDLCleanupDataHandles$0$anon40_Else#1;

  inline$BDLCleanupDataHandles$0$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon21#1;

  inline$BDLCleanupDataHandles$0$anon21#1:
    goto inline$BDLCleanupDataHandles$0$label_75#1;

  inline$BDLCleanupDataHandles$0$label_75#1:
    goto inline$BDLCleanupDataHandles$0$label_75_true#1, inline$BDLCleanupDataHandles$0$label_75_false#1;

  inline$BDLCleanupDataHandles$0$label_75_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$20$) == 0;
    goto inline$BDLCleanupDataHandles$0$label_76#1;

  inline$BDLCleanupDataHandles$0$label_75_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$20$) != 0;
    goto inline$BDLCleanupDataHandles$0$label_79#1;

  inline$BDLCleanupDataHandles$0$label_79#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_80#1;

  inline$BDLCleanupDataHandles$0$label_80#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_81#1;

  inline$BDLCleanupDataHandles$0$label_81#1:
    call inline$BDLCleanupDataHandles$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCleanupDataHandles$0$label_82#1;

  inline$BDLCleanupDataHandles$0$label_82#1:
    havoc inline$BDLCleanupDataHandles$0$$result.DbgPrint$3290.0$21$;
    goto inline$BDLCleanupDataHandles$0$label_76#1;

  inline$BDLCleanupDataHandles$0$label_76#1:
    goto inline$BDLGetDebugLevel$225$Entry#1;

  inline$BDLGetDebugLevel$225$Entry#1:
    goto inline$BDLGetDebugLevel$225$start#1;

  inline$BDLGetDebugLevel$225$start#1:
    goto inline$BDLGetDebugLevel$225$label_3#1;

  inline$BDLGetDebugLevel$225$label_3#1:
    havoc inline$BDLGetDebugLevel$225$myNondetVar_0;
    inline$BDLGetDebugLevel$225$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$225$myNondetVar_0;
    goto inline$BDLGetDebugLevel$225$label_1#1;

  inline$BDLGetDebugLevel$225$label_1#1:
    goto inline$BDLGetDebugLevel$225$Return#1;

  inline$BDLGetDebugLevel$225$Return#1:
    inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$25$ := inline$BDLGetDebugLevel$225$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLCleanupDataHandles$0$label_76$1#1;

  inline$BDLCleanupDataHandles$0$label_76$1#1:
    goto inline$BDLCleanupDataHandles$0$anon41_Then#1, inline$BDLCleanupDataHandles$0$anon41_Else#1;

  inline$BDLCleanupDataHandles$0$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon23#1;

  inline$BDLCleanupDataHandles$0$anon23#1:
    goto inline$BDLCleanupDataHandles$0$label_85#1;

  inline$BDLCleanupDataHandles$0$label_85#1:
    goto inline$BDLCleanupDataHandles$0$label_85_true#1, inline$BDLCleanupDataHandles$0$label_85_false#1;

  inline$BDLCleanupDataHandles$0$label_85_false#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$25$, 4) == 0;
    goto inline$BDLCleanupDataHandles$0$label_54#1;

  inline$BDLCleanupDataHandles$0$label_85_true#1:
    assume BIT_BAND(inline$BDLCleanupDataHandles$0$$result.BDLGetDebugLevel$3290.0$25$, 4) != 0;
    goto inline$BDLCleanupDataHandles$0$label_86#1;

  inline$BDLCleanupDataHandles$0$label_86#1:
    goto inline$BDLCleanupDataHandles$0$label_54#1;

  inline$BDLCleanupDataHandles$0$anon41_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon40_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon39_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$label_49_true#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    assume INT_EQ(inline$BDLCleanupDataHandles$0$myNondetVar_0, 2);
    goto inline$BDLCleanupDataHandles$0$label_51#1;

  inline$BDLCleanupDataHandles$0$label_51#1:
    havoc inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$bdliFree$0$Entry#1;

  inline$bdliFree$0$Entry#1:
    inline$bdliFree$0$$pvBlock$1$2740.28$bdliFree$4_.1 := inline$BDLCleanupDataHandles$0$myNondetVar_0;
    goto inline$bdliFree$0$start#1;

  inline$bdliFree$0$start#1:
    inline$bdliFree$0$$pvBlock$1$2740.28$bdliFree$4 := inline$bdliFree$0$$pvBlock$1$2740.28$bdliFree$4_.1;
    goto inline$bdliFree$0$label_3#1;

  inline$bdliFree$0$label_3#1:
    call ExFreePoolWithTag(inline$bdliFree$0$$pvBlock$1$2740.28$bdliFree$4, 1229734978);
    goto inline$bdliFree$0$anon2_Then#1, inline$bdliFree$0$anon2_Else#1;

  inline$bdliFree$0$anon2_Else#1:
    assume !raiseException;
    goto inline$bdliFree$0$anon1#1;

  inline$bdliFree$0$anon1#1:
    goto inline$bdliFree$0$label_1#1;

  inline$bdliFree$0$label_1#1:
    goto inline$bdliFree$0$Return#1;

  inline$bdliFree$0$anon2_Then#1:
    assume raiseException;
    goto inline$bdliFree$0$Return#1;

  inline$bdliFree$0$Return#1:
    goto inline$BDLCleanupDataHandles$0$label_51$1#1;

  inline$BDLCleanupDataHandles$0$label_51$1#1:
    goto inline$BDLCleanupDataHandles$0$anon37_Then#1, inline$BDLCleanupDataHandles$0$anon37_Else#1;

  inline$BDLCleanupDataHandles$0$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon15#1;

  inline$BDLCleanupDataHandles$0$anon15#1:
    goto inline$BDLCleanupDataHandles$0$label_54#1;

  inline$BDLCleanupDataHandles$0$label_54#1:
    call ExFreePoolWithTag(inline$BDLCleanupDataHandles$0$$pBDDIItem$3$3246.29$BDLCleanupDataHandles$4, 541869122);
    goto inline$BDLCleanupDataHandles$0$anon38_Then#1, inline$BDLCleanupDataHandles$0$anon38_Else#1;

  inline$BDLCleanupDataHandles$0$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDataHandles$0$anon17#1;

  inline$BDLCleanupDataHandles$0$anon17#1:
    goto inline$BDLCleanupDataHandles$0$label_38_head#0;

  inline$BDLCleanupDataHandles$0$label_38_head#0:
    assume false;
    return;

  inline$BDLCleanupDataHandles$0$anon38_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon37_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon36_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon34_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon33_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDataHandles$0$Return#1;

  inline$BDLCleanupDataHandles$0$Return#1:
    goto inline$BDLHandleRemove$0$label_41$1#1;

  inline$BDLHandleRemove$0$label_41$1#1:
    goto inline$BDLHandleRemove$0$anon48_Then#1, inline$BDLHandleRemove$0$anon48_Else#1;

  inline$BDLHandleRemove$0$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon13#1;

  inline$BDLHandleRemove$0$anon13#1:
    goto inline$BDLHandleRemove$0$label_44#1;

  inline$BDLHandleRemove$0$label_44#1:
    goto inline$BDLHandleRemove$0$label_44_true#1, inline$BDLHandleRemove$0$label_44_false#1;

  inline$BDLHandleRemove$0$label_44_false#1:
    havoc inline$BDLHandleRemove$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLHandleRemove$0$myNondetVar_0, 1);
    goto inline$BDLHandleRemove$0$label_45#1;

  inline$BDLHandleRemove$0$label_44_true#1:
    havoc inline$BDLHandleRemove$0$myNondetVar_0;
    assume INT_EQ(inline$BDLHandleRemove$0$myNondetVar_0, 1);
    goto inline$BDLHandleRemove$0$label_48#1;

  inline$BDLHandleRemove$0$label_48#1:
    goto inline$BDLHandleRemove$0$label_51#1;

  inline$BDLHandleRemove$0$label_51#1:
    inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 := inline$BDLHandleRemove$0$$callresult.$2419.71$15$;
    goto inline$BDLHandleRemove$0$label_52#1;

  inline$BDLHandleRemove$0$label_52#1:
    goto inline$BDLHandleRemove$0$label_52_true#1, inline$BDLHandleRemove$0$label_52_false#1;

  inline$BDLHandleRemove$0$label_52_false#1:
    assume inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 == 0;
    goto inline$BDLHandleRemove$0$label_53#1;

  inline$BDLHandleRemove$0$label_52_true#1:
    assume inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 != 0;
    goto inline$BDLHandleRemove$0$label_54#1;

  inline$BDLHandleRemove$0$label_54#1:
    goto inline$BDLGetDebugLevel$229$Entry#1;

  inline$BDLGetDebugLevel$229$Entry#1:
    goto inline$BDLGetDebugLevel$229$start#1;

  inline$BDLGetDebugLevel$229$start#1:
    goto inline$BDLGetDebugLevel$229$label_3#1;

  inline$BDLGetDebugLevel$229$label_3#1:
    havoc inline$BDLGetDebugLevel$229$myNondetVar_0;
    inline$BDLGetDebugLevel$229$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$229$myNondetVar_0;
    goto inline$BDLGetDebugLevel$229$label_1#1;

  inline$BDLGetDebugLevel$229$label_1#1:
    goto inline$BDLGetDebugLevel$229$Return#1;

  inline$BDLGetDebugLevel$229$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$16$ := inline$BDLGetDebugLevel$229$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_54$1#1;

  inline$BDLHandleRemove$0$label_54$1#1:
    goto inline$BDLHandleRemove$0$anon49_Then#1, inline$BDLHandleRemove$0$anon49_Else#1;

  inline$BDLHandleRemove$0$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon15#1;

  inline$BDLHandleRemove$0$anon15#1:
    goto inline$BDLHandleRemove$0$label_57#1;

  inline$BDLHandleRemove$0$label_57#1:
    goto inline$BDLHandleRemove$0$label_57_true#1, inline$BDLHandleRemove$0$label_57_false#1;

  inline$BDLHandleRemove$0$label_57_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$16$) == 0;
    goto inline$BDLHandleRemove$0$label_58#1;

  inline$BDLHandleRemove$0$label_57_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$16$) != 0;
    goto inline$BDLHandleRemove$0$label_61#1;

  inline$BDLHandleRemove$0$label_61#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_62#1;

  inline$BDLHandleRemove$0$label_62#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_63#1;

  inline$BDLHandleRemove$0$label_63#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_64#1;

  inline$BDLHandleRemove$0$label_64#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2423.0$17$;
    goto inline$BDLHandleRemove$0$label_58#1;

  inline$BDLHandleRemove$0$label_58#1:
    goto inline$BDLGetDebugLevel$230$Entry#1;

  inline$BDLGetDebugLevel$230$Entry#1:
    goto inline$BDLGetDebugLevel$230$start#1;

  inline$BDLGetDebugLevel$230$start#1:
    goto inline$BDLGetDebugLevel$230$label_3#1;

  inline$BDLGetDebugLevel$230$label_3#1:
    havoc inline$BDLGetDebugLevel$230$myNondetVar_0;
    inline$BDLGetDebugLevel$230$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$230$myNondetVar_0;
    goto inline$BDLGetDebugLevel$230$label_1#1;

  inline$BDLGetDebugLevel$230$label_1#1:
    goto inline$BDLGetDebugLevel$230$Return#1;

  inline$BDLGetDebugLevel$230$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$21$ := inline$BDLGetDebugLevel$230$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_58$1#1;

  inline$BDLHandleRemove$0$label_58$1#1:
    goto inline$BDLHandleRemove$0$anon50_Then#1, inline$BDLHandleRemove$0$anon50_Else#1;

  inline$BDLHandleRemove$0$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon17#1;

  inline$BDLHandleRemove$0$anon17#1:
    goto inline$BDLHandleRemove$0$label_67#1;

  inline$BDLHandleRemove$0$label_67#1:
    goto inline$BDLHandleRemove$0$label_67_true#1, inline$BDLHandleRemove$0$label_67_false#1;

  inline$BDLHandleRemove$0$label_67_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$21$) == 0;
    goto inline$BDLHandleRemove$0$label_68#1;

  inline$BDLHandleRemove$0$label_67_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$21$) != 0;
    goto inline$BDLHandleRemove$0$label_71#1;

  inline$BDLHandleRemove$0$label_71#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_72#1;

  inline$BDLHandleRemove$0$label_72#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_73#1;

  inline$BDLHandleRemove$0$label_73#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_74#1;

  inline$BDLHandleRemove$0$label_74#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2423.0$22$;
    goto inline$BDLHandleRemove$0$label_68#1;

  inline$BDLHandleRemove$0$label_68#1:
    goto inline$BDLGetDebugLevel$231$Entry#1;

  inline$BDLGetDebugLevel$231$Entry#1:
    goto inline$BDLGetDebugLevel$231$start#1;

  inline$BDLGetDebugLevel$231$start#1:
    goto inline$BDLGetDebugLevel$231$label_3#1;

  inline$BDLGetDebugLevel$231$label_3#1:
    havoc inline$BDLGetDebugLevel$231$myNondetVar_0;
    inline$BDLGetDebugLevel$231$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$231$myNondetVar_0;
    goto inline$BDLGetDebugLevel$231$label_1#1;

  inline$BDLGetDebugLevel$231$label_1#1:
    goto inline$BDLGetDebugLevel$231$Return#1;

  inline$BDLGetDebugLevel$231$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$26$ := inline$BDLGetDebugLevel$231$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_68$1#1;

  inline$BDLHandleRemove$0$label_68$1#1:
    goto inline$BDLHandleRemove$0$anon51_Then#1, inline$BDLHandleRemove$0$anon51_Else#1;

  inline$BDLHandleRemove$0$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon19#1;

  inline$BDLHandleRemove$0$anon19#1:
    goto inline$BDLHandleRemove$0$label_77#1;

  inline$BDLHandleRemove$0$label_77#1:
    goto inline$BDLHandleRemove$0$label_77_true#1, inline$BDLHandleRemove$0$label_77_false#1;

  inline$BDLHandleRemove$0$label_77_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$26$, 4) == 0;
    goto inline$BDLHandleRemove$0$label_53#1;

  inline$BDLHandleRemove$0$label_77_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2423.0$26$, 4) != 0;
    goto inline$BDLHandleRemove$0$label_78#1;

  inline$BDLHandleRemove$0$label_78#1:
    goto inline$BDLHandleRemove$0$label_53#1;

  inline$BDLHandleRemove$0$label_53#1:
    goto inline$BDLHandleRemove$0$label_45#1;

  inline$BDLHandleRemove$0$label_45#1:
    goto inline$BDLHandleRemove$0$label_79#1;

  inline$BDLHandleRemove$0$label_79#1:
    inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 := inline$BDLHandleRemove$0$$callresult.$2437.63$27$;
    goto inline$BDLHandleRemove$0$label_80#1;

  inline$BDLHandleRemove$0$label_80#1:
    goto inline$BDLHandleRemove$0$label_80_true#1, inline$BDLHandleRemove$0$label_80_false#1;

  inline$BDLHandleRemove$0$label_80_false#1:
    assume inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 == 0;
    goto inline$BDLHandleRemove$0$label_81#1;

  inline$BDLHandleRemove$0$label_80_true#1:
    assume inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 != 0;
    goto inline$BDLHandleRemove$0$label_84#1;

  inline$BDLHandleRemove$0$label_84#1:
    goto inline$BDLGetDebugLevel$232$Entry#1;

  inline$BDLGetDebugLevel$232$Entry#1:
    goto inline$BDLGetDebugLevel$232$start#1;

  inline$BDLGetDebugLevel$232$start#1:
    goto inline$BDLGetDebugLevel$232$label_3#1;

  inline$BDLGetDebugLevel$232$label_3#1:
    havoc inline$BDLGetDebugLevel$232$myNondetVar_0;
    inline$BDLGetDebugLevel$232$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$232$myNondetVar_0;
    goto inline$BDLGetDebugLevel$232$label_1#1;

  inline$BDLGetDebugLevel$232$label_1#1:
    goto inline$BDLGetDebugLevel$232$Return#1;

  inline$BDLGetDebugLevel$232$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$28$ := inline$BDLGetDebugLevel$232$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_84$1#1;

  inline$BDLHandleRemove$0$label_84$1#1:
    goto inline$BDLHandleRemove$0$anon53_Then#1, inline$BDLHandleRemove$0$anon53_Else#1;

  inline$BDLHandleRemove$0$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon23#1;

  inline$BDLHandleRemove$0$anon23#1:
    goto inline$BDLHandleRemove$0$label_87#1;

  inline$BDLHandleRemove$0$label_87#1:
    goto inline$BDLHandleRemove$0$label_87_true#1, inline$BDLHandleRemove$0$label_87_false#1;

  inline$BDLHandleRemove$0$label_87_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$28$) == 0;
    goto inline$BDLHandleRemove$0$label_88#1;

  inline$BDLHandleRemove$0$label_87_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$28$) != 0;
    goto inline$BDLHandleRemove$0$label_91#1;

  inline$BDLHandleRemove$0$label_91#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_92#1;

  inline$BDLHandleRemove$0$label_92#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_93#1;

  inline$BDLHandleRemove$0$label_93#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_94#1;

  inline$BDLHandleRemove$0$label_94#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2441.0$29$;
    goto inline$BDLHandleRemove$0$label_88#1;

  inline$BDLHandleRemove$0$label_88#1:
    goto inline$BDLGetDebugLevel$233$Entry#1;

  inline$BDLGetDebugLevel$233$Entry#1:
    goto inline$BDLGetDebugLevel$233$start#1;

  inline$BDLGetDebugLevel$233$start#1:
    goto inline$BDLGetDebugLevel$233$label_3#1;

  inline$BDLGetDebugLevel$233$label_3#1:
    havoc inline$BDLGetDebugLevel$233$myNondetVar_0;
    inline$BDLGetDebugLevel$233$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$233$myNondetVar_0;
    goto inline$BDLGetDebugLevel$233$label_1#1;

  inline$BDLGetDebugLevel$233$label_1#1:
    goto inline$BDLGetDebugLevel$233$Return#1;

  inline$BDLGetDebugLevel$233$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$33$ := inline$BDLGetDebugLevel$233$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_88$1#1;

  inline$BDLHandleRemove$0$label_88$1#1:
    goto inline$BDLHandleRemove$0$anon54_Then#1, inline$BDLHandleRemove$0$anon54_Else#1;

  inline$BDLHandleRemove$0$anon54_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon25#1;

  inline$BDLHandleRemove$0$anon25#1:
    goto inline$BDLHandleRemove$0$label_97#1;

  inline$BDLHandleRemove$0$label_97#1:
    goto inline$BDLHandleRemove$0$label_97_true#1, inline$BDLHandleRemove$0$label_97_false#1;

  inline$BDLHandleRemove$0$label_97_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$33$) == 0;
    goto inline$BDLHandleRemove$0$label_98#1;

  inline$BDLHandleRemove$0$label_97_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$33$) != 0;
    goto inline$BDLHandleRemove$0$label_101#1;

  inline$BDLHandleRemove$0$label_101#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_102#1;

  inline$BDLHandleRemove$0$label_102#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_103#1;

  inline$BDLHandleRemove$0$label_103#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_104#1;

  inline$BDLHandleRemove$0$label_104#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2441.0$34$;
    goto inline$BDLHandleRemove$0$label_98#1;

  inline$BDLHandleRemove$0$label_98#1:
    goto inline$BDLGetDebugLevel$234$Entry#1;

  inline$BDLGetDebugLevel$234$Entry#1:
    goto inline$BDLGetDebugLevel$234$start#1;

  inline$BDLGetDebugLevel$234$start#1:
    goto inline$BDLGetDebugLevel$234$label_3#1;

  inline$BDLGetDebugLevel$234$label_3#1:
    havoc inline$BDLGetDebugLevel$234$myNondetVar_0;
    inline$BDLGetDebugLevel$234$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$234$myNondetVar_0;
    goto inline$BDLGetDebugLevel$234$label_1#1;

  inline$BDLGetDebugLevel$234$label_1#1:
    goto inline$BDLGetDebugLevel$234$Return#1;

  inline$BDLGetDebugLevel$234$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$38$ := inline$BDLGetDebugLevel$234$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_98$1#1;

  inline$BDLHandleRemove$0$label_98$1#1:
    goto inline$BDLHandleRemove$0$anon55_Then#1, inline$BDLHandleRemove$0$anon55_Else#1;

  inline$BDLHandleRemove$0$anon55_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon27#1;

  inline$BDLHandleRemove$0$anon27#1:
    goto inline$BDLHandleRemove$0$label_107#1;

  inline$BDLHandleRemove$0$label_107#1:
    goto inline$BDLHandleRemove$0$label_107_true#1, inline$BDLHandleRemove$0$label_107_false#1;

  inline$BDLHandleRemove$0$label_107_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$38$, 4) == 0;
    goto inline$BDLHandleRemove$0$label_81#1;

  inline$BDLHandleRemove$0$label_107_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2441.0$38$, 4) != 0;
    goto inline$BDLHandleRemove$0$label_108#1;

  inline$BDLHandleRemove$0$label_108#1:
    goto inline$BDLHandleRemove$0$label_81#1;

  inline$BDLHandleRemove$0$label_81#1:
    goto inline$IoSkipCurrentIrpStackLocation$0$Entry#1;

  inline$IoSkipCurrentIrpStackLocation$0$Entry#1:
    inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1 := inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12;
    goto inline$IoSkipCurrentIrpStackLocation$0$start#1;

  inline$IoSkipCurrentIrpStackLocation$0$start#1:
    inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4 := inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1;
    goto inline$IoSkipCurrentIrpStackLocation$0$label_3#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_3#1:
    goto inline$IoSkipCurrentIrpStackLocation$0$label_3_true#1, inline$IoSkipCurrentIrpStackLocation$0$label_3_false#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_3_false#1:
    inline$IoSkipCurrentIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$0$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoSkipCurrentIrpStackLocation$0$myVar_0, inline$IoSkipCurrentIrpStackLocation$0$myVar_1);
    goto inline$IoSkipCurrentIrpStackLocation$0$label_4#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_4#1:
    call inline$IoSkipCurrentIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSkipCurrentIrpStackLocation$0$label_7#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_7#1:
    call inline$IoSkipCurrentIrpStackLocation$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSkipCurrentIrpStackLocation$0$label_8#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_8#1:
    goto inline$IoSkipCurrentIrpStackLocation$0$label_5#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_3_true#1:
    inline$IoSkipCurrentIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$0$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoSkipCurrentIrpStackLocation$0$myVar_0, inline$IoSkipCurrentIrpStackLocation$0$myVar_1);
    goto inline$IoSkipCurrentIrpStackLocation$0$label_5#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_5#1:
    inline$IoSkipCurrentIrpStackLocation$0$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$0$tempBoogie0 := PLUS(inline$IoSkipCurrentIrpStackLocation$0$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$0$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4) := inline$IoSkipCurrentIrpStackLocation$0$tempBoogie0];
    call contextSwitch();
    goto inline$IoSkipCurrentIrpStackLocation$0$label_6#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_6#1:
    havoc inline$IoSkipCurrentIrpStackLocation$0$myNondetVar_0;
    inline$IoSkipCurrentIrpStackLocation$0$tempBoogie0 := PLUS(inline$IoSkipCurrentIrpStackLocation$0$myNondetVar_0, 36, 1);
    goto inline$IoSkipCurrentIrpStackLocation$0$label_1#1;

  inline$IoSkipCurrentIrpStackLocation$0$label_1#1:
    goto inline$IoSkipCurrentIrpStackLocation$0$Return#1;

  inline$IoSkipCurrentIrpStackLocation$0$Return#1:
    goto inline$BDLHandleRemove$0$label_81$1#1;

  inline$BDLHandleRemove$0$label_81$1#1:
    goto inline$BDLHandleRemove$0$anon52_Then#1, inline$BDLHandleRemove$0$anon52_Else#1;

  inline$BDLHandleRemove$0$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon21#1;

  inline$BDLHandleRemove$0$anon21#1:
    goto inline$BDLHandleRemove$0$label_109#1;

  inline$BDLHandleRemove$0$label_109#1:
    goto inline$storm_IoCallDriver$4$Entry#1;

  inline$storm_IoCallDriver$4$Entry#1:
    inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLHandleRemove$0$$pIrp$3$2380.40$BDLHandleRemove$12;
    goto inline$storm_IoCallDriver$4$start#1;

  inline$storm_IoCallDriver$4$start#1:
    inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$4$label_3#1;

  inline$storm_IoCallDriver$4$label_3#1:
    goto inline$storm_IoCallDriver$4$label_4#1;

  inline$storm_IoCallDriver$4$label_4#1:
    goto inline$storm_IoCallDriver$4$label_5#1;

  inline$storm_IoCallDriver$4$label_5#1:
    goto inline$storm_IoCallDriver$4$label_6#1;

  inline$storm_IoCallDriver$4$label_6#1:
    call inline$storm_IoCallDriver$4$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$4$label_9#1;

  inline$storm_IoCallDriver$4$label_9#1:
    goto inline$storm_IoCallDriver$4$label_9_true#1, inline$storm_IoCallDriver$4$label_9_false#1;

  inline$storm_IoCallDriver$4$label_9_false#1:
    assume inline$storm_IoCallDriver$4$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$4$label_10#1;

  inline$storm_IoCallDriver$4$label_9_true#1:
    assume inline$storm_IoCallDriver$4$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$4$label_13#1;

  inline$storm_IoCallDriver$4$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$4$anon12_Then#1, inline$storm_IoCallDriver$4$anon12_Else#1;

  inline$storm_IoCallDriver$4$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$4$anon3#1;

  inline$storm_IoCallDriver$4$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$4$label_14#1;

  inline$storm_IoCallDriver$4$label_14#1:
    goto inline$storm_IoCallDriver$4$label_14_true#1, inline$storm_IoCallDriver$4$label_14_false#1;

  inline$storm_IoCallDriver$4$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$4$label_15#1;

  inline$storm_IoCallDriver$4$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$4$label_1#1;

  inline$storm_IoCallDriver$4$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$4$label_10#1;

  inline$storm_IoCallDriver$4$label_10#1:
    goto inline$IoSetNextIrpStackLocation$5$Entry#1;

  inline$IoSetNextIrpStackLocation$5$Entry#1:
    inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$5$start#1;

  inline$IoSetNextIrpStackLocation$5$start#1:
    inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$5$label_3#1;

  inline$IoSetNextIrpStackLocation$5$label_3#1:
    goto inline$IoSetNextIrpStackLocation$5$label_3_true#1, inline$IoSetNextIrpStackLocation$5$label_3_false#1;

  inline$IoSetNextIrpStackLocation$5$label_3_false#1:
    inline$IoSetNextIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$5$myVar_0);
    goto inline$IoSetNextIrpStackLocation$5$label_4#1;

  inline$IoSetNextIrpStackLocation$5$label_4#1:
    call inline$IoSetNextIrpStackLocation$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$5$label_7#1;

  inline$IoSetNextIrpStackLocation$5$label_7#1:
    call inline$IoSetNextIrpStackLocation$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$5$label_8#1;

  inline$IoSetNextIrpStackLocation$5$label_8#1:
    goto inline$IoSetNextIrpStackLocation$5$label_5#1;

  inline$IoSetNextIrpStackLocation$5$label_3_true#1:
    inline$IoSetNextIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$5$myVar_0);
    goto inline$IoSetNextIrpStackLocation$5$label_5#1;

  inline$IoSetNextIrpStackLocation$5$label_5#1:
    inline$IoSetNextIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$5$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$5$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$5$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$5$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$5$label_6#1;

  inline$IoSetNextIrpStackLocation$5$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$5$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$5$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$5$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$5$label_1#1;

  inline$IoSetNextIrpStackLocation$5$label_1#1:
    goto inline$IoSetNextIrpStackLocation$5$Return#1;

  inline$IoSetNextIrpStackLocation$5$Return#1:
    goto inline$storm_IoCallDriver$4$label_10$1#1;

  inline$storm_IoCallDriver$4$label_10$1#1:
    goto inline$storm_IoCallDriver$4$anon11_Then#1, inline$storm_IoCallDriver$4$anon11_Else#1;

  inline$storm_IoCallDriver$4$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$4$anon1#1;

  inline$storm_IoCallDriver$4$anon1#1:
    goto inline$storm_IoCallDriver$4$label_18#1;

  inline$storm_IoCallDriver$4$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$43$Entry#1;

  inline$IoGetCurrentIrpStackLocation$43$Entry#1:
    inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$43$start#1;

  inline$IoGetCurrentIrpStackLocation$43$start#1:
    inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$43$label_3#1;

  inline$IoGetCurrentIrpStackLocation$43$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$43$label_3_true#1, inline$IoGetCurrentIrpStackLocation$43$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$43$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$43$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$43$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$43$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$43$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$43$label_4#1;

  inline$IoGetCurrentIrpStackLocation$43$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$43$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$43$label_6#1;

  inline$IoGetCurrentIrpStackLocation$43$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$43$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$43$label_7#1;

  inline$IoGetCurrentIrpStackLocation$43$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$43$label_5#1;

  inline$IoGetCurrentIrpStackLocation$43$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$43$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$43$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$43$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$43$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$43$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$43$label_5#1;

  inline$IoGetCurrentIrpStackLocation$43$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$43$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$43$label_1#1;

  inline$IoGetCurrentIrpStackLocation$43$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$43$Return#1;

  inline$IoGetCurrentIrpStackLocation$43$Return#1:
    goto inline$storm_IoCallDriver$4$label_18$1#1;

  inline$storm_IoCallDriver$4$label_18$1#1:
    goto inline$storm_IoCallDriver$4$anon13_Then#1, inline$storm_IoCallDriver$4$anon13_Else#1;

  inline$storm_IoCallDriver$4$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$4$anon6#1;

  inline$storm_IoCallDriver$4$anon6#1:
    goto inline$storm_IoCallDriver$4$label_21#1;

  inline$storm_IoCallDriver$4$label_21#1:
    goto inline$storm_IoCallDriver$4$label_22#1;

  inline$storm_IoCallDriver$4$label_22#1:
    goto inline$storm_IoCallDriver$4$label_23#1;

  inline$storm_IoCallDriver$4$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$4$label_24#1;

  inline$storm_IoCallDriver$4$label_24#1:
    call inline$storm_IoCallDriver$4$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$4$label_27#1;

  inline$storm_IoCallDriver$4$label_27#1:
    goto inline$storm_IoCallDriver$4$label_27_case_0#1, inline$storm_IoCallDriver$4$label_27_case_1#1, inline$storm_IoCallDriver$4$label_27_case_2#1;

  inline$storm_IoCallDriver$4$label_27_case_2#1:
    assume inline$storm_IoCallDriver$4$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$4$label_30#1;

  inline$storm_IoCallDriver$4$label_30#1:
    inline$storm_IoCallDriver$4$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$4$label_31#1;

  inline$storm_IoCallDriver$4$label_31#1:
    goto inline$storm_IoCallDriver$4$label_32#1;

  inline$storm_IoCallDriver$4$label_32#1:
    goto inline$storm_IoCallDriver$4$label_33#1;

  inline$storm_IoCallDriver$4$label_33#1:
    goto inline$CallCompletionRoutine$8$Entry#1;

  inline$CallCompletionRoutine$8$Entry#1:
    inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$8$start#1;

  inline$CallCompletionRoutine$8$start#1:
    inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$8$label_3#1;

  inline$CallCompletionRoutine$8$label_3#1:
    goto inline$CallCompletionRoutine$8$label_4#1;

  inline$CallCompletionRoutine$8$label_4#1:
    goto inline$CallCompletionRoutine$8$label_5#1;

  inline$CallCompletionRoutine$8$label_5#1:
    goto inline$CallCompletionRoutine$8$label_6#1;

  inline$CallCompletionRoutine$8$label_6#1:
    goto inline$CallCompletionRoutine$8$label_7#1;

  inline$CallCompletionRoutine$8$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$44$Entry#1;

  inline$IoGetCurrentIrpStackLocation$44$Entry#1:
    inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$44$start#1;

  inline$IoGetCurrentIrpStackLocation$44$start#1:
    inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$44$label_3#1;

  inline$IoGetCurrentIrpStackLocation$44$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$44$label_3_true#1, inline$IoGetCurrentIrpStackLocation$44$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$44$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$44$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$44$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$44$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$44$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$44$label_4#1;

  inline$IoGetCurrentIrpStackLocation$44$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$44$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$44$label_6#1;

  inline$IoGetCurrentIrpStackLocation$44$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$44$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$44$label_7#1;

  inline$IoGetCurrentIrpStackLocation$44$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$44$label_5#1;

  inline$IoGetCurrentIrpStackLocation$44$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$44$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$44$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$44$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$44$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$44$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$44$label_5#1;

  inline$IoGetCurrentIrpStackLocation$44$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$44$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$44$label_1#1;

  inline$IoGetCurrentIrpStackLocation$44$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$44$Return#1;

  inline$IoGetCurrentIrpStackLocation$44$Return#1:
    goto inline$CallCompletionRoutine$8$label_7$1#1;

  inline$CallCompletionRoutine$8$label_7$1#1:
    goto inline$CallCompletionRoutine$8$anon10_Then#1, inline$CallCompletionRoutine$8$anon10_Else#1;

  inline$CallCompletionRoutine$8$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$8$anon1#1;

  inline$CallCompletionRoutine$8$anon1#1:
    goto inline$CallCompletionRoutine$8$label_10#1;

  inline$CallCompletionRoutine$8$label_10#1:
    goto inline$CallCompletionRoutine$8$label_11#1;

  inline$CallCompletionRoutine$8$label_11#1:
    havoc inline$CallCompletionRoutine$8$myNondetVar_0;
    inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$8$myNondetVar_0;
    goto inline$CallCompletionRoutine$8$label_12#1;

  inline$CallCompletionRoutine$8$label_12#1:
    havoc inline$CallCompletionRoutine$8$myNondetVar_0;
    inline$CallCompletionRoutine$8$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$8$myNondetVar_0;
    goto inline$CallCompletionRoutine$8$label_13#1;

  inline$CallCompletionRoutine$8$label_13#1:
    havoc inline$CallCompletionRoutine$8$myNondetVar_0;
    goto inline$CallCompletionRoutine$8$label_14#1;

  inline$CallCompletionRoutine$8$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$45$Entry#1;

  inline$IoGetCurrentIrpStackLocation$45$Entry#1:
    inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$45$start#1;

  inline$IoGetCurrentIrpStackLocation$45$start#1:
    inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$45$label_3#1;

  inline$IoGetCurrentIrpStackLocation$45$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$45$label_3_true#1, inline$IoGetCurrentIrpStackLocation$45$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$45$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$45$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$45$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$45$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$45$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$45$label_4#1;

  inline$IoGetCurrentIrpStackLocation$45$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$45$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$45$label_6#1;

  inline$IoGetCurrentIrpStackLocation$45$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$45$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$45$label_7#1;

  inline$IoGetCurrentIrpStackLocation$45$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$45$label_5#1;

  inline$IoGetCurrentIrpStackLocation$45$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$45$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$45$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$45$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$45$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$45$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$45$label_5#1;

  inline$IoGetCurrentIrpStackLocation$45$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$45$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$45$label_1#1;

  inline$IoGetCurrentIrpStackLocation$45$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$45$Return#1;

  inline$IoGetCurrentIrpStackLocation$45$Return#1:
    goto inline$CallCompletionRoutine$8$label_14$1#1;

  inline$CallCompletionRoutine$8$label_14$1#1:
    goto inline$CallCompletionRoutine$8$anon11_Then#1, inline$CallCompletionRoutine$8$anon11_Else#1;

  inline$CallCompletionRoutine$8$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$8$anon3#1;

  inline$CallCompletionRoutine$8$anon3#1:
    goto inline$CallCompletionRoutine$8$label_17#1;

  inline$CallCompletionRoutine$8$label_17#1:
    goto inline$CallCompletionRoutine$8$label_18#1;

  inline$CallCompletionRoutine$8$label_18#1:
    goto inline$CallCompletionRoutine$8$label_18_true#1, inline$CallCompletionRoutine$8$label_18_false#1;

  inline$CallCompletionRoutine$8$label_18_false#1:
    assume inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$8$label_1#1;

  inline$CallCompletionRoutine$8$label_18_true#1:
    assume inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$8$label_19#1;

  inline$CallCompletionRoutine$8$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$8$label_20#1;

  inline$CallCompletionRoutine$8$label_20#1:
    goto inline$CallCompletionRoutine$8$label_20_icall_1#1, inline$CallCompletionRoutine$8$label_20_icall_2#1, inline$CallCompletionRoutine$8$label_20_icall_3#1;

  inline$CallCompletionRoutine$8$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$8$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$8$Entry#1;

  inline$BDLSystemPowerIoCompletion$8$Entry#1:
    inline$BDLSystemPowerIoCompletion$8$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$8$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$8$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$8$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$8$start#1;

  inline$BDLSystemPowerIoCompletion$8$start#1:
    call inline$BDLSystemPowerIoCompletion$8$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$8$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$8$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$8$label_3#1;

  inline$BDLSystemPowerIoCompletion$8$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_4#1;

  inline$BDLSystemPowerIoCompletion$8$label_4#1:
    inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_5#1;

  inline$BDLSystemPowerIoCompletion$8$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_6#1;

  inline$BDLSystemPowerIoCompletion$8$label_6#1:
    inline$BDLSystemPowerIoCompletion$8$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$8$label_7#1;

  inline$BDLSystemPowerIoCompletion$8$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_8#1;

  inline$BDLSystemPowerIoCompletion$8$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$8$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$8$label_9#1;

  inline$BDLSystemPowerIoCompletion$8$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_10#1;

  inline$BDLSystemPowerIoCompletion$8$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$47$Entry#1;

  inline$IoGetCurrentIrpStackLocation$47$Entry#1:
    inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$47$start#1;

  inline$IoGetCurrentIrpStackLocation$47$start#1:
    inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$47$label_3#1;

  inline$IoGetCurrentIrpStackLocation$47$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$47$label_3_true#1, inline$IoGetCurrentIrpStackLocation$47$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$47$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$47$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$47$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$47$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$47$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$47$label_4#1;

  inline$IoGetCurrentIrpStackLocation$47$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$47$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$47$label_6#1;

  inline$IoGetCurrentIrpStackLocation$47$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$47$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$47$label_7#1;

  inline$IoGetCurrentIrpStackLocation$47$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$47$label_5#1;

  inline$IoGetCurrentIrpStackLocation$47$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$47$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$47$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$47$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$47$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$47$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$47$label_5#1;

  inline$IoGetCurrentIrpStackLocation$47$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$47$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$47$label_1#1;

  inline$IoGetCurrentIrpStackLocation$47$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$47$Return#1;

  inline$IoGetCurrentIrpStackLocation$47$Return#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon36_Then#1, inline$BDLSystemPowerIoCompletion$8$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon1#1;

  inline$BDLSystemPowerIoCompletion$8$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_13#1;

  inline$BDLSystemPowerIoCompletion$8$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_14#1;

  inline$BDLSystemPowerIoCompletion$8$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_15#1;

  inline$BDLSystemPowerIoCompletion$8$label_15#1:
    goto inline$BDLGetDebugLevel$244$Entry#1;

  inline$BDLGetDebugLevel$244$Entry#1:
    goto inline$BDLGetDebugLevel$244$start#1;

  inline$BDLGetDebugLevel$244$start#1:
    goto inline$BDLGetDebugLevel$244$label_3#1;

  inline$BDLGetDebugLevel$244$label_3#1:
    havoc inline$BDLGetDebugLevel$244$myNondetVar_0;
    inline$BDLGetDebugLevel$244$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$244$myNondetVar_0;
    goto inline$BDLGetDebugLevel$244$label_1#1;

  inline$BDLGetDebugLevel$244$label_1#1:
    goto inline$BDLGetDebugLevel$244$Return#1;

  inline$BDLGetDebugLevel$244$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$244$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon37_Then#1, inline$BDLSystemPowerIoCompletion$8$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon3#1;

  inline$BDLSystemPowerIoCompletion$8$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_18#1;

  inline$BDLSystemPowerIoCompletion$8$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_18_true#1, inline$BDLSystemPowerIoCompletion$8$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_19#1;

  inline$BDLSystemPowerIoCompletion$8$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_22#1;

  inline$BDLSystemPowerIoCompletion$8$label_22#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_23#1;

  inline$BDLSystemPowerIoCompletion$8$label_23#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_24#1;

  inline$BDLSystemPowerIoCompletion$8$label_24#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_25#1;

  inline$BDLSystemPowerIoCompletion$8$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$8$label_19#1;

  inline$BDLSystemPowerIoCompletion$8$label_19#1:
    goto inline$BDLGetDebugLevel$245$Entry#1;

  inline$BDLGetDebugLevel$245$Entry#1:
    goto inline$BDLGetDebugLevel$245$start#1;

  inline$BDLGetDebugLevel$245$start#1:
    goto inline$BDLGetDebugLevel$245$label_3#1;

  inline$BDLGetDebugLevel$245$label_3#1:
    havoc inline$BDLGetDebugLevel$245$myNondetVar_0;
    inline$BDLGetDebugLevel$245$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$245$myNondetVar_0;
    goto inline$BDLGetDebugLevel$245$label_1#1;

  inline$BDLGetDebugLevel$245$label_1#1:
    goto inline$BDLGetDebugLevel$245$Return#1;

  inline$BDLGetDebugLevel$245$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$245$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon38_Then#1, inline$BDLSystemPowerIoCompletion$8$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon5#1;

  inline$BDLSystemPowerIoCompletion$8$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_28#1;

  inline$BDLSystemPowerIoCompletion$8$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_28_true#1, inline$BDLSystemPowerIoCompletion$8$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_29#1;

  inline$BDLSystemPowerIoCompletion$8$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_32#1;

  inline$BDLSystemPowerIoCompletion$8$label_32#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_33#1;

  inline$BDLSystemPowerIoCompletion$8$label_33#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_34#1;

  inline$BDLSystemPowerIoCompletion$8$label_34#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_35#1;

  inline$BDLSystemPowerIoCompletion$8$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$8$label_29#1;

  inline$BDLSystemPowerIoCompletion$8$label_29#1:
    goto inline$BDLGetDebugLevel$246$Entry#1;

  inline$BDLGetDebugLevel$246$Entry#1:
    goto inline$BDLGetDebugLevel$246$start#1;

  inline$BDLGetDebugLevel$246$start#1:
    goto inline$BDLGetDebugLevel$246$label_3#1;

  inline$BDLGetDebugLevel$246$label_3#1:
    havoc inline$BDLGetDebugLevel$246$myNondetVar_0;
    inline$BDLGetDebugLevel$246$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$246$myNondetVar_0;
    goto inline$BDLGetDebugLevel$246$label_1#1;

  inline$BDLGetDebugLevel$246$label_1#1:
    goto inline$BDLGetDebugLevel$246$Return#1;

  inline$BDLGetDebugLevel$246$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$246$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon39_Then#1, inline$BDLSystemPowerIoCompletion$8$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon7#1;

  inline$BDLSystemPowerIoCompletion$8$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_38#1;

  inline$BDLSystemPowerIoCompletion$8$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_38_true#1, inline$BDLSystemPowerIoCompletion$8$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_39#1;

  inline$BDLSystemPowerIoCompletion$8$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_40#1;

  inline$BDLSystemPowerIoCompletion$8$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_39#1;

  inline$BDLSystemPowerIoCompletion$8$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_39_true#1, inline$BDLSystemPowerIoCompletion$8$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_41#1;

  inline$BDLSystemPowerIoCompletion$8$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$8$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$8$label_107#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$8$label_108#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$8$label_108#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$8$label_108#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$8$label_108#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$8$label_108#1;

  inline$BDLSystemPowerIoCompletion$8$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_109#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$8$label_107#1;

  inline$BDLSystemPowerIoCompletion$8$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_109#1;

  inline$BDLSystemPowerIoCompletion$8$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$8$label_106#1;

  inline$BDLSystemPowerIoCompletion$8$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_106_true#1, inline$BDLSystemPowerIoCompletion$8$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_142#1;

  inline$BDLSystemPowerIoCompletion$8$label_142#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_143#1;

  inline$BDLSystemPowerIoCompletion$8$label_143#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_144#1;

  inline$BDLSystemPowerIoCompletion$8$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_109#1;

  inline$BDLSystemPowerIoCompletion$8$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_109#1;

  inline$BDLSystemPowerIoCompletion$8$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$8$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$8$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$8$myNondetVar_0, inline$BDLSystemPowerIoCompletion$8$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$8$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$8$anon50_Then#1, inline$BDLSystemPowerIoCompletion$8$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon29#1;

  inline$BDLSystemPowerIoCompletion$8$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_112#1;

  inline$BDLSystemPowerIoCompletion$8$label_112#1:
    inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$8$label_113#1;

  inline$BDLSystemPowerIoCompletion$8$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_113_true#1, inline$BDLSystemPowerIoCompletion$8$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$8$label_114#1;

  inline$BDLSystemPowerIoCompletion$8$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_116#1;

  inline$BDLSystemPowerIoCompletion$8$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_117#1;

  inline$BDLSystemPowerIoCompletion$8$label_117#1:
    goto inline$BDLGetDebugLevel$253$Entry#1;

  inline$BDLGetDebugLevel$253$Entry#1:
    goto inline$BDLGetDebugLevel$253$start#1;

  inline$BDLGetDebugLevel$253$start#1:
    goto inline$BDLGetDebugLevel$253$label_3#1;

  inline$BDLGetDebugLevel$253$label_3#1:
    havoc inline$BDLGetDebugLevel$253$myNondetVar_0;
    inline$BDLGetDebugLevel$253$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$253$myNondetVar_0;
    goto inline$BDLGetDebugLevel$253$label_1#1;

  inline$BDLGetDebugLevel$253$label_1#1:
    goto inline$BDLGetDebugLevel$253$Return#1;

  inline$BDLGetDebugLevel$253$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$253$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon51_Then#1, inline$BDLSystemPowerIoCompletion$8$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon31#1;

  inline$BDLSystemPowerIoCompletion$8$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_120#1;

  inline$BDLSystemPowerIoCompletion$8$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_120_true#1, inline$BDLSystemPowerIoCompletion$8$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_121#1;

  inline$BDLSystemPowerIoCompletion$8$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_124#1;

  inline$BDLSystemPowerIoCompletion$8$label_124#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_125#1;

  inline$BDLSystemPowerIoCompletion$8$label_125#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_126#1;

  inline$BDLSystemPowerIoCompletion$8$label_126#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_127#1;

  inline$BDLSystemPowerIoCompletion$8$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$8$label_121#1;

  inline$BDLSystemPowerIoCompletion$8$label_121#1:
    goto inline$BDLGetDebugLevel$254$Entry#1;

  inline$BDLGetDebugLevel$254$Entry#1:
    goto inline$BDLGetDebugLevel$254$start#1;

  inline$BDLGetDebugLevel$254$start#1:
    goto inline$BDLGetDebugLevel$254$label_3#1;

  inline$BDLGetDebugLevel$254$label_3#1:
    havoc inline$BDLGetDebugLevel$254$myNondetVar_0;
    inline$BDLGetDebugLevel$254$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$254$myNondetVar_0;
    goto inline$BDLGetDebugLevel$254$label_1#1;

  inline$BDLGetDebugLevel$254$label_1#1:
    goto inline$BDLGetDebugLevel$254$Return#1;

  inline$BDLGetDebugLevel$254$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$254$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon52_Then#1, inline$BDLSystemPowerIoCompletion$8$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon33#1;

  inline$BDLSystemPowerIoCompletion$8$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_130#1;

  inline$BDLSystemPowerIoCompletion$8$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_130_true#1, inline$BDLSystemPowerIoCompletion$8$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_131#1;

  inline$BDLSystemPowerIoCompletion$8$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_134#1;

  inline$BDLSystemPowerIoCompletion$8$label_134#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_135#1;

  inline$BDLSystemPowerIoCompletion$8$label_135#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_136#1;

  inline$BDLSystemPowerIoCompletion$8$label_136#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_137#1;

  inline$BDLSystemPowerIoCompletion$8$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$8$label_131#1;

  inline$BDLSystemPowerIoCompletion$8$label_131#1:
    goto inline$BDLGetDebugLevel$255$Entry#1;

  inline$BDLGetDebugLevel$255$Entry#1:
    goto inline$BDLGetDebugLevel$255$start#1;

  inline$BDLGetDebugLevel$255$start#1:
    goto inline$BDLGetDebugLevel$255$label_3#1;

  inline$BDLGetDebugLevel$255$label_3#1:
    havoc inline$BDLGetDebugLevel$255$myNondetVar_0;
    inline$BDLGetDebugLevel$255$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$255$myNondetVar_0;
    goto inline$BDLGetDebugLevel$255$label_1#1;

  inline$BDLGetDebugLevel$255$label_1#1:
    goto inline$BDLGetDebugLevel$255$Return#1;

  inline$BDLGetDebugLevel$255$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$255$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon53_Then#1, inline$BDLSystemPowerIoCompletion$8$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon35#1;

  inline$BDLSystemPowerIoCompletion$8$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_140#1;

  inline$BDLSystemPowerIoCompletion$8$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_140_true#1, inline$BDLSystemPowerIoCompletion$8$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_67#1;

  inline$BDLSystemPowerIoCompletion$8$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_141#1;

  inline$BDLSystemPowerIoCompletion$8$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_67#1;

  inline$BDLSystemPowerIoCompletion$8$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$8$label_115#1;

  inline$BDLSystemPowerIoCompletion$8$label_115#1:
    inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$8$label_80#1;

  inline$BDLSystemPowerIoCompletion$8$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$8$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_42#1;

  inline$BDLSystemPowerIoCompletion$8$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$8$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$8$label_43#1;

  inline$BDLSystemPowerIoCompletion$8$label_43#1:
    goto inline$BDLGetDebugLevel$247$Entry#1;

  inline$BDLGetDebugLevel$247$Entry#1:
    goto inline$BDLGetDebugLevel$247$start#1;

  inline$BDLGetDebugLevel$247$start#1:
    goto inline$BDLGetDebugLevel$247$label_3#1;

  inline$BDLGetDebugLevel$247$label_3#1:
    havoc inline$BDLGetDebugLevel$247$myNondetVar_0;
    inline$BDLGetDebugLevel$247$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$247$myNondetVar_0;
    goto inline$BDLGetDebugLevel$247$label_1#1;

  inline$BDLGetDebugLevel$247$label_1#1:
    goto inline$BDLGetDebugLevel$247$Return#1;

  inline$BDLGetDebugLevel$247$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$247$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon40_Then#1, inline$BDLSystemPowerIoCompletion$8$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon9#1;

  inline$BDLSystemPowerIoCompletion$8$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_46#1;

  inline$BDLSystemPowerIoCompletion$8$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_46_true#1, inline$BDLSystemPowerIoCompletion$8$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_47#1;

  inline$BDLSystemPowerIoCompletion$8$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_50#1;

  inline$BDLSystemPowerIoCompletion$8$label_50#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_51#1;

  inline$BDLSystemPowerIoCompletion$8$label_51#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_52#1;

  inline$BDLSystemPowerIoCompletion$8$label_52#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_53#1;

  inline$BDLSystemPowerIoCompletion$8$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$8$label_47#1;

  inline$BDLSystemPowerIoCompletion$8$label_47#1:
    goto inline$BDLGetDebugLevel$248$Entry#1;

  inline$BDLGetDebugLevel$248$Entry#1:
    goto inline$BDLGetDebugLevel$248$start#1;

  inline$BDLGetDebugLevel$248$start#1:
    goto inline$BDLGetDebugLevel$248$label_3#1;

  inline$BDLGetDebugLevel$248$label_3#1:
    havoc inline$BDLGetDebugLevel$248$myNondetVar_0;
    inline$BDLGetDebugLevel$248$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$248$myNondetVar_0;
    goto inline$BDLGetDebugLevel$248$label_1#1;

  inline$BDLGetDebugLevel$248$label_1#1:
    goto inline$BDLGetDebugLevel$248$Return#1;

  inline$BDLGetDebugLevel$248$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$248$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon41_Then#1, inline$BDLSystemPowerIoCompletion$8$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon11#1;

  inline$BDLSystemPowerIoCompletion$8$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_56#1;

  inline$BDLSystemPowerIoCompletion$8$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_56_true#1, inline$BDLSystemPowerIoCompletion$8$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_57#1;

  inline$BDLSystemPowerIoCompletion$8$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_60#1;

  inline$BDLSystemPowerIoCompletion$8$label_60#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_61#1;

  inline$BDLSystemPowerIoCompletion$8$label_61#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_62#1;

  inline$BDLSystemPowerIoCompletion$8$label_62#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_63#1;

  inline$BDLSystemPowerIoCompletion$8$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$8$label_57#1;

  inline$BDLSystemPowerIoCompletion$8$label_57#1:
    goto inline$BDLGetDebugLevel$249$Entry#1;

  inline$BDLGetDebugLevel$249$Entry#1:
    goto inline$BDLGetDebugLevel$249$start#1;

  inline$BDLGetDebugLevel$249$start#1:
    goto inline$BDLGetDebugLevel$249$label_3#1;

  inline$BDLGetDebugLevel$249$label_3#1:
    havoc inline$BDLGetDebugLevel$249$myNondetVar_0;
    inline$BDLGetDebugLevel$249$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$249$myNondetVar_0;
    goto inline$BDLGetDebugLevel$249$label_1#1;

  inline$BDLGetDebugLevel$249$label_1#1:
    goto inline$BDLGetDebugLevel$249$Return#1;

  inline$BDLGetDebugLevel$249$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$249$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon42_Then#1, inline$BDLSystemPowerIoCompletion$8$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon13#1;

  inline$BDLSystemPowerIoCompletion$8$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_66#1;

  inline$BDLSystemPowerIoCompletion$8$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_66_true#1, inline$BDLSystemPowerIoCompletion$8$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_67#1;

  inline$BDLSystemPowerIoCompletion$8$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_70#1;

  inline$BDLSystemPowerIoCompletion$8$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_67#1;

  inline$BDLSystemPowerIoCompletion$8$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$8$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$8$anon43_Then#1, inline$BDLSystemPowerIoCompletion$8$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon15#1;

  inline$BDLSystemPowerIoCompletion$8$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_71#1;

  inline$BDLSystemPowerIoCompletion$8$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$8$anon44_Then#1, inline$BDLSystemPowerIoCompletion$8$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon17#1;

  inline$BDLSystemPowerIoCompletion$8$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_74#1;

  inline$BDLSystemPowerIoCompletion$8$label_74#1:
    goto inline$storm_IoCompleteRequest$18$Entry#1;

  inline$storm_IoCompleteRequest$18$Entry#1:
    inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$8$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$18$start#1;

  inline$storm_IoCompleteRequest$18$start#1:
    inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$18$label_3#1;

  inline$storm_IoCompleteRequest$18$label_3#1:
    call inline$storm_IoCompleteRequest$18$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$18$label_6#1;

  inline$storm_IoCompleteRequest$18$label_6#1:
    goto inline$storm_IoCompleteRequest$18$label_6_true#1, inline$storm_IoCompleteRequest$18$label_6_false#1;

  inline$storm_IoCompleteRequest$18$label_6_false#1:
    assume inline$storm_IoCompleteRequest$18$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$18$label_7#1;

  inline$storm_IoCompleteRequest$18$label_6_true#1:
    assume inline$storm_IoCompleteRequest$18$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$18$label_8#1;

  inline$storm_IoCompleteRequest$18$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$18$anon3_Then#1, inline$storm_IoCompleteRequest$18$anon3_Else#1;

  inline$storm_IoCompleteRequest$18$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$18$anon1#1;

  inline$storm_IoCompleteRequest$18$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$18$label_9#1;

  inline$storm_IoCompleteRequest$18$label_9#1:
    goto inline$storm_IoCompleteRequest$18$label_9_true#1, inline$storm_IoCompleteRequest$18$label_9_false#1;

  inline$storm_IoCompleteRequest$18$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$18$label_10#1;

  inline$storm_IoCompleteRequest$18$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$18$label_1#1;

  inline$storm_IoCompleteRequest$18$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$18$label_7#1;

  inline$storm_IoCompleteRequest$18$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$18$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$18$label_1#1;

  inline$storm_IoCompleteRequest$18$label_1#1:
    goto inline$storm_IoCompleteRequest$18$Return#1;

  inline$storm_IoCompleteRequest$18$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$18$Return#1;

  inline$storm_IoCompleteRequest$18$Return#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon45_Then#1, inline$BDLSystemPowerIoCompletion$8$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon19#1;

  inline$BDLSystemPowerIoCompletion$8$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_77#1;

  inline$BDLSystemPowerIoCompletion$8$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$8$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$8$anon46_Then#1, inline$BDLSystemPowerIoCompletion$8$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon21#1;

  inline$BDLSystemPowerIoCompletion$8$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_80#1;

  inline$BDLSystemPowerIoCompletion$8$label_80#1:
    goto inline$BDLGetDebugLevel$250$Entry#1;

  inline$BDLGetDebugLevel$250$Entry#1:
    goto inline$BDLGetDebugLevel$250$start#1;

  inline$BDLGetDebugLevel$250$start#1:
    goto inline$BDLGetDebugLevel$250$label_3#1;

  inline$BDLGetDebugLevel$250$label_3#1:
    havoc inline$BDLGetDebugLevel$250$myNondetVar_0;
    inline$BDLGetDebugLevel$250$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$250$myNondetVar_0;
    goto inline$BDLGetDebugLevel$250$label_1#1;

  inline$BDLGetDebugLevel$250$label_1#1:
    goto inline$BDLGetDebugLevel$250$Return#1;

  inline$BDLGetDebugLevel$250$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$250$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon47_Then#1, inline$BDLSystemPowerIoCompletion$8$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon23#1;

  inline$BDLSystemPowerIoCompletion$8$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_83#1;

  inline$BDLSystemPowerIoCompletion$8$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_83_true#1, inline$BDLSystemPowerIoCompletion$8$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_84#1;

  inline$BDLSystemPowerIoCompletion$8$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_87#1;

  inline$BDLSystemPowerIoCompletion$8$label_87#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_88#1;

  inline$BDLSystemPowerIoCompletion$8$label_88#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_89#1;

  inline$BDLSystemPowerIoCompletion$8$label_89#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_90#1;

  inline$BDLSystemPowerIoCompletion$8$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$8$label_84#1;

  inline$BDLSystemPowerIoCompletion$8$label_84#1:
    goto inline$BDLGetDebugLevel$251$Entry#1;

  inline$BDLGetDebugLevel$251$Entry#1:
    goto inline$BDLGetDebugLevel$251$start#1;

  inline$BDLGetDebugLevel$251$start#1:
    goto inline$BDLGetDebugLevel$251$label_3#1;

  inline$BDLGetDebugLevel$251$label_3#1:
    havoc inline$BDLGetDebugLevel$251$myNondetVar_0;
    inline$BDLGetDebugLevel$251$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$251$myNondetVar_0;
    goto inline$BDLGetDebugLevel$251$label_1#1;

  inline$BDLGetDebugLevel$251$label_1#1:
    goto inline$BDLGetDebugLevel$251$Return#1;

  inline$BDLGetDebugLevel$251$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$251$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon48_Then#1, inline$BDLSystemPowerIoCompletion$8$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon25#1;

  inline$BDLSystemPowerIoCompletion$8$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_93#1;

  inline$BDLSystemPowerIoCompletion$8$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_93_true#1, inline$BDLSystemPowerIoCompletion$8$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_94#1;

  inline$BDLSystemPowerIoCompletion$8$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_97#1;

  inline$BDLSystemPowerIoCompletion$8$label_97#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_98#1;

  inline$BDLSystemPowerIoCompletion$8$label_98#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_99#1;

  inline$BDLSystemPowerIoCompletion$8$label_99#1:
    call inline$BDLSystemPowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$8$label_100#1;

  inline$BDLSystemPowerIoCompletion$8$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$8$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$8$label_94#1;

  inline$BDLSystemPowerIoCompletion$8$label_94#1:
    goto inline$BDLGetDebugLevel$252$Entry#1;

  inline$BDLGetDebugLevel$252$Entry#1:
    goto inline$BDLGetDebugLevel$252$start#1;

  inline$BDLGetDebugLevel$252$start#1:
    goto inline$BDLGetDebugLevel$252$label_3#1;

  inline$BDLGetDebugLevel$252$label_3#1:
    havoc inline$BDLGetDebugLevel$252$myNondetVar_0;
    inline$BDLGetDebugLevel$252$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$252$myNondetVar_0;
    goto inline$BDLGetDebugLevel$252$label_1#1;

  inline$BDLGetDebugLevel$252$label_1#1:
    goto inline$BDLGetDebugLevel$252$Return#1;

  inline$BDLGetDebugLevel$252$Return#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$252$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$8$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$8$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$8$anon49_Then#1, inline$BDLSystemPowerIoCompletion$8$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$8$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$anon27#1;

  inline$BDLSystemPowerIoCompletion$8$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_103#1;

  inline$BDLSystemPowerIoCompletion$8$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_103_true#1, inline$BDLSystemPowerIoCompletion$8$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$8$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_104#1;

  inline$BDLSystemPowerIoCompletion$8$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$8$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$8$label_105#1;

  inline$BDLSystemPowerIoCompletion$8$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$8$label_104#1;

  inline$BDLSystemPowerIoCompletion$8$label_104#1:
    inline$BDLSystemPowerIoCompletion$8$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$8$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$8$label_1#1;

  inline$BDLSystemPowerIoCompletion$8$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$8$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$8$Return#1;

  inline$BDLSystemPowerIoCompletion$8$Return#1:
    inline$CallCompletionRoutine$8$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$8$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$8$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$8$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$8$anon14_Then#1, inline$CallCompletionRoutine$8$anon14_Else#1;

  inline$CallCompletionRoutine$8$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$8$anon9#1;

  inline$CallCompletionRoutine$8$anon9#1:
    goto inline$CallCompletionRoutine$8$label_20_icall_return#1;

  inline$CallCompletionRoutine$8$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$8$Return#1;

  inline$CallCompletionRoutine$8$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$8$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$8$Entry#1;

  inline$BDLDevicePowerIoCompletion$8$Entry#1:
    inline$BDLDevicePowerIoCompletion$8$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$8$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$8$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$8$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$8$start#1;

  inline$BDLDevicePowerIoCompletion$8$start#1:
    call inline$BDLDevicePowerIoCompletion$8$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$8$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$8$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$8$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$8$label_3#1;

  inline$BDLDevicePowerIoCompletion$8$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_4#1;

  inline$BDLDevicePowerIoCompletion$8$label_4#1:
    inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_5#1;

  inline$BDLDevicePowerIoCompletion$8$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_6#1;

  inline$BDLDevicePowerIoCompletion$8$label_6#1:
    inline$BDLDevicePowerIoCompletion$8$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$8$label_7#1;

  inline$BDLDevicePowerIoCompletion$8$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_8#1;

  inline$BDLDevicePowerIoCompletion$8$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$8$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$8$label_9#1;

  inline$BDLDevicePowerIoCompletion$8$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_10#1;

  inline$BDLDevicePowerIoCompletion$8$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$46$Entry#1;

  inline$IoGetCurrentIrpStackLocation$46$Entry#1:
    inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$46$start#1;

  inline$IoGetCurrentIrpStackLocation$46$start#1:
    inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$46$label_3#1;

  inline$IoGetCurrentIrpStackLocation$46$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$46$label_3_true#1, inline$IoGetCurrentIrpStackLocation$46$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$46$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$46$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$46$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$46$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$46$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$46$label_4#1;

  inline$IoGetCurrentIrpStackLocation$46$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$46$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$46$label_6#1;

  inline$IoGetCurrentIrpStackLocation$46$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$46$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$46$label_7#1;

  inline$IoGetCurrentIrpStackLocation$46$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$46$label_5#1;

  inline$IoGetCurrentIrpStackLocation$46$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$46$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$46$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$46$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$46$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$46$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$46$label_5#1;

  inline$IoGetCurrentIrpStackLocation$46$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$46$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$46$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$46$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$46$label_1#1;

  inline$IoGetCurrentIrpStackLocation$46$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$46$Return#1;

  inline$IoGetCurrentIrpStackLocation$46$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$46$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon30_Then#1, inline$BDLDevicePowerIoCompletion$8$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon1#1;

  inline$BDLDevicePowerIoCompletion$8$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_13#1;

  inline$BDLDevicePowerIoCompletion$8$label_13#1:
    inline$BDLDevicePowerIoCompletion$8$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$8$label_14#1;

  inline$BDLDevicePowerIoCompletion$8$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_15#1;

  inline$BDLDevicePowerIoCompletion$8$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$8$label_16#1;

  inline$BDLDevicePowerIoCompletion$8$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_17#1;

  inline$BDLDevicePowerIoCompletion$8$label_17#1:
    goto inline$BDLGetDebugLevel$235$Entry#1;

  inline$BDLGetDebugLevel$235$Entry#1:
    goto inline$BDLGetDebugLevel$235$start#1;

  inline$BDLGetDebugLevel$235$start#1:
    goto inline$BDLGetDebugLevel$235$label_3#1;

  inline$BDLGetDebugLevel$235$label_3#1:
    havoc inline$BDLGetDebugLevel$235$myNondetVar_0;
    inline$BDLGetDebugLevel$235$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$235$myNondetVar_0;
    goto inline$BDLGetDebugLevel$235$label_1#1;

  inline$BDLGetDebugLevel$235$label_1#1:
    goto inline$BDLGetDebugLevel$235$Return#1;

  inline$BDLGetDebugLevel$235$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$235$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon31_Then#1, inline$BDLDevicePowerIoCompletion$8$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon3#1;

  inline$BDLDevicePowerIoCompletion$8$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_20#1;

  inline$BDLDevicePowerIoCompletion$8$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_20_true#1, inline$BDLDevicePowerIoCompletion$8$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_21#1;

  inline$BDLDevicePowerIoCompletion$8$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_24#1;

  inline$BDLDevicePowerIoCompletion$8$label_24#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_25#1;

  inline$BDLDevicePowerIoCompletion$8$label_25#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_26#1;

  inline$BDLDevicePowerIoCompletion$8$label_26#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_27#1;

  inline$BDLDevicePowerIoCompletion$8$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$8$label_21#1;

  inline$BDLDevicePowerIoCompletion$8$label_21#1:
    goto inline$BDLGetDebugLevel$236$Entry#1;

  inline$BDLGetDebugLevel$236$Entry#1:
    goto inline$BDLGetDebugLevel$236$start#1;

  inline$BDLGetDebugLevel$236$start#1:
    goto inline$BDLGetDebugLevel$236$label_3#1;

  inline$BDLGetDebugLevel$236$label_3#1:
    havoc inline$BDLGetDebugLevel$236$myNondetVar_0;
    inline$BDLGetDebugLevel$236$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$236$myNondetVar_0;
    goto inline$BDLGetDebugLevel$236$label_1#1;

  inline$BDLGetDebugLevel$236$label_1#1:
    goto inline$BDLGetDebugLevel$236$Return#1;

  inline$BDLGetDebugLevel$236$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$236$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon32_Then#1, inline$BDLDevicePowerIoCompletion$8$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon5#1;

  inline$BDLDevicePowerIoCompletion$8$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_30#1;

  inline$BDLDevicePowerIoCompletion$8$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_30_true#1, inline$BDLDevicePowerIoCompletion$8$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_31#1;

  inline$BDLDevicePowerIoCompletion$8$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_34#1;

  inline$BDLDevicePowerIoCompletion$8$label_34#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_35#1;

  inline$BDLDevicePowerIoCompletion$8$label_35#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_36#1;

  inline$BDLDevicePowerIoCompletion$8$label_36#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_37#1;

  inline$BDLDevicePowerIoCompletion$8$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$8$label_31#1;

  inline$BDLDevicePowerIoCompletion$8$label_31#1:
    goto inline$BDLGetDebugLevel$237$Entry#1;

  inline$BDLGetDebugLevel$237$Entry#1:
    goto inline$BDLGetDebugLevel$237$start#1;

  inline$BDLGetDebugLevel$237$start#1:
    goto inline$BDLGetDebugLevel$237$label_3#1;

  inline$BDLGetDebugLevel$237$label_3#1:
    havoc inline$BDLGetDebugLevel$237$myNondetVar_0;
    inline$BDLGetDebugLevel$237$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$237$myNondetVar_0;
    goto inline$BDLGetDebugLevel$237$label_1#1;

  inline$BDLGetDebugLevel$237$label_1#1:
    goto inline$BDLGetDebugLevel$237$Return#1;

  inline$BDLGetDebugLevel$237$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$237$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon33_Then#1, inline$BDLDevicePowerIoCompletion$8$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon7#1;

  inline$BDLDevicePowerIoCompletion$8$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_40#1;

  inline$BDLDevicePowerIoCompletion$8$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_40_true#1, inline$BDLDevicePowerIoCompletion$8$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_41#1;

  inline$BDLDevicePowerIoCompletion$8$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_42#1;

  inline$BDLDevicePowerIoCompletion$8$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_41#1;

  inline$BDLDevicePowerIoCompletion$8$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_41_true#1, inline$BDLDevicePowerIoCompletion$8$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$8$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$8$label_43#1;

  inline$BDLDevicePowerIoCompletion$8$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$8$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$8$label_44#1;

  inline$BDLDevicePowerIoCompletion$8$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_44_true#1, inline$BDLDevicePowerIoCompletion$8$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$8$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$8$label_45#1;

  inline$BDLDevicePowerIoCompletion$8$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_45_true#1, inline$BDLDevicePowerIoCompletion$8$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$8$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$8$label_43#1;

  inline$BDLDevicePowerIoCompletion$8$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$8$label_86#1;

  inline$BDLDevicePowerIoCompletion$8$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$8$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$8$label_46#1;

  inline$BDLDevicePowerIoCompletion$8$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$8$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$8$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$8$label_46#1;

  inline$BDLDevicePowerIoCompletion$8$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$8$label_49#1;

  inline$BDLDevicePowerIoCompletion$8$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_50#1;

  inline$BDLDevicePowerIoCompletion$8$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_51#1;

  inline$BDLDevicePowerIoCompletion$8$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_54#1;

  inline$BDLDevicePowerIoCompletion$8$label_54#1:
    inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$8$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$8$label_55#1;

  inline$BDLDevicePowerIoCompletion$8$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_55_true#1, inline$BDLDevicePowerIoCompletion$8$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_56#1;

  inline$BDLDevicePowerIoCompletion$8$label_56#1:
    call inline$BDLDevicePowerIoCompletion$8$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$8$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$8$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$8$anon34_Then#1, inline$BDLDevicePowerIoCompletion$8$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon9#1;

  inline$BDLDevicePowerIoCompletion$8$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_83#1;

  inline$BDLDevicePowerIoCompletion$8$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_59#1;

  inline$BDLDevicePowerIoCompletion$8$label_59#1:
    goto inline$BDLGetDebugLevel$238$Entry#1;

  inline$BDLGetDebugLevel$238$Entry#1:
    goto inline$BDLGetDebugLevel$238$start#1;

  inline$BDLGetDebugLevel$238$start#1:
    goto inline$BDLGetDebugLevel$238$label_3#1;

  inline$BDLGetDebugLevel$238$label_3#1:
    havoc inline$BDLGetDebugLevel$238$myNondetVar_0;
    inline$BDLGetDebugLevel$238$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$238$myNondetVar_0;
    goto inline$BDLGetDebugLevel$238$label_1#1;

  inline$BDLGetDebugLevel$238$label_1#1:
    goto inline$BDLGetDebugLevel$238$Return#1;

  inline$BDLGetDebugLevel$238$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$238$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon35_Then#1, inline$BDLDevicePowerIoCompletion$8$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon11#1;

  inline$BDLDevicePowerIoCompletion$8$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_62#1;

  inline$BDLDevicePowerIoCompletion$8$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_62_true#1, inline$BDLDevicePowerIoCompletion$8$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_63#1;

  inline$BDLDevicePowerIoCompletion$8$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_66#1;

  inline$BDLDevicePowerIoCompletion$8$label_66#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_67#1;

  inline$BDLDevicePowerIoCompletion$8$label_67#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_68#1;

  inline$BDLDevicePowerIoCompletion$8$label_68#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_69#1;

  inline$BDLDevicePowerIoCompletion$8$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$8$label_63#1;

  inline$BDLDevicePowerIoCompletion$8$label_63#1:
    goto inline$BDLGetDebugLevel$239$Entry#1;

  inline$BDLGetDebugLevel$239$Entry#1:
    goto inline$BDLGetDebugLevel$239$start#1;

  inline$BDLGetDebugLevel$239$start#1:
    goto inline$BDLGetDebugLevel$239$label_3#1;

  inline$BDLGetDebugLevel$239$label_3#1:
    havoc inline$BDLGetDebugLevel$239$myNondetVar_0;
    inline$BDLGetDebugLevel$239$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$239$myNondetVar_0;
    goto inline$BDLGetDebugLevel$239$label_1#1;

  inline$BDLGetDebugLevel$239$label_1#1:
    goto inline$BDLGetDebugLevel$239$Return#1;

  inline$BDLGetDebugLevel$239$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$239$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon36_Then#1, inline$BDLDevicePowerIoCompletion$8$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon13#1;

  inline$BDLDevicePowerIoCompletion$8$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_72#1;

  inline$BDLDevicePowerIoCompletion$8$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_72_true#1, inline$BDLDevicePowerIoCompletion$8$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_73#1;

  inline$BDLDevicePowerIoCompletion$8$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_76#1;

  inline$BDLDevicePowerIoCompletion$8$label_76#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_77#1;

  inline$BDLDevicePowerIoCompletion$8$label_77#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_78#1;

  inline$BDLDevicePowerIoCompletion$8$label_78#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_79#1;

  inline$BDLDevicePowerIoCompletion$8$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$8$label_73#1;

  inline$BDLDevicePowerIoCompletion$8$label_73#1:
    goto inline$BDLGetDebugLevel$240$Entry#1;

  inline$BDLGetDebugLevel$240$Entry#1:
    goto inline$BDLGetDebugLevel$240$start#1;

  inline$BDLGetDebugLevel$240$start#1:
    goto inline$BDLGetDebugLevel$240$label_3#1;

  inline$BDLGetDebugLevel$240$label_3#1:
    havoc inline$BDLGetDebugLevel$240$myNondetVar_0;
    inline$BDLGetDebugLevel$240$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$240$myNondetVar_0;
    goto inline$BDLGetDebugLevel$240$label_1#1;

  inline$BDLGetDebugLevel$240$label_1#1:
    goto inline$BDLGetDebugLevel$240$Return#1;

  inline$BDLGetDebugLevel$240$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$240$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon37_Then#1, inline$BDLDevicePowerIoCompletion$8$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon15#1;

  inline$BDLDevicePowerIoCompletion$8$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_82#1;

  inline$BDLDevicePowerIoCompletion$8$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_82_true#1, inline$BDLDevicePowerIoCompletion$8$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_83#1;

  inline$BDLDevicePowerIoCompletion$8$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_84#1;

  inline$BDLDevicePowerIoCompletion$8$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_83#1;

  inline$BDLDevicePowerIoCompletion$8$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_85#1;

  inline$BDLDevicePowerIoCompletion$8$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_86#1;

  inline$BDLDevicePowerIoCompletion$8$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$8$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$8$anon38_Then#1, inline$BDLDevicePowerIoCompletion$8$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon17#1;

  inline$BDLDevicePowerIoCompletion$8$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_89#1;

  inline$BDLDevicePowerIoCompletion$8$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$8$anon39_Then#1, inline$BDLDevicePowerIoCompletion$8$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon19#1;

  inline$BDLDevicePowerIoCompletion$8$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_92#1;

  inline$BDLDevicePowerIoCompletion$8$label_92#1:
    goto inline$storm_IoCompleteRequest$17$Entry#1;

  inline$storm_IoCompleteRequest$17$Entry#1:
    inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$8$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$17$start#1;

  inline$storm_IoCompleteRequest$17$start#1:
    inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$17$label_3#1;

  inline$storm_IoCompleteRequest$17$label_3#1:
    call inline$storm_IoCompleteRequest$17$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$17$label_6#1;

  inline$storm_IoCompleteRequest$17$label_6#1:
    goto inline$storm_IoCompleteRequest$17$label_6_true#1, inline$storm_IoCompleteRequest$17$label_6_false#1;

  inline$storm_IoCompleteRequest$17$label_6_false#1:
    assume inline$storm_IoCompleteRequest$17$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$17$label_7#1;

  inline$storm_IoCompleteRequest$17$label_6_true#1:
    assume inline$storm_IoCompleteRequest$17$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$17$label_8#1;

  inline$storm_IoCompleteRequest$17$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$17$anon3_Then#1, inline$storm_IoCompleteRequest$17$anon3_Else#1;

  inline$storm_IoCompleteRequest$17$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$17$anon1#1;

  inline$storm_IoCompleteRequest$17$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$17$label_9#1;

  inline$storm_IoCompleteRequest$17$label_9#1:
    goto inline$storm_IoCompleteRequest$17$label_9_true#1, inline$storm_IoCompleteRequest$17$label_9_false#1;

  inline$storm_IoCompleteRequest$17$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$17$label_10#1;

  inline$storm_IoCompleteRequest$17$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$17$label_1#1;

  inline$storm_IoCompleteRequest$17$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$17$label_7#1;

  inline$storm_IoCompleteRequest$17$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$17$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$17$label_1#1;

  inline$storm_IoCompleteRequest$17$label_1#1:
    goto inline$storm_IoCompleteRequest$17$Return#1;

  inline$storm_IoCompleteRequest$17$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$17$Return#1;

  inline$storm_IoCompleteRequest$17$Return#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon40_Then#1, inline$BDLDevicePowerIoCompletion$8$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon21#1;

  inline$BDLDevicePowerIoCompletion$8$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_95#1;

  inline$BDLDevicePowerIoCompletion$8$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$8$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$8$anon41_Then#1, inline$BDLDevicePowerIoCompletion$8$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon23#1;

  inline$BDLDevicePowerIoCompletion$8$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_98#1;

  inline$BDLDevicePowerIoCompletion$8$label_98#1:
    goto inline$BDLGetDebugLevel$241$Entry#1;

  inline$BDLGetDebugLevel$241$Entry#1:
    goto inline$BDLGetDebugLevel$241$start#1;

  inline$BDLGetDebugLevel$241$start#1:
    goto inline$BDLGetDebugLevel$241$label_3#1;

  inline$BDLGetDebugLevel$241$label_3#1:
    havoc inline$BDLGetDebugLevel$241$myNondetVar_0;
    inline$BDLGetDebugLevel$241$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$241$myNondetVar_0;
    goto inline$BDLGetDebugLevel$241$label_1#1;

  inline$BDLGetDebugLevel$241$label_1#1:
    goto inline$BDLGetDebugLevel$241$Return#1;

  inline$BDLGetDebugLevel$241$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$241$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon42_Then#1, inline$BDLDevicePowerIoCompletion$8$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon25#1;

  inline$BDLDevicePowerIoCompletion$8$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_101#1;

  inline$BDLDevicePowerIoCompletion$8$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_101_true#1, inline$BDLDevicePowerIoCompletion$8$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_102#1;

  inline$BDLDevicePowerIoCompletion$8$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_105#1;

  inline$BDLDevicePowerIoCompletion$8$label_105#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_106#1;

  inline$BDLDevicePowerIoCompletion$8$label_106#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_107#1;

  inline$BDLDevicePowerIoCompletion$8$label_107#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_108#1;

  inline$BDLDevicePowerIoCompletion$8$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$8$label_102#1;

  inline$BDLDevicePowerIoCompletion$8$label_102#1:
    goto inline$BDLGetDebugLevel$242$Entry#1;

  inline$BDLGetDebugLevel$242$Entry#1:
    goto inline$BDLGetDebugLevel$242$start#1;

  inline$BDLGetDebugLevel$242$start#1:
    goto inline$BDLGetDebugLevel$242$label_3#1;

  inline$BDLGetDebugLevel$242$label_3#1:
    havoc inline$BDLGetDebugLevel$242$myNondetVar_0;
    inline$BDLGetDebugLevel$242$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$242$myNondetVar_0;
    goto inline$BDLGetDebugLevel$242$label_1#1;

  inline$BDLGetDebugLevel$242$label_1#1:
    goto inline$BDLGetDebugLevel$242$Return#1;

  inline$BDLGetDebugLevel$242$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$242$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon43_Then#1, inline$BDLDevicePowerIoCompletion$8$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon27#1;

  inline$BDLDevicePowerIoCompletion$8$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_111#1;

  inline$BDLDevicePowerIoCompletion$8$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_111_true#1, inline$BDLDevicePowerIoCompletion$8$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_112#1;

  inline$BDLDevicePowerIoCompletion$8$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_115#1;

  inline$BDLDevicePowerIoCompletion$8$label_115#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_116#1;

  inline$BDLDevicePowerIoCompletion$8$label_116#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_117#1;

  inline$BDLDevicePowerIoCompletion$8$label_117#1:
    call inline$BDLDevicePowerIoCompletion$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$8$label_118#1;

  inline$BDLDevicePowerIoCompletion$8$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$8$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$8$label_112#1;

  inline$BDLDevicePowerIoCompletion$8$label_112#1:
    goto inline$BDLGetDebugLevel$243$Entry#1;

  inline$BDLGetDebugLevel$243$Entry#1:
    goto inline$BDLGetDebugLevel$243$start#1;

  inline$BDLGetDebugLevel$243$start#1:
    goto inline$BDLGetDebugLevel$243$label_3#1;

  inline$BDLGetDebugLevel$243$label_3#1:
    havoc inline$BDLGetDebugLevel$243$myNondetVar_0;
    inline$BDLGetDebugLevel$243$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$243$myNondetVar_0;
    goto inline$BDLGetDebugLevel$243$label_1#1;

  inline$BDLGetDebugLevel$243$label_1#1:
    goto inline$BDLGetDebugLevel$243$Return#1;

  inline$BDLGetDebugLevel$243$Return#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$243$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$8$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$8$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$8$anon44_Then#1, inline$BDLDevicePowerIoCompletion$8$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$8$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$anon29#1;

  inline$BDLDevicePowerIoCompletion$8$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_121#1;

  inline$BDLDevicePowerIoCompletion$8$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_121_true#1, inline$BDLDevicePowerIoCompletion$8$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$8$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_122#1;

  inline$BDLDevicePowerIoCompletion$8$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$8$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$8$label_123#1;

  inline$BDLDevicePowerIoCompletion$8$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$8$label_122#1;

  inline$BDLDevicePowerIoCompletion$8$label_122#1:
    inline$BDLDevicePowerIoCompletion$8$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$8$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$8$label_1#1;

  inline$BDLDevicePowerIoCompletion$8$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$8$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$8$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$8$Return#1;

  inline$BDLDevicePowerIoCompletion$8$Return#1:
    inline$CallCompletionRoutine$8$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$8$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$8$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$8$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$8$anon13_Then#1, inline$CallCompletionRoutine$8$anon13_Else#1;

  inline$CallCompletionRoutine$8$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$8$anon7#1;

  inline$CallCompletionRoutine$8$anon7#1:
    goto inline$CallCompletionRoutine$8$label_20_icall_return#1;

  inline$CallCompletionRoutine$8$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$8$Return#1;

  inline$CallCompletionRoutine$8$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$8$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$8$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$8$Entry#1;

  inline$BDLCallDriverCompletionRoutine$8$Entry#1:
    inline$BDLCallDriverCompletionRoutine$8$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$8$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$8$start#1;

  inline$BDLCallDriverCompletionRoutine$8$start#1:
    inline$BDLCallDriverCompletionRoutine$8$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$8$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$8$label_3#1;

  inline$BDLCallDriverCompletionRoutine$8$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$8$label_3_true#1, inline$BDLCallDriverCompletionRoutine$8$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$8$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$8$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$8$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$8$label_4#1;

  inline$BDLCallDriverCompletionRoutine$8$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$8$label_6#1;

  inline$BDLCallDriverCompletionRoutine$8$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$8$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$8$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$8$label_5#1;

  inline$BDLCallDriverCompletionRoutine$8$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$8$label_6#1;

  inline$BDLCallDriverCompletionRoutine$8$label_6#1:
    goto inline$storm_KeSetEvent$10$Entry#1;

  inline$storm_KeSetEvent$10$Entry#1:
    inline$storm_KeSetEvent$10$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$8$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$10$start#1;

  inline$storm_KeSetEvent$10$start#1:
    inline$storm_KeSetEvent$10$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$10$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$10$label_3#1;

  inline$storm_KeSetEvent$10$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$10$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$10$label_1#1;

  inline$storm_KeSetEvent$10$label_1#1:
    goto inline$storm_KeSetEvent$10$Return#1;

  inline$storm_KeSetEvent$10$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$8$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$8$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$8$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$8$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$8$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$8$anon1#1;

  inline$BDLCallDriverCompletionRoutine$8$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$8$label_9#1;

  inline$BDLCallDriverCompletionRoutine$8$label_9#1:
    inline$BDLCallDriverCompletionRoutine$8$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$8$label_1#1;

  inline$BDLCallDriverCompletionRoutine$8$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$8$Return#1;

  inline$BDLCallDriverCompletionRoutine$8$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$8$Return#1;

  inline$BDLCallDriverCompletionRoutine$8$Return#1:
    inline$CallCompletionRoutine$8$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$8$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$8$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$8$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$8$anon12_Then#1, inline$CallCompletionRoutine$8$anon12_Else#1;

  inline$CallCompletionRoutine$8$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$8$anon5#1;

  inline$CallCompletionRoutine$8$anon5#1:
    goto inline$CallCompletionRoutine$8$label_20_icall_return#1;

  inline$CallCompletionRoutine$8$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$8$label_23#1;

  inline$CallCompletionRoutine$8$label_23#1:
    inline$CallCompletionRoutine$8$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$8$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$8$label_24#1;

  inline$CallCompletionRoutine$8$label_24#1:
    goto inline$CallCompletionRoutine$8$label_24_true#1, inline$CallCompletionRoutine$8$label_24_false#1;

  inline$CallCompletionRoutine$8$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$8$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$8$label_1#1;

  inline$CallCompletionRoutine$8$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$8$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$8$label_25#1;

  inline$CallCompletionRoutine$8$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$8$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$8$label_1#1;

  inline$CallCompletionRoutine$8$label_1#1:
    goto inline$CallCompletionRoutine$8$Return#1;

  inline$CallCompletionRoutine$8$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$8$Return#1;

  inline$CallCompletionRoutine$8$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$8$Return#1;

  inline$CallCompletionRoutine$8$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$8$Return#1;

  inline$CallCompletionRoutine$8$Return#1:
    goto inline$storm_IoCallDriver$4$label_33$1#1;

  inline$storm_IoCallDriver$4$label_33$1#1:
    goto inline$storm_IoCallDriver$4$anon14_Then#1, inline$storm_IoCallDriver$4$anon14_Else#1;

  inline$storm_IoCallDriver$4$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$4$anon8#1;

  inline$storm_IoCallDriver$4$anon8#1:
    goto inline$storm_IoCallDriver$4$label_36#1;

  inline$storm_IoCallDriver$4$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$4$Return#1;

  inline$storm_IoCallDriver$4$label_27_case_1#1:
    assume inline$storm_IoCallDriver$4$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$4$label_29#1;

  inline$storm_IoCallDriver$4$label_29#1:
    inline$storm_IoCallDriver$4$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$4$label_37#1;

  inline$storm_IoCallDriver$4$label_37#1:
    goto inline$storm_IoCallDriver$4$label_38#1;

  inline$storm_IoCallDriver$4$label_38#1:
    goto inline$storm_IoCallDriver$4$label_39#1;

  inline$storm_IoCallDriver$4$label_39#1:
    goto inline$CallCompletionRoutine$9$Entry#1;

  inline$CallCompletionRoutine$9$Entry#1:
    inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$9$start#1;

  inline$CallCompletionRoutine$9$start#1:
    inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$9$label_3#1;

  inline$CallCompletionRoutine$9$label_3#1:
    goto inline$CallCompletionRoutine$9$label_4#1;

  inline$CallCompletionRoutine$9$label_4#1:
    goto inline$CallCompletionRoutine$9$label_5#1;

  inline$CallCompletionRoutine$9$label_5#1:
    goto inline$CallCompletionRoutine$9$label_6#1;

  inline$CallCompletionRoutine$9$label_6#1:
    goto inline$CallCompletionRoutine$9$label_7#1;

  inline$CallCompletionRoutine$9$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$48$Entry#1;

  inline$IoGetCurrentIrpStackLocation$48$Entry#1:
    inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$48$start#1;

  inline$IoGetCurrentIrpStackLocation$48$start#1:
    inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$48$label_3#1;

  inline$IoGetCurrentIrpStackLocation$48$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$48$label_3_true#1, inline$IoGetCurrentIrpStackLocation$48$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$48$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$48$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$48$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$48$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$48$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$48$label_4#1;

  inline$IoGetCurrentIrpStackLocation$48$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$48$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$48$label_6#1;

  inline$IoGetCurrentIrpStackLocation$48$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$48$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$48$label_7#1;

  inline$IoGetCurrentIrpStackLocation$48$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$48$label_5#1;

  inline$IoGetCurrentIrpStackLocation$48$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$48$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$48$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$48$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$48$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$48$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$48$label_5#1;

  inline$IoGetCurrentIrpStackLocation$48$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$48$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$48$label_1#1;

  inline$IoGetCurrentIrpStackLocation$48$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$48$Return#1;

  inline$IoGetCurrentIrpStackLocation$48$Return#1:
    goto inline$CallCompletionRoutine$9$label_7$1#1;

  inline$CallCompletionRoutine$9$label_7$1#1:
    goto inline$CallCompletionRoutine$9$anon10_Then#1, inline$CallCompletionRoutine$9$anon10_Else#1;

  inline$CallCompletionRoutine$9$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$9$anon1#1;

  inline$CallCompletionRoutine$9$anon1#1:
    goto inline$CallCompletionRoutine$9$label_10#1;

  inline$CallCompletionRoutine$9$label_10#1:
    goto inline$CallCompletionRoutine$9$label_11#1;

  inline$CallCompletionRoutine$9$label_11#1:
    havoc inline$CallCompletionRoutine$9$myNondetVar_0;
    inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$9$myNondetVar_0;
    goto inline$CallCompletionRoutine$9$label_12#1;

  inline$CallCompletionRoutine$9$label_12#1:
    havoc inline$CallCompletionRoutine$9$myNondetVar_0;
    inline$CallCompletionRoutine$9$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$9$myNondetVar_0;
    goto inline$CallCompletionRoutine$9$label_13#1;

  inline$CallCompletionRoutine$9$label_13#1:
    havoc inline$CallCompletionRoutine$9$myNondetVar_0;
    goto inline$CallCompletionRoutine$9$label_14#1;

  inline$CallCompletionRoutine$9$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$49$Entry#1;

  inline$IoGetCurrentIrpStackLocation$49$Entry#1:
    inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$49$start#1;

  inline$IoGetCurrentIrpStackLocation$49$start#1:
    inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$49$label_3#1;

  inline$IoGetCurrentIrpStackLocation$49$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$49$label_3_true#1, inline$IoGetCurrentIrpStackLocation$49$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$49$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$49$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$49$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$49$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$49$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$49$label_4#1;

  inline$IoGetCurrentIrpStackLocation$49$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$49$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$49$label_6#1;

  inline$IoGetCurrentIrpStackLocation$49$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$49$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$49$label_7#1;

  inline$IoGetCurrentIrpStackLocation$49$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$49$label_5#1;

  inline$IoGetCurrentIrpStackLocation$49$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$49$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$49$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$49$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$49$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$49$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$49$label_5#1;

  inline$IoGetCurrentIrpStackLocation$49$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$49$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$49$label_1#1;

  inline$IoGetCurrentIrpStackLocation$49$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$49$Return#1;

  inline$IoGetCurrentIrpStackLocation$49$Return#1:
    goto inline$CallCompletionRoutine$9$label_14$1#1;

  inline$CallCompletionRoutine$9$label_14$1#1:
    goto inline$CallCompletionRoutine$9$anon11_Then#1, inline$CallCompletionRoutine$9$anon11_Else#1;

  inline$CallCompletionRoutine$9$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$9$anon3#1;

  inline$CallCompletionRoutine$9$anon3#1:
    goto inline$CallCompletionRoutine$9$label_17#1;

  inline$CallCompletionRoutine$9$label_17#1:
    goto inline$CallCompletionRoutine$9$label_18#1;

  inline$CallCompletionRoutine$9$label_18#1:
    goto inline$CallCompletionRoutine$9$label_18_true#1, inline$CallCompletionRoutine$9$label_18_false#1;

  inline$CallCompletionRoutine$9$label_18_false#1:
    assume inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$9$label_1#1;

  inline$CallCompletionRoutine$9$label_18_true#1:
    assume inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$9$label_19#1;

  inline$CallCompletionRoutine$9$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$9$label_20#1;

  inline$CallCompletionRoutine$9$label_20#1:
    goto inline$CallCompletionRoutine$9$label_20_icall_1#1, inline$CallCompletionRoutine$9$label_20_icall_2#1, inline$CallCompletionRoutine$9$label_20_icall_3#1;

  inline$CallCompletionRoutine$9$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$9$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$9$Entry#1;

  inline$BDLSystemPowerIoCompletion$9$Entry#1:
    inline$BDLSystemPowerIoCompletion$9$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$9$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$9$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$9$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$9$start#1;

  inline$BDLSystemPowerIoCompletion$9$start#1:
    call inline$BDLSystemPowerIoCompletion$9$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$9$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$9$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$9$label_3#1;

  inline$BDLSystemPowerIoCompletion$9$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_4#1;

  inline$BDLSystemPowerIoCompletion$9$label_4#1:
    inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_5#1;

  inline$BDLSystemPowerIoCompletion$9$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_6#1;

  inline$BDLSystemPowerIoCompletion$9$label_6#1:
    inline$BDLSystemPowerIoCompletion$9$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$9$label_7#1;

  inline$BDLSystemPowerIoCompletion$9$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_8#1;

  inline$BDLSystemPowerIoCompletion$9$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$9$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$9$label_9#1;

  inline$BDLSystemPowerIoCompletion$9$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_10#1;

  inline$BDLSystemPowerIoCompletion$9$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$51$Entry#1;

  inline$IoGetCurrentIrpStackLocation$51$Entry#1:
    inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$51$start#1;

  inline$IoGetCurrentIrpStackLocation$51$start#1:
    inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$51$label_3#1;

  inline$IoGetCurrentIrpStackLocation$51$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$51$label_3_true#1, inline$IoGetCurrentIrpStackLocation$51$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$51$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$51$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$51$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$51$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$51$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$51$label_4#1;

  inline$IoGetCurrentIrpStackLocation$51$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$51$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$51$label_6#1;

  inline$IoGetCurrentIrpStackLocation$51$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$51$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$51$label_7#1;

  inline$IoGetCurrentIrpStackLocation$51$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$51$label_5#1;

  inline$IoGetCurrentIrpStackLocation$51$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$51$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$51$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$51$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$51$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$51$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$51$label_5#1;

  inline$IoGetCurrentIrpStackLocation$51$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$51$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$51$label_1#1;

  inline$IoGetCurrentIrpStackLocation$51$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$51$Return#1;

  inline$IoGetCurrentIrpStackLocation$51$Return#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon36_Then#1, inline$BDLSystemPowerIoCompletion$9$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon1#1;

  inline$BDLSystemPowerIoCompletion$9$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_13#1;

  inline$BDLSystemPowerIoCompletion$9$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_14#1;

  inline$BDLSystemPowerIoCompletion$9$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_15#1;

  inline$BDLSystemPowerIoCompletion$9$label_15#1:
    goto inline$BDLGetDebugLevel$265$Entry#1;

  inline$BDLGetDebugLevel$265$Entry#1:
    goto inline$BDLGetDebugLevel$265$start#1;

  inline$BDLGetDebugLevel$265$start#1:
    goto inline$BDLGetDebugLevel$265$label_3#1;

  inline$BDLGetDebugLevel$265$label_3#1:
    havoc inline$BDLGetDebugLevel$265$myNondetVar_0;
    inline$BDLGetDebugLevel$265$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$265$myNondetVar_0;
    goto inline$BDLGetDebugLevel$265$label_1#1;

  inline$BDLGetDebugLevel$265$label_1#1:
    goto inline$BDLGetDebugLevel$265$Return#1;

  inline$BDLGetDebugLevel$265$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$265$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon37_Then#1, inline$BDLSystemPowerIoCompletion$9$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon3#1;

  inline$BDLSystemPowerIoCompletion$9$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_18#1;

  inline$BDLSystemPowerIoCompletion$9$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_18_true#1, inline$BDLSystemPowerIoCompletion$9$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_19#1;

  inline$BDLSystemPowerIoCompletion$9$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_22#1;

  inline$BDLSystemPowerIoCompletion$9$label_22#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_23#1;

  inline$BDLSystemPowerIoCompletion$9$label_23#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_24#1;

  inline$BDLSystemPowerIoCompletion$9$label_24#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_25#1;

  inline$BDLSystemPowerIoCompletion$9$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$9$label_19#1;

  inline$BDLSystemPowerIoCompletion$9$label_19#1:
    goto inline$BDLGetDebugLevel$266$Entry#1;

  inline$BDLGetDebugLevel$266$Entry#1:
    goto inline$BDLGetDebugLevel$266$start#1;

  inline$BDLGetDebugLevel$266$start#1:
    goto inline$BDLGetDebugLevel$266$label_3#1;

  inline$BDLGetDebugLevel$266$label_3#1:
    havoc inline$BDLGetDebugLevel$266$myNondetVar_0;
    inline$BDLGetDebugLevel$266$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$266$myNondetVar_0;
    goto inline$BDLGetDebugLevel$266$label_1#1;

  inline$BDLGetDebugLevel$266$label_1#1:
    goto inline$BDLGetDebugLevel$266$Return#1;

  inline$BDLGetDebugLevel$266$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$266$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon38_Then#1, inline$BDLSystemPowerIoCompletion$9$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon5#1;

  inline$BDLSystemPowerIoCompletion$9$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_28#1;

  inline$BDLSystemPowerIoCompletion$9$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_28_true#1, inline$BDLSystemPowerIoCompletion$9$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_29#1;

  inline$BDLSystemPowerIoCompletion$9$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_32#1;

  inline$BDLSystemPowerIoCompletion$9$label_32#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_33#1;

  inline$BDLSystemPowerIoCompletion$9$label_33#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_34#1;

  inline$BDLSystemPowerIoCompletion$9$label_34#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_35#1;

  inline$BDLSystemPowerIoCompletion$9$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$9$label_29#1;

  inline$BDLSystemPowerIoCompletion$9$label_29#1:
    goto inline$BDLGetDebugLevel$267$Entry#1;

  inline$BDLGetDebugLevel$267$Entry#1:
    goto inline$BDLGetDebugLevel$267$start#1;

  inline$BDLGetDebugLevel$267$start#1:
    goto inline$BDLGetDebugLevel$267$label_3#1;

  inline$BDLGetDebugLevel$267$label_3#1:
    havoc inline$BDLGetDebugLevel$267$myNondetVar_0;
    inline$BDLGetDebugLevel$267$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$267$myNondetVar_0;
    goto inline$BDLGetDebugLevel$267$label_1#1;

  inline$BDLGetDebugLevel$267$label_1#1:
    goto inline$BDLGetDebugLevel$267$Return#1;

  inline$BDLGetDebugLevel$267$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$267$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon39_Then#1, inline$BDLSystemPowerIoCompletion$9$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon7#1;

  inline$BDLSystemPowerIoCompletion$9$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_38#1;

  inline$BDLSystemPowerIoCompletion$9$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_38_true#1, inline$BDLSystemPowerIoCompletion$9$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_39#1;

  inline$BDLSystemPowerIoCompletion$9$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_40#1;

  inline$BDLSystemPowerIoCompletion$9$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_39#1;

  inline$BDLSystemPowerIoCompletion$9$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_39_true#1, inline$BDLSystemPowerIoCompletion$9$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_41#1;

  inline$BDLSystemPowerIoCompletion$9$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$9$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$9$label_107#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$9$label_108#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$9$label_108#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$9$label_108#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$9$label_108#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$9$label_108#1;

  inline$BDLSystemPowerIoCompletion$9$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_109#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$9$label_107#1;

  inline$BDLSystemPowerIoCompletion$9$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_109#1;

  inline$BDLSystemPowerIoCompletion$9$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$9$label_106#1;

  inline$BDLSystemPowerIoCompletion$9$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_106_true#1, inline$BDLSystemPowerIoCompletion$9$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_142#1;

  inline$BDLSystemPowerIoCompletion$9$label_142#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_143#1;

  inline$BDLSystemPowerIoCompletion$9$label_143#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_144#1;

  inline$BDLSystemPowerIoCompletion$9$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_109#1;

  inline$BDLSystemPowerIoCompletion$9$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_109#1;

  inline$BDLSystemPowerIoCompletion$9$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$9$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$9$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$9$myNondetVar_0, inline$BDLSystemPowerIoCompletion$9$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$9$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$9$anon50_Then#1, inline$BDLSystemPowerIoCompletion$9$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon29#1;

  inline$BDLSystemPowerIoCompletion$9$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_112#1;

  inline$BDLSystemPowerIoCompletion$9$label_112#1:
    inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$9$label_113#1;

  inline$BDLSystemPowerIoCompletion$9$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_113_true#1, inline$BDLSystemPowerIoCompletion$9$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$9$label_114#1;

  inline$BDLSystemPowerIoCompletion$9$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_116#1;

  inline$BDLSystemPowerIoCompletion$9$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_117#1;

  inline$BDLSystemPowerIoCompletion$9$label_117#1:
    goto inline$BDLGetDebugLevel$274$Entry#1;

  inline$BDLGetDebugLevel$274$Entry#1:
    goto inline$BDLGetDebugLevel$274$start#1;

  inline$BDLGetDebugLevel$274$start#1:
    goto inline$BDLGetDebugLevel$274$label_3#1;

  inline$BDLGetDebugLevel$274$label_3#1:
    havoc inline$BDLGetDebugLevel$274$myNondetVar_0;
    inline$BDLGetDebugLevel$274$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$274$myNondetVar_0;
    goto inline$BDLGetDebugLevel$274$label_1#1;

  inline$BDLGetDebugLevel$274$label_1#1:
    goto inline$BDLGetDebugLevel$274$Return#1;

  inline$BDLGetDebugLevel$274$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$274$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon51_Then#1, inline$BDLSystemPowerIoCompletion$9$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon31#1;

  inline$BDLSystemPowerIoCompletion$9$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_120#1;

  inline$BDLSystemPowerIoCompletion$9$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_120_true#1, inline$BDLSystemPowerIoCompletion$9$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_121#1;

  inline$BDLSystemPowerIoCompletion$9$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_124#1;

  inline$BDLSystemPowerIoCompletion$9$label_124#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_125#1;

  inline$BDLSystemPowerIoCompletion$9$label_125#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_126#1;

  inline$BDLSystemPowerIoCompletion$9$label_126#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_127#1;

  inline$BDLSystemPowerIoCompletion$9$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$9$label_121#1;

  inline$BDLSystemPowerIoCompletion$9$label_121#1:
    goto inline$BDLGetDebugLevel$275$Entry#1;

  inline$BDLGetDebugLevel$275$Entry#1:
    goto inline$BDLGetDebugLevel$275$start#1;

  inline$BDLGetDebugLevel$275$start#1:
    goto inline$BDLGetDebugLevel$275$label_3#1;

  inline$BDLGetDebugLevel$275$label_3#1:
    havoc inline$BDLGetDebugLevel$275$myNondetVar_0;
    inline$BDLGetDebugLevel$275$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$275$myNondetVar_0;
    goto inline$BDLGetDebugLevel$275$label_1#1;

  inline$BDLGetDebugLevel$275$label_1#1:
    goto inline$BDLGetDebugLevel$275$Return#1;

  inline$BDLGetDebugLevel$275$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$275$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon52_Then#1, inline$BDLSystemPowerIoCompletion$9$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon33#1;

  inline$BDLSystemPowerIoCompletion$9$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_130#1;

  inline$BDLSystemPowerIoCompletion$9$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_130_true#1, inline$BDLSystemPowerIoCompletion$9$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_131#1;

  inline$BDLSystemPowerIoCompletion$9$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_134#1;

  inline$BDLSystemPowerIoCompletion$9$label_134#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_135#1;

  inline$BDLSystemPowerIoCompletion$9$label_135#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_136#1;

  inline$BDLSystemPowerIoCompletion$9$label_136#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_137#1;

  inline$BDLSystemPowerIoCompletion$9$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$9$label_131#1;

  inline$BDLSystemPowerIoCompletion$9$label_131#1:
    goto inline$BDLGetDebugLevel$276$Entry#1;

  inline$BDLGetDebugLevel$276$Entry#1:
    goto inline$BDLGetDebugLevel$276$start#1;

  inline$BDLGetDebugLevel$276$start#1:
    goto inline$BDLGetDebugLevel$276$label_3#1;

  inline$BDLGetDebugLevel$276$label_3#1:
    havoc inline$BDLGetDebugLevel$276$myNondetVar_0;
    inline$BDLGetDebugLevel$276$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$276$myNondetVar_0;
    goto inline$BDLGetDebugLevel$276$label_1#1;

  inline$BDLGetDebugLevel$276$label_1#1:
    goto inline$BDLGetDebugLevel$276$Return#1;

  inline$BDLGetDebugLevel$276$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$276$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon53_Then#1, inline$BDLSystemPowerIoCompletion$9$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon35#1;

  inline$BDLSystemPowerIoCompletion$9$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_140#1;

  inline$BDLSystemPowerIoCompletion$9$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_140_true#1, inline$BDLSystemPowerIoCompletion$9$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_67#1;

  inline$BDLSystemPowerIoCompletion$9$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_141#1;

  inline$BDLSystemPowerIoCompletion$9$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_67#1;

  inline$BDLSystemPowerIoCompletion$9$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$9$label_115#1;

  inline$BDLSystemPowerIoCompletion$9$label_115#1:
    inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$9$label_80#1;

  inline$BDLSystemPowerIoCompletion$9$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$9$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_42#1;

  inline$BDLSystemPowerIoCompletion$9$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$9$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$9$label_43#1;

  inline$BDLSystemPowerIoCompletion$9$label_43#1:
    goto inline$BDLGetDebugLevel$268$Entry#1;

  inline$BDLGetDebugLevel$268$Entry#1:
    goto inline$BDLGetDebugLevel$268$start#1;

  inline$BDLGetDebugLevel$268$start#1:
    goto inline$BDLGetDebugLevel$268$label_3#1;

  inline$BDLGetDebugLevel$268$label_3#1:
    havoc inline$BDLGetDebugLevel$268$myNondetVar_0;
    inline$BDLGetDebugLevel$268$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$268$myNondetVar_0;
    goto inline$BDLGetDebugLevel$268$label_1#1;

  inline$BDLGetDebugLevel$268$label_1#1:
    goto inline$BDLGetDebugLevel$268$Return#1;

  inline$BDLGetDebugLevel$268$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$268$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon40_Then#1, inline$BDLSystemPowerIoCompletion$9$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon9#1;

  inline$BDLSystemPowerIoCompletion$9$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_46#1;

  inline$BDLSystemPowerIoCompletion$9$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_46_true#1, inline$BDLSystemPowerIoCompletion$9$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_47#1;

  inline$BDLSystemPowerIoCompletion$9$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_50#1;

  inline$BDLSystemPowerIoCompletion$9$label_50#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_51#1;

  inline$BDLSystemPowerIoCompletion$9$label_51#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_52#1;

  inline$BDLSystemPowerIoCompletion$9$label_52#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_53#1;

  inline$BDLSystemPowerIoCompletion$9$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$9$label_47#1;

  inline$BDLSystemPowerIoCompletion$9$label_47#1:
    goto inline$BDLGetDebugLevel$269$Entry#1;

  inline$BDLGetDebugLevel$269$Entry#1:
    goto inline$BDLGetDebugLevel$269$start#1;

  inline$BDLGetDebugLevel$269$start#1:
    goto inline$BDLGetDebugLevel$269$label_3#1;

  inline$BDLGetDebugLevel$269$label_3#1:
    havoc inline$BDLGetDebugLevel$269$myNondetVar_0;
    inline$BDLGetDebugLevel$269$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$269$myNondetVar_0;
    goto inline$BDLGetDebugLevel$269$label_1#1;

  inline$BDLGetDebugLevel$269$label_1#1:
    goto inline$BDLGetDebugLevel$269$Return#1;

  inline$BDLGetDebugLevel$269$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$269$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon41_Then#1, inline$BDLSystemPowerIoCompletion$9$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon11#1;

  inline$BDLSystemPowerIoCompletion$9$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_56#1;

  inline$BDLSystemPowerIoCompletion$9$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_56_true#1, inline$BDLSystemPowerIoCompletion$9$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_57#1;

  inline$BDLSystemPowerIoCompletion$9$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_60#1;

  inline$BDLSystemPowerIoCompletion$9$label_60#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_61#1;

  inline$BDLSystemPowerIoCompletion$9$label_61#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_62#1;

  inline$BDLSystemPowerIoCompletion$9$label_62#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_63#1;

  inline$BDLSystemPowerIoCompletion$9$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$9$label_57#1;

  inline$BDLSystemPowerIoCompletion$9$label_57#1:
    goto inline$BDLGetDebugLevel$270$Entry#1;

  inline$BDLGetDebugLevel$270$Entry#1:
    goto inline$BDLGetDebugLevel$270$start#1;

  inline$BDLGetDebugLevel$270$start#1:
    goto inline$BDLGetDebugLevel$270$label_3#1;

  inline$BDLGetDebugLevel$270$label_3#1:
    havoc inline$BDLGetDebugLevel$270$myNondetVar_0;
    inline$BDLGetDebugLevel$270$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$270$myNondetVar_0;
    goto inline$BDLGetDebugLevel$270$label_1#1;

  inline$BDLGetDebugLevel$270$label_1#1:
    goto inline$BDLGetDebugLevel$270$Return#1;

  inline$BDLGetDebugLevel$270$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$270$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon42_Then#1, inline$BDLSystemPowerIoCompletion$9$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon13#1;

  inline$BDLSystemPowerIoCompletion$9$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_66#1;

  inline$BDLSystemPowerIoCompletion$9$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_66_true#1, inline$BDLSystemPowerIoCompletion$9$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_67#1;

  inline$BDLSystemPowerIoCompletion$9$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_70#1;

  inline$BDLSystemPowerIoCompletion$9$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_67#1;

  inline$BDLSystemPowerIoCompletion$9$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$9$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$9$anon43_Then#1, inline$BDLSystemPowerIoCompletion$9$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon15#1;

  inline$BDLSystemPowerIoCompletion$9$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_71#1;

  inline$BDLSystemPowerIoCompletion$9$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$9$anon44_Then#1, inline$BDLSystemPowerIoCompletion$9$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon17#1;

  inline$BDLSystemPowerIoCompletion$9$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_74#1;

  inline$BDLSystemPowerIoCompletion$9$label_74#1:
    goto inline$storm_IoCompleteRequest$20$Entry#1;

  inline$storm_IoCompleteRequest$20$Entry#1:
    inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$9$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$20$start#1;

  inline$storm_IoCompleteRequest$20$start#1:
    inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$20$label_3#1;

  inline$storm_IoCompleteRequest$20$label_3#1:
    call inline$storm_IoCompleteRequest$20$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$20$label_6#1;

  inline$storm_IoCompleteRequest$20$label_6#1:
    goto inline$storm_IoCompleteRequest$20$label_6_true#1, inline$storm_IoCompleteRequest$20$label_6_false#1;

  inline$storm_IoCompleteRequest$20$label_6_false#1:
    assume inline$storm_IoCompleteRequest$20$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$20$label_7#1;

  inline$storm_IoCompleteRequest$20$label_6_true#1:
    assume inline$storm_IoCompleteRequest$20$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$20$label_8#1;

  inline$storm_IoCompleteRequest$20$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$20$anon3_Then#1, inline$storm_IoCompleteRequest$20$anon3_Else#1;

  inline$storm_IoCompleteRequest$20$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$20$anon1#1;

  inline$storm_IoCompleteRequest$20$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$20$label_9#1;

  inline$storm_IoCompleteRequest$20$label_9#1:
    goto inline$storm_IoCompleteRequest$20$label_9_true#1, inline$storm_IoCompleteRequest$20$label_9_false#1;

  inline$storm_IoCompleteRequest$20$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$20$label_10#1;

  inline$storm_IoCompleteRequest$20$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$20$label_1#1;

  inline$storm_IoCompleteRequest$20$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$20$label_7#1;

  inline$storm_IoCompleteRequest$20$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$20$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$20$label_1#1;

  inline$storm_IoCompleteRequest$20$label_1#1:
    goto inline$storm_IoCompleteRequest$20$Return#1;

  inline$storm_IoCompleteRequest$20$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$20$Return#1;

  inline$storm_IoCompleteRequest$20$Return#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon45_Then#1, inline$BDLSystemPowerIoCompletion$9$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon19#1;

  inline$BDLSystemPowerIoCompletion$9$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_77#1;

  inline$BDLSystemPowerIoCompletion$9$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$9$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$9$anon46_Then#1, inline$BDLSystemPowerIoCompletion$9$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon21#1;

  inline$BDLSystemPowerIoCompletion$9$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_80#1;

  inline$BDLSystemPowerIoCompletion$9$label_80#1:
    goto inline$BDLGetDebugLevel$271$Entry#1;

  inline$BDLGetDebugLevel$271$Entry#1:
    goto inline$BDLGetDebugLevel$271$start#1;

  inline$BDLGetDebugLevel$271$start#1:
    goto inline$BDLGetDebugLevel$271$label_3#1;

  inline$BDLGetDebugLevel$271$label_3#1:
    havoc inline$BDLGetDebugLevel$271$myNondetVar_0;
    inline$BDLGetDebugLevel$271$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$271$myNondetVar_0;
    goto inline$BDLGetDebugLevel$271$label_1#1;

  inline$BDLGetDebugLevel$271$label_1#1:
    goto inline$BDLGetDebugLevel$271$Return#1;

  inline$BDLGetDebugLevel$271$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$271$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon47_Then#1, inline$BDLSystemPowerIoCompletion$9$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon23#1;

  inline$BDLSystemPowerIoCompletion$9$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_83#1;

  inline$BDLSystemPowerIoCompletion$9$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_83_true#1, inline$BDLSystemPowerIoCompletion$9$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_84#1;

  inline$BDLSystemPowerIoCompletion$9$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_87#1;

  inline$BDLSystemPowerIoCompletion$9$label_87#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_88#1;

  inline$BDLSystemPowerIoCompletion$9$label_88#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_89#1;

  inline$BDLSystemPowerIoCompletion$9$label_89#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_90#1;

  inline$BDLSystemPowerIoCompletion$9$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$9$label_84#1;

  inline$BDLSystemPowerIoCompletion$9$label_84#1:
    goto inline$BDLGetDebugLevel$272$Entry#1;

  inline$BDLGetDebugLevel$272$Entry#1:
    goto inline$BDLGetDebugLevel$272$start#1;

  inline$BDLGetDebugLevel$272$start#1:
    goto inline$BDLGetDebugLevel$272$label_3#1;

  inline$BDLGetDebugLevel$272$label_3#1:
    havoc inline$BDLGetDebugLevel$272$myNondetVar_0;
    inline$BDLGetDebugLevel$272$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$272$myNondetVar_0;
    goto inline$BDLGetDebugLevel$272$label_1#1;

  inline$BDLGetDebugLevel$272$label_1#1:
    goto inline$BDLGetDebugLevel$272$Return#1;

  inline$BDLGetDebugLevel$272$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$272$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon48_Then#1, inline$BDLSystemPowerIoCompletion$9$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon25#1;

  inline$BDLSystemPowerIoCompletion$9$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_93#1;

  inline$BDLSystemPowerIoCompletion$9$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_93_true#1, inline$BDLSystemPowerIoCompletion$9$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_94#1;

  inline$BDLSystemPowerIoCompletion$9$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_97#1;

  inline$BDLSystemPowerIoCompletion$9$label_97#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_98#1;

  inline$BDLSystemPowerIoCompletion$9$label_98#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_99#1;

  inline$BDLSystemPowerIoCompletion$9$label_99#1:
    call inline$BDLSystemPowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$9$label_100#1;

  inline$BDLSystemPowerIoCompletion$9$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$9$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$9$label_94#1;

  inline$BDLSystemPowerIoCompletion$9$label_94#1:
    goto inline$BDLGetDebugLevel$273$Entry#1;

  inline$BDLGetDebugLevel$273$Entry#1:
    goto inline$BDLGetDebugLevel$273$start#1;

  inline$BDLGetDebugLevel$273$start#1:
    goto inline$BDLGetDebugLevel$273$label_3#1;

  inline$BDLGetDebugLevel$273$label_3#1:
    havoc inline$BDLGetDebugLevel$273$myNondetVar_0;
    inline$BDLGetDebugLevel$273$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$273$myNondetVar_0;
    goto inline$BDLGetDebugLevel$273$label_1#1;

  inline$BDLGetDebugLevel$273$label_1#1:
    goto inline$BDLGetDebugLevel$273$Return#1;

  inline$BDLGetDebugLevel$273$Return#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$273$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$9$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$9$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$9$anon49_Then#1, inline$BDLSystemPowerIoCompletion$9$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$9$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$anon27#1;

  inline$BDLSystemPowerIoCompletion$9$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_103#1;

  inline$BDLSystemPowerIoCompletion$9$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_103_true#1, inline$BDLSystemPowerIoCompletion$9$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$9$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_104#1;

  inline$BDLSystemPowerIoCompletion$9$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$9$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$9$label_105#1;

  inline$BDLSystemPowerIoCompletion$9$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$9$label_104#1;

  inline$BDLSystemPowerIoCompletion$9$label_104#1:
    inline$BDLSystemPowerIoCompletion$9$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$9$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$9$label_1#1;

  inline$BDLSystemPowerIoCompletion$9$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$9$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$9$Return#1;

  inline$BDLSystemPowerIoCompletion$9$Return#1:
    inline$CallCompletionRoutine$9$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$9$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$9$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$9$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$9$anon14_Then#1, inline$CallCompletionRoutine$9$anon14_Else#1;

  inline$CallCompletionRoutine$9$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$9$anon9#1;

  inline$CallCompletionRoutine$9$anon9#1:
    goto inline$CallCompletionRoutine$9$label_20_icall_return#1;

  inline$CallCompletionRoutine$9$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$9$Return#1;

  inline$CallCompletionRoutine$9$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$9$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$9$Entry#1;

  inline$BDLDevicePowerIoCompletion$9$Entry#1:
    inline$BDLDevicePowerIoCompletion$9$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$9$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$9$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$9$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$9$start#1;

  inline$BDLDevicePowerIoCompletion$9$start#1:
    call inline$BDLDevicePowerIoCompletion$9$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$9$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$9$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$9$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$9$label_3#1;

  inline$BDLDevicePowerIoCompletion$9$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_4#1;

  inline$BDLDevicePowerIoCompletion$9$label_4#1:
    inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_5#1;

  inline$BDLDevicePowerIoCompletion$9$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_6#1;

  inline$BDLDevicePowerIoCompletion$9$label_6#1:
    inline$BDLDevicePowerIoCompletion$9$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$9$label_7#1;

  inline$BDLDevicePowerIoCompletion$9$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_8#1;

  inline$BDLDevicePowerIoCompletion$9$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$9$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$9$label_9#1;

  inline$BDLDevicePowerIoCompletion$9$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_10#1;

  inline$BDLDevicePowerIoCompletion$9$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$50$Entry#1;

  inline$IoGetCurrentIrpStackLocation$50$Entry#1:
    inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$50$start#1;

  inline$IoGetCurrentIrpStackLocation$50$start#1:
    inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$50$label_3#1;

  inline$IoGetCurrentIrpStackLocation$50$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$50$label_3_true#1, inline$IoGetCurrentIrpStackLocation$50$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$50$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$50$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$50$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$50$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$50$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$50$label_4#1;

  inline$IoGetCurrentIrpStackLocation$50$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$50$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$50$label_6#1;

  inline$IoGetCurrentIrpStackLocation$50$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$50$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$50$label_7#1;

  inline$IoGetCurrentIrpStackLocation$50$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$50$label_5#1;

  inline$IoGetCurrentIrpStackLocation$50$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$50$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$50$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$50$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$50$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$50$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$50$label_5#1;

  inline$IoGetCurrentIrpStackLocation$50$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$50$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$50$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$50$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$50$label_1#1;

  inline$IoGetCurrentIrpStackLocation$50$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$50$Return#1;

  inline$IoGetCurrentIrpStackLocation$50$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$50$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon30_Then#1, inline$BDLDevicePowerIoCompletion$9$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon1#1;

  inline$BDLDevicePowerIoCompletion$9$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_13#1;

  inline$BDLDevicePowerIoCompletion$9$label_13#1:
    inline$BDLDevicePowerIoCompletion$9$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$9$label_14#1;

  inline$BDLDevicePowerIoCompletion$9$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_15#1;

  inline$BDLDevicePowerIoCompletion$9$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$9$label_16#1;

  inline$BDLDevicePowerIoCompletion$9$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_17#1;

  inline$BDLDevicePowerIoCompletion$9$label_17#1:
    goto inline$BDLGetDebugLevel$256$Entry#1;

  inline$BDLGetDebugLevel$256$Entry#1:
    goto inline$BDLGetDebugLevel$256$start#1;

  inline$BDLGetDebugLevel$256$start#1:
    goto inline$BDLGetDebugLevel$256$label_3#1;

  inline$BDLGetDebugLevel$256$label_3#1:
    havoc inline$BDLGetDebugLevel$256$myNondetVar_0;
    inline$BDLGetDebugLevel$256$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$256$myNondetVar_0;
    goto inline$BDLGetDebugLevel$256$label_1#1;

  inline$BDLGetDebugLevel$256$label_1#1:
    goto inline$BDLGetDebugLevel$256$Return#1;

  inline$BDLGetDebugLevel$256$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$256$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon31_Then#1, inline$BDLDevicePowerIoCompletion$9$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon3#1;

  inline$BDLDevicePowerIoCompletion$9$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_20#1;

  inline$BDLDevicePowerIoCompletion$9$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_20_true#1, inline$BDLDevicePowerIoCompletion$9$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_21#1;

  inline$BDLDevicePowerIoCompletion$9$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_24#1;

  inline$BDLDevicePowerIoCompletion$9$label_24#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_25#1;

  inline$BDLDevicePowerIoCompletion$9$label_25#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_26#1;

  inline$BDLDevicePowerIoCompletion$9$label_26#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_27#1;

  inline$BDLDevicePowerIoCompletion$9$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$9$label_21#1;

  inline$BDLDevicePowerIoCompletion$9$label_21#1:
    goto inline$BDLGetDebugLevel$257$Entry#1;

  inline$BDLGetDebugLevel$257$Entry#1:
    goto inline$BDLGetDebugLevel$257$start#1;

  inline$BDLGetDebugLevel$257$start#1:
    goto inline$BDLGetDebugLevel$257$label_3#1;

  inline$BDLGetDebugLevel$257$label_3#1:
    havoc inline$BDLGetDebugLevel$257$myNondetVar_0;
    inline$BDLGetDebugLevel$257$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$257$myNondetVar_0;
    goto inline$BDLGetDebugLevel$257$label_1#1;

  inline$BDLGetDebugLevel$257$label_1#1:
    goto inline$BDLGetDebugLevel$257$Return#1;

  inline$BDLGetDebugLevel$257$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$257$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon32_Then#1, inline$BDLDevicePowerIoCompletion$9$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon5#1;

  inline$BDLDevicePowerIoCompletion$9$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_30#1;

  inline$BDLDevicePowerIoCompletion$9$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_30_true#1, inline$BDLDevicePowerIoCompletion$9$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_31#1;

  inline$BDLDevicePowerIoCompletion$9$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_34#1;

  inline$BDLDevicePowerIoCompletion$9$label_34#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_35#1;

  inline$BDLDevicePowerIoCompletion$9$label_35#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_36#1;

  inline$BDLDevicePowerIoCompletion$9$label_36#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_37#1;

  inline$BDLDevicePowerIoCompletion$9$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$9$label_31#1;

  inline$BDLDevicePowerIoCompletion$9$label_31#1:
    goto inline$BDLGetDebugLevel$258$Entry#1;

  inline$BDLGetDebugLevel$258$Entry#1:
    goto inline$BDLGetDebugLevel$258$start#1;

  inline$BDLGetDebugLevel$258$start#1:
    goto inline$BDLGetDebugLevel$258$label_3#1;

  inline$BDLGetDebugLevel$258$label_3#1:
    havoc inline$BDLGetDebugLevel$258$myNondetVar_0;
    inline$BDLGetDebugLevel$258$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$258$myNondetVar_0;
    goto inline$BDLGetDebugLevel$258$label_1#1;

  inline$BDLGetDebugLevel$258$label_1#1:
    goto inline$BDLGetDebugLevel$258$Return#1;

  inline$BDLGetDebugLevel$258$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$258$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon33_Then#1, inline$BDLDevicePowerIoCompletion$9$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon7#1;

  inline$BDLDevicePowerIoCompletion$9$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_40#1;

  inline$BDLDevicePowerIoCompletion$9$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_40_true#1, inline$BDLDevicePowerIoCompletion$9$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_41#1;

  inline$BDLDevicePowerIoCompletion$9$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_42#1;

  inline$BDLDevicePowerIoCompletion$9$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_41#1;

  inline$BDLDevicePowerIoCompletion$9$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_41_true#1, inline$BDLDevicePowerIoCompletion$9$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$9$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$9$label_43#1;

  inline$BDLDevicePowerIoCompletion$9$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$9$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$9$label_44#1;

  inline$BDLDevicePowerIoCompletion$9$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_44_true#1, inline$BDLDevicePowerIoCompletion$9$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$9$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$9$label_45#1;

  inline$BDLDevicePowerIoCompletion$9$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_45_true#1, inline$BDLDevicePowerIoCompletion$9$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$9$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$9$label_43#1;

  inline$BDLDevicePowerIoCompletion$9$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$9$label_86#1;

  inline$BDLDevicePowerIoCompletion$9$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$9$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$9$label_46#1;

  inline$BDLDevicePowerIoCompletion$9$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$9$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$9$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$9$label_46#1;

  inline$BDLDevicePowerIoCompletion$9$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$9$label_49#1;

  inline$BDLDevicePowerIoCompletion$9$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_50#1;

  inline$BDLDevicePowerIoCompletion$9$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_51#1;

  inline$BDLDevicePowerIoCompletion$9$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_54#1;

  inline$BDLDevicePowerIoCompletion$9$label_54#1:
    inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$9$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$9$label_55#1;

  inline$BDLDevicePowerIoCompletion$9$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_55_true#1, inline$BDLDevicePowerIoCompletion$9$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_56#1;

  inline$BDLDevicePowerIoCompletion$9$label_56#1:
    call inline$BDLDevicePowerIoCompletion$9$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$9$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$9$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$9$anon34_Then#1, inline$BDLDevicePowerIoCompletion$9$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon9#1;

  inline$BDLDevicePowerIoCompletion$9$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_83#1;

  inline$BDLDevicePowerIoCompletion$9$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_59#1;

  inline$BDLDevicePowerIoCompletion$9$label_59#1:
    goto inline$BDLGetDebugLevel$259$Entry#1;

  inline$BDLGetDebugLevel$259$Entry#1:
    goto inline$BDLGetDebugLevel$259$start#1;

  inline$BDLGetDebugLevel$259$start#1:
    goto inline$BDLGetDebugLevel$259$label_3#1;

  inline$BDLGetDebugLevel$259$label_3#1:
    havoc inline$BDLGetDebugLevel$259$myNondetVar_0;
    inline$BDLGetDebugLevel$259$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$259$myNondetVar_0;
    goto inline$BDLGetDebugLevel$259$label_1#1;

  inline$BDLGetDebugLevel$259$label_1#1:
    goto inline$BDLGetDebugLevel$259$Return#1;

  inline$BDLGetDebugLevel$259$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$259$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon35_Then#1, inline$BDLDevicePowerIoCompletion$9$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon11#1;

  inline$BDLDevicePowerIoCompletion$9$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_62#1;

  inline$BDLDevicePowerIoCompletion$9$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_62_true#1, inline$BDLDevicePowerIoCompletion$9$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_63#1;

  inline$BDLDevicePowerIoCompletion$9$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_66#1;

  inline$BDLDevicePowerIoCompletion$9$label_66#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_67#1;

  inline$BDLDevicePowerIoCompletion$9$label_67#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_68#1;

  inline$BDLDevicePowerIoCompletion$9$label_68#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_69#1;

  inline$BDLDevicePowerIoCompletion$9$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$9$label_63#1;

  inline$BDLDevicePowerIoCompletion$9$label_63#1:
    goto inline$BDLGetDebugLevel$260$Entry#1;

  inline$BDLGetDebugLevel$260$Entry#1:
    goto inline$BDLGetDebugLevel$260$start#1;

  inline$BDLGetDebugLevel$260$start#1:
    goto inline$BDLGetDebugLevel$260$label_3#1;

  inline$BDLGetDebugLevel$260$label_3#1:
    havoc inline$BDLGetDebugLevel$260$myNondetVar_0;
    inline$BDLGetDebugLevel$260$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$260$myNondetVar_0;
    goto inline$BDLGetDebugLevel$260$label_1#1;

  inline$BDLGetDebugLevel$260$label_1#1:
    goto inline$BDLGetDebugLevel$260$Return#1;

  inline$BDLGetDebugLevel$260$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$260$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon36_Then#1, inline$BDLDevicePowerIoCompletion$9$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon13#1;

  inline$BDLDevicePowerIoCompletion$9$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_72#1;

  inline$BDLDevicePowerIoCompletion$9$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_72_true#1, inline$BDLDevicePowerIoCompletion$9$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_73#1;

  inline$BDLDevicePowerIoCompletion$9$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_76#1;

  inline$BDLDevicePowerIoCompletion$9$label_76#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_77#1;

  inline$BDLDevicePowerIoCompletion$9$label_77#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_78#1;

  inline$BDLDevicePowerIoCompletion$9$label_78#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_79#1;

  inline$BDLDevicePowerIoCompletion$9$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$9$label_73#1;

  inline$BDLDevicePowerIoCompletion$9$label_73#1:
    goto inline$BDLGetDebugLevel$261$Entry#1;

  inline$BDLGetDebugLevel$261$Entry#1:
    goto inline$BDLGetDebugLevel$261$start#1;

  inline$BDLGetDebugLevel$261$start#1:
    goto inline$BDLGetDebugLevel$261$label_3#1;

  inline$BDLGetDebugLevel$261$label_3#1:
    havoc inline$BDLGetDebugLevel$261$myNondetVar_0;
    inline$BDLGetDebugLevel$261$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$261$myNondetVar_0;
    goto inline$BDLGetDebugLevel$261$label_1#1;

  inline$BDLGetDebugLevel$261$label_1#1:
    goto inline$BDLGetDebugLevel$261$Return#1;

  inline$BDLGetDebugLevel$261$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$261$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon37_Then#1, inline$BDLDevicePowerIoCompletion$9$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon15#1;

  inline$BDLDevicePowerIoCompletion$9$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_82#1;

  inline$BDLDevicePowerIoCompletion$9$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_82_true#1, inline$BDLDevicePowerIoCompletion$9$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_83#1;

  inline$BDLDevicePowerIoCompletion$9$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_84#1;

  inline$BDLDevicePowerIoCompletion$9$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_83#1;

  inline$BDLDevicePowerIoCompletion$9$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_85#1;

  inline$BDLDevicePowerIoCompletion$9$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_86#1;

  inline$BDLDevicePowerIoCompletion$9$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$9$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$9$anon38_Then#1, inline$BDLDevicePowerIoCompletion$9$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon17#1;

  inline$BDLDevicePowerIoCompletion$9$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_89#1;

  inline$BDLDevicePowerIoCompletion$9$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$9$anon39_Then#1, inline$BDLDevicePowerIoCompletion$9$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon19#1;

  inline$BDLDevicePowerIoCompletion$9$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_92#1;

  inline$BDLDevicePowerIoCompletion$9$label_92#1:
    goto inline$storm_IoCompleteRequest$19$Entry#1;

  inline$storm_IoCompleteRequest$19$Entry#1:
    inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$9$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$19$start#1;

  inline$storm_IoCompleteRequest$19$start#1:
    inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$19$label_3#1;

  inline$storm_IoCompleteRequest$19$label_3#1:
    call inline$storm_IoCompleteRequest$19$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$19$label_6#1;

  inline$storm_IoCompleteRequest$19$label_6#1:
    goto inline$storm_IoCompleteRequest$19$label_6_true#1, inline$storm_IoCompleteRequest$19$label_6_false#1;

  inline$storm_IoCompleteRequest$19$label_6_false#1:
    assume inline$storm_IoCompleteRequest$19$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$19$label_7#1;

  inline$storm_IoCompleteRequest$19$label_6_true#1:
    assume inline$storm_IoCompleteRequest$19$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$19$label_8#1;

  inline$storm_IoCompleteRequest$19$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$19$anon3_Then#1, inline$storm_IoCompleteRequest$19$anon3_Else#1;

  inline$storm_IoCompleteRequest$19$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$19$anon1#1;

  inline$storm_IoCompleteRequest$19$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$19$label_9#1;

  inline$storm_IoCompleteRequest$19$label_9#1:
    goto inline$storm_IoCompleteRequest$19$label_9_true#1, inline$storm_IoCompleteRequest$19$label_9_false#1;

  inline$storm_IoCompleteRequest$19$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$19$label_10#1;

  inline$storm_IoCompleteRequest$19$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$19$label_1#1;

  inline$storm_IoCompleteRequest$19$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$19$label_7#1;

  inline$storm_IoCompleteRequest$19$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$19$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$19$label_1#1;

  inline$storm_IoCompleteRequest$19$label_1#1:
    goto inline$storm_IoCompleteRequest$19$Return#1;

  inline$storm_IoCompleteRequest$19$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$19$Return#1;

  inline$storm_IoCompleteRequest$19$Return#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon40_Then#1, inline$BDLDevicePowerIoCompletion$9$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon21#1;

  inline$BDLDevicePowerIoCompletion$9$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_95#1;

  inline$BDLDevicePowerIoCompletion$9$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$9$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$9$anon41_Then#1, inline$BDLDevicePowerIoCompletion$9$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon23#1;

  inline$BDLDevicePowerIoCompletion$9$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_98#1;

  inline$BDLDevicePowerIoCompletion$9$label_98#1:
    goto inline$BDLGetDebugLevel$262$Entry#1;

  inline$BDLGetDebugLevel$262$Entry#1:
    goto inline$BDLGetDebugLevel$262$start#1;

  inline$BDLGetDebugLevel$262$start#1:
    goto inline$BDLGetDebugLevel$262$label_3#1;

  inline$BDLGetDebugLevel$262$label_3#1:
    havoc inline$BDLGetDebugLevel$262$myNondetVar_0;
    inline$BDLGetDebugLevel$262$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$262$myNondetVar_0;
    goto inline$BDLGetDebugLevel$262$label_1#1;

  inline$BDLGetDebugLevel$262$label_1#1:
    goto inline$BDLGetDebugLevel$262$Return#1;

  inline$BDLGetDebugLevel$262$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$262$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon42_Then#1, inline$BDLDevicePowerIoCompletion$9$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon25#1;

  inline$BDLDevicePowerIoCompletion$9$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_101#1;

  inline$BDLDevicePowerIoCompletion$9$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_101_true#1, inline$BDLDevicePowerIoCompletion$9$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_102#1;

  inline$BDLDevicePowerIoCompletion$9$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_105#1;

  inline$BDLDevicePowerIoCompletion$9$label_105#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_106#1;

  inline$BDLDevicePowerIoCompletion$9$label_106#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_107#1;

  inline$BDLDevicePowerIoCompletion$9$label_107#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_108#1;

  inline$BDLDevicePowerIoCompletion$9$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$9$label_102#1;

  inline$BDLDevicePowerIoCompletion$9$label_102#1:
    goto inline$BDLGetDebugLevel$263$Entry#1;

  inline$BDLGetDebugLevel$263$Entry#1:
    goto inline$BDLGetDebugLevel$263$start#1;

  inline$BDLGetDebugLevel$263$start#1:
    goto inline$BDLGetDebugLevel$263$label_3#1;

  inline$BDLGetDebugLevel$263$label_3#1:
    havoc inline$BDLGetDebugLevel$263$myNondetVar_0;
    inline$BDLGetDebugLevel$263$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$263$myNondetVar_0;
    goto inline$BDLGetDebugLevel$263$label_1#1;

  inline$BDLGetDebugLevel$263$label_1#1:
    goto inline$BDLGetDebugLevel$263$Return#1;

  inline$BDLGetDebugLevel$263$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$263$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon43_Then#1, inline$BDLDevicePowerIoCompletion$9$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon27#1;

  inline$BDLDevicePowerIoCompletion$9$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_111#1;

  inline$BDLDevicePowerIoCompletion$9$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_111_true#1, inline$BDLDevicePowerIoCompletion$9$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_112#1;

  inline$BDLDevicePowerIoCompletion$9$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_115#1;

  inline$BDLDevicePowerIoCompletion$9$label_115#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_116#1;

  inline$BDLDevicePowerIoCompletion$9$label_116#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_117#1;

  inline$BDLDevicePowerIoCompletion$9$label_117#1:
    call inline$BDLDevicePowerIoCompletion$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$9$label_118#1;

  inline$BDLDevicePowerIoCompletion$9$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$9$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$9$label_112#1;

  inline$BDLDevicePowerIoCompletion$9$label_112#1:
    goto inline$BDLGetDebugLevel$264$Entry#1;

  inline$BDLGetDebugLevel$264$Entry#1:
    goto inline$BDLGetDebugLevel$264$start#1;

  inline$BDLGetDebugLevel$264$start#1:
    goto inline$BDLGetDebugLevel$264$label_3#1;

  inline$BDLGetDebugLevel$264$label_3#1:
    havoc inline$BDLGetDebugLevel$264$myNondetVar_0;
    inline$BDLGetDebugLevel$264$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$264$myNondetVar_0;
    goto inline$BDLGetDebugLevel$264$label_1#1;

  inline$BDLGetDebugLevel$264$label_1#1:
    goto inline$BDLGetDebugLevel$264$Return#1;

  inline$BDLGetDebugLevel$264$Return#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$264$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$9$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$9$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$9$anon44_Then#1, inline$BDLDevicePowerIoCompletion$9$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$9$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$anon29#1;

  inline$BDLDevicePowerIoCompletion$9$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_121#1;

  inline$BDLDevicePowerIoCompletion$9$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_121_true#1, inline$BDLDevicePowerIoCompletion$9$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$9$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_122#1;

  inline$BDLDevicePowerIoCompletion$9$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$9$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$9$label_123#1;

  inline$BDLDevicePowerIoCompletion$9$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$9$label_122#1;

  inline$BDLDevicePowerIoCompletion$9$label_122#1:
    inline$BDLDevicePowerIoCompletion$9$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$9$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$9$label_1#1;

  inline$BDLDevicePowerIoCompletion$9$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$9$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$9$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$9$Return#1;

  inline$BDLDevicePowerIoCompletion$9$Return#1:
    inline$CallCompletionRoutine$9$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$9$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$9$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$9$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$9$anon13_Then#1, inline$CallCompletionRoutine$9$anon13_Else#1;

  inline$CallCompletionRoutine$9$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$9$anon7#1;

  inline$CallCompletionRoutine$9$anon7#1:
    goto inline$CallCompletionRoutine$9$label_20_icall_return#1;

  inline$CallCompletionRoutine$9$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$9$Return#1;

  inline$CallCompletionRoutine$9$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$9$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$9$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$9$Entry#1;

  inline$BDLCallDriverCompletionRoutine$9$Entry#1:
    inline$BDLCallDriverCompletionRoutine$9$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$9$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$9$start#1;

  inline$BDLCallDriverCompletionRoutine$9$start#1:
    inline$BDLCallDriverCompletionRoutine$9$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$9$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$9$label_3#1;

  inline$BDLCallDriverCompletionRoutine$9$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$9$label_3_true#1, inline$BDLCallDriverCompletionRoutine$9$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$9$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$9$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$9$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$9$label_4#1;

  inline$BDLCallDriverCompletionRoutine$9$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$9$label_6#1;

  inline$BDLCallDriverCompletionRoutine$9$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$9$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$9$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$9$label_5#1;

  inline$BDLCallDriverCompletionRoutine$9$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$9$label_6#1;

  inline$BDLCallDriverCompletionRoutine$9$label_6#1:
    goto inline$storm_KeSetEvent$11$Entry#1;

  inline$storm_KeSetEvent$11$Entry#1:
    inline$storm_KeSetEvent$11$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$9$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$11$start#1;

  inline$storm_KeSetEvent$11$start#1:
    inline$storm_KeSetEvent$11$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$11$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$11$label_3#1;

  inline$storm_KeSetEvent$11$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$11$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$11$label_1#1;

  inline$storm_KeSetEvent$11$label_1#1:
    goto inline$storm_KeSetEvent$11$Return#1;

  inline$storm_KeSetEvent$11$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$9$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$9$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$9$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$9$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$9$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$9$anon1#1;

  inline$BDLCallDriverCompletionRoutine$9$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$9$label_9#1;

  inline$BDLCallDriverCompletionRoutine$9$label_9#1:
    inline$BDLCallDriverCompletionRoutine$9$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$9$label_1#1;

  inline$BDLCallDriverCompletionRoutine$9$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$9$Return#1;

  inline$BDLCallDriverCompletionRoutine$9$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$9$Return#1;

  inline$BDLCallDriverCompletionRoutine$9$Return#1:
    inline$CallCompletionRoutine$9$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$9$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$9$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$9$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$9$anon12_Then#1, inline$CallCompletionRoutine$9$anon12_Else#1;

  inline$CallCompletionRoutine$9$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$9$anon5#1;

  inline$CallCompletionRoutine$9$anon5#1:
    goto inline$CallCompletionRoutine$9$label_20_icall_return#1;

  inline$CallCompletionRoutine$9$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$9$label_23#1;

  inline$CallCompletionRoutine$9$label_23#1:
    inline$CallCompletionRoutine$9$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$9$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$9$label_24#1;

  inline$CallCompletionRoutine$9$label_24#1:
    goto inline$CallCompletionRoutine$9$label_24_true#1, inline$CallCompletionRoutine$9$label_24_false#1;

  inline$CallCompletionRoutine$9$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$9$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$9$label_1#1;

  inline$CallCompletionRoutine$9$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$9$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$9$label_25#1;

  inline$CallCompletionRoutine$9$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$9$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$9$label_1#1;

  inline$CallCompletionRoutine$9$label_1#1:
    goto inline$CallCompletionRoutine$9$Return#1;

  inline$CallCompletionRoutine$9$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$9$Return#1;

  inline$CallCompletionRoutine$9$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$9$Return#1;

  inline$CallCompletionRoutine$9$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$9$Return#1;

  inline$CallCompletionRoutine$9$Return#1:
    goto inline$storm_IoCallDriver$4$label_39$1#1;

  inline$storm_IoCallDriver$4$label_39$1#1:
    goto inline$storm_IoCallDriver$4$anon15_Then#1, inline$storm_IoCallDriver$4$anon15_Else#1;

  inline$storm_IoCallDriver$4$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$4$anon10#1;

  inline$storm_IoCallDriver$4$anon10#1:
    goto inline$storm_IoCallDriver$4$label_36#1;

  inline$storm_IoCallDriver$4$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$4$Return#1;

  inline$storm_IoCallDriver$4$label_27_case_0#1:
    assume inline$storm_IoCallDriver$4$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$4$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$4$label_28#1;

  inline$storm_IoCallDriver$4$label_28#1:
    inline$storm_IoCallDriver$4$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$4$label_42#1;

  inline$storm_IoCallDriver$4$label_42#1:
    goto inline$storm_IoCallDriver$4$label_43#1;

  inline$storm_IoCallDriver$4$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$4$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$4$label_36#1;

  inline$storm_IoCallDriver$4$label_36#1:
    inline$storm_IoCallDriver$4$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$4$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$4$label_1#1;

  inline$storm_IoCallDriver$4$label_1#1:
    goto inline$storm_IoCallDriver$4$Return#1;

  inline$storm_IoCallDriver$4$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$4$Return#1;

  inline$storm_IoCallDriver$4$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$4$Return#1;

  inline$storm_IoCallDriver$4$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$4$Return#1;

  inline$storm_IoCallDriver$4$Return#1:
    inline$BDLHandleRemove$0$$result.storm_IoCallDriver$2453.25$39$ := inline$storm_IoCallDriver$4$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLHandleRemove$0$label_109$1#1;

  inline$BDLHandleRemove$0$label_109$1#1:
    goto inline$BDLHandleRemove$0$anon56_Then#1, inline$BDLHandleRemove$0$anon56_Else#1;

  inline$BDLHandleRemove$0$anon56_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon29#1;

  inline$BDLHandleRemove$0$anon29#1:
    goto inline$BDLHandleRemove$0$label_112#1;

  inline$BDLHandleRemove$0$label_112#1:
    inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 := inline$BDLHandleRemove$0$$result.storm_IoCallDriver$2453.25$39$;
    goto inline$BDLHandleRemove$0$label_113#1;

  inline$BDLHandleRemove$0$label_113#1:
    goto inline$BDLHandleRemove$0$label_113_true#1, inline$BDLHandleRemove$0$label_113_false#1;

  inline$BDLHandleRemove$0$label_113_false#1:
    assume inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 == 0;
    goto inline$BDLHandleRemove$0$label_114#1;

  inline$BDLHandleRemove$0$label_113_true#1:
    assume inline$BDLHandleRemove$0$$status$4$2383.28$BDLHandleRemove$12 != 0;
    goto inline$BDLHandleRemove$0$label_117#1;

  inline$BDLHandleRemove$0$label_117#1:
    goto inline$BDLGetDebugLevel$278$Entry#1;

  inline$BDLGetDebugLevel$278$Entry#1:
    goto inline$BDLGetDebugLevel$278$start#1;

  inline$BDLGetDebugLevel$278$start#1:
    goto inline$BDLGetDebugLevel$278$label_3#1;

  inline$BDLGetDebugLevel$278$label_3#1:
    havoc inline$BDLGetDebugLevel$278$myNondetVar_0;
    inline$BDLGetDebugLevel$278$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$278$myNondetVar_0;
    goto inline$BDLGetDebugLevel$278$label_1#1;

  inline$BDLGetDebugLevel$278$label_1#1:
    goto inline$BDLGetDebugLevel$278$Return#1;

  inline$BDLGetDebugLevel$278$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$40$ := inline$BDLGetDebugLevel$278$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_117$1#1;

  inline$BDLHandleRemove$0$label_117$1#1:
    goto inline$BDLHandleRemove$0$anon58_Then#1, inline$BDLHandleRemove$0$anon58_Else#1;

  inline$BDLHandleRemove$0$anon58_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon33#1;

  inline$BDLHandleRemove$0$anon33#1:
    goto inline$BDLHandleRemove$0$label_120#1;

  inline$BDLHandleRemove$0$label_120#1:
    goto inline$BDLHandleRemove$0$label_120_true#1, inline$BDLHandleRemove$0$label_120_false#1;

  inline$BDLHandleRemove$0$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$40$) == 0;
    goto inline$BDLHandleRemove$0$label_121#1;

  inline$BDLHandleRemove$0$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$40$) != 0;
    goto inline$BDLHandleRemove$0$label_124#1;

  inline$BDLHandleRemove$0$label_124#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_125#1;

  inline$BDLHandleRemove$0$label_125#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_126#1;

  inline$BDLHandleRemove$0$label_126#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_127#1;

  inline$BDLHandleRemove$0$label_127#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2457.0$41$;
    goto inline$BDLHandleRemove$0$label_121#1;

  inline$BDLHandleRemove$0$label_121#1:
    goto inline$BDLGetDebugLevel$279$Entry#1;

  inline$BDLGetDebugLevel$279$Entry#1:
    goto inline$BDLGetDebugLevel$279$start#1;

  inline$BDLGetDebugLevel$279$start#1:
    goto inline$BDLGetDebugLevel$279$label_3#1;

  inline$BDLGetDebugLevel$279$label_3#1:
    havoc inline$BDLGetDebugLevel$279$myNondetVar_0;
    inline$BDLGetDebugLevel$279$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$279$myNondetVar_0;
    goto inline$BDLGetDebugLevel$279$label_1#1;

  inline$BDLGetDebugLevel$279$label_1#1:
    goto inline$BDLGetDebugLevel$279$Return#1;

  inline$BDLGetDebugLevel$279$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$45$ := inline$BDLGetDebugLevel$279$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_121$1#1;

  inline$BDLHandleRemove$0$label_121$1#1:
    goto inline$BDLHandleRemove$0$anon59_Then#1, inline$BDLHandleRemove$0$anon59_Else#1;

  inline$BDLHandleRemove$0$anon59_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon35#1;

  inline$BDLHandleRemove$0$anon35#1:
    goto inline$BDLHandleRemove$0$label_130#1;

  inline$BDLHandleRemove$0$label_130#1:
    goto inline$BDLHandleRemove$0$label_130_true#1, inline$BDLHandleRemove$0$label_130_false#1;

  inline$BDLHandleRemove$0$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$45$) == 0;
    goto inline$BDLHandleRemove$0$label_131#1;

  inline$BDLHandleRemove$0$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$45$) != 0;
    goto inline$BDLHandleRemove$0$label_134#1;

  inline$BDLHandleRemove$0$label_134#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_135#1;

  inline$BDLHandleRemove$0$label_135#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_136#1;

  inline$BDLHandleRemove$0$label_136#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_137#1;

  inline$BDLHandleRemove$0$label_137#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2457.0$46$;
    goto inline$BDLHandleRemove$0$label_131#1;

  inline$BDLHandleRemove$0$label_131#1:
    goto inline$BDLGetDebugLevel$280$Entry#1;

  inline$BDLGetDebugLevel$280$Entry#1:
    goto inline$BDLGetDebugLevel$280$start#1;

  inline$BDLGetDebugLevel$280$start#1:
    goto inline$BDLGetDebugLevel$280$label_3#1;

  inline$BDLGetDebugLevel$280$label_3#1:
    havoc inline$BDLGetDebugLevel$280$myNondetVar_0;
    inline$BDLGetDebugLevel$280$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$280$myNondetVar_0;
    goto inline$BDLGetDebugLevel$280$label_1#1;

  inline$BDLGetDebugLevel$280$label_1#1:
    goto inline$BDLGetDebugLevel$280$Return#1;

  inline$BDLGetDebugLevel$280$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$50$ := inline$BDLGetDebugLevel$280$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_131$1#1;

  inline$BDLHandleRemove$0$label_131$1#1:
    goto inline$BDLHandleRemove$0$anon60_Then#1, inline$BDLHandleRemove$0$anon60_Else#1;

  inline$BDLHandleRemove$0$anon60_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon37#1;

  inline$BDLHandleRemove$0$anon37#1:
    goto inline$BDLHandleRemove$0$label_140#1;

  inline$BDLHandleRemove$0$label_140#1:
    goto inline$BDLHandleRemove$0$label_140_true#1, inline$BDLHandleRemove$0$label_140_false#1;

  inline$BDLHandleRemove$0$label_140_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$50$, 4) == 0;
    goto inline$BDLHandleRemove$0$label_114#1;

  inline$BDLHandleRemove$0$label_140_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2457.0$50$, 4) != 0;
    goto inline$BDLHandleRemove$0$label_141#1;

  inline$BDLHandleRemove$0$label_141#1:
    goto inline$BDLHandleRemove$0$label_114#1;

  inline$BDLHandleRemove$0$label_114#1:
    goto inline$BDLGetDebugLevel$277$Entry#1;

  inline$BDLGetDebugLevel$277$Entry#1:
    goto inline$BDLGetDebugLevel$277$start#1;

  inline$BDLGetDebugLevel$277$start#1:
    goto inline$BDLGetDebugLevel$277$label_3#1;

  inline$BDLGetDebugLevel$277$label_3#1:
    havoc inline$BDLGetDebugLevel$277$myNondetVar_0;
    inline$BDLGetDebugLevel$277$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$277$myNondetVar_0;
    goto inline$BDLGetDebugLevel$277$label_1#1;

  inline$BDLGetDebugLevel$277$label_1#1:
    goto inline$BDLGetDebugLevel$277$Return#1;

  inline$BDLGetDebugLevel$277$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$51$ := inline$BDLGetDebugLevel$277$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_114$1#1;

  inline$BDLHandleRemove$0$label_114$1#1:
    goto inline$BDLHandleRemove$0$anon57_Then#1, inline$BDLHandleRemove$0$anon57_Else#1;

  inline$BDLHandleRemove$0$anon57_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon31#1;

  inline$BDLHandleRemove$0$anon31#1:
    goto inline$BDLHandleRemove$0$label_142#1;

  inline$BDLHandleRemove$0$label_142#1:
    goto inline$BDLHandleRemove$0$label_142_true#1, inline$BDLHandleRemove$0$label_142_false#1;

  inline$BDLHandleRemove$0$label_142_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$51$) == 0;
    goto inline$BDLHandleRemove$0$label_143#1;

  inline$BDLHandleRemove$0$label_142_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$51$) != 0;
    goto inline$BDLHandleRemove$0$label_146#1;

  inline$BDLHandleRemove$0$label_146#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_147#1;

  inline$BDLHandleRemove$0$label_147#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_148#1;

  inline$BDLHandleRemove$0$label_148#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_149#1;

  inline$BDLHandleRemove$0$label_149#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2465.0$52$;
    goto inline$BDLHandleRemove$0$label_143#1;

  inline$BDLHandleRemove$0$label_143#1:
    goto inline$BDLGetDebugLevel$281$Entry#1;

  inline$BDLGetDebugLevel$281$Entry#1:
    goto inline$BDLGetDebugLevel$281$start#1;

  inline$BDLGetDebugLevel$281$start#1:
    goto inline$BDLGetDebugLevel$281$label_3#1;

  inline$BDLGetDebugLevel$281$label_3#1:
    havoc inline$BDLGetDebugLevel$281$myNondetVar_0;
    inline$BDLGetDebugLevel$281$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$281$myNondetVar_0;
    goto inline$BDLGetDebugLevel$281$label_1#1;

  inline$BDLGetDebugLevel$281$label_1#1:
    goto inline$BDLGetDebugLevel$281$Return#1;

  inline$BDLGetDebugLevel$281$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$56$ := inline$BDLGetDebugLevel$281$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_143$1#1;

  inline$BDLHandleRemove$0$label_143$1#1:
    goto inline$BDLHandleRemove$0$anon61_Then#1, inline$BDLHandleRemove$0$anon61_Else#1;

  inline$BDLHandleRemove$0$anon61_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon39#1;

  inline$BDLHandleRemove$0$anon39#1:
    goto inline$BDLHandleRemove$0$label_152#1;

  inline$BDLHandleRemove$0$label_152#1:
    goto inline$BDLHandleRemove$0$label_152_true#1, inline$BDLHandleRemove$0$label_152_false#1;

  inline$BDLHandleRemove$0$label_152_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$56$) == 0;
    goto inline$BDLHandleRemove$0$label_153#1;

  inline$BDLHandleRemove$0$label_152_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$56$) != 0;
    goto inline$BDLHandleRemove$0$label_156#1;

  inline$BDLHandleRemove$0$label_156#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_157#1;

  inline$BDLHandleRemove$0$label_157#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_158#1;

  inline$BDLHandleRemove$0$label_158#1:
    call inline$BDLHandleRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLHandleRemove$0$label_159#1;

  inline$BDLHandleRemove$0$label_159#1:
    havoc inline$BDLHandleRemove$0$$result.DbgPrint$2465.0$57$;
    goto inline$BDLHandleRemove$0$label_153#1;

  inline$BDLHandleRemove$0$label_153#1:
    goto inline$BDLGetDebugLevel$282$Entry#1;

  inline$BDLGetDebugLevel$282$Entry#1:
    goto inline$BDLGetDebugLevel$282$start#1;

  inline$BDLGetDebugLevel$282$start#1:
    goto inline$BDLGetDebugLevel$282$label_3#1;

  inline$BDLGetDebugLevel$282$label_3#1:
    havoc inline$BDLGetDebugLevel$282$myNondetVar_0;
    inline$BDLGetDebugLevel$282$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$282$myNondetVar_0;
    goto inline$BDLGetDebugLevel$282$label_1#1;

  inline$BDLGetDebugLevel$282$label_1#1:
    goto inline$BDLGetDebugLevel$282$Return#1;

  inline$BDLGetDebugLevel$282$Return#1:
    inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$61$ := inline$BDLGetDebugLevel$282$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLHandleRemove$0$label_153$1#1;

  inline$BDLHandleRemove$0$label_153$1#1:
    goto inline$BDLHandleRemove$0$anon62_Then#1, inline$BDLHandleRemove$0$anon62_Else#1;

  inline$BDLHandleRemove$0$anon62_Else#1:
    assume !raiseException;
    goto inline$BDLHandleRemove$0$anon41#1;

  inline$BDLHandleRemove$0$anon41#1:
    goto inline$BDLHandleRemove$0$label_162#1;

  inline$BDLHandleRemove$0$label_162#1:
    goto inline$BDLHandleRemove$0$label_162_true#1, inline$BDLHandleRemove$0$label_162_false#1;

  inline$BDLHandleRemove$0$label_162_false#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$61$, 4) == 0;
    goto inline$BDLHandleRemove$0$label_163#1;

  inline$BDLHandleRemove$0$label_162_true#1:
    assume BIT_BAND(inline$BDLHandleRemove$0$$result.BDLGetDebugLevel$2465.0$61$, 4) != 0;
    goto inline$BDLHandleRemove$0$label_164#1;

  inline$BDLHandleRemove$0$label_164#1:
    goto inline$BDLHandleRemove$0$label_163#1;

  inline$BDLHandleRemove$0$label_163#1:
    goto inline$BDLHandleRemove$0$label_1#1;

  inline$BDLHandleRemove$0$label_1#1:
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon62_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon61_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon57_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon60_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon59_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon58_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon56_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon52_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon55_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon54_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon53_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon51_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon50_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon49_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon48_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon47_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon46_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon45_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon44_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon43_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$anon42_Then#1:
    assume raiseException;
    goto inline$BDLHandleRemove$0$Return#1;

  inline$BDLHandleRemove$0$Return#1:
    goto inline$BDLPnPRemove$0$label_73$1#1;

  inline$BDLPnPRemove$0$label_73$1#1:
    goto inline$BDLPnPRemove$0$anon35_Then#1, inline$BDLPnPRemove$0$anon35_Else#1;

  inline$BDLPnPRemove$0$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon23#1;

  inline$BDLPnPRemove$0$anon23#1:
    goto inline$BDLPnPRemove$0$label_32#1;

  inline$BDLPnPRemove$0$anon35_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$label_29_true#1:
    havoc inline$BDLPnPRemove$0$myNondetVar_0;
    assume inline$BDLPnPRemove$0$myNondetVar_0 != 0;
    goto inline$BDLPnPRemove$0$label_32#1;

  inline$BDLPnPRemove$0$label_32#1:
    call IoReleaseRemoveLockAndWaitEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16), 544632146, 88);
    goto inline$BDLPnPRemove$0$anon27_Then#1, inline$BDLPnPRemove$0$anon27_Else#1;

  inline$BDLPnPRemove$0$anon27_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon7#1;

  inline$BDLPnPRemove$0$anon7#1:
    goto inline$BDLPnPRemove$0$label_35#1;

  inline$BDLPnPRemove$0$label_35#1:
    goto inline$BDLCleanupDeviceCapabilities$0$Entry#1;

  inline$BDLCleanupDeviceCapabilities$0$Entry#1:
    goto inline$BDLCleanupDeviceCapabilities$0$start#1;

  inline$BDLCleanupDeviceCapabilities$0$start#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_3#1;

  inline$BDLCleanupDeviceCapabilities$0$label_3#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_4#1;

  inline$BDLCleanupDeviceCapabilities$0$label_4#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_5#1;

  inline$BDLCleanupDeviceCapabilities$0$label_5#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_6#1;

  inline$BDLCleanupDeviceCapabilities$0$label_6#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_7#1;

  inline$BDLCleanupDeviceCapabilities$0$label_7#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_7_true#1, inline$BDLCleanupDeviceCapabilities$0$label_7_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_7_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_8#1;

  inline$BDLCleanupDeviceCapabilities$0$label_7_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_9#1;

  inline$BDLCleanupDeviceCapabilities$0$label_9#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon14_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon14_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon14_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon1#1;

  inline$BDLCleanupDeviceCapabilities$0$anon1#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_12#1;

  inline$BDLCleanupDeviceCapabilities$0$label_12#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_8#1;

  inline$BDLCleanupDeviceCapabilities$0$label_8#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_8_true#1, inline$BDLCleanupDeviceCapabilities$0$label_8_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_8_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_1#1;

  inline$BDLCleanupDeviceCapabilities$0$label_8_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_13#1;

  inline$BDLCleanupDeviceCapabilities$0$label_13#1:
    inline$BDLCleanupDeviceCapabilities$0$$i$3$1733.10$BDLCleanupDeviceCapabilities$4 := 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_14#1;

  inline$BDLCleanupDeviceCapabilities$0$label_14#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_14_head#1;

  inline$BDLCleanupDeviceCapabilities$0$label_14_head#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_14_true#1, inline$BDLCleanupDeviceCapabilities$0$label_14_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_14_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    assume !INT_ULT(inline$BDLCleanupDeviceCapabilities$0$$i$3$1733.10$BDLCleanupDeviceCapabilities$4, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0);
    goto inline$BDLCleanupDeviceCapabilities$0$label_15#1;

  inline$BDLCleanupDeviceCapabilities$0$label_15#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon15_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon15_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon15_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon3#1;

  inline$BDLCleanupDeviceCapabilities$0$anon3#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_47#1;

  inline$BDLCleanupDeviceCapabilities$0$label_47#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_1#1;

  inline$BDLCleanupDeviceCapabilities$0$label_1#1:
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$anon15_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$label_14_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    assume INT_ULT(inline$BDLCleanupDeviceCapabilities$0$$i$3$1733.10$BDLCleanupDeviceCapabilities$4, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0);
    goto inline$BDLCleanupDeviceCapabilities$0$label_18#1;

  inline$BDLCleanupDeviceCapabilities$0$label_18#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_18_true#1, inline$BDLCleanupDeviceCapabilities$0$label_18_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_18_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_19#1;

  inline$BDLCleanupDeviceCapabilities$0$label_18_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_20#1;

  inline$BDLCleanupDeviceCapabilities$0$label_20#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$1$ := inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    goto inline$BDLCleanupDeviceCapabilities$0$label_21#1;

  inline$BDLCleanupDeviceCapabilities$0$label_21#1:
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$1$, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon16_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon16_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon5#1;

  inline$BDLCleanupDeviceCapabilities$0$anon5#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_19#1;

  inline$BDLCleanupDeviceCapabilities$0$label_19#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_19_true#1, inline$BDLCleanupDeviceCapabilities$0$label_19_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_19_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_24#1;

  inline$BDLCleanupDeviceCapabilities$0$label_19_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_25#1;

  inline$BDLCleanupDeviceCapabilities$0$label_25#1:
    inline$BDLCleanupDeviceCapabilities$0$$j$4$1733.13$BDLCleanupDeviceCapabilities$4 := 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_26#1;

  inline$BDLCleanupDeviceCapabilities$0$label_26#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_26_head#1;

  inline$BDLCleanupDeviceCapabilities$0$label_26_head#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_26_true#1, inline$BDLCleanupDeviceCapabilities$0$label_26_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_26_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    assume !INT_ULT(inline$BDLCleanupDeviceCapabilities$0$$j$4$1733.13$BDLCleanupDeviceCapabilities$4, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1);
    goto inline$BDLCleanupDeviceCapabilities$0$label_27#1;

  inline$BDLCleanupDeviceCapabilities$0$label_27#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$5$ := inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    goto inline$BDLCleanupDeviceCapabilities$0$label_44#1;

  inline$BDLCleanupDeviceCapabilities$0$label_44#1:
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$5$, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon20_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon20_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon13#1;

  inline$BDLCleanupDeviceCapabilities$0$anon13#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_24#1;

  inline$BDLCleanupDeviceCapabilities$0$label_24#1:
    inline$BDLCleanupDeviceCapabilities$0$$i$3$1733.10$BDLCleanupDeviceCapabilities$4 := PLUS(inline$BDLCleanupDeviceCapabilities$0$$i$3$1733.10$BDLCleanupDeviceCapabilities$4, 1, 1);
    goto inline$BDLCleanupDeviceCapabilities$0$label_14_head#0;

  inline$BDLCleanupDeviceCapabilities$0$label_14_head#0:
    assume false;
    return;

  inline$BDLCleanupDeviceCapabilities$0$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$label_26_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    assume INT_ULT(inline$BDLCleanupDeviceCapabilities$0$$j$4$1733.13$BDLCleanupDeviceCapabilities$4, inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1);
    goto inline$BDLCleanupDeviceCapabilities$0$label_28#1;

  inline$BDLCleanupDeviceCapabilities$0$label_28#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_28_true#1, inline$BDLCleanupDeviceCapabilities$0$label_28_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_28_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_29#1;

  inline$BDLCleanupDeviceCapabilities$0$label_28_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_30#1;

  inline$BDLCleanupDeviceCapabilities$0$label_30#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$2$ := inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    goto inline$BDLCleanupDeviceCapabilities$0$label_31#1;

  inline$BDLCleanupDeviceCapabilities$0$label_31#1:
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$2$, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon17_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon17_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon7#1;

  inline$BDLCleanupDeviceCapabilities$0$anon7#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_29#1;

  inline$BDLCleanupDeviceCapabilities$0$label_29#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_29_true#1, inline$BDLCleanupDeviceCapabilities$0$label_29_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_29_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_34#1;

  inline$BDLCleanupDeviceCapabilities$0$label_29_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_35#1;

  inline$BDLCleanupDeviceCapabilities$0$label_35#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$3$ := inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    goto inline$BDLCleanupDeviceCapabilities$0$label_36#1;

  inline$BDLCleanupDeviceCapabilities$0$label_36#1:
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$3$, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon18_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon18_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon9#1;

  inline$BDLCleanupDeviceCapabilities$0$anon9#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_34#1;

  inline$BDLCleanupDeviceCapabilities$0$label_34#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_34_true#1, inline$BDLCleanupDeviceCapabilities$0$label_34_false#1;

  inline$BDLCleanupDeviceCapabilities$0$label_34_false#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2 == 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_39#1;

  inline$BDLCleanupDeviceCapabilities$0$label_34_true#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    assume inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2 != 0;
    goto inline$BDLCleanupDeviceCapabilities$0$label_40#1;

  inline$BDLCleanupDeviceCapabilities$0$label_40#1:
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_0;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_1;
    havoc inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$4$ := inline$BDLCleanupDeviceCapabilities$0$myNondetVar_2;
    goto inline$BDLCleanupDeviceCapabilities$0$label_41#1;

  inline$BDLCleanupDeviceCapabilities$0$label_41#1:
    call ExFreePoolWithTag(inline$BDLCleanupDeviceCapabilities$0$$ExFreePoolWithTag.arg.1$4$, 541869122);
    goto inline$BDLCleanupDeviceCapabilities$0$anon19_Then#1, inline$BDLCleanupDeviceCapabilities$0$anon19_Else#1;

  inline$BDLCleanupDeviceCapabilities$0$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$anon11#1;

  inline$BDLCleanupDeviceCapabilities$0$anon11#1:
    goto inline$BDLCleanupDeviceCapabilities$0$label_39#1;

  inline$BDLCleanupDeviceCapabilities$0$label_39#1:
    inline$BDLCleanupDeviceCapabilities$0$$j$4$1733.13$BDLCleanupDeviceCapabilities$4 := PLUS(inline$BDLCleanupDeviceCapabilities$0$$j$4$1733.13$BDLCleanupDeviceCapabilities$4, 1, 1);
    goto inline$BDLCleanupDeviceCapabilities$0$label_26_head#0;

  inline$BDLCleanupDeviceCapabilities$0$label_26_head#0:
    assume false;
    return;

  inline$BDLCleanupDeviceCapabilities$0$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$anon14_Then#1:
    assume raiseException;
    goto inline$BDLCleanupDeviceCapabilities$0$Return#1;

  inline$BDLCleanupDeviceCapabilities$0$Return#1:
    goto inline$BDLPnPRemove$0$label_35$1#1;

  inline$BDLPnPRemove$0$label_35$1#1:
    goto inline$BDLPnPRemove$0$anon28_Then#1, inline$BDLPnPRemove$0$anon28_Else#1;

  inline$BDLPnPRemove$0$anon28_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon9#1;

  inline$BDLPnPRemove$0$anon9#1:
    goto inline$BDLPnPRemove$0$label_38#1;

  inline$BDLPnPRemove$0$label_38#1:
    call IoDetachDevice(inline$BDLPnPRemove$0$$pAttachedDeviceObject$3$2480.40$BDLPnPRemove$16);
    goto inline$BDLPnPRemove$0$anon29_Then#1, inline$BDLPnPRemove$0$anon29_Else#1;

  inline$BDLPnPRemove$0$anon29_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon11#1;

  inline$BDLPnPRemove$0$anon11#1:
    goto inline$BDLPnPRemove$0$label_41#1;

  inline$BDLPnPRemove$0$label_41#1:
    call RtlFreeUnicodeString(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPRemove$0$$pBDLExtension$1$2478.40$BDLPnPRemove$16));
    goto inline$BDLPnPRemove$0$anon30_Then#1, inline$BDLPnPRemove$0$anon30_Else#1;

  inline$BDLPnPRemove$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon13#1;

  inline$BDLPnPRemove$0$anon13#1:
    goto inline$BDLPnPRemove$0$label_44#1;

  inline$BDLPnPRemove$0$label_44#1:
    call IoDeleteDevice(inline$BDLPnPRemove$0$$pDeviceObject$2$2479.40$BDLPnPRemove$16);
    goto inline$BDLPnPRemove$0$anon31_Then#1, inline$BDLPnPRemove$0$anon31_Else#1;

  inline$BDLPnPRemove$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon15#1;

  inline$BDLPnPRemove$0$anon15#1:
    goto inline$BDLPnPRemove$0$label_47#1;

  inline$BDLPnPRemove$0$label_47#1:
    goto inline$BDLGetDebugLevel$205$Entry#1;

  inline$BDLGetDebugLevel$205$Entry#1:
    goto inline$BDLGetDebugLevel$205$start#1;

  inline$BDLGetDebugLevel$205$start#1:
    goto inline$BDLGetDebugLevel$205$label_3#1;

  inline$BDLGetDebugLevel$205$label_3#1:
    havoc inline$BDLGetDebugLevel$205$myNondetVar_0;
    inline$BDLGetDebugLevel$205$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$205$myNondetVar_0;
    goto inline$BDLGetDebugLevel$205$label_1#1;

  inline$BDLGetDebugLevel$205$label_1#1:
    goto inline$BDLGetDebugLevel$205$Return#1;

  inline$BDLGetDebugLevel$205$Return#1:
    inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$14$ := inline$BDLGetDebugLevel$205$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPRemove$0$label_47$1#1;

  inline$BDLPnPRemove$0$label_47$1#1:
    goto inline$BDLPnPRemove$0$anon32_Then#1, inline$BDLPnPRemove$0$anon32_Else#1;

  inline$BDLPnPRemove$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon17#1;

  inline$BDLPnPRemove$0$anon17#1:
    goto inline$BDLPnPRemove$0$label_50#1;

  inline$BDLPnPRemove$0$label_50#1:
    goto inline$BDLPnPRemove$0$label_50_true#1, inline$BDLPnPRemove$0$label_50_false#1;

  inline$BDLPnPRemove$0$label_50_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$14$) == 0;
    goto inline$BDLPnPRemove$0$label_51#1;

  inline$BDLPnPRemove$0$label_50_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$14$) != 0;
    goto inline$BDLPnPRemove$0$label_54#1;

  inline$BDLPnPRemove$0$label_54#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_55#1;

  inline$BDLPnPRemove$0$label_55#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_56#1;

  inline$BDLPnPRemove$0$label_56#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_57#1;

  inline$BDLPnPRemove$0$label_57#1:
    havoc inline$BDLPnPRemove$0$$result.DbgPrint$2516.0$15$;
    goto inline$BDLPnPRemove$0$label_51#1;

  inline$BDLPnPRemove$0$label_51#1:
    goto inline$BDLGetDebugLevel$206$Entry#1;

  inline$BDLGetDebugLevel$206$Entry#1:
    goto inline$BDLGetDebugLevel$206$start#1;

  inline$BDLGetDebugLevel$206$start#1:
    goto inline$BDLGetDebugLevel$206$label_3#1;

  inline$BDLGetDebugLevel$206$label_3#1:
    havoc inline$BDLGetDebugLevel$206$myNondetVar_0;
    inline$BDLGetDebugLevel$206$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$206$myNondetVar_0;
    goto inline$BDLGetDebugLevel$206$label_1#1;

  inline$BDLGetDebugLevel$206$label_1#1:
    goto inline$BDLGetDebugLevel$206$Return#1;

  inline$BDLGetDebugLevel$206$Return#1:
    inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$19$ := inline$BDLGetDebugLevel$206$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPRemove$0$label_51$1#1;

  inline$BDLPnPRemove$0$label_51$1#1:
    goto inline$BDLPnPRemove$0$anon33_Then#1, inline$BDLPnPRemove$0$anon33_Else#1;

  inline$BDLPnPRemove$0$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon19#1;

  inline$BDLPnPRemove$0$anon19#1:
    goto inline$BDLPnPRemove$0$label_60#1;

  inline$BDLPnPRemove$0$label_60#1:
    goto inline$BDLPnPRemove$0$label_60_true#1, inline$BDLPnPRemove$0$label_60_false#1;

  inline$BDLPnPRemove$0$label_60_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$19$) == 0;
    goto inline$BDLPnPRemove$0$label_61#1;

  inline$BDLPnPRemove$0$label_60_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$19$) != 0;
    goto inline$BDLPnPRemove$0$label_64#1;

  inline$BDLPnPRemove$0$label_64#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_65#1;

  inline$BDLPnPRemove$0$label_65#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_66#1;

  inline$BDLPnPRemove$0$label_66#1:
    call inline$BDLPnPRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPRemove$0$label_67#1;

  inline$BDLPnPRemove$0$label_67#1:
    havoc inline$BDLPnPRemove$0$$result.DbgPrint$2516.0$20$;
    goto inline$BDLPnPRemove$0$label_61#1;

  inline$BDLPnPRemove$0$label_61#1:
    goto inline$BDLGetDebugLevel$207$Entry#1;

  inline$BDLGetDebugLevel$207$Entry#1:
    goto inline$BDLGetDebugLevel$207$start#1;

  inline$BDLGetDebugLevel$207$start#1:
    goto inline$BDLGetDebugLevel$207$label_3#1;

  inline$BDLGetDebugLevel$207$label_3#1:
    havoc inline$BDLGetDebugLevel$207$myNondetVar_0;
    inline$BDLGetDebugLevel$207$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$207$myNondetVar_0;
    goto inline$BDLGetDebugLevel$207$label_1#1;

  inline$BDLGetDebugLevel$207$label_1#1:
    goto inline$BDLGetDebugLevel$207$Return#1;

  inline$BDLGetDebugLevel$207$Return#1:
    inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$24$ := inline$BDLGetDebugLevel$207$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPRemove$0$label_61$1#1;

  inline$BDLPnPRemove$0$label_61$1#1:
    goto inline$BDLPnPRemove$0$anon34_Then#1, inline$BDLPnPRemove$0$anon34_Else#1;

  inline$BDLPnPRemove$0$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLPnPRemove$0$anon21#1;

  inline$BDLPnPRemove$0$anon21#1:
    goto inline$BDLPnPRemove$0$label_70#1;

  inline$BDLPnPRemove$0$label_70#1:
    goto inline$BDLPnPRemove$0$label_70_true#1, inline$BDLPnPRemove$0$label_70_false#1;

  inline$BDLPnPRemove$0$label_70_false#1:
    assume BIT_BAND(inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$24$, 4) == 0;
    goto inline$BDLPnPRemove$0$label_71#1;

  inline$BDLPnPRemove$0$label_70_true#1:
    assume BIT_BAND(inline$BDLPnPRemove$0$$result.BDLGetDebugLevel$2516.0$24$, 4) != 0;
    goto inline$BDLPnPRemove$0$label_72#1;

  inline$BDLPnPRemove$0$label_72#1:
    goto inline$BDLPnPRemove$0$label_71#1;

  inline$BDLPnPRemove$0$label_71#1:
    inline$BDLPnPRemove$0$$result.BDLPnPRemove$2476.0$1$ := inline$BDLPnPRemove$0$$status$5$2484.16$BDLPnPRemove$16;
    goto inline$BDLPnPRemove$0$label_1#1;

  inline$BDLPnPRemove$0$label_1#1:
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon34_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon33_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon29_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon28_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon27_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon26_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon25_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$anon24_Then#1:
    assume raiseException;
    goto inline$BDLPnPRemove$0$Return#1;

  inline$BDLPnPRemove$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPRemove$961.29$34$ := inline$BDLPnPRemove$0$$result.BDLPnPRemove$2476.0$1$;
    goto inline$BDLPnP$0$label_119$1#1;

  inline$BDLPnP$0$label_119$1#1:
    goto inline$BDLPnP$0$anon69_Then#1, inline$BDLPnP$0$anon69_Else#1;

  inline$BDLPnP$0$anon69_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon31#1;

  inline$BDLPnP$0$anon31#1:
    goto inline$BDLPnP$0$label_152#1;

  inline$BDLPnP$0$label_152#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPRemove$961.29$34$;
    goto inline$BDLPnP$0$label_153#1;

  inline$BDLPnP$0$label_153#1:
    inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8 := 0;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon69_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_2#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 1;
    goto inline$BDLPnP$0$label_116#1;

  inline$BDLPnP$0$label_116#1:
    goto inline$BDLPnPQueryRemove$0$Entry#1;

  inline$BDLPnPQueryRemove$0$Entry#1:
    inline$BDLPnPQueryRemove$0$$pBDLExtension$1$2256.40$BDLPnPQueryRemove$12_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPQueryRemove$0$$pIrp$3$2258.40$BDLPnPQueryRemove$12_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPQueryRemove$0$start#1;

  inline$BDLPnPQueryRemove$0$start#1:
    inline$BDLPnPQueryRemove$0$$pBDLExtension$1$2256.40$BDLPnPQueryRemove$12 := inline$BDLPnPQueryRemove$0$$pBDLExtension$1$2256.40$BDLPnPQueryRemove$12_.1;
    inline$BDLPnPQueryRemove$0$$pIrp$3$2258.40$BDLPnPQueryRemove$12 := inline$BDLPnPQueryRemove$0$$pIrp$3$2258.40$BDLPnPQueryRemove$12_.1;
    goto inline$BDLPnPQueryRemove$0$label_3#1;

  inline$BDLPnPQueryRemove$0$label_3#1:
    goto inline$BDLPnPQueryRemove$0$label_4#1;

  inline$BDLPnPQueryRemove$0$label_4#1:
    inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12 := 0;
    goto inline$BDLPnPQueryRemove$0$label_5#1;

  inline$BDLPnPQueryRemove$0$label_5#1:
    goto inline$BDLGetDebugLevel$109$Entry#1;

  inline$BDLGetDebugLevel$109$Entry#1:
    goto inline$BDLGetDebugLevel$109$start#1;

  inline$BDLGetDebugLevel$109$start#1:
    goto inline$BDLGetDebugLevel$109$label_3#1;

  inline$BDLGetDebugLevel$109$label_3#1:
    havoc inline$BDLGetDebugLevel$109$myNondetVar_0;
    inline$BDLGetDebugLevel$109$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$109$myNondetVar_0;
    goto inline$BDLGetDebugLevel$109$label_1#1;

  inline$BDLGetDebugLevel$109$label_1#1:
    goto inline$BDLGetDebugLevel$109$Return#1;

  inline$BDLGetDebugLevel$109$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$2$ := inline$BDLGetDebugLevel$109$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_5$1#1;

  inline$BDLPnPQueryRemove$0$label_5$1#1:
    goto inline$BDLPnPQueryRemove$0$anon22_Then#1, inline$BDLPnPQueryRemove$0$anon22_Else#1;

  inline$BDLPnPQueryRemove$0$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon1#1;

  inline$BDLPnPQueryRemove$0$anon1#1:
    goto inline$BDLPnPQueryRemove$0$label_8#1;

  inline$BDLPnPQueryRemove$0$label_8#1:
    goto inline$BDLPnPQueryRemove$0$label_8_true#1, inline$BDLPnPQueryRemove$0$label_8_false#1;

  inline$BDLPnPQueryRemove$0$label_8_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$2$) == 0;
    goto inline$BDLPnPQueryRemove$0$label_9#1;

  inline$BDLPnPQueryRemove$0$label_8_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$2$) != 0;
    goto inline$BDLPnPQueryRemove$0$label_12#1;

  inline$BDLPnPQueryRemove$0$label_12#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_13#1;

  inline$BDLPnPQueryRemove$0$label_13#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_14#1;

  inline$BDLPnPQueryRemove$0$label_14#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_15#1;

  inline$BDLPnPQueryRemove$0$label_15#1:
    havoc inline$BDLPnPQueryRemove$0$$result.DbgPrint$2263.0$3$;
    goto inline$BDLPnPQueryRemove$0$label_9#1;

  inline$BDLPnPQueryRemove$0$label_9#1:
    goto inline$BDLGetDebugLevel$110$Entry#1;

  inline$BDLGetDebugLevel$110$Entry#1:
    goto inline$BDLGetDebugLevel$110$start#1;

  inline$BDLGetDebugLevel$110$start#1:
    goto inline$BDLGetDebugLevel$110$label_3#1;

  inline$BDLGetDebugLevel$110$label_3#1:
    havoc inline$BDLGetDebugLevel$110$myNondetVar_0;
    inline$BDLGetDebugLevel$110$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$110$myNondetVar_0;
    goto inline$BDLGetDebugLevel$110$label_1#1;

  inline$BDLGetDebugLevel$110$label_1#1:
    goto inline$BDLGetDebugLevel$110$Return#1;

  inline$BDLGetDebugLevel$110$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$7$ := inline$BDLGetDebugLevel$110$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_9$1#1;

  inline$BDLPnPQueryRemove$0$label_9$1#1:
    goto inline$BDLPnPQueryRemove$0$anon23_Then#1, inline$BDLPnPQueryRemove$0$anon23_Else#1;

  inline$BDLPnPQueryRemove$0$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon3#1;

  inline$BDLPnPQueryRemove$0$anon3#1:
    goto inline$BDLPnPQueryRemove$0$label_18#1;

  inline$BDLPnPQueryRemove$0$label_18#1:
    goto inline$BDLPnPQueryRemove$0$label_18_true#1, inline$BDLPnPQueryRemove$0$label_18_false#1;

  inline$BDLPnPQueryRemove$0$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$7$) == 0;
    goto inline$BDLPnPQueryRemove$0$label_19#1;

  inline$BDLPnPQueryRemove$0$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$7$) != 0;
    goto inline$BDLPnPQueryRemove$0$label_22#1;

  inline$BDLPnPQueryRemove$0$label_22#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_23#1;

  inline$BDLPnPQueryRemove$0$label_23#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_24#1;

  inline$BDLPnPQueryRemove$0$label_24#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_25#1;

  inline$BDLPnPQueryRemove$0$label_25#1:
    havoc inline$BDLPnPQueryRemove$0$$result.DbgPrint$2263.0$8$;
    goto inline$BDLPnPQueryRemove$0$label_19#1;

  inline$BDLPnPQueryRemove$0$label_19#1:
    goto inline$BDLGetDebugLevel$111$Entry#1;

  inline$BDLGetDebugLevel$111$Entry#1:
    goto inline$BDLGetDebugLevel$111$start#1;

  inline$BDLGetDebugLevel$111$start#1:
    goto inline$BDLGetDebugLevel$111$label_3#1;

  inline$BDLGetDebugLevel$111$label_3#1:
    havoc inline$BDLGetDebugLevel$111$myNondetVar_0;
    inline$BDLGetDebugLevel$111$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$111$myNondetVar_0;
    goto inline$BDLGetDebugLevel$111$label_1#1;

  inline$BDLGetDebugLevel$111$label_1#1:
    goto inline$BDLGetDebugLevel$111$Return#1;

  inline$BDLGetDebugLevel$111$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$12$ := inline$BDLGetDebugLevel$111$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_19$1#1;

  inline$BDLPnPQueryRemove$0$label_19$1#1:
    goto inline$BDLPnPQueryRemove$0$anon24_Then#1, inline$BDLPnPQueryRemove$0$anon24_Else#1;

  inline$BDLPnPQueryRemove$0$anon24_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon5#1;

  inline$BDLPnPQueryRemove$0$anon5#1:
    goto inline$BDLPnPQueryRemove$0$label_28#1;

  inline$BDLPnPQueryRemove$0$label_28#1:
    goto inline$BDLPnPQueryRemove$0$label_28_true#1, inline$BDLPnPQueryRemove$0$label_28_false#1;

  inline$BDLPnPQueryRemove$0$label_28_false#1:
    assume BIT_BAND(inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$12$, 4) == 0;
    goto inline$BDLPnPQueryRemove$0$label_29#1;

  inline$BDLPnPQueryRemove$0$label_28_true#1:
    assume BIT_BAND(inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2263.0$12$, 4) != 0;
    goto inline$BDLPnPQueryRemove$0$label_32#1;

  inline$BDLPnPQueryRemove$0$label_32#1:
    goto inline$BDLPnPQueryRemove$0$label_29#1;

  inline$BDLPnPQueryRemove$0$label_29#1:
    call inline$BDLPnPQueryRemove$0$$result.IoSetDeviceInterfaceState$2272.29$13$ := IoSetDeviceInterfaceState(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPQueryRemove$0$$pBDLExtension$1$2256.40$BDLPnPQueryRemove$12), 0);
    goto inline$BDLPnPQueryRemove$0$anon25_Then#1, inline$BDLPnPQueryRemove$0$anon25_Else#1;

  inline$BDLPnPQueryRemove$0$anon25_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon7#1;

  inline$BDLPnPQueryRemove$0$anon7#1:
    goto inline$BDLPnPQueryRemove$0$label_33#1;

  inline$BDLPnPQueryRemove$0$label_33#1:
    goto inline$BDLPnPQueryRemove$0$label_33_true#1, inline$BDLPnPQueryRemove$0$label_33_false#1;

  inline$BDLPnPQueryRemove$0$label_33_false#1:
    havoc inline$BDLPnPQueryRemove$0$myNondetVar_0;
    assume inline$BDLPnPQueryRemove$0$myNondetVar_0 == 0;
    goto inline$BDLPnPQueryRemove$0$label_34#1;

  inline$BDLPnPQueryRemove$0$label_34#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$Entry#1;

  inline$BDLCallLowerLevelDriverAndWait$1$Entry#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1 := inline$BDLPnPQueryRemove$0$$pIrp$3$2258.40$BDLPnPQueryRemove$12;
    goto inline$BDLCallLowerLevelDriverAndWait$1$start#1;

  inline$BDLCallLowerLevelDriverAndWait$1$start#1:
    call inline$BDLCallLowerLevelDriverAndWait$1$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8 := __HAVOC_malloc(16);
    inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_3#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_4#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_4#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := 0;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_5#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_6#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_6#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$Entry#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$Entry#1:
    inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$start#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$start#1:
    inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4 := inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_4#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_4#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_5#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_5#1:
    goto inline$IoGetCurrentIrpStackLocation$23$Entry#1;

  inline$IoGetCurrentIrpStackLocation$23$Entry#1:
    inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetCurrentIrpStackLocation$23$start#1;

  inline$IoGetCurrentIrpStackLocation$23$start#1:
    inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$23$label_3#1;

  inline$IoGetCurrentIrpStackLocation$23$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$23$label_3_true#1, inline$IoGetCurrentIrpStackLocation$23$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$23$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$23$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$23$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$23$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$23$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$23$label_4#1;

  inline$IoGetCurrentIrpStackLocation$23$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$23$label_6#1;

  inline$IoGetCurrentIrpStackLocation$23$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$23$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$23$label_7#1;

  inline$IoGetCurrentIrpStackLocation$23$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$23$label_5#1;

  inline$IoGetCurrentIrpStackLocation$23$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$23$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$23$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$23$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$23$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$23$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$23$label_5#1;

  inline$IoGetCurrentIrpStackLocation$23$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$23$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$23$label_1#1;

  inline$IoGetCurrentIrpStackLocation$23$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$23$Return#1;

  inline$IoGetCurrentIrpStackLocation$23$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_5$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_5$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$anon4_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$1$anon4_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$anon4_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$anon1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$anon1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_8#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_8#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_9#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_9#1:
    goto inline$IoGetNextIrpStackLocation$3$Entry#1;

  inline$IoGetNextIrpStackLocation$3$Entry#1:
    inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$1$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetNextIrpStackLocation$3$start#1;

  inline$IoGetNextIrpStackLocation$3$start#1:
    inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$3$label_3#1;

  inline$IoGetNextIrpStackLocation$3$label_3#1:
    goto inline$IoGetNextIrpStackLocation$3$label_3_true#1, inline$IoGetNextIrpStackLocation$3$label_3_false#1;

  inline$IoGetNextIrpStackLocation$3$label_3_false#1:
    inline$IoGetNextIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$3$myVar_0);
    goto inline$IoGetNextIrpStackLocation$3$label_4#1;

  inline$IoGetNextIrpStackLocation$3$label_4#1:
    call inline$IoGetNextIrpStackLocation$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$3$label_6#1;

  inline$IoGetNextIrpStackLocation$3$label_6#1:
    call inline$IoGetNextIrpStackLocation$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$3$label_7#1;

  inline$IoGetNextIrpStackLocation$3$label_7#1:
    goto inline$IoGetNextIrpStackLocation$3$label_5#1;

  inline$IoGetNextIrpStackLocation$3$label_3_true#1:
    inline$IoGetNextIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$3$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$3$myVar_0);
    goto inline$IoGetNextIrpStackLocation$3$label_5#1;

  inline$IoGetNextIrpStackLocation$3$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$3$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$3$label_1#1;

  inline$IoGetNextIrpStackLocation$3$label_1#1:
    goto inline$IoGetNextIrpStackLocation$3$Return#1;

  inline$IoGetNextIrpStackLocation$3$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_9$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_9$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$anon5_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$1$anon5_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$anon5_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$anon3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$anon3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_12#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_12#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_13#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_13#1:
    havoc inline$IoCopyCurrentIrpStackLocationToNext$1$$result.memcpy$25110.4$3$;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_16#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_16#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$label_1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$label_1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$anon5_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$anon4_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$1$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$1$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_6$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_6$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon16_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon16_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_9#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_9#1:
    goto inline$storm_KeInitializeEvent$1$Entry#1;

  inline$storm_KeInitializeEvent$1$Entry#1:
    inline$storm_KeInitializeEvent$1$$Event$1$203.14$storm_KeInitializeEvent$12_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeInitializeEvent$1$$State$3$205.13$storm_KeInitializeEvent$12_.1 := 0;
    goto inline$storm_KeInitializeEvent$1$start#1;

  inline$storm_KeInitializeEvent$1$start#1:
    inline$storm_KeInitializeEvent$1$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$1$$Event$1$203.14$storm_KeInitializeEvent$12_.1;
    inline$storm_KeInitializeEvent$1$$State$3$205.13$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$1$$State$3$205.13$storm_KeInitializeEvent$12_.1;
    goto inline$storm_KeInitializeEvent$1$label_3#1;

  inline$storm_KeInitializeEvent$1$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeInitializeEvent$1$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$1$$State$3$205.13$storm_KeInitializeEvent$12];
    call contextSwitch();
    goto inline$storm_KeInitializeEvent$1$label_1#1;

  inline$storm_KeInitializeEvent$1$label_1#1:
    goto inline$storm_KeInitializeEvent$1$Return#1;

  inline$storm_KeInitializeEvent$1$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_9$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_9$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon17_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon17_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon3#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_12#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$1$Entry#1;

  inline$storm_IoSetCompletionRoutine$1$Entry#1:
    inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoSetCompletionRoutine$1$start#1;

  inline$storm_IoSetCompletionRoutine$1$start#1:
    inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24 := inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1;
    goto inline$storm_IoSetCompletionRoutine$1$label_3#1;

  inline$storm_IoSetCompletionRoutine$1$label_3#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_4#1;

  inline$storm_IoSetCompletionRoutine$1$label_4#1:
    call inline$storm_IoSetCompletionRoutine$1$$result.storm_nondet$405.2$1$ := storm_nondet();
    goto inline$storm_IoSetCompletionRoutine$1$label_7#1;

  inline$storm_IoSetCompletionRoutine$1$label_7#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_7_true#1, inline$storm_IoSetCompletionRoutine$1$label_7_false#1;

  inline$storm_IoSetCompletionRoutine$1$label_7_false#1:
    assume inline$storm_IoSetCompletionRoutine$1$$result.storm_nondet$405.2$1$ == 0;
    goto inline$storm_IoSetCompletionRoutine$1$label_8#1;

  inline$storm_IoSetCompletionRoutine$1$label_7_true#1:
    assume inline$storm_IoSetCompletionRoutine$1$$result.storm_nondet$405.2$1$ != 0;
    goto inline$storm_IoSetCompletionRoutine$1$label_11#1;

  inline$storm_IoSetCompletionRoutine$1$label_11#1:
    havoc raiseException;
    goto inline$storm_IoSetCompletionRoutine$1$anon6_Then#1, inline$storm_IoSetCompletionRoutine$1$anon6_Else#1;

  inline$storm_IoSetCompletionRoutine$1$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$1$anon3#1;

  inline$storm_IoSetCompletionRoutine$1$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24], 1);
    call contextSwitch();
    goto inline$storm_IoSetCompletionRoutine$1$label_12#1;

  inline$storm_IoSetCompletionRoutine$1$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_12_true#1, inline$storm_IoSetCompletionRoutine$1$label_12_false#1;

  inline$storm_IoSetCompletionRoutine$1$label_12_false#1:
    assume 0 == 0;
    goto inline$storm_IoSetCompletionRoutine$1$label_13#1;

  inline$storm_IoSetCompletionRoutine$1$label_13#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoSetCompletionRoutine$1$label_1#1;

  inline$storm_IoSetCompletionRoutine$1$label_12_true#1:
    assume 0 != 0;
    goto inline$storm_IoSetCompletionRoutine$1$label_8#1;

  inline$storm_IoSetCompletionRoutine$1$label_8#1:
    goto inline$IoGetNextIrpStackLocation$4$Entry#1;

  inline$IoGetNextIrpStackLocation$4$Entry#1:
    inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoSetCompletionRoutine$1$$pirp$1$396.10$storm_IoSetCompletionRoutine$24;
    goto inline$IoGetNextIrpStackLocation$4$start#1;

  inline$IoGetNextIrpStackLocation$4$start#1:
    inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$4$label_3#1;

  inline$IoGetNextIrpStackLocation$4$label_3#1:
    goto inline$IoGetNextIrpStackLocation$4$label_3_true#1, inline$IoGetNextIrpStackLocation$4$label_3_false#1;

  inline$IoGetNextIrpStackLocation$4$label_3_false#1:
    inline$IoGetNextIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$4$myVar_0);
    goto inline$IoGetNextIrpStackLocation$4$label_4#1;

  inline$IoGetNextIrpStackLocation$4$label_4#1:
    call inline$IoGetNextIrpStackLocation$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$4$label_6#1;

  inline$IoGetNextIrpStackLocation$4$label_6#1:
    call inline$IoGetNextIrpStackLocation$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$4$label_7#1;

  inline$IoGetNextIrpStackLocation$4$label_7#1:
    goto inline$IoGetNextIrpStackLocation$4$label_5#1;

  inline$IoGetNextIrpStackLocation$4$label_3_true#1:
    inline$IoGetNextIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$4$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$4$myVar_0);
    goto inline$IoGetNextIrpStackLocation$4$label_5#1;

  inline$IoGetNextIrpStackLocation$4$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$4$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$4$label_1#1;

  inline$IoGetNextIrpStackLocation$4$label_1#1:
    goto inline$IoGetNextIrpStackLocation$4$Return#1;

  inline$IoGetNextIrpStackLocation$4$Return#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_8$1#1;

  inline$storm_IoSetCompletionRoutine$1$label_8$1#1:
    goto inline$storm_IoSetCompletionRoutine$1$anon5_Then#1, inline$storm_IoSetCompletionRoutine$1$anon5_Else#1;

  inline$storm_IoSetCompletionRoutine$1$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$1$anon1#1;

  inline$storm_IoSetCompletionRoutine$1$anon1#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_16#1;

  inline$storm_IoSetCompletionRoutine$1$label_16#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_17#1;

  inline$storm_IoSetCompletionRoutine$1$label_17#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_18#1;

  inline$storm_IoSetCompletionRoutine$1$label_18#1:
    goto inline$storm_IoSetCompletionRoutine$1$label_1#1;

  inline$storm_IoSetCompletionRoutine$1$label_1#1:
    goto inline$storm_IoSetCompletionRoutine$1$Return#1;

  inline$storm_IoSetCompletionRoutine$1$anon5_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$1$Return#1;

  inline$storm_IoSetCompletionRoutine$1$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$1$Return#1;

  inline$storm_IoSetCompletionRoutine$1$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_12$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_12$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon18_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon18_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon5#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_15#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_15#1:
    goto inline$IoGetCurrentIrpStackLocation$24$Entry#1;

  inline$IoGetCurrentIrpStackLocation$24$Entry#1:
    inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoGetCurrentIrpStackLocation$24$start#1;

  inline$IoGetCurrentIrpStackLocation$24$start#1:
    inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$24$label_3#1;

  inline$IoGetCurrentIrpStackLocation$24$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$24$label_3_true#1, inline$IoGetCurrentIrpStackLocation$24$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$24$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$24$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$24$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$24$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$24$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$24$label_4#1;

  inline$IoGetCurrentIrpStackLocation$24$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$24$label_6#1;

  inline$IoGetCurrentIrpStackLocation$24$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$24$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$24$label_7#1;

  inline$IoGetCurrentIrpStackLocation$24$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$24$label_5#1;

  inline$IoGetCurrentIrpStackLocation$24$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$24$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$24$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$24$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$24$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$24$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$24$label_5#1;

  inline$IoGetCurrentIrpStackLocation$24$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$24$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$24$label_1#1;

  inline$IoGetCurrentIrpStackLocation$24$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$24$Return#1;

  inline$IoGetCurrentIrpStackLocation$24$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_15$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_15$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon19_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon19_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon7#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon7#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_18#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_18#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_18_true#1, inline$BDLCallLowerLevelDriverAndWait$1$label_18_false#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_18_false#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_19#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_19#1:
    goto inline$storm_IoCallDriver$2$Entry#1;

  inline$storm_IoCallDriver$2$Entry#1:
    inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoCallDriver$2$start#1;

  inline$storm_IoCallDriver$2$start#1:
    inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$2$label_3#1;

  inline$storm_IoCallDriver$2$label_3#1:
    goto inline$storm_IoCallDriver$2$label_4#1;

  inline$storm_IoCallDriver$2$label_4#1:
    goto inline$storm_IoCallDriver$2$label_5#1;

  inline$storm_IoCallDriver$2$label_5#1:
    goto inline$storm_IoCallDriver$2$label_6#1;

  inline$storm_IoCallDriver$2$label_6#1:
    call inline$storm_IoCallDriver$2$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$2$label_9#1;

  inline$storm_IoCallDriver$2$label_9#1:
    goto inline$storm_IoCallDriver$2$label_9_true#1, inline$storm_IoCallDriver$2$label_9_false#1;

  inline$storm_IoCallDriver$2$label_9_false#1:
    assume inline$storm_IoCallDriver$2$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$2$label_10#1;

  inline$storm_IoCallDriver$2$label_9_true#1:
    assume inline$storm_IoCallDriver$2$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$2$label_13#1;

  inline$storm_IoCallDriver$2$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$2$anon12_Then#1, inline$storm_IoCallDriver$2$anon12_Else#1;

  inline$storm_IoCallDriver$2$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$2$anon3#1;

  inline$storm_IoCallDriver$2$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$2$label_14#1;

  inline$storm_IoCallDriver$2$label_14#1:
    goto inline$storm_IoCallDriver$2$label_14_true#1, inline$storm_IoCallDriver$2$label_14_false#1;

  inline$storm_IoCallDriver$2$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$2$label_15#1;

  inline$storm_IoCallDriver$2$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$2$label_1#1;

  inline$storm_IoCallDriver$2$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$2$label_10#1;

  inline$storm_IoCallDriver$2$label_10#1:
    goto inline$IoSetNextIrpStackLocation$3$Entry#1;

  inline$IoSetNextIrpStackLocation$3$Entry#1:
    inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$3$start#1;

  inline$IoSetNextIrpStackLocation$3$start#1:
    inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$3$label_3#1;

  inline$IoSetNextIrpStackLocation$3$label_3#1:
    goto inline$IoSetNextIrpStackLocation$3$label_3_true#1, inline$IoSetNextIrpStackLocation$3$label_3_false#1;

  inline$IoSetNextIrpStackLocation$3$label_3_false#1:
    inline$IoSetNextIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$3$myVar_0);
    goto inline$IoSetNextIrpStackLocation$3$label_4#1;

  inline$IoSetNextIrpStackLocation$3$label_4#1:
    call inline$IoSetNextIrpStackLocation$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$3$label_7#1;

  inline$IoSetNextIrpStackLocation$3$label_7#1:
    call inline$IoSetNextIrpStackLocation$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$3$label_8#1;

  inline$IoSetNextIrpStackLocation$3$label_8#1:
    goto inline$IoSetNextIrpStackLocation$3$label_5#1;

  inline$IoSetNextIrpStackLocation$3$label_3_true#1:
    inline$IoSetNextIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$3$myVar_0);
    goto inline$IoSetNextIrpStackLocation$3$label_5#1;

  inline$IoSetNextIrpStackLocation$3$label_5#1:
    inline$IoSetNextIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$3$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$3$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$3$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$3$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$3$label_6#1;

  inline$IoSetNextIrpStackLocation$3$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$3$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$3$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$3$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$3$label_1#1;

  inline$IoSetNextIrpStackLocation$3$label_1#1:
    goto inline$IoSetNextIrpStackLocation$3$Return#1;

  inline$IoSetNextIrpStackLocation$3$Return#1:
    goto inline$storm_IoCallDriver$2$label_10$1#1;

  inline$storm_IoCallDriver$2$label_10$1#1:
    goto inline$storm_IoCallDriver$2$anon11_Then#1, inline$storm_IoCallDriver$2$anon11_Else#1;

  inline$storm_IoCallDriver$2$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$2$anon1#1;

  inline$storm_IoCallDriver$2$anon1#1:
    goto inline$storm_IoCallDriver$2$label_18#1;

  inline$storm_IoCallDriver$2$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$25$Entry#1;

  inline$IoGetCurrentIrpStackLocation$25$Entry#1:
    inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$25$start#1;

  inline$IoGetCurrentIrpStackLocation$25$start#1:
    inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$25$label_3#1;

  inline$IoGetCurrentIrpStackLocation$25$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$25$label_3_true#1, inline$IoGetCurrentIrpStackLocation$25$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$25$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$25$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$25$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$25$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$25$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$25$label_4#1;

  inline$IoGetCurrentIrpStackLocation$25$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$25$label_6#1;

  inline$IoGetCurrentIrpStackLocation$25$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$25$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$25$label_7#1;

  inline$IoGetCurrentIrpStackLocation$25$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$25$label_5#1;

  inline$IoGetCurrentIrpStackLocation$25$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$25$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$25$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$25$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$25$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$25$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$25$label_5#1;

  inline$IoGetCurrentIrpStackLocation$25$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$25$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$25$label_1#1;

  inline$IoGetCurrentIrpStackLocation$25$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$25$Return#1;

  inline$IoGetCurrentIrpStackLocation$25$Return#1:
    goto inline$storm_IoCallDriver$2$label_18$1#1;

  inline$storm_IoCallDriver$2$label_18$1#1:
    goto inline$storm_IoCallDriver$2$anon13_Then#1, inline$storm_IoCallDriver$2$anon13_Else#1;

  inline$storm_IoCallDriver$2$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$2$anon6#1;

  inline$storm_IoCallDriver$2$anon6#1:
    goto inline$storm_IoCallDriver$2$label_21#1;

  inline$storm_IoCallDriver$2$label_21#1:
    goto inline$storm_IoCallDriver$2$label_22#1;

  inline$storm_IoCallDriver$2$label_22#1:
    goto inline$storm_IoCallDriver$2$label_23#1;

  inline$storm_IoCallDriver$2$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$2$label_24#1;

  inline$storm_IoCallDriver$2$label_24#1:
    call inline$storm_IoCallDriver$2$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$2$label_27#1;

  inline$storm_IoCallDriver$2$label_27#1:
    goto inline$storm_IoCallDriver$2$label_27_case_0#1, inline$storm_IoCallDriver$2$label_27_case_1#1, inline$storm_IoCallDriver$2$label_27_case_2#1;

  inline$storm_IoCallDriver$2$label_27_case_2#1:
    assume inline$storm_IoCallDriver$2$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$2$label_30#1;

  inline$storm_IoCallDriver$2$label_30#1:
    inline$storm_IoCallDriver$2$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$2$label_31#1;

  inline$storm_IoCallDriver$2$label_31#1:
    goto inline$storm_IoCallDriver$2$label_32#1;

  inline$storm_IoCallDriver$2$label_32#1:
    goto inline$storm_IoCallDriver$2$label_33#1;

  inline$storm_IoCallDriver$2$label_33#1:
    goto inline$CallCompletionRoutine$4$Entry#1;

  inline$CallCompletionRoutine$4$Entry#1:
    inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$4$start#1;

  inline$CallCompletionRoutine$4$start#1:
    inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$4$label_3#1;

  inline$CallCompletionRoutine$4$label_3#1:
    goto inline$CallCompletionRoutine$4$label_4#1;

  inline$CallCompletionRoutine$4$label_4#1:
    goto inline$CallCompletionRoutine$4$label_5#1;

  inline$CallCompletionRoutine$4$label_5#1:
    goto inline$CallCompletionRoutine$4$label_6#1;

  inline$CallCompletionRoutine$4$label_6#1:
    goto inline$CallCompletionRoutine$4$label_7#1;

  inline$CallCompletionRoutine$4$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$26$Entry#1;

  inline$IoGetCurrentIrpStackLocation$26$Entry#1:
    inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$26$start#1;

  inline$IoGetCurrentIrpStackLocation$26$start#1:
    inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$26$label_3#1;

  inline$IoGetCurrentIrpStackLocation$26$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$26$label_3_true#1, inline$IoGetCurrentIrpStackLocation$26$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$26$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$26$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$26$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$26$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$26$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$26$label_4#1;

  inline$IoGetCurrentIrpStackLocation$26$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$26$label_6#1;

  inline$IoGetCurrentIrpStackLocation$26$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$26$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$26$label_7#1;

  inline$IoGetCurrentIrpStackLocation$26$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$26$label_5#1;

  inline$IoGetCurrentIrpStackLocation$26$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$26$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$26$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$26$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$26$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$26$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$26$label_5#1;

  inline$IoGetCurrentIrpStackLocation$26$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$26$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$26$label_1#1;

  inline$IoGetCurrentIrpStackLocation$26$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$26$Return#1;

  inline$IoGetCurrentIrpStackLocation$26$Return#1:
    goto inline$CallCompletionRoutine$4$label_7$1#1;

  inline$CallCompletionRoutine$4$label_7$1#1:
    goto inline$CallCompletionRoutine$4$anon10_Then#1, inline$CallCompletionRoutine$4$anon10_Else#1;

  inline$CallCompletionRoutine$4$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$4$anon1#1;

  inline$CallCompletionRoutine$4$anon1#1:
    goto inline$CallCompletionRoutine$4$label_10#1;

  inline$CallCompletionRoutine$4$label_10#1:
    goto inline$CallCompletionRoutine$4$label_11#1;

  inline$CallCompletionRoutine$4$label_11#1:
    havoc inline$CallCompletionRoutine$4$myNondetVar_0;
    inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$4$myNondetVar_0;
    goto inline$CallCompletionRoutine$4$label_12#1;

  inline$CallCompletionRoutine$4$label_12#1:
    havoc inline$CallCompletionRoutine$4$myNondetVar_0;
    inline$CallCompletionRoutine$4$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$4$myNondetVar_0;
    goto inline$CallCompletionRoutine$4$label_13#1;

  inline$CallCompletionRoutine$4$label_13#1:
    havoc inline$CallCompletionRoutine$4$myNondetVar_0;
    goto inline$CallCompletionRoutine$4$label_14#1;

  inline$CallCompletionRoutine$4$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$27$Entry#1;

  inline$IoGetCurrentIrpStackLocation$27$Entry#1:
    inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$27$start#1;

  inline$IoGetCurrentIrpStackLocation$27$start#1:
    inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$27$label_3#1;

  inline$IoGetCurrentIrpStackLocation$27$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$27$label_3_true#1, inline$IoGetCurrentIrpStackLocation$27$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$27$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$27$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$27$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$27$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$27$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$27$label_4#1;

  inline$IoGetCurrentIrpStackLocation$27$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$27$label_6#1;

  inline$IoGetCurrentIrpStackLocation$27$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$27$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$27$label_7#1;

  inline$IoGetCurrentIrpStackLocation$27$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$27$label_5#1;

  inline$IoGetCurrentIrpStackLocation$27$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$27$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$27$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$27$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$27$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$27$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$27$label_5#1;

  inline$IoGetCurrentIrpStackLocation$27$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$27$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$27$label_1#1;

  inline$IoGetCurrentIrpStackLocation$27$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$27$Return#1;

  inline$IoGetCurrentIrpStackLocation$27$Return#1:
    goto inline$CallCompletionRoutine$4$label_14$1#1;

  inline$CallCompletionRoutine$4$label_14$1#1:
    goto inline$CallCompletionRoutine$4$anon11_Then#1, inline$CallCompletionRoutine$4$anon11_Else#1;

  inline$CallCompletionRoutine$4$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$4$anon3#1;

  inline$CallCompletionRoutine$4$anon3#1:
    goto inline$CallCompletionRoutine$4$label_17#1;

  inline$CallCompletionRoutine$4$label_17#1:
    goto inline$CallCompletionRoutine$4$label_18#1;

  inline$CallCompletionRoutine$4$label_18#1:
    goto inline$CallCompletionRoutine$4$label_18_true#1, inline$CallCompletionRoutine$4$label_18_false#1;

  inline$CallCompletionRoutine$4$label_18_false#1:
    assume inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$4$label_1#1;

  inline$CallCompletionRoutine$4$label_18_true#1:
    assume inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$4$label_19#1;

  inline$CallCompletionRoutine$4$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$4$label_20#1;

  inline$CallCompletionRoutine$4$label_20#1:
    goto inline$CallCompletionRoutine$4$label_20_icall_1#1, inline$CallCompletionRoutine$4$label_20_icall_2#1, inline$CallCompletionRoutine$4$label_20_icall_3#1;

  inline$CallCompletionRoutine$4$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$4$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$4$Entry#1;

  inline$BDLSystemPowerIoCompletion$4$Entry#1:
    inline$BDLSystemPowerIoCompletion$4$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$4$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$4$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$4$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$4$start#1;

  inline$BDLSystemPowerIoCompletion$4$start#1:
    call inline$BDLSystemPowerIoCompletion$4$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$4$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$4$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$4$label_3#1;

  inline$BDLSystemPowerIoCompletion$4$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_4#1;

  inline$BDLSystemPowerIoCompletion$4$label_4#1:
    inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_5#1;

  inline$BDLSystemPowerIoCompletion$4$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_6#1;

  inline$BDLSystemPowerIoCompletion$4$label_6#1:
    inline$BDLSystemPowerIoCompletion$4$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$4$label_7#1;

  inline$BDLSystemPowerIoCompletion$4$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_8#1;

  inline$BDLSystemPowerIoCompletion$4$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$4$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$4$label_9#1;

  inline$BDLSystemPowerIoCompletion$4$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_10#1;

  inline$BDLSystemPowerIoCompletion$4$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$29$Entry#1;

  inline$IoGetCurrentIrpStackLocation$29$Entry#1:
    inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$29$start#1;

  inline$IoGetCurrentIrpStackLocation$29$start#1:
    inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$29$label_3#1;

  inline$IoGetCurrentIrpStackLocation$29$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$29$label_3_true#1, inline$IoGetCurrentIrpStackLocation$29$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$29$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$29$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$29$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$29$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$29$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$29$label_4#1;

  inline$IoGetCurrentIrpStackLocation$29$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$29$label_6#1;

  inline$IoGetCurrentIrpStackLocation$29$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$29$label_7#1;

  inline$IoGetCurrentIrpStackLocation$29$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$29$label_5#1;

  inline$IoGetCurrentIrpStackLocation$29$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$29$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$29$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$29$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$29$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$29$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$29$label_5#1;

  inline$IoGetCurrentIrpStackLocation$29$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$29$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$29$label_1#1;

  inline$IoGetCurrentIrpStackLocation$29$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$29$Return#1;

  inline$IoGetCurrentIrpStackLocation$29$Return#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon36_Then#1, inline$BDLSystemPowerIoCompletion$4$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon1#1;

  inline$BDLSystemPowerIoCompletion$4$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_13#1;

  inline$BDLSystemPowerIoCompletion$4$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_14#1;

  inline$BDLSystemPowerIoCompletion$4$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_15#1;

  inline$BDLSystemPowerIoCompletion$4$label_15#1:
    goto inline$BDLGetDebugLevel$121$Entry#1;

  inline$BDLGetDebugLevel$121$Entry#1:
    goto inline$BDLGetDebugLevel$121$start#1;

  inline$BDLGetDebugLevel$121$start#1:
    goto inline$BDLGetDebugLevel$121$label_3#1;

  inline$BDLGetDebugLevel$121$label_3#1:
    havoc inline$BDLGetDebugLevel$121$myNondetVar_0;
    inline$BDLGetDebugLevel$121$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$121$myNondetVar_0;
    goto inline$BDLGetDebugLevel$121$label_1#1;

  inline$BDLGetDebugLevel$121$label_1#1:
    goto inline$BDLGetDebugLevel$121$Return#1;

  inline$BDLGetDebugLevel$121$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$121$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon37_Then#1, inline$BDLSystemPowerIoCompletion$4$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon3#1;

  inline$BDLSystemPowerIoCompletion$4$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_18#1;

  inline$BDLSystemPowerIoCompletion$4$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_18_true#1, inline$BDLSystemPowerIoCompletion$4$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_19#1;

  inline$BDLSystemPowerIoCompletion$4$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_22#1;

  inline$BDLSystemPowerIoCompletion$4$label_22#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_23#1;

  inline$BDLSystemPowerIoCompletion$4$label_23#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_24#1;

  inline$BDLSystemPowerIoCompletion$4$label_24#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_25#1;

  inline$BDLSystemPowerIoCompletion$4$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$4$label_19#1;

  inline$BDLSystemPowerIoCompletion$4$label_19#1:
    goto inline$BDLGetDebugLevel$122$Entry#1;

  inline$BDLGetDebugLevel$122$Entry#1:
    goto inline$BDLGetDebugLevel$122$start#1;

  inline$BDLGetDebugLevel$122$start#1:
    goto inline$BDLGetDebugLevel$122$label_3#1;

  inline$BDLGetDebugLevel$122$label_3#1:
    havoc inline$BDLGetDebugLevel$122$myNondetVar_0;
    inline$BDLGetDebugLevel$122$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$122$myNondetVar_0;
    goto inline$BDLGetDebugLevel$122$label_1#1;

  inline$BDLGetDebugLevel$122$label_1#1:
    goto inline$BDLGetDebugLevel$122$Return#1;

  inline$BDLGetDebugLevel$122$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$122$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon38_Then#1, inline$BDLSystemPowerIoCompletion$4$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon5#1;

  inline$BDLSystemPowerIoCompletion$4$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_28#1;

  inline$BDLSystemPowerIoCompletion$4$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_28_true#1, inline$BDLSystemPowerIoCompletion$4$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_29#1;

  inline$BDLSystemPowerIoCompletion$4$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_32#1;

  inline$BDLSystemPowerIoCompletion$4$label_32#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_33#1;

  inline$BDLSystemPowerIoCompletion$4$label_33#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_34#1;

  inline$BDLSystemPowerIoCompletion$4$label_34#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_35#1;

  inline$BDLSystemPowerIoCompletion$4$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$4$label_29#1;

  inline$BDLSystemPowerIoCompletion$4$label_29#1:
    goto inline$BDLGetDebugLevel$123$Entry#1;

  inline$BDLGetDebugLevel$123$Entry#1:
    goto inline$BDLGetDebugLevel$123$start#1;

  inline$BDLGetDebugLevel$123$start#1:
    goto inline$BDLGetDebugLevel$123$label_3#1;

  inline$BDLGetDebugLevel$123$label_3#1:
    havoc inline$BDLGetDebugLevel$123$myNondetVar_0;
    inline$BDLGetDebugLevel$123$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$123$myNondetVar_0;
    goto inline$BDLGetDebugLevel$123$label_1#1;

  inline$BDLGetDebugLevel$123$label_1#1:
    goto inline$BDLGetDebugLevel$123$Return#1;

  inline$BDLGetDebugLevel$123$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$123$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon39_Then#1, inline$BDLSystemPowerIoCompletion$4$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon7#1;

  inline$BDLSystemPowerIoCompletion$4$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_38#1;

  inline$BDLSystemPowerIoCompletion$4$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_38_true#1, inline$BDLSystemPowerIoCompletion$4$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_39#1;

  inline$BDLSystemPowerIoCompletion$4$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_40#1;

  inline$BDLSystemPowerIoCompletion$4$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_39#1;

  inline$BDLSystemPowerIoCompletion$4$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_39_true#1, inline$BDLSystemPowerIoCompletion$4$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_41#1;

  inline$BDLSystemPowerIoCompletion$4$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$4$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$4$label_107#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$4$label_108#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$4$label_108#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$4$label_108#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$4$label_108#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$4$label_108#1;

  inline$BDLSystemPowerIoCompletion$4$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_109#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$4$label_107#1;

  inline$BDLSystemPowerIoCompletion$4$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_109#1;

  inline$BDLSystemPowerIoCompletion$4$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$4$label_106#1;

  inline$BDLSystemPowerIoCompletion$4$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_106_true#1, inline$BDLSystemPowerIoCompletion$4$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_142#1;

  inline$BDLSystemPowerIoCompletion$4$label_142#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_143#1;

  inline$BDLSystemPowerIoCompletion$4$label_143#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_144#1;

  inline$BDLSystemPowerIoCompletion$4$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_109#1;

  inline$BDLSystemPowerIoCompletion$4$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_109#1;

  inline$BDLSystemPowerIoCompletion$4$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$4$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$4$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$4$myNondetVar_0, inline$BDLSystemPowerIoCompletion$4$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$4$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$4$anon50_Then#1, inline$BDLSystemPowerIoCompletion$4$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon29#1;

  inline$BDLSystemPowerIoCompletion$4$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_112#1;

  inline$BDLSystemPowerIoCompletion$4$label_112#1:
    inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$4$label_113#1;

  inline$BDLSystemPowerIoCompletion$4$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_113_true#1, inline$BDLSystemPowerIoCompletion$4$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$4$label_114#1;

  inline$BDLSystemPowerIoCompletion$4$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_116#1;

  inline$BDLSystemPowerIoCompletion$4$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_117#1;

  inline$BDLSystemPowerIoCompletion$4$label_117#1:
    goto inline$BDLGetDebugLevel$130$Entry#1;

  inline$BDLGetDebugLevel$130$Entry#1:
    goto inline$BDLGetDebugLevel$130$start#1;

  inline$BDLGetDebugLevel$130$start#1:
    goto inline$BDLGetDebugLevel$130$label_3#1;

  inline$BDLGetDebugLevel$130$label_3#1:
    havoc inline$BDLGetDebugLevel$130$myNondetVar_0;
    inline$BDLGetDebugLevel$130$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$130$myNondetVar_0;
    goto inline$BDLGetDebugLevel$130$label_1#1;

  inline$BDLGetDebugLevel$130$label_1#1:
    goto inline$BDLGetDebugLevel$130$Return#1;

  inline$BDLGetDebugLevel$130$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$130$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon51_Then#1, inline$BDLSystemPowerIoCompletion$4$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon31#1;

  inline$BDLSystemPowerIoCompletion$4$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_120#1;

  inline$BDLSystemPowerIoCompletion$4$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_120_true#1, inline$BDLSystemPowerIoCompletion$4$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_121#1;

  inline$BDLSystemPowerIoCompletion$4$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_124#1;

  inline$BDLSystemPowerIoCompletion$4$label_124#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_125#1;

  inline$BDLSystemPowerIoCompletion$4$label_125#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_126#1;

  inline$BDLSystemPowerIoCompletion$4$label_126#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_127#1;

  inline$BDLSystemPowerIoCompletion$4$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$4$label_121#1;

  inline$BDLSystemPowerIoCompletion$4$label_121#1:
    goto inline$BDLGetDebugLevel$131$Entry#1;

  inline$BDLGetDebugLevel$131$Entry#1:
    goto inline$BDLGetDebugLevel$131$start#1;

  inline$BDLGetDebugLevel$131$start#1:
    goto inline$BDLGetDebugLevel$131$label_3#1;

  inline$BDLGetDebugLevel$131$label_3#1:
    havoc inline$BDLGetDebugLevel$131$myNondetVar_0;
    inline$BDLGetDebugLevel$131$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$131$myNondetVar_0;
    goto inline$BDLGetDebugLevel$131$label_1#1;

  inline$BDLGetDebugLevel$131$label_1#1:
    goto inline$BDLGetDebugLevel$131$Return#1;

  inline$BDLGetDebugLevel$131$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$131$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon52_Then#1, inline$BDLSystemPowerIoCompletion$4$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon33#1;

  inline$BDLSystemPowerIoCompletion$4$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_130#1;

  inline$BDLSystemPowerIoCompletion$4$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_130_true#1, inline$BDLSystemPowerIoCompletion$4$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_131#1;

  inline$BDLSystemPowerIoCompletion$4$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_134#1;

  inline$BDLSystemPowerIoCompletion$4$label_134#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_135#1;

  inline$BDLSystemPowerIoCompletion$4$label_135#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_136#1;

  inline$BDLSystemPowerIoCompletion$4$label_136#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_137#1;

  inline$BDLSystemPowerIoCompletion$4$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$4$label_131#1;

  inline$BDLSystemPowerIoCompletion$4$label_131#1:
    goto inline$BDLGetDebugLevel$132$Entry#1;

  inline$BDLGetDebugLevel$132$Entry#1:
    goto inline$BDLGetDebugLevel$132$start#1;

  inline$BDLGetDebugLevel$132$start#1:
    goto inline$BDLGetDebugLevel$132$label_3#1;

  inline$BDLGetDebugLevel$132$label_3#1:
    havoc inline$BDLGetDebugLevel$132$myNondetVar_0;
    inline$BDLGetDebugLevel$132$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$132$myNondetVar_0;
    goto inline$BDLGetDebugLevel$132$label_1#1;

  inline$BDLGetDebugLevel$132$label_1#1:
    goto inline$BDLGetDebugLevel$132$Return#1;

  inline$BDLGetDebugLevel$132$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$132$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon53_Then#1, inline$BDLSystemPowerIoCompletion$4$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon35#1;

  inline$BDLSystemPowerIoCompletion$4$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_140#1;

  inline$BDLSystemPowerIoCompletion$4$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_140_true#1, inline$BDLSystemPowerIoCompletion$4$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_67#1;

  inline$BDLSystemPowerIoCompletion$4$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_141#1;

  inline$BDLSystemPowerIoCompletion$4$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_67#1;

  inline$BDLSystemPowerIoCompletion$4$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$4$label_115#1;

  inline$BDLSystemPowerIoCompletion$4$label_115#1:
    inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$4$label_80#1;

  inline$BDLSystemPowerIoCompletion$4$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$4$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_42#1;

  inline$BDLSystemPowerIoCompletion$4$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$4$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$4$label_43#1;

  inline$BDLSystemPowerIoCompletion$4$label_43#1:
    goto inline$BDLGetDebugLevel$124$Entry#1;

  inline$BDLGetDebugLevel$124$Entry#1:
    goto inline$BDLGetDebugLevel$124$start#1;

  inline$BDLGetDebugLevel$124$start#1:
    goto inline$BDLGetDebugLevel$124$label_3#1;

  inline$BDLGetDebugLevel$124$label_3#1:
    havoc inline$BDLGetDebugLevel$124$myNondetVar_0;
    inline$BDLGetDebugLevel$124$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$124$myNondetVar_0;
    goto inline$BDLGetDebugLevel$124$label_1#1;

  inline$BDLGetDebugLevel$124$label_1#1:
    goto inline$BDLGetDebugLevel$124$Return#1;

  inline$BDLGetDebugLevel$124$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$124$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon40_Then#1, inline$BDLSystemPowerIoCompletion$4$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon9#1;

  inline$BDLSystemPowerIoCompletion$4$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_46#1;

  inline$BDLSystemPowerIoCompletion$4$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_46_true#1, inline$BDLSystemPowerIoCompletion$4$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_47#1;

  inline$BDLSystemPowerIoCompletion$4$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_50#1;

  inline$BDLSystemPowerIoCompletion$4$label_50#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_51#1;

  inline$BDLSystemPowerIoCompletion$4$label_51#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_52#1;

  inline$BDLSystemPowerIoCompletion$4$label_52#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_53#1;

  inline$BDLSystemPowerIoCompletion$4$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$4$label_47#1;

  inline$BDLSystemPowerIoCompletion$4$label_47#1:
    goto inline$BDLGetDebugLevel$125$Entry#1;

  inline$BDLGetDebugLevel$125$Entry#1:
    goto inline$BDLGetDebugLevel$125$start#1;

  inline$BDLGetDebugLevel$125$start#1:
    goto inline$BDLGetDebugLevel$125$label_3#1;

  inline$BDLGetDebugLevel$125$label_3#1:
    havoc inline$BDLGetDebugLevel$125$myNondetVar_0;
    inline$BDLGetDebugLevel$125$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$125$myNondetVar_0;
    goto inline$BDLGetDebugLevel$125$label_1#1;

  inline$BDLGetDebugLevel$125$label_1#1:
    goto inline$BDLGetDebugLevel$125$Return#1;

  inline$BDLGetDebugLevel$125$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$125$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon41_Then#1, inline$BDLSystemPowerIoCompletion$4$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon11#1;

  inline$BDLSystemPowerIoCompletion$4$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_56#1;

  inline$BDLSystemPowerIoCompletion$4$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_56_true#1, inline$BDLSystemPowerIoCompletion$4$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_57#1;

  inline$BDLSystemPowerIoCompletion$4$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_60#1;

  inline$BDLSystemPowerIoCompletion$4$label_60#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_61#1;

  inline$BDLSystemPowerIoCompletion$4$label_61#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_62#1;

  inline$BDLSystemPowerIoCompletion$4$label_62#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_63#1;

  inline$BDLSystemPowerIoCompletion$4$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$4$label_57#1;

  inline$BDLSystemPowerIoCompletion$4$label_57#1:
    goto inline$BDLGetDebugLevel$126$Entry#1;

  inline$BDLGetDebugLevel$126$Entry#1:
    goto inline$BDLGetDebugLevel$126$start#1;

  inline$BDLGetDebugLevel$126$start#1:
    goto inline$BDLGetDebugLevel$126$label_3#1;

  inline$BDLGetDebugLevel$126$label_3#1:
    havoc inline$BDLGetDebugLevel$126$myNondetVar_0;
    inline$BDLGetDebugLevel$126$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$126$myNondetVar_0;
    goto inline$BDLGetDebugLevel$126$label_1#1;

  inline$BDLGetDebugLevel$126$label_1#1:
    goto inline$BDLGetDebugLevel$126$Return#1;

  inline$BDLGetDebugLevel$126$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$126$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon42_Then#1, inline$BDLSystemPowerIoCompletion$4$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon13#1;

  inline$BDLSystemPowerIoCompletion$4$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_66#1;

  inline$BDLSystemPowerIoCompletion$4$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_66_true#1, inline$BDLSystemPowerIoCompletion$4$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_67#1;

  inline$BDLSystemPowerIoCompletion$4$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_70#1;

  inline$BDLSystemPowerIoCompletion$4$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_67#1;

  inline$BDLSystemPowerIoCompletion$4$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$4$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$4$anon43_Then#1, inline$BDLSystemPowerIoCompletion$4$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon15#1;

  inline$BDLSystemPowerIoCompletion$4$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_71#1;

  inline$BDLSystemPowerIoCompletion$4$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$4$anon44_Then#1, inline$BDLSystemPowerIoCompletion$4$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon17#1;

  inline$BDLSystemPowerIoCompletion$4$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_74#1;

  inline$BDLSystemPowerIoCompletion$4$label_74#1:
    goto inline$storm_IoCompleteRequest$10$Entry#1;

  inline$storm_IoCompleteRequest$10$Entry#1:
    inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$4$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$10$start#1;

  inline$storm_IoCompleteRequest$10$start#1:
    inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$10$label_3#1;

  inline$storm_IoCompleteRequest$10$label_3#1:
    call inline$storm_IoCompleteRequest$10$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$10$label_6#1;

  inline$storm_IoCompleteRequest$10$label_6#1:
    goto inline$storm_IoCompleteRequest$10$label_6_true#1, inline$storm_IoCompleteRequest$10$label_6_false#1;

  inline$storm_IoCompleteRequest$10$label_6_false#1:
    assume inline$storm_IoCompleteRequest$10$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$10$label_7#1;

  inline$storm_IoCompleteRequest$10$label_6_true#1:
    assume inline$storm_IoCompleteRequest$10$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$10$label_8#1;

  inline$storm_IoCompleteRequest$10$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$10$anon3_Then#1, inline$storm_IoCompleteRequest$10$anon3_Else#1;

  inline$storm_IoCompleteRequest$10$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$10$anon1#1;

  inline$storm_IoCompleteRequest$10$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$10$label_9#1;

  inline$storm_IoCompleteRequest$10$label_9#1:
    goto inline$storm_IoCompleteRequest$10$label_9_true#1, inline$storm_IoCompleteRequest$10$label_9_false#1;

  inline$storm_IoCompleteRequest$10$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$10$label_10#1;

  inline$storm_IoCompleteRequest$10$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$10$label_1#1;

  inline$storm_IoCompleteRequest$10$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$10$label_7#1;

  inline$storm_IoCompleteRequest$10$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$10$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$10$label_1#1;

  inline$storm_IoCompleteRequest$10$label_1#1:
    goto inline$storm_IoCompleteRequest$10$Return#1;

  inline$storm_IoCompleteRequest$10$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$10$Return#1;

  inline$storm_IoCompleteRequest$10$Return#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon45_Then#1, inline$BDLSystemPowerIoCompletion$4$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon19#1;

  inline$BDLSystemPowerIoCompletion$4$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_77#1;

  inline$BDLSystemPowerIoCompletion$4$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$4$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$4$anon46_Then#1, inline$BDLSystemPowerIoCompletion$4$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon21#1;

  inline$BDLSystemPowerIoCompletion$4$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_80#1;

  inline$BDLSystemPowerIoCompletion$4$label_80#1:
    goto inline$BDLGetDebugLevel$127$Entry#1;

  inline$BDLGetDebugLevel$127$Entry#1:
    goto inline$BDLGetDebugLevel$127$start#1;

  inline$BDLGetDebugLevel$127$start#1:
    goto inline$BDLGetDebugLevel$127$label_3#1;

  inline$BDLGetDebugLevel$127$label_3#1:
    havoc inline$BDLGetDebugLevel$127$myNondetVar_0;
    inline$BDLGetDebugLevel$127$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$127$myNondetVar_0;
    goto inline$BDLGetDebugLevel$127$label_1#1;

  inline$BDLGetDebugLevel$127$label_1#1:
    goto inline$BDLGetDebugLevel$127$Return#1;

  inline$BDLGetDebugLevel$127$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$127$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon47_Then#1, inline$BDLSystemPowerIoCompletion$4$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon23#1;

  inline$BDLSystemPowerIoCompletion$4$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_83#1;

  inline$BDLSystemPowerIoCompletion$4$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_83_true#1, inline$BDLSystemPowerIoCompletion$4$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_84#1;

  inline$BDLSystemPowerIoCompletion$4$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_87#1;

  inline$BDLSystemPowerIoCompletion$4$label_87#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_88#1;

  inline$BDLSystemPowerIoCompletion$4$label_88#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_89#1;

  inline$BDLSystemPowerIoCompletion$4$label_89#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_90#1;

  inline$BDLSystemPowerIoCompletion$4$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$4$label_84#1;

  inline$BDLSystemPowerIoCompletion$4$label_84#1:
    goto inline$BDLGetDebugLevel$128$Entry#1;

  inline$BDLGetDebugLevel$128$Entry#1:
    goto inline$BDLGetDebugLevel$128$start#1;

  inline$BDLGetDebugLevel$128$start#1:
    goto inline$BDLGetDebugLevel$128$label_3#1;

  inline$BDLGetDebugLevel$128$label_3#1:
    havoc inline$BDLGetDebugLevel$128$myNondetVar_0;
    inline$BDLGetDebugLevel$128$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$128$myNondetVar_0;
    goto inline$BDLGetDebugLevel$128$label_1#1;

  inline$BDLGetDebugLevel$128$label_1#1:
    goto inline$BDLGetDebugLevel$128$Return#1;

  inline$BDLGetDebugLevel$128$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$128$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon48_Then#1, inline$BDLSystemPowerIoCompletion$4$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon25#1;

  inline$BDLSystemPowerIoCompletion$4$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_93#1;

  inline$BDLSystemPowerIoCompletion$4$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_93_true#1, inline$BDLSystemPowerIoCompletion$4$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_94#1;

  inline$BDLSystemPowerIoCompletion$4$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_97#1;

  inline$BDLSystemPowerIoCompletion$4$label_97#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_98#1;

  inline$BDLSystemPowerIoCompletion$4$label_98#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_99#1;

  inline$BDLSystemPowerIoCompletion$4$label_99#1:
    call inline$BDLSystemPowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$4$label_100#1;

  inline$BDLSystemPowerIoCompletion$4$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$4$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$4$label_94#1;

  inline$BDLSystemPowerIoCompletion$4$label_94#1:
    goto inline$BDLGetDebugLevel$129$Entry#1;

  inline$BDLGetDebugLevel$129$Entry#1:
    goto inline$BDLGetDebugLevel$129$start#1;

  inline$BDLGetDebugLevel$129$start#1:
    goto inline$BDLGetDebugLevel$129$label_3#1;

  inline$BDLGetDebugLevel$129$label_3#1:
    havoc inline$BDLGetDebugLevel$129$myNondetVar_0;
    inline$BDLGetDebugLevel$129$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$129$myNondetVar_0;
    goto inline$BDLGetDebugLevel$129$label_1#1;

  inline$BDLGetDebugLevel$129$label_1#1:
    goto inline$BDLGetDebugLevel$129$Return#1;

  inline$BDLGetDebugLevel$129$Return#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$129$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$4$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$4$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$4$anon49_Then#1, inline$BDLSystemPowerIoCompletion$4$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$4$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$anon27#1;

  inline$BDLSystemPowerIoCompletion$4$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_103#1;

  inline$BDLSystemPowerIoCompletion$4$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_103_true#1, inline$BDLSystemPowerIoCompletion$4$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$4$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_104#1;

  inline$BDLSystemPowerIoCompletion$4$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$4$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$4$label_105#1;

  inline$BDLSystemPowerIoCompletion$4$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$4$label_104#1;

  inline$BDLSystemPowerIoCompletion$4$label_104#1:
    inline$BDLSystemPowerIoCompletion$4$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$4$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$4$label_1#1;

  inline$BDLSystemPowerIoCompletion$4$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$4$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$4$Return#1;

  inline$BDLSystemPowerIoCompletion$4$Return#1:
    inline$CallCompletionRoutine$4$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$4$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$4$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$4$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$4$anon14_Then#1, inline$CallCompletionRoutine$4$anon14_Else#1;

  inline$CallCompletionRoutine$4$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$4$anon9#1;

  inline$CallCompletionRoutine$4$anon9#1:
    goto inline$CallCompletionRoutine$4$label_20_icall_return#1;

  inline$CallCompletionRoutine$4$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$4$Return#1;

  inline$CallCompletionRoutine$4$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$4$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$4$Entry#1;

  inline$BDLDevicePowerIoCompletion$4$Entry#1:
    inline$BDLDevicePowerIoCompletion$4$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$4$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$4$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$4$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$4$start#1;

  inline$BDLDevicePowerIoCompletion$4$start#1:
    call inline$BDLDevicePowerIoCompletion$4$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$4$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$4$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$4$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$4$label_3#1;

  inline$BDLDevicePowerIoCompletion$4$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_4#1;

  inline$BDLDevicePowerIoCompletion$4$label_4#1:
    inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_5#1;

  inline$BDLDevicePowerIoCompletion$4$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_6#1;

  inline$BDLDevicePowerIoCompletion$4$label_6#1:
    inline$BDLDevicePowerIoCompletion$4$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$4$label_7#1;

  inline$BDLDevicePowerIoCompletion$4$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_8#1;

  inline$BDLDevicePowerIoCompletion$4$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$4$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$4$label_9#1;

  inline$BDLDevicePowerIoCompletion$4$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_10#1;

  inline$BDLDevicePowerIoCompletion$4$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$28$Entry#1;

  inline$IoGetCurrentIrpStackLocation$28$Entry#1:
    inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$28$start#1;

  inline$IoGetCurrentIrpStackLocation$28$start#1:
    inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$28$label_3#1;

  inline$IoGetCurrentIrpStackLocation$28$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$28$label_3_true#1, inline$IoGetCurrentIrpStackLocation$28$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$28$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$28$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$28$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$28$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$28$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$28$label_4#1;

  inline$IoGetCurrentIrpStackLocation$28$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$28$label_6#1;

  inline$IoGetCurrentIrpStackLocation$28$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$28$label_7#1;

  inline$IoGetCurrentIrpStackLocation$28$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$28$label_5#1;

  inline$IoGetCurrentIrpStackLocation$28$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$28$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$28$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$28$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$28$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$28$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$28$label_5#1;

  inline$IoGetCurrentIrpStackLocation$28$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$28$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$28$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$28$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$28$label_1#1;

  inline$IoGetCurrentIrpStackLocation$28$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$28$Return#1;

  inline$IoGetCurrentIrpStackLocation$28$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$28$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon30_Then#1, inline$BDLDevicePowerIoCompletion$4$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon1#1;

  inline$BDLDevicePowerIoCompletion$4$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_13#1;

  inline$BDLDevicePowerIoCompletion$4$label_13#1:
    inline$BDLDevicePowerIoCompletion$4$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$4$label_14#1;

  inline$BDLDevicePowerIoCompletion$4$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_15#1;

  inline$BDLDevicePowerIoCompletion$4$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$4$label_16#1;

  inline$BDLDevicePowerIoCompletion$4$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_17#1;

  inline$BDLDevicePowerIoCompletion$4$label_17#1:
    goto inline$BDLGetDebugLevel$112$Entry#1;

  inline$BDLGetDebugLevel$112$Entry#1:
    goto inline$BDLGetDebugLevel$112$start#1;

  inline$BDLGetDebugLevel$112$start#1:
    goto inline$BDLGetDebugLevel$112$label_3#1;

  inline$BDLGetDebugLevel$112$label_3#1:
    havoc inline$BDLGetDebugLevel$112$myNondetVar_0;
    inline$BDLGetDebugLevel$112$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$112$myNondetVar_0;
    goto inline$BDLGetDebugLevel$112$label_1#1;

  inline$BDLGetDebugLevel$112$label_1#1:
    goto inline$BDLGetDebugLevel$112$Return#1;

  inline$BDLGetDebugLevel$112$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$112$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon31_Then#1, inline$BDLDevicePowerIoCompletion$4$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon3#1;

  inline$BDLDevicePowerIoCompletion$4$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_20#1;

  inline$BDLDevicePowerIoCompletion$4$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_20_true#1, inline$BDLDevicePowerIoCompletion$4$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_21#1;

  inline$BDLDevicePowerIoCompletion$4$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_24#1;

  inline$BDLDevicePowerIoCompletion$4$label_24#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_25#1;

  inline$BDLDevicePowerIoCompletion$4$label_25#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_26#1;

  inline$BDLDevicePowerIoCompletion$4$label_26#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_27#1;

  inline$BDLDevicePowerIoCompletion$4$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$4$label_21#1;

  inline$BDLDevicePowerIoCompletion$4$label_21#1:
    goto inline$BDLGetDebugLevel$113$Entry#1;

  inline$BDLGetDebugLevel$113$Entry#1:
    goto inline$BDLGetDebugLevel$113$start#1;

  inline$BDLGetDebugLevel$113$start#1:
    goto inline$BDLGetDebugLevel$113$label_3#1;

  inline$BDLGetDebugLevel$113$label_3#1:
    havoc inline$BDLGetDebugLevel$113$myNondetVar_0;
    inline$BDLGetDebugLevel$113$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$113$myNondetVar_0;
    goto inline$BDLGetDebugLevel$113$label_1#1;

  inline$BDLGetDebugLevel$113$label_1#1:
    goto inline$BDLGetDebugLevel$113$Return#1;

  inline$BDLGetDebugLevel$113$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$113$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon32_Then#1, inline$BDLDevicePowerIoCompletion$4$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon5#1;

  inline$BDLDevicePowerIoCompletion$4$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_30#1;

  inline$BDLDevicePowerIoCompletion$4$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_30_true#1, inline$BDLDevicePowerIoCompletion$4$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_31#1;

  inline$BDLDevicePowerIoCompletion$4$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_34#1;

  inline$BDLDevicePowerIoCompletion$4$label_34#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_35#1;

  inline$BDLDevicePowerIoCompletion$4$label_35#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_36#1;

  inline$BDLDevicePowerIoCompletion$4$label_36#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_37#1;

  inline$BDLDevicePowerIoCompletion$4$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$4$label_31#1;

  inline$BDLDevicePowerIoCompletion$4$label_31#1:
    goto inline$BDLGetDebugLevel$114$Entry#1;

  inline$BDLGetDebugLevel$114$Entry#1:
    goto inline$BDLGetDebugLevel$114$start#1;

  inline$BDLGetDebugLevel$114$start#1:
    goto inline$BDLGetDebugLevel$114$label_3#1;

  inline$BDLGetDebugLevel$114$label_3#1:
    havoc inline$BDLGetDebugLevel$114$myNondetVar_0;
    inline$BDLGetDebugLevel$114$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$114$myNondetVar_0;
    goto inline$BDLGetDebugLevel$114$label_1#1;

  inline$BDLGetDebugLevel$114$label_1#1:
    goto inline$BDLGetDebugLevel$114$Return#1;

  inline$BDLGetDebugLevel$114$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$114$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon33_Then#1, inline$BDLDevicePowerIoCompletion$4$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon7#1;

  inline$BDLDevicePowerIoCompletion$4$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_40#1;

  inline$BDLDevicePowerIoCompletion$4$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_40_true#1, inline$BDLDevicePowerIoCompletion$4$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_41#1;

  inline$BDLDevicePowerIoCompletion$4$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_42#1;

  inline$BDLDevicePowerIoCompletion$4$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_41#1;

  inline$BDLDevicePowerIoCompletion$4$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_41_true#1, inline$BDLDevicePowerIoCompletion$4$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$4$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$4$label_43#1;

  inline$BDLDevicePowerIoCompletion$4$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$4$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$4$label_44#1;

  inline$BDLDevicePowerIoCompletion$4$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_44_true#1, inline$BDLDevicePowerIoCompletion$4$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$4$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$4$label_45#1;

  inline$BDLDevicePowerIoCompletion$4$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_45_true#1, inline$BDLDevicePowerIoCompletion$4$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$4$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$4$label_43#1;

  inline$BDLDevicePowerIoCompletion$4$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$4$label_86#1;

  inline$BDLDevicePowerIoCompletion$4$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$4$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$4$label_46#1;

  inline$BDLDevicePowerIoCompletion$4$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$4$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$4$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$4$label_46#1;

  inline$BDLDevicePowerIoCompletion$4$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$4$label_49#1;

  inline$BDLDevicePowerIoCompletion$4$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_50#1;

  inline$BDLDevicePowerIoCompletion$4$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_51#1;

  inline$BDLDevicePowerIoCompletion$4$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_54#1;

  inline$BDLDevicePowerIoCompletion$4$label_54#1:
    inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$4$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$4$label_55#1;

  inline$BDLDevicePowerIoCompletion$4$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_55_true#1, inline$BDLDevicePowerIoCompletion$4$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_56#1;

  inline$BDLDevicePowerIoCompletion$4$label_56#1:
    call inline$BDLDevicePowerIoCompletion$4$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$4$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$4$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$4$anon34_Then#1, inline$BDLDevicePowerIoCompletion$4$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon9#1;

  inline$BDLDevicePowerIoCompletion$4$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_83#1;

  inline$BDLDevicePowerIoCompletion$4$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_59#1;

  inline$BDLDevicePowerIoCompletion$4$label_59#1:
    goto inline$BDLGetDebugLevel$115$Entry#1;

  inline$BDLGetDebugLevel$115$Entry#1:
    goto inline$BDLGetDebugLevel$115$start#1;

  inline$BDLGetDebugLevel$115$start#1:
    goto inline$BDLGetDebugLevel$115$label_3#1;

  inline$BDLGetDebugLevel$115$label_3#1:
    havoc inline$BDLGetDebugLevel$115$myNondetVar_0;
    inline$BDLGetDebugLevel$115$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$115$myNondetVar_0;
    goto inline$BDLGetDebugLevel$115$label_1#1;

  inline$BDLGetDebugLevel$115$label_1#1:
    goto inline$BDLGetDebugLevel$115$Return#1;

  inline$BDLGetDebugLevel$115$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$115$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon35_Then#1, inline$BDLDevicePowerIoCompletion$4$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon11#1;

  inline$BDLDevicePowerIoCompletion$4$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_62#1;

  inline$BDLDevicePowerIoCompletion$4$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_62_true#1, inline$BDLDevicePowerIoCompletion$4$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_63#1;

  inline$BDLDevicePowerIoCompletion$4$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_66#1;

  inline$BDLDevicePowerIoCompletion$4$label_66#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_67#1;

  inline$BDLDevicePowerIoCompletion$4$label_67#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_68#1;

  inline$BDLDevicePowerIoCompletion$4$label_68#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_69#1;

  inline$BDLDevicePowerIoCompletion$4$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$4$label_63#1;

  inline$BDLDevicePowerIoCompletion$4$label_63#1:
    goto inline$BDLGetDebugLevel$116$Entry#1;

  inline$BDLGetDebugLevel$116$Entry#1:
    goto inline$BDLGetDebugLevel$116$start#1;

  inline$BDLGetDebugLevel$116$start#1:
    goto inline$BDLGetDebugLevel$116$label_3#1;

  inline$BDLGetDebugLevel$116$label_3#1:
    havoc inline$BDLGetDebugLevel$116$myNondetVar_0;
    inline$BDLGetDebugLevel$116$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$116$myNondetVar_0;
    goto inline$BDLGetDebugLevel$116$label_1#1;

  inline$BDLGetDebugLevel$116$label_1#1:
    goto inline$BDLGetDebugLevel$116$Return#1;

  inline$BDLGetDebugLevel$116$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$116$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon36_Then#1, inline$BDLDevicePowerIoCompletion$4$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon13#1;

  inline$BDLDevicePowerIoCompletion$4$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_72#1;

  inline$BDLDevicePowerIoCompletion$4$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_72_true#1, inline$BDLDevicePowerIoCompletion$4$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_73#1;

  inline$BDLDevicePowerIoCompletion$4$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_76#1;

  inline$BDLDevicePowerIoCompletion$4$label_76#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_77#1;

  inline$BDLDevicePowerIoCompletion$4$label_77#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_78#1;

  inline$BDLDevicePowerIoCompletion$4$label_78#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_79#1;

  inline$BDLDevicePowerIoCompletion$4$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$4$label_73#1;

  inline$BDLDevicePowerIoCompletion$4$label_73#1:
    goto inline$BDLGetDebugLevel$117$Entry#1;

  inline$BDLGetDebugLevel$117$Entry#1:
    goto inline$BDLGetDebugLevel$117$start#1;

  inline$BDLGetDebugLevel$117$start#1:
    goto inline$BDLGetDebugLevel$117$label_3#1;

  inline$BDLGetDebugLevel$117$label_3#1:
    havoc inline$BDLGetDebugLevel$117$myNondetVar_0;
    inline$BDLGetDebugLevel$117$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$117$myNondetVar_0;
    goto inline$BDLGetDebugLevel$117$label_1#1;

  inline$BDLGetDebugLevel$117$label_1#1:
    goto inline$BDLGetDebugLevel$117$Return#1;

  inline$BDLGetDebugLevel$117$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$117$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon37_Then#1, inline$BDLDevicePowerIoCompletion$4$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon15#1;

  inline$BDLDevicePowerIoCompletion$4$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_82#1;

  inline$BDLDevicePowerIoCompletion$4$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_82_true#1, inline$BDLDevicePowerIoCompletion$4$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_83#1;

  inline$BDLDevicePowerIoCompletion$4$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_84#1;

  inline$BDLDevicePowerIoCompletion$4$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_83#1;

  inline$BDLDevicePowerIoCompletion$4$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_85#1;

  inline$BDLDevicePowerIoCompletion$4$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_86#1;

  inline$BDLDevicePowerIoCompletion$4$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$4$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$4$anon38_Then#1, inline$BDLDevicePowerIoCompletion$4$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon17#1;

  inline$BDLDevicePowerIoCompletion$4$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_89#1;

  inline$BDLDevicePowerIoCompletion$4$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$4$anon39_Then#1, inline$BDLDevicePowerIoCompletion$4$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon19#1;

  inline$BDLDevicePowerIoCompletion$4$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_92#1;

  inline$BDLDevicePowerIoCompletion$4$label_92#1:
    goto inline$storm_IoCompleteRequest$9$Entry#1;

  inline$storm_IoCompleteRequest$9$Entry#1:
    inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$4$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$9$start#1;

  inline$storm_IoCompleteRequest$9$start#1:
    inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$9$label_3#1;

  inline$storm_IoCompleteRequest$9$label_3#1:
    call inline$storm_IoCompleteRequest$9$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$9$label_6#1;

  inline$storm_IoCompleteRequest$9$label_6#1:
    goto inline$storm_IoCompleteRequest$9$label_6_true#1, inline$storm_IoCompleteRequest$9$label_6_false#1;

  inline$storm_IoCompleteRequest$9$label_6_false#1:
    assume inline$storm_IoCompleteRequest$9$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$9$label_7#1;

  inline$storm_IoCompleteRequest$9$label_6_true#1:
    assume inline$storm_IoCompleteRequest$9$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$9$label_8#1;

  inline$storm_IoCompleteRequest$9$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$9$anon3_Then#1, inline$storm_IoCompleteRequest$9$anon3_Else#1;

  inline$storm_IoCompleteRequest$9$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$9$anon1#1;

  inline$storm_IoCompleteRequest$9$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$9$label_9#1;

  inline$storm_IoCompleteRequest$9$label_9#1:
    goto inline$storm_IoCompleteRequest$9$label_9_true#1, inline$storm_IoCompleteRequest$9$label_9_false#1;

  inline$storm_IoCompleteRequest$9$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$9$label_10#1;

  inline$storm_IoCompleteRequest$9$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$9$label_1#1;

  inline$storm_IoCompleteRequest$9$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$9$label_7#1;

  inline$storm_IoCompleteRequest$9$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$9$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$9$label_1#1;

  inline$storm_IoCompleteRequest$9$label_1#1:
    goto inline$storm_IoCompleteRequest$9$Return#1;

  inline$storm_IoCompleteRequest$9$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$9$Return#1;

  inline$storm_IoCompleteRequest$9$Return#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon40_Then#1, inline$BDLDevicePowerIoCompletion$4$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon21#1;

  inline$BDLDevicePowerIoCompletion$4$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_95#1;

  inline$BDLDevicePowerIoCompletion$4$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$4$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$4$anon41_Then#1, inline$BDLDevicePowerIoCompletion$4$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon23#1;

  inline$BDLDevicePowerIoCompletion$4$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_98#1;

  inline$BDLDevicePowerIoCompletion$4$label_98#1:
    goto inline$BDLGetDebugLevel$118$Entry#1;

  inline$BDLGetDebugLevel$118$Entry#1:
    goto inline$BDLGetDebugLevel$118$start#1;

  inline$BDLGetDebugLevel$118$start#1:
    goto inline$BDLGetDebugLevel$118$label_3#1;

  inline$BDLGetDebugLevel$118$label_3#1:
    havoc inline$BDLGetDebugLevel$118$myNondetVar_0;
    inline$BDLGetDebugLevel$118$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$118$myNondetVar_0;
    goto inline$BDLGetDebugLevel$118$label_1#1;

  inline$BDLGetDebugLevel$118$label_1#1:
    goto inline$BDLGetDebugLevel$118$Return#1;

  inline$BDLGetDebugLevel$118$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$118$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon42_Then#1, inline$BDLDevicePowerIoCompletion$4$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon25#1;

  inline$BDLDevicePowerIoCompletion$4$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_101#1;

  inline$BDLDevicePowerIoCompletion$4$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_101_true#1, inline$BDLDevicePowerIoCompletion$4$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_102#1;

  inline$BDLDevicePowerIoCompletion$4$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_105#1;

  inline$BDLDevicePowerIoCompletion$4$label_105#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_106#1;

  inline$BDLDevicePowerIoCompletion$4$label_106#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_107#1;

  inline$BDLDevicePowerIoCompletion$4$label_107#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_108#1;

  inline$BDLDevicePowerIoCompletion$4$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$4$label_102#1;

  inline$BDLDevicePowerIoCompletion$4$label_102#1:
    goto inline$BDLGetDebugLevel$119$Entry#1;

  inline$BDLGetDebugLevel$119$Entry#1:
    goto inline$BDLGetDebugLevel$119$start#1;

  inline$BDLGetDebugLevel$119$start#1:
    goto inline$BDLGetDebugLevel$119$label_3#1;

  inline$BDLGetDebugLevel$119$label_3#1:
    havoc inline$BDLGetDebugLevel$119$myNondetVar_0;
    inline$BDLGetDebugLevel$119$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$119$myNondetVar_0;
    goto inline$BDLGetDebugLevel$119$label_1#1;

  inline$BDLGetDebugLevel$119$label_1#1:
    goto inline$BDLGetDebugLevel$119$Return#1;

  inline$BDLGetDebugLevel$119$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$119$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon43_Then#1, inline$BDLDevicePowerIoCompletion$4$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon27#1;

  inline$BDLDevicePowerIoCompletion$4$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_111#1;

  inline$BDLDevicePowerIoCompletion$4$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_111_true#1, inline$BDLDevicePowerIoCompletion$4$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_112#1;

  inline$BDLDevicePowerIoCompletion$4$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_115#1;

  inline$BDLDevicePowerIoCompletion$4$label_115#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_116#1;

  inline$BDLDevicePowerIoCompletion$4$label_116#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_117#1;

  inline$BDLDevicePowerIoCompletion$4$label_117#1:
    call inline$BDLDevicePowerIoCompletion$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$4$label_118#1;

  inline$BDLDevicePowerIoCompletion$4$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$4$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$4$label_112#1;

  inline$BDLDevicePowerIoCompletion$4$label_112#1:
    goto inline$BDLGetDebugLevel$120$Entry#1;

  inline$BDLGetDebugLevel$120$Entry#1:
    goto inline$BDLGetDebugLevel$120$start#1;

  inline$BDLGetDebugLevel$120$start#1:
    goto inline$BDLGetDebugLevel$120$label_3#1;

  inline$BDLGetDebugLevel$120$label_3#1:
    havoc inline$BDLGetDebugLevel$120$myNondetVar_0;
    inline$BDLGetDebugLevel$120$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$120$myNondetVar_0;
    goto inline$BDLGetDebugLevel$120$label_1#1;

  inline$BDLGetDebugLevel$120$label_1#1:
    goto inline$BDLGetDebugLevel$120$Return#1;

  inline$BDLGetDebugLevel$120$Return#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$120$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$4$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$4$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$4$anon44_Then#1, inline$BDLDevicePowerIoCompletion$4$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$4$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$anon29#1;

  inline$BDLDevicePowerIoCompletion$4$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_121#1;

  inline$BDLDevicePowerIoCompletion$4$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_121_true#1, inline$BDLDevicePowerIoCompletion$4$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$4$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_122#1;

  inline$BDLDevicePowerIoCompletion$4$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$4$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$4$label_123#1;

  inline$BDLDevicePowerIoCompletion$4$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$4$label_122#1;

  inline$BDLDevicePowerIoCompletion$4$label_122#1:
    inline$BDLDevicePowerIoCompletion$4$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$4$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$4$label_1#1;

  inline$BDLDevicePowerIoCompletion$4$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$4$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$4$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$4$Return#1;

  inline$BDLDevicePowerIoCompletion$4$Return#1:
    inline$CallCompletionRoutine$4$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$4$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$4$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$4$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$4$anon13_Then#1, inline$CallCompletionRoutine$4$anon13_Else#1;

  inline$CallCompletionRoutine$4$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$4$anon7#1;

  inline$CallCompletionRoutine$4$anon7#1:
    goto inline$CallCompletionRoutine$4$label_20_icall_return#1;

  inline$CallCompletionRoutine$4$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$4$Return#1;

  inline$CallCompletionRoutine$4$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$4$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$4$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$4$Entry#1;

  inline$BDLCallDriverCompletionRoutine$4$Entry#1:
    inline$BDLCallDriverCompletionRoutine$4$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$4$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$4$start#1;

  inline$BDLCallDriverCompletionRoutine$4$start#1:
    inline$BDLCallDriverCompletionRoutine$4$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$4$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$4$label_3#1;

  inline$BDLCallDriverCompletionRoutine$4$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$4$label_3_true#1, inline$BDLCallDriverCompletionRoutine$4$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$4$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$4$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$4$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$4$label_4#1;

  inline$BDLCallDriverCompletionRoutine$4$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$4$label_6#1;

  inline$BDLCallDriverCompletionRoutine$4$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$4$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$4$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$4$label_5#1;

  inline$BDLCallDriverCompletionRoutine$4$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$4$label_6#1;

  inline$BDLCallDriverCompletionRoutine$4$label_6#1:
    goto inline$storm_KeSetEvent$5$Entry#1;

  inline$storm_KeSetEvent$5$Entry#1:
    inline$storm_KeSetEvent$5$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$4$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$5$start#1;

  inline$storm_KeSetEvent$5$start#1:
    inline$storm_KeSetEvent$5$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$5$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$5$label_3#1;

  inline$storm_KeSetEvent$5$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$5$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$5$label_1#1;

  inline$storm_KeSetEvent$5$label_1#1:
    goto inline$storm_KeSetEvent$5$Return#1;

  inline$storm_KeSetEvent$5$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$4$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$4$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$4$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$4$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$4$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$4$anon1#1;

  inline$BDLCallDriverCompletionRoutine$4$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$4$label_9#1;

  inline$BDLCallDriverCompletionRoutine$4$label_9#1:
    inline$BDLCallDriverCompletionRoutine$4$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$4$label_1#1;

  inline$BDLCallDriverCompletionRoutine$4$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$4$Return#1;

  inline$BDLCallDriverCompletionRoutine$4$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$4$Return#1;

  inline$BDLCallDriverCompletionRoutine$4$Return#1:
    inline$CallCompletionRoutine$4$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$4$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$4$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$4$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$4$anon12_Then#1, inline$CallCompletionRoutine$4$anon12_Else#1;

  inline$CallCompletionRoutine$4$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$4$anon5#1;

  inline$CallCompletionRoutine$4$anon5#1:
    goto inline$CallCompletionRoutine$4$label_20_icall_return#1;

  inline$CallCompletionRoutine$4$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$4$label_23#1;

  inline$CallCompletionRoutine$4$label_23#1:
    inline$CallCompletionRoutine$4$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$4$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$4$label_24#1;

  inline$CallCompletionRoutine$4$label_24#1:
    goto inline$CallCompletionRoutine$4$label_24_true#1, inline$CallCompletionRoutine$4$label_24_false#1;

  inline$CallCompletionRoutine$4$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$4$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$4$label_1#1;

  inline$CallCompletionRoutine$4$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$4$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$4$label_25#1;

  inline$CallCompletionRoutine$4$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$4$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$4$label_1#1;

  inline$CallCompletionRoutine$4$label_1#1:
    goto inline$CallCompletionRoutine$4$Return#1;

  inline$CallCompletionRoutine$4$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$4$Return#1;

  inline$CallCompletionRoutine$4$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$4$Return#1;

  inline$CallCompletionRoutine$4$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$4$Return#1;

  inline$CallCompletionRoutine$4$Return#1:
    goto inline$storm_IoCallDriver$2$label_33$1#1;

  inline$storm_IoCallDriver$2$label_33$1#1:
    goto inline$storm_IoCallDriver$2$anon14_Then#1, inline$storm_IoCallDriver$2$anon14_Else#1;

  inline$storm_IoCallDriver$2$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$2$anon8#1;

  inline$storm_IoCallDriver$2$anon8#1:
    goto inline$storm_IoCallDriver$2$label_36#1;

  inline$storm_IoCallDriver$2$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$2$Return#1;

  inline$storm_IoCallDriver$2$label_27_case_1#1:
    assume inline$storm_IoCallDriver$2$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$2$label_29#1;

  inline$storm_IoCallDriver$2$label_29#1:
    inline$storm_IoCallDriver$2$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$2$label_37#1;

  inline$storm_IoCallDriver$2$label_37#1:
    goto inline$storm_IoCallDriver$2$label_38#1;

  inline$storm_IoCallDriver$2$label_38#1:
    goto inline$storm_IoCallDriver$2$label_39#1;

  inline$storm_IoCallDriver$2$label_39#1:
    goto inline$CallCompletionRoutine$5$Entry#1;

  inline$CallCompletionRoutine$5$Entry#1:
    inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$5$start#1;

  inline$CallCompletionRoutine$5$start#1:
    inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$5$label_3#1;

  inline$CallCompletionRoutine$5$label_3#1:
    goto inline$CallCompletionRoutine$5$label_4#1;

  inline$CallCompletionRoutine$5$label_4#1:
    goto inline$CallCompletionRoutine$5$label_5#1;

  inline$CallCompletionRoutine$5$label_5#1:
    goto inline$CallCompletionRoutine$5$label_6#1;

  inline$CallCompletionRoutine$5$label_6#1:
    goto inline$CallCompletionRoutine$5$label_7#1;

  inline$CallCompletionRoutine$5$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$30$Entry#1;

  inline$IoGetCurrentIrpStackLocation$30$Entry#1:
    inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$30$start#1;

  inline$IoGetCurrentIrpStackLocation$30$start#1:
    inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$30$label_3#1;

  inline$IoGetCurrentIrpStackLocation$30$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$30$label_3_true#1, inline$IoGetCurrentIrpStackLocation$30$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$30$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$30$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$30$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$30$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$30$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$30$label_4#1;

  inline$IoGetCurrentIrpStackLocation$30$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$30$label_6#1;

  inline$IoGetCurrentIrpStackLocation$30$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$30$label_7#1;

  inline$IoGetCurrentIrpStackLocation$30$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$30$label_5#1;

  inline$IoGetCurrentIrpStackLocation$30$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$30$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$30$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$30$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$30$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$30$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$30$label_5#1;

  inline$IoGetCurrentIrpStackLocation$30$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$30$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$30$label_1#1;

  inline$IoGetCurrentIrpStackLocation$30$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$30$Return#1;

  inline$IoGetCurrentIrpStackLocation$30$Return#1:
    goto inline$CallCompletionRoutine$5$label_7$1#1;

  inline$CallCompletionRoutine$5$label_7$1#1:
    goto inline$CallCompletionRoutine$5$anon10_Then#1, inline$CallCompletionRoutine$5$anon10_Else#1;

  inline$CallCompletionRoutine$5$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$5$anon1#1;

  inline$CallCompletionRoutine$5$anon1#1:
    goto inline$CallCompletionRoutine$5$label_10#1;

  inline$CallCompletionRoutine$5$label_10#1:
    goto inline$CallCompletionRoutine$5$label_11#1;

  inline$CallCompletionRoutine$5$label_11#1:
    havoc inline$CallCompletionRoutine$5$myNondetVar_0;
    inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$5$myNondetVar_0;
    goto inline$CallCompletionRoutine$5$label_12#1;

  inline$CallCompletionRoutine$5$label_12#1:
    havoc inline$CallCompletionRoutine$5$myNondetVar_0;
    inline$CallCompletionRoutine$5$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$5$myNondetVar_0;
    goto inline$CallCompletionRoutine$5$label_13#1;

  inline$CallCompletionRoutine$5$label_13#1:
    havoc inline$CallCompletionRoutine$5$myNondetVar_0;
    goto inline$CallCompletionRoutine$5$label_14#1;

  inline$CallCompletionRoutine$5$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$31$Entry#1;

  inline$IoGetCurrentIrpStackLocation$31$Entry#1:
    inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$31$start#1;

  inline$IoGetCurrentIrpStackLocation$31$start#1:
    inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$31$label_3#1;

  inline$IoGetCurrentIrpStackLocation$31$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$31$label_3_true#1, inline$IoGetCurrentIrpStackLocation$31$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$31$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$31$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$31$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$31$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$31$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$31$label_4#1;

  inline$IoGetCurrentIrpStackLocation$31$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$31$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$31$label_6#1;

  inline$IoGetCurrentIrpStackLocation$31$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$31$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$31$label_7#1;

  inline$IoGetCurrentIrpStackLocation$31$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$31$label_5#1;

  inline$IoGetCurrentIrpStackLocation$31$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$31$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$31$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$31$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$31$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$31$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$31$label_5#1;

  inline$IoGetCurrentIrpStackLocation$31$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$31$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$31$label_1#1;

  inline$IoGetCurrentIrpStackLocation$31$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$31$Return#1;

  inline$IoGetCurrentIrpStackLocation$31$Return#1:
    goto inline$CallCompletionRoutine$5$label_14$1#1;

  inline$CallCompletionRoutine$5$label_14$1#1:
    goto inline$CallCompletionRoutine$5$anon11_Then#1, inline$CallCompletionRoutine$5$anon11_Else#1;

  inline$CallCompletionRoutine$5$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$5$anon3#1;

  inline$CallCompletionRoutine$5$anon3#1:
    goto inline$CallCompletionRoutine$5$label_17#1;

  inline$CallCompletionRoutine$5$label_17#1:
    goto inline$CallCompletionRoutine$5$label_18#1;

  inline$CallCompletionRoutine$5$label_18#1:
    goto inline$CallCompletionRoutine$5$label_18_true#1, inline$CallCompletionRoutine$5$label_18_false#1;

  inline$CallCompletionRoutine$5$label_18_false#1:
    assume inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$5$label_1#1;

  inline$CallCompletionRoutine$5$label_18_true#1:
    assume inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$5$label_19#1;

  inline$CallCompletionRoutine$5$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$5$label_20#1;

  inline$CallCompletionRoutine$5$label_20#1:
    goto inline$CallCompletionRoutine$5$label_20_icall_1#1, inline$CallCompletionRoutine$5$label_20_icall_2#1, inline$CallCompletionRoutine$5$label_20_icall_3#1;

  inline$CallCompletionRoutine$5$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$5$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$5$Entry#1;

  inline$BDLSystemPowerIoCompletion$5$Entry#1:
    inline$BDLSystemPowerIoCompletion$5$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$5$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$5$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$5$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$5$start#1;

  inline$BDLSystemPowerIoCompletion$5$start#1:
    call inline$BDLSystemPowerIoCompletion$5$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$5$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$5$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$5$label_3#1;

  inline$BDLSystemPowerIoCompletion$5$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_4#1;

  inline$BDLSystemPowerIoCompletion$5$label_4#1:
    inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_5#1;

  inline$BDLSystemPowerIoCompletion$5$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_6#1;

  inline$BDLSystemPowerIoCompletion$5$label_6#1:
    inline$BDLSystemPowerIoCompletion$5$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$5$label_7#1;

  inline$BDLSystemPowerIoCompletion$5$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_8#1;

  inline$BDLSystemPowerIoCompletion$5$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$5$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$5$label_9#1;

  inline$BDLSystemPowerIoCompletion$5$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_10#1;

  inline$BDLSystemPowerIoCompletion$5$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$33$Entry#1;

  inline$IoGetCurrentIrpStackLocation$33$Entry#1:
    inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$33$start#1;

  inline$IoGetCurrentIrpStackLocation$33$start#1:
    inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$33$label_3#1;

  inline$IoGetCurrentIrpStackLocation$33$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$33$label_3_true#1, inline$IoGetCurrentIrpStackLocation$33$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$33$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$33$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$33$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$33$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$33$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$33$label_4#1;

  inline$IoGetCurrentIrpStackLocation$33$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$33$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$33$label_6#1;

  inline$IoGetCurrentIrpStackLocation$33$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$33$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$33$label_7#1;

  inline$IoGetCurrentIrpStackLocation$33$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$33$label_5#1;

  inline$IoGetCurrentIrpStackLocation$33$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$33$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$33$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$33$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$33$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$33$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$33$label_5#1;

  inline$IoGetCurrentIrpStackLocation$33$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$33$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$33$label_1#1;

  inline$IoGetCurrentIrpStackLocation$33$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$33$Return#1;

  inline$IoGetCurrentIrpStackLocation$33$Return#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon36_Then#1, inline$BDLSystemPowerIoCompletion$5$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon1#1;

  inline$BDLSystemPowerIoCompletion$5$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_13#1;

  inline$BDLSystemPowerIoCompletion$5$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_14#1;

  inline$BDLSystemPowerIoCompletion$5$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_15#1;

  inline$BDLSystemPowerIoCompletion$5$label_15#1:
    goto inline$BDLGetDebugLevel$142$Entry#1;

  inline$BDLGetDebugLevel$142$Entry#1:
    goto inline$BDLGetDebugLevel$142$start#1;

  inline$BDLGetDebugLevel$142$start#1:
    goto inline$BDLGetDebugLevel$142$label_3#1;

  inline$BDLGetDebugLevel$142$label_3#1:
    havoc inline$BDLGetDebugLevel$142$myNondetVar_0;
    inline$BDLGetDebugLevel$142$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$142$myNondetVar_0;
    goto inline$BDLGetDebugLevel$142$label_1#1;

  inline$BDLGetDebugLevel$142$label_1#1:
    goto inline$BDLGetDebugLevel$142$Return#1;

  inline$BDLGetDebugLevel$142$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$142$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon37_Then#1, inline$BDLSystemPowerIoCompletion$5$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon3#1;

  inline$BDLSystemPowerIoCompletion$5$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_18#1;

  inline$BDLSystemPowerIoCompletion$5$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_18_true#1, inline$BDLSystemPowerIoCompletion$5$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_19#1;

  inline$BDLSystemPowerIoCompletion$5$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_22#1;

  inline$BDLSystemPowerIoCompletion$5$label_22#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_23#1;

  inline$BDLSystemPowerIoCompletion$5$label_23#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_24#1;

  inline$BDLSystemPowerIoCompletion$5$label_24#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_25#1;

  inline$BDLSystemPowerIoCompletion$5$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$5$label_19#1;

  inline$BDLSystemPowerIoCompletion$5$label_19#1:
    goto inline$BDLGetDebugLevel$143$Entry#1;

  inline$BDLGetDebugLevel$143$Entry#1:
    goto inline$BDLGetDebugLevel$143$start#1;

  inline$BDLGetDebugLevel$143$start#1:
    goto inline$BDLGetDebugLevel$143$label_3#1;

  inline$BDLGetDebugLevel$143$label_3#1:
    havoc inline$BDLGetDebugLevel$143$myNondetVar_0;
    inline$BDLGetDebugLevel$143$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$143$myNondetVar_0;
    goto inline$BDLGetDebugLevel$143$label_1#1;

  inline$BDLGetDebugLevel$143$label_1#1:
    goto inline$BDLGetDebugLevel$143$Return#1;

  inline$BDLGetDebugLevel$143$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$143$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon38_Then#1, inline$BDLSystemPowerIoCompletion$5$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon5#1;

  inline$BDLSystemPowerIoCompletion$5$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_28#1;

  inline$BDLSystemPowerIoCompletion$5$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_28_true#1, inline$BDLSystemPowerIoCompletion$5$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_29#1;

  inline$BDLSystemPowerIoCompletion$5$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_32#1;

  inline$BDLSystemPowerIoCompletion$5$label_32#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_33#1;

  inline$BDLSystemPowerIoCompletion$5$label_33#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_34#1;

  inline$BDLSystemPowerIoCompletion$5$label_34#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_35#1;

  inline$BDLSystemPowerIoCompletion$5$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$5$label_29#1;

  inline$BDLSystemPowerIoCompletion$5$label_29#1:
    goto inline$BDLGetDebugLevel$144$Entry#1;

  inline$BDLGetDebugLevel$144$Entry#1:
    goto inline$BDLGetDebugLevel$144$start#1;

  inline$BDLGetDebugLevel$144$start#1:
    goto inline$BDLGetDebugLevel$144$label_3#1;

  inline$BDLGetDebugLevel$144$label_3#1:
    havoc inline$BDLGetDebugLevel$144$myNondetVar_0;
    inline$BDLGetDebugLevel$144$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$144$myNondetVar_0;
    goto inline$BDLGetDebugLevel$144$label_1#1;

  inline$BDLGetDebugLevel$144$label_1#1:
    goto inline$BDLGetDebugLevel$144$Return#1;

  inline$BDLGetDebugLevel$144$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$144$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon39_Then#1, inline$BDLSystemPowerIoCompletion$5$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon7#1;

  inline$BDLSystemPowerIoCompletion$5$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_38#1;

  inline$BDLSystemPowerIoCompletion$5$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_38_true#1, inline$BDLSystemPowerIoCompletion$5$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_39#1;

  inline$BDLSystemPowerIoCompletion$5$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_40#1;

  inline$BDLSystemPowerIoCompletion$5$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_39#1;

  inline$BDLSystemPowerIoCompletion$5$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_39_true#1, inline$BDLSystemPowerIoCompletion$5$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_41#1;

  inline$BDLSystemPowerIoCompletion$5$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$5$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$5$label_107#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$5$label_108#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$5$label_108#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$5$label_108#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$5$label_108#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$5$label_108#1;

  inline$BDLSystemPowerIoCompletion$5$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_109#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$5$label_107#1;

  inline$BDLSystemPowerIoCompletion$5$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_109#1;

  inline$BDLSystemPowerIoCompletion$5$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$5$label_106#1;

  inline$BDLSystemPowerIoCompletion$5$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_106_true#1, inline$BDLSystemPowerIoCompletion$5$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_142#1;

  inline$BDLSystemPowerIoCompletion$5$label_142#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_143#1;

  inline$BDLSystemPowerIoCompletion$5$label_143#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_144#1;

  inline$BDLSystemPowerIoCompletion$5$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_109#1;

  inline$BDLSystemPowerIoCompletion$5$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_109#1;

  inline$BDLSystemPowerIoCompletion$5$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$5$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$5$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$5$myNondetVar_0, inline$BDLSystemPowerIoCompletion$5$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$5$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$5$anon50_Then#1, inline$BDLSystemPowerIoCompletion$5$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon29#1;

  inline$BDLSystemPowerIoCompletion$5$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_112#1;

  inline$BDLSystemPowerIoCompletion$5$label_112#1:
    inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$5$label_113#1;

  inline$BDLSystemPowerIoCompletion$5$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_113_true#1, inline$BDLSystemPowerIoCompletion$5$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$5$label_114#1;

  inline$BDLSystemPowerIoCompletion$5$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_116#1;

  inline$BDLSystemPowerIoCompletion$5$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_117#1;

  inline$BDLSystemPowerIoCompletion$5$label_117#1:
    goto inline$BDLGetDebugLevel$151$Entry#1;

  inline$BDLGetDebugLevel$151$Entry#1:
    goto inline$BDLGetDebugLevel$151$start#1;

  inline$BDLGetDebugLevel$151$start#1:
    goto inline$BDLGetDebugLevel$151$label_3#1;

  inline$BDLGetDebugLevel$151$label_3#1:
    havoc inline$BDLGetDebugLevel$151$myNondetVar_0;
    inline$BDLGetDebugLevel$151$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$151$myNondetVar_0;
    goto inline$BDLGetDebugLevel$151$label_1#1;

  inline$BDLGetDebugLevel$151$label_1#1:
    goto inline$BDLGetDebugLevel$151$Return#1;

  inline$BDLGetDebugLevel$151$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$151$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon51_Then#1, inline$BDLSystemPowerIoCompletion$5$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon31#1;

  inline$BDLSystemPowerIoCompletion$5$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_120#1;

  inline$BDLSystemPowerIoCompletion$5$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_120_true#1, inline$BDLSystemPowerIoCompletion$5$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_121#1;

  inline$BDLSystemPowerIoCompletion$5$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_124#1;

  inline$BDLSystemPowerIoCompletion$5$label_124#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_125#1;

  inline$BDLSystemPowerIoCompletion$5$label_125#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_126#1;

  inline$BDLSystemPowerIoCompletion$5$label_126#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_127#1;

  inline$BDLSystemPowerIoCompletion$5$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$5$label_121#1;

  inline$BDLSystemPowerIoCompletion$5$label_121#1:
    goto inline$BDLGetDebugLevel$152$Entry#1;

  inline$BDLGetDebugLevel$152$Entry#1:
    goto inline$BDLGetDebugLevel$152$start#1;

  inline$BDLGetDebugLevel$152$start#1:
    goto inline$BDLGetDebugLevel$152$label_3#1;

  inline$BDLGetDebugLevel$152$label_3#1:
    havoc inline$BDLGetDebugLevel$152$myNondetVar_0;
    inline$BDLGetDebugLevel$152$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$152$myNondetVar_0;
    goto inline$BDLGetDebugLevel$152$label_1#1;

  inline$BDLGetDebugLevel$152$label_1#1:
    goto inline$BDLGetDebugLevel$152$Return#1;

  inline$BDLGetDebugLevel$152$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$152$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon52_Then#1, inline$BDLSystemPowerIoCompletion$5$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon33#1;

  inline$BDLSystemPowerIoCompletion$5$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_130#1;

  inline$BDLSystemPowerIoCompletion$5$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_130_true#1, inline$BDLSystemPowerIoCompletion$5$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_131#1;

  inline$BDLSystemPowerIoCompletion$5$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_134#1;

  inline$BDLSystemPowerIoCompletion$5$label_134#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_135#1;

  inline$BDLSystemPowerIoCompletion$5$label_135#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_136#1;

  inline$BDLSystemPowerIoCompletion$5$label_136#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_137#1;

  inline$BDLSystemPowerIoCompletion$5$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$5$label_131#1;

  inline$BDLSystemPowerIoCompletion$5$label_131#1:
    goto inline$BDLGetDebugLevel$153$Entry#1;

  inline$BDLGetDebugLevel$153$Entry#1:
    goto inline$BDLGetDebugLevel$153$start#1;

  inline$BDLGetDebugLevel$153$start#1:
    goto inline$BDLGetDebugLevel$153$label_3#1;

  inline$BDLGetDebugLevel$153$label_3#1:
    havoc inline$BDLGetDebugLevel$153$myNondetVar_0;
    inline$BDLGetDebugLevel$153$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$153$myNondetVar_0;
    goto inline$BDLGetDebugLevel$153$label_1#1;

  inline$BDLGetDebugLevel$153$label_1#1:
    goto inline$BDLGetDebugLevel$153$Return#1;

  inline$BDLGetDebugLevel$153$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$153$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon53_Then#1, inline$BDLSystemPowerIoCompletion$5$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon35#1;

  inline$BDLSystemPowerIoCompletion$5$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_140#1;

  inline$BDLSystemPowerIoCompletion$5$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_140_true#1, inline$BDLSystemPowerIoCompletion$5$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_67#1;

  inline$BDLSystemPowerIoCompletion$5$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_141#1;

  inline$BDLSystemPowerIoCompletion$5$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_67#1;

  inline$BDLSystemPowerIoCompletion$5$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$5$label_115#1;

  inline$BDLSystemPowerIoCompletion$5$label_115#1:
    inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$5$label_80#1;

  inline$BDLSystemPowerIoCompletion$5$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$5$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_42#1;

  inline$BDLSystemPowerIoCompletion$5$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$5$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$5$label_43#1;

  inline$BDLSystemPowerIoCompletion$5$label_43#1:
    goto inline$BDLGetDebugLevel$145$Entry#1;

  inline$BDLGetDebugLevel$145$Entry#1:
    goto inline$BDLGetDebugLevel$145$start#1;

  inline$BDLGetDebugLevel$145$start#1:
    goto inline$BDLGetDebugLevel$145$label_3#1;

  inline$BDLGetDebugLevel$145$label_3#1:
    havoc inline$BDLGetDebugLevel$145$myNondetVar_0;
    inline$BDLGetDebugLevel$145$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$145$myNondetVar_0;
    goto inline$BDLGetDebugLevel$145$label_1#1;

  inline$BDLGetDebugLevel$145$label_1#1:
    goto inline$BDLGetDebugLevel$145$Return#1;

  inline$BDLGetDebugLevel$145$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$145$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon40_Then#1, inline$BDLSystemPowerIoCompletion$5$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon9#1;

  inline$BDLSystemPowerIoCompletion$5$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_46#1;

  inline$BDLSystemPowerIoCompletion$5$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_46_true#1, inline$BDLSystemPowerIoCompletion$5$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_47#1;

  inline$BDLSystemPowerIoCompletion$5$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_50#1;

  inline$BDLSystemPowerIoCompletion$5$label_50#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_51#1;

  inline$BDLSystemPowerIoCompletion$5$label_51#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_52#1;

  inline$BDLSystemPowerIoCompletion$5$label_52#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_53#1;

  inline$BDLSystemPowerIoCompletion$5$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$5$label_47#1;

  inline$BDLSystemPowerIoCompletion$5$label_47#1:
    goto inline$BDLGetDebugLevel$146$Entry#1;

  inline$BDLGetDebugLevel$146$Entry#1:
    goto inline$BDLGetDebugLevel$146$start#1;

  inline$BDLGetDebugLevel$146$start#1:
    goto inline$BDLGetDebugLevel$146$label_3#1;

  inline$BDLGetDebugLevel$146$label_3#1:
    havoc inline$BDLGetDebugLevel$146$myNondetVar_0;
    inline$BDLGetDebugLevel$146$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$146$myNondetVar_0;
    goto inline$BDLGetDebugLevel$146$label_1#1;

  inline$BDLGetDebugLevel$146$label_1#1:
    goto inline$BDLGetDebugLevel$146$Return#1;

  inline$BDLGetDebugLevel$146$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$146$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon41_Then#1, inline$BDLSystemPowerIoCompletion$5$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon11#1;

  inline$BDLSystemPowerIoCompletion$5$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_56#1;

  inline$BDLSystemPowerIoCompletion$5$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_56_true#1, inline$BDLSystemPowerIoCompletion$5$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_57#1;

  inline$BDLSystemPowerIoCompletion$5$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_60#1;

  inline$BDLSystemPowerIoCompletion$5$label_60#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_61#1;

  inline$BDLSystemPowerIoCompletion$5$label_61#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_62#1;

  inline$BDLSystemPowerIoCompletion$5$label_62#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_63#1;

  inline$BDLSystemPowerIoCompletion$5$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$5$label_57#1;

  inline$BDLSystemPowerIoCompletion$5$label_57#1:
    goto inline$BDLGetDebugLevel$147$Entry#1;

  inline$BDLGetDebugLevel$147$Entry#1:
    goto inline$BDLGetDebugLevel$147$start#1;

  inline$BDLGetDebugLevel$147$start#1:
    goto inline$BDLGetDebugLevel$147$label_3#1;

  inline$BDLGetDebugLevel$147$label_3#1:
    havoc inline$BDLGetDebugLevel$147$myNondetVar_0;
    inline$BDLGetDebugLevel$147$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$147$myNondetVar_0;
    goto inline$BDLGetDebugLevel$147$label_1#1;

  inline$BDLGetDebugLevel$147$label_1#1:
    goto inline$BDLGetDebugLevel$147$Return#1;

  inline$BDLGetDebugLevel$147$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$147$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon42_Then#1, inline$BDLSystemPowerIoCompletion$5$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon13#1;

  inline$BDLSystemPowerIoCompletion$5$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_66#1;

  inline$BDLSystemPowerIoCompletion$5$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_66_true#1, inline$BDLSystemPowerIoCompletion$5$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_67#1;

  inline$BDLSystemPowerIoCompletion$5$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_70#1;

  inline$BDLSystemPowerIoCompletion$5$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_67#1;

  inline$BDLSystemPowerIoCompletion$5$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$5$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$5$anon43_Then#1, inline$BDLSystemPowerIoCompletion$5$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon15#1;

  inline$BDLSystemPowerIoCompletion$5$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_71#1;

  inline$BDLSystemPowerIoCompletion$5$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$5$anon44_Then#1, inline$BDLSystemPowerIoCompletion$5$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon17#1;

  inline$BDLSystemPowerIoCompletion$5$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_74#1;

  inline$BDLSystemPowerIoCompletion$5$label_74#1:
    goto inline$storm_IoCompleteRequest$12$Entry#1;

  inline$storm_IoCompleteRequest$12$Entry#1:
    inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$5$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$12$start#1;

  inline$storm_IoCompleteRequest$12$start#1:
    inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$12$label_3#1;

  inline$storm_IoCompleteRequest$12$label_3#1:
    call inline$storm_IoCompleteRequest$12$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$12$label_6#1;

  inline$storm_IoCompleteRequest$12$label_6#1:
    goto inline$storm_IoCompleteRequest$12$label_6_true#1, inline$storm_IoCompleteRequest$12$label_6_false#1;

  inline$storm_IoCompleteRequest$12$label_6_false#1:
    assume inline$storm_IoCompleteRequest$12$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$12$label_7#1;

  inline$storm_IoCompleteRequest$12$label_6_true#1:
    assume inline$storm_IoCompleteRequest$12$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$12$label_8#1;

  inline$storm_IoCompleteRequest$12$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$12$anon3_Then#1, inline$storm_IoCompleteRequest$12$anon3_Else#1;

  inline$storm_IoCompleteRequest$12$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$12$anon1#1;

  inline$storm_IoCompleteRequest$12$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$12$label_9#1;

  inline$storm_IoCompleteRequest$12$label_9#1:
    goto inline$storm_IoCompleteRequest$12$label_9_true#1, inline$storm_IoCompleteRequest$12$label_9_false#1;

  inline$storm_IoCompleteRequest$12$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$12$label_10#1;

  inline$storm_IoCompleteRequest$12$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$12$label_1#1;

  inline$storm_IoCompleteRequest$12$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$12$label_7#1;

  inline$storm_IoCompleteRequest$12$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$12$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$12$label_1#1;

  inline$storm_IoCompleteRequest$12$label_1#1:
    goto inline$storm_IoCompleteRequest$12$Return#1;

  inline$storm_IoCompleteRequest$12$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$12$Return#1;

  inline$storm_IoCompleteRequest$12$Return#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon45_Then#1, inline$BDLSystemPowerIoCompletion$5$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon19#1;

  inline$BDLSystemPowerIoCompletion$5$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_77#1;

  inline$BDLSystemPowerIoCompletion$5$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$5$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$5$anon46_Then#1, inline$BDLSystemPowerIoCompletion$5$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon21#1;

  inline$BDLSystemPowerIoCompletion$5$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_80#1;

  inline$BDLSystemPowerIoCompletion$5$label_80#1:
    goto inline$BDLGetDebugLevel$148$Entry#1;

  inline$BDLGetDebugLevel$148$Entry#1:
    goto inline$BDLGetDebugLevel$148$start#1;

  inline$BDLGetDebugLevel$148$start#1:
    goto inline$BDLGetDebugLevel$148$label_3#1;

  inline$BDLGetDebugLevel$148$label_3#1:
    havoc inline$BDLGetDebugLevel$148$myNondetVar_0;
    inline$BDLGetDebugLevel$148$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$148$myNondetVar_0;
    goto inline$BDLGetDebugLevel$148$label_1#1;

  inline$BDLGetDebugLevel$148$label_1#1:
    goto inline$BDLGetDebugLevel$148$Return#1;

  inline$BDLGetDebugLevel$148$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$148$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon47_Then#1, inline$BDLSystemPowerIoCompletion$5$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon23#1;

  inline$BDLSystemPowerIoCompletion$5$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_83#1;

  inline$BDLSystemPowerIoCompletion$5$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_83_true#1, inline$BDLSystemPowerIoCompletion$5$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_84#1;

  inline$BDLSystemPowerIoCompletion$5$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_87#1;

  inline$BDLSystemPowerIoCompletion$5$label_87#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_88#1;

  inline$BDLSystemPowerIoCompletion$5$label_88#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_89#1;

  inline$BDLSystemPowerIoCompletion$5$label_89#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_90#1;

  inline$BDLSystemPowerIoCompletion$5$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$5$label_84#1;

  inline$BDLSystemPowerIoCompletion$5$label_84#1:
    goto inline$BDLGetDebugLevel$149$Entry#1;

  inline$BDLGetDebugLevel$149$Entry#1:
    goto inline$BDLGetDebugLevel$149$start#1;

  inline$BDLGetDebugLevel$149$start#1:
    goto inline$BDLGetDebugLevel$149$label_3#1;

  inline$BDLGetDebugLevel$149$label_3#1:
    havoc inline$BDLGetDebugLevel$149$myNondetVar_0;
    inline$BDLGetDebugLevel$149$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$149$myNondetVar_0;
    goto inline$BDLGetDebugLevel$149$label_1#1;

  inline$BDLGetDebugLevel$149$label_1#1:
    goto inline$BDLGetDebugLevel$149$Return#1;

  inline$BDLGetDebugLevel$149$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$149$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon48_Then#1, inline$BDLSystemPowerIoCompletion$5$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon25#1;

  inline$BDLSystemPowerIoCompletion$5$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_93#1;

  inline$BDLSystemPowerIoCompletion$5$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_93_true#1, inline$BDLSystemPowerIoCompletion$5$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_94#1;

  inline$BDLSystemPowerIoCompletion$5$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_97#1;

  inline$BDLSystemPowerIoCompletion$5$label_97#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_98#1;

  inline$BDLSystemPowerIoCompletion$5$label_98#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_99#1;

  inline$BDLSystemPowerIoCompletion$5$label_99#1:
    call inline$BDLSystemPowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$5$label_100#1;

  inline$BDLSystemPowerIoCompletion$5$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$5$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$5$label_94#1;

  inline$BDLSystemPowerIoCompletion$5$label_94#1:
    goto inline$BDLGetDebugLevel$150$Entry#1;

  inline$BDLGetDebugLevel$150$Entry#1:
    goto inline$BDLGetDebugLevel$150$start#1;

  inline$BDLGetDebugLevel$150$start#1:
    goto inline$BDLGetDebugLevel$150$label_3#1;

  inline$BDLGetDebugLevel$150$label_3#1:
    havoc inline$BDLGetDebugLevel$150$myNondetVar_0;
    inline$BDLGetDebugLevel$150$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$150$myNondetVar_0;
    goto inline$BDLGetDebugLevel$150$label_1#1;

  inline$BDLGetDebugLevel$150$label_1#1:
    goto inline$BDLGetDebugLevel$150$Return#1;

  inline$BDLGetDebugLevel$150$Return#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$150$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$5$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$5$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$5$anon49_Then#1, inline$BDLSystemPowerIoCompletion$5$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$5$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$anon27#1;

  inline$BDLSystemPowerIoCompletion$5$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_103#1;

  inline$BDLSystemPowerIoCompletion$5$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_103_true#1, inline$BDLSystemPowerIoCompletion$5$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$5$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_104#1;

  inline$BDLSystemPowerIoCompletion$5$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$5$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$5$label_105#1;

  inline$BDLSystemPowerIoCompletion$5$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$5$label_104#1;

  inline$BDLSystemPowerIoCompletion$5$label_104#1:
    inline$BDLSystemPowerIoCompletion$5$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$5$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$5$label_1#1;

  inline$BDLSystemPowerIoCompletion$5$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$5$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$5$Return#1;

  inline$BDLSystemPowerIoCompletion$5$Return#1:
    inline$CallCompletionRoutine$5$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$5$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$5$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$5$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$5$anon14_Then#1, inline$CallCompletionRoutine$5$anon14_Else#1;

  inline$CallCompletionRoutine$5$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$5$anon9#1;

  inline$CallCompletionRoutine$5$anon9#1:
    goto inline$CallCompletionRoutine$5$label_20_icall_return#1;

  inline$CallCompletionRoutine$5$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$5$Return#1;

  inline$CallCompletionRoutine$5$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$5$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$5$Entry#1;

  inline$BDLDevicePowerIoCompletion$5$Entry#1:
    inline$BDLDevicePowerIoCompletion$5$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$5$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$5$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$5$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$5$start#1;

  inline$BDLDevicePowerIoCompletion$5$start#1:
    call inline$BDLDevicePowerIoCompletion$5$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$5$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$5$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$5$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$5$label_3#1;

  inline$BDLDevicePowerIoCompletion$5$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_4#1;

  inline$BDLDevicePowerIoCompletion$5$label_4#1:
    inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_5#1;

  inline$BDLDevicePowerIoCompletion$5$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_6#1;

  inline$BDLDevicePowerIoCompletion$5$label_6#1:
    inline$BDLDevicePowerIoCompletion$5$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$5$label_7#1;

  inline$BDLDevicePowerIoCompletion$5$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_8#1;

  inline$BDLDevicePowerIoCompletion$5$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$5$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$5$label_9#1;

  inline$BDLDevicePowerIoCompletion$5$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_10#1;

  inline$BDLDevicePowerIoCompletion$5$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$32$Entry#1;

  inline$IoGetCurrentIrpStackLocation$32$Entry#1:
    inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$32$start#1;

  inline$IoGetCurrentIrpStackLocation$32$start#1:
    inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$32$label_3#1;

  inline$IoGetCurrentIrpStackLocation$32$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$32$label_3_true#1, inline$IoGetCurrentIrpStackLocation$32$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$32$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$32$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$32$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$32$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$32$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$32$label_4#1;

  inline$IoGetCurrentIrpStackLocation$32$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$32$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$32$label_6#1;

  inline$IoGetCurrentIrpStackLocation$32$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$32$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$32$label_7#1;

  inline$IoGetCurrentIrpStackLocation$32$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$32$label_5#1;

  inline$IoGetCurrentIrpStackLocation$32$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$32$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$32$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$32$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$32$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$32$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$32$label_5#1;

  inline$IoGetCurrentIrpStackLocation$32$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$32$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$32$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$32$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$32$label_1#1;

  inline$IoGetCurrentIrpStackLocation$32$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$32$Return#1;

  inline$IoGetCurrentIrpStackLocation$32$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$32$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon30_Then#1, inline$BDLDevicePowerIoCompletion$5$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon1#1;

  inline$BDLDevicePowerIoCompletion$5$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_13#1;

  inline$BDLDevicePowerIoCompletion$5$label_13#1:
    inline$BDLDevicePowerIoCompletion$5$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$5$label_14#1;

  inline$BDLDevicePowerIoCompletion$5$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_15#1;

  inline$BDLDevicePowerIoCompletion$5$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$5$label_16#1;

  inline$BDLDevicePowerIoCompletion$5$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_17#1;

  inline$BDLDevicePowerIoCompletion$5$label_17#1:
    goto inline$BDLGetDebugLevel$133$Entry#1;

  inline$BDLGetDebugLevel$133$Entry#1:
    goto inline$BDLGetDebugLevel$133$start#1;

  inline$BDLGetDebugLevel$133$start#1:
    goto inline$BDLGetDebugLevel$133$label_3#1;

  inline$BDLGetDebugLevel$133$label_3#1:
    havoc inline$BDLGetDebugLevel$133$myNondetVar_0;
    inline$BDLGetDebugLevel$133$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$133$myNondetVar_0;
    goto inline$BDLGetDebugLevel$133$label_1#1;

  inline$BDLGetDebugLevel$133$label_1#1:
    goto inline$BDLGetDebugLevel$133$Return#1;

  inline$BDLGetDebugLevel$133$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$133$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon31_Then#1, inline$BDLDevicePowerIoCompletion$5$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon3#1;

  inline$BDLDevicePowerIoCompletion$5$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_20#1;

  inline$BDLDevicePowerIoCompletion$5$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_20_true#1, inline$BDLDevicePowerIoCompletion$5$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_21#1;

  inline$BDLDevicePowerIoCompletion$5$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_24#1;

  inline$BDLDevicePowerIoCompletion$5$label_24#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_25#1;

  inline$BDLDevicePowerIoCompletion$5$label_25#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_26#1;

  inline$BDLDevicePowerIoCompletion$5$label_26#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_27#1;

  inline$BDLDevicePowerIoCompletion$5$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$5$label_21#1;

  inline$BDLDevicePowerIoCompletion$5$label_21#1:
    goto inline$BDLGetDebugLevel$134$Entry#1;

  inline$BDLGetDebugLevel$134$Entry#1:
    goto inline$BDLGetDebugLevel$134$start#1;

  inline$BDLGetDebugLevel$134$start#1:
    goto inline$BDLGetDebugLevel$134$label_3#1;

  inline$BDLGetDebugLevel$134$label_3#1:
    havoc inline$BDLGetDebugLevel$134$myNondetVar_0;
    inline$BDLGetDebugLevel$134$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$134$myNondetVar_0;
    goto inline$BDLGetDebugLevel$134$label_1#1;

  inline$BDLGetDebugLevel$134$label_1#1:
    goto inline$BDLGetDebugLevel$134$Return#1;

  inline$BDLGetDebugLevel$134$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$134$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon32_Then#1, inline$BDLDevicePowerIoCompletion$5$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon5#1;

  inline$BDLDevicePowerIoCompletion$5$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_30#1;

  inline$BDLDevicePowerIoCompletion$5$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_30_true#1, inline$BDLDevicePowerIoCompletion$5$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_31#1;

  inline$BDLDevicePowerIoCompletion$5$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_34#1;

  inline$BDLDevicePowerIoCompletion$5$label_34#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_35#1;

  inline$BDLDevicePowerIoCompletion$5$label_35#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_36#1;

  inline$BDLDevicePowerIoCompletion$5$label_36#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_37#1;

  inline$BDLDevicePowerIoCompletion$5$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$5$label_31#1;

  inline$BDLDevicePowerIoCompletion$5$label_31#1:
    goto inline$BDLGetDebugLevel$135$Entry#1;

  inline$BDLGetDebugLevel$135$Entry#1:
    goto inline$BDLGetDebugLevel$135$start#1;

  inline$BDLGetDebugLevel$135$start#1:
    goto inline$BDLGetDebugLevel$135$label_3#1;

  inline$BDLGetDebugLevel$135$label_3#1:
    havoc inline$BDLGetDebugLevel$135$myNondetVar_0;
    inline$BDLGetDebugLevel$135$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$135$myNondetVar_0;
    goto inline$BDLGetDebugLevel$135$label_1#1;

  inline$BDLGetDebugLevel$135$label_1#1:
    goto inline$BDLGetDebugLevel$135$Return#1;

  inline$BDLGetDebugLevel$135$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$135$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon33_Then#1, inline$BDLDevicePowerIoCompletion$5$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon7#1;

  inline$BDLDevicePowerIoCompletion$5$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_40#1;

  inline$BDLDevicePowerIoCompletion$5$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_40_true#1, inline$BDLDevicePowerIoCompletion$5$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_41#1;

  inline$BDLDevicePowerIoCompletion$5$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_42#1;

  inline$BDLDevicePowerIoCompletion$5$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_41#1;

  inline$BDLDevicePowerIoCompletion$5$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_41_true#1, inline$BDLDevicePowerIoCompletion$5$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$5$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$5$label_43#1;

  inline$BDLDevicePowerIoCompletion$5$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$5$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$5$label_44#1;

  inline$BDLDevicePowerIoCompletion$5$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_44_true#1, inline$BDLDevicePowerIoCompletion$5$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$5$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$5$label_45#1;

  inline$BDLDevicePowerIoCompletion$5$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_45_true#1, inline$BDLDevicePowerIoCompletion$5$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$5$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$5$label_43#1;

  inline$BDLDevicePowerIoCompletion$5$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$5$label_86#1;

  inline$BDLDevicePowerIoCompletion$5$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$5$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$5$label_46#1;

  inline$BDLDevicePowerIoCompletion$5$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$5$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$5$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$5$label_46#1;

  inline$BDLDevicePowerIoCompletion$5$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$5$label_49#1;

  inline$BDLDevicePowerIoCompletion$5$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_50#1;

  inline$BDLDevicePowerIoCompletion$5$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_51#1;

  inline$BDLDevicePowerIoCompletion$5$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_54#1;

  inline$BDLDevicePowerIoCompletion$5$label_54#1:
    inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$5$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$5$label_55#1;

  inline$BDLDevicePowerIoCompletion$5$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_55_true#1, inline$BDLDevicePowerIoCompletion$5$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_56#1;

  inline$BDLDevicePowerIoCompletion$5$label_56#1:
    call inline$BDLDevicePowerIoCompletion$5$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$5$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$5$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$5$anon34_Then#1, inline$BDLDevicePowerIoCompletion$5$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon9#1;

  inline$BDLDevicePowerIoCompletion$5$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_83#1;

  inline$BDLDevicePowerIoCompletion$5$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_59#1;

  inline$BDLDevicePowerIoCompletion$5$label_59#1:
    goto inline$BDLGetDebugLevel$136$Entry#1;

  inline$BDLGetDebugLevel$136$Entry#1:
    goto inline$BDLGetDebugLevel$136$start#1;

  inline$BDLGetDebugLevel$136$start#1:
    goto inline$BDLGetDebugLevel$136$label_3#1;

  inline$BDLGetDebugLevel$136$label_3#1:
    havoc inline$BDLGetDebugLevel$136$myNondetVar_0;
    inline$BDLGetDebugLevel$136$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$136$myNondetVar_0;
    goto inline$BDLGetDebugLevel$136$label_1#1;

  inline$BDLGetDebugLevel$136$label_1#1:
    goto inline$BDLGetDebugLevel$136$Return#1;

  inline$BDLGetDebugLevel$136$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$136$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon35_Then#1, inline$BDLDevicePowerIoCompletion$5$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon11#1;

  inline$BDLDevicePowerIoCompletion$5$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_62#1;

  inline$BDLDevicePowerIoCompletion$5$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_62_true#1, inline$BDLDevicePowerIoCompletion$5$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_63#1;

  inline$BDLDevicePowerIoCompletion$5$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_66#1;

  inline$BDLDevicePowerIoCompletion$5$label_66#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_67#1;

  inline$BDLDevicePowerIoCompletion$5$label_67#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_68#1;

  inline$BDLDevicePowerIoCompletion$5$label_68#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_69#1;

  inline$BDLDevicePowerIoCompletion$5$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$5$label_63#1;

  inline$BDLDevicePowerIoCompletion$5$label_63#1:
    goto inline$BDLGetDebugLevel$137$Entry#1;

  inline$BDLGetDebugLevel$137$Entry#1:
    goto inline$BDLGetDebugLevel$137$start#1;

  inline$BDLGetDebugLevel$137$start#1:
    goto inline$BDLGetDebugLevel$137$label_3#1;

  inline$BDLGetDebugLevel$137$label_3#1:
    havoc inline$BDLGetDebugLevel$137$myNondetVar_0;
    inline$BDLGetDebugLevel$137$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$137$myNondetVar_0;
    goto inline$BDLGetDebugLevel$137$label_1#1;

  inline$BDLGetDebugLevel$137$label_1#1:
    goto inline$BDLGetDebugLevel$137$Return#1;

  inline$BDLGetDebugLevel$137$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$137$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon36_Then#1, inline$BDLDevicePowerIoCompletion$5$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon13#1;

  inline$BDLDevicePowerIoCompletion$5$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_72#1;

  inline$BDLDevicePowerIoCompletion$5$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_72_true#1, inline$BDLDevicePowerIoCompletion$5$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_73#1;

  inline$BDLDevicePowerIoCompletion$5$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_76#1;

  inline$BDLDevicePowerIoCompletion$5$label_76#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_77#1;

  inline$BDLDevicePowerIoCompletion$5$label_77#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_78#1;

  inline$BDLDevicePowerIoCompletion$5$label_78#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_79#1;

  inline$BDLDevicePowerIoCompletion$5$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$5$label_73#1;

  inline$BDLDevicePowerIoCompletion$5$label_73#1:
    goto inline$BDLGetDebugLevel$138$Entry#1;

  inline$BDLGetDebugLevel$138$Entry#1:
    goto inline$BDLGetDebugLevel$138$start#1;

  inline$BDLGetDebugLevel$138$start#1:
    goto inline$BDLGetDebugLevel$138$label_3#1;

  inline$BDLGetDebugLevel$138$label_3#1:
    havoc inline$BDLGetDebugLevel$138$myNondetVar_0;
    inline$BDLGetDebugLevel$138$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$138$myNondetVar_0;
    goto inline$BDLGetDebugLevel$138$label_1#1;

  inline$BDLGetDebugLevel$138$label_1#1:
    goto inline$BDLGetDebugLevel$138$Return#1;

  inline$BDLGetDebugLevel$138$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$138$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon37_Then#1, inline$BDLDevicePowerIoCompletion$5$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon15#1;

  inline$BDLDevicePowerIoCompletion$5$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_82#1;

  inline$BDLDevicePowerIoCompletion$5$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_82_true#1, inline$BDLDevicePowerIoCompletion$5$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_83#1;

  inline$BDLDevicePowerIoCompletion$5$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_84#1;

  inline$BDLDevicePowerIoCompletion$5$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_83#1;

  inline$BDLDevicePowerIoCompletion$5$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_85#1;

  inline$BDLDevicePowerIoCompletion$5$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_86#1;

  inline$BDLDevicePowerIoCompletion$5$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$5$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$5$anon38_Then#1, inline$BDLDevicePowerIoCompletion$5$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon17#1;

  inline$BDLDevicePowerIoCompletion$5$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_89#1;

  inline$BDLDevicePowerIoCompletion$5$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$5$anon39_Then#1, inline$BDLDevicePowerIoCompletion$5$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon19#1;

  inline$BDLDevicePowerIoCompletion$5$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_92#1;

  inline$BDLDevicePowerIoCompletion$5$label_92#1:
    goto inline$storm_IoCompleteRequest$11$Entry#1;

  inline$storm_IoCompleteRequest$11$Entry#1:
    inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$5$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$11$start#1;

  inline$storm_IoCompleteRequest$11$start#1:
    inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$11$label_3#1;

  inline$storm_IoCompleteRequest$11$label_3#1:
    call inline$storm_IoCompleteRequest$11$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$11$label_6#1;

  inline$storm_IoCompleteRequest$11$label_6#1:
    goto inline$storm_IoCompleteRequest$11$label_6_true#1, inline$storm_IoCompleteRequest$11$label_6_false#1;

  inline$storm_IoCompleteRequest$11$label_6_false#1:
    assume inline$storm_IoCompleteRequest$11$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$11$label_7#1;

  inline$storm_IoCompleteRequest$11$label_6_true#1:
    assume inline$storm_IoCompleteRequest$11$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$11$label_8#1;

  inline$storm_IoCompleteRequest$11$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$11$anon3_Then#1, inline$storm_IoCompleteRequest$11$anon3_Else#1;

  inline$storm_IoCompleteRequest$11$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$11$anon1#1;

  inline$storm_IoCompleteRequest$11$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$11$label_9#1;

  inline$storm_IoCompleteRequest$11$label_9#1:
    goto inline$storm_IoCompleteRequest$11$label_9_true#1, inline$storm_IoCompleteRequest$11$label_9_false#1;

  inline$storm_IoCompleteRequest$11$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$11$label_10#1;

  inline$storm_IoCompleteRequest$11$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$11$label_1#1;

  inline$storm_IoCompleteRequest$11$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$11$label_7#1;

  inline$storm_IoCompleteRequest$11$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$11$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$11$label_1#1;

  inline$storm_IoCompleteRequest$11$label_1#1:
    goto inline$storm_IoCompleteRequest$11$Return#1;

  inline$storm_IoCompleteRequest$11$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$11$Return#1;

  inline$storm_IoCompleteRequest$11$Return#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon40_Then#1, inline$BDLDevicePowerIoCompletion$5$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon21#1;

  inline$BDLDevicePowerIoCompletion$5$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_95#1;

  inline$BDLDevicePowerIoCompletion$5$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$5$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$5$anon41_Then#1, inline$BDLDevicePowerIoCompletion$5$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon23#1;

  inline$BDLDevicePowerIoCompletion$5$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_98#1;

  inline$BDLDevicePowerIoCompletion$5$label_98#1:
    goto inline$BDLGetDebugLevel$139$Entry#1;

  inline$BDLGetDebugLevel$139$Entry#1:
    goto inline$BDLGetDebugLevel$139$start#1;

  inline$BDLGetDebugLevel$139$start#1:
    goto inline$BDLGetDebugLevel$139$label_3#1;

  inline$BDLGetDebugLevel$139$label_3#1:
    havoc inline$BDLGetDebugLevel$139$myNondetVar_0;
    inline$BDLGetDebugLevel$139$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$139$myNondetVar_0;
    goto inline$BDLGetDebugLevel$139$label_1#1;

  inline$BDLGetDebugLevel$139$label_1#1:
    goto inline$BDLGetDebugLevel$139$Return#1;

  inline$BDLGetDebugLevel$139$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$139$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon42_Then#1, inline$BDLDevicePowerIoCompletion$5$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon25#1;

  inline$BDLDevicePowerIoCompletion$5$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_101#1;

  inline$BDLDevicePowerIoCompletion$5$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_101_true#1, inline$BDLDevicePowerIoCompletion$5$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_102#1;

  inline$BDLDevicePowerIoCompletion$5$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_105#1;

  inline$BDLDevicePowerIoCompletion$5$label_105#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_106#1;

  inline$BDLDevicePowerIoCompletion$5$label_106#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_107#1;

  inline$BDLDevicePowerIoCompletion$5$label_107#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_108#1;

  inline$BDLDevicePowerIoCompletion$5$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$5$label_102#1;

  inline$BDLDevicePowerIoCompletion$5$label_102#1:
    goto inline$BDLGetDebugLevel$140$Entry#1;

  inline$BDLGetDebugLevel$140$Entry#1:
    goto inline$BDLGetDebugLevel$140$start#1;

  inline$BDLGetDebugLevel$140$start#1:
    goto inline$BDLGetDebugLevel$140$label_3#1;

  inline$BDLGetDebugLevel$140$label_3#1:
    havoc inline$BDLGetDebugLevel$140$myNondetVar_0;
    inline$BDLGetDebugLevel$140$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$140$myNondetVar_0;
    goto inline$BDLGetDebugLevel$140$label_1#1;

  inline$BDLGetDebugLevel$140$label_1#1:
    goto inline$BDLGetDebugLevel$140$Return#1;

  inline$BDLGetDebugLevel$140$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$140$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon43_Then#1, inline$BDLDevicePowerIoCompletion$5$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon27#1;

  inline$BDLDevicePowerIoCompletion$5$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_111#1;

  inline$BDLDevicePowerIoCompletion$5$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_111_true#1, inline$BDLDevicePowerIoCompletion$5$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_112#1;

  inline$BDLDevicePowerIoCompletion$5$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_115#1;

  inline$BDLDevicePowerIoCompletion$5$label_115#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_116#1;

  inline$BDLDevicePowerIoCompletion$5$label_116#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_117#1;

  inline$BDLDevicePowerIoCompletion$5$label_117#1:
    call inline$BDLDevicePowerIoCompletion$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$5$label_118#1;

  inline$BDLDevicePowerIoCompletion$5$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$5$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$5$label_112#1;

  inline$BDLDevicePowerIoCompletion$5$label_112#1:
    goto inline$BDLGetDebugLevel$141$Entry#1;

  inline$BDLGetDebugLevel$141$Entry#1:
    goto inline$BDLGetDebugLevel$141$start#1;

  inline$BDLGetDebugLevel$141$start#1:
    goto inline$BDLGetDebugLevel$141$label_3#1;

  inline$BDLGetDebugLevel$141$label_3#1:
    havoc inline$BDLGetDebugLevel$141$myNondetVar_0;
    inline$BDLGetDebugLevel$141$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$141$myNondetVar_0;
    goto inline$BDLGetDebugLevel$141$label_1#1;

  inline$BDLGetDebugLevel$141$label_1#1:
    goto inline$BDLGetDebugLevel$141$Return#1;

  inline$BDLGetDebugLevel$141$Return#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$141$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$5$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$5$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$5$anon44_Then#1, inline$BDLDevicePowerIoCompletion$5$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$5$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$anon29#1;

  inline$BDLDevicePowerIoCompletion$5$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_121#1;

  inline$BDLDevicePowerIoCompletion$5$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_121_true#1, inline$BDLDevicePowerIoCompletion$5$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$5$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_122#1;

  inline$BDLDevicePowerIoCompletion$5$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$5$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$5$label_123#1;

  inline$BDLDevicePowerIoCompletion$5$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$5$label_122#1;

  inline$BDLDevicePowerIoCompletion$5$label_122#1:
    inline$BDLDevicePowerIoCompletion$5$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$5$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$5$label_1#1;

  inline$BDLDevicePowerIoCompletion$5$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$5$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$5$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$5$Return#1;

  inline$BDLDevicePowerIoCompletion$5$Return#1:
    inline$CallCompletionRoutine$5$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$5$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$5$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$5$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$5$anon13_Then#1, inline$CallCompletionRoutine$5$anon13_Else#1;

  inline$CallCompletionRoutine$5$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$5$anon7#1;

  inline$CallCompletionRoutine$5$anon7#1:
    goto inline$CallCompletionRoutine$5$label_20_icall_return#1;

  inline$CallCompletionRoutine$5$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$5$Return#1;

  inline$CallCompletionRoutine$5$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$5$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$5$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$5$Entry#1;

  inline$BDLCallDriverCompletionRoutine$5$Entry#1:
    inline$BDLCallDriverCompletionRoutine$5$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$5$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$5$start#1;

  inline$BDLCallDriverCompletionRoutine$5$start#1:
    inline$BDLCallDriverCompletionRoutine$5$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$5$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$5$label_3#1;

  inline$BDLCallDriverCompletionRoutine$5$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$5$label_3_true#1, inline$BDLCallDriverCompletionRoutine$5$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$5$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$5$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$5$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$5$label_4#1;

  inline$BDLCallDriverCompletionRoutine$5$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$5$label_6#1;

  inline$BDLCallDriverCompletionRoutine$5$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$5$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$5$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$5$label_5#1;

  inline$BDLCallDriverCompletionRoutine$5$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$5$label_6#1;

  inline$BDLCallDriverCompletionRoutine$5$label_6#1:
    goto inline$storm_KeSetEvent$6$Entry#1;

  inline$storm_KeSetEvent$6$Entry#1:
    inline$storm_KeSetEvent$6$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$5$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$6$start#1;

  inline$storm_KeSetEvent$6$start#1:
    inline$storm_KeSetEvent$6$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$6$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$6$label_3#1;

  inline$storm_KeSetEvent$6$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$6$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$6$label_1#1;

  inline$storm_KeSetEvent$6$label_1#1:
    goto inline$storm_KeSetEvent$6$Return#1;

  inline$storm_KeSetEvent$6$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$5$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$5$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$5$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$5$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$5$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$5$anon1#1;

  inline$BDLCallDriverCompletionRoutine$5$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$5$label_9#1;

  inline$BDLCallDriverCompletionRoutine$5$label_9#1:
    inline$BDLCallDriverCompletionRoutine$5$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$5$label_1#1;

  inline$BDLCallDriverCompletionRoutine$5$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$5$Return#1;

  inline$BDLCallDriverCompletionRoutine$5$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$5$Return#1;

  inline$BDLCallDriverCompletionRoutine$5$Return#1:
    inline$CallCompletionRoutine$5$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$5$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$5$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$5$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$5$anon12_Then#1, inline$CallCompletionRoutine$5$anon12_Else#1;

  inline$CallCompletionRoutine$5$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$5$anon5#1;

  inline$CallCompletionRoutine$5$anon5#1:
    goto inline$CallCompletionRoutine$5$label_20_icall_return#1;

  inline$CallCompletionRoutine$5$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$5$label_23#1;

  inline$CallCompletionRoutine$5$label_23#1:
    inline$CallCompletionRoutine$5$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$5$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$5$label_24#1;

  inline$CallCompletionRoutine$5$label_24#1:
    goto inline$CallCompletionRoutine$5$label_24_true#1, inline$CallCompletionRoutine$5$label_24_false#1;

  inline$CallCompletionRoutine$5$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$5$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$5$label_1#1;

  inline$CallCompletionRoutine$5$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$5$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$5$label_25#1;

  inline$CallCompletionRoutine$5$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$5$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$5$label_1#1;

  inline$CallCompletionRoutine$5$label_1#1:
    goto inline$CallCompletionRoutine$5$Return#1;

  inline$CallCompletionRoutine$5$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$5$Return#1;

  inline$CallCompletionRoutine$5$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$5$Return#1;

  inline$CallCompletionRoutine$5$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$5$Return#1;

  inline$CallCompletionRoutine$5$Return#1:
    goto inline$storm_IoCallDriver$2$label_39$1#1;

  inline$storm_IoCallDriver$2$label_39$1#1:
    goto inline$storm_IoCallDriver$2$anon15_Then#1, inline$storm_IoCallDriver$2$anon15_Else#1;

  inline$storm_IoCallDriver$2$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$2$anon10#1;

  inline$storm_IoCallDriver$2$anon10#1:
    goto inline$storm_IoCallDriver$2$label_36#1;

  inline$storm_IoCallDriver$2$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$2$Return#1;

  inline$storm_IoCallDriver$2$label_27_case_0#1:
    assume inline$storm_IoCallDriver$2$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$2$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$2$label_28#1;

  inline$storm_IoCallDriver$2$label_28#1:
    inline$storm_IoCallDriver$2$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$2$label_42#1;

  inline$storm_IoCallDriver$2$label_42#1:
    goto inline$storm_IoCallDriver$2$label_43#1;

  inline$storm_IoCallDriver$2$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$2$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$2$label_36#1;

  inline$storm_IoCallDriver$2$label_36#1:
    inline$storm_IoCallDriver$2$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$2$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$2$label_1#1;

  inline$storm_IoCallDriver$2$label_1#1:
    goto inline$storm_IoCallDriver$2$Return#1;

  inline$storm_IoCallDriver$2$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$2$Return#1;

  inline$storm_IoCallDriver$2$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$2$Return#1;

  inline$storm_IoCallDriver$2$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$2$Return#1;

  inline$storm_IoCallDriver$2$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_IoCallDriver$108.29$4$ := inline$storm_IoCallDriver$2$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_19$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_19$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon20_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon20_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon9#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon9#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_42#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_42#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_IoCallDriver$108.29$4$;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_18_true#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0;
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_22#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_22#1:
    call PoStartNextPowerIrp(inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon21_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon21_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon21_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon11#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon11#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_25#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_25#1:
    goto inline$storm_PoCallDriver$1$Entry#1;

  inline$storm_PoCallDriver$1$Entry#1:
    inline$storm_PoCallDriver$1$$Irp$2$496.14$storm_PoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_PoCallDriver$1$start#1;

  inline$storm_PoCallDriver$1$start#1:
    inline$storm_PoCallDriver$1$$Irp$2$496.14$storm_PoCallDriver$8 := inline$storm_PoCallDriver$1$$Irp$2$496.14$storm_PoCallDriver$8_.1;
    goto inline$storm_PoCallDriver$1$label_3#1;

  inline$storm_PoCallDriver$1$label_3#1:
    goto inline$storm_IoCallDriver$3$Entry#1;

  inline$storm_IoCallDriver$3$Entry#1:
    inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$storm_PoCallDriver$1$$Irp$2$496.14$storm_PoCallDriver$8;
    goto inline$storm_IoCallDriver$3$start#1;

  inline$storm_IoCallDriver$3$start#1:
    inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$3$label_3#1;

  inline$storm_IoCallDriver$3$label_3#1:
    goto inline$storm_IoCallDriver$3$label_4#1;

  inline$storm_IoCallDriver$3$label_4#1:
    goto inline$storm_IoCallDriver$3$label_5#1;

  inline$storm_IoCallDriver$3$label_5#1:
    goto inline$storm_IoCallDriver$3$label_6#1;

  inline$storm_IoCallDriver$3$label_6#1:
    call inline$storm_IoCallDriver$3$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$3$label_9#1;

  inline$storm_IoCallDriver$3$label_9#1:
    goto inline$storm_IoCallDriver$3$label_9_true#1, inline$storm_IoCallDriver$3$label_9_false#1;

  inline$storm_IoCallDriver$3$label_9_false#1:
    assume inline$storm_IoCallDriver$3$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$3$label_10#1;

  inline$storm_IoCallDriver$3$label_9_true#1:
    assume inline$storm_IoCallDriver$3$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$3$label_13#1;

  inline$storm_IoCallDriver$3$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$3$anon12_Then#1, inline$storm_IoCallDriver$3$anon12_Else#1;

  inline$storm_IoCallDriver$3$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$3$anon3#1;

  inline$storm_IoCallDriver$3$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$3$label_14#1;

  inline$storm_IoCallDriver$3$label_14#1:
    goto inline$storm_IoCallDriver$3$label_14_true#1, inline$storm_IoCallDriver$3$label_14_false#1;

  inline$storm_IoCallDriver$3$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$3$label_15#1;

  inline$storm_IoCallDriver$3$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$3$label_1#1;

  inline$storm_IoCallDriver$3$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$3$label_10#1;

  inline$storm_IoCallDriver$3$label_10#1:
    goto inline$IoSetNextIrpStackLocation$4$Entry#1;

  inline$IoSetNextIrpStackLocation$4$Entry#1:
    inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$4$start#1;

  inline$IoSetNextIrpStackLocation$4$start#1:
    inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$4$label_3#1;

  inline$IoSetNextIrpStackLocation$4$label_3#1:
    goto inline$IoSetNextIrpStackLocation$4$label_3_true#1, inline$IoSetNextIrpStackLocation$4$label_3_false#1;

  inline$IoSetNextIrpStackLocation$4$label_3_false#1:
    inline$IoSetNextIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$4$myVar_0);
    goto inline$IoSetNextIrpStackLocation$4$label_4#1;

  inline$IoSetNextIrpStackLocation$4$label_4#1:
    call inline$IoSetNextIrpStackLocation$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$4$label_7#1;

  inline$IoSetNextIrpStackLocation$4$label_7#1:
    call inline$IoSetNextIrpStackLocation$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$4$label_8#1;

  inline$IoSetNextIrpStackLocation$4$label_8#1:
    goto inline$IoSetNextIrpStackLocation$4$label_5#1;

  inline$IoSetNextIrpStackLocation$4$label_3_true#1:
    inline$IoSetNextIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$4$myVar_0);
    goto inline$IoSetNextIrpStackLocation$4$label_5#1;

  inline$IoSetNextIrpStackLocation$4$label_5#1:
    inline$IoSetNextIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$4$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$4$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$4$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$4$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$4$label_6#1;

  inline$IoSetNextIrpStackLocation$4$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$4$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$4$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$4$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$4$label_1#1;

  inline$IoSetNextIrpStackLocation$4$label_1#1:
    goto inline$IoSetNextIrpStackLocation$4$Return#1;

  inline$IoSetNextIrpStackLocation$4$Return#1:
    goto inline$storm_IoCallDriver$3$label_10$1#1;

  inline$storm_IoCallDriver$3$label_10$1#1:
    goto inline$storm_IoCallDriver$3$anon11_Then#1, inline$storm_IoCallDriver$3$anon11_Else#1;

  inline$storm_IoCallDriver$3$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$3$anon1#1;

  inline$storm_IoCallDriver$3$anon1#1:
    goto inline$storm_IoCallDriver$3$label_18#1;

  inline$storm_IoCallDriver$3$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$34$Entry#1;

  inline$IoGetCurrentIrpStackLocation$34$Entry#1:
    inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$34$start#1;

  inline$IoGetCurrentIrpStackLocation$34$start#1:
    inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$34$label_3#1;

  inline$IoGetCurrentIrpStackLocation$34$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$34$label_3_true#1, inline$IoGetCurrentIrpStackLocation$34$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$34$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$34$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$34$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$34$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$34$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$34$label_4#1;

  inline$IoGetCurrentIrpStackLocation$34$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$34$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$34$label_6#1;

  inline$IoGetCurrentIrpStackLocation$34$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$34$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$34$label_7#1;

  inline$IoGetCurrentIrpStackLocation$34$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$34$label_5#1;

  inline$IoGetCurrentIrpStackLocation$34$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$34$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$34$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$34$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$34$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$34$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$34$label_5#1;

  inline$IoGetCurrentIrpStackLocation$34$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$34$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$34$label_1#1;

  inline$IoGetCurrentIrpStackLocation$34$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$34$Return#1;

  inline$IoGetCurrentIrpStackLocation$34$Return#1:
    goto inline$storm_IoCallDriver$3$label_18$1#1;

  inline$storm_IoCallDriver$3$label_18$1#1:
    goto inline$storm_IoCallDriver$3$anon13_Then#1, inline$storm_IoCallDriver$3$anon13_Else#1;

  inline$storm_IoCallDriver$3$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$3$anon6#1;

  inline$storm_IoCallDriver$3$anon6#1:
    goto inline$storm_IoCallDriver$3$label_21#1;

  inline$storm_IoCallDriver$3$label_21#1:
    goto inline$storm_IoCallDriver$3$label_22#1;

  inline$storm_IoCallDriver$3$label_22#1:
    goto inline$storm_IoCallDriver$3$label_23#1;

  inline$storm_IoCallDriver$3$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$3$label_24#1;

  inline$storm_IoCallDriver$3$label_24#1:
    call inline$storm_IoCallDriver$3$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$3$label_27#1;

  inline$storm_IoCallDriver$3$label_27#1:
    goto inline$storm_IoCallDriver$3$label_27_case_0#1, inline$storm_IoCallDriver$3$label_27_case_1#1, inline$storm_IoCallDriver$3$label_27_case_2#1;

  inline$storm_IoCallDriver$3$label_27_case_2#1:
    assume inline$storm_IoCallDriver$3$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$3$label_30#1;

  inline$storm_IoCallDriver$3$label_30#1:
    inline$storm_IoCallDriver$3$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$3$label_31#1;

  inline$storm_IoCallDriver$3$label_31#1:
    goto inline$storm_IoCallDriver$3$label_32#1;

  inline$storm_IoCallDriver$3$label_32#1:
    goto inline$storm_IoCallDriver$3$label_33#1;

  inline$storm_IoCallDriver$3$label_33#1:
    goto inline$CallCompletionRoutine$6$Entry#1;

  inline$CallCompletionRoutine$6$Entry#1:
    inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$6$start#1;

  inline$CallCompletionRoutine$6$start#1:
    inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$6$label_3#1;

  inline$CallCompletionRoutine$6$label_3#1:
    goto inline$CallCompletionRoutine$6$label_4#1;

  inline$CallCompletionRoutine$6$label_4#1:
    goto inline$CallCompletionRoutine$6$label_5#1;

  inline$CallCompletionRoutine$6$label_5#1:
    goto inline$CallCompletionRoutine$6$label_6#1;

  inline$CallCompletionRoutine$6$label_6#1:
    goto inline$CallCompletionRoutine$6$label_7#1;

  inline$CallCompletionRoutine$6$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$35$Entry#1;

  inline$IoGetCurrentIrpStackLocation$35$Entry#1:
    inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$35$start#1;

  inline$IoGetCurrentIrpStackLocation$35$start#1:
    inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$35$label_3#1;

  inline$IoGetCurrentIrpStackLocation$35$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$35$label_3_true#1, inline$IoGetCurrentIrpStackLocation$35$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$35$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$35$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$35$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$35$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$35$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$35$label_4#1;

  inline$IoGetCurrentIrpStackLocation$35$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$35$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$35$label_6#1;

  inline$IoGetCurrentIrpStackLocation$35$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$35$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$35$label_7#1;

  inline$IoGetCurrentIrpStackLocation$35$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$35$label_5#1;

  inline$IoGetCurrentIrpStackLocation$35$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$35$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$35$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$35$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$35$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$35$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$35$label_5#1;

  inline$IoGetCurrentIrpStackLocation$35$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$35$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$35$label_1#1;

  inline$IoGetCurrentIrpStackLocation$35$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$35$Return#1;

  inline$IoGetCurrentIrpStackLocation$35$Return#1:
    goto inline$CallCompletionRoutine$6$label_7$1#1;

  inline$CallCompletionRoutine$6$label_7$1#1:
    goto inline$CallCompletionRoutine$6$anon10_Then#1, inline$CallCompletionRoutine$6$anon10_Else#1;

  inline$CallCompletionRoutine$6$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$6$anon1#1;

  inline$CallCompletionRoutine$6$anon1#1:
    goto inline$CallCompletionRoutine$6$label_10#1;

  inline$CallCompletionRoutine$6$label_10#1:
    goto inline$CallCompletionRoutine$6$label_11#1;

  inline$CallCompletionRoutine$6$label_11#1:
    havoc inline$CallCompletionRoutine$6$myNondetVar_0;
    inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$6$myNondetVar_0;
    goto inline$CallCompletionRoutine$6$label_12#1;

  inline$CallCompletionRoutine$6$label_12#1:
    havoc inline$CallCompletionRoutine$6$myNondetVar_0;
    inline$CallCompletionRoutine$6$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$6$myNondetVar_0;
    goto inline$CallCompletionRoutine$6$label_13#1;

  inline$CallCompletionRoutine$6$label_13#1:
    havoc inline$CallCompletionRoutine$6$myNondetVar_0;
    goto inline$CallCompletionRoutine$6$label_14#1;

  inline$CallCompletionRoutine$6$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$36$Entry#1;

  inline$IoGetCurrentIrpStackLocation$36$Entry#1:
    inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$36$start#1;

  inline$IoGetCurrentIrpStackLocation$36$start#1:
    inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$36$label_3#1;

  inline$IoGetCurrentIrpStackLocation$36$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$36$label_3_true#1, inline$IoGetCurrentIrpStackLocation$36$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$36$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$36$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$36$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$36$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$36$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$36$label_4#1;

  inline$IoGetCurrentIrpStackLocation$36$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$36$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$36$label_6#1;

  inline$IoGetCurrentIrpStackLocation$36$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$36$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$36$label_7#1;

  inline$IoGetCurrentIrpStackLocation$36$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$36$label_5#1;

  inline$IoGetCurrentIrpStackLocation$36$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$36$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$36$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$36$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$36$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$36$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$36$label_5#1;

  inline$IoGetCurrentIrpStackLocation$36$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$36$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$36$label_1#1;

  inline$IoGetCurrentIrpStackLocation$36$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$36$Return#1;

  inline$IoGetCurrentIrpStackLocation$36$Return#1:
    goto inline$CallCompletionRoutine$6$label_14$1#1;

  inline$CallCompletionRoutine$6$label_14$1#1:
    goto inline$CallCompletionRoutine$6$anon11_Then#1, inline$CallCompletionRoutine$6$anon11_Else#1;

  inline$CallCompletionRoutine$6$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$6$anon3#1;

  inline$CallCompletionRoutine$6$anon3#1:
    goto inline$CallCompletionRoutine$6$label_17#1;

  inline$CallCompletionRoutine$6$label_17#1:
    goto inline$CallCompletionRoutine$6$label_18#1;

  inline$CallCompletionRoutine$6$label_18#1:
    goto inline$CallCompletionRoutine$6$label_18_true#1, inline$CallCompletionRoutine$6$label_18_false#1;

  inline$CallCompletionRoutine$6$label_18_false#1:
    assume inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$6$label_1#1;

  inline$CallCompletionRoutine$6$label_18_true#1:
    assume inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$6$label_19#1;

  inline$CallCompletionRoutine$6$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$6$label_20#1;

  inline$CallCompletionRoutine$6$label_20#1:
    goto inline$CallCompletionRoutine$6$label_20_icall_1#1, inline$CallCompletionRoutine$6$label_20_icall_2#1, inline$CallCompletionRoutine$6$label_20_icall_3#1;

  inline$CallCompletionRoutine$6$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$6$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$6$Entry#1;

  inline$BDLSystemPowerIoCompletion$6$Entry#1:
    inline$BDLSystemPowerIoCompletion$6$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$6$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$6$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$6$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$6$start#1;

  inline$BDLSystemPowerIoCompletion$6$start#1:
    call inline$BDLSystemPowerIoCompletion$6$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$6$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$6$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$6$label_3#1;

  inline$BDLSystemPowerIoCompletion$6$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_4#1;

  inline$BDLSystemPowerIoCompletion$6$label_4#1:
    inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_5#1;

  inline$BDLSystemPowerIoCompletion$6$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_6#1;

  inline$BDLSystemPowerIoCompletion$6$label_6#1:
    inline$BDLSystemPowerIoCompletion$6$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$6$label_7#1;

  inline$BDLSystemPowerIoCompletion$6$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_8#1;

  inline$BDLSystemPowerIoCompletion$6$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$6$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$6$label_9#1;

  inline$BDLSystemPowerIoCompletion$6$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_10#1;

  inline$BDLSystemPowerIoCompletion$6$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$38$Entry#1;

  inline$IoGetCurrentIrpStackLocation$38$Entry#1:
    inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$38$start#1;

  inline$IoGetCurrentIrpStackLocation$38$start#1:
    inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$38$label_3#1;

  inline$IoGetCurrentIrpStackLocation$38$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$38$label_3_true#1, inline$IoGetCurrentIrpStackLocation$38$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$38$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$38$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$38$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$38$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$38$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$38$label_4#1;

  inline$IoGetCurrentIrpStackLocation$38$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$38$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$38$label_6#1;

  inline$IoGetCurrentIrpStackLocation$38$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$38$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$38$label_7#1;

  inline$IoGetCurrentIrpStackLocation$38$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$38$label_5#1;

  inline$IoGetCurrentIrpStackLocation$38$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$38$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$38$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$38$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$38$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$38$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$38$label_5#1;

  inline$IoGetCurrentIrpStackLocation$38$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$38$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$38$label_1#1;

  inline$IoGetCurrentIrpStackLocation$38$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$38$Return#1;

  inline$IoGetCurrentIrpStackLocation$38$Return#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon36_Then#1, inline$BDLSystemPowerIoCompletion$6$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon1#1;

  inline$BDLSystemPowerIoCompletion$6$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_13#1;

  inline$BDLSystemPowerIoCompletion$6$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_14#1;

  inline$BDLSystemPowerIoCompletion$6$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_15#1;

  inline$BDLSystemPowerIoCompletion$6$label_15#1:
    goto inline$BDLGetDebugLevel$163$Entry#1;

  inline$BDLGetDebugLevel$163$Entry#1:
    goto inline$BDLGetDebugLevel$163$start#1;

  inline$BDLGetDebugLevel$163$start#1:
    goto inline$BDLGetDebugLevel$163$label_3#1;

  inline$BDLGetDebugLevel$163$label_3#1:
    havoc inline$BDLGetDebugLevel$163$myNondetVar_0;
    inline$BDLGetDebugLevel$163$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$163$myNondetVar_0;
    goto inline$BDLGetDebugLevel$163$label_1#1;

  inline$BDLGetDebugLevel$163$label_1#1:
    goto inline$BDLGetDebugLevel$163$Return#1;

  inline$BDLGetDebugLevel$163$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$163$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon37_Then#1, inline$BDLSystemPowerIoCompletion$6$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon3#1;

  inline$BDLSystemPowerIoCompletion$6$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_18#1;

  inline$BDLSystemPowerIoCompletion$6$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_18_true#1, inline$BDLSystemPowerIoCompletion$6$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_19#1;

  inline$BDLSystemPowerIoCompletion$6$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_22#1;

  inline$BDLSystemPowerIoCompletion$6$label_22#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_23#1;

  inline$BDLSystemPowerIoCompletion$6$label_23#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_24#1;

  inline$BDLSystemPowerIoCompletion$6$label_24#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_25#1;

  inline$BDLSystemPowerIoCompletion$6$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$6$label_19#1;

  inline$BDLSystemPowerIoCompletion$6$label_19#1:
    goto inline$BDLGetDebugLevel$164$Entry#1;

  inline$BDLGetDebugLevel$164$Entry#1:
    goto inline$BDLGetDebugLevel$164$start#1;

  inline$BDLGetDebugLevel$164$start#1:
    goto inline$BDLGetDebugLevel$164$label_3#1;

  inline$BDLGetDebugLevel$164$label_3#1:
    havoc inline$BDLGetDebugLevel$164$myNondetVar_0;
    inline$BDLGetDebugLevel$164$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$164$myNondetVar_0;
    goto inline$BDLGetDebugLevel$164$label_1#1;

  inline$BDLGetDebugLevel$164$label_1#1:
    goto inline$BDLGetDebugLevel$164$Return#1;

  inline$BDLGetDebugLevel$164$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$164$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon38_Then#1, inline$BDLSystemPowerIoCompletion$6$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon5#1;

  inline$BDLSystemPowerIoCompletion$6$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_28#1;

  inline$BDLSystemPowerIoCompletion$6$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_28_true#1, inline$BDLSystemPowerIoCompletion$6$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_29#1;

  inline$BDLSystemPowerIoCompletion$6$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_32#1;

  inline$BDLSystemPowerIoCompletion$6$label_32#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_33#1;

  inline$BDLSystemPowerIoCompletion$6$label_33#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_34#1;

  inline$BDLSystemPowerIoCompletion$6$label_34#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_35#1;

  inline$BDLSystemPowerIoCompletion$6$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$6$label_29#1;

  inline$BDLSystemPowerIoCompletion$6$label_29#1:
    goto inline$BDLGetDebugLevel$165$Entry#1;

  inline$BDLGetDebugLevel$165$Entry#1:
    goto inline$BDLGetDebugLevel$165$start#1;

  inline$BDLGetDebugLevel$165$start#1:
    goto inline$BDLGetDebugLevel$165$label_3#1;

  inline$BDLGetDebugLevel$165$label_3#1:
    havoc inline$BDLGetDebugLevel$165$myNondetVar_0;
    inline$BDLGetDebugLevel$165$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$165$myNondetVar_0;
    goto inline$BDLGetDebugLevel$165$label_1#1;

  inline$BDLGetDebugLevel$165$label_1#1:
    goto inline$BDLGetDebugLevel$165$Return#1;

  inline$BDLGetDebugLevel$165$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$165$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon39_Then#1, inline$BDLSystemPowerIoCompletion$6$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon7#1;

  inline$BDLSystemPowerIoCompletion$6$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_38#1;

  inline$BDLSystemPowerIoCompletion$6$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_38_true#1, inline$BDLSystemPowerIoCompletion$6$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_39#1;

  inline$BDLSystemPowerIoCompletion$6$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_40#1;

  inline$BDLSystemPowerIoCompletion$6$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_39#1;

  inline$BDLSystemPowerIoCompletion$6$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_39_true#1, inline$BDLSystemPowerIoCompletion$6$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_41#1;

  inline$BDLSystemPowerIoCompletion$6$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$6$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$6$label_107#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$6$label_108#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$6$label_108#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$6$label_108#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$6$label_108#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$6$label_108#1;

  inline$BDLSystemPowerIoCompletion$6$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_109#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$6$label_107#1;

  inline$BDLSystemPowerIoCompletion$6$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_109#1;

  inline$BDLSystemPowerIoCompletion$6$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$6$label_106#1;

  inline$BDLSystemPowerIoCompletion$6$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_106_true#1, inline$BDLSystemPowerIoCompletion$6$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_142#1;

  inline$BDLSystemPowerIoCompletion$6$label_142#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_143#1;

  inline$BDLSystemPowerIoCompletion$6$label_143#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_144#1;

  inline$BDLSystemPowerIoCompletion$6$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_109#1;

  inline$BDLSystemPowerIoCompletion$6$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_109#1;

  inline$BDLSystemPowerIoCompletion$6$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$6$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$6$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$6$myNondetVar_0, inline$BDLSystemPowerIoCompletion$6$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$6$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$6$anon50_Then#1, inline$BDLSystemPowerIoCompletion$6$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon29#1;

  inline$BDLSystemPowerIoCompletion$6$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_112#1;

  inline$BDLSystemPowerIoCompletion$6$label_112#1:
    inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$6$label_113#1;

  inline$BDLSystemPowerIoCompletion$6$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_113_true#1, inline$BDLSystemPowerIoCompletion$6$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$6$label_114#1;

  inline$BDLSystemPowerIoCompletion$6$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_116#1;

  inline$BDLSystemPowerIoCompletion$6$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_117#1;

  inline$BDLSystemPowerIoCompletion$6$label_117#1:
    goto inline$BDLGetDebugLevel$172$Entry#1;

  inline$BDLGetDebugLevel$172$Entry#1:
    goto inline$BDLGetDebugLevel$172$start#1;

  inline$BDLGetDebugLevel$172$start#1:
    goto inline$BDLGetDebugLevel$172$label_3#1;

  inline$BDLGetDebugLevel$172$label_3#1:
    havoc inline$BDLGetDebugLevel$172$myNondetVar_0;
    inline$BDLGetDebugLevel$172$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$172$myNondetVar_0;
    goto inline$BDLGetDebugLevel$172$label_1#1;

  inline$BDLGetDebugLevel$172$label_1#1:
    goto inline$BDLGetDebugLevel$172$Return#1;

  inline$BDLGetDebugLevel$172$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$172$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon51_Then#1, inline$BDLSystemPowerIoCompletion$6$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon31#1;

  inline$BDLSystemPowerIoCompletion$6$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_120#1;

  inline$BDLSystemPowerIoCompletion$6$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_120_true#1, inline$BDLSystemPowerIoCompletion$6$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_121#1;

  inline$BDLSystemPowerIoCompletion$6$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_124#1;

  inline$BDLSystemPowerIoCompletion$6$label_124#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_125#1;

  inline$BDLSystemPowerIoCompletion$6$label_125#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_126#1;

  inline$BDLSystemPowerIoCompletion$6$label_126#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_127#1;

  inline$BDLSystemPowerIoCompletion$6$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$6$label_121#1;

  inline$BDLSystemPowerIoCompletion$6$label_121#1:
    goto inline$BDLGetDebugLevel$173$Entry#1;

  inline$BDLGetDebugLevel$173$Entry#1:
    goto inline$BDLGetDebugLevel$173$start#1;

  inline$BDLGetDebugLevel$173$start#1:
    goto inline$BDLGetDebugLevel$173$label_3#1;

  inline$BDLGetDebugLevel$173$label_3#1:
    havoc inline$BDLGetDebugLevel$173$myNondetVar_0;
    inline$BDLGetDebugLevel$173$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$173$myNondetVar_0;
    goto inline$BDLGetDebugLevel$173$label_1#1;

  inline$BDLGetDebugLevel$173$label_1#1:
    goto inline$BDLGetDebugLevel$173$Return#1;

  inline$BDLGetDebugLevel$173$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$173$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon52_Then#1, inline$BDLSystemPowerIoCompletion$6$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon33#1;

  inline$BDLSystemPowerIoCompletion$6$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_130#1;

  inline$BDLSystemPowerIoCompletion$6$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_130_true#1, inline$BDLSystemPowerIoCompletion$6$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_131#1;

  inline$BDLSystemPowerIoCompletion$6$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_134#1;

  inline$BDLSystemPowerIoCompletion$6$label_134#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_135#1;

  inline$BDLSystemPowerIoCompletion$6$label_135#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_136#1;

  inline$BDLSystemPowerIoCompletion$6$label_136#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_137#1;

  inline$BDLSystemPowerIoCompletion$6$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$6$label_131#1;

  inline$BDLSystemPowerIoCompletion$6$label_131#1:
    goto inline$BDLGetDebugLevel$174$Entry#1;

  inline$BDLGetDebugLevel$174$Entry#1:
    goto inline$BDLGetDebugLevel$174$start#1;

  inline$BDLGetDebugLevel$174$start#1:
    goto inline$BDLGetDebugLevel$174$label_3#1;

  inline$BDLGetDebugLevel$174$label_3#1:
    havoc inline$BDLGetDebugLevel$174$myNondetVar_0;
    inline$BDLGetDebugLevel$174$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$174$myNondetVar_0;
    goto inline$BDLGetDebugLevel$174$label_1#1;

  inline$BDLGetDebugLevel$174$label_1#1:
    goto inline$BDLGetDebugLevel$174$Return#1;

  inline$BDLGetDebugLevel$174$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$174$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon53_Then#1, inline$BDLSystemPowerIoCompletion$6$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon35#1;

  inline$BDLSystemPowerIoCompletion$6$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_140#1;

  inline$BDLSystemPowerIoCompletion$6$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_140_true#1, inline$BDLSystemPowerIoCompletion$6$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_67#1;

  inline$BDLSystemPowerIoCompletion$6$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_141#1;

  inline$BDLSystemPowerIoCompletion$6$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_67#1;

  inline$BDLSystemPowerIoCompletion$6$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$6$label_115#1;

  inline$BDLSystemPowerIoCompletion$6$label_115#1:
    inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$6$label_80#1;

  inline$BDLSystemPowerIoCompletion$6$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$6$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_42#1;

  inline$BDLSystemPowerIoCompletion$6$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$6$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$6$label_43#1;

  inline$BDLSystemPowerIoCompletion$6$label_43#1:
    goto inline$BDLGetDebugLevel$166$Entry#1;

  inline$BDLGetDebugLevel$166$Entry#1:
    goto inline$BDLGetDebugLevel$166$start#1;

  inline$BDLGetDebugLevel$166$start#1:
    goto inline$BDLGetDebugLevel$166$label_3#1;

  inline$BDLGetDebugLevel$166$label_3#1:
    havoc inline$BDLGetDebugLevel$166$myNondetVar_0;
    inline$BDLGetDebugLevel$166$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$166$myNondetVar_0;
    goto inline$BDLGetDebugLevel$166$label_1#1;

  inline$BDLGetDebugLevel$166$label_1#1:
    goto inline$BDLGetDebugLevel$166$Return#1;

  inline$BDLGetDebugLevel$166$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$166$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon40_Then#1, inline$BDLSystemPowerIoCompletion$6$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon9#1;

  inline$BDLSystemPowerIoCompletion$6$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_46#1;

  inline$BDLSystemPowerIoCompletion$6$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_46_true#1, inline$BDLSystemPowerIoCompletion$6$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_47#1;

  inline$BDLSystemPowerIoCompletion$6$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_50#1;

  inline$BDLSystemPowerIoCompletion$6$label_50#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_51#1;

  inline$BDLSystemPowerIoCompletion$6$label_51#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_52#1;

  inline$BDLSystemPowerIoCompletion$6$label_52#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_53#1;

  inline$BDLSystemPowerIoCompletion$6$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$6$label_47#1;

  inline$BDLSystemPowerIoCompletion$6$label_47#1:
    goto inline$BDLGetDebugLevel$167$Entry#1;

  inline$BDLGetDebugLevel$167$Entry#1:
    goto inline$BDLGetDebugLevel$167$start#1;

  inline$BDLGetDebugLevel$167$start#1:
    goto inline$BDLGetDebugLevel$167$label_3#1;

  inline$BDLGetDebugLevel$167$label_3#1:
    havoc inline$BDLGetDebugLevel$167$myNondetVar_0;
    inline$BDLGetDebugLevel$167$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$167$myNondetVar_0;
    goto inline$BDLGetDebugLevel$167$label_1#1;

  inline$BDLGetDebugLevel$167$label_1#1:
    goto inline$BDLGetDebugLevel$167$Return#1;

  inline$BDLGetDebugLevel$167$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$167$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon41_Then#1, inline$BDLSystemPowerIoCompletion$6$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon11#1;

  inline$BDLSystemPowerIoCompletion$6$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_56#1;

  inline$BDLSystemPowerIoCompletion$6$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_56_true#1, inline$BDLSystemPowerIoCompletion$6$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_57#1;

  inline$BDLSystemPowerIoCompletion$6$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_60#1;

  inline$BDLSystemPowerIoCompletion$6$label_60#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_61#1;

  inline$BDLSystemPowerIoCompletion$6$label_61#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_62#1;

  inline$BDLSystemPowerIoCompletion$6$label_62#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_63#1;

  inline$BDLSystemPowerIoCompletion$6$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$6$label_57#1;

  inline$BDLSystemPowerIoCompletion$6$label_57#1:
    goto inline$BDLGetDebugLevel$168$Entry#1;

  inline$BDLGetDebugLevel$168$Entry#1:
    goto inline$BDLGetDebugLevel$168$start#1;

  inline$BDLGetDebugLevel$168$start#1:
    goto inline$BDLGetDebugLevel$168$label_3#1;

  inline$BDLGetDebugLevel$168$label_3#1:
    havoc inline$BDLGetDebugLevel$168$myNondetVar_0;
    inline$BDLGetDebugLevel$168$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$168$myNondetVar_0;
    goto inline$BDLGetDebugLevel$168$label_1#1;

  inline$BDLGetDebugLevel$168$label_1#1:
    goto inline$BDLGetDebugLevel$168$Return#1;

  inline$BDLGetDebugLevel$168$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$168$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon42_Then#1, inline$BDLSystemPowerIoCompletion$6$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon13#1;

  inline$BDLSystemPowerIoCompletion$6$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_66#1;

  inline$BDLSystemPowerIoCompletion$6$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_66_true#1, inline$BDLSystemPowerIoCompletion$6$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_67#1;

  inline$BDLSystemPowerIoCompletion$6$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_70#1;

  inline$BDLSystemPowerIoCompletion$6$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_67#1;

  inline$BDLSystemPowerIoCompletion$6$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$6$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$6$anon43_Then#1, inline$BDLSystemPowerIoCompletion$6$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon15#1;

  inline$BDLSystemPowerIoCompletion$6$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_71#1;

  inline$BDLSystemPowerIoCompletion$6$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$6$anon44_Then#1, inline$BDLSystemPowerIoCompletion$6$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon17#1;

  inline$BDLSystemPowerIoCompletion$6$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_74#1;

  inline$BDLSystemPowerIoCompletion$6$label_74#1:
    goto inline$storm_IoCompleteRequest$14$Entry#1;

  inline$storm_IoCompleteRequest$14$Entry#1:
    inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$6$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$14$start#1;

  inline$storm_IoCompleteRequest$14$start#1:
    inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$14$label_3#1;

  inline$storm_IoCompleteRequest$14$label_3#1:
    call inline$storm_IoCompleteRequest$14$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$14$label_6#1;

  inline$storm_IoCompleteRequest$14$label_6#1:
    goto inline$storm_IoCompleteRequest$14$label_6_true#1, inline$storm_IoCompleteRequest$14$label_6_false#1;

  inline$storm_IoCompleteRequest$14$label_6_false#1:
    assume inline$storm_IoCompleteRequest$14$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$14$label_7#1;

  inline$storm_IoCompleteRequest$14$label_6_true#1:
    assume inline$storm_IoCompleteRequest$14$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$14$label_8#1;

  inline$storm_IoCompleteRequest$14$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$14$anon3_Then#1, inline$storm_IoCompleteRequest$14$anon3_Else#1;

  inline$storm_IoCompleteRequest$14$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$14$anon1#1;

  inline$storm_IoCompleteRequest$14$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$14$label_9#1;

  inline$storm_IoCompleteRequest$14$label_9#1:
    goto inline$storm_IoCompleteRequest$14$label_9_true#1, inline$storm_IoCompleteRequest$14$label_9_false#1;

  inline$storm_IoCompleteRequest$14$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$14$label_10#1;

  inline$storm_IoCompleteRequest$14$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$14$label_1#1;

  inline$storm_IoCompleteRequest$14$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$14$label_7#1;

  inline$storm_IoCompleteRequest$14$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$14$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$14$label_1#1;

  inline$storm_IoCompleteRequest$14$label_1#1:
    goto inline$storm_IoCompleteRequest$14$Return#1;

  inline$storm_IoCompleteRequest$14$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$14$Return#1;

  inline$storm_IoCompleteRequest$14$Return#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon45_Then#1, inline$BDLSystemPowerIoCompletion$6$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon19#1;

  inline$BDLSystemPowerIoCompletion$6$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_77#1;

  inline$BDLSystemPowerIoCompletion$6$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$6$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$6$anon46_Then#1, inline$BDLSystemPowerIoCompletion$6$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon21#1;

  inline$BDLSystemPowerIoCompletion$6$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_80#1;

  inline$BDLSystemPowerIoCompletion$6$label_80#1:
    goto inline$BDLGetDebugLevel$169$Entry#1;

  inline$BDLGetDebugLevel$169$Entry#1:
    goto inline$BDLGetDebugLevel$169$start#1;

  inline$BDLGetDebugLevel$169$start#1:
    goto inline$BDLGetDebugLevel$169$label_3#1;

  inline$BDLGetDebugLevel$169$label_3#1:
    havoc inline$BDLGetDebugLevel$169$myNondetVar_0;
    inline$BDLGetDebugLevel$169$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$169$myNondetVar_0;
    goto inline$BDLGetDebugLevel$169$label_1#1;

  inline$BDLGetDebugLevel$169$label_1#1:
    goto inline$BDLGetDebugLevel$169$Return#1;

  inline$BDLGetDebugLevel$169$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$169$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon47_Then#1, inline$BDLSystemPowerIoCompletion$6$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon23#1;

  inline$BDLSystemPowerIoCompletion$6$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_83#1;

  inline$BDLSystemPowerIoCompletion$6$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_83_true#1, inline$BDLSystemPowerIoCompletion$6$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_84#1;

  inline$BDLSystemPowerIoCompletion$6$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_87#1;

  inline$BDLSystemPowerIoCompletion$6$label_87#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_88#1;

  inline$BDLSystemPowerIoCompletion$6$label_88#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_89#1;

  inline$BDLSystemPowerIoCompletion$6$label_89#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_90#1;

  inline$BDLSystemPowerIoCompletion$6$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$6$label_84#1;

  inline$BDLSystemPowerIoCompletion$6$label_84#1:
    goto inline$BDLGetDebugLevel$170$Entry#1;

  inline$BDLGetDebugLevel$170$Entry#1:
    goto inline$BDLGetDebugLevel$170$start#1;

  inline$BDLGetDebugLevel$170$start#1:
    goto inline$BDLGetDebugLevel$170$label_3#1;

  inline$BDLGetDebugLevel$170$label_3#1:
    havoc inline$BDLGetDebugLevel$170$myNondetVar_0;
    inline$BDLGetDebugLevel$170$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$170$myNondetVar_0;
    goto inline$BDLGetDebugLevel$170$label_1#1;

  inline$BDLGetDebugLevel$170$label_1#1:
    goto inline$BDLGetDebugLevel$170$Return#1;

  inline$BDLGetDebugLevel$170$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$170$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon48_Then#1, inline$BDLSystemPowerIoCompletion$6$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon25#1;

  inline$BDLSystemPowerIoCompletion$6$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_93#1;

  inline$BDLSystemPowerIoCompletion$6$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_93_true#1, inline$BDLSystemPowerIoCompletion$6$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_94#1;

  inline$BDLSystemPowerIoCompletion$6$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_97#1;

  inline$BDLSystemPowerIoCompletion$6$label_97#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_98#1;

  inline$BDLSystemPowerIoCompletion$6$label_98#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_99#1;

  inline$BDLSystemPowerIoCompletion$6$label_99#1:
    call inline$BDLSystemPowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$6$label_100#1;

  inline$BDLSystemPowerIoCompletion$6$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$6$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$6$label_94#1;

  inline$BDLSystemPowerIoCompletion$6$label_94#1:
    goto inline$BDLGetDebugLevel$171$Entry#1;

  inline$BDLGetDebugLevel$171$Entry#1:
    goto inline$BDLGetDebugLevel$171$start#1;

  inline$BDLGetDebugLevel$171$start#1:
    goto inline$BDLGetDebugLevel$171$label_3#1;

  inline$BDLGetDebugLevel$171$label_3#1:
    havoc inline$BDLGetDebugLevel$171$myNondetVar_0;
    inline$BDLGetDebugLevel$171$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$171$myNondetVar_0;
    goto inline$BDLGetDebugLevel$171$label_1#1;

  inline$BDLGetDebugLevel$171$label_1#1:
    goto inline$BDLGetDebugLevel$171$Return#1;

  inline$BDLGetDebugLevel$171$Return#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$171$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$6$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$6$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$6$anon49_Then#1, inline$BDLSystemPowerIoCompletion$6$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$6$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$anon27#1;

  inline$BDLSystemPowerIoCompletion$6$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_103#1;

  inline$BDLSystemPowerIoCompletion$6$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_103_true#1, inline$BDLSystemPowerIoCompletion$6$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$6$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_104#1;

  inline$BDLSystemPowerIoCompletion$6$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$6$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$6$label_105#1;

  inline$BDLSystemPowerIoCompletion$6$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$6$label_104#1;

  inline$BDLSystemPowerIoCompletion$6$label_104#1:
    inline$BDLSystemPowerIoCompletion$6$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$6$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$6$label_1#1;

  inline$BDLSystemPowerIoCompletion$6$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$6$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$6$Return#1;

  inline$BDLSystemPowerIoCompletion$6$Return#1:
    inline$CallCompletionRoutine$6$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$6$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$6$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$6$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$6$anon14_Then#1, inline$CallCompletionRoutine$6$anon14_Else#1;

  inline$CallCompletionRoutine$6$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$6$anon9#1;

  inline$CallCompletionRoutine$6$anon9#1:
    goto inline$CallCompletionRoutine$6$label_20_icall_return#1;

  inline$CallCompletionRoutine$6$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$6$Return#1;

  inline$CallCompletionRoutine$6$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$6$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$6$Entry#1;

  inline$BDLDevicePowerIoCompletion$6$Entry#1:
    inline$BDLDevicePowerIoCompletion$6$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$6$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$6$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$6$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$6$start#1;

  inline$BDLDevicePowerIoCompletion$6$start#1:
    call inline$BDLDevicePowerIoCompletion$6$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$6$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$6$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$6$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$6$label_3#1;

  inline$BDLDevicePowerIoCompletion$6$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_4#1;

  inline$BDLDevicePowerIoCompletion$6$label_4#1:
    inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_5#1;

  inline$BDLDevicePowerIoCompletion$6$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_6#1;

  inline$BDLDevicePowerIoCompletion$6$label_6#1:
    inline$BDLDevicePowerIoCompletion$6$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$6$label_7#1;

  inline$BDLDevicePowerIoCompletion$6$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_8#1;

  inline$BDLDevicePowerIoCompletion$6$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$6$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$6$label_9#1;

  inline$BDLDevicePowerIoCompletion$6$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_10#1;

  inline$BDLDevicePowerIoCompletion$6$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$37$Entry#1;

  inline$IoGetCurrentIrpStackLocation$37$Entry#1:
    inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$37$start#1;

  inline$IoGetCurrentIrpStackLocation$37$start#1:
    inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$37$label_3#1;

  inline$IoGetCurrentIrpStackLocation$37$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$37$label_3_true#1, inline$IoGetCurrentIrpStackLocation$37$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$37$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$37$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$37$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$37$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$37$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$37$label_4#1;

  inline$IoGetCurrentIrpStackLocation$37$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$37$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$37$label_6#1;

  inline$IoGetCurrentIrpStackLocation$37$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$37$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$37$label_7#1;

  inline$IoGetCurrentIrpStackLocation$37$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$37$label_5#1;

  inline$IoGetCurrentIrpStackLocation$37$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$37$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$37$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$37$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$37$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$37$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$37$label_5#1;

  inline$IoGetCurrentIrpStackLocation$37$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$37$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$37$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$37$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$37$label_1#1;

  inline$IoGetCurrentIrpStackLocation$37$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$37$Return#1;

  inline$IoGetCurrentIrpStackLocation$37$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$37$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon30_Then#1, inline$BDLDevicePowerIoCompletion$6$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon1#1;

  inline$BDLDevicePowerIoCompletion$6$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_13#1;

  inline$BDLDevicePowerIoCompletion$6$label_13#1:
    inline$BDLDevicePowerIoCompletion$6$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$6$label_14#1;

  inline$BDLDevicePowerIoCompletion$6$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_15#1;

  inline$BDLDevicePowerIoCompletion$6$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$6$label_16#1;

  inline$BDLDevicePowerIoCompletion$6$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_17#1;

  inline$BDLDevicePowerIoCompletion$6$label_17#1:
    goto inline$BDLGetDebugLevel$154$Entry#1;

  inline$BDLGetDebugLevel$154$Entry#1:
    goto inline$BDLGetDebugLevel$154$start#1;

  inline$BDLGetDebugLevel$154$start#1:
    goto inline$BDLGetDebugLevel$154$label_3#1;

  inline$BDLGetDebugLevel$154$label_3#1:
    havoc inline$BDLGetDebugLevel$154$myNondetVar_0;
    inline$BDLGetDebugLevel$154$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$154$myNondetVar_0;
    goto inline$BDLGetDebugLevel$154$label_1#1;

  inline$BDLGetDebugLevel$154$label_1#1:
    goto inline$BDLGetDebugLevel$154$Return#1;

  inline$BDLGetDebugLevel$154$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$154$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon31_Then#1, inline$BDLDevicePowerIoCompletion$6$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon3#1;

  inline$BDLDevicePowerIoCompletion$6$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_20#1;

  inline$BDLDevicePowerIoCompletion$6$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_20_true#1, inline$BDLDevicePowerIoCompletion$6$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_21#1;

  inline$BDLDevicePowerIoCompletion$6$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_24#1;

  inline$BDLDevicePowerIoCompletion$6$label_24#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_25#1;

  inline$BDLDevicePowerIoCompletion$6$label_25#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_26#1;

  inline$BDLDevicePowerIoCompletion$6$label_26#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_27#1;

  inline$BDLDevicePowerIoCompletion$6$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$6$label_21#1;

  inline$BDLDevicePowerIoCompletion$6$label_21#1:
    goto inline$BDLGetDebugLevel$155$Entry#1;

  inline$BDLGetDebugLevel$155$Entry#1:
    goto inline$BDLGetDebugLevel$155$start#1;

  inline$BDLGetDebugLevel$155$start#1:
    goto inline$BDLGetDebugLevel$155$label_3#1;

  inline$BDLGetDebugLevel$155$label_3#1:
    havoc inline$BDLGetDebugLevel$155$myNondetVar_0;
    inline$BDLGetDebugLevel$155$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$155$myNondetVar_0;
    goto inline$BDLGetDebugLevel$155$label_1#1;

  inline$BDLGetDebugLevel$155$label_1#1:
    goto inline$BDLGetDebugLevel$155$Return#1;

  inline$BDLGetDebugLevel$155$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$155$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon32_Then#1, inline$BDLDevicePowerIoCompletion$6$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon5#1;

  inline$BDLDevicePowerIoCompletion$6$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_30#1;

  inline$BDLDevicePowerIoCompletion$6$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_30_true#1, inline$BDLDevicePowerIoCompletion$6$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_31#1;

  inline$BDLDevicePowerIoCompletion$6$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_34#1;

  inline$BDLDevicePowerIoCompletion$6$label_34#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_35#1;

  inline$BDLDevicePowerIoCompletion$6$label_35#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_36#1;

  inline$BDLDevicePowerIoCompletion$6$label_36#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_37#1;

  inline$BDLDevicePowerIoCompletion$6$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$6$label_31#1;

  inline$BDLDevicePowerIoCompletion$6$label_31#1:
    goto inline$BDLGetDebugLevel$156$Entry#1;

  inline$BDLGetDebugLevel$156$Entry#1:
    goto inline$BDLGetDebugLevel$156$start#1;

  inline$BDLGetDebugLevel$156$start#1:
    goto inline$BDLGetDebugLevel$156$label_3#1;

  inline$BDLGetDebugLevel$156$label_3#1:
    havoc inline$BDLGetDebugLevel$156$myNondetVar_0;
    inline$BDLGetDebugLevel$156$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$156$myNondetVar_0;
    goto inline$BDLGetDebugLevel$156$label_1#1;

  inline$BDLGetDebugLevel$156$label_1#1:
    goto inline$BDLGetDebugLevel$156$Return#1;

  inline$BDLGetDebugLevel$156$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$156$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon33_Then#1, inline$BDLDevicePowerIoCompletion$6$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon7#1;

  inline$BDLDevicePowerIoCompletion$6$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_40#1;

  inline$BDLDevicePowerIoCompletion$6$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_40_true#1, inline$BDLDevicePowerIoCompletion$6$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_41#1;

  inline$BDLDevicePowerIoCompletion$6$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_42#1;

  inline$BDLDevicePowerIoCompletion$6$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_41#1;

  inline$BDLDevicePowerIoCompletion$6$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_41_true#1, inline$BDLDevicePowerIoCompletion$6$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$6$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$6$label_43#1;

  inline$BDLDevicePowerIoCompletion$6$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$6$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$6$label_44#1;

  inline$BDLDevicePowerIoCompletion$6$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_44_true#1, inline$BDLDevicePowerIoCompletion$6$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$6$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$6$label_45#1;

  inline$BDLDevicePowerIoCompletion$6$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_45_true#1, inline$BDLDevicePowerIoCompletion$6$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$6$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$6$label_43#1;

  inline$BDLDevicePowerIoCompletion$6$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$6$label_86#1;

  inline$BDLDevicePowerIoCompletion$6$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$6$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$6$label_46#1;

  inline$BDLDevicePowerIoCompletion$6$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$6$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$6$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$6$label_46#1;

  inline$BDLDevicePowerIoCompletion$6$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$6$label_49#1;

  inline$BDLDevicePowerIoCompletion$6$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_50#1;

  inline$BDLDevicePowerIoCompletion$6$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_51#1;

  inline$BDLDevicePowerIoCompletion$6$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_54#1;

  inline$BDLDevicePowerIoCompletion$6$label_54#1:
    inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$6$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$6$label_55#1;

  inline$BDLDevicePowerIoCompletion$6$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_55_true#1, inline$BDLDevicePowerIoCompletion$6$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_56#1;

  inline$BDLDevicePowerIoCompletion$6$label_56#1:
    call inline$BDLDevicePowerIoCompletion$6$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$6$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$6$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$6$anon34_Then#1, inline$BDLDevicePowerIoCompletion$6$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon9#1;

  inline$BDLDevicePowerIoCompletion$6$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_83#1;

  inline$BDLDevicePowerIoCompletion$6$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_59#1;

  inline$BDLDevicePowerIoCompletion$6$label_59#1:
    goto inline$BDLGetDebugLevel$157$Entry#1;

  inline$BDLGetDebugLevel$157$Entry#1:
    goto inline$BDLGetDebugLevel$157$start#1;

  inline$BDLGetDebugLevel$157$start#1:
    goto inline$BDLGetDebugLevel$157$label_3#1;

  inline$BDLGetDebugLevel$157$label_3#1:
    havoc inline$BDLGetDebugLevel$157$myNondetVar_0;
    inline$BDLGetDebugLevel$157$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$157$myNondetVar_0;
    goto inline$BDLGetDebugLevel$157$label_1#1;

  inline$BDLGetDebugLevel$157$label_1#1:
    goto inline$BDLGetDebugLevel$157$Return#1;

  inline$BDLGetDebugLevel$157$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$157$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon35_Then#1, inline$BDLDevicePowerIoCompletion$6$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon11#1;

  inline$BDLDevicePowerIoCompletion$6$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_62#1;

  inline$BDLDevicePowerIoCompletion$6$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_62_true#1, inline$BDLDevicePowerIoCompletion$6$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_63#1;

  inline$BDLDevicePowerIoCompletion$6$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_66#1;

  inline$BDLDevicePowerIoCompletion$6$label_66#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_67#1;

  inline$BDLDevicePowerIoCompletion$6$label_67#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_68#1;

  inline$BDLDevicePowerIoCompletion$6$label_68#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_69#1;

  inline$BDLDevicePowerIoCompletion$6$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$6$label_63#1;

  inline$BDLDevicePowerIoCompletion$6$label_63#1:
    goto inline$BDLGetDebugLevel$158$Entry#1;

  inline$BDLGetDebugLevel$158$Entry#1:
    goto inline$BDLGetDebugLevel$158$start#1;

  inline$BDLGetDebugLevel$158$start#1:
    goto inline$BDLGetDebugLevel$158$label_3#1;

  inline$BDLGetDebugLevel$158$label_3#1:
    havoc inline$BDLGetDebugLevel$158$myNondetVar_0;
    inline$BDLGetDebugLevel$158$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$158$myNondetVar_0;
    goto inline$BDLGetDebugLevel$158$label_1#1;

  inline$BDLGetDebugLevel$158$label_1#1:
    goto inline$BDLGetDebugLevel$158$Return#1;

  inline$BDLGetDebugLevel$158$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$158$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon36_Then#1, inline$BDLDevicePowerIoCompletion$6$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon13#1;

  inline$BDLDevicePowerIoCompletion$6$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_72#1;

  inline$BDLDevicePowerIoCompletion$6$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_72_true#1, inline$BDLDevicePowerIoCompletion$6$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_73#1;

  inline$BDLDevicePowerIoCompletion$6$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_76#1;

  inline$BDLDevicePowerIoCompletion$6$label_76#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_77#1;

  inline$BDLDevicePowerIoCompletion$6$label_77#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_78#1;

  inline$BDLDevicePowerIoCompletion$6$label_78#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_79#1;

  inline$BDLDevicePowerIoCompletion$6$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$6$label_73#1;

  inline$BDLDevicePowerIoCompletion$6$label_73#1:
    goto inline$BDLGetDebugLevel$159$Entry#1;

  inline$BDLGetDebugLevel$159$Entry#1:
    goto inline$BDLGetDebugLevel$159$start#1;

  inline$BDLGetDebugLevel$159$start#1:
    goto inline$BDLGetDebugLevel$159$label_3#1;

  inline$BDLGetDebugLevel$159$label_3#1:
    havoc inline$BDLGetDebugLevel$159$myNondetVar_0;
    inline$BDLGetDebugLevel$159$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$159$myNondetVar_0;
    goto inline$BDLGetDebugLevel$159$label_1#1;

  inline$BDLGetDebugLevel$159$label_1#1:
    goto inline$BDLGetDebugLevel$159$Return#1;

  inline$BDLGetDebugLevel$159$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$159$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon37_Then#1, inline$BDLDevicePowerIoCompletion$6$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon15#1;

  inline$BDLDevicePowerIoCompletion$6$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_82#1;

  inline$BDLDevicePowerIoCompletion$6$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_82_true#1, inline$BDLDevicePowerIoCompletion$6$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_83#1;

  inline$BDLDevicePowerIoCompletion$6$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_84#1;

  inline$BDLDevicePowerIoCompletion$6$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_83#1;

  inline$BDLDevicePowerIoCompletion$6$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_85#1;

  inline$BDLDevicePowerIoCompletion$6$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_86#1;

  inline$BDLDevicePowerIoCompletion$6$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$6$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$6$anon38_Then#1, inline$BDLDevicePowerIoCompletion$6$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon17#1;

  inline$BDLDevicePowerIoCompletion$6$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_89#1;

  inline$BDLDevicePowerIoCompletion$6$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$6$anon39_Then#1, inline$BDLDevicePowerIoCompletion$6$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon19#1;

  inline$BDLDevicePowerIoCompletion$6$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_92#1;

  inline$BDLDevicePowerIoCompletion$6$label_92#1:
    goto inline$storm_IoCompleteRequest$13$Entry#1;

  inline$storm_IoCompleteRequest$13$Entry#1:
    inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$6$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$13$start#1;

  inline$storm_IoCompleteRequest$13$start#1:
    inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$13$label_3#1;

  inline$storm_IoCompleteRequest$13$label_3#1:
    call inline$storm_IoCompleteRequest$13$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$13$label_6#1;

  inline$storm_IoCompleteRequest$13$label_6#1:
    goto inline$storm_IoCompleteRequest$13$label_6_true#1, inline$storm_IoCompleteRequest$13$label_6_false#1;

  inline$storm_IoCompleteRequest$13$label_6_false#1:
    assume inline$storm_IoCompleteRequest$13$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$13$label_7#1;

  inline$storm_IoCompleteRequest$13$label_6_true#1:
    assume inline$storm_IoCompleteRequest$13$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$13$label_8#1;

  inline$storm_IoCompleteRequest$13$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$13$anon3_Then#1, inline$storm_IoCompleteRequest$13$anon3_Else#1;

  inline$storm_IoCompleteRequest$13$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$13$anon1#1;

  inline$storm_IoCompleteRequest$13$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$13$label_9#1;

  inline$storm_IoCompleteRequest$13$label_9#1:
    goto inline$storm_IoCompleteRequest$13$label_9_true#1, inline$storm_IoCompleteRequest$13$label_9_false#1;

  inline$storm_IoCompleteRequest$13$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$13$label_10#1;

  inline$storm_IoCompleteRequest$13$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$13$label_1#1;

  inline$storm_IoCompleteRequest$13$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$13$label_7#1;

  inline$storm_IoCompleteRequest$13$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$13$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$13$label_1#1;

  inline$storm_IoCompleteRequest$13$label_1#1:
    goto inline$storm_IoCompleteRequest$13$Return#1;

  inline$storm_IoCompleteRequest$13$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$13$Return#1;

  inline$storm_IoCompleteRequest$13$Return#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon40_Then#1, inline$BDLDevicePowerIoCompletion$6$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon21#1;

  inline$BDLDevicePowerIoCompletion$6$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_95#1;

  inline$BDLDevicePowerIoCompletion$6$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$6$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$6$anon41_Then#1, inline$BDLDevicePowerIoCompletion$6$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon23#1;

  inline$BDLDevicePowerIoCompletion$6$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_98#1;

  inline$BDLDevicePowerIoCompletion$6$label_98#1:
    goto inline$BDLGetDebugLevel$160$Entry#1;

  inline$BDLGetDebugLevel$160$Entry#1:
    goto inline$BDLGetDebugLevel$160$start#1;

  inline$BDLGetDebugLevel$160$start#1:
    goto inline$BDLGetDebugLevel$160$label_3#1;

  inline$BDLGetDebugLevel$160$label_3#1:
    havoc inline$BDLGetDebugLevel$160$myNondetVar_0;
    inline$BDLGetDebugLevel$160$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$160$myNondetVar_0;
    goto inline$BDLGetDebugLevel$160$label_1#1;

  inline$BDLGetDebugLevel$160$label_1#1:
    goto inline$BDLGetDebugLevel$160$Return#1;

  inline$BDLGetDebugLevel$160$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$160$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon42_Then#1, inline$BDLDevicePowerIoCompletion$6$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon25#1;

  inline$BDLDevicePowerIoCompletion$6$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_101#1;

  inline$BDLDevicePowerIoCompletion$6$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_101_true#1, inline$BDLDevicePowerIoCompletion$6$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_102#1;

  inline$BDLDevicePowerIoCompletion$6$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_105#1;

  inline$BDLDevicePowerIoCompletion$6$label_105#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_106#1;

  inline$BDLDevicePowerIoCompletion$6$label_106#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_107#1;

  inline$BDLDevicePowerIoCompletion$6$label_107#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_108#1;

  inline$BDLDevicePowerIoCompletion$6$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$6$label_102#1;

  inline$BDLDevicePowerIoCompletion$6$label_102#1:
    goto inline$BDLGetDebugLevel$161$Entry#1;

  inline$BDLGetDebugLevel$161$Entry#1:
    goto inline$BDLGetDebugLevel$161$start#1;

  inline$BDLGetDebugLevel$161$start#1:
    goto inline$BDLGetDebugLevel$161$label_3#1;

  inline$BDLGetDebugLevel$161$label_3#1:
    havoc inline$BDLGetDebugLevel$161$myNondetVar_0;
    inline$BDLGetDebugLevel$161$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$161$myNondetVar_0;
    goto inline$BDLGetDebugLevel$161$label_1#1;

  inline$BDLGetDebugLevel$161$label_1#1:
    goto inline$BDLGetDebugLevel$161$Return#1;

  inline$BDLGetDebugLevel$161$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$161$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon43_Then#1, inline$BDLDevicePowerIoCompletion$6$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon27#1;

  inline$BDLDevicePowerIoCompletion$6$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_111#1;

  inline$BDLDevicePowerIoCompletion$6$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_111_true#1, inline$BDLDevicePowerIoCompletion$6$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_112#1;

  inline$BDLDevicePowerIoCompletion$6$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_115#1;

  inline$BDLDevicePowerIoCompletion$6$label_115#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_116#1;

  inline$BDLDevicePowerIoCompletion$6$label_116#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_117#1;

  inline$BDLDevicePowerIoCompletion$6$label_117#1:
    call inline$BDLDevicePowerIoCompletion$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$6$label_118#1;

  inline$BDLDevicePowerIoCompletion$6$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$6$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$6$label_112#1;

  inline$BDLDevicePowerIoCompletion$6$label_112#1:
    goto inline$BDLGetDebugLevel$162$Entry#1;

  inline$BDLGetDebugLevel$162$Entry#1:
    goto inline$BDLGetDebugLevel$162$start#1;

  inline$BDLGetDebugLevel$162$start#1:
    goto inline$BDLGetDebugLevel$162$label_3#1;

  inline$BDLGetDebugLevel$162$label_3#1:
    havoc inline$BDLGetDebugLevel$162$myNondetVar_0;
    inline$BDLGetDebugLevel$162$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$162$myNondetVar_0;
    goto inline$BDLGetDebugLevel$162$label_1#1;

  inline$BDLGetDebugLevel$162$label_1#1:
    goto inline$BDLGetDebugLevel$162$Return#1;

  inline$BDLGetDebugLevel$162$Return#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$162$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$6$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$6$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$6$anon44_Then#1, inline$BDLDevicePowerIoCompletion$6$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$6$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$anon29#1;

  inline$BDLDevicePowerIoCompletion$6$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_121#1;

  inline$BDLDevicePowerIoCompletion$6$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_121_true#1, inline$BDLDevicePowerIoCompletion$6$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$6$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_122#1;

  inline$BDLDevicePowerIoCompletion$6$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$6$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$6$label_123#1;

  inline$BDLDevicePowerIoCompletion$6$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$6$label_122#1;

  inline$BDLDevicePowerIoCompletion$6$label_122#1:
    inline$BDLDevicePowerIoCompletion$6$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$6$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$6$label_1#1;

  inline$BDLDevicePowerIoCompletion$6$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$6$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$6$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$6$Return#1;

  inline$BDLDevicePowerIoCompletion$6$Return#1:
    inline$CallCompletionRoutine$6$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$6$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$6$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$6$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$6$anon13_Then#1, inline$CallCompletionRoutine$6$anon13_Else#1;

  inline$CallCompletionRoutine$6$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$6$anon7#1;

  inline$CallCompletionRoutine$6$anon7#1:
    goto inline$CallCompletionRoutine$6$label_20_icall_return#1;

  inline$CallCompletionRoutine$6$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$6$Return#1;

  inline$CallCompletionRoutine$6$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$6$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$6$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$6$Entry#1;

  inline$BDLCallDriverCompletionRoutine$6$Entry#1:
    inline$BDLCallDriverCompletionRoutine$6$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$6$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$6$start#1;

  inline$BDLCallDriverCompletionRoutine$6$start#1:
    inline$BDLCallDriverCompletionRoutine$6$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$6$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$6$label_3#1;

  inline$BDLCallDriverCompletionRoutine$6$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$6$label_3_true#1, inline$BDLCallDriverCompletionRoutine$6$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$6$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$6$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$6$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$6$label_4#1;

  inline$BDLCallDriverCompletionRoutine$6$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$6$label_6#1;

  inline$BDLCallDriverCompletionRoutine$6$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$6$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$6$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$6$label_5#1;

  inline$BDLCallDriverCompletionRoutine$6$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$6$label_6#1;

  inline$BDLCallDriverCompletionRoutine$6$label_6#1:
    goto inline$storm_KeSetEvent$7$Entry#1;

  inline$storm_KeSetEvent$7$Entry#1:
    inline$storm_KeSetEvent$7$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$6$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$7$start#1;

  inline$storm_KeSetEvent$7$start#1:
    inline$storm_KeSetEvent$7$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$7$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$7$label_3#1;

  inline$storm_KeSetEvent$7$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$7$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$7$label_1#1;

  inline$storm_KeSetEvent$7$label_1#1:
    goto inline$storm_KeSetEvent$7$Return#1;

  inline$storm_KeSetEvent$7$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$6$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$6$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$6$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$6$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$6$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$6$anon1#1;

  inline$BDLCallDriverCompletionRoutine$6$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$6$label_9#1;

  inline$BDLCallDriverCompletionRoutine$6$label_9#1:
    inline$BDLCallDriverCompletionRoutine$6$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$6$label_1#1;

  inline$BDLCallDriverCompletionRoutine$6$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$6$Return#1;

  inline$BDLCallDriverCompletionRoutine$6$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$6$Return#1;

  inline$BDLCallDriverCompletionRoutine$6$Return#1:
    inline$CallCompletionRoutine$6$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$6$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$6$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$6$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$6$anon12_Then#1, inline$CallCompletionRoutine$6$anon12_Else#1;

  inline$CallCompletionRoutine$6$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$6$anon5#1;

  inline$CallCompletionRoutine$6$anon5#1:
    goto inline$CallCompletionRoutine$6$label_20_icall_return#1;

  inline$CallCompletionRoutine$6$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$6$label_23#1;

  inline$CallCompletionRoutine$6$label_23#1:
    inline$CallCompletionRoutine$6$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$6$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$6$label_24#1;

  inline$CallCompletionRoutine$6$label_24#1:
    goto inline$CallCompletionRoutine$6$label_24_true#1, inline$CallCompletionRoutine$6$label_24_false#1;

  inline$CallCompletionRoutine$6$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$6$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$6$label_1#1;

  inline$CallCompletionRoutine$6$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$6$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$6$label_25#1;

  inline$CallCompletionRoutine$6$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$6$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$6$label_1#1;

  inline$CallCompletionRoutine$6$label_1#1:
    goto inline$CallCompletionRoutine$6$Return#1;

  inline$CallCompletionRoutine$6$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$6$Return#1;

  inline$CallCompletionRoutine$6$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$6$Return#1;

  inline$CallCompletionRoutine$6$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$6$Return#1;

  inline$CallCompletionRoutine$6$Return#1:
    goto inline$storm_IoCallDriver$3$label_33$1#1;

  inline$storm_IoCallDriver$3$label_33$1#1:
    goto inline$storm_IoCallDriver$3$anon14_Then#1, inline$storm_IoCallDriver$3$anon14_Else#1;

  inline$storm_IoCallDriver$3$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$3$anon8#1;

  inline$storm_IoCallDriver$3$anon8#1:
    goto inline$storm_IoCallDriver$3$label_36#1;

  inline$storm_IoCallDriver$3$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$3$Return#1;

  inline$storm_IoCallDriver$3$label_27_case_1#1:
    assume inline$storm_IoCallDriver$3$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$3$label_29#1;

  inline$storm_IoCallDriver$3$label_29#1:
    inline$storm_IoCallDriver$3$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$3$label_37#1;

  inline$storm_IoCallDriver$3$label_37#1:
    goto inline$storm_IoCallDriver$3$label_38#1;

  inline$storm_IoCallDriver$3$label_38#1:
    goto inline$storm_IoCallDriver$3$label_39#1;

  inline$storm_IoCallDriver$3$label_39#1:
    goto inline$CallCompletionRoutine$7$Entry#1;

  inline$CallCompletionRoutine$7$Entry#1:
    inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$7$start#1;

  inline$CallCompletionRoutine$7$start#1:
    inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$7$label_3#1;

  inline$CallCompletionRoutine$7$label_3#1:
    goto inline$CallCompletionRoutine$7$label_4#1;

  inline$CallCompletionRoutine$7$label_4#1:
    goto inline$CallCompletionRoutine$7$label_5#1;

  inline$CallCompletionRoutine$7$label_5#1:
    goto inline$CallCompletionRoutine$7$label_6#1;

  inline$CallCompletionRoutine$7$label_6#1:
    goto inline$CallCompletionRoutine$7$label_7#1;

  inline$CallCompletionRoutine$7$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$39$Entry#1;

  inline$IoGetCurrentIrpStackLocation$39$Entry#1:
    inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$39$start#1;

  inline$IoGetCurrentIrpStackLocation$39$start#1:
    inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$39$label_3#1;

  inline$IoGetCurrentIrpStackLocation$39$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$39$label_3_true#1, inline$IoGetCurrentIrpStackLocation$39$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$39$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$39$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$39$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$39$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$39$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$39$label_4#1;

  inline$IoGetCurrentIrpStackLocation$39$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$39$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$39$label_6#1;

  inline$IoGetCurrentIrpStackLocation$39$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$39$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$39$label_7#1;

  inline$IoGetCurrentIrpStackLocation$39$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$39$label_5#1;

  inline$IoGetCurrentIrpStackLocation$39$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$39$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$39$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$39$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$39$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$39$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$39$label_5#1;

  inline$IoGetCurrentIrpStackLocation$39$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$39$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$39$label_1#1;

  inline$IoGetCurrentIrpStackLocation$39$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$39$Return#1;

  inline$IoGetCurrentIrpStackLocation$39$Return#1:
    goto inline$CallCompletionRoutine$7$label_7$1#1;

  inline$CallCompletionRoutine$7$label_7$1#1:
    goto inline$CallCompletionRoutine$7$anon10_Then#1, inline$CallCompletionRoutine$7$anon10_Else#1;

  inline$CallCompletionRoutine$7$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$7$anon1#1;

  inline$CallCompletionRoutine$7$anon1#1:
    goto inline$CallCompletionRoutine$7$label_10#1;

  inline$CallCompletionRoutine$7$label_10#1:
    goto inline$CallCompletionRoutine$7$label_11#1;

  inline$CallCompletionRoutine$7$label_11#1:
    havoc inline$CallCompletionRoutine$7$myNondetVar_0;
    inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$7$myNondetVar_0;
    goto inline$CallCompletionRoutine$7$label_12#1;

  inline$CallCompletionRoutine$7$label_12#1:
    havoc inline$CallCompletionRoutine$7$myNondetVar_0;
    inline$CallCompletionRoutine$7$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$7$myNondetVar_0;
    goto inline$CallCompletionRoutine$7$label_13#1;

  inline$CallCompletionRoutine$7$label_13#1:
    havoc inline$CallCompletionRoutine$7$myNondetVar_0;
    goto inline$CallCompletionRoutine$7$label_14#1;

  inline$CallCompletionRoutine$7$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$40$Entry#1;

  inline$IoGetCurrentIrpStackLocation$40$Entry#1:
    inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$40$start#1;

  inline$IoGetCurrentIrpStackLocation$40$start#1:
    inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$40$label_3#1;

  inline$IoGetCurrentIrpStackLocation$40$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$40$label_3_true#1, inline$IoGetCurrentIrpStackLocation$40$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$40$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$40$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$40$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$40$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$40$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$40$label_4#1;

  inline$IoGetCurrentIrpStackLocation$40$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$40$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$40$label_6#1;

  inline$IoGetCurrentIrpStackLocation$40$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$40$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$40$label_7#1;

  inline$IoGetCurrentIrpStackLocation$40$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$40$label_5#1;

  inline$IoGetCurrentIrpStackLocation$40$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$40$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$40$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$40$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$40$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$40$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$40$label_5#1;

  inline$IoGetCurrentIrpStackLocation$40$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$40$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$40$label_1#1;

  inline$IoGetCurrentIrpStackLocation$40$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$40$Return#1;

  inline$IoGetCurrentIrpStackLocation$40$Return#1:
    goto inline$CallCompletionRoutine$7$label_14$1#1;

  inline$CallCompletionRoutine$7$label_14$1#1:
    goto inline$CallCompletionRoutine$7$anon11_Then#1, inline$CallCompletionRoutine$7$anon11_Else#1;

  inline$CallCompletionRoutine$7$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$7$anon3#1;

  inline$CallCompletionRoutine$7$anon3#1:
    goto inline$CallCompletionRoutine$7$label_17#1;

  inline$CallCompletionRoutine$7$label_17#1:
    goto inline$CallCompletionRoutine$7$label_18#1;

  inline$CallCompletionRoutine$7$label_18#1:
    goto inline$CallCompletionRoutine$7$label_18_true#1, inline$CallCompletionRoutine$7$label_18_false#1;

  inline$CallCompletionRoutine$7$label_18_false#1:
    assume inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$7$label_1#1;

  inline$CallCompletionRoutine$7$label_18_true#1:
    assume inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$7$label_19#1;

  inline$CallCompletionRoutine$7$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$7$label_20#1;

  inline$CallCompletionRoutine$7$label_20#1:
    goto inline$CallCompletionRoutine$7$label_20_icall_1#1, inline$CallCompletionRoutine$7$label_20_icall_2#1, inline$CallCompletionRoutine$7$label_20_icall_3#1;

  inline$CallCompletionRoutine$7$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$7$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$7$Entry#1;

  inline$BDLSystemPowerIoCompletion$7$Entry#1:
    inline$BDLSystemPowerIoCompletion$7$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$7$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$7$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$7$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$7$start#1;

  inline$BDLSystemPowerIoCompletion$7$start#1:
    call inline$BDLSystemPowerIoCompletion$7$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$7$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$7$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$7$label_3#1;

  inline$BDLSystemPowerIoCompletion$7$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_4#1;

  inline$BDLSystemPowerIoCompletion$7$label_4#1:
    inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_5#1;

  inline$BDLSystemPowerIoCompletion$7$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_6#1;

  inline$BDLSystemPowerIoCompletion$7$label_6#1:
    inline$BDLSystemPowerIoCompletion$7$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$7$label_7#1;

  inline$BDLSystemPowerIoCompletion$7$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_8#1;

  inline$BDLSystemPowerIoCompletion$7$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$7$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$7$label_9#1;

  inline$BDLSystemPowerIoCompletion$7$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_10#1;

  inline$BDLSystemPowerIoCompletion$7$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$42$Entry#1;

  inline$IoGetCurrentIrpStackLocation$42$Entry#1:
    inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$42$start#1;

  inline$IoGetCurrentIrpStackLocation$42$start#1:
    inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$42$label_3#1;

  inline$IoGetCurrentIrpStackLocation$42$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$42$label_3_true#1, inline$IoGetCurrentIrpStackLocation$42$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$42$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$42$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$42$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$42$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$42$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$42$label_4#1;

  inline$IoGetCurrentIrpStackLocation$42$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$42$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$42$label_6#1;

  inline$IoGetCurrentIrpStackLocation$42$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$42$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$42$label_7#1;

  inline$IoGetCurrentIrpStackLocation$42$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$42$label_5#1;

  inline$IoGetCurrentIrpStackLocation$42$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$42$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$42$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$42$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$42$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$42$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$42$label_5#1;

  inline$IoGetCurrentIrpStackLocation$42$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$42$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$42$label_1#1;

  inline$IoGetCurrentIrpStackLocation$42$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$42$Return#1;

  inline$IoGetCurrentIrpStackLocation$42$Return#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon36_Then#1, inline$BDLSystemPowerIoCompletion$7$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon1#1;

  inline$BDLSystemPowerIoCompletion$7$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_13#1;

  inline$BDLSystemPowerIoCompletion$7$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_14#1;

  inline$BDLSystemPowerIoCompletion$7$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_15#1;

  inline$BDLSystemPowerIoCompletion$7$label_15#1:
    goto inline$BDLGetDebugLevel$184$Entry#1;

  inline$BDLGetDebugLevel$184$Entry#1:
    goto inline$BDLGetDebugLevel$184$start#1;

  inline$BDLGetDebugLevel$184$start#1:
    goto inline$BDLGetDebugLevel$184$label_3#1;

  inline$BDLGetDebugLevel$184$label_3#1:
    havoc inline$BDLGetDebugLevel$184$myNondetVar_0;
    inline$BDLGetDebugLevel$184$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$184$myNondetVar_0;
    goto inline$BDLGetDebugLevel$184$label_1#1;

  inline$BDLGetDebugLevel$184$label_1#1:
    goto inline$BDLGetDebugLevel$184$Return#1;

  inline$BDLGetDebugLevel$184$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$184$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon37_Then#1, inline$BDLSystemPowerIoCompletion$7$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon3#1;

  inline$BDLSystemPowerIoCompletion$7$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_18#1;

  inline$BDLSystemPowerIoCompletion$7$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_18_true#1, inline$BDLSystemPowerIoCompletion$7$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_19#1;

  inline$BDLSystemPowerIoCompletion$7$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_22#1;

  inline$BDLSystemPowerIoCompletion$7$label_22#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_23#1;

  inline$BDLSystemPowerIoCompletion$7$label_23#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_24#1;

  inline$BDLSystemPowerIoCompletion$7$label_24#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_25#1;

  inline$BDLSystemPowerIoCompletion$7$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$7$label_19#1;

  inline$BDLSystemPowerIoCompletion$7$label_19#1:
    goto inline$BDLGetDebugLevel$185$Entry#1;

  inline$BDLGetDebugLevel$185$Entry#1:
    goto inline$BDLGetDebugLevel$185$start#1;

  inline$BDLGetDebugLevel$185$start#1:
    goto inline$BDLGetDebugLevel$185$label_3#1;

  inline$BDLGetDebugLevel$185$label_3#1:
    havoc inline$BDLGetDebugLevel$185$myNondetVar_0;
    inline$BDLGetDebugLevel$185$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$185$myNondetVar_0;
    goto inline$BDLGetDebugLevel$185$label_1#1;

  inline$BDLGetDebugLevel$185$label_1#1:
    goto inline$BDLGetDebugLevel$185$Return#1;

  inline$BDLGetDebugLevel$185$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$185$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon38_Then#1, inline$BDLSystemPowerIoCompletion$7$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon5#1;

  inline$BDLSystemPowerIoCompletion$7$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_28#1;

  inline$BDLSystemPowerIoCompletion$7$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_28_true#1, inline$BDLSystemPowerIoCompletion$7$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_29#1;

  inline$BDLSystemPowerIoCompletion$7$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_32#1;

  inline$BDLSystemPowerIoCompletion$7$label_32#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_33#1;

  inline$BDLSystemPowerIoCompletion$7$label_33#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_34#1;

  inline$BDLSystemPowerIoCompletion$7$label_34#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_35#1;

  inline$BDLSystemPowerIoCompletion$7$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$7$label_29#1;

  inline$BDLSystemPowerIoCompletion$7$label_29#1:
    goto inline$BDLGetDebugLevel$186$Entry#1;

  inline$BDLGetDebugLevel$186$Entry#1:
    goto inline$BDLGetDebugLevel$186$start#1;

  inline$BDLGetDebugLevel$186$start#1:
    goto inline$BDLGetDebugLevel$186$label_3#1;

  inline$BDLGetDebugLevel$186$label_3#1:
    havoc inline$BDLGetDebugLevel$186$myNondetVar_0;
    inline$BDLGetDebugLevel$186$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$186$myNondetVar_0;
    goto inline$BDLGetDebugLevel$186$label_1#1;

  inline$BDLGetDebugLevel$186$label_1#1:
    goto inline$BDLGetDebugLevel$186$Return#1;

  inline$BDLGetDebugLevel$186$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$186$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon39_Then#1, inline$BDLSystemPowerIoCompletion$7$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon7#1;

  inline$BDLSystemPowerIoCompletion$7$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_38#1;

  inline$BDLSystemPowerIoCompletion$7$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_38_true#1, inline$BDLSystemPowerIoCompletion$7$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_39#1;

  inline$BDLSystemPowerIoCompletion$7$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_40#1;

  inline$BDLSystemPowerIoCompletion$7$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_39#1;

  inline$BDLSystemPowerIoCompletion$7$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_39_true#1, inline$BDLSystemPowerIoCompletion$7$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_41#1;

  inline$BDLSystemPowerIoCompletion$7$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$7$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$7$label_107#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$7$label_108#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$7$label_108#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$7$label_108#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$7$label_108#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$7$label_108#1;

  inline$BDLSystemPowerIoCompletion$7$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_109#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$7$label_107#1;

  inline$BDLSystemPowerIoCompletion$7$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_109#1;

  inline$BDLSystemPowerIoCompletion$7$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$7$label_106#1;

  inline$BDLSystemPowerIoCompletion$7$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_106_true#1, inline$BDLSystemPowerIoCompletion$7$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_142#1;

  inline$BDLSystemPowerIoCompletion$7$label_142#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_143#1;

  inline$BDLSystemPowerIoCompletion$7$label_143#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_144#1;

  inline$BDLSystemPowerIoCompletion$7$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_109#1;

  inline$BDLSystemPowerIoCompletion$7$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_109#1;

  inline$BDLSystemPowerIoCompletion$7$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$7$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$7$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$7$myNondetVar_0, inline$BDLSystemPowerIoCompletion$7$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$7$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$7$anon50_Then#1, inline$BDLSystemPowerIoCompletion$7$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon29#1;

  inline$BDLSystemPowerIoCompletion$7$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_112#1;

  inline$BDLSystemPowerIoCompletion$7$label_112#1:
    inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$7$label_113#1;

  inline$BDLSystemPowerIoCompletion$7$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_113_true#1, inline$BDLSystemPowerIoCompletion$7$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$7$label_114#1;

  inline$BDLSystemPowerIoCompletion$7$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_116#1;

  inline$BDLSystemPowerIoCompletion$7$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_117#1;

  inline$BDLSystemPowerIoCompletion$7$label_117#1:
    goto inline$BDLGetDebugLevel$193$Entry#1;

  inline$BDLGetDebugLevel$193$Entry#1:
    goto inline$BDLGetDebugLevel$193$start#1;

  inline$BDLGetDebugLevel$193$start#1:
    goto inline$BDLGetDebugLevel$193$label_3#1;

  inline$BDLGetDebugLevel$193$label_3#1:
    havoc inline$BDLGetDebugLevel$193$myNondetVar_0;
    inline$BDLGetDebugLevel$193$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$193$myNondetVar_0;
    goto inline$BDLGetDebugLevel$193$label_1#1;

  inline$BDLGetDebugLevel$193$label_1#1:
    goto inline$BDLGetDebugLevel$193$Return#1;

  inline$BDLGetDebugLevel$193$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$193$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon51_Then#1, inline$BDLSystemPowerIoCompletion$7$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon31#1;

  inline$BDLSystemPowerIoCompletion$7$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_120#1;

  inline$BDLSystemPowerIoCompletion$7$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_120_true#1, inline$BDLSystemPowerIoCompletion$7$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_121#1;

  inline$BDLSystemPowerIoCompletion$7$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_124#1;

  inline$BDLSystemPowerIoCompletion$7$label_124#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_125#1;

  inline$BDLSystemPowerIoCompletion$7$label_125#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_126#1;

  inline$BDLSystemPowerIoCompletion$7$label_126#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_127#1;

  inline$BDLSystemPowerIoCompletion$7$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$7$label_121#1;

  inline$BDLSystemPowerIoCompletion$7$label_121#1:
    goto inline$BDLGetDebugLevel$194$Entry#1;

  inline$BDLGetDebugLevel$194$Entry#1:
    goto inline$BDLGetDebugLevel$194$start#1;

  inline$BDLGetDebugLevel$194$start#1:
    goto inline$BDLGetDebugLevel$194$label_3#1;

  inline$BDLGetDebugLevel$194$label_3#1:
    havoc inline$BDLGetDebugLevel$194$myNondetVar_0;
    inline$BDLGetDebugLevel$194$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$194$myNondetVar_0;
    goto inline$BDLGetDebugLevel$194$label_1#1;

  inline$BDLGetDebugLevel$194$label_1#1:
    goto inline$BDLGetDebugLevel$194$Return#1;

  inline$BDLGetDebugLevel$194$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$194$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon52_Then#1, inline$BDLSystemPowerIoCompletion$7$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon33#1;

  inline$BDLSystemPowerIoCompletion$7$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_130#1;

  inline$BDLSystemPowerIoCompletion$7$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_130_true#1, inline$BDLSystemPowerIoCompletion$7$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_131#1;

  inline$BDLSystemPowerIoCompletion$7$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_134#1;

  inline$BDLSystemPowerIoCompletion$7$label_134#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_135#1;

  inline$BDLSystemPowerIoCompletion$7$label_135#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_136#1;

  inline$BDLSystemPowerIoCompletion$7$label_136#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_137#1;

  inline$BDLSystemPowerIoCompletion$7$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$7$label_131#1;

  inline$BDLSystemPowerIoCompletion$7$label_131#1:
    goto inline$BDLGetDebugLevel$195$Entry#1;

  inline$BDLGetDebugLevel$195$Entry#1:
    goto inline$BDLGetDebugLevel$195$start#1;

  inline$BDLGetDebugLevel$195$start#1:
    goto inline$BDLGetDebugLevel$195$label_3#1;

  inline$BDLGetDebugLevel$195$label_3#1:
    havoc inline$BDLGetDebugLevel$195$myNondetVar_0;
    inline$BDLGetDebugLevel$195$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$195$myNondetVar_0;
    goto inline$BDLGetDebugLevel$195$label_1#1;

  inline$BDLGetDebugLevel$195$label_1#1:
    goto inline$BDLGetDebugLevel$195$Return#1;

  inline$BDLGetDebugLevel$195$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$195$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon53_Then#1, inline$BDLSystemPowerIoCompletion$7$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon35#1;

  inline$BDLSystemPowerIoCompletion$7$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_140#1;

  inline$BDLSystemPowerIoCompletion$7$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_140_true#1, inline$BDLSystemPowerIoCompletion$7$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_67#1;

  inline$BDLSystemPowerIoCompletion$7$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_141#1;

  inline$BDLSystemPowerIoCompletion$7$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_67#1;

  inline$BDLSystemPowerIoCompletion$7$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$7$label_115#1;

  inline$BDLSystemPowerIoCompletion$7$label_115#1:
    inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$7$label_80#1;

  inline$BDLSystemPowerIoCompletion$7$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$7$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_42#1;

  inline$BDLSystemPowerIoCompletion$7$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$7$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$7$label_43#1;

  inline$BDLSystemPowerIoCompletion$7$label_43#1:
    goto inline$BDLGetDebugLevel$187$Entry#1;

  inline$BDLGetDebugLevel$187$Entry#1:
    goto inline$BDLGetDebugLevel$187$start#1;

  inline$BDLGetDebugLevel$187$start#1:
    goto inline$BDLGetDebugLevel$187$label_3#1;

  inline$BDLGetDebugLevel$187$label_3#1:
    havoc inline$BDLGetDebugLevel$187$myNondetVar_0;
    inline$BDLGetDebugLevel$187$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$187$myNondetVar_0;
    goto inline$BDLGetDebugLevel$187$label_1#1;

  inline$BDLGetDebugLevel$187$label_1#1:
    goto inline$BDLGetDebugLevel$187$Return#1;

  inline$BDLGetDebugLevel$187$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$187$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon40_Then#1, inline$BDLSystemPowerIoCompletion$7$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon9#1;

  inline$BDLSystemPowerIoCompletion$7$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_46#1;

  inline$BDLSystemPowerIoCompletion$7$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_46_true#1, inline$BDLSystemPowerIoCompletion$7$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_47#1;

  inline$BDLSystemPowerIoCompletion$7$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_50#1;

  inline$BDLSystemPowerIoCompletion$7$label_50#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_51#1;

  inline$BDLSystemPowerIoCompletion$7$label_51#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_52#1;

  inline$BDLSystemPowerIoCompletion$7$label_52#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_53#1;

  inline$BDLSystemPowerIoCompletion$7$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$7$label_47#1;

  inline$BDLSystemPowerIoCompletion$7$label_47#1:
    goto inline$BDLGetDebugLevel$188$Entry#1;

  inline$BDLGetDebugLevel$188$Entry#1:
    goto inline$BDLGetDebugLevel$188$start#1;

  inline$BDLGetDebugLevel$188$start#1:
    goto inline$BDLGetDebugLevel$188$label_3#1;

  inline$BDLGetDebugLevel$188$label_3#1:
    havoc inline$BDLGetDebugLevel$188$myNondetVar_0;
    inline$BDLGetDebugLevel$188$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$188$myNondetVar_0;
    goto inline$BDLGetDebugLevel$188$label_1#1;

  inline$BDLGetDebugLevel$188$label_1#1:
    goto inline$BDLGetDebugLevel$188$Return#1;

  inline$BDLGetDebugLevel$188$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$188$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon41_Then#1, inline$BDLSystemPowerIoCompletion$7$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon11#1;

  inline$BDLSystemPowerIoCompletion$7$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_56#1;

  inline$BDLSystemPowerIoCompletion$7$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_56_true#1, inline$BDLSystemPowerIoCompletion$7$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_57#1;

  inline$BDLSystemPowerIoCompletion$7$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_60#1;

  inline$BDLSystemPowerIoCompletion$7$label_60#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_61#1;

  inline$BDLSystemPowerIoCompletion$7$label_61#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_62#1;

  inline$BDLSystemPowerIoCompletion$7$label_62#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_63#1;

  inline$BDLSystemPowerIoCompletion$7$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$7$label_57#1;

  inline$BDLSystemPowerIoCompletion$7$label_57#1:
    goto inline$BDLGetDebugLevel$189$Entry#1;

  inline$BDLGetDebugLevel$189$Entry#1:
    goto inline$BDLGetDebugLevel$189$start#1;

  inline$BDLGetDebugLevel$189$start#1:
    goto inline$BDLGetDebugLevel$189$label_3#1;

  inline$BDLGetDebugLevel$189$label_3#1:
    havoc inline$BDLGetDebugLevel$189$myNondetVar_0;
    inline$BDLGetDebugLevel$189$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$189$myNondetVar_0;
    goto inline$BDLGetDebugLevel$189$label_1#1;

  inline$BDLGetDebugLevel$189$label_1#1:
    goto inline$BDLGetDebugLevel$189$Return#1;

  inline$BDLGetDebugLevel$189$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$189$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon42_Then#1, inline$BDLSystemPowerIoCompletion$7$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon13#1;

  inline$BDLSystemPowerIoCompletion$7$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_66#1;

  inline$BDLSystemPowerIoCompletion$7$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_66_true#1, inline$BDLSystemPowerIoCompletion$7$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_67#1;

  inline$BDLSystemPowerIoCompletion$7$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_70#1;

  inline$BDLSystemPowerIoCompletion$7$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_67#1;

  inline$BDLSystemPowerIoCompletion$7$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$7$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$7$anon43_Then#1, inline$BDLSystemPowerIoCompletion$7$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon15#1;

  inline$BDLSystemPowerIoCompletion$7$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_71#1;

  inline$BDLSystemPowerIoCompletion$7$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$7$anon44_Then#1, inline$BDLSystemPowerIoCompletion$7$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon17#1;

  inline$BDLSystemPowerIoCompletion$7$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_74#1;

  inline$BDLSystemPowerIoCompletion$7$label_74#1:
    goto inline$storm_IoCompleteRequest$16$Entry#1;

  inline$storm_IoCompleteRequest$16$Entry#1:
    inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$7$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$16$start#1;

  inline$storm_IoCompleteRequest$16$start#1:
    inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$16$label_3#1;

  inline$storm_IoCompleteRequest$16$label_3#1:
    call inline$storm_IoCompleteRequest$16$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$16$label_6#1;

  inline$storm_IoCompleteRequest$16$label_6#1:
    goto inline$storm_IoCompleteRequest$16$label_6_true#1, inline$storm_IoCompleteRequest$16$label_6_false#1;

  inline$storm_IoCompleteRequest$16$label_6_false#1:
    assume inline$storm_IoCompleteRequest$16$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$16$label_7#1;

  inline$storm_IoCompleteRequest$16$label_6_true#1:
    assume inline$storm_IoCompleteRequest$16$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$16$label_8#1;

  inline$storm_IoCompleteRequest$16$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$16$anon3_Then#1, inline$storm_IoCompleteRequest$16$anon3_Else#1;

  inline$storm_IoCompleteRequest$16$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$16$anon1#1;

  inline$storm_IoCompleteRequest$16$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$16$label_9#1;

  inline$storm_IoCompleteRequest$16$label_9#1:
    goto inline$storm_IoCompleteRequest$16$label_9_true#1, inline$storm_IoCompleteRequest$16$label_9_false#1;

  inline$storm_IoCompleteRequest$16$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$16$label_10#1;

  inline$storm_IoCompleteRequest$16$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$16$label_1#1;

  inline$storm_IoCompleteRequest$16$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$16$label_7#1;

  inline$storm_IoCompleteRequest$16$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$16$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$16$label_1#1;

  inline$storm_IoCompleteRequest$16$label_1#1:
    goto inline$storm_IoCompleteRequest$16$Return#1;

  inline$storm_IoCompleteRequest$16$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$16$Return#1;

  inline$storm_IoCompleteRequest$16$Return#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon45_Then#1, inline$BDLSystemPowerIoCompletion$7$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon19#1;

  inline$BDLSystemPowerIoCompletion$7$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_77#1;

  inline$BDLSystemPowerIoCompletion$7$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$7$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$7$anon46_Then#1, inline$BDLSystemPowerIoCompletion$7$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon21#1;

  inline$BDLSystemPowerIoCompletion$7$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_80#1;

  inline$BDLSystemPowerIoCompletion$7$label_80#1:
    goto inline$BDLGetDebugLevel$190$Entry#1;

  inline$BDLGetDebugLevel$190$Entry#1:
    goto inline$BDLGetDebugLevel$190$start#1;

  inline$BDLGetDebugLevel$190$start#1:
    goto inline$BDLGetDebugLevel$190$label_3#1;

  inline$BDLGetDebugLevel$190$label_3#1:
    havoc inline$BDLGetDebugLevel$190$myNondetVar_0;
    inline$BDLGetDebugLevel$190$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$190$myNondetVar_0;
    goto inline$BDLGetDebugLevel$190$label_1#1;

  inline$BDLGetDebugLevel$190$label_1#1:
    goto inline$BDLGetDebugLevel$190$Return#1;

  inline$BDLGetDebugLevel$190$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$190$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon47_Then#1, inline$BDLSystemPowerIoCompletion$7$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon23#1;

  inline$BDLSystemPowerIoCompletion$7$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_83#1;

  inline$BDLSystemPowerIoCompletion$7$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_83_true#1, inline$BDLSystemPowerIoCompletion$7$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_84#1;

  inline$BDLSystemPowerIoCompletion$7$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_87#1;

  inline$BDLSystemPowerIoCompletion$7$label_87#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_88#1;

  inline$BDLSystemPowerIoCompletion$7$label_88#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_89#1;

  inline$BDLSystemPowerIoCompletion$7$label_89#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_90#1;

  inline$BDLSystemPowerIoCompletion$7$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$7$label_84#1;

  inline$BDLSystemPowerIoCompletion$7$label_84#1:
    goto inline$BDLGetDebugLevel$191$Entry#1;

  inline$BDLGetDebugLevel$191$Entry#1:
    goto inline$BDLGetDebugLevel$191$start#1;

  inline$BDLGetDebugLevel$191$start#1:
    goto inline$BDLGetDebugLevel$191$label_3#1;

  inline$BDLGetDebugLevel$191$label_3#1:
    havoc inline$BDLGetDebugLevel$191$myNondetVar_0;
    inline$BDLGetDebugLevel$191$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$191$myNondetVar_0;
    goto inline$BDLGetDebugLevel$191$label_1#1;

  inline$BDLGetDebugLevel$191$label_1#1:
    goto inline$BDLGetDebugLevel$191$Return#1;

  inline$BDLGetDebugLevel$191$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$191$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon48_Then#1, inline$BDLSystemPowerIoCompletion$7$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon25#1;

  inline$BDLSystemPowerIoCompletion$7$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_93#1;

  inline$BDLSystemPowerIoCompletion$7$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_93_true#1, inline$BDLSystemPowerIoCompletion$7$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_94#1;

  inline$BDLSystemPowerIoCompletion$7$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_97#1;

  inline$BDLSystemPowerIoCompletion$7$label_97#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_98#1;

  inline$BDLSystemPowerIoCompletion$7$label_98#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_99#1;

  inline$BDLSystemPowerIoCompletion$7$label_99#1:
    call inline$BDLSystemPowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$7$label_100#1;

  inline$BDLSystemPowerIoCompletion$7$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$7$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$7$label_94#1;

  inline$BDLSystemPowerIoCompletion$7$label_94#1:
    goto inline$BDLGetDebugLevel$192$Entry#1;

  inline$BDLGetDebugLevel$192$Entry#1:
    goto inline$BDLGetDebugLevel$192$start#1;

  inline$BDLGetDebugLevel$192$start#1:
    goto inline$BDLGetDebugLevel$192$label_3#1;

  inline$BDLGetDebugLevel$192$label_3#1:
    havoc inline$BDLGetDebugLevel$192$myNondetVar_0;
    inline$BDLGetDebugLevel$192$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$192$myNondetVar_0;
    goto inline$BDLGetDebugLevel$192$label_1#1;

  inline$BDLGetDebugLevel$192$label_1#1:
    goto inline$BDLGetDebugLevel$192$Return#1;

  inline$BDLGetDebugLevel$192$Return#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$192$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$7$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$7$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$7$anon49_Then#1, inline$BDLSystemPowerIoCompletion$7$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$7$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$anon27#1;

  inline$BDLSystemPowerIoCompletion$7$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_103#1;

  inline$BDLSystemPowerIoCompletion$7$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_103_true#1, inline$BDLSystemPowerIoCompletion$7$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$7$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_104#1;

  inline$BDLSystemPowerIoCompletion$7$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$7$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$7$label_105#1;

  inline$BDLSystemPowerIoCompletion$7$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$7$label_104#1;

  inline$BDLSystemPowerIoCompletion$7$label_104#1:
    inline$BDLSystemPowerIoCompletion$7$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$7$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$7$label_1#1;

  inline$BDLSystemPowerIoCompletion$7$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$7$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$7$Return#1;

  inline$BDLSystemPowerIoCompletion$7$Return#1:
    inline$CallCompletionRoutine$7$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$7$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$7$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$7$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$7$anon14_Then#1, inline$CallCompletionRoutine$7$anon14_Else#1;

  inline$CallCompletionRoutine$7$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$7$anon9#1;

  inline$CallCompletionRoutine$7$anon9#1:
    goto inline$CallCompletionRoutine$7$label_20_icall_return#1;

  inline$CallCompletionRoutine$7$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$7$Return#1;

  inline$CallCompletionRoutine$7$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$7$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$7$Entry#1;

  inline$BDLDevicePowerIoCompletion$7$Entry#1:
    inline$BDLDevicePowerIoCompletion$7$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$7$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$7$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$7$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$7$start#1;

  inline$BDLDevicePowerIoCompletion$7$start#1:
    call inline$BDLDevicePowerIoCompletion$7$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$7$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$7$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$7$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$7$label_3#1;

  inline$BDLDevicePowerIoCompletion$7$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_4#1;

  inline$BDLDevicePowerIoCompletion$7$label_4#1:
    inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_5#1;

  inline$BDLDevicePowerIoCompletion$7$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_6#1;

  inline$BDLDevicePowerIoCompletion$7$label_6#1:
    inline$BDLDevicePowerIoCompletion$7$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$7$label_7#1;

  inline$BDLDevicePowerIoCompletion$7$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_8#1;

  inline$BDLDevicePowerIoCompletion$7$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$7$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$7$label_9#1;

  inline$BDLDevicePowerIoCompletion$7$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_10#1;

  inline$BDLDevicePowerIoCompletion$7$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$41$Entry#1;

  inline$IoGetCurrentIrpStackLocation$41$Entry#1:
    inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$41$start#1;

  inline$IoGetCurrentIrpStackLocation$41$start#1:
    inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$41$label_3#1;

  inline$IoGetCurrentIrpStackLocation$41$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$41$label_3_true#1, inline$IoGetCurrentIrpStackLocation$41$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$41$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$41$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$41$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$41$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$41$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$41$label_4#1;

  inline$IoGetCurrentIrpStackLocation$41$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$41$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$41$label_6#1;

  inline$IoGetCurrentIrpStackLocation$41$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$41$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$41$label_7#1;

  inline$IoGetCurrentIrpStackLocation$41$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$41$label_5#1;

  inline$IoGetCurrentIrpStackLocation$41$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$41$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$41$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$41$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$41$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$41$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$41$label_5#1;

  inline$IoGetCurrentIrpStackLocation$41$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$41$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$41$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$41$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$41$label_1#1;

  inline$IoGetCurrentIrpStackLocation$41$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$41$Return#1;

  inline$IoGetCurrentIrpStackLocation$41$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$41$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon30_Then#1, inline$BDLDevicePowerIoCompletion$7$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon1#1;

  inline$BDLDevicePowerIoCompletion$7$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_13#1;

  inline$BDLDevicePowerIoCompletion$7$label_13#1:
    inline$BDLDevicePowerIoCompletion$7$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$7$label_14#1;

  inline$BDLDevicePowerIoCompletion$7$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_15#1;

  inline$BDLDevicePowerIoCompletion$7$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$7$label_16#1;

  inline$BDLDevicePowerIoCompletion$7$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_17#1;

  inline$BDLDevicePowerIoCompletion$7$label_17#1:
    goto inline$BDLGetDebugLevel$175$Entry#1;

  inline$BDLGetDebugLevel$175$Entry#1:
    goto inline$BDLGetDebugLevel$175$start#1;

  inline$BDLGetDebugLevel$175$start#1:
    goto inline$BDLGetDebugLevel$175$label_3#1;

  inline$BDLGetDebugLevel$175$label_3#1:
    havoc inline$BDLGetDebugLevel$175$myNondetVar_0;
    inline$BDLGetDebugLevel$175$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$175$myNondetVar_0;
    goto inline$BDLGetDebugLevel$175$label_1#1;

  inline$BDLGetDebugLevel$175$label_1#1:
    goto inline$BDLGetDebugLevel$175$Return#1;

  inline$BDLGetDebugLevel$175$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$175$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon31_Then#1, inline$BDLDevicePowerIoCompletion$7$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon3#1;

  inline$BDLDevicePowerIoCompletion$7$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_20#1;

  inline$BDLDevicePowerIoCompletion$7$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_20_true#1, inline$BDLDevicePowerIoCompletion$7$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_21#1;

  inline$BDLDevicePowerIoCompletion$7$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_24#1;

  inline$BDLDevicePowerIoCompletion$7$label_24#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_25#1;

  inline$BDLDevicePowerIoCompletion$7$label_25#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_26#1;

  inline$BDLDevicePowerIoCompletion$7$label_26#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_27#1;

  inline$BDLDevicePowerIoCompletion$7$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$7$label_21#1;

  inline$BDLDevicePowerIoCompletion$7$label_21#1:
    goto inline$BDLGetDebugLevel$176$Entry#1;

  inline$BDLGetDebugLevel$176$Entry#1:
    goto inline$BDLGetDebugLevel$176$start#1;

  inline$BDLGetDebugLevel$176$start#1:
    goto inline$BDLGetDebugLevel$176$label_3#1;

  inline$BDLGetDebugLevel$176$label_3#1:
    havoc inline$BDLGetDebugLevel$176$myNondetVar_0;
    inline$BDLGetDebugLevel$176$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$176$myNondetVar_0;
    goto inline$BDLGetDebugLevel$176$label_1#1;

  inline$BDLGetDebugLevel$176$label_1#1:
    goto inline$BDLGetDebugLevel$176$Return#1;

  inline$BDLGetDebugLevel$176$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$176$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon32_Then#1, inline$BDLDevicePowerIoCompletion$7$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon5#1;

  inline$BDLDevicePowerIoCompletion$7$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_30#1;

  inline$BDLDevicePowerIoCompletion$7$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_30_true#1, inline$BDLDevicePowerIoCompletion$7$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_31#1;

  inline$BDLDevicePowerIoCompletion$7$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_34#1;

  inline$BDLDevicePowerIoCompletion$7$label_34#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_35#1;

  inline$BDLDevicePowerIoCompletion$7$label_35#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_36#1;

  inline$BDLDevicePowerIoCompletion$7$label_36#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_37#1;

  inline$BDLDevicePowerIoCompletion$7$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$7$label_31#1;

  inline$BDLDevicePowerIoCompletion$7$label_31#1:
    goto inline$BDLGetDebugLevel$177$Entry#1;

  inline$BDLGetDebugLevel$177$Entry#1:
    goto inline$BDLGetDebugLevel$177$start#1;

  inline$BDLGetDebugLevel$177$start#1:
    goto inline$BDLGetDebugLevel$177$label_3#1;

  inline$BDLGetDebugLevel$177$label_3#1:
    havoc inline$BDLGetDebugLevel$177$myNondetVar_0;
    inline$BDLGetDebugLevel$177$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$177$myNondetVar_0;
    goto inline$BDLGetDebugLevel$177$label_1#1;

  inline$BDLGetDebugLevel$177$label_1#1:
    goto inline$BDLGetDebugLevel$177$Return#1;

  inline$BDLGetDebugLevel$177$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$177$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon33_Then#1, inline$BDLDevicePowerIoCompletion$7$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon7#1;

  inline$BDLDevicePowerIoCompletion$7$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_40#1;

  inline$BDLDevicePowerIoCompletion$7$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_40_true#1, inline$BDLDevicePowerIoCompletion$7$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_41#1;

  inline$BDLDevicePowerIoCompletion$7$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_42#1;

  inline$BDLDevicePowerIoCompletion$7$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_41#1;

  inline$BDLDevicePowerIoCompletion$7$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_41_true#1, inline$BDLDevicePowerIoCompletion$7$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$7$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$7$label_43#1;

  inline$BDLDevicePowerIoCompletion$7$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$7$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$7$label_44#1;

  inline$BDLDevicePowerIoCompletion$7$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_44_true#1, inline$BDLDevicePowerIoCompletion$7$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$7$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$7$label_45#1;

  inline$BDLDevicePowerIoCompletion$7$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_45_true#1, inline$BDLDevicePowerIoCompletion$7$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$7$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$7$label_43#1;

  inline$BDLDevicePowerIoCompletion$7$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$7$label_86#1;

  inline$BDLDevicePowerIoCompletion$7$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$7$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$7$label_46#1;

  inline$BDLDevicePowerIoCompletion$7$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$7$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$7$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$7$label_46#1;

  inline$BDLDevicePowerIoCompletion$7$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$7$label_49#1;

  inline$BDLDevicePowerIoCompletion$7$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_50#1;

  inline$BDLDevicePowerIoCompletion$7$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_51#1;

  inline$BDLDevicePowerIoCompletion$7$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_54#1;

  inline$BDLDevicePowerIoCompletion$7$label_54#1:
    inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$7$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$7$label_55#1;

  inline$BDLDevicePowerIoCompletion$7$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_55_true#1, inline$BDLDevicePowerIoCompletion$7$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_56#1;

  inline$BDLDevicePowerIoCompletion$7$label_56#1:
    call inline$BDLDevicePowerIoCompletion$7$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$7$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$7$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$7$anon34_Then#1, inline$BDLDevicePowerIoCompletion$7$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon9#1;

  inline$BDLDevicePowerIoCompletion$7$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_83#1;

  inline$BDLDevicePowerIoCompletion$7$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_59#1;

  inline$BDLDevicePowerIoCompletion$7$label_59#1:
    goto inline$BDLGetDebugLevel$178$Entry#1;

  inline$BDLGetDebugLevel$178$Entry#1:
    goto inline$BDLGetDebugLevel$178$start#1;

  inline$BDLGetDebugLevel$178$start#1:
    goto inline$BDLGetDebugLevel$178$label_3#1;

  inline$BDLGetDebugLevel$178$label_3#1:
    havoc inline$BDLGetDebugLevel$178$myNondetVar_0;
    inline$BDLGetDebugLevel$178$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$178$myNondetVar_0;
    goto inline$BDLGetDebugLevel$178$label_1#1;

  inline$BDLGetDebugLevel$178$label_1#1:
    goto inline$BDLGetDebugLevel$178$Return#1;

  inline$BDLGetDebugLevel$178$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$178$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon35_Then#1, inline$BDLDevicePowerIoCompletion$7$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon11#1;

  inline$BDLDevicePowerIoCompletion$7$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_62#1;

  inline$BDLDevicePowerIoCompletion$7$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_62_true#1, inline$BDLDevicePowerIoCompletion$7$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_63#1;

  inline$BDLDevicePowerIoCompletion$7$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_66#1;

  inline$BDLDevicePowerIoCompletion$7$label_66#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_67#1;

  inline$BDLDevicePowerIoCompletion$7$label_67#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_68#1;

  inline$BDLDevicePowerIoCompletion$7$label_68#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_69#1;

  inline$BDLDevicePowerIoCompletion$7$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$7$label_63#1;

  inline$BDLDevicePowerIoCompletion$7$label_63#1:
    goto inline$BDLGetDebugLevel$179$Entry#1;

  inline$BDLGetDebugLevel$179$Entry#1:
    goto inline$BDLGetDebugLevel$179$start#1;

  inline$BDLGetDebugLevel$179$start#1:
    goto inline$BDLGetDebugLevel$179$label_3#1;

  inline$BDLGetDebugLevel$179$label_3#1:
    havoc inline$BDLGetDebugLevel$179$myNondetVar_0;
    inline$BDLGetDebugLevel$179$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$179$myNondetVar_0;
    goto inline$BDLGetDebugLevel$179$label_1#1;

  inline$BDLGetDebugLevel$179$label_1#1:
    goto inline$BDLGetDebugLevel$179$Return#1;

  inline$BDLGetDebugLevel$179$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$179$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon36_Then#1, inline$BDLDevicePowerIoCompletion$7$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon13#1;

  inline$BDLDevicePowerIoCompletion$7$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_72#1;

  inline$BDLDevicePowerIoCompletion$7$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_72_true#1, inline$BDLDevicePowerIoCompletion$7$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_73#1;

  inline$BDLDevicePowerIoCompletion$7$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_76#1;

  inline$BDLDevicePowerIoCompletion$7$label_76#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_77#1;

  inline$BDLDevicePowerIoCompletion$7$label_77#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_78#1;

  inline$BDLDevicePowerIoCompletion$7$label_78#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_79#1;

  inline$BDLDevicePowerIoCompletion$7$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$7$label_73#1;

  inline$BDLDevicePowerIoCompletion$7$label_73#1:
    goto inline$BDLGetDebugLevel$180$Entry#1;

  inline$BDLGetDebugLevel$180$Entry#1:
    goto inline$BDLGetDebugLevel$180$start#1;

  inline$BDLGetDebugLevel$180$start#1:
    goto inline$BDLGetDebugLevel$180$label_3#1;

  inline$BDLGetDebugLevel$180$label_3#1:
    havoc inline$BDLGetDebugLevel$180$myNondetVar_0;
    inline$BDLGetDebugLevel$180$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$180$myNondetVar_0;
    goto inline$BDLGetDebugLevel$180$label_1#1;

  inline$BDLGetDebugLevel$180$label_1#1:
    goto inline$BDLGetDebugLevel$180$Return#1;

  inline$BDLGetDebugLevel$180$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$180$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon37_Then#1, inline$BDLDevicePowerIoCompletion$7$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon15#1;

  inline$BDLDevicePowerIoCompletion$7$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_82#1;

  inline$BDLDevicePowerIoCompletion$7$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_82_true#1, inline$BDLDevicePowerIoCompletion$7$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_83#1;

  inline$BDLDevicePowerIoCompletion$7$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_84#1;

  inline$BDLDevicePowerIoCompletion$7$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_83#1;

  inline$BDLDevicePowerIoCompletion$7$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_85#1;

  inline$BDLDevicePowerIoCompletion$7$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_86#1;

  inline$BDLDevicePowerIoCompletion$7$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$7$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$7$anon38_Then#1, inline$BDLDevicePowerIoCompletion$7$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon17#1;

  inline$BDLDevicePowerIoCompletion$7$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_89#1;

  inline$BDLDevicePowerIoCompletion$7$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$7$anon39_Then#1, inline$BDLDevicePowerIoCompletion$7$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon19#1;

  inline$BDLDevicePowerIoCompletion$7$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_92#1;

  inline$BDLDevicePowerIoCompletion$7$label_92#1:
    goto inline$storm_IoCompleteRequest$15$Entry#1;

  inline$storm_IoCompleteRequest$15$Entry#1:
    inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$7$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$15$start#1;

  inline$storm_IoCompleteRequest$15$start#1:
    inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$15$label_3#1;

  inline$storm_IoCompleteRequest$15$label_3#1:
    call inline$storm_IoCompleteRequest$15$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$15$label_6#1;

  inline$storm_IoCompleteRequest$15$label_6#1:
    goto inline$storm_IoCompleteRequest$15$label_6_true#1, inline$storm_IoCompleteRequest$15$label_6_false#1;

  inline$storm_IoCompleteRequest$15$label_6_false#1:
    assume inline$storm_IoCompleteRequest$15$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$15$label_7#1;

  inline$storm_IoCompleteRequest$15$label_6_true#1:
    assume inline$storm_IoCompleteRequest$15$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$15$label_8#1;

  inline$storm_IoCompleteRequest$15$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$15$anon3_Then#1, inline$storm_IoCompleteRequest$15$anon3_Else#1;

  inline$storm_IoCompleteRequest$15$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$15$anon1#1;

  inline$storm_IoCompleteRequest$15$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$15$label_9#1;

  inline$storm_IoCompleteRequest$15$label_9#1:
    goto inline$storm_IoCompleteRequest$15$label_9_true#1, inline$storm_IoCompleteRequest$15$label_9_false#1;

  inline$storm_IoCompleteRequest$15$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$15$label_10#1;

  inline$storm_IoCompleteRequest$15$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$15$label_1#1;

  inline$storm_IoCompleteRequest$15$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$15$label_7#1;

  inline$storm_IoCompleteRequest$15$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$15$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$15$label_1#1;

  inline$storm_IoCompleteRequest$15$label_1#1:
    goto inline$storm_IoCompleteRequest$15$Return#1;

  inline$storm_IoCompleteRequest$15$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$15$Return#1;

  inline$storm_IoCompleteRequest$15$Return#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon40_Then#1, inline$BDLDevicePowerIoCompletion$7$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon21#1;

  inline$BDLDevicePowerIoCompletion$7$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_95#1;

  inline$BDLDevicePowerIoCompletion$7$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$7$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$7$anon41_Then#1, inline$BDLDevicePowerIoCompletion$7$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon23#1;

  inline$BDLDevicePowerIoCompletion$7$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_98#1;

  inline$BDLDevicePowerIoCompletion$7$label_98#1:
    goto inline$BDLGetDebugLevel$181$Entry#1;

  inline$BDLGetDebugLevel$181$Entry#1:
    goto inline$BDLGetDebugLevel$181$start#1;

  inline$BDLGetDebugLevel$181$start#1:
    goto inline$BDLGetDebugLevel$181$label_3#1;

  inline$BDLGetDebugLevel$181$label_3#1:
    havoc inline$BDLGetDebugLevel$181$myNondetVar_0;
    inline$BDLGetDebugLevel$181$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$181$myNondetVar_0;
    goto inline$BDLGetDebugLevel$181$label_1#1;

  inline$BDLGetDebugLevel$181$label_1#1:
    goto inline$BDLGetDebugLevel$181$Return#1;

  inline$BDLGetDebugLevel$181$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$181$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon42_Then#1, inline$BDLDevicePowerIoCompletion$7$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon25#1;

  inline$BDLDevicePowerIoCompletion$7$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_101#1;

  inline$BDLDevicePowerIoCompletion$7$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_101_true#1, inline$BDLDevicePowerIoCompletion$7$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_102#1;

  inline$BDLDevicePowerIoCompletion$7$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_105#1;

  inline$BDLDevicePowerIoCompletion$7$label_105#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_106#1;

  inline$BDLDevicePowerIoCompletion$7$label_106#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_107#1;

  inline$BDLDevicePowerIoCompletion$7$label_107#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_108#1;

  inline$BDLDevicePowerIoCompletion$7$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$7$label_102#1;

  inline$BDLDevicePowerIoCompletion$7$label_102#1:
    goto inline$BDLGetDebugLevel$182$Entry#1;

  inline$BDLGetDebugLevel$182$Entry#1:
    goto inline$BDLGetDebugLevel$182$start#1;

  inline$BDLGetDebugLevel$182$start#1:
    goto inline$BDLGetDebugLevel$182$label_3#1;

  inline$BDLGetDebugLevel$182$label_3#1:
    havoc inline$BDLGetDebugLevel$182$myNondetVar_0;
    inline$BDLGetDebugLevel$182$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$182$myNondetVar_0;
    goto inline$BDLGetDebugLevel$182$label_1#1;

  inline$BDLGetDebugLevel$182$label_1#1:
    goto inline$BDLGetDebugLevel$182$Return#1;

  inline$BDLGetDebugLevel$182$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$182$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon43_Then#1, inline$BDLDevicePowerIoCompletion$7$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon27#1;

  inline$BDLDevicePowerIoCompletion$7$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_111#1;

  inline$BDLDevicePowerIoCompletion$7$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_111_true#1, inline$BDLDevicePowerIoCompletion$7$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_112#1;

  inline$BDLDevicePowerIoCompletion$7$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_115#1;

  inline$BDLDevicePowerIoCompletion$7$label_115#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_116#1;

  inline$BDLDevicePowerIoCompletion$7$label_116#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_117#1;

  inline$BDLDevicePowerIoCompletion$7$label_117#1:
    call inline$BDLDevicePowerIoCompletion$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$7$label_118#1;

  inline$BDLDevicePowerIoCompletion$7$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$7$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$7$label_112#1;

  inline$BDLDevicePowerIoCompletion$7$label_112#1:
    goto inline$BDLGetDebugLevel$183$Entry#1;

  inline$BDLGetDebugLevel$183$Entry#1:
    goto inline$BDLGetDebugLevel$183$start#1;

  inline$BDLGetDebugLevel$183$start#1:
    goto inline$BDLGetDebugLevel$183$label_3#1;

  inline$BDLGetDebugLevel$183$label_3#1:
    havoc inline$BDLGetDebugLevel$183$myNondetVar_0;
    inline$BDLGetDebugLevel$183$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$183$myNondetVar_0;
    goto inline$BDLGetDebugLevel$183$label_1#1;

  inline$BDLGetDebugLevel$183$label_1#1:
    goto inline$BDLGetDebugLevel$183$Return#1;

  inline$BDLGetDebugLevel$183$Return#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$183$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$7$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$7$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$7$anon44_Then#1, inline$BDLDevicePowerIoCompletion$7$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$7$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$anon29#1;

  inline$BDLDevicePowerIoCompletion$7$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_121#1;

  inline$BDLDevicePowerIoCompletion$7$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_121_true#1, inline$BDLDevicePowerIoCompletion$7$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$7$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_122#1;

  inline$BDLDevicePowerIoCompletion$7$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$7$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$7$label_123#1;

  inline$BDLDevicePowerIoCompletion$7$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$7$label_122#1;

  inline$BDLDevicePowerIoCompletion$7$label_122#1:
    inline$BDLDevicePowerIoCompletion$7$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$7$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$7$label_1#1;

  inline$BDLDevicePowerIoCompletion$7$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$7$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$7$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$7$Return#1;

  inline$BDLDevicePowerIoCompletion$7$Return#1:
    inline$CallCompletionRoutine$7$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$7$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$7$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$7$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$7$anon13_Then#1, inline$CallCompletionRoutine$7$anon13_Else#1;

  inline$CallCompletionRoutine$7$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$7$anon7#1;

  inline$CallCompletionRoutine$7$anon7#1:
    goto inline$CallCompletionRoutine$7$label_20_icall_return#1;

  inline$CallCompletionRoutine$7$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$7$Return#1;

  inline$CallCompletionRoutine$7$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$7$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$7$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$7$Entry#1;

  inline$BDLCallDriverCompletionRoutine$7$Entry#1:
    inline$BDLCallDriverCompletionRoutine$7$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$7$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$7$start#1;

  inline$BDLCallDriverCompletionRoutine$7$start#1:
    inline$BDLCallDriverCompletionRoutine$7$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$7$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$7$label_3#1;

  inline$BDLCallDriverCompletionRoutine$7$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$7$label_3_true#1, inline$BDLCallDriverCompletionRoutine$7$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$7$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$7$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$7$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$7$label_4#1;

  inline$BDLCallDriverCompletionRoutine$7$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$7$label_6#1;

  inline$BDLCallDriverCompletionRoutine$7$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$7$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$7$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$7$label_5#1;

  inline$BDLCallDriverCompletionRoutine$7$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$7$label_6#1;

  inline$BDLCallDriverCompletionRoutine$7$label_6#1:
    goto inline$storm_KeSetEvent$8$Entry#1;

  inline$storm_KeSetEvent$8$Entry#1:
    inline$storm_KeSetEvent$8$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$7$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$8$start#1;

  inline$storm_KeSetEvent$8$start#1:
    inline$storm_KeSetEvent$8$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$8$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$8$label_3#1;

  inline$storm_KeSetEvent$8$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$8$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$8$label_1#1;

  inline$storm_KeSetEvent$8$label_1#1:
    goto inline$storm_KeSetEvent$8$Return#1;

  inline$storm_KeSetEvent$8$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$7$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$7$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$7$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$7$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$7$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$7$anon1#1;

  inline$BDLCallDriverCompletionRoutine$7$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$7$label_9#1;

  inline$BDLCallDriverCompletionRoutine$7$label_9#1:
    inline$BDLCallDriverCompletionRoutine$7$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$7$label_1#1;

  inline$BDLCallDriverCompletionRoutine$7$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$7$Return#1;

  inline$BDLCallDriverCompletionRoutine$7$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$7$Return#1;

  inline$BDLCallDriverCompletionRoutine$7$Return#1:
    inline$CallCompletionRoutine$7$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$7$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$7$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$7$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$7$anon12_Then#1, inline$CallCompletionRoutine$7$anon12_Else#1;

  inline$CallCompletionRoutine$7$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$7$anon5#1;

  inline$CallCompletionRoutine$7$anon5#1:
    goto inline$CallCompletionRoutine$7$label_20_icall_return#1;

  inline$CallCompletionRoutine$7$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$7$label_23#1;

  inline$CallCompletionRoutine$7$label_23#1:
    inline$CallCompletionRoutine$7$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$7$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$7$label_24#1;

  inline$CallCompletionRoutine$7$label_24#1:
    goto inline$CallCompletionRoutine$7$label_24_true#1, inline$CallCompletionRoutine$7$label_24_false#1;

  inline$CallCompletionRoutine$7$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$7$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$7$label_1#1;

  inline$CallCompletionRoutine$7$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$7$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$7$label_25#1;

  inline$CallCompletionRoutine$7$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$7$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$7$label_1#1;

  inline$CallCompletionRoutine$7$label_1#1:
    goto inline$CallCompletionRoutine$7$Return#1;

  inline$CallCompletionRoutine$7$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$7$Return#1;

  inline$CallCompletionRoutine$7$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$7$Return#1;

  inline$CallCompletionRoutine$7$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$7$Return#1;

  inline$CallCompletionRoutine$7$Return#1:
    goto inline$storm_IoCallDriver$3$label_39$1#1;

  inline$storm_IoCallDriver$3$label_39$1#1:
    goto inline$storm_IoCallDriver$3$anon15_Then#1, inline$storm_IoCallDriver$3$anon15_Else#1;

  inline$storm_IoCallDriver$3$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$3$anon10#1;

  inline$storm_IoCallDriver$3$anon10#1:
    goto inline$storm_IoCallDriver$3$label_36#1;

  inline$storm_IoCallDriver$3$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$3$Return#1;

  inline$storm_IoCallDriver$3$label_27_case_0#1:
    assume inline$storm_IoCallDriver$3$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$3$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$3$label_28#1;

  inline$storm_IoCallDriver$3$label_28#1:
    inline$storm_IoCallDriver$3$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$3$label_42#1;

  inline$storm_IoCallDriver$3$label_42#1:
    goto inline$storm_IoCallDriver$3$label_43#1;

  inline$storm_IoCallDriver$3$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$3$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$3$label_36#1;

  inline$storm_IoCallDriver$3$label_36#1:
    inline$storm_IoCallDriver$3$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$3$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$3$label_1#1;

  inline$storm_IoCallDriver$3$label_1#1:
    goto inline$storm_IoCallDriver$3$Return#1;

  inline$storm_IoCallDriver$3$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$3$Return#1;

  inline$storm_IoCallDriver$3$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$3$Return#1;

  inline$storm_IoCallDriver$3$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$3$Return#1;

  inline$storm_IoCallDriver$3$Return#1:
    inline$storm_PoCallDriver$1$$result.storm_IoCallDriver$499.27$2$ := inline$storm_IoCallDriver$3$$result.storm_IoCallDriver$456.0$1$;
    goto inline$storm_PoCallDriver$1$label_3$1#1;

  inline$storm_PoCallDriver$1$label_3$1#1:
    goto inline$storm_PoCallDriver$1$anon2_Then#1, inline$storm_PoCallDriver$1$anon2_Else#1;

  inline$storm_PoCallDriver$1$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_PoCallDriver$1$anon1#1;

  inline$storm_PoCallDriver$1$anon1#1:
    goto inline$storm_PoCallDriver$1$label_6#1;

  inline$storm_PoCallDriver$1$label_6#1:
    inline$storm_PoCallDriver$1$$result.storm_PoCallDriver$494.0$1$ := inline$storm_PoCallDriver$1$$result.storm_IoCallDriver$499.27$2$;
    goto inline$storm_PoCallDriver$1$label_1#1;

  inline$storm_PoCallDriver$1$label_1#1:
    goto inline$storm_PoCallDriver$1$Return#1;

  inline$storm_PoCallDriver$1$anon2_Then#1:
    assume raiseException;
    goto inline$storm_PoCallDriver$1$Return#1;

  inline$storm_PoCallDriver$1$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_PoCallDriver$104.29$3$ := inline$storm_PoCallDriver$1$$result.storm_PoCallDriver$494.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_25$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_25$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon22_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon22_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon13#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon13#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_28#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_28#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_PoCallDriver$104.29$3$;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_29_true#1, inline$BDLCallLowerLevelDriverAndWait$1$label_29_false#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_29_false#1:
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_29_true#1:
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_31#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_31#1:
    goto inline$storm_KeWaitForSingleObject$1$Entry#1;

  inline$storm_KeWaitForSingleObject$1$Entry#1:
    inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1 := inline$BDLCallLowerLevelDriverAndWait$1$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1 := 0;
    goto inline$storm_KeWaitForSingleObject$1$start#1;

  inline$storm_KeWaitForSingleObject$1$start#1:
    inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1;
    inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1;
    goto inline$storm_KeWaitForSingleObject$1$label_3#1;

  inline$storm_KeWaitForSingleObject$1$label_3#1:
    goto inline$storm_KeWaitForSingleObject$1$label_3_true#1, inline$storm_KeWaitForSingleObject$1$label_3_false#1;

  inline$storm_KeWaitForSingleObject$1$label_3_false#1:
    assume inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 == 0;
    goto inline$storm_KeWaitForSingleObject$1$label_4#1;

  inline$storm_KeWaitForSingleObject$1$label_4#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$1$anon6_Then#1, inline$storm_KeWaitForSingleObject$1$anon6_Else#1;

  inline$storm_KeWaitForSingleObject$1$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$1$anon1#1;

  inline$storm_KeWaitForSingleObject$1$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$1$label_13#1;

  inline$storm_KeWaitForSingleObject$1$label_13#1:
    inline$storm_KeWaitForSingleObject$1$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$1$label_1#1;

  inline$storm_KeWaitForSingleObject$1$anon6_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$1$Return#1;

  inline$storm_KeWaitForSingleObject$1$label_3_true#1:
    assume inline$storm_KeWaitForSingleObject$1$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 != 0;
    goto inline$storm_KeWaitForSingleObject$1$label_5#1;

  inline$storm_KeWaitForSingleObject$1$label_5#1:
    call inline$storm_KeWaitForSingleObject$1$$result.storm_nondet$256.20$2$ := storm_nondet();
    goto inline$storm_KeWaitForSingleObject$1$label_8#1;

  inline$storm_KeWaitForSingleObject$1$label_8#1:
    goto inline$storm_KeWaitForSingleObject$1$label_8_true#1, inline$storm_KeWaitForSingleObject$1$label_8_false#1;

  inline$storm_KeWaitForSingleObject$1$label_8_false#1:
    assume inline$storm_KeWaitForSingleObject$1$$result.storm_nondet$256.20$2$ == 0;
    goto inline$storm_KeWaitForSingleObject$1$label_9#1;

  inline$storm_KeWaitForSingleObject$1$label_9#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$1$anon7_Then#1, inline$storm_KeWaitForSingleObject$1$anon7_Else#1;

  inline$storm_KeWaitForSingleObject$1$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$1$anon3#1;

  inline$storm_KeWaitForSingleObject$1$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20], 0);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$1$label_12#1;

  inline$storm_KeWaitForSingleObject$1$label_12#1:
    inline$storm_KeWaitForSingleObject$1$$result.storm_KeWaitForSingleObject$243.0$1$ := 258;
    goto inline$storm_KeWaitForSingleObject$1$label_1#1;

  inline$storm_KeWaitForSingleObject$1$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$1$Return#1;

  inline$storm_KeWaitForSingleObject$1$label_8_true#1:
    assume inline$storm_KeWaitForSingleObject$1$$result.storm_nondet$256.20$2$ != 0;
    goto inline$storm_KeWaitForSingleObject$1$label_10#1;

  inline$storm_KeWaitForSingleObject$1$label_10#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$1$anon8_Then#1, inline$storm_KeWaitForSingleObject$1$anon8_Else#1;

  inline$storm_KeWaitForSingleObject$1$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$1$anon5#1;

  inline$storm_KeWaitForSingleObject$1$anon5#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$1$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$1$label_11#1;

  inline$storm_KeWaitForSingleObject$1$label_11#1:
    inline$storm_KeWaitForSingleObject$1$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$1$label_1#1;

  inline$storm_KeWaitForSingleObject$1$label_1#1:
    goto inline$storm_KeWaitForSingleObject$1$Return#1;

  inline$storm_KeWaitForSingleObject$1$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$1$Return#1;

  inline$storm_KeWaitForSingleObject$1$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_KeWaitForSingleObject$116.38$5$ := inline$storm_KeWaitForSingleObject$1$$result.storm_KeWaitForSingleObject$243.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_31$1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_31$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon23_Then#1, inline$BDLCallLowerLevelDriverAndWait$1$anon23_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$anon15#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon15#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_34#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_34#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$1$$result.storm_KeWaitForSingleObject$116.38$5$;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_35#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_35#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_35_true#1, inline$BDLCallLowerLevelDriverAndWait$1$label_35_false#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_35_false#1:
    assume inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 == 0;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_35_true#1:
    assume inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 != 0;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_37#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_37#1:
    call inline$BDLCallLowerLevelDriverAndWait$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_38#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_38#1:
    call inline$BDLCallLowerLevelDriverAndWait$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_39#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_39#1:
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_36#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0;
    inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$1$myNondetVar_0;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_30#1:
    inline$BDLCallLowerLevelDriverAndWait$1$$result.BDLCallLowerLevelDriverAndWait$71.0$1$ := inline$BDLCallLowerLevelDriverAndWait$1$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8;
    goto inline$BDLCallLowerLevelDriverAndWait$1$label_1#1;

  inline$BDLCallLowerLevelDriverAndWait$1$label_1#1:
    call __HAVOC_free(inline$BDLCallLowerLevelDriverAndWait$1$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon23_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon22_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon21_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$1$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$1$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLCallLowerLevelDriverAndWait$2287.43$14$ := inline$BDLCallLowerLevelDriverAndWait$1$$result.BDLCallLowerLevelDriverAndWait$71.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_34$1#1;

  inline$BDLPnPQueryRemove$0$label_34$1#1:
    goto inline$BDLPnPQueryRemove$0$anon26_Then#1, inline$BDLPnPQueryRemove$0$anon26_Else#1;

  inline$BDLPnPQueryRemove$0$anon26_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon9#1;

  inline$BDLPnPQueryRemove$0$anon9#1:
    goto inline$BDLPnPQueryRemove$0$label_64#1;

  inline$BDLPnPQueryRemove$0$label_64#1:
    inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12 := inline$BDLPnPQueryRemove$0$$result.BDLCallLowerLevelDriverAndWait$2287.43$14$;
    goto inline$BDLPnPQueryRemove$0$label_65#1;

  inline$BDLPnPQueryRemove$0$label_65#1:
    goto inline$BDLPnPQueryRemove$0$label_65_true#1, inline$BDLPnPQueryRemove$0$label_65_false#1;

  inline$BDLPnPQueryRemove$0$label_65_false#1:
    assume inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12 == 0;
    goto inline$BDLPnPQueryRemove$0$label_38#1;

  inline$BDLPnPQueryRemove$0$label_65_true#1:
    assume inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12 != 0;
    goto inline$BDLPnPQueryRemove$0$label_66#1;

  inline$BDLPnPQueryRemove$0$label_66#1:
    goto inline$BDLGetDebugLevel$199$Entry#1;

  inline$BDLGetDebugLevel$199$Entry#1:
    goto inline$BDLGetDebugLevel$199$start#1;

  inline$BDLGetDebugLevel$199$start#1:
    goto inline$BDLGetDebugLevel$199$label_3#1;

  inline$BDLGetDebugLevel$199$label_3#1:
    havoc inline$BDLGetDebugLevel$199$myNondetVar_0;
    inline$BDLGetDebugLevel$199$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$199$myNondetVar_0;
    goto inline$BDLGetDebugLevel$199$label_1#1;

  inline$BDLGetDebugLevel$199$label_1#1:
    goto inline$BDLGetDebugLevel$199$Return#1;

  inline$BDLGetDebugLevel$199$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$15$ := inline$BDLGetDebugLevel$199$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_66$1#1;

  inline$BDLPnPQueryRemove$0$label_66$1#1:
    goto inline$BDLPnPQueryRemove$0$anon30_Then#1, inline$BDLPnPQueryRemove$0$anon30_Else#1;

  inline$BDLPnPQueryRemove$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon17#1;

  inline$BDLPnPQueryRemove$0$anon17#1:
    goto inline$BDLPnPQueryRemove$0$label_69#1;

  inline$BDLPnPQueryRemove$0$label_69#1:
    goto inline$BDLPnPQueryRemove$0$label_69_true#1, inline$BDLPnPQueryRemove$0$label_69_false#1;

  inline$BDLPnPQueryRemove$0$label_69_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$15$) == 0;
    goto inline$BDLPnPQueryRemove$0$label_70#1;

  inline$BDLPnPQueryRemove$0$label_69_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$15$) != 0;
    goto inline$BDLPnPQueryRemove$0$label_73#1;

  inline$BDLPnPQueryRemove$0$label_73#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_74#1;

  inline$BDLPnPQueryRemove$0$label_74#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_75#1;

  inline$BDLPnPQueryRemove$0$label_75#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_76#1;

  inline$BDLPnPQueryRemove$0$label_76#1:
    havoc inline$BDLPnPQueryRemove$0$$result.DbgPrint$2291.0$16$;
    goto inline$BDLPnPQueryRemove$0$label_70#1;

  inline$BDLPnPQueryRemove$0$label_70#1:
    goto inline$BDLGetDebugLevel$200$Entry#1;

  inline$BDLGetDebugLevel$200$Entry#1:
    goto inline$BDLGetDebugLevel$200$start#1;

  inline$BDLGetDebugLevel$200$start#1:
    goto inline$BDLGetDebugLevel$200$label_3#1;

  inline$BDLGetDebugLevel$200$label_3#1:
    havoc inline$BDLGetDebugLevel$200$myNondetVar_0;
    inline$BDLGetDebugLevel$200$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$200$myNondetVar_0;
    goto inline$BDLGetDebugLevel$200$label_1#1;

  inline$BDLGetDebugLevel$200$label_1#1:
    goto inline$BDLGetDebugLevel$200$Return#1;

  inline$BDLGetDebugLevel$200$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$20$ := inline$BDLGetDebugLevel$200$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_70$1#1;

  inline$BDLPnPQueryRemove$0$label_70$1#1:
    goto inline$BDLPnPQueryRemove$0$anon31_Then#1, inline$BDLPnPQueryRemove$0$anon31_Else#1;

  inline$BDLPnPQueryRemove$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon19#1;

  inline$BDLPnPQueryRemove$0$anon19#1:
    goto inline$BDLPnPQueryRemove$0$label_79#1;

  inline$BDLPnPQueryRemove$0$label_79#1:
    goto inline$BDLPnPQueryRemove$0$label_79_true#1, inline$BDLPnPQueryRemove$0$label_79_false#1;

  inline$BDLPnPQueryRemove$0$label_79_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$20$) == 0;
    goto inline$BDLPnPQueryRemove$0$label_80#1;

  inline$BDLPnPQueryRemove$0$label_79_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$20$) != 0;
    goto inline$BDLPnPQueryRemove$0$label_83#1;

  inline$BDLPnPQueryRemove$0$label_83#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_84#1;

  inline$BDLPnPQueryRemove$0$label_84#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_85#1;

  inline$BDLPnPQueryRemove$0$label_85#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_86#1;

  inline$BDLPnPQueryRemove$0$label_86#1:
    havoc inline$BDLPnPQueryRemove$0$$result.DbgPrint$2291.0$21$;
    goto inline$BDLPnPQueryRemove$0$label_80#1;

  inline$BDLPnPQueryRemove$0$label_80#1:
    goto inline$BDLGetDebugLevel$201$Entry#1;

  inline$BDLGetDebugLevel$201$Entry#1:
    goto inline$BDLGetDebugLevel$201$start#1;

  inline$BDLGetDebugLevel$201$start#1:
    goto inline$BDLGetDebugLevel$201$label_3#1;

  inline$BDLGetDebugLevel$201$label_3#1:
    havoc inline$BDLGetDebugLevel$201$myNondetVar_0;
    inline$BDLGetDebugLevel$201$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$201$myNondetVar_0;
    goto inline$BDLGetDebugLevel$201$label_1#1;

  inline$BDLGetDebugLevel$201$label_1#1:
    goto inline$BDLGetDebugLevel$201$Return#1;

  inline$BDLGetDebugLevel$201$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$25$ := inline$BDLGetDebugLevel$201$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_80$1#1;

  inline$BDLPnPQueryRemove$0$label_80$1#1:
    goto inline$BDLPnPQueryRemove$0$anon32_Then#1, inline$BDLPnPQueryRemove$0$anon32_Else#1;

  inline$BDLPnPQueryRemove$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon21#1;

  inline$BDLPnPQueryRemove$0$anon21#1:
    goto inline$BDLPnPQueryRemove$0$label_89#1;

  inline$BDLPnPQueryRemove$0$label_89#1:
    goto inline$BDLPnPQueryRemove$0$label_89_true#1, inline$BDLPnPQueryRemove$0$label_89_false#1;

  inline$BDLPnPQueryRemove$0$label_89_false#1:
    assume BIT_BAND(inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$25$, 4) == 0;
    goto inline$BDLPnPQueryRemove$0$label_38#1;

  inline$BDLPnPQueryRemove$0$label_89_true#1:
    assume BIT_BAND(inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2291.0$25$, 4) != 0;
    goto inline$BDLPnPQueryRemove$0$label_90#1;

  inline$BDLPnPQueryRemove$0$label_90#1:
    goto inline$BDLPnPQueryRemove$0$label_38#1;

  inline$BDLPnPQueryRemove$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon26_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$label_33_true#1:
    havoc inline$BDLPnPQueryRemove$0$myNondetVar_0;
    assume inline$BDLPnPQueryRemove$0$myNondetVar_0 != 0;
    goto inline$BDLPnPQueryRemove$0$label_37#1;

  inline$BDLPnPQueryRemove$0$label_37#1:
    inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12 := 0 - 1073741823;
    goto inline$BDLPnPQueryRemove$0$label_38#1;

  inline$BDLPnPQueryRemove$0$label_38#1:
    goto inline$BDLGetDebugLevel$196$Entry#1;

  inline$BDLGetDebugLevel$196$Entry#1:
    goto inline$BDLGetDebugLevel$196$start#1;

  inline$BDLGetDebugLevel$196$start#1:
    goto inline$BDLGetDebugLevel$196$label_3#1;

  inline$BDLGetDebugLevel$196$label_3#1:
    havoc inline$BDLGetDebugLevel$196$myNondetVar_0;
    inline$BDLGetDebugLevel$196$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$196$myNondetVar_0;
    goto inline$BDLGetDebugLevel$196$label_1#1;

  inline$BDLGetDebugLevel$196$label_1#1:
    goto inline$BDLGetDebugLevel$196$Return#1;

  inline$BDLGetDebugLevel$196$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$26$ := inline$BDLGetDebugLevel$196$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_38$1#1;

  inline$BDLPnPQueryRemove$0$label_38$1#1:
    goto inline$BDLPnPQueryRemove$0$anon27_Then#1, inline$BDLPnPQueryRemove$0$anon27_Else#1;

  inline$BDLPnPQueryRemove$0$anon27_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon11#1;

  inline$BDLPnPQueryRemove$0$anon11#1:
    goto inline$BDLPnPQueryRemove$0$label_41#1;

  inline$BDLPnPQueryRemove$0$label_41#1:
    goto inline$BDLPnPQueryRemove$0$label_41_true#1, inline$BDLPnPQueryRemove$0$label_41_false#1;

  inline$BDLPnPQueryRemove$0$label_41_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$26$) == 0;
    goto inline$BDLPnPQueryRemove$0$label_42#1;

  inline$BDLPnPQueryRemove$0$label_41_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$26$) != 0;
    goto inline$BDLPnPQueryRemove$0$label_45#1;

  inline$BDLPnPQueryRemove$0$label_45#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_46#1;

  inline$BDLPnPQueryRemove$0$label_46#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_47#1;

  inline$BDLPnPQueryRemove$0$label_47#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_48#1;

  inline$BDLPnPQueryRemove$0$label_48#1:
    havoc inline$BDLPnPQueryRemove$0$$result.DbgPrint$2303.0$27$;
    goto inline$BDLPnPQueryRemove$0$label_42#1;

  inline$BDLPnPQueryRemove$0$label_42#1:
    goto inline$BDLGetDebugLevel$197$Entry#1;

  inline$BDLGetDebugLevel$197$Entry#1:
    goto inline$BDLGetDebugLevel$197$start#1;

  inline$BDLGetDebugLevel$197$start#1:
    goto inline$BDLGetDebugLevel$197$label_3#1;

  inline$BDLGetDebugLevel$197$label_3#1:
    havoc inline$BDLGetDebugLevel$197$myNondetVar_0;
    inline$BDLGetDebugLevel$197$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$197$myNondetVar_0;
    goto inline$BDLGetDebugLevel$197$label_1#1;

  inline$BDLGetDebugLevel$197$label_1#1:
    goto inline$BDLGetDebugLevel$197$Return#1;

  inline$BDLGetDebugLevel$197$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$31$ := inline$BDLGetDebugLevel$197$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_42$1#1;

  inline$BDLPnPQueryRemove$0$label_42$1#1:
    goto inline$BDLPnPQueryRemove$0$anon28_Then#1, inline$BDLPnPQueryRemove$0$anon28_Else#1;

  inline$BDLPnPQueryRemove$0$anon28_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon13#1;

  inline$BDLPnPQueryRemove$0$anon13#1:
    goto inline$BDLPnPQueryRemove$0$label_51#1;

  inline$BDLPnPQueryRemove$0$label_51#1:
    goto inline$BDLPnPQueryRemove$0$label_51_true#1, inline$BDLPnPQueryRemove$0$label_51_false#1;

  inline$BDLPnPQueryRemove$0$label_51_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$31$) == 0;
    goto inline$BDLPnPQueryRemove$0$label_52#1;

  inline$BDLPnPQueryRemove$0$label_51_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$31$) != 0;
    goto inline$BDLPnPQueryRemove$0$label_55#1;

  inline$BDLPnPQueryRemove$0$label_55#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_56#1;

  inline$BDLPnPQueryRemove$0$label_56#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_57#1;

  inline$BDLPnPQueryRemove$0$label_57#1:
    call inline$BDLPnPQueryRemove$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPQueryRemove$0$label_58#1;

  inline$BDLPnPQueryRemove$0$label_58#1:
    havoc inline$BDLPnPQueryRemove$0$$result.DbgPrint$2303.0$32$;
    goto inline$BDLPnPQueryRemove$0$label_52#1;

  inline$BDLPnPQueryRemove$0$label_52#1:
    goto inline$BDLGetDebugLevel$198$Entry#1;

  inline$BDLGetDebugLevel$198$Entry#1:
    goto inline$BDLGetDebugLevel$198$start#1;

  inline$BDLGetDebugLevel$198$start#1:
    goto inline$BDLGetDebugLevel$198$label_3#1;

  inline$BDLGetDebugLevel$198$label_3#1:
    havoc inline$BDLGetDebugLevel$198$myNondetVar_0;
    inline$BDLGetDebugLevel$198$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$198$myNondetVar_0;
    goto inline$BDLGetDebugLevel$198$label_1#1;

  inline$BDLGetDebugLevel$198$label_1#1:
    goto inline$BDLGetDebugLevel$198$Return#1;

  inline$BDLGetDebugLevel$198$Return#1:
    inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$36$ := inline$BDLGetDebugLevel$198$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPQueryRemove$0$label_52$1#1;

  inline$BDLPnPQueryRemove$0$label_52$1#1:
    goto inline$BDLPnPQueryRemove$0$anon29_Then#1, inline$BDLPnPQueryRemove$0$anon29_Else#1;

  inline$BDLPnPQueryRemove$0$anon29_Else#1:
    assume !raiseException;
    goto inline$BDLPnPQueryRemove$0$anon15#1;

  inline$BDLPnPQueryRemove$0$anon15#1:
    goto inline$BDLPnPQueryRemove$0$label_61#1;

  inline$BDLPnPQueryRemove$0$label_61#1:
    goto inline$BDLPnPQueryRemove$0$label_61_true#1, inline$BDLPnPQueryRemove$0$label_61_false#1;

  inline$BDLPnPQueryRemove$0$label_61_false#1:
    assume BIT_BAND(inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$36$, 4) == 0;
    goto inline$BDLPnPQueryRemove$0$label_62#1;

  inline$BDLPnPQueryRemove$0$label_61_true#1:
    assume BIT_BAND(inline$BDLPnPQueryRemove$0$$result.BDLGetDebugLevel$2303.0$36$, 4) != 0;
    goto inline$BDLPnPQueryRemove$0$label_63#1;

  inline$BDLPnPQueryRemove$0$label_63#1:
    goto inline$BDLPnPQueryRemove$0$label_62#1;

  inline$BDLPnPQueryRemove$0$label_62#1:
    inline$BDLPnPQueryRemove$0$$result.BDLPnPQueryRemove$2254.0$1$ := inline$BDLPnPQueryRemove$0$$status$4$2261.28$BDLPnPQueryRemove$12;
    goto inline$BDLPnPQueryRemove$0$label_1#1;

  inline$BDLPnPQueryRemove$0$label_1#1:
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon29_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon28_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon27_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon25_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon24_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon23_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$anon22_Then#1:
    assume raiseException;
    goto inline$BDLPnPQueryRemove$0$Return#1;

  inline$BDLPnPQueryRemove$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPQueryRemove$943.34$32$ := inline$BDLPnPQueryRemove$0$$result.BDLPnPQueryRemove$2254.0$1$;
    goto inline$BDLPnP$0$label_116$1#1;

  inline$BDLPnP$0$label_116$1#1:
    goto inline$BDLPnP$0$anon68_Then#1, inline$BDLPnP$0$anon68_Else#1;

  inline$BDLPnP$0$anon68_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon29#1;

  inline$BDLPnP$0$anon29#1:
    goto inline$BDLPnP$0$label_154#1;

  inline$BDLPnP$0$label_154#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPQueryRemove$943.34$32$;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon68_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_1#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 == 0;
    goto inline$BDLPnP$0$label_113#1;

  inline$BDLPnP$0$label_113#1:
    goto inline$BDLPnPStart$0$Entry#1;

  inline$BDLPnPStart$0$Entry#1:
    inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16_.1 := inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8;
    inline$BDLPnPStart$0$$pIrp$3$1958.40$BDLPnPStart$16_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$BDLPnPStart$0$start#1;

  inline$BDLPnPStart$0$start#1:
    call inline$BDLPnPStart$0$$bdsiInitializeResourcesParams$7$1964.32$BDLPnPStart$16 := __HAVOC_malloc(548);
    inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16 := inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16_.1;
    inline$BDLPnPStart$0$$pIrp$3$1958.40$BDLPnPStart$16 := inline$BDLPnPStart$0$$pIrp$3$1958.40$BDLPnPStart$16_.1;
    goto inline$BDLPnPStart$0$label_3#1;

  inline$BDLPnPStart$0$label_3#1:
    goto inline$BDLPnPStart$0$label_4#1;

  inline$BDLPnPStart$0$label_4#1:
    inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 := 0;
    goto inline$BDLPnPStart$0$label_5#1;

  inline$BDLPnPStart$0$label_5#1:
    goto inline$BDLPnPStart$0$label_6#1;

  inline$BDLPnPStart$0$label_6#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_7#1;

  inline$BDLPnPStart$0$label_7#1:
    goto inline$BDLPnPStart$0$label_8#1;

  inline$BDLPnPStart$0$label_8#1:
    goto inline$BDLGetDebugLevel$10$Entry#1;

  inline$BDLGetDebugLevel$10$Entry#1:
    goto inline$BDLGetDebugLevel$10$start#1;

  inline$BDLGetDebugLevel$10$start#1:
    goto inline$BDLGetDebugLevel$10$label_3#1;

  inline$BDLGetDebugLevel$10$label_3#1:
    havoc inline$BDLGetDebugLevel$10$myNondetVar_0;
    inline$BDLGetDebugLevel$10$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$10$myNondetVar_0;
    goto inline$BDLGetDebugLevel$10$label_1#1;

  inline$BDLGetDebugLevel$10$label_1#1:
    goto inline$BDLGetDebugLevel$10$Return#1;

  inline$BDLGetDebugLevel$10$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$2$ := inline$BDLGetDebugLevel$10$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_8$1#1;

  inline$BDLPnPStart$0$label_8$1#1:
    goto inline$BDLPnPStart$0$anon36_Then#1, inline$BDLPnPStart$0$anon36_Else#1;

  inline$BDLPnPStart$0$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon1#1;

  inline$BDLPnPStart$0$anon1#1:
    goto inline$BDLPnPStart$0$label_11#1;

  inline$BDLPnPStart$0$label_11#1:
    goto inline$BDLPnPStart$0$label_11_true#1, inline$BDLPnPStart$0$label_11_false#1;

  inline$BDLPnPStart$0$label_11_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$2$) == 0;
    goto inline$BDLPnPStart$0$label_12#1;

  inline$BDLPnPStart$0$label_11_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$2$) != 0;
    goto inline$BDLPnPStart$0$label_15#1;

  inline$BDLPnPStart$0$label_15#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_16#1;

  inline$BDLPnPStart$0$label_16#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_17#1;

  inline$BDLPnPStart$0$label_17#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_18#1;

  inline$BDLPnPStart$0$label_18#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$1966.0$3$;
    goto inline$BDLPnPStart$0$label_12#1;

  inline$BDLPnPStart$0$label_12#1:
    goto inline$BDLGetDebugLevel$11$Entry#1;

  inline$BDLGetDebugLevel$11$Entry#1:
    goto inline$BDLGetDebugLevel$11$start#1;

  inline$BDLGetDebugLevel$11$start#1:
    goto inline$BDLGetDebugLevel$11$label_3#1;

  inline$BDLGetDebugLevel$11$label_3#1:
    havoc inline$BDLGetDebugLevel$11$myNondetVar_0;
    inline$BDLGetDebugLevel$11$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$11$myNondetVar_0;
    goto inline$BDLGetDebugLevel$11$label_1#1;

  inline$BDLGetDebugLevel$11$label_1#1:
    goto inline$BDLGetDebugLevel$11$Return#1;

  inline$BDLGetDebugLevel$11$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$7$ := inline$BDLGetDebugLevel$11$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_12$1#1;

  inline$BDLPnPStart$0$label_12$1#1:
    goto inline$BDLPnPStart$0$anon37_Then#1, inline$BDLPnPStart$0$anon37_Else#1;

  inline$BDLPnPStart$0$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon3#1;

  inline$BDLPnPStart$0$anon3#1:
    goto inline$BDLPnPStart$0$label_21#1;

  inline$BDLPnPStart$0$label_21#1:
    goto inline$BDLPnPStart$0$label_21_true#1, inline$BDLPnPStart$0$label_21_false#1;

  inline$BDLPnPStart$0$label_21_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$7$) == 0;
    goto inline$BDLPnPStart$0$label_22#1;

  inline$BDLPnPStart$0$label_21_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$7$) != 0;
    goto inline$BDLPnPStart$0$label_25#1;

  inline$BDLPnPStart$0$label_25#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_26#1;

  inline$BDLPnPStart$0$label_26#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_27#1;

  inline$BDLPnPStart$0$label_27#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_28#1;

  inline$BDLPnPStart$0$label_28#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$1966.0$8$;
    goto inline$BDLPnPStart$0$label_22#1;

  inline$BDLPnPStart$0$label_22#1:
    goto inline$BDLGetDebugLevel$12$Entry#1;

  inline$BDLGetDebugLevel$12$Entry#1:
    goto inline$BDLGetDebugLevel$12$start#1;

  inline$BDLGetDebugLevel$12$start#1:
    goto inline$BDLGetDebugLevel$12$label_3#1;

  inline$BDLGetDebugLevel$12$label_3#1:
    havoc inline$BDLGetDebugLevel$12$myNondetVar_0;
    inline$BDLGetDebugLevel$12$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$12$myNondetVar_0;
    goto inline$BDLGetDebugLevel$12$label_1#1;

  inline$BDLGetDebugLevel$12$label_1#1:
    goto inline$BDLGetDebugLevel$12$Return#1;

  inline$BDLGetDebugLevel$12$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$12$ := inline$BDLGetDebugLevel$12$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_22$1#1;

  inline$BDLPnPStart$0$label_22$1#1:
    goto inline$BDLPnPStart$0$anon38_Then#1, inline$BDLPnPStart$0$anon38_Else#1;

  inline$BDLPnPStart$0$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon5#1;

  inline$BDLPnPStart$0$anon5#1:
    goto inline$BDLPnPStart$0$label_31#1;

  inline$BDLPnPStart$0$label_31#1:
    goto inline$BDLPnPStart$0$label_31_true#1, inline$BDLPnPStart$0$label_31_false#1;

  inline$BDLPnPStart$0$label_31_false#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$12$, 4) == 0;
    goto inline$BDLPnPStart$0$label_32#1;

  inline$BDLPnPStart$0$label_31_true#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1966.0$12$, 4) != 0;
    goto inline$BDLPnPStart$0$label_35#1;

  inline$BDLPnPStart$0$label_35#1:
    goto inline$BDLPnPStart$0$label_32#1;

  inline$BDLPnPStart$0$label_32#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$Entry#1;

  inline$BDLCallLowerLevelDriverAndWait$0$Entry#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1 := inline$BDLPnPStart$0$$pIrp$3$1958.40$BDLPnPStart$16;
    goto inline$BDLCallLowerLevelDriverAndWait$0$start#1;

  inline$BDLCallLowerLevelDriverAndWait$0$start#1:
    call inline$BDLCallLowerLevelDriverAndWait$0$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8 := __HAVOC_malloc(16);
    inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8_.1;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_3#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_4#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_4#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := 0;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_5#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_6#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_6#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$Entry#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$Entry#1:
    inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$start#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$start#1:
    inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4 := inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4_.1;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_4#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_4#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_5#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_5#1:
    goto inline$IoGetCurrentIrpStackLocation$3$Entry#1;

  inline$IoGetCurrentIrpStackLocation$3$Entry#1:
    inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetCurrentIrpStackLocation$3$start#1;

  inline$IoGetCurrentIrpStackLocation$3$start#1:
    inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$3$label_3#1;

  inline$IoGetCurrentIrpStackLocation$3$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$3$label_3_true#1, inline$IoGetCurrentIrpStackLocation$3$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$3$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$3$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$3$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$3$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$3$label_4#1;

  inline$IoGetCurrentIrpStackLocation$3$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$3$label_6#1;

  inline$IoGetCurrentIrpStackLocation$3$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$3$label_7#1;

  inline$IoGetCurrentIrpStackLocation$3$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$3$label_5#1;

  inline$IoGetCurrentIrpStackLocation$3$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$3$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$3$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$3$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$3$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$3$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$3$label_5#1;

  inline$IoGetCurrentIrpStackLocation$3$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$3$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$3$label_1#1;

  inline$IoGetCurrentIrpStackLocation$3$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$3$Return#1;

  inline$IoGetCurrentIrpStackLocation$3$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_5$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_5$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$anon4_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$0$anon4_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$anon4_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$anon1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$anon1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_8#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_8#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_9#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_9#1:
    goto inline$IoGetNextIrpStackLocation$1$Entry#1;

  inline$IoGetNextIrpStackLocation$1$Entry#1:
    inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$IoCopyCurrentIrpStackLocationToNext$0$$Irp$1$25081.17$IoCopyCurrentIrpStackLocationToNext$4;
    goto inline$IoGetNextIrpStackLocation$1$start#1;

  inline$IoGetNextIrpStackLocation$1$start#1:
    inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$1$label_3#1;

  inline$IoGetNextIrpStackLocation$1$label_3#1:
    goto inline$IoGetNextIrpStackLocation$1$label_3_true#1, inline$IoGetNextIrpStackLocation$1$label_3_false#1;

  inline$IoGetNextIrpStackLocation$1$label_3_false#1:
    inline$IoGetNextIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$1$myVar_0);
    goto inline$IoGetNextIrpStackLocation$1$label_4#1;

  inline$IoGetNextIrpStackLocation$1$label_4#1:
    call inline$IoGetNextIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$1$label_6#1;

  inline$IoGetNextIrpStackLocation$1$label_6#1:
    call inline$IoGetNextIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$1$label_7#1;

  inline$IoGetNextIrpStackLocation$1$label_7#1:
    goto inline$IoGetNextIrpStackLocation$1$label_5#1;

  inline$IoGetNextIrpStackLocation$1$label_3_true#1:
    inline$IoGetNextIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$1$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$1$myVar_0);
    goto inline$IoGetNextIrpStackLocation$1$label_5#1;

  inline$IoGetNextIrpStackLocation$1$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$1$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$1$label_1#1;

  inline$IoGetNextIrpStackLocation$1$label_1#1:
    goto inline$IoGetNextIrpStackLocation$1$Return#1;

  inline$IoGetNextIrpStackLocation$1$Return#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_9$1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_9$1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$anon5_Then#1, inline$IoCopyCurrentIrpStackLocationToNext$0$anon5_Else#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$anon5_Else#1:
    assume !raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$anon3#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$anon3#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_12#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_12#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_13#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_13#1:
    havoc inline$IoCopyCurrentIrpStackLocationToNext$0$$result.memcpy$25110.4$3$;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_16#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_16#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$label_1#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$label_1#1:
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$anon5_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$anon4_Then#1:
    assume raiseException;
    goto inline$IoCopyCurrentIrpStackLocationToNext$0$Return#1;

  inline$IoCopyCurrentIrpStackLocationToNext$0$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_6$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_6$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon16_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon16_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon16_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_9#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_9#1:
    goto inline$storm_KeInitializeEvent$0$Entry#1;

  inline$storm_KeInitializeEvent$0$Entry#1:
    inline$storm_KeInitializeEvent$0$$Event$1$203.14$storm_KeInitializeEvent$12_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeInitializeEvent$0$$State$3$205.13$storm_KeInitializeEvent$12_.1 := 0;
    goto inline$storm_KeInitializeEvent$0$start#1;

  inline$storm_KeInitializeEvent$0$start#1:
    inline$storm_KeInitializeEvent$0$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$0$$Event$1$203.14$storm_KeInitializeEvent$12_.1;
    inline$storm_KeInitializeEvent$0$$State$3$205.13$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$0$$State$3$205.13$storm_KeInitializeEvent$12_.1;
    goto inline$storm_KeInitializeEvent$0$label_3#1;

  inline$storm_KeInitializeEvent$0$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeInitializeEvent$0$$Event$1$203.14$storm_KeInitializeEvent$12 := inline$storm_KeInitializeEvent$0$$State$3$205.13$storm_KeInitializeEvent$12];
    call contextSwitch();
    goto inline$storm_KeInitializeEvent$0$label_1#1;

  inline$storm_KeInitializeEvent$0$label_1#1:
    goto inline$storm_KeInitializeEvent$0$Return#1;

  inline$storm_KeInitializeEvent$0$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_9$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_9$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon17_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon17_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon17_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon3#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon3#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_12#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$0$Entry#1;

  inline$storm_IoSetCompletionRoutine$0$Entry#1:
    inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoSetCompletionRoutine$0$start#1;

  inline$storm_IoSetCompletionRoutine$0$start#1:
    inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24 := inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24_.1;
    goto inline$storm_IoSetCompletionRoutine$0$label_3#1;

  inline$storm_IoSetCompletionRoutine$0$label_3#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_4#1;

  inline$storm_IoSetCompletionRoutine$0$label_4#1:
    call inline$storm_IoSetCompletionRoutine$0$$result.storm_nondet$405.2$1$ := storm_nondet();
    goto inline$storm_IoSetCompletionRoutine$0$label_7#1;

  inline$storm_IoSetCompletionRoutine$0$label_7#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_7_true#1, inline$storm_IoSetCompletionRoutine$0$label_7_false#1;

  inline$storm_IoSetCompletionRoutine$0$label_7_false#1:
    assume inline$storm_IoSetCompletionRoutine$0$$result.storm_nondet$405.2$1$ == 0;
    goto inline$storm_IoSetCompletionRoutine$0$label_8#1;

  inline$storm_IoSetCompletionRoutine$0$label_7_true#1:
    assume inline$storm_IoSetCompletionRoutine$0$$result.storm_nondet$405.2$1$ != 0;
    goto inline$storm_IoSetCompletionRoutine$0$label_11#1;

  inline$storm_IoSetCompletionRoutine$0$label_11#1:
    havoc raiseException;
    goto inline$storm_IoSetCompletionRoutine$0$anon6_Then#1, inline$storm_IoSetCompletionRoutine$0$anon6_Else#1;

  inline$storm_IoSetCompletionRoutine$0$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$0$anon3#1;

  inline$storm_IoSetCompletionRoutine$0$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24], 1);
    call contextSwitch();
    goto inline$storm_IoSetCompletionRoutine$0$label_12#1;

  inline$storm_IoSetCompletionRoutine$0$label_12#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_12_true#1, inline$storm_IoSetCompletionRoutine$0$label_12_false#1;

  inline$storm_IoSetCompletionRoutine$0$label_12_false#1:
    assume 0 == 0;
    goto inline$storm_IoSetCompletionRoutine$0$label_13#1;

  inline$storm_IoSetCompletionRoutine$0$label_13#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoSetCompletionRoutine$0$label_1#1;

  inline$storm_IoSetCompletionRoutine$0$label_12_true#1:
    assume 0 != 0;
    goto inline$storm_IoSetCompletionRoutine$0$label_8#1;

  inline$storm_IoSetCompletionRoutine$0$label_8#1:
    goto inline$IoGetNextIrpStackLocation$2$Entry#1;

  inline$IoGetNextIrpStackLocation$2$Entry#1:
    inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1 := inline$storm_IoSetCompletionRoutine$0$$pirp$1$396.10$storm_IoSetCompletionRoutine$24;
    goto inline$IoGetNextIrpStackLocation$2$start#1;

  inline$IoGetNextIrpStackLocation$2$start#1:
    inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4 := inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4_.1;
    goto inline$IoGetNextIrpStackLocation$2$label_3#1;

  inline$IoGetNextIrpStackLocation$2$label_3#1:
    goto inline$IoGetNextIrpStackLocation$2$label_3_true#1, inline$IoGetNextIrpStackLocation$2$label_3_false#1;

  inline$IoGetNextIrpStackLocation$2$label_3_false#1:
    inline$IoGetNextIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoGetNextIrpStackLocation$2$myVar_0);
    goto inline$IoGetNextIrpStackLocation$2$label_4#1;

  inline$IoGetNextIrpStackLocation$2$label_4#1:
    call inline$IoGetNextIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$2$label_6#1;

  inline$IoGetNextIrpStackLocation$2$label_6#1:
    call inline$IoGetNextIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetNextIrpStackLocation$2$label_7#1;

  inline$IoGetNextIrpStackLocation$2$label_7#1:
    goto inline$IoGetNextIrpStackLocation$2$label_5#1;

  inline$IoGetNextIrpStackLocation$2$label_3_true#1:
    inline$IoGetNextIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetNextIrpStackLocation$2$$Irp$1$24655.14$IoGetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoGetNextIrpStackLocation$2$myVar_0);
    goto inline$IoGetNextIrpStackLocation$2$label_5#1;

  inline$IoGetNextIrpStackLocation$2$label_5#1:
    havoc inline$IoGetNextIrpStackLocation$2$myNondetVar_0;
    goto inline$IoGetNextIrpStackLocation$2$label_1#1;

  inline$IoGetNextIrpStackLocation$2$label_1#1:
    goto inline$IoGetNextIrpStackLocation$2$Return#1;

  inline$IoGetNextIrpStackLocation$2$Return#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_8$1#1;

  inline$storm_IoSetCompletionRoutine$0$label_8$1#1:
    goto inline$storm_IoSetCompletionRoutine$0$anon5_Then#1, inline$storm_IoSetCompletionRoutine$0$anon5_Else#1;

  inline$storm_IoSetCompletionRoutine$0$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_IoSetCompletionRoutine$0$anon1#1;

  inline$storm_IoSetCompletionRoutine$0$anon1#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_16#1;

  inline$storm_IoSetCompletionRoutine$0$label_16#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_17#1;

  inline$storm_IoSetCompletionRoutine$0$label_17#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_18#1;

  inline$storm_IoSetCompletionRoutine$0$label_18#1:
    goto inline$storm_IoSetCompletionRoutine$0$label_1#1;

  inline$storm_IoSetCompletionRoutine$0$label_1#1:
    goto inline$storm_IoSetCompletionRoutine$0$Return#1;

  inline$storm_IoSetCompletionRoutine$0$anon5_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$0$Return#1;

  inline$storm_IoSetCompletionRoutine$0$anon6_Then#1:
    assume raiseException;
    goto inline$storm_IoSetCompletionRoutine$0$Return#1;

  inline$storm_IoSetCompletionRoutine$0$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_12$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_12$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon18_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon18_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon18_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon5#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon5#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_15#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_15#1:
    goto inline$IoGetCurrentIrpStackLocation$4$Entry#1;

  inline$IoGetCurrentIrpStackLocation$4$Entry#1:
    inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$IoGetCurrentIrpStackLocation$4$start#1;

  inline$IoGetCurrentIrpStackLocation$4$start#1:
    inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$4$label_3#1;

  inline$IoGetCurrentIrpStackLocation$4$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$4$label_3_true#1, inline$IoGetCurrentIrpStackLocation$4$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$4$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$4$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$4$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$4$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$4$label_4#1;

  inline$IoGetCurrentIrpStackLocation$4$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$4$label_6#1;

  inline$IoGetCurrentIrpStackLocation$4$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$4$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$4$label_7#1;

  inline$IoGetCurrentIrpStackLocation$4$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$4$label_5#1;

  inline$IoGetCurrentIrpStackLocation$4$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$4$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$4$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$4$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$4$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$4$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$4$label_5#1;

  inline$IoGetCurrentIrpStackLocation$4$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$4$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$4$label_1#1;

  inline$IoGetCurrentIrpStackLocation$4$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$4$Return#1;

  inline$IoGetCurrentIrpStackLocation$4$Return#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_15$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_15$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon19_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon19_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon19_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon7#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon7#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_18#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_18#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_18_true#1, inline$BDLCallLowerLevelDriverAndWait$0$label_18_false#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_18_false#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_19#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_19#1:
    goto inline$storm_IoCallDriver$0$Entry#1;

  inline$storm_IoCallDriver$0$Entry#1:
    inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_IoCallDriver$0$start#1;

  inline$storm_IoCallDriver$0$start#1:
    inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$0$label_3#1;

  inline$storm_IoCallDriver$0$label_3#1:
    goto inline$storm_IoCallDriver$0$label_4#1;

  inline$storm_IoCallDriver$0$label_4#1:
    goto inline$storm_IoCallDriver$0$label_5#1;

  inline$storm_IoCallDriver$0$label_5#1:
    goto inline$storm_IoCallDriver$0$label_6#1;

  inline$storm_IoCallDriver$0$label_6#1:
    call inline$storm_IoCallDriver$0$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$0$label_9#1;

  inline$storm_IoCallDriver$0$label_9#1:
    goto inline$storm_IoCallDriver$0$label_9_true#1, inline$storm_IoCallDriver$0$label_9_false#1;

  inline$storm_IoCallDriver$0$label_9_false#1:
    assume inline$storm_IoCallDriver$0$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$0$label_10#1;

  inline$storm_IoCallDriver$0$label_9_true#1:
    assume inline$storm_IoCallDriver$0$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$0$label_13#1;

  inline$storm_IoCallDriver$0$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$0$anon12_Then#1, inline$storm_IoCallDriver$0$anon12_Else#1;

  inline$storm_IoCallDriver$0$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$0$anon3#1;

  inline$storm_IoCallDriver$0$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$0$label_14#1;

  inline$storm_IoCallDriver$0$label_14#1:
    goto inline$storm_IoCallDriver$0$label_14_true#1, inline$storm_IoCallDriver$0$label_14_false#1;

  inline$storm_IoCallDriver$0$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$0$label_15#1;

  inline$storm_IoCallDriver$0$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$0$label_1#1;

  inline$storm_IoCallDriver$0$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$0$label_10#1;

  inline$storm_IoCallDriver$0$label_10#1:
    goto inline$IoSetNextIrpStackLocation$1$Entry#1;

  inline$IoSetNextIrpStackLocation$1$Entry#1:
    inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$1$start#1;

  inline$IoSetNextIrpStackLocation$1$start#1:
    inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$1$label_3#1;

  inline$IoSetNextIrpStackLocation$1$label_3#1:
    goto inline$IoSetNextIrpStackLocation$1$label_3_true#1, inline$IoSetNextIrpStackLocation$1$label_3_false#1;

  inline$IoSetNextIrpStackLocation$1$label_3_false#1:
    inline$IoSetNextIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$1$myVar_0);
    goto inline$IoSetNextIrpStackLocation$1$label_4#1;

  inline$IoSetNextIrpStackLocation$1$label_4#1:
    call inline$IoSetNextIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$1$label_7#1;

  inline$IoSetNextIrpStackLocation$1$label_7#1:
    call inline$IoSetNextIrpStackLocation$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$1$label_8#1;

  inline$IoSetNextIrpStackLocation$1$label_8#1:
    goto inline$IoSetNextIrpStackLocation$1$label_5#1;

  inline$IoSetNextIrpStackLocation$1$label_3_true#1:
    inline$IoSetNextIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$1$myVar_0);
    goto inline$IoSetNextIrpStackLocation$1$label_5#1;

  inline$IoSetNextIrpStackLocation$1$label_5#1:
    inline$IoSetNextIrpStackLocation$1$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$1$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$1$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$1$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$1$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$1$label_6#1;

  inline$IoSetNextIrpStackLocation$1$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$1$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$1$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$1$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$1$label_1#1;

  inline$IoSetNextIrpStackLocation$1$label_1#1:
    goto inline$IoSetNextIrpStackLocation$1$Return#1;

  inline$IoSetNextIrpStackLocation$1$Return#1:
    goto inline$storm_IoCallDriver$0$label_10$1#1;

  inline$storm_IoCallDriver$0$label_10$1#1:
    goto inline$storm_IoCallDriver$0$anon11_Then#1, inline$storm_IoCallDriver$0$anon11_Else#1;

  inline$storm_IoCallDriver$0$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$0$anon1#1;

  inline$storm_IoCallDriver$0$anon1#1:
    goto inline$storm_IoCallDriver$0$label_18#1;

  inline$storm_IoCallDriver$0$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$5$Entry#1;

  inline$IoGetCurrentIrpStackLocation$5$Entry#1:
    inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$5$start#1;

  inline$IoGetCurrentIrpStackLocation$5$start#1:
    inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$5$label_3#1;

  inline$IoGetCurrentIrpStackLocation$5$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$5$label_3_true#1, inline$IoGetCurrentIrpStackLocation$5$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$5$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$5$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$5$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$5$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$5$label_4#1;

  inline$IoGetCurrentIrpStackLocation$5$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$5$label_6#1;

  inline$IoGetCurrentIrpStackLocation$5$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$5$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$5$label_7#1;

  inline$IoGetCurrentIrpStackLocation$5$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$5$label_5#1;

  inline$IoGetCurrentIrpStackLocation$5$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$5$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$5$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$5$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$5$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$5$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$5$label_5#1;

  inline$IoGetCurrentIrpStackLocation$5$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$5$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$5$label_1#1;

  inline$IoGetCurrentIrpStackLocation$5$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$5$Return#1;

  inline$IoGetCurrentIrpStackLocation$5$Return#1:
    goto inline$storm_IoCallDriver$0$label_18$1#1;

  inline$storm_IoCallDriver$0$label_18$1#1:
    goto inline$storm_IoCallDriver$0$anon13_Then#1, inline$storm_IoCallDriver$0$anon13_Else#1;

  inline$storm_IoCallDriver$0$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$0$anon6#1;

  inline$storm_IoCallDriver$0$anon6#1:
    goto inline$storm_IoCallDriver$0$label_21#1;

  inline$storm_IoCallDriver$0$label_21#1:
    goto inline$storm_IoCallDriver$0$label_22#1;

  inline$storm_IoCallDriver$0$label_22#1:
    goto inline$storm_IoCallDriver$0$label_23#1;

  inline$storm_IoCallDriver$0$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$0$label_24#1;

  inline$storm_IoCallDriver$0$label_24#1:
    call inline$storm_IoCallDriver$0$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$0$label_27#1;

  inline$storm_IoCallDriver$0$label_27#1:
    goto inline$storm_IoCallDriver$0$label_27_case_0#1, inline$storm_IoCallDriver$0$label_27_case_1#1, inline$storm_IoCallDriver$0$label_27_case_2#1;

  inline$storm_IoCallDriver$0$label_27_case_2#1:
    assume inline$storm_IoCallDriver$0$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$0$label_30#1;

  inline$storm_IoCallDriver$0$label_30#1:
    inline$storm_IoCallDriver$0$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$0$label_31#1;

  inline$storm_IoCallDriver$0$label_31#1:
    goto inline$storm_IoCallDriver$0$label_32#1;

  inline$storm_IoCallDriver$0$label_32#1:
    goto inline$storm_IoCallDriver$0$label_33#1;

  inline$storm_IoCallDriver$0$label_33#1:
    goto inline$CallCompletionRoutine$0$Entry#1;

  inline$CallCompletionRoutine$0$Entry#1:
    inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$0$start#1;

  inline$CallCompletionRoutine$0$start#1:
    inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$0$label_3#1;

  inline$CallCompletionRoutine$0$label_3#1:
    goto inline$CallCompletionRoutine$0$label_4#1;

  inline$CallCompletionRoutine$0$label_4#1:
    goto inline$CallCompletionRoutine$0$label_5#1;

  inline$CallCompletionRoutine$0$label_5#1:
    goto inline$CallCompletionRoutine$0$label_6#1;

  inline$CallCompletionRoutine$0$label_6#1:
    goto inline$CallCompletionRoutine$0$label_7#1;

  inline$CallCompletionRoutine$0$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$6$Entry#1;

  inline$IoGetCurrentIrpStackLocation$6$Entry#1:
    inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$6$start#1;

  inline$IoGetCurrentIrpStackLocation$6$start#1:
    inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$6$label_3#1;

  inline$IoGetCurrentIrpStackLocation$6$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$6$label_3_true#1, inline$IoGetCurrentIrpStackLocation$6$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$6$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$6$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$6$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$6$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$6$label_4#1;

  inline$IoGetCurrentIrpStackLocation$6$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$6$label_6#1;

  inline$IoGetCurrentIrpStackLocation$6$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$6$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$6$label_7#1;

  inline$IoGetCurrentIrpStackLocation$6$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$6$label_5#1;

  inline$IoGetCurrentIrpStackLocation$6$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$6$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$6$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$6$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$6$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$6$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$6$label_5#1;

  inline$IoGetCurrentIrpStackLocation$6$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$6$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$6$label_1#1;

  inline$IoGetCurrentIrpStackLocation$6$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$6$Return#1;

  inline$IoGetCurrentIrpStackLocation$6$Return#1:
    goto inline$CallCompletionRoutine$0$label_7$1#1;

  inline$CallCompletionRoutine$0$label_7$1#1:
    goto inline$CallCompletionRoutine$0$anon10_Then#1, inline$CallCompletionRoutine$0$anon10_Else#1;

  inline$CallCompletionRoutine$0$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$0$anon1#1;

  inline$CallCompletionRoutine$0$anon1#1:
    goto inline$CallCompletionRoutine$0$label_10#1;

  inline$CallCompletionRoutine$0$label_10#1:
    goto inline$CallCompletionRoutine$0$label_11#1;

  inline$CallCompletionRoutine$0$label_11#1:
    havoc inline$CallCompletionRoutine$0$myNondetVar_0;
    inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$0$myNondetVar_0;
    goto inline$CallCompletionRoutine$0$label_12#1;

  inline$CallCompletionRoutine$0$label_12#1:
    havoc inline$CallCompletionRoutine$0$myNondetVar_0;
    inline$CallCompletionRoutine$0$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$0$myNondetVar_0;
    goto inline$CallCompletionRoutine$0$label_13#1;

  inline$CallCompletionRoutine$0$label_13#1:
    havoc inline$CallCompletionRoutine$0$myNondetVar_0;
    goto inline$CallCompletionRoutine$0$label_14#1;

  inline$CallCompletionRoutine$0$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$7$Entry#1;

  inline$IoGetCurrentIrpStackLocation$7$Entry#1:
    inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$7$start#1;

  inline$IoGetCurrentIrpStackLocation$7$start#1:
    inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$7$label_3#1;

  inline$IoGetCurrentIrpStackLocation$7$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$7$label_3_true#1, inline$IoGetCurrentIrpStackLocation$7$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$7$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$7$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$7$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$7$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$7$label_4#1;

  inline$IoGetCurrentIrpStackLocation$7$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$7$label_6#1;

  inline$IoGetCurrentIrpStackLocation$7$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$7$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$7$label_7#1;

  inline$IoGetCurrentIrpStackLocation$7$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$7$label_5#1;

  inline$IoGetCurrentIrpStackLocation$7$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$7$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$7$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$7$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$7$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$7$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$7$label_5#1;

  inline$IoGetCurrentIrpStackLocation$7$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$7$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$7$label_1#1;

  inline$IoGetCurrentIrpStackLocation$7$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$7$Return#1;

  inline$IoGetCurrentIrpStackLocation$7$Return#1:
    goto inline$CallCompletionRoutine$0$label_14$1#1;

  inline$CallCompletionRoutine$0$label_14$1#1:
    goto inline$CallCompletionRoutine$0$anon11_Then#1, inline$CallCompletionRoutine$0$anon11_Else#1;

  inline$CallCompletionRoutine$0$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$0$anon3#1;

  inline$CallCompletionRoutine$0$anon3#1:
    goto inline$CallCompletionRoutine$0$label_17#1;

  inline$CallCompletionRoutine$0$label_17#1:
    goto inline$CallCompletionRoutine$0$label_18#1;

  inline$CallCompletionRoutine$0$label_18#1:
    goto inline$CallCompletionRoutine$0$label_18_true#1, inline$CallCompletionRoutine$0$label_18_false#1;

  inline$CallCompletionRoutine$0$label_18_false#1:
    assume inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$0$label_1#1;

  inline$CallCompletionRoutine$0$label_18_true#1:
    assume inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$0$label_19#1;

  inline$CallCompletionRoutine$0$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$0$label_20#1;

  inline$CallCompletionRoutine$0$label_20#1:
    goto inline$CallCompletionRoutine$0$label_20_icall_1#1, inline$CallCompletionRoutine$0$label_20_icall_2#1, inline$CallCompletionRoutine$0$label_20_icall_3#1;

  inline$CallCompletionRoutine$0$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$0$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$0$Entry#1;

  inline$BDLSystemPowerIoCompletion$0$Entry#1:
    inline$BDLSystemPowerIoCompletion$0$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$0$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$0$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$0$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$0$start#1;

  inline$BDLSystemPowerIoCompletion$0$start#1:
    call inline$BDLSystemPowerIoCompletion$0$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$0$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$0$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$0$label_3#1;

  inline$BDLSystemPowerIoCompletion$0$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_4#1;

  inline$BDLSystemPowerIoCompletion$0$label_4#1:
    inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_5#1;

  inline$BDLSystemPowerIoCompletion$0$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_6#1;

  inline$BDLSystemPowerIoCompletion$0$label_6#1:
    inline$BDLSystemPowerIoCompletion$0$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$0$label_7#1;

  inline$BDLSystemPowerIoCompletion$0$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_8#1;

  inline$BDLSystemPowerIoCompletion$0$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$0$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$0$label_9#1;

  inline$BDLSystemPowerIoCompletion$0$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_10#1;

  inline$BDLSystemPowerIoCompletion$0$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$9$Entry#1;

  inline$IoGetCurrentIrpStackLocation$9$Entry#1:
    inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$9$start#1;

  inline$IoGetCurrentIrpStackLocation$9$start#1:
    inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$9$label_3#1;

  inline$IoGetCurrentIrpStackLocation$9$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$9$label_3_true#1, inline$IoGetCurrentIrpStackLocation$9$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$9$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$9$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$9$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$9$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$9$label_4#1;

  inline$IoGetCurrentIrpStackLocation$9$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$9$label_6#1;

  inline$IoGetCurrentIrpStackLocation$9$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$9$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$9$label_7#1;

  inline$IoGetCurrentIrpStackLocation$9$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$9$label_5#1;

  inline$IoGetCurrentIrpStackLocation$9$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$9$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$9$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$9$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$9$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$9$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$9$label_5#1;

  inline$IoGetCurrentIrpStackLocation$9$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$9$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$9$label_1#1;

  inline$IoGetCurrentIrpStackLocation$9$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$9$Return#1;

  inline$IoGetCurrentIrpStackLocation$9$Return#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon36_Then#1, inline$BDLSystemPowerIoCompletion$0$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon1#1;

  inline$BDLSystemPowerIoCompletion$0$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_13#1;

  inline$BDLSystemPowerIoCompletion$0$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_14#1;

  inline$BDLSystemPowerIoCompletion$0$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_15#1;

  inline$BDLSystemPowerIoCompletion$0$label_15#1:
    goto inline$BDLGetDebugLevel$22$Entry#1;

  inline$BDLGetDebugLevel$22$Entry#1:
    goto inline$BDLGetDebugLevel$22$start#1;

  inline$BDLGetDebugLevel$22$start#1:
    goto inline$BDLGetDebugLevel$22$label_3#1;

  inline$BDLGetDebugLevel$22$label_3#1:
    havoc inline$BDLGetDebugLevel$22$myNondetVar_0;
    inline$BDLGetDebugLevel$22$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$22$myNondetVar_0;
    goto inline$BDLGetDebugLevel$22$label_1#1;

  inline$BDLGetDebugLevel$22$label_1#1:
    goto inline$BDLGetDebugLevel$22$Return#1;

  inline$BDLGetDebugLevel$22$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$22$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon37_Then#1, inline$BDLSystemPowerIoCompletion$0$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon3#1;

  inline$BDLSystemPowerIoCompletion$0$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_18#1;

  inline$BDLSystemPowerIoCompletion$0$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_18_true#1, inline$BDLSystemPowerIoCompletion$0$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_19#1;

  inline$BDLSystemPowerIoCompletion$0$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_22#1;

  inline$BDLSystemPowerIoCompletion$0$label_22#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_23#1;

  inline$BDLSystemPowerIoCompletion$0$label_23#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_24#1;

  inline$BDLSystemPowerIoCompletion$0$label_24#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_25#1;

  inline$BDLSystemPowerIoCompletion$0$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$0$label_19#1;

  inline$BDLSystemPowerIoCompletion$0$label_19#1:
    goto inline$BDLGetDebugLevel$23$Entry#1;

  inline$BDLGetDebugLevel$23$Entry#1:
    goto inline$BDLGetDebugLevel$23$start#1;

  inline$BDLGetDebugLevel$23$start#1:
    goto inline$BDLGetDebugLevel$23$label_3#1;

  inline$BDLGetDebugLevel$23$label_3#1:
    havoc inline$BDLGetDebugLevel$23$myNondetVar_0;
    inline$BDLGetDebugLevel$23$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$23$myNondetVar_0;
    goto inline$BDLGetDebugLevel$23$label_1#1;

  inline$BDLGetDebugLevel$23$label_1#1:
    goto inline$BDLGetDebugLevel$23$Return#1;

  inline$BDLGetDebugLevel$23$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$23$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon38_Then#1, inline$BDLSystemPowerIoCompletion$0$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon5#1;

  inline$BDLSystemPowerIoCompletion$0$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_28#1;

  inline$BDLSystemPowerIoCompletion$0$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_28_true#1, inline$BDLSystemPowerIoCompletion$0$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_29#1;

  inline$BDLSystemPowerIoCompletion$0$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_32#1;

  inline$BDLSystemPowerIoCompletion$0$label_32#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_33#1;

  inline$BDLSystemPowerIoCompletion$0$label_33#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_34#1;

  inline$BDLSystemPowerIoCompletion$0$label_34#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_35#1;

  inline$BDLSystemPowerIoCompletion$0$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$0$label_29#1;

  inline$BDLSystemPowerIoCompletion$0$label_29#1:
    goto inline$BDLGetDebugLevel$24$Entry#1;

  inline$BDLGetDebugLevel$24$Entry#1:
    goto inline$BDLGetDebugLevel$24$start#1;

  inline$BDLGetDebugLevel$24$start#1:
    goto inline$BDLGetDebugLevel$24$label_3#1;

  inline$BDLGetDebugLevel$24$label_3#1:
    havoc inline$BDLGetDebugLevel$24$myNondetVar_0;
    inline$BDLGetDebugLevel$24$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$24$myNondetVar_0;
    goto inline$BDLGetDebugLevel$24$label_1#1;

  inline$BDLGetDebugLevel$24$label_1#1:
    goto inline$BDLGetDebugLevel$24$Return#1;

  inline$BDLGetDebugLevel$24$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$24$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon39_Then#1, inline$BDLSystemPowerIoCompletion$0$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon7#1;

  inline$BDLSystemPowerIoCompletion$0$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_38#1;

  inline$BDLSystemPowerIoCompletion$0$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_38_true#1, inline$BDLSystemPowerIoCompletion$0$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_39#1;

  inline$BDLSystemPowerIoCompletion$0$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_40#1;

  inline$BDLSystemPowerIoCompletion$0$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_39#1;

  inline$BDLSystemPowerIoCompletion$0$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_39_true#1, inline$BDLSystemPowerIoCompletion$0$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_41#1;

  inline$BDLSystemPowerIoCompletion$0$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$0$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$0$label_107#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$0$label_108#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$0$label_108#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$0$label_108#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$0$label_108#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$0$label_108#1;

  inline$BDLSystemPowerIoCompletion$0$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_109#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$0$label_107#1;

  inline$BDLSystemPowerIoCompletion$0$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_109#1;

  inline$BDLSystemPowerIoCompletion$0$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$0$label_106#1;

  inline$BDLSystemPowerIoCompletion$0$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_106_true#1, inline$BDLSystemPowerIoCompletion$0$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_142#1;

  inline$BDLSystemPowerIoCompletion$0$label_142#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_143#1;

  inline$BDLSystemPowerIoCompletion$0$label_143#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_144#1;

  inline$BDLSystemPowerIoCompletion$0$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_109#1;

  inline$BDLSystemPowerIoCompletion$0$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_109#1;

  inline$BDLSystemPowerIoCompletion$0$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$0$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$0$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$0$myNondetVar_0, inline$BDLSystemPowerIoCompletion$0$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$0$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$0$anon50_Then#1, inline$BDLSystemPowerIoCompletion$0$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon29#1;

  inline$BDLSystemPowerIoCompletion$0$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_112#1;

  inline$BDLSystemPowerIoCompletion$0$label_112#1:
    inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$0$label_113#1;

  inline$BDLSystemPowerIoCompletion$0$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_113_true#1, inline$BDLSystemPowerIoCompletion$0$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$0$label_114#1;

  inline$BDLSystemPowerIoCompletion$0$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_116#1;

  inline$BDLSystemPowerIoCompletion$0$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_117#1;

  inline$BDLSystemPowerIoCompletion$0$label_117#1:
    goto inline$BDLGetDebugLevel$31$Entry#1;

  inline$BDLGetDebugLevel$31$Entry#1:
    goto inline$BDLGetDebugLevel$31$start#1;

  inline$BDLGetDebugLevel$31$start#1:
    goto inline$BDLGetDebugLevel$31$label_3#1;

  inline$BDLGetDebugLevel$31$label_3#1:
    havoc inline$BDLGetDebugLevel$31$myNondetVar_0;
    inline$BDLGetDebugLevel$31$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$31$myNondetVar_0;
    goto inline$BDLGetDebugLevel$31$label_1#1;

  inline$BDLGetDebugLevel$31$label_1#1:
    goto inline$BDLGetDebugLevel$31$Return#1;

  inline$BDLGetDebugLevel$31$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$31$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon51_Then#1, inline$BDLSystemPowerIoCompletion$0$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon31#1;

  inline$BDLSystemPowerIoCompletion$0$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_120#1;

  inline$BDLSystemPowerIoCompletion$0$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_120_true#1, inline$BDLSystemPowerIoCompletion$0$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_121#1;

  inline$BDLSystemPowerIoCompletion$0$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_124#1;

  inline$BDLSystemPowerIoCompletion$0$label_124#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_125#1;

  inline$BDLSystemPowerIoCompletion$0$label_125#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_126#1;

  inline$BDLSystemPowerIoCompletion$0$label_126#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_127#1;

  inline$BDLSystemPowerIoCompletion$0$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$0$label_121#1;

  inline$BDLSystemPowerIoCompletion$0$label_121#1:
    goto inline$BDLGetDebugLevel$32$Entry#1;

  inline$BDLGetDebugLevel$32$Entry#1:
    goto inline$BDLGetDebugLevel$32$start#1;

  inline$BDLGetDebugLevel$32$start#1:
    goto inline$BDLGetDebugLevel$32$label_3#1;

  inline$BDLGetDebugLevel$32$label_3#1:
    havoc inline$BDLGetDebugLevel$32$myNondetVar_0;
    inline$BDLGetDebugLevel$32$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$32$myNondetVar_0;
    goto inline$BDLGetDebugLevel$32$label_1#1;

  inline$BDLGetDebugLevel$32$label_1#1:
    goto inline$BDLGetDebugLevel$32$Return#1;

  inline$BDLGetDebugLevel$32$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$32$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon52_Then#1, inline$BDLSystemPowerIoCompletion$0$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon33#1;

  inline$BDLSystemPowerIoCompletion$0$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_130#1;

  inline$BDLSystemPowerIoCompletion$0$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_130_true#1, inline$BDLSystemPowerIoCompletion$0$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_131#1;

  inline$BDLSystemPowerIoCompletion$0$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_134#1;

  inline$BDLSystemPowerIoCompletion$0$label_134#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_135#1;

  inline$BDLSystemPowerIoCompletion$0$label_135#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_136#1;

  inline$BDLSystemPowerIoCompletion$0$label_136#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_137#1;

  inline$BDLSystemPowerIoCompletion$0$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$0$label_131#1;

  inline$BDLSystemPowerIoCompletion$0$label_131#1:
    goto inline$BDLGetDebugLevel$33$Entry#1;

  inline$BDLGetDebugLevel$33$Entry#1:
    goto inline$BDLGetDebugLevel$33$start#1;

  inline$BDLGetDebugLevel$33$start#1:
    goto inline$BDLGetDebugLevel$33$label_3#1;

  inline$BDLGetDebugLevel$33$label_3#1:
    havoc inline$BDLGetDebugLevel$33$myNondetVar_0;
    inline$BDLGetDebugLevel$33$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$33$myNondetVar_0;
    goto inline$BDLGetDebugLevel$33$label_1#1;

  inline$BDLGetDebugLevel$33$label_1#1:
    goto inline$BDLGetDebugLevel$33$Return#1;

  inline$BDLGetDebugLevel$33$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$33$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon53_Then#1, inline$BDLSystemPowerIoCompletion$0$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon35#1;

  inline$BDLSystemPowerIoCompletion$0$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_140#1;

  inline$BDLSystemPowerIoCompletion$0$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_140_true#1, inline$BDLSystemPowerIoCompletion$0$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_67#1;

  inline$BDLSystemPowerIoCompletion$0$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_141#1;

  inline$BDLSystemPowerIoCompletion$0$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_67#1;

  inline$BDLSystemPowerIoCompletion$0$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$0$label_115#1;

  inline$BDLSystemPowerIoCompletion$0$label_115#1:
    inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$0$label_80#1;

  inline$BDLSystemPowerIoCompletion$0$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$0$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_42#1;

  inline$BDLSystemPowerIoCompletion$0$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$0$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$0$label_43#1;

  inline$BDLSystemPowerIoCompletion$0$label_43#1:
    goto inline$BDLGetDebugLevel$25$Entry#1;

  inline$BDLGetDebugLevel$25$Entry#1:
    goto inline$BDLGetDebugLevel$25$start#1;

  inline$BDLGetDebugLevel$25$start#1:
    goto inline$BDLGetDebugLevel$25$label_3#1;

  inline$BDLGetDebugLevel$25$label_3#1:
    havoc inline$BDLGetDebugLevel$25$myNondetVar_0;
    inline$BDLGetDebugLevel$25$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$25$myNondetVar_0;
    goto inline$BDLGetDebugLevel$25$label_1#1;

  inline$BDLGetDebugLevel$25$label_1#1:
    goto inline$BDLGetDebugLevel$25$Return#1;

  inline$BDLGetDebugLevel$25$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$25$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon40_Then#1, inline$BDLSystemPowerIoCompletion$0$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon9#1;

  inline$BDLSystemPowerIoCompletion$0$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_46#1;

  inline$BDLSystemPowerIoCompletion$0$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_46_true#1, inline$BDLSystemPowerIoCompletion$0$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_47#1;

  inline$BDLSystemPowerIoCompletion$0$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_50#1;

  inline$BDLSystemPowerIoCompletion$0$label_50#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_51#1;

  inline$BDLSystemPowerIoCompletion$0$label_51#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_52#1;

  inline$BDLSystemPowerIoCompletion$0$label_52#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_53#1;

  inline$BDLSystemPowerIoCompletion$0$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$0$label_47#1;

  inline$BDLSystemPowerIoCompletion$0$label_47#1:
    goto inline$BDLGetDebugLevel$26$Entry#1;

  inline$BDLGetDebugLevel$26$Entry#1:
    goto inline$BDLGetDebugLevel$26$start#1;

  inline$BDLGetDebugLevel$26$start#1:
    goto inline$BDLGetDebugLevel$26$label_3#1;

  inline$BDLGetDebugLevel$26$label_3#1:
    havoc inline$BDLGetDebugLevel$26$myNondetVar_0;
    inline$BDLGetDebugLevel$26$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$26$myNondetVar_0;
    goto inline$BDLGetDebugLevel$26$label_1#1;

  inline$BDLGetDebugLevel$26$label_1#1:
    goto inline$BDLGetDebugLevel$26$Return#1;

  inline$BDLGetDebugLevel$26$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$26$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon41_Then#1, inline$BDLSystemPowerIoCompletion$0$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon11#1;

  inline$BDLSystemPowerIoCompletion$0$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_56#1;

  inline$BDLSystemPowerIoCompletion$0$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_56_true#1, inline$BDLSystemPowerIoCompletion$0$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_57#1;

  inline$BDLSystemPowerIoCompletion$0$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_60#1;

  inline$BDLSystemPowerIoCompletion$0$label_60#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_61#1;

  inline$BDLSystemPowerIoCompletion$0$label_61#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_62#1;

  inline$BDLSystemPowerIoCompletion$0$label_62#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_63#1;

  inline$BDLSystemPowerIoCompletion$0$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$0$label_57#1;

  inline$BDLSystemPowerIoCompletion$0$label_57#1:
    goto inline$BDLGetDebugLevel$27$Entry#1;

  inline$BDLGetDebugLevel$27$Entry#1:
    goto inline$BDLGetDebugLevel$27$start#1;

  inline$BDLGetDebugLevel$27$start#1:
    goto inline$BDLGetDebugLevel$27$label_3#1;

  inline$BDLGetDebugLevel$27$label_3#1:
    havoc inline$BDLGetDebugLevel$27$myNondetVar_0;
    inline$BDLGetDebugLevel$27$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$27$myNondetVar_0;
    goto inline$BDLGetDebugLevel$27$label_1#1;

  inline$BDLGetDebugLevel$27$label_1#1:
    goto inline$BDLGetDebugLevel$27$Return#1;

  inline$BDLGetDebugLevel$27$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$27$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon42_Then#1, inline$BDLSystemPowerIoCompletion$0$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon13#1;

  inline$BDLSystemPowerIoCompletion$0$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_66#1;

  inline$BDLSystemPowerIoCompletion$0$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_66_true#1, inline$BDLSystemPowerIoCompletion$0$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_67#1;

  inline$BDLSystemPowerIoCompletion$0$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_70#1;

  inline$BDLSystemPowerIoCompletion$0$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_67#1;

  inline$BDLSystemPowerIoCompletion$0$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$0$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$0$anon43_Then#1, inline$BDLSystemPowerIoCompletion$0$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon15#1;

  inline$BDLSystemPowerIoCompletion$0$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_71#1;

  inline$BDLSystemPowerIoCompletion$0$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$0$anon44_Then#1, inline$BDLSystemPowerIoCompletion$0$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon17#1;

  inline$BDLSystemPowerIoCompletion$0$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_74#1;

  inline$BDLSystemPowerIoCompletion$0$label_74#1:
    goto inline$storm_IoCompleteRequest$2$Entry#1;

  inline$storm_IoCompleteRequest$2$Entry#1:
    inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$0$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$2$start#1;

  inline$storm_IoCompleteRequest$2$start#1:
    inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$2$label_3#1;

  inline$storm_IoCompleteRequest$2$label_3#1:
    call inline$storm_IoCompleteRequest$2$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$2$label_6#1;

  inline$storm_IoCompleteRequest$2$label_6#1:
    goto inline$storm_IoCompleteRequest$2$label_6_true#1, inline$storm_IoCompleteRequest$2$label_6_false#1;

  inline$storm_IoCompleteRequest$2$label_6_false#1:
    assume inline$storm_IoCompleteRequest$2$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$2$label_7#1;

  inline$storm_IoCompleteRequest$2$label_6_true#1:
    assume inline$storm_IoCompleteRequest$2$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$2$label_8#1;

  inline$storm_IoCompleteRequest$2$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$2$anon3_Then#1, inline$storm_IoCompleteRequest$2$anon3_Else#1;

  inline$storm_IoCompleteRequest$2$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$2$anon1#1;

  inline$storm_IoCompleteRequest$2$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$2$label_9#1;

  inline$storm_IoCompleteRequest$2$label_9#1:
    goto inline$storm_IoCompleteRequest$2$label_9_true#1, inline$storm_IoCompleteRequest$2$label_9_false#1;

  inline$storm_IoCompleteRequest$2$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$2$label_10#1;

  inline$storm_IoCompleteRequest$2$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$2$label_1#1;

  inline$storm_IoCompleteRequest$2$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$2$label_7#1;

  inline$storm_IoCompleteRequest$2$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$2$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$2$label_1#1;

  inline$storm_IoCompleteRequest$2$label_1#1:
    goto inline$storm_IoCompleteRequest$2$Return#1;

  inline$storm_IoCompleteRequest$2$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$2$Return#1;

  inline$storm_IoCompleteRequest$2$Return#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon45_Then#1, inline$BDLSystemPowerIoCompletion$0$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon19#1;

  inline$BDLSystemPowerIoCompletion$0$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_77#1;

  inline$BDLSystemPowerIoCompletion$0$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$0$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$0$anon46_Then#1, inline$BDLSystemPowerIoCompletion$0$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon21#1;

  inline$BDLSystemPowerIoCompletion$0$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_80#1;

  inline$BDLSystemPowerIoCompletion$0$label_80#1:
    goto inline$BDLGetDebugLevel$28$Entry#1;

  inline$BDLGetDebugLevel$28$Entry#1:
    goto inline$BDLGetDebugLevel$28$start#1;

  inline$BDLGetDebugLevel$28$start#1:
    goto inline$BDLGetDebugLevel$28$label_3#1;

  inline$BDLGetDebugLevel$28$label_3#1:
    havoc inline$BDLGetDebugLevel$28$myNondetVar_0;
    inline$BDLGetDebugLevel$28$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$28$myNondetVar_0;
    goto inline$BDLGetDebugLevel$28$label_1#1;

  inline$BDLGetDebugLevel$28$label_1#1:
    goto inline$BDLGetDebugLevel$28$Return#1;

  inline$BDLGetDebugLevel$28$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$28$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon47_Then#1, inline$BDLSystemPowerIoCompletion$0$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon23#1;

  inline$BDLSystemPowerIoCompletion$0$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_83#1;

  inline$BDLSystemPowerIoCompletion$0$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_83_true#1, inline$BDLSystemPowerIoCompletion$0$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_84#1;

  inline$BDLSystemPowerIoCompletion$0$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_87#1;

  inline$BDLSystemPowerIoCompletion$0$label_87#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_88#1;

  inline$BDLSystemPowerIoCompletion$0$label_88#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_89#1;

  inline$BDLSystemPowerIoCompletion$0$label_89#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_90#1;

  inline$BDLSystemPowerIoCompletion$0$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$0$label_84#1;

  inline$BDLSystemPowerIoCompletion$0$label_84#1:
    goto inline$BDLGetDebugLevel$29$Entry#1;

  inline$BDLGetDebugLevel$29$Entry#1:
    goto inline$BDLGetDebugLevel$29$start#1;

  inline$BDLGetDebugLevel$29$start#1:
    goto inline$BDLGetDebugLevel$29$label_3#1;

  inline$BDLGetDebugLevel$29$label_3#1:
    havoc inline$BDLGetDebugLevel$29$myNondetVar_0;
    inline$BDLGetDebugLevel$29$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$29$myNondetVar_0;
    goto inline$BDLGetDebugLevel$29$label_1#1;

  inline$BDLGetDebugLevel$29$label_1#1:
    goto inline$BDLGetDebugLevel$29$Return#1;

  inline$BDLGetDebugLevel$29$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$29$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon48_Then#1, inline$BDLSystemPowerIoCompletion$0$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon25#1;

  inline$BDLSystemPowerIoCompletion$0$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_93#1;

  inline$BDLSystemPowerIoCompletion$0$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_93_true#1, inline$BDLSystemPowerIoCompletion$0$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_94#1;

  inline$BDLSystemPowerIoCompletion$0$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_97#1;

  inline$BDLSystemPowerIoCompletion$0$label_97#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_98#1;

  inline$BDLSystemPowerIoCompletion$0$label_98#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_99#1;

  inline$BDLSystemPowerIoCompletion$0$label_99#1:
    call inline$BDLSystemPowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$0$label_100#1;

  inline$BDLSystemPowerIoCompletion$0$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$0$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$0$label_94#1;

  inline$BDLSystemPowerIoCompletion$0$label_94#1:
    goto inline$BDLGetDebugLevel$30$Entry#1;

  inline$BDLGetDebugLevel$30$Entry#1:
    goto inline$BDLGetDebugLevel$30$start#1;

  inline$BDLGetDebugLevel$30$start#1:
    goto inline$BDLGetDebugLevel$30$label_3#1;

  inline$BDLGetDebugLevel$30$label_3#1:
    havoc inline$BDLGetDebugLevel$30$myNondetVar_0;
    inline$BDLGetDebugLevel$30$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$30$myNondetVar_0;
    goto inline$BDLGetDebugLevel$30$label_1#1;

  inline$BDLGetDebugLevel$30$label_1#1:
    goto inline$BDLGetDebugLevel$30$Return#1;

  inline$BDLGetDebugLevel$30$Return#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$30$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$0$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$0$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$0$anon49_Then#1, inline$BDLSystemPowerIoCompletion$0$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$0$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$anon27#1;

  inline$BDLSystemPowerIoCompletion$0$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_103#1;

  inline$BDLSystemPowerIoCompletion$0$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_103_true#1, inline$BDLSystemPowerIoCompletion$0$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$0$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_104#1;

  inline$BDLSystemPowerIoCompletion$0$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$0$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$0$label_105#1;

  inline$BDLSystemPowerIoCompletion$0$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$0$label_104#1;

  inline$BDLSystemPowerIoCompletion$0$label_104#1:
    inline$BDLSystemPowerIoCompletion$0$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$0$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$0$label_1#1;

  inline$BDLSystemPowerIoCompletion$0$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$0$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$0$Return#1;

  inline$BDLSystemPowerIoCompletion$0$Return#1:
    inline$CallCompletionRoutine$0$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$0$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$0$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$0$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$0$anon14_Then#1, inline$CallCompletionRoutine$0$anon14_Else#1;

  inline$CallCompletionRoutine$0$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$0$anon9#1;

  inline$CallCompletionRoutine$0$anon9#1:
    goto inline$CallCompletionRoutine$0$label_20_icall_return#1;

  inline$CallCompletionRoutine$0$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$0$Return#1;

  inline$CallCompletionRoutine$0$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$0$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$0$Entry#1;

  inline$BDLDevicePowerIoCompletion$0$Entry#1:
    inline$BDLDevicePowerIoCompletion$0$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$0$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$0$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$0$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$0$start#1;

  inline$BDLDevicePowerIoCompletion$0$start#1:
    call inline$BDLDevicePowerIoCompletion$0$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$0$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$0$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$0$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$0$label_3#1;

  inline$BDLDevicePowerIoCompletion$0$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_4#1;

  inline$BDLDevicePowerIoCompletion$0$label_4#1:
    inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_5#1;

  inline$BDLDevicePowerIoCompletion$0$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_6#1;

  inline$BDLDevicePowerIoCompletion$0$label_6#1:
    inline$BDLDevicePowerIoCompletion$0$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$0$label_7#1;

  inline$BDLDevicePowerIoCompletion$0$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_8#1;

  inline$BDLDevicePowerIoCompletion$0$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$0$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$0$label_9#1;

  inline$BDLDevicePowerIoCompletion$0$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_10#1;

  inline$BDLDevicePowerIoCompletion$0$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$8$Entry#1;

  inline$IoGetCurrentIrpStackLocation$8$Entry#1:
    inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$8$start#1;

  inline$IoGetCurrentIrpStackLocation$8$start#1:
    inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$8$label_3#1;

  inline$IoGetCurrentIrpStackLocation$8$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$8$label_3_true#1, inline$IoGetCurrentIrpStackLocation$8$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$8$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$8$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$8$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$8$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$8$label_4#1;

  inline$IoGetCurrentIrpStackLocation$8$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$8$label_6#1;

  inline$IoGetCurrentIrpStackLocation$8$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$8$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$8$label_7#1;

  inline$IoGetCurrentIrpStackLocation$8$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$8$label_5#1;

  inline$IoGetCurrentIrpStackLocation$8$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$8$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$8$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$8$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$8$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$8$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$8$label_5#1;

  inline$IoGetCurrentIrpStackLocation$8$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$8$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$8$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$8$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$8$label_1#1;

  inline$IoGetCurrentIrpStackLocation$8$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$8$Return#1;

  inline$IoGetCurrentIrpStackLocation$8$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$8$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon30_Then#1, inline$BDLDevicePowerIoCompletion$0$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon1#1;

  inline$BDLDevicePowerIoCompletion$0$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_13#1;

  inline$BDLDevicePowerIoCompletion$0$label_13#1:
    inline$BDLDevicePowerIoCompletion$0$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$0$label_14#1;

  inline$BDLDevicePowerIoCompletion$0$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_15#1;

  inline$BDLDevicePowerIoCompletion$0$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$0$label_16#1;

  inline$BDLDevicePowerIoCompletion$0$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_17#1;

  inline$BDLDevicePowerIoCompletion$0$label_17#1:
    goto inline$BDLGetDebugLevel$13$Entry#1;

  inline$BDLGetDebugLevel$13$Entry#1:
    goto inline$BDLGetDebugLevel$13$start#1;

  inline$BDLGetDebugLevel$13$start#1:
    goto inline$BDLGetDebugLevel$13$label_3#1;

  inline$BDLGetDebugLevel$13$label_3#1:
    havoc inline$BDLGetDebugLevel$13$myNondetVar_0;
    inline$BDLGetDebugLevel$13$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$13$myNondetVar_0;
    goto inline$BDLGetDebugLevel$13$label_1#1;

  inline$BDLGetDebugLevel$13$label_1#1:
    goto inline$BDLGetDebugLevel$13$Return#1;

  inline$BDLGetDebugLevel$13$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$13$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon31_Then#1, inline$BDLDevicePowerIoCompletion$0$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon3#1;

  inline$BDLDevicePowerIoCompletion$0$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_20#1;

  inline$BDLDevicePowerIoCompletion$0$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_20_true#1, inline$BDLDevicePowerIoCompletion$0$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_21#1;

  inline$BDLDevicePowerIoCompletion$0$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_24#1;

  inline$BDLDevicePowerIoCompletion$0$label_24#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_25#1;

  inline$BDLDevicePowerIoCompletion$0$label_25#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_26#1;

  inline$BDLDevicePowerIoCompletion$0$label_26#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_27#1;

  inline$BDLDevicePowerIoCompletion$0$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$0$label_21#1;

  inline$BDLDevicePowerIoCompletion$0$label_21#1:
    goto inline$BDLGetDebugLevel$14$Entry#1;

  inline$BDLGetDebugLevel$14$Entry#1:
    goto inline$BDLGetDebugLevel$14$start#1;

  inline$BDLGetDebugLevel$14$start#1:
    goto inline$BDLGetDebugLevel$14$label_3#1;

  inline$BDLGetDebugLevel$14$label_3#1:
    havoc inline$BDLGetDebugLevel$14$myNondetVar_0;
    inline$BDLGetDebugLevel$14$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$14$myNondetVar_0;
    goto inline$BDLGetDebugLevel$14$label_1#1;

  inline$BDLGetDebugLevel$14$label_1#1:
    goto inline$BDLGetDebugLevel$14$Return#1;

  inline$BDLGetDebugLevel$14$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$14$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon32_Then#1, inline$BDLDevicePowerIoCompletion$0$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon5#1;

  inline$BDLDevicePowerIoCompletion$0$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_30#1;

  inline$BDLDevicePowerIoCompletion$0$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_30_true#1, inline$BDLDevicePowerIoCompletion$0$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_31#1;

  inline$BDLDevicePowerIoCompletion$0$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_34#1;

  inline$BDLDevicePowerIoCompletion$0$label_34#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_35#1;

  inline$BDLDevicePowerIoCompletion$0$label_35#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_36#1;

  inline$BDLDevicePowerIoCompletion$0$label_36#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_37#1;

  inline$BDLDevicePowerIoCompletion$0$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$0$label_31#1;

  inline$BDLDevicePowerIoCompletion$0$label_31#1:
    goto inline$BDLGetDebugLevel$15$Entry#1;

  inline$BDLGetDebugLevel$15$Entry#1:
    goto inline$BDLGetDebugLevel$15$start#1;

  inline$BDLGetDebugLevel$15$start#1:
    goto inline$BDLGetDebugLevel$15$label_3#1;

  inline$BDLGetDebugLevel$15$label_3#1:
    havoc inline$BDLGetDebugLevel$15$myNondetVar_0;
    inline$BDLGetDebugLevel$15$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$15$myNondetVar_0;
    goto inline$BDLGetDebugLevel$15$label_1#1;

  inline$BDLGetDebugLevel$15$label_1#1:
    goto inline$BDLGetDebugLevel$15$Return#1;

  inline$BDLGetDebugLevel$15$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$15$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon33_Then#1, inline$BDLDevicePowerIoCompletion$0$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon7#1;

  inline$BDLDevicePowerIoCompletion$0$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_40#1;

  inline$BDLDevicePowerIoCompletion$0$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_40_true#1, inline$BDLDevicePowerIoCompletion$0$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_41#1;

  inline$BDLDevicePowerIoCompletion$0$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_42#1;

  inline$BDLDevicePowerIoCompletion$0$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_41#1;

  inline$BDLDevicePowerIoCompletion$0$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_41_true#1, inline$BDLDevicePowerIoCompletion$0$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$0$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$0$label_43#1;

  inline$BDLDevicePowerIoCompletion$0$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$0$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$0$label_44#1;

  inline$BDLDevicePowerIoCompletion$0$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_44_true#1, inline$BDLDevicePowerIoCompletion$0$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$0$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$0$label_45#1;

  inline$BDLDevicePowerIoCompletion$0$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_45_true#1, inline$BDLDevicePowerIoCompletion$0$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$0$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$0$label_43#1;

  inline$BDLDevicePowerIoCompletion$0$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$0$label_86#1;

  inline$BDLDevicePowerIoCompletion$0$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$0$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$0$label_46#1;

  inline$BDLDevicePowerIoCompletion$0$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$0$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$0$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$0$label_46#1;

  inline$BDLDevicePowerIoCompletion$0$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$0$label_49#1;

  inline$BDLDevicePowerIoCompletion$0$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_50#1;

  inline$BDLDevicePowerIoCompletion$0$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_51#1;

  inline$BDLDevicePowerIoCompletion$0$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_54#1;

  inline$BDLDevicePowerIoCompletion$0$label_54#1:
    inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$0$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$0$label_55#1;

  inline$BDLDevicePowerIoCompletion$0$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_55_true#1, inline$BDLDevicePowerIoCompletion$0$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_56#1;

  inline$BDLDevicePowerIoCompletion$0$label_56#1:
    call inline$BDLDevicePowerIoCompletion$0$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$0$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$0$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$0$anon34_Then#1, inline$BDLDevicePowerIoCompletion$0$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon9#1;

  inline$BDLDevicePowerIoCompletion$0$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_83#1;

  inline$BDLDevicePowerIoCompletion$0$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_59#1;

  inline$BDLDevicePowerIoCompletion$0$label_59#1:
    goto inline$BDLGetDebugLevel$16$Entry#1;

  inline$BDLGetDebugLevel$16$Entry#1:
    goto inline$BDLGetDebugLevel$16$start#1;

  inline$BDLGetDebugLevel$16$start#1:
    goto inline$BDLGetDebugLevel$16$label_3#1;

  inline$BDLGetDebugLevel$16$label_3#1:
    havoc inline$BDLGetDebugLevel$16$myNondetVar_0;
    inline$BDLGetDebugLevel$16$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$16$myNondetVar_0;
    goto inline$BDLGetDebugLevel$16$label_1#1;

  inline$BDLGetDebugLevel$16$label_1#1:
    goto inline$BDLGetDebugLevel$16$Return#1;

  inline$BDLGetDebugLevel$16$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$16$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon35_Then#1, inline$BDLDevicePowerIoCompletion$0$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon11#1;

  inline$BDLDevicePowerIoCompletion$0$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_62#1;

  inline$BDLDevicePowerIoCompletion$0$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_62_true#1, inline$BDLDevicePowerIoCompletion$0$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_63#1;

  inline$BDLDevicePowerIoCompletion$0$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_66#1;

  inline$BDLDevicePowerIoCompletion$0$label_66#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_67#1;

  inline$BDLDevicePowerIoCompletion$0$label_67#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_68#1;

  inline$BDLDevicePowerIoCompletion$0$label_68#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_69#1;

  inline$BDLDevicePowerIoCompletion$0$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$0$label_63#1;

  inline$BDLDevicePowerIoCompletion$0$label_63#1:
    goto inline$BDLGetDebugLevel$17$Entry#1;

  inline$BDLGetDebugLevel$17$Entry#1:
    goto inline$BDLGetDebugLevel$17$start#1;

  inline$BDLGetDebugLevel$17$start#1:
    goto inline$BDLGetDebugLevel$17$label_3#1;

  inline$BDLGetDebugLevel$17$label_3#1:
    havoc inline$BDLGetDebugLevel$17$myNondetVar_0;
    inline$BDLGetDebugLevel$17$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$17$myNondetVar_0;
    goto inline$BDLGetDebugLevel$17$label_1#1;

  inline$BDLGetDebugLevel$17$label_1#1:
    goto inline$BDLGetDebugLevel$17$Return#1;

  inline$BDLGetDebugLevel$17$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$17$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon36_Then#1, inline$BDLDevicePowerIoCompletion$0$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon13#1;

  inline$BDLDevicePowerIoCompletion$0$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_72#1;

  inline$BDLDevicePowerIoCompletion$0$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_72_true#1, inline$BDLDevicePowerIoCompletion$0$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_73#1;

  inline$BDLDevicePowerIoCompletion$0$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_76#1;

  inline$BDLDevicePowerIoCompletion$0$label_76#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_77#1;

  inline$BDLDevicePowerIoCompletion$0$label_77#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_78#1;

  inline$BDLDevicePowerIoCompletion$0$label_78#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_79#1;

  inline$BDLDevicePowerIoCompletion$0$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$0$label_73#1;

  inline$BDLDevicePowerIoCompletion$0$label_73#1:
    goto inline$BDLGetDebugLevel$18$Entry#1;

  inline$BDLGetDebugLevel$18$Entry#1:
    goto inline$BDLGetDebugLevel$18$start#1;

  inline$BDLGetDebugLevel$18$start#1:
    goto inline$BDLGetDebugLevel$18$label_3#1;

  inline$BDLGetDebugLevel$18$label_3#1:
    havoc inline$BDLGetDebugLevel$18$myNondetVar_0;
    inline$BDLGetDebugLevel$18$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$18$myNondetVar_0;
    goto inline$BDLGetDebugLevel$18$label_1#1;

  inline$BDLGetDebugLevel$18$label_1#1:
    goto inline$BDLGetDebugLevel$18$Return#1;

  inline$BDLGetDebugLevel$18$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$18$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon37_Then#1, inline$BDLDevicePowerIoCompletion$0$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon15#1;

  inline$BDLDevicePowerIoCompletion$0$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_82#1;

  inline$BDLDevicePowerIoCompletion$0$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_82_true#1, inline$BDLDevicePowerIoCompletion$0$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_83#1;

  inline$BDLDevicePowerIoCompletion$0$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_84#1;

  inline$BDLDevicePowerIoCompletion$0$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_83#1;

  inline$BDLDevicePowerIoCompletion$0$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_85#1;

  inline$BDLDevicePowerIoCompletion$0$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_86#1;

  inline$BDLDevicePowerIoCompletion$0$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$0$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$0$anon38_Then#1, inline$BDLDevicePowerIoCompletion$0$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon17#1;

  inline$BDLDevicePowerIoCompletion$0$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_89#1;

  inline$BDLDevicePowerIoCompletion$0$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$0$anon39_Then#1, inline$BDLDevicePowerIoCompletion$0$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon19#1;

  inline$BDLDevicePowerIoCompletion$0$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_92#1;

  inline$BDLDevicePowerIoCompletion$0$label_92#1:
    goto inline$storm_IoCompleteRequest$1$Entry#1;

  inline$storm_IoCompleteRequest$1$Entry#1:
    inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$0$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$1$start#1;

  inline$storm_IoCompleteRequest$1$start#1:
    inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$1$label_3#1;

  inline$storm_IoCompleteRequest$1$label_3#1:
    call inline$storm_IoCompleteRequest$1$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$1$label_6#1;

  inline$storm_IoCompleteRequest$1$label_6#1:
    goto inline$storm_IoCompleteRequest$1$label_6_true#1, inline$storm_IoCompleteRequest$1$label_6_false#1;

  inline$storm_IoCompleteRequest$1$label_6_false#1:
    assume inline$storm_IoCompleteRequest$1$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$1$label_7#1;

  inline$storm_IoCompleteRequest$1$label_6_true#1:
    assume inline$storm_IoCompleteRequest$1$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$1$label_8#1;

  inline$storm_IoCompleteRequest$1$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$1$anon3_Then#1, inline$storm_IoCompleteRequest$1$anon3_Else#1;

  inline$storm_IoCompleteRequest$1$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$1$anon1#1;

  inline$storm_IoCompleteRequest$1$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$1$label_9#1;

  inline$storm_IoCompleteRequest$1$label_9#1:
    goto inline$storm_IoCompleteRequest$1$label_9_true#1, inline$storm_IoCompleteRequest$1$label_9_false#1;

  inline$storm_IoCompleteRequest$1$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$1$label_10#1;

  inline$storm_IoCompleteRequest$1$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$1$label_1#1;

  inline$storm_IoCompleteRequest$1$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$1$label_7#1;

  inline$storm_IoCompleteRequest$1$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$1$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$1$label_1#1;

  inline$storm_IoCompleteRequest$1$label_1#1:
    goto inline$storm_IoCompleteRequest$1$Return#1;

  inline$storm_IoCompleteRequest$1$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$1$Return#1;

  inline$storm_IoCompleteRequest$1$Return#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon40_Then#1, inline$BDLDevicePowerIoCompletion$0$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon21#1;

  inline$BDLDevicePowerIoCompletion$0$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_95#1;

  inline$BDLDevicePowerIoCompletion$0$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$0$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$0$anon41_Then#1, inline$BDLDevicePowerIoCompletion$0$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon23#1;

  inline$BDLDevicePowerIoCompletion$0$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_98#1;

  inline$BDLDevicePowerIoCompletion$0$label_98#1:
    goto inline$BDLGetDebugLevel$19$Entry#1;

  inline$BDLGetDebugLevel$19$Entry#1:
    goto inline$BDLGetDebugLevel$19$start#1;

  inline$BDLGetDebugLevel$19$start#1:
    goto inline$BDLGetDebugLevel$19$label_3#1;

  inline$BDLGetDebugLevel$19$label_3#1:
    havoc inline$BDLGetDebugLevel$19$myNondetVar_0;
    inline$BDLGetDebugLevel$19$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$19$myNondetVar_0;
    goto inline$BDLGetDebugLevel$19$label_1#1;

  inline$BDLGetDebugLevel$19$label_1#1:
    goto inline$BDLGetDebugLevel$19$Return#1;

  inline$BDLGetDebugLevel$19$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$19$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon42_Then#1, inline$BDLDevicePowerIoCompletion$0$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon25#1;

  inline$BDLDevicePowerIoCompletion$0$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_101#1;

  inline$BDLDevicePowerIoCompletion$0$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_101_true#1, inline$BDLDevicePowerIoCompletion$0$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_102#1;

  inline$BDLDevicePowerIoCompletion$0$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_105#1;

  inline$BDLDevicePowerIoCompletion$0$label_105#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_106#1;

  inline$BDLDevicePowerIoCompletion$0$label_106#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_107#1;

  inline$BDLDevicePowerIoCompletion$0$label_107#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_108#1;

  inline$BDLDevicePowerIoCompletion$0$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$0$label_102#1;

  inline$BDLDevicePowerIoCompletion$0$label_102#1:
    goto inline$BDLGetDebugLevel$20$Entry#1;

  inline$BDLGetDebugLevel$20$Entry#1:
    goto inline$BDLGetDebugLevel$20$start#1;

  inline$BDLGetDebugLevel$20$start#1:
    goto inline$BDLGetDebugLevel$20$label_3#1;

  inline$BDLGetDebugLevel$20$label_3#1:
    havoc inline$BDLGetDebugLevel$20$myNondetVar_0;
    inline$BDLGetDebugLevel$20$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$20$myNondetVar_0;
    goto inline$BDLGetDebugLevel$20$label_1#1;

  inline$BDLGetDebugLevel$20$label_1#1:
    goto inline$BDLGetDebugLevel$20$Return#1;

  inline$BDLGetDebugLevel$20$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$20$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon43_Then#1, inline$BDLDevicePowerIoCompletion$0$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon27#1;

  inline$BDLDevicePowerIoCompletion$0$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_111#1;

  inline$BDLDevicePowerIoCompletion$0$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_111_true#1, inline$BDLDevicePowerIoCompletion$0$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_112#1;

  inline$BDLDevicePowerIoCompletion$0$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_115#1;

  inline$BDLDevicePowerIoCompletion$0$label_115#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_116#1;

  inline$BDLDevicePowerIoCompletion$0$label_116#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_117#1;

  inline$BDLDevicePowerIoCompletion$0$label_117#1:
    call inline$BDLDevicePowerIoCompletion$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$0$label_118#1;

  inline$BDLDevicePowerIoCompletion$0$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$0$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$0$label_112#1;

  inline$BDLDevicePowerIoCompletion$0$label_112#1:
    goto inline$BDLGetDebugLevel$21$Entry#1;

  inline$BDLGetDebugLevel$21$Entry#1:
    goto inline$BDLGetDebugLevel$21$start#1;

  inline$BDLGetDebugLevel$21$start#1:
    goto inline$BDLGetDebugLevel$21$label_3#1;

  inline$BDLGetDebugLevel$21$label_3#1:
    havoc inline$BDLGetDebugLevel$21$myNondetVar_0;
    inline$BDLGetDebugLevel$21$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$21$myNondetVar_0;
    goto inline$BDLGetDebugLevel$21$label_1#1;

  inline$BDLGetDebugLevel$21$label_1#1:
    goto inline$BDLGetDebugLevel$21$Return#1;

  inline$BDLGetDebugLevel$21$Return#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$21$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$0$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$0$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$0$anon44_Then#1, inline$BDLDevicePowerIoCompletion$0$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$0$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$anon29#1;

  inline$BDLDevicePowerIoCompletion$0$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_121#1;

  inline$BDLDevicePowerIoCompletion$0$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_121_true#1, inline$BDLDevicePowerIoCompletion$0$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$0$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_122#1;

  inline$BDLDevicePowerIoCompletion$0$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$0$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$0$label_123#1;

  inline$BDLDevicePowerIoCompletion$0$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$0$label_122#1;

  inline$BDLDevicePowerIoCompletion$0$label_122#1:
    inline$BDLDevicePowerIoCompletion$0$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$0$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$0$label_1#1;

  inline$BDLDevicePowerIoCompletion$0$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$0$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$0$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$0$Return#1;

  inline$BDLDevicePowerIoCompletion$0$Return#1:
    inline$CallCompletionRoutine$0$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$0$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$0$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$0$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$0$anon13_Then#1, inline$CallCompletionRoutine$0$anon13_Else#1;

  inline$CallCompletionRoutine$0$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$0$anon7#1;

  inline$CallCompletionRoutine$0$anon7#1:
    goto inline$CallCompletionRoutine$0$label_20_icall_return#1;

  inline$CallCompletionRoutine$0$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$0$Return#1;

  inline$CallCompletionRoutine$0$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$0$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$0$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$0$Entry#1;

  inline$BDLCallDriverCompletionRoutine$0$Entry#1:
    inline$BDLCallDriverCompletionRoutine$0$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$0$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$0$start#1;

  inline$BDLCallDriverCompletionRoutine$0$start#1:
    inline$BDLCallDriverCompletionRoutine$0$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$0$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$0$label_3#1;

  inline$BDLCallDriverCompletionRoutine$0$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$0$label_3_true#1, inline$BDLCallDriverCompletionRoutine$0$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$0$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$0$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$0$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$0$label_4#1;

  inline$BDLCallDriverCompletionRoutine$0$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$0$label_6#1;

  inline$BDLCallDriverCompletionRoutine$0$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$0$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$0$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$0$label_5#1;

  inline$BDLCallDriverCompletionRoutine$0$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$0$label_6#1;

  inline$BDLCallDriverCompletionRoutine$0$label_6#1:
    goto inline$storm_KeSetEvent$0$Entry#1;

  inline$storm_KeSetEvent$0$Entry#1:
    inline$storm_KeSetEvent$0$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$0$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$0$start#1;

  inline$storm_KeSetEvent$0$start#1:
    inline$storm_KeSetEvent$0$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$0$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$0$label_3#1;

  inline$storm_KeSetEvent$0$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$0$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$0$label_1#1;

  inline$storm_KeSetEvent$0$label_1#1:
    goto inline$storm_KeSetEvent$0$Return#1;

  inline$storm_KeSetEvent$0$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$0$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$0$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$0$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$0$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$0$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$0$anon1#1;

  inline$BDLCallDriverCompletionRoutine$0$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$0$label_9#1;

  inline$BDLCallDriverCompletionRoutine$0$label_9#1:
    inline$BDLCallDriverCompletionRoutine$0$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$0$label_1#1;

  inline$BDLCallDriverCompletionRoutine$0$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$0$Return#1;

  inline$BDLCallDriverCompletionRoutine$0$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$0$Return#1;

  inline$BDLCallDriverCompletionRoutine$0$Return#1:
    inline$CallCompletionRoutine$0$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$0$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$0$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$0$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$0$anon12_Then#1, inline$CallCompletionRoutine$0$anon12_Else#1;

  inline$CallCompletionRoutine$0$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$0$anon5#1;

  inline$CallCompletionRoutine$0$anon5#1:
    goto inline$CallCompletionRoutine$0$label_20_icall_return#1;

  inline$CallCompletionRoutine$0$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$0$label_23#1;

  inline$CallCompletionRoutine$0$label_23#1:
    inline$CallCompletionRoutine$0$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$0$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$0$label_24#1;

  inline$CallCompletionRoutine$0$label_24#1:
    goto inline$CallCompletionRoutine$0$label_24_true#1, inline$CallCompletionRoutine$0$label_24_false#1;

  inline$CallCompletionRoutine$0$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$0$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$0$label_1#1;

  inline$CallCompletionRoutine$0$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$0$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$0$label_25#1;

  inline$CallCompletionRoutine$0$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$0$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$0$label_1#1;

  inline$CallCompletionRoutine$0$label_1#1:
    goto inline$CallCompletionRoutine$0$Return#1;

  inline$CallCompletionRoutine$0$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$0$Return#1;

  inline$CallCompletionRoutine$0$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$0$Return#1;

  inline$CallCompletionRoutine$0$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$0$Return#1;

  inline$CallCompletionRoutine$0$Return#1:
    goto inline$storm_IoCallDriver$0$label_33$1#1;

  inline$storm_IoCallDriver$0$label_33$1#1:
    goto inline$storm_IoCallDriver$0$anon14_Then#1, inline$storm_IoCallDriver$0$anon14_Else#1;

  inline$storm_IoCallDriver$0$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$0$anon8#1;

  inline$storm_IoCallDriver$0$anon8#1:
    goto inline$storm_IoCallDriver$0$label_36#1;

  inline$storm_IoCallDriver$0$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$0$Return#1;

  inline$storm_IoCallDriver$0$label_27_case_1#1:
    assume inline$storm_IoCallDriver$0$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$0$label_29#1;

  inline$storm_IoCallDriver$0$label_29#1:
    inline$storm_IoCallDriver$0$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$0$label_37#1;

  inline$storm_IoCallDriver$0$label_37#1:
    goto inline$storm_IoCallDriver$0$label_38#1;

  inline$storm_IoCallDriver$0$label_38#1:
    goto inline$storm_IoCallDriver$0$label_39#1;

  inline$storm_IoCallDriver$0$label_39#1:
    goto inline$CallCompletionRoutine$1$Entry#1;

  inline$CallCompletionRoutine$1$Entry#1:
    inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$1$start#1;

  inline$CallCompletionRoutine$1$start#1:
    inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$1$label_3#1;

  inline$CallCompletionRoutine$1$label_3#1:
    goto inline$CallCompletionRoutine$1$label_4#1;

  inline$CallCompletionRoutine$1$label_4#1:
    goto inline$CallCompletionRoutine$1$label_5#1;

  inline$CallCompletionRoutine$1$label_5#1:
    goto inline$CallCompletionRoutine$1$label_6#1;

  inline$CallCompletionRoutine$1$label_6#1:
    goto inline$CallCompletionRoutine$1$label_7#1;

  inline$CallCompletionRoutine$1$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$10$Entry#1;

  inline$IoGetCurrentIrpStackLocation$10$Entry#1:
    inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$10$start#1;

  inline$IoGetCurrentIrpStackLocation$10$start#1:
    inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$10$label_3#1;

  inline$IoGetCurrentIrpStackLocation$10$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$10$label_3_true#1, inline$IoGetCurrentIrpStackLocation$10$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$10$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$10$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$10$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$10$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$10$label_4#1;

  inline$IoGetCurrentIrpStackLocation$10$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$10$label_6#1;

  inline$IoGetCurrentIrpStackLocation$10$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$10$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$10$label_7#1;

  inline$IoGetCurrentIrpStackLocation$10$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$10$label_5#1;

  inline$IoGetCurrentIrpStackLocation$10$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$10$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$10$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$10$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$10$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$10$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$10$label_5#1;

  inline$IoGetCurrentIrpStackLocation$10$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$10$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$10$label_1#1;

  inline$IoGetCurrentIrpStackLocation$10$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$10$Return#1;

  inline$IoGetCurrentIrpStackLocation$10$Return#1:
    goto inline$CallCompletionRoutine$1$label_7$1#1;

  inline$CallCompletionRoutine$1$label_7$1#1:
    goto inline$CallCompletionRoutine$1$anon10_Then#1, inline$CallCompletionRoutine$1$anon10_Else#1;

  inline$CallCompletionRoutine$1$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$1$anon1#1;

  inline$CallCompletionRoutine$1$anon1#1:
    goto inline$CallCompletionRoutine$1$label_10#1;

  inline$CallCompletionRoutine$1$label_10#1:
    goto inline$CallCompletionRoutine$1$label_11#1;

  inline$CallCompletionRoutine$1$label_11#1:
    havoc inline$CallCompletionRoutine$1$myNondetVar_0;
    inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$1$myNondetVar_0;
    goto inline$CallCompletionRoutine$1$label_12#1;

  inline$CallCompletionRoutine$1$label_12#1:
    havoc inline$CallCompletionRoutine$1$myNondetVar_0;
    inline$CallCompletionRoutine$1$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$1$myNondetVar_0;
    goto inline$CallCompletionRoutine$1$label_13#1;

  inline$CallCompletionRoutine$1$label_13#1:
    havoc inline$CallCompletionRoutine$1$myNondetVar_0;
    goto inline$CallCompletionRoutine$1$label_14#1;

  inline$CallCompletionRoutine$1$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$11$Entry#1;

  inline$IoGetCurrentIrpStackLocation$11$Entry#1:
    inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$11$start#1;

  inline$IoGetCurrentIrpStackLocation$11$start#1:
    inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$11$label_3#1;

  inline$IoGetCurrentIrpStackLocation$11$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$11$label_3_true#1, inline$IoGetCurrentIrpStackLocation$11$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$11$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$11$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$11$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$11$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$11$label_4#1;

  inline$IoGetCurrentIrpStackLocation$11$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$11$label_6#1;

  inline$IoGetCurrentIrpStackLocation$11$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$11$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$11$label_7#1;

  inline$IoGetCurrentIrpStackLocation$11$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$11$label_5#1;

  inline$IoGetCurrentIrpStackLocation$11$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$11$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$11$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$11$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$11$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$11$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$11$label_5#1;

  inline$IoGetCurrentIrpStackLocation$11$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$11$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$11$label_1#1;

  inline$IoGetCurrentIrpStackLocation$11$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$11$Return#1;

  inline$IoGetCurrentIrpStackLocation$11$Return#1:
    goto inline$CallCompletionRoutine$1$label_14$1#1;

  inline$CallCompletionRoutine$1$label_14$1#1:
    goto inline$CallCompletionRoutine$1$anon11_Then#1, inline$CallCompletionRoutine$1$anon11_Else#1;

  inline$CallCompletionRoutine$1$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$1$anon3#1;

  inline$CallCompletionRoutine$1$anon3#1:
    goto inline$CallCompletionRoutine$1$label_17#1;

  inline$CallCompletionRoutine$1$label_17#1:
    goto inline$CallCompletionRoutine$1$label_18#1;

  inline$CallCompletionRoutine$1$label_18#1:
    goto inline$CallCompletionRoutine$1$label_18_true#1, inline$CallCompletionRoutine$1$label_18_false#1;

  inline$CallCompletionRoutine$1$label_18_false#1:
    assume inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$1$label_1#1;

  inline$CallCompletionRoutine$1$label_18_true#1:
    assume inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$1$label_19#1;

  inline$CallCompletionRoutine$1$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$1$label_20#1;

  inline$CallCompletionRoutine$1$label_20#1:
    goto inline$CallCompletionRoutine$1$label_20_icall_1#1, inline$CallCompletionRoutine$1$label_20_icall_2#1, inline$CallCompletionRoutine$1$label_20_icall_3#1;

  inline$CallCompletionRoutine$1$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$1$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$1$Entry#1;

  inline$BDLSystemPowerIoCompletion$1$Entry#1:
    inline$BDLSystemPowerIoCompletion$1$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$1$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$1$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$1$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$1$start#1;

  inline$BDLSystemPowerIoCompletion$1$start#1:
    call inline$BDLSystemPowerIoCompletion$1$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$1$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$1$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$1$label_3#1;

  inline$BDLSystemPowerIoCompletion$1$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_4#1;

  inline$BDLSystemPowerIoCompletion$1$label_4#1:
    inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_5#1;

  inline$BDLSystemPowerIoCompletion$1$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_6#1;

  inline$BDLSystemPowerIoCompletion$1$label_6#1:
    inline$BDLSystemPowerIoCompletion$1$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$1$label_7#1;

  inline$BDLSystemPowerIoCompletion$1$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_8#1;

  inline$BDLSystemPowerIoCompletion$1$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$1$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$1$label_9#1;

  inline$BDLSystemPowerIoCompletion$1$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_10#1;

  inline$BDLSystemPowerIoCompletion$1$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$13$Entry#1;

  inline$IoGetCurrentIrpStackLocation$13$Entry#1:
    inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$13$start#1;

  inline$IoGetCurrentIrpStackLocation$13$start#1:
    inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$13$label_3#1;

  inline$IoGetCurrentIrpStackLocation$13$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$13$label_3_true#1, inline$IoGetCurrentIrpStackLocation$13$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$13$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$13$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$13$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$13$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$13$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$13$label_4#1;

  inline$IoGetCurrentIrpStackLocation$13$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$13$label_6#1;

  inline$IoGetCurrentIrpStackLocation$13$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$13$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$13$label_7#1;

  inline$IoGetCurrentIrpStackLocation$13$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$13$label_5#1;

  inline$IoGetCurrentIrpStackLocation$13$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$13$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$13$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$13$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$13$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$13$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$13$label_5#1;

  inline$IoGetCurrentIrpStackLocation$13$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$13$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$13$label_1#1;

  inline$IoGetCurrentIrpStackLocation$13$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$13$Return#1;

  inline$IoGetCurrentIrpStackLocation$13$Return#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon36_Then#1, inline$BDLSystemPowerIoCompletion$1$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon1#1;

  inline$BDLSystemPowerIoCompletion$1$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_13#1;

  inline$BDLSystemPowerIoCompletion$1$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_14#1;

  inline$BDLSystemPowerIoCompletion$1$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_15#1;

  inline$BDLSystemPowerIoCompletion$1$label_15#1:
    goto inline$BDLGetDebugLevel$43$Entry#1;

  inline$BDLGetDebugLevel$43$Entry#1:
    goto inline$BDLGetDebugLevel$43$start#1;

  inline$BDLGetDebugLevel$43$start#1:
    goto inline$BDLGetDebugLevel$43$label_3#1;

  inline$BDLGetDebugLevel$43$label_3#1:
    havoc inline$BDLGetDebugLevel$43$myNondetVar_0;
    inline$BDLGetDebugLevel$43$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$43$myNondetVar_0;
    goto inline$BDLGetDebugLevel$43$label_1#1;

  inline$BDLGetDebugLevel$43$label_1#1:
    goto inline$BDLGetDebugLevel$43$Return#1;

  inline$BDLGetDebugLevel$43$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$43$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon37_Then#1, inline$BDLSystemPowerIoCompletion$1$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon3#1;

  inline$BDLSystemPowerIoCompletion$1$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_18#1;

  inline$BDLSystemPowerIoCompletion$1$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_18_true#1, inline$BDLSystemPowerIoCompletion$1$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_19#1;

  inline$BDLSystemPowerIoCompletion$1$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_22#1;

  inline$BDLSystemPowerIoCompletion$1$label_22#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_23#1;

  inline$BDLSystemPowerIoCompletion$1$label_23#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_24#1;

  inline$BDLSystemPowerIoCompletion$1$label_24#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_25#1;

  inline$BDLSystemPowerIoCompletion$1$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$1$label_19#1;

  inline$BDLSystemPowerIoCompletion$1$label_19#1:
    goto inline$BDLGetDebugLevel$44$Entry#1;

  inline$BDLGetDebugLevel$44$Entry#1:
    goto inline$BDLGetDebugLevel$44$start#1;

  inline$BDLGetDebugLevel$44$start#1:
    goto inline$BDLGetDebugLevel$44$label_3#1;

  inline$BDLGetDebugLevel$44$label_3#1:
    havoc inline$BDLGetDebugLevel$44$myNondetVar_0;
    inline$BDLGetDebugLevel$44$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$44$myNondetVar_0;
    goto inline$BDLGetDebugLevel$44$label_1#1;

  inline$BDLGetDebugLevel$44$label_1#1:
    goto inline$BDLGetDebugLevel$44$Return#1;

  inline$BDLGetDebugLevel$44$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$44$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon38_Then#1, inline$BDLSystemPowerIoCompletion$1$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon5#1;

  inline$BDLSystemPowerIoCompletion$1$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_28#1;

  inline$BDLSystemPowerIoCompletion$1$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_28_true#1, inline$BDLSystemPowerIoCompletion$1$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_29#1;

  inline$BDLSystemPowerIoCompletion$1$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_32#1;

  inline$BDLSystemPowerIoCompletion$1$label_32#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_33#1;

  inline$BDLSystemPowerIoCompletion$1$label_33#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_34#1;

  inline$BDLSystemPowerIoCompletion$1$label_34#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_35#1;

  inline$BDLSystemPowerIoCompletion$1$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$1$label_29#1;

  inline$BDLSystemPowerIoCompletion$1$label_29#1:
    goto inline$BDLGetDebugLevel$45$Entry#1;

  inline$BDLGetDebugLevel$45$Entry#1:
    goto inline$BDLGetDebugLevel$45$start#1;

  inline$BDLGetDebugLevel$45$start#1:
    goto inline$BDLGetDebugLevel$45$label_3#1;

  inline$BDLGetDebugLevel$45$label_3#1:
    havoc inline$BDLGetDebugLevel$45$myNondetVar_0;
    inline$BDLGetDebugLevel$45$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$45$myNondetVar_0;
    goto inline$BDLGetDebugLevel$45$label_1#1;

  inline$BDLGetDebugLevel$45$label_1#1:
    goto inline$BDLGetDebugLevel$45$Return#1;

  inline$BDLGetDebugLevel$45$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$45$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon39_Then#1, inline$BDLSystemPowerIoCompletion$1$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon7#1;

  inline$BDLSystemPowerIoCompletion$1$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_38#1;

  inline$BDLSystemPowerIoCompletion$1$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_38_true#1, inline$BDLSystemPowerIoCompletion$1$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_39#1;

  inline$BDLSystemPowerIoCompletion$1$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_40#1;

  inline$BDLSystemPowerIoCompletion$1$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_39#1;

  inline$BDLSystemPowerIoCompletion$1$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_39_true#1, inline$BDLSystemPowerIoCompletion$1$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_41#1;

  inline$BDLSystemPowerIoCompletion$1$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$1$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$1$label_107#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$1$label_108#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$1$label_108#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$1$label_108#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$1$label_108#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$1$label_108#1;

  inline$BDLSystemPowerIoCompletion$1$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_109#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$1$label_107#1;

  inline$BDLSystemPowerIoCompletion$1$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_109#1;

  inline$BDLSystemPowerIoCompletion$1$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$1$label_106#1;

  inline$BDLSystemPowerIoCompletion$1$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_106_true#1, inline$BDLSystemPowerIoCompletion$1$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_142#1;

  inline$BDLSystemPowerIoCompletion$1$label_142#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_143#1;

  inline$BDLSystemPowerIoCompletion$1$label_143#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_144#1;

  inline$BDLSystemPowerIoCompletion$1$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_109#1;

  inline$BDLSystemPowerIoCompletion$1$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_109#1;

  inline$BDLSystemPowerIoCompletion$1$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$1$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$1$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$1$myNondetVar_0, inline$BDLSystemPowerIoCompletion$1$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$1$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$1$anon50_Then#1, inline$BDLSystemPowerIoCompletion$1$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon29#1;

  inline$BDLSystemPowerIoCompletion$1$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_112#1;

  inline$BDLSystemPowerIoCompletion$1$label_112#1:
    inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$1$label_113#1;

  inline$BDLSystemPowerIoCompletion$1$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_113_true#1, inline$BDLSystemPowerIoCompletion$1$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$1$label_114#1;

  inline$BDLSystemPowerIoCompletion$1$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_116#1;

  inline$BDLSystemPowerIoCompletion$1$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_117#1;

  inline$BDLSystemPowerIoCompletion$1$label_117#1:
    goto inline$BDLGetDebugLevel$52$Entry#1;

  inline$BDLGetDebugLevel$52$Entry#1:
    goto inline$BDLGetDebugLevel$52$start#1;

  inline$BDLGetDebugLevel$52$start#1:
    goto inline$BDLGetDebugLevel$52$label_3#1;

  inline$BDLGetDebugLevel$52$label_3#1:
    havoc inline$BDLGetDebugLevel$52$myNondetVar_0;
    inline$BDLGetDebugLevel$52$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$52$myNondetVar_0;
    goto inline$BDLGetDebugLevel$52$label_1#1;

  inline$BDLGetDebugLevel$52$label_1#1:
    goto inline$BDLGetDebugLevel$52$Return#1;

  inline$BDLGetDebugLevel$52$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$52$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon51_Then#1, inline$BDLSystemPowerIoCompletion$1$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon31#1;

  inline$BDLSystemPowerIoCompletion$1$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_120#1;

  inline$BDLSystemPowerIoCompletion$1$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_120_true#1, inline$BDLSystemPowerIoCompletion$1$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_121#1;

  inline$BDLSystemPowerIoCompletion$1$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_124#1;

  inline$BDLSystemPowerIoCompletion$1$label_124#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_125#1;

  inline$BDLSystemPowerIoCompletion$1$label_125#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_126#1;

  inline$BDLSystemPowerIoCompletion$1$label_126#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_127#1;

  inline$BDLSystemPowerIoCompletion$1$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$1$label_121#1;

  inline$BDLSystemPowerIoCompletion$1$label_121#1:
    goto inline$BDLGetDebugLevel$53$Entry#1;

  inline$BDLGetDebugLevel$53$Entry#1:
    goto inline$BDLGetDebugLevel$53$start#1;

  inline$BDLGetDebugLevel$53$start#1:
    goto inline$BDLGetDebugLevel$53$label_3#1;

  inline$BDLGetDebugLevel$53$label_3#1:
    havoc inline$BDLGetDebugLevel$53$myNondetVar_0;
    inline$BDLGetDebugLevel$53$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$53$myNondetVar_0;
    goto inline$BDLGetDebugLevel$53$label_1#1;

  inline$BDLGetDebugLevel$53$label_1#1:
    goto inline$BDLGetDebugLevel$53$Return#1;

  inline$BDLGetDebugLevel$53$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$53$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon52_Then#1, inline$BDLSystemPowerIoCompletion$1$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon33#1;

  inline$BDLSystemPowerIoCompletion$1$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_130#1;

  inline$BDLSystemPowerIoCompletion$1$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_130_true#1, inline$BDLSystemPowerIoCompletion$1$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_131#1;

  inline$BDLSystemPowerIoCompletion$1$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_134#1;

  inline$BDLSystemPowerIoCompletion$1$label_134#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_135#1;

  inline$BDLSystemPowerIoCompletion$1$label_135#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_136#1;

  inline$BDLSystemPowerIoCompletion$1$label_136#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_137#1;

  inline$BDLSystemPowerIoCompletion$1$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$1$label_131#1;

  inline$BDLSystemPowerIoCompletion$1$label_131#1:
    goto inline$BDLGetDebugLevel$54$Entry#1;

  inline$BDLGetDebugLevel$54$Entry#1:
    goto inline$BDLGetDebugLevel$54$start#1;

  inline$BDLGetDebugLevel$54$start#1:
    goto inline$BDLGetDebugLevel$54$label_3#1;

  inline$BDLGetDebugLevel$54$label_3#1:
    havoc inline$BDLGetDebugLevel$54$myNondetVar_0;
    inline$BDLGetDebugLevel$54$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$54$myNondetVar_0;
    goto inline$BDLGetDebugLevel$54$label_1#1;

  inline$BDLGetDebugLevel$54$label_1#1:
    goto inline$BDLGetDebugLevel$54$Return#1;

  inline$BDLGetDebugLevel$54$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$54$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon53_Then#1, inline$BDLSystemPowerIoCompletion$1$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon35#1;

  inline$BDLSystemPowerIoCompletion$1$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_140#1;

  inline$BDLSystemPowerIoCompletion$1$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_140_true#1, inline$BDLSystemPowerIoCompletion$1$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_67#1;

  inline$BDLSystemPowerIoCompletion$1$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_141#1;

  inline$BDLSystemPowerIoCompletion$1$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_67#1;

  inline$BDLSystemPowerIoCompletion$1$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$1$label_115#1;

  inline$BDLSystemPowerIoCompletion$1$label_115#1:
    inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$1$label_80#1;

  inline$BDLSystemPowerIoCompletion$1$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$1$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_42#1;

  inline$BDLSystemPowerIoCompletion$1$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$1$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$1$label_43#1;

  inline$BDLSystemPowerIoCompletion$1$label_43#1:
    goto inline$BDLGetDebugLevel$46$Entry#1;

  inline$BDLGetDebugLevel$46$Entry#1:
    goto inline$BDLGetDebugLevel$46$start#1;

  inline$BDLGetDebugLevel$46$start#1:
    goto inline$BDLGetDebugLevel$46$label_3#1;

  inline$BDLGetDebugLevel$46$label_3#1:
    havoc inline$BDLGetDebugLevel$46$myNondetVar_0;
    inline$BDLGetDebugLevel$46$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$46$myNondetVar_0;
    goto inline$BDLGetDebugLevel$46$label_1#1;

  inline$BDLGetDebugLevel$46$label_1#1:
    goto inline$BDLGetDebugLevel$46$Return#1;

  inline$BDLGetDebugLevel$46$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$46$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon40_Then#1, inline$BDLSystemPowerIoCompletion$1$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon9#1;

  inline$BDLSystemPowerIoCompletion$1$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_46#1;

  inline$BDLSystemPowerIoCompletion$1$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_46_true#1, inline$BDLSystemPowerIoCompletion$1$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_47#1;

  inline$BDLSystemPowerIoCompletion$1$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_50#1;

  inline$BDLSystemPowerIoCompletion$1$label_50#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_51#1;

  inline$BDLSystemPowerIoCompletion$1$label_51#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_52#1;

  inline$BDLSystemPowerIoCompletion$1$label_52#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_53#1;

  inline$BDLSystemPowerIoCompletion$1$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$1$label_47#1;

  inline$BDLSystemPowerIoCompletion$1$label_47#1:
    goto inline$BDLGetDebugLevel$47$Entry#1;

  inline$BDLGetDebugLevel$47$Entry#1:
    goto inline$BDLGetDebugLevel$47$start#1;

  inline$BDLGetDebugLevel$47$start#1:
    goto inline$BDLGetDebugLevel$47$label_3#1;

  inline$BDLGetDebugLevel$47$label_3#1:
    havoc inline$BDLGetDebugLevel$47$myNondetVar_0;
    inline$BDLGetDebugLevel$47$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$47$myNondetVar_0;
    goto inline$BDLGetDebugLevel$47$label_1#1;

  inline$BDLGetDebugLevel$47$label_1#1:
    goto inline$BDLGetDebugLevel$47$Return#1;

  inline$BDLGetDebugLevel$47$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$47$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon41_Then#1, inline$BDLSystemPowerIoCompletion$1$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon11#1;

  inline$BDLSystemPowerIoCompletion$1$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_56#1;

  inline$BDLSystemPowerIoCompletion$1$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_56_true#1, inline$BDLSystemPowerIoCompletion$1$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_57#1;

  inline$BDLSystemPowerIoCompletion$1$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_60#1;

  inline$BDLSystemPowerIoCompletion$1$label_60#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_61#1;

  inline$BDLSystemPowerIoCompletion$1$label_61#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_62#1;

  inline$BDLSystemPowerIoCompletion$1$label_62#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_63#1;

  inline$BDLSystemPowerIoCompletion$1$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$1$label_57#1;

  inline$BDLSystemPowerIoCompletion$1$label_57#1:
    goto inline$BDLGetDebugLevel$48$Entry#1;

  inline$BDLGetDebugLevel$48$Entry#1:
    goto inline$BDLGetDebugLevel$48$start#1;

  inline$BDLGetDebugLevel$48$start#1:
    goto inline$BDLGetDebugLevel$48$label_3#1;

  inline$BDLGetDebugLevel$48$label_3#1:
    havoc inline$BDLGetDebugLevel$48$myNondetVar_0;
    inline$BDLGetDebugLevel$48$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$48$myNondetVar_0;
    goto inline$BDLGetDebugLevel$48$label_1#1;

  inline$BDLGetDebugLevel$48$label_1#1:
    goto inline$BDLGetDebugLevel$48$Return#1;

  inline$BDLGetDebugLevel$48$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$48$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon42_Then#1, inline$BDLSystemPowerIoCompletion$1$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon13#1;

  inline$BDLSystemPowerIoCompletion$1$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_66#1;

  inline$BDLSystemPowerIoCompletion$1$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_66_true#1, inline$BDLSystemPowerIoCompletion$1$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_67#1;

  inline$BDLSystemPowerIoCompletion$1$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_70#1;

  inline$BDLSystemPowerIoCompletion$1$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_67#1;

  inline$BDLSystemPowerIoCompletion$1$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$1$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$1$anon43_Then#1, inline$BDLSystemPowerIoCompletion$1$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon15#1;

  inline$BDLSystemPowerIoCompletion$1$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_71#1;

  inline$BDLSystemPowerIoCompletion$1$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$1$anon44_Then#1, inline$BDLSystemPowerIoCompletion$1$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon17#1;

  inline$BDLSystemPowerIoCompletion$1$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_74#1;

  inline$BDLSystemPowerIoCompletion$1$label_74#1:
    goto inline$storm_IoCompleteRequest$4$Entry#1;

  inline$storm_IoCompleteRequest$4$Entry#1:
    inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$1$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$4$start#1;

  inline$storm_IoCompleteRequest$4$start#1:
    inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$4$label_3#1;

  inline$storm_IoCompleteRequest$4$label_3#1:
    call inline$storm_IoCompleteRequest$4$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$4$label_6#1;

  inline$storm_IoCompleteRequest$4$label_6#1:
    goto inline$storm_IoCompleteRequest$4$label_6_true#1, inline$storm_IoCompleteRequest$4$label_6_false#1;

  inline$storm_IoCompleteRequest$4$label_6_false#1:
    assume inline$storm_IoCompleteRequest$4$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$4$label_7#1;

  inline$storm_IoCompleteRequest$4$label_6_true#1:
    assume inline$storm_IoCompleteRequest$4$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$4$label_8#1;

  inline$storm_IoCompleteRequest$4$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$4$anon3_Then#1, inline$storm_IoCompleteRequest$4$anon3_Else#1;

  inline$storm_IoCompleteRequest$4$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$4$anon1#1;

  inline$storm_IoCompleteRequest$4$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$4$label_9#1;

  inline$storm_IoCompleteRequest$4$label_9#1:
    goto inline$storm_IoCompleteRequest$4$label_9_true#1, inline$storm_IoCompleteRequest$4$label_9_false#1;

  inline$storm_IoCompleteRequest$4$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$4$label_10#1;

  inline$storm_IoCompleteRequest$4$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$4$label_1#1;

  inline$storm_IoCompleteRequest$4$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$4$label_7#1;

  inline$storm_IoCompleteRequest$4$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$4$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$4$label_1#1;

  inline$storm_IoCompleteRequest$4$label_1#1:
    goto inline$storm_IoCompleteRequest$4$Return#1;

  inline$storm_IoCompleteRequest$4$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$4$Return#1;

  inline$storm_IoCompleteRequest$4$Return#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon45_Then#1, inline$BDLSystemPowerIoCompletion$1$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon19#1;

  inline$BDLSystemPowerIoCompletion$1$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_77#1;

  inline$BDLSystemPowerIoCompletion$1$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$1$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$1$anon46_Then#1, inline$BDLSystemPowerIoCompletion$1$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon21#1;

  inline$BDLSystemPowerIoCompletion$1$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_80#1;

  inline$BDLSystemPowerIoCompletion$1$label_80#1:
    goto inline$BDLGetDebugLevel$49$Entry#1;

  inline$BDLGetDebugLevel$49$Entry#1:
    goto inline$BDLGetDebugLevel$49$start#1;

  inline$BDLGetDebugLevel$49$start#1:
    goto inline$BDLGetDebugLevel$49$label_3#1;

  inline$BDLGetDebugLevel$49$label_3#1:
    havoc inline$BDLGetDebugLevel$49$myNondetVar_0;
    inline$BDLGetDebugLevel$49$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$49$myNondetVar_0;
    goto inline$BDLGetDebugLevel$49$label_1#1;

  inline$BDLGetDebugLevel$49$label_1#1:
    goto inline$BDLGetDebugLevel$49$Return#1;

  inline$BDLGetDebugLevel$49$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$49$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon47_Then#1, inline$BDLSystemPowerIoCompletion$1$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon23#1;

  inline$BDLSystemPowerIoCompletion$1$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_83#1;

  inline$BDLSystemPowerIoCompletion$1$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_83_true#1, inline$BDLSystemPowerIoCompletion$1$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_84#1;

  inline$BDLSystemPowerIoCompletion$1$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_87#1;

  inline$BDLSystemPowerIoCompletion$1$label_87#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_88#1;

  inline$BDLSystemPowerIoCompletion$1$label_88#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_89#1;

  inline$BDLSystemPowerIoCompletion$1$label_89#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_90#1;

  inline$BDLSystemPowerIoCompletion$1$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$1$label_84#1;

  inline$BDLSystemPowerIoCompletion$1$label_84#1:
    goto inline$BDLGetDebugLevel$50$Entry#1;

  inline$BDLGetDebugLevel$50$Entry#1:
    goto inline$BDLGetDebugLevel$50$start#1;

  inline$BDLGetDebugLevel$50$start#1:
    goto inline$BDLGetDebugLevel$50$label_3#1;

  inline$BDLGetDebugLevel$50$label_3#1:
    havoc inline$BDLGetDebugLevel$50$myNondetVar_0;
    inline$BDLGetDebugLevel$50$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$50$myNondetVar_0;
    goto inline$BDLGetDebugLevel$50$label_1#1;

  inline$BDLGetDebugLevel$50$label_1#1:
    goto inline$BDLGetDebugLevel$50$Return#1;

  inline$BDLGetDebugLevel$50$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$50$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon48_Then#1, inline$BDLSystemPowerIoCompletion$1$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon25#1;

  inline$BDLSystemPowerIoCompletion$1$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_93#1;

  inline$BDLSystemPowerIoCompletion$1$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_93_true#1, inline$BDLSystemPowerIoCompletion$1$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_94#1;

  inline$BDLSystemPowerIoCompletion$1$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_97#1;

  inline$BDLSystemPowerIoCompletion$1$label_97#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_98#1;

  inline$BDLSystemPowerIoCompletion$1$label_98#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_99#1;

  inline$BDLSystemPowerIoCompletion$1$label_99#1:
    call inline$BDLSystemPowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$1$label_100#1;

  inline$BDLSystemPowerIoCompletion$1$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$1$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$1$label_94#1;

  inline$BDLSystemPowerIoCompletion$1$label_94#1:
    goto inline$BDLGetDebugLevel$51$Entry#1;

  inline$BDLGetDebugLevel$51$Entry#1:
    goto inline$BDLGetDebugLevel$51$start#1;

  inline$BDLGetDebugLevel$51$start#1:
    goto inline$BDLGetDebugLevel$51$label_3#1;

  inline$BDLGetDebugLevel$51$label_3#1:
    havoc inline$BDLGetDebugLevel$51$myNondetVar_0;
    inline$BDLGetDebugLevel$51$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$51$myNondetVar_0;
    goto inline$BDLGetDebugLevel$51$label_1#1;

  inline$BDLGetDebugLevel$51$label_1#1:
    goto inline$BDLGetDebugLevel$51$Return#1;

  inline$BDLGetDebugLevel$51$Return#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$51$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$1$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$1$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$1$anon49_Then#1, inline$BDLSystemPowerIoCompletion$1$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$1$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$anon27#1;

  inline$BDLSystemPowerIoCompletion$1$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_103#1;

  inline$BDLSystemPowerIoCompletion$1$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_103_true#1, inline$BDLSystemPowerIoCompletion$1$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$1$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_104#1;

  inline$BDLSystemPowerIoCompletion$1$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$1$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$1$label_105#1;

  inline$BDLSystemPowerIoCompletion$1$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$1$label_104#1;

  inline$BDLSystemPowerIoCompletion$1$label_104#1:
    inline$BDLSystemPowerIoCompletion$1$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$1$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$1$label_1#1;

  inline$BDLSystemPowerIoCompletion$1$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$1$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$1$Return#1;

  inline$BDLSystemPowerIoCompletion$1$Return#1:
    inline$CallCompletionRoutine$1$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$1$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$1$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$1$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$1$anon14_Then#1, inline$CallCompletionRoutine$1$anon14_Else#1;

  inline$CallCompletionRoutine$1$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$1$anon9#1;

  inline$CallCompletionRoutine$1$anon9#1:
    goto inline$CallCompletionRoutine$1$label_20_icall_return#1;

  inline$CallCompletionRoutine$1$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$1$Return#1;

  inline$CallCompletionRoutine$1$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$1$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$1$Entry#1;

  inline$BDLDevicePowerIoCompletion$1$Entry#1:
    inline$BDLDevicePowerIoCompletion$1$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$1$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$1$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$1$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$1$start#1;

  inline$BDLDevicePowerIoCompletion$1$start#1:
    call inline$BDLDevicePowerIoCompletion$1$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$1$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$1$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$1$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$1$label_3#1;

  inline$BDLDevicePowerIoCompletion$1$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_4#1;

  inline$BDLDevicePowerIoCompletion$1$label_4#1:
    inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_5#1;

  inline$BDLDevicePowerIoCompletion$1$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_6#1;

  inline$BDLDevicePowerIoCompletion$1$label_6#1:
    inline$BDLDevicePowerIoCompletion$1$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$1$label_7#1;

  inline$BDLDevicePowerIoCompletion$1$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_8#1;

  inline$BDLDevicePowerIoCompletion$1$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$1$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$1$label_9#1;

  inline$BDLDevicePowerIoCompletion$1$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_10#1;

  inline$BDLDevicePowerIoCompletion$1$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$12$Entry#1;

  inline$IoGetCurrentIrpStackLocation$12$Entry#1:
    inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$12$start#1;

  inline$IoGetCurrentIrpStackLocation$12$start#1:
    inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$12$label_3#1;

  inline$IoGetCurrentIrpStackLocation$12$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$12$label_3_true#1, inline$IoGetCurrentIrpStackLocation$12$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$12$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$12$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$12$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$12$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$12$label_4#1;

  inline$IoGetCurrentIrpStackLocation$12$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$12$label_6#1;

  inline$IoGetCurrentIrpStackLocation$12$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$12$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$12$label_7#1;

  inline$IoGetCurrentIrpStackLocation$12$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$12$label_5#1;

  inline$IoGetCurrentIrpStackLocation$12$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$12$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$12$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$12$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$12$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$12$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$12$label_5#1;

  inline$IoGetCurrentIrpStackLocation$12$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$12$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$12$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$12$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$12$label_1#1;

  inline$IoGetCurrentIrpStackLocation$12$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$12$Return#1;

  inline$IoGetCurrentIrpStackLocation$12$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$12$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon30_Then#1, inline$BDLDevicePowerIoCompletion$1$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon1#1;

  inline$BDLDevicePowerIoCompletion$1$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_13#1;

  inline$BDLDevicePowerIoCompletion$1$label_13#1:
    inline$BDLDevicePowerIoCompletion$1$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$1$label_14#1;

  inline$BDLDevicePowerIoCompletion$1$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_15#1;

  inline$BDLDevicePowerIoCompletion$1$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$1$label_16#1;

  inline$BDLDevicePowerIoCompletion$1$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_17#1;

  inline$BDLDevicePowerIoCompletion$1$label_17#1:
    goto inline$BDLGetDebugLevel$34$Entry#1;

  inline$BDLGetDebugLevel$34$Entry#1:
    goto inline$BDLGetDebugLevel$34$start#1;

  inline$BDLGetDebugLevel$34$start#1:
    goto inline$BDLGetDebugLevel$34$label_3#1;

  inline$BDLGetDebugLevel$34$label_3#1:
    havoc inline$BDLGetDebugLevel$34$myNondetVar_0;
    inline$BDLGetDebugLevel$34$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$34$myNondetVar_0;
    goto inline$BDLGetDebugLevel$34$label_1#1;

  inline$BDLGetDebugLevel$34$label_1#1:
    goto inline$BDLGetDebugLevel$34$Return#1;

  inline$BDLGetDebugLevel$34$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$34$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon31_Then#1, inline$BDLDevicePowerIoCompletion$1$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon3#1;

  inline$BDLDevicePowerIoCompletion$1$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_20#1;

  inline$BDLDevicePowerIoCompletion$1$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_20_true#1, inline$BDLDevicePowerIoCompletion$1$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_21#1;

  inline$BDLDevicePowerIoCompletion$1$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_24#1;

  inline$BDLDevicePowerIoCompletion$1$label_24#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_25#1;

  inline$BDLDevicePowerIoCompletion$1$label_25#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_26#1;

  inline$BDLDevicePowerIoCompletion$1$label_26#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_27#1;

  inline$BDLDevicePowerIoCompletion$1$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$1$label_21#1;

  inline$BDLDevicePowerIoCompletion$1$label_21#1:
    goto inline$BDLGetDebugLevel$35$Entry#1;

  inline$BDLGetDebugLevel$35$Entry#1:
    goto inline$BDLGetDebugLevel$35$start#1;

  inline$BDLGetDebugLevel$35$start#1:
    goto inline$BDLGetDebugLevel$35$label_3#1;

  inline$BDLGetDebugLevel$35$label_3#1:
    havoc inline$BDLGetDebugLevel$35$myNondetVar_0;
    inline$BDLGetDebugLevel$35$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$35$myNondetVar_0;
    goto inline$BDLGetDebugLevel$35$label_1#1;

  inline$BDLGetDebugLevel$35$label_1#1:
    goto inline$BDLGetDebugLevel$35$Return#1;

  inline$BDLGetDebugLevel$35$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$35$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon32_Then#1, inline$BDLDevicePowerIoCompletion$1$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon5#1;

  inline$BDLDevicePowerIoCompletion$1$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_30#1;

  inline$BDLDevicePowerIoCompletion$1$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_30_true#1, inline$BDLDevicePowerIoCompletion$1$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_31#1;

  inline$BDLDevicePowerIoCompletion$1$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_34#1;

  inline$BDLDevicePowerIoCompletion$1$label_34#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_35#1;

  inline$BDLDevicePowerIoCompletion$1$label_35#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_36#1;

  inline$BDLDevicePowerIoCompletion$1$label_36#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_37#1;

  inline$BDLDevicePowerIoCompletion$1$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$1$label_31#1;

  inline$BDLDevicePowerIoCompletion$1$label_31#1:
    goto inline$BDLGetDebugLevel$36$Entry#1;

  inline$BDLGetDebugLevel$36$Entry#1:
    goto inline$BDLGetDebugLevel$36$start#1;

  inline$BDLGetDebugLevel$36$start#1:
    goto inline$BDLGetDebugLevel$36$label_3#1;

  inline$BDLGetDebugLevel$36$label_3#1:
    havoc inline$BDLGetDebugLevel$36$myNondetVar_0;
    inline$BDLGetDebugLevel$36$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$36$myNondetVar_0;
    goto inline$BDLGetDebugLevel$36$label_1#1;

  inline$BDLGetDebugLevel$36$label_1#1:
    goto inline$BDLGetDebugLevel$36$Return#1;

  inline$BDLGetDebugLevel$36$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$36$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon33_Then#1, inline$BDLDevicePowerIoCompletion$1$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon7#1;

  inline$BDLDevicePowerIoCompletion$1$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_40#1;

  inline$BDLDevicePowerIoCompletion$1$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_40_true#1, inline$BDLDevicePowerIoCompletion$1$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_41#1;

  inline$BDLDevicePowerIoCompletion$1$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_42#1;

  inline$BDLDevicePowerIoCompletion$1$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_41#1;

  inline$BDLDevicePowerIoCompletion$1$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_41_true#1, inline$BDLDevicePowerIoCompletion$1$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$1$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$1$label_43#1;

  inline$BDLDevicePowerIoCompletion$1$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$1$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$1$label_44#1;

  inline$BDLDevicePowerIoCompletion$1$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_44_true#1, inline$BDLDevicePowerIoCompletion$1$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$1$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$1$label_45#1;

  inline$BDLDevicePowerIoCompletion$1$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_45_true#1, inline$BDLDevicePowerIoCompletion$1$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$1$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$1$label_43#1;

  inline$BDLDevicePowerIoCompletion$1$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$1$label_86#1;

  inline$BDLDevicePowerIoCompletion$1$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$1$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$1$label_46#1;

  inline$BDLDevicePowerIoCompletion$1$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$1$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$1$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$1$label_46#1;

  inline$BDLDevicePowerIoCompletion$1$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$1$label_49#1;

  inline$BDLDevicePowerIoCompletion$1$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_50#1;

  inline$BDLDevicePowerIoCompletion$1$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_51#1;

  inline$BDLDevicePowerIoCompletion$1$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_54#1;

  inline$BDLDevicePowerIoCompletion$1$label_54#1:
    inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$1$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$1$label_55#1;

  inline$BDLDevicePowerIoCompletion$1$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_55_true#1, inline$BDLDevicePowerIoCompletion$1$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_56#1;

  inline$BDLDevicePowerIoCompletion$1$label_56#1:
    call inline$BDLDevicePowerIoCompletion$1$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$1$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$1$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$1$anon34_Then#1, inline$BDLDevicePowerIoCompletion$1$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon9#1;

  inline$BDLDevicePowerIoCompletion$1$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_83#1;

  inline$BDLDevicePowerIoCompletion$1$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_59#1;

  inline$BDLDevicePowerIoCompletion$1$label_59#1:
    goto inline$BDLGetDebugLevel$37$Entry#1;

  inline$BDLGetDebugLevel$37$Entry#1:
    goto inline$BDLGetDebugLevel$37$start#1;

  inline$BDLGetDebugLevel$37$start#1:
    goto inline$BDLGetDebugLevel$37$label_3#1;

  inline$BDLGetDebugLevel$37$label_3#1:
    havoc inline$BDLGetDebugLevel$37$myNondetVar_0;
    inline$BDLGetDebugLevel$37$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$37$myNondetVar_0;
    goto inline$BDLGetDebugLevel$37$label_1#1;

  inline$BDLGetDebugLevel$37$label_1#1:
    goto inline$BDLGetDebugLevel$37$Return#1;

  inline$BDLGetDebugLevel$37$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$37$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon35_Then#1, inline$BDLDevicePowerIoCompletion$1$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon11#1;

  inline$BDLDevicePowerIoCompletion$1$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_62#1;

  inline$BDLDevicePowerIoCompletion$1$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_62_true#1, inline$BDLDevicePowerIoCompletion$1$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_63#1;

  inline$BDLDevicePowerIoCompletion$1$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_66#1;

  inline$BDLDevicePowerIoCompletion$1$label_66#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_67#1;

  inline$BDLDevicePowerIoCompletion$1$label_67#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_68#1;

  inline$BDLDevicePowerIoCompletion$1$label_68#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_69#1;

  inline$BDLDevicePowerIoCompletion$1$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$1$label_63#1;

  inline$BDLDevicePowerIoCompletion$1$label_63#1:
    goto inline$BDLGetDebugLevel$38$Entry#1;

  inline$BDLGetDebugLevel$38$Entry#1:
    goto inline$BDLGetDebugLevel$38$start#1;

  inline$BDLGetDebugLevel$38$start#1:
    goto inline$BDLGetDebugLevel$38$label_3#1;

  inline$BDLGetDebugLevel$38$label_3#1:
    havoc inline$BDLGetDebugLevel$38$myNondetVar_0;
    inline$BDLGetDebugLevel$38$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$38$myNondetVar_0;
    goto inline$BDLGetDebugLevel$38$label_1#1;

  inline$BDLGetDebugLevel$38$label_1#1:
    goto inline$BDLGetDebugLevel$38$Return#1;

  inline$BDLGetDebugLevel$38$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$38$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon36_Then#1, inline$BDLDevicePowerIoCompletion$1$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon13#1;

  inline$BDLDevicePowerIoCompletion$1$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_72#1;

  inline$BDLDevicePowerIoCompletion$1$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_72_true#1, inline$BDLDevicePowerIoCompletion$1$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_73#1;

  inline$BDLDevicePowerIoCompletion$1$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_76#1;

  inline$BDLDevicePowerIoCompletion$1$label_76#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_77#1;

  inline$BDLDevicePowerIoCompletion$1$label_77#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_78#1;

  inline$BDLDevicePowerIoCompletion$1$label_78#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_79#1;

  inline$BDLDevicePowerIoCompletion$1$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$1$label_73#1;

  inline$BDLDevicePowerIoCompletion$1$label_73#1:
    goto inline$BDLGetDebugLevel$39$Entry#1;

  inline$BDLGetDebugLevel$39$Entry#1:
    goto inline$BDLGetDebugLevel$39$start#1;

  inline$BDLGetDebugLevel$39$start#1:
    goto inline$BDLGetDebugLevel$39$label_3#1;

  inline$BDLGetDebugLevel$39$label_3#1:
    havoc inline$BDLGetDebugLevel$39$myNondetVar_0;
    inline$BDLGetDebugLevel$39$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$39$myNondetVar_0;
    goto inline$BDLGetDebugLevel$39$label_1#1;

  inline$BDLGetDebugLevel$39$label_1#1:
    goto inline$BDLGetDebugLevel$39$Return#1;

  inline$BDLGetDebugLevel$39$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$39$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon37_Then#1, inline$BDLDevicePowerIoCompletion$1$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon15#1;

  inline$BDLDevicePowerIoCompletion$1$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_82#1;

  inline$BDLDevicePowerIoCompletion$1$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_82_true#1, inline$BDLDevicePowerIoCompletion$1$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_83#1;

  inline$BDLDevicePowerIoCompletion$1$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_84#1;

  inline$BDLDevicePowerIoCompletion$1$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_83#1;

  inline$BDLDevicePowerIoCompletion$1$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_85#1;

  inline$BDLDevicePowerIoCompletion$1$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_86#1;

  inline$BDLDevicePowerIoCompletion$1$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$1$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$1$anon38_Then#1, inline$BDLDevicePowerIoCompletion$1$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon17#1;

  inline$BDLDevicePowerIoCompletion$1$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_89#1;

  inline$BDLDevicePowerIoCompletion$1$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$1$anon39_Then#1, inline$BDLDevicePowerIoCompletion$1$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon19#1;

  inline$BDLDevicePowerIoCompletion$1$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_92#1;

  inline$BDLDevicePowerIoCompletion$1$label_92#1:
    goto inline$storm_IoCompleteRequest$3$Entry#1;

  inline$storm_IoCompleteRequest$3$Entry#1:
    inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$1$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$3$start#1;

  inline$storm_IoCompleteRequest$3$start#1:
    inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$3$label_3#1;

  inline$storm_IoCompleteRequest$3$label_3#1:
    call inline$storm_IoCompleteRequest$3$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$3$label_6#1;

  inline$storm_IoCompleteRequest$3$label_6#1:
    goto inline$storm_IoCompleteRequest$3$label_6_true#1, inline$storm_IoCompleteRequest$3$label_6_false#1;

  inline$storm_IoCompleteRequest$3$label_6_false#1:
    assume inline$storm_IoCompleteRequest$3$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$3$label_7#1;

  inline$storm_IoCompleteRequest$3$label_6_true#1:
    assume inline$storm_IoCompleteRequest$3$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$3$label_8#1;

  inline$storm_IoCompleteRequest$3$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$3$anon3_Then#1, inline$storm_IoCompleteRequest$3$anon3_Else#1;

  inline$storm_IoCompleteRequest$3$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$3$anon1#1;

  inline$storm_IoCompleteRequest$3$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$3$label_9#1;

  inline$storm_IoCompleteRequest$3$label_9#1:
    goto inline$storm_IoCompleteRequest$3$label_9_true#1, inline$storm_IoCompleteRequest$3$label_9_false#1;

  inline$storm_IoCompleteRequest$3$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$3$label_10#1;

  inline$storm_IoCompleteRequest$3$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$3$label_1#1;

  inline$storm_IoCompleteRequest$3$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$3$label_7#1;

  inline$storm_IoCompleteRequest$3$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$3$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$3$label_1#1;

  inline$storm_IoCompleteRequest$3$label_1#1:
    goto inline$storm_IoCompleteRequest$3$Return#1;

  inline$storm_IoCompleteRequest$3$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$3$Return#1;

  inline$storm_IoCompleteRequest$3$Return#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon40_Then#1, inline$BDLDevicePowerIoCompletion$1$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon21#1;

  inline$BDLDevicePowerIoCompletion$1$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_95#1;

  inline$BDLDevicePowerIoCompletion$1$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$1$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$1$anon41_Then#1, inline$BDLDevicePowerIoCompletion$1$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon23#1;

  inline$BDLDevicePowerIoCompletion$1$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_98#1;

  inline$BDLDevicePowerIoCompletion$1$label_98#1:
    goto inline$BDLGetDebugLevel$40$Entry#1;

  inline$BDLGetDebugLevel$40$Entry#1:
    goto inline$BDLGetDebugLevel$40$start#1;

  inline$BDLGetDebugLevel$40$start#1:
    goto inline$BDLGetDebugLevel$40$label_3#1;

  inline$BDLGetDebugLevel$40$label_3#1:
    havoc inline$BDLGetDebugLevel$40$myNondetVar_0;
    inline$BDLGetDebugLevel$40$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$40$myNondetVar_0;
    goto inline$BDLGetDebugLevel$40$label_1#1;

  inline$BDLGetDebugLevel$40$label_1#1:
    goto inline$BDLGetDebugLevel$40$Return#1;

  inline$BDLGetDebugLevel$40$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$40$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon42_Then#1, inline$BDLDevicePowerIoCompletion$1$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon25#1;

  inline$BDLDevicePowerIoCompletion$1$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_101#1;

  inline$BDLDevicePowerIoCompletion$1$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_101_true#1, inline$BDLDevicePowerIoCompletion$1$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_102#1;

  inline$BDLDevicePowerIoCompletion$1$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_105#1;

  inline$BDLDevicePowerIoCompletion$1$label_105#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_106#1;

  inline$BDLDevicePowerIoCompletion$1$label_106#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_107#1;

  inline$BDLDevicePowerIoCompletion$1$label_107#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_108#1;

  inline$BDLDevicePowerIoCompletion$1$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$1$label_102#1;

  inline$BDLDevicePowerIoCompletion$1$label_102#1:
    goto inline$BDLGetDebugLevel$41$Entry#1;

  inline$BDLGetDebugLevel$41$Entry#1:
    goto inline$BDLGetDebugLevel$41$start#1;

  inline$BDLGetDebugLevel$41$start#1:
    goto inline$BDLGetDebugLevel$41$label_3#1;

  inline$BDLGetDebugLevel$41$label_3#1:
    havoc inline$BDLGetDebugLevel$41$myNondetVar_0;
    inline$BDLGetDebugLevel$41$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$41$myNondetVar_0;
    goto inline$BDLGetDebugLevel$41$label_1#1;

  inline$BDLGetDebugLevel$41$label_1#1:
    goto inline$BDLGetDebugLevel$41$Return#1;

  inline$BDLGetDebugLevel$41$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$41$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon43_Then#1, inline$BDLDevicePowerIoCompletion$1$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon27#1;

  inline$BDLDevicePowerIoCompletion$1$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_111#1;

  inline$BDLDevicePowerIoCompletion$1$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_111_true#1, inline$BDLDevicePowerIoCompletion$1$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_112#1;

  inline$BDLDevicePowerIoCompletion$1$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_115#1;

  inline$BDLDevicePowerIoCompletion$1$label_115#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_116#1;

  inline$BDLDevicePowerIoCompletion$1$label_116#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_117#1;

  inline$BDLDevicePowerIoCompletion$1$label_117#1:
    call inline$BDLDevicePowerIoCompletion$1$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$1$label_118#1;

  inline$BDLDevicePowerIoCompletion$1$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$1$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$1$label_112#1;

  inline$BDLDevicePowerIoCompletion$1$label_112#1:
    goto inline$BDLGetDebugLevel$42$Entry#1;

  inline$BDLGetDebugLevel$42$Entry#1:
    goto inline$BDLGetDebugLevel$42$start#1;

  inline$BDLGetDebugLevel$42$start#1:
    goto inline$BDLGetDebugLevel$42$label_3#1;

  inline$BDLGetDebugLevel$42$label_3#1:
    havoc inline$BDLGetDebugLevel$42$myNondetVar_0;
    inline$BDLGetDebugLevel$42$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$42$myNondetVar_0;
    goto inline$BDLGetDebugLevel$42$label_1#1;

  inline$BDLGetDebugLevel$42$label_1#1:
    goto inline$BDLGetDebugLevel$42$Return#1;

  inline$BDLGetDebugLevel$42$Return#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$42$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$1$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$1$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$1$anon44_Then#1, inline$BDLDevicePowerIoCompletion$1$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$1$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$anon29#1;

  inline$BDLDevicePowerIoCompletion$1$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_121#1;

  inline$BDLDevicePowerIoCompletion$1$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_121_true#1, inline$BDLDevicePowerIoCompletion$1$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$1$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_122#1;

  inline$BDLDevicePowerIoCompletion$1$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$1$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$1$label_123#1;

  inline$BDLDevicePowerIoCompletion$1$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$1$label_122#1;

  inline$BDLDevicePowerIoCompletion$1$label_122#1:
    inline$BDLDevicePowerIoCompletion$1$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$1$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$1$label_1#1;

  inline$BDLDevicePowerIoCompletion$1$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$1$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$1$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$1$Return#1;

  inline$BDLDevicePowerIoCompletion$1$Return#1:
    inline$CallCompletionRoutine$1$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$1$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$1$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$1$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$1$anon13_Then#1, inline$CallCompletionRoutine$1$anon13_Else#1;

  inline$CallCompletionRoutine$1$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$1$anon7#1;

  inline$CallCompletionRoutine$1$anon7#1:
    goto inline$CallCompletionRoutine$1$label_20_icall_return#1;

  inline$CallCompletionRoutine$1$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$1$Return#1;

  inline$CallCompletionRoutine$1$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$1$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$1$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$1$Entry#1;

  inline$BDLCallDriverCompletionRoutine$1$Entry#1:
    inline$BDLCallDriverCompletionRoutine$1$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$1$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$1$start#1;

  inline$BDLCallDriverCompletionRoutine$1$start#1:
    inline$BDLCallDriverCompletionRoutine$1$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$1$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$1$label_3#1;

  inline$BDLCallDriverCompletionRoutine$1$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$1$label_3_true#1, inline$BDLCallDriverCompletionRoutine$1$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$1$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$1$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$1$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$1$label_4#1;

  inline$BDLCallDriverCompletionRoutine$1$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$1$label_6#1;

  inline$BDLCallDriverCompletionRoutine$1$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$1$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$1$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$1$label_5#1;

  inline$BDLCallDriverCompletionRoutine$1$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$1$label_6#1;

  inline$BDLCallDriverCompletionRoutine$1$label_6#1:
    goto inline$storm_KeSetEvent$1$Entry#1;

  inline$storm_KeSetEvent$1$Entry#1:
    inline$storm_KeSetEvent$1$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$1$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$1$start#1;

  inline$storm_KeSetEvent$1$start#1:
    inline$storm_KeSetEvent$1$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$1$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$1$label_3#1;

  inline$storm_KeSetEvent$1$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$1$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$1$label_1#1;

  inline$storm_KeSetEvent$1$label_1#1:
    goto inline$storm_KeSetEvent$1$Return#1;

  inline$storm_KeSetEvent$1$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$1$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$1$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$1$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$1$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$1$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$1$anon1#1;

  inline$BDLCallDriverCompletionRoutine$1$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$1$label_9#1;

  inline$BDLCallDriverCompletionRoutine$1$label_9#1:
    inline$BDLCallDriverCompletionRoutine$1$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$1$label_1#1;

  inline$BDLCallDriverCompletionRoutine$1$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$1$Return#1;

  inline$BDLCallDriverCompletionRoutine$1$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$1$Return#1;

  inline$BDLCallDriverCompletionRoutine$1$Return#1:
    inline$CallCompletionRoutine$1$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$1$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$1$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$1$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$1$anon12_Then#1, inline$CallCompletionRoutine$1$anon12_Else#1;

  inline$CallCompletionRoutine$1$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$1$anon5#1;

  inline$CallCompletionRoutine$1$anon5#1:
    goto inline$CallCompletionRoutine$1$label_20_icall_return#1;

  inline$CallCompletionRoutine$1$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$1$label_23#1;

  inline$CallCompletionRoutine$1$label_23#1:
    inline$CallCompletionRoutine$1$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$1$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$1$label_24#1;

  inline$CallCompletionRoutine$1$label_24#1:
    goto inline$CallCompletionRoutine$1$label_24_true#1, inline$CallCompletionRoutine$1$label_24_false#1;

  inline$CallCompletionRoutine$1$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$1$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$1$label_1#1;

  inline$CallCompletionRoutine$1$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$1$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$1$label_25#1;

  inline$CallCompletionRoutine$1$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$1$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$1$label_1#1;

  inline$CallCompletionRoutine$1$label_1#1:
    goto inline$CallCompletionRoutine$1$Return#1;

  inline$CallCompletionRoutine$1$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$1$Return#1;

  inline$CallCompletionRoutine$1$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$1$Return#1;

  inline$CallCompletionRoutine$1$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$1$Return#1;

  inline$CallCompletionRoutine$1$Return#1:
    goto inline$storm_IoCallDriver$0$label_39$1#1;

  inline$storm_IoCallDriver$0$label_39$1#1:
    goto inline$storm_IoCallDriver$0$anon15_Then#1, inline$storm_IoCallDriver$0$anon15_Else#1;

  inline$storm_IoCallDriver$0$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$0$anon10#1;

  inline$storm_IoCallDriver$0$anon10#1:
    goto inline$storm_IoCallDriver$0$label_36#1;

  inline$storm_IoCallDriver$0$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$0$Return#1;

  inline$storm_IoCallDriver$0$label_27_case_0#1:
    assume inline$storm_IoCallDriver$0$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$0$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$0$label_28#1;

  inline$storm_IoCallDriver$0$label_28#1:
    inline$storm_IoCallDriver$0$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$0$label_42#1;

  inline$storm_IoCallDriver$0$label_42#1:
    goto inline$storm_IoCallDriver$0$label_43#1;

  inline$storm_IoCallDriver$0$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$0$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$0$label_36#1;

  inline$storm_IoCallDriver$0$label_36#1:
    inline$storm_IoCallDriver$0$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$0$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$0$label_1#1;

  inline$storm_IoCallDriver$0$label_1#1:
    goto inline$storm_IoCallDriver$0$Return#1;

  inline$storm_IoCallDriver$0$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$0$Return#1;

  inline$storm_IoCallDriver$0$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$0$Return#1;

  inline$storm_IoCallDriver$0$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$0$Return#1;

  inline$storm_IoCallDriver$0$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_IoCallDriver$108.29$4$ := inline$storm_IoCallDriver$0$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_19$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_19$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon20_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon20_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon20_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon9#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon9#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_42#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_42#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_IoCallDriver$108.29$4$;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon20_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_18_true#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0;
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0, 22);
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_22#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_22#1:
    call PoStartNextPowerIrp(inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon21_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon21_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon21_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon11#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon11#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_25#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_25#1:
    goto inline$storm_PoCallDriver$0$Entry#1;

  inline$storm_PoCallDriver$0$Entry#1:
    inline$storm_PoCallDriver$0$$Irp$2$496.14$storm_PoCallDriver$8_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$pIrp$2$74.24$BDLCallLowerLevelDriverAndWait$8;
    goto inline$storm_PoCallDriver$0$start#1;

  inline$storm_PoCallDriver$0$start#1:
    inline$storm_PoCallDriver$0$$Irp$2$496.14$storm_PoCallDriver$8 := inline$storm_PoCallDriver$0$$Irp$2$496.14$storm_PoCallDriver$8_.1;
    goto inline$storm_PoCallDriver$0$label_3#1;

  inline$storm_PoCallDriver$0$label_3#1:
    goto inline$storm_IoCallDriver$1$Entry#1;

  inline$storm_IoCallDriver$1$Entry#1:
    inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$storm_PoCallDriver$0$$Irp$2$496.14$storm_PoCallDriver$8;
    goto inline$storm_IoCallDriver$1$start#1;

  inline$storm_IoCallDriver$1$start#1:
    inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$1$label_3#1;

  inline$storm_IoCallDriver$1$label_3#1:
    goto inline$storm_IoCallDriver$1$label_4#1;

  inline$storm_IoCallDriver$1$label_4#1:
    goto inline$storm_IoCallDriver$1$label_5#1;

  inline$storm_IoCallDriver$1$label_5#1:
    goto inline$storm_IoCallDriver$1$label_6#1;

  inline$storm_IoCallDriver$1$label_6#1:
    call inline$storm_IoCallDriver$1$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$1$label_9#1;

  inline$storm_IoCallDriver$1$label_9#1:
    goto inline$storm_IoCallDriver$1$label_9_true#1, inline$storm_IoCallDriver$1$label_9_false#1;

  inline$storm_IoCallDriver$1$label_9_false#1:
    assume inline$storm_IoCallDriver$1$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$1$label_10#1;

  inline$storm_IoCallDriver$1$label_9_true#1:
    assume inline$storm_IoCallDriver$1$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$1$label_13#1;

  inline$storm_IoCallDriver$1$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$1$anon12_Then#1, inline$storm_IoCallDriver$1$anon12_Else#1;

  inline$storm_IoCallDriver$1$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$1$anon3#1;

  inline$storm_IoCallDriver$1$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$1$label_14#1;

  inline$storm_IoCallDriver$1$label_14#1:
    goto inline$storm_IoCallDriver$1$label_14_true#1, inline$storm_IoCallDriver$1$label_14_false#1;

  inline$storm_IoCallDriver$1$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$1$label_15#1;

  inline$storm_IoCallDriver$1$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$1$label_1#1;

  inline$storm_IoCallDriver$1$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$1$label_10#1;

  inline$storm_IoCallDriver$1$label_10#1:
    goto inline$IoSetNextIrpStackLocation$2$Entry#1;

  inline$IoSetNextIrpStackLocation$2$Entry#1:
    inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$2$start#1;

  inline$IoSetNextIrpStackLocation$2$start#1:
    inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$2$label_3#1;

  inline$IoSetNextIrpStackLocation$2$label_3#1:
    goto inline$IoSetNextIrpStackLocation$2$label_3_true#1, inline$IoSetNextIrpStackLocation$2$label_3_false#1;

  inline$IoSetNextIrpStackLocation$2$label_3_false#1:
    inline$IoSetNextIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$2$myVar_0);
    goto inline$IoSetNextIrpStackLocation$2$label_4#1;

  inline$IoSetNextIrpStackLocation$2$label_4#1:
    call inline$IoSetNextIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$2$label_7#1;

  inline$IoSetNextIrpStackLocation$2$label_7#1:
    call inline$IoSetNextIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$2$label_8#1;

  inline$IoSetNextIrpStackLocation$2$label_8#1:
    goto inline$IoSetNextIrpStackLocation$2$label_5#1;

  inline$IoSetNextIrpStackLocation$2$label_3_true#1:
    inline$IoSetNextIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$2$myVar_0);
    goto inline$IoSetNextIrpStackLocation$2$label_5#1;

  inline$IoSetNextIrpStackLocation$2$label_5#1:
    inline$IoSetNextIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$2$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$2$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$2$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$2$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$2$label_6#1;

  inline$IoSetNextIrpStackLocation$2$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$2$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$2$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$2$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$2$label_1#1;

  inline$IoSetNextIrpStackLocation$2$label_1#1:
    goto inline$IoSetNextIrpStackLocation$2$Return#1;

  inline$IoSetNextIrpStackLocation$2$Return#1:
    goto inline$storm_IoCallDriver$1$label_10$1#1;

  inline$storm_IoCallDriver$1$label_10$1#1:
    goto inline$storm_IoCallDriver$1$anon11_Then#1, inline$storm_IoCallDriver$1$anon11_Else#1;

  inline$storm_IoCallDriver$1$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$1$anon1#1;

  inline$storm_IoCallDriver$1$anon1#1:
    goto inline$storm_IoCallDriver$1$label_18#1;

  inline$storm_IoCallDriver$1$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$14$Entry#1;

  inline$IoGetCurrentIrpStackLocation$14$Entry#1:
    inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$14$start#1;

  inline$IoGetCurrentIrpStackLocation$14$start#1:
    inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$14$label_3#1;

  inline$IoGetCurrentIrpStackLocation$14$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$14$label_3_true#1, inline$IoGetCurrentIrpStackLocation$14$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$14$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$14$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$14$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$14$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$14$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$14$label_4#1;

  inline$IoGetCurrentIrpStackLocation$14$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$14$label_6#1;

  inline$IoGetCurrentIrpStackLocation$14$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$14$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$14$label_7#1;

  inline$IoGetCurrentIrpStackLocation$14$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$14$label_5#1;

  inline$IoGetCurrentIrpStackLocation$14$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$14$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$14$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$14$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$14$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$14$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$14$label_5#1;

  inline$IoGetCurrentIrpStackLocation$14$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$14$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$14$label_1#1;

  inline$IoGetCurrentIrpStackLocation$14$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$14$Return#1;

  inline$IoGetCurrentIrpStackLocation$14$Return#1:
    goto inline$storm_IoCallDriver$1$label_18$1#1;

  inline$storm_IoCallDriver$1$label_18$1#1:
    goto inline$storm_IoCallDriver$1$anon13_Then#1, inline$storm_IoCallDriver$1$anon13_Else#1;

  inline$storm_IoCallDriver$1$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$1$anon6#1;

  inline$storm_IoCallDriver$1$anon6#1:
    goto inline$storm_IoCallDriver$1$label_21#1;

  inline$storm_IoCallDriver$1$label_21#1:
    goto inline$storm_IoCallDriver$1$label_22#1;

  inline$storm_IoCallDriver$1$label_22#1:
    goto inline$storm_IoCallDriver$1$label_23#1;

  inline$storm_IoCallDriver$1$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$1$label_24#1;

  inline$storm_IoCallDriver$1$label_24#1:
    call inline$storm_IoCallDriver$1$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$1$label_27#1;

  inline$storm_IoCallDriver$1$label_27#1:
    goto inline$storm_IoCallDriver$1$label_27_case_0#1, inline$storm_IoCallDriver$1$label_27_case_1#1, inline$storm_IoCallDriver$1$label_27_case_2#1;

  inline$storm_IoCallDriver$1$label_27_case_2#1:
    assume inline$storm_IoCallDriver$1$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$1$label_30#1;

  inline$storm_IoCallDriver$1$label_30#1:
    inline$storm_IoCallDriver$1$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$1$label_31#1;

  inline$storm_IoCallDriver$1$label_31#1:
    goto inline$storm_IoCallDriver$1$label_32#1;

  inline$storm_IoCallDriver$1$label_32#1:
    goto inline$storm_IoCallDriver$1$label_33#1;

  inline$storm_IoCallDriver$1$label_33#1:
    goto inline$CallCompletionRoutine$2$Entry#1;

  inline$CallCompletionRoutine$2$Entry#1:
    inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$2$start#1;

  inline$CallCompletionRoutine$2$start#1:
    inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$2$label_3#1;

  inline$CallCompletionRoutine$2$label_3#1:
    goto inline$CallCompletionRoutine$2$label_4#1;

  inline$CallCompletionRoutine$2$label_4#1:
    goto inline$CallCompletionRoutine$2$label_5#1;

  inline$CallCompletionRoutine$2$label_5#1:
    goto inline$CallCompletionRoutine$2$label_6#1;

  inline$CallCompletionRoutine$2$label_6#1:
    goto inline$CallCompletionRoutine$2$label_7#1;

  inline$CallCompletionRoutine$2$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$15$Entry#1;

  inline$IoGetCurrentIrpStackLocation$15$Entry#1:
    inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$15$start#1;

  inline$IoGetCurrentIrpStackLocation$15$start#1:
    inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$15$label_3#1;

  inline$IoGetCurrentIrpStackLocation$15$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$15$label_3_true#1, inline$IoGetCurrentIrpStackLocation$15$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$15$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$15$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$15$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$15$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$15$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$15$label_4#1;

  inline$IoGetCurrentIrpStackLocation$15$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$15$label_6#1;

  inline$IoGetCurrentIrpStackLocation$15$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$15$label_7#1;

  inline$IoGetCurrentIrpStackLocation$15$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$15$label_5#1;

  inline$IoGetCurrentIrpStackLocation$15$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$15$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$15$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$15$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$15$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$15$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$15$label_5#1;

  inline$IoGetCurrentIrpStackLocation$15$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$15$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$15$label_1#1;

  inline$IoGetCurrentIrpStackLocation$15$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$15$Return#1;

  inline$IoGetCurrentIrpStackLocation$15$Return#1:
    goto inline$CallCompletionRoutine$2$label_7$1#1;

  inline$CallCompletionRoutine$2$label_7$1#1:
    goto inline$CallCompletionRoutine$2$anon10_Then#1, inline$CallCompletionRoutine$2$anon10_Else#1;

  inline$CallCompletionRoutine$2$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$2$anon1#1;

  inline$CallCompletionRoutine$2$anon1#1:
    goto inline$CallCompletionRoutine$2$label_10#1;

  inline$CallCompletionRoutine$2$label_10#1:
    goto inline$CallCompletionRoutine$2$label_11#1;

  inline$CallCompletionRoutine$2$label_11#1:
    havoc inline$CallCompletionRoutine$2$myNondetVar_0;
    inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$2$myNondetVar_0;
    goto inline$CallCompletionRoutine$2$label_12#1;

  inline$CallCompletionRoutine$2$label_12#1:
    havoc inline$CallCompletionRoutine$2$myNondetVar_0;
    inline$CallCompletionRoutine$2$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$2$myNondetVar_0;
    goto inline$CallCompletionRoutine$2$label_13#1;

  inline$CallCompletionRoutine$2$label_13#1:
    havoc inline$CallCompletionRoutine$2$myNondetVar_0;
    goto inline$CallCompletionRoutine$2$label_14#1;

  inline$CallCompletionRoutine$2$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$16$Entry#1;

  inline$IoGetCurrentIrpStackLocation$16$Entry#1:
    inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$16$start#1;

  inline$IoGetCurrentIrpStackLocation$16$start#1:
    inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$16$label_3#1;

  inline$IoGetCurrentIrpStackLocation$16$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$16$label_3_true#1, inline$IoGetCurrentIrpStackLocation$16$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$16$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$16$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$16$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$16$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$16$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$16$label_4#1;

  inline$IoGetCurrentIrpStackLocation$16$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$16$label_6#1;

  inline$IoGetCurrentIrpStackLocation$16$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$16$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$16$label_7#1;

  inline$IoGetCurrentIrpStackLocation$16$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$16$label_5#1;

  inline$IoGetCurrentIrpStackLocation$16$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$16$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$16$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$16$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$16$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$16$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$16$label_5#1;

  inline$IoGetCurrentIrpStackLocation$16$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$16$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$16$label_1#1;

  inline$IoGetCurrentIrpStackLocation$16$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$16$Return#1;

  inline$IoGetCurrentIrpStackLocation$16$Return#1:
    goto inline$CallCompletionRoutine$2$label_14$1#1;

  inline$CallCompletionRoutine$2$label_14$1#1:
    goto inline$CallCompletionRoutine$2$anon11_Then#1, inline$CallCompletionRoutine$2$anon11_Else#1;

  inline$CallCompletionRoutine$2$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$2$anon3#1;

  inline$CallCompletionRoutine$2$anon3#1:
    goto inline$CallCompletionRoutine$2$label_17#1;

  inline$CallCompletionRoutine$2$label_17#1:
    goto inline$CallCompletionRoutine$2$label_18#1;

  inline$CallCompletionRoutine$2$label_18#1:
    goto inline$CallCompletionRoutine$2$label_18_true#1, inline$CallCompletionRoutine$2$label_18_false#1;

  inline$CallCompletionRoutine$2$label_18_false#1:
    assume inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$2$label_1#1;

  inline$CallCompletionRoutine$2$label_18_true#1:
    assume inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$2$label_19#1;

  inline$CallCompletionRoutine$2$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$2$label_20#1;

  inline$CallCompletionRoutine$2$label_20#1:
    goto inline$CallCompletionRoutine$2$label_20_icall_1#1, inline$CallCompletionRoutine$2$label_20_icall_2#1, inline$CallCompletionRoutine$2$label_20_icall_3#1;

  inline$CallCompletionRoutine$2$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$2$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$2$Entry#1;

  inline$BDLSystemPowerIoCompletion$2$Entry#1:
    inline$BDLSystemPowerIoCompletion$2$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$2$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$2$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$2$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$2$start#1;

  inline$BDLSystemPowerIoCompletion$2$start#1:
    call inline$BDLSystemPowerIoCompletion$2$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$2$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$2$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$2$label_3#1;

  inline$BDLSystemPowerIoCompletion$2$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_4#1;

  inline$BDLSystemPowerIoCompletion$2$label_4#1:
    inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_5#1;

  inline$BDLSystemPowerIoCompletion$2$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_6#1;

  inline$BDLSystemPowerIoCompletion$2$label_6#1:
    inline$BDLSystemPowerIoCompletion$2$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$2$label_7#1;

  inline$BDLSystemPowerIoCompletion$2$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_8#1;

  inline$BDLSystemPowerIoCompletion$2$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$2$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$2$label_9#1;

  inline$BDLSystemPowerIoCompletion$2$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_10#1;

  inline$BDLSystemPowerIoCompletion$2$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$18$Entry#1;

  inline$IoGetCurrentIrpStackLocation$18$Entry#1:
    inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$18$start#1;

  inline$IoGetCurrentIrpStackLocation$18$start#1:
    inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$18$label_3#1;

  inline$IoGetCurrentIrpStackLocation$18$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$18$label_3_true#1, inline$IoGetCurrentIrpStackLocation$18$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$18$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$18$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$18$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$18$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$18$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$18$label_4#1;

  inline$IoGetCurrentIrpStackLocation$18$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$18$label_6#1;

  inline$IoGetCurrentIrpStackLocation$18$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$18$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$18$label_7#1;

  inline$IoGetCurrentIrpStackLocation$18$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$18$label_5#1;

  inline$IoGetCurrentIrpStackLocation$18$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$18$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$18$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$18$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$18$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$18$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$18$label_5#1;

  inline$IoGetCurrentIrpStackLocation$18$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$18$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$18$label_1#1;

  inline$IoGetCurrentIrpStackLocation$18$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$18$Return#1;

  inline$IoGetCurrentIrpStackLocation$18$Return#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon36_Then#1, inline$BDLSystemPowerIoCompletion$2$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon1#1;

  inline$BDLSystemPowerIoCompletion$2$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_13#1;

  inline$BDLSystemPowerIoCompletion$2$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_14#1;

  inline$BDLSystemPowerIoCompletion$2$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_15#1;

  inline$BDLSystemPowerIoCompletion$2$label_15#1:
    goto inline$BDLGetDebugLevel$64$Entry#1;

  inline$BDLGetDebugLevel$64$Entry#1:
    goto inline$BDLGetDebugLevel$64$start#1;

  inline$BDLGetDebugLevel$64$start#1:
    goto inline$BDLGetDebugLevel$64$label_3#1;

  inline$BDLGetDebugLevel$64$label_3#1:
    havoc inline$BDLGetDebugLevel$64$myNondetVar_0;
    inline$BDLGetDebugLevel$64$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$64$myNondetVar_0;
    goto inline$BDLGetDebugLevel$64$label_1#1;

  inline$BDLGetDebugLevel$64$label_1#1:
    goto inline$BDLGetDebugLevel$64$Return#1;

  inline$BDLGetDebugLevel$64$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$64$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon37_Then#1, inline$BDLSystemPowerIoCompletion$2$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon3#1;

  inline$BDLSystemPowerIoCompletion$2$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_18#1;

  inline$BDLSystemPowerIoCompletion$2$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_18_true#1, inline$BDLSystemPowerIoCompletion$2$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_19#1;

  inline$BDLSystemPowerIoCompletion$2$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_22#1;

  inline$BDLSystemPowerIoCompletion$2$label_22#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_23#1;

  inline$BDLSystemPowerIoCompletion$2$label_23#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_24#1;

  inline$BDLSystemPowerIoCompletion$2$label_24#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_25#1;

  inline$BDLSystemPowerIoCompletion$2$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$2$label_19#1;

  inline$BDLSystemPowerIoCompletion$2$label_19#1:
    goto inline$BDLGetDebugLevel$65$Entry#1;

  inline$BDLGetDebugLevel$65$Entry#1:
    goto inline$BDLGetDebugLevel$65$start#1;

  inline$BDLGetDebugLevel$65$start#1:
    goto inline$BDLGetDebugLevel$65$label_3#1;

  inline$BDLGetDebugLevel$65$label_3#1:
    havoc inline$BDLGetDebugLevel$65$myNondetVar_0;
    inline$BDLGetDebugLevel$65$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$65$myNondetVar_0;
    goto inline$BDLGetDebugLevel$65$label_1#1;

  inline$BDLGetDebugLevel$65$label_1#1:
    goto inline$BDLGetDebugLevel$65$Return#1;

  inline$BDLGetDebugLevel$65$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$65$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon38_Then#1, inline$BDLSystemPowerIoCompletion$2$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon5#1;

  inline$BDLSystemPowerIoCompletion$2$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_28#1;

  inline$BDLSystemPowerIoCompletion$2$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_28_true#1, inline$BDLSystemPowerIoCompletion$2$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_29#1;

  inline$BDLSystemPowerIoCompletion$2$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_32#1;

  inline$BDLSystemPowerIoCompletion$2$label_32#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_33#1;

  inline$BDLSystemPowerIoCompletion$2$label_33#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_34#1;

  inline$BDLSystemPowerIoCompletion$2$label_34#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_35#1;

  inline$BDLSystemPowerIoCompletion$2$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$2$label_29#1;

  inline$BDLSystemPowerIoCompletion$2$label_29#1:
    goto inline$BDLGetDebugLevel$66$Entry#1;

  inline$BDLGetDebugLevel$66$Entry#1:
    goto inline$BDLGetDebugLevel$66$start#1;

  inline$BDLGetDebugLevel$66$start#1:
    goto inline$BDLGetDebugLevel$66$label_3#1;

  inline$BDLGetDebugLevel$66$label_3#1:
    havoc inline$BDLGetDebugLevel$66$myNondetVar_0;
    inline$BDLGetDebugLevel$66$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$66$myNondetVar_0;
    goto inline$BDLGetDebugLevel$66$label_1#1;

  inline$BDLGetDebugLevel$66$label_1#1:
    goto inline$BDLGetDebugLevel$66$Return#1;

  inline$BDLGetDebugLevel$66$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$66$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon39_Then#1, inline$BDLSystemPowerIoCompletion$2$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon7#1;

  inline$BDLSystemPowerIoCompletion$2$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_38#1;

  inline$BDLSystemPowerIoCompletion$2$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_38_true#1, inline$BDLSystemPowerIoCompletion$2$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_39#1;

  inline$BDLSystemPowerIoCompletion$2$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_40#1;

  inline$BDLSystemPowerIoCompletion$2$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_39#1;

  inline$BDLSystemPowerIoCompletion$2$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_39_true#1, inline$BDLSystemPowerIoCompletion$2$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_41#1;

  inline$BDLSystemPowerIoCompletion$2$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$2$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$2$label_107#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$2$label_108#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$2$label_108#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$2$label_108#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$2$label_108#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$2$label_108#1;

  inline$BDLSystemPowerIoCompletion$2$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_109#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$2$label_107#1;

  inline$BDLSystemPowerIoCompletion$2$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_109#1;

  inline$BDLSystemPowerIoCompletion$2$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$2$label_106#1;

  inline$BDLSystemPowerIoCompletion$2$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_106_true#1, inline$BDLSystemPowerIoCompletion$2$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_142#1;

  inline$BDLSystemPowerIoCompletion$2$label_142#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_143#1;

  inline$BDLSystemPowerIoCompletion$2$label_143#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_144#1;

  inline$BDLSystemPowerIoCompletion$2$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_109#1;

  inline$BDLSystemPowerIoCompletion$2$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_109#1;

  inline$BDLSystemPowerIoCompletion$2$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$2$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$2$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$2$myNondetVar_0, inline$BDLSystemPowerIoCompletion$2$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$2$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$2$anon50_Then#1, inline$BDLSystemPowerIoCompletion$2$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon29#1;

  inline$BDLSystemPowerIoCompletion$2$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_112#1;

  inline$BDLSystemPowerIoCompletion$2$label_112#1:
    inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$2$label_113#1;

  inline$BDLSystemPowerIoCompletion$2$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_113_true#1, inline$BDLSystemPowerIoCompletion$2$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$2$label_114#1;

  inline$BDLSystemPowerIoCompletion$2$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_116#1;

  inline$BDLSystemPowerIoCompletion$2$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_117#1;

  inline$BDLSystemPowerIoCompletion$2$label_117#1:
    goto inline$BDLGetDebugLevel$73$Entry#1;

  inline$BDLGetDebugLevel$73$Entry#1:
    goto inline$BDLGetDebugLevel$73$start#1;

  inline$BDLGetDebugLevel$73$start#1:
    goto inline$BDLGetDebugLevel$73$label_3#1;

  inline$BDLGetDebugLevel$73$label_3#1:
    havoc inline$BDLGetDebugLevel$73$myNondetVar_0;
    inline$BDLGetDebugLevel$73$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$73$myNondetVar_0;
    goto inline$BDLGetDebugLevel$73$label_1#1;

  inline$BDLGetDebugLevel$73$label_1#1:
    goto inline$BDLGetDebugLevel$73$Return#1;

  inline$BDLGetDebugLevel$73$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$73$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon51_Then#1, inline$BDLSystemPowerIoCompletion$2$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon31#1;

  inline$BDLSystemPowerIoCompletion$2$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_120#1;

  inline$BDLSystemPowerIoCompletion$2$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_120_true#1, inline$BDLSystemPowerIoCompletion$2$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_121#1;

  inline$BDLSystemPowerIoCompletion$2$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_124#1;

  inline$BDLSystemPowerIoCompletion$2$label_124#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_125#1;

  inline$BDLSystemPowerIoCompletion$2$label_125#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_126#1;

  inline$BDLSystemPowerIoCompletion$2$label_126#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_127#1;

  inline$BDLSystemPowerIoCompletion$2$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$2$label_121#1;

  inline$BDLSystemPowerIoCompletion$2$label_121#1:
    goto inline$BDLGetDebugLevel$74$Entry#1;

  inline$BDLGetDebugLevel$74$Entry#1:
    goto inline$BDLGetDebugLevel$74$start#1;

  inline$BDLGetDebugLevel$74$start#1:
    goto inline$BDLGetDebugLevel$74$label_3#1;

  inline$BDLGetDebugLevel$74$label_3#1:
    havoc inline$BDLGetDebugLevel$74$myNondetVar_0;
    inline$BDLGetDebugLevel$74$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$74$myNondetVar_0;
    goto inline$BDLGetDebugLevel$74$label_1#1;

  inline$BDLGetDebugLevel$74$label_1#1:
    goto inline$BDLGetDebugLevel$74$Return#1;

  inline$BDLGetDebugLevel$74$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$74$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon52_Then#1, inline$BDLSystemPowerIoCompletion$2$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon33#1;

  inline$BDLSystemPowerIoCompletion$2$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_130#1;

  inline$BDLSystemPowerIoCompletion$2$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_130_true#1, inline$BDLSystemPowerIoCompletion$2$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_131#1;

  inline$BDLSystemPowerIoCompletion$2$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_134#1;

  inline$BDLSystemPowerIoCompletion$2$label_134#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_135#1;

  inline$BDLSystemPowerIoCompletion$2$label_135#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_136#1;

  inline$BDLSystemPowerIoCompletion$2$label_136#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_137#1;

  inline$BDLSystemPowerIoCompletion$2$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$2$label_131#1;

  inline$BDLSystemPowerIoCompletion$2$label_131#1:
    goto inline$BDLGetDebugLevel$75$Entry#1;

  inline$BDLGetDebugLevel$75$Entry#1:
    goto inline$BDLGetDebugLevel$75$start#1;

  inline$BDLGetDebugLevel$75$start#1:
    goto inline$BDLGetDebugLevel$75$label_3#1;

  inline$BDLGetDebugLevel$75$label_3#1:
    havoc inline$BDLGetDebugLevel$75$myNondetVar_0;
    inline$BDLGetDebugLevel$75$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$75$myNondetVar_0;
    goto inline$BDLGetDebugLevel$75$label_1#1;

  inline$BDLGetDebugLevel$75$label_1#1:
    goto inline$BDLGetDebugLevel$75$Return#1;

  inline$BDLGetDebugLevel$75$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$75$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon53_Then#1, inline$BDLSystemPowerIoCompletion$2$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon35#1;

  inline$BDLSystemPowerIoCompletion$2$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_140#1;

  inline$BDLSystemPowerIoCompletion$2$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_140_true#1, inline$BDLSystemPowerIoCompletion$2$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_67#1;

  inline$BDLSystemPowerIoCompletion$2$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_141#1;

  inline$BDLSystemPowerIoCompletion$2$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_67#1;

  inline$BDLSystemPowerIoCompletion$2$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$2$label_115#1;

  inline$BDLSystemPowerIoCompletion$2$label_115#1:
    inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$2$label_80#1;

  inline$BDLSystemPowerIoCompletion$2$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$2$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_42#1;

  inline$BDLSystemPowerIoCompletion$2$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$2$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$2$label_43#1;

  inline$BDLSystemPowerIoCompletion$2$label_43#1:
    goto inline$BDLGetDebugLevel$67$Entry#1;

  inline$BDLGetDebugLevel$67$Entry#1:
    goto inline$BDLGetDebugLevel$67$start#1;

  inline$BDLGetDebugLevel$67$start#1:
    goto inline$BDLGetDebugLevel$67$label_3#1;

  inline$BDLGetDebugLevel$67$label_3#1:
    havoc inline$BDLGetDebugLevel$67$myNondetVar_0;
    inline$BDLGetDebugLevel$67$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$67$myNondetVar_0;
    goto inline$BDLGetDebugLevel$67$label_1#1;

  inline$BDLGetDebugLevel$67$label_1#1:
    goto inline$BDLGetDebugLevel$67$Return#1;

  inline$BDLGetDebugLevel$67$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$67$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon40_Then#1, inline$BDLSystemPowerIoCompletion$2$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon9#1;

  inline$BDLSystemPowerIoCompletion$2$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_46#1;

  inline$BDLSystemPowerIoCompletion$2$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_46_true#1, inline$BDLSystemPowerIoCompletion$2$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_47#1;

  inline$BDLSystemPowerIoCompletion$2$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_50#1;

  inline$BDLSystemPowerIoCompletion$2$label_50#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_51#1;

  inline$BDLSystemPowerIoCompletion$2$label_51#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_52#1;

  inline$BDLSystemPowerIoCompletion$2$label_52#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_53#1;

  inline$BDLSystemPowerIoCompletion$2$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$2$label_47#1;

  inline$BDLSystemPowerIoCompletion$2$label_47#1:
    goto inline$BDLGetDebugLevel$68$Entry#1;

  inline$BDLGetDebugLevel$68$Entry#1:
    goto inline$BDLGetDebugLevel$68$start#1;

  inline$BDLGetDebugLevel$68$start#1:
    goto inline$BDLGetDebugLevel$68$label_3#1;

  inline$BDLGetDebugLevel$68$label_3#1:
    havoc inline$BDLGetDebugLevel$68$myNondetVar_0;
    inline$BDLGetDebugLevel$68$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$68$myNondetVar_0;
    goto inline$BDLGetDebugLevel$68$label_1#1;

  inline$BDLGetDebugLevel$68$label_1#1:
    goto inline$BDLGetDebugLevel$68$Return#1;

  inline$BDLGetDebugLevel$68$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$68$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon41_Then#1, inline$BDLSystemPowerIoCompletion$2$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon11#1;

  inline$BDLSystemPowerIoCompletion$2$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_56#1;

  inline$BDLSystemPowerIoCompletion$2$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_56_true#1, inline$BDLSystemPowerIoCompletion$2$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_57#1;

  inline$BDLSystemPowerIoCompletion$2$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_60#1;

  inline$BDLSystemPowerIoCompletion$2$label_60#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_61#1;

  inline$BDLSystemPowerIoCompletion$2$label_61#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_62#1;

  inline$BDLSystemPowerIoCompletion$2$label_62#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_63#1;

  inline$BDLSystemPowerIoCompletion$2$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$2$label_57#1;

  inline$BDLSystemPowerIoCompletion$2$label_57#1:
    goto inline$BDLGetDebugLevel$69$Entry#1;

  inline$BDLGetDebugLevel$69$Entry#1:
    goto inline$BDLGetDebugLevel$69$start#1;

  inline$BDLGetDebugLevel$69$start#1:
    goto inline$BDLGetDebugLevel$69$label_3#1;

  inline$BDLGetDebugLevel$69$label_3#1:
    havoc inline$BDLGetDebugLevel$69$myNondetVar_0;
    inline$BDLGetDebugLevel$69$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$69$myNondetVar_0;
    goto inline$BDLGetDebugLevel$69$label_1#1;

  inline$BDLGetDebugLevel$69$label_1#1:
    goto inline$BDLGetDebugLevel$69$Return#1;

  inline$BDLGetDebugLevel$69$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$69$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon42_Then#1, inline$BDLSystemPowerIoCompletion$2$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon13#1;

  inline$BDLSystemPowerIoCompletion$2$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_66#1;

  inline$BDLSystemPowerIoCompletion$2$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_66_true#1, inline$BDLSystemPowerIoCompletion$2$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_67#1;

  inline$BDLSystemPowerIoCompletion$2$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_70#1;

  inline$BDLSystemPowerIoCompletion$2$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_67#1;

  inline$BDLSystemPowerIoCompletion$2$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$2$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$2$anon43_Then#1, inline$BDLSystemPowerIoCompletion$2$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon15#1;

  inline$BDLSystemPowerIoCompletion$2$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_71#1;

  inline$BDLSystemPowerIoCompletion$2$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$2$anon44_Then#1, inline$BDLSystemPowerIoCompletion$2$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon17#1;

  inline$BDLSystemPowerIoCompletion$2$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_74#1;

  inline$BDLSystemPowerIoCompletion$2$label_74#1:
    goto inline$storm_IoCompleteRequest$6$Entry#1;

  inline$storm_IoCompleteRequest$6$Entry#1:
    inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$2$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$6$start#1;

  inline$storm_IoCompleteRequest$6$start#1:
    inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$6$label_3#1;

  inline$storm_IoCompleteRequest$6$label_3#1:
    call inline$storm_IoCompleteRequest$6$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$6$label_6#1;

  inline$storm_IoCompleteRequest$6$label_6#1:
    goto inline$storm_IoCompleteRequest$6$label_6_true#1, inline$storm_IoCompleteRequest$6$label_6_false#1;

  inline$storm_IoCompleteRequest$6$label_6_false#1:
    assume inline$storm_IoCompleteRequest$6$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$6$label_7#1;

  inline$storm_IoCompleteRequest$6$label_6_true#1:
    assume inline$storm_IoCompleteRequest$6$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$6$label_8#1;

  inline$storm_IoCompleteRequest$6$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$6$anon3_Then#1, inline$storm_IoCompleteRequest$6$anon3_Else#1;

  inline$storm_IoCompleteRequest$6$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$6$anon1#1;

  inline$storm_IoCompleteRequest$6$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$6$label_9#1;

  inline$storm_IoCompleteRequest$6$label_9#1:
    goto inline$storm_IoCompleteRequest$6$label_9_true#1, inline$storm_IoCompleteRequest$6$label_9_false#1;

  inline$storm_IoCompleteRequest$6$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$6$label_10#1;

  inline$storm_IoCompleteRequest$6$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$6$label_1#1;

  inline$storm_IoCompleteRequest$6$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$6$label_7#1;

  inline$storm_IoCompleteRequest$6$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$6$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$6$label_1#1;

  inline$storm_IoCompleteRequest$6$label_1#1:
    goto inline$storm_IoCompleteRequest$6$Return#1;

  inline$storm_IoCompleteRequest$6$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$6$Return#1;

  inline$storm_IoCompleteRequest$6$Return#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon45_Then#1, inline$BDLSystemPowerIoCompletion$2$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon19#1;

  inline$BDLSystemPowerIoCompletion$2$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_77#1;

  inline$BDLSystemPowerIoCompletion$2$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$2$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$2$anon46_Then#1, inline$BDLSystemPowerIoCompletion$2$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon21#1;

  inline$BDLSystemPowerIoCompletion$2$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_80#1;

  inline$BDLSystemPowerIoCompletion$2$label_80#1:
    goto inline$BDLGetDebugLevel$70$Entry#1;

  inline$BDLGetDebugLevel$70$Entry#1:
    goto inline$BDLGetDebugLevel$70$start#1;

  inline$BDLGetDebugLevel$70$start#1:
    goto inline$BDLGetDebugLevel$70$label_3#1;

  inline$BDLGetDebugLevel$70$label_3#1:
    havoc inline$BDLGetDebugLevel$70$myNondetVar_0;
    inline$BDLGetDebugLevel$70$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$70$myNondetVar_0;
    goto inline$BDLGetDebugLevel$70$label_1#1;

  inline$BDLGetDebugLevel$70$label_1#1:
    goto inline$BDLGetDebugLevel$70$Return#1;

  inline$BDLGetDebugLevel$70$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$70$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon47_Then#1, inline$BDLSystemPowerIoCompletion$2$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon23#1;

  inline$BDLSystemPowerIoCompletion$2$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_83#1;

  inline$BDLSystemPowerIoCompletion$2$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_83_true#1, inline$BDLSystemPowerIoCompletion$2$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_84#1;

  inline$BDLSystemPowerIoCompletion$2$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_87#1;

  inline$BDLSystemPowerIoCompletion$2$label_87#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_88#1;

  inline$BDLSystemPowerIoCompletion$2$label_88#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_89#1;

  inline$BDLSystemPowerIoCompletion$2$label_89#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_90#1;

  inline$BDLSystemPowerIoCompletion$2$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$2$label_84#1;

  inline$BDLSystemPowerIoCompletion$2$label_84#1:
    goto inline$BDLGetDebugLevel$71$Entry#1;

  inline$BDLGetDebugLevel$71$Entry#1:
    goto inline$BDLGetDebugLevel$71$start#1;

  inline$BDLGetDebugLevel$71$start#1:
    goto inline$BDLGetDebugLevel$71$label_3#1;

  inline$BDLGetDebugLevel$71$label_3#1:
    havoc inline$BDLGetDebugLevel$71$myNondetVar_0;
    inline$BDLGetDebugLevel$71$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$71$myNondetVar_0;
    goto inline$BDLGetDebugLevel$71$label_1#1;

  inline$BDLGetDebugLevel$71$label_1#1:
    goto inline$BDLGetDebugLevel$71$Return#1;

  inline$BDLGetDebugLevel$71$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$71$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon48_Then#1, inline$BDLSystemPowerIoCompletion$2$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon25#1;

  inline$BDLSystemPowerIoCompletion$2$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_93#1;

  inline$BDLSystemPowerIoCompletion$2$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_93_true#1, inline$BDLSystemPowerIoCompletion$2$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_94#1;

  inline$BDLSystemPowerIoCompletion$2$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_97#1;

  inline$BDLSystemPowerIoCompletion$2$label_97#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_98#1;

  inline$BDLSystemPowerIoCompletion$2$label_98#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_99#1;

  inline$BDLSystemPowerIoCompletion$2$label_99#1:
    call inline$BDLSystemPowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$2$label_100#1;

  inline$BDLSystemPowerIoCompletion$2$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$2$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$2$label_94#1;

  inline$BDLSystemPowerIoCompletion$2$label_94#1:
    goto inline$BDLGetDebugLevel$72$Entry#1;

  inline$BDLGetDebugLevel$72$Entry#1:
    goto inline$BDLGetDebugLevel$72$start#1;

  inline$BDLGetDebugLevel$72$start#1:
    goto inline$BDLGetDebugLevel$72$label_3#1;

  inline$BDLGetDebugLevel$72$label_3#1:
    havoc inline$BDLGetDebugLevel$72$myNondetVar_0;
    inline$BDLGetDebugLevel$72$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$72$myNondetVar_0;
    goto inline$BDLGetDebugLevel$72$label_1#1;

  inline$BDLGetDebugLevel$72$label_1#1:
    goto inline$BDLGetDebugLevel$72$Return#1;

  inline$BDLGetDebugLevel$72$Return#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$72$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$2$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$2$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$2$anon49_Then#1, inline$BDLSystemPowerIoCompletion$2$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$2$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$anon27#1;

  inline$BDLSystemPowerIoCompletion$2$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_103#1;

  inline$BDLSystemPowerIoCompletion$2$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_103_true#1, inline$BDLSystemPowerIoCompletion$2$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$2$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_104#1;

  inline$BDLSystemPowerIoCompletion$2$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$2$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$2$label_105#1;

  inline$BDLSystemPowerIoCompletion$2$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$2$label_104#1;

  inline$BDLSystemPowerIoCompletion$2$label_104#1:
    inline$BDLSystemPowerIoCompletion$2$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$2$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$2$label_1#1;

  inline$BDLSystemPowerIoCompletion$2$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$2$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$2$Return#1;

  inline$BDLSystemPowerIoCompletion$2$Return#1:
    inline$CallCompletionRoutine$2$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$2$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$2$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$2$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$2$anon14_Then#1, inline$CallCompletionRoutine$2$anon14_Else#1;

  inline$CallCompletionRoutine$2$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$2$anon9#1;

  inline$CallCompletionRoutine$2$anon9#1:
    goto inline$CallCompletionRoutine$2$label_20_icall_return#1;

  inline$CallCompletionRoutine$2$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$2$Return#1;

  inline$CallCompletionRoutine$2$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$2$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$2$Entry#1;

  inline$BDLDevicePowerIoCompletion$2$Entry#1:
    inline$BDLDevicePowerIoCompletion$2$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$2$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$2$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$2$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$2$start#1;

  inline$BDLDevicePowerIoCompletion$2$start#1:
    call inline$BDLDevicePowerIoCompletion$2$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$2$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$2$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$2$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$2$label_3#1;

  inline$BDLDevicePowerIoCompletion$2$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_4#1;

  inline$BDLDevicePowerIoCompletion$2$label_4#1:
    inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_5#1;

  inline$BDLDevicePowerIoCompletion$2$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_6#1;

  inline$BDLDevicePowerIoCompletion$2$label_6#1:
    inline$BDLDevicePowerIoCompletion$2$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$2$label_7#1;

  inline$BDLDevicePowerIoCompletion$2$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_8#1;

  inline$BDLDevicePowerIoCompletion$2$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$2$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$2$label_9#1;

  inline$BDLDevicePowerIoCompletion$2$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_10#1;

  inline$BDLDevicePowerIoCompletion$2$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$17$Entry#1;

  inline$IoGetCurrentIrpStackLocation$17$Entry#1:
    inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$17$start#1;

  inline$IoGetCurrentIrpStackLocation$17$start#1:
    inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$17$label_3#1;

  inline$IoGetCurrentIrpStackLocation$17$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$17$label_3_true#1, inline$IoGetCurrentIrpStackLocation$17$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$17$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$17$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$17$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$17$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$17$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$17$label_4#1;

  inline$IoGetCurrentIrpStackLocation$17$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$17$label_6#1;

  inline$IoGetCurrentIrpStackLocation$17$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$17$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$17$label_7#1;

  inline$IoGetCurrentIrpStackLocation$17$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$17$label_5#1;

  inline$IoGetCurrentIrpStackLocation$17$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$17$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$17$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$17$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$17$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$17$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$17$label_5#1;

  inline$IoGetCurrentIrpStackLocation$17$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$17$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$17$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$17$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$17$label_1#1;

  inline$IoGetCurrentIrpStackLocation$17$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$17$Return#1;

  inline$IoGetCurrentIrpStackLocation$17$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$17$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon30_Then#1, inline$BDLDevicePowerIoCompletion$2$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon1#1;

  inline$BDLDevicePowerIoCompletion$2$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_13#1;

  inline$BDLDevicePowerIoCompletion$2$label_13#1:
    inline$BDLDevicePowerIoCompletion$2$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$2$label_14#1;

  inline$BDLDevicePowerIoCompletion$2$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_15#1;

  inline$BDLDevicePowerIoCompletion$2$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$2$label_16#1;

  inline$BDLDevicePowerIoCompletion$2$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_17#1;

  inline$BDLDevicePowerIoCompletion$2$label_17#1:
    goto inline$BDLGetDebugLevel$55$Entry#1;

  inline$BDLGetDebugLevel$55$Entry#1:
    goto inline$BDLGetDebugLevel$55$start#1;

  inline$BDLGetDebugLevel$55$start#1:
    goto inline$BDLGetDebugLevel$55$label_3#1;

  inline$BDLGetDebugLevel$55$label_3#1:
    havoc inline$BDLGetDebugLevel$55$myNondetVar_0;
    inline$BDLGetDebugLevel$55$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$55$myNondetVar_0;
    goto inline$BDLGetDebugLevel$55$label_1#1;

  inline$BDLGetDebugLevel$55$label_1#1:
    goto inline$BDLGetDebugLevel$55$Return#1;

  inline$BDLGetDebugLevel$55$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$55$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon31_Then#1, inline$BDLDevicePowerIoCompletion$2$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon3#1;

  inline$BDLDevicePowerIoCompletion$2$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_20#1;

  inline$BDLDevicePowerIoCompletion$2$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_20_true#1, inline$BDLDevicePowerIoCompletion$2$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_21#1;

  inline$BDLDevicePowerIoCompletion$2$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_24#1;

  inline$BDLDevicePowerIoCompletion$2$label_24#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_25#1;

  inline$BDLDevicePowerIoCompletion$2$label_25#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_26#1;

  inline$BDLDevicePowerIoCompletion$2$label_26#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_27#1;

  inline$BDLDevicePowerIoCompletion$2$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$2$label_21#1;

  inline$BDLDevicePowerIoCompletion$2$label_21#1:
    goto inline$BDLGetDebugLevel$56$Entry#1;

  inline$BDLGetDebugLevel$56$Entry#1:
    goto inline$BDLGetDebugLevel$56$start#1;

  inline$BDLGetDebugLevel$56$start#1:
    goto inline$BDLGetDebugLevel$56$label_3#1;

  inline$BDLGetDebugLevel$56$label_3#1:
    havoc inline$BDLGetDebugLevel$56$myNondetVar_0;
    inline$BDLGetDebugLevel$56$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$56$myNondetVar_0;
    goto inline$BDLGetDebugLevel$56$label_1#1;

  inline$BDLGetDebugLevel$56$label_1#1:
    goto inline$BDLGetDebugLevel$56$Return#1;

  inline$BDLGetDebugLevel$56$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$56$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon32_Then#1, inline$BDLDevicePowerIoCompletion$2$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon5#1;

  inline$BDLDevicePowerIoCompletion$2$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_30#1;

  inline$BDLDevicePowerIoCompletion$2$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_30_true#1, inline$BDLDevicePowerIoCompletion$2$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_31#1;

  inline$BDLDevicePowerIoCompletion$2$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_34#1;

  inline$BDLDevicePowerIoCompletion$2$label_34#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_35#1;

  inline$BDLDevicePowerIoCompletion$2$label_35#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_36#1;

  inline$BDLDevicePowerIoCompletion$2$label_36#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_37#1;

  inline$BDLDevicePowerIoCompletion$2$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$2$label_31#1;

  inline$BDLDevicePowerIoCompletion$2$label_31#1:
    goto inline$BDLGetDebugLevel$57$Entry#1;

  inline$BDLGetDebugLevel$57$Entry#1:
    goto inline$BDLGetDebugLevel$57$start#1;

  inline$BDLGetDebugLevel$57$start#1:
    goto inline$BDLGetDebugLevel$57$label_3#1;

  inline$BDLGetDebugLevel$57$label_3#1:
    havoc inline$BDLGetDebugLevel$57$myNondetVar_0;
    inline$BDLGetDebugLevel$57$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$57$myNondetVar_0;
    goto inline$BDLGetDebugLevel$57$label_1#1;

  inline$BDLGetDebugLevel$57$label_1#1:
    goto inline$BDLGetDebugLevel$57$Return#1;

  inline$BDLGetDebugLevel$57$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$57$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon33_Then#1, inline$BDLDevicePowerIoCompletion$2$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon7#1;

  inline$BDLDevicePowerIoCompletion$2$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_40#1;

  inline$BDLDevicePowerIoCompletion$2$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_40_true#1, inline$BDLDevicePowerIoCompletion$2$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_41#1;

  inline$BDLDevicePowerIoCompletion$2$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_42#1;

  inline$BDLDevicePowerIoCompletion$2$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_41#1;

  inline$BDLDevicePowerIoCompletion$2$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_41_true#1, inline$BDLDevicePowerIoCompletion$2$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$2$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$2$label_43#1;

  inline$BDLDevicePowerIoCompletion$2$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$2$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$2$label_44#1;

  inline$BDLDevicePowerIoCompletion$2$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_44_true#1, inline$BDLDevicePowerIoCompletion$2$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$2$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$2$label_45#1;

  inline$BDLDevicePowerIoCompletion$2$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_45_true#1, inline$BDLDevicePowerIoCompletion$2$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$2$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$2$label_43#1;

  inline$BDLDevicePowerIoCompletion$2$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$2$label_86#1;

  inline$BDLDevicePowerIoCompletion$2$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$2$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$2$label_46#1;

  inline$BDLDevicePowerIoCompletion$2$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$2$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$2$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$2$label_46#1;

  inline$BDLDevicePowerIoCompletion$2$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$2$label_49#1;

  inline$BDLDevicePowerIoCompletion$2$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_50#1;

  inline$BDLDevicePowerIoCompletion$2$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_51#1;

  inline$BDLDevicePowerIoCompletion$2$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_54#1;

  inline$BDLDevicePowerIoCompletion$2$label_54#1:
    inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$2$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$2$label_55#1;

  inline$BDLDevicePowerIoCompletion$2$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_55_true#1, inline$BDLDevicePowerIoCompletion$2$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_56#1;

  inline$BDLDevicePowerIoCompletion$2$label_56#1:
    call inline$BDLDevicePowerIoCompletion$2$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$2$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$2$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$2$anon34_Then#1, inline$BDLDevicePowerIoCompletion$2$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon9#1;

  inline$BDLDevicePowerIoCompletion$2$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_83#1;

  inline$BDLDevicePowerIoCompletion$2$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_59#1;

  inline$BDLDevicePowerIoCompletion$2$label_59#1:
    goto inline$BDLGetDebugLevel$58$Entry#1;

  inline$BDLGetDebugLevel$58$Entry#1:
    goto inline$BDLGetDebugLevel$58$start#1;

  inline$BDLGetDebugLevel$58$start#1:
    goto inline$BDLGetDebugLevel$58$label_3#1;

  inline$BDLGetDebugLevel$58$label_3#1:
    havoc inline$BDLGetDebugLevel$58$myNondetVar_0;
    inline$BDLGetDebugLevel$58$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$58$myNondetVar_0;
    goto inline$BDLGetDebugLevel$58$label_1#1;

  inline$BDLGetDebugLevel$58$label_1#1:
    goto inline$BDLGetDebugLevel$58$Return#1;

  inline$BDLGetDebugLevel$58$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$58$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon35_Then#1, inline$BDLDevicePowerIoCompletion$2$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon11#1;

  inline$BDLDevicePowerIoCompletion$2$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_62#1;

  inline$BDLDevicePowerIoCompletion$2$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_62_true#1, inline$BDLDevicePowerIoCompletion$2$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_63#1;

  inline$BDLDevicePowerIoCompletion$2$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_66#1;

  inline$BDLDevicePowerIoCompletion$2$label_66#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_67#1;

  inline$BDLDevicePowerIoCompletion$2$label_67#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_68#1;

  inline$BDLDevicePowerIoCompletion$2$label_68#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_69#1;

  inline$BDLDevicePowerIoCompletion$2$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$2$label_63#1;

  inline$BDLDevicePowerIoCompletion$2$label_63#1:
    goto inline$BDLGetDebugLevel$59$Entry#1;

  inline$BDLGetDebugLevel$59$Entry#1:
    goto inline$BDLGetDebugLevel$59$start#1;

  inline$BDLGetDebugLevel$59$start#1:
    goto inline$BDLGetDebugLevel$59$label_3#1;

  inline$BDLGetDebugLevel$59$label_3#1:
    havoc inline$BDLGetDebugLevel$59$myNondetVar_0;
    inline$BDLGetDebugLevel$59$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$59$myNondetVar_0;
    goto inline$BDLGetDebugLevel$59$label_1#1;

  inline$BDLGetDebugLevel$59$label_1#1:
    goto inline$BDLGetDebugLevel$59$Return#1;

  inline$BDLGetDebugLevel$59$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$59$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon36_Then#1, inline$BDLDevicePowerIoCompletion$2$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon13#1;

  inline$BDLDevicePowerIoCompletion$2$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_72#1;

  inline$BDLDevicePowerIoCompletion$2$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_72_true#1, inline$BDLDevicePowerIoCompletion$2$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_73#1;

  inline$BDLDevicePowerIoCompletion$2$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_76#1;

  inline$BDLDevicePowerIoCompletion$2$label_76#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_77#1;

  inline$BDLDevicePowerIoCompletion$2$label_77#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_78#1;

  inline$BDLDevicePowerIoCompletion$2$label_78#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_79#1;

  inline$BDLDevicePowerIoCompletion$2$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$2$label_73#1;

  inline$BDLDevicePowerIoCompletion$2$label_73#1:
    goto inline$BDLGetDebugLevel$60$Entry#1;

  inline$BDLGetDebugLevel$60$Entry#1:
    goto inline$BDLGetDebugLevel$60$start#1;

  inline$BDLGetDebugLevel$60$start#1:
    goto inline$BDLGetDebugLevel$60$label_3#1;

  inline$BDLGetDebugLevel$60$label_3#1:
    havoc inline$BDLGetDebugLevel$60$myNondetVar_0;
    inline$BDLGetDebugLevel$60$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$60$myNondetVar_0;
    goto inline$BDLGetDebugLevel$60$label_1#1;

  inline$BDLGetDebugLevel$60$label_1#1:
    goto inline$BDLGetDebugLevel$60$Return#1;

  inline$BDLGetDebugLevel$60$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$60$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon37_Then#1, inline$BDLDevicePowerIoCompletion$2$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon15#1;

  inline$BDLDevicePowerIoCompletion$2$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_82#1;

  inline$BDLDevicePowerIoCompletion$2$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_82_true#1, inline$BDLDevicePowerIoCompletion$2$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_83#1;

  inline$BDLDevicePowerIoCompletion$2$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_84#1;

  inline$BDLDevicePowerIoCompletion$2$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_83#1;

  inline$BDLDevicePowerIoCompletion$2$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_85#1;

  inline$BDLDevicePowerIoCompletion$2$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_86#1;

  inline$BDLDevicePowerIoCompletion$2$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$2$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$2$anon38_Then#1, inline$BDLDevicePowerIoCompletion$2$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon17#1;

  inline$BDLDevicePowerIoCompletion$2$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_89#1;

  inline$BDLDevicePowerIoCompletion$2$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$2$anon39_Then#1, inline$BDLDevicePowerIoCompletion$2$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon19#1;

  inline$BDLDevicePowerIoCompletion$2$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_92#1;

  inline$BDLDevicePowerIoCompletion$2$label_92#1:
    goto inline$storm_IoCompleteRequest$5$Entry#1;

  inline$storm_IoCompleteRequest$5$Entry#1:
    inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$2$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$5$start#1;

  inline$storm_IoCompleteRequest$5$start#1:
    inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$5$label_3#1;

  inline$storm_IoCompleteRequest$5$label_3#1:
    call inline$storm_IoCompleteRequest$5$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$5$label_6#1;

  inline$storm_IoCompleteRequest$5$label_6#1:
    goto inline$storm_IoCompleteRequest$5$label_6_true#1, inline$storm_IoCompleteRequest$5$label_6_false#1;

  inline$storm_IoCompleteRequest$5$label_6_false#1:
    assume inline$storm_IoCompleteRequest$5$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$5$label_7#1;

  inline$storm_IoCompleteRequest$5$label_6_true#1:
    assume inline$storm_IoCompleteRequest$5$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$5$label_8#1;

  inline$storm_IoCompleteRequest$5$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$5$anon3_Then#1, inline$storm_IoCompleteRequest$5$anon3_Else#1;

  inline$storm_IoCompleteRequest$5$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$5$anon1#1;

  inline$storm_IoCompleteRequest$5$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$5$label_9#1;

  inline$storm_IoCompleteRequest$5$label_9#1:
    goto inline$storm_IoCompleteRequest$5$label_9_true#1, inline$storm_IoCompleteRequest$5$label_9_false#1;

  inline$storm_IoCompleteRequest$5$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$5$label_10#1;

  inline$storm_IoCompleteRequest$5$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$5$label_1#1;

  inline$storm_IoCompleteRequest$5$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$5$label_7#1;

  inline$storm_IoCompleteRequest$5$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$5$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$5$label_1#1;

  inline$storm_IoCompleteRequest$5$label_1#1:
    goto inline$storm_IoCompleteRequest$5$Return#1;

  inline$storm_IoCompleteRequest$5$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$5$Return#1;

  inline$storm_IoCompleteRequest$5$Return#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon40_Then#1, inline$BDLDevicePowerIoCompletion$2$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon21#1;

  inline$BDLDevicePowerIoCompletion$2$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_95#1;

  inline$BDLDevicePowerIoCompletion$2$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$2$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$2$anon41_Then#1, inline$BDLDevicePowerIoCompletion$2$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon23#1;

  inline$BDLDevicePowerIoCompletion$2$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_98#1;

  inline$BDLDevicePowerIoCompletion$2$label_98#1:
    goto inline$BDLGetDebugLevel$61$Entry#1;

  inline$BDLGetDebugLevel$61$Entry#1:
    goto inline$BDLGetDebugLevel$61$start#1;

  inline$BDLGetDebugLevel$61$start#1:
    goto inline$BDLGetDebugLevel$61$label_3#1;

  inline$BDLGetDebugLevel$61$label_3#1:
    havoc inline$BDLGetDebugLevel$61$myNondetVar_0;
    inline$BDLGetDebugLevel$61$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$61$myNondetVar_0;
    goto inline$BDLGetDebugLevel$61$label_1#1;

  inline$BDLGetDebugLevel$61$label_1#1:
    goto inline$BDLGetDebugLevel$61$Return#1;

  inline$BDLGetDebugLevel$61$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$61$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon42_Then#1, inline$BDLDevicePowerIoCompletion$2$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon25#1;

  inline$BDLDevicePowerIoCompletion$2$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_101#1;

  inline$BDLDevicePowerIoCompletion$2$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_101_true#1, inline$BDLDevicePowerIoCompletion$2$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_102#1;

  inline$BDLDevicePowerIoCompletion$2$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_105#1;

  inline$BDLDevicePowerIoCompletion$2$label_105#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_106#1;

  inline$BDLDevicePowerIoCompletion$2$label_106#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_107#1;

  inline$BDLDevicePowerIoCompletion$2$label_107#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_108#1;

  inline$BDLDevicePowerIoCompletion$2$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$2$label_102#1;

  inline$BDLDevicePowerIoCompletion$2$label_102#1:
    goto inline$BDLGetDebugLevel$62$Entry#1;

  inline$BDLGetDebugLevel$62$Entry#1:
    goto inline$BDLGetDebugLevel$62$start#1;

  inline$BDLGetDebugLevel$62$start#1:
    goto inline$BDLGetDebugLevel$62$label_3#1;

  inline$BDLGetDebugLevel$62$label_3#1:
    havoc inline$BDLGetDebugLevel$62$myNondetVar_0;
    inline$BDLGetDebugLevel$62$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$62$myNondetVar_0;
    goto inline$BDLGetDebugLevel$62$label_1#1;

  inline$BDLGetDebugLevel$62$label_1#1:
    goto inline$BDLGetDebugLevel$62$Return#1;

  inline$BDLGetDebugLevel$62$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$62$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon43_Then#1, inline$BDLDevicePowerIoCompletion$2$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon27#1;

  inline$BDLDevicePowerIoCompletion$2$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_111#1;

  inline$BDLDevicePowerIoCompletion$2$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_111_true#1, inline$BDLDevicePowerIoCompletion$2$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_112#1;

  inline$BDLDevicePowerIoCompletion$2$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_115#1;

  inline$BDLDevicePowerIoCompletion$2$label_115#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_116#1;

  inline$BDLDevicePowerIoCompletion$2$label_116#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_117#1;

  inline$BDLDevicePowerIoCompletion$2$label_117#1:
    call inline$BDLDevicePowerIoCompletion$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$2$label_118#1;

  inline$BDLDevicePowerIoCompletion$2$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$2$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$2$label_112#1;

  inline$BDLDevicePowerIoCompletion$2$label_112#1:
    goto inline$BDLGetDebugLevel$63$Entry#1;

  inline$BDLGetDebugLevel$63$Entry#1:
    goto inline$BDLGetDebugLevel$63$start#1;

  inline$BDLGetDebugLevel$63$start#1:
    goto inline$BDLGetDebugLevel$63$label_3#1;

  inline$BDLGetDebugLevel$63$label_3#1:
    havoc inline$BDLGetDebugLevel$63$myNondetVar_0;
    inline$BDLGetDebugLevel$63$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$63$myNondetVar_0;
    goto inline$BDLGetDebugLevel$63$label_1#1;

  inline$BDLGetDebugLevel$63$label_1#1:
    goto inline$BDLGetDebugLevel$63$Return#1;

  inline$BDLGetDebugLevel$63$Return#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$63$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$2$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$2$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$2$anon44_Then#1, inline$BDLDevicePowerIoCompletion$2$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$2$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$anon29#1;

  inline$BDLDevicePowerIoCompletion$2$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_121#1;

  inline$BDLDevicePowerIoCompletion$2$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_121_true#1, inline$BDLDevicePowerIoCompletion$2$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$2$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_122#1;

  inline$BDLDevicePowerIoCompletion$2$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$2$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$2$label_123#1;

  inline$BDLDevicePowerIoCompletion$2$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$2$label_122#1;

  inline$BDLDevicePowerIoCompletion$2$label_122#1:
    inline$BDLDevicePowerIoCompletion$2$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$2$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$2$label_1#1;

  inline$BDLDevicePowerIoCompletion$2$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$2$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$2$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$2$Return#1;

  inline$BDLDevicePowerIoCompletion$2$Return#1:
    inline$CallCompletionRoutine$2$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$2$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$2$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$2$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$2$anon13_Then#1, inline$CallCompletionRoutine$2$anon13_Else#1;

  inline$CallCompletionRoutine$2$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$2$anon7#1;

  inline$CallCompletionRoutine$2$anon7#1:
    goto inline$CallCompletionRoutine$2$label_20_icall_return#1;

  inline$CallCompletionRoutine$2$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$2$Return#1;

  inline$CallCompletionRoutine$2$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$2$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$2$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$2$Entry#1;

  inline$BDLCallDriverCompletionRoutine$2$Entry#1:
    inline$BDLCallDriverCompletionRoutine$2$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$2$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$2$start#1;

  inline$BDLCallDriverCompletionRoutine$2$start#1:
    inline$BDLCallDriverCompletionRoutine$2$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$2$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$2$label_3#1;

  inline$BDLCallDriverCompletionRoutine$2$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$2$label_3_true#1, inline$BDLCallDriverCompletionRoutine$2$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$2$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$2$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$2$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$2$label_4#1;

  inline$BDLCallDriverCompletionRoutine$2$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$2$label_6#1;

  inline$BDLCallDriverCompletionRoutine$2$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$2$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$2$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$2$label_5#1;

  inline$BDLCallDriverCompletionRoutine$2$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$2$label_6#1;

  inline$BDLCallDriverCompletionRoutine$2$label_6#1:
    goto inline$storm_KeSetEvent$2$Entry#1;

  inline$storm_KeSetEvent$2$Entry#1:
    inline$storm_KeSetEvent$2$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$2$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$2$start#1;

  inline$storm_KeSetEvent$2$start#1:
    inline$storm_KeSetEvent$2$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$2$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$2$label_3#1;

  inline$storm_KeSetEvent$2$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$2$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$2$label_1#1;

  inline$storm_KeSetEvent$2$label_1#1:
    goto inline$storm_KeSetEvent$2$Return#1;

  inline$storm_KeSetEvent$2$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$2$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$2$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$2$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$2$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$2$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$2$anon1#1;

  inline$BDLCallDriverCompletionRoutine$2$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$2$label_9#1;

  inline$BDLCallDriverCompletionRoutine$2$label_9#1:
    inline$BDLCallDriverCompletionRoutine$2$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$2$label_1#1;

  inline$BDLCallDriverCompletionRoutine$2$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$2$Return#1;

  inline$BDLCallDriverCompletionRoutine$2$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$2$Return#1;

  inline$BDLCallDriverCompletionRoutine$2$Return#1:
    inline$CallCompletionRoutine$2$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$2$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$2$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$2$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$2$anon12_Then#1, inline$CallCompletionRoutine$2$anon12_Else#1;

  inline$CallCompletionRoutine$2$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$2$anon5#1;

  inline$CallCompletionRoutine$2$anon5#1:
    goto inline$CallCompletionRoutine$2$label_20_icall_return#1;

  inline$CallCompletionRoutine$2$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$2$label_23#1;

  inline$CallCompletionRoutine$2$label_23#1:
    inline$CallCompletionRoutine$2$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$2$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$2$label_24#1;

  inline$CallCompletionRoutine$2$label_24#1:
    goto inline$CallCompletionRoutine$2$label_24_true#1, inline$CallCompletionRoutine$2$label_24_false#1;

  inline$CallCompletionRoutine$2$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$2$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$2$label_1#1;

  inline$CallCompletionRoutine$2$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$2$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$2$label_25#1;

  inline$CallCompletionRoutine$2$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$2$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$2$label_1#1;

  inline$CallCompletionRoutine$2$label_1#1:
    goto inline$CallCompletionRoutine$2$Return#1;

  inline$CallCompletionRoutine$2$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$2$Return#1;

  inline$CallCompletionRoutine$2$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$2$Return#1;

  inline$CallCompletionRoutine$2$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$2$Return#1;

  inline$CallCompletionRoutine$2$Return#1:
    goto inline$storm_IoCallDriver$1$label_33$1#1;

  inline$storm_IoCallDriver$1$label_33$1#1:
    goto inline$storm_IoCallDriver$1$anon14_Then#1, inline$storm_IoCallDriver$1$anon14_Else#1;

  inline$storm_IoCallDriver$1$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$1$anon8#1;

  inline$storm_IoCallDriver$1$anon8#1:
    goto inline$storm_IoCallDriver$1$label_36#1;

  inline$storm_IoCallDriver$1$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$1$Return#1;

  inline$storm_IoCallDriver$1$label_27_case_1#1:
    assume inline$storm_IoCallDriver$1$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$1$label_29#1;

  inline$storm_IoCallDriver$1$label_29#1:
    inline$storm_IoCallDriver$1$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$1$label_37#1;

  inline$storm_IoCallDriver$1$label_37#1:
    goto inline$storm_IoCallDriver$1$label_38#1;

  inline$storm_IoCallDriver$1$label_38#1:
    goto inline$storm_IoCallDriver$1$label_39#1;

  inline$storm_IoCallDriver$1$label_39#1:
    goto inline$CallCompletionRoutine$3$Entry#1;

  inline$CallCompletionRoutine$3$Entry#1:
    inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$3$start#1;

  inline$CallCompletionRoutine$3$start#1:
    inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$3$label_3#1;

  inline$CallCompletionRoutine$3$label_3#1:
    goto inline$CallCompletionRoutine$3$label_4#1;

  inline$CallCompletionRoutine$3$label_4#1:
    goto inline$CallCompletionRoutine$3$label_5#1;

  inline$CallCompletionRoutine$3$label_5#1:
    goto inline$CallCompletionRoutine$3$label_6#1;

  inline$CallCompletionRoutine$3$label_6#1:
    goto inline$CallCompletionRoutine$3$label_7#1;

  inline$CallCompletionRoutine$3$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$19$Entry#1;

  inline$IoGetCurrentIrpStackLocation$19$Entry#1:
    inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$19$start#1;

  inline$IoGetCurrentIrpStackLocation$19$start#1:
    inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$19$label_3#1;

  inline$IoGetCurrentIrpStackLocation$19$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$19$label_3_true#1, inline$IoGetCurrentIrpStackLocation$19$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$19$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$19$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$19$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$19$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$19$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$19$label_4#1;

  inline$IoGetCurrentIrpStackLocation$19$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$19$label_6#1;

  inline$IoGetCurrentIrpStackLocation$19$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$19$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$19$label_7#1;

  inline$IoGetCurrentIrpStackLocation$19$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$19$label_5#1;

  inline$IoGetCurrentIrpStackLocation$19$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$19$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$19$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$19$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$19$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$19$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$19$label_5#1;

  inline$IoGetCurrentIrpStackLocation$19$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$19$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$19$label_1#1;

  inline$IoGetCurrentIrpStackLocation$19$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$19$Return#1;

  inline$IoGetCurrentIrpStackLocation$19$Return#1:
    goto inline$CallCompletionRoutine$3$label_7$1#1;

  inline$CallCompletionRoutine$3$label_7$1#1:
    goto inline$CallCompletionRoutine$3$anon10_Then#1, inline$CallCompletionRoutine$3$anon10_Else#1;

  inline$CallCompletionRoutine$3$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$3$anon1#1;

  inline$CallCompletionRoutine$3$anon1#1:
    goto inline$CallCompletionRoutine$3$label_10#1;

  inline$CallCompletionRoutine$3$label_10#1:
    goto inline$CallCompletionRoutine$3$label_11#1;

  inline$CallCompletionRoutine$3$label_11#1:
    havoc inline$CallCompletionRoutine$3$myNondetVar_0;
    inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$3$myNondetVar_0;
    goto inline$CallCompletionRoutine$3$label_12#1;

  inline$CallCompletionRoutine$3$label_12#1:
    havoc inline$CallCompletionRoutine$3$myNondetVar_0;
    inline$CallCompletionRoutine$3$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$3$myNondetVar_0;
    goto inline$CallCompletionRoutine$3$label_13#1;

  inline$CallCompletionRoutine$3$label_13#1:
    havoc inline$CallCompletionRoutine$3$myNondetVar_0;
    goto inline$CallCompletionRoutine$3$label_14#1;

  inline$CallCompletionRoutine$3$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$20$Entry#1;

  inline$IoGetCurrentIrpStackLocation$20$Entry#1:
    inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$20$start#1;

  inline$IoGetCurrentIrpStackLocation$20$start#1:
    inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$20$label_3#1;

  inline$IoGetCurrentIrpStackLocation$20$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$20$label_3_true#1, inline$IoGetCurrentIrpStackLocation$20$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$20$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$20$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$20$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$20$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$20$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$20$label_4#1;

  inline$IoGetCurrentIrpStackLocation$20$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$20$label_6#1;

  inline$IoGetCurrentIrpStackLocation$20$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$20$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$20$label_7#1;

  inline$IoGetCurrentIrpStackLocation$20$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$20$label_5#1;

  inline$IoGetCurrentIrpStackLocation$20$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$20$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$20$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$20$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$20$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$20$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$20$label_5#1;

  inline$IoGetCurrentIrpStackLocation$20$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$20$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$20$label_1#1;

  inline$IoGetCurrentIrpStackLocation$20$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$20$Return#1;

  inline$IoGetCurrentIrpStackLocation$20$Return#1:
    goto inline$CallCompletionRoutine$3$label_14$1#1;

  inline$CallCompletionRoutine$3$label_14$1#1:
    goto inline$CallCompletionRoutine$3$anon11_Then#1, inline$CallCompletionRoutine$3$anon11_Else#1;

  inline$CallCompletionRoutine$3$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$3$anon3#1;

  inline$CallCompletionRoutine$3$anon3#1:
    goto inline$CallCompletionRoutine$3$label_17#1;

  inline$CallCompletionRoutine$3$label_17#1:
    goto inline$CallCompletionRoutine$3$label_18#1;

  inline$CallCompletionRoutine$3$label_18#1:
    goto inline$CallCompletionRoutine$3$label_18_true#1, inline$CallCompletionRoutine$3$label_18_false#1;

  inline$CallCompletionRoutine$3$label_18_false#1:
    assume inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$3$label_1#1;

  inline$CallCompletionRoutine$3$label_18_true#1:
    assume inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$3$label_19#1;

  inline$CallCompletionRoutine$3$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$3$label_20#1;

  inline$CallCompletionRoutine$3$label_20#1:
    goto inline$CallCompletionRoutine$3$label_20_icall_1#1, inline$CallCompletionRoutine$3$label_20_icall_2#1, inline$CallCompletionRoutine$3$label_20_icall_3#1;

  inline$CallCompletionRoutine$3$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$3$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$3$Entry#1;

  inline$BDLSystemPowerIoCompletion$3$Entry#1:
    inline$BDLSystemPowerIoCompletion$3$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$3$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$3$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$3$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$3$start#1;

  inline$BDLSystemPowerIoCompletion$3$start#1:
    call inline$BDLSystemPowerIoCompletion$3$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$3$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$3$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$3$label_3#1;

  inline$BDLSystemPowerIoCompletion$3$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_4#1;

  inline$BDLSystemPowerIoCompletion$3$label_4#1:
    inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_5#1;

  inline$BDLSystemPowerIoCompletion$3$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_6#1;

  inline$BDLSystemPowerIoCompletion$3$label_6#1:
    inline$BDLSystemPowerIoCompletion$3$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$3$label_7#1;

  inline$BDLSystemPowerIoCompletion$3$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_8#1;

  inline$BDLSystemPowerIoCompletion$3$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$3$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$3$label_9#1;

  inline$BDLSystemPowerIoCompletion$3$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_10#1;

  inline$BDLSystemPowerIoCompletion$3$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$22$Entry#1;

  inline$IoGetCurrentIrpStackLocation$22$Entry#1:
    inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$22$start#1;

  inline$IoGetCurrentIrpStackLocation$22$start#1:
    inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$22$label_3#1;

  inline$IoGetCurrentIrpStackLocation$22$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$22$label_3_true#1, inline$IoGetCurrentIrpStackLocation$22$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$22$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$22$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$22$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$22$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$22$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$22$label_4#1;

  inline$IoGetCurrentIrpStackLocation$22$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$22$label_6#1;

  inline$IoGetCurrentIrpStackLocation$22$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$22$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$22$label_7#1;

  inline$IoGetCurrentIrpStackLocation$22$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$22$label_5#1;

  inline$IoGetCurrentIrpStackLocation$22$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$22$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$22$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$22$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$22$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$22$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$22$label_5#1;

  inline$IoGetCurrentIrpStackLocation$22$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$22$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$22$label_1#1;

  inline$IoGetCurrentIrpStackLocation$22$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$22$Return#1;

  inline$IoGetCurrentIrpStackLocation$22$Return#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon36_Then#1, inline$BDLSystemPowerIoCompletion$3$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon1#1;

  inline$BDLSystemPowerIoCompletion$3$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_13#1;

  inline$BDLSystemPowerIoCompletion$3$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_14#1;

  inline$BDLSystemPowerIoCompletion$3$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_15#1;

  inline$BDLSystemPowerIoCompletion$3$label_15#1:
    goto inline$BDLGetDebugLevel$85$Entry#1;

  inline$BDLGetDebugLevel$85$Entry#1:
    goto inline$BDLGetDebugLevel$85$start#1;

  inline$BDLGetDebugLevel$85$start#1:
    goto inline$BDLGetDebugLevel$85$label_3#1;

  inline$BDLGetDebugLevel$85$label_3#1:
    havoc inline$BDLGetDebugLevel$85$myNondetVar_0;
    inline$BDLGetDebugLevel$85$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$85$myNondetVar_0;
    goto inline$BDLGetDebugLevel$85$label_1#1;

  inline$BDLGetDebugLevel$85$label_1#1:
    goto inline$BDLGetDebugLevel$85$Return#1;

  inline$BDLGetDebugLevel$85$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$85$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon37_Then#1, inline$BDLSystemPowerIoCompletion$3$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon3#1;

  inline$BDLSystemPowerIoCompletion$3$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_18#1;

  inline$BDLSystemPowerIoCompletion$3$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_18_true#1, inline$BDLSystemPowerIoCompletion$3$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_19#1;

  inline$BDLSystemPowerIoCompletion$3$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_22#1;

  inline$BDLSystemPowerIoCompletion$3$label_22#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_23#1;

  inline$BDLSystemPowerIoCompletion$3$label_23#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_24#1;

  inline$BDLSystemPowerIoCompletion$3$label_24#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_25#1;

  inline$BDLSystemPowerIoCompletion$3$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$3$label_19#1;

  inline$BDLSystemPowerIoCompletion$3$label_19#1:
    goto inline$BDLGetDebugLevel$86$Entry#1;

  inline$BDLGetDebugLevel$86$Entry#1:
    goto inline$BDLGetDebugLevel$86$start#1;

  inline$BDLGetDebugLevel$86$start#1:
    goto inline$BDLGetDebugLevel$86$label_3#1;

  inline$BDLGetDebugLevel$86$label_3#1:
    havoc inline$BDLGetDebugLevel$86$myNondetVar_0;
    inline$BDLGetDebugLevel$86$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$86$myNondetVar_0;
    goto inline$BDLGetDebugLevel$86$label_1#1;

  inline$BDLGetDebugLevel$86$label_1#1:
    goto inline$BDLGetDebugLevel$86$Return#1;

  inline$BDLGetDebugLevel$86$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$86$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon38_Then#1, inline$BDLSystemPowerIoCompletion$3$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon5#1;

  inline$BDLSystemPowerIoCompletion$3$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_28#1;

  inline$BDLSystemPowerIoCompletion$3$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_28_true#1, inline$BDLSystemPowerIoCompletion$3$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_29#1;

  inline$BDLSystemPowerIoCompletion$3$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_32#1;

  inline$BDLSystemPowerIoCompletion$3$label_32#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_33#1;

  inline$BDLSystemPowerIoCompletion$3$label_33#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_34#1;

  inline$BDLSystemPowerIoCompletion$3$label_34#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_35#1;

  inline$BDLSystemPowerIoCompletion$3$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$3$label_29#1;

  inline$BDLSystemPowerIoCompletion$3$label_29#1:
    goto inline$BDLGetDebugLevel$87$Entry#1;

  inline$BDLGetDebugLevel$87$Entry#1:
    goto inline$BDLGetDebugLevel$87$start#1;

  inline$BDLGetDebugLevel$87$start#1:
    goto inline$BDLGetDebugLevel$87$label_3#1;

  inline$BDLGetDebugLevel$87$label_3#1:
    havoc inline$BDLGetDebugLevel$87$myNondetVar_0;
    inline$BDLGetDebugLevel$87$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$87$myNondetVar_0;
    goto inline$BDLGetDebugLevel$87$label_1#1;

  inline$BDLGetDebugLevel$87$label_1#1:
    goto inline$BDLGetDebugLevel$87$Return#1;

  inline$BDLGetDebugLevel$87$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$87$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon39_Then#1, inline$BDLSystemPowerIoCompletion$3$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon7#1;

  inline$BDLSystemPowerIoCompletion$3$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_38#1;

  inline$BDLSystemPowerIoCompletion$3$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_38_true#1, inline$BDLSystemPowerIoCompletion$3$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_39#1;

  inline$BDLSystemPowerIoCompletion$3$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_40#1;

  inline$BDLSystemPowerIoCompletion$3$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_39#1;

  inline$BDLSystemPowerIoCompletion$3$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_39_true#1, inline$BDLSystemPowerIoCompletion$3$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_41#1;

  inline$BDLSystemPowerIoCompletion$3$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$3$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$3$label_107#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$3$label_108#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$3$label_108#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$3$label_108#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$3$label_108#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$3$label_108#1;

  inline$BDLSystemPowerIoCompletion$3$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_109#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$3$label_107#1;

  inline$BDLSystemPowerIoCompletion$3$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_109#1;

  inline$BDLSystemPowerIoCompletion$3$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$3$label_106#1;

  inline$BDLSystemPowerIoCompletion$3$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_106_true#1, inline$BDLSystemPowerIoCompletion$3$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_142#1;

  inline$BDLSystemPowerIoCompletion$3$label_142#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_143#1;

  inline$BDLSystemPowerIoCompletion$3$label_143#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_144#1;

  inline$BDLSystemPowerIoCompletion$3$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_109#1;

  inline$BDLSystemPowerIoCompletion$3$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_109#1;

  inline$BDLSystemPowerIoCompletion$3$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$3$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$3$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$3$myNondetVar_0, inline$BDLSystemPowerIoCompletion$3$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$3$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$3$anon50_Then#1, inline$BDLSystemPowerIoCompletion$3$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon29#1;

  inline$BDLSystemPowerIoCompletion$3$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_112#1;

  inline$BDLSystemPowerIoCompletion$3$label_112#1:
    inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$3$label_113#1;

  inline$BDLSystemPowerIoCompletion$3$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_113_true#1, inline$BDLSystemPowerIoCompletion$3$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$3$label_114#1;

  inline$BDLSystemPowerIoCompletion$3$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_116#1;

  inline$BDLSystemPowerIoCompletion$3$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_117#1;

  inline$BDLSystemPowerIoCompletion$3$label_117#1:
    goto inline$BDLGetDebugLevel$94$Entry#1;

  inline$BDLGetDebugLevel$94$Entry#1:
    goto inline$BDLGetDebugLevel$94$start#1;

  inline$BDLGetDebugLevel$94$start#1:
    goto inline$BDLGetDebugLevel$94$label_3#1;

  inline$BDLGetDebugLevel$94$label_3#1:
    havoc inline$BDLGetDebugLevel$94$myNondetVar_0;
    inline$BDLGetDebugLevel$94$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$94$myNondetVar_0;
    goto inline$BDLGetDebugLevel$94$label_1#1;

  inline$BDLGetDebugLevel$94$label_1#1:
    goto inline$BDLGetDebugLevel$94$Return#1;

  inline$BDLGetDebugLevel$94$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$94$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon51_Then#1, inline$BDLSystemPowerIoCompletion$3$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon31#1;

  inline$BDLSystemPowerIoCompletion$3$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_120#1;

  inline$BDLSystemPowerIoCompletion$3$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_120_true#1, inline$BDLSystemPowerIoCompletion$3$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_121#1;

  inline$BDLSystemPowerIoCompletion$3$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_124#1;

  inline$BDLSystemPowerIoCompletion$3$label_124#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_125#1;

  inline$BDLSystemPowerIoCompletion$3$label_125#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_126#1;

  inline$BDLSystemPowerIoCompletion$3$label_126#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_127#1;

  inline$BDLSystemPowerIoCompletion$3$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$3$label_121#1;

  inline$BDLSystemPowerIoCompletion$3$label_121#1:
    goto inline$BDLGetDebugLevel$95$Entry#1;

  inline$BDLGetDebugLevel$95$Entry#1:
    goto inline$BDLGetDebugLevel$95$start#1;

  inline$BDLGetDebugLevel$95$start#1:
    goto inline$BDLGetDebugLevel$95$label_3#1;

  inline$BDLGetDebugLevel$95$label_3#1:
    havoc inline$BDLGetDebugLevel$95$myNondetVar_0;
    inline$BDLGetDebugLevel$95$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$95$myNondetVar_0;
    goto inline$BDLGetDebugLevel$95$label_1#1;

  inline$BDLGetDebugLevel$95$label_1#1:
    goto inline$BDLGetDebugLevel$95$Return#1;

  inline$BDLGetDebugLevel$95$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$95$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon52_Then#1, inline$BDLSystemPowerIoCompletion$3$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon33#1;

  inline$BDLSystemPowerIoCompletion$3$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_130#1;

  inline$BDLSystemPowerIoCompletion$3$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_130_true#1, inline$BDLSystemPowerIoCompletion$3$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_131#1;

  inline$BDLSystemPowerIoCompletion$3$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_134#1;

  inline$BDLSystemPowerIoCompletion$3$label_134#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_135#1;

  inline$BDLSystemPowerIoCompletion$3$label_135#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_136#1;

  inline$BDLSystemPowerIoCompletion$3$label_136#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_137#1;

  inline$BDLSystemPowerIoCompletion$3$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$3$label_131#1;

  inline$BDLSystemPowerIoCompletion$3$label_131#1:
    goto inline$BDLGetDebugLevel$96$Entry#1;

  inline$BDLGetDebugLevel$96$Entry#1:
    goto inline$BDLGetDebugLevel$96$start#1;

  inline$BDLGetDebugLevel$96$start#1:
    goto inline$BDLGetDebugLevel$96$label_3#1;

  inline$BDLGetDebugLevel$96$label_3#1:
    havoc inline$BDLGetDebugLevel$96$myNondetVar_0;
    inline$BDLGetDebugLevel$96$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$96$myNondetVar_0;
    goto inline$BDLGetDebugLevel$96$label_1#1;

  inline$BDLGetDebugLevel$96$label_1#1:
    goto inline$BDLGetDebugLevel$96$Return#1;

  inline$BDLGetDebugLevel$96$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$96$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon53_Then#1, inline$BDLSystemPowerIoCompletion$3$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon35#1;

  inline$BDLSystemPowerIoCompletion$3$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_140#1;

  inline$BDLSystemPowerIoCompletion$3$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_140_true#1, inline$BDLSystemPowerIoCompletion$3$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_67#1;

  inline$BDLSystemPowerIoCompletion$3$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_141#1;

  inline$BDLSystemPowerIoCompletion$3$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_67#1;

  inline$BDLSystemPowerIoCompletion$3$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$3$label_115#1;

  inline$BDLSystemPowerIoCompletion$3$label_115#1:
    inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$3$label_80#1;

  inline$BDLSystemPowerIoCompletion$3$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$3$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_42#1;

  inline$BDLSystemPowerIoCompletion$3$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$3$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$3$label_43#1;

  inline$BDLSystemPowerIoCompletion$3$label_43#1:
    goto inline$BDLGetDebugLevel$88$Entry#1;

  inline$BDLGetDebugLevel$88$Entry#1:
    goto inline$BDLGetDebugLevel$88$start#1;

  inline$BDLGetDebugLevel$88$start#1:
    goto inline$BDLGetDebugLevel$88$label_3#1;

  inline$BDLGetDebugLevel$88$label_3#1:
    havoc inline$BDLGetDebugLevel$88$myNondetVar_0;
    inline$BDLGetDebugLevel$88$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$88$myNondetVar_0;
    goto inline$BDLGetDebugLevel$88$label_1#1;

  inline$BDLGetDebugLevel$88$label_1#1:
    goto inline$BDLGetDebugLevel$88$Return#1;

  inline$BDLGetDebugLevel$88$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$88$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon40_Then#1, inline$BDLSystemPowerIoCompletion$3$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon9#1;

  inline$BDLSystemPowerIoCompletion$3$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_46#1;

  inline$BDLSystemPowerIoCompletion$3$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_46_true#1, inline$BDLSystemPowerIoCompletion$3$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_47#1;

  inline$BDLSystemPowerIoCompletion$3$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_50#1;

  inline$BDLSystemPowerIoCompletion$3$label_50#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_51#1;

  inline$BDLSystemPowerIoCompletion$3$label_51#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_52#1;

  inline$BDLSystemPowerIoCompletion$3$label_52#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_53#1;

  inline$BDLSystemPowerIoCompletion$3$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$3$label_47#1;

  inline$BDLSystemPowerIoCompletion$3$label_47#1:
    goto inline$BDLGetDebugLevel$89$Entry#1;

  inline$BDLGetDebugLevel$89$Entry#1:
    goto inline$BDLGetDebugLevel$89$start#1;

  inline$BDLGetDebugLevel$89$start#1:
    goto inline$BDLGetDebugLevel$89$label_3#1;

  inline$BDLGetDebugLevel$89$label_3#1:
    havoc inline$BDLGetDebugLevel$89$myNondetVar_0;
    inline$BDLGetDebugLevel$89$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$89$myNondetVar_0;
    goto inline$BDLGetDebugLevel$89$label_1#1;

  inline$BDLGetDebugLevel$89$label_1#1:
    goto inline$BDLGetDebugLevel$89$Return#1;

  inline$BDLGetDebugLevel$89$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$89$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon41_Then#1, inline$BDLSystemPowerIoCompletion$3$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon11#1;

  inline$BDLSystemPowerIoCompletion$3$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_56#1;

  inline$BDLSystemPowerIoCompletion$3$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_56_true#1, inline$BDLSystemPowerIoCompletion$3$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_57#1;

  inline$BDLSystemPowerIoCompletion$3$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_60#1;

  inline$BDLSystemPowerIoCompletion$3$label_60#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_61#1;

  inline$BDLSystemPowerIoCompletion$3$label_61#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_62#1;

  inline$BDLSystemPowerIoCompletion$3$label_62#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_63#1;

  inline$BDLSystemPowerIoCompletion$3$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$3$label_57#1;

  inline$BDLSystemPowerIoCompletion$3$label_57#1:
    goto inline$BDLGetDebugLevel$90$Entry#1;

  inline$BDLGetDebugLevel$90$Entry#1:
    goto inline$BDLGetDebugLevel$90$start#1;

  inline$BDLGetDebugLevel$90$start#1:
    goto inline$BDLGetDebugLevel$90$label_3#1;

  inline$BDLGetDebugLevel$90$label_3#1:
    havoc inline$BDLGetDebugLevel$90$myNondetVar_0;
    inline$BDLGetDebugLevel$90$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$90$myNondetVar_0;
    goto inline$BDLGetDebugLevel$90$label_1#1;

  inline$BDLGetDebugLevel$90$label_1#1:
    goto inline$BDLGetDebugLevel$90$Return#1;

  inline$BDLGetDebugLevel$90$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$90$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon42_Then#1, inline$BDLSystemPowerIoCompletion$3$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon13#1;

  inline$BDLSystemPowerIoCompletion$3$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_66#1;

  inline$BDLSystemPowerIoCompletion$3$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_66_true#1, inline$BDLSystemPowerIoCompletion$3$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_67#1;

  inline$BDLSystemPowerIoCompletion$3$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_70#1;

  inline$BDLSystemPowerIoCompletion$3$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_67#1;

  inline$BDLSystemPowerIoCompletion$3$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$3$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$3$anon43_Then#1, inline$BDLSystemPowerIoCompletion$3$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon15#1;

  inline$BDLSystemPowerIoCompletion$3$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_71#1;

  inline$BDLSystemPowerIoCompletion$3$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$3$anon44_Then#1, inline$BDLSystemPowerIoCompletion$3$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon17#1;

  inline$BDLSystemPowerIoCompletion$3$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_74#1;

  inline$BDLSystemPowerIoCompletion$3$label_74#1:
    goto inline$storm_IoCompleteRequest$8$Entry#1;

  inline$storm_IoCompleteRequest$8$Entry#1:
    inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$3$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$8$start#1;

  inline$storm_IoCompleteRequest$8$start#1:
    inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$8$label_3#1;

  inline$storm_IoCompleteRequest$8$label_3#1:
    call inline$storm_IoCompleteRequest$8$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$8$label_6#1;

  inline$storm_IoCompleteRequest$8$label_6#1:
    goto inline$storm_IoCompleteRequest$8$label_6_true#1, inline$storm_IoCompleteRequest$8$label_6_false#1;

  inline$storm_IoCompleteRequest$8$label_6_false#1:
    assume inline$storm_IoCompleteRequest$8$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$8$label_7#1;

  inline$storm_IoCompleteRequest$8$label_6_true#1:
    assume inline$storm_IoCompleteRequest$8$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$8$label_8#1;

  inline$storm_IoCompleteRequest$8$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$8$anon3_Then#1, inline$storm_IoCompleteRequest$8$anon3_Else#1;

  inline$storm_IoCompleteRequest$8$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$8$anon1#1;

  inline$storm_IoCompleteRequest$8$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$8$label_9#1;

  inline$storm_IoCompleteRequest$8$label_9#1:
    goto inline$storm_IoCompleteRequest$8$label_9_true#1, inline$storm_IoCompleteRequest$8$label_9_false#1;

  inline$storm_IoCompleteRequest$8$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$8$label_10#1;

  inline$storm_IoCompleteRequest$8$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$8$label_1#1;

  inline$storm_IoCompleteRequest$8$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$8$label_7#1;

  inline$storm_IoCompleteRequest$8$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$8$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$8$label_1#1;

  inline$storm_IoCompleteRequest$8$label_1#1:
    goto inline$storm_IoCompleteRequest$8$Return#1;

  inline$storm_IoCompleteRequest$8$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$8$Return#1;

  inline$storm_IoCompleteRequest$8$Return#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon45_Then#1, inline$BDLSystemPowerIoCompletion$3$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon19#1;

  inline$BDLSystemPowerIoCompletion$3$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_77#1;

  inline$BDLSystemPowerIoCompletion$3$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$3$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$3$anon46_Then#1, inline$BDLSystemPowerIoCompletion$3$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon21#1;

  inline$BDLSystemPowerIoCompletion$3$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_80#1;

  inline$BDLSystemPowerIoCompletion$3$label_80#1:
    goto inline$BDLGetDebugLevel$91$Entry#1;

  inline$BDLGetDebugLevel$91$Entry#1:
    goto inline$BDLGetDebugLevel$91$start#1;

  inline$BDLGetDebugLevel$91$start#1:
    goto inline$BDLGetDebugLevel$91$label_3#1;

  inline$BDLGetDebugLevel$91$label_3#1:
    havoc inline$BDLGetDebugLevel$91$myNondetVar_0;
    inline$BDLGetDebugLevel$91$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$91$myNondetVar_0;
    goto inline$BDLGetDebugLevel$91$label_1#1;

  inline$BDLGetDebugLevel$91$label_1#1:
    goto inline$BDLGetDebugLevel$91$Return#1;

  inline$BDLGetDebugLevel$91$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$91$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon47_Then#1, inline$BDLSystemPowerIoCompletion$3$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon23#1;

  inline$BDLSystemPowerIoCompletion$3$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_83#1;

  inline$BDLSystemPowerIoCompletion$3$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_83_true#1, inline$BDLSystemPowerIoCompletion$3$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_84#1;

  inline$BDLSystemPowerIoCompletion$3$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_87#1;

  inline$BDLSystemPowerIoCompletion$3$label_87#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_88#1;

  inline$BDLSystemPowerIoCompletion$3$label_88#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_89#1;

  inline$BDLSystemPowerIoCompletion$3$label_89#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_90#1;

  inline$BDLSystemPowerIoCompletion$3$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$3$label_84#1;

  inline$BDLSystemPowerIoCompletion$3$label_84#1:
    goto inline$BDLGetDebugLevel$92$Entry#1;

  inline$BDLGetDebugLevel$92$Entry#1:
    goto inline$BDLGetDebugLevel$92$start#1;

  inline$BDLGetDebugLevel$92$start#1:
    goto inline$BDLGetDebugLevel$92$label_3#1;

  inline$BDLGetDebugLevel$92$label_3#1:
    havoc inline$BDLGetDebugLevel$92$myNondetVar_0;
    inline$BDLGetDebugLevel$92$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$92$myNondetVar_0;
    goto inline$BDLGetDebugLevel$92$label_1#1;

  inline$BDLGetDebugLevel$92$label_1#1:
    goto inline$BDLGetDebugLevel$92$Return#1;

  inline$BDLGetDebugLevel$92$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$92$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon48_Then#1, inline$BDLSystemPowerIoCompletion$3$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon25#1;

  inline$BDLSystemPowerIoCompletion$3$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_93#1;

  inline$BDLSystemPowerIoCompletion$3$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_93_true#1, inline$BDLSystemPowerIoCompletion$3$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_94#1;

  inline$BDLSystemPowerIoCompletion$3$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_97#1;

  inline$BDLSystemPowerIoCompletion$3$label_97#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_98#1;

  inline$BDLSystemPowerIoCompletion$3$label_98#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_99#1;

  inline$BDLSystemPowerIoCompletion$3$label_99#1:
    call inline$BDLSystemPowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$3$label_100#1;

  inline$BDLSystemPowerIoCompletion$3$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$3$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$3$label_94#1;

  inline$BDLSystemPowerIoCompletion$3$label_94#1:
    goto inline$BDLGetDebugLevel$93$Entry#1;

  inline$BDLGetDebugLevel$93$Entry#1:
    goto inline$BDLGetDebugLevel$93$start#1;

  inline$BDLGetDebugLevel$93$start#1:
    goto inline$BDLGetDebugLevel$93$label_3#1;

  inline$BDLGetDebugLevel$93$label_3#1:
    havoc inline$BDLGetDebugLevel$93$myNondetVar_0;
    inline$BDLGetDebugLevel$93$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$93$myNondetVar_0;
    goto inline$BDLGetDebugLevel$93$label_1#1;

  inline$BDLGetDebugLevel$93$label_1#1:
    goto inline$BDLGetDebugLevel$93$Return#1;

  inline$BDLGetDebugLevel$93$Return#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$93$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$3$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$3$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$3$anon49_Then#1, inline$BDLSystemPowerIoCompletion$3$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$3$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$anon27#1;

  inline$BDLSystemPowerIoCompletion$3$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_103#1;

  inline$BDLSystemPowerIoCompletion$3$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_103_true#1, inline$BDLSystemPowerIoCompletion$3$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$3$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_104#1;

  inline$BDLSystemPowerIoCompletion$3$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$3$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$3$label_105#1;

  inline$BDLSystemPowerIoCompletion$3$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$3$label_104#1;

  inline$BDLSystemPowerIoCompletion$3$label_104#1:
    inline$BDLSystemPowerIoCompletion$3$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$3$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$3$label_1#1;

  inline$BDLSystemPowerIoCompletion$3$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$3$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$3$Return#1;

  inline$BDLSystemPowerIoCompletion$3$Return#1:
    inline$CallCompletionRoutine$3$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$3$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$3$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$3$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$3$anon14_Then#1, inline$CallCompletionRoutine$3$anon14_Else#1;

  inline$CallCompletionRoutine$3$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$3$anon9#1;

  inline$CallCompletionRoutine$3$anon9#1:
    goto inline$CallCompletionRoutine$3$label_20_icall_return#1;

  inline$CallCompletionRoutine$3$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$3$Return#1;

  inline$CallCompletionRoutine$3$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$3$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$3$Entry#1;

  inline$BDLDevicePowerIoCompletion$3$Entry#1:
    inline$BDLDevicePowerIoCompletion$3$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$3$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$3$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$3$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$3$start#1;

  inline$BDLDevicePowerIoCompletion$3$start#1:
    call inline$BDLDevicePowerIoCompletion$3$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$3$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$3$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$3$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$3$label_3#1;

  inline$BDLDevicePowerIoCompletion$3$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_4#1;

  inline$BDLDevicePowerIoCompletion$3$label_4#1:
    inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_5#1;

  inline$BDLDevicePowerIoCompletion$3$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_6#1;

  inline$BDLDevicePowerIoCompletion$3$label_6#1:
    inline$BDLDevicePowerIoCompletion$3$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$3$label_7#1;

  inline$BDLDevicePowerIoCompletion$3$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_8#1;

  inline$BDLDevicePowerIoCompletion$3$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$3$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$3$label_9#1;

  inline$BDLDevicePowerIoCompletion$3$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_10#1;

  inline$BDLDevicePowerIoCompletion$3$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$21$Entry#1;

  inline$IoGetCurrentIrpStackLocation$21$Entry#1:
    inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$21$start#1;

  inline$IoGetCurrentIrpStackLocation$21$start#1:
    inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$21$label_3#1;

  inline$IoGetCurrentIrpStackLocation$21$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$21$label_3_true#1, inline$IoGetCurrentIrpStackLocation$21$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$21$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$21$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$21$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$21$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$21$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$21$label_4#1;

  inline$IoGetCurrentIrpStackLocation$21$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$21$label_6#1;

  inline$IoGetCurrentIrpStackLocation$21$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$21$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$21$label_7#1;

  inline$IoGetCurrentIrpStackLocation$21$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$21$label_5#1;

  inline$IoGetCurrentIrpStackLocation$21$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$21$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$21$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$21$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$21$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$21$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$21$label_5#1;

  inline$IoGetCurrentIrpStackLocation$21$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$21$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$21$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$21$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$21$label_1#1;

  inline$IoGetCurrentIrpStackLocation$21$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$21$Return#1;

  inline$IoGetCurrentIrpStackLocation$21$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$21$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon30_Then#1, inline$BDLDevicePowerIoCompletion$3$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon1#1;

  inline$BDLDevicePowerIoCompletion$3$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_13#1;

  inline$BDLDevicePowerIoCompletion$3$label_13#1:
    inline$BDLDevicePowerIoCompletion$3$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$3$label_14#1;

  inline$BDLDevicePowerIoCompletion$3$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_15#1;

  inline$BDLDevicePowerIoCompletion$3$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$3$label_16#1;

  inline$BDLDevicePowerIoCompletion$3$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_17#1;

  inline$BDLDevicePowerIoCompletion$3$label_17#1:
    goto inline$BDLGetDebugLevel$76$Entry#1;

  inline$BDLGetDebugLevel$76$Entry#1:
    goto inline$BDLGetDebugLevel$76$start#1;

  inline$BDLGetDebugLevel$76$start#1:
    goto inline$BDLGetDebugLevel$76$label_3#1;

  inline$BDLGetDebugLevel$76$label_3#1:
    havoc inline$BDLGetDebugLevel$76$myNondetVar_0;
    inline$BDLGetDebugLevel$76$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$76$myNondetVar_0;
    goto inline$BDLGetDebugLevel$76$label_1#1;

  inline$BDLGetDebugLevel$76$label_1#1:
    goto inline$BDLGetDebugLevel$76$Return#1;

  inline$BDLGetDebugLevel$76$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$76$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon31_Then#1, inline$BDLDevicePowerIoCompletion$3$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon3#1;

  inline$BDLDevicePowerIoCompletion$3$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_20#1;

  inline$BDLDevicePowerIoCompletion$3$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_20_true#1, inline$BDLDevicePowerIoCompletion$3$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_21#1;

  inline$BDLDevicePowerIoCompletion$3$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_24#1;

  inline$BDLDevicePowerIoCompletion$3$label_24#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_25#1;

  inline$BDLDevicePowerIoCompletion$3$label_25#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_26#1;

  inline$BDLDevicePowerIoCompletion$3$label_26#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_27#1;

  inline$BDLDevicePowerIoCompletion$3$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$3$label_21#1;

  inline$BDLDevicePowerIoCompletion$3$label_21#1:
    goto inline$BDLGetDebugLevel$77$Entry#1;

  inline$BDLGetDebugLevel$77$Entry#1:
    goto inline$BDLGetDebugLevel$77$start#1;

  inline$BDLGetDebugLevel$77$start#1:
    goto inline$BDLGetDebugLevel$77$label_3#1;

  inline$BDLGetDebugLevel$77$label_3#1:
    havoc inline$BDLGetDebugLevel$77$myNondetVar_0;
    inline$BDLGetDebugLevel$77$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$77$myNondetVar_0;
    goto inline$BDLGetDebugLevel$77$label_1#1;

  inline$BDLGetDebugLevel$77$label_1#1:
    goto inline$BDLGetDebugLevel$77$Return#1;

  inline$BDLGetDebugLevel$77$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$77$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon32_Then#1, inline$BDLDevicePowerIoCompletion$3$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon5#1;

  inline$BDLDevicePowerIoCompletion$3$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_30#1;

  inline$BDLDevicePowerIoCompletion$3$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_30_true#1, inline$BDLDevicePowerIoCompletion$3$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_31#1;

  inline$BDLDevicePowerIoCompletion$3$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_34#1;

  inline$BDLDevicePowerIoCompletion$3$label_34#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_35#1;

  inline$BDLDevicePowerIoCompletion$3$label_35#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_36#1;

  inline$BDLDevicePowerIoCompletion$3$label_36#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_37#1;

  inline$BDLDevicePowerIoCompletion$3$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$3$label_31#1;

  inline$BDLDevicePowerIoCompletion$3$label_31#1:
    goto inline$BDLGetDebugLevel$78$Entry#1;

  inline$BDLGetDebugLevel$78$Entry#1:
    goto inline$BDLGetDebugLevel$78$start#1;

  inline$BDLGetDebugLevel$78$start#1:
    goto inline$BDLGetDebugLevel$78$label_3#1;

  inline$BDLGetDebugLevel$78$label_3#1:
    havoc inline$BDLGetDebugLevel$78$myNondetVar_0;
    inline$BDLGetDebugLevel$78$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$78$myNondetVar_0;
    goto inline$BDLGetDebugLevel$78$label_1#1;

  inline$BDLGetDebugLevel$78$label_1#1:
    goto inline$BDLGetDebugLevel$78$Return#1;

  inline$BDLGetDebugLevel$78$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$78$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon33_Then#1, inline$BDLDevicePowerIoCompletion$3$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon7#1;

  inline$BDLDevicePowerIoCompletion$3$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_40#1;

  inline$BDLDevicePowerIoCompletion$3$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_40_true#1, inline$BDLDevicePowerIoCompletion$3$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_41#1;

  inline$BDLDevicePowerIoCompletion$3$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_42#1;

  inline$BDLDevicePowerIoCompletion$3$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_41#1;

  inline$BDLDevicePowerIoCompletion$3$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_41_true#1, inline$BDLDevicePowerIoCompletion$3$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$3$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$3$label_43#1;

  inline$BDLDevicePowerIoCompletion$3$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$3$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$3$label_44#1;

  inline$BDLDevicePowerIoCompletion$3$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_44_true#1, inline$BDLDevicePowerIoCompletion$3$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$3$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$3$label_45#1;

  inline$BDLDevicePowerIoCompletion$3$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_45_true#1, inline$BDLDevicePowerIoCompletion$3$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$3$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$3$label_43#1;

  inline$BDLDevicePowerIoCompletion$3$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$3$label_86#1;

  inline$BDLDevicePowerIoCompletion$3$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$3$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$3$label_46#1;

  inline$BDLDevicePowerIoCompletion$3$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$3$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$3$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$3$label_46#1;

  inline$BDLDevicePowerIoCompletion$3$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$3$label_49#1;

  inline$BDLDevicePowerIoCompletion$3$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_50#1;

  inline$BDLDevicePowerIoCompletion$3$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_51#1;

  inline$BDLDevicePowerIoCompletion$3$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_54#1;

  inline$BDLDevicePowerIoCompletion$3$label_54#1:
    inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$3$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$3$label_55#1;

  inline$BDLDevicePowerIoCompletion$3$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_55_true#1, inline$BDLDevicePowerIoCompletion$3$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_56#1;

  inline$BDLDevicePowerIoCompletion$3$label_56#1:
    call inline$BDLDevicePowerIoCompletion$3$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$3$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$3$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$3$anon34_Then#1, inline$BDLDevicePowerIoCompletion$3$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon9#1;

  inline$BDLDevicePowerIoCompletion$3$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_83#1;

  inline$BDLDevicePowerIoCompletion$3$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_59#1;

  inline$BDLDevicePowerIoCompletion$3$label_59#1:
    goto inline$BDLGetDebugLevel$79$Entry#1;

  inline$BDLGetDebugLevel$79$Entry#1:
    goto inline$BDLGetDebugLevel$79$start#1;

  inline$BDLGetDebugLevel$79$start#1:
    goto inline$BDLGetDebugLevel$79$label_3#1;

  inline$BDLGetDebugLevel$79$label_3#1:
    havoc inline$BDLGetDebugLevel$79$myNondetVar_0;
    inline$BDLGetDebugLevel$79$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$79$myNondetVar_0;
    goto inline$BDLGetDebugLevel$79$label_1#1;

  inline$BDLGetDebugLevel$79$label_1#1:
    goto inline$BDLGetDebugLevel$79$Return#1;

  inline$BDLGetDebugLevel$79$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$79$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon35_Then#1, inline$BDLDevicePowerIoCompletion$3$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon11#1;

  inline$BDLDevicePowerIoCompletion$3$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_62#1;

  inline$BDLDevicePowerIoCompletion$3$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_62_true#1, inline$BDLDevicePowerIoCompletion$3$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_63#1;

  inline$BDLDevicePowerIoCompletion$3$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_66#1;

  inline$BDLDevicePowerIoCompletion$3$label_66#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_67#1;

  inline$BDLDevicePowerIoCompletion$3$label_67#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_68#1;

  inline$BDLDevicePowerIoCompletion$3$label_68#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_69#1;

  inline$BDLDevicePowerIoCompletion$3$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$3$label_63#1;

  inline$BDLDevicePowerIoCompletion$3$label_63#1:
    goto inline$BDLGetDebugLevel$80$Entry#1;

  inline$BDLGetDebugLevel$80$Entry#1:
    goto inline$BDLGetDebugLevel$80$start#1;

  inline$BDLGetDebugLevel$80$start#1:
    goto inline$BDLGetDebugLevel$80$label_3#1;

  inline$BDLGetDebugLevel$80$label_3#1:
    havoc inline$BDLGetDebugLevel$80$myNondetVar_0;
    inline$BDLGetDebugLevel$80$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$80$myNondetVar_0;
    goto inline$BDLGetDebugLevel$80$label_1#1;

  inline$BDLGetDebugLevel$80$label_1#1:
    goto inline$BDLGetDebugLevel$80$Return#1;

  inline$BDLGetDebugLevel$80$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$80$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon36_Then#1, inline$BDLDevicePowerIoCompletion$3$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon13#1;

  inline$BDLDevicePowerIoCompletion$3$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_72#1;

  inline$BDLDevicePowerIoCompletion$3$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_72_true#1, inline$BDLDevicePowerIoCompletion$3$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_73#1;

  inline$BDLDevicePowerIoCompletion$3$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_76#1;

  inline$BDLDevicePowerIoCompletion$3$label_76#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_77#1;

  inline$BDLDevicePowerIoCompletion$3$label_77#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_78#1;

  inline$BDLDevicePowerIoCompletion$3$label_78#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_79#1;

  inline$BDLDevicePowerIoCompletion$3$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$3$label_73#1;

  inline$BDLDevicePowerIoCompletion$3$label_73#1:
    goto inline$BDLGetDebugLevel$81$Entry#1;

  inline$BDLGetDebugLevel$81$Entry#1:
    goto inline$BDLGetDebugLevel$81$start#1;

  inline$BDLGetDebugLevel$81$start#1:
    goto inline$BDLGetDebugLevel$81$label_3#1;

  inline$BDLGetDebugLevel$81$label_3#1:
    havoc inline$BDLGetDebugLevel$81$myNondetVar_0;
    inline$BDLGetDebugLevel$81$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$81$myNondetVar_0;
    goto inline$BDLGetDebugLevel$81$label_1#1;

  inline$BDLGetDebugLevel$81$label_1#1:
    goto inline$BDLGetDebugLevel$81$Return#1;

  inline$BDLGetDebugLevel$81$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$81$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon37_Then#1, inline$BDLDevicePowerIoCompletion$3$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon15#1;

  inline$BDLDevicePowerIoCompletion$3$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_82#1;

  inline$BDLDevicePowerIoCompletion$3$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_82_true#1, inline$BDLDevicePowerIoCompletion$3$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_83#1;

  inline$BDLDevicePowerIoCompletion$3$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_84#1;

  inline$BDLDevicePowerIoCompletion$3$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_83#1;

  inline$BDLDevicePowerIoCompletion$3$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_85#1;

  inline$BDLDevicePowerIoCompletion$3$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_86#1;

  inline$BDLDevicePowerIoCompletion$3$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$3$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$3$anon38_Then#1, inline$BDLDevicePowerIoCompletion$3$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon17#1;

  inline$BDLDevicePowerIoCompletion$3$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_89#1;

  inline$BDLDevicePowerIoCompletion$3$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$3$anon39_Then#1, inline$BDLDevicePowerIoCompletion$3$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon19#1;

  inline$BDLDevicePowerIoCompletion$3$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_92#1;

  inline$BDLDevicePowerIoCompletion$3$label_92#1:
    goto inline$storm_IoCompleteRequest$7$Entry#1;

  inline$storm_IoCompleteRequest$7$Entry#1:
    inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$3$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$7$start#1;

  inline$storm_IoCompleteRequest$7$start#1:
    inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$7$label_3#1;

  inline$storm_IoCompleteRequest$7$label_3#1:
    call inline$storm_IoCompleteRequest$7$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$7$label_6#1;

  inline$storm_IoCompleteRequest$7$label_6#1:
    goto inline$storm_IoCompleteRequest$7$label_6_true#1, inline$storm_IoCompleteRequest$7$label_6_false#1;

  inline$storm_IoCompleteRequest$7$label_6_false#1:
    assume inline$storm_IoCompleteRequest$7$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$7$label_7#1;

  inline$storm_IoCompleteRequest$7$label_6_true#1:
    assume inline$storm_IoCompleteRequest$7$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$7$label_8#1;

  inline$storm_IoCompleteRequest$7$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$7$anon3_Then#1, inline$storm_IoCompleteRequest$7$anon3_Else#1;

  inline$storm_IoCompleteRequest$7$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$7$anon1#1;

  inline$storm_IoCompleteRequest$7$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$7$label_9#1;

  inline$storm_IoCompleteRequest$7$label_9#1:
    goto inline$storm_IoCompleteRequest$7$label_9_true#1, inline$storm_IoCompleteRequest$7$label_9_false#1;

  inline$storm_IoCompleteRequest$7$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$7$label_10#1;

  inline$storm_IoCompleteRequest$7$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$7$label_1#1;

  inline$storm_IoCompleteRequest$7$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$7$label_7#1;

  inline$storm_IoCompleteRequest$7$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$7$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$7$label_1#1;

  inline$storm_IoCompleteRequest$7$label_1#1:
    goto inline$storm_IoCompleteRequest$7$Return#1;

  inline$storm_IoCompleteRequest$7$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$7$Return#1;

  inline$storm_IoCompleteRequest$7$Return#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon40_Then#1, inline$BDLDevicePowerIoCompletion$3$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon21#1;

  inline$BDLDevicePowerIoCompletion$3$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_95#1;

  inline$BDLDevicePowerIoCompletion$3$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$3$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$3$anon41_Then#1, inline$BDLDevicePowerIoCompletion$3$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon23#1;

  inline$BDLDevicePowerIoCompletion$3$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_98#1;

  inline$BDLDevicePowerIoCompletion$3$label_98#1:
    goto inline$BDLGetDebugLevel$82$Entry#1;

  inline$BDLGetDebugLevel$82$Entry#1:
    goto inline$BDLGetDebugLevel$82$start#1;

  inline$BDLGetDebugLevel$82$start#1:
    goto inline$BDLGetDebugLevel$82$label_3#1;

  inline$BDLGetDebugLevel$82$label_3#1:
    havoc inline$BDLGetDebugLevel$82$myNondetVar_0;
    inline$BDLGetDebugLevel$82$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$82$myNondetVar_0;
    goto inline$BDLGetDebugLevel$82$label_1#1;

  inline$BDLGetDebugLevel$82$label_1#1:
    goto inline$BDLGetDebugLevel$82$Return#1;

  inline$BDLGetDebugLevel$82$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$82$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon42_Then#1, inline$BDLDevicePowerIoCompletion$3$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon25#1;

  inline$BDLDevicePowerIoCompletion$3$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_101#1;

  inline$BDLDevicePowerIoCompletion$3$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_101_true#1, inline$BDLDevicePowerIoCompletion$3$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_102#1;

  inline$BDLDevicePowerIoCompletion$3$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_105#1;

  inline$BDLDevicePowerIoCompletion$3$label_105#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_106#1;

  inline$BDLDevicePowerIoCompletion$3$label_106#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_107#1;

  inline$BDLDevicePowerIoCompletion$3$label_107#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_108#1;

  inline$BDLDevicePowerIoCompletion$3$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$3$label_102#1;

  inline$BDLDevicePowerIoCompletion$3$label_102#1:
    goto inline$BDLGetDebugLevel$83$Entry#1;

  inline$BDLGetDebugLevel$83$Entry#1:
    goto inline$BDLGetDebugLevel$83$start#1;

  inline$BDLGetDebugLevel$83$start#1:
    goto inline$BDLGetDebugLevel$83$label_3#1;

  inline$BDLGetDebugLevel$83$label_3#1:
    havoc inline$BDLGetDebugLevel$83$myNondetVar_0;
    inline$BDLGetDebugLevel$83$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$83$myNondetVar_0;
    goto inline$BDLGetDebugLevel$83$label_1#1;

  inline$BDLGetDebugLevel$83$label_1#1:
    goto inline$BDLGetDebugLevel$83$Return#1;

  inline$BDLGetDebugLevel$83$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$83$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon43_Then#1, inline$BDLDevicePowerIoCompletion$3$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon27#1;

  inline$BDLDevicePowerIoCompletion$3$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_111#1;

  inline$BDLDevicePowerIoCompletion$3$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_111_true#1, inline$BDLDevicePowerIoCompletion$3$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_112#1;

  inline$BDLDevicePowerIoCompletion$3$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_115#1;

  inline$BDLDevicePowerIoCompletion$3$label_115#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_116#1;

  inline$BDLDevicePowerIoCompletion$3$label_116#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_117#1;

  inline$BDLDevicePowerIoCompletion$3$label_117#1:
    call inline$BDLDevicePowerIoCompletion$3$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$3$label_118#1;

  inline$BDLDevicePowerIoCompletion$3$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$3$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$3$label_112#1;

  inline$BDLDevicePowerIoCompletion$3$label_112#1:
    goto inline$BDLGetDebugLevel$84$Entry#1;

  inline$BDLGetDebugLevel$84$Entry#1:
    goto inline$BDLGetDebugLevel$84$start#1;

  inline$BDLGetDebugLevel$84$start#1:
    goto inline$BDLGetDebugLevel$84$label_3#1;

  inline$BDLGetDebugLevel$84$label_3#1:
    havoc inline$BDLGetDebugLevel$84$myNondetVar_0;
    inline$BDLGetDebugLevel$84$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$84$myNondetVar_0;
    goto inline$BDLGetDebugLevel$84$label_1#1;

  inline$BDLGetDebugLevel$84$label_1#1:
    goto inline$BDLGetDebugLevel$84$Return#1;

  inline$BDLGetDebugLevel$84$Return#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$84$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$3$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$3$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$3$anon44_Then#1, inline$BDLDevicePowerIoCompletion$3$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$3$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$anon29#1;

  inline$BDLDevicePowerIoCompletion$3$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_121#1;

  inline$BDLDevicePowerIoCompletion$3$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_121_true#1, inline$BDLDevicePowerIoCompletion$3$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$3$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_122#1;

  inline$BDLDevicePowerIoCompletion$3$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$3$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$3$label_123#1;

  inline$BDLDevicePowerIoCompletion$3$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$3$label_122#1;

  inline$BDLDevicePowerIoCompletion$3$label_122#1:
    inline$BDLDevicePowerIoCompletion$3$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$3$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$3$label_1#1;

  inline$BDLDevicePowerIoCompletion$3$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$3$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$3$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$3$Return#1;

  inline$BDLDevicePowerIoCompletion$3$Return#1:
    inline$CallCompletionRoutine$3$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$3$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$3$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$3$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$3$anon13_Then#1, inline$CallCompletionRoutine$3$anon13_Else#1;

  inline$CallCompletionRoutine$3$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$3$anon7#1;

  inline$CallCompletionRoutine$3$anon7#1:
    goto inline$CallCompletionRoutine$3$label_20_icall_return#1;

  inline$CallCompletionRoutine$3$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$3$Return#1;

  inline$CallCompletionRoutine$3$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$3$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$3$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$3$Entry#1;

  inline$BDLCallDriverCompletionRoutine$3$Entry#1:
    inline$BDLCallDriverCompletionRoutine$3$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$3$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$3$start#1;

  inline$BDLCallDriverCompletionRoutine$3$start#1:
    inline$BDLCallDriverCompletionRoutine$3$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$3$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$3$label_3#1;

  inline$BDLCallDriverCompletionRoutine$3$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$3$label_3_true#1, inline$BDLCallDriverCompletionRoutine$3$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$3$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$3$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$3$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$3$label_4#1;

  inline$BDLCallDriverCompletionRoutine$3$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$3$label_6#1;

  inline$BDLCallDriverCompletionRoutine$3$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$3$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$3$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$3$label_5#1;

  inline$BDLCallDriverCompletionRoutine$3$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$3$label_6#1;

  inline$BDLCallDriverCompletionRoutine$3$label_6#1:
    goto inline$storm_KeSetEvent$3$Entry#1;

  inline$storm_KeSetEvent$3$Entry#1:
    inline$storm_KeSetEvent$3$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$3$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$3$start#1;

  inline$storm_KeSetEvent$3$start#1:
    inline$storm_KeSetEvent$3$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$3$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$3$label_3#1;

  inline$storm_KeSetEvent$3$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$3$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$3$label_1#1;

  inline$storm_KeSetEvent$3$label_1#1:
    goto inline$storm_KeSetEvent$3$Return#1;

  inline$storm_KeSetEvent$3$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$3$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$3$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$3$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$3$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$3$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$3$anon1#1;

  inline$BDLCallDriverCompletionRoutine$3$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$3$label_9#1;

  inline$BDLCallDriverCompletionRoutine$3$label_9#1:
    inline$BDLCallDriverCompletionRoutine$3$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$3$label_1#1;

  inline$BDLCallDriverCompletionRoutine$3$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$3$Return#1;

  inline$BDLCallDriverCompletionRoutine$3$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$3$Return#1;

  inline$BDLCallDriverCompletionRoutine$3$Return#1:
    inline$CallCompletionRoutine$3$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$3$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$3$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$3$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$3$anon12_Then#1, inline$CallCompletionRoutine$3$anon12_Else#1;

  inline$CallCompletionRoutine$3$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$3$anon5#1;

  inline$CallCompletionRoutine$3$anon5#1:
    goto inline$CallCompletionRoutine$3$label_20_icall_return#1;

  inline$CallCompletionRoutine$3$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$3$label_23#1;

  inline$CallCompletionRoutine$3$label_23#1:
    inline$CallCompletionRoutine$3$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$3$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$3$label_24#1;

  inline$CallCompletionRoutine$3$label_24#1:
    goto inline$CallCompletionRoutine$3$label_24_true#1, inline$CallCompletionRoutine$3$label_24_false#1;

  inline$CallCompletionRoutine$3$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$3$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$3$label_1#1;

  inline$CallCompletionRoutine$3$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$3$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$3$label_25#1;

  inline$CallCompletionRoutine$3$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$3$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$3$label_1#1;

  inline$CallCompletionRoutine$3$label_1#1:
    goto inline$CallCompletionRoutine$3$Return#1;

  inline$CallCompletionRoutine$3$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$3$Return#1;

  inline$CallCompletionRoutine$3$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$3$Return#1;

  inline$CallCompletionRoutine$3$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$3$Return#1;

  inline$CallCompletionRoutine$3$Return#1:
    goto inline$storm_IoCallDriver$1$label_39$1#1;

  inline$storm_IoCallDriver$1$label_39$1#1:
    goto inline$storm_IoCallDriver$1$anon15_Then#1, inline$storm_IoCallDriver$1$anon15_Else#1;

  inline$storm_IoCallDriver$1$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$1$anon10#1;

  inline$storm_IoCallDriver$1$anon10#1:
    goto inline$storm_IoCallDriver$1$label_36#1;

  inline$storm_IoCallDriver$1$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$1$Return#1;

  inline$storm_IoCallDriver$1$label_27_case_0#1:
    assume inline$storm_IoCallDriver$1$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$1$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$1$label_28#1;

  inline$storm_IoCallDriver$1$label_28#1:
    inline$storm_IoCallDriver$1$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$1$label_42#1;

  inline$storm_IoCallDriver$1$label_42#1:
    goto inline$storm_IoCallDriver$1$label_43#1;

  inline$storm_IoCallDriver$1$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$1$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$1$label_36#1;

  inline$storm_IoCallDriver$1$label_36#1:
    inline$storm_IoCallDriver$1$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$1$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$1$label_1#1;

  inline$storm_IoCallDriver$1$label_1#1:
    goto inline$storm_IoCallDriver$1$Return#1;

  inline$storm_IoCallDriver$1$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$1$Return#1;

  inline$storm_IoCallDriver$1$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$1$Return#1;

  inline$storm_IoCallDriver$1$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$1$Return#1;

  inline$storm_IoCallDriver$1$Return#1:
    inline$storm_PoCallDriver$0$$result.storm_IoCallDriver$499.27$2$ := inline$storm_IoCallDriver$1$$result.storm_IoCallDriver$456.0$1$;
    goto inline$storm_PoCallDriver$0$label_3$1#1;

  inline$storm_PoCallDriver$0$label_3$1#1:
    goto inline$storm_PoCallDriver$0$anon2_Then#1, inline$storm_PoCallDriver$0$anon2_Else#1;

  inline$storm_PoCallDriver$0$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_PoCallDriver$0$anon1#1;

  inline$storm_PoCallDriver$0$anon1#1:
    goto inline$storm_PoCallDriver$0$label_6#1;

  inline$storm_PoCallDriver$0$label_6#1:
    inline$storm_PoCallDriver$0$$result.storm_PoCallDriver$494.0$1$ := inline$storm_PoCallDriver$0$$result.storm_IoCallDriver$499.27$2$;
    goto inline$storm_PoCallDriver$0$label_1#1;

  inline$storm_PoCallDriver$0$label_1#1:
    goto inline$storm_PoCallDriver$0$Return#1;

  inline$storm_PoCallDriver$0$anon2_Then#1:
    assume raiseException;
    goto inline$storm_PoCallDriver$0$Return#1;

  inline$storm_PoCallDriver$0$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_PoCallDriver$104.29$3$ := inline$storm_PoCallDriver$0$$result.storm_PoCallDriver$494.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_25$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_25$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon22_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon22_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon22_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon13#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon13#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_28#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_28#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_PoCallDriver$104.29$3$;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_29#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_29#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_29_true#1, inline$BDLCallLowerLevelDriverAndWait$0$label_29_false#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_29_false#1:
    assume !INT_EQ(inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_29_true#1:
    assume INT_EQ(inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8, 259);
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_31#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_31#1:
    goto inline$storm_KeWaitForSingleObject$0$Entry#1;

  inline$storm_KeWaitForSingleObject$0$Entry#1:
    inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1 := inline$BDLCallLowerLevelDriverAndWait$0$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8;
    inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1 := 0;
    goto inline$storm_KeWaitForSingleObject$0$start#1;

  inline$storm_KeWaitForSingleObject$0$start#1:
    inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20_.1;
    inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 := inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20_.1;
    goto inline$storm_KeWaitForSingleObject$0$label_3#1;

  inline$storm_KeWaitForSingleObject$0$label_3#1:
    goto inline$storm_KeWaitForSingleObject$0$label_3_true#1, inline$storm_KeWaitForSingleObject$0$label_3_false#1;

  inline$storm_KeWaitForSingleObject$0$label_3_false#1:
    assume inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 == 0;
    goto inline$storm_KeWaitForSingleObject$0$label_4#1;

  inline$storm_KeWaitForSingleObject$0$label_4#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$0$anon6_Then#1, inline$storm_KeWaitForSingleObject$0$anon6_Else#1;

  inline$storm_KeWaitForSingleObject$0$anon6_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$0$anon1#1;

  inline$storm_KeWaitForSingleObject$0$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$0$label_13#1;

  inline$storm_KeWaitForSingleObject$0$label_13#1:
    inline$storm_KeWaitForSingleObject$0$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$0$label_1#1;

  inline$storm_KeWaitForSingleObject$0$anon6_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$0$Return#1;

  inline$storm_KeWaitForSingleObject$0$label_3_true#1:
    assume inline$storm_KeWaitForSingleObject$0$$Timeout$5$248.20$storm_KeWaitForSingleObject$20 != 0;
    goto inline$storm_KeWaitForSingleObject$0$label_5#1;

  inline$storm_KeWaitForSingleObject$0$label_5#1:
    call inline$storm_KeWaitForSingleObject$0$$result.storm_nondet$256.20$2$ := storm_nondet();
    goto inline$storm_KeWaitForSingleObject$0$label_8#1;

  inline$storm_KeWaitForSingleObject$0$label_8#1:
    goto inline$storm_KeWaitForSingleObject$0$label_8_true#1, inline$storm_KeWaitForSingleObject$0$label_8_false#1;

  inline$storm_KeWaitForSingleObject$0$label_8_false#1:
    assume inline$storm_KeWaitForSingleObject$0$$result.storm_nondet$256.20$2$ == 0;
    goto inline$storm_KeWaitForSingleObject$0$label_9#1;

  inline$storm_KeWaitForSingleObject$0$label_9#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$0$anon7_Then#1, inline$storm_KeWaitForSingleObject$0$anon7_Else#1;

  inline$storm_KeWaitForSingleObject$0$anon7_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$0$anon3#1;

  inline$storm_KeWaitForSingleObject$0$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20], 0);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$0$label_12#1;

  inline$storm_KeWaitForSingleObject$0$label_12#1:
    inline$storm_KeWaitForSingleObject$0$$result.storm_KeWaitForSingleObject$243.0$1$ := 258;
    goto inline$storm_KeWaitForSingleObject$0$label_1#1;

  inline$storm_KeWaitForSingleObject$0$anon7_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$0$Return#1;

  inline$storm_KeWaitForSingleObject$0$label_8_true#1:
    assume inline$storm_KeWaitForSingleObject$0$$result.storm_nondet$256.20$2$ != 0;
    goto inline$storm_KeWaitForSingleObject$0$label_10#1;

  inline$storm_KeWaitForSingleObject$0$label_10#1:
    havoc raiseException;
    goto inline$storm_KeWaitForSingleObject$0$anon8_Then#1, inline$storm_KeWaitForSingleObject$0$anon8_Else#1;

  inline$storm_KeWaitForSingleObject$0$anon8_Else#1:
    assume !raiseException;
    goto inline$storm_KeWaitForSingleObject$0$anon5#1;

  inline$storm_KeWaitForSingleObject$0$anon5#1:
    assume k == 0 ==> INT_EQ(Res_0_EVENT[inline$storm_KeWaitForSingleObject$0$$Object$1$244.11$storm_KeWaitForSingleObject$20], 1);
    call contextSwitch();
    goto inline$storm_KeWaitForSingleObject$0$label_11#1;

  inline$storm_KeWaitForSingleObject$0$label_11#1:
    inline$storm_KeWaitForSingleObject$0$$result.storm_KeWaitForSingleObject$243.0$1$ := 0;
    goto inline$storm_KeWaitForSingleObject$0$label_1#1;

  inline$storm_KeWaitForSingleObject$0$label_1#1:
    goto inline$storm_KeWaitForSingleObject$0$Return#1;

  inline$storm_KeWaitForSingleObject$0$anon8_Then#1:
    assume raiseException;
    goto inline$storm_KeWaitForSingleObject$0$Return#1;

  inline$storm_KeWaitForSingleObject$0$Return#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_KeWaitForSingleObject$116.38$5$ := inline$storm_KeWaitForSingleObject$0$$result.storm_KeWaitForSingleObject$243.0$1$;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_31$1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_31$1#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon23_Then#1, inline$BDLCallLowerLevelDriverAndWait$0$anon23_Else#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon23_Else#1:
    assume !raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$anon15#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon15#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_34#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_34#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$0$$result.storm_KeWaitForSingleObject$116.38$5$;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_35#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_35#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_35_true#1, inline$BDLCallLowerLevelDriverAndWait$0$label_35_false#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_35_false#1:
    assume inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 == 0;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_35_true#1:
    assume inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 != 0;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_37#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_37#1:
    call inline$BDLCallLowerLevelDriverAndWait$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_38#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_38#1:
    call inline$BDLCallLowerLevelDriverAndWait$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_39#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_39#1:
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_36#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_36#1:
    havoc inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0;
    inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8 := inline$BDLCallLowerLevelDriverAndWait$0$myNondetVar_0;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_30#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_30#1:
    inline$BDLCallLowerLevelDriverAndWait$0$$result.BDLCallLowerLevelDriverAndWait$71.0$1$ := inline$BDLCallLowerLevelDriverAndWait$0$$status$3$78.16$BDLCallLowerLevelDriverAndWait$8;
    goto inline$BDLCallLowerLevelDriverAndWait$0$label_1#1;

  inline$BDLCallLowerLevelDriverAndWait$0$label_1#1:
    call __HAVOC_free(inline$BDLCallLowerLevelDriverAndWait$0$$Event$4$79.16$BDLCallLowerLevelDriverAndWait$8);
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon23_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon22_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon21_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon19_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon18_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon17_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$anon16_Then#1:
    assume raiseException;
    goto inline$BDLCallLowerLevelDriverAndWait$0$Return#1;

  inline$BDLCallLowerLevelDriverAndWait$0$Return#1:
    inline$BDLPnPStart$0$$result.BDLCallLowerLevelDriverAndWait$1975.43$13$ := inline$BDLCallLowerLevelDriverAndWait$0$$result.BDLCallLowerLevelDriverAndWait$71.0$1$;
    goto inline$BDLPnPStart$0$label_32$1#1;

  inline$BDLPnPStart$0$label_32$1#1:
    goto inline$BDLPnPStart$0$anon39_Then#1, inline$BDLPnPStart$0$anon39_Else#1;

  inline$BDLPnPStart$0$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon7#1;

  inline$BDLPnPStart$0$anon7#1:
    goto inline$BDLPnPStart$0$label_36#1;

  inline$BDLPnPStart$0$label_36#1:
    inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 := inline$BDLPnPStart$0$$result.BDLCallLowerLevelDriverAndWait$1975.43$13$;
    goto inline$BDLPnPStart$0$label_37#1;

  inline$BDLPnPStart$0$label_37#1:
    goto inline$BDLPnPStart$0$label_37_true#1, inline$BDLPnPStart$0$label_37_false#1;

  inline$BDLPnPStart$0$label_37_false#1:
    assume !INT_LEQ(0, inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16);
    goto inline$BDLPnPStart$0$label_38#1;

  inline$BDLPnPStart$0$label_38#1:
    goto inline$BDLGetDebugLevel$97$Entry#1;

  inline$BDLGetDebugLevel$97$Entry#1:
    goto inline$BDLGetDebugLevel$97$start#1;

  inline$BDLGetDebugLevel$97$start#1:
    goto inline$BDLGetDebugLevel$97$label_3#1;

  inline$BDLGetDebugLevel$97$label_3#1:
    havoc inline$BDLGetDebugLevel$97$myNondetVar_0;
    inline$BDLGetDebugLevel$97$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$97$myNondetVar_0;
    goto inline$BDLGetDebugLevel$97$label_1#1;

  inline$BDLGetDebugLevel$97$label_1#1:
    goto inline$BDLGetDebugLevel$97$Return#1;

  inline$BDLGetDebugLevel$97$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$14$ := inline$BDLGetDebugLevel$97$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_38$1#1;

  inline$BDLPnPStart$0$label_38$1#1:
    goto inline$BDLPnPStart$0$anon40_Then#1, inline$BDLPnPStart$0$anon40_Else#1;

  inline$BDLPnPStart$0$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon9#1;

  inline$BDLPnPStart$0$anon9#1:
    goto inline$BDLPnPStart$0$label_151#1;

  inline$BDLPnPStart$0$label_151#1:
    goto inline$BDLPnPStart$0$label_151_true#1, inline$BDLPnPStart$0$label_151_false#1;

  inline$BDLPnPStart$0$label_151_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$14$) == 0;
    goto inline$BDLPnPStart$0$label_152#1;

  inline$BDLPnPStart$0$label_151_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$14$) != 0;
    goto inline$BDLPnPStart$0$label_155#1;

  inline$BDLPnPStart$0$label_155#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_156#1;

  inline$BDLPnPStart$0$label_156#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_157#1;

  inline$BDLPnPStart$0$label_157#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_158#1;

  inline$BDLPnPStart$0$label_158#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$1979.0$15$;
    goto inline$BDLPnPStart$0$label_152#1;

  inline$BDLPnPStart$0$label_152#1:
    goto inline$BDLGetDebugLevel$107$Entry#1;

  inline$BDLGetDebugLevel$107$Entry#1:
    goto inline$BDLGetDebugLevel$107$start#1;

  inline$BDLGetDebugLevel$107$start#1:
    goto inline$BDLGetDebugLevel$107$label_3#1;

  inline$BDLGetDebugLevel$107$label_3#1:
    havoc inline$BDLGetDebugLevel$107$myNondetVar_0;
    inline$BDLGetDebugLevel$107$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$107$myNondetVar_0;
    goto inline$BDLGetDebugLevel$107$label_1#1;

  inline$BDLGetDebugLevel$107$label_1#1:
    goto inline$BDLGetDebugLevel$107$Return#1;

  inline$BDLGetDebugLevel$107$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$19$ := inline$BDLGetDebugLevel$107$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_152$1#1;

  inline$BDLPnPStart$0$label_152$1#1:
    goto inline$BDLPnPStart$0$anon52_Then#1, inline$BDLPnPStart$0$anon52_Else#1;

  inline$BDLPnPStart$0$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon33#1;

  inline$BDLPnPStart$0$anon33#1:
    goto inline$BDLPnPStart$0$label_161#1;

  inline$BDLPnPStart$0$label_161#1:
    goto inline$BDLPnPStart$0$label_161_true#1, inline$BDLPnPStart$0$label_161_false#1;

  inline$BDLPnPStart$0$label_161_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$19$) == 0;
    goto inline$BDLPnPStart$0$label_162#1;

  inline$BDLPnPStart$0$label_161_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$19$) != 0;
    goto inline$BDLPnPStart$0$label_165#1;

  inline$BDLPnPStart$0$label_165#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_166#1;

  inline$BDLPnPStart$0$label_166#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_167#1;

  inline$BDLPnPStart$0$label_167#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_168#1;

  inline$BDLPnPStart$0$label_168#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$1979.0$20$;
    goto inline$BDLPnPStart$0$label_162#1;

  inline$BDLPnPStart$0$label_162#1:
    goto inline$BDLGetDebugLevel$108$Entry#1;

  inline$BDLGetDebugLevel$108$Entry#1:
    goto inline$BDLGetDebugLevel$108$start#1;

  inline$BDLGetDebugLevel$108$start#1:
    goto inline$BDLGetDebugLevel$108$label_3#1;

  inline$BDLGetDebugLevel$108$label_3#1:
    havoc inline$BDLGetDebugLevel$108$myNondetVar_0;
    inline$BDLGetDebugLevel$108$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$108$myNondetVar_0;
    goto inline$BDLGetDebugLevel$108$label_1#1;

  inline$BDLGetDebugLevel$108$label_1#1:
    goto inline$BDLGetDebugLevel$108$Return#1;

  inline$BDLGetDebugLevel$108$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$24$ := inline$BDLGetDebugLevel$108$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_162$1#1;

  inline$BDLPnPStart$0$label_162$1#1:
    goto inline$BDLPnPStart$0$anon53_Then#1, inline$BDLPnPStart$0$anon53_Else#1;

  inline$BDLPnPStart$0$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon35#1;

  inline$BDLPnPStart$0$anon35#1:
    goto inline$BDLPnPStart$0$label_171#1;

  inline$BDLPnPStart$0$label_171#1:
    goto inline$BDLPnPStart$0$label_171_true#1, inline$BDLPnPStart$0$label_171_false#1;

  inline$BDLPnPStart$0$label_171_false#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$24$, 4) == 0;
    goto inline$BDLPnPStart$0$label_77#1;

  inline$BDLPnPStart$0$label_171_true#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$1979.0$24$, 4) != 0;
    goto inline$BDLPnPStart$0$label_172#1;

  inline$BDLPnPStart$0$label_172#1:
    goto inline$BDLPnPStart$0$label_77#1;

  inline$BDLPnPStart$0$anon53_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon52_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon40_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$label_37_true#1:
    assume INT_LEQ(0, inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16);
    goto inline$BDLPnPStart$0$label_41#1;

  inline$BDLPnPStart$0$label_41#1:
    havoc inline$BDLPnPStart$0$$result.memset$1992.4$25$;
    goto inline$BDLPnPStart$0$label_44#1;

  inline$BDLPnPStart$0$label_44#1:
    goto inline$BDLPnPStart$0$label_45#1;

  inline$BDLPnPStart$0$label_45#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_46#1;

  inline$BDLPnPStart$0$label_46#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_47#1;

  inline$BDLPnPStart$0$label_47#1:
    goto inline$BDLPnPStart$0$label_50#1;

  inline$BDLPnPStart$0$label_50#1:
    inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 := inline$BDLPnPStart$0$$callresult.$1999.70$26$;
    goto inline$BDLPnPStart$0$label_51#1;

  inline$BDLPnPStart$0$label_51#1:
    goto inline$BDLPnPStart$0$label_51_true#1, inline$BDLPnPStart$0$label_51_false#1;

  inline$BDLPnPStart$0$label_51_false#1:
    assume inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 == 0;
    goto inline$BDLPnPStart$0$label_52#1;

  inline$BDLPnPStart$0$label_52#1:
    goto inline$BDLPnPStart$0$label_104#1;

  inline$BDLPnPStart$0$label_104#1:
    goto inline$BDLPnPStart$0$label_105#1;

  inline$BDLPnPStart$0$label_105#1:
    havoc inline$BDLPnPStart$0$$result.memcpy$2018.0$38$;
    goto inline$BDLPnPStart$0$label_108#1;

  inline$BDLPnPStart$0$label_108#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_109#1;

  inline$BDLPnPStart$0$label_109#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_110#1;

  inline$BDLPnPStart$0$label_110#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_111#1;

  inline$BDLPnPStart$0$label_111#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_112#1;

  inline$BDLPnPStart$0$label_112#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_113#1;

  inline$BDLPnPStart$0$label_113#1:
    havoc inline$BDLPnPStart$0$myNondetVar_0;
    goto inline$BDLPnPStart$0$label_114#1;

  inline$BDLPnPStart$0$label_114#1:
    call inline$BDLPnPStart$0$$result.IoSetDeviceInterfaceState$2033.38$41$ := IoSetDeviceInterfaceState(SymbolicLinkName__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16), 1);
    goto inline$BDLPnPStart$0$anon47_Then#1, inline$BDLPnPStart$0$anon47_Else#1;

  inline$BDLPnPStart$0$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon23#1;

  inline$BDLPnPStart$0$anon23#1:
    goto inline$BDLPnPStart$0$label_117#1;

  inline$BDLPnPStart$0$label_117#1:
    inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 := inline$BDLPnPStart$0$$result.IoSetDeviceInterfaceState$2033.38$41$;
    goto inline$BDLPnPStart$0$label_118#1;

  inline$BDLPnPStart$0$label_118#1:
    goto inline$BDLPnPStart$0$label_118_true#1, inline$BDLPnPStart$0$label_118_false#1;

  inline$BDLPnPStart$0$label_118_false#1:
    assume inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 == 0;
    goto inline$BDLPnPStart$0$label_119#1;

  inline$BDLPnPStart$0$label_119#1:
    goto inline$BDLPnPStart$0$label_148#1;

  inline$BDLPnPStart$0$label_148#1:
    goto inline$storm_KeSetEvent$4$Entry#1;

  inline$storm_KeSetEvent$4$Entry#1:
    inline$storm_KeSetEvent$4$$Event$1$213.14$storm_KeSetEvent$12_.1 := DeviceStartedEvent__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnPStart$0$$pBDLExtension$1$1956.40$BDLPnPStart$16);
    goto inline$storm_KeSetEvent$4$start#1;

  inline$storm_KeSetEvent$4$start#1:
    inline$storm_KeSetEvent$4$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$4$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$4$label_3#1;

  inline$storm_KeSetEvent$4$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$4$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$4$label_1#1;

  inline$storm_KeSetEvent$4$label_1#1:
    goto inline$storm_KeSetEvent$4$Return#1;

  inline$storm_KeSetEvent$4$Return#1:
    goto inline$BDLPnPStart$0$label_148$1#1;

  inline$BDLPnPStart$0$label_148$1#1:
    goto inline$BDLPnPStart$0$anon51_Then#1, inline$BDLPnPStart$0$anon51_Else#1;

  inline$BDLPnPStart$0$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon31#1;

  inline$BDLPnPStart$0$anon31#1:
    goto inline$BDLPnPStart$0$label_77#1;

  inline$BDLPnPStart$0$anon51_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$label_118_true#1:
    assume inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 != 0;
    goto inline$BDLPnPStart$0$label_120#1;

  inline$BDLPnPStart$0$label_120#1:
    goto inline$BDLGetDebugLevel$104$Entry#1;

  inline$BDLGetDebugLevel$104$Entry#1:
    goto inline$BDLGetDebugLevel$104$start#1;

  inline$BDLGetDebugLevel$104$start#1:
    goto inline$BDLGetDebugLevel$104$label_3#1;

  inline$BDLGetDebugLevel$104$label_3#1:
    havoc inline$BDLGetDebugLevel$104$myNondetVar_0;
    inline$BDLGetDebugLevel$104$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$104$myNondetVar_0;
    goto inline$BDLGetDebugLevel$104$label_1#1;

  inline$BDLGetDebugLevel$104$label_1#1:
    goto inline$BDLGetDebugLevel$104$Return#1;

  inline$BDLGetDebugLevel$104$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$42$ := inline$BDLGetDebugLevel$104$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_120$1#1;

  inline$BDLPnPStart$0$label_120$1#1:
    goto inline$BDLPnPStart$0$anon48_Then#1, inline$BDLPnPStart$0$anon48_Else#1;

  inline$BDLPnPStart$0$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon25#1;

  inline$BDLPnPStart$0$anon25#1:
    goto inline$BDLPnPStart$0$label_123#1;

  inline$BDLPnPStart$0$label_123#1:
    goto inline$BDLPnPStart$0$label_123_true#1, inline$BDLPnPStart$0$label_123_false#1;

  inline$BDLPnPStart$0$label_123_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$42$) == 0;
    goto inline$BDLPnPStart$0$label_124#1;

  inline$BDLPnPStart$0$label_123_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$42$) != 0;
    goto inline$BDLPnPStart$0$label_127#1;

  inline$BDLPnPStart$0$label_127#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_128#1;

  inline$BDLPnPStart$0$label_128#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_129#1;

  inline$BDLPnPStart$0$label_129#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_130#1;

  inline$BDLPnPStart$0$label_130#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$2037.0$43$;
    goto inline$BDLPnPStart$0$label_124#1;

  inline$BDLPnPStart$0$label_124#1:
    goto inline$BDLGetDebugLevel$105$Entry#1;

  inline$BDLGetDebugLevel$105$Entry#1:
    goto inline$BDLGetDebugLevel$105$start#1;

  inline$BDLGetDebugLevel$105$start#1:
    goto inline$BDLGetDebugLevel$105$label_3#1;

  inline$BDLGetDebugLevel$105$label_3#1:
    havoc inline$BDLGetDebugLevel$105$myNondetVar_0;
    inline$BDLGetDebugLevel$105$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$105$myNondetVar_0;
    goto inline$BDLGetDebugLevel$105$label_1#1;

  inline$BDLGetDebugLevel$105$label_1#1:
    goto inline$BDLGetDebugLevel$105$Return#1;

  inline$BDLGetDebugLevel$105$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$47$ := inline$BDLGetDebugLevel$105$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_124$1#1;

  inline$BDLPnPStart$0$label_124$1#1:
    goto inline$BDLPnPStart$0$anon49_Then#1, inline$BDLPnPStart$0$anon49_Else#1;

  inline$BDLPnPStart$0$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon27#1;

  inline$BDLPnPStart$0$anon27#1:
    goto inline$BDLPnPStart$0$label_133#1;

  inline$BDLPnPStart$0$label_133#1:
    goto inline$BDLPnPStart$0$label_133_true#1, inline$BDLPnPStart$0$label_133_false#1;

  inline$BDLPnPStart$0$label_133_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$47$) == 0;
    goto inline$BDLPnPStart$0$label_134#1;

  inline$BDLPnPStart$0$label_133_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$47$) != 0;
    goto inline$BDLPnPStart$0$label_137#1;

  inline$BDLPnPStart$0$label_137#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_138#1;

  inline$BDLPnPStart$0$label_138#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_139#1;

  inline$BDLPnPStart$0$label_139#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_140#1;

  inline$BDLPnPStart$0$label_140#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$2037.0$48$;
    goto inline$BDLPnPStart$0$label_134#1;

  inline$BDLPnPStart$0$label_134#1:
    goto inline$BDLGetDebugLevel$106$Entry#1;

  inline$BDLGetDebugLevel$106$Entry#1:
    goto inline$BDLGetDebugLevel$106$start#1;

  inline$BDLGetDebugLevel$106$start#1:
    goto inline$BDLGetDebugLevel$106$label_3#1;

  inline$BDLGetDebugLevel$106$label_3#1:
    havoc inline$BDLGetDebugLevel$106$myNondetVar_0;
    inline$BDLGetDebugLevel$106$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$106$myNondetVar_0;
    goto inline$BDLGetDebugLevel$106$label_1#1;

  inline$BDLGetDebugLevel$106$label_1#1:
    goto inline$BDLGetDebugLevel$106$Return#1;

  inline$BDLGetDebugLevel$106$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$52$ := inline$BDLGetDebugLevel$106$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_134$1#1;

  inline$BDLPnPStart$0$label_134$1#1:
    goto inline$BDLPnPStart$0$anon50_Then#1, inline$BDLPnPStart$0$anon50_Else#1;

  inline$BDLPnPStart$0$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon29#1;

  inline$BDLPnPStart$0$anon29#1:
    goto inline$BDLPnPStart$0$label_143#1;

  inline$BDLPnPStart$0$label_143#1:
    goto inline$BDLPnPStart$0$label_143_true#1, inline$BDLPnPStart$0$label_143_false#1;

  inline$BDLPnPStart$0$label_143_false#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$52$, 4) == 0;
    goto inline$BDLPnPStart$0$label_144#1;

  inline$BDLPnPStart$0$label_143_true#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2037.0$52$, 4) != 0;
    goto inline$BDLPnPStart$0$label_147#1;

  inline$BDLPnPStart$0$label_147#1:
    goto inline$BDLPnPStart$0$label_144#1;

  inline$BDLPnPStart$0$label_144#1:
    goto inline$BDLPnPStart$0$label_77#1;

  inline$BDLPnPStart$0$anon50_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon49_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon48_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon47_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$label_51_true#1:
    assume inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16 != 0;
    goto inline$BDLPnPStart$0$label_53#1;

  inline$BDLPnPStart$0$label_53#1:
    goto inline$BDLGetDebugLevel$98$Entry#1;

  inline$BDLGetDebugLevel$98$Entry#1:
    goto inline$BDLGetDebugLevel$98$start#1;

  inline$BDLGetDebugLevel$98$start#1:
    goto inline$BDLGetDebugLevel$98$label_3#1;

  inline$BDLGetDebugLevel$98$label_3#1:
    havoc inline$BDLGetDebugLevel$98$myNondetVar_0;
    inline$BDLGetDebugLevel$98$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$98$myNondetVar_0;
    goto inline$BDLGetDebugLevel$98$label_1#1;

  inline$BDLGetDebugLevel$98$label_1#1:
    goto inline$BDLGetDebugLevel$98$Return#1;

  inline$BDLGetDebugLevel$98$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$27$ := inline$BDLGetDebugLevel$98$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_53$1#1;

  inline$BDLPnPStart$0$label_53$1#1:
    goto inline$BDLPnPStart$0$anon41_Then#1, inline$BDLPnPStart$0$anon41_Else#1;

  inline$BDLPnPStart$0$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon11#1;

  inline$BDLPnPStart$0$anon11#1:
    goto inline$BDLPnPStart$0$label_56#1;

  inline$BDLPnPStart$0$label_56#1:
    goto inline$BDLPnPStart$0$label_56_true#1, inline$BDLPnPStart$0$label_56_false#1;

  inline$BDLPnPStart$0$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$27$) == 0;
    goto inline$BDLPnPStart$0$label_57#1;

  inline$BDLPnPStart$0$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$27$) != 0;
    goto inline$BDLPnPStart$0$label_60#1;

  inline$BDLPnPStart$0$label_60#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_61#1;

  inline$BDLPnPStart$0$label_61#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_62#1;

  inline$BDLPnPStart$0$label_62#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_63#1;

  inline$BDLPnPStart$0$label_63#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$2005.0$28$;
    goto inline$BDLPnPStart$0$label_57#1;

  inline$BDLPnPStart$0$label_57#1:
    goto inline$BDLGetDebugLevel$99$Entry#1;

  inline$BDLGetDebugLevel$99$Entry#1:
    goto inline$BDLGetDebugLevel$99$start#1;

  inline$BDLGetDebugLevel$99$start#1:
    goto inline$BDLGetDebugLevel$99$label_3#1;

  inline$BDLGetDebugLevel$99$label_3#1:
    havoc inline$BDLGetDebugLevel$99$myNondetVar_0;
    inline$BDLGetDebugLevel$99$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$99$myNondetVar_0;
    goto inline$BDLGetDebugLevel$99$label_1#1;

  inline$BDLGetDebugLevel$99$label_1#1:
    goto inline$BDLGetDebugLevel$99$Return#1;

  inline$BDLGetDebugLevel$99$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$32$ := inline$BDLGetDebugLevel$99$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_57$1#1;

  inline$BDLPnPStart$0$label_57$1#1:
    goto inline$BDLPnPStart$0$anon42_Then#1, inline$BDLPnPStart$0$anon42_Else#1;

  inline$BDLPnPStart$0$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon13#1;

  inline$BDLPnPStart$0$anon13#1:
    goto inline$BDLPnPStart$0$label_66#1;

  inline$BDLPnPStart$0$label_66#1:
    goto inline$BDLPnPStart$0$label_66_true#1, inline$BDLPnPStart$0$label_66_false#1;

  inline$BDLPnPStart$0$label_66_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$32$) == 0;
    goto inline$BDLPnPStart$0$label_67#1;

  inline$BDLPnPStart$0$label_66_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$32$) != 0;
    goto inline$BDLPnPStart$0$label_70#1;

  inline$BDLPnPStart$0$label_70#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_71#1;

  inline$BDLPnPStart$0$label_71#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_72#1;

  inline$BDLPnPStart$0$label_72#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_73#1;

  inline$BDLPnPStart$0$label_73#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$2005.0$33$;
    goto inline$BDLPnPStart$0$label_67#1;

  inline$BDLPnPStart$0$label_67#1:
    goto inline$BDLGetDebugLevel$100$Entry#1;

  inline$BDLGetDebugLevel$100$Entry#1:
    goto inline$BDLGetDebugLevel$100$start#1;

  inline$BDLGetDebugLevel$100$start#1:
    goto inline$BDLGetDebugLevel$100$label_3#1;

  inline$BDLGetDebugLevel$100$label_3#1:
    havoc inline$BDLGetDebugLevel$100$myNondetVar_0;
    inline$BDLGetDebugLevel$100$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$100$myNondetVar_0;
    goto inline$BDLGetDebugLevel$100$label_1#1;

  inline$BDLGetDebugLevel$100$label_1#1:
    goto inline$BDLGetDebugLevel$100$Return#1;

  inline$BDLGetDebugLevel$100$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$37$ := inline$BDLGetDebugLevel$100$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_67$1#1;

  inline$BDLPnPStart$0$label_67$1#1:
    goto inline$BDLPnPStart$0$anon43_Then#1, inline$BDLPnPStart$0$anon43_Else#1;

  inline$BDLPnPStart$0$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon15#1;

  inline$BDLPnPStart$0$anon15#1:
    goto inline$BDLPnPStart$0$label_76#1;

  inline$BDLPnPStart$0$label_76#1:
    goto inline$BDLPnPStart$0$label_76_true#1, inline$BDLPnPStart$0$label_76_false#1;

  inline$BDLPnPStart$0$label_76_false#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$37$, 4) == 0;
    goto inline$BDLPnPStart$0$label_77#1;

  inline$BDLPnPStart$0$label_76_true#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2005.0$37$, 4) != 0;
    goto inline$BDLPnPStart$0$label_80#1;

  inline$BDLPnPStart$0$label_80#1:
    goto inline$BDLPnPStart$0$label_77#1;

  inline$BDLPnPStart$0$label_77#1:
    goto inline$BDLGetDebugLevel$101$Entry#1;

  inline$BDLGetDebugLevel$101$Entry#1:
    goto inline$BDLGetDebugLevel$101$start#1;

  inline$BDLGetDebugLevel$101$start#1:
    goto inline$BDLGetDebugLevel$101$label_3#1;

  inline$BDLGetDebugLevel$101$label_3#1:
    havoc inline$BDLGetDebugLevel$101$myNondetVar_0;
    inline$BDLGetDebugLevel$101$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$101$myNondetVar_0;
    goto inline$BDLGetDebugLevel$101$label_1#1;

  inline$BDLGetDebugLevel$101$label_1#1:
    goto inline$BDLGetDebugLevel$101$Return#1;

  inline$BDLGetDebugLevel$101$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$55$ := inline$BDLGetDebugLevel$101$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_77$1#1;

  inline$BDLPnPStart$0$label_77$1#1:
    goto inline$BDLPnPStart$0$anon44_Then#1, inline$BDLPnPStart$0$anon44_Else#1;

  inline$BDLPnPStart$0$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon17#1;

  inline$BDLPnPStart$0$anon17#1:
    goto inline$BDLPnPStart$0$label_81#1;

  inline$BDLPnPStart$0$label_81#1:
    goto inline$BDLPnPStart$0$label_81_true#1, inline$BDLPnPStart$0$label_81_false#1;

  inline$BDLPnPStart$0$label_81_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$55$) == 0;
    goto inline$BDLPnPStart$0$label_82#1;

  inline$BDLPnPStart$0$label_81_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$55$) != 0;
    goto inline$BDLPnPStart$0$label_85#1;

  inline$BDLPnPStart$0$label_85#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_86#1;

  inline$BDLPnPStart$0$label_86#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_87#1;

  inline$BDLPnPStart$0$label_87#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_88#1;

  inline$BDLPnPStart$0$label_88#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$2063.0$56$;
    goto inline$BDLPnPStart$0$label_82#1;

  inline$BDLPnPStart$0$label_82#1:
    goto inline$BDLGetDebugLevel$102$Entry#1;

  inline$BDLGetDebugLevel$102$Entry#1:
    goto inline$BDLGetDebugLevel$102$start#1;

  inline$BDLGetDebugLevel$102$start#1:
    goto inline$BDLGetDebugLevel$102$label_3#1;

  inline$BDLGetDebugLevel$102$label_3#1:
    havoc inline$BDLGetDebugLevel$102$myNondetVar_0;
    inline$BDLGetDebugLevel$102$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$102$myNondetVar_0;
    goto inline$BDLGetDebugLevel$102$label_1#1;

  inline$BDLGetDebugLevel$102$label_1#1:
    goto inline$BDLGetDebugLevel$102$Return#1;

  inline$BDLGetDebugLevel$102$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$60$ := inline$BDLGetDebugLevel$102$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_82$1#1;

  inline$BDLPnPStart$0$label_82$1#1:
    goto inline$BDLPnPStart$0$anon45_Then#1, inline$BDLPnPStart$0$anon45_Else#1;

  inline$BDLPnPStart$0$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon19#1;

  inline$BDLPnPStart$0$anon19#1:
    goto inline$BDLPnPStart$0$label_91#1;

  inline$BDLPnPStart$0$label_91#1:
    goto inline$BDLPnPStart$0$label_91_true#1, inline$BDLPnPStart$0$label_91_false#1;

  inline$BDLPnPStart$0$label_91_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$60$) == 0;
    goto inline$BDLPnPStart$0$label_92#1;

  inline$BDLPnPStart$0$label_91_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$60$) != 0;
    goto inline$BDLPnPStart$0$label_95#1;

  inline$BDLPnPStart$0$label_95#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_96#1;

  inline$BDLPnPStart$0$label_96#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_97#1;

  inline$BDLPnPStart$0$label_97#1:
    call inline$BDLPnPStart$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnPStart$0$label_98#1;

  inline$BDLPnPStart$0$label_98#1:
    havoc inline$BDLPnPStart$0$$result.DbgPrint$2063.0$61$;
    goto inline$BDLPnPStart$0$label_92#1;

  inline$BDLPnPStart$0$label_92#1:
    goto inline$BDLGetDebugLevel$103$Entry#1;

  inline$BDLGetDebugLevel$103$Entry#1:
    goto inline$BDLGetDebugLevel$103$start#1;

  inline$BDLGetDebugLevel$103$start#1:
    goto inline$BDLGetDebugLevel$103$label_3#1;

  inline$BDLGetDebugLevel$103$label_3#1:
    havoc inline$BDLGetDebugLevel$103$myNondetVar_0;
    inline$BDLGetDebugLevel$103$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$103$myNondetVar_0;
    goto inline$BDLGetDebugLevel$103$label_1#1;

  inline$BDLGetDebugLevel$103$label_1#1:
    goto inline$BDLGetDebugLevel$103$Return#1;

  inline$BDLGetDebugLevel$103$Return#1:
    inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$65$ := inline$BDLGetDebugLevel$103$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnPStart$0$label_92$1#1;

  inline$BDLPnPStart$0$label_92$1#1:
    goto inline$BDLPnPStart$0$anon46_Then#1, inline$BDLPnPStart$0$anon46_Else#1;

  inline$BDLPnPStart$0$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLPnPStart$0$anon21#1;

  inline$BDLPnPStart$0$anon21#1:
    goto inline$BDLPnPStart$0$label_101#1;

  inline$BDLPnPStart$0$label_101#1:
    goto inline$BDLPnPStart$0$label_101_true#1, inline$BDLPnPStart$0$label_101_false#1;

  inline$BDLPnPStart$0$label_101_false#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$65$, 4) == 0;
    goto inline$BDLPnPStart$0$label_102#1;

  inline$BDLPnPStart$0$label_101_true#1:
    assume BIT_BAND(inline$BDLPnPStart$0$$result.BDLGetDebugLevel$2063.0$65$, 4) != 0;
    goto inline$BDLPnPStart$0$label_103#1;

  inline$BDLPnPStart$0$label_103#1:
    goto inline$BDLPnPStart$0$label_102#1;

  inline$BDLPnPStart$0$label_102#1:
    inline$BDLPnPStart$0$$result.BDLPnPStart$1954.0$1$ := inline$BDLPnPStart$0$$status$5$1962.32$BDLPnPStart$16;
    goto inline$BDLPnPStart$0$label_1#1;

  inline$BDLPnPStart$0$label_1#1:
    call __HAVOC_free(inline$BDLPnPStart$0$$bdsiInitializeResourcesParams$7$1964.32$BDLPnPStart$16);
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon46_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon45_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon44_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon43_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon42_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon41_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon39_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon38_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon37_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$anon36_Then#1:
    assume raiseException;
    goto inline$BDLPnPStart$0$Return#1;

  inline$BDLPnPStart$0$Return#1:
    inline$BDLPnP$0$$result.BDLPnPStart$906.28$28$ := inline$BDLPnPStart$0$$result.BDLPnPStart$1954.0$1$;
    goto inline$BDLPnP$0$label_113$1#1;

  inline$BDLPnP$0$label_113$1#1:
    goto inline$BDLPnP$0$anon67_Then#1, inline$BDLPnP$0$anon67_Else#1;

  inline$BDLPnP$0$anon67_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon27#1;

  inline$BDLPnP$0$anon27#1:
    goto inline$BDLPnP$0$label_155#1;

  inline$BDLPnP$0$label_155#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.BDLPnPStart$906.28$28$;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$anon67_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_52_case_0#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 0;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 1;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 2;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 3;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 4;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 5;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 6;
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume inline$BDLPnP$0$myNondetVar_0 != 23;
    goto inline$BDLPnP$0$label_110#1;

  inline$BDLPnP$0$label_110#1:
    goto inline$BDLGetDebugLevel$9$Entry#1;

  inline$BDLGetDebugLevel$9$Entry#1:
    goto inline$BDLGetDebugLevel$9$start#1;

  inline$BDLGetDebugLevel$9$start#1:
    goto inline$BDLGetDebugLevel$9$label_3#1;

  inline$BDLGetDebugLevel$9$label_3#1:
    havoc inline$BDLGetDebugLevel$9$myNondetVar_0;
    inline$BDLGetDebugLevel$9$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$9$myNondetVar_0;
    goto inline$BDLGetDebugLevel$9$label_1#1;

  inline$BDLGetDebugLevel$9$label_1#1:
    goto inline$BDLGetDebugLevel$9$Return#1;

  inline$BDLGetDebugLevel$9$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$36$ := inline$BDLGetDebugLevel$9$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_110$1#1;

  inline$BDLPnP$0$label_110$1#1:
    goto inline$BDLPnP$0$anon66_Then#1, inline$BDLPnP$0$anon66_Else#1;

  inline$BDLPnP$0$anon66_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon25#1;

  inline$BDLPnP$0$anon25#1:
    goto inline$BDLPnP$0$label_156#1;

  inline$BDLPnP$0$label_156#1:
    goto inline$BDLPnP$0$label_156_true#1, inline$BDLPnP$0$label_156_false#1;

  inline$BDLPnP$0$label_156_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$36$) == 0;
    goto inline$BDLPnP$0$label_157#1;

  inline$BDLPnP$0$label_156_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$36$) != 0;
    goto inline$BDLPnP$0$label_160#1;

  inline$BDLPnP$0$label_160#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_161#1;

  inline$BDLPnP$0$label_161#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_162#1;

  inline$BDLPnP$0$label_162#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_163#1;

  inline$BDLPnP$0$label_163#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$987.0$37$;
    goto inline$BDLPnP$0$label_157#1;

  inline$BDLPnP$0$label_157#1:
    goto inline$BDLGetDebugLevel$739$Entry#1;

  inline$BDLGetDebugLevel$739$Entry#1:
    goto inline$BDLGetDebugLevel$739$start#1;

  inline$BDLGetDebugLevel$739$start#1:
    goto inline$BDLGetDebugLevel$739$label_3#1;

  inline$BDLGetDebugLevel$739$label_3#1:
    havoc inline$BDLGetDebugLevel$739$myNondetVar_0;
    inline$BDLGetDebugLevel$739$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$739$myNondetVar_0;
    goto inline$BDLGetDebugLevel$739$label_1#1;

  inline$BDLGetDebugLevel$739$label_1#1:
    goto inline$BDLGetDebugLevel$739$Return#1;

  inline$BDLGetDebugLevel$739$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$41$ := inline$BDLGetDebugLevel$739$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_157$1#1;

  inline$BDLPnP$0$label_157$1#1:
    goto inline$BDLPnP$0$anon77_Then#1, inline$BDLPnP$0$anon77_Else#1;

  inline$BDLPnP$0$anon77_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon47#1;

  inline$BDLPnP$0$anon47#1:
    goto inline$BDLPnP$0$label_166#1;

  inline$BDLPnP$0$label_166#1:
    goto inline$BDLPnP$0$label_166_true#1, inline$BDLPnP$0$label_166_false#1;

  inline$BDLPnP$0$label_166_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$41$) == 0;
    goto inline$BDLPnP$0$label_167#1;

  inline$BDLPnP$0$label_166_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$41$) != 0;
    goto inline$BDLPnP$0$label_170#1;

  inline$BDLPnP$0$label_170#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_171#1;

  inline$BDLPnP$0$label_171#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_172#1;

  inline$BDLPnP$0$label_172#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_173#1;

  inline$BDLPnP$0$label_173#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$987.0$42$;
    goto inline$BDLPnP$0$label_167#1;

  inline$BDLPnP$0$label_167#1:
    goto inline$BDLGetDebugLevel$740$Entry#1;

  inline$BDLGetDebugLevel$740$Entry#1:
    goto inline$BDLGetDebugLevel$740$start#1;

  inline$BDLGetDebugLevel$740$start#1:
    goto inline$BDLGetDebugLevel$740$label_3#1;

  inline$BDLGetDebugLevel$740$label_3#1:
    havoc inline$BDLGetDebugLevel$740$myNondetVar_0;
    inline$BDLGetDebugLevel$740$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$740$myNondetVar_0;
    goto inline$BDLGetDebugLevel$740$label_1#1;

  inline$BDLGetDebugLevel$740$label_1#1:
    goto inline$BDLGetDebugLevel$740$Return#1;

  inline$BDLGetDebugLevel$740$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$46$ := inline$BDLGetDebugLevel$740$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_167$1#1;

  inline$BDLPnP$0$label_167$1#1:
    goto inline$BDLPnP$0$anon78_Then#1, inline$BDLPnP$0$anon78_Else#1;

  inline$BDLPnP$0$anon78_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon49#1;

  inline$BDLPnP$0$anon49#1:
    goto inline$BDLPnP$0$label_176#1;

  inline$BDLPnP$0$label_176#1:
    goto inline$BDLPnP$0$label_176_true#1, inline$BDLPnP$0$label_176_false#1;

  inline$BDLPnP$0$label_176_false#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$46$, 4) == 0;
    goto inline$BDLPnP$0$label_177#1;

  inline$BDLPnP$0$label_176_true#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$987.0$46$, 4) != 0;
    goto inline$BDLPnP$0$label_180#1;

  inline$BDLPnP$0$label_180#1:
    goto inline$BDLPnP$0$label_177#1;

  inline$BDLPnP$0$label_177#1:
    goto inline$IoSkipCurrentIrpStackLocation$2$Entry#1;

  inline$IoSkipCurrentIrpStackLocation$2$Entry#1:
    inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$IoSkipCurrentIrpStackLocation$2$start#1;

  inline$IoSkipCurrentIrpStackLocation$2$start#1:
    inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4 := inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4_.1;
    goto inline$IoSkipCurrentIrpStackLocation$2$label_3#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_3#1:
    goto inline$IoSkipCurrentIrpStackLocation$2$label_3_true#1, inline$IoSkipCurrentIrpStackLocation$2$label_3_false#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_3_false#1:
    inline$IoSkipCurrentIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$2$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoSkipCurrentIrpStackLocation$2$myVar_0, inline$IoSkipCurrentIrpStackLocation$2$myVar_1);
    goto inline$IoSkipCurrentIrpStackLocation$2$label_4#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_4#1:
    call inline$IoSkipCurrentIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSkipCurrentIrpStackLocation$2$label_7#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_7#1:
    call inline$IoSkipCurrentIrpStackLocation$2$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSkipCurrentIrpStackLocation$2$label_8#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_8#1:
    goto inline$IoSkipCurrentIrpStackLocation$2$label_5#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_3_true#1:
    inline$IoSkipCurrentIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$2$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoSkipCurrentIrpStackLocation$2$myVar_0, inline$IoSkipCurrentIrpStackLocation$2$myVar_1);
    goto inline$IoSkipCurrentIrpStackLocation$2$label_5#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_5#1:
    inline$IoSkipCurrentIrpStackLocation$2$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSkipCurrentIrpStackLocation$2$tempBoogie0 := PLUS(inline$IoSkipCurrentIrpStackLocation$2$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSkipCurrentIrpStackLocation$2$$Irp$1$25117.17$IoSkipCurrentIrpStackLocation$4) := inline$IoSkipCurrentIrpStackLocation$2$tempBoogie0];
    call contextSwitch();
    goto inline$IoSkipCurrentIrpStackLocation$2$label_6#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_6#1:
    havoc inline$IoSkipCurrentIrpStackLocation$2$myNondetVar_0;
    inline$IoSkipCurrentIrpStackLocation$2$tempBoogie0 := PLUS(inline$IoSkipCurrentIrpStackLocation$2$myNondetVar_0, 36, 1);
    goto inline$IoSkipCurrentIrpStackLocation$2$label_1#1;

  inline$IoSkipCurrentIrpStackLocation$2$label_1#1:
    goto inline$IoSkipCurrentIrpStackLocation$2$Return#1;

  inline$IoSkipCurrentIrpStackLocation$2$Return#1:
    goto inline$BDLPnP$0$label_177$1#1;

  inline$BDLPnP$0$label_177$1#1:
    goto inline$BDLPnP$0$anon79_Then#1, inline$BDLPnP$0$anon79_Else#1;

  inline$BDLPnP$0$anon79_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon51#1;

  inline$BDLPnP$0$anon51#1:
    goto inline$BDLPnP$0$label_181#1;

  inline$BDLPnP$0$label_181#1:
    goto inline$storm_IoCallDriver$14$Entry#1;

  inline$storm_IoCallDriver$14$Entry#1:
    inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$storm_IoCallDriver$14$start#1;

  inline$storm_IoCallDriver$14$start#1:
    inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8 := inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8_.1;
    goto inline$storm_IoCallDriver$14$label_3#1;

  inline$storm_IoCallDriver$14$label_3#1:
    goto inline$storm_IoCallDriver$14$label_4#1;

  inline$storm_IoCallDriver$14$label_4#1:
    goto inline$storm_IoCallDriver$14$label_5#1;

  inline$storm_IoCallDriver$14$label_5#1:
    goto inline$storm_IoCallDriver$14$label_6#1;

  inline$storm_IoCallDriver$14$label_6#1:
    call inline$storm_IoCallDriver$14$$result.storm_nondet$465.2$2$ := storm_nondet();
    goto inline$storm_IoCallDriver$14$label_9#1;

  inline$storm_IoCallDriver$14$label_9#1:
    goto inline$storm_IoCallDriver$14$label_9_true#1, inline$storm_IoCallDriver$14$label_9_false#1;

  inline$storm_IoCallDriver$14$label_9_false#1:
    assume inline$storm_IoCallDriver$14$$result.storm_nondet$465.2$2$ == 0;
    goto inline$storm_IoCallDriver$14$label_10#1;

  inline$storm_IoCallDriver$14$label_9_true#1:
    assume inline$storm_IoCallDriver$14$$result.storm_nondet$465.2$2$ != 0;
    goto inline$storm_IoCallDriver$14$label_13#1;

  inline$storm_IoCallDriver$14$label_13#1:
    havoc raiseException;
    goto inline$storm_IoCallDriver$14$anon12_Then#1, inline$storm_IoCallDriver$14$anon12_Else#1;

  inline$storm_IoCallDriver$14$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$14$anon3#1;

  inline$storm_IoCallDriver$14$anon3#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8], 1);
    call contextSwitch();
    goto inline$storm_IoCallDriver$14$label_14#1;

  inline$storm_IoCallDriver$14$label_14#1:
    goto inline$storm_IoCallDriver$14$label_14_true#1, inline$storm_IoCallDriver$14$label_14_false#1;

  inline$storm_IoCallDriver$14$label_14_false#1:
    assume 0 == 0;
    goto inline$storm_IoCallDriver$14$label_15#1;

  inline$storm_IoCallDriver$14$label_15#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCallDriver$14$label_1#1;

  inline$storm_IoCallDriver$14$label_14_true#1:
    assume 0 != 0;
    goto inline$storm_IoCallDriver$14$label_10#1;

  inline$storm_IoCallDriver$14$label_10#1:
    goto inline$IoSetNextIrpStackLocation$15$Entry#1;

  inline$IoSetNextIrpStackLocation$15$Entry#1:
    inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1 := inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoSetNextIrpStackLocation$15$start#1;

  inline$IoSetNextIrpStackLocation$15$start#1:
    inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4 := inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4_.1;
    goto inline$IoSetNextIrpStackLocation$15$label_3#1;

  inline$IoSetNextIrpStackLocation$15$label_3#1:
    goto inline$IoSetNextIrpStackLocation$15$label_3_true#1, inline$IoSetNextIrpStackLocation$15$label_3_false#1;

  inline$IoSetNextIrpStackLocation$15$label_3_false#1:
    inline$IoSetNextIrpStackLocation$15$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LT(0, inline$IoSetNextIrpStackLocation$15$myVar_0);
    goto inline$IoSetNextIrpStackLocation$15$label_4#1;

  inline$IoSetNextIrpStackLocation$15$label_4#1:
    call inline$IoSetNextIrpStackLocation$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$15$label_7#1;

  inline$IoSetNextIrpStackLocation$15$label_7#1:
    call inline$IoSetNextIrpStackLocation$15$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoSetNextIrpStackLocation$15$label_8#1;

  inline$IoSetNextIrpStackLocation$15$label_8#1:
    goto inline$IoSetNextIrpStackLocation$15$label_5#1;

  inline$IoSetNextIrpStackLocation$15$label_3_true#1:
    inline$IoSetNextIrpStackLocation$15$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LT(0, inline$IoSetNextIrpStackLocation$15$myVar_0);
    goto inline$IoSetNextIrpStackLocation$15$label_5#1;

  inline$IoSetNextIrpStackLocation$15$label_5#1:
    inline$IoSetNextIrpStackLocation$15$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4)];
    call contextSwitch();
    inline$IoSetNextIrpStackLocation$15$tempBoogie0 := MINUS_BOTH_PTR_OR_BOTH_INT(inline$IoSetNextIrpStackLocation$15$myVar_0, 1, 1);
    Mem_0_T.CurrentLocation__IRP := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoSetNextIrpStackLocation$15$$Irp$1$25054.16$IoSetNextIrpStackLocation$4) := inline$IoSetNextIrpStackLocation$15$tempBoogie0];
    call contextSwitch();
    goto inline$IoSetNextIrpStackLocation$15$label_6#1;

  inline$IoSetNextIrpStackLocation$15$label_6#1:
    havoc inline$IoSetNextIrpStackLocation$15$myNondetVar_0;
    inline$IoSetNextIrpStackLocation$15$tempBoogie0 := MINUS_LEFT_PTR(inline$IoSetNextIrpStackLocation$15$myNondetVar_0, 36, 1);
    goto inline$IoSetNextIrpStackLocation$15$label_1#1;

  inline$IoSetNextIrpStackLocation$15$label_1#1:
    goto inline$IoSetNextIrpStackLocation$15$Return#1;

  inline$IoSetNextIrpStackLocation$15$Return#1:
    goto inline$storm_IoCallDriver$14$label_10$1#1;

  inline$storm_IoCallDriver$14$label_10$1#1:
    goto inline$storm_IoCallDriver$14$anon11_Then#1, inline$storm_IoCallDriver$14$anon11_Else#1;

  inline$storm_IoCallDriver$14$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$14$anon1#1;

  inline$storm_IoCallDriver$14$anon1#1:
    goto inline$storm_IoCallDriver$14$label_18#1;

  inline$storm_IoCallDriver$14$label_18#1:
    goto inline$IoGetCurrentIrpStackLocation$141$Entry#1;

  inline$IoGetCurrentIrpStackLocation$141$Entry#1:
    inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$IoGetCurrentIrpStackLocation$141$start#1;

  inline$IoGetCurrentIrpStackLocation$141$start#1:
    inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$141$label_3#1;

  inline$IoGetCurrentIrpStackLocation$141$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$141$label_3_true#1, inline$IoGetCurrentIrpStackLocation$141$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$141$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$141$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$141$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$141$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$141$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$141$label_4#1;

  inline$IoGetCurrentIrpStackLocation$141$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$141$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$141$label_6#1;

  inline$IoGetCurrentIrpStackLocation$141$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$141$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$141$label_7#1;

  inline$IoGetCurrentIrpStackLocation$141$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$141$label_5#1;

  inline$IoGetCurrentIrpStackLocation$141$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$141$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$141$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$141$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$141$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$141$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$141$label_5#1;

  inline$IoGetCurrentIrpStackLocation$141$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$141$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$141$label_1#1;

  inline$IoGetCurrentIrpStackLocation$141$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$141$Return#1;

  inline$IoGetCurrentIrpStackLocation$141$Return#1:
    goto inline$storm_IoCallDriver$14$label_18$1#1;

  inline$storm_IoCallDriver$14$label_18$1#1:
    goto inline$storm_IoCallDriver$14$anon13_Then#1, inline$storm_IoCallDriver$14$anon13_Else#1;

  inline$storm_IoCallDriver$14$anon13_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$14$anon6#1;

  inline$storm_IoCallDriver$14$anon6#1:
    goto inline$storm_IoCallDriver$14$label_21#1;

  inline$storm_IoCallDriver$14$label_21#1:
    goto inline$storm_IoCallDriver$14$label_22#1;

  inline$storm_IoCallDriver$14$label_22#1:
    goto inline$storm_IoCallDriver$14$label_23#1;

  inline$storm_IoCallDriver$14$label_23#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCallDriver$14$label_24#1;

  inline$storm_IoCallDriver$14$label_24#1:
    call inline$storm_IoCallDriver$14$$result.storm_nondet$472.22$4$ := storm_nondet();
    goto inline$storm_IoCallDriver$14$label_27#1;

  inline$storm_IoCallDriver$14$label_27#1:
    goto inline$storm_IoCallDriver$14$label_27_case_0#1, inline$storm_IoCallDriver$14$label_27_case_1#1, inline$storm_IoCallDriver$14$label_27_case_2#1;

  inline$storm_IoCallDriver$14$label_27_case_2#1:
    assume inline$storm_IoCallDriver$14$$result.storm_nondet$472.22$4$ == 1;
    goto inline$storm_IoCallDriver$14$label_30#1;

  inline$storm_IoCallDriver$14$label_30#1:
    inline$storm_IoCallDriver$14$$status$4$462.11$storm_IoCallDriver$8 := 0 - 1073741823;
    goto inline$storm_IoCallDriver$14$label_31#1;

  inline$storm_IoCallDriver$14$label_31#1:
    goto inline$storm_IoCallDriver$14$label_32#1;

  inline$storm_IoCallDriver$14$label_32#1:
    goto inline$storm_IoCallDriver$14$label_33#1;

  inline$storm_IoCallDriver$14$label_33#1:
    goto inline$CallCompletionRoutine$28$Entry#1;

  inline$CallCompletionRoutine$28$Entry#1:
    inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$28$start#1;

  inline$CallCompletionRoutine$28$start#1:
    inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$28$label_3#1;

  inline$CallCompletionRoutine$28$label_3#1:
    goto inline$CallCompletionRoutine$28$label_4#1;

  inline$CallCompletionRoutine$28$label_4#1:
    goto inline$CallCompletionRoutine$28$label_5#1;

  inline$CallCompletionRoutine$28$label_5#1:
    goto inline$CallCompletionRoutine$28$label_6#1;

  inline$CallCompletionRoutine$28$label_6#1:
    goto inline$CallCompletionRoutine$28$label_7#1;

  inline$CallCompletionRoutine$28$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$142$Entry#1;

  inline$IoGetCurrentIrpStackLocation$142$Entry#1:
    inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$142$start#1;

  inline$IoGetCurrentIrpStackLocation$142$start#1:
    inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$142$label_3#1;

  inline$IoGetCurrentIrpStackLocation$142$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$142$label_3_true#1, inline$IoGetCurrentIrpStackLocation$142$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$142$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$142$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$142$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$142$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$142$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$142$label_4#1;

  inline$IoGetCurrentIrpStackLocation$142$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$142$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$142$label_6#1;

  inline$IoGetCurrentIrpStackLocation$142$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$142$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$142$label_7#1;

  inline$IoGetCurrentIrpStackLocation$142$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$142$label_5#1;

  inline$IoGetCurrentIrpStackLocation$142$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$142$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$142$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$142$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$142$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$142$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$142$label_5#1;

  inline$IoGetCurrentIrpStackLocation$142$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$142$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$142$label_1#1;

  inline$IoGetCurrentIrpStackLocation$142$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$142$Return#1;

  inline$IoGetCurrentIrpStackLocation$142$Return#1:
    goto inline$CallCompletionRoutine$28$label_7$1#1;

  inline$CallCompletionRoutine$28$label_7$1#1:
    goto inline$CallCompletionRoutine$28$anon10_Then#1, inline$CallCompletionRoutine$28$anon10_Else#1;

  inline$CallCompletionRoutine$28$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$28$anon1#1;

  inline$CallCompletionRoutine$28$anon1#1:
    goto inline$CallCompletionRoutine$28$label_10#1;

  inline$CallCompletionRoutine$28$label_10#1:
    goto inline$CallCompletionRoutine$28$label_11#1;

  inline$CallCompletionRoutine$28$label_11#1:
    havoc inline$CallCompletionRoutine$28$myNondetVar_0;
    inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$28$myNondetVar_0;
    goto inline$CallCompletionRoutine$28$label_12#1;

  inline$CallCompletionRoutine$28$label_12#1:
    havoc inline$CallCompletionRoutine$28$myNondetVar_0;
    inline$CallCompletionRoutine$28$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$28$myNondetVar_0;
    goto inline$CallCompletionRoutine$28$label_13#1;

  inline$CallCompletionRoutine$28$label_13#1:
    havoc inline$CallCompletionRoutine$28$myNondetVar_0;
    goto inline$CallCompletionRoutine$28$label_14#1;

  inline$CallCompletionRoutine$28$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$143$Entry#1;

  inline$IoGetCurrentIrpStackLocation$143$Entry#1:
    inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$143$start#1;

  inline$IoGetCurrentIrpStackLocation$143$start#1:
    inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$143$label_3#1;

  inline$IoGetCurrentIrpStackLocation$143$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$143$label_3_true#1, inline$IoGetCurrentIrpStackLocation$143$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$143$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$143$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$143$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$143$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$143$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$143$label_4#1;

  inline$IoGetCurrentIrpStackLocation$143$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$143$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$143$label_6#1;

  inline$IoGetCurrentIrpStackLocation$143$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$143$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$143$label_7#1;

  inline$IoGetCurrentIrpStackLocation$143$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$143$label_5#1;

  inline$IoGetCurrentIrpStackLocation$143$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$143$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$143$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$143$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$143$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$143$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$143$label_5#1;

  inline$IoGetCurrentIrpStackLocation$143$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$143$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$143$label_1#1;

  inline$IoGetCurrentIrpStackLocation$143$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$143$Return#1;

  inline$IoGetCurrentIrpStackLocation$143$Return#1:
    goto inline$CallCompletionRoutine$28$label_14$1#1;

  inline$CallCompletionRoutine$28$label_14$1#1:
    goto inline$CallCompletionRoutine$28$anon11_Then#1, inline$CallCompletionRoutine$28$anon11_Else#1;

  inline$CallCompletionRoutine$28$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$28$anon3#1;

  inline$CallCompletionRoutine$28$anon3#1:
    goto inline$CallCompletionRoutine$28$label_17#1;

  inline$CallCompletionRoutine$28$label_17#1:
    goto inline$CallCompletionRoutine$28$label_18#1;

  inline$CallCompletionRoutine$28$label_18#1:
    goto inline$CallCompletionRoutine$28$label_18_true#1, inline$CallCompletionRoutine$28$label_18_false#1;

  inline$CallCompletionRoutine$28$label_18_false#1:
    assume inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$28$label_1#1;

  inline$CallCompletionRoutine$28$label_18_true#1:
    assume inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$28$label_19#1;

  inline$CallCompletionRoutine$28$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$28$label_20#1;

  inline$CallCompletionRoutine$28$label_20#1:
    goto inline$CallCompletionRoutine$28$label_20_icall_1#1, inline$CallCompletionRoutine$28$label_20_icall_2#1, inline$CallCompletionRoutine$28$label_20_icall_3#1;

  inline$CallCompletionRoutine$28$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$28$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$28$Entry#1;

  inline$BDLSystemPowerIoCompletion$28$Entry#1:
    inline$BDLSystemPowerIoCompletion$28$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$28$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$28$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$28$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$28$start#1;

  inline$BDLSystemPowerIoCompletion$28$start#1:
    call inline$BDLSystemPowerIoCompletion$28$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$28$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$28$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$28$label_3#1;

  inline$BDLSystemPowerIoCompletion$28$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_4#1;

  inline$BDLSystemPowerIoCompletion$28$label_4#1:
    inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_5#1;

  inline$BDLSystemPowerIoCompletion$28$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_6#1;

  inline$BDLSystemPowerIoCompletion$28$label_6#1:
    inline$BDLSystemPowerIoCompletion$28$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$28$label_7#1;

  inline$BDLSystemPowerIoCompletion$28$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_8#1;

  inline$BDLSystemPowerIoCompletion$28$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$28$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$28$label_9#1;

  inline$BDLSystemPowerIoCompletion$28$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_10#1;

  inline$BDLSystemPowerIoCompletion$28$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$145$Entry#1;

  inline$IoGetCurrentIrpStackLocation$145$Entry#1:
    inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$145$start#1;

  inline$IoGetCurrentIrpStackLocation$145$start#1:
    inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$145$label_3#1;

  inline$IoGetCurrentIrpStackLocation$145$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$145$label_3_true#1, inline$IoGetCurrentIrpStackLocation$145$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$145$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$145$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$145$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$145$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$145$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$145$label_4#1;

  inline$IoGetCurrentIrpStackLocation$145$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$145$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$145$label_6#1;

  inline$IoGetCurrentIrpStackLocation$145$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$145$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$145$label_7#1;

  inline$IoGetCurrentIrpStackLocation$145$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$145$label_5#1;

  inline$IoGetCurrentIrpStackLocation$145$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$145$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$145$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$145$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$145$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$145$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$145$label_5#1;

  inline$IoGetCurrentIrpStackLocation$145$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$145$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$145$label_1#1;

  inline$IoGetCurrentIrpStackLocation$145$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$145$Return#1;

  inline$IoGetCurrentIrpStackLocation$145$Return#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon36_Then#1, inline$BDLSystemPowerIoCompletion$28$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon1#1;

  inline$BDLSystemPowerIoCompletion$28$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_13#1;

  inline$BDLSystemPowerIoCompletion$28$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_14#1;

  inline$BDLSystemPowerIoCompletion$28$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_15#1;

  inline$BDLSystemPowerIoCompletion$28$label_15#1:
    goto inline$BDLGetDebugLevel$750$Entry#1;

  inline$BDLGetDebugLevel$750$Entry#1:
    goto inline$BDLGetDebugLevel$750$start#1;

  inline$BDLGetDebugLevel$750$start#1:
    goto inline$BDLGetDebugLevel$750$label_3#1;

  inline$BDLGetDebugLevel$750$label_3#1:
    havoc inline$BDLGetDebugLevel$750$myNondetVar_0;
    inline$BDLGetDebugLevel$750$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$750$myNondetVar_0;
    goto inline$BDLGetDebugLevel$750$label_1#1;

  inline$BDLGetDebugLevel$750$label_1#1:
    goto inline$BDLGetDebugLevel$750$Return#1;

  inline$BDLGetDebugLevel$750$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$750$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon37_Then#1, inline$BDLSystemPowerIoCompletion$28$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon3#1;

  inline$BDLSystemPowerIoCompletion$28$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_18#1;

  inline$BDLSystemPowerIoCompletion$28$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_18_true#1, inline$BDLSystemPowerIoCompletion$28$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_19#1;

  inline$BDLSystemPowerIoCompletion$28$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_22#1;

  inline$BDLSystemPowerIoCompletion$28$label_22#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_23#1;

  inline$BDLSystemPowerIoCompletion$28$label_23#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_24#1;

  inline$BDLSystemPowerIoCompletion$28$label_24#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_25#1;

  inline$BDLSystemPowerIoCompletion$28$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$28$label_19#1;

  inline$BDLSystemPowerIoCompletion$28$label_19#1:
    goto inline$BDLGetDebugLevel$751$Entry#1;

  inline$BDLGetDebugLevel$751$Entry#1:
    goto inline$BDLGetDebugLevel$751$start#1;

  inline$BDLGetDebugLevel$751$start#1:
    goto inline$BDLGetDebugLevel$751$label_3#1;

  inline$BDLGetDebugLevel$751$label_3#1:
    havoc inline$BDLGetDebugLevel$751$myNondetVar_0;
    inline$BDLGetDebugLevel$751$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$751$myNondetVar_0;
    goto inline$BDLGetDebugLevel$751$label_1#1;

  inline$BDLGetDebugLevel$751$label_1#1:
    goto inline$BDLGetDebugLevel$751$Return#1;

  inline$BDLGetDebugLevel$751$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$751$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon38_Then#1, inline$BDLSystemPowerIoCompletion$28$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon5#1;

  inline$BDLSystemPowerIoCompletion$28$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_28#1;

  inline$BDLSystemPowerIoCompletion$28$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_28_true#1, inline$BDLSystemPowerIoCompletion$28$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_29#1;

  inline$BDLSystemPowerIoCompletion$28$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_32#1;

  inline$BDLSystemPowerIoCompletion$28$label_32#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_33#1;

  inline$BDLSystemPowerIoCompletion$28$label_33#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_34#1;

  inline$BDLSystemPowerIoCompletion$28$label_34#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_35#1;

  inline$BDLSystemPowerIoCompletion$28$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$28$label_29#1;

  inline$BDLSystemPowerIoCompletion$28$label_29#1:
    goto inline$BDLGetDebugLevel$752$Entry#1;

  inline$BDLGetDebugLevel$752$Entry#1:
    goto inline$BDLGetDebugLevel$752$start#1;

  inline$BDLGetDebugLevel$752$start#1:
    goto inline$BDLGetDebugLevel$752$label_3#1;

  inline$BDLGetDebugLevel$752$label_3#1:
    havoc inline$BDLGetDebugLevel$752$myNondetVar_0;
    inline$BDLGetDebugLevel$752$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$752$myNondetVar_0;
    goto inline$BDLGetDebugLevel$752$label_1#1;

  inline$BDLGetDebugLevel$752$label_1#1:
    goto inline$BDLGetDebugLevel$752$Return#1;

  inline$BDLGetDebugLevel$752$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$752$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon39_Then#1, inline$BDLSystemPowerIoCompletion$28$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon7#1;

  inline$BDLSystemPowerIoCompletion$28$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_38#1;

  inline$BDLSystemPowerIoCompletion$28$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_38_true#1, inline$BDLSystemPowerIoCompletion$28$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_39#1;

  inline$BDLSystemPowerIoCompletion$28$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_40#1;

  inline$BDLSystemPowerIoCompletion$28$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_39#1;

  inline$BDLSystemPowerIoCompletion$28$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_39_true#1, inline$BDLSystemPowerIoCompletion$28$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_41#1;

  inline$BDLSystemPowerIoCompletion$28$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$28$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$28$label_107#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$28$label_108#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$28$label_108#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$28$label_108#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$28$label_108#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$28$label_108#1;

  inline$BDLSystemPowerIoCompletion$28$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_109#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$28$label_107#1;

  inline$BDLSystemPowerIoCompletion$28$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_109#1;

  inline$BDLSystemPowerIoCompletion$28$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$28$label_106#1;

  inline$BDLSystemPowerIoCompletion$28$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_106_true#1, inline$BDLSystemPowerIoCompletion$28$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_142#1;

  inline$BDLSystemPowerIoCompletion$28$label_142#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_143#1;

  inline$BDLSystemPowerIoCompletion$28$label_143#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_144#1;

  inline$BDLSystemPowerIoCompletion$28$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_109#1;

  inline$BDLSystemPowerIoCompletion$28$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_109#1;

  inline$BDLSystemPowerIoCompletion$28$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$28$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$28$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$28$myNondetVar_0, inline$BDLSystemPowerIoCompletion$28$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$28$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$28$anon50_Then#1, inline$BDLSystemPowerIoCompletion$28$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon29#1;

  inline$BDLSystemPowerIoCompletion$28$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_112#1;

  inline$BDLSystemPowerIoCompletion$28$label_112#1:
    inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$28$label_113#1;

  inline$BDLSystemPowerIoCompletion$28$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_113_true#1, inline$BDLSystemPowerIoCompletion$28$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$28$label_114#1;

  inline$BDLSystemPowerIoCompletion$28$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_116#1;

  inline$BDLSystemPowerIoCompletion$28$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_117#1;

  inline$BDLSystemPowerIoCompletion$28$label_117#1:
    goto inline$BDLGetDebugLevel$759$Entry#1;

  inline$BDLGetDebugLevel$759$Entry#1:
    goto inline$BDLGetDebugLevel$759$start#1;

  inline$BDLGetDebugLevel$759$start#1:
    goto inline$BDLGetDebugLevel$759$label_3#1;

  inline$BDLGetDebugLevel$759$label_3#1:
    havoc inline$BDLGetDebugLevel$759$myNondetVar_0;
    inline$BDLGetDebugLevel$759$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$759$myNondetVar_0;
    goto inline$BDLGetDebugLevel$759$label_1#1;

  inline$BDLGetDebugLevel$759$label_1#1:
    goto inline$BDLGetDebugLevel$759$Return#1;

  inline$BDLGetDebugLevel$759$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$759$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon51_Then#1, inline$BDLSystemPowerIoCompletion$28$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon31#1;

  inline$BDLSystemPowerIoCompletion$28$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_120#1;

  inline$BDLSystemPowerIoCompletion$28$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_120_true#1, inline$BDLSystemPowerIoCompletion$28$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_121#1;

  inline$BDLSystemPowerIoCompletion$28$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_124#1;

  inline$BDLSystemPowerIoCompletion$28$label_124#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_125#1;

  inline$BDLSystemPowerIoCompletion$28$label_125#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_126#1;

  inline$BDLSystemPowerIoCompletion$28$label_126#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_127#1;

  inline$BDLSystemPowerIoCompletion$28$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$28$label_121#1;

  inline$BDLSystemPowerIoCompletion$28$label_121#1:
    goto inline$BDLGetDebugLevel$760$Entry#1;

  inline$BDLGetDebugLevel$760$Entry#1:
    goto inline$BDLGetDebugLevel$760$start#1;

  inline$BDLGetDebugLevel$760$start#1:
    goto inline$BDLGetDebugLevel$760$label_3#1;

  inline$BDLGetDebugLevel$760$label_3#1:
    havoc inline$BDLGetDebugLevel$760$myNondetVar_0;
    inline$BDLGetDebugLevel$760$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$760$myNondetVar_0;
    goto inline$BDLGetDebugLevel$760$label_1#1;

  inline$BDLGetDebugLevel$760$label_1#1:
    goto inline$BDLGetDebugLevel$760$Return#1;

  inline$BDLGetDebugLevel$760$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$760$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon52_Then#1, inline$BDLSystemPowerIoCompletion$28$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon33#1;

  inline$BDLSystemPowerIoCompletion$28$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_130#1;

  inline$BDLSystemPowerIoCompletion$28$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_130_true#1, inline$BDLSystemPowerIoCompletion$28$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_131#1;

  inline$BDLSystemPowerIoCompletion$28$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_134#1;

  inline$BDLSystemPowerIoCompletion$28$label_134#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_135#1;

  inline$BDLSystemPowerIoCompletion$28$label_135#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_136#1;

  inline$BDLSystemPowerIoCompletion$28$label_136#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_137#1;

  inline$BDLSystemPowerIoCompletion$28$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$28$label_131#1;

  inline$BDLSystemPowerIoCompletion$28$label_131#1:
    goto inline$BDLGetDebugLevel$761$Entry#1;

  inline$BDLGetDebugLevel$761$Entry#1:
    goto inline$BDLGetDebugLevel$761$start#1;

  inline$BDLGetDebugLevel$761$start#1:
    goto inline$BDLGetDebugLevel$761$label_3#1;

  inline$BDLGetDebugLevel$761$label_3#1:
    havoc inline$BDLGetDebugLevel$761$myNondetVar_0;
    inline$BDLGetDebugLevel$761$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$761$myNondetVar_0;
    goto inline$BDLGetDebugLevel$761$label_1#1;

  inline$BDLGetDebugLevel$761$label_1#1:
    goto inline$BDLGetDebugLevel$761$Return#1;

  inline$BDLGetDebugLevel$761$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$761$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon53_Then#1, inline$BDLSystemPowerIoCompletion$28$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon35#1;

  inline$BDLSystemPowerIoCompletion$28$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_140#1;

  inline$BDLSystemPowerIoCompletion$28$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_140_true#1, inline$BDLSystemPowerIoCompletion$28$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_67#1;

  inline$BDLSystemPowerIoCompletion$28$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_141#1;

  inline$BDLSystemPowerIoCompletion$28$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_67#1;

  inline$BDLSystemPowerIoCompletion$28$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$28$label_115#1;

  inline$BDLSystemPowerIoCompletion$28$label_115#1:
    inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$28$label_80#1;

  inline$BDLSystemPowerIoCompletion$28$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$28$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_42#1;

  inline$BDLSystemPowerIoCompletion$28$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$28$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$28$label_43#1;

  inline$BDLSystemPowerIoCompletion$28$label_43#1:
    goto inline$BDLGetDebugLevel$753$Entry#1;

  inline$BDLGetDebugLevel$753$Entry#1:
    goto inline$BDLGetDebugLevel$753$start#1;

  inline$BDLGetDebugLevel$753$start#1:
    goto inline$BDLGetDebugLevel$753$label_3#1;

  inline$BDLGetDebugLevel$753$label_3#1:
    havoc inline$BDLGetDebugLevel$753$myNondetVar_0;
    inline$BDLGetDebugLevel$753$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$753$myNondetVar_0;
    goto inline$BDLGetDebugLevel$753$label_1#1;

  inline$BDLGetDebugLevel$753$label_1#1:
    goto inline$BDLGetDebugLevel$753$Return#1;

  inline$BDLGetDebugLevel$753$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$753$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon40_Then#1, inline$BDLSystemPowerIoCompletion$28$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon9#1;

  inline$BDLSystemPowerIoCompletion$28$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_46#1;

  inline$BDLSystemPowerIoCompletion$28$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_46_true#1, inline$BDLSystemPowerIoCompletion$28$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_47#1;

  inline$BDLSystemPowerIoCompletion$28$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_50#1;

  inline$BDLSystemPowerIoCompletion$28$label_50#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_51#1;

  inline$BDLSystemPowerIoCompletion$28$label_51#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_52#1;

  inline$BDLSystemPowerIoCompletion$28$label_52#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_53#1;

  inline$BDLSystemPowerIoCompletion$28$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$28$label_47#1;

  inline$BDLSystemPowerIoCompletion$28$label_47#1:
    goto inline$BDLGetDebugLevel$754$Entry#1;

  inline$BDLGetDebugLevel$754$Entry#1:
    goto inline$BDLGetDebugLevel$754$start#1;

  inline$BDLGetDebugLevel$754$start#1:
    goto inline$BDLGetDebugLevel$754$label_3#1;

  inline$BDLGetDebugLevel$754$label_3#1:
    havoc inline$BDLGetDebugLevel$754$myNondetVar_0;
    inline$BDLGetDebugLevel$754$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$754$myNondetVar_0;
    goto inline$BDLGetDebugLevel$754$label_1#1;

  inline$BDLGetDebugLevel$754$label_1#1:
    goto inline$BDLGetDebugLevel$754$Return#1;

  inline$BDLGetDebugLevel$754$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$754$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon41_Then#1, inline$BDLSystemPowerIoCompletion$28$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon11#1;

  inline$BDLSystemPowerIoCompletion$28$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_56#1;

  inline$BDLSystemPowerIoCompletion$28$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_56_true#1, inline$BDLSystemPowerIoCompletion$28$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_57#1;

  inline$BDLSystemPowerIoCompletion$28$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_60#1;

  inline$BDLSystemPowerIoCompletion$28$label_60#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_61#1;

  inline$BDLSystemPowerIoCompletion$28$label_61#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_62#1;

  inline$BDLSystemPowerIoCompletion$28$label_62#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_63#1;

  inline$BDLSystemPowerIoCompletion$28$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$28$label_57#1;

  inline$BDLSystemPowerIoCompletion$28$label_57#1:
    goto inline$BDLGetDebugLevel$755$Entry#1;

  inline$BDLGetDebugLevel$755$Entry#1:
    goto inline$BDLGetDebugLevel$755$start#1;

  inline$BDLGetDebugLevel$755$start#1:
    goto inline$BDLGetDebugLevel$755$label_3#1;

  inline$BDLGetDebugLevel$755$label_3#1:
    havoc inline$BDLGetDebugLevel$755$myNondetVar_0;
    inline$BDLGetDebugLevel$755$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$755$myNondetVar_0;
    goto inline$BDLGetDebugLevel$755$label_1#1;

  inline$BDLGetDebugLevel$755$label_1#1:
    goto inline$BDLGetDebugLevel$755$Return#1;

  inline$BDLGetDebugLevel$755$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$755$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon42_Then#1, inline$BDLSystemPowerIoCompletion$28$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon13#1;

  inline$BDLSystemPowerIoCompletion$28$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_66#1;

  inline$BDLSystemPowerIoCompletion$28$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_66_true#1, inline$BDLSystemPowerIoCompletion$28$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_67#1;

  inline$BDLSystemPowerIoCompletion$28$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_70#1;

  inline$BDLSystemPowerIoCompletion$28$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_67#1;

  inline$BDLSystemPowerIoCompletion$28$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$28$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$28$anon43_Then#1, inline$BDLSystemPowerIoCompletion$28$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon15#1;

  inline$BDLSystemPowerIoCompletion$28$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_71#1;

  inline$BDLSystemPowerIoCompletion$28$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$28$anon44_Then#1, inline$BDLSystemPowerIoCompletion$28$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon17#1;

  inline$BDLSystemPowerIoCompletion$28$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_74#1;

  inline$BDLSystemPowerIoCompletion$28$label_74#1:
    goto inline$storm_IoCompleteRequest$59$Entry#1;

  inline$storm_IoCompleteRequest$59$Entry#1:
    inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$28$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$59$start#1;

  inline$storm_IoCompleteRequest$59$start#1:
    inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$59$label_3#1;

  inline$storm_IoCompleteRequest$59$label_3#1:
    call inline$storm_IoCompleteRequest$59$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$59$label_6#1;

  inline$storm_IoCompleteRequest$59$label_6#1:
    goto inline$storm_IoCompleteRequest$59$label_6_true#1, inline$storm_IoCompleteRequest$59$label_6_false#1;

  inline$storm_IoCompleteRequest$59$label_6_false#1:
    assume inline$storm_IoCompleteRequest$59$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$59$label_7#1;

  inline$storm_IoCompleteRequest$59$label_6_true#1:
    assume inline$storm_IoCompleteRequest$59$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$59$label_8#1;

  inline$storm_IoCompleteRequest$59$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$59$anon3_Then#1, inline$storm_IoCompleteRequest$59$anon3_Else#1;

  inline$storm_IoCompleteRequest$59$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$59$anon1#1;

  inline$storm_IoCompleteRequest$59$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$59$label_9#1;

  inline$storm_IoCompleteRequest$59$label_9#1:
    goto inline$storm_IoCompleteRequest$59$label_9_true#1, inline$storm_IoCompleteRequest$59$label_9_false#1;

  inline$storm_IoCompleteRequest$59$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$59$label_10#1;

  inline$storm_IoCompleteRequest$59$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$59$label_1#1;

  inline$storm_IoCompleteRequest$59$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$59$label_7#1;

  inline$storm_IoCompleteRequest$59$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$59$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$59$label_1#1;

  inline$storm_IoCompleteRequest$59$label_1#1:
    goto inline$storm_IoCompleteRequest$59$Return#1;

  inline$storm_IoCompleteRequest$59$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$59$Return#1;

  inline$storm_IoCompleteRequest$59$Return#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon45_Then#1, inline$BDLSystemPowerIoCompletion$28$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon19#1;

  inline$BDLSystemPowerIoCompletion$28$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_77#1;

  inline$BDLSystemPowerIoCompletion$28$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$28$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$28$anon46_Then#1, inline$BDLSystemPowerIoCompletion$28$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon21#1;

  inline$BDLSystemPowerIoCompletion$28$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_80#1;

  inline$BDLSystemPowerIoCompletion$28$label_80#1:
    goto inline$BDLGetDebugLevel$756$Entry#1;

  inline$BDLGetDebugLevel$756$Entry#1:
    goto inline$BDLGetDebugLevel$756$start#1;

  inline$BDLGetDebugLevel$756$start#1:
    goto inline$BDLGetDebugLevel$756$label_3#1;

  inline$BDLGetDebugLevel$756$label_3#1:
    havoc inline$BDLGetDebugLevel$756$myNondetVar_0;
    inline$BDLGetDebugLevel$756$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$756$myNondetVar_0;
    goto inline$BDLGetDebugLevel$756$label_1#1;

  inline$BDLGetDebugLevel$756$label_1#1:
    goto inline$BDLGetDebugLevel$756$Return#1;

  inline$BDLGetDebugLevel$756$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$756$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon47_Then#1, inline$BDLSystemPowerIoCompletion$28$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon23#1;

  inline$BDLSystemPowerIoCompletion$28$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_83#1;

  inline$BDLSystemPowerIoCompletion$28$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_83_true#1, inline$BDLSystemPowerIoCompletion$28$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_84#1;

  inline$BDLSystemPowerIoCompletion$28$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_87#1;

  inline$BDLSystemPowerIoCompletion$28$label_87#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_88#1;

  inline$BDLSystemPowerIoCompletion$28$label_88#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_89#1;

  inline$BDLSystemPowerIoCompletion$28$label_89#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_90#1;

  inline$BDLSystemPowerIoCompletion$28$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$28$label_84#1;

  inline$BDLSystemPowerIoCompletion$28$label_84#1:
    goto inline$BDLGetDebugLevel$757$Entry#1;

  inline$BDLGetDebugLevel$757$Entry#1:
    goto inline$BDLGetDebugLevel$757$start#1;

  inline$BDLGetDebugLevel$757$start#1:
    goto inline$BDLGetDebugLevel$757$label_3#1;

  inline$BDLGetDebugLevel$757$label_3#1:
    havoc inline$BDLGetDebugLevel$757$myNondetVar_0;
    inline$BDLGetDebugLevel$757$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$757$myNondetVar_0;
    goto inline$BDLGetDebugLevel$757$label_1#1;

  inline$BDLGetDebugLevel$757$label_1#1:
    goto inline$BDLGetDebugLevel$757$Return#1;

  inline$BDLGetDebugLevel$757$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$757$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon48_Then#1, inline$BDLSystemPowerIoCompletion$28$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon25#1;

  inline$BDLSystemPowerIoCompletion$28$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_93#1;

  inline$BDLSystemPowerIoCompletion$28$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_93_true#1, inline$BDLSystemPowerIoCompletion$28$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_94#1;

  inline$BDLSystemPowerIoCompletion$28$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_97#1;

  inline$BDLSystemPowerIoCompletion$28$label_97#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_98#1;

  inline$BDLSystemPowerIoCompletion$28$label_98#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_99#1;

  inline$BDLSystemPowerIoCompletion$28$label_99#1:
    call inline$BDLSystemPowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$28$label_100#1;

  inline$BDLSystemPowerIoCompletion$28$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$28$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$28$label_94#1;

  inline$BDLSystemPowerIoCompletion$28$label_94#1:
    goto inline$BDLGetDebugLevel$758$Entry#1;

  inline$BDLGetDebugLevel$758$Entry#1:
    goto inline$BDLGetDebugLevel$758$start#1;

  inline$BDLGetDebugLevel$758$start#1:
    goto inline$BDLGetDebugLevel$758$label_3#1;

  inline$BDLGetDebugLevel$758$label_3#1:
    havoc inline$BDLGetDebugLevel$758$myNondetVar_0;
    inline$BDLGetDebugLevel$758$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$758$myNondetVar_0;
    goto inline$BDLGetDebugLevel$758$label_1#1;

  inline$BDLGetDebugLevel$758$label_1#1:
    goto inline$BDLGetDebugLevel$758$Return#1;

  inline$BDLGetDebugLevel$758$Return#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$758$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$28$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$28$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$28$anon49_Then#1, inline$BDLSystemPowerIoCompletion$28$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$28$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$anon27#1;

  inline$BDLSystemPowerIoCompletion$28$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_103#1;

  inline$BDLSystemPowerIoCompletion$28$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_103_true#1, inline$BDLSystemPowerIoCompletion$28$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$28$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_104#1;

  inline$BDLSystemPowerIoCompletion$28$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$28$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$28$label_105#1;

  inline$BDLSystemPowerIoCompletion$28$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$28$label_104#1;

  inline$BDLSystemPowerIoCompletion$28$label_104#1:
    inline$BDLSystemPowerIoCompletion$28$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$28$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$28$label_1#1;

  inline$BDLSystemPowerIoCompletion$28$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$28$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$28$Return#1;

  inline$BDLSystemPowerIoCompletion$28$Return#1:
    inline$CallCompletionRoutine$28$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$28$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$28$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$28$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$28$anon14_Then#1, inline$CallCompletionRoutine$28$anon14_Else#1;

  inline$CallCompletionRoutine$28$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$28$anon9#1;

  inline$CallCompletionRoutine$28$anon9#1:
    goto inline$CallCompletionRoutine$28$label_20_icall_return#1;

  inline$CallCompletionRoutine$28$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$28$Return#1;

  inline$CallCompletionRoutine$28$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$28$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$28$Entry#1;

  inline$BDLDevicePowerIoCompletion$28$Entry#1:
    inline$BDLDevicePowerIoCompletion$28$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$28$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$28$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$28$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$28$start#1;

  inline$BDLDevicePowerIoCompletion$28$start#1:
    call inline$BDLDevicePowerIoCompletion$28$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$28$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$28$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$28$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$28$label_3#1;

  inline$BDLDevicePowerIoCompletion$28$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_4#1;

  inline$BDLDevicePowerIoCompletion$28$label_4#1:
    inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_5#1;

  inline$BDLDevicePowerIoCompletion$28$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_6#1;

  inline$BDLDevicePowerIoCompletion$28$label_6#1:
    inline$BDLDevicePowerIoCompletion$28$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$28$label_7#1;

  inline$BDLDevicePowerIoCompletion$28$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_8#1;

  inline$BDLDevicePowerIoCompletion$28$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$28$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$28$label_9#1;

  inline$BDLDevicePowerIoCompletion$28$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_10#1;

  inline$BDLDevicePowerIoCompletion$28$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$144$Entry#1;

  inline$IoGetCurrentIrpStackLocation$144$Entry#1:
    inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$144$start#1;

  inline$IoGetCurrentIrpStackLocation$144$start#1:
    inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$144$label_3#1;

  inline$IoGetCurrentIrpStackLocation$144$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$144$label_3_true#1, inline$IoGetCurrentIrpStackLocation$144$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$144$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$144$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$144$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$144$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$144$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$144$label_4#1;

  inline$IoGetCurrentIrpStackLocation$144$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$144$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$144$label_6#1;

  inline$IoGetCurrentIrpStackLocation$144$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$144$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$144$label_7#1;

  inline$IoGetCurrentIrpStackLocation$144$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$144$label_5#1;

  inline$IoGetCurrentIrpStackLocation$144$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$144$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$144$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$144$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$144$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$144$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$144$label_5#1;

  inline$IoGetCurrentIrpStackLocation$144$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$144$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$144$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$144$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$144$label_1#1;

  inline$IoGetCurrentIrpStackLocation$144$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$144$Return#1;

  inline$IoGetCurrentIrpStackLocation$144$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$144$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon30_Then#1, inline$BDLDevicePowerIoCompletion$28$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon1#1;

  inline$BDLDevicePowerIoCompletion$28$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_13#1;

  inline$BDLDevicePowerIoCompletion$28$label_13#1:
    inline$BDLDevicePowerIoCompletion$28$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$28$label_14#1;

  inline$BDLDevicePowerIoCompletion$28$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_15#1;

  inline$BDLDevicePowerIoCompletion$28$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$28$label_16#1;

  inline$BDLDevicePowerIoCompletion$28$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_17#1;

  inline$BDLDevicePowerIoCompletion$28$label_17#1:
    goto inline$BDLGetDebugLevel$741$Entry#1;

  inline$BDLGetDebugLevel$741$Entry#1:
    goto inline$BDLGetDebugLevel$741$start#1;

  inline$BDLGetDebugLevel$741$start#1:
    goto inline$BDLGetDebugLevel$741$label_3#1;

  inline$BDLGetDebugLevel$741$label_3#1:
    havoc inline$BDLGetDebugLevel$741$myNondetVar_0;
    inline$BDLGetDebugLevel$741$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$741$myNondetVar_0;
    goto inline$BDLGetDebugLevel$741$label_1#1;

  inline$BDLGetDebugLevel$741$label_1#1:
    goto inline$BDLGetDebugLevel$741$Return#1;

  inline$BDLGetDebugLevel$741$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$741$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon31_Then#1, inline$BDLDevicePowerIoCompletion$28$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon3#1;

  inline$BDLDevicePowerIoCompletion$28$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_20#1;

  inline$BDLDevicePowerIoCompletion$28$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_20_true#1, inline$BDLDevicePowerIoCompletion$28$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_21#1;

  inline$BDLDevicePowerIoCompletion$28$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_24#1;

  inline$BDLDevicePowerIoCompletion$28$label_24#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_25#1;

  inline$BDLDevicePowerIoCompletion$28$label_25#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_26#1;

  inline$BDLDevicePowerIoCompletion$28$label_26#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_27#1;

  inline$BDLDevicePowerIoCompletion$28$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$28$label_21#1;

  inline$BDLDevicePowerIoCompletion$28$label_21#1:
    goto inline$BDLGetDebugLevel$742$Entry#1;

  inline$BDLGetDebugLevel$742$Entry#1:
    goto inline$BDLGetDebugLevel$742$start#1;

  inline$BDLGetDebugLevel$742$start#1:
    goto inline$BDLGetDebugLevel$742$label_3#1;

  inline$BDLGetDebugLevel$742$label_3#1:
    havoc inline$BDLGetDebugLevel$742$myNondetVar_0;
    inline$BDLGetDebugLevel$742$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$742$myNondetVar_0;
    goto inline$BDLGetDebugLevel$742$label_1#1;

  inline$BDLGetDebugLevel$742$label_1#1:
    goto inline$BDLGetDebugLevel$742$Return#1;

  inline$BDLGetDebugLevel$742$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$742$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon32_Then#1, inline$BDLDevicePowerIoCompletion$28$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon5#1;

  inline$BDLDevicePowerIoCompletion$28$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_30#1;

  inline$BDLDevicePowerIoCompletion$28$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_30_true#1, inline$BDLDevicePowerIoCompletion$28$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_31#1;

  inline$BDLDevicePowerIoCompletion$28$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_34#1;

  inline$BDLDevicePowerIoCompletion$28$label_34#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_35#1;

  inline$BDLDevicePowerIoCompletion$28$label_35#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_36#1;

  inline$BDLDevicePowerIoCompletion$28$label_36#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_37#1;

  inline$BDLDevicePowerIoCompletion$28$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$28$label_31#1;

  inline$BDLDevicePowerIoCompletion$28$label_31#1:
    goto inline$BDLGetDebugLevel$743$Entry#1;

  inline$BDLGetDebugLevel$743$Entry#1:
    goto inline$BDLGetDebugLevel$743$start#1;

  inline$BDLGetDebugLevel$743$start#1:
    goto inline$BDLGetDebugLevel$743$label_3#1;

  inline$BDLGetDebugLevel$743$label_3#1:
    havoc inline$BDLGetDebugLevel$743$myNondetVar_0;
    inline$BDLGetDebugLevel$743$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$743$myNondetVar_0;
    goto inline$BDLGetDebugLevel$743$label_1#1;

  inline$BDLGetDebugLevel$743$label_1#1:
    goto inline$BDLGetDebugLevel$743$Return#1;

  inline$BDLGetDebugLevel$743$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$743$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon33_Then#1, inline$BDLDevicePowerIoCompletion$28$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon7#1;

  inline$BDLDevicePowerIoCompletion$28$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_40#1;

  inline$BDLDevicePowerIoCompletion$28$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_40_true#1, inline$BDLDevicePowerIoCompletion$28$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_41#1;

  inline$BDLDevicePowerIoCompletion$28$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_42#1;

  inline$BDLDevicePowerIoCompletion$28$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_41#1;

  inline$BDLDevicePowerIoCompletion$28$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_41_true#1, inline$BDLDevicePowerIoCompletion$28$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$28$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$28$label_43#1;

  inline$BDLDevicePowerIoCompletion$28$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$28$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$28$label_44#1;

  inline$BDLDevicePowerIoCompletion$28$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_44_true#1, inline$BDLDevicePowerIoCompletion$28$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$28$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$28$label_45#1;

  inline$BDLDevicePowerIoCompletion$28$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_45_true#1, inline$BDLDevicePowerIoCompletion$28$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$28$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$28$label_43#1;

  inline$BDLDevicePowerIoCompletion$28$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$28$label_86#1;

  inline$BDLDevicePowerIoCompletion$28$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$28$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$28$label_46#1;

  inline$BDLDevicePowerIoCompletion$28$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$28$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$28$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$28$label_46#1;

  inline$BDLDevicePowerIoCompletion$28$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$28$label_49#1;

  inline$BDLDevicePowerIoCompletion$28$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_50#1;

  inline$BDLDevicePowerIoCompletion$28$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_51#1;

  inline$BDLDevicePowerIoCompletion$28$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_54#1;

  inline$BDLDevicePowerIoCompletion$28$label_54#1:
    inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$28$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$28$label_55#1;

  inline$BDLDevicePowerIoCompletion$28$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_55_true#1, inline$BDLDevicePowerIoCompletion$28$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_56#1;

  inline$BDLDevicePowerIoCompletion$28$label_56#1:
    call inline$BDLDevicePowerIoCompletion$28$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$28$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$28$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$28$anon34_Then#1, inline$BDLDevicePowerIoCompletion$28$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon9#1;

  inline$BDLDevicePowerIoCompletion$28$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_83#1;

  inline$BDLDevicePowerIoCompletion$28$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_59#1;

  inline$BDLDevicePowerIoCompletion$28$label_59#1:
    goto inline$BDLGetDebugLevel$744$Entry#1;

  inline$BDLGetDebugLevel$744$Entry#1:
    goto inline$BDLGetDebugLevel$744$start#1;

  inline$BDLGetDebugLevel$744$start#1:
    goto inline$BDLGetDebugLevel$744$label_3#1;

  inline$BDLGetDebugLevel$744$label_3#1:
    havoc inline$BDLGetDebugLevel$744$myNondetVar_0;
    inline$BDLGetDebugLevel$744$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$744$myNondetVar_0;
    goto inline$BDLGetDebugLevel$744$label_1#1;

  inline$BDLGetDebugLevel$744$label_1#1:
    goto inline$BDLGetDebugLevel$744$Return#1;

  inline$BDLGetDebugLevel$744$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$744$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon35_Then#1, inline$BDLDevicePowerIoCompletion$28$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon11#1;

  inline$BDLDevicePowerIoCompletion$28$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_62#1;

  inline$BDLDevicePowerIoCompletion$28$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_62_true#1, inline$BDLDevicePowerIoCompletion$28$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_63#1;

  inline$BDLDevicePowerIoCompletion$28$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_66#1;

  inline$BDLDevicePowerIoCompletion$28$label_66#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_67#1;

  inline$BDLDevicePowerIoCompletion$28$label_67#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_68#1;

  inline$BDLDevicePowerIoCompletion$28$label_68#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_69#1;

  inline$BDLDevicePowerIoCompletion$28$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$28$label_63#1;

  inline$BDLDevicePowerIoCompletion$28$label_63#1:
    goto inline$BDLGetDebugLevel$745$Entry#1;

  inline$BDLGetDebugLevel$745$Entry#1:
    goto inline$BDLGetDebugLevel$745$start#1;

  inline$BDLGetDebugLevel$745$start#1:
    goto inline$BDLGetDebugLevel$745$label_3#1;

  inline$BDLGetDebugLevel$745$label_3#1:
    havoc inline$BDLGetDebugLevel$745$myNondetVar_0;
    inline$BDLGetDebugLevel$745$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$745$myNondetVar_0;
    goto inline$BDLGetDebugLevel$745$label_1#1;

  inline$BDLGetDebugLevel$745$label_1#1:
    goto inline$BDLGetDebugLevel$745$Return#1;

  inline$BDLGetDebugLevel$745$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$745$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon36_Then#1, inline$BDLDevicePowerIoCompletion$28$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon13#1;

  inline$BDLDevicePowerIoCompletion$28$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_72#1;

  inline$BDLDevicePowerIoCompletion$28$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_72_true#1, inline$BDLDevicePowerIoCompletion$28$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_73#1;

  inline$BDLDevicePowerIoCompletion$28$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_76#1;

  inline$BDLDevicePowerIoCompletion$28$label_76#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_77#1;

  inline$BDLDevicePowerIoCompletion$28$label_77#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_78#1;

  inline$BDLDevicePowerIoCompletion$28$label_78#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_79#1;

  inline$BDLDevicePowerIoCompletion$28$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$28$label_73#1;

  inline$BDLDevicePowerIoCompletion$28$label_73#1:
    goto inline$BDLGetDebugLevel$746$Entry#1;

  inline$BDLGetDebugLevel$746$Entry#1:
    goto inline$BDLGetDebugLevel$746$start#1;

  inline$BDLGetDebugLevel$746$start#1:
    goto inline$BDLGetDebugLevel$746$label_3#1;

  inline$BDLGetDebugLevel$746$label_3#1:
    havoc inline$BDLGetDebugLevel$746$myNondetVar_0;
    inline$BDLGetDebugLevel$746$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$746$myNondetVar_0;
    goto inline$BDLGetDebugLevel$746$label_1#1;

  inline$BDLGetDebugLevel$746$label_1#1:
    goto inline$BDLGetDebugLevel$746$Return#1;

  inline$BDLGetDebugLevel$746$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$746$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon37_Then#1, inline$BDLDevicePowerIoCompletion$28$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon15#1;

  inline$BDLDevicePowerIoCompletion$28$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_82#1;

  inline$BDLDevicePowerIoCompletion$28$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_82_true#1, inline$BDLDevicePowerIoCompletion$28$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_83#1;

  inline$BDLDevicePowerIoCompletion$28$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_84#1;

  inline$BDLDevicePowerIoCompletion$28$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_83#1;

  inline$BDLDevicePowerIoCompletion$28$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_85#1;

  inline$BDLDevicePowerIoCompletion$28$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_86#1;

  inline$BDLDevicePowerIoCompletion$28$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$28$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$28$anon38_Then#1, inline$BDLDevicePowerIoCompletion$28$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon17#1;

  inline$BDLDevicePowerIoCompletion$28$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_89#1;

  inline$BDLDevicePowerIoCompletion$28$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$28$anon39_Then#1, inline$BDLDevicePowerIoCompletion$28$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon19#1;

  inline$BDLDevicePowerIoCompletion$28$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_92#1;

  inline$BDLDevicePowerIoCompletion$28$label_92#1:
    goto inline$storm_IoCompleteRequest$58$Entry#1;

  inline$storm_IoCompleteRequest$58$Entry#1:
    inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$28$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$58$start#1;

  inline$storm_IoCompleteRequest$58$start#1:
    inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$58$label_3#1;

  inline$storm_IoCompleteRequest$58$label_3#1:
    call inline$storm_IoCompleteRequest$58$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$58$label_6#1;

  inline$storm_IoCompleteRequest$58$label_6#1:
    goto inline$storm_IoCompleteRequest$58$label_6_true#1, inline$storm_IoCompleteRequest$58$label_6_false#1;

  inline$storm_IoCompleteRequest$58$label_6_false#1:
    assume inline$storm_IoCompleteRequest$58$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$58$label_7#1;

  inline$storm_IoCompleteRequest$58$label_6_true#1:
    assume inline$storm_IoCompleteRequest$58$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$58$label_8#1;

  inline$storm_IoCompleteRequest$58$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$58$anon3_Then#1, inline$storm_IoCompleteRequest$58$anon3_Else#1;

  inline$storm_IoCompleteRequest$58$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$58$anon1#1;

  inline$storm_IoCompleteRequest$58$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$58$label_9#1;

  inline$storm_IoCompleteRequest$58$label_9#1:
    goto inline$storm_IoCompleteRequest$58$label_9_true#1, inline$storm_IoCompleteRequest$58$label_9_false#1;

  inline$storm_IoCompleteRequest$58$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$58$label_10#1;

  inline$storm_IoCompleteRequest$58$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$58$label_1#1;

  inline$storm_IoCompleteRequest$58$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$58$label_7#1;

  inline$storm_IoCompleteRequest$58$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$58$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$58$label_1#1;

  inline$storm_IoCompleteRequest$58$label_1#1:
    goto inline$storm_IoCompleteRequest$58$Return#1;

  inline$storm_IoCompleteRequest$58$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$58$Return#1;

  inline$storm_IoCompleteRequest$58$Return#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon40_Then#1, inline$BDLDevicePowerIoCompletion$28$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon21#1;

  inline$BDLDevicePowerIoCompletion$28$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_95#1;

  inline$BDLDevicePowerIoCompletion$28$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$28$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$28$anon41_Then#1, inline$BDLDevicePowerIoCompletion$28$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon23#1;

  inline$BDLDevicePowerIoCompletion$28$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_98#1;

  inline$BDLDevicePowerIoCompletion$28$label_98#1:
    goto inline$BDLGetDebugLevel$747$Entry#1;

  inline$BDLGetDebugLevel$747$Entry#1:
    goto inline$BDLGetDebugLevel$747$start#1;

  inline$BDLGetDebugLevel$747$start#1:
    goto inline$BDLGetDebugLevel$747$label_3#1;

  inline$BDLGetDebugLevel$747$label_3#1:
    havoc inline$BDLGetDebugLevel$747$myNondetVar_0;
    inline$BDLGetDebugLevel$747$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$747$myNondetVar_0;
    goto inline$BDLGetDebugLevel$747$label_1#1;

  inline$BDLGetDebugLevel$747$label_1#1:
    goto inline$BDLGetDebugLevel$747$Return#1;

  inline$BDLGetDebugLevel$747$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$747$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon42_Then#1, inline$BDLDevicePowerIoCompletion$28$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon25#1;

  inline$BDLDevicePowerIoCompletion$28$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_101#1;

  inline$BDLDevicePowerIoCompletion$28$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_101_true#1, inline$BDLDevicePowerIoCompletion$28$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_102#1;

  inline$BDLDevicePowerIoCompletion$28$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_105#1;

  inline$BDLDevicePowerIoCompletion$28$label_105#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_106#1;

  inline$BDLDevicePowerIoCompletion$28$label_106#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_107#1;

  inline$BDLDevicePowerIoCompletion$28$label_107#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_108#1;

  inline$BDLDevicePowerIoCompletion$28$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$28$label_102#1;

  inline$BDLDevicePowerIoCompletion$28$label_102#1:
    goto inline$BDLGetDebugLevel$748$Entry#1;

  inline$BDLGetDebugLevel$748$Entry#1:
    goto inline$BDLGetDebugLevel$748$start#1;

  inline$BDLGetDebugLevel$748$start#1:
    goto inline$BDLGetDebugLevel$748$label_3#1;

  inline$BDLGetDebugLevel$748$label_3#1:
    havoc inline$BDLGetDebugLevel$748$myNondetVar_0;
    inline$BDLGetDebugLevel$748$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$748$myNondetVar_0;
    goto inline$BDLGetDebugLevel$748$label_1#1;

  inline$BDLGetDebugLevel$748$label_1#1:
    goto inline$BDLGetDebugLevel$748$Return#1;

  inline$BDLGetDebugLevel$748$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$748$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon43_Then#1, inline$BDLDevicePowerIoCompletion$28$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon27#1;

  inline$BDLDevicePowerIoCompletion$28$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_111#1;

  inline$BDLDevicePowerIoCompletion$28$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_111_true#1, inline$BDLDevicePowerIoCompletion$28$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_112#1;

  inline$BDLDevicePowerIoCompletion$28$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_115#1;

  inline$BDLDevicePowerIoCompletion$28$label_115#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_116#1;

  inline$BDLDevicePowerIoCompletion$28$label_116#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_117#1;

  inline$BDLDevicePowerIoCompletion$28$label_117#1:
    call inline$BDLDevicePowerIoCompletion$28$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$28$label_118#1;

  inline$BDLDevicePowerIoCompletion$28$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$28$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$28$label_112#1;

  inline$BDLDevicePowerIoCompletion$28$label_112#1:
    goto inline$BDLGetDebugLevel$749$Entry#1;

  inline$BDLGetDebugLevel$749$Entry#1:
    goto inline$BDLGetDebugLevel$749$start#1;

  inline$BDLGetDebugLevel$749$start#1:
    goto inline$BDLGetDebugLevel$749$label_3#1;

  inline$BDLGetDebugLevel$749$label_3#1:
    havoc inline$BDLGetDebugLevel$749$myNondetVar_0;
    inline$BDLGetDebugLevel$749$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$749$myNondetVar_0;
    goto inline$BDLGetDebugLevel$749$label_1#1;

  inline$BDLGetDebugLevel$749$label_1#1:
    goto inline$BDLGetDebugLevel$749$Return#1;

  inline$BDLGetDebugLevel$749$Return#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$749$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$28$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$28$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$28$anon44_Then#1, inline$BDLDevicePowerIoCompletion$28$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$28$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$anon29#1;

  inline$BDLDevicePowerIoCompletion$28$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_121#1;

  inline$BDLDevicePowerIoCompletion$28$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_121_true#1, inline$BDLDevicePowerIoCompletion$28$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$28$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_122#1;

  inline$BDLDevicePowerIoCompletion$28$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$28$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$28$label_123#1;

  inline$BDLDevicePowerIoCompletion$28$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$28$label_122#1;

  inline$BDLDevicePowerIoCompletion$28$label_122#1:
    inline$BDLDevicePowerIoCompletion$28$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$28$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$28$label_1#1;

  inline$BDLDevicePowerIoCompletion$28$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$28$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$28$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$28$Return#1;

  inline$BDLDevicePowerIoCompletion$28$Return#1:
    inline$CallCompletionRoutine$28$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$28$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$28$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$28$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$28$anon13_Then#1, inline$CallCompletionRoutine$28$anon13_Else#1;

  inline$CallCompletionRoutine$28$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$28$anon7#1;

  inline$CallCompletionRoutine$28$anon7#1:
    goto inline$CallCompletionRoutine$28$label_20_icall_return#1;

  inline$CallCompletionRoutine$28$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$28$Return#1;

  inline$CallCompletionRoutine$28$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$28$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$28$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$28$Entry#1;

  inline$BDLCallDriverCompletionRoutine$28$Entry#1:
    inline$BDLCallDriverCompletionRoutine$28$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$28$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$28$start#1;

  inline$BDLCallDriverCompletionRoutine$28$start#1:
    inline$BDLCallDriverCompletionRoutine$28$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$28$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$28$label_3#1;

  inline$BDLCallDriverCompletionRoutine$28$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$28$label_3_true#1, inline$BDLCallDriverCompletionRoutine$28$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$28$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$28$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$28$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$28$label_4#1;

  inline$BDLCallDriverCompletionRoutine$28$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$28$label_6#1;

  inline$BDLCallDriverCompletionRoutine$28$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$28$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$28$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$28$label_5#1;

  inline$BDLCallDriverCompletionRoutine$28$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$28$label_6#1;

  inline$BDLCallDriverCompletionRoutine$28$label_6#1:
    goto inline$storm_KeSetEvent$32$Entry#1;

  inline$storm_KeSetEvent$32$Entry#1:
    inline$storm_KeSetEvent$32$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$28$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$32$start#1;

  inline$storm_KeSetEvent$32$start#1:
    inline$storm_KeSetEvent$32$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$32$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$32$label_3#1;

  inline$storm_KeSetEvent$32$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$32$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$32$label_1#1;

  inline$storm_KeSetEvent$32$label_1#1:
    goto inline$storm_KeSetEvent$32$Return#1;

  inline$storm_KeSetEvent$32$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$28$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$28$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$28$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$28$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$28$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$28$anon1#1;

  inline$BDLCallDriverCompletionRoutine$28$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$28$label_9#1;

  inline$BDLCallDriverCompletionRoutine$28$label_9#1:
    inline$BDLCallDriverCompletionRoutine$28$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$28$label_1#1;

  inline$BDLCallDriverCompletionRoutine$28$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$28$Return#1;

  inline$BDLCallDriverCompletionRoutine$28$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$28$Return#1;

  inline$BDLCallDriverCompletionRoutine$28$Return#1:
    inline$CallCompletionRoutine$28$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$28$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$28$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$28$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$28$anon12_Then#1, inline$CallCompletionRoutine$28$anon12_Else#1;

  inline$CallCompletionRoutine$28$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$28$anon5#1;

  inline$CallCompletionRoutine$28$anon5#1:
    goto inline$CallCompletionRoutine$28$label_20_icall_return#1;

  inline$CallCompletionRoutine$28$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$28$label_23#1;

  inline$CallCompletionRoutine$28$label_23#1:
    inline$CallCompletionRoutine$28$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$28$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$28$label_24#1;

  inline$CallCompletionRoutine$28$label_24#1:
    goto inline$CallCompletionRoutine$28$label_24_true#1, inline$CallCompletionRoutine$28$label_24_false#1;

  inline$CallCompletionRoutine$28$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$28$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$28$label_1#1;

  inline$CallCompletionRoutine$28$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$28$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$28$label_25#1;

  inline$CallCompletionRoutine$28$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$28$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$28$label_1#1;

  inline$CallCompletionRoutine$28$label_1#1:
    goto inline$CallCompletionRoutine$28$Return#1;

  inline$CallCompletionRoutine$28$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$28$Return#1;

  inline$CallCompletionRoutine$28$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$28$Return#1;

  inline$CallCompletionRoutine$28$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$28$Return#1;

  inline$CallCompletionRoutine$28$Return#1:
    goto inline$storm_IoCallDriver$14$label_33$1#1;

  inline$storm_IoCallDriver$14$label_33$1#1:
    goto inline$storm_IoCallDriver$14$anon14_Then#1, inline$storm_IoCallDriver$14$anon14_Else#1;

  inline$storm_IoCallDriver$14$anon14_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$14$anon8#1;

  inline$storm_IoCallDriver$14$anon8#1:
    goto inline$storm_IoCallDriver$14$label_36#1;

  inline$storm_IoCallDriver$14$anon14_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$14$Return#1;

  inline$storm_IoCallDriver$14$label_27_case_1#1:
    assume inline$storm_IoCallDriver$14$$result.storm_nondet$472.22$4$ == 0;
    goto inline$storm_IoCallDriver$14$label_29#1;

  inline$storm_IoCallDriver$14$label_29#1:
    inline$storm_IoCallDriver$14$$status$4$462.11$storm_IoCallDriver$8 := 0;
    goto inline$storm_IoCallDriver$14$label_37#1;

  inline$storm_IoCallDriver$14$label_37#1:
    goto inline$storm_IoCallDriver$14$label_38#1;

  inline$storm_IoCallDriver$14$label_38#1:
    goto inline$storm_IoCallDriver$14$label_39#1;

  inline$storm_IoCallDriver$14$label_39#1:
    goto inline$CallCompletionRoutine$29$Entry#1;

  inline$CallCompletionRoutine$29$Entry#1:
    inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4_.1 := inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8;
    goto inline$CallCompletionRoutine$29$start#1;

  inline$CallCompletionRoutine$29$start#1:
    inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$29$label_3#1;

  inline$CallCompletionRoutine$29$label_3#1:
    goto inline$CallCompletionRoutine$29$label_4#1;

  inline$CallCompletionRoutine$29$label_4#1:
    goto inline$CallCompletionRoutine$29$label_5#1;

  inline$CallCompletionRoutine$29$label_5#1:
    goto inline$CallCompletionRoutine$29$label_6#1;

  inline$CallCompletionRoutine$29$label_6#1:
    goto inline$CallCompletionRoutine$29$label_7#1;

  inline$CallCompletionRoutine$29$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$146$Entry#1;

  inline$IoGetCurrentIrpStackLocation$146$Entry#1:
    inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$146$start#1;

  inline$IoGetCurrentIrpStackLocation$146$start#1:
    inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$146$label_3#1;

  inline$IoGetCurrentIrpStackLocation$146$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$146$label_3_true#1, inline$IoGetCurrentIrpStackLocation$146$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$146$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$146$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$146$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$146$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$146$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$146$label_4#1;

  inline$IoGetCurrentIrpStackLocation$146$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$146$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$146$label_6#1;

  inline$IoGetCurrentIrpStackLocation$146$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$146$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$146$label_7#1;

  inline$IoGetCurrentIrpStackLocation$146$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$146$label_5#1;

  inline$IoGetCurrentIrpStackLocation$146$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$146$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$146$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$146$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$146$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$146$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$146$label_5#1;

  inline$IoGetCurrentIrpStackLocation$146$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$146$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$146$label_1#1;

  inline$IoGetCurrentIrpStackLocation$146$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$146$Return#1;

  inline$IoGetCurrentIrpStackLocation$146$Return#1:
    goto inline$CallCompletionRoutine$29$label_7$1#1;

  inline$CallCompletionRoutine$29$label_7$1#1:
    goto inline$CallCompletionRoutine$29$anon10_Then#1, inline$CallCompletionRoutine$29$anon10_Else#1;

  inline$CallCompletionRoutine$29$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$29$anon1#1;

  inline$CallCompletionRoutine$29$anon1#1:
    goto inline$CallCompletionRoutine$29$label_10#1;

  inline$CallCompletionRoutine$29$label_10#1:
    goto inline$CallCompletionRoutine$29$label_11#1;

  inline$CallCompletionRoutine$29$label_11#1:
    havoc inline$CallCompletionRoutine$29$myNondetVar_0;
    inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$29$myNondetVar_0;
    goto inline$CallCompletionRoutine$29$label_12#1;

  inline$CallCompletionRoutine$29$label_12#1:
    havoc inline$CallCompletionRoutine$29$myNondetVar_0;
    inline$CallCompletionRoutine$29$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$29$myNondetVar_0;
    goto inline$CallCompletionRoutine$29$label_13#1;

  inline$CallCompletionRoutine$29$label_13#1:
    havoc inline$CallCompletionRoutine$29$myNondetVar_0;
    goto inline$CallCompletionRoutine$29$label_14#1;

  inline$CallCompletionRoutine$29$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$147$Entry#1;

  inline$IoGetCurrentIrpStackLocation$147$Entry#1:
    inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$147$start#1;

  inline$IoGetCurrentIrpStackLocation$147$start#1:
    inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$147$label_3#1;

  inline$IoGetCurrentIrpStackLocation$147$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$147$label_3_true#1, inline$IoGetCurrentIrpStackLocation$147$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$147$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$147$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$147$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$147$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$147$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$147$label_4#1;

  inline$IoGetCurrentIrpStackLocation$147$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$147$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$147$label_6#1;

  inline$IoGetCurrentIrpStackLocation$147$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$147$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$147$label_7#1;

  inline$IoGetCurrentIrpStackLocation$147$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$147$label_5#1;

  inline$IoGetCurrentIrpStackLocation$147$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$147$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$147$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$147$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$147$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$147$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$147$label_5#1;

  inline$IoGetCurrentIrpStackLocation$147$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$147$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$147$label_1#1;

  inline$IoGetCurrentIrpStackLocation$147$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$147$Return#1;

  inline$IoGetCurrentIrpStackLocation$147$Return#1:
    goto inline$CallCompletionRoutine$29$label_14$1#1;

  inline$CallCompletionRoutine$29$label_14$1#1:
    goto inline$CallCompletionRoutine$29$anon11_Then#1, inline$CallCompletionRoutine$29$anon11_Else#1;

  inline$CallCompletionRoutine$29$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$29$anon3#1;

  inline$CallCompletionRoutine$29$anon3#1:
    goto inline$CallCompletionRoutine$29$label_17#1;

  inline$CallCompletionRoutine$29$label_17#1:
    goto inline$CallCompletionRoutine$29$label_18#1;

  inline$CallCompletionRoutine$29$label_18#1:
    goto inline$CallCompletionRoutine$29$label_18_true#1, inline$CallCompletionRoutine$29$label_18_false#1;

  inline$CallCompletionRoutine$29$label_18_false#1:
    assume inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$29$label_1#1;

  inline$CallCompletionRoutine$29$label_18_true#1:
    assume inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$29$label_19#1;

  inline$CallCompletionRoutine$29$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$29$label_20#1;

  inline$CallCompletionRoutine$29$label_20#1:
    goto inline$CallCompletionRoutine$29$label_20_icall_1#1, inline$CallCompletionRoutine$29$label_20_icall_2#1, inline$CallCompletionRoutine$29$label_20_icall_3#1;

  inline$CallCompletionRoutine$29$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$29$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$29$Entry#1;

  inline$BDLSystemPowerIoCompletion$29$Entry#1:
    inline$BDLSystemPowerIoCompletion$29$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$29$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$29$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$29$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$29$start#1;

  inline$BDLSystemPowerIoCompletion$29$start#1:
    call inline$BDLSystemPowerIoCompletion$29$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$29$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$29$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$29$label_3#1;

  inline$BDLSystemPowerIoCompletion$29$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_4#1;

  inline$BDLSystemPowerIoCompletion$29$label_4#1:
    inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_5#1;

  inline$BDLSystemPowerIoCompletion$29$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_6#1;

  inline$BDLSystemPowerIoCompletion$29$label_6#1:
    inline$BDLSystemPowerIoCompletion$29$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$29$label_7#1;

  inline$BDLSystemPowerIoCompletion$29$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_8#1;

  inline$BDLSystemPowerIoCompletion$29$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$29$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$29$label_9#1;

  inline$BDLSystemPowerIoCompletion$29$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_10#1;

  inline$BDLSystemPowerIoCompletion$29$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$149$Entry#1;

  inline$IoGetCurrentIrpStackLocation$149$Entry#1:
    inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$149$start#1;

  inline$IoGetCurrentIrpStackLocation$149$start#1:
    inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$149$label_3#1;

  inline$IoGetCurrentIrpStackLocation$149$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$149$label_3_true#1, inline$IoGetCurrentIrpStackLocation$149$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$149$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$149$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$149$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$149$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$149$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$149$label_4#1;

  inline$IoGetCurrentIrpStackLocation$149$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$149$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$149$label_6#1;

  inline$IoGetCurrentIrpStackLocation$149$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$149$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$149$label_7#1;

  inline$IoGetCurrentIrpStackLocation$149$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$149$label_5#1;

  inline$IoGetCurrentIrpStackLocation$149$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$149$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$149$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$149$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$149$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$149$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$149$label_5#1;

  inline$IoGetCurrentIrpStackLocation$149$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$149$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$149$label_1#1;

  inline$IoGetCurrentIrpStackLocation$149$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$149$Return#1;

  inline$IoGetCurrentIrpStackLocation$149$Return#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon36_Then#1, inline$BDLSystemPowerIoCompletion$29$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon1#1;

  inline$BDLSystemPowerIoCompletion$29$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_13#1;

  inline$BDLSystemPowerIoCompletion$29$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_14#1;

  inline$BDLSystemPowerIoCompletion$29$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_15#1;

  inline$BDLSystemPowerIoCompletion$29$label_15#1:
    goto inline$BDLGetDebugLevel$771$Entry#1;

  inline$BDLGetDebugLevel$771$Entry#1:
    goto inline$BDLGetDebugLevel$771$start#1;

  inline$BDLGetDebugLevel$771$start#1:
    goto inline$BDLGetDebugLevel$771$label_3#1;

  inline$BDLGetDebugLevel$771$label_3#1:
    havoc inline$BDLGetDebugLevel$771$myNondetVar_0;
    inline$BDLGetDebugLevel$771$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$771$myNondetVar_0;
    goto inline$BDLGetDebugLevel$771$label_1#1;

  inline$BDLGetDebugLevel$771$label_1#1:
    goto inline$BDLGetDebugLevel$771$Return#1;

  inline$BDLGetDebugLevel$771$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$771$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon37_Then#1, inline$BDLSystemPowerIoCompletion$29$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon3#1;

  inline$BDLSystemPowerIoCompletion$29$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_18#1;

  inline$BDLSystemPowerIoCompletion$29$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_18_true#1, inline$BDLSystemPowerIoCompletion$29$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_19#1;

  inline$BDLSystemPowerIoCompletion$29$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_22#1;

  inline$BDLSystemPowerIoCompletion$29$label_22#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_23#1;

  inline$BDLSystemPowerIoCompletion$29$label_23#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_24#1;

  inline$BDLSystemPowerIoCompletion$29$label_24#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_25#1;

  inline$BDLSystemPowerIoCompletion$29$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$29$label_19#1;

  inline$BDLSystemPowerIoCompletion$29$label_19#1:
    goto inline$BDLGetDebugLevel$772$Entry#1;

  inline$BDLGetDebugLevel$772$Entry#1:
    goto inline$BDLGetDebugLevel$772$start#1;

  inline$BDLGetDebugLevel$772$start#1:
    goto inline$BDLGetDebugLevel$772$label_3#1;

  inline$BDLGetDebugLevel$772$label_3#1:
    havoc inline$BDLGetDebugLevel$772$myNondetVar_0;
    inline$BDLGetDebugLevel$772$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$772$myNondetVar_0;
    goto inline$BDLGetDebugLevel$772$label_1#1;

  inline$BDLGetDebugLevel$772$label_1#1:
    goto inline$BDLGetDebugLevel$772$Return#1;

  inline$BDLGetDebugLevel$772$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$772$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon38_Then#1, inline$BDLSystemPowerIoCompletion$29$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon5#1;

  inline$BDLSystemPowerIoCompletion$29$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_28#1;

  inline$BDLSystemPowerIoCompletion$29$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_28_true#1, inline$BDLSystemPowerIoCompletion$29$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_29#1;

  inline$BDLSystemPowerIoCompletion$29$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_32#1;

  inline$BDLSystemPowerIoCompletion$29$label_32#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_33#1;

  inline$BDLSystemPowerIoCompletion$29$label_33#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_34#1;

  inline$BDLSystemPowerIoCompletion$29$label_34#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_35#1;

  inline$BDLSystemPowerIoCompletion$29$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$29$label_29#1;

  inline$BDLSystemPowerIoCompletion$29$label_29#1:
    goto inline$BDLGetDebugLevel$773$Entry#1;

  inline$BDLGetDebugLevel$773$Entry#1:
    goto inline$BDLGetDebugLevel$773$start#1;

  inline$BDLGetDebugLevel$773$start#1:
    goto inline$BDLGetDebugLevel$773$label_3#1;

  inline$BDLGetDebugLevel$773$label_3#1:
    havoc inline$BDLGetDebugLevel$773$myNondetVar_0;
    inline$BDLGetDebugLevel$773$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$773$myNondetVar_0;
    goto inline$BDLGetDebugLevel$773$label_1#1;

  inline$BDLGetDebugLevel$773$label_1#1:
    goto inline$BDLGetDebugLevel$773$Return#1;

  inline$BDLGetDebugLevel$773$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$773$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon39_Then#1, inline$BDLSystemPowerIoCompletion$29$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon7#1;

  inline$BDLSystemPowerIoCompletion$29$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_38#1;

  inline$BDLSystemPowerIoCompletion$29$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_38_true#1, inline$BDLSystemPowerIoCompletion$29$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_39#1;

  inline$BDLSystemPowerIoCompletion$29$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_40#1;

  inline$BDLSystemPowerIoCompletion$29$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_39#1;

  inline$BDLSystemPowerIoCompletion$29$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_39_true#1, inline$BDLSystemPowerIoCompletion$29$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_41#1;

  inline$BDLSystemPowerIoCompletion$29$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$29$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$29$label_107#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$29$label_108#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$29$label_108#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$29$label_108#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$29$label_108#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$29$label_108#1;

  inline$BDLSystemPowerIoCompletion$29$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_109#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$29$label_107#1;

  inline$BDLSystemPowerIoCompletion$29$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_109#1;

  inline$BDLSystemPowerIoCompletion$29$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$29$label_106#1;

  inline$BDLSystemPowerIoCompletion$29$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_106_true#1, inline$BDLSystemPowerIoCompletion$29$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_142#1;

  inline$BDLSystemPowerIoCompletion$29$label_142#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_143#1;

  inline$BDLSystemPowerIoCompletion$29$label_143#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_144#1;

  inline$BDLSystemPowerIoCompletion$29$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_109#1;

  inline$BDLSystemPowerIoCompletion$29$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_109#1;

  inline$BDLSystemPowerIoCompletion$29$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$29$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$29$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$29$myNondetVar_0, inline$BDLSystemPowerIoCompletion$29$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$29$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$29$anon50_Then#1, inline$BDLSystemPowerIoCompletion$29$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon29#1;

  inline$BDLSystemPowerIoCompletion$29$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_112#1;

  inline$BDLSystemPowerIoCompletion$29$label_112#1:
    inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$29$label_113#1;

  inline$BDLSystemPowerIoCompletion$29$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_113_true#1, inline$BDLSystemPowerIoCompletion$29$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$29$label_114#1;

  inline$BDLSystemPowerIoCompletion$29$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_116#1;

  inline$BDLSystemPowerIoCompletion$29$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_117#1;

  inline$BDLSystemPowerIoCompletion$29$label_117#1:
    goto inline$BDLGetDebugLevel$780$Entry#1;

  inline$BDLGetDebugLevel$780$Entry#1:
    goto inline$BDLGetDebugLevel$780$start#1;

  inline$BDLGetDebugLevel$780$start#1:
    goto inline$BDLGetDebugLevel$780$label_3#1;

  inline$BDLGetDebugLevel$780$label_3#1:
    havoc inline$BDLGetDebugLevel$780$myNondetVar_0;
    inline$BDLGetDebugLevel$780$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$780$myNondetVar_0;
    goto inline$BDLGetDebugLevel$780$label_1#1;

  inline$BDLGetDebugLevel$780$label_1#1:
    goto inline$BDLGetDebugLevel$780$Return#1;

  inline$BDLGetDebugLevel$780$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$780$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon51_Then#1, inline$BDLSystemPowerIoCompletion$29$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon31#1;

  inline$BDLSystemPowerIoCompletion$29$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_120#1;

  inline$BDLSystemPowerIoCompletion$29$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_120_true#1, inline$BDLSystemPowerIoCompletion$29$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_121#1;

  inline$BDLSystemPowerIoCompletion$29$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_124#1;

  inline$BDLSystemPowerIoCompletion$29$label_124#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_125#1;

  inline$BDLSystemPowerIoCompletion$29$label_125#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_126#1;

  inline$BDLSystemPowerIoCompletion$29$label_126#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_127#1;

  inline$BDLSystemPowerIoCompletion$29$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$29$label_121#1;

  inline$BDLSystemPowerIoCompletion$29$label_121#1:
    goto inline$BDLGetDebugLevel$781$Entry#1;

  inline$BDLGetDebugLevel$781$Entry#1:
    goto inline$BDLGetDebugLevel$781$start#1;

  inline$BDLGetDebugLevel$781$start#1:
    goto inline$BDLGetDebugLevel$781$label_3#1;

  inline$BDLGetDebugLevel$781$label_3#1:
    havoc inline$BDLGetDebugLevel$781$myNondetVar_0;
    inline$BDLGetDebugLevel$781$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$781$myNondetVar_0;
    goto inline$BDLGetDebugLevel$781$label_1#1;

  inline$BDLGetDebugLevel$781$label_1#1:
    goto inline$BDLGetDebugLevel$781$Return#1;

  inline$BDLGetDebugLevel$781$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$781$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon52_Then#1, inline$BDLSystemPowerIoCompletion$29$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon33#1;

  inline$BDLSystemPowerIoCompletion$29$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_130#1;

  inline$BDLSystemPowerIoCompletion$29$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_130_true#1, inline$BDLSystemPowerIoCompletion$29$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_131#1;

  inline$BDLSystemPowerIoCompletion$29$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_134#1;

  inline$BDLSystemPowerIoCompletion$29$label_134#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_135#1;

  inline$BDLSystemPowerIoCompletion$29$label_135#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_136#1;

  inline$BDLSystemPowerIoCompletion$29$label_136#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_137#1;

  inline$BDLSystemPowerIoCompletion$29$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$29$label_131#1;

  inline$BDLSystemPowerIoCompletion$29$label_131#1:
    goto inline$BDLGetDebugLevel$782$Entry#1;

  inline$BDLGetDebugLevel$782$Entry#1:
    goto inline$BDLGetDebugLevel$782$start#1;

  inline$BDLGetDebugLevel$782$start#1:
    goto inline$BDLGetDebugLevel$782$label_3#1;

  inline$BDLGetDebugLevel$782$label_3#1:
    havoc inline$BDLGetDebugLevel$782$myNondetVar_0;
    inline$BDLGetDebugLevel$782$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$782$myNondetVar_0;
    goto inline$BDLGetDebugLevel$782$label_1#1;

  inline$BDLGetDebugLevel$782$label_1#1:
    goto inline$BDLGetDebugLevel$782$Return#1;

  inline$BDLGetDebugLevel$782$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$782$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon53_Then#1, inline$BDLSystemPowerIoCompletion$29$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon35#1;

  inline$BDLSystemPowerIoCompletion$29$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_140#1;

  inline$BDLSystemPowerIoCompletion$29$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_140_true#1, inline$BDLSystemPowerIoCompletion$29$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_67#1;

  inline$BDLSystemPowerIoCompletion$29$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_141#1;

  inline$BDLSystemPowerIoCompletion$29$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_67#1;

  inline$BDLSystemPowerIoCompletion$29$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$29$label_115#1;

  inline$BDLSystemPowerIoCompletion$29$label_115#1:
    inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$29$label_80#1;

  inline$BDLSystemPowerIoCompletion$29$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$29$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_42#1;

  inline$BDLSystemPowerIoCompletion$29$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$29$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$29$label_43#1;

  inline$BDLSystemPowerIoCompletion$29$label_43#1:
    goto inline$BDLGetDebugLevel$774$Entry#1;

  inline$BDLGetDebugLevel$774$Entry#1:
    goto inline$BDLGetDebugLevel$774$start#1;

  inline$BDLGetDebugLevel$774$start#1:
    goto inline$BDLGetDebugLevel$774$label_3#1;

  inline$BDLGetDebugLevel$774$label_3#1:
    havoc inline$BDLGetDebugLevel$774$myNondetVar_0;
    inline$BDLGetDebugLevel$774$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$774$myNondetVar_0;
    goto inline$BDLGetDebugLevel$774$label_1#1;

  inline$BDLGetDebugLevel$774$label_1#1:
    goto inline$BDLGetDebugLevel$774$Return#1;

  inline$BDLGetDebugLevel$774$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$774$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon40_Then#1, inline$BDLSystemPowerIoCompletion$29$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon9#1;

  inline$BDLSystemPowerIoCompletion$29$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_46#1;

  inline$BDLSystemPowerIoCompletion$29$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_46_true#1, inline$BDLSystemPowerIoCompletion$29$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_47#1;

  inline$BDLSystemPowerIoCompletion$29$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_50#1;

  inline$BDLSystemPowerIoCompletion$29$label_50#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_51#1;

  inline$BDLSystemPowerIoCompletion$29$label_51#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_52#1;

  inline$BDLSystemPowerIoCompletion$29$label_52#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_53#1;

  inline$BDLSystemPowerIoCompletion$29$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$29$label_47#1;

  inline$BDLSystemPowerIoCompletion$29$label_47#1:
    goto inline$BDLGetDebugLevel$775$Entry#1;

  inline$BDLGetDebugLevel$775$Entry#1:
    goto inline$BDLGetDebugLevel$775$start#1;

  inline$BDLGetDebugLevel$775$start#1:
    goto inline$BDLGetDebugLevel$775$label_3#1;

  inline$BDLGetDebugLevel$775$label_3#1:
    havoc inline$BDLGetDebugLevel$775$myNondetVar_0;
    inline$BDLGetDebugLevel$775$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$775$myNondetVar_0;
    goto inline$BDLGetDebugLevel$775$label_1#1;

  inline$BDLGetDebugLevel$775$label_1#1:
    goto inline$BDLGetDebugLevel$775$Return#1;

  inline$BDLGetDebugLevel$775$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$775$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon41_Then#1, inline$BDLSystemPowerIoCompletion$29$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon11#1;

  inline$BDLSystemPowerIoCompletion$29$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_56#1;

  inline$BDLSystemPowerIoCompletion$29$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_56_true#1, inline$BDLSystemPowerIoCompletion$29$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_57#1;

  inline$BDLSystemPowerIoCompletion$29$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_60#1;

  inline$BDLSystemPowerIoCompletion$29$label_60#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_61#1;

  inline$BDLSystemPowerIoCompletion$29$label_61#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_62#1;

  inline$BDLSystemPowerIoCompletion$29$label_62#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_63#1;

  inline$BDLSystemPowerIoCompletion$29$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$29$label_57#1;

  inline$BDLSystemPowerIoCompletion$29$label_57#1:
    goto inline$BDLGetDebugLevel$776$Entry#1;

  inline$BDLGetDebugLevel$776$Entry#1:
    goto inline$BDLGetDebugLevel$776$start#1;

  inline$BDLGetDebugLevel$776$start#1:
    goto inline$BDLGetDebugLevel$776$label_3#1;

  inline$BDLGetDebugLevel$776$label_3#1:
    havoc inline$BDLGetDebugLevel$776$myNondetVar_0;
    inline$BDLGetDebugLevel$776$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$776$myNondetVar_0;
    goto inline$BDLGetDebugLevel$776$label_1#1;

  inline$BDLGetDebugLevel$776$label_1#1:
    goto inline$BDLGetDebugLevel$776$Return#1;

  inline$BDLGetDebugLevel$776$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$776$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon42_Then#1, inline$BDLSystemPowerIoCompletion$29$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon13#1;

  inline$BDLSystemPowerIoCompletion$29$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_66#1;

  inline$BDLSystemPowerIoCompletion$29$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_66_true#1, inline$BDLSystemPowerIoCompletion$29$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_67#1;

  inline$BDLSystemPowerIoCompletion$29$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_70#1;

  inline$BDLSystemPowerIoCompletion$29$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_67#1;

  inline$BDLSystemPowerIoCompletion$29$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$29$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$29$anon43_Then#1, inline$BDLSystemPowerIoCompletion$29$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon15#1;

  inline$BDLSystemPowerIoCompletion$29$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_71#1;

  inline$BDLSystemPowerIoCompletion$29$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$29$anon44_Then#1, inline$BDLSystemPowerIoCompletion$29$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon17#1;

  inline$BDLSystemPowerIoCompletion$29$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_74#1;

  inline$BDLSystemPowerIoCompletion$29$label_74#1:
    goto inline$storm_IoCompleteRequest$61$Entry#1;

  inline$storm_IoCompleteRequest$61$Entry#1:
    inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$29$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$61$start#1;

  inline$storm_IoCompleteRequest$61$start#1:
    inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$61$label_3#1;

  inline$storm_IoCompleteRequest$61$label_3#1:
    call inline$storm_IoCompleteRequest$61$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$61$label_6#1;

  inline$storm_IoCompleteRequest$61$label_6#1:
    goto inline$storm_IoCompleteRequest$61$label_6_true#1, inline$storm_IoCompleteRequest$61$label_6_false#1;

  inline$storm_IoCompleteRequest$61$label_6_false#1:
    assume inline$storm_IoCompleteRequest$61$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$61$label_7#1;

  inline$storm_IoCompleteRequest$61$label_6_true#1:
    assume inline$storm_IoCompleteRequest$61$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$61$label_8#1;

  inline$storm_IoCompleteRequest$61$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$61$anon3_Then#1, inline$storm_IoCompleteRequest$61$anon3_Else#1;

  inline$storm_IoCompleteRequest$61$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$61$anon1#1;

  inline$storm_IoCompleteRequest$61$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$61$label_9#1;

  inline$storm_IoCompleteRequest$61$label_9#1:
    goto inline$storm_IoCompleteRequest$61$label_9_true#1, inline$storm_IoCompleteRequest$61$label_9_false#1;

  inline$storm_IoCompleteRequest$61$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$61$label_10#1;

  inline$storm_IoCompleteRequest$61$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$61$label_1#1;

  inline$storm_IoCompleteRequest$61$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$61$label_7#1;

  inline$storm_IoCompleteRequest$61$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$61$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$61$label_1#1;

  inline$storm_IoCompleteRequest$61$label_1#1:
    goto inline$storm_IoCompleteRequest$61$Return#1;

  inline$storm_IoCompleteRequest$61$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$61$Return#1;

  inline$storm_IoCompleteRequest$61$Return#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon45_Then#1, inline$BDLSystemPowerIoCompletion$29$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon19#1;

  inline$BDLSystemPowerIoCompletion$29$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_77#1;

  inline$BDLSystemPowerIoCompletion$29$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$29$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$29$anon46_Then#1, inline$BDLSystemPowerIoCompletion$29$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon21#1;

  inline$BDLSystemPowerIoCompletion$29$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_80#1;

  inline$BDLSystemPowerIoCompletion$29$label_80#1:
    goto inline$BDLGetDebugLevel$777$Entry#1;

  inline$BDLGetDebugLevel$777$Entry#1:
    goto inline$BDLGetDebugLevel$777$start#1;

  inline$BDLGetDebugLevel$777$start#1:
    goto inline$BDLGetDebugLevel$777$label_3#1;

  inline$BDLGetDebugLevel$777$label_3#1:
    havoc inline$BDLGetDebugLevel$777$myNondetVar_0;
    inline$BDLGetDebugLevel$777$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$777$myNondetVar_0;
    goto inline$BDLGetDebugLevel$777$label_1#1;

  inline$BDLGetDebugLevel$777$label_1#1:
    goto inline$BDLGetDebugLevel$777$Return#1;

  inline$BDLGetDebugLevel$777$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$777$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon47_Then#1, inline$BDLSystemPowerIoCompletion$29$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon23#1;

  inline$BDLSystemPowerIoCompletion$29$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_83#1;

  inline$BDLSystemPowerIoCompletion$29$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_83_true#1, inline$BDLSystemPowerIoCompletion$29$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_84#1;

  inline$BDLSystemPowerIoCompletion$29$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_87#1;

  inline$BDLSystemPowerIoCompletion$29$label_87#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_88#1;

  inline$BDLSystemPowerIoCompletion$29$label_88#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_89#1;

  inline$BDLSystemPowerIoCompletion$29$label_89#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_90#1;

  inline$BDLSystemPowerIoCompletion$29$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$29$label_84#1;

  inline$BDLSystemPowerIoCompletion$29$label_84#1:
    goto inline$BDLGetDebugLevel$778$Entry#1;

  inline$BDLGetDebugLevel$778$Entry#1:
    goto inline$BDLGetDebugLevel$778$start#1;

  inline$BDLGetDebugLevel$778$start#1:
    goto inline$BDLGetDebugLevel$778$label_3#1;

  inline$BDLGetDebugLevel$778$label_3#1:
    havoc inline$BDLGetDebugLevel$778$myNondetVar_0;
    inline$BDLGetDebugLevel$778$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$778$myNondetVar_0;
    goto inline$BDLGetDebugLevel$778$label_1#1;

  inline$BDLGetDebugLevel$778$label_1#1:
    goto inline$BDLGetDebugLevel$778$Return#1;

  inline$BDLGetDebugLevel$778$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$778$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon48_Then#1, inline$BDLSystemPowerIoCompletion$29$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon25#1;

  inline$BDLSystemPowerIoCompletion$29$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_93#1;

  inline$BDLSystemPowerIoCompletion$29$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_93_true#1, inline$BDLSystemPowerIoCompletion$29$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_94#1;

  inline$BDLSystemPowerIoCompletion$29$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_97#1;

  inline$BDLSystemPowerIoCompletion$29$label_97#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_98#1;

  inline$BDLSystemPowerIoCompletion$29$label_98#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_99#1;

  inline$BDLSystemPowerIoCompletion$29$label_99#1:
    call inline$BDLSystemPowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$29$label_100#1;

  inline$BDLSystemPowerIoCompletion$29$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$29$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$29$label_94#1;

  inline$BDLSystemPowerIoCompletion$29$label_94#1:
    goto inline$BDLGetDebugLevel$779$Entry#1;

  inline$BDLGetDebugLevel$779$Entry#1:
    goto inline$BDLGetDebugLevel$779$start#1;

  inline$BDLGetDebugLevel$779$start#1:
    goto inline$BDLGetDebugLevel$779$label_3#1;

  inline$BDLGetDebugLevel$779$label_3#1:
    havoc inline$BDLGetDebugLevel$779$myNondetVar_0;
    inline$BDLGetDebugLevel$779$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$779$myNondetVar_0;
    goto inline$BDLGetDebugLevel$779$label_1#1;

  inline$BDLGetDebugLevel$779$label_1#1:
    goto inline$BDLGetDebugLevel$779$Return#1;

  inline$BDLGetDebugLevel$779$Return#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$779$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$29$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$29$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$29$anon49_Then#1, inline$BDLSystemPowerIoCompletion$29$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$29$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$anon27#1;

  inline$BDLSystemPowerIoCompletion$29$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_103#1;

  inline$BDLSystemPowerIoCompletion$29$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_103_true#1, inline$BDLSystemPowerIoCompletion$29$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$29$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_104#1;

  inline$BDLSystemPowerIoCompletion$29$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$29$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$29$label_105#1;

  inline$BDLSystemPowerIoCompletion$29$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$29$label_104#1;

  inline$BDLSystemPowerIoCompletion$29$label_104#1:
    inline$BDLSystemPowerIoCompletion$29$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$29$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$29$label_1#1;

  inline$BDLSystemPowerIoCompletion$29$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$29$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$29$Return#1;

  inline$BDLSystemPowerIoCompletion$29$Return#1:
    inline$CallCompletionRoutine$29$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$29$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$29$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$29$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$29$anon14_Then#1, inline$CallCompletionRoutine$29$anon14_Else#1;

  inline$CallCompletionRoutine$29$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$29$anon9#1;

  inline$CallCompletionRoutine$29$anon9#1:
    goto inline$CallCompletionRoutine$29$label_20_icall_return#1;

  inline$CallCompletionRoutine$29$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$29$Return#1;

  inline$CallCompletionRoutine$29$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$29$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$29$Entry#1;

  inline$BDLDevicePowerIoCompletion$29$Entry#1:
    inline$BDLDevicePowerIoCompletion$29$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$29$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$29$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$29$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$29$start#1;

  inline$BDLDevicePowerIoCompletion$29$start#1:
    call inline$BDLDevicePowerIoCompletion$29$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$29$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$29$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$29$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$29$label_3#1;

  inline$BDLDevicePowerIoCompletion$29$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_4#1;

  inline$BDLDevicePowerIoCompletion$29$label_4#1:
    inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_5#1;

  inline$BDLDevicePowerIoCompletion$29$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_6#1;

  inline$BDLDevicePowerIoCompletion$29$label_6#1:
    inline$BDLDevicePowerIoCompletion$29$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$29$label_7#1;

  inline$BDLDevicePowerIoCompletion$29$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_8#1;

  inline$BDLDevicePowerIoCompletion$29$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$29$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$29$label_9#1;

  inline$BDLDevicePowerIoCompletion$29$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_10#1;

  inline$BDLDevicePowerIoCompletion$29$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$148$Entry#1;

  inline$IoGetCurrentIrpStackLocation$148$Entry#1:
    inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$148$start#1;

  inline$IoGetCurrentIrpStackLocation$148$start#1:
    inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$148$label_3#1;

  inline$IoGetCurrentIrpStackLocation$148$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$148$label_3_true#1, inline$IoGetCurrentIrpStackLocation$148$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$148$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$148$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$148$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$148$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$148$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$148$label_4#1;

  inline$IoGetCurrentIrpStackLocation$148$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$148$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$148$label_6#1;

  inline$IoGetCurrentIrpStackLocation$148$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$148$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$148$label_7#1;

  inline$IoGetCurrentIrpStackLocation$148$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$148$label_5#1;

  inline$IoGetCurrentIrpStackLocation$148$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$148$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$148$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$148$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$148$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$148$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$148$label_5#1;

  inline$IoGetCurrentIrpStackLocation$148$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$148$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$148$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$148$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$148$label_1#1;

  inline$IoGetCurrentIrpStackLocation$148$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$148$Return#1;

  inline$IoGetCurrentIrpStackLocation$148$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$148$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon30_Then#1, inline$BDLDevicePowerIoCompletion$29$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon1#1;

  inline$BDLDevicePowerIoCompletion$29$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_13#1;

  inline$BDLDevicePowerIoCompletion$29$label_13#1:
    inline$BDLDevicePowerIoCompletion$29$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$29$label_14#1;

  inline$BDLDevicePowerIoCompletion$29$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_15#1;

  inline$BDLDevicePowerIoCompletion$29$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$29$label_16#1;

  inline$BDLDevicePowerIoCompletion$29$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_17#1;

  inline$BDLDevicePowerIoCompletion$29$label_17#1:
    goto inline$BDLGetDebugLevel$762$Entry#1;

  inline$BDLGetDebugLevel$762$Entry#1:
    goto inline$BDLGetDebugLevel$762$start#1;

  inline$BDLGetDebugLevel$762$start#1:
    goto inline$BDLGetDebugLevel$762$label_3#1;

  inline$BDLGetDebugLevel$762$label_3#1:
    havoc inline$BDLGetDebugLevel$762$myNondetVar_0;
    inline$BDLGetDebugLevel$762$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$762$myNondetVar_0;
    goto inline$BDLGetDebugLevel$762$label_1#1;

  inline$BDLGetDebugLevel$762$label_1#1:
    goto inline$BDLGetDebugLevel$762$Return#1;

  inline$BDLGetDebugLevel$762$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$762$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon31_Then#1, inline$BDLDevicePowerIoCompletion$29$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon3#1;

  inline$BDLDevicePowerIoCompletion$29$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_20#1;

  inline$BDLDevicePowerIoCompletion$29$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_20_true#1, inline$BDLDevicePowerIoCompletion$29$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_21#1;

  inline$BDLDevicePowerIoCompletion$29$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_24#1;

  inline$BDLDevicePowerIoCompletion$29$label_24#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_25#1;

  inline$BDLDevicePowerIoCompletion$29$label_25#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_26#1;

  inline$BDLDevicePowerIoCompletion$29$label_26#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_27#1;

  inline$BDLDevicePowerIoCompletion$29$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$29$label_21#1;

  inline$BDLDevicePowerIoCompletion$29$label_21#1:
    goto inline$BDLGetDebugLevel$763$Entry#1;

  inline$BDLGetDebugLevel$763$Entry#1:
    goto inline$BDLGetDebugLevel$763$start#1;

  inline$BDLGetDebugLevel$763$start#1:
    goto inline$BDLGetDebugLevel$763$label_3#1;

  inline$BDLGetDebugLevel$763$label_3#1:
    havoc inline$BDLGetDebugLevel$763$myNondetVar_0;
    inline$BDLGetDebugLevel$763$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$763$myNondetVar_0;
    goto inline$BDLGetDebugLevel$763$label_1#1;

  inline$BDLGetDebugLevel$763$label_1#1:
    goto inline$BDLGetDebugLevel$763$Return#1;

  inline$BDLGetDebugLevel$763$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$763$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon32_Then#1, inline$BDLDevicePowerIoCompletion$29$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon5#1;

  inline$BDLDevicePowerIoCompletion$29$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_30#1;

  inline$BDLDevicePowerIoCompletion$29$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_30_true#1, inline$BDLDevicePowerIoCompletion$29$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_31#1;

  inline$BDLDevicePowerIoCompletion$29$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_34#1;

  inline$BDLDevicePowerIoCompletion$29$label_34#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_35#1;

  inline$BDLDevicePowerIoCompletion$29$label_35#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_36#1;

  inline$BDLDevicePowerIoCompletion$29$label_36#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_37#1;

  inline$BDLDevicePowerIoCompletion$29$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$29$label_31#1;

  inline$BDLDevicePowerIoCompletion$29$label_31#1:
    goto inline$BDLGetDebugLevel$764$Entry#1;

  inline$BDLGetDebugLevel$764$Entry#1:
    goto inline$BDLGetDebugLevel$764$start#1;

  inline$BDLGetDebugLevel$764$start#1:
    goto inline$BDLGetDebugLevel$764$label_3#1;

  inline$BDLGetDebugLevel$764$label_3#1:
    havoc inline$BDLGetDebugLevel$764$myNondetVar_0;
    inline$BDLGetDebugLevel$764$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$764$myNondetVar_0;
    goto inline$BDLGetDebugLevel$764$label_1#1;

  inline$BDLGetDebugLevel$764$label_1#1:
    goto inline$BDLGetDebugLevel$764$Return#1;

  inline$BDLGetDebugLevel$764$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$764$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon33_Then#1, inline$BDLDevicePowerIoCompletion$29$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon7#1;

  inline$BDLDevicePowerIoCompletion$29$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_40#1;

  inline$BDLDevicePowerIoCompletion$29$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_40_true#1, inline$BDLDevicePowerIoCompletion$29$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_41#1;

  inline$BDLDevicePowerIoCompletion$29$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_42#1;

  inline$BDLDevicePowerIoCompletion$29$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_41#1;

  inline$BDLDevicePowerIoCompletion$29$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_41_true#1, inline$BDLDevicePowerIoCompletion$29$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$29$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$29$label_43#1;

  inline$BDLDevicePowerIoCompletion$29$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$29$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$29$label_44#1;

  inline$BDLDevicePowerIoCompletion$29$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_44_true#1, inline$BDLDevicePowerIoCompletion$29$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$29$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$29$label_45#1;

  inline$BDLDevicePowerIoCompletion$29$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_45_true#1, inline$BDLDevicePowerIoCompletion$29$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$29$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$29$label_43#1;

  inline$BDLDevicePowerIoCompletion$29$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$29$label_86#1;

  inline$BDLDevicePowerIoCompletion$29$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$29$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$29$label_46#1;

  inline$BDLDevicePowerIoCompletion$29$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$29$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$29$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$29$label_46#1;

  inline$BDLDevicePowerIoCompletion$29$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$29$label_49#1;

  inline$BDLDevicePowerIoCompletion$29$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_50#1;

  inline$BDLDevicePowerIoCompletion$29$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_51#1;

  inline$BDLDevicePowerIoCompletion$29$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_54#1;

  inline$BDLDevicePowerIoCompletion$29$label_54#1:
    inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$29$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$29$label_55#1;

  inline$BDLDevicePowerIoCompletion$29$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_55_true#1, inline$BDLDevicePowerIoCompletion$29$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_56#1;

  inline$BDLDevicePowerIoCompletion$29$label_56#1:
    call inline$BDLDevicePowerIoCompletion$29$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$29$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$29$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$29$anon34_Then#1, inline$BDLDevicePowerIoCompletion$29$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon9#1;

  inline$BDLDevicePowerIoCompletion$29$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_83#1;

  inline$BDLDevicePowerIoCompletion$29$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_59#1;

  inline$BDLDevicePowerIoCompletion$29$label_59#1:
    goto inline$BDLGetDebugLevel$765$Entry#1;

  inline$BDLGetDebugLevel$765$Entry#1:
    goto inline$BDLGetDebugLevel$765$start#1;

  inline$BDLGetDebugLevel$765$start#1:
    goto inline$BDLGetDebugLevel$765$label_3#1;

  inline$BDLGetDebugLevel$765$label_3#1:
    havoc inline$BDLGetDebugLevel$765$myNondetVar_0;
    inline$BDLGetDebugLevel$765$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$765$myNondetVar_0;
    goto inline$BDLGetDebugLevel$765$label_1#1;

  inline$BDLGetDebugLevel$765$label_1#1:
    goto inline$BDLGetDebugLevel$765$Return#1;

  inline$BDLGetDebugLevel$765$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$765$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon35_Then#1, inline$BDLDevicePowerIoCompletion$29$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon11#1;

  inline$BDLDevicePowerIoCompletion$29$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_62#1;

  inline$BDLDevicePowerIoCompletion$29$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_62_true#1, inline$BDLDevicePowerIoCompletion$29$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_63#1;

  inline$BDLDevicePowerIoCompletion$29$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_66#1;

  inline$BDLDevicePowerIoCompletion$29$label_66#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_67#1;

  inline$BDLDevicePowerIoCompletion$29$label_67#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_68#1;

  inline$BDLDevicePowerIoCompletion$29$label_68#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_69#1;

  inline$BDLDevicePowerIoCompletion$29$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$29$label_63#1;

  inline$BDLDevicePowerIoCompletion$29$label_63#1:
    goto inline$BDLGetDebugLevel$766$Entry#1;

  inline$BDLGetDebugLevel$766$Entry#1:
    goto inline$BDLGetDebugLevel$766$start#1;

  inline$BDLGetDebugLevel$766$start#1:
    goto inline$BDLGetDebugLevel$766$label_3#1;

  inline$BDLGetDebugLevel$766$label_3#1:
    havoc inline$BDLGetDebugLevel$766$myNondetVar_0;
    inline$BDLGetDebugLevel$766$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$766$myNondetVar_0;
    goto inline$BDLGetDebugLevel$766$label_1#1;

  inline$BDLGetDebugLevel$766$label_1#1:
    goto inline$BDLGetDebugLevel$766$Return#1;

  inline$BDLGetDebugLevel$766$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$766$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon36_Then#1, inline$BDLDevicePowerIoCompletion$29$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon13#1;

  inline$BDLDevicePowerIoCompletion$29$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_72#1;

  inline$BDLDevicePowerIoCompletion$29$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_72_true#1, inline$BDLDevicePowerIoCompletion$29$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_73#1;

  inline$BDLDevicePowerIoCompletion$29$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_76#1;

  inline$BDLDevicePowerIoCompletion$29$label_76#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_77#1;

  inline$BDLDevicePowerIoCompletion$29$label_77#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_78#1;

  inline$BDLDevicePowerIoCompletion$29$label_78#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_79#1;

  inline$BDLDevicePowerIoCompletion$29$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$29$label_73#1;

  inline$BDLDevicePowerIoCompletion$29$label_73#1:
    goto inline$BDLGetDebugLevel$767$Entry#1;

  inline$BDLGetDebugLevel$767$Entry#1:
    goto inline$BDLGetDebugLevel$767$start#1;

  inline$BDLGetDebugLevel$767$start#1:
    goto inline$BDLGetDebugLevel$767$label_3#1;

  inline$BDLGetDebugLevel$767$label_3#1:
    havoc inline$BDLGetDebugLevel$767$myNondetVar_0;
    inline$BDLGetDebugLevel$767$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$767$myNondetVar_0;
    goto inline$BDLGetDebugLevel$767$label_1#1;

  inline$BDLGetDebugLevel$767$label_1#1:
    goto inline$BDLGetDebugLevel$767$Return#1;

  inline$BDLGetDebugLevel$767$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$767$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon37_Then#1, inline$BDLDevicePowerIoCompletion$29$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon15#1;

  inline$BDLDevicePowerIoCompletion$29$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_82#1;

  inline$BDLDevicePowerIoCompletion$29$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_82_true#1, inline$BDLDevicePowerIoCompletion$29$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_83#1;

  inline$BDLDevicePowerIoCompletion$29$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_84#1;

  inline$BDLDevicePowerIoCompletion$29$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_83#1;

  inline$BDLDevicePowerIoCompletion$29$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_85#1;

  inline$BDLDevicePowerIoCompletion$29$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_86#1;

  inline$BDLDevicePowerIoCompletion$29$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$29$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$29$anon38_Then#1, inline$BDLDevicePowerIoCompletion$29$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon17#1;

  inline$BDLDevicePowerIoCompletion$29$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_89#1;

  inline$BDLDevicePowerIoCompletion$29$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$29$anon39_Then#1, inline$BDLDevicePowerIoCompletion$29$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon19#1;

  inline$BDLDevicePowerIoCompletion$29$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_92#1;

  inline$BDLDevicePowerIoCompletion$29$label_92#1:
    goto inline$storm_IoCompleteRequest$60$Entry#1;

  inline$storm_IoCompleteRequest$60$Entry#1:
    inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$29$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$60$start#1;

  inline$storm_IoCompleteRequest$60$start#1:
    inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$60$label_3#1;

  inline$storm_IoCompleteRequest$60$label_3#1:
    call inline$storm_IoCompleteRequest$60$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$60$label_6#1;

  inline$storm_IoCompleteRequest$60$label_6#1:
    goto inline$storm_IoCompleteRequest$60$label_6_true#1, inline$storm_IoCompleteRequest$60$label_6_false#1;

  inline$storm_IoCompleteRequest$60$label_6_false#1:
    assume inline$storm_IoCompleteRequest$60$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$60$label_7#1;

  inline$storm_IoCompleteRequest$60$label_6_true#1:
    assume inline$storm_IoCompleteRequest$60$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$60$label_8#1;

  inline$storm_IoCompleteRequest$60$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$60$anon3_Then#1, inline$storm_IoCompleteRequest$60$anon3_Else#1;

  inline$storm_IoCompleteRequest$60$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$60$anon1#1;

  inline$storm_IoCompleteRequest$60$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$60$label_9#1;

  inline$storm_IoCompleteRequest$60$label_9#1:
    goto inline$storm_IoCompleteRequest$60$label_9_true#1, inline$storm_IoCompleteRequest$60$label_9_false#1;

  inline$storm_IoCompleteRequest$60$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$60$label_10#1;

  inline$storm_IoCompleteRequest$60$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$60$label_1#1;

  inline$storm_IoCompleteRequest$60$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$60$label_7#1;

  inline$storm_IoCompleteRequest$60$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$60$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$60$label_1#1;

  inline$storm_IoCompleteRequest$60$label_1#1:
    goto inline$storm_IoCompleteRequest$60$Return#1;

  inline$storm_IoCompleteRequest$60$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$60$Return#1;

  inline$storm_IoCompleteRequest$60$Return#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon40_Then#1, inline$BDLDevicePowerIoCompletion$29$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon21#1;

  inline$BDLDevicePowerIoCompletion$29$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_95#1;

  inline$BDLDevicePowerIoCompletion$29$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$29$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$29$anon41_Then#1, inline$BDLDevicePowerIoCompletion$29$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon23#1;

  inline$BDLDevicePowerIoCompletion$29$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_98#1;

  inline$BDLDevicePowerIoCompletion$29$label_98#1:
    goto inline$BDLGetDebugLevel$768$Entry#1;

  inline$BDLGetDebugLevel$768$Entry#1:
    goto inline$BDLGetDebugLevel$768$start#1;

  inline$BDLGetDebugLevel$768$start#1:
    goto inline$BDLGetDebugLevel$768$label_3#1;

  inline$BDLGetDebugLevel$768$label_3#1:
    havoc inline$BDLGetDebugLevel$768$myNondetVar_0;
    inline$BDLGetDebugLevel$768$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$768$myNondetVar_0;
    goto inline$BDLGetDebugLevel$768$label_1#1;

  inline$BDLGetDebugLevel$768$label_1#1:
    goto inline$BDLGetDebugLevel$768$Return#1;

  inline$BDLGetDebugLevel$768$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$768$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon42_Then#1, inline$BDLDevicePowerIoCompletion$29$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon25#1;

  inline$BDLDevicePowerIoCompletion$29$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_101#1;

  inline$BDLDevicePowerIoCompletion$29$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_101_true#1, inline$BDLDevicePowerIoCompletion$29$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_102#1;

  inline$BDLDevicePowerIoCompletion$29$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_105#1;

  inline$BDLDevicePowerIoCompletion$29$label_105#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_106#1;

  inline$BDLDevicePowerIoCompletion$29$label_106#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_107#1;

  inline$BDLDevicePowerIoCompletion$29$label_107#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_108#1;

  inline$BDLDevicePowerIoCompletion$29$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$29$label_102#1;

  inline$BDLDevicePowerIoCompletion$29$label_102#1:
    goto inline$BDLGetDebugLevel$769$Entry#1;

  inline$BDLGetDebugLevel$769$Entry#1:
    goto inline$BDLGetDebugLevel$769$start#1;

  inline$BDLGetDebugLevel$769$start#1:
    goto inline$BDLGetDebugLevel$769$label_3#1;

  inline$BDLGetDebugLevel$769$label_3#1:
    havoc inline$BDLGetDebugLevel$769$myNondetVar_0;
    inline$BDLGetDebugLevel$769$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$769$myNondetVar_0;
    goto inline$BDLGetDebugLevel$769$label_1#1;

  inline$BDLGetDebugLevel$769$label_1#1:
    goto inline$BDLGetDebugLevel$769$Return#1;

  inline$BDLGetDebugLevel$769$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$769$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon43_Then#1, inline$BDLDevicePowerIoCompletion$29$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon27#1;

  inline$BDLDevicePowerIoCompletion$29$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_111#1;

  inline$BDLDevicePowerIoCompletion$29$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_111_true#1, inline$BDLDevicePowerIoCompletion$29$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_112#1;

  inline$BDLDevicePowerIoCompletion$29$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_115#1;

  inline$BDLDevicePowerIoCompletion$29$label_115#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_116#1;

  inline$BDLDevicePowerIoCompletion$29$label_116#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_117#1;

  inline$BDLDevicePowerIoCompletion$29$label_117#1:
    call inline$BDLDevicePowerIoCompletion$29$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$29$label_118#1;

  inline$BDLDevicePowerIoCompletion$29$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$29$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$29$label_112#1;

  inline$BDLDevicePowerIoCompletion$29$label_112#1:
    goto inline$BDLGetDebugLevel$770$Entry#1;

  inline$BDLGetDebugLevel$770$Entry#1:
    goto inline$BDLGetDebugLevel$770$start#1;

  inline$BDLGetDebugLevel$770$start#1:
    goto inline$BDLGetDebugLevel$770$label_3#1;

  inline$BDLGetDebugLevel$770$label_3#1:
    havoc inline$BDLGetDebugLevel$770$myNondetVar_0;
    inline$BDLGetDebugLevel$770$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$770$myNondetVar_0;
    goto inline$BDLGetDebugLevel$770$label_1#1;

  inline$BDLGetDebugLevel$770$label_1#1:
    goto inline$BDLGetDebugLevel$770$Return#1;

  inline$BDLGetDebugLevel$770$Return#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$770$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$29$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$29$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$29$anon44_Then#1, inline$BDLDevicePowerIoCompletion$29$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$29$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$anon29#1;

  inline$BDLDevicePowerIoCompletion$29$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_121#1;

  inline$BDLDevicePowerIoCompletion$29$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_121_true#1, inline$BDLDevicePowerIoCompletion$29$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$29$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_122#1;

  inline$BDLDevicePowerIoCompletion$29$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$29$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$29$label_123#1;

  inline$BDLDevicePowerIoCompletion$29$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$29$label_122#1;

  inline$BDLDevicePowerIoCompletion$29$label_122#1:
    inline$BDLDevicePowerIoCompletion$29$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$29$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$29$label_1#1;

  inline$BDLDevicePowerIoCompletion$29$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$29$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$29$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$29$Return#1;

  inline$BDLDevicePowerIoCompletion$29$Return#1:
    inline$CallCompletionRoutine$29$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$29$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$29$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$29$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$29$anon13_Then#1, inline$CallCompletionRoutine$29$anon13_Else#1;

  inline$CallCompletionRoutine$29$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$29$anon7#1;

  inline$CallCompletionRoutine$29$anon7#1:
    goto inline$CallCompletionRoutine$29$label_20_icall_return#1;

  inline$CallCompletionRoutine$29$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$29$Return#1;

  inline$CallCompletionRoutine$29$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$29$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$29$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$29$Entry#1;

  inline$BDLCallDriverCompletionRoutine$29$Entry#1:
    inline$BDLCallDriverCompletionRoutine$29$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$29$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$29$start#1;

  inline$BDLCallDriverCompletionRoutine$29$start#1:
    inline$BDLCallDriverCompletionRoutine$29$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$29$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$29$label_3#1;

  inline$BDLCallDriverCompletionRoutine$29$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$29$label_3_true#1, inline$BDLCallDriverCompletionRoutine$29$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$29$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$29$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$29$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$29$label_4#1;

  inline$BDLCallDriverCompletionRoutine$29$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$29$label_6#1;

  inline$BDLCallDriverCompletionRoutine$29$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$29$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$29$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$29$label_5#1;

  inline$BDLCallDriverCompletionRoutine$29$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$29$label_6#1;

  inline$BDLCallDriverCompletionRoutine$29$label_6#1:
    goto inline$storm_KeSetEvent$33$Entry#1;

  inline$storm_KeSetEvent$33$Entry#1:
    inline$storm_KeSetEvent$33$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$29$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$33$start#1;

  inline$storm_KeSetEvent$33$start#1:
    inline$storm_KeSetEvent$33$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$33$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$33$label_3#1;

  inline$storm_KeSetEvent$33$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$33$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$33$label_1#1;

  inline$storm_KeSetEvent$33$label_1#1:
    goto inline$storm_KeSetEvent$33$Return#1;

  inline$storm_KeSetEvent$33$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$29$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$29$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$29$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$29$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$29$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$29$anon1#1;

  inline$BDLCallDriverCompletionRoutine$29$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$29$label_9#1;

  inline$BDLCallDriverCompletionRoutine$29$label_9#1:
    inline$BDLCallDriverCompletionRoutine$29$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$29$label_1#1;

  inline$BDLCallDriverCompletionRoutine$29$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$29$Return#1;

  inline$BDLCallDriverCompletionRoutine$29$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$29$Return#1;

  inline$BDLCallDriverCompletionRoutine$29$Return#1:
    inline$CallCompletionRoutine$29$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$29$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$29$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$29$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$29$anon12_Then#1, inline$CallCompletionRoutine$29$anon12_Else#1;

  inline$CallCompletionRoutine$29$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$29$anon5#1;

  inline$CallCompletionRoutine$29$anon5#1:
    goto inline$CallCompletionRoutine$29$label_20_icall_return#1;

  inline$CallCompletionRoutine$29$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$29$label_23#1;

  inline$CallCompletionRoutine$29$label_23#1:
    inline$CallCompletionRoutine$29$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$29$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$29$label_24#1;

  inline$CallCompletionRoutine$29$label_24#1:
    goto inline$CallCompletionRoutine$29$label_24_true#1, inline$CallCompletionRoutine$29$label_24_false#1;

  inline$CallCompletionRoutine$29$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$29$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$29$label_1#1;

  inline$CallCompletionRoutine$29$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$29$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$29$label_25#1;

  inline$CallCompletionRoutine$29$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$29$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$29$label_1#1;

  inline$CallCompletionRoutine$29$label_1#1:
    goto inline$CallCompletionRoutine$29$Return#1;

  inline$CallCompletionRoutine$29$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$29$Return#1;

  inline$CallCompletionRoutine$29$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$29$Return#1;

  inline$CallCompletionRoutine$29$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$29$Return#1;

  inline$CallCompletionRoutine$29$Return#1:
    goto inline$storm_IoCallDriver$14$label_39$1#1;

  inline$storm_IoCallDriver$14$label_39$1#1:
    goto inline$storm_IoCallDriver$14$anon15_Then#1, inline$storm_IoCallDriver$14$anon15_Else#1;

  inline$storm_IoCallDriver$14$anon15_Else#1:
    assume !raiseException;
    goto inline$storm_IoCallDriver$14$anon10#1;

  inline$storm_IoCallDriver$14$anon10#1:
    goto inline$storm_IoCallDriver$14$label_36#1;

  inline$storm_IoCallDriver$14$anon15_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$14$Return#1;

  inline$storm_IoCallDriver$14$label_27_case_0#1:
    assume inline$storm_IoCallDriver$14$$result.storm_nondet$472.22$4$ != 0;
    assume inline$storm_IoCallDriver$14$$result.storm_nondet$472.22$4$ != 1;
    goto inline$storm_IoCallDriver$14$label_28#1;

  inline$storm_IoCallDriver$14$label_28#1:
    inline$storm_IoCallDriver$14$$status$4$462.11$storm_IoCallDriver$8 := 259;
    goto inline$storm_IoCallDriver$14$label_42#1;

  inline$storm_IoCallDriver$14$label_42#1:
    goto inline$storm_IoCallDriver$14$label_43#1;

  inline$storm_IoCallDriver$14$label_43#1:
    created_irp_0 := inline$storm_IoCallDriver$14$$Irp$2$458.14$storm_IoCallDriver$8;
    call contextSwitch();
    goto inline$storm_IoCallDriver$14$label_36#1;

  inline$storm_IoCallDriver$14$label_36#1:
    inline$storm_IoCallDriver$14$$result.storm_IoCallDriver$456.0$1$ := inline$storm_IoCallDriver$14$$status$4$462.11$storm_IoCallDriver$8;
    goto inline$storm_IoCallDriver$14$label_1#1;

  inline$storm_IoCallDriver$14$label_1#1:
    goto inline$storm_IoCallDriver$14$Return#1;

  inline$storm_IoCallDriver$14$anon13_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$14$Return#1;

  inline$storm_IoCallDriver$14$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$14$Return#1;

  inline$storm_IoCallDriver$14$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCallDriver$14$Return#1;

  inline$storm_IoCallDriver$14$Return#1:
    inline$BDLPnP$0$$result.storm_IoCallDriver$995.29$47$ := inline$storm_IoCallDriver$14$$result.storm_IoCallDriver$456.0$1$;
    goto inline$BDLPnP$0$label_181$1#1;

  inline$BDLPnP$0$label_181$1#1:
    goto inline$BDLPnP$0$anon80_Then#1, inline$BDLPnP$0$anon80_Else#1;

  inline$BDLPnP$0$anon80_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon53#1;

  inline$BDLPnP$0$anon53#1:
    goto inline$BDLPnP$0$label_184#1;

  inline$BDLPnP$0$label_184#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := inline$BDLPnP$0$$result.storm_IoCallDriver$995.29$47$;
    goto inline$BDLPnP$0$label_185#1;

  inline$BDLPnP$0$label_185#1:
    inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8 := 0;
    goto inline$BDLPnP$0$label_139#1;

  inline$BDLPnP$0$label_139#1:
    goto inline$BDLPnP$0$label_139_true#1, inline$BDLPnP$0$label_139_false#1;

  inline$BDLPnP$0$label_139_false#1:
    assume !INT_EQ(inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8, 1);
    goto inline$BDLPnP$0$label_140#1;

  inline$BDLPnP$0$label_139_true#1:
    assume INT_EQ(inline$BDLPnP$0$$fCompleteIrp$7$863.36$BDLPnP$8, 1);
    goto inline$BDLPnP$0$label_141#1;

  inline$BDLPnP$0$label_141#1:
    goto inline$BDLPnP$0$label_142#1;

  inline$BDLPnP$0$label_142#1:
    goto inline$storm_IoCompleteRequest$57$Entry#1;

  inline$storm_IoCompleteRequest$57$Entry#1:
    inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$storm_IoCompleteRequest$57$start#1;

  inline$storm_IoCompleteRequest$57$start#1:
    inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$57$label_3#1;

  inline$storm_IoCompleteRequest$57$label_3#1:
    call inline$storm_IoCompleteRequest$57$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$57$label_6#1;

  inline$storm_IoCompleteRequest$57$label_6#1:
    goto inline$storm_IoCompleteRequest$57$label_6_true#1, inline$storm_IoCompleteRequest$57$label_6_false#1;

  inline$storm_IoCompleteRequest$57$label_6_false#1:
    assume inline$storm_IoCompleteRequest$57$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$57$label_7#1;

  inline$storm_IoCompleteRequest$57$label_6_true#1:
    assume inline$storm_IoCompleteRequest$57$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$57$label_8#1;

  inline$storm_IoCompleteRequest$57$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$57$anon3_Then#1, inline$storm_IoCompleteRequest$57$anon3_Else#1;

  inline$storm_IoCompleteRequest$57$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$57$anon1#1;

  inline$storm_IoCompleteRequest$57$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$57$label_9#1;

  inline$storm_IoCompleteRequest$57$label_9#1:
    goto inline$storm_IoCompleteRequest$57$label_9_true#1, inline$storm_IoCompleteRequest$57$label_9_false#1;

  inline$storm_IoCompleteRequest$57$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$57$label_10#1;

  inline$storm_IoCompleteRequest$57$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$57$label_1#1;

  inline$storm_IoCompleteRequest$57$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$57$label_7#1;

  inline$storm_IoCompleteRequest$57$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$57$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$57$label_1#1;

  inline$storm_IoCompleteRequest$57$label_1#1:
    goto inline$storm_IoCompleteRequest$57$Return#1;

  inline$storm_IoCompleteRequest$57$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$57$Return#1;

  inline$storm_IoCompleteRequest$57$Return#1:
    goto inline$BDLPnP$0$label_142$1#1;

  inline$BDLPnP$0$label_142$1#1:
    goto inline$BDLPnP$0$anon75_Then#1, inline$BDLPnP$0$anon75_Else#1;

  inline$BDLPnP$0$anon75_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon43#1;

  inline$BDLPnP$0$anon43#1:
    goto inline$BDLPnP$0$label_140#1;

  inline$BDLPnP$0$label_140#1:
    goto inline$BDLPnP$0$label_140_true#1, inline$BDLPnP$0$label_140_false#1;

  inline$BDLPnP$0$label_140_false#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume !INT_NEQ(inline$BDLPnP$0$myNondetVar_0, 2);
    goto inline$BDLPnP$0$label_84#1;

  inline$BDLPnP$0$label_140_true#1:
    havoc inline$BDLPnP$0$myNondetVar_0;
    assume INT_NEQ(inline$BDLPnP$0$myNondetVar_0, 2);
    goto inline$BDLPnP$0$label_145#1;

  inline$BDLPnP$0$label_145#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLPnP$0$$pBDLExtension$4$860.36$BDLPnP$8), 542142032, 88);
    goto inline$BDLPnP$0$anon76_Then#1, inline$BDLPnP$0$anon76_Else#1;

  inline$BDLPnP$0$anon76_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon45#1;

  inline$BDLPnP$0$anon45#1:
    goto inline$BDLPnP$0$label_84#1;

  inline$BDLPnP$0$anon76_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon75_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon80_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon79_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon78_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon77_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon66_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$label_51_true#1:
    assume inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 != 0;
    goto inline$BDLPnP$0$label_53#1;

  inline$BDLPnP$0$label_53#1:
    goto inline$BDLGetDebugLevel$3$Entry#1;

  inline$BDLGetDebugLevel$3$Entry#1:
    goto inline$BDLGetDebugLevel$3$start#1;

  inline$BDLGetDebugLevel$3$start#1:
    goto inline$BDLGetDebugLevel$3$label_3#1;

  inline$BDLGetDebugLevel$3$label_3#1:
    havoc inline$BDLGetDebugLevel$3$myNondetVar_0;
    inline$BDLGetDebugLevel$3$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$3$myNondetVar_0;
    goto inline$BDLGetDebugLevel$3$label_1#1;

  inline$BDLGetDebugLevel$3$label_1#1:
    goto inline$BDLGetDebugLevel$3$Return#1;

  inline$BDLGetDebugLevel$3$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$17$ := inline$BDLGetDebugLevel$3$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_53$1#1;

  inline$BDLPnP$0$label_53$1#1:
    goto inline$BDLPnP$0$anon59_Then#1, inline$BDLPnP$0$anon59_Else#1;

  inline$BDLPnP$0$anon59_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon11#1;

  inline$BDLPnP$0$anon11#1:
    goto inline$BDLPnP$0$label_56#1;

  inline$BDLPnP$0$label_56#1:
    goto inline$BDLPnP$0$label_56_true#1, inline$BDLPnP$0$label_56_false#1;

  inline$BDLPnP$0$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$17$) == 0;
    goto inline$BDLPnP$0$label_57#1;

  inline$BDLPnP$0$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$17$) != 0;
    goto inline$BDLPnP$0$label_60#1;

  inline$BDLPnP$0$label_60#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_61#1;

  inline$BDLPnP$0$label_61#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_62#1;

  inline$BDLPnP$0$label_62#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_63#1;

  inline$BDLPnP$0$label_63#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$886.0$18$;
    goto inline$BDLPnP$0$label_57#1;

  inline$BDLPnP$0$label_57#1:
    goto inline$BDLGetDebugLevel$4$Entry#1;

  inline$BDLGetDebugLevel$4$Entry#1:
    goto inline$BDLGetDebugLevel$4$start#1;

  inline$BDLGetDebugLevel$4$start#1:
    goto inline$BDLGetDebugLevel$4$label_3#1;

  inline$BDLGetDebugLevel$4$label_3#1:
    havoc inline$BDLGetDebugLevel$4$myNondetVar_0;
    inline$BDLGetDebugLevel$4$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$4$myNondetVar_0;
    goto inline$BDLGetDebugLevel$4$label_1#1;

  inline$BDLGetDebugLevel$4$label_1#1:
    goto inline$BDLGetDebugLevel$4$Return#1;

  inline$BDLGetDebugLevel$4$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$22$ := inline$BDLGetDebugLevel$4$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_57$1#1;

  inline$BDLPnP$0$label_57$1#1:
    goto inline$BDLPnP$0$anon60_Then#1, inline$BDLPnP$0$anon60_Else#1;

  inline$BDLPnP$0$anon60_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon13#1;

  inline$BDLPnP$0$anon13#1:
    goto inline$BDLPnP$0$label_66#1;

  inline$BDLPnP$0$label_66#1:
    goto inline$BDLPnP$0$label_66_true#1, inline$BDLPnP$0$label_66_false#1;

  inline$BDLPnP$0$label_66_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$22$) == 0;
    goto inline$BDLPnP$0$label_67#1;

  inline$BDLPnP$0$label_66_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$22$) != 0;
    goto inline$BDLPnP$0$label_70#1;

  inline$BDLPnP$0$label_70#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_71#1;

  inline$BDLPnP$0$label_71#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_72#1;

  inline$BDLPnP$0$label_72#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_73#1;

  inline$BDLPnP$0$label_73#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$886.0$23$;
    goto inline$BDLPnP$0$label_67#1;

  inline$BDLPnP$0$label_67#1:
    goto inline$BDLGetDebugLevel$5$Entry#1;

  inline$BDLGetDebugLevel$5$Entry#1:
    goto inline$BDLGetDebugLevel$5$start#1;

  inline$BDLGetDebugLevel$5$start#1:
    goto inline$BDLGetDebugLevel$5$label_3#1;

  inline$BDLGetDebugLevel$5$label_3#1:
    havoc inline$BDLGetDebugLevel$5$myNondetVar_0;
    inline$BDLGetDebugLevel$5$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$5$myNondetVar_0;
    goto inline$BDLGetDebugLevel$5$label_1#1;

  inline$BDLGetDebugLevel$5$label_1#1:
    goto inline$BDLGetDebugLevel$5$Return#1;

  inline$BDLGetDebugLevel$5$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$27$ := inline$BDLGetDebugLevel$5$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_67$1#1;

  inline$BDLPnP$0$label_67$1#1:
    goto inline$BDLPnP$0$anon61_Then#1, inline$BDLPnP$0$anon61_Else#1;

  inline$BDLPnP$0$anon61_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon15#1;

  inline$BDLPnP$0$anon15#1:
    goto inline$BDLPnP$0$label_76#1;

  inline$BDLPnP$0$label_76#1:
    goto inline$BDLPnP$0$label_76_true#1, inline$BDLPnP$0$label_76_false#1;

  inline$BDLPnP$0$label_76_false#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$27$, 4) == 0;
    goto inline$BDLPnP$0$label_77#1;

  inline$BDLPnP$0$label_76_true#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$886.0$27$, 4) != 0;
    goto inline$BDLPnP$0$label_78#1;

  inline$BDLPnP$0$label_78#1:
    goto inline$BDLPnP$0$label_77#1;

  inline$BDLPnP$0$label_77#1:
    goto inline$BDLPnP$0$label_79#1;

  inline$BDLPnP$0$label_79#1:
    goto inline$BDLPnP$0$label_80#1;

  inline$BDLPnP$0$label_80#1:
    goto inline$storm_IoCompleteRequest$0$Entry#1;

  inline$storm_IoCompleteRequest$0$Entry#1:
    inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLPnP$0$$pIrp$2$856.24$BDLPnP$8;
    goto inline$storm_IoCompleteRequest$0$start#1;

  inline$storm_IoCompleteRequest$0$start#1:
    inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$0$label_3#1;

  inline$storm_IoCompleteRequest$0$label_3#1:
    call inline$storm_IoCompleteRequest$0$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$0$label_6#1;

  inline$storm_IoCompleteRequest$0$label_6#1:
    goto inline$storm_IoCompleteRequest$0$label_6_true#1, inline$storm_IoCompleteRequest$0$label_6_false#1;

  inline$storm_IoCompleteRequest$0$label_6_false#1:
    assume inline$storm_IoCompleteRequest$0$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$0$label_7#1;

  inline$storm_IoCompleteRequest$0$label_6_true#1:
    assume inline$storm_IoCompleteRequest$0$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$0$label_8#1;

  inline$storm_IoCompleteRequest$0$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$0$anon3_Then#1, inline$storm_IoCompleteRequest$0$anon3_Else#1;

  inline$storm_IoCompleteRequest$0$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$0$anon1#1;

  inline$storm_IoCompleteRequest$0$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$0$label_9#1;

  inline$storm_IoCompleteRequest$0$label_9#1:
    goto inline$storm_IoCompleteRequest$0$label_9_true#1, inline$storm_IoCompleteRequest$0$label_9_false#1;

  inline$storm_IoCompleteRequest$0$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$0$label_10#1;

  inline$storm_IoCompleteRequest$0$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$0$label_1#1;

  inline$storm_IoCompleteRequest$0$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$0$label_7#1;

  inline$storm_IoCompleteRequest$0$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$0$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$0$label_1#1;

  inline$storm_IoCompleteRequest$0$label_1#1:
    goto inline$storm_IoCompleteRequest$0$Return#1;

  inline$storm_IoCompleteRequest$0$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$0$Return#1;

  inline$storm_IoCompleteRequest$0$Return#1:
    goto inline$BDLPnP$0$label_80$1#1;

  inline$BDLPnP$0$label_80$1#1:
    goto inline$BDLPnP$0$anon62_Then#1, inline$BDLPnP$0$anon62_Else#1;

  inline$BDLPnP$0$anon62_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon17#1;

  inline$BDLPnP$0$anon17#1:
    goto inline$BDLPnP$0$label_83#1;

  inline$BDLPnP$0$label_83#1:
    inline$BDLPnP$0$$status$3$859.36$BDLPnP$8 := 0 - 1073741130;
    goto inline$BDLPnP$0$label_84#1;

  inline$BDLPnP$0$label_84#1:
    goto inline$BDLGetDebugLevel$6$Entry#1;

  inline$BDLGetDebugLevel$6$Entry#1:
    goto inline$BDLGetDebugLevel$6$start#1;

  inline$BDLGetDebugLevel$6$start#1:
    goto inline$BDLGetDebugLevel$6$label_3#1;

  inline$BDLGetDebugLevel$6$label_3#1:
    havoc inline$BDLGetDebugLevel$6$myNondetVar_0;
    inline$BDLGetDebugLevel$6$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$6$myNondetVar_0;
    goto inline$BDLGetDebugLevel$6$label_1#1;

  inline$BDLGetDebugLevel$6$label_1#1:
    goto inline$BDLGetDebugLevel$6$Return#1;

  inline$BDLGetDebugLevel$6$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$48$ := inline$BDLGetDebugLevel$6$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_84$1#1;

  inline$BDLPnP$0$label_84$1#1:
    goto inline$BDLPnP$0$anon63_Then#1, inline$BDLPnP$0$anon63_Else#1;

  inline$BDLPnP$0$anon63_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon19#1;

  inline$BDLPnP$0$anon19#1:
    goto inline$BDLPnP$0$label_87#1;

  inline$BDLPnP$0$label_87#1:
    goto inline$BDLPnP$0$label_87_true#1, inline$BDLPnP$0$label_87_false#1;

  inline$BDLPnP$0$label_87_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$48$) == 0;
    goto inline$BDLPnP$0$label_88#1;

  inline$BDLPnP$0$label_87_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$48$) != 0;
    goto inline$BDLPnP$0$label_91#1;

  inline$BDLPnP$0$label_91#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_92#1;

  inline$BDLPnP$0$label_92#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_93#1;

  inline$BDLPnP$0$label_93#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_94#1;

  inline$BDLPnP$0$label_94#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$1023.0$49$;
    goto inline$BDLPnP$0$label_88#1;

  inline$BDLPnP$0$label_88#1:
    goto inline$BDLGetDebugLevel$7$Entry#1;

  inline$BDLGetDebugLevel$7$Entry#1:
    goto inline$BDLGetDebugLevel$7$start#1;

  inline$BDLGetDebugLevel$7$start#1:
    goto inline$BDLGetDebugLevel$7$label_3#1;

  inline$BDLGetDebugLevel$7$label_3#1:
    havoc inline$BDLGetDebugLevel$7$myNondetVar_0;
    inline$BDLGetDebugLevel$7$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$7$myNondetVar_0;
    goto inline$BDLGetDebugLevel$7$label_1#1;

  inline$BDLGetDebugLevel$7$label_1#1:
    goto inline$BDLGetDebugLevel$7$Return#1;

  inline$BDLGetDebugLevel$7$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$53$ := inline$BDLGetDebugLevel$7$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_88$1#1;

  inline$BDLPnP$0$label_88$1#1:
    goto inline$BDLPnP$0$anon64_Then#1, inline$BDLPnP$0$anon64_Else#1;

  inline$BDLPnP$0$anon64_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon21#1;

  inline$BDLPnP$0$anon21#1:
    goto inline$BDLPnP$0$label_97#1;

  inline$BDLPnP$0$label_97#1:
    goto inline$BDLPnP$0$label_97_true#1, inline$BDLPnP$0$label_97_false#1;

  inline$BDLPnP$0$label_97_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$53$) == 0;
    goto inline$BDLPnP$0$label_98#1;

  inline$BDLPnP$0$label_97_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$53$) != 0;
    goto inline$BDLPnP$0$label_101#1;

  inline$BDLPnP$0$label_101#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_102#1;

  inline$BDLPnP$0$label_102#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_103#1;

  inline$BDLPnP$0$label_103#1:
    call inline$BDLPnP$0$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLPnP$0$label_104#1;

  inline$BDLPnP$0$label_104#1:
    havoc inline$BDLPnP$0$$result.DbgPrint$1023.0$54$;
    goto inline$BDLPnP$0$label_98#1;

  inline$BDLPnP$0$label_98#1:
    goto inline$BDLGetDebugLevel$8$Entry#1;

  inline$BDLGetDebugLevel$8$Entry#1:
    goto inline$BDLGetDebugLevel$8$start#1;

  inline$BDLGetDebugLevel$8$start#1:
    goto inline$BDLGetDebugLevel$8$label_3#1;

  inline$BDLGetDebugLevel$8$label_3#1:
    havoc inline$BDLGetDebugLevel$8$myNondetVar_0;
    inline$BDLGetDebugLevel$8$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$8$myNondetVar_0;
    goto inline$BDLGetDebugLevel$8$label_1#1;

  inline$BDLGetDebugLevel$8$label_1#1:
    goto inline$BDLGetDebugLevel$8$Return#1;

  inline$BDLGetDebugLevel$8$Return#1:
    inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$58$ := inline$BDLGetDebugLevel$8$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLPnP$0$label_98$1#1;

  inline$BDLPnP$0$label_98$1#1:
    goto inline$BDLPnP$0$anon65_Then#1, inline$BDLPnP$0$anon65_Else#1;

  inline$BDLPnP$0$anon65_Else#1:
    assume !raiseException;
    goto inline$BDLPnP$0$anon23#1;

  inline$BDLPnP$0$anon23#1:
    goto inline$BDLPnP$0$label_107#1;

  inline$BDLPnP$0$label_107#1:
    goto inline$BDLPnP$0$label_107_true#1, inline$BDLPnP$0$label_107_false#1;

  inline$BDLPnP$0$label_107_false#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$58$, 4) == 0;
    goto inline$BDLPnP$0$label_108#1;

  inline$BDLPnP$0$label_107_true#1:
    assume BIT_BAND(inline$BDLPnP$0$$result.BDLGetDebugLevel$1023.0$58$, 4) != 0;
    goto inline$BDLPnP$0$label_109#1;

  inline$BDLPnP$0$label_109#1:
    goto inline$BDLPnP$0$label_108#1;

  inline$BDLPnP$0$label_108#1:
    goto inline$BDLPnP$0$label_1#1;

  inline$BDLPnP$0$label_1#1:
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon65_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon64_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon63_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon62_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon61_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon60_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon59_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon58_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon57_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon56_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon55_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$anon54_Then#1:
    assume raiseException;
    goto inline$BDLPnP$0$Return#1;

  inline$BDLPnP$0$Return#1:
    goto inline$storm_thread_dispatch$0$label_8$1#1;

  inline$storm_thread_dispatch$0$label_8$1#1:
    goto inline$storm_thread_dispatch$0$anon5_Then#1, inline$storm_thread_dispatch$0$anon5_Else#1;

  inline$storm_thread_dispatch$0$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_thread_dispatch$0$anon3#1;

  inline$storm_thread_dispatch$0$anon3#1:
    goto inline$storm_thread_dispatch$0$label_11#1;

  inline$storm_thread_dispatch$0$label_11#1:
    goto inline$storm_thread_dispatch$0$label_1#1;

  inline$storm_thread_dispatch$0$label_1#1:
    __storm_thread_done_3 := true;
    goto inline$storm_thread_dispatch$0$Return#1;

  inline$storm_thread_dispatch$0$anon5_Then#1:
    assume raiseException;
    goto inline$storm_thread_dispatch$0$Return#1;

  inline$storm_thread_dispatch$0$anon4_Then#1:
    assume raiseException;
    goto inline$storm_thread_dispatch$0$Return#1;

  inline$storm_thread_dispatch$0$Return#1:
    goto label_29$1#1;

  label_29$1#1:
    goto label_32#1;

  label_32#1:
    goto inline$storm_thread_cancel$0$Entry#1;

  inline$storm_thread_cancel$0$Entry#1:
    inline$storm_thread_cancel$0$$Irp$1$64.5$storm_thread_cancel$4_.1 := $irp$1$96.7$storm_main$0;
    goto inline$storm_thread_cancel$0$start#1;

  inline$storm_thread_cancel$0$start#1:
    k := 0;
    raiseException := false;
    __storm_thread_id := 1;
    call contextSwitch();
    inline$storm_thread_cancel$0$$Irp$1$64.5$storm_thread_cancel$4 := inline$storm_thread_cancel$0$$Irp$1$64.5$storm_thread_cancel$4_.1;
    goto inline$storm_thread_cancel$0$label_3#1;

  inline$storm_thread_cancel$0$label_3#1:
    goto inline$storm_IoCancelIrp$0$Entry#1;

  inline$storm_IoCancelIrp$0$Entry#1:
    inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4_.1 := inline$storm_thread_cancel$0$$Irp$1$64.5$storm_thread_cancel$4;
    goto inline$storm_IoCancelIrp$0$start#1;

  inline$storm_IoCancelIrp$0$start#1:
    inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4 := inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4_.1;
    goto inline$storm_IoCancelIrp$0$label_3#1;

  inline$storm_IoCancelIrp$0$label_3#1:
    goto inline$storm_IoCancelIrp$0$label_4#1;

  inline$storm_IoCancelIrp$0$label_4#1:
    goto inline$storm_IoCancelIrp$0$label_5#1;

  inline$storm_IoCancelIrp$0$label_5#1:
    __storm_atomic := true;
    goto inline$storm_IoCancelIrp$0$label_8#1;

  inline$storm_IoCancelIrp$0$label_8#1:
    inline$storm_IoCancelIrp$0$myVar_0 := Mem_0_T.CancelRoutine__IRP[CancelRoutine__IRP(inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4)];
    call contextSwitch();
    inline$storm_IoCancelIrp$0$$oldCancelRoutine$2$347.17$storm_IoCancelIrp$4 := inline$storm_IoCancelIrp$0$myVar_0;
    goto inline$storm_IoCancelIrp$0$label_9#1;

  inline$storm_IoCancelIrp$0$label_9#1:
    Mem_0_T.CancelRoutine__IRP := Mem_0_T.CancelRoutine__IRP[CancelRoutine__IRP(inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4) := 0];
    call contextSwitch();
    goto inline$storm_IoCancelIrp$0$label_10#1;

  inline$storm_IoCancelIrp$0$label_10#1:
    goto inline$storm_IoCancelIrp$0$anon9_Then#1, inline$storm_IoCancelIrp$0$anon9_Else#1;

  inline$storm_IoCancelIrp$0$anon9_Else#1:
    assume __storm_init;
    goto inline$storm_IoCancelIrp$0$anon1#1;

  inline$storm_IoCancelIrp$0$anon9_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_IoCancelIrp$0$anon1#1;

  inline$storm_IoCancelIrp$0$anon1#1:
    call contextSwitch();
    goto inline$storm_IoCancelIrp$0$label_13#1;

  inline$storm_IoCancelIrp$0$label_13#1:
    havoc inline$storm_IoCancelIrp$0$myNondetVar_0;
    havoc inline$storm_IoCancelIrp$0$myNondetVar_1;
    assume inline$storm_IoCancelIrp$0$myNondetVar_0 == inline$storm_IoCancelIrp$0$myNondetVar_1;
    goto inline$storm_IoAcquireCancelSpinLock$0$Entry#1;

  inline$storm_IoAcquireCancelSpinLock$0$Entry#1:
    goto inline$storm_IoAcquireCancelSpinLock$0$start#1;

  inline$storm_IoAcquireCancelSpinLock$0$start#1:
    goto inline$storm_IoAcquireCancelSpinLock$0$label_3#1;

  inline$storm_IoAcquireCancelSpinLock$0$label_3#1:
    __storm_atomic := true;
    goto inline$storm_IoAcquireCancelSpinLock$0$label_6#1;

  inline$storm_IoAcquireCancelSpinLock$0$label_6#1:
    havoc raiseException;
    goto inline$storm_IoAcquireCancelSpinLock$0$anon4_Then#1, inline$storm_IoAcquireCancelSpinLock$0$anon4_Else#1;

  inline$storm_IoAcquireCancelSpinLock$0$anon4_Else#1:
    assume !raiseException;
    goto inline$storm_IoAcquireCancelSpinLock$0$anon1#1;

  inline$storm_IoAcquireCancelSpinLock$0$anon1#1:
    assume k == 0 ==> INT_EQ(cancelLockStatus_0, 0);
    call contextSwitch();
    goto inline$storm_IoAcquireCancelSpinLock$0$label_7#1;

  inline$storm_IoAcquireCancelSpinLock$0$label_7#1:
    cancelLockStatus_0 := 1;
    call contextSwitch();
    goto inline$storm_IoAcquireCancelSpinLock$0$label_8#1;

  inline$storm_IoAcquireCancelSpinLock$0$label_8#1:
    goto inline$storm_IoAcquireCancelSpinLock$0$anon5_Then#1, inline$storm_IoAcquireCancelSpinLock$0$anon5_Else#1;

  inline$storm_IoAcquireCancelSpinLock$0$anon5_Else#1:
    assume __storm_init;
    goto inline$storm_IoAcquireCancelSpinLock$0$anon3#1;

  inline$storm_IoAcquireCancelSpinLock$0$anon5_Then#1:
    assume !__storm_init;
    __storm_atomic := false;
    goto inline$storm_IoAcquireCancelSpinLock$0$anon3#1;

  inline$storm_IoAcquireCancelSpinLock$0$anon3#1:
    call contextSwitch();
    goto inline$storm_IoAcquireCancelSpinLock$0$label_1#1;

  inline$storm_IoAcquireCancelSpinLock$0$label_1#1:
    goto inline$storm_IoAcquireCancelSpinLock$0$Return#1;

  inline$storm_IoAcquireCancelSpinLock$0$anon4_Then#1:
    assume raiseException;
    goto inline$storm_IoAcquireCancelSpinLock$0$Return#1;

  inline$storm_IoAcquireCancelSpinLock$0$Return#1:
    goto inline$storm_IoCancelIrp$0$label_13$1#1;

  inline$storm_IoCancelIrp$0$label_13$1#1:
    goto inline$storm_IoCancelIrp$0$anon10_Then#1, inline$storm_IoCancelIrp$0$anon10_Else#1;

  inline$storm_IoCancelIrp$0$anon10_Else#1:
    assume !raiseException;
    goto inline$storm_IoCancelIrp$0$anon3#1;

  inline$storm_IoCancelIrp$0$anon3#1:
    havoc inline$storm_IoCancelIrp$0$myNondetVar_0;
    goto inline$storm_IoCancelIrp$0$label_16#1;

  inline$storm_IoCancelIrp$0$label_16#1:
    goto inline$storm_IoCancelIrp$0$label_16_true#1, inline$storm_IoCancelIrp$0$label_16_false#1;

  inline$storm_IoCancelIrp$0$label_16_false#1:
    assume inline$storm_IoCancelIrp$0$$oldCancelRoutine$2$347.17$storm_IoCancelIrp$4 == 0;
    goto inline$storm_IoCancelIrp$0$label_17#1;

  inline$storm_IoCancelIrp$0$label_17#1:
    goto inline$storm_IoCancelIrp$0$label_1#1;

  inline$storm_IoCancelIrp$0$label_16_true#1:
    assume inline$storm_IoCancelIrp$0$$oldCancelRoutine$2$347.17$storm_IoCancelIrp$4 != 0;
    goto inline$storm_IoCancelIrp$0$label_18#1;

  inline$storm_IoCancelIrp$0$label_18#1:
    goto inline$storm_IoCancelIrp$0$label_19#1;

  inline$storm_IoCancelIrp$0$label_19#1:
    call inline$storm_IoCancelIrp$0$$result.storm_nondet$360.4$2$ := storm_nondet();
    goto inline$storm_IoCancelIrp$0$label_22#1;

  inline$storm_IoCancelIrp$0$label_22#1:
    goto inline$storm_IoCancelIrp$0$label_22_true#1, inline$storm_IoCancelIrp$0$label_22_false#1;

  inline$storm_IoCancelIrp$0$label_22_false#1:
    assume inline$storm_IoCancelIrp$0$$result.storm_nondet$360.4$2$ == 0;
    goto inline$storm_IoCancelIrp$0$label_23#1;

  inline$storm_IoCancelIrp$0$label_22_true#1:
    assume inline$storm_IoCancelIrp$0$$result.storm_nondet$360.4$2$ != 0;
    goto inline$storm_IoCancelIrp$0$label_26#1;

  inline$storm_IoCancelIrp$0$label_26#1:
    havoc raiseException;
    goto inline$storm_IoCancelIrp$0$anon12_Then#1, inline$storm_IoCancelIrp$0$anon12_Else#1;

  inline$storm_IoCancelIrp$0$anon12_Else#1:
    assume !raiseException;
    goto inline$storm_IoCancelIrp$0$anon7#1;

  inline$storm_IoCancelIrp$0$anon7#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4], 1);
    call contextSwitch();
    goto inline$storm_IoCancelIrp$0$label_27#1;

  inline$storm_IoCancelIrp$0$label_27#1:
    goto inline$storm_IoCancelIrp$0$label_27_true#1, inline$storm_IoCancelIrp$0$label_27_false#1;

  inline$storm_IoCancelIrp$0$label_27_false#1:
    assume 0 == 0;
    goto inline$storm_IoCancelIrp$0$label_28#1;

  inline$storm_IoCancelIrp$0$label_28#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCancelIrp$0$label_1#1;

  inline$storm_IoCancelIrp$0$label_27_true#1:
    assume 0 != 0;
    goto inline$storm_IoCancelIrp$0$label_23#1;

  inline$storm_IoCancelIrp$0$label_23#1:
    goto inline$IoGetCurrentIrpStackLocation$150$Entry#1;

  inline$IoGetCurrentIrpStackLocation$150$Entry#1:
    inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$storm_IoCancelIrp$0$$Irp$1$344.10$storm_IoCancelIrp$4;
    goto inline$IoGetCurrentIrpStackLocation$150$start#1;

  inline$IoGetCurrentIrpStackLocation$150$start#1:
    inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$150$label_3#1;

  inline$IoGetCurrentIrpStackLocation$150$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$150$label_3_true#1, inline$IoGetCurrentIrpStackLocation$150$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$150$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$150$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$150$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$150$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$150$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$150$label_4#1;

  inline$IoGetCurrentIrpStackLocation$150$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$150$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$150$label_6#1;

  inline$IoGetCurrentIrpStackLocation$150$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$150$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$150$label_7#1;

  inline$IoGetCurrentIrpStackLocation$150$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$150$label_5#1;

  inline$IoGetCurrentIrpStackLocation$150$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$150$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$150$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$150$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$150$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$150$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$150$label_5#1;

  inline$IoGetCurrentIrpStackLocation$150$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$150$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$150$label_1#1;

  inline$IoGetCurrentIrpStackLocation$150$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$150$Return#1;

  inline$IoGetCurrentIrpStackLocation$150$Return#1:
    goto inline$storm_IoCancelIrp$0$label_23$1#1;

  inline$storm_IoCancelIrp$0$label_23$1#1:
    goto inline$storm_IoCancelIrp$0$anon11_Then#1, inline$storm_IoCancelIrp$0$anon11_Else#1;

  inline$storm_IoCancelIrp$0$anon11_Else#1:
    assume !raiseException;
    goto inline$storm_IoCancelIrp$0$anon5#1;

  inline$storm_IoCancelIrp$0$anon5#1:
    goto inline$storm_IoCancelIrp$0$label_31#1;

  inline$storm_IoCancelIrp$0$label_31#1:
    goto inline$storm_IoCancelIrp$0$label_32#1;

  inline$storm_IoCancelIrp$0$label_32#1:
    goto inline$storm_IoCancelIrp$0$label_35#1;

  inline$storm_IoCancelIrp$0$label_35#1:
    goto inline$storm_IoCancelIrp$0$label_1#1;

  inline$storm_IoCancelIrp$0$label_1#1:
    goto inline$storm_IoCancelIrp$0$Return#1;

  inline$storm_IoCancelIrp$0$anon11_Then#1:
    assume raiseException;
    goto inline$storm_IoCancelIrp$0$Return#1;

  inline$storm_IoCancelIrp$0$anon12_Then#1:
    assume raiseException;
    goto inline$storm_IoCancelIrp$0$Return#1;

  inline$storm_IoCancelIrp$0$anon10_Then#1:
    assume raiseException;
    goto inline$storm_IoCancelIrp$0$Return#1;

  inline$storm_IoCancelIrp$0$Return#1:
    goto inline$storm_thread_cancel$0$label_3$1#1;

  inline$storm_thread_cancel$0$label_3$1#1:
    goto inline$storm_thread_cancel$0$anon2_Then#1, inline$storm_thread_cancel$0$anon2_Else#1;

  inline$storm_thread_cancel$0$anon2_Else#1:
    assume !raiseException;
    goto inline$storm_thread_cancel$0$anon1#1;

  inline$storm_thread_cancel$0$anon1#1:
    goto inline$storm_thread_cancel$0$label_1#1;

  inline$storm_thread_cancel$0$label_1#1:
    __storm_thread_done_1 := true;
    goto inline$storm_thread_cancel$0$Return#1;

  inline$storm_thread_cancel$0$anon2_Then#1:
    assume raiseException;
    goto inline$storm_thread_cancel$0$Return#1;

  inline$storm_thread_cancel$0$Return#1:
    goto label_32$1#1;

  label_32$1#1:
    goto label_35#1;

  label_35#1:
    goto inline$storm_thread_dpc$0$Entry#1;

  inline$storm_thread_dpc$0$Entry#1:
    goto inline$storm_thread_dpc$0$start#1;

  inline$storm_thread_dpc$0$start#1:
    k := 0;
    raiseException := false;
    __storm_thread_id := 4;
    call contextSwitch();
    goto inline$storm_thread_dpc$0$label_1#1;

  inline$storm_thread_dpc$0$label_1#1:
    __storm_thread_done_4 := true;
    goto inline$storm_thread_dpc$0$Return#1;

  inline$storm_thread_dpc$0$Return#1:
    goto label_35$1#1;

  label_35$1#1:
    goto label_38#1;

  label_38#1:
    goto inline$storm_thread_completion$0$Entry#1;

  inline$storm_thread_completion$0$Entry#1:
    goto inline$storm_thread_completion$0$start#1;

  inline$storm_thread_completion$0$start#1:
    k := 0;
    raiseException := false;
    __storm_thread_id := 2;
    call contextSwitch();
    goto inline$storm_thread_completion$0$label_3#1;

  inline$storm_thread_completion$0$label_3#1:
    havoc raiseException;
    goto inline$storm_thread_completion$0$anon4_Then#1, inline$storm_thread_completion$0$anon4_Else#1;

  inline$storm_thread_completion$0$anon4_Else#1:
    assume !raiseException;
    goto inline$storm_thread_completion$0$anon1#1;

  inline$storm_thread_completion$0$anon1#1:
    assume k == 0 ==> INT_NEQ(created_irp_0, 0);
    call contextSwitch();
    goto inline$storm_thread_completion$0$label_4#1;

  inline$storm_thread_completion$0$label_4#1:
    goto inline$CallCompletionRoutine$30$Entry#1;

  inline$CallCompletionRoutine$30$Entry#1:
    inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4_.1 := created_irp_0;
    goto inline$CallCompletionRoutine$30$start#1;

  inline$CallCompletionRoutine$30$start#1:
    inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4 := inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4_.1;
    goto inline$CallCompletionRoutine$30$label_3#1;

  inline$CallCompletionRoutine$30$label_3#1:
    goto inline$CallCompletionRoutine$30$label_4#1;

  inline$CallCompletionRoutine$30$label_4#1:
    goto inline$CallCompletionRoutine$30$label_5#1;

  inline$CallCompletionRoutine$30$label_5#1:
    goto inline$CallCompletionRoutine$30$label_6#1;

  inline$CallCompletionRoutine$30$label_6#1:
    goto inline$CallCompletionRoutine$30$label_7#1;

  inline$CallCompletionRoutine$30$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$151$Entry#1;

  inline$IoGetCurrentIrpStackLocation$151$Entry#1:
    inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$151$start#1;

  inline$IoGetCurrentIrpStackLocation$151$start#1:
    inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$151$label_3#1;

  inline$IoGetCurrentIrpStackLocation$151$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$151$label_3_true#1, inline$IoGetCurrentIrpStackLocation$151$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$151$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$151$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$151$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$151$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$151$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$151$label_4#1;

  inline$IoGetCurrentIrpStackLocation$151$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$151$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$151$label_6#1;

  inline$IoGetCurrentIrpStackLocation$151$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$151$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$151$label_7#1;

  inline$IoGetCurrentIrpStackLocation$151$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$151$label_5#1;

  inline$IoGetCurrentIrpStackLocation$151$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$151$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$151$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$151$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$151$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$151$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$151$label_5#1;

  inline$IoGetCurrentIrpStackLocation$151$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$151$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$151$label_1#1;

  inline$IoGetCurrentIrpStackLocation$151$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$151$Return#1;

  inline$IoGetCurrentIrpStackLocation$151$Return#1:
    goto inline$CallCompletionRoutine$30$label_7$1#1;

  inline$CallCompletionRoutine$30$label_7$1#1:
    goto inline$CallCompletionRoutine$30$anon10_Then#1, inline$CallCompletionRoutine$30$anon10_Else#1;

  inline$CallCompletionRoutine$30$anon10_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$30$anon1#1;

  inline$CallCompletionRoutine$30$anon1#1:
    goto inline$CallCompletionRoutine$30$label_10#1;

  inline$CallCompletionRoutine$30$label_10#1:
    goto inline$CallCompletionRoutine$30$label_11#1;

  inline$CallCompletionRoutine$30$label_11#1:
    havoc inline$CallCompletionRoutine$30$myNondetVar_0;
    inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4 := inline$CallCompletionRoutine$30$myNondetVar_0;
    goto inline$CallCompletionRoutine$30$label_12#1;

  inline$CallCompletionRoutine$30$label_12#1:
    havoc inline$CallCompletionRoutine$30$myNondetVar_0;
    inline$CallCompletionRoutine$30$$context$2$435.8$CallCompletionRoutine$4 := inline$CallCompletionRoutine$30$myNondetVar_0;
    goto inline$CallCompletionRoutine$30$label_13#1;

  inline$CallCompletionRoutine$30$label_13#1:
    havoc inline$CallCompletionRoutine$30$myNondetVar_0;
    goto inline$CallCompletionRoutine$30$label_14#1;

  inline$CallCompletionRoutine$30$label_14#1:
    goto inline$IoGetCurrentIrpStackLocation$152$Entry#1;

  inline$IoGetCurrentIrpStackLocation$152$Entry#1:
    inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4;
    goto inline$IoGetCurrentIrpStackLocation$152$start#1;

  inline$IoGetCurrentIrpStackLocation$152$start#1:
    inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$152$label_3#1;

  inline$IoGetCurrentIrpStackLocation$152$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$152$label_3_true#1, inline$IoGetCurrentIrpStackLocation$152$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$152$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$152$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$152$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$152$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$152$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$152$label_4#1;

  inline$IoGetCurrentIrpStackLocation$152$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$152$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$152$label_6#1;

  inline$IoGetCurrentIrpStackLocation$152$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$152$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$152$label_7#1;

  inline$IoGetCurrentIrpStackLocation$152$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$152$label_5#1;

  inline$IoGetCurrentIrpStackLocation$152$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$152$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$152$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$152$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$152$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$152$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$152$label_5#1;

  inline$IoGetCurrentIrpStackLocation$152$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$152$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$152$label_1#1;

  inline$IoGetCurrentIrpStackLocation$152$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$152$Return#1;

  inline$IoGetCurrentIrpStackLocation$152$Return#1:
    goto inline$CallCompletionRoutine$30$label_14$1#1;

  inline$CallCompletionRoutine$30$label_14$1#1:
    goto inline$CallCompletionRoutine$30$anon11_Then#1, inline$CallCompletionRoutine$30$anon11_Else#1;

  inline$CallCompletionRoutine$30$anon11_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$30$anon3#1;

  inline$CallCompletionRoutine$30$anon3#1:
    goto inline$CallCompletionRoutine$30$label_17#1;

  inline$CallCompletionRoutine$30$label_17#1:
    goto inline$CallCompletionRoutine$30$label_18#1;

  inline$CallCompletionRoutine$30$label_18#1:
    goto inline$CallCompletionRoutine$30$label_18_true#1, inline$CallCompletionRoutine$30$label_18_false#1;

  inline$CallCompletionRoutine$30$label_18_false#1:
    assume inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4 == 0;
    goto inline$CallCompletionRoutine$30$label_1#1;

  inline$CallCompletionRoutine$30$label_18_true#1:
    assume inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4 != 0;
    goto inline$CallCompletionRoutine$30$label_19#1;

  inline$CallCompletionRoutine$30$label_19#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4 := 0];
    call contextSwitch();
    goto inline$CallCompletionRoutine$30$label_20#1;

  inline$CallCompletionRoutine$30$label_20#1:
    goto inline$CallCompletionRoutine$30$label_20_icall_1#1, inline$CallCompletionRoutine$30$label_20_icall_2#1, inline$CallCompletionRoutine$30$label_20_icall_3#1;

  inline$CallCompletionRoutine$30$label_20_icall_3#1:
    assume inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLSystemPowerIoCompletion;
    havoc inline$CallCompletionRoutine$30$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$30$Entry#1;

  inline$BDLSystemPowerIoCompletion$30$Entry#1:
    inline$BDLSystemPowerIoCompletion$30$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$30$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLSystemPowerIoCompletion$30$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1 := inline$CallCompletionRoutine$30$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLSystemPowerIoCompletion$30$start#1;

  inline$BDLSystemPowerIoCompletion$30$start#1:
    call inline$BDLSystemPowerIoCompletion$30$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12 := __HAVOC_malloc(4);
    inline$BDLSystemPowerIoCompletion$30$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12_.1;
    inline$BDLSystemPowerIoCompletion$30$$Context$3$1335.24$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$$Context$3$1335.24$BDLSystemPowerIoCompletion$12_.1;
    goto inline$BDLSystemPowerIoCompletion$30$label_3#1;

  inline$BDLSystemPowerIoCompletion$30$label_3#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_4#1;

  inline$BDLSystemPowerIoCompletion$30$label_4#1:
    inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_5#1;

  inline$BDLSystemPowerIoCompletion$30$label_5#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_6#1;

  inline$BDLSystemPowerIoCompletion$30$label_6#1:
    inline$BDLSystemPowerIoCompletion$30$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$$Context$3$1335.24$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$30$label_7#1;

  inline$BDLSystemPowerIoCompletion$30$label_7#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_8#1;

  inline$BDLSystemPowerIoCompletion$30$label_8#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$30$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$30$label_9#1;

  inline$BDLSystemPowerIoCompletion$30$label_9#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_10#1;

  inline$BDLSystemPowerIoCompletion$30$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$154$Entry#1;

  inline$IoGetCurrentIrpStackLocation$154$Entry#1:
    inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$154$start#1;

  inline$IoGetCurrentIrpStackLocation$154$start#1:
    inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$154$label_3#1;

  inline$IoGetCurrentIrpStackLocation$154$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$154$label_3_true#1, inline$IoGetCurrentIrpStackLocation$154$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$154$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$154$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$154$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$154$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$154$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$154$label_4#1;

  inline$IoGetCurrentIrpStackLocation$154$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$154$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$154$label_6#1;

  inline$IoGetCurrentIrpStackLocation$154$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$154$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$154$label_7#1;

  inline$IoGetCurrentIrpStackLocation$154$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$154$label_5#1;

  inline$IoGetCurrentIrpStackLocation$154$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$154$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$154$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$154$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$154$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$154$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$154$label_5#1;

  inline$IoGetCurrentIrpStackLocation$154$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$154$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$154$label_1#1;

  inline$IoGetCurrentIrpStackLocation$154$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$154$Return#1;

  inline$IoGetCurrentIrpStackLocation$154$Return#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_10$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_10$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon36_Then#1, inline$BDLSystemPowerIoCompletion$30$anon36_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon1#1;

  inline$BDLSystemPowerIoCompletion$30$anon1#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_13#1;

  inline$BDLSystemPowerIoCompletion$30$label_13#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_14#1;

  inline$BDLSystemPowerIoCompletion$30$label_14#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_15#1;

  inline$BDLSystemPowerIoCompletion$30$label_15#1:
    goto inline$BDLGetDebugLevel$792$Entry#1;

  inline$BDLGetDebugLevel$792$Entry#1:
    goto inline$BDLGetDebugLevel$792$start#1;

  inline$BDLGetDebugLevel$792$start#1:
    goto inline$BDLGetDebugLevel$792$label_3#1;

  inline$BDLGetDebugLevel$792$label_3#1:
    havoc inline$BDLGetDebugLevel$792$myNondetVar_0;
    inline$BDLGetDebugLevel$792$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$792$myNondetVar_0;
    goto inline$BDLGetDebugLevel$792$label_1#1;

  inline$BDLGetDebugLevel$792$label_1#1:
    goto inline$BDLGetDebugLevel$792$Return#1;

  inline$BDLGetDebugLevel$792$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$3$ := inline$BDLGetDebugLevel$792$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_15$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_15$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon37_Then#1, inline$BDLSystemPowerIoCompletion$30$anon37_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon3#1;

  inline$BDLSystemPowerIoCompletion$30$anon3#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_18#1;

  inline$BDLSystemPowerIoCompletion$30$label_18#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_18_true#1, inline$BDLSystemPowerIoCompletion$30$label_18_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_18_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$3$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_19#1;

  inline$BDLSystemPowerIoCompletion$30$label_18_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$3$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_22#1;

  inline$BDLSystemPowerIoCompletion$30$label_22#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_23#1;

  inline$BDLSystemPowerIoCompletion$30$label_23#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_24#1;

  inline$BDLSystemPowerIoCompletion$30$label_24#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_25#1;

  inline$BDLSystemPowerIoCompletion$30$label_25#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1344.0$4$;
    goto inline$BDLSystemPowerIoCompletion$30$label_19#1;

  inline$BDLSystemPowerIoCompletion$30$label_19#1:
    goto inline$BDLGetDebugLevel$793$Entry#1;

  inline$BDLGetDebugLevel$793$Entry#1:
    goto inline$BDLGetDebugLevel$793$start#1;

  inline$BDLGetDebugLevel$793$start#1:
    goto inline$BDLGetDebugLevel$793$label_3#1;

  inline$BDLGetDebugLevel$793$label_3#1:
    havoc inline$BDLGetDebugLevel$793$myNondetVar_0;
    inline$BDLGetDebugLevel$793$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$793$myNondetVar_0;
    goto inline$BDLGetDebugLevel$793$label_1#1;

  inline$BDLGetDebugLevel$793$label_1#1:
    goto inline$BDLGetDebugLevel$793$Return#1;

  inline$BDLGetDebugLevel$793$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$8$ := inline$BDLGetDebugLevel$793$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_19$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_19$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon38_Then#1, inline$BDLSystemPowerIoCompletion$30$anon38_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon5#1;

  inline$BDLSystemPowerIoCompletion$30$anon5#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_28#1;

  inline$BDLSystemPowerIoCompletion$30$label_28#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_28_true#1, inline$BDLSystemPowerIoCompletion$30$label_28_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_28_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$8$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_29#1;

  inline$BDLSystemPowerIoCompletion$30$label_28_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$8$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_32#1;

  inline$BDLSystemPowerIoCompletion$30$label_32#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_33#1;

  inline$BDLSystemPowerIoCompletion$30$label_33#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_34#1;

  inline$BDLSystemPowerIoCompletion$30$label_34#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_35#1;

  inline$BDLSystemPowerIoCompletion$30$label_35#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1344.0$9$;
    goto inline$BDLSystemPowerIoCompletion$30$label_29#1;

  inline$BDLSystemPowerIoCompletion$30$label_29#1:
    goto inline$BDLGetDebugLevel$794$Entry#1;

  inline$BDLGetDebugLevel$794$Entry#1:
    goto inline$BDLGetDebugLevel$794$start#1;

  inline$BDLGetDebugLevel$794$start#1:
    goto inline$BDLGetDebugLevel$794$label_3#1;

  inline$BDLGetDebugLevel$794$label_3#1:
    havoc inline$BDLGetDebugLevel$794$myNondetVar_0;
    inline$BDLGetDebugLevel$794$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$794$myNondetVar_0;
    goto inline$BDLGetDebugLevel$794$label_1#1;

  inline$BDLGetDebugLevel$794$label_1#1:
    goto inline$BDLGetDebugLevel$794$Return#1;

  inline$BDLGetDebugLevel$794$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$13$ := inline$BDLGetDebugLevel$794$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_29$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_29$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon39_Then#1, inline$BDLSystemPowerIoCompletion$30$anon39_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon7#1;

  inline$BDLSystemPowerIoCompletion$30$anon7#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_38#1;

  inline$BDLSystemPowerIoCompletion$30$label_38#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_38_true#1, inline$BDLSystemPowerIoCompletion$30$label_38_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_38_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$13$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_39#1;

  inline$BDLSystemPowerIoCompletion$30$label_38_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1344.0$13$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_40#1;

  inline$BDLSystemPowerIoCompletion$30$label_40#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_39#1;

  inline$BDLSystemPowerIoCompletion$30$label_39#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_39_true#1, inline$BDLSystemPowerIoCompletion$30$label_39_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_39_false#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_41#1;

  inline$BDLSystemPowerIoCompletion$30$label_41#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_41_case_0#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_1#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_2#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_3#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_4#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_5#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_6#1, inline$BDLSystemPowerIoCompletion$30$label_41_case_7#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_7#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 7;
    goto inline$BDLSystemPowerIoCompletion$30$label_107#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_6#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 6;
    goto inline$BDLSystemPowerIoCompletion$30$label_108#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_5#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 5;
    goto inline$BDLSystemPowerIoCompletion$30$label_108#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_4#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 4;
    goto inline$BDLSystemPowerIoCompletion$30$label_108#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_3#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 3;
    goto inline$BDLSystemPowerIoCompletion$30$label_108#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_2#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 2;
    goto inline$BDLSystemPowerIoCompletion$30$label_108#1;

  inline$BDLSystemPowerIoCompletion$30$label_108#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_109#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_1#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 == 1;
    goto inline$BDLSystemPowerIoCompletion$30$label_107#1;

  inline$BDLSystemPowerIoCompletion$30$label_107#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_109#1;

  inline$BDLSystemPowerIoCompletion$30$label_41_case_0#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 1;
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 2;
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 3;
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 4;
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 5;
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 6;
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 7;
    goto inline$BDLSystemPowerIoCompletion$30$label_106#1;

  inline$BDLSystemPowerIoCompletion$30$label_106#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_106_true#1, inline$BDLSystemPowerIoCompletion$30$label_106_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_106_false#1:
    assume 0 == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_142#1;

  inline$BDLSystemPowerIoCompletion$30$label_142#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_143#1;

  inline$BDLSystemPowerIoCompletion$30$label_143#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_144#1;

  inline$BDLSystemPowerIoCompletion$30$label_144#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_109#1;

  inline$BDLSystemPowerIoCompletion$30$label_106_true#1:
    assume 0 != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_109#1;

  inline$BDLSystemPowerIoCompletion$30$label_109#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    call inline$BDLSystemPowerIoCompletion$30$$result.PoRequestPowerIrp$1410.31$27$ := PoRequestPowerIrp(inline$BDLSystemPowerIoCompletion$30$$pDeviceObject$1$1333.24$BDLSystemPowerIoCompletion$12, inline$BDLSystemPowerIoCompletion$30$myNondetVar_0, inline$BDLSystemPowerIoCompletion$30$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12, BDLSystemPowerCompleted, inline$BDLSystemPowerIoCompletion$30$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 0);
    goto inline$BDLSystemPowerIoCompletion$30$anon50_Then#1, inline$BDLSystemPowerIoCompletion$30$anon50_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon50_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon29#1;

  inline$BDLSystemPowerIoCompletion$30$anon29#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_112#1;

  inline$BDLSystemPowerIoCompletion$30$label_112#1:
    inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$$result.PoRequestPowerIrp$1410.31$27$;
    goto inline$BDLSystemPowerIoCompletion$30$label_113#1;

  inline$BDLSystemPowerIoCompletion$30$label_113#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_113_true#1, inline$BDLSystemPowerIoCompletion$30$label_113_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_113_false#1:
    assume !INT_EQ(inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$30$label_114#1;

  inline$BDLSystemPowerIoCompletion$30$label_114#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_116#1;

  inline$BDLSystemPowerIoCompletion$30$label_116#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_117#1;

  inline$BDLSystemPowerIoCompletion$30$label_117#1:
    goto inline$BDLGetDebugLevel$801$Entry#1;

  inline$BDLGetDebugLevel$801$Entry#1:
    goto inline$BDLGetDebugLevel$801$start#1;

  inline$BDLGetDebugLevel$801$start#1:
    goto inline$BDLGetDebugLevel$801$label_3#1;

  inline$BDLGetDebugLevel$801$label_3#1:
    havoc inline$BDLGetDebugLevel$801$myNondetVar_0;
    inline$BDLGetDebugLevel$801$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$801$myNondetVar_0;
    goto inline$BDLGetDebugLevel$801$label_1#1;

  inline$BDLGetDebugLevel$801$label_1#1:
    goto inline$BDLGetDebugLevel$801$Return#1;

  inline$BDLGetDebugLevel$801$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$28$ := inline$BDLGetDebugLevel$801$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_117$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_117$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon51_Then#1, inline$BDLSystemPowerIoCompletion$30$anon51_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon51_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon31#1;

  inline$BDLSystemPowerIoCompletion$30$anon31#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_120#1;

  inline$BDLSystemPowerIoCompletion$30$label_120#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_120_true#1, inline$BDLSystemPowerIoCompletion$30$label_120_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_120_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$28$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_121#1;

  inline$BDLSystemPowerIoCompletion$30$label_120_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$28$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_124#1;

  inline$BDLSystemPowerIoCompletion$30$label_124#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_125#1;

  inline$BDLSystemPowerIoCompletion$30$label_125#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_126#1;

  inline$BDLSystemPowerIoCompletion$30$label_126#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_127#1;

  inline$BDLSystemPowerIoCompletion$30$label_127#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1428.0$29$;
    goto inline$BDLSystemPowerIoCompletion$30$label_121#1;

  inline$BDLSystemPowerIoCompletion$30$label_121#1:
    goto inline$BDLGetDebugLevel$802$Entry#1;

  inline$BDLGetDebugLevel$802$Entry#1:
    goto inline$BDLGetDebugLevel$802$start#1;

  inline$BDLGetDebugLevel$802$start#1:
    goto inline$BDLGetDebugLevel$802$label_3#1;

  inline$BDLGetDebugLevel$802$label_3#1:
    havoc inline$BDLGetDebugLevel$802$myNondetVar_0;
    inline$BDLGetDebugLevel$802$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$802$myNondetVar_0;
    goto inline$BDLGetDebugLevel$802$label_1#1;

  inline$BDLGetDebugLevel$802$label_1#1:
    goto inline$BDLGetDebugLevel$802$Return#1;

  inline$BDLGetDebugLevel$802$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$33$ := inline$BDLGetDebugLevel$802$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_121$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_121$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon52_Then#1, inline$BDLSystemPowerIoCompletion$30$anon52_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon52_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon33#1;

  inline$BDLSystemPowerIoCompletion$30$anon33#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_130#1;

  inline$BDLSystemPowerIoCompletion$30$label_130#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_130_true#1, inline$BDLSystemPowerIoCompletion$30$label_130_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_130_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$33$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_131#1;

  inline$BDLSystemPowerIoCompletion$30$label_130_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$33$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_134#1;

  inline$BDLSystemPowerIoCompletion$30$label_134#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_135#1;

  inline$BDLSystemPowerIoCompletion$30$label_135#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_136#1;

  inline$BDLSystemPowerIoCompletion$30$label_136#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_137#1;

  inline$BDLSystemPowerIoCompletion$30$label_137#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1428.0$34$;
    goto inline$BDLSystemPowerIoCompletion$30$label_131#1;

  inline$BDLSystemPowerIoCompletion$30$label_131#1:
    goto inline$BDLGetDebugLevel$803$Entry#1;

  inline$BDLGetDebugLevel$803$Entry#1:
    goto inline$BDLGetDebugLevel$803$start#1;

  inline$BDLGetDebugLevel$803$start#1:
    goto inline$BDLGetDebugLevel$803$label_3#1;

  inline$BDLGetDebugLevel$803$label_3#1:
    havoc inline$BDLGetDebugLevel$803$myNondetVar_0;
    inline$BDLGetDebugLevel$803$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$803$myNondetVar_0;
    goto inline$BDLGetDebugLevel$803$label_1#1;

  inline$BDLGetDebugLevel$803$label_1#1:
    goto inline$BDLGetDebugLevel$803$Return#1;

  inline$BDLGetDebugLevel$803$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$38$ := inline$BDLGetDebugLevel$803$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_131$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_131$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon53_Then#1, inline$BDLSystemPowerIoCompletion$30$anon53_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon53_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon35#1;

  inline$BDLSystemPowerIoCompletion$30$anon35#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_140#1;

  inline$BDLSystemPowerIoCompletion$30$label_140#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_140_true#1, inline$BDLSystemPowerIoCompletion$30$label_140_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_140_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$38$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_67#1;

  inline$BDLSystemPowerIoCompletion$30$label_140_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1428.0$38$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_141#1;

  inline$BDLSystemPowerIoCompletion$30$label_141#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_67#1;

  inline$BDLSystemPowerIoCompletion$30$anon53_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon52_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon51_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$label_113_true#1:
    assume INT_EQ(inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12, 259);
    goto inline$BDLSystemPowerIoCompletion$30$label_115#1;

  inline$BDLSystemPowerIoCompletion$30$label_115#1:
    inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := 0 - 1073741802;
    goto inline$BDLSystemPowerIoCompletion$30$label_80#1;

  inline$BDLSystemPowerIoCompletion$30$anon50_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$label_39_true#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    assume inline$BDLSystemPowerIoCompletion$30$myNondetVar_0 != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_42#1;

  inline$BDLSystemPowerIoCompletion$30$label_42#1:
    havoc inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12 := inline$BDLSystemPowerIoCompletion$30$myNondetVar_0;
    goto inline$BDLSystemPowerIoCompletion$30$label_43#1;

  inline$BDLSystemPowerIoCompletion$30$label_43#1:
    goto inline$BDLGetDebugLevel$795$Entry#1;

  inline$BDLGetDebugLevel$795$Entry#1:
    goto inline$BDLGetDebugLevel$795$start#1;

  inline$BDLGetDebugLevel$795$start#1:
    goto inline$BDLGetDebugLevel$795$label_3#1;

  inline$BDLGetDebugLevel$795$label_3#1:
    havoc inline$BDLGetDebugLevel$795$myNondetVar_0;
    inline$BDLGetDebugLevel$795$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$795$myNondetVar_0;
    goto inline$BDLGetDebugLevel$795$label_1#1;

  inline$BDLGetDebugLevel$795$label_1#1:
    goto inline$BDLGetDebugLevel$795$Return#1;

  inline$BDLGetDebugLevel$795$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$14$ := inline$BDLGetDebugLevel$795$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_43$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_43$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon40_Then#1, inline$BDLSystemPowerIoCompletion$30$anon40_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon9#1;

  inline$BDLSystemPowerIoCompletion$30$anon9#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_46#1;

  inline$BDLSystemPowerIoCompletion$30$label_46#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_46_true#1, inline$BDLSystemPowerIoCompletion$30$label_46_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_46_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$14$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_47#1;

  inline$BDLSystemPowerIoCompletion$30$label_46_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$14$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_50#1;

  inline$BDLSystemPowerIoCompletion$30$label_50#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_51#1;

  inline$BDLSystemPowerIoCompletion$30$label_51#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_52#1;

  inline$BDLSystemPowerIoCompletion$30$label_52#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_53#1;

  inline$BDLSystemPowerIoCompletion$30$label_53#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1358.0$15$;
    goto inline$BDLSystemPowerIoCompletion$30$label_47#1;

  inline$BDLSystemPowerIoCompletion$30$label_47#1:
    goto inline$BDLGetDebugLevel$796$Entry#1;

  inline$BDLGetDebugLevel$796$Entry#1:
    goto inline$BDLGetDebugLevel$796$start#1;

  inline$BDLGetDebugLevel$796$start#1:
    goto inline$BDLGetDebugLevel$796$label_3#1;

  inline$BDLGetDebugLevel$796$label_3#1:
    havoc inline$BDLGetDebugLevel$796$myNondetVar_0;
    inline$BDLGetDebugLevel$796$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$796$myNondetVar_0;
    goto inline$BDLGetDebugLevel$796$label_1#1;

  inline$BDLGetDebugLevel$796$label_1#1:
    goto inline$BDLGetDebugLevel$796$Return#1;

  inline$BDLGetDebugLevel$796$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$19$ := inline$BDLGetDebugLevel$796$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_47$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_47$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon41_Then#1, inline$BDLSystemPowerIoCompletion$30$anon41_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon11#1;

  inline$BDLSystemPowerIoCompletion$30$anon11#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_56#1;

  inline$BDLSystemPowerIoCompletion$30$label_56#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_56_true#1, inline$BDLSystemPowerIoCompletion$30$label_56_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_56_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$19$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_57#1;

  inline$BDLSystemPowerIoCompletion$30$label_56_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$19$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_60#1;

  inline$BDLSystemPowerIoCompletion$30$label_60#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_61#1;

  inline$BDLSystemPowerIoCompletion$30$label_61#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_62#1;

  inline$BDLSystemPowerIoCompletion$30$label_62#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_63#1;

  inline$BDLSystemPowerIoCompletion$30$label_63#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1358.0$20$;
    goto inline$BDLSystemPowerIoCompletion$30$label_57#1;

  inline$BDLSystemPowerIoCompletion$30$label_57#1:
    goto inline$BDLGetDebugLevel$797$Entry#1;

  inline$BDLGetDebugLevel$797$Entry#1:
    goto inline$BDLGetDebugLevel$797$start#1;

  inline$BDLGetDebugLevel$797$start#1:
    goto inline$BDLGetDebugLevel$797$label_3#1;

  inline$BDLGetDebugLevel$797$label_3#1:
    havoc inline$BDLGetDebugLevel$797$myNondetVar_0;
    inline$BDLGetDebugLevel$797$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$797$myNondetVar_0;
    goto inline$BDLGetDebugLevel$797$label_1#1;

  inline$BDLGetDebugLevel$797$label_1#1:
    goto inline$BDLGetDebugLevel$797$Return#1;

  inline$BDLGetDebugLevel$797$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$24$ := inline$BDLGetDebugLevel$797$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_57$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_57$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon42_Then#1, inline$BDLSystemPowerIoCompletion$30$anon42_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon13#1;

  inline$BDLSystemPowerIoCompletion$30$anon13#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_66#1;

  inline$BDLSystemPowerIoCompletion$30$label_66#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_66_true#1, inline$BDLSystemPowerIoCompletion$30$label_66_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_66_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$24$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_67#1;

  inline$BDLSystemPowerIoCompletion$30$label_66_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1358.0$24$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_70#1;

  inline$BDLSystemPowerIoCompletion$30$label_70#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_67#1;

  inline$BDLSystemPowerIoCompletion$30$label_67#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLSystemPowerIoCompletion$30$$pBDLExtension$6$1340.36$BDLSystemPowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLSystemPowerIoCompletion$30$anon43_Then#1, inline$BDLSystemPowerIoCompletion$30$anon43_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon15#1;

  inline$BDLSystemPowerIoCompletion$30$anon15#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_71#1;

  inline$BDLSystemPowerIoCompletion$30$label_71#1:
    call PoStartNextPowerIrp(inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$30$anon44_Then#1, inline$BDLSystemPowerIoCompletion$30$anon44_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon17#1;

  inline$BDLSystemPowerIoCompletion$30$anon17#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_74#1;

  inline$BDLSystemPowerIoCompletion$30$label_74#1:
    goto inline$storm_IoCompleteRequest$63$Entry#1;

  inline$storm_IoCompleteRequest$63$Entry#1:
    inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLSystemPowerIoCompletion$30$$pIrp$2$1334.24$BDLSystemPowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$63$start#1;

  inline$storm_IoCompleteRequest$63$start#1:
    inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$63$label_3#1;

  inline$storm_IoCompleteRequest$63$label_3#1:
    call inline$storm_IoCompleteRequest$63$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$63$label_6#1;

  inline$storm_IoCompleteRequest$63$label_6#1:
    goto inline$storm_IoCompleteRequest$63$label_6_true#1, inline$storm_IoCompleteRequest$63$label_6_false#1;

  inline$storm_IoCompleteRequest$63$label_6_false#1:
    assume inline$storm_IoCompleteRequest$63$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$63$label_7#1;

  inline$storm_IoCompleteRequest$63$label_6_true#1:
    assume inline$storm_IoCompleteRequest$63$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$63$label_8#1;

  inline$storm_IoCompleteRequest$63$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$63$anon3_Then#1, inline$storm_IoCompleteRequest$63$anon3_Else#1;

  inline$storm_IoCompleteRequest$63$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$63$anon1#1;

  inline$storm_IoCompleteRequest$63$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$63$label_9#1;

  inline$storm_IoCompleteRequest$63$label_9#1:
    goto inline$storm_IoCompleteRequest$63$label_9_true#1, inline$storm_IoCompleteRequest$63$label_9_false#1;

  inline$storm_IoCompleteRequest$63$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$63$label_10#1;

  inline$storm_IoCompleteRequest$63$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$63$label_1#1;

  inline$storm_IoCompleteRequest$63$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$63$label_7#1;

  inline$storm_IoCompleteRequest$63$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$63$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$63$label_1#1;

  inline$storm_IoCompleteRequest$63$label_1#1:
    goto inline$storm_IoCompleteRequest$63$Return#1;

  inline$storm_IoCompleteRequest$63$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$63$Return#1;

  inline$storm_IoCompleteRequest$63$Return#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_74$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_74$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon45_Then#1, inline$BDLSystemPowerIoCompletion$30$anon45_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon45_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon19#1;

  inline$BDLSystemPowerIoCompletion$30$anon19#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_77#1;

  inline$BDLSystemPowerIoCompletion$30$label_77#1:
    call ExFreePoolWithTag(inline$BDLSystemPowerIoCompletion$30$$pPowerIrpContext$5$1339.37$BDLSystemPowerIoCompletion$12, 541869122);
    goto inline$BDLSystemPowerIoCompletion$30$anon46_Then#1, inline$BDLSystemPowerIoCompletion$30$anon46_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon46_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon21#1;

  inline$BDLSystemPowerIoCompletion$30$anon21#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_80#1;

  inline$BDLSystemPowerIoCompletion$30$label_80#1:
    goto inline$BDLGetDebugLevel$798$Entry#1;

  inline$BDLGetDebugLevel$798$Entry#1:
    goto inline$BDLGetDebugLevel$798$start#1;

  inline$BDLGetDebugLevel$798$start#1:
    goto inline$BDLGetDebugLevel$798$label_3#1;

  inline$BDLGetDebugLevel$798$label_3#1:
    havoc inline$BDLGetDebugLevel$798$myNondetVar_0;
    inline$BDLGetDebugLevel$798$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$798$myNondetVar_0;
    goto inline$BDLGetDebugLevel$798$label_1#1;

  inline$BDLGetDebugLevel$798$label_1#1:
    goto inline$BDLGetDebugLevel$798$Return#1;

  inline$BDLGetDebugLevel$798$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$39$ := inline$BDLGetDebugLevel$798$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_80$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_80$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon47_Then#1, inline$BDLSystemPowerIoCompletion$30$anon47_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon47_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon23#1;

  inline$BDLSystemPowerIoCompletion$30$anon23#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_83#1;

  inline$BDLSystemPowerIoCompletion$30$label_83#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_83_true#1, inline$BDLSystemPowerIoCompletion$30$label_83_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_83_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$39$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_84#1;

  inline$BDLSystemPowerIoCompletion$30$label_83_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$39$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_87#1;

  inline$BDLSystemPowerIoCompletion$30$label_87#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_88#1;

  inline$BDLSystemPowerIoCompletion$30$label_88#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_89#1;

  inline$BDLSystemPowerIoCompletion$30$label_89#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_90#1;

  inline$BDLSystemPowerIoCompletion$30$label_90#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1440.0$40$;
    goto inline$BDLSystemPowerIoCompletion$30$label_84#1;

  inline$BDLSystemPowerIoCompletion$30$label_84#1:
    goto inline$BDLGetDebugLevel$799$Entry#1;

  inline$BDLGetDebugLevel$799$Entry#1:
    goto inline$BDLGetDebugLevel$799$start#1;

  inline$BDLGetDebugLevel$799$start#1:
    goto inline$BDLGetDebugLevel$799$label_3#1;

  inline$BDLGetDebugLevel$799$label_3#1:
    havoc inline$BDLGetDebugLevel$799$myNondetVar_0;
    inline$BDLGetDebugLevel$799$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$799$myNondetVar_0;
    goto inline$BDLGetDebugLevel$799$label_1#1;

  inline$BDLGetDebugLevel$799$label_1#1:
    goto inline$BDLGetDebugLevel$799$Return#1;

  inline$BDLGetDebugLevel$799$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$44$ := inline$BDLGetDebugLevel$799$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_84$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_84$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon48_Then#1, inline$BDLSystemPowerIoCompletion$30$anon48_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon48_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon25#1;

  inline$BDLSystemPowerIoCompletion$30$anon25#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_93#1;

  inline$BDLSystemPowerIoCompletion$30$label_93#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_93_true#1, inline$BDLSystemPowerIoCompletion$30$label_93_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_93_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$44$) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_94#1;

  inline$BDLSystemPowerIoCompletion$30$label_93_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$44$) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_97#1;

  inline$BDLSystemPowerIoCompletion$30$label_97#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_98#1;

  inline$BDLSystemPowerIoCompletion$30$label_98#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_99#1;

  inline$BDLSystemPowerIoCompletion$30$label_99#1:
    call inline$BDLSystemPowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLSystemPowerIoCompletion$30$label_100#1;

  inline$BDLSystemPowerIoCompletion$30$label_100#1:
    havoc inline$BDLSystemPowerIoCompletion$30$$result.DbgPrint$1440.0$45$;
    goto inline$BDLSystemPowerIoCompletion$30$label_94#1;

  inline$BDLSystemPowerIoCompletion$30$label_94#1:
    goto inline$BDLGetDebugLevel$800$Entry#1;

  inline$BDLGetDebugLevel$800$Entry#1:
    goto inline$BDLGetDebugLevel$800$start#1;

  inline$BDLGetDebugLevel$800$start#1:
    goto inline$BDLGetDebugLevel$800$label_3#1;

  inline$BDLGetDebugLevel$800$label_3#1:
    havoc inline$BDLGetDebugLevel$800$myNondetVar_0;
    inline$BDLGetDebugLevel$800$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$800$myNondetVar_0;
    goto inline$BDLGetDebugLevel$800$label_1#1;

  inline$BDLGetDebugLevel$800$label_1#1:
    goto inline$BDLGetDebugLevel$800$Return#1;

  inline$BDLGetDebugLevel$800$Return#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$49$ := inline$BDLGetDebugLevel$800$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLSystemPowerIoCompletion$30$label_94$1#1;

  inline$BDLSystemPowerIoCompletion$30$label_94$1#1:
    goto inline$BDLSystemPowerIoCompletion$30$anon49_Then#1, inline$BDLSystemPowerIoCompletion$30$anon49_Else#1;

  inline$BDLSystemPowerIoCompletion$30$anon49_Else#1:
    assume !raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$anon27#1;

  inline$BDLSystemPowerIoCompletion$30$anon27#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_103#1;

  inline$BDLSystemPowerIoCompletion$30$label_103#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_103_true#1, inline$BDLSystemPowerIoCompletion$30$label_103_false#1;

  inline$BDLSystemPowerIoCompletion$30$label_103_false#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$49$, 4) == 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_104#1;

  inline$BDLSystemPowerIoCompletion$30$label_103_true#1:
    assume BIT_BAND(inline$BDLSystemPowerIoCompletion$30$$result.BDLGetDebugLevel$1440.0$49$, 4) != 0;
    goto inline$BDLSystemPowerIoCompletion$30$label_105#1;

  inline$BDLSystemPowerIoCompletion$30$label_105#1:
    goto inline$BDLSystemPowerIoCompletion$30$label_104#1;

  inline$BDLSystemPowerIoCompletion$30$label_104#1:
    inline$BDLSystemPowerIoCompletion$30$$result.BDLSystemPowerIoCompletion$1331.0$1$ := inline$BDLSystemPowerIoCompletion$30$$status$4$1338.36$BDLSystemPowerIoCompletion$12;
    goto inline$BDLSystemPowerIoCompletion$30$label_1#1;

  inline$BDLSystemPowerIoCompletion$30$label_1#1:
    call __HAVOC_free(inline$BDLSystemPowerIoCompletion$30$$PowerState$8$1342.36$BDLSystemPowerIoCompletion$12);
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon49_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon48_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon47_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon46_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon45_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon44_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon43_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon42_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon41_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon40_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon39_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon38_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon37_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$anon36_Then#1:
    assume raiseException;
    goto inline$BDLSystemPowerIoCompletion$30$Return#1;

  inline$BDLSystemPowerIoCompletion$30$Return#1:
    inline$CallCompletionRoutine$30$$result.completionRoutine$448.30$3$ := inline$BDLSystemPowerIoCompletion$30$$result.BDLSystemPowerIoCompletion$1331.0$1$;
    goto inline$CallCompletionRoutine$30$label_20_icall_3$1#1;

  inline$CallCompletionRoutine$30$label_20_icall_3$1#1:
    goto inline$CallCompletionRoutine$30$anon14_Then#1, inline$CallCompletionRoutine$30$anon14_Else#1;

  inline$CallCompletionRoutine$30$anon14_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$30$anon9#1;

  inline$CallCompletionRoutine$30$anon9#1:
    goto inline$CallCompletionRoutine$30$label_20_icall_return#1;

  inline$CallCompletionRoutine$30$anon14_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$30$Return#1;

  inline$CallCompletionRoutine$30$label_20_icall_2#1:
    assume inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLDevicePowerIoCompletion;
    havoc inline$CallCompletionRoutine$30$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$30$Entry#1;

  inline$BDLDevicePowerIoCompletion$30$Entry#1:
    inline$BDLDevicePowerIoCompletion$30$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$30$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4;
    inline$BDLDevicePowerIoCompletion$30$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1 := inline$CallCompletionRoutine$30$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLDevicePowerIoCompletion$30$start#1;

  inline$BDLDevicePowerIoCompletion$30$start#1:
    call inline$BDLDevicePowerIoCompletion$30$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12 := __HAVOC_malloc(8);
    call inline$BDLDevicePowerIoCompletion$30$$result.PoSetPowerState$1693.27$16$ := __HAVOC_malloc(4);
    inline$BDLDevicePowerIoCompletion$30$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12_.1;
    inline$BDLDevicePowerIoCompletion$30$$Context$3$1655.24$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$$Context$3$1655.24$BDLDevicePowerIoCompletion$12_.1;
    goto inline$BDLDevicePowerIoCompletion$30$label_3#1;

  inline$BDLDevicePowerIoCompletion$30$label_3#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_4#1;

  inline$BDLDevicePowerIoCompletion$30$label_4#1:
    inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_5#1;

  inline$BDLDevicePowerIoCompletion$30$label_5#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_6#1;

  inline$BDLDevicePowerIoCompletion$30$label_6#1:
    inline$BDLDevicePowerIoCompletion$30$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$$Context$3$1655.24$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$30$label_7#1;

  inline$BDLDevicePowerIoCompletion$30$label_7#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_8#1;

  inline$BDLDevicePowerIoCompletion$30$label_8#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$30$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$30$label_9#1;

  inline$BDLDevicePowerIoCompletion$30$label_9#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_10#1;

  inline$BDLDevicePowerIoCompletion$30$label_10#1:
    goto inline$IoGetCurrentIrpStackLocation$153$Entry#1;

  inline$IoGetCurrentIrpStackLocation$153$Entry#1:
    inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1 := inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$IoGetCurrentIrpStackLocation$153$start#1;

  inline$IoGetCurrentIrpStackLocation$153$start#1:
    inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4 := inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4_.1;
    goto inline$IoGetCurrentIrpStackLocation$153$label_3#1;

  inline$IoGetCurrentIrpStackLocation$153$label_3#1:
    goto inline$IoGetCurrentIrpStackLocation$153$label_3_true#1, inline$IoGetCurrentIrpStackLocation$153$label_3_false#1;

  inline$IoGetCurrentIrpStackLocation$153$label_3_false#1:
    inline$IoGetCurrentIrpStackLocation$153$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$153$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume !INT_LEQ(inline$IoGetCurrentIrpStackLocation$153$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$153$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$153$label_4#1;

  inline$IoGetCurrentIrpStackLocation$153$label_4#1:
    call inline$IoGetCurrentIrpStackLocation$153$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$153$label_6#1;

  inline$IoGetCurrentIrpStackLocation$153$label_6#1:
    call inline$IoGetCurrentIrpStackLocation$153$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$IoGetCurrentIrpStackLocation$153$label_7#1;

  inline$IoGetCurrentIrpStackLocation$153$label_7#1:
    goto inline$IoGetCurrentIrpStackLocation$153$label_5#1;

  inline$IoGetCurrentIrpStackLocation$153$label_3_true#1:
    inline$IoGetCurrentIrpStackLocation$153$myVar_0 := Mem_0_T.CurrentLocation__IRP[CurrentLocation__IRP(inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    inline$IoGetCurrentIrpStackLocation$153$myVar_1 := Mem_0_T.StackCount__IRP[StackCount__IRP(inline$IoGetCurrentIrpStackLocation$153$$Irp$1$24490.14$IoGetCurrentIrpStackLocation$4)];
    call contextSwitch();
    assume INT_LEQ(inline$IoGetCurrentIrpStackLocation$153$myVar_0, PLUS(inline$IoGetCurrentIrpStackLocation$153$myVar_1, 1, 1));
    goto inline$IoGetCurrentIrpStackLocation$153$label_5#1;

  inline$IoGetCurrentIrpStackLocation$153$label_5#1:
    havoc inline$IoGetCurrentIrpStackLocation$153$myNondetVar_0;
    inline$IoGetCurrentIrpStackLocation$153$$result.IoGetCurrentIrpStackLocation$24489.0$1$ := inline$IoGetCurrentIrpStackLocation$153$myNondetVar_0;
    goto inline$IoGetCurrentIrpStackLocation$153$label_1#1;

  inline$IoGetCurrentIrpStackLocation$153$label_1#1:
    goto inline$IoGetCurrentIrpStackLocation$153$Return#1;

  inline$IoGetCurrentIrpStackLocation$153$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.IoGetCurrentIrpStackLocation$1661.86$2$ := inline$IoGetCurrentIrpStackLocation$153$$result.IoGetCurrentIrpStackLocation$24489.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_10$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_10$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon30_Then#1, inline$BDLDevicePowerIoCompletion$30$anon30_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon30_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon1#1;

  inline$BDLDevicePowerIoCompletion$30$anon1#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_13#1;

  inline$BDLDevicePowerIoCompletion$30$label_13#1:
    inline$BDLDevicePowerIoCompletion$30$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$$result.IoGetCurrentIrpStackLocation$1661.86$2$;
    goto inline$BDLDevicePowerIoCompletion$30$label_14#1;

  inline$BDLDevicePowerIoCompletion$30$label_14#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_15#1;

  inline$BDLDevicePowerIoCompletion$30$label_15#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$30$label_16#1;

  inline$BDLDevicePowerIoCompletion$30$label_16#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_17#1;

  inline$BDLDevicePowerIoCompletion$30$label_17#1:
    goto inline$BDLGetDebugLevel$783$Entry#1;

  inline$BDLGetDebugLevel$783$Entry#1:
    goto inline$BDLGetDebugLevel$783$start#1;

  inline$BDLGetDebugLevel$783$start#1:
    goto inline$BDLGetDebugLevel$783$label_3#1;

  inline$BDLGetDebugLevel$783$label_3#1:
    havoc inline$BDLGetDebugLevel$783$myNondetVar_0;
    inline$BDLGetDebugLevel$783$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$783$myNondetVar_0;
    goto inline$BDLGetDebugLevel$783$label_1#1;

  inline$BDLGetDebugLevel$783$label_1#1:
    goto inline$BDLGetDebugLevel$783$Return#1;

  inline$BDLGetDebugLevel$783$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$3$ := inline$BDLGetDebugLevel$783$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_17$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_17$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon31_Then#1, inline$BDLDevicePowerIoCompletion$30$anon31_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon31_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon3#1;

  inline$BDLDevicePowerIoCompletion$30$anon3#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_20#1;

  inline$BDLDevicePowerIoCompletion$30$label_20#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_20_true#1, inline$BDLDevicePowerIoCompletion$30$label_20_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_20_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$3$) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_21#1;

  inline$BDLDevicePowerIoCompletion$30$label_20_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$3$) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_24#1;

  inline$BDLDevicePowerIoCompletion$30$label_24#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_25#1;

  inline$BDLDevicePowerIoCompletion$30$label_25#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_26#1;

  inline$BDLDevicePowerIoCompletion$30$label_26#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_27#1;

  inline$BDLDevicePowerIoCompletion$30$label_27#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1665.0$4$;
    goto inline$BDLDevicePowerIoCompletion$30$label_21#1;

  inline$BDLDevicePowerIoCompletion$30$label_21#1:
    goto inline$BDLGetDebugLevel$784$Entry#1;

  inline$BDLGetDebugLevel$784$Entry#1:
    goto inline$BDLGetDebugLevel$784$start#1;

  inline$BDLGetDebugLevel$784$start#1:
    goto inline$BDLGetDebugLevel$784$label_3#1;

  inline$BDLGetDebugLevel$784$label_3#1:
    havoc inline$BDLGetDebugLevel$784$myNondetVar_0;
    inline$BDLGetDebugLevel$784$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$784$myNondetVar_0;
    goto inline$BDLGetDebugLevel$784$label_1#1;

  inline$BDLGetDebugLevel$784$label_1#1:
    goto inline$BDLGetDebugLevel$784$Return#1;

  inline$BDLGetDebugLevel$784$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$8$ := inline$BDLGetDebugLevel$784$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_21$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_21$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon32_Then#1, inline$BDLDevicePowerIoCompletion$30$anon32_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon32_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon5#1;

  inline$BDLDevicePowerIoCompletion$30$anon5#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_30#1;

  inline$BDLDevicePowerIoCompletion$30$label_30#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_30_true#1, inline$BDLDevicePowerIoCompletion$30$label_30_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_30_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$8$) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_31#1;

  inline$BDLDevicePowerIoCompletion$30$label_30_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$8$) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_34#1;

  inline$BDLDevicePowerIoCompletion$30$label_34#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_35#1;

  inline$BDLDevicePowerIoCompletion$30$label_35#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_36#1;

  inline$BDLDevicePowerIoCompletion$30$label_36#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_37#1;

  inline$BDLDevicePowerIoCompletion$30$label_37#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1665.0$9$;
    goto inline$BDLDevicePowerIoCompletion$30$label_31#1;

  inline$BDLDevicePowerIoCompletion$30$label_31#1:
    goto inline$BDLGetDebugLevel$785$Entry#1;

  inline$BDLGetDebugLevel$785$Entry#1:
    goto inline$BDLGetDebugLevel$785$start#1;

  inline$BDLGetDebugLevel$785$start#1:
    goto inline$BDLGetDebugLevel$785$label_3#1;

  inline$BDLGetDebugLevel$785$label_3#1:
    havoc inline$BDLGetDebugLevel$785$myNondetVar_0;
    inline$BDLGetDebugLevel$785$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$785$myNondetVar_0;
    goto inline$BDLGetDebugLevel$785$label_1#1;

  inline$BDLGetDebugLevel$785$label_1#1:
    goto inline$BDLGetDebugLevel$785$Return#1;

  inline$BDLGetDebugLevel$785$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$13$ := inline$BDLGetDebugLevel$785$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_31$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_31$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon33_Then#1, inline$BDLDevicePowerIoCompletion$30$anon33_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon33_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon7#1;

  inline$BDLDevicePowerIoCompletion$30$anon7#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_40#1;

  inline$BDLDevicePowerIoCompletion$30$label_40#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_40_true#1, inline$BDLDevicePowerIoCompletion$30$label_40_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_40_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$13$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_41#1;

  inline$BDLDevicePowerIoCompletion$30$label_40_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1665.0$13$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_42#1;

  inline$BDLDevicePowerIoCompletion$30$label_42#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_41#1;

  inline$BDLDevicePowerIoCompletion$30$label_41#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_41_true#1, inline$BDLDevicePowerIoCompletion$30$label_41_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_41_false#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$30$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$30$label_43#1;

  inline$BDLDevicePowerIoCompletion$30$label_41_true#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$30$myNondetVar_0, 2);
    goto inline$BDLDevicePowerIoCompletion$30$label_44#1;

  inline$BDLDevicePowerIoCompletion$30$label_44#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_44_true#1, inline$BDLDevicePowerIoCompletion$30$label_44_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_44_false#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$30$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$30$label_45#1;

  inline$BDLDevicePowerIoCompletion$30$label_45#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_45_true#1, inline$BDLDevicePowerIoCompletion$30$label_45_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_45_false#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    assume !INT_EQ(inline$BDLDevicePowerIoCompletion$30$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$30$label_43#1;

  inline$BDLDevicePowerIoCompletion$30$label_43#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    goto inline$BDLDevicePowerIoCompletion$30$label_86#1;

  inline$BDLDevicePowerIoCompletion$30$label_45_true#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$30$myNondetVar_0, 5);
    goto inline$BDLDevicePowerIoCompletion$30$label_46#1;

  inline$BDLDevicePowerIoCompletion$30$label_44_true#1:
    havoc inline$BDLDevicePowerIoCompletion$30$myNondetVar_0;
    assume INT_EQ(inline$BDLDevicePowerIoCompletion$30$myNondetVar_0, 1);
    goto inline$BDLDevicePowerIoCompletion$30$label_46#1;

  inline$BDLDevicePowerIoCompletion$30$label_46#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.memset$1683.8$14$;
    goto inline$BDLDevicePowerIoCompletion$30$label_49#1;

  inline$BDLDevicePowerIoCompletion$30$label_49#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_50#1;

  inline$BDLDevicePowerIoCompletion$30$label_50#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_51#1;

  inline$BDLDevicePowerIoCompletion$30$label_51#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_54#1;

  inline$BDLDevicePowerIoCompletion$30$label_54#1:
    inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12 := inline$BDLDevicePowerIoCompletion$30$$callresult.$1687.68$15$;
    goto inline$BDLDevicePowerIoCompletion$30$label_55#1;

  inline$BDLDevicePowerIoCompletion$30$label_55#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_55_true#1, inline$BDLDevicePowerIoCompletion$30$label_55_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_55_false#1:
    assume inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12 == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_56#1;

  inline$BDLDevicePowerIoCompletion$30$label_56#1:
    call inline$BDLDevicePowerIoCompletion$30$$result.PoSetPowerState$1693.27$16$ := PoSetPowerState(inline$BDLDevicePowerIoCompletion$30$$pDeviceObject$1$1653.24$BDLDevicePowerIoCompletion$12, 1, State___unnamed_16_72a8bca0(Power___unnamed_16_357c4db4(Parameters__IO_STACK_LOCATION(inline$BDLDevicePowerIoCompletion$30$$pStackLocation$7$1661.36$BDLDevicePowerIoCompletion$12))));
    goto inline$BDLDevicePowerIoCompletion$30$anon34_Then#1, inline$BDLDevicePowerIoCompletion$30$anon34_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon34_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon9#1;

  inline$BDLDevicePowerIoCompletion$30$anon9#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_83#1;

  inline$BDLDevicePowerIoCompletion$30$anon34_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$label_55_true#1:
    assume inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12 != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_59#1;

  inline$BDLDevicePowerIoCompletion$30$label_59#1:
    goto inline$BDLGetDebugLevel$786$Entry#1;

  inline$BDLGetDebugLevel$786$Entry#1:
    goto inline$BDLGetDebugLevel$786$start#1;

  inline$BDLGetDebugLevel$786$start#1:
    goto inline$BDLGetDebugLevel$786$label_3#1;

  inline$BDLGetDebugLevel$786$label_3#1:
    havoc inline$BDLGetDebugLevel$786$myNondetVar_0;
    inline$BDLGetDebugLevel$786$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$786$myNondetVar_0;
    goto inline$BDLGetDebugLevel$786$label_1#1;

  inline$BDLGetDebugLevel$786$label_1#1:
    goto inline$BDLGetDebugLevel$786$Return#1;

  inline$BDLGetDebugLevel$786$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$17$ := inline$BDLGetDebugLevel$786$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_59$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_59$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon35_Then#1, inline$BDLDevicePowerIoCompletion$30$anon35_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon35_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon11#1;

  inline$BDLDevicePowerIoCompletion$30$anon11#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_62#1;

  inline$BDLDevicePowerIoCompletion$30$label_62#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_62_true#1, inline$BDLDevicePowerIoCompletion$30$label_62_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_62_false#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$17$) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_63#1;

  inline$BDLDevicePowerIoCompletion$30$label_62_true#1:
    assume BIT_BAND(BIT_BAND(2, 1), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$17$) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_66#1;

  inline$BDLDevicePowerIoCompletion$30$label_66#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_67#1;

  inline$BDLDevicePowerIoCompletion$30$label_67#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_68#1;

  inline$BDLDevicePowerIoCompletion$30$label_68#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_69#1;

  inline$BDLDevicePowerIoCompletion$30$label_69#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1700.0$18$;
    goto inline$BDLDevicePowerIoCompletion$30$label_63#1;

  inline$BDLDevicePowerIoCompletion$30$label_63#1:
    goto inline$BDLGetDebugLevel$787$Entry#1;

  inline$BDLGetDebugLevel$787$Entry#1:
    goto inline$BDLGetDebugLevel$787$start#1;

  inline$BDLGetDebugLevel$787$start#1:
    goto inline$BDLGetDebugLevel$787$label_3#1;

  inline$BDLGetDebugLevel$787$label_3#1:
    havoc inline$BDLGetDebugLevel$787$myNondetVar_0;
    inline$BDLGetDebugLevel$787$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$787$myNondetVar_0;
    goto inline$BDLGetDebugLevel$787$label_1#1;

  inline$BDLGetDebugLevel$787$label_1#1:
    goto inline$BDLGetDebugLevel$787$Return#1;

  inline$BDLGetDebugLevel$787$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$22$ := inline$BDLGetDebugLevel$787$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_63$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_63$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon36_Then#1, inline$BDLDevicePowerIoCompletion$30$anon36_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon36_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon13#1;

  inline$BDLDevicePowerIoCompletion$30$anon13#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_72#1;

  inline$BDLDevicePowerIoCompletion$30$label_72#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_72_true#1, inline$BDLDevicePowerIoCompletion$30$label_72_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_72_false#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$22$) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_73#1;

  inline$BDLDevicePowerIoCompletion$30$label_72_true#1:
    assume BIT_BAND(BIT_BAND(2, 2), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$22$) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_76#1;

  inline$BDLDevicePowerIoCompletion$30$label_76#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_77#1;

  inline$BDLDevicePowerIoCompletion$30$label_77#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_78#1;

  inline$BDLDevicePowerIoCompletion$30$label_78#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_79#1;

  inline$BDLDevicePowerIoCompletion$30$label_79#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1700.0$23$;
    goto inline$BDLDevicePowerIoCompletion$30$label_73#1;

  inline$BDLDevicePowerIoCompletion$30$label_73#1:
    goto inline$BDLGetDebugLevel$788$Entry#1;

  inline$BDLGetDebugLevel$788$Entry#1:
    goto inline$BDLGetDebugLevel$788$start#1;

  inline$BDLGetDebugLevel$788$start#1:
    goto inline$BDLGetDebugLevel$788$label_3#1;

  inline$BDLGetDebugLevel$788$label_3#1:
    havoc inline$BDLGetDebugLevel$788$myNondetVar_0;
    inline$BDLGetDebugLevel$788$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$788$myNondetVar_0;
    goto inline$BDLGetDebugLevel$788$label_1#1;

  inline$BDLGetDebugLevel$788$label_1#1:
    goto inline$BDLGetDebugLevel$788$Return#1;

  inline$BDLGetDebugLevel$788$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$27$ := inline$BDLGetDebugLevel$788$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_73$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_73$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon37_Then#1, inline$BDLDevicePowerIoCompletion$30$anon37_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon37_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon15#1;

  inline$BDLDevicePowerIoCompletion$30$anon15#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_82#1;

  inline$BDLDevicePowerIoCompletion$30$label_82#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_82_true#1, inline$BDLDevicePowerIoCompletion$30$label_82_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_82_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$27$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_83#1;

  inline$BDLDevicePowerIoCompletion$30$label_82_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1700.0$27$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_84#1;

  inline$BDLDevicePowerIoCompletion$30$label_84#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_83#1;

  inline$BDLDevicePowerIoCompletion$30$label_83#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_85#1;

  inline$BDLDevicePowerIoCompletion$30$label_85#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_86#1;

  inline$BDLDevicePowerIoCompletion$30$label_86#1:
    call IoReleaseRemoveLockEx(RemoveLock__BDL_INTERNAL_DEVICE_EXTENSION(inline$BDLDevicePowerIoCompletion$30$$pBDLExtension$6$1660.36$BDLDevicePowerIoCompletion$12), 1920429904, 88);
    goto inline$BDLDevicePowerIoCompletion$30$anon38_Then#1, inline$BDLDevicePowerIoCompletion$30$anon38_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon38_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon17#1;

  inline$BDLDevicePowerIoCompletion$30$anon17#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_89#1;

  inline$BDLDevicePowerIoCompletion$30$label_89#1:
    call PoStartNextPowerIrp(inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12);
    goto inline$BDLDevicePowerIoCompletion$30$anon39_Then#1, inline$BDLDevicePowerIoCompletion$30$anon39_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon39_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon19#1;

  inline$BDLDevicePowerIoCompletion$30$anon19#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_92#1;

  inline$BDLDevicePowerIoCompletion$30$label_92#1:
    goto inline$storm_IoCompleteRequest$62$Entry#1;

  inline$storm_IoCompleteRequest$62$Entry#1:
    inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8_.1 := inline$BDLDevicePowerIoCompletion$30$$pIrp$2$1654.24$BDLDevicePowerIoCompletion$12;
    goto inline$storm_IoCompleteRequest$62$start#1;

  inline$storm_IoCompleteRequest$62$start#1:
    inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8 := inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8_.1;
    goto inline$storm_IoCompleteRequest$62$label_3#1;

  inline$storm_IoCompleteRequest$62$label_3#1:
    call inline$storm_IoCompleteRequest$62$$result.storm_nondet$338.2$1$ := storm_nondet();
    goto inline$storm_IoCompleteRequest$62$label_6#1;

  inline$storm_IoCompleteRequest$62$label_6#1:
    goto inline$storm_IoCompleteRequest$62$label_6_true#1, inline$storm_IoCompleteRequest$62$label_6_false#1;

  inline$storm_IoCompleteRequest$62$label_6_false#1:
    assume inline$storm_IoCompleteRequest$62$$result.storm_nondet$338.2$1$ == 0;
    goto inline$storm_IoCompleteRequest$62$label_7#1;

  inline$storm_IoCompleteRequest$62$label_6_true#1:
    assume inline$storm_IoCompleteRequest$62$$result.storm_nondet$338.2$1$ != 0;
    goto inline$storm_IoCompleteRequest$62$label_8#1;

  inline$storm_IoCompleteRequest$62$label_8#1:
    havoc raiseException;
    goto inline$storm_IoCompleteRequest$62$anon3_Then#1, inline$storm_IoCompleteRequest$62$anon3_Else#1;

  inline$storm_IoCompleteRequest$62$anon3_Else#1:
    assume !raiseException;
    goto inline$storm_IoCompleteRequest$62$anon1#1;

  inline$storm_IoCompleteRequest$62$anon1#1:
    assume k == 0 ==> INT_EQ(Res_0_COMPLETED[inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8], 1);
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$62$label_9#1;

  inline$storm_IoCompleteRequest$62$label_9#1:
    goto inline$storm_IoCompleteRequest$62$label_9_true#1, inline$storm_IoCompleteRequest$62$label_9_false#1;

  inline$storm_IoCompleteRequest$62$label_9_false#1:
    assume 0 == 0;
    goto inline$storm_IoCompleteRequest$62$label_10#1;

  inline$storm_IoCompleteRequest$62$label_10#1:
    errorReached := true;
    raiseException := true;
    __storm_atomic := false;
    __storm_init := false;
    goto inline$storm_IoCompleteRequest$62$label_1#1;

  inline$storm_IoCompleteRequest$62$label_9_true#1:
    assume 0 != 0;
    goto inline$storm_IoCompleteRequest$62$label_7#1;

  inline$storm_IoCompleteRequest$62$label_7#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$storm_IoCompleteRequest$62$$pirp$1$334.10$storm_IoCompleteRequest$8 := 1];
    call contextSwitch();
    goto inline$storm_IoCompleteRequest$62$label_1#1;

  inline$storm_IoCompleteRequest$62$label_1#1:
    goto inline$storm_IoCompleteRequest$62$Return#1;

  inline$storm_IoCompleteRequest$62$anon3_Then#1:
    assume raiseException;
    goto inline$storm_IoCompleteRequest$62$Return#1;

  inline$storm_IoCompleteRequest$62$Return#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_92$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_92$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon40_Then#1, inline$BDLDevicePowerIoCompletion$30$anon40_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon40_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon21#1;

  inline$BDLDevicePowerIoCompletion$30$anon21#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_95#1;

  inline$BDLDevicePowerIoCompletion$30$label_95#1:
    call ExFreePoolWithTag(inline$BDLDevicePowerIoCompletion$30$$pPowerIrpContext$5$1659.37$BDLDevicePowerIoCompletion$12, 541869122);
    goto inline$BDLDevicePowerIoCompletion$30$anon41_Then#1, inline$BDLDevicePowerIoCompletion$30$anon41_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon41_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon23#1;

  inline$BDLDevicePowerIoCompletion$30$anon23#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_98#1;

  inline$BDLDevicePowerIoCompletion$30$label_98#1:
    goto inline$BDLGetDebugLevel$789$Entry#1;

  inline$BDLGetDebugLevel$789$Entry#1:
    goto inline$BDLGetDebugLevel$789$start#1;

  inline$BDLGetDebugLevel$789$start#1:
    goto inline$BDLGetDebugLevel$789$label_3#1;

  inline$BDLGetDebugLevel$789$label_3#1:
    havoc inline$BDLGetDebugLevel$789$myNondetVar_0;
    inline$BDLGetDebugLevel$789$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$789$myNondetVar_0;
    goto inline$BDLGetDebugLevel$789$label_1#1;

  inline$BDLGetDebugLevel$789$label_1#1:
    goto inline$BDLGetDebugLevel$789$Return#1;

  inline$BDLGetDebugLevel$789$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$28$ := inline$BDLGetDebugLevel$789$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_98$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_98$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon42_Then#1, inline$BDLDevicePowerIoCompletion$30$anon42_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon42_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon25#1;

  inline$BDLDevicePowerIoCompletion$30$anon25#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_101#1;

  inline$BDLDevicePowerIoCompletion$30$label_101#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_101_true#1, inline$BDLDevicePowerIoCompletion$30$label_101_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_101_false#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$28$) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_102#1;

  inline$BDLDevicePowerIoCompletion$30$label_101_true#1:
    assume BIT_BAND(BIT_BAND(1, 1), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$28$) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_105#1;

  inline$BDLDevicePowerIoCompletion$30$label_105#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_106#1;

  inline$BDLDevicePowerIoCompletion$30$label_106#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_107#1;

  inline$BDLDevicePowerIoCompletion$30$label_107#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_108#1;

  inline$BDLDevicePowerIoCompletion$30$label_108#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1723.0$29$;
    goto inline$BDLDevicePowerIoCompletion$30$label_102#1;

  inline$BDLDevicePowerIoCompletion$30$label_102#1:
    goto inline$BDLGetDebugLevel$790$Entry#1;

  inline$BDLGetDebugLevel$790$Entry#1:
    goto inline$BDLGetDebugLevel$790$start#1;

  inline$BDLGetDebugLevel$790$start#1:
    goto inline$BDLGetDebugLevel$790$label_3#1;

  inline$BDLGetDebugLevel$790$label_3#1:
    havoc inline$BDLGetDebugLevel$790$myNondetVar_0;
    inline$BDLGetDebugLevel$790$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$790$myNondetVar_0;
    goto inline$BDLGetDebugLevel$790$label_1#1;

  inline$BDLGetDebugLevel$790$label_1#1:
    goto inline$BDLGetDebugLevel$790$Return#1;

  inline$BDLGetDebugLevel$790$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$33$ := inline$BDLGetDebugLevel$790$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_102$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_102$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon43_Then#1, inline$BDLDevicePowerIoCompletion$30$anon43_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon43_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon27#1;

  inline$BDLDevicePowerIoCompletion$30$anon27#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_111#1;

  inline$BDLDevicePowerIoCompletion$30$label_111#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_111_true#1, inline$BDLDevicePowerIoCompletion$30$label_111_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_111_false#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$33$) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_112#1;

  inline$BDLDevicePowerIoCompletion$30$label_111_true#1:
    assume BIT_BAND(BIT_BAND(1, 2), inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$33$) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_115#1;

  inline$BDLDevicePowerIoCompletion$30$label_115#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_116#1;

  inline$BDLDevicePowerIoCompletion$30$label_116#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_117#1;

  inline$BDLDevicePowerIoCompletion$30$label_117#1:
    call inline$BDLDevicePowerIoCompletion$30$havoc_stringTemp := __HAVOC_malloc(1);
    goto inline$BDLDevicePowerIoCompletion$30$label_118#1;

  inline$BDLDevicePowerIoCompletion$30$label_118#1:
    havoc inline$BDLDevicePowerIoCompletion$30$$result.DbgPrint$1723.0$34$;
    goto inline$BDLDevicePowerIoCompletion$30$label_112#1;

  inline$BDLDevicePowerIoCompletion$30$label_112#1:
    goto inline$BDLGetDebugLevel$791$Entry#1;

  inline$BDLGetDebugLevel$791$Entry#1:
    goto inline$BDLGetDebugLevel$791$start#1;

  inline$BDLGetDebugLevel$791$start#1:
    goto inline$BDLGetDebugLevel$791$label_3#1;

  inline$BDLGetDebugLevel$791$label_3#1:
    havoc inline$BDLGetDebugLevel$791$myNondetVar_0;
    inline$BDLGetDebugLevel$791$$result.BDLGetDebugLevel$39.0$1$ := inline$BDLGetDebugLevel$791$myNondetVar_0;
    goto inline$BDLGetDebugLevel$791$label_1#1;

  inline$BDLGetDebugLevel$791$label_1#1:
    goto inline$BDLGetDebugLevel$791$Return#1;

  inline$BDLGetDebugLevel$791$Return#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$38$ := inline$BDLGetDebugLevel$791$$result.BDLGetDebugLevel$39.0$1$;
    goto inline$BDLDevicePowerIoCompletion$30$label_112$1#1;

  inline$BDLDevicePowerIoCompletion$30$label_112$1#1:
    goto inline$BDLDevicePowerIoCompletion$30$anon44_Then#1, inline$BDLDevicePowerIoCompletion$30$anon44_Else#1;

  inline$BDLDevicePowerIoCompletion$30$anon44_Else#1:
    assume !raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$anon29#1;

  inline$BDLDevicePowerIoCompletion$30$anon29#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_121#1;

  inline$BDLDevicePowerIoCompletion$30$label_121#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_121_true#1, inline$BDLDevicePowerIoCompletion$30$label_121_false#1;

  inline$BDLDevicePowerIoCompletion$30$label_121_false#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$38$, 4) == 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_122#1;

  inline$BDLDevicePowerIoCompletion$30$label_121_true#1:
    assume BIT_BAND(inline$BDLDevicePowerIoCompletion$30$$result.BDLGetDebugLevel$1723.0$38$, 4) != 0;
    goto inline$BDLDevicePowerIoCompletion$30$label_123#1;

  inline$BDLDevicePowerIoCompletion$30$label_123#1:
    goto inline$BDLDevicePowerIoCompletion$30$label_122#1;

  inline$BDLDevicePowerIoCompletion$30$label_122#1:
    inline$BDLDevicePowerIoCompletion$30$$result.BDLDevicePowerIoCompletion$1651.0$1$ := inline$BDLDevicePowerIoCompletion$30$$status$4$1658.36$BDLDevicePowerIoCompletion$12;
    goto inline$BDLDevicePowerIoCompletion$30$label_1#1;

  inline$BDLDevicePowerIoCompletion$30$label_1#1:
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$30$$bdsiSetPowerStateParams$9$1663.36$BDLDevicePowerIoCompletion$12);
    call __HAVOC_free(inline$BDLDevicePowerIoCompletion$30$$result.PoSetPowerState$1693.27$16$);
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon44_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon43_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon42_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon41_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon40_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon39_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon38_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon37_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon36_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon35_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon33_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon32_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon31_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$anon30_Then#1:
    assume raiseException;
    goto inline$BDLDevicePowerIoCompletion$30$Return#1;

  inline$BDLDevicePowerIoCompletion$30$Return#1:
    inline$CallCompletionRoutine$30$$result.completionRoutine$448.30$3$ := inline$BDLDevicePowerIoCompletion$30$$result.BDLDevicePowerIoCompletion$1651.0$1$;
    goto inline$CallCompletionRoutine$30$label_20_icall_2$1#1;

  inline$CallCompletionRoutine$30$label_20_icall_2$1#1:
    goto inline$CallCompletionRoutine$30$anon13_Then#1, inline$CallCompletionRoutine$30$anon13_Else#1;

  inline$CallCompletionRoutine$30$anon13_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$30$anon7#1;

  inline$CallCompletionRoutine$30$anon7#1:
    goto inline$CallCompletionRoutine$30$label_20_icall_return#1;

  inline$CallCompletionRoutine$30$anon13_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$30$Return#1;

  inline$CallCompletionRoutine$30$label_20_icall_1#1:
    assume inline$CallCompletionRoutine$30$$completionRoutine$4$437.25$CallCompletionRoutine$4 == BDLCallDriverCompletionRoutine;
    havoc inline$CallCompletionRoutine$30$myNondetVar_0;
    goto inline$BDLCallDriverCompletionRoutine$30$Entry#1;

  inline$BDLCallDriverCompletionRoutine$30$Entry#1:
    inline$BDLCallDriverCompletionRoutine$30$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1 := inline$CallCompletionRoutine$30$$context$2$435.8$CallCompletionRoutine$4;
    goto inline$BDLCallDriverCompletionRoutine$30$start#1;

  inline$BDLCallDriverCompletionRoutine$30$start#1:
    inline$BDLCallDriverCompletionRoutine$30$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12 := inline$BDLCallDriverCompletionRoutine$30$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12_.1;
    goto inline$BDLCallDriverCompletionRoutine$30$label_3#1;

  inline$BDLCallDriverCompletionRoutine$30$label_3#1:
    goto inline$BDLCallDriverCompletionRoutine$30$label_3_true#1, inline$BDLCallDriverCompletionRoutine$30$label_3_false#1;

  inline$BDLCallDriverCompletionRoutine$30$label_3_false#1:
    havoc inline$BDLCallDriverCompletionRoutine$30$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$30$myNondetVar_0 == 0;
    goto inline$BDLCallDriverCompletionRoutine$30$label_4#1;

  inline$BDLCallDriverCompletionRoutine$30$label_4#1:
    goto inline$BDLCallDriverCompletionRoutine$30$label_6#1;

  inline$BDLCallDriverCompletionRoutine$30$label_3_true#1:
    havoc inline$BDLCallDriverCompletionRoutine$30$myNondetVar_0;
    assume inline$BDLCallDriverCompletionRoutine$30$myNondetVar_0 != 0;
    goto inline$BDLCallDriverCompletionRoutine$30$label_5#1;

  inline$BDLCallDriverCompletionRoutine$30$label_5#1:
    goto inline$BDLCallDriverCompletionRoutine$30$label_6#1;

  inline$BDLCallDriverCompletionRoutine$30$label_6#1:
    goto inline$storm_KeSetEvent$34$Entry#1;

  inline$storm_KeSetEvent$34$Entry#1:
    inline$storm_KeSetEvent$34$$Event$1$213.14$storm_KeSetEvent$12_.1 := inline$BDLCallDriverCompletionRoutine$30$$pEvent$3$50.24$BDLCallDriverCompletionRoutine$12;
    goto inline$storm_KeSetEvent$34$start#1;

  inline$storm_KeSetEvent$34$start#1:
    inline$storm_KeSetEvent$34$$Event$1$213.14$storm_KeSetEvent$12 := inline$storm_KeSetEvent$34$$Event$1$213.14$storm_KeSetEvent$12_.1;
    goto inline$storm_KeSetEvent$34$label_3#1;

  inline$storm_KeSetEvent$34$label_3#1:
    Res_0_EVENT := Res_0_EVENT[inline$storm_KeSetEvent$34$$Event$1$213.14$storm_KeSetEvent$12 := 1];
    call contextSwitch();
    goto inline$storm_KeSetEvent$34$label_1#1;

  inline$storm_KeSetEvent$34$label_1#1:
    goto inline$storm_KeSetEvent$34$Return#1;

  inline$storm_KeSetEvent$34$Return#1:
    goto inline$BDLCallDriverCompletionRoutine$30$label_6$1#1;

  inline$BDLCallDriverCompletionRoutine$30$label_6$1#1:
    goto inline$BDLCallDriverCompletionRoutine$30$anon2_Then#1, inline$BDLCallDriverCompletionRoutine$30$anon2_Else#1;

  inline$BDLCallDriverCompletionRoutine$30$anon2_Else#1:
    assume !raiseException;
    goto inline$BDLCallDriverCompletionRoutine$30$anon1#1;

  inline$BDLCallDriverCompletionRoutine$30$anon1#1:
    goto inline$BDLCallDriverCompletionRoutine$30$label_9#1;

  inline$BDLCallDriverCompletionRoutine$30$label_9#1:
    inline$BDLCallDriverCompletionRoutine$30$$result.BDLCallDriverCompletionRoutine$46.0$1$ := 0 - 1073741802;
    goto inline$BDLCallDriverCompletionRoutine$30$label_1#1;

  inline$BDLCallDriverCompletionRoutine$30$label_1#1:
    goto inline$BDLCallDriverCompletionRoutine$30$Return#1;

  inline$BDLCallDriverCompletionRoutine$30$anon2_Then#1:
    assume raiseException;
    goto inline$BDLCallDriverCompletionRoutine$30$Return#1;

  inline$BDLCallDriverCompletionRoutine$30$Return#1:
    inline$CallCompletionRoutine$30$$result.completionRoutine$448.30$3$ := inline$BDLCallDriverCompletionRoutine$30$$result.BDLCallDriverCompletionRoutine$46.0$1$;
    goto inline$CallCompletionRoutine$30$label_20_icall_1$1#1;

  inline$CallCompletionRoutine$30$label_20_icall_1$1#1:
    goto inline$CallCompletionRoutine$30$anon12_Then#1, inline$CallCompletionRoutine$30$anon12_Else#1;

  inline$CallCompletionRoutine$30$anon12_Else#1:
    assume !raiseException;
    goto inline$CallCompletionRoutine$30$anon5#1;

  inline$CallCompletionRoutine$30$anon5#1:
    goto inline$CallCompletionRoutine$30$label_20_icall_return#1;

  inline$CallCompletionRoutine$30$label_20_icall_return#1:
    goto inline$CallCompletionRoutine$30$label_23#1;

  inline$CallCompletionRoutine$30$label_23#1:
    inline$CallCompletionRoutine$30$$status$5$438.11$CallCompletionRoutine$4 := inline$CallCompletionRoutine$30$$result.completionRoutine$448.30$3$;
    goto inline$CallCompletionRoutine$30$label_24#1;

  inline$CallCompletionRoutine$30$label_24#1:
    goto inline$CallCompletionRoutine$30$label_24_true#1, inline$CallCompletionRoutine$30$label_24_false#1;

  inline$CallCompletionRoutine$30$label_24_false#1:
    assume !INT_NEQ(inline$CallCompletionRoutine$30$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$30$label_1#1;

  inline$CallCompletionRoutine$30$label_24_true#1:
    assume INT_NEQ(inline$CallCompletionRoutine$30$$status$5$438.11$CallCompletionRoutine$4, 0 - 1073741802);
    goto inline$CallCompletionRoutine$30$label_25#1;

  inline$CallCompletionRoutine$30$label_25#1:
    Res_0_COMPLETED := Res_0_COMPLETED[inline$CallCompletionRoutine$30$$Irp$1$434.32$CallCompletionRoutine$4 := 1];
    call contextSwitch();
    goto inline$CallCompletionRoutine$30$label_1#1;

  inline$CallCompletionRoutine$30$label_1#1:
    goto inline$CallCompletionRoutine$30$Return#1;

  inline$CallCompletionRoutine$30$anon12_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$30$Return#1;

  inline$CallCompletionRoutine$30$anon11_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$30$Return#1;

  inline$CallCompletionRoutine$30$anon10_Then#1:
    assume raiseException;
    goto inline$CallCompletionRoutine$30$Return#1;

  inline$CallCompletionRoutine$30$Return#1:
    goto inline$storm_thread_completion$0$label_4$1#1;

  inline$storm_thread_completion$0$label_4$1#1:
    call contextSwitch();
    goto inline$storm_thread_completion$0$anon5_Then#1, inline$storm_thread_completion$0$anon5_Else#1;

  inline$storm_thread_completion$0$anon5_Else#1:
    assume !raiseException;
    goto inline$storm_thread_completion$0$anon3#1;

  inline$storm_thread_completion$0$anon3#1:
    goto inline$storm_thread_completion$0$label_1#1;

  inline$storm_thread_completion$0$label_1#1:
    __storm_thread_done_2 := true;
    goto inline$storm_thread_completion$0$Return#1;

  inline$storm_thread_completion$0$anon5_Then#1:
    assume raiseException;
    goto inline$storm_thread_completion$0$Return#1;

  inline$storm_thread_completion$0$anon4_Then#1:
    assume raiseException;
    goto inline$storm_thread_completion$0$Return#1;

  inline$storm_thread_completion$0$Return#1:
    goto label_38$1#1;

  label_38$1#1:
    goto label_1#1;

  label_1#1:
    assert !errorReached;
    return;

  anon14_Then#1:
    assume raiseException;
    return;

  anon13_Then#1:
    assume raiseException;
    return;

  anon12_Then#1:
    assume raiseException;
    return;

  anon11_Then#1:
    assume raiseException;
    return;

  anon10_Then#1:
    assume raiseException;
    return;
}
